/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Q=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/path","vs/base/common/async","vs/base/common/network","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","electron","vs/base/common/resources","vs/base/common/errors","vs/base/common/buffer","vs/platform/files/common/files","vs/platform/configuration/common/configuration","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/platform/product/common/productService","vs/base/common/cancellation","vs/platform/environment/electron-main/environmentMainService","vs/base/common/strings","os","vs/platform/workspaces/common/workspaces","fs","vs/platform/telemetry/common/telemetry","vs/base/common/arrays","vs/base/common/uuid","vs/base/common/process","vs/base/common/extpath","vs/base/common/labels","vs/base/parts/ipc/common/ipc","vs/platform/windows/electron-main/windows","vs/platform/registry/common/platform","vs/platform/state/electron-main/state","vs/base/common/json","vs/base/common/map","vs/platform/update/common/update","vs/base/common/functional","child_process","vs/base/common/errorMessage","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/base/common/objects","vs/platform/environment/common/environment","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/backup/electron-main/backup","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/native/electron-main/nativeHostMainService","vs/platform/environment/node/argvHelper","vs/platform/files/common/watcher","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/base/parts/ipc/node/ipc.net","vs/base/common/keybindings","vs/base/common/stream","crypto","net","vs/base/common/performance","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/theme/electron-main/themeMainService","vs/platform/windows/common/windows","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/iterator","vs/base/common/normalization","vs/base/node/id","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/sign/common/sign","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/jsonEdit","vs/base/common/keyCodes","vs/base/common/processes","vs/base/common/hash","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/node/argv","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/environment/node/shellEnv","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/remote/common/tunnel","vs/platform/storage/common/storage","vs/platform/url/common/url","vs/platform/storage/electron-main/storageMainService","vs/platform/windows/electron-main/windowsFinder","vs/platform/workspaces/electron-main/workspaces","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/keybindingParser","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/console","vs/base/common/marshalling","vs/base/common/uriIpc","vs/base/common/worker/simpleWorker","vs/base/node/crypto","vs/base/node/decoder","vs/base/node/macAddress","util","vs/base/node/ports","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/storage/node/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/keybindingLabels","vs/base/common/keybindingLabels","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderIpc","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/windows/electron-main/window","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/driver/common/driverIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensions/common/extensionValidator","vs/platform/files/node/diskFileSystemProviderIpc","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/parcel/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/keybinding/common/baseResolvedKeybinding","vs/platform/keybinding/common/resolvedKeybindingItem","vs/platform/keybinding/common/usLayoutResolvedKeybinding","vs/platform/lifecycle/common/lifecycle","vs/platform/configuration/common/userConfigurationFileService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/electron-main/diskFileSystemProviderIpc","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/workspace/common/workspace","vs/platform/storage/electron-main/storageIpc","vs/platform/storage/electron-main/storageMain","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/extensions/electron-main/workerMainProcessExtensionHostStarter","zlib","vs/platform/driver/node/driver","vs/platform/driver/electron-main/driver","vs/platform/backup/electron-main/backupMainService","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/state/electron-main/stateMainService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/window","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","string_decoder","minimist","path","assert","graceful-fs","worker_threads","vs/code/electron-main/main"],J=function(H){for(var e=[],v=0,D=H.length;v<D;v++)e[v]=Q[H[v]];return e};define(Q[104],J([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function v(D,M){if(!D)throw new Error(M?`Assertion failed (${M})`:"Assertion Failed")}e.ok=v}),define(Q[46],J([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function v(n){return(I,d,f)=>{let y=null,E=null;if(typeof f.value=="function"?(y="value",E=f.value):typeof f.get=="function"&&(y="get",E=f.get),!E)throw new Error("not supported");f[y]=n(E,d)}}e.createDecorator=v;function D(n,I,d){let f=null,y=null;if(typeof d.value=="function"?(f="value",y=d.value,y.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof d.get=="function"&&(f="get",y=d.get),!y)throw new Error("not supported");const E=`$memoize$${I}`;d[f]=function(...m){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:y.apply(this,m)}),this[E]}}e.memoize=D;function M(n,I,d){return v((f,y)=>{const E=`$debounce$${y}`,m=`$debounce$result$${y}`;return function(...p){this[m]||(this[m]=d?d():void 0),clearTimeout(this[E]),I&&(this[m]=I(this[m],...p),p=[this[m]]),this[E]=setTimeout(()=>{f.apply(this,p),this[m]=d?d():void 0},n)}})}e.debounce=M;function C(n,I,d){return v((f,y)=>{const E=`$throttle$timer$${y}`,m=`$throttle$result$${y}`,p=`$throttle$lastRun$${y}`,t=`$throttle$pending$${y}`;return function(...w){if(this[m]||(this[m]=d?d():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),I&&(this[m]=I(this[m],...w)),this[t])return;const b=this[p]+n;b<=Date.now()?(this[p]=Date.now(),f.apply(this,[this[m]]),this[m]=d?d():void 0):(this[t]=!0,this[E]=setTimeout(()=>{this[t]=!1,this[p]=Date.now(),f.apply(this,[this[m]]),this[m]=d?d():void 0},b-Date.now()))}})}e.throttle=C}),define(Q[16],J([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class v{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(s){setTimeout(()=>{throw s.stack?new Error(s.message+`

`+s.stack):s},0)}}addListener(s){return this.listeners.push(s),()=>{this._removeListener(s)}}emit(s){this.listeners.forEach(u=>{u(s)})}_removeListener(s){this.listeners.splice(this.listeners.indexOf(s),1)}setUnexpectedErrorHandler(s){this.unexpectedErrorHandler=s}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(s){this.unexpectedErrorHandler(s),this.emit(s)}onUnexpectedExternalError(s){this.unexpectedErrorHandler(s)}}e.ErrorHandler=v,e.errorHandler=new v;function D(l){e.errorHandler.setUnexpectedErrorHandler(l)}e.setUnexpectedErrorHandler=D;function M(l){d(l)||e.errorHandler.onUnexpectedError(l)}e.onUnexpectedError=M;function C(l){d(l)||e.errorHandler.onUnexpectedExternalError(l)}e.onUnexpectedExternalError=C;function n(l){if(l instanceof Error){let{name:s,message:u}=l;const r=l.stacktrace||l.stack;return{$isError:!0,name:s,message:u,stack:r}}return l}e.transformErrorForSerialization=n;const I="Canceled";function d(l){return l instanceof Error&&l.name===I&&l.message===I}e.isPromiseCanceledError=d;class f extends Error{constructor(){super(I);this.name=this.message}}e.CancellationError=f;function y(){const l=new Error(I);return l.name=l.message,l}e.canceled=y;function E(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}e.illegalArgument=E;function m(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}e.illegalState=m;function p(l){return l?new Error(`readonly property '${l} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=p;function t(l){const s=new Error(`${l} has been disposed`);return s.name="DISPOSED",s}e.disposed=t;function w(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}e.getErrorMessage=w;class b extends Error{constructor(s){super("NotImplemented");s&&(this.message=s)}}e.NotImplementedError=b;class S extends Error{constructor(s){super("NotSupported");s&&(this.message=s)}}e.NotSupportedError=S;class P extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=P;function c(l){const s=l;return s instanceof Error&&Array.isArray(s.actions)}e.isErrorWithActions=c;function a(l,s=Object.create(null)){const u=new Error(l);return s.actions&&(u.actions=s.actions),u}e.createErrorWithActions=a}),define(Q[30],J([0,1,16]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function D(F,A=0){return F[F.length-(1+A)]}e.tail=D;function M(F){if(F.length===0)throw new Error("Invalid tail call");return[F.slice(0,F.length-1),F[F.length-1]]}e.tail2=M;function C(F,A,O=($,X)=>$===X){if(F===A)return!0;if(!F||!A||F.length!==A.length)return!1;for(let $=0,X=F.length;$<X;$++)if(!O(F[$],A[$]))return!1;return!0}e.equals=C;function n(F,A,O){let $=0,X=F.length-1;for(;$<=X;){const V=($+X)/2|0,z=O(F[V],A);if(z<0)$=V+1;else if(z>0)X=V-1;else return V}return-($+1)}e.binarySearch=n;function I(F,A){let O=0,$=F.length;if($===0)return 0;for(;O<$;){const X=Math.floor((O+$)/2);A(F[X])?$=X:O=X+1}return O}e.findFirstInSorted=I;function d(F,A,O){if(F=F|0,F>=A.length)throw new TypeError("invalid index");let $=A[Math.floor(A.length*Math.random())],X=[],V=[],z=[];for(let Z of A){const te=O(Z,$);te<0?X.push(Z):te>0?V.push(Z):z.push(Z)}return F<X.length?d(F,X,O):F<X.length+z.length?z[0]:d(F-(X.length+z.length),V,O)}e.quickSelect=d;function f(F,A){const O=[];let $;for(const X of F.slice(0).sort(A))!$||A($[0],X)!==0?($=[X],O.push($)):$.push(X);return O}e.groupBy=f;function y(F,A,O){const $=[];function X(Z,te,ce){if(te===0&&ce.length===0)return;const se=$[$.length-1];se&&se.start+se.deleteCount===Z?(se.deleteCount+=te,se.toInsert.push(...ce)):$.push({start:Z,deleteCount:te,toInsert:ce})}let V=0,z=0;for(;;){if(V===F.length){X(V,0,A.slice(z));break}if(z===A.length){X(V,F.length-V,[]);break}const Z=F[V],te=A[z],ce=O(Z,te);ce===0?(V+=1,z+=1):ce<0?(X(V,1,[]),V+=1):ce>0&&(X(V,0,[te]),z+=1)}return $}e.sortedDiff=y;function E(F,A,O){const $=y(F,A,O),X=[],V=[];for(const z of $)X.push(...F.slice(z.start,z.start+z.deleteCount)),V.push(...z.toInsert);return{removed:X,added:V}}e.delta=E;function m(F,A,O){if(O===0)return[];const $=F.slice(0,O).sort(A);return t(F,A,$,O,F.length),$}e.top=m;function p(F,A,O,$,X){return O===0?Promise.resolve([]):new Promise((V,z)=>{(async()=>{const Z=F.length,te=F.slice(0,O).sort(A);for(let ce=O,se=Math.min(O+$,Z);ce<Z;ce=se,se=Math.min(se+$,Z)){if(ce>O&&await new Promise(ie=>setTimeout(ie)),X&&X.isCancellationRequested)throw(0,v.canceled)();t(F,A,te,ce,se)}return te})().then(V,z)})}e.topAsync=p;function t(F,A,O,$,X){for(const V=O.length;$<X;$++){const z=F[$];if(A(z,O[V-1])<0){O.pop();const Z=I(O,te=>A(z,te)<0);O.splice(Z,0,z)}}}function w(F){return F.filter(A=>!!A)}e.coalesce=w;function b(F){let A=0;for(let O=0;O<F.length;O++)F[O]&&(F[A]=F[O],A+=1);F.length=A}e.coalesceInPlace=b;function S(F,A,O){F.splice(O,0,F.splice(A,1)[0])}e.move=S;function P(F){return!Array.isArray(F)||F.length===0}e.isFalsyOrEmpty=P;function c(F){return Array.isArray(F)&&F.length>0}e.isNonEmptyArray=c;function a(F,A=O=>O){const O=new Set;return F.filter($=>{const X=A($);return O.has(X)?!1:(O.add(X),!0)})}e.distinct=a;function l(F){const A=Object.create(null);return O=>{const $=F(O);return A[$]?!1:(A[$]=!0,!0)}}e.uniqueFilter=l;function s(F,A){const O=u(F,A);if(O!==-1)return F[O]}e.findLast=s;function u(F,A){for(let O=F.length-1;O>=0;O--){const $=F[O];if(A($))return O}return-1}e.lastIndex=u;function r(F,A){return F.length>0?F[0]:A}e.firstOrDefault=r;function i(F,A,O=($,X)=>$===X){let $=0;for(let X=0,V=Math.min(F.length,A.length);X<V&&O(F[X],A[X]);X++)$++;return $}e.commonPrefixLength=i;function o(F){return[].concat(...F)}e.flatten=o;function h(F,A){let O=typeof A=="number"?F:0;typeof A=="number"?O=F:(O=0,A=F);const $=[];if(O<=A)for(let X=O;X<A;X++)$.push(X);else for(let X=O;X>A;X--)$.push(X);return $}e.range=h;function g(F,A,O){return F.reduce(($,X)=>($[A(X)]=O?O(X):X,$),Object.create(null))}e.index=g;function k(F,A){return F.push(A),()=>L(F,A)}e.insert=k;function L(F,A){const O=F.indexOf(A);if(O>-1)return F.splice(O,1),A}e.remove=L;function R(F,A,O){const $=F.slice(0,A),X=F.slice(A);return $.concat(O,X)}e.arrayInsert=R;function W(F,A){let O;if(typeof A=="number"){let $=A;O=()=>{const X=Math.sin($++)*179426549;return X-Math.floor(X)}}else O=Math.random;for(let $=F.length-1;$>0;$-=1){const X=Math.floor(O()*($+1)),V=F[$];F[$]=F[X],F[X]=V}}e.shuffle=W;function j(F,A){const O=F.indexOf(A);O>-1&&(F.splice(O,1),F.unshift(A))}e.pushToStart=j;function x(F,A){const O=F.indexOf(A);O>-1&&(F.splice(O,1),F.push(A))}e.pushToEnd=x;function ne(F,A){return Array.isArray(F)?F.map(A):A(F)}e.mapArrayOrNot=ne;function oe(F){return Array.isArray(F)?F:[F]}e.asArray=oe;function G(F){return F[Math.floor(Math.random()*F.length)]}e.getRandomElement=G;function T(F,A){for(const O of F){const $=A(O);if($!==void 0)return $}}e.mapFind=T;function B(F,A,O){const $=U(F,A),X=F.length,V=O.length;F.length=X+V;for(let z=X-1;z>=$;z--)F[z+V]=F[z];for(let z=0;z<V;z++)F[z+$]=O[z]}e.insertInto=B;function q(F,A,O,$){const X=U(F,A),V=F.splice(X,O);return B(F,X,$),V}e.splice=q;function U(F,A){return A<0?Math.max(A+F.length,0):Math.min(A,F.length)}function N(F,A){let O=Number.MAX_SAFE_INTEGER,$=0;return F.forEach((X,V)=>{const z=A(X);z<O&&(O=z,$=V)}),$}e.minIndex=N;function _(F,A){let O=Number.MIN_SAFE_INTEGER,$=0;return F.forEach((X,V)=>{const z=A(X);z>O&&(O=z,$=V)}),$}e.maxIndex=_;class Y{constructor(A){this.items=A,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(A){let O=this.firstIdx;for(;O<this.items.length&&A(this.items[O]);)O++;const $=O===this.firstIdx?null:this.items.slice(this.firstIdx,O);return this.firstIdx=O,$}takeFromEndWhile(A){let O=this.lastIdx;for(;O>=0&&A(this.items[O]);)O--;const $=O===this.lastIdx?null:this.items.slice(O+1,this.lastIdx+1);return this.lastIdx=O,$}peek(){return this.items[this.firstIdx]}dequeue(){const A=this.items[this.firstIdx];return this.firstIdx++,A}takeCount(A){const O=this.items.slice(this.firstIdx,this.firstIdx+A);return this.firstIdx+=A,O}}e.ArrayQueue=Y}),define(Q[42],J([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function v(D){const M=this;let C=!1,n;return function(){return C||(C=!0,n=D.apply(M,arguments)),n}}e.once=v}),define(Q[69],J([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var v;(function(D){function M(l){return l&&typeof l=="object"&&typeof l[Symbol.iterator]=="function"}D.is=M;const C=Object.freeze([]);function n(){return C}D.empty=n;function*I(l){yield l}D.single=I;function d(l){return l||C}D.from=d;function f(l){return!l||l[Symbol.iterator]().next().done===!0}D.isEmpty=f;function y(l){return l[Symbol.iterator]().next().value}D.first=y;function E(l,s){for(const u of l)if(s(u))return!0;return!1}D.some=E;function m(l,s){for(const u of l)if(s(u))return u}D.find=m;function*p(l,s){for(const u of l)s(u)&&(yield u)}D.filter=p;function*t(l,s){let u=0;for(const r of l)yield s(r,u++)}D.map=t;function*w(...l){for(const s of l)for(const u of s)yield u}D.concat=w;function*b(l){for(const s of l)for(const u of s)yield u}D.concatNested=b;function S(l,s,u){let r=u;for(const i of l)r=s(r,i);return r}D.reduce=S;function*P(l,s,u=l.length){for(s<0&&(s+=l.length),u<0?u+=l.length:u>l.length&&(u=l.length);s<u;s++)yield l[s]}D.slice=P;function c(l,s=Number.POSITIVE_INFINITY){const u=[];if(s===0)return[u,l];const r=l[Symbol.iterator]();for(let i=0;i<s;i++){const o=r.next();if(o.done)return[u,D.empty()];u.push(o.value)}return[u,{[Symbol.iterator](){return r}}]}D.consume=c;function a(l,s,u=(r,i)=>r===i){const r=l[Symbol.iterator](),i=s[Symbol.iterator]();for(;;){const o=r.next(),h=i.next();if(o.done!==h.done)return!1;if(o.done)return!0;if(!u(o.value,h.value))return!1}}D.equals=a})(v=e.Iterable||(e.Iterable={}))}),define(Q[39],J([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var v;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(v=e.ScanError||(e.ScanError={}));var D;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(D=e.SyntaxKind||(e.SyntaxKind={}));var M;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(M=e.ParseErrorCode||(e.ParseErrorCode={}));var C;(function(s){s.DEFAULT={allowTrailingComma:!0}})(C=e.ParseOptions||(e.ParseOptions={}));function n(s,u=!1){let r=0,i=s.length,o="",h=0,g=16,k=0;function L(G){let T=0,B=0;for(;T<G;){const q=s.charCodeAt(r);if(q>=48&&q<=57)B=B*16+q-48;else if(q>=65&&q<=70)B=B*16+q-65+10;else if(q>=97&&q<=102)B=B*16+q-97+10;else break;r++,T++}return T<G&&(B=-1),B}function R(G){r=G,o="",h=0,g=16,k=0}function W(){const G=r;if(s.charCodeAt(r)===48)r++;else for(r++;r<s.length&&f(s.charCodeAt(r));)r++;if(r<s.length&&s.charCodeAt(r)===46)if(r++,r<s.length&&f(s.charCodeAt(r)))for(r++;r<s.length&&f(s.charCodeAt(r));)r++;else return k=3,s.substring(G,r);let T=r;if(r<s.length&&(s.charCodeAt(r)===69||s.charCodeAt(r)===101))if(r++,(r<s.length&&s.charCodeAt(r)===43||s.charCodeAt(r)===45)&&r++,r<s.length&&f(s.charCodeAt(r))){for(r++;r<s.length&&f(s.charCodeAt(r));)r++;T=r}else k=3;return s.substring(G,T)}function j(){let G="",T=r;for(;;){if(r>=i){G+=s.substring(T,r),k=2;break}const B=s.charCodeAt(r);if(B===34){G+=s.substring(T,r),r++;break}if(B===92){if(G+=s.substring(T,r),r++,r>=i){k=2;break}switch(s.charCodeAt(r++)){case 34:G+='"';break;case 92:G+="\\";break;case 47:G+="/";break;case 98:G+="\b";break;case 102:G+="\f";break;case 110:G+=`
`;break;case 114:G+="\r";break;case 116:G+="	";break;case 117:const U=L(4);U>=0?G+=String.fromCharCode(U):k=4;break;default:k=5}T=r;continue}if(B>=0&&B<=31)if(d(B)){G+=s.substring(T,r),k=2;break}else k=6;r++}return G}function x(){if(o="",k=0,h=r,r>=i)return h=i,g=17;let G=s.charCodeAt(r);if(I(G)){do r++,o+=String.fromCharCode(G),G=s.charCodeAt(r);while(I(G));return g=15}if(d(G))return r++,o+=String.fromCharCode(G),G===13&&s.charCodeAt(r)===10&&(r++,o+=`
`),g=14;switch(G){case 123:return r++,g=1;case 125:return r++,g=2;case 91:return r++,g=3;case 93:return r++,g=4;case 58:return r++,g=6;case 44:return r++,g=5;case 34:return r++,o=j(),g=10;case 47:const T=r-1;if(s.charCodeAt(r+1)===47){for(r+=2;r<i&&!d(s.charCodeAt(r));)r++;return o=s.substring(T,r),g=12}if(s.charCodeAt(r+1)===42){r+=2;const B=i-1;let q=!1;for(;r<B;){if(s.charCodeAt(r)===42&&s.charCodeAt(r+1)===47){r+=2,q=!0;break}r++}return q||(r++,k=1),o=s.substring(T,r),g=13}return o+=String.fromCharCode(G),r++,g=16;case 45:if(o+=String.fromCharCode(G),r++,r===i||!f(s.charCodeAt(r)))return g=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=W(),g=11;default:for(;r<i&&ne(G);)r++,G=s.charCodeAt(r);if(h!==r){switch(o=s.substring(h,r),o){case"true":return g=8;case"false":return g=9;case"null":return g=7}return g=16}return o+=String.fromCharCode(G),r++,g=16}}function ne(G){if(I(G)||d(G))return!1;switch(G){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function oe(){let G;do G=x();while(G>=12&&G<=15);return G}return{setPosition:R,getPosition:()=>r,scan:u?oe:x,getToken:()=>g,getTokenValue:()=>o,getTokenOffset:()=>h,getTokenLength:()=>r-h,getTokenError:()=>k}}e.createScanner=n;function I(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function d(s){return s===10||s===13||s===8232||s===8233}function f(s){return s>=48&&s<=57}var y;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(y||(y={}));function E(s,u){const r=[],i=new Object;let o;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let g=!1;function k(L,R,W,j){h.value=L,h.offset=R,h.length=W,h.type=j,h.colonOffset=void 0,o=h}try{c(s,{onObjectBegin:(L,R)=>{if(u<=L)throw i;o=void 0,g=u>L,r.push("")},onObjectProperty:(L,R,W)=>{if(u<R||(k(L,R,W,"property"),r[r.length-1]=L,u<=R+W))throw i},onObjectEnd:(L,R)=>{if(u<=L)throw i;o=void 0,r.pop()},onArrayBegin:(L,R)=>{if(u<=L)throw i;o=void 0,r.push(0)},onArrayEnd:(L,R)=>{if(u<=L)throw i;o=void 0,r.pop()},onLiteralValue:(L,R,W)=>{if(u<R||(k(L,R,W,l(L)),u<=R+W))throw i},onSeparator:(L,R,W)=>{if(u<=R)throw i;if(L===":"&&o&&o.type==="property")o.colonOffset=R,g=!1,o=void 0;else if(L===","){const j=r[r.length-1];typeof j=="number"?r[r.length-1]=j+1:(g=!0,r[r.length-1]=""),o=void 0}}})}catch(L){if(L!==i)throw L}return{path:r,previousNode:o,isAtPropertyKey:g,matches:L=>{let R=0;for(let W=0;R<L.length&&W<r.length;W++)if(L[R]===r[W]||L[R]==="*")R++;else if(L[R]!=="**")return!1;return R===L.length}}}e.getLocation=E;function m(s,u=[],r=C.DEFAULT){let i=null,o=[];const h=[];function g(L){Array.isArray(o)?o.push(L):i!==null&&(o[i]=L)}return c(s,{onObjectBegin:()=>{const L={};g(L),h.push(o),o=L,i=null},onObjectProperty:L=>{i=L},onObjectEnd:()=>{o=h.pop()},onArrayBegin:()=>{const L=[];g(L),h.push(o),o=L,i=null},onArrayEnd:()=>{o=h.pop()},onLiteralValue:g,onError:(L,R,W)=>{u.push({error:L,offset:R,length:W})}},r),o[0]}e.parse=m;function p(s,u=[],r=C.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(L){i.type==="property"&&(i.length=L-i.offset,i=i.parent)}function h(L){return i.children.push(L),L}c(s,{onObjectBegin:L=>{i=h({type:"object",offset:L,length:-1,parent:i,children:[]})},onObjectProperty:(L,R,W)=>{i=h({type:"property",offset:R,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:L,offset:R,length:W,parent:i})},onObjectEnd:(L,R)=>{i.length=L+R-i.offset,i=i.parent,o(L+R)},onArrayBegin:(L,R)=>{i=h({type:"array",offset:L,length:-1,parent:i,children:[]})},onArrayEnd:(L,R)=>{i.length=L+R-i.offset,i=i.parent,o(L+R)},onLiteralValue:(L,R,W)=>{h({type:l(L),offset:R,length:W,parent:i,value:L}),o(R+W)},onSeparator:(L,R,W)=>{i.type==="property"&&(L===":"?i.colonOffset=R:L===","&&o(R))},onError:(L,R,W)=>{u.push({error:L,offset:R,length:W})}},r);const k=i.children[0];return k&&delete k.parent,k}e.parseTree=p;function t(s,u){if(!s)return;let r=s;for(let i of u)if(typeof i=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let o=!1;for(const h of r.children)if(Array.isArray(h.children)&&h.children[0].value===i){r=h.children[1],o=!0;break}if(!o)return}else{const o=i;if(r.type!=="array"||o<0||!Array.isArray(r.children)||o>=r.children.length)return;r=r.children[o]}return r}e.findNodeAtLocation=t;function w(s){if(!s.parent||!s.parent.children)return[];const u=w(s.parent);if(s.parent.type==="property"){const r=s.parent.children[0].value;u.push(r)}else if(s.parent.type==="array"){const r=s.parent.children.indexOf(s);r!==-1&&u.push(r)}return u}e.getNodePath=w;function b(s){switch(s.type){case"array":return s.children.map(b);case"object":const u=Object.create(null);for(let r of s.children){const i=r.children[1];i&&(u[r.children[0].value]=b(i))}return u;case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.getNodeValue=b;function S(s,u,r=!1){return u>=s.offset&&u<s.offset+s.length||r&&u===s.offset+s.length}e.contains=S;function P(s,u,r=!1){if(S(s,u,r)){const i=s.children;if(Array.isArray(i))for(let o=0;o<i.length&&i[o].offset<=u;o++){const h=P(i[o],u,r);if(h)return h}return s}}e.findNodeAtOffset=P;function c(s,u,r=C.DEFAULT){const i=n(s,!1);function o(O){return O?()=>O(i.getTokenOffset(),i.getTokenLength()):()=>!0}function h(O){return O?$=>O($,i.getTokenOffset(),i.getTokenLength()):()=>!0}const g=o(u.onObjectBegin),k=h(u.onObjectProperty),L=o(u.onObjectEnd),R=o(u.onArrayBegin),W=o(u.onArrayEnd),j=h(u.onLiteralValue),x=h(u.onSeparator),ne=o(u.onComment),oe=h(u.onError),G=r&&r.disallowComments,T=r&&r.allowTrailingComma;function B(){for(;;){const O=i.scan();switch(i.getTokenError()){case 4:q(14);break;case 5:q(15);break;case 3:q(13);break;case 1:G||q(11);break;case 2:q(12);break;case 6:q(16);break}switch(O){case 12:case 13:G?q(10):ne();break;case 16:q(1);break;case 15:case 14:break;default:return O}}}function q(O,$=[],X=[]){if(oe(O),$.length+X.length>0){let V=i.getToken();for(;V!==17;){if($.indexOf(V)!==-1){B();break}else if(X.indexOf(V)!==-1)break;V=B()}}}function U(O){const $=i.getTokenValue();return O?j($):k($),B(),!0}function N(){switch(i.getToken()){case 11:let O=0;try{O=JSON.parse(i.getTokenValue()),typeof O!="number"&&(q(2),O=0)}catch($){q(2)}j(O);break;case 7:j(null);break;case 8:j(!0);break;case 9:j(!1);break;default:return!1}return B(),!0}function _(){return i.getToken()!==10?(q(3,[],[2,5]),!1):(U(!1),i.getToken()===6?(x(":"),B(),A()||q(4,[],[2,5])):q(5,[],[2,5]),!0)}function Y(){g(),B();let O=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(O||q(4,[],[]),x(","),B(),i.getToken()===2&&T)break}else O&&q(6,[],[]);_()||q(4,[],[2,5]),O=!0}return L(),i.getToken()!==2?q(7,[2],[]):B(),!0}function F(){R(),B();let O=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(O||q(4,[],[]),x(","),B(),i.getToken()===4&&T)break}else O&&q(6,[],[]);A()||q(4,[],[4,5]),O=!0}return W(),i.getToken()!==4?q(8,[4],[]):B(),!0}function A(){switch(i.getToken()){case 3:return F();case 1:return Y();case 10:return U(!0);default:return N()}}return B(),i.getToken()===17?r.allowEmptyContent?!0:(q(4,[],[]),!1):A()?(i.getToken()!==17&&q(9,[],[]),!0):(q(4,[],[]),!1)}e.visit=c;function a(s,u){let r=n(s),i=[],o,h=0,g;do switch(g=r.getPosition(),o=r.scan(),o){case 12:case 13:case 17:h!==g&&i.push(s.substring(h,g)),u!==void 0&&i.push(r.getTokenValue().replace(/[^\r\n]/g,u)),h=r.getPosition();break}while(o!==17);return i.join("")}e.stripComments=a;function l(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=l}),define(Q[105],J([0,1,39]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function D(d,f,y){let E,m,p,t,w;if(f){for(t=f.offset,w=t+f.length,p=t;p>0&&!I(d,p-1);)p--;let h=w;for(;h<d.length&&!I(d,h);)h++;m=d.substring(p,h),E=C(m,y)}else m=d,E=0,p=0,t=0,w=d.length;const b=n(y,d);let S=!1,P=0,c;y.insertSpaces?c=M(" ",y.tabSize||4):c="	";const a=(0,v.createScanner)(m,!1);let l=!1;function s(){return b+M(c,E+P)}function u(){let h=a.scan();for(S=!1;h===15||h===14;)S=S||h===14,h=a.scan();return l=h===16||a.getTokenError()!==0,h}const r=[];function i(h,g,k){!l&&g<w&&k>t&&d.substring(g,k)!==h&&r.push({offset:g,length:k-g,content:h})}let o=u();if(o!==17){const h=a.getTokenOffset()+p,g=M(c,E);i(g,p,h)}for(;o!==17;){let h=a.getTokenOffset()+a.getTokenLength()+p,g=u(),k="";for(;!S&&(g===12||g===13);){const R=a.getTokenOffset()+p;i(" ",h,R),h=a.getTokenOffset()+a.getTokenLength()+p,k=g===12?s():"",g=u()}if(g===2)o!==1&&(P--,k=s());else if(g===4)o!==3&&(P--,k=s());else{switch(o){case 3:case 1:P++,k=s();break;case 5:case 12:k=s();break;case 13:S?k=s():k=" ";break;case 6:k=" ";break;case 10:if(g===6){k="";break}case 7:case 8:case 9:case 11:case 2:case 4:g===12||g===13?k=" ":g!==5&&g!==17&&(l=!0);break;case 16:l=!0;break}S&&(g===12||g===13)&&(k=s())}const L=a.getTokenOffset()+p;i(k,h,L),o=g}return r}e.format=D;function M(d,f){let y="";for(let E=0;E<f;E++)y+=d;return y}function C(d,f){let y=0,E=0;const m=f.tabSize||4;for(;y<d.length;){const p=d.charAt(y);if(p===" ")E++;else if(p==="	")E+=m;else break;y++}return Math.floor(E/m)}function n(d,f){for(let y=0;y<f.length;y++){const E=f.charAt(y);if(E==="\r")return y+1<f.length&&f.charAt(y+1)===`
`?`\r
`:"\r";if(E===`
`)return`
`}return d&&d.eol||`
`}e.getEOL=n;function I(d,f){return`\r
`.indexOf(d.charAt(f))!==-1}e.isEOL=I}),define(Q[78],J([0,1,39,105]),function(H,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function M(f,y,E){return C(f,y,void 0,E)}e.removeProperty=M;function C(f,y,E,m,p){const t=y.slice(),w=[],b=(0,v.parseTree)(f,w);let S,P;for(;t.length>0&&(P=t.pop(),S=(0,v.findNodeAtLocation)(b,t),S===void 0&&E!==void 0);)typeof P=="string"?E={[P]:E}:E=[E];if(S)if(S.type==="object"&&typeof P=="string"&&Array.isArray(S.children)){const c=(0,v.findNodeAtLocation)(S,[P]);if(c!==void 0)if(E===void 0){if(!c.parent)throw new Error("Malformed AST");const a=S.children.indexOf(c.parent);let l,s=c.parent.offset+c.parent.length;if(a>0){const u=S.children[a-1];l=u.offset+u.length}else l=S.offset+1,S.children.length>1&&(s=S.children[1].offset);return n(f,{offset:l,length:s-l,content:""},m)}else return n(f,{offset:c.offset,length:c.length,content:JSON.stringify(E)},m);else{if(E===void 0)return[];const a=`${JSON.stringify(P)}: ${JSON.stringify(E)}`,l=p?p(S.children.map(u=>u.children[0].value)):S.children.length;let s;if(l>0){const u=S.children[l-1];s={offset:u.offset+u.length,length:0,content:","+a}}else S.children.length===0?s={offset:S.offset+1,length:0,content:a}:s={offset:S.offset+1,length:0,content:a+","};return n(f,s,m)}}else if(S.type==="array"&&typeof P=="number"&&Array.isArray(S.children))if(E!==void 0){const c=`${JSON.stringify(E)}`;let a;if(S.children.length===0||P===0)a={offset:S.offset+1,length:0,content:S.children.length===0?c:c+","};else{const l=P===-1||P>S.children.length?S.children.length:P,s=S.children[l-1];a={offset:s.offset+s.length,length:0,content:","+c}}return n(f,a,m)}else{const c=P,a=S.children[c];let l;if(S.children.length===1)l={offset:S.offset+1,length:S.length-2,content:""};else if(S.children.length-1===c){const s=S.children[c-1],u=s.offset+s.length,r=S.offset+S.length;l={offset:u,length:r-2-u,content:""}}else l={offset:a.offset,length:S.children[c+1].offset-a.offset,content:""};return n(f,l,m)}else throw new Error(`Can not add ${typeof P!="number"?"index":"property"} to parent of type ${S.type}`);else{if(E===void 0)throw new Error("Can not delete in empty document");return n(f,{offset:b?b.offset:0,length:b?b.length:0,content:JSON.stringify(E)},m)}}e.setProperty=C;function n(f,y,E){let m=I(f,y),p=y.offset,t=y.offset+y.content.length;if(y.length===0||y.content.length===0){for(;p>0&&!(0,D.isEOL)(m,p-1);)p--;for(;t<m.length&&!(0,D.isEOL)(m,t);)t++}const w=(0,D.format)(m,{offset:p,length:t-p},E);for(let S=w.length-1;S>=0;S--){const P=w[S];m=I(m,P),p=Math.min(p,P.offset),t=Math.max(t,P.offset+P.length),t+=P.content.length-P.length}const b=f.length-(m.length-t)-p;return[{offset:p,length:b,content:m.substring(p,t)}]}e.withFormatting=n;function I(f,y){return f.substring(0,y.offset)+y.content+f.substring(y.offset+y.length)}e.applyEdit=I;function d(f,y){let E=y.slice(0).sort((p,t)=>{const w=p.offset-t.offset;return w===0?p.length-t.length:w}),m=f.length;for(let p=E.length-1;p>=0;p--){let t=E[p];if(t.offset+t.length<=m)f=I(f,t);else throw new Error("Overlapping edit");m=t.offset}return f}e.applyEdits=d}),define(Q[79],J([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyChord=e.KeyMod=e.KeyCodeUtils=e.IMMUTABLE_KEY_CODE_TO_CODE=e.IMMUTABLE_CODE_TO_KEY_CODE=e.ScanCodeUtils=e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=e.EVENT_KEY_CODE_MAP=e.ScanCode=e.KeyCode=void 0;var v;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.Unknown=0]="Unknown",t[t.Backspace=1]="Backspace",t[t.Tab=2]="Tab",t[t.Enter=3]="Enter",t[t.Shift=4]="Shift",t[t.Ctrl=5]="Ctrl",t[t.Alt=6]="Alt",t[t.PauseBreak=7]="PauseBreak",t[t.CapsLock=8]="CapsLock",t[t.Escape=9]="Escape",t[t.Space=10]="Space",t[t.PageUp=11]="PageUp",t[t.PageDown=12]="PageDown",t[t.End=13]="End",t[t.Home=14]="Home",t[t.LeftArrow=15]="LeftArrow",t[t.UpArrow=16]="UpArrow",t[t.RightArrow=17]="RightArrow",t[t.DownArrow=18]="DownArrow",t[t.Insert=19]="Insert",t[t.Delete=20]="Delete",t[t.Digit0=21]="Digit0",t[t.Digit1=22]="Digit1",t[t.Digit2=23]="Digit2",t[t.Digit3=24]="Digit3",t[t.Digit4=25]="Digit4",t[t.Digit5=26]="Digit5",t[t.Digit6=27]="Digit6",t[t.Digit7=28]="Digit7",t[t.Digit8=29]="Digit8",t[t.Digit9=30]="Digit9",t[t.KeyA=31]="KeyA",t[t.KeyB=32]="KeyB",t[t.KeyC=33]="KeyC",t[t.KeyD=34]="KeyD",t[t.KeyE=35]="KeyE",t[t.KeyF=36]="KeyF",t[t.KeyG=37]="KeyG",t[t.KeyH=38]="KeyH",t[t.KeyI=39]="KeyI",t[t.KeyJ=40]="KeyJ",t[t.KeyK=41]="KeyK",t[t.KeyL=42]="KeyL",t[t.KeyM=43]="KeyM",t[t.KeyN=44]="KeyN",t[t.KeyO=45]="KeyO",t[t.KeyP=46]="KeyP",t[t.KeyQ=47]="KeyQ",t[t.KeyR=48]="KeyR",t[t.KeyS=49]="KeyS",t[t.KeyT=50]="KeyT",t[t.KeyU=51]="KeyU",t[t.KeyV=52]="KeyV",t[t.KeyW=53]="KeyW",t[t.KeyX=54]="KeyX",t[t.KeyY=55]="KeyY",t[t.KeyZ=56]="KeyZ",t[t.Meta=57]="Meta",t[t.ContextMenu=58]="ContextMenu",t[t.F1=59]="F1",t[t.F2=60]="F2",t[t.F3=61]="F3",t[t.F4=62]="F4",t[t.F5=63]="F5",t[t.F6=64]="F6",t[t.F7=65]="F7",t[t.F8=66]="F8",t[t.F9=67]="F9",t[t.F10=68]="F10",t[t.F11=69]="F11",t[t.F12=70]="F12",t[t.F13=71]="F13",t[t.F14=72]="F14",t[t.F15=73]="F15",t[t.F16=74]="F16",t[t.F17=75]="F17",t[t.F18=76]="F18",t[t.F19=77]="F19",t[t.NumLock=78]="NumLock",t[t.ScrollLock=79]="ScrollLock",t[t.Semicolon=80]="Semicolon",t[t.Equal=81]="Equal",t[t.Comma=82]="Comma",t[t.Minus=83]="Minus",t[t.Period=84]="Period",t[t.Slash=85]="Slash",t[t.Backquote=86]="Backquote",t[t.BracketLeft=87]="BracketLeft",t[t.Backslash=88]="Backslash",t[t.BracketRight=89]="BracketRight",t[t.Quote=90]="Quote",t[t.OEM_8=91]="OEM_8",t[t.IntlBackslash=92]="IntlBackslash",t[t.Numpad0=93]="Numpad0",t[t.Numpad1=94]="Numpad1",t[t.Numpad2=95]="Numpad2",t[t.Numpad3=96]="Numpad3",t[t.Numpad4=97]="Numpad4",t[t.Numpad5=98]="Numpad5",t[t.Numpad6=99]="Numpad6",t[t.Numpad7=100]="Numpad7",t[t.Numpad8=101]="Numpad8",t[t.Numpad9=102]="Numpad9",t[t.NumpadMultiply=103]="NumpadMultiply",t[t.NumpadAdd=104]="NumpadAdd",t[t.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",t[t.NumpadSubtract=106]="NumpadSubtract",t[t.NumpadDecimal=107]="NumpadDecimal",t[t.NumpadDivide=108]="NumpadDivide",t[t.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",t[t.ABNT_C1=110]="ABNT_C1",t[t.ABNT_C2=111]="ABNT_C2",t[t.AudioVolumeMute=112]="AudioVolumeMute",t[t.AudioVolumeUp=113]="AudioVolumeUp",t[t.AudioVolumeDown=114]="AudioVolumeDown",t[t.BrowserSearch=115]="BrowserSearch",t[t.BrowserHome=116]="BrowserHome",t[t.BrowserBack=117]="BrowserBack",t[t.BrowserForward=118]="BrowserForward",t[t.MediaTrackNext=119]="MediaTrackNext",t[t.MediaTrackPrevious=120]="MediaTrackPrevious",t[t.MediaStop=121]="MediaStop",t[t.MediaPlayPause=122]="MediaPlayPause",t[t.LaunchMediaPlayer=123]="LaunchMediaPlayer",t[t.LaunchMail=124]="LaunchMail",t[t.LaunchApp2=125]="LaunchApp2",t[t.MAX_VALUE=126]="MAX_VALUE"})(v=e.KeyCode||(e.KeyCode={}));var D;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.None=0]="None",t[t.Hyper=1]="Hyper",t[t.Super=2]="Super",t[t.Fn=3]="Fn",t[t.FnLock=4]="FnLock",t[t.Suspend=5]="Suspend",t[t.Resume=6]="Resume",t[t.Turbo=7]="Turbo",t[t.Sleep=8]="Sleep",t[t.WakeUp=9]="WakeUp",t[t.KeyA=10]="KeyA",t[t.KeyB=11]="KeyB",t[t.KeyC=12]="KeyC",t[t.KeyD=13]="KeyD",t[t.KeyE=14]="KeyE",t[t.KeyF=15]="KeyF",t[t.KeyG=16]="KeyG",t[t.KeyH=17]="KeyH",t[t.KeyI=18]="KeyI",t[t.KeyJ=19]="KeyJ",t[t.KeyK=20]="KeyK",t[t.KeyL=21]="KeyL",t[t.KeyM=22]="KeyM",t[t.KeyN=23]="KeyN",t[t.KeyO=24]="KeyO",t[t.KeyP=25]="KeyP",t[t.KeyQ=26]="KeyQ",t[t.KeyR=27]="KeyR",t[t.KeyS=28]="KeyS",t[t.KeyT=29]="KeyT",t[t.KeyU=30]="KeyU",t[t.KeyV=31]="KeyV",t[t.KeyW=32]="KeyW",t[t.KeyX=33]="KeyX",t[t.KeyY=34]="KeyY",t[t.KeyZ=35]="KeyZ",t[t.Digit1=36]="Digit1",t[t.Digit2=37]="Digit2",t[t.Digit3=38]="Digit3",t[t.Digit4=39]="Digit4",t[t.Digit5=40]="Digit5",t[t.Digit6=41]="Digit6",t[t.Digit7=42]="Digit7",t[t.Digit8=43]="Digit8",t[t.Digit9=44]="Digit9",t[t.Digit0=45]="Digit0",t[t.Enter=46]="Enter",t[t.Escape=47]="Escape",t[t.Backspace=48]="Backspace",t[t.Tab=49]="Tab",t[t.Space=50]="Space",t[t.Minus=51]="Minus",t[t.Equal=52]="Equal",t[t.BracketLeft=53]="BracketLeft",t[t.BracketRight=54]="BracketRight",t[t.Backslash=55]="Backslash",t[t.IntlHash=56]="IntlHash",t[t.Semicolon=57]="Semicolon",t[t.Quote=58]="Quote",t[t.Backquote=59]="Backquote",t[t.Comma=60]="Comma",t[t.Period=61]="Period",t[t.Slash=62]="Slash",t[t.CapsLock=63]="CapsLock",t[t.F1=64]="F1",t[t.F2=65]="F2",t[t.F3=66]="F3",t[t.F4=67]="F4",t[t.F5=68]="F5",t[t.F6=69]="F6",t[t.F7=70]="F7",t[t.F8=71]="F8",t[t.F9=72]="F9",t[t.F10=73]="F10",t[t.F11=74]="F11",t[t.F12=75]="F12",t[t.PrintScreen=76]="PrintScreen",t[t.ScrollLock=77]="ScrollLock",t[t.Pause=78]="Pause",t[t.Insert=79]="Insert",t[t.Home=80]="Home",t[t.PageUp=81]="PageUp",t[t.Delete=82]="Delete",t[t.End=83]="End",t[t.PageDown=84]="PageDown",t[t.ArrowRight=85]="ArrowRight",t[t.ArrowLeft=86]="ArrowLeft",t[t.ArrowDown=87]="ArrowDown",t[t.ArrowUp=88]="ArrowUp",t[t.NumLock=89]="NumLock",t[t.NumpadDivide=90]="NumpadDivide",t[t.NumpadMultiply=91]="NumpadMultiply",t[t.NumpadSubtract=92]="NumpadSubtract",t[t.NumpadAdd=93]="NumpadAdd",t[t.NumpadEnter=94]="NumpadEnter",t[t.Numpad1=95]="Numpad1",t[t.Numpad2=96]="Numpad2",t[t.Numpad3=97]="Numpad3",t[t.Numpad4=98]="Numpad4",t[t.Numpad5=99]="Numpad5",t[t.Numpad6=100]="Numpad6",t[t.Numpad7=101]="Numpad7",t[t.Numpad8=102]="Numpad8",t[t.Numpad9=103]="Numpad9",t[t.Numpad0=104]="Numpad0",t[t.NumpadDecimal=105]="NumpadDecimal",t[t.IntlBackslash=106]="IntlBackslash",t[t.ContextMenu=107]="ContextMenu",t[t.Power=108]="Power",t[t.NumpadEqual=109]="NumpadEqual",t[t.F13=110]="F13",t[t.F14=111]="F14",t[t.F15=112]="F15",t[t.F16=113]="F16",t[t.F17=114]="F17",t[t.F18=115]="F18",t[t.F19=116]="F19",t[t.F20=117]="F20",t[t.F21=118]="F21",t[t.F22=119]="F22",t[t.F23=120]="F23",t[t.F24=121]="F24",t[t.Open=122]="Open",t[t.Help=123]="Help",t[t.Select=124]="Select",t[t.Again=125]="Again",t[t.Undo=126]="Undo",t[t.Cut=127]="Cut",t[t.Copy=128]="Copy",t[t.Paste=129]="Paste",t[t.Find=130]="Find",t[t.AudioVolumeMute=131]="AudioVolumeMute",t[t.AudioVolumeUp=132]="AudioVolumeUp",t[t.AudioVolumeDown=133]="AudioVolumeDown",t[t.NumpadComma=134]="NumpadComma",t[t.IntlRo=135]="IntlRo",t[t.KanaMode=136]="KanaMode",t[t.IntlYen=137]="IntlYen",t[t.Convert=138]="Convert",t[t.NonConvert=139]="NonConvert",t[t.Lang1=140]="Lang1",t[t.Lang2=141]="Lang2",t[t.Lang3=142]="Lang3",t[t.Lang4=143]="Lang4",t[t.Lang5=144]="Lang5",t[t.Abort=145]="Abort",t[t.Props=146]="Props",t[t.NumpadParenLeft=147]="NumpadParenLeft",t[t.NumpadParenRight=148]="NumpadParenRight",t[t.NumpadBackspace=149]="NumpadBackspace",t[t.NumpadMemoryStore=150]="NumpadMemoryStore",t[t.NumpadMemoryRecall=151]="NumpadMemoryRecall",t[t.NumpadMemoryClear=152]="NumpadMemoryClear",t[t.NumpadMemoryAdd=153]="NumpadMemoryAdd",t[t.NumpadMemorySubtract=154]="NumpadMemorySubtract",t[t.NumpadClear=155]="NumpadClear",t[t.NumpadClearEntry=156]="NumpadClearEntry",t[t.ControlLeft=157]="ControlLeft",t[t.ShiftLeft=158]="ShiftLeft",t[t.AltLeft=159]="AltLeft",t[t.MetaLeft=160]="MetaLeft",t[t.ControlRight=161]="ControlRight",t[t.ShiftRight=162]="ShiftRight",t[t.AltRight=163]="AltRight",t[t.MetaRight=164]="MetaRight",t[t.BrightnessUp=165]="BrightnessUp",t[t.BrightnessDown=166]="BrightnessDown",t[t.MediaPlay=167]="MediaPlay",t[t.MediaRecord=168]="MediaRecord",t[t.MediaFastForward=169]="MediaFastForward",t[t.MediaRewind=170]="MediaRewind",t[t.MediaTrackNext=171]="MediaTrackNext",t[t.MediaTrackPrevious=172]="MediaTrackPrevious",t[t.MediaStop=173]="MediaStop",t[t.Eject=174]="Eject",t[t.MediaPlayPause=175]="MediaPlayPause",t[t.MediaSelect=176]="MediaSelect",t[t.LaunchMail=177]="LaunchMail",t[t.LaunchApp2=178]="LaunchApp2",t[t.LaunchApp1=179]="LaunchApp1",t[t.SelectTask=180]="SelectTask",t[t.LaunchScreenSaver=181]="LaunchScreenSaver",t[t.BrowserSearch=182]="BrowserSearch",t[t.BrowserHome=183]="BrowserHome",t[t.BrowserBack=184]="BrowserBack",t[t.BrowserForward=185]="BrowserForward",t[t.BrowserStop=186]="BrowserStop",t[t.BrowserRefresh=187]="BrowserRefresh",t[t.BrowserFavorites=188]="BrowserFavorites",t[t.ZoomToggle=189]="ZoomToggle",t[t.MailReply=190]="MailReply",t[t.MailForward=191]="MailForward",t[t.MailSend=192]="MailSend",t[t.MAX_VALUE=193]="MAX_VALUE"})(D=e.ScanCode||(e.ScanCode={}));class M{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(w,b){this._keyCodeToStr[w]=b,this._strToKeyCode[b.toLowerCase()]=w}keyCodeToStr(w){return this._keyCodeToStr[w]}strToKeyCode(w){return this._strToKeyCode[w.toLowerCase()]||0}}const C=new M,n=new M,I=new M;e.EVENT_KEY_CODE_MAP=new Array(230),e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const d=[],f=Object.create(null),y=Object.create(null);e.ScanCodeUtils={lowerCaseToEnum:t=>y[t]||0,toEnum:t=>f[t]||0,toString:t=>d[t]||"None"},e.IMMUTABLE_CODE_TO_KEY_CODE=[],e.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let t=0;t<=193;t++)e.IMMUTABLE_CODE_TO_KEY_CODE[t]=-1;for(let t=0;t<=126;t++)e.IMMUTABLE_KEY_CODE_TO_CODE[t]=-1;(function(){const t="",w=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",t,t],[0,1,1,"Hyper",0,t,0,t,t,t],[0,1,2,"Super",0,t,0,t,t,t],[0,1,3,"Fn",0,t,0,t,t,t],[0,1,4,"FnLock",0,t,0,t,t,t],[0,1,5,"Suspend",0,t,0,t,t,t],[0,1,6,"Resume",0,t,0,t,t,t],[0,1,7,"Turbo",0,t,0,t,t,t],[0,1,8,"Sleep",0,t,0,"VK_SLEEP",t,t],[0,1,9,"WakeUp",0,t,0,t,t,t],[31,0,10,"KeyA",31,"A",65,"VK_A",t,t],[32,0,11,"KeyB",32,"B",66,"VK_B",t,t],[33,0,12,"KeyC",33,"C",67,"VK_C",t,t],[34,0,13,"KeyD",34,"D",68,"VK_D",t,t],[35,0,14,"KeyE",35,"E",69,"VK_E",t,t],[36,0,15,"KeyF",36,"F",70,"VK_F",t,t],[37,0,16,"KeyG",37,"G",71,"VK_G",t,t],[38,0,17,"KeyH",38,"H",72,"VK_H",t,t],[39,0,18,"KeyI",39,"I",73,"VK_I",t,t],[40,0,19,"KeyJ",40,"J",74,"VK_J",t,t],[41,0,20,"KeyK",41,"K",75,"VK_K",t,t],[42,0,21,"KeyL",42,"L",76,"VK_L",t,t],[43,0,22,"KeyM",43,"M",77,"VK_M",t,t],[44,0,23,"KeyN",44,"N",78,"VK_N",t,t],[45,0,24,"KeyO",45,"O",79,"VK_O",t,t],[46,0,25,"KeyP",46,"P",80,"VK_P",t,t],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",t,t],[48,0,27,"KeyR",48,"R",82,"VK_R",t,t],[49,0,28,"KeyS",49,"S",83,"VK_S",t,t],[50,0,29,"KeyT",50,"T",84,"VK_T",t,t],[51,0,30,"KeyU",51,"U",85,"VK_U",t,t],[52,0,31,"KeyV",52,"V",86,"VK_V",t,t],[53,0,32,"KeyW",53,"W",87,"VK_W",t,t],[54,0,33,"KeyX",54,"X",88,"VK_X",t,t],[55,0,34,"KeyY",55,"Y",89,"VK_Y",t,t],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",t,t],[22,0,36,"Digit1",22,"1",49,"VK_1",t,t],[23,0,37,"Digit2",23,"2",50,"VK_2",t,t],[24,0,38,"Digit3",24,"3",51,"VK_3",t,t],[25,0,39,"Digit4",25,"4",52,"VK_4",t,t],[26,0,40,"Digit5",26,"5",53,"VK_5",t,t],[27,0,41,"Digit6",27,"6",54,"VK_6",t,t],[28,0,42,"Digit7",28,"7",55,"VK_7",t,t],[29,0,43,"Digit8",29,"8",56,"VK_8",t,t],[30,0,44,"Digit9",30,"9",57,"VK_9",t,t],[21,0,45,"Digit0",21,"0",48,"VK_0",t,t],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",t,t],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",t,t],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",t,t],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",t,t],[10,1,50,"Space",10,"Space",32,"VK_SPACE",t,t],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,t,0,t,t,t],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",t,t],[59,1,64,"F1",59,"F1",112,"VK_F1",t,t],[60,1,65,"F2",60,"F2",113,"VK_F2",t,t],[61,1,66,"F3",61,"F3",114,"VK_F3",t,t],[62,1,67,"F4",62,"F4",115,"VK_F4",t,t],[63,1,68,"F5",63,"F5",116,"VK_F5",t,t],[64,1,69,"F6",64,"F6",117,"VK_F6",t,t],[65,1,70,"F7",65,"F7",118,"VK_F7",t,t],[66,1,71,"F8",66,"F8",119,"VK_F8",t,t],[67,1,72,"F9",67,"F9",120,"VK_F9",t,t],[68,1,73,"F10",68,"F10",121,"VK_F10",t,t],[69,1,74,"F11",69,"F11",122,"VK_F11",t,t],[70,1,75,"F12",70,"F12",123,"VK_F12",t,t],[0,1,76,"PrintScreen",0,t,0,t,t,t],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",t,t],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",t,t],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",t,t],[14,1,80,"Home",14,"Home",36,"VK_HOME",t,t],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",t,t],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",t,t],[13,1,83,"End",13,"End",35,"VK_END",t,t],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",t,t],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",t],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",t],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",t],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",t],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",t,t],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",t,t],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",t,t],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",t,t],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",t,t],[3,1,94,"NumpadEnter",3,t,0,t,t,t],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",t,t],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",t,t],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",t,t],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",t,t],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",t,t],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",t,t],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",t,t],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",t,t],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",t,t],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",t,t],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",t,t],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",t,t],[58,1,107,"ContextMenu",58,"ContextMenu",93,t,t,t],[0,1,108,"Power",0,t,0,t,t,t],[0,1,109,"NumpadEqual",0,t,0,t,t,t],[71,1,110,"F13",71,"F13",124,"VK_F13",t,t],[72,1,111,"F14",72,"F14",125,"VK_F14",t,t],[73,1,112,"F15",73,"F15",126,"VK_F15",t,t],[74,1,113,"F16",74,"F16",127,"VK_F16",t,t],[75,1,114,"F17",75,"F17",128,"VK_F17",t,t],[76,1,115,"F18",76,"F18",129,"VK_F18",t,t],[77,1,116,"F19",77,"F19",130,"VK_F19",t,t],[0,1,117,"F20",0,t,0,"VK_F20",t,t],[0,1,118,"F21",0,t,0,"VK_F21",t,t],[0,1,119,"F22",0,t,0,"VK_F22",t,t],[0,1,120,"F23",0,t,0,"VK_F23",t,t],[0,1,121,"F24",0,t,0,"VK_F24",t,t],[0,1,122,"Open",0,t,0,t,t,t],[0,1,123,"Help",0,t,0,t,t,t],[0,1,124,"Select",0,t,0,t,t,t],[0,1,125,"Again",0,t,0,t,t,t],[0,1,126,"Undo",0,t,0,t,t,t],[0,1,127,"Cut",0,t,0,t,t,t],[0,1,128,"Copy",0,t,0,t,t,t],[0,1,129,"Paste",0,t,0,t,t,t],[0,1,130,"Find",0,t,0,t,t,t],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",t,t],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",t,t],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",t,t],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",t,t],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",t,t],[0,1,136,"KanaMode",0,t,0,t,t,t],[0,0,137,"IntlYen",0,t,0,t,t,t],[0,1,138,"Convert",0,t,0,t,t,t],[0,1,139,"NonConvert",0,t,0,t,t,t],[0,1,140,"Lang1",0,t,0,t,t,t],[0,1,141,"Lang2",0,t,0,t,t,t],[0,1,142,"Lang3",0,t,0,t,t,t],[0,1,143,"Lang4",0,t,0,t,t,t],[0,1,144,"Lang5",0,t,0,t,t,t],[0,1,145,"Abort",0,t,0,t,t,t],[0,1,146,"Props",0,t,0,t,t,t],[0,1,147,"NumpadParenLeft",0,t,0,t,t,t],[0,1,148,"NumpadParenRight",0,t,0,t,t,t],[0,1,149,"NumpadBackspace",0,t,0,t,t,t],[0,1,150,"NumpadMemoryStore",0,t,0,t,t,t],[0,1,151,"NumpadMemoryRecall",0,t,0,t,t,t],[0,1,152,"NumpadMemoryClear",0,t,0,t,t,t],[0,1,153,"NumpadMemoryAdd",0,t,0,t,t,t],[0,1,154,"NumpadMemorySubtract",0,t,0,t,t,t],[0,1,155,"NumpadClear",0,t,0,t,t,t],[0,1,156,"NumpadClearEntry",0,t,0,t,t,t],[5,1,0,t,5,"Ctrl",17,"VK_CONTROL",t,t],[4,1,0,t,4,"Shift",16,"VK_SHIFT",t,t],[6,1,0,t,6,"Alt",18,"VK_MENU",t,t],[57,1,0,t,57,"Meta",0,"VK_COMMAND",t,t],[5,1,157,"ControlLeft",5,t,0,"VK_LCONTROL",t,t],[4,1,158,"ShiftLeft",4,t,0,"VK_LSHIFT",t,t],[6,1,159,"AltLeft",6,t,0,"VK_LMENU",t,t],[57,1,160,"MetaLeft",57,t,0,"VK_LWIN",t,t],[5,1,161,"ControlRight",5,t,0,"VK_RCONTROL",t,t],[4,1,162,"ShiftRight",4,t,0,"VK_RSHIFT",t,t],[6,1,163,"AltRight",6,t,0,"VK_RMENU",t,t],[57,1,164,"MetaRight",57,t,0,"VK_RWIN",t,t],[0,1,165,"BrightnessUp",0,t,0,t,t,t],[0,1,166,"BrightnessDown",0,t,0,t,t,t],[0,1,167,"MediaPlay",0,t,0,t,t,t],[0,1,168,"MediaRecord",0,t,0,t,t,t],[0,1,169,"MediaFastForward",0,t,0,t,t,t],[0,1,170,"MediaRewind",0,t,0,t,t,t],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",t,t],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",t,t],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",t,t],[0,1,174,"Eject",0,t,0,t,t,t],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",t,t],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",t,t],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",t,t],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",t,t],[0,1,179,"LaunchApp1",0,t,0,"VK_MEDIA_LAUNCH_APP1",t,t],[0,1,180,"SelectTask",0,t,0,t,t,t],[0,1,181,"LaunchScreenSaver",0,t,0,t,t,t],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",t,t],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",t,t],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",t,t],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",t,t],[0,1,186,"BrowserStop",0,t,0,"VK_BROWSER_STOP",t,t],[0,1,187,"BrowserRefresh",0,t,0,"VK_BROWSER_REFRESH",t,t],[0,1,188,"BrowserFavorites",0,t,0,"VK_BROWSER_FAVORITES",t,t],[0,1,189,"ZoomToggle",0,t,0,t,t,t],[0,1,190,"MailReply",0,t,0,t,t,t],[0,1,191,"MailForward",0,t,0,t,t,t],[0,1,192,"MailSend",0,t,0,t,t,t],[109,1,0,t,109,"KeyInComposition",229,t,t,t],[111,1,0,t,111,"ABNT_C2",194,"VK_ABNT_C2",t,t],[91,1,0,t,91,"OEM_8",223,"VK_OEM_8",t,t],[0,1,0,t,0,t,0,"VK_CLEAR",t,t],[0,1,0,t,0,t,0,"VK_KANA",t,t],[0,1,0,t,0,t,0,"VK_HANGUL",t,t],[0,1,0,t,0,t,0,"VK_JUNJA",t,t],[0,1,0,t,0,t,0,"VK_FINAL",t,t],[0,1,0,t,0,t,0,"VK_HANJA",t,t],[0,1,0,t,0,t,0,"VK_KANJI",t,t],[0,1,0,t,0,t,0,"VK_CONVERT",t,t],[0,1,0,t,0,t,0,"VK_NONCONVERT",t,t],[0,1,0,t,0,t,0,"VK_ACCEPT",t,t],[0,1,0,t,0,t,0,"VK_MODECHANGE",t,t],[0,1,0,t,0,t,0,"VK_SELECT",t,t],[0,1,0,t,0,t,0,"VK_PRINT",t,t],[0,1,0,t,0,t,0,"VK_EXECUTE",t,t],[0,1,0,t,0,t,0,"VK_SNAPSHOT",t,t],[0,1,0,t,0,t,0,"VK_HELP",t,t],[0,1,0,t,0,t,0,"VK_APPS",t,t],[0,1,0,t,0,t,0,"VK_PROCESSKEY",t,t],[0,1,0,t,0,t,0,"VK_PACKET",t,t],[0,1,0,t,0,t,0,"VK_DBE_SBCSCHAR",t,t],[0,1,0,t,0,t,0,"VK_DBE_DBCSCHAR",t,t],[0,1,0,t,0,t,0,"VK_ATTN",t,t],[0,1,0,t,0,t,0,"VK_CRSEL",t,t],[0,1,0,t,0,t,0,"VK_EXSEL",t,t],[0,1,0,t,0,t,0,"VK_EREOF",t,t],[0,1,0,t,0,t,0,"VK_PLAY",t,t],[0,1,0,t,0,t,0,"VK_ZOOM",t,t],[0,1,0,t,0,t,0,"VK_NONAME",t,t],[0,1,0,t,0,t,0,"VK_PA1",t,t],[0,1,0,t,0,t,0,"VK_OEM_CLEAR",t,t]];let b=[],S=[];for(const P of w){const[c,a,l,s,u,r,i,o,h,g]=P;if(S[l]||(S[l]=!0,d[l]=s,f[s]=l,y[s.toLowerCase()]=l,a&&(e.IMMUTABLE_CODE_TO_KEY_CODE[l]=u,u!==0&&u!==3&&u!==5&&u!==4&&u!==6&&u!==57&&(e.IMMUTABLE_KEY_CODE_TO_CODE[u]=l))),!b[u]){if(b[u]=!0,!r)throw new Error(`String representation missing for key code ${u} around scan code ${s}`);C.define(u,r),n.define(u,h||r),I.define(u,g||h||r)}i&&(e.EVENT_KEY_CODE_MAP[i]=u),o&&(e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[o]=u)}e.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var E;(function(t){function w(l){return C.keyCodeToStr(l)}t.toString=w;function b(l){return C.strToKeyCode(l)}t.fromString=b;function S(l){return n.keyCodeToStr(l)}t.toUserSettingsUS=S;function P(l){return I.keyCodeToStr(l)}t.toUserSettingsGeneral=P;function c(l){return n.strToKeyCode(l)||I.strToKeyCode(l)}t.fromUserSettings=c;function a(l){if(l>=93&&l<=108)return null;switch(l){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return C.keyCodeToStr(l)}t.toElectronAccelerator=a})(E=e.KeyCodeUtils||(e.KeyCodeUtils={}));var m;(function(t){t[t.CtrlCmd=2048]="CtrlCmd",t[t.Shift=1024]="Shift",t[t.Alt=512]="Alt",t[t.WinCtrl=256]="WinCtrl"})(m=e.KeyMod||(e.KeyMod={}));function p(t,w){const b=(w&65535)<<16>>>0;return(t|b)>>>0}e.KeyChord=p}),define(Q[59],J([0,1,16]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedKeybinding=e.ResolvedKeybindingPart=e.ScanCodeBinding=e.ChordKeybinding=e.SimpleKeybinding=e.createSimpleKeybinding=e.createKeybinding=void 0;var D;(function(E){E[E.CtrlCmd=2048]="CtrlCmd",E[E.Shift=1024]="Shift",E[E.Alt=512]="Alt",E[E.WinCtrl=256]="WinCtrl",E[E.KeyCode=255]="KeyCode"})(D||(D={}));function M(E,m){if(E===0)return null;const p=(E&65535)>>>0,t=(E&4294901760)>>>16;return t!==0?new I([C(p,m),C(t,m)]):new I([C(p,m)])}e.createKeybinding=M;function C(E,m){const p=!!(E&2048),t=!!(E&256),w=m===2?t:p,b=!!(E&1024),S=!!(E&512),P=m===2?p:t,c=E&255;return new n(w,b,S,P,c)}e.createSimpleKeybinding=C;class n{constructor(m,p,t,w,b){this.ctrlKey=m,this.shiftKey=p,this.altKey=t,this.metaKey=w,this.keyCode=b}equals(m){return this.ctrlKey===m.ctrlKey&&this.shiftKey===m.shiftKey&&this.altKey===m.altKey&&this.metaKey===m.metaKey&&this.keyCode===m.keyCode}getHashCode(){const m=this.ctrlKey?"1":"0",p=this.shiftKey?"1":"0",t=this.altKey?"1":"0",w=this.metaKey?"1":"0";return`${m}${p}${t}${w}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new I([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}e.SimpleKeybinding=n;class I{constructor(m){if(m.length===0)throw(0,v.illegalArgument)("parts");this.parts=m}getHashCode(){let m="";for(let p=0,t=this.parts.length;p<t;p++)p!==0&&(m+=";"),m+=this.parts[p].getHashCode();return m}equals(m){if(m===null||this.parts.length!==m.parts.length)return!1;for(let p=0;p<this.parts.length;p++)if(!this.parts[p].equals(m.parts[p]))return!1;return!0}}e.ChordKeybinding=I;class d{constructor(m,p,t,w,b){this.ctrlKey=m,this.shiftKey=p,this.altKey=t,this.metaKey=w,this.scanCode=b}equals(m){return this.ctrlKey===m.ctrlKey&&this.shiftKey===m.shiftKey&&this.altKey===m.altKey&&this.metaKey===m.metaKey&&this.scanCode===m.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}e.ScanCodeBinding=d;class f{constructor(m,p,t,w,b,S){this.ctrlKey=m,this.shiftKey=p,this.altKey=t,this.metaKey=w,this.keyLabel=b,this.keyAriaLabel=S}}e.ResolvedKeybindingPart=f;class y{}e.ResolvedKeybinding=y}),define(Q[106],J([0,1,79,59]),function(H,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingParser=void 0;class M{static _readModifiers(n){n=n.toLowerCase().trim();let I=!1,d=!1,f=!1,y=!1,E;do E=!1,/^ctrl(\+|\-)/.test(n)&&(I=!0,n=n.substr("ctrl-".length),E=!0),/^shift(\+|\-)/.test(n)&&(d=!0,n=n.substr("shift-".length),E=!0),/^alt(\+|\-)/.test(n)&&(f=!0,n=n.substr("alt-".length),E=!0),/^meta(\+|\-)/.test(n)&&(y=!0,n=n.substr("meta-".length),E=!0),/^win(\+|\-)/.test(n)&&(y=!0,n=n.substr("win-".length),E=!0),/^cmd(\+|\-)/.test(n)&&(y=!0,n=n.substr("cmd-".length),E=!0);while(E);let m;const p=n.indexOf(" ");return p>0?(m=n.substring(0,p),n=n.substring(p)):(m=n,n=""),{remains:n,ctrl:I,shift:d,alt:f,meta:y,key:m}}static parseSimpleKeybinding(n){const I=this._readModifiers(n),d=v.KeyCodeUtils.fromUserSettings(I.key);return[new D.SimpleKeybinding(I.ctrl,I.shift,I.alt,I.meta,d),I.remains]}static parseKeybinding(n,I){if(!n)return null;const d=[];let f;do[f,n]=this.parseSimpleKeybinding(n),d.push(f);while(n.length>0);return new D.ChordKeybinding(d)}static parseSimpleUserBinding(n){const I=this._readModifiers(n),d=I.key.match(/^\[([^\]]+)\]$/);if(d){const y=d[1],E=v.ScanCodeUtils.lowerCaseToEnum(y);return[new D.ScanCodeBinding(I.ctrl,I.shift,I.alt,I.meta,E),I.remains]}const f=v.KeyCodeUtils.fromUserSettings(I.key);return[new D.SimpleKeybinding(I.ctrl,I.shift,I.alt,I.meta,f),I.remains]}static parseUserBinding(n){if(!n)return[];const I=[];let d;for(;n.length>0;)[d,n]=this.parseSimpleUserBinding(n),I.push(d);return I}}e.KeybindingParser=M}),define(Q[2],J([0,1,42,69]),function(H,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const M=!1;let C=null;function n(i){C=i}if(e.setDisposableTracker=n,M){const i="__is_disposable_tracked__";n(new class{trackDisposable(o){const h=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[i]||console.log(h)},3e3)}setParent(o,h){if(o&&o!==P.None)try{o[i]=!0}catch{}}markAsDisposed(o){if(o&&o!==P.None)try{o[i]=!0}catch{}}markAsSingleton(o){}})}function I(i){return C?.trackDisposable(i),i}function d(i){C?.markAsDisposed(i)}function f(i,o){C?.setParent(i,o)}function y(i,o){if(!!C)for(const h of i)C.setParent(h,o)}function E(i){return C?.markAsSingleton(i),i}e.markAsSingleton=E;class m extends Error{constructor(o){super(`Encountered errors while disposing of store. Errors: [${o.join(", ")}]`);this.errors=o}}e.MultiDisposeError=m;function p(i){return typeof i.dispose=="function"&&i.dispose.length===0}e.isDisposable=p;function t(i){if(D.Iterable.is(i)){let o=[];for(const h of i)if(h)try{h.dispose()}catch(g){o.push(g)}if(o.length===1)throw o[0];if(o.length>1)throw new m(o);return Array.isArray(i)?[]:i}else if(i)return i.dispose(),i}e.dispose=t;function w(...i){const o=b(()=>t(i));return y(i,o),o}e.combinedDisposable=w;function b(i){const o=I({dispose:(0,v.once)(()=>{d(o),i()})});return o}e.toDisposable=b;class S{constructor(){this._toDispose=new Set,this._isDisposed=!1,I(this)}dispose(){this._isDisposed||(d(this),this._isDisposed=!0,this.clear())}clear(){try{t(this._toDispose.values())}finally{this._toDispose.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return f(o,this),this._isDisposed?S.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(o),o}}e.DisposableStore=S,S.DISABLE_DISPOSED_WARNING=!1;class P{constructor(){this._store=new S,I(this),f(this._store,this)}dispose(){d(this),this._store.dispose()}_register(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(o)}}e.Disposable=P,P.None=Object.freeze({dispose(){}});class c{constructor(){this._isDisposed=!1,I(this)}get value(){return this._isDisposed?void 0:this._value}set value(o){this._isDisposed||o===this._value||(this._value?.dispose(),o&&f(o,this),this._value=o)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,d(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const o=this._value;return this._value=void 0,o&&f(o,null),o}}e.MutableDisposable=c;class a{constructor(o){this._disposable=o,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=a;class l{constructor(){this.references=new Map}acquire(o,...h){let g=this.references.get(o);g||(g={counter:0,object:this.createReferencedObject(o,...h)},this.references.set(o,g));const{object:k}=g,L=(0,v.once)(()=>{--g.counter==0&&(this.destroyReferencedObject(o,g.object),this.references.delete(o))});return g.counter++,{object:k,dispose:L}}}e.ReferenceCollection=l;class s{constructor(o){this.referenceCollection=o}async acquire(o,...h){const g=this.referenceCollection.acquire(o,...h);try{return{object:await g.object,dispose:()=>g.dispose()}}catch(k){throw g.dispose(),k}}}e.AsyncReferenceCollection=s;class u{constructor(o){this.object=o}dispose(){}}e.ImmortalReference=u;function r(i){const o=new S;try{i(o)}finally{o.dispose()}}e.disposeOnReturn=r}),define(Q[107],J([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class v{constructor(C){this.element=C,this.next=v.Undefined,this.prev=v.Undefined}}v.Undefined=new v(void 0);class D{constructor(){this._first=v.Undefined,this._last=v.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===v.Undefined}clear(){let C=this._first;for(;C!==v.Undefined;){const n=C.next;C.prev=v.Undefined,C.next=v.Undefined,C=n}this._first=v.Undefined,this._last=v.Undefined,this._size=0}unshift(C){return this._insert(C,!1)}push(C){return this._insert(C,!0)}_insert(C,n){const I=new v(C);if(this._first===v.Undefined)this._first=I,this._last=I;else if(n){const f=this._last;this._last=I,I.prev=f,f.next=I}else{const f=this._first;this._first=I,I.next=f,f.prev=I}this._size+=1;let d=!1;return()=>{d||(d=!0,this._remove(I))}}shift(){if(this._first!==v.Undefined){const C=this._first.element;return this._remove(this._first),C}}pop(){if(this._last!==v.Undefined){const C=this._last.element;return this._remove(this._last),C}}_remove(C){if(C.prev!==v.Undefined&&C.next!==v.Undefined){const n=C.prev;n.next=C.next,C.next.prev=n}else C.prev===v.Undefined&&C.next===v.Undefined?(this._first=v.Undefined,this._last=v.Undefined):C.next===v.Undefined?(this._last=this._last.prev,this._last.next=v.Undefined):C.prev===v.Undefined&&(this._first=this._first.next,this._first.prev=v.Undefined);this._size-=1}*[Symbol.iterator](){let C=this._first;for(;C!==v.Undefined;)yield C.element,C=C.next}}e.LinkedList=D}),function(){function H(M){const C=[];typeof M=="number"&&C.push("code/timeOrigin",M);function n(d){C.push(d,Date.now())}function I(){const d=[];for(let f=0;f<C.length;f+=2)d.push({name:C[f],startTime:C[f+1]});return d}return{mark:n,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?H():{mark(M){performance.mark(M)},getMarks(){let M=performance.timeOrigin;typeof M!="number"&&(M=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const C=[{name:"code/timeOrigin",startTime:Math.round(M)}];for(const n of performance.getEntriesByType("mark"))C.push({name:n.name,startTime:Math.round(M+n.startTime)});return C}};if(typeof process=="object"){const M=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return H(M)}else return console.trace("perf-util loaded in UNKNOWN environment"),H()}function v(M){return M.MonacoPerformanceMarks||(M.MonacoPerformanceMarks=e()),M.MonacoPerformanceMarks}var D;typeof global=="object"?D=global:typeof self=="object"?D=self:D={},typeof define=="function"?define("vs/base/common/performance",[],function(){return v(D)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=v(D):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),D.perf=v(D))}(),define(Q[3],J([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const v="en";let D=!1,M=!1,C=!1,n=!1,I=!1,d=!1,f=!1,y,E=v,m,p;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let t;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?t=e.globals.vscode.process:typeof process!="undefined"&&(t=process);const w=typeof t?.versions?.electron=="string"&&t.type==="renderer";if(e.isElectronSandboxed=w&&t?.sandboxed,typeof navigator=="object"&&!w)p=navigator.userAgent,D=p.indexOf("Windows")>=0,M=p.indexOf("Macintosh")>=0,f=(p.indexOf("Macintosh")>=0||p.indexOf("iPad")>=0||p.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,C=p.indexOf("Linux")>=0,d=!0,y=navigator.language,E=y;else if(typeof t=="object"){D=t.platform==="win32",M=t.platform==="darwin",C=t.platform==="linux",n=C&&!!t.env.SNAP&&!!t.env.SNAP_REVISION,y=v,E=v;const r=t.env.VSCODE_NLS_CONFIG;if(r)try{const i=JSON.parse(r),o=i.availableLanguages["*"];y=i.locale,E=o||v,m=i._translationsConfigFile}catch(i){}I=!0}else console.error("Unable to resolve platform.");var b;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(b=e.Platform||(e.Platform={}));function S(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=S;let P=0;M?P=1:D?P=3:C&&(P=2),e.isWindows=D,e.isMacintosh=M,e.isLinux=C,e.isLinuxSnap=n,e.isNative=I,e.isWeb=d,e.isIOS=f,e.platform=P,e.userAgent=p,e.language=E;var c;(function(r){function i(){return e.language}r.value=i;function o(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=o;function h(){return e.language==="en"}r.isDefault=h})(c=e.Language||(e.Language={})),e.locale=y,e.translationsConfigFile=m,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let o=[];e.globals.addEventListener("message",g=>{if(g.data&&g.data.vscodeSetImmediateId)for(let k=0,L=o.length;k<L;k++){const R=o[k];if(R.id===g.data.vscodeSetImmediateId){o.splice(k,1),R.callback();return}}});let h=0;return g=>{const k=++h;o.push({id:k,callback:g}),e.globals.postMessage({vscodeSetImmediateId:k},"*")}}if(typeof t?.nextTick=="function")return t.nextTick.bind(t);const i=Promise.resolve();return o=>i.then(o)}();var a;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(a=e.OperatingSystem||(e.OperatingSystem={})),e.OS=M||f?2:D?1:3;let l=!0,s=!1;function u(){if(!s){s=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,l=new Uint16Array(r.buffer)[0]===(2<<8)+1}return l}e.isLittleEndian=u}),define(Q[32],J([0,1,3]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.nextTick=e.platform=e.env=e.cwd=void 0;let D;if(typeof v.globals.vscode!="undefined"&&typeof v.globals.vscode.process!="undefined"){const M=v.globals.vscode.process;D={get platform(){return M.platform},get arch(){return M.arch},get env(){return M.env},cwd(){return M.cwd()},nextTick(C){return(0,v.setImmediate)(C)}}}else typeof process!="undefined"?D={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(M){return process.nextTick(M)}}:D={get platform(){return v.isWindows?"win32":v.isMacintosh?"darwin":"linux"},get arch(){},nextTick(M){return(0,v.setImmediate)(M)},get env(){return{}},cwd(){return"/"}};e.cwd=D.cwd,e.env=D.env,e.platform=D.platform,e.nextTick=D.nextTick,e.arch=D.arch}),define(Q[8],J([0,1,32]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const D=65,M=97,C=90,n=122,I=46,d=47,f=92,y=58,E=63;class m extends Error{constructor(a,l,s){let u;typeof l=="string"&&l.indexOf("not ")===0?(u="must not be",l=l.replace(/^not /,"")):u="must be";const r=a.indexOf(".")!==-1?"property":"argument";let i=`The "${a}" ${r} ${u} of type ${l}`;i+=`. Received type ${typeof s}`,super(i),this.code="ERR_INVALID_ARG_TYPE"}}function p(c,a){if(typeof c!="string")throw new m(a,"string",c)}function t(c){return c===d||c===f}function w(c){return c===d}function b(c){return c>=D&&c<=C||c>=M&&c<=n}function S(c,a,l,s){let u="",r=0,i=-1,o=0,h=0;for(let g=0;g<=c.length;++g){if(g<c.length)h=c.charCodeAt(g);else{if(s(h))break;h=d}if(s(h)){if(!(i===g-1||o===1))if(o===2){if(u.length<2||r!==2||u.charCodeAt(u.length-1)!==I||u.charCodeAt(u.length-2)!==I){if(u.length>2){const k=u.lastIndexOf(l);k===-1?(u="",r=0):(u=u.slice(0,k),r=u.length-1-u.lastIndexOf(l)),i=g,o=0;continue}else if(u.length!==0){u="",r=0,i=g,o=0;continue}}a&&(u+=u.length>0?`${l}..`:"..",r=2)}else u.length>0?u+=`${l}${c.slice(i+1,g)}`:u=c.slice(i+1,g),r=g-i-1;i=g,o=0}else h===I&&o!==-1?++o:o=-1}return u}function P(c,a){if(a===null||typeof a!="object")throw new m("pathObject","Object",a);const l=a.dir||a.root,s=a.base||`${a.name||""}${a.ext||""}`;return l?l===a.root?`${l}${s}`:`${l}${c}${s}`:s}e.win32={resolve(...c){let a="",l="",s=!1;for(let u=c.length-1;u>=-1;u--){let r;if(u>=0){if(r=c[u],p(r,"path"),r.length===0)continue}else a.length===0?r=v.cwd():(r=v.env[`=${a}`]||v.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==a.toLowerCase()&&r.charCodeAt(2)===f)&&(r=`${a}\\`));const i=r.length;let o=0,h="",g=!1;const k=r.charCodeAt(0);if(i===1)t(k)&&(o=1,g=!0);else if(t(k))if(g=!0,t(r.charCodeAt(1))){let L=2,R=L;for(;L<i&&!t(r.charCodeAt(L));)L++;if(L<i&&L!==R){const W=r.slice(R,L);for(R=L;L<i&&t(r.charCodeAt(L));)L++;if(L<i&&L!==R){for(R=L;L<i&&!t(r.charCodeAt(L));)L++;(L===i||L!==R)&&(h=`\\\\${W}\\${r.slice(R,L)}`,o=L)}}}else o=1;else b(k)&&r.charCodeAt(1)===y&&(h=r.slice(0,2),o=2,i>2&&t(r.charCodeAt(2))&&(g=!0,o=3));if(h.length>0)if(a.length>0){if(h.toLowerCase()!==a.toLowerCase())continue}else a=h;if(s){if(a.length>0)break}else if(l=`${r.slice(o)}\\${l}`,s=g,g&&a.length>0)break}return l=S(l,!s,"\\",t),s?`${a}\\${l}`:`${a}${l}`||"."},normalize(c){p(c,"path");const a=c.length;if(a===0)return".";let l=0,s,u=!1;const r=c.charCodeAt(0);if(a===1)return w(r)?"\\":c;if(t(r))if(u=!0,t(c.charCodeAt(1))){let o=2,h=o;for(;o<a&&!t(c.charCodeAt(o));)o++;if(o<a&&o!==h){const g=c.slice(h,o);for(h=o;o<a&&t(c.charCodeAt(o));)o++;if(o<a&&o!==h){for(h=o;o<a&&!t(c.charCodeAt(o));)o++;if(o===a)return`\\\\${g}\\${c.slice(h)}\\`;o!==h&&(s=`\\\\${g}\\${c.slice(h,o)}`,l=o)}}}else l=1;else b(r)&&c.charCodeAt(1)===y&&(s=c.slice(0,2),l=2,a>2&&t(c.charCodeAt(2))&&(u=!0,l=3));let i=l<a?S(c.slice(l),!u,"\\",t):"";return i.length===0&&!u&&(i="."),i.length>0&&t(c.charCodeAt(a-1))&&(i+="\\"),s===void 0?u?`\\${i}`:i:u?`${s}\\${i}`:`${s}${i}`},isAbsolute(c){p(c,"path");const a=c.length;if(a===0)return!1;const l=c.charCodeAt(0);return t(l)||a>2&&b(l)&&c.charCodeAt(1)===y&&t(c.charCodeAt(2))},join(...c){if(c.length===0)return".";let a,l;for(let r=0;r<c.length;++r){const i=c[r];p(i,"path"),i.length>0&&(a===void 0?a=l=i:a+=`\\${i}`)}if(a===void 0)return".";let s=!0,u=0;if(typeof l=="string"&&t(l.charCodeAt(0))){++u;const r=l.length;r>1&&t(l.charCodeAt(1))&&(++u,r>2&&(t(l.charCodeAt(2))?++u:s=!1))}if(s){for(;u<a.length&&t(a.charCodeAt(u));)u++;u>=2&&(a=`\\${a.slice(u)}`)}return e.win32.normalize(a)},relative(c,a){if(p(c,"from"),p(a,"to"),c===a)return"";const l=e.win32.resolve(c),s=e.win32.resolve(a);if(l===s||(c=l.toLowerCase(),a=s.toLowerCase(),c===a))return"";let u=0;for(;u<c.length&&c.charCodeAt(u)===f;)u++;let r=c.length;for(;r-1>u&&c.charCodeAt(r-1)===f;)r--;const i=r-u;let o=0;for(;o<a.length&&a.charCodeAt(o)===f;)o++;let h=a.length;for(;h-1>o&&a.charCodeAt(h-1)===f;)h--;const g=h-o,k=i<g?i:g;let L=-1,R=0;for(;R<k;R++){const j=c.charCodeAt(u+R);if(j!==a.charCodeAt(o+R))break;j===f&&(L=R)}if(R!==k){if(L===-1)return s}else{if(g>k){if(a.charCodeAt(o+R)===f)return s.slice(o+R+1);if(R===2)return s.slice(o+R)}i>k&&(c.charCodeAt(u+R)===f?L=R:R===2&&(L=3)),L===-1&&(L=0)}let W="";for(R=u+L+1;R<=r;++R)(R===r||c.charCodeAt(R)===f)&&(W+=W.length===0?"..":"\\..");return o+=L,W.length>0?`${W}${s.slice(o,h)}`:(s.charCodeAt(o)===f&&++o,s.slice(o,h))},toNamespacedPath(c){if(typeof c!="string")return c;if(c.length===0)return"";const a=e.win32.resolve(c);if(a.length<=2)return c;if(a.charCodeAt(0)===f){if(a.charCodeAt(1)===f){const l=a.charCodeAt(2);if(l!==E&&l!==I)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(b(a.charCodeAt(0))&&a.charCodeAt(1)===y&&a.charCodeAt(2)===f)return`\\\\?\\${a}`;return c},dirname(c){p(c,"path");const a=c.length;if(a===0)return".";let l=-1,s=0;const u=c.charCodeAt(0);if(a===1)return t(u)?c:".";if(t(u)){if(l=s=1,t(c.charCodeAt(1))){let o=2,h=o;for(;o<a&&!t(c.charCodeAt(o));)o++;if(o<a&&o!==h){for(h=o;o<a&&t(c.charCodeAt(o));)o++;if(o<a&&o!==h){for(h=o;o<a&&!t(c.charCodeAt(o));)o++;if(o===a)return c;o!==h&&(l=s=o+1)}}}}else b(u)&&c.charCodeAt(1)===y&&(l=a>2&&t(c.charCodeAt(2))?3:2,s=l);let r=-1,i=!0;for(let o=a-1;o>=s;--o)if(t(c.charCodeAt(o))){if(!i){r=o;break}}else i=!1;if(r===-1){if(l===-1)return".";r=l}return c.slice(0,r)},basename(c,a){a!==void 0&&p(a,"ext"),p(c,"path");let l=0,s=-1,u=!0,r;if(c.length>=2&&b(c.charCodeAt(0))&&c.charCodeAt(1)===y&&(l=2),a!==void 0&&a.length>0&&a.length<=c.length){if(a===c)return"";let i=a.length-1,o=-1;for(r=c.length-1;r>=l;--r){const h=c.charCodeAt(r);if(t(h)){if(!u){l=r+1;break}}else o===-1&&(u=!1,o=r+1),i>=0&&(h===a.charCodeAt(i)?--i==-1&&(s=r):(i=-1,s=o))}return l===s?s=o:s===-1&&(s=c.length),c.slice(l,s)}for(r=c.length-1;r>=l;--r)if(t(c.charCodeAt(r))){if(!u){l=r+1;break}}else s===-1&&(u=!1,s=r+1);return s===-1?"":c.slice(l,s)},extname(c){p(c,"path");let a=0,l=-1,s=0,u=-1,r=!0,i=0;c.length>=2&&c.charCodeAt(1)===y&&b(c.charCodeAt(0))&&(a=s=2);for(let o=c.length-1;o>=a;--o){const h=c.charCodeAt(o);if(t(h)){if(!r){s=o+1;break}continue}u===-1&&(r=!1,u=o+1),h===I?l===-1?l=o:i!==1&&(i=1):l!==-1&&(i=-1)}return l===-1||u===-1||i===0||i===1&&l===u-1&&l===s+1?"":c.slice(l,u)},format:P.bind(null,"\\"),parse(c){p(c,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return a;const l=c.length;let s=0,u=c.charCodeAt(0);if(l===1)return t(u)?(a.root=a.dir=c,a):(a.base=a.name=c,a);if(t(u)){if(s=1,t(c.charCodeAt(1))){let L=2,R=L;for(;L<l&&!t(c.charCodeAt(L));)L++;if(L<l&&L!==R){for(R=L;L<l&&t(c.charCodeAt(L));)L++;if(L<l&&L!==R){for(R=L;L<l&&!t(c.charCodeAt(L));)L++;L===l?s=L:L!==R&&(s=L+1)}}}}else if(b(u)&&c.charCodeAt(1)===y){if(l<=2)return a.root=a.dir=c,a;if(s=2,t(c.charCodeAt(2))){if(l===3)return a.root=a.dir=c,a;s=3}}s>0&&(a.root=c.slice(0,s));let r=-1,i=s,o=-1,h=!0,g=c.length-1,k=0;for(;g>=s;--g){if(u=c.charCodeAt(g),t(u)){if(!h){i=g+1;break}continue}o===-1&&(h=!1,o=g+1),u===I?r===-1?r=g:k!==1&&(k=1):r!==-1&&(k=-1)}return o!==-1&&(r===-1||k===0||k===1&&r===o-1&&r===i+1?a.base=a.name=c.slice(i,o):(a.name=c.slice(i,r),a.base=c.slice(i,o),a.ext=c.slice(r,o))),i>0&&i!==s?a.dir=c.slice(0,i-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...c){let a="",l=!1;for(let s=c.length-1;s>=-1&&!l;s--){const u=s>=0?c[s]:v.cwd();p(u,"path"),u.length!==0&&(a=`${u}/${a}`,l=u.charCodeAt(0)===d)}return a=S(a,!l,"/",w),l?`/${a}`:a.length>0?a:"."},normalize(c){if(p(c,"path"),c.length===0)return".";const a=c.charCodeAt(0)===d,l=c.charCodeAt(c.length-1)===d;return c=S(c,!a,"/",w),c.length===0?a?"/":l?"./":".":(l&&(c+="/"),a?`/${c}`:c)},isAbsolute(c){return p(c,"path"),c.length>0&&c.charCodeAt(0)===d},join(...c){if(c.length===0)return".";let a;for(let l=0;l<c.length;++l){const s=c[l];p(s,"path"),s.length>0&&(a===void 0?a=s:a+=`/${s}`)}return a===void 0?".":e.posix.normalize(a)},relative(c,a){if(p(c,"from"),p(a,"to"),c===a||(c=e.posix.resolve(c),a=e.posix.resolve(a),c===a))return"";const l=1,s=c.length,u=s-l,r=1,i=a.length-r,o=u<i?u:i;let h=-1,g=0;for(;g<o;g++){const L=c.charCodeAt(l+g);if(L!==a.charCodeAt(r+g))break;L===d&&(h=g)}if(g===o)if(i>o){if(a.charCodeAt(r+g)===d)return a.slice(r+g+1);if(g===0)return a.slice(r+g)}else u>o&&(c.charCodeAt(l+g)===d?h=g:g===0&&(h=0));let k="";for(g=l+h+1;g<=s;++g)(g===s||c.charCodeAt(g)===d)&&(k+=k.length===0?"..":"/..");return`${k}${a.slice(r+h)}`},toNamespacedPath(c){return c},dirname(c){if(p(c,"path"),c.length===0)return".";const a=c.charCodeAt(0)===d;let l=-1,s=!0;for(let u=c.length-1;u>=1;--u)if(c.charCodeAt(u)===d){if(!s){l=u;break}}else s=!1;return l===-1?a?"/":".":a&&l===1?"//":c.slice(0,l)},basename(c,a){a!==void 0&&p(a,"ext"),p(c,"path");let l=0,s=-1,u=!0,r;if(a!==void 0&&a.length>0&&a.length<=c.length){if(a===c)return"";let i=a.length-1,o=-1;for(r=c.length-1;r>=0;--r){const h=c.charCodeAt(r);if(h===d){if(!u){l=r+1;break}}else o===-1&&(u=!1,o=r+1),i>=0&&(h===a.charCodeAt(i)?--i==-1&&(s=r):(i=-1,s=o))}return l===s?s=o:s===-1&&(s=c.length),c.slice(l,s)}for(r=c.length-1;r>=0;--r)if(c.charCodeAt(r)===d){if(!u){l=r+1;break}}else s===-1&&(u=!1,s=r+1);return s===-1?"":c.slice(l,s)},extname(c){p(c,"path");let a=-1,l=0,s=-1,u=!0,r=0;for(let i=c.length-1;i>=0;--i){const o=c.charCodeAt(i);if(o===d){if(!u){l=i+1;break}continue}s===-1&&(u=!1,s=i+1),o===I?a===-1?a=i:r!==1&&(r=1):a!==-1&&(r=-1)}return a===-1||s===-1||r===0||r===1&&a===s-1&&a===l+1?"":c.slice(a,s)},format:P.bind(null,"/"),parse(c){p(c,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return a;const l=c.charCodeAt(0)===d;let s;l?(a.root="/",s=1):s=0;let u=-1,r=0,i=-1,o=!0,h=c.length-1,g=0;for(;h>=s;--h){const k=c.charCodeAt(h);if(k===d){if(!o){r=h+1;break}continue}i===-1&&(o=!1,i=h+1),k===I?u===-1?u=h:g!==1&&(g=1):u!==-1&&(g=-1)}if(i!==-1){const k=r===0&&l?1:r;u===-1||g===0||g===1&&u===i-1&&u===r+1?a.base=a.name=c.slice(k,i):(a.name=c.slice(k,u),a.base=c.slice(k,i),a.ext=c.slice(u,i))}return r>0?a.dir=c.slice(0,r-1):l&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=v.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=v.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=v.platform==="win32"?e.win32.join:e.posix.join,e.resolve=v.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=v.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=v.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=v.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=v.platform==="win32"?e.win32.extname:e.posix.extname,e.format=v.platform==="win32"?e.win32.format:e.posix.format,e.parse=v.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=v.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=v.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=v.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(Q[80],J([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var v;(function(C){C[C.stdout=0]="stdout",C[C.stderr=1]="stderr"})(v=e.Source||(e.Source={}));var D;(function(C){C[C.Success=0]="Success",C[C.Unknown=1]="Unknown",C[C.AccessDenied=2]="AccessDenied",C[C.ProcessNotFound=3]="ProcessNotFound"})(D=e.TerminateResponseCode||(e.TerminateResponseCode={}));function M(C,...n){const I=n.reduce((y,E)=>(y[E]=!0,y),{}),d=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(C).filter(y=>!I[y]).forEach(y=>{for(let E=0;E<d.length;E++)if(y.search(d[E])!==-1){delete C[y];break}})}e.sanitizeProcessEnvironment=M}),define(Q[108],J([0,1,3]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const D=v.globals.performance&&typeof v.globals.performance.now=="function";class M{constructor(n){this._highResolution=D&&n,this._startTime=this._now(),this._stopTime=-1}static create(n=!0){return new M(n)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?v.globals.performance.now():Date.now()}}e.StopWatch=M}),define(Q[4],J([0,1,16,42,2,107,108]),function(H,e,v,D,M,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var I;(function(a){a.None=()=>M.Disposable.None;function l(T){return(B,q=null,U)=>{let N=!1,_;return _=T(Y=>{if(!N)return _?_.dispose():N=!0,B.call(q,Y)},null,U),N&&_.dispose(),_}}a.once=l;function s(T,B){return g((q,U=null,N)=>T(_=>q.call(U,B(_)),null,N))}a.map=s;function u(T,B){return g((q,U=null,N)=>T(_=>{B(_),q.call(U,_)},null,N))}a.forEach=u;function r(T,B){return g((q,U=null,N)=>T(_=>B(_)&&q.call(U,_),null,N))}a.filter=r;function i(T){return T}a.signal=i;function o(...T){return(B,q=null,U)=>(0,M.combinedDisposable)(...T.map(N=>N(_=>B.call(q,_),null,U)))}a.any=o;function h(T,B,q){let U=q;return s(T,N=>(U=B(U,N),U))}a.reduce=h;function g(T){let B;const q=new m({onFirstListenerAdd(){B=T(q.fire,q)},onLastListenerRemove(){B.dispose()}});return q.event}function k(T,B,q=100,U=!1,N){let _,Y,F,A=0;const O=new m({leakWarningThreshold:N,onFirstListenerAdd(){_=T($=>{A++,Y=B(Y,$),U&&!F&&(O.fire(Y),Y=void 0),clearTimeout(F),F=setTimeout(()=>{const X=Y;Y=void 0,F=void 0,(!U||A>1)&&O.fire(X),A=0},q)})},onLastListenerRemove(){_.dispose()}});return O.event}a.debounce=k;function L(T,B=(q,U)=>q===U){let q=!0,U;return r(T,N=>{const _=q||!B(N,U);return q=!1,U=N,_})}a.latch=L;function R(T,B){return[a.filter(T,B),a.filter(T,q=>!B(q))]}a.split=R;function W(T,B=!1,q=[]){let U=q.slice(),N=T(F=>{U?U.push(F):Y.fire(F)});const _=()=>{U&&U.forEach(F=>Y.fire(F)),U=null},Y=new m({onFirstListenerAdd(){N||(N=T(F=>Y.fire(F)))},onFirstListenerDidAdd(){U&&(B?setTimeout(_):_())},onLastListenerRemove(){N&&N.dispose(),N=null}});return Y.event}a.buffer=W;class j{constructor(B){this.event=B}map(B){return new j(s(this.event,B))}forEach(B){return new j(u(this.event,B))}filter(B){return new j(r(this.event,B))}reduce(B,q){return new j(h(this.event,B,q))}latch(){return new j(L(this.event))}debounce(B,q=100,U=!1,N){return new j(k(this.event,B,q,U,N))}on(B,q,U){return this.event(B,q,U)}once(B,q,U){return l(this.event)(B,q,U)}}function x(T){return new j(T)}a.chain=x;function ne(T,B,q=U=>U){const U=(...F)=>Y.fire(q(...F)),N=()=>T.on(B,U),_=()=>T.removeListener(B,U),Y=new m({onFirstListenerAdd:N,onLastListenerRemove:_});return Y.event}a.fromNodeEventEmitter=ne;function oe(T,B,q=U=>U){const U=(...F)=>Y.fire(q(...F)),N=()=>T.addEventListener(B,U),_=()=>T.removeEventListener(B,U),Y=new m({onFirstListenerAdd:N,onLastListenerRemove:_});return Y.event}a.fromDOMEventEmitter=oe;function G(T){return new Promise(B=>l(T)(B))}a.toPromise=G})(I=e.Event||(e.Event={}));class d{constructor(l){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${l}_${d._idPool++}`}start(l){this._stopWatch=new n.StopWatch(!0),this._listenerCount=l}stop(){if(this._stopWatch){const l=this._stopWatch.elapsed();this._elapsedOverall+=l,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${l.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}d._idPool=0;let f=-1;function y(a){const l=f;return f=a,{dispose(){f=l}}}e.setGlobalLeakWarningThreshold=y;class E{constructor(l,s=Math.random().toString(18).slice(2,5)){this.customThreshold=l,this.name=s,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(l){let s=f;if(typeof this.customThreshold=="number"&&(s=this.customThreshold),s<=0||l<s)return;this._stacks||(this._stacks=new Map);const u=new Error().stack.split(`
`).slice(3).join(`
`),r=this._stacks.get(u)||0;if(this._stacks.set(u,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=s*.5;let i,o=0;for(const[h,g]of this._stacks)(!i||o<g)&&(i=h,o=g);console.warn(`[${this.name}] potential listener LEAK detected, having ${l} listeners already. MOST frequent listener (${o}):`),console.warn(i)}return()=>{const i=this._stacks.get(u)||0;this._stacks.set(u,i-1)}}}class m{constructor(l){this._disposed=!1,this._options=l,this._leakageMon=f>0?new E(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new d(this._options._profName):void 0}get event(){return this._event||(this._event=(l,s,u)=>{this._listeners||(this._listeners=new C.LinkedList);const r=this._listeners.isEmpty();r&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(s?[l,s]:l);r&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,l,s);const o=this._leakageMon?.check(this._listeners.size),h=(0,M.toDisposable)(()=>{o&&o(),this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return u instanceof M.DisposableStore?u.add(h):Array.isArray(u)&&u.push(h),h}),this._event}fire(l){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new C.LinkedList);for(let s of this._listeners)this._deliveryQueue.push([s,l]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[s,u]=this._deliveryQueue.shift();try{typeof s=="function"?s.call(void 0,u):s[0].call(s[1],u)}catch(r){(0,v.onUnexpectedError)(r)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=m;class p extends m{async fireAsync(l,s,u){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new C.LinkedList);for(const r of this._listeners)this._asyncDeliveryQueue.push([r,l]);for(;this._asyncDeliveryQueue.size>0&&!s.isCancellationRequested;){const[r,i]=this._asyncDeliveryQueue.shift(),o=[],h={...i,waitUntil:g=>{if(Object.isFrozen(o))throw new Error("waitUntil can NOT be called asynchronous");u&&(g=u(g,typeof r=="function"?r:r[0])),o.push(g)}};try{typeof r=="function"?r.call(void 0,h):r[0].call(r[1],h)}catch(g){(0,v.onUnexpectedError)(g);continue}Object.freeze(o),await Promise.allSettled(o).then(g=>{for(const k of g)k.status==="rejected"&&(0,v.onUnexpectedError)(k.reason)})}}}}e.AsyncEmitter=p;class t extends m{constructor(l){super(l);this._isPaused=0,this._eventQueue=new C.LinkedList,this._mergeFn=l?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const l=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(l))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(l){this._listeners&&(this._isPaused!==0?this._eventQueue.push(l):super.fire(l))}}e.PauseableEmitter=t;class w extends t{constructor(l){super(l);this._delay=l.delay??100}fire(l){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(l)}}e.DebounceEmitter=w;class b extends m{constructor(l){super(l);this._queuedEvents=[],this._mergeFn=l?.merge}fire(l){this._queuedEvents.push(l),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(s=>super.fire(s)),this._queuedEvents=[]})}}e.MicrotaskEmitter=b;class S{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new m({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(l){const s={event:l,listener:null};this.events.push(s),this.hasListeners&&this.hook(s);const u=()=>{this.hasListeners&&this.unhook(s);const r=this.events.indexOf(s);this.events.splice(r,1)};return(0,M.toDisposable)((0,D.once)(u))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(l=>this.hook(l))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(l=>this.unhook(l))}hook(l){l.listener=l.event(s=>this.emitter.fire(s))}unhook(l){l.listener&&l.listener.dispose(),l.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=S;class P{constructor(){this.buffers=[]}wrapEvent(l){return(s,u,r)=>l(i=>{const o=this.buffers[this.buffers.length-1];o?o.push(()=>s.call(u,i)):s.call(u,i)},void 0,r)}bufferEvents(l){const s=[];this.buffers.push(s);const u=l();return this.buffers.pop(),s.forEach(r=>r()),u}}e.EventBufferer=P;class c{constructor(){this.listening=!1,this.inputEvent=I.None,this.inputEventListener=M.Disposable.None,this.emitter=new m({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(l){this.inputEvent=l,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=l(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=c}),define(Q[23],J([0,1,4]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const D=Object.freeze(function(I,d){const f=setTimeout(I.bind(d),0);return{dispose(){clearTimeout(f)}}});var M;(function(I){function d(f){return f===I.None||f===I.Cancelled||f instanceof C?!0:!f||typeof f!="object"?!1:typeof f.isCancellationRequested=="boolean"&&typeof f.onCancellationRequested=="function"}I.isCancellationToken=d,I.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:v.Event.None}),I.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:D})})(M=e.CancellationToken||(e.CancellationToken={}));class C{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?D:(this._emitter||(this._emitter=new v.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class n{constructor(d){this._token=void 0,this._parentListener=void 0,this._parentListener=d&&d.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new C),this._token}cancel(){this._token?this._token instanceof C&&this._token.cancel():this._token=M.Cancelled}dispose(d=!1){d&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof C&&this._token.dispose():this._token=M.None}}e.CancellationTokenSource=n}),define(Q[109],J([0,1,4]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.iconRegistry=void 0;class D{constructor(){this._icons=new Map,this._onDidRegister=new v.Emitter}add(y){const E=this._icons.get(y.id);E?y.description?E.description=y.description:console.error(`Duplicate registration of codicon ${y.id}`):(this._icons.set(y.id,y),this._onDidRegister.fire(y))}get(y){return this._icons.get(y)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const M=new D;e.iconRegistry=M;function C(f){return f?f.replace(/\$\((.*?)\)/g,(y,E)=>` ${E} `).trim():""}e.getCodiconAriaLabel=C;class n{constructor(y,E,m){this.id=y,this.definition=E,this.description=m,M.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=n,n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",n.add.definition),n.gistNew=new n("gist-new",n.add.definition),n.repoCreate=new n("repo-create",n.add.definition),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.runErrors=new n("run-errors",{fontCharacter:"\\ebde"}),n.folderLibrary=new n("folder-library",{fontCharacter:"\\ebdf"}),n.debugContinueSmall=new n("debug-continue-small",{fontCharacter:"\\ebe0"}),n.beakerStop=new n("beaker-stop",{fontCharacter:"\\ebe1"}),n.graphLine=new n("graph-line",{fontCharacter:"\\ebe2"}),n.graphScatter=new n("graph-scatter",{fontCharacter:"\\ebe3"}),n.pieChart=new n("pie-chart",{fontCharacter:"\\ebe4"}),n.bracket=new n("bracket",n.json.definition),n.bracketDot=new n("bracket-dot",{fontCharacter:"\\ebe5"}),n.bracketError=new n("bracket-error",{fontCharacter:"\\ebe6"}),n.lockSmall=new n("lock-small",{fontCharacter:"\\ebe7"}),n.azureDevops=new n("azure-devops",{fontCharacter:"\\ebe8"}),n.verifiedFilled=new n("verified-filled",{fontCharacter:"\\ebe9"}),n.newLine=new n("newline",{fontCharacter:"\\ebea"}),n.dialogError=new n("dialog-error",n.error.definition),n.dialogWarning=new n("dialog-warning",n.warning.definition),n.dialogInfo=new n("dialog-info",n.info.definition),n.dialogClose=new n("dialog-close",n.close.definition),n.treeItemExpanded=new n("tree-item-expanded",n.chevronDown.definition),n.treeFilterOnTypeOn=new n("tree-filter-on-type-on",n.listFilter.definition),n.treeFilterOnTypeOff=new n("tree-filter-on-type-off",n.listSelection.definition),n.treeFilterClear=new n("tree-filter-clear",n.close.definition),n.treeItemLoading=new n("tree-item-loading",n.loading.definition),n.menuSelection=new n("menu-selection",n.check.definition),n.menuSubmenu=new n("menu-submenu",n.chevronRight.definition),n.menuBarMore=new n("menubar-more",n.more.definition),n.scrollbarButtonLeft=new n("scrollbar-button-left",n.triangleLeft.definition),n.scrollbarButtonRight=new n("scrollbar-button-right",n.triangleRight.definition),n.scrollbarButtonUp=new n("scrollbar-button-up",n.triangleUp.definition),n.scrollbarButtonDown=new n("scrollbar-button-down",n.triangleDown.definition),n.toolBarMore=new n("toolbar-more",n.more.definition),n.quickInputBack=new n("quick-input-back",n.arrowLeft.definition);function I(f,y){const E=["codicon","codicon-"+f];return y&&E.push("codicon-modifier-"+y),E}e.getClassNamesArray=I;var d;(function(f){f.iconNameSegment="[A-Za-z0-9]+",f.iconNameExpression="[A-Za-z0-9-]+",f.iconModifierExpression="~[A-Za-z]+",f.iconNameCharacter="[A-Za-z0-9~-]";const y=new RegExp(`^(${f.iconNameExpression})(${f.iconModifierExpression})?$`);function E(t){if(t instanceof n)return["codicon","codicon-"+t.id];const w=y.exec(t.id);if(!w)return E(n.error);let[,b,S]=w;const P=["codicon","codicon-"+b];return S&&P.push("codicon-modifier-"+S.substr(1)),P}f.asClassNameArray=E;function m(t){return E(t).join(" ")}f.asClassName=m;function p(t){return"."+E(t).join(".")}f.asCSSSelector=p})(d=e.CSSIcon||(e.CSSIcon={}))}),define(Q[60],J([0,1,16,2]),function(H,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function M(c){const a=c;return a?[a.on,a.pause,a.resume,a.destroy].every(l=>typeof l=="function"):!1}e.isReadableStream=M;function C(c){const a=c;return a?M(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}e.isReadableBufferedStream=C;function n(c,a){return new I(c,a)}e.newWriteableStream=n;class I{constructor(a,l){this.reducer=a,this.options=l,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(a){if(!this.state.destroyed){if(this.state.flowing)this.emitData(a);else if(this.buffer.data.push(a),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(l=>this.pendingWritePromises.push(l))}}error(a){this.state.destroyed||(this.state.flowing?this.emitError(a):this.buffer.error.push(a))}end(a){this.state.destroyed||(typeof a!="undefined"&&this.write(a),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(a){this.listeners.data.slice(0).forEach(l=>l(a))}emitError(a){this.listeners.error.length===0?(0,v.onUnexpectedError)(a):this.listeners.error.slice(0).forEach(l=>l(a))}emitEnd(){this.listeners.end.slice(0).forEach(a=>a())}on(a,l){if(!this.state.destroyed)switch(a){case"data":this.listeners.data.push(l),this.resume();break;case"end":this.listeners.end.push(l),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(l),this.state.flowing&&this.flowErrors();break}}removeListener(a,l){if(this.state.destroyed)return;let s;switch(a){case"data":s=this.listeners.data;break;case"end":s=this.listeners.end;break;case"error":s=this.listeners.error;break}if(s){const u=s.indexOf(l);u>=0&&s.splice(u,1)}}flowData(){if(this.buffer.data.length>0){const a=this.reducer(this.buffer.data);this.emitData(a),this.buffer.data.length=0;const l=[...this.pendingWritePromises];this.pendingWritePromises.length=0,l.forEach(s=>s())}}flowErrors(){if(this.listeners.error.length>0){for(const a of this.buffer.error)this.emitError(a);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function d(c,a){const l=[];let s;for(;(s=c.read())!==null;)l.push(s);return a(l)}e.consumeReadable=d;function f(c,a,l){const s=[];let u;for(;(u=c.read())!==null&&s.length<l;)s.push(u);return u===null&&s.length>0?a(s):{read:()=>{if(s.length>0)return s.shift();if(typeof u!="undefined"){const r=u;return u=void 0,r}return c.read()}}}e.peekReadable=f;function y(c,a){return new Promise((l,s)=>{const u=[];E(c,{onData:r=>{a&&u.push(r)},onError:r=>{a?s(r):l(void 0)},onEnd:()=>{l(a?a(u):void 0)}})})}e.consumeStream=y;function E(c,a){c.on("error",l=>a.onError(l)),c.on("end",()=>a.onEnd()),c.on("data",l=>a.onData(l))}e.listenStream=E;function m(c,a){return new Promise((l,s)=>{const u=new D.DisposableStore,r=[],i=g=>{if(r.push(g),r.length>a)return u.dispose(),c.pause(),l({stream:c,buffer:r,ended:!1})},o=g=>s(g),h=()=>l({stream:c,buffer:r,ended:!0});u.add((0,D.toDisposable)(()=>c.removeListener("error",o))),c.on("error",o),u.add((0,D.toDisposable)(()=>c.removeListener("end",h))),c.on("end",h),u.add((0,D.toDisposable)(()=>c.removeListener("data",i))),c.on("data",i)})}e.peekStream=m;function p(c,a){const l=n(a);return l.end(c),l}e.toStream=p;function t(){const c=n(()=>{throw new Error("not supported")});return c.end(),c}e.emptyStream=t;function w(c){let a=!1;return{read:()=>a?null:(a=!0,c)}}e.toReadable=w;function b(c,a,l){const s=n(l);return E(c,{onData:u=>s.write(a.data(u)),onError:u=>s.error(a.error?a.error(u):u),onEnd:()=>s.end()}),s}e.transform=b;function S(c,a,l){let s=!1;return{read:()=>{const u=a.read();return s?u:(s=!0,u!==null?l([c,u]):c)}}}e.prefixedReadable=S;function P(c,a,l){let s=!1;const u=n(l);return E(a,{onData:r=>s?u.write(r):(s=!0,u.write(l([c,r]))),onError:r=>u.error(r),onEnd:()=>{s||(s=!0,u.write(c)),u.end()}}),u}e.prefixedStream=P}),define(Q[17],J([0,1,60]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const D=typeof Buffer!="undefined";let M,C;class n{constructor(i){this.buffer=i,this.byteLength=this.buffer.byteLength}static alloc(i){return D?new n(Buffer.allocUnsafe(i)):new n(new Uint8Array(i))}static wrap(i){return D&&!Buffer.isBuffer(i)&&(i=Buffer.from(i.buffer,i.byteOffset,i.byteLength)),new n(i)}static fromString(i,o){return!(o?.dontUseNodeBuffer||!1)&&D?new n(Buffer.from(i)):(M||(M=new TextEncoder),new n(M.encode(i)))}static concat(i,o){if(typeof o=="undefined"){o=0;for(let k=0,L=i.length;k<L;k++)o+=i[k].byteLength}const h=n.alloc(o);let g=0;for(let k=0,L=i.length;k<L;k++){const R=i[k];h.set(R,g),g+=R.byteLength}return h}toString(){return D?this.buffer.toString():(C||(C=new TextDecoder),C.decode(this.buffer))}slice(i,o){return new n(this.buffer.subarray(i,o))}set(i,o){i instanceof n?this.buffer.set(i.buffer,o):this.buffer.set(i,o)}readUInt32BE(i){return f(this.buffer,i)}writeUInt32BE(i,o){y(this.buffer,i,o)}readUInt32LE(i){return E(this.buffer,i)}writeUInt32LE(i,o){m(this.buffer,i,o)}readUInt8(i){return p(this.buffer,i)}writeUInt8(i,o){t(this.buffer,i,o)}}e.VSBuffer=n;function I(r,i){return r[i+0]<<0>>>0|r[i+1]<<8>>>0}e.readUInt16LE=I;function d(r,i,o){r[o+0]=i&255,i=i>>>8,r[o+1]=i&255}e.writeUInt16LE=d;function f(r,i){return r[i]*2**24+r[i+1]*2**16+r[i+2]*2**8+r[i+3]}e.readUInt32BE=f;function y(r,i,o){r[o+3]=i,i=i>>>8,r[o+2]=i,i=i>>>8,r[o+1]=i,i=i>>>8,r[o]=i}e.writeUInt32BE=y;function E(r,i){return r[i+0]<<0>>>0|r[i+1]<<8>>>0|r[i+2]<<16>>>0|r[i+3]<<24>>>0}e.readUInt32LE=E;function m(r,i,o){r[o+0]=i&255,i=i>>>8,r[o+1]=i&255,i=i>>>8,r[o+2]=i&255,i=i>>>8,r[o+3]=i&255}e.writeUInt32LE=m;function p(r,i){return r[i]}e.readUInt8=p;function t(r,i,o){r[o]=i}e.writeUInt8=t;function w(r){return v.consumeReadable(r,i=>n.concat(i))}e.readableToBuffer=w;function b(r){return v.toReadable(r)}e.bufferToReadable=b;function S(r){return v.consumeStream(r,i=>n.concat(i))}e.streamToBuffer=S;async function P(r){return r.ended?n.concat(r.buffer):n.concat([...r.buffer,await S(r.stream)])}e.bufferedStreamToBuffer=P;function c(r){return v.toStream(r,i=>n.concat(i))}e.bufferToStream=c;function a(r){return v.transform(r,{data:i=>typeof i=="string"?n.fromString(i):n.wrap(i)},i=>n.concat(i))}e.streamToBufferReadableStream=a;function l(r){return v.newWriteableStream(i=>n.concat(i),r)}e.newWriteableBufferStream=l;function s(r,i){return v.prefixedReadable(r,i,o=>n.concat(o))}e.prefixedBufferReadable=s;function u(r,i){return v.prefixedStream(r,i,o=>n.concat(o))}e.prefixedBufferStream=u}),define(Q[25],J([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function v(K){return!K||typeof K!="string"?!0:K.trim().length===0}e.isFalsyOrWhitespace=v;const D=/{(\d+)}/g;function M(K,...re){return re.length===0?K:K.replace(D,function(le,we){const Ee=parseInt(we,10);return isNaN(Ee)||Ee<0||Ee>=re.length?le:re[Ee]})}e.format=M;const C=/{([^}]+)}/g;function n(K,re){return K.replace(C,(le,we)=>re[we]??le)}e.format2=n;function I(K){return K.replace(/[<>&]/g,function(re){switch(re){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return re}})}e.escape=I;function d(K){return K.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=d;function f(K,re){let le=0;const we=re.charCodeAt(0);for(let Ee=K.length-1;Ee>=0;Ee--)K.charCodeAt(Ee)===we&&le++;return le}e.count=f;function y(K,re,le="\u2026"){return K.length<=re?K:`${K.substr(0,re)}${le}`}e.truncate=y;function E(K,re=" "){const le=m(K,re);return p(le,re)}e.trim=E;function m(K,re){if(!K||!re)return K;const le=re.length;if(le===0||K.length===0)return K;let we=0;for(;K.indexOf(re,we)===we;)we=we+le;return K.substring(we)}e.ltrim=m;function p(K,re){if(!K||!re)return K;const le=re.length,we=K.length;if(le===0||we===0)return K;let Ee=we,De=-1;for(;De=K.lastIndexOf(re,Ee-1),!(De===-1||De+le!==Ee);){if(De===0)return"";Ee=De}return K.substring(0,Ee)}e.rtrim=p;function t(K){return K.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=t;function w(K){return K.replace(/\*/g,"")}e.stripWildcards=w;function b(K,re,le={}){if(!K)throw new Error("Cannot create regex from empty string");re||(K=d(K)),le.wholeWord&&(/\B/.test(K.charAt(0))||(K="\\b"+K),/\B/.test(K.charAt(K.length-1))||(K=K+"\\b"));let we="";return le.global&&(we+="g"),le.matchCase||(we+="i"),le.multiline&&(we+="m"),le.unicode&&(we+="u"),new RegExp(K,we)}e.createRegExp=b;function S(K){return K.source==="^"||K.source==="^$"||K.source==="$"||K.source==="^\\s*$"?!1:!!(K.exec("")&&K.lastIndex===0)}e.regExpLeadsToEndlessLoop=S;function P(K){return!!K.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=P;function c(K){return(K.global?"g":"")+(K.ignoreCase?"i":"")+(K.multiline?"m":"")+(K.unicode?"u":"")}e.regExpFlags=c;function a(K){return K.split(/\r\n|\r|\n/)}e.splitLines=a;function l(K){for(let re=0,le=K.length;re<le;re++){const we=K.charCodeAt(re);if(we!==32&&we!==9)return re}return-1}e.firstNonWhitespaceIndex=l;function s(K,re=0,le=K.length){for(let we=re;we<le;we++){const Ee=K.charCodeAt(we);if(Ee!==32&&Ee!==9)return K.substring(re,we)}return K.substring(re,le)}e.getLeadingWhitespace=s;function u(K,re=K.length-1){for(let le=re;le>=0;le--){const we=K.charCodeAt(le);if(we!==32&&we!==9)return le}return-1}e.lastNonWhitespaceIndex=u;function r(K,re){return K<re?-1:K>re?1:0}e.compare=r;function i(K,re,le=0,we=K.length,Ee=0,De=re.length){for(;le<we&&Ee<De;le++,Ee++){let Ne=K.charCodeAt(le),Be=re.charCodeAt(Ee);if(Ne<Be)return-1;if(Ne>Be)return 1}const Oe=we-le,_e=De-Ee;return Oe<_e?-1:Oe>_e?1:0}e.compareSubstring=i;function o(K,re){return h(K,re,0,K.length,0,re.length)}e.compareIgnoreCase=o;function h(K,re,le=0,we=K.length,Ee=0,De=re.length){for(;le<we&&Ee<De;le++,Ee++){let Ne=K.charCodeAt(le),Be=re.charCodeAt(Ee);if(Ne===Be)continue;if(Ne>=128||Be>=128)return i(K.toLowerCase(),re.toLowerCase(),le,we,Ee,De);g(Ne)&&(Ne-=32),g(Be)&&(Be-=32);const Ve=Ne-Be;if(Ve!==0)return Ve}const Oe=we-le,_e=De-Ee;return Oe<_e?-1:Oe>_e?1:0}e.compareSubstringIgnoreCase=h;function g(K){return K>=97&&K<=122}e.isLowerAsciiLetter=g;function k(K){return K>=65&&K<=90}e.isUpperAsciiLetter=k;function L(K,re){return K.length===re.length&&h(K,re)===0}e.equalsIgnoreCase=L;function R(K,re){const le=re.length;return re.length>K.length?!1:h(K,re,0,le)===0}e.startsWithIgnoreCase=R;function W(K,re){let le,we=Math.min(K.length,re.length);for(le=0;le<we;le++)if(K.charCodeAt(le)!==re.charCodeAt(le))return le;return we}e.commonPrefixLength=W;function j(K,re){let le,we=Math.min(K.length,re.length);const Ee=K.length-1,De=re.length-1;for(le=0;le<we;le++)if(K.charCodeAt(Ee-le)!==re.charCodeAt(De-le))return le;return we}e.commonSuffixLength=j;function x(K){return 55296<=K&&K<=56319}e.isHighSurrogate=x;function ne(K){return 56320<=K&&K<=57343}e.isLowSurrogate=ne;function oe(K,re){return(K-55296<<10)+(re-56320)+65536}e.computeCodePoint=oe;function G(K,re,le){const we=K.charCodeAt(le);if(x(we)&&le+1<re){const Ee=K.charCodeAt(le+1);if(ne(Ee))return oe(we,Ee)}return we}e.getNextCodePoint=G;function T(K,re){const le=K.charCodeAt(re-1);if(ne(le)&&re>1){const we=K.charCodeAt(re-2);if(x(we))return oe(we,le)}return le}function B(K,re){const le=Fe.getInstance(),we=re,Ee=K.length,De=G(K,Ee,re);re+=De>=65536?2:1;let Oe=le.getGraphemeBreakType(De);for(;re<Ee;){const _e=G(K,Ee,re),Ne=le.getGraphemeBreakType(_e);if(Ae(Oe,Ne))break;re+=_e>=65536?2:1,Oe=Ne}return re-we}e.nextCharLength=B;function q(K,re){const le=Fe.getInstance(),we=re,Ee=T(K,re);re-=Ee>=65536?2:1;let De=le.getGraphemeBreakType(Ee);for(;re>0;){const Oe=T(K,re),_e=le.getGraphemeBreakType(Oe);if(Ae(_e,De))break;re-=Oe>=65536?2:1,De=_e}return we-re}e.prevCharLength=q;function U(K,re){const le=Fe.getInstance(),we=K.length,Ee=re,De=G(K,we,re),Oe=le.getGraphemeBreakType(De);re+=De>=65536?2:1;let _e=Oe;for(;re<we;){const Be=G(K,we,re),Ve=le.getGraphemeBreakType(Be);if(Ae(_e,Ve))break;re+=Be>=65536?2:1,_e=Ve}const Ne=re;for(re=Ee,_e=Oe;re>0;){const Be=T(K,re),Ve=le.getGraphemeBreakType(Be);if(Ae(Ve,_e))break;re-=Be>=65536?2:1,_e=Ve}return[re,Ne]}function N(K,re){return re>0&&ne(K.charCodeAt(re))?U(K,re-1):U(K,re)}e.getCharContainingOffset=N;const _=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function Y(K){return _.test(K)}e.containsRTL=Y;const F=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function A(K){return F.test(K)}e.containsEmoji=A;const O=/^[\t\n\r\x20-\x7E]*$/;function $(K){return O.test(K)}e.isBasicASCII=$,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function X(K){return e.UNUSUAL_LINE_TERMINATORS.test(K)}e.containsUnusualLineTerminators=X;function V(K){for(let re=0,le=K.length;re<le;re++)if(z(K.charCodeAt(re)))return!0;return!1}e.containsFullWidthCharacter=V;function z(K){return K>=11904&&K<=55215||K>=63744&&K<=64255||K>=65281&&K<=65374}e.isFullWidthCharacter=z;function Z(K){return K>=127462&&K<=127487||K===8986||K===8987||K===9200||K===9203||K>=9728&&K<=10175||K===11088||K===11093||K>=127744&&K<=128591||K>=128640&&K<=128764||K>=128992&&K<=129003||K>=129280&&K<=129535||K>=129648&&K<=129750}e.isEmojiImprecise=Z;function te(K,re){if(K.length<re)return K;const le=/\b/g;let we=0;for(;le.test(K)&&!(K.length-le.lastIndex<re);)we=le.lastIndex,le.lastIndex+=1;return K.substring(we).replace(/^\s/,"")}e.lcut=te;const ce=/\x1B\x5B[12]?K/g,se=/\x1b\[\d+m/g,ie=/\x1b\[0?m/g;function ae(K){return K&&(K=K.replace(ce,""),K=K.replace(se,""),K=K.replace(ie,"")),K}e.removeAnsiEscapeCodes=ae,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ue(K){return!!(K&&K.length>0&&K.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ue;function de(K){return ue(K)?K.substr(1):K}e.stripUTF8BOM=de;function ve(K,re){if(!K||!re||K.length<re.length)return!1;const le=re.length,we=K.toLowerCase();let Ee=0,De=-1;for(;Ee<le;){const Oe=we.indexOf(re[Ee],De+1);if(Oe<0)return!1;De=Oe,Ee++}return!0}e.fuzzyContains=ve;function Pe(K,re=!1){return K?(re&&(K=K.replace(/\\./g,"")),K.toLowerCase()!==K):!1}e.containsUppercaseCharacter=Pe;function pe(K){return K.charAt(0).toUpperCase()+K.slice(1)}e.uppercaseFirstLetter=pe;function ge(K,re=1){if(re===0)return"";let le=-1;do le=K.indexOf(`
`,le+1),re--;while(re>0&&le>=0);return le===-1?K:(K[le-1]==="\r"&&le--,K.substr(0,le))}e.getNLines=ge;function be(K){const re=90-65+1;return K=K%(2*re),K<re?String.fromCharCode(97+K):String.fromCharCode(65+K-re)}e.singleLetterHash=be;function ke(K){return Fe.getInstance().getGraphemeBreakType(K)}e.getGraphemeBreakType=ke;function Ae(K,re){return K===0?re!==5&&re!==7:K===2&&re===3?!1:K===4||K===2||K===3||re===4||re===2||re===3?!0:!(K===8&&(re===8||re===9||re===11||re===12)||(K===11||K===9)&&(re===9||re===10)||(K===12||K===10)&&re===10||re===5||re===13||re===7||K===1||K===13&&re===14||K===6&&re===6)}e.breakBetweenGraphemeBreakType=Ae;var We;(function(K){K[K.Other=0]="Other",K[K.Prepend=1]="Prepend",K[K.CR=2]="CR",K[K.LF=3]="LF",K[K.Control=4]="Control",K[K.Extend=5]="Extend",K[K.Regional_Indicator=6]="Regional_Indicator",K[K.SpacingMark=7]="SpacingMark",K[K.L=8]="L",K[K.V=9]="V",K[K.T=10]="T",K[K.LV=11]="LV",K[K.LVT=12]="LVT",K[K.ZWJ=13]="ZWJ",K[K.Extended_Pictographic=14]="Extended_Pictographic"})(We=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Fe{constructor(){this._data=et()}static getInstance(){return Fe._INSTANCE||(Fe._INSTANCE=new Fe),Fe._INSTANCE}getGraphemeBreakType(re){if(re<32)return re===10?3:re===13?2:4;if(re<127)return 0;const le=this._data,we=le.length/3;let Ee=1;for(;Ee<=we;)if(re<le[3*Ee])Ee=2*Ee;else if(re>le[3*Ee+1])Ee=2*Ee+1;else return le[3*Ee+2];return 0}}Fe._INSTANCE=null;function et(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function Ge(K,re){if(K===0)return 0;const le=He(K,re);if(le!==void 0)return le;const we=T(re,K);return K-=Xe(we),K}e.getLeftDeleteOffset=Ge;function He(K,re){let le=T(re,K);for(K-=Xe(le);at(le)||le===65039||le===8419;){if(K===0)return;le=T(re,K),K-=Xe(le)}if(!!Z(le)){if(K>=0){const we=T(re,K);we===8205&&(K-=Xe(we))}return K}}function Xe(K){return K>=65536?2:1}function at(K){return 127995<=K&&K<=127999}var tt;(function(K){K[K.zwj=8205]="zwj",K[K.emojiVariantSelector=65039]="emojiVariantSelector",K[K.enclosingKeyCap=8419]="enclosingKeyCap"})(tt||(tt={})),e.noBreakWhitespace="\xA0"}),define(Q[81],J([0,1,25]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function D(S){return M(S,0)}e.hash=D;function M(S,P){switch(typeof S){case"object":return S===null?C(349,P):Array.isArray(S)?d(S,P):f(S,P);case"string":return I(S,P);case"boolean":return n(S,P);case"number":return C(S,P);case"undefined":return C(937,P);default:return C(617,P)}}e.doHash=M;function C(S,P){return(P<<5)-P+S|0}e.numberHash=C;function n(S,P){return C(S?433:863,P)}function I(S,P){P=C(149417,P);for(let c=0,a=S.length;c<a;c++)P=C(S.charCodeAt(c),P);return P}e.stringHash=I;function d(S,P){return P=C(104579,P),S.reduce((c,a)=>M(a,c),P)}function f(S,P){return P=C(181387,P),Object.keys(S).sort().reduce((c,a)=>(c=I(a,c),M(S[a],c)),P)}class y{constructor(){this._value=0}get value(){return this._value}hash(P){return this._value=M(P,this._value),this._value}}e.Hasher=y;var E;(function(S){S[S.BLOCK_SIZE=64]="BLOCK_SIZE",S[S.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function m(S,P,c=32){const a=c-P,l=~((1<<a)-1);return(S<<P|(l&S)>>>a)>>>0}function p(S,P=0,c=S.byteLength,a=0){for(let l=0;l<c;l++)S[P+l]=a}function t(S,P,c="0"){for(;S.length<P;)S=c+S;return S}function w(S,P=32){return S instanceof ArrayBuffer?Array.from(new Uint8Array(S)).map(c=>c.toString(16).padStart(2,"0")).join(""):t((S>>>0).toString(16),P/4)}e.toHexString=w;class b{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(P){const c=P.length;if(c===0)return;const a=this._buff;let l=this._buffLen,s=this._leftoverHighSurrogate,u,r;for(s!==0?(u=s,r=-1,s=0):(u=P.charCodeAt(0),r=0);;){let i=u;if(v.isHighSurrogate(u))if(r+1<c){const o=P.charCodeAt(r+1);v.isLowSurrogate(o)?(r++,i=v.computeCodePoint(u,o)):i=65533}else{s=u;break}else v.isLowSurrogate(u)&&(i=65533);if(l=this._push(a,l,i),r++,r<c)u=P.charCodeAt(r);else break}this._buffLen=l,this._leftoverHighSurrogate=s}_push(P,c,a){return a<128?P[c++]=a:a<2048?(P[c++]=192|(a&1984)>>>6,P[c++]=128|(a&63)>>>0):a<65536?(P[c++]=224|(a&61440)>>>12,P[c++]=128|(a&4032)>>>6,P[c++]=128|(a&63)>>>0):(P[c++]=240|(a&1835008)>>>18,P[c++]=128|(a&258048)>>>12,P[c++]=128|(a&4032)>>>6,P[c++]=128|(a&63)>>>0),c>=64&&(this._step(),c-=64,this._totalLen+=64,P[0]=P[64+0],P[1]=P[64+1],P[2]=P[64+2]),c}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),w(this._h0)+w(this._h1)+w(this._h2)+w(this._h3)+w(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,p(this._buff,this._buffLen),this._buffLen>56&&(this._step(),p(this._buff));const P=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(P/4294967296),!1),this._buffDV.setUint32(60,P%4294967296,!1),this._step()}_step(){const P=b._bigBlock32,c=this._buffDV;for(let g=0;g<64;g+=4)P.setUint32(g,c.getUint32(g,!1),!1);for(let g=64;g<320;g+=4)P.setUint32(g,m(P.getUint32(g-12,!1)^P.getUint32(g-32,!1)^P.getUint32(g-56,!1)^P.getUint32(g-64,!1),1),!1);let a=this._h0,l=this._h1,s=this._h2,u=this._h3,r=this._h4,i,o,h;for(let g=0;g<80;g++)g<20?(i=l&s|~l&u,o=1518500249):g<40?(i=l^s^u,o=1859775393):g<60?(i=l&s|l&u|s&u,o=2400959708):(i=l^s^u,o=3395469782),h=m(a,5)+i+r+o+P.getUint32(g*4,!1)&4294967295,r=u,u=s,s=m(l,30),l=a,a=h;this._h0=this._h0+a&4294967295,this._h1=this._h1+l&4294967295,this._h2=this._h2+s&4294967295,this._h3=this._h3+u&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=b,b._bigBlock32=new DataView(new ArrayBuffer(320))});var Pt=this&&this.__classPrivateFieldSet||function(H,e,v,D,M){if(D==="m")throw new TypeError("Private method is not writable");if(D==="a"&&!M)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?H!==e||!M:!e.has(H))throw new TypeError("Cannot write private member to an object whose class did not declare it");return D==="a"?M.call(H,v):M?M.value=v:e.set(H,v),v},qe=this&&this.__classPrivateFieldGet||function(H,e,v,D){if(v==="a"&&!D)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?H!==e||!D:!e.has(H))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?D:v==="a"?D.call(H):D?D.value:e.get(H)};define(Q[40],J([0,1,30,25]),function(H,e,v,D){"use strict";var M,C,n;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function I(r,i,o){let h=r.get(i);return h===void 0&&(h=o,r.set(i,h)),h}e.getOrSet=I;function d(r){const i=[];return r.forEach((o,h)=>{i.push(`${h} => ${o}`)}),`Map(${r.size}) {${i.join(", ")}}`}e.mapToString=d;function f(r){const i=[];return r.forEach(o=>{i.push(o)}),`Set(${r.size}) {${i.join(", ")}}`}e.setToString=f;class y{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const o=i.charCodeAt(0),h=this._value.charCodeAt(this._pos);return o-h}value(){return this._value[this._pos]}}e.StringIterator=y;class E{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,D.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,D.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=E;class m{constructor(i=!0,o=!0){this._splitOnBackslash=i,this._caseSensitive=o}reset(i){return this._value=i.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++){const o=this._value.charCodeAt(this._to);if(o===47||this._splitOnBackslash&&o===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,D.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,D.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=m;var p;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(p||(p={}));class t{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new m(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,D.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,D.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,D.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,D.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=t;class w{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var b;(function(r){r[r.Left=-1]="Left",r[r.Mid=0]="Mid",r[r.Right=1]="Right"})(b||(b={}));class S{constructor(i){this._iter=i}static forUris(i=()=>!1){return new S(new t(i))}static forPaths(){return new S(new m)}static forStrings(){return new S(new y)}static forConfigKeys(){return new S(new E)}clear(){this._root=void 0}fill(i,o){if(o){const h=o.slice(0);(0,v.shuffle)(h);for(let g of h)this.set(g,i)}else{const h=i.slice(0);(0,v.shuffle)(h);for(let g of h)this.set(g[0],g[1])}}set(i,o){const h=this._iter.reset(i);let g;this._root||(this._root=new w,this._root.segment=h.value());const k=[];for(g=this._root;;){const R=h.cmp(g.segment);if(R>0)g.left||(g.left=new w,g.left.segment=h.value()),k.push([-1,g]),g=g.left;else if(R<0)g.right||(g.right=new w,g.right.segment=h.value()),k.push([1,g]),g=g.right;else if(h.hasNext())h.next(),g.mid||(g.mid=new w,g.mid.segment=h.value()),k.push([0,g]),g=g.mid;else break}const L=g.value;g.value=o,g.key=i;for(let R=k.length-1;R>=0;R--){const W=k[R][1];W.updateHeight();const j=W.balanceFactor();if(j<-1||j>1){const x=k[R][0],ne=k[R+1][0];if(x===1&&ne===1)k[R][1]=W.rotateLeft();else if(x===-1&&ne===-1)k[R][1]=W.rotateRight();else if(x===1&&ne===-1)W.right=k[R+1][1]=k[R+1][1].rotateRight(),k[R][1]=W.rotateLeft();else if(x===-1&&ne===1)W.left=k[R+1][1]=k[R+1][1].rotateLeft(),k[R][1]=W.rotateRight();else throw new Error;if(R>0)switch(k[R-1][0]){case-1:k[R-1][1].left=k[R][1];break;case 1:k[R-1][1].right=k[R][1];break;case 0:k[R-1][1].mid=k[R][1];break}else this._root=k[0][1]}}return L}get(i){return this._getNode(i)?.value}_getNode(i){const o=this._iter.reset(i);let h=this._root;for(;h;){const g=o.cmp(h.segment);if(g>0)h=h.left;else if(g<0)h=h.right;else if(o.hasNext())o.next(),h=h.mid;else break}return h}has(i){const o=this._getNode(i);return!(o?.value===void 0&&o?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,o){const h=this._iter.reset(i),g=[];let k=this._root;for(;k;){const L=h.cmp(k.segment);if(L>0)g.push([-1,k]),k=k.left;else if(L<0)g.push([1,k]),k=k.right;else if(h.hasNext())h.next(),g.push([0,k]),k=k.mid;else break}if(!!k){if(o?(k.left=void 0,k.mid=void 0,k.right=void 0,k.height=1):(k.key=void 0,k.value=void 0),!k.mid&&!k.value)if(k.left&&k.right){const L=this._min(k.right),{key:R,value:W,segment:j}=L;this._delete(L.key,!1),k.key=R,k.value=W,k.segment=j}else{const L=k.left??k.right;if(g.length>0){const[R,W]=g[g.length-1];switch(R){case-1:W.left=L;break;case 0:W.mid=L;break;case 1:W.right=L;break}}else this._root=L}for(let L=g.length-1;L>=0;L--){const R=g[L][1];R.updateHeight();const W=R.balanceFactor();if(W>1?(R.right.balanceFactor()>=0||(R.right=g[L+1][1]=g[L+1][1].rotateRight()),g[L][1]=R.rotateLeft()):W<-1&&(R.left.balanceFactor()<=0||(R.left=g[L+1][1]=g[L+1][1].rotateLeft()),g[L][1]=R.rotateRight()),L>0)switch(g[L-1][0]){case-1:g[L-1][1].left=g[L][1];break;case 1:g[L-1][1].right=g[L][1];break;case 0:g[L-1][1].mid=g[L][1];break}else this._root=g[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const o=this._iter.reset(i);let h=this._root,g;for(;h;){const k=o.cmp(h.segment);if(k>0)h=h.left;else if(k<0)h=h.right;else if(o.hasNext())o.next(),g=h.value||g,h=h.mid;else break}return h&&h.value||g}findSuperstr(i){const o=this._iter.reset(i);let h=this._root;for(;h;){const g=o.cmp(h.segment);if(g>0)h=h.left;else if(g<0)h=h.right;else if(o.hasNext())o.next(),h=h.mid;else return h.mid?this._entries(h.mid):void 0}}forEach(i){for(const[o,h]of this)i(h,o)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){!i||(i.left&&(yield*this._entries(i.left)),i.value&&(yield[i.key,i.value]),i.mid&&(yield*this._entries(i.mid)),i.right&&(yield*this._entries(i.right)))}_isBalanced(){const i=o=>{if(!o)return!0;const h=o.balanceFactor();return h<-1||h>1?!1:i(o.left)&&i(o.right)};return i(this._root)}}e.TernarySearchTree=S;class P{constructor(i,o){this.uri=i,this.value=o}}class c{constructor(i,o){this[M]="ResourceMap",i instanceof c?(this.map=new Map(i.map),this.toKey=o??c.defaultToKey):(this.map=new Map,this.toKey=i??c.defaultToKey)}set(i,o){return this.map.set(this.toKey(i),new P(i,o)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,o){typeof o!="undefined"&&(i=i.bind(o));for(let[h,g]of this.map)i(g.value,g.uri,this)}*values(){for(let i of this.map.values())yield i.value}*keys(){for(let i of this.map.values())yield i.uri}*entries(){for(let i of this.map.values())yield[i.uri,i.value]}*[(M=Symbol.toStringTag,Symbol.iterator)](){for(let[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=c,c.defaultToKey=r=>r.toString();var a;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(a=e.Touch||(e.Touch={}));class l{constructor(){this[C]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,o=0){const h=this._map.get(i);if(!!h)return o!==0&&this.touch(h,o),h.value}set(i,o,h=0){let g=this._map.get(i);if(g)g.value=o,h!==0&&this.touch(g,h);else{switch(g={key:i,value:o,next:void 0,previous:void 0},h){case 0:this.addItemLast(g);break;case 1:this.addItemFirst(g);break;case 2:this.addItemLast(g);break;default:this.addItemLast(g);break}this._map.set(i,g),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const o=this._map.get(i);if(!!o)return this._map.delete(i),this.removeItem(o),this._size--,o.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,o){const h=this._state;let g=this._head;for(;g;){if(o?i.bind(o)(g.value,g.key,this):i(g.value,g.key,this),this._state!==h)throw new Error("LinkedMap got modified during iteration.");g=g.next}}keys(){const i=this,o=this._state;let h=this._head;const g={[Symbol.iterator](){return g},next(){if(i._state!==o)throw new Error("LinkedMap got modified during iteration.");if(h){const k={value:h.key,done:!1};return h=h.next,k}else return{value:void 0,done:!0}}};return g}values(){const i=this,o=this._state;let h=this._head;const g={[Symbol.iterator](){return g},next(){if(i._state!==o)throw new Error("LinkedMap got modified during iteration.");if(h){const k={value:h.value,done:!1};return h=h.next,k}else return{value:void 0,done:!0}}};return g}entries(){const i=this,o=this._state;let h=this._head;const g={[Symbol.iterator](){return g},next(){if(i._state!==o)throw new Error("LinkedMap got modified during iteration.");if(h){const k={value:[h.key,h.value],done:!1};return h=h.next,k}else return{value:void 0,done:!0}}};return g}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let o=this._head,h=this.size;for(;o&&h>i;)this._map.delete(o.key),o=o.next,h--;this._head=o,this._size=h,o&&(o.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const o=i.next,h=i.previous;if(!o||!h)throw new Error("Invalid list");o.previous=h,h.next=o}i.next=void 0,i.previous=void 0,this._state++}touch(i,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(i===this._head)return;const h=i.next,g=i.previous;i===this._tail?(g.next=void 0,this._tail=g):(h.previous=g,g.next=h),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(o===2){if(i===this._tail)return;const h=i.next,g=i.previous;i===this._head?(h.previous=void 0,this._head=h):(h.previous=g,g.next=h),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((o,h)=>{i.push([h,o])}),i}fromJSON(i){this.clear();for(const[o,h]of i)this.set(o,h)}}e.LinkedMap=l;class s extends l{constructor(i,o=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,o=2){return super.get(i,o)}peek(i){return super.get(i,0)}set(i,o){return super.set(i,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=s;class u{constructor(i){n.set(this,void 0),Pt(this,n,i,"f")}get size(){return qe(this,n,"f").size}forEach(i,o){qe(this,n,"f").forEach(i,o)}get(i){return qe(this,n,"f").get(i)}has(i){return qe(this,n,"f").has(i)}entries(){return qe(this,n,"f").entries()}keys(){return qe(this,n,"f").keys()}values(){return qe(this,n,"f").values()}[(n=new WeakMap,Symbol.iterator)](){return qe(this,n,"f").entries()}}e.ReadonlyMapView=u}),define(Q[70],J([0,1,40]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const D=new v.LRUCache(1e4);function M(f){return d(f,"NFC",D)}e.normalizeNFC=M;const C=new v.LRUCache(1e4);function n(f){return d(f,"NFD",C)}e.normalizeNFD=n;const I=/[^\u0000-\u0080]/;function d(f,y,E){if(!f)return f;const m=E.get(f);if(m)return m;let p;return I.test(f)?p=f.normalize(y):p=f,E.set(f,p),p}e.removeAccents=function(){const f=/[\u0300-\u036f]/g;return function(y){return n(y).replace(f,"")}}()}),define(Q[13],J([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function v(k){return Array.isArray(k)}e.isArray=v;function D(k){return typeof k=="string"}e.isString=D;function M(k){return Array.isArray(k)&&k.every(L=>D(L))}e.isStringArray=M;function C(k){return typeof k=="object"&&k!==null&&!Array.isArray(k)&&!(k instanceof RegExp)&&!(k instanceof Date)}e.isObject=C;function n(k){return typeof k=="number"&&!isNaN(k)}e.isNumber=n;function I(k){return!!k&&typeof k[Symbol.iterator]=="function"}e.isIterable=I;function d(k){return k===!0||k===!1}e.isBoolean=d;function f(k){return typeof k=="undefined"}e.isUndefined=f;function y(k){return!E(k)}e.isDefined=y;function E(k){return f(k)||k===null}e.isUndefinedOrNull=E;function m(k,L){if(!k)throw new Error(L?`Unexpected type, expected '${L}'`:"Unexpected type")}e.assertType=m;function p(k){if(E(k))throw new Error("Assertion Failed: argument is undefined or null");return k}e.assertIsDefined=p;function t(...k){const L=[];for(let R=0;R<k.length;R++){const W=k[R];if(E(W))throw new Error(`Assertion Failed: argument at index ${R} is undefined or null`);L.push(W)}return L}e.assertAllDefined=t;const w=Object.prototype.hasOwnProperty;function b(k){if(!C(k))return!1;for(let L in k)if(w.call(k,L))return!1;return!0}e.isEmptyObject=b;function S(k){return typeof k=="function"}e.isFunction=S;function P(...k){return k.length>0&&k.every(S)}e.areFunctions=P;function c(k,L){const R=Math.min(k.length,L.length);for(let W=0;W<R;W++)a(k[W],L[W])}e.validateConstraints=c;function a(k,L){if(D(L)){if(typeof k!==L)throw new Error(`argument does not match constraint: typeof ${L}`)}else if(S(L)){try{if(k instanceof L)return}catch{}if(!E(k)&&k.constructor===L||L.length===1&&L.call(void 0,k)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=a;function l(k){let L=[],R=Object.getPrototypeOf(k);for(;Object.prototype!==R;)L=L.concat(Object.getOwnPropertyNames(R)),R=Object.getPrototypeOf(R);return L}e.getAllPropertyNames=l;function s(k){const L=[];for(const R of l(k))typeof k[R]=="function"&&L.push(R);return L}e.getAllMethodNames=s;function u(k,L){const R=j=>function(){const x=Array.prototype.slice.call(arguments,0);return L(j,x)};let W={};for(const j of k)W[j]=R(j);return W}e.createProxyObject=u;function r(k){return k===null?void 0:k}e.withNullAsUndefined=r;function i(k){return typeof k=="undefined"?null:k}e.withUndefinedAsNull=i;function o(k){return class{constructor(){return new Proxy({},{get(L,R){if(L[R])return L[R];throw new Error(`Not Implemented: ${k}->${String(R)}`)}})}}}e.NotImplementedProxy=o;function h(k,L="Unreachable"){throw new Error(L)}e.assertNever=h;function g(k){return!!k&&typeof k.then=="function"&&typeof k.catch=="function"}e.isPromise=g}),define(Q[33],J([0,1,8,3,25,13]),function(H,e,v,D,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function n(r){return r===47||r===92}e.isPathSeparator=n;function I(r){return r.replace(/[\\/]/g,v.posix.sep)}e.toSlashes=I;function d(r){return r.indexOf("/")===-1&&(r=I(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=d;function f(r,i=v.posix.sep){if(!r)return"";const o=r.length,h=r.charCodeAt(0);if(n(h)){if(n(r.charCodeAt(1))&&!n(r.charCodeAt(2))){let k=3;const L=k;for(;k<o&&!n(r.charCodeAt(k));k++);if(L!==k&&!n(r.charCodeAt(k+1))){for(k+=1;k<o;k++)if(n(r.charCodeAt(k)))return r.slice(0,k+1).replace(/[\\/]/g,i)}}return i}else if(S(h)&&r.charCodeAt(1)===58)return n(r.charCodeAt(2))?r.slice(0,2)+i:r.slice(0,2);let g=r.indexOf("://");if(g!==-1){for(g+=3;g<o;g++)if(n(r.charCodeAt(g)))return r.slice(0,g+1)}return""}e.getRoot=f;function y(r){if(!D.isWindows||!r||r.length<5)return!1;let i=r.charCodeAt(0);if(i!==92||(i=r.charCodeAt(1),i!==92))return!1;let o=2;const h=o;for(;o<r.length&&(i=r.charCodeAt(o),i!==92);o++);return!(h===o||(i=r.charCodeAt(o+1),isNaN(i)||i===92))}e.isUNC=y;const E=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function t(r,i=D.isWindows){const o=i?E:m;return!(!r||r.length===0||/^\s+$/.test(r)||(o.lastIndex=0,o.test(r))||i&&p.test(r)||r==="."||r===".."||i&&r[r.length-1]==="."||i&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=t;function w(r,i,o){const h=r===i;return!o||h?h:!r||!i?!1:(0,M.equalsIgnoreCase)(r,i)}e.isEqual=w;function b(r,i,o,h=v.sep){if(r===i)return!0;if(!r||!i||i.length>r.length)return!1;if(o){if(!(0,M.startsWithIgnoreCase)(r,i))return!1;if(i.length===r.length)return!0;let k=i.length;return i.charAt(i.length-1)===h&&k--,r.charAt(k)===h}return i.charAt(i.length-1)!==h&&(i+=h),r.indexOf(i)===0}e.isEqualOrParent=b;function S(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=S;function P(r,i){return D.isWindows&&r.endsWith(":")&&(r+=v.sep),(0,v.isAbsolute)(r)||(r=(0,v.join)(i,r)),r=(0,v.normalize)(r),D.isWindows?(r=(0,M.rtrim)(r,v.sep),r.endsWith(":")&&(r+=v.sep)):(r=(0,M.rtrim)(r,v.sep),r||(r=v.sep)),r}e.sanitizeFilePath=P;function c(r){const i=(0,v.normalize)(r);return D.isWindows?r.length>3?!1:a(i)&&(r.length===2||i.charCodeAt(2)===92):i===v.posix.sep}e.isRootOrDriveLetter=c;function a(r,i){return(i!==void 0?i:D.isWindows)?S(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=a;function l(r){return a(r)?r[0]:void 0}e.getDriveLetter=l;function s(r,i,o){return i.length>r.length?-1:r===i?0:(o&&(r=r.toLowerCase(),i=i.toLowerCase()),r.indexOf(i))}e.indexOfPath=s;function u(r){const i=r.split(":");let o,h,g;if(i.forEach(k=>{const L=Number(k);(0,C.isNumber)(L)?h===void 0?h=L:g===void 0&&(g=L):o=o?[o,k].join(":"):k}),!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:h!==void 0?h:void 0,column:g!==void 0?g:h!==void 0?1:void 0}}e.parseLineAndColumnAware=u}),define(Q[47],J([0,1,13]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function D(w){if(!w||typeof w!="object"||w instanceof RegExp)return w;const b=Array.isArray(w)?[]:{};return Object.keys(w).forEach(S=>{w[S]&&typeof w[S]=="object"?b[S]=D(w[S]):b[S]=w[S]}),b}e.deepClone=D;function M(w){if(!w||typeof w!="object")return w;const b=[w];for(;b.length>0;){const S=b.shift();Object.freeze(S);for(const P in S)if(C.call(S,P)){const c=S[P];typeof c=="object"&&!Object.isFrozen(c)&&b.push(c)}}return w}e.deepFreeze=M;const C=Object.prototype.hasOwnProperty;function n(w,b){return I(w,b,new Set)}e.cloneAndChange=n;function I(w,b,S){if((0,v.isUndefinedOrNull)(w))return w;const P=b(w);if(typeof P!="undefined")return P;if((0,v.isArray)(w)){const c=[];for(const a of w)c.push(I(a,b,S));return c}if((0,v.isObject)(w)){if(S.has(w))throw new Error("Cannot clone recursive data-structure");S.add(w);const c={};for(let a in w)C.call(w,a)&&(c[a]=I(w[a],b,S));return S.delete(w),c}return w}function d(w,b,S=!0){return(0,v.isObject)(w)?((0,v.isObject)(b)&&Object.keys(b).forEach(P=>{P in w?S&&((0,v.isObject)(w[P])&&(0,v.isObject)(b[P])?d(w[P],b[P],S):w[P]=b[P]):w[P]=b[P]}),w):b}e.mixin=d;function f(w,b){if(w===b)return!0;if(w==null||b===null||b===void 0||typeof w!=typeof b||typeof w!="object"||Array.isArray(w)!==Array.isArray(b))return!1;let S,P;if(Array.isArray(w)){if(w.length!==b.length)return!1;for(S=0;S<w.length;S++)if(!f(w[S],b[S]))return!1}else{const c=[];for(P in w)c.push(P);c.sort();const a=[];for(P in b)a.push(P);if(a.sort(),!f(c,a))return!1;for(S=0;S<c.length;S++)if(!f(w[c[S]],b[c[S]]))return!1}return!0}e.equals=f;function y(w){const b=new Set;return JSON.stringify(w,(S,P)=>{if((0,v.isObject)(P)||Array.isArray(P)){if(b.has(P))return"[Circular]";b.add(P)}return P})}e.safeStringify=y;function E(w,b,S){const P=b(w);return typeof P=="undefined"?S:P}e.getOrDefault=E;function m(w,b){const S=Object.create(null);return!w||!b||Object.keys(b).forEach(c=>{const a=w[c],l=b[c];f(a,l)||(S[c]=l)}),S}e.distinct=m;function p(w,b){const S=b.toLowerCase(),P=Object.keys(w).find(c=>c.toLowerCase()===S);return P?w[P]:w[b]}e.getCaseInsensitive=p;function t(w,b){const S=Object.create(null);for(const[P,c]of Object.entries(w))b(P,c)&&(S[P]=c);return S}e.filter=t}),define(Q[7],J([0,1,8,3]),function(H,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const M=/^\w[\w\d+.-]*$/,C=/^\//,n=/^\/\//;function I(r,i){if(!r.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!M.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!C.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(n.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function d(r,i){return!r&&!i?"file":r}function f(r,i){switch(r){case"https":case"http":case"file":i?i[0]!==E&&(i=E+i):i=E;break}return i}const y="",E="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class p{constructor(i,o,h,g,k,L=!1){typeof i=="object"?(this.scheme=i.scheme||y,this.authority=i.authority||y,this.path=i.path||y,this.query=i.query||y,this.fragment=i.fragment||y):(this.scheme=d(i,L),this.authority=o||y,this.path=f(this.scheme,h||y),this.query=g||y,this.fragment=k||y,I(this,L))}static isUri(i){return i instanceof p?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return c(this,!1)}with(i){if(!i)return this;let{scheme:o,authority:h,path:g,query:k,fragment:L}=i;return o===void 0?o=this.scheme:o===null&&(o=y),h===void 0?h=this.authority:h===null&&(h=y),g===void 0?g=this.path:g===null&&(g=y),k===void 0?k=this.query:k===null&&(k=y),L===void 0?L=this.fragment:L===null&&(L=y),o===this.scheme&&h===this.authority&&g===this.path&&k===this.query&&L===this.fragment?this:new w(o,h,g,k,L)}static parse(i,o=!1){const h=m.exec(i);return h?new w(h[2]||y,u(h[4]||y),u(h[5]||y),u(h[7]||y),u(h[9]||y),o):new w(y,y,y,y,y)}static file(i){let o=y;if(D.isWindows&&(i=i.replace(/\\/g,E)),i[0]===E&&i[1]===E){const h=i.indexOf(E,2);h===-1?(o=i.substring(2),i=E):(o=i.substring(2,h),i=i.substring(h)||E)}return new w("file",o,i,y,y)}static from(i){const o=new w(i.scheme,i.authority,i.path,i.query,i.fragment);return I(o,!0),o}static joinPath(i,...o){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let h;return D.isWindows&&i.scheme==="file"?h=p.file(v.win32.join(c(i,!0),...o)).path:h=v.posix.join(i.path,...o),i.with({path:h})}toString(i=!1){return a(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof p)return i;{const o=new w(i);return o._formatted=i.external,o._fsPath=i._sep===t?i.fsPath:null,o}}else return i}}e.URI=p;const t=D.isWindows?1:void 0;class w extends p{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=c(this,!1)),this._fsPath}toString(i=!1){return i?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=t),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const b={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function S(r,i){let o,h=-1;for(let g=0;g<r.length;g++){const k=r.charCodeAt(g);if(k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57||k===45||k===46||k===95||k===126||i&&k===47)h!==-1&&(o+=encodeURIComponent(r.substring(h,g)),h=-1),o!==void 0&&(o+=r.charAt(g));else{o===void 0&&(o=r.substr(0,g));const L=b[k];L!==void 0?(h!==-1&&(o+=encodeURIComponent(r.substring(h,g)),h=-1),o+=L):h===-1&&(h=g)}}return h!==-1&&(o+=encodeURIComponent(r.substring(h))),o!==void 0?o:r}function P(r){let i;for(let o=0;o<r.length;o++){const h=r.charCodeAt(o);h===35||h===63?(i===void 0&&(i=r.substr(0,o)),i+=b[h]):i!==void 0&&(i+=r[o])}return i!==void 0?i:r}function c(r,i){let o;return r.authority&&r.path.length>1&&r.scheme==="file"?o=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?i?o=r.path.substr(1):o=r.path[1].toLowerCase()+r.path.substr(2):o=r.path,D.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=c;function a(r,i){const o=i?P:S;let h="",{scheme:g,authority:k,path:L,query:R,fragment:W}=r;if(g&&(h+=g,h+=":"),(k||g==="file")&&(h+=E,h+=E),k){let j=k.indexOf("@");if(j!==-1){const x=k.substr(0,j);k=k.substr(j+1),j=x.indexOf(":"),j===-1?h+=o(x,!1):(h+=o(x.substr(0,j),!1),h+=":",h+=o(x.substr(j+1),!1)),h+="@"}k=k.toLowerCase(),j=k.indexOf(":"),j===-1?h+=o(k,!1):(h+=o(k.substr(0,j),!1),h+=k.substr(j))}if(L){if(L.length>=3&&L.charCodeAt(0)===47&&L.charCodeAt(2)===58){const j=L.charCodeAt(1);j>=65&&j<=90&&(L=`/${String.fromCharCode(j+32)}:${L.substr(3)}`)}else if(L.length>=2&&L.charCodeAt(1)===58){const j=L.charCodeAt(0);j>=65&&j<=90&&(L=`${String.fromCharCode(j+32)}:${L.substr(2)}`)}h+=o(L,!0)}return R&&(h+="?",h+=o(R,!1)),W&&(h+="#",h+=i?W:S(W,!1)),h}function l(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+l(r.substr(3)):r}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function u(r){return r.match(s)?r.replace(s,i=>l(i)):r}}),define(Q[110],J([0,1,7]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function D(f){const y=f;return y&&typeof y.type=="string"&&typeof y.severity=="string"}e.isRemoteConsoleLog=D;function M(f){const y=[];let E;try{const m=JSON.parse(f.arguments),p=m[m.length-1];p&&p.__$stack&&(m.pop(),E=p.__$stack),y.push(...m)}catch(m){y.push("Unable to log remote console arguments",f.arguments)}return{args:y,stack:E}}e.parse=M;function C(f){if(typeof f!="string")return C(M(f).stack);const y=f;if(y){const E=n(y),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(m&&m.length===4)return{uri:v.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}e.getFirstFrame=C;function n(f){if(!f)return f;const y=f.indexOf(`
`);return y===-1?f:f.substring(0,y)}function I(f,y){const{args:E,stack:m}=M(f),p=typeof E[0]=="string"&&E.length===1;let t=n(m);t&&(t=`(${t.trim()})`);let w=[];if(typeof E[0]=="string"?t&&p?w=[`%c[${y}] %c${E[0]} %c${t}`,d("blue"),d(""),d("grey")]:w=[`%c[${y}] %c${E[0]}`,d("blue"),d(""),...E.slice(1)]:w=[`%c[${y}]%`,d("blue"),...E],t&&!p&&w.push(t),typeof console[f.severity]!="function")throw new Error("Unknown console method");console[f.severity].apply(console,w)}e.log=I;function d(f){return`color: ${f}`}}),define(Q[111],J([0,1,17,25,7]),function(H,e,v,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function C(y){return JSON.stringify(y,d)}e.stringify=C;function n(y){let E=JSON.parse(y);return E=f(E),E}e.parse=n;var I;(function(y){y[y.Uri=1]="Uri",y[y.Regexp=2]="Regexp",y[y.ScmResource=3]="ScmResource",y[y.ScmResourceGroup=4]="ScmResourceGroup",y[y.ScmProvider=5]="ScmProvider",y[y.CommentController=6]="CommentController",y[y.CommentThread=7]="CommentThread",y[y.CommentThreadReply=8]="CommentThreadReply",y[y.CommentNode=9]="CommentNode",y[y.CommentThreadNode=10]="CommentThreadNode",y[y.TimelineActionContext=11]="TimelineActionContext",y[y.NotebookCellActionContext=12]="NotebookCellActionContext",y[y.TestItemContext=13]="TestItemContext"})(I=e.MarshalledId||(e.MarshalledId={}));function d(y,E){return E instanceof RegExp?{$mid:2,source:E.source,flags:(0,D.regExpFlags)(E)}:E}function f(y,E=0){if(!y||E>200)return y;if(typeof y=="object"){switch(y.$mid){case 1:return M.URI.revive(y);case 2:return new RegExp(y.source,y.flags)}if(y instanceof v.VSBuffer||y instanceof Uint8Array)return y;if(Array.isArray(y))for(let m=0;m<y.length;++m)y[m]=f(y[m],E+1);else for(const m in y)Object.hasOwnProperty.call(y,m)&&(y[m]=f(y[m],E+1))}return y}e.revive=f}),define(Q[10],J([0,1,3,7]),function(H,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var M;(function(I){I.inMemory="inmemory",I.vscode="vscode",I.internal="private",I.walkThrough="walkThrough",I.walkThroughSnippet="walkThroughSnippet",I.http="http",I.https="https",I.file="file",I.mailto="mailto",I.untitled="untitled",I.data="data",I.command="command",I.vscodeRemote="vscode-remote",I.vscodeRemoteResource="vscode-remote-resource",I.userData="vscode-userdata",I.vscodeCustomEditor="vscode-custom-editor",I.vscodeNotebook="vscode-notebook",I.vscodeNotebookCell="vscode-notebook-cell",I.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",I.vscodeNotebookCellOutput="vscode-notebook-cell-output",I.vscodeInteractive="vscode-interactive",I.vscodeInteractiveInput="vscode-interactive-input",I.vscodeSettings="vscode-settings",I.vscodeWorkspaceTrust="vscode-workspace-trust",I.vscodeTerminal="vscode-terminal",I.webviewPanel="webview-panel",I.vscodeWebview="vscode-webview",I.extension="extension",I.vscodeFileResource="vscode-file",I.tmp="tmp",I.vsls="vsls"})(M=e.Schemas||(e.Schemas={}));class C{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(d){this._preferredWebSchema=d}setDelegate(d){this._delegate=d}set(d,f,y){this._hosts[d]=f,this._ports[d]=y}setConnectionToken(d,f){this._connectionTokens[d]=f}rewrite(d){if(this._delegate)return this._delegate(d);const f=d.authority;let y=this._hosts[f];y&&y.indexOf(":")!==-1&&(y=`[${y}]`);const E=this._ports[f],m=this._connectionTokens[f];let p=`path=${encodeURIComponent(d.path)}`;return typeof m=="string"&&(p+=`&tkn=${encodeURIComponent(m)}`),D.URI.from({scheme:v.isWeb?this._preferredWebSchema:M.vscodeRemoteResource,authority:`${y}:${E}`,path:"/vscode-remote-resource",query:p})}}e.RemoteAuthorities=new C;class n{asBrowserUri(d,f){const y=this.toUri(d,f);return y.scheme===M.vscodeRemote?e.RemoteAuthorities.rewrite(y):y.scheme===M.file&&(v.isNative||typeof v.globals.importScripts=="function"&&v.globals.origin===`${M.vscodeFileResource}://${n.FALLBACK_AUTHORITY}`)?y.with({scheme:M.vscodeFileResource,authority:y.authority||n.FALLBACK_AUTHORITY,query:null,fragment:null}):y}asFileUri(d,f){const y=this.toUri(d,f);return y.scheme===M.vscodeFileResource?y.with({scheme:M.file,authority:y.authority!==n.FALLBACK_AUTHORITY?y.authority:null,query:null,fragment:null}):y}toUri(d,f){return D.URI.isUri(d)?d:D.URI.parse(f.toUrl(d))}}n.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new n}),define(Q[15],J([0,1,33,10,8,3,25,7]),function(H,e,v,D,M,C,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function d(p){return(0,I.uriToFsPath)(p,!0)}e.originalFSPath=d;class f{constructor(t){this._ignorePathCasing=t}compare(t,w,b=!1){return t===w?0:(0,n.compare)(this.getComparisonKey(t,b),this.getComparisonKey(w,b))}isEqual(t,w,b=!1){return t===w?!0:!t||!w?!1:this.getComparisonKey(t,b)===this.getComparisonKey(w,b)}getComparisonKey(t,w=!1){return t.with({path:this._ignorePathCasing(t)?t.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing(t){return this._ignorePathCasing(t)}isEqualOrParent(t,w,b=!1){if(t.scheme===w.scheme){if(t.scheme===D.Schemas.file)return v.isEqualOrParent(d(t),d(w),this._ignorePathCasing(t))&&t.query===w.query&&(b||t.fragment===w.fragment);if((0,e.isEqualAuthority)(t.authority,w.authority))return v.isEqualOrParent(t.path,w.path,this._ignorePathCasing(t),"/")&&t.query===w.query&&(b||t.fragment===w.fragment)}return!1}joinPath(t,...w){return I.URI.joinPath(t,...w)}basenameOrAuthority(t){return(0,e.basename)(t)||t.authority}basename(t){return M.posix.basename(t.path)}extname(t){return M.posix.extname(t.path)}dirname(t){if(t.path.length===0)return t;let w;return t.scheme===D.Schemas.file?w=I.URI.file(M.dirname(d(t))).path:(w=M.posix.dirname(t.path),t.authority&&w.length&&w.charCodeAt(0)!==47&&(console.error(`dirname("${t.toString})) resulted in a relative path`),w="/")),t.with({path:w})}normalizePath(t){if(!t.path.length)return t;let w;return t.scheme===D.Schemas.file?w=I.URI.file(M.normalize(d(t))).path:w=M.posix.normalize(t.path),t.with({path:w})}relativePath(t,w){if(t.scheme!==w.scheme||!(0,e.isEqualAuthority)(t.authority,w.authority))return;if(t.scheme===D.Schemas.file){const P=M.relative(d(t),d(w));return C.isWindows?v.toSlashes(P):P}let b=t.path||"/",S=w.path||"/";if(this._ignorePathCasing(t)){let P=0;for(const c=Math.min(b.length,S.length);P<c&&!(b.charCodeAt(P)!==S.charCodeAt(P)&&b.charAt(P).toLowerCase()!==S.charAt(P).toLowerCase());P++);b=S.substr(0,P)+b.substr(P)}return M.posix.relative(b,S)}resolvePath(t,w){if(t.scheme===D.Schemas.file){const b=I.URI.file(M.resolve(d(t),w));return t.with({authority:b.authority,path:b.path})}return w=v.toPosixPath(w),t.with({path:M.posix.resolve(t.path,w)})}isAbsolutePath(t){return!!t.path&&t.path[0]==="/"}isEqualAuthority(t,w){return t===w||t!==void 0&&w!==void 0&&(0,n.equalsIgnoreCase)(t,w)}hasTrailingPathSeparator(t,w=M.sep){if(t.scheme===D.Schemas.file){const b=d(t);return b.length>v.getRoot(b).length&&b[b.length-1]===w}else{const b=t.path;return b.length>1&&b.charCodeAt(b.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(t.fsPath)}}removeTrailingPathSeparator(t,w=M.sep){return(0,e.hasTrailingPathSeparator)(t,w)?t.with({path:t.path.substr(0,t.path.length-1)}):t}addTrailingPathSeparator(t,w=M.sep){let b=!1;if(t.scheme===D.Schemas.file){const S=d(t);b=S!==void 0&&S.length===v.getRoot(S).length&&S[S.length-1]===w}else{w="/";const S=t.path;b=S.length===1&&S.charCodeAt(S.length-1)===47}return!b&&!(0,e.hasTrailingPathSeparator)(t,w)?t.with({path:t.path+"/"}):t}}e.ExtUri=f,e.extUri=new f(()=>!1),e.extUriBiasedIgnorePathCase=new f(p=>p.scheme===D.Schemas.file?!C.isLinux:!0),e.extUriIgnorePathCase=new f(p=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function y(p,t){const w=[];for(let b=0;b<p.length;b++){const S=t(p[b]);p.some((P,c)=>c===b?!1:(0,e.isEqualOrParent)(S,t(P)))||w.push(p[b])}return w}e.distinctParents=y;var E;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function t(w){const b=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach(c=>{const[a,l]=c.split(":");a&&l&&b.set(a,l)});const P=w.path.substring(0,w.path.indexOf(";"));return P&&b.set(p.META_DATA_MIME,P),b}p.parseMetaData=t})(E=e.DataUri||(e.DataUri={}));function m(p,t,w){if(t){let b=p.path;return b&&b[0]!==M.posix.sep&&(b=M.posix.sep+b),p.with({scheme:w,authority:t,path:b})}return p.with({scheme:w})}e.toLocalResource=m}),define(Q[9],J([0,1,23,16,4,2,15]),function(H,e,v,D,M,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function I(q){return!!q&&typeof q.then=="function"}e.isThenable=I;function d(q){const U=new v.CancellationTokenSource,N=q(U.token),_=new Promise((Y,F)=>{const A=U.token.onCancellationRequested(()=>{A.dispose(),U.dispose(),F((0,D.canceled)())});Promise.resolve(N).then(O=>{A.dispose(),U.dispose(),Y(O)},O=>{A.dispose(),U.dispose(),F(O)})});return new class{cancel(){U.cancel()}then(Y,F){return _.then(Y,F)}catch(Y){return this.then(void 0,Y)}finally(Y){return _.finally(Y)}}}e.createCancelablePromise=d;function f(q,U,N){return Promise.race([q,new Promise(_=>U.onCancellationRequested(()=>_(N)))])}e.raceCancellation=f;async function y(q){let U=-1;const N=q.map((Y,F)=>Y.then(A=>(U=F,A))),_=await Promise.race(N);return q.forEach((Y,F)=>{F!==U&&Y.cancel()}),_}e.raceCancellablePromises=y;function E(q,U,N){let _;const Y=setTimeout(()=>{_?.(void 0),N?.()},U);return Promise.race([q.finally(()=>clearTimeout(Y)),new Promise(F=>_=F)])}e.raceTimeout=E;function m(q){return new Promise((U,N)=>{const _=q();I(_)?_.then(U,N):U(_)})}e.asPromise=m;class p{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(U){if(this.activePromise){if(this.queuedPromiseFactory=U,!this.queuedPromise){const N=()=>{this.queuedPromise=null;const _=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,_};this.queuedPromise=new Promise(_=>{this.activePromise.then(N,N).then(_)})}return new Promise((N,_)=>{this.queuedPromise.then(N,_)})}return this.activePromise=U(),new Promise((N,_)=>{this.activePromise.then(Y=>{this.activePromise=null,N(Y)},Y=>{this.activePromise=null,_(Y)})})}}e.Throttler=p;class t{constructor(){this.current=Promise.resolve(null)}queue(U){return this.current=this.current.then(()=>U(),()=>U())}}e.Sequencer=t;class w{constructor(){this.promiseMap=new Map}queue(U,N){const Y=(this.promiseMap.get(U)??Promise.resolve()).catch(()=>{}).then(N).finally(()=>{this.promiseMap.get(U)===Y&&this.promiseMap.delete(U)});return this.promiseMap.set(U,Y),Y}}e.SequencerByKey=w;class b{constructor(U){this.defaultDelay=U,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(U,N=this.defaultDelay){return this.task=U,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((_,Y)=>{this.doResolve=_,this.doReject=Y}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const _=this.task;return this.task=null,_()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},N),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,D.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=b;class S{constructor(U){this.delayer=new b(U),this.throttler=new p}trigger(U,N){return this.delayer.trigger(()=>this.throttler.queue(U),N)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=S;class P{constructor(){this._isOpen=!1,this._promise=new Promise((U,N)=>{this._completePromise=U})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=P;class c extends P{constructor(U){super();this._timeout=setTimeout(()=>this.open(),U)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=c;function a(q,U){return U?new Promise((N,_)=>{const Y=setTimeout(()=>{F.dispose(),N()},q),F=U.onCancellationRequested(()=>{clearTimeout(Y),F.dispose(),_((0,D.canceled)())})}):d(N=>a(q,N))}e.timeout=a;function l(q,U=0){const N=setTimeout(q,U);return(0,C.toDisposable)(()=>clearTimeout(N))}e.disposableTimeout=l;function s(q){const U=[];let N=0;const _=q.length;function Y(){return N<_?q[N++]():null}function F(A){A!=null&&U.push(A);const O=Y();return O?O.then(F):Promise.resolve(U)}return Promise.resolve(null).then(F)}e.sequence=s;function u(q,U=_=>!!_,N=null){let _=0;const Y=q.length,F=()=>{if(_>=Y)return Promise.resolve(N);const A=q[_++];return Promise.resolve(A()).then($=>U($)?Promise.resolve($):F())};return F()}e.first=u;function r(q,U=_=>!!_,N=null){if(q.length===0)return Promise.resolve(N);let _=q.length;const Y=()=>{_=-1;for(const F of q)F.cancel?.()};return new Promise((F,A)=>{for(const O of q)O.then($=>{--_>=0&&U($)?(Y(),F($)):_===0&&F(N)}).catch($=>{--_>=0&&(Y(),A($))})})}e.firstParallel=r;class i{constructor(U){this._size=0,this.maxDegreeOfParalellism=U,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new M.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(U){return this._size++,new Promise((N,_)=>{this.outstandingPromises.push({factory:U,c:N,e:_}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const U=this.outstandingPromises.shift();this.runningPromises++;const N=U.factory();N.then(U.c,U.e),N.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=i;class o extends i{constructor(){super(1)}}e.Queue=o;class h{constructor(){this.queues=new Map}queueFor(U,N=n.extUri){const _=N.getComparisonKey(U);let Y=this.queues.get(_);return Y||(Y=new o,M.Event.once(Y.onFinished)(()=>{Y?.dispose(),this.queues.delete(_)}),this.queues.set(_,Y)),Y}dispose(){this.queues.forEach(U=>U.dispose()),this.queues.clear()}}e.ResourceQueue=h;class g{constructor(U,N){this._token=-1,typeof U=="function"&&typeof N=="number"&&this.setIfNotSet(U,N)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(U,N){this.cancel(),this._token=setTimeout(()=>{this._token=-1,U()},N)}setIfNotSet(U,N){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,U()},N))}}e.TimeoutTimer=g;class k{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(U,N){this.cancel(),this._token=setInterval(()=>{U()},N)}}e.IntervalTimer=k;class L{constructor(U,N){this.timeoutToken=-1,this.runner=U,this.timeout=N,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(U=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,U)}get delay(){return this.timeout}set delay(U){this.timeout=U}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=L;class R{constructor(U,N){N%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${N}ms is not a multiple of 1000ms.`),this.runner=U,this.timeout=N,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(U=this.timeout){U%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${U}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(U/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=R;class W extends L{constructor(U,N){super(U,N);this.units=[]}work(U){this.units.push(U),this.isScheduled()||this.schedule()}doRun(){const U=this.units;this.units=[],this.runner&&this.runner(U)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=W;class j extends C.Disposable{constructor(U,N,_,Y){super();this.maxWorkChunkSize=U,this.maxPendingWork=N,this.throttleDelay=_,this.handler=Y,this.pendingWork=[],this.throttler=this._register(new C.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(U){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+U.length>this.maxPendingWork)return!1}else if(this.pending+U.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...U),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new L(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=j,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=q=>{const U=setTimeout(()=>{const _=Date.now()+15;q(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,_-Date.now())}}))});let N=!1;return{dispose(){N||(N=!0,clearTimeout(U))}}}:e.runWhenIdle=(q,U)=>{const N=requestIdleCallback(q,typeof U=="number"?{timeout:U}:void 0);let _=!1;return{dispose(){_||(_=!0,cancelIdleCallback(N))}}}}();class x{constructor(U){this._didRun=!1,this._executor=()=>{try{this._value=U()}catch(N){this._error=N}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=x;async function ne(q,U,N){let _;for(let Y=0;Y<N;Y++)try{return await q()}catch(F){_=F,await a(U)}throw _}e.retry=ne;class oe{hasPending(U){return this._pending?typeof U=="number"?this._pending.taskId===U:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(U,N,_){return this._pending={taskId:U,cancel:()=>_?.(),promise:N},N.then(()=>this.donePending(U),()=>this.donePending(U)),N}donePending(U){this._pending&&U===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const U=this._next;this._next=void 0,U.run().then(U.promiseResolve,U.promiseReject)}}setNext(U){if(this._next)this._next.run=U;else{let N,_;const Y=new Promise((F,A)=>{N=F,_=A});this._next={run:U,promise:Y,promiseResolve:N,promiseReject:_}}return this._next.promise}}e.TaskSequentializer=oe;class G{constructor(U){this.interval=U,this.lastIncrementTime=0,this.value=0}increment(){const U=Date.now();return U-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=U,this.value=0),this.value++,this.value}}e.IntervalCounter=G;class T{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((U,N)=>{this.completeCallback=U,this.errorCallback=N})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(U){return new Promise(N=>{this.completeCallback(U),this.resolved=!0,N()})}error(U){return new Promise(N=>{this.errorCallback(U),this.rejected=!0,N()})}cancel(){new Promise(U=>{this.errorCallback((0,D.canceled)()),this.rejected=!0,U()})}}e.DeferredPromise=T;var B;(function(q){async function U(_){let Y;const F=await Promise.all(_.map(A=>A.then(O=>O,O=>{Y||(Y=O)})));if(typeof Y!="undefined")throw Y;return F}q.settled=U;function N(_){return new Promise(async(Y,F)=>{try{await _(Y,F)}catch(A){F(A)}})}q.withAsyncBody=N})(B=e.Promises||(e.Promises={}))}),define(Q[34],J([0,1,33,10,8,3,15,25,7]),function(H,e,v,D,M,C,n,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function f(i,o,h){if(typeof i=="string"&&(i=d.URI.file(i)),h){const k=h.getWorkspaceFolder(i);if(k){const L=h.getWorkspace().folders.length>1;let R;if((0,n.isEqual)(k.uri,i)?R="":R=(0,n.relativePath)(k.uri,i),L){const W=k.name?k.name:(0,n.basename)(k.uri);R=R?W+" \u2022 "+R:W}return R}}if(i.scheme!==D.Schemas.file&&i.scheme!==D.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,v.hasDriveLetter)(i.fsPath))return(0,M.normalize)(E(i.fsPath));let g=(0,M.normalize)(i.fsPath);return!C.isWindows&&o?.userHome&&(g=p(g,o.userHome.fsPath)),g}e.getPathLabel=f;function y(i){if(!i)return;typeof i=="string"&&(i=d.URI.file(i));const o=(0,n.basename)(i)||(i.scheme===D.Schemas.file?i.fsPath:i.path);return C.isWindows&&(0,v.isRootOrDriveLetter)(o)?E(o):o}e.getBaseLabel=y;function E(i,o){return(0,v.hasDriveLetter)(i,o)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=E;let m=Object.create(null);function p(i,o){if(C.isWindows||!i||!o)return i;let h=m.original===o?m.normalized:void 0;return h||(h=`${(0,I.rtrim)(o,M.posix.sep)}${M.posix.sep}`,m={original:o,normalized:h}),(C.isLinux?i.startsWith(h):(0,I.startsWithIgnoreCase)(i,h))&&(i=`~/${i.substr(h.length)}`),i}e.tildify=p;function t(i,o){return i.replace(/^~($|\/|\\)/,`${o}$1`)}e.untildify=t;const w="\u2026",b="\\\\",S="~";function P(i,o=M.sep){const h=new Array(i.length);let g=!1;for(let k=0;k<i.length;k++){let L=i[k];if(L===""){h[k]=`.${o}`;continue}if(!L){h[k]=L;continue}g=!0;let R="";L.indexOf(b)===0?(R=L.substr(0,L.indexOf(b)+b.length),L=L.substr(L.indexOf(b)+b.length)):L.indexOf(o)===0?(R=L.substr(0,L.indexOf(o)+o.length),L=L.substr(L.indexOf(o)+o.length)):L.indexOf(S)===0&&(R=L.substr(0,L.indexOf(S)+S.length),L=L.substr(L.indexOf(S)+S.length));const W=L.split(o);for(let j=1;g&&j<=W.length;j++)for(let x=W.length-j;g&&x>=0;x--){g=!1;let ne=W.slice(x,x+j).join(o);for(let oe=0;!g&&oe<i.length;oe++)if(oe!==k&&i[oe]&&i[oe].indexOf(ne)>-1){const G=x+j===W.length,T=x>0&&i[oe].indexOf(o)>-1?o+ne:ne,B=i[oe].endsWith(T);g=!G||B}if(!g){let oe="";(W[0].endsWith(":")||R!=="")&&(x===1&&(x=0,j++,ne=W[0]+o+ne),x>0&&(oe=W[0]+o),oe=R+oe),x>0&&(oe=oe+w+o),oe=oe+ne,x+j<W.length&&(oe=oe+o+w),h[k]=oe}}g&&(h[k]=L)}return h}e.shorten=P;var c;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function a(i,o=Object.create(null)){const h=[];let g=!1,k="";for(const L of i)if(L==="$"||g&&L==="{")k&&h.push({value:k,type:c.TEXT}),k="",g=!0;else if(L==="}"&&g){const R=o[k];if(typeof R=="string")R.length&&h.push({value:R,type:c.VARIABLE});else if(R){const W=h[h.length-1];(!W||W.type!==c.SEPARATOR)&&h.push({value:R.label,type:c.SEPARATOR})}k="",g=!1}else k+=L;return k&&!g&&h.push({value:k,type:c.TEXT}),h.filter((L,R)=>{if(L.type===c.SEPARATOR){const W=h[R-1],j=h[R+1];return[W,j].every(x=>x&&(x.type===c.VARIABLE||x.type===c.TEXT)&&x.value.length>0)}return!0}).map(L=>L.value).join("")}e.template=a;function l(i,o){return C.isMacintosh||o?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,C.isMacintosh?"&":"&&"):i.replace(/&&|&/g,h=>h==="&"?"&&":"&")}e.mnemonicMenuLabel=l;function s(i,o){return C.isMacintosh||o?i.replace(/\(&&\w\)|&&/g,""):C.isWindows?i.replace(/&&|&/g,h=>h==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=s;function u(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=u;function r(i){const o=i.indexOf("/")!==-1?M.posix:M.win32,h=o.basename(i),g=o.dirname(i);return h.length?{name:h,parentPath:g}:{name:g,parentPath:""}}e.splitName=r}),define(Q[112],J([0,1,7]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function D(y){return y.toJSON()}class M{constructor(E){this._uriTransformer=E}transformIncoming(E){const m=this._uriTransformer.transformIncoming(E);return m===E?E:D(v.URI.from(m))}transformOutgoing(E){const m=this._uriTransformer.transformOutgoing(E);return m===E?E:D(v.URI.from(m))}transformOutgoingURI(E){const m=this._uriTransformer.transformOutgoing(E);return m===E?E:v.URI.from(m)}transformOutgoingScheme(E){return this._uriTransformer.transformOutgoingScheme(E)}}e.URITransformer=M,e.DefaultURITransformer=new class{transformIncoming(y){return y}transformOutgoing(y){return y}transformOutgoingURI(y){return y}transformOutgoingScheme(y){return y}};function C(y,E,m){if(!y||m>200)return null;if(typeof y=="object"){if(y instanceof v.URI)return E.transformOutgoing(y);for(let p in y)if(Object.hasOwnProperty.call(y,p)){const t=C(y[p],E,m+1);t!==null&&(y[p]=t)}}return null}function n(y,E){const m=C(y,E,0);return m===null?y:m}e.transformOutgoingURIs=n;function I(y,E,m,p){if(!y||p>200)return null;if(typeof y=="object"){if(y.$mid===1)return m?v.URI.revive(E.transformIncoming(y)):E.transformIncoming(y);for(let t in y)if(Object.hasOwnProperty.call(y,t)){const w=I(y[t],E,m,p+1);w!==null&&(y[t]=w)}}return null}function d(y,E){const m=I(y,E,!1,0);return m===null?y:m}e.transformIncomingURIs=d;function f(y,E){const m=I(y,E,!0,0);return m===null?y:m}e.transformAndReviveIncomingURIs=f}),define(Q[31],J([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const v=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function D(d){return v.test(d)}e.isUUID=D;const M=new Uint8Array(16),C=[];for(let d=0;d<256;d++)C.push(d.toString(16).padStart(2,"0"));let n;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?n=crypto.getRandomValues.bind(crypto):n=function(d){for(let f=0;f<d.length;f++)d[f]=Math.floor(Math.random()*256);return d};function I(){n(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let d=0,f="";return f+=C[M[d++]],f+=C[M[d++]],f+=C[M[d++]],f+=C[M[d++]],f+="-",f+=C[M[d++]],f+=C[M[d++]],f+="-",f+=C[M[d++]],f+=C[M[d++]],f+="-",f+=C[M[d++]],f+=C[M[d++]],f+="-",f+=C[M[d++]],f+=C[M[d++]],f+=C[M[d++]],f+=C[M[d++]],f+=C[M[d++]],f+=C[M[d++]],f}e.generateUuid=I}),define(Q[113],J([0,1,16,4,2,3,13,25]),function(H,e,v,D,M,C,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=e.SimpleWorkerServer=e.SimpleWorkerClient=e.logOnceWebWorkerWarning=void 0;const d="$initialize";let f=!1;function y(r){!C.isWeb||(f||(f=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(r.message))}e.logOnceWebWorkerWarning=y;var E;(function(r){r[r.Request=0]="Request",r[r.Reply=1]="Reply",r[r.SubscribeEvent=2]="SubscribeEvent",r[r.Event=3]="Event",r[r.UnsubscribeEvent=4]="UnsubscribeEvent"})(E||(E={}));class m{constructor(i,o,h,g){this.vsWorker=i,this.req=o,this.method=h,this.args=g,this.type=0}}class p{constructor(i,o,h,g){this.vsWorker=i,this.seq=o,this.res=h,this.err=g,this.type=1}}class t{constructor(i,o,h,g){this.vsWorker=i,this.req=o,this.eventName=h,this.arg=g,this.type=2}}class w{constructor(i,o,h){this.vsWorker=i,this.req=o,this.event=h,this.type=3}}class b{constructor(i,o){this.vsWorker=i,this.req=o,this.type=4}}class S{constructor(i){this._workerId=-1,this._handler=i,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(i){this._workerId=i}sendMessage(i,o){const h=String(++this._lastSentReq);return new Promise((g,k)=>{this._pendingReplies[h]={resolve:g,reject:k},this._send(new m(this._workerId,h,i,o))})}listen(i,o){let h=null;const g=new D.Emitter({onFirstListenerAdd:()=>{h=String(++this._lastSentReq),this._pendingEmitters.set(h,g),this._send(new t(this._workerId,h,i,o))},onLastListenerRemove:()=>{this._pendingEmitters.delete(h),this._send(new b(this._workerId,h)),h=null}});return g.event}handleMessage(i){!i||!i.vsWorker||this._workerId!==-1&&i.vsWorker!==this._workerId||this._handleMessage(i)}_handleMessage(i){switch(i.type){case 1:return this._handleReplyMessage(i);case 0:return this._handleRequestMessage(i);case 2:return this._handleSubscribeEventMessage(i);case 3:return this._handleEventMessage(i);case 4:return this._handleUnsubscribeEventMessage(i)}}_handleReplyMessage(i){if(!this._pendingReplies[i.seq]){console.warn("Got reply to unknown seq");return}let o=this._pendingReplies[i.seq];if(delete this._pendingReplies[i.seq],i.err){let h=i.err;i.err.$isError&&(h=new Error,h.name=i.err.name,h.message=i.err.message,h.stack=i.err.stack),o.reject(h);return}o.resolve(i.res)}_handleRequestMessage(i){let o=i.req;this._handler.handleMessage(i.method,i.args).then(g=>{this._send(new p(this._workerId,o,g,void 0))},g=>{g.detail instanceof Error&&(g.detail=(0,v.transformErrorForSerialization)(g.detail)),this._send(new p(this._workerId,o,void 0,(0,v.transformErrorForSerialization)(g)))})}_handleSubscribeEventMessage(i){const o=i.req,h=this._handler.handleEvent(i.eventName,i.arg)(g=>{this._send(new w(this._workerId,o,g))});this._pendingEvents.set(o,h)}_handleEventMessage(i){if(!this._pendingEmitters.has(i.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(i.req).fire(i.event)}_handleUnsubscribeEventMessage(i){if(!this._pendingEvents.has(i.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(i.req).dispose(),this._pendingEvents.delete(i.req)}_send(i){let o=[];if(i.type===0)for(let h=0;h<i.args.length;h++)i.args[h]instanceof ArrayBuffer&&o.push(i.args[h]);else i.type===1&&i.res instanceof ArrayBuffer&&o.push(i.res);this._handler.sendMessage(i,o)}}class P extends M.Disposable{constructor(i,o,h){super();let g=null;this._worker=this._register(i.create("vs/base/common/worker/simpleWorker",j=>{this._protocol.handleMessage(j)},j=>{g&&g(j)})),this._protocol=new S({sendMessage:(j,x)=>{this._worker.postMessage(j,x)},handleMessage:(j,x)=>{if(typeof h[j]!="function")return Promise.reject(new Error("Missing method "+j+" on main thread host."));try{return Promise.resolve(h[j].apply(h,x))}catch(ne){return Promise.reject(ne)}},handleEvent:(j,x)=>{if(a(j)){const ne=h[j].call(h,x);if(typeof ne!="function")throw new Error(`Missing dynamic event ${j} on main thread host.`);return ne}if(c(j)){const ne=h[j];if(typeof ne!="function")throw new Error(`Missing event ${j} on main thread host.`);return ne}throw new Error(`Malformed event name ${j}`)}}),this._protocol.setWorkerId(this._worker.getId());let k=null;typeof C.globals.require!="undefined"&&typeof C.globals.require.getConfig=="function"?k=C.globals.require.getConfig():typeof C.globals.requirejs!="undefined"&&(k=C.globals.requirejs.s.contexts._.config);const L=n.getAllMethodNames(h);this._onModuleLoaded=this._protocol.sendMessage(d,[this._worker.getId(),JSON.parse(JSON.stringify(k)),o,L]);const R=(j,x)=>this._request(j,x),W=(j,x)=>this._protocol.listen(j,x);this._lazyProxy=new Promise((j,x)=>{g=x,this._onModuleLoaded.then(ne=>{j(l(ne,R,W))},ne=>{x(ne),this._onError("Worker failed to load "+o,ne)})})}getProxyObject(){return this._lazyProxy}_request(i,o){return new Promise((h,g)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(i,o).then(h,g)},g)})}_onError(i,o){console.error(i),console.info(o)}}e.SimpleWorkerClient=P;function c(r){return r[0]==="o"&&r[1]==="n"&&I.isUpperAsciiLetter(r.charCodeAt(2))}function a(r){return/^onDynamic/.test(r)&&I.isUpperAsciiLetter(r.charCodeAt(9))}function l(r,i,o){const h=L=>function(){const R=Array.prototype.slice.call(arguments,0);return i(L,R)},g=L=>function(R){return o(L,R)};let k={};for(const L of r){if(a(L)){k[L]=g(L);continue}if(c(L)){k[L]=o(L,void 0);continue}k[L]=h(L)}return k}class s{constructor(i,o){this._requestHandlerFactory=o,this._requestHandler=null,this._protocol=new S({sendMessage:(h,g)=>{i(h,g)},handleMessage:(h,g)=>this._handleMessage(h,g),handleEvent:(h,g)=>this._handleEvent(h,g)})}onmessage(i){this._protocol.handleMessage(i)}_handleMessage(i,o){if(i===d)return this.initialize(o[0],o[1],o[2],o[3]);if(!this._requestHandler||typeof this._requestHandler[i]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+i));try{return Promise.resolve(this._requestHandler[i].apply(this._requestHandler,o))}catch(h){return Promise.reject(h)}}_handleEvent(i,o){if(!this._requestHandler)throw new Error("Missing requestHandler");if(a(i)){const h=this._requestHandler[i].call(this._requestHandler,o);if(typeof h!="function")throw new Error(`Missing dynamic event ${i} on request handler.`);return h}if(c(i)){const h=this._requestHandler[i];if(typeof h!="function")throw new Error(`Missing event ${i} on request handler.`);return h}throw new Error(`Malformed event name ${i}`)}initialize(i,o,h,g){this._protocol.setWorkerId(i);const R=l(g,(W,j)=>this._protocol.sendMessage(W,j),(W,j)=>this._protocol.listen(W,j));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(R),Promise.resolve(n.getAllMethodNames(this._requestHandler))):(o&&(typeof o.baseUrl!="undefined"&&delete o.baseUrl,typeof o.paths!="undefined"&&typeof o.paths.vs!="undefined"&&delete o.paths.vs,typeof o.trustedTypesPolicy!==void 0&&delete o.trustedTypesPolicy,o.catchError=!0,C.globals.require.config(o)),new Promise((W,j)=>{(C.globals.require||H)([h],ne=>{if(this._requestHandler=ne.create(R),!this._requestHandler){j(new Error("No RequestHandler!"));return}W(n.getAllMethodNames(this._requestHandler))},j)}))}}e.SimpleWorkerServer=s;function u(r){return new s(r,null)}e.create=u}),define(Q[114],J([0,1,61,28,42]),function(H,e,v,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function C(n,I){if(await new Promise((y,E)=>{const m=D.createReadStream(n),p=v.createHash("sha1");m.pipe(p);const t=(0,M.once)((w,b)=>{m.removeAllListeners(),p.removeAllListeners(),w?E(w):y(b)});m.once("error",t),m.once("end",t),p.once("error",t),p.once("data",w=>t(void 0,w.toString("hex")))})!==I)throw new Error("Hash mismatch")}e.checksum=C}),define(Q[115],J([0,1,245]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class D{constructor(C="utf8"){this.stringDecoder=new v.StringDecoder(C),this.remaining=null}write(C){const n=[],I=this.remaining?this.remaining+this.stringDecoder.write(C):this.stringDecoder.write(C);if(I.length<1)return n;let d=0,f,y=d;for(;y<I.length;)if(f=I.charCodeAt(y),f===13||f===10){if(n.push(I.substring(d,y)),y++,y<I.length){const E=f;f=I.charCodeAt(y),(E===13&&f===10||E===10&&f===13)&&y++}d=y}else y++;return this.remaining=d<I.length?I.substr(d):null,n}end(){return this.remaining}}e.LineDecoder=D}),define(Q[116],J([0,1,26]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const D=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function M(n){const I=n.replace(/\-/g,":").toLowerCase();return!D.has(I)}function C(){const n=(0,v.networkInterfaces)();for(let I in n){const d=n[I];if(d){for(const{mac:f}of d)if(M(f))return f}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=C}),define(Q[71],J([0,1,26,16,40,31,116]),function(H,e,v,D,M,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(y){return this._virtualMachineOUIs||(this._virtualMachineOUIs=M.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(y)}value(){if(this._value===void 0){let y=0,E=0;const m=(0,v.networkInterfaces)();for(let p in m){const t=m[p];if(t)for(const{mac:w,internal:b}of t)b||(E+=1,this._isVirtualMachineMacAddress(w.toUpperCase())&&(y+=1))}this._value=E>0?y/E:0}return this._value}};let I;async function d(){return I||(I=(async()=>await f()||C.generateUuid())()),I}e.getMachineId=d;async function f(){try{const y=await new Promise((m,p)=>{H(["crypto"],m,p)}),E=(0,n.getMac)();return y.createHash("sha256").update(E,"utf8").digest("hex")}catch(y){D.onUnexpectedError(y);return}}}),define(Q[21],J([0,1,28,26,117,9,33,70,8,3,15,7,31]),function(H,e,v,D,M,C,n,I,d,f,y,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var p;(function(T){T[T.UNLINK=0]="UNLINK",T[T.MOVE=1]="MOVE"})(p=e.RimRafMode||(e.RimRafMode={}));async function t(T,B=p.UNLINK){if((0,n.isRootOrDriveLetter)(T))throw new Error("rimraf - will refuse to recursively delete root");return B===p.UNLINK?b(T):w(T)}async function w(T){try{const B=(0,d.join)((0,D.tmpdir)(),(0,m.generateUuid)());try{await e.Promises.rename(T,B)}catch(q){return b(T)}b(B).catch(q=>{})}catch(B){if(B.code!=="ENOENT")throw B}}async function b(T){return e.Promises.rmdir(T,{recursive:!0,maxRetries:3})}function S(T){if((0,n.isRootOrDriveLetter)(T))throw new Error("rimraf - will refuse to recursively delete root");v.rmdirSync(T,{recursive:!0})}e.rimrafSync=S;async function P(T,B){return l(await(B?c(T):(0,M.promisify)(v.readdir)(T)))}async function c(T){try{return await(0,M.promisify)(v.readdir)(T,{withFileTypes:!0})}catch(U){console.warn("[node.js fs] readdir with filetypes failed with error: ",U)}const B=[],q=await P(T);for(const U of q){let N=!1,_=!1,Y=!1;try{const F=await e.Promises.lstat((0,d.join)(T,U));N=F.isFile(),_=F.isDirectory(),Y=F.isSymbolicLink()}catch(F){console.warn("[node.js fs] unexpected error from lstat after readdir: ",F)}B.push({name:U,isFile:()=>N,isDirectory:()=>_,isSymbolicLink:()=>Y})}return B}function a(T){return l(v.readdirSync(T))}e.readdirSync=a;function l(T){return T.map(B=>typeof B=="string"?f.isMacintosh?(0,I.normalizeNFC)(B):B:(B.name=f.isMacintosh?(0,I.normalizeNFC)(B.name):B.name,B))}async function s(T){const B=await P(T),q=[];for(const U of B)await r.existsDirectory((0,d.join)(T,U))&&q.push(U);return q}function u(T,B=1e3){return new Promise(q=>{let U=!1;const N=setInterval(()=>{U||(U=!0,v.access(T,_=>{U=!1,_&&(clearInterval(N),q(void 0))}))},B)})}e.whenDeleted=u;var r;(function(T){async function B(N){let _;try{if(_=await e.Promises.lstat(N),!_.isSymbolicLink())return{stat:_}}catch(Y){}try{return{stat:await e.Promises.stat(N),symbolicLink:_?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Y){if(Y.code==="ENOENT"&&_)return{stat:_,symbolicLink:{dangling:!0}};if(f.isWindows&&Y.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(N)),symbolicLink:{dangling:!1}}}catch(F){if(F.code==="ENOENT"&&_)return{stat:_,symbolicLink:{dangling:!0}};throw F}throw Y}}T.stat=B;async function q(N){try{const{stat:_,symbolicLink:Y}=await T.stat(N);return _.isFile()&&Y?.dangling!==!0}catch(_){}return!1}T.existsFile=q;async function U(N){try{const{stat:_,symbolicLink:Y}=await T.stat(N);return _.isDirectory()&&Y?.dangling!==!0}catch(_){}return!1}T.existsDirectory=U})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new C.ResourceQueue;function o(T,B,q){return i.queueFor(E.URI.file(T),y.extUriBiasedIgnorePathCase).queue(()=>{const U=L(q);return new Promise((N,_)=>g(T,B,U,Y=>Y?_(Y):N()))})}let h=!0;function g(T,B,q,U){if(!h)return v.writeFile(T,B,{mode:q.mode,flag:q.flag},U);v.open(T,q.flag,q.mode,(N,_)=>{if(N)return U(N);v.writeFile(_,B,Y=>{if(Y)return v.close(_,()=>U(Y));v.fdatasync(_,F=>(F&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",F),h=!1),v.close(_,A=>U(A))))})})}function k(T,B,q){const U=L(q);if(!h)return v.writeFileSync(T,B,{mode:U.mode,flag:U.flag});const N=v.openSync(T,U.flag,U.mode);try{v.writeFileSync(N,B);try{v.fdatasyncSync(N)}catch(_){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",_),h=!1}}finally{v.closeSync(N)}}e.writeFileSync=k;function L(T){return T?{mode:typeof T.mode=="number"?T.mode:438,flag:typeof T.flag=="string"?T.flag:"w"}:{mode:438,flag:"w"}}async function R(T,B){if(T===B)return;async function q(U){try{const N=await e.Promises.lstat(U);if(N.isDirectory()||N.isSymbolicLink())return;await e.Promises.utimes(U,N.atime,new Date)}catch(N){}}try{await e.Promises.rename(T,B),await q(B)}catch(U){if(T.toLowerCase()!==B.toLowerCase()&&U.code==="EXDEV"||T.endsWith("."))await W(T,B,{preserveSymlinks:!1}),await t(T,p.MOVE),await q(B);else throw U}}async function W(T,B,q){return x(T,B,{root:{source:T,target:B},options:q,handledSourcePaths:new Set})}const j=511;async function x(T,B,q){if(q.handledSourcePaths.has(T))return;q.handledSourcePaths.add(T);const{stat:U,symbolicLink:N}=await r.stat(T);if(N){if(q.options.preserveSymlinks)try{return await G(T,B,q)}catch(_){console.warn("[node.js fs] copy of symlink failed: ",_)}if(N.dangling)return}return U.isDirectory()?ne(T,B,U.mode&j,q):oe(T,B,U.mode&j)}async function ne(T,B,q,U){await e.Promises.mkdir(B,{recursive:!0,mode:q});const N=await P(T);for(const _ of N)await x((0,d.join)(T,_),(0,d.join)(B,_),U)}async function oe(T,B,q){await e.Promises.copyFile(T,B),await e.Promises.chmod(B,q)}async function G(T,B,q){let U=await e.Promises.readlink(T);(0,n.isEqualOrParent)(U,q.root.source,!f.isLinux)&&(U=(0,d.join)(q.root.target,U.substr(q.root.source.length+1))),await e.Promises.symlink(U,B)}e.Promises=new class{get access(){return(0,M.promisify)(v.access)}get stat(){return(0,M.promisify)(v.stat)}get lstat(){return(0,M.promisify)(v.lstat)}get utimes(){return(0,M.promisify)(v.utimes)}get read(){return(0,M.promisify)(v.read)}get readFile(){return(0,M.promisify)(v.readFile)}get write(){return(0,M.promisify)(v.write)}get appendFile(){return(0,M.promisify)(v.appendFile)}get fdatasync(){return(0,M.promisify)(v.fdatasync)}get truncate(){return(0,M.promisify)(v.truncate)}get rename(){return(0,M.promisify)(v.rename)}get copyFile(){return(0,M.promisify)(v.copyFile)}get open(){return(0,M.promisify)(v.open)}get close(){return(0,M.promisify)(v.close)}get symlink(){return(0,M.promisify)(v.symlink)}get readlink(){return(0,M.promisify)(v.readlink)}get chmod(){return(0,M.promisify)(v.chmod)}get mkdir(){return(0,M.promisify)(v.mkdir)}get unlink(){return(0,M.promisify)(v.unlink)}get rmdir(){return(0,M.promisify)(v.rmdir)}get realpath(){return(0,M.promisify)(v.realpath)}async exists(T){try{return await e.Promises.access(T),!0}catch{return!1}}get readdir(){return P}get readDirsInDir(){return s}get writeFile(){return o}get rm(){return t}get move(){return R}get copy(){return W}}}),define(Q[82],J([0,1,28,8,25,21]),function(H,e,v,D,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function n(y){const E=(0,D.dirname)(y);if(y===E)return y;const m=((0,D.basename)(y)||y).toLowerCase();try{const t=(0,C.readdirSync)(E).filter(w=>w.toLowerCase()===m);if(t.length===1){const w=n(E);if(w)return(0,D.join)(w,t[0])}else if(t.length>1){const w=t.indexOf(m);if(w>=0){const b=n(E);if(b)return(0,D.join)(b,t[w])}}}catch(p){}return null}e.realcaseSync=n;async function I(y){try{return await C.Promises.realpath(y)}catch(E){const m=f(y);return await C.Promises.access(m,v.constants.R_OK),m}}e.realpath=I;function d(y){try{return v.realpathSync(y)}catch(E){const m=f(y);return v.accessSync(m,v.constants.R_OK),m}}e.realpathSync=d;function f(y){return(0,M.rtrim)((0,D.normalize)(y),D.sep)}}),define(Q[118],J([0,1,62]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function D(I,d,f,y=1){let E=!1;return new Promise(m=>{const p=setTimeout(()=>{if(!E)return E=!0,m(0)},f);M(I,d,y,t=>{if(!E)return E=!0,clearTimeout(p),m(t)})})}e.findFreePort=D;function M(I,d,f,y){if(d===0)return y(0);const E=new v.Socket;E.once("connect",()=>(n(E),M(I+f,d-1,f,y))),E.once("data",()=>{}),E.once("error",m=>(n(E),m.code!=="ECONNREFUSED"?M(I+f,d-1,f,y):y(I))),E.connect(I,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function C(I,d,f){let y=!1,E,m=1;const p=v.createServer({pauseOnConnect:!0});function t(w,b){y||(y=!0,p.removeAllListeners(),p.close(),E&&clearTimeout(E),b(w))}return new Promise(w=>{E=setTimeout(()=>{t(0,w)},f),p.on("listening",()=>{t(I,w)}),p.on("error",b=>{b&&(b.code==="EADDRINUSE"||b.code==="EACCES")&&m<d?(I++,m++,p.listen(I,"127.0.0.1")):t(0,w)}),p.on("close",()=>{t(0,w)}),p.listen(I,"127.0.0.1")})}e.findFreePortFaster=C;function n(I){try{I.removeAllListeners("connect"),I.removeAllListeners("error"),I.end(),I.destroy(),I.unref()}catch(d){console.error(d)}}}),define(Q[119],J([0,1,26,8,21]),function(H,e,v,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const C=/^\d+$/,n=/^Microsoft.PowerShell_.*/,I=/^Microsoft.PowerShellPreview_.*/;var d;(function(a){a[a.x64=0]="x64",a[a.x86=1]="x86",a[a.ARM=2]="ARM"})(d||(d={}));let f;switch(process.arch){case"ia32":case"x32":f=1;break;case"arm":case"arm64":f=2;break;default:f=0;break}let y;process.env.PROCESSOR_ARCHITEW6432?y=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?y=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?y=1:y=0;class E{constructor(l,s,u){this.exePath=l,this.displayName=s,this.knownToExist=u}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await M.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function m({useAlternateBitness:a=!1}={}){return a?f===0?process.env["ProgramFiles(x86)"]||null:y===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function p({useAlternateBitness:a=!1,findPreview:l=!1}={}){const s=m({useAlternateBitness:a});if(!s)return null;const u=D.join(s,"PowerShell");if(!await M.SymlinkSupport.existsDirectory(u))return null;let r=-1,i=null;for(const g of await M.Promises.readdir(u)){let k=-1;if(l){const R=g.indexOf("-");if(R<0)continue;const W=g.substring(0,R);if(!C.test(W)||g.substring(R+1)!=="preview")continue;k=parseInt(W,10)}else{if(!C.test(g))continue;k=parseInt(g,10)}if(k<=r)continue;const L=D.join(u,g,"pwsh.exe");!await M.SymlinkSupport.existsFile(L)||(i=L,r=k)}if(!i)return null;const o=s.includes("x86")?" (x86)":"",h=l?" Preview":"";return new E(i,`PowerShell${h}${o}`,!0)}async function t({findPreview:a}={}){if(!process.env.LOCALAPPDATA)return null;const l=D.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await M.SymlinkSupport.existsDirectory(l))return null;const{pwshMsixDirRegex:s,pwshMsixName:u}=a?{pwshMsixDirRegex:I,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:n,pwshMsixName:"PowerShell (Store)"};for(const r of await M.Promises.readdir(l))if(s.test(r)){const i=D.join(l,r,"pwsh.exe");return new E(i,u)}return null}function w(){const a=D.join(v.homedir(),".dotnet","tools","pwsh.exe");return new E(a,".NET Core PowerShell Global Tool")}function b(){const a=D.join(process.env.windir,f===1&&y!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new E(a,"Windows PowerShell",!0)}async function*S(){let a=await p();a&&(yield a),a=await p({useAlternateBitness:!0}),a&&(yield a),a=await t(),a&&(yield a),a=w(),a&&(yield a),a=await p({findPreview:!0}),a&&(yield a),a=await t({findPreview:!0}),a&&(yield a),a=await p({useAlternateBitness:!0,findPreview:!0}),a&&(yield a),a=b(),a&&(yield a)}async function*P(){for await(const a of S())await a.exists()&&(yield a)}e.enumeratePowerShellInstallations=P;async function c(){for await(const a of P())return a;return null}e.getFirstAvailablePowerShellInstallation=c}),define(Q[83],J([0,1,43,10]),function(H,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function M(n){return new Promise((I,d)=>{let f;const y=new Map;function E(p,t,w,b,S){const P=y.get(t);if(p===n||P){const c={name:m(w),cmd:w,pid:p,ppid:t,load:b,mem:S};y.set(p,c),p===n&&(f=c),P&&(P.children||(P.children=[]),P.children.push(c),P.children.length>1&&(P.children=P.children.sort((a,l)=>a.pid-l.pid)))}}function m(p){const t=/--disable-blink-features=Auxclick/,w=/\\watcher\\win32\\CodeHelper\.exe/,b=/--crashes-directory/,S=/\\pipe\\winpty-control/,P=/conhost\.exe/,c=/--type=([a-zA-Z-]+)/;if(w.exec(p))return"watcherService ";if(b.exec(p))return"electron-crash-reporter";if(S.exec(p))return"winpty-process";if(P.exec(p))return"console-window-host (Windows internal process)";let a=c.exec(p);if(a&&a.length===2)return a[1]==="renderer"?t.exec(p)?"shared-process":"window":a[1];const l=/[a-zA-Z-]+\.js/g;let s="";do a=l.exec(p),a&&(s+=a+" ");while(a);return s&&p.indexOf("node ")<0&&p.indexOf("node.exe")<0?`electron_node ${s}`:p}if(process.platform==="win32"){const p=t=>t.indexOf("\\\\?\\")===0||t.indexOf("\\??\\")===0?t.substr(4):t.indexOf('"\\\\?\\')===0||t.indexOf('"\\??\\')===0?'"'+t.substr(5):t;new Promise((t,w)=>{H(["windows-process-tree"],t,w)}).then(t=>{t.getProcessList(n,w=>{t.getProcessCpuUsage(w,b=>{const S=new Map;b.forEach(P=>{const c=p(P.commandLine||"");S.set(P.pid,{name:m(c),cmd:c,pid:P.pid,ppid:P.ppid,load:P.cpu||0,mem:P.memory||0})}),f=S.get(n),f?(S.forEach(P=>{const c=S.get(P.ppid);c&&(c.children||(c.children=[]),c.children.push(P))}),S.forEach(P=>{P.children&&(P.children=P.children.sort((c,a)=>c.pid-a.pid))}),I(f)):d(new Error(`Root process ${n} not found`))})},t.ProcessDataFlag.CommandLine|t.ProcessDataFlag.Memory)})}else{let p=function(){let t=[f];const w=[];for(;t.length;){const S=t.shift();S&&(w.push(S.pid),S.children&&(t=t.concat(S.children)))}let b=JSON.stringify(D.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",H).fsPath);b+=" "+w.join(" "),(0,v.exec)(b,{},(S,P,c)=>{if(S||c)d(S||new Error(c.toString()));else{const a=P.toString().split(`
`);for(let l=0;l<w.length;l++){const s=y.get(w[l]);s.load=parseFloat(a[l])}if(!f){d(new Error(`Root process ${n} not found`));return}I(f)}})};(0,v.exec)("which ps",{},(t,w,b)=>{if(t||b)if(process.platform!=="linux")d(t||new Error(b.toString()));else{const S=JSON.stringify(D.FileAccess.asFileUri("vs/base/node/ps.sh",H).fsPath);(0,v.exec)(S,{},(P,c,a)=>{P||a?d(P||new Error(a.toString())):(C(c,E),p())})}else{const S=w.toString().trim(),P="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,v.exec)(`${S} ${P}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(c,a,l)=>{c||l&&!l.includes("screen size is bogus")?d(c||new Error(l.toString())):(C(a,E),process.platform==="linux"?p():f?I(f):d(new Error(`Root process ${n} not found`)))})}})}})}e.listProcesses=M;function C(n,I){const d=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,f=n.toString().split(`
`);for(const y of f){const E=d.exec(y.trim());E&&E.length===6&&I(parseInt(E[1]),parseInt(E[2]),E[5],parseFloat(E[3]),parseFloat(E[4]))}}}),define(Q[120],J([0,1,28,23,33,2,70,8,3,21]),function(H,e,v,D,M,C,n,I,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function y(t,w,b){return m({path:t,isDirectory:!1},w,b)}e.watchFile=y;function E(t,w,b){return m({path:t,isDirectory:!0},w,b)}e.watchFolder=E,e.CHANGE_BUFFER_DELAY=100;function m(t,w,b){if(d.isMacintosh&&(0,M.isEqualOrParent)(t.path,"/Volumes/"))return b(`Refusing to watch ${t.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),C.Disposable.None;const S=(0,I.basename)(t.path),P=new Map;let c=!1,a=[(0,C.toDisposable)(()=>{P.forEach(l=>(0,C.dispose)(l)),P.clear()})];try{const l=(0,v.watch)(t.path);a.push((0,C.toDisposable)(()=>{l.removeAllListeners(),l.close()}));const s=new Set;t.isDirectory&&f.Promises.readdir(t.path).then(u=>u.forEach(r=>s.add(r))),l.on("error",(u,r)=>{c||b(`Failed to watch ${t.path} for changes using fs.watch() (${u}, ${r})`)}),l.on("change",(u,r)=>{if(c)return;let i="";if(r&&(i=r.toString(),d.isMacintosh&&(i=(0,n.normalizeNFC)(i))),!i||u!=="change"&&u!=="rename")return;const o=t.isDirectory?(0,I.join)(t.path,i):t.path;if(t.isDirectory)if(u==="rename"){const h=P.get(o);h&&(0,C.dispose)(h);const g=setTimeout(async()=>{P.delete(o);const k=await f.Promises.exists(o);if(c)return;let L;k?s.has(i)?L="changed":(L="added",s.add(i)):(s.delete(i),L="deleted"),w(L,o)},e.CHANGE_BUFFER_DELAY);P.set(o,(0,C.toDisposable)(()=>clearTimeout(g)))}else{let h;s.has(i)?h="changed":(h="added",s.add(i)),w(h,o)}else if(u==="rename"||i!==S){const h=setTimeout(async()=>{const g=await f.Promises.exists(o);c||(g?(w("changed",o),a=[m(t,w,b)]):w("deleted",o))},e.CHANGE_BUFFER_DELAY);(0,C.dispose)(a),a=[(0,C.toDisposable)(()=>clearTimeout(h))]}else w("changed",o)})}catch(l){f.Promises.exists(t.path).then(s=>{s&&!c&&b(`Failed to watch ${t.path} for changes using fs.watch() (${l.toString()})`)})}return(0,C.toDisposable)(()=>{c=!0,a=(0,C.dispose)(a)})}async function p(t,w,b,S=512){const P=await f.Promises.open(t,"r"),c=Buffer.allocUnsafe(S),a=new D.CancellationTokenSource(b);let l,s=!1;const u=y(t,async r=>{if(r==="changed"){if(s)return;s=!0;try{for(;!a.token.isCancellationRequested;){const{bytesRead:i}=await f.Promises.read(P,c,0,S,null);if(!i||a.token.isCancellationRequested)break;w(c.slice(0,i))}}catch(i){l=new Error(i),a.dispose(!0)}finally{s=!1}}},r=>{l=new Error(r),a.dispose(!0)});return new Promise((r,i)=>{a.token.onCancellationRequested(async()=>{u.dispose(),await f.Promises.close(P),l?i(l):r()})})}e.watchFileContents=p}),define(Q[121],J([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(Q[122],J([0,1,14,13,121]),function(H,e,v,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function C(){v.ipcMain.on(M.CONTEXT_MENU_CHANNEL,(I,d,f,y,E)=>{const m=n(I,y,f);m.popup({window:(0,D.withNullAsUndefined)(v.BrowserWindow.fromWebContents(I.sender)),x:E?E.x:void 0,y:E?E.y:void 0,positioningItem:E?E.positioningItem:void 0,callback:()=>{m&&I.sender.send(M.CONTEXT_MENU_CLOSE_CHANNEL,d)}})})}e.registerContextMenuListener=C;function n(I,d,f){const y=new v.Menu;return f.forEach(E=>{let m;E.type==="separator"?m=new v.MenuItem({type:E.type}):Array.isArray(E.submenu)?m=new v.MenuItem({submenu:n(I,d,E.submenu),label:E.label}):m=new v.MenuItem({label:E.label,type:E.type,accelerator:E.accelerator,checked:E.checked,enabled:E.enabled,visible:E.visible,click:(p,t,w)=>I.sender.send(d,E.id,w)}),y.append(m)}),y}});var he=this&&this.__decorate||function(H,e,v,D){var M=arguments.length,C=M<3?e:D===null?D=Object.getOwnPropertyDescriptor(e,v):D,n;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")C=Reflect.decorate(H,e,v,D);else for(var I=H.length-1;I>=0;I--)(n=H[I])&&(C=(M<3?n(C):M>3?n(e,v,C):n(e,v))||C);return M>3&&C&&Object.defineProperty(e,v,C),C};define(Q[35],J([0,1,30,9,17,23,46,16,4,2,111,25,13]),function(H,e,v,D,M,C,n,I,d,f,y,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var p;(function(N){N[N.Promise=100]="Promise",N[N.PromiseCancel=101]="PromiseCancel",N[N.EventListen=102]="EventListen",N[N.EventDispose=103]="EventDispose"})(p=e.RequestType||(e.RequestType={}));function t(N){switch(N){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var w;(function(N){N[N.Initialize=200]="Initialize",N[N.PromiseSuccess=201]="PromiseSuccess",N[N.PromiseError=202]="PromiseError",N[N.PromiseErrorObj=203]="PromiseErrorObj",N[N.EventFire=204]="EventFire"})(w=e.ResponseType||(e.ResponseType={}));function b(N){switch(N){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var S;(function(N){N[N.Uninitialized=0]="Uninitialized",N[N.Idle=1]="Idle"})(S||(S={}));class P{constructor(_){this.buffer=_,this.pos=0}read(_){const Y=this.buffer.slice(this.pos,this.pos+_);return this.pos+=Y.byteLength,Y}}class c{constructor(){this.buffers=[]}get buffer(){return M.VSBuffer.concat(this.buffers)}write(_){this.buffers.push(_)}}var a;(function(N){N[N.Undefined=0]="Undefined",N[N.String=1]="String",N[N.Buffer=2]="Buffer",N[N.VSBuffer=3]="VSBuffer",N[N.Array=4]="Array",N[N.Object=5]="Object"})(a||(a={}));function l(N){const _=M.VSBuffer.alloc(4);return _.writeUInt32BE(N,0),_}function s(N){return N.read(4).readUInt32BE(0)}function u(N){const _=M.VSBuffer.alloc(1);return _.writeUInt8(N,0),_}const r={Undefined:u(a.Undefined),String:u(a.String),Buffer:u(a.Buffer),VSBuffer:u(a.VSBuffer),Array:u(a.Array),Object:u(a.Object)},i=typeof Buffer!="undefined";function o(N,_){if(typeof _=="undefined")N.write(r.Undefined);else if(typeof _=="string"){const Y=M.VSBuffer.fromString(_);N.write(r.String),N.write(l(Y.byteLength)),N.write(Y)}else if(i&&Buffer.isBuffer(_)){const Y=M.VSBuffer.wrap(_);N.write(r.Buffer),N.write(l(Y.byteLength)),N.write(Y)}else if(_ instanceof M.VSBuffer)N.write(r.VSBuffer),N.write(l(_.byteLength)),N.write(_);else if(Array.isArray(_)){N.write(r.Array),N.write(l(_.length));for(const Y of _)o(N,Y)}else{const Y=M.VSBuffer.fromString(JSON.stringify(_));N.write(r.Object),N.write(l(Y.byteLength)),N.write(Y)}}function h(N){switch(N.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return N.read(s(N)).toString();case a.Buffer:return N.read(s(N)).buffer;case a.VSBuffer:return N.read(s(N));case a.Array:{const Y=s(N),F=[];for(let A=0;A<Y;A++)F.push(h(N));return F}case a.Object:return JSON.parse(N.read(s(N)).toString())}}class g{constructor(_,Y,F=null,A=1e3){this.protocol=_,this.ctx=Y,this.logger=F,this.timeoutDelay=A,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(O=>this.onRawMessage(O)),this.sendResponse({type:200})}registerChannel(_,Y){this.channels.set(_,Y),setTimeout(()=>this.flushPendingRequests(_),0)}sendResponse(_){switch(_.type){case 200:{const Y=this.send([_.type]);this.logger&&this.logger.logOutgoing(Y,0,1,b(_.type));return}case 201:case 202:case 204:case 203:{const Y=this.send([_.type,_.id],_.data);this.logger&&this.logger.logOutgoing(Y,_.id,1,b(_.type),_.data);return}}}send(_,Y=void 0){const F=new c;return o(F,_),o(F,Y),this.sendBuffer(F.buffer)}sendBuffer(_){try{return this.protocol.send(_),_.byteLength}catch(Y){return 0}}onRawMessage(_){const Y=new P(_),F=h(Y),A=h(Y),O=F[0];switch(O){case 100:return this.logger&&this.logger.logIncoming(_.byteLength,F[1],1,`${t(O)}: ${F[2]}.${F[3]}`,A),this.onPromise({type:O,id:F[1],channelName:F[2],name:F[3],arg:A});case 102:return this.logger&&this.logger.logIncoming(_.byteLength,F[1],1,`${t(O)}: ${F[2]}.${F[3]}`,A),this.onEventListen({type:O,id:F[1],channelName:F[2],name:F[3],arg:A});case 101:return this.logger&&this.logger.logIncoming(_.byteLength,F[1],1,`${t(O)}`),this.disposeActiveRequest({type:O,id:F[1]});case 103:return this.logger&&this.logger.logIncoming(_.byteLength,F[1],1,`${t(O)}`),this.disposeActiveRequest({type:O,id:F[1]})}}onPromise(_){const Y=this.channels.get(_.channelName);if(!Y){this.collectPendingRequest(_);return}const F=new C.CancellationTokenSource;let A;try{A=Y.call(this.ctx,_.name,_.arg,F.token)}catch(X){A=Promise.reject(X)}const O=_.id;A.then(X=>{this.sendResponse({id:O,data:X,type:201}),this.activeRequests.delete(_.id)},X=>{X instanceof Error?this.sendResponse({id:O,data:{message:X.message,name:X.name,stack:X.stack?X.stack.split?X.stack.split(`
`):X.stack:void 0},type:202}):this.sendResponse({id:O,data:X,type:203}),this.activeRequests.delete(_.id)});const $=(0,f.toDisposable)(()=>F.cancel());this.activeRequests.set(_.id,$)}onEventListen(_){const Y=this.channels.get(_.channelName);if(!Y){this.collectPendingRequest(_);return}const F=_.id,O=Y.listen(this.ctx,_.name,_.arg)($=>this.sendResponse({id:F,data:$,type:204}));this.activeRequests.set(_.id,O)}disposeActiveRequest(_){const Y=this.activeRequests.get(_.id);Y&&(Y.dispose(),this.activeRequests.delete(_.id))}collectPendingRequest(_){let Y=this.pendingRequests.get(_.channelName);Y||(Y=[],this.pendingRequests.set(_.channelName,Y));const F=setTimeout(()=>{console.error(`Unknown channel: ${_.channelName}`),_.type===100&&this.sendResponse({id:_.id,data:{name:"Unknown channel",message:`Channel name '${_.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);Y.push({request:_,timeoutTimer:F})}flushPendingRequests(_){const Y=this.pendingRequests.get(_);if(Y){for(const F of Y)switch(clearTimeout(F.timeoutTimer),F.request.type){case 100:this.onPromise(F.request);break;case 102:this.onEventListen(F.request);break}this.pendingRequests.delete(_)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(_=>_.dispose()),this.activeRequests.clear()}}e.ChannelServer=g;var k;(function(N){N[N.LocalSide=0]="LocalSide",N[N.OtherSide=1]="OtherSide"})(k=e.RequestInitiator||(e.RequestInitiator={}));class L{constructor(_,Y=null){this.protocol=_,this.isDisposed=!1,this.state=S.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new d.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(F=>this.onBuffer(F)),this.logger=Y}getChannel(_){const Y=this;return{call(F,A,O){return Y.isDisposed?Promise.reject(I.canceled()):Y.requestPromise(_,F,A,O)},listen(F,A){return Y.isDisposed?Promise.reject(I.canceled()):Y.requestEvent(_,F,A)}}}requestPromise(_,Y,F,A=C.CancellationToken.None){const O=this.lastRequestId++,X={id:O,type:100,channelName:_,name:Y,arg:F};if(A.isCancellationRequested)return Promise.reject(I.canceled());let V;return new Promise((Z,te)=>{if(A.isCancellationRequested)return te(I.canceled());const ce=()=>{const ue=de=>{switch(de.type){case 201:this.handlers.delete(O),Z(de.data);break;case 202:this.handlers.delete(O);const ve=new Error(de.data.message);ve.stack=de.data.stack,ve.name=de.data.name,te(ve);break;case 203:this.handlers.delete(O),te(de.data);break}};this.handlers.set(O,ue),this.sendRequest(X)};let se=null;this.state===S.Idle?ce():(se=(0,D.createCancelablePromise)(ue=>this.whenInitialized()),se.then(()=>{se=null,ce()}));const ie=()=>{se?(se.cancel(),se=null):this.sendRequest({id:O,type:101}),te(I.canceled())},ae=A.onCancellationRequested(ie);V=(0,f.combinedDisposable)((0,f.toDisposable)(ie),ae),this.activeRequests.add(V)}).finally(()=>{this.activeRequests.delete(V)})}requestEvent(_,Y,F){const A=this.lastRequestId++,$={id:A,type:102,channelName:_,name:Y,arg:F};let X=null;const V=new d.Emitter({onFirstListenerAdd:()=>{X=(0,D.createCancelablePromise)(Z=>this.whenInitialized()),X.then(()=>{X=null,this.activeRequests.add(V),this.sendRequest($)})},onLastListenerRemove:()=>{X?(X.cancel(),X=null):(this.activeRequests.delete(V),this.sendRequest({id:A,type:103}))}}),z=Z=>V.fire(Z.data);return this.handlers.set(A,z),V.event}sendRequest(_){switch(_.type){case 100:case 102:{const Y=this.send([_.type,_.id,_.channelName,_.name],_.arg);this.logger&&this.logger.logOutgoing(Y,_.id,0,`${t(_.type)}: ${_.channelName}.${_.name}`,_.arg);return}case 101:case 103:{const Y=this.send([_.type,_.id]);this.logger&&this.logger.logOutgoing(Y,_.id,0,t(_.type));return}}}send(_,Y=void 0){const F=new c;return o(F,_),o(F,Y),this.sendBuffer(F.buffer)}sendBuffer(_){try{return this.protocol.send(_),_.byteLength}catch(Y){return 0}}onBuffer(_){const Y=new P(_),F=h(Y),A=h(Y),O=F[0];switch(O){case 200:return this.logger&&this.logger.logIncoming(_.byteLength,0,0,b(O)),this.onResponse({type:F[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(_.byteLength,F[1],0,b(O),A),this.onResponse({type:F[0],id:F[1],data:A})}}onResponse(_){if(_.type===200){this.state=S.Idle,this._onDidInitialize.fire();return}const Y=this.handlers.get(_.id);Y&&Y(_)}get onDidInitializePromise(){return d.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===S.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(_=>_.dispose()),this.activeRequests.clear()}}he([n.memoize],L.prototype,"onDidInitializePromise",null),e.ChannelClient=L;class R{constructor(_){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new d.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new d.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,_(({protocol:Y,onDidClientDisconnect:F})=>{d.Event.once(Y.onMessage)(O=>{const $=new P(O),X=h($),V=new g(Y,X),z=new L(Y);this.channels.forEach((te,ce)=>V.registerChannel(ce,te));const Z={channelServer:V,channelClient:z,ctx:X};this._connections.add(Z),this._onDidAddConnection.fire(Z),F(()=>{V.dispose(),z.dispose(),this._connections.delete(Z),this._onDidRemoveConnection.fire(Z)})})})}get connections(){const _=[];return this._connections.forEach(Y=>_.push(Y)),_}getChannel(_,Y){const F=this;return{call(A,O,$){let X;if((0,m.isFunction)(Y)){let z=(0,v.getRandomElement)(F.connections.filter(Y));X=z?Promise.resolve(z):d.Event.toPromise(d.Event.filter(F.onDidAddConnection,Y))}else X=Y.routeCall(F,A,O);const V=X.then(z=>z.channelClient.getChannel(_));return j(V).call(A,O,$)},listen(A,O){if((0,m.isFunction)(Y))return F.getMulticastEvent(_,Y,A,O);const $=Y.routeEvent(F,A,O).then(X=>X.channelClient.getChannel(_));return j($).listen(A,O)}}}getMulticastEvent(_,Y,F,A){const O=this;let $=new f.DisposableStore;const X=new d.Emitter({onFirstListenerAdd:()=>{$=new f.DisposableStore;const V=new d.EventMultiplexer,z=new Map,Z=ce=>{const ie=ce.channelClient.getChannel(_).listen(F,A),ae=V.add(ie);z.set(ce,ae)},te=ce=>{const se=z.get(ce);!se||(se.dispose(),z.delete(ce))};O.connections.filter(Y).forEach(Z),d.Event.filter(O.onDidAddConnection,Y)(Z,void 0,$),O.onDidRemoveConnection(te,void 0,$),V.event(X.fire,X,$),$.add(V)},onLastListenerRemove:()=>{$.dispose()}});return X.event}registerChannel(_,Y){this.channels.set(_,Y),this._connections.forEach(F=>{F.channelServer.registerChannel(_,Y)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=R;class W{constructor(_,Y,F=null){const A=new c;o(A,Y),_.send(A.buffer),this.channelClient=new L(_,F),this.channelServer=new g(_,Y,F)}getChannel(_){return this.channelClient.getChannel(_)}registerChannel(_,Y){this.channelServer.registerChannel(_,Y)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=W;function j(N){return{call(_,Y,F){return N.then(A=>A.call(_,Y,F))},listen(_,Y){const F=new d.Relay;return N.then(A=>F.input=A.listen(_,Y)),F.event}}}e.getDelayedChannel=j;function x(N){let _=!1;return{call(Y,F,A){return _?N.call(Y,F,A):(0,D.timeout)(0).then(()=>_=!0).then(()=>N.call(Y,F,A))},listen(Y,F){if(_)return N.listen(Y,F);const A=new d.Relay;return(0,D.timeout)(0).then(()=>_=!0).then(()=>A.input=N.listen(Y,F)),A.event}}}e.getNextTickChannel=x;class ne{constructor(_){this.fn=_}routeCall(_){return this.route(_)}routeEvent(_){return this.route(_)}async route(_){for(const Y of _.connections)if(await Promise.resolve(this.fn(Y.ctx)))return Promise.resolve(Y);return await d.Event.toPromise(_.onDidAddConnection),await this.route(_)}}e.StaticRouter=ne;var oe;(function(N){function _(O,$){const X=O,V=$&&$.disableMarshalling,z=new Map;for(const Z in X)F(Z)&&z.set(Z,d.Event.buffer(X[Z],!0));return new class{listen(Z,te,ce){const se=z.get(te);if(se)return se;if(A(te)){const ie=X[te];if(typeof ie=="function")return ie.call(X,ce)}throw new Error(`Event not found: ${te}`)}call(Z,te,ce){const se=X[te];if(typeof se=="function"){if(!V&&Array.isArray(ce))for(let ie=0;ie<ce.length;ie++)ce[ie]=(0,y.revive)(ce[ie]);return se.apply(X,ce)}throw new Error(`Method not found: ${te}`)}}}N.fromService=_;function Y(O,$){const X=$&&$.disableMarshalling;return new Proxy({},{get(V,z){if(typeof z=="string")return $?.properties?.has(z)?$.properties.get(z):A(z)?function(Z){return O.listen(z,Z)}:F(z)?O.listen(z):async function(...Z){let te;$&&!(0,m.isUndefinedOrNull)($.context)?te=[$.context,...Z]:te=Z;const ce=await O.call(z,te);return X?ce:(0,y.revive)(ce)};throw new Error(`Property not found: ${String(z)}`)}})}N.toService=Y;function F(O){return O[0]==="o"&&O[1]==="n"&&E.isUpperAsciiLetter(O.charCodeAt(2))}function A(O){return/^onDynamic/.test(O)&&E.isUpperAsciiLetter(O.charCodeAt(9))}})(oe=e.ProxyChannel||(e.ProxyChannel={}));const G=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function T(N){if(Array.isArray(N))return N;if(N&&typeof N=="object"&&typeof N.toString=="function"){let _=N.toString();if(_!=="[object Object]")return _}return N}function B(N){return Array.isArray(N)?N.map(T):T(N)}function q(N,_,Y,F,A,O,$){$=B($);const X=G[A],V=X[F%X.length];let z=[`%c[${N}]%c[${String(_).padStart(7," ")}]%c[len: ${String(Y).padStart(5," ")}]%c${String(F).padStart(5," ")} - ${O}`,"color: darkgreen","color: grey","color: grey",`color: ${V}`];/\($/.test(O)?(z=z.concat($),z.push(")")):z.push($),console.log.apply(console,z)}e.logWithColors=q;class U{constructor(_,Y){this._outgoingPrefix=_,this._incomingPrefix=Y,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(_,Y,F,A,O){this._totalOutgoing+=_,q(this._outgoingPrefix,this._totalOutgoing,_,Y,F,A,O)}logIncoming(_,Y,F,A,O){this._totalIncoming+=_,q(this._incomingPrefix,this._totalIncoming,_,Y,F,A,O)}}e.IPCLogger=U}),define(Q[123],J([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class v{constructor(M,C){this.sender=M,this.onMessage=C}send(M){try{this.sender.send("vscode:message",M.buffer)}catch(C){}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=v}),define(Q[124],J([0,1,17,4,35]),function(H,e,v,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class C{constructor(d){this.port=d,this.onMessage=D.Event.fromDOMEventEmitter(this.port,"message",f=>v.VSBuffer.wrap(f.data)),d.start()}send(d){this.port.postMessage(d.buffer)}disconnect(){this.port.close()}}e.Protocol=C;class n extends M.IPCClient{constructor(d,f){const y=new C(d);super(y,f);this.protocol=y}dispose(){this.protocol.disconnect()}}e.Client=n}),define(Q[84],J([0,1,17,4,2,3,32,35]),function(H,e,v,D,M,C,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var d;(function(r){r[r.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",r[r.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(d=e.SocketCloseEventType||(e.SocketCloseEventType={}));let f=null;function y(){return f||(f=v.VSBuffer.alloc(0)),f}class E{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(i){this._chunks.push(i),this._totalLength+=i.byteLength}read(i){return this._read(i,!0)}peek(i){return this._read(i,!1)}_read(i,o){if(i===0)return y();if(i>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===i){const L=this._chunks[0];return o&&(this._chunks.shift(),this._totalLength-=i),L}if(this._chunks[0].byteLength>i){const L=this._chunks[0].slice(0,i);return o&&(this._chunks[0]=this._chunks[0].slice(i),this._totalLength-=i),L}let h=v.VSBuffer.alloc(i),g=0,k=0;for(;i>0;){const L=this._chunks[k];if(L.byteLength>i){const R=L.slice(0,i);h.set(R,g),g+=i,o&&(this._chunks[k]=L.slice(i),this._totalLength-=i),i-=i}else h.set(L,g),g+=L.byteLength,o?(this._chunks.shift(),this._totalLength-=L.byteLength):k++,i-=L.byteLength}return h}}e.ChunkStream=E;var m;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.KeepAlive=4]="KeepAlive",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest"})(m||(m={}));var p;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",r[r.KeepAliveTime=5e3]="KeepAliveTime",r[r.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(p=e.ProtocolConstants||(e.ProtocolConstants={}));class t{constructor(i,o,h,g){this.type=i,this.id=o,this.ack=h,this.data=g,this.writtenTime=0}get size(){return this.data.byteLength}}class w extends M.Disposable{constructor(i){super();this._onMessage=this._register(new D.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=i,this._isDisposed=!1,this._incomingData=new E,this._register(this._socket.onData(o=>this.acceptChunk(o))),this.lastReadTime=Date.now()}acceptChunk(i){if(!(!i||i.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(i);this._incomingData.byteLength>=this._state.readLen;){const o=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=o.readUInt32BE(9),this._state.messageType=o.readUInt8(0),this._state.id=o.readUInt32BE(1),this._state.ack=o.readUInt32BE(5);else{const h=this._state.messageType,g=this._state.id,k=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new t(h,g,k,o)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class b{constructor(i){this._isDisposed=!1,this._socket=i,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(i){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(i){if(this._isDisposed)return;i.writtenTime=Date.now(),this.lastWriteTime=Date.now();const o=v.VSBuffer.alloc(13);o.writeUInt8(i.type,0),o.writeUInt32BE(i.id,1),o.writeUInt32BE(i.ack,5),o.writeUInt32BE(i.data.byteLength,9),this._writeSoon(o,i.data)}_bufferAdd(i,o){const h=this._totalLength===0;return this._data.push(i,o),this._totalLength+=i.byteLength+o.byteLength,h}_bufferTake(){const i=v.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,i}_writeSoon(i,o){this._bufferAdd(i,o)&&C.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class S extends M.Disposable{constructor(i){super();this._onMessage=new D.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new D.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=i,this._socketWriter=this._register(new b(this._socket)),this._socketReader=this._register(new w(this._socket)),this._register(this._socketReader.onMessage(o=>{o.type===1&&this._onMessage.fire(o.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(i){this._socketWriter.write(new t(1,0,0,i))}}e.Protocol=S;class P extends I.IPCClient{constructor(i,o,h=null){super(i,o,h);this.protocol=i}static fromSocket(i,o){return new P(new S(i),o)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const i=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),i.end()}}e.Client=P;class c{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new D.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,n.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(i){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(i):this._emitter.fire(i):this._bufferedMessages.push(i)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=c;class a{constructor(i){this.data=i,this.next=null}}class l{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let i=[],o=0,h=this._first;for(;h;)i[o++]=h.data,h=h.next;return i}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(i){const o=new a(i);if(!this._first){this._first=o,this._last=o;return}this._last.next=o,this._last=o}}class s{constructor(){this.lastRuns=[];const i=Date.now();for(let o=0;o<s._HISTORY_LENGTH;o++)this.lastRuns[o]=i-1e3*o;setInterval(()=>{for(let o=s._HISTORY_LENGTH;o>=1;o--)this.lastRuns[o]=this.lastRuns[o-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return s._INSTANCE||(s._INSTANCE=new s),s._INSTANCE}load(){const i=Date.now(),o=(1+s._HISTORY_LENGTH)*1e3;let h=0;for(let g=0;g<s._HISTORY_LENGTH;g++)i-this.lastRuns[g]<=o&&h++;return 1-h/s._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}s._HISTORY_LENGTH=10,s._INSTANCE=null;class u{constructor(i,o=null,h=s.getInstance()){this._onControlMessage=new c,this.onControlMessage=this._onControlMessage.event,this._onMessage=new c,this.onMessage=this._onMessage.event,this._onDidDispose=new c,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new c,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new c,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=h,this._isReconnecting=!1,this._outgoingUnackMsg=new l,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=i,this._socketWriter=new b(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new w(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(g=>this._receiveMessage(g))),this._socketDisposables.push(this._socket.onClose(g=>this._onSocketClose.fire(g))),o&&this._socketReader.acceptChunk(o),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,M.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const i=new t(5,0,0,y());this._socketWriter.write(i),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const i=Date.now()-this._socketWriter.lastWriteTime;if(i>=5e3){const o=new t(4,0,0,y());this._socketWriter.write(o),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-i+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const i=Date.now()-this._socketReader.lastReadTime;if(i>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-i,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(i,o){this._isReconnecting=!0,this._socketDisposables=(0,M.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=i,this._socketWriter=new b(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new w(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(h=>this._receiveMessage(h))),this._socketDisposables.push(this._socket.onClose(h=>this._onSocketClose.fire(h))),this._socketReader.acceptChunk(o)}endAcceptReconnection(){this._isReconnecting=!1;const i=this._outgoingUnackMsg.toArray();for(let o=0,h=i.length;o<h;o++)this._socketWriter.write(i[o]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(i){if(i.ack>this._outgoingAckId){this._outgoingAckId=i.ack;do{const o=this._outgoingUnackMsg.peek();if(o&&o.id<=i.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(i.type===1){if(i.id>this._incomingMsgId)if(i.id!==this._incomingMsgId+1){const o=Date.now();o-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=o,this._socketWriter.write(new t(6,0,0,y())))}else this._incomingMsgId=i.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(i.data)}else if(i.type===2)this._onControlMessage.fire(i.data);else if(i.type===5)this._onDidDispose.fire();else if(i.type===6){const o=this._outgoingUnackMsg.toArray();for(let h=0,g=o.length;h<g;h++)this._socketWriter.write(o[h]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(i){const o=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const h=new t(1,o,this._incomingAckId,i);this._outgoingUnackMsg.push(h),this._isReconnecting||(this._socketWriter.write(h),this._recvAckCheck())}sendControl(i){const o=new t(2,0,0,i);this._socketWriter.write(o)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const i=Date.now()-this._incomingMsgLastTime;if(i>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-i+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const i=this._outgoingUnackMsg.peek(),o=Date.now()-i.writtenTime;if(o>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-o,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const i=new t(3,0,this._incomingAckId,y());this._socketWriter.write(i)}}e.PersistentProtocol=u}),define(Q[125],J([0,1,14,17,4,2,35,123]),function(H,e,v,D,M,C,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function d(y,E){const m=M.Event.fromNodeEventEmitter(v.ipcMain,E,(t,w)=>({event:t,message:w})),p=M.Event.filter(m,({event:t})=>t.sender.id===y);return M.Event.map(p,({message:t})=>t&&D.VSBuffer.wrap(t))}class f extends n.IPCServer{constructor(){super(f.getOnDidClientConnect())}static getOnDidClientConnect(){const E=M.Event.fromNodeEventEmitter(v.ipcMain,"vscode:hello",({sender:m})=>m);return M.Event.map(E,m=>{const p=m.id,t=f.Clients.get(p);t&&t.dispose();const w=new M.Emitter;f.Clients.set(p,(0,C.toDisposable)(()=>w.fire()));const b=d(p,"vscode:message"),S=M.Event.any(M.Event.signal(d(p,"vscode:disconnect")),w.event);return{protocol:new I.Protocol(m,b),onDidClientDisconnect:S}})}}e.Server=f,f.Clients=new Map}),define(Q[85],J([0,1,14,4,31,124]),function(H,e,v,D,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class n extends C.Client{constructor(f,y){super({addEventListener:(E,m)=>f.addListener(E,m),removeEventListener:(E,m)=>f.removeListener(E,m),postMessage:E=>f.postMessage(E),start:()=>f.start(),close:()=>f.close()},y)}}e.Client=n;async function I(d){if(d.isDestroyed()||d.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const f=(0,M.generateUuid)();d.webContents.send("vscode:createMessageChannel",f);const y=D.Event.fromNodeEventEmitter(v.ipcMain,"vscode:createMessageChannelResult",(m,p)=>({nonce:p,port:m.ports[0]})),{port:E}=await D.Event.toPromise(D.Event.once(D.Event.filter(y,m=>m.nonce===f)));return E}e.connect=I}),define(Q[86],J([0,1,9,4,2,13]),function(H,e,v,D,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var n;(function(E){E[E.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(n=e.StorageHint||(e.StorageHint={}));function I(E){const m=E;return m?.changed instanceof Map||m?.deleted instanceof Set}e.isStorageItemsChangeEvent=I;var d;(function(E){E[E.None=0]="None",E[E.Initialized=1]="Initialized",E[E.Closed=2]="Closed"})(d||(d={}));class f extends M.Disposable{constructor(m,p=Object.create(null)){super();this.database=m,this.options=p,this._onDidChangeStorage=this._register(new D.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=d.None,this.cache=new Map,this.flushDelayer=new v.ThrottledDelayer(f.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(m=>this.onDidChangeItemsExternal(m)))}onDidChangeItemsExternal(m){m.changed?.forEach((p,t)=>this.accept(t,p)),m.deleted?.forEach(p=>this.accept(p,void 0))}accept(m,p){if(this.state===d.Closed)return;let t=!1;(0,C.isUndefinedOrNull)(p)?t=this.cache.delete(m):this.cache.get(m)!==p&&(this.cache.set(m,p),t=!0),t&&this._onDidChangeStorage.fire(m)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===d.None&&(this.state=d.Initialized,this.options.hint!==n.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(m,p){const t=this.cache.get(m);return(0,C.isUndefinedOrNull)(t)?p:t}getBoolean(m,p){const t=this.get(m);return(0,C.isUndefinedOrNull)(t)?p:t==="true"}getNumber(m,p){const t=this.get(m);return(0,C.isUndefinedOrNull)(t)?p:parseInt(t,10)}async set(m,p){if(this.state===d.Closed)return;if((0,C.isUndefinedOrNull)(p))return this.delete(m);const t=String(p);if(this.cache.get(m)!==t)return this.cache.set(m,t),this.pendingInserts.set(m,t),this.pendingDeletes.delete(m),this._onDidChangeStorage.fire(m),this.doFlush()}async delete(m){if(!(this.state===d.Closed||!this.cache.delete(m)))return this.pendingDeletes.has(m)||this.pendingDeletes.add(m),this.pendingInserts.delete(m),this._onDidChangeStorage.fire(m),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=d.Closed;try{await this.doFlush(0)}catch(m){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const m={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(m).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(m){if(!!this.hasPending)return this.doFlush(m)}async doFlush(m){return this.flushDelayer.trigger(()=>this.flushPending(),m)}async whenFlushed(){if(!!this.hasPending)return new Promise(m=>this.whenFlushedCallbacks.push(m))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=f,f.DEFAULT_FLUSH_DELAY=100;class y{constructor(){this.onDidChangeItemsExternal=D.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(m){m.insert&&m.insert.forEach((p,t)=>this.items.set(t,p)),m.delete&&m.delete.forEach(p=>this.items.delete(p))}async close(){}}e.InMemoryStorageDatabase=y}),define(Q[126],J([0,1,9,4,40,8,21]),function(H,e,v,D,M,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class I{constructor(y,E=Object.create(null)){this.path=y,this.options=E,this.name=(0,C.basename)(this.path),this.logger=new d(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return D.Event.None}async getItems(){const y=await this.whenConnected,E=new Map;return(await this.all(y,"SELECT * FROM ItemTable")).forEach(p=>E.set(p.key,p.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${E.size} rows`),E}async updateItems(y){const E=await this.whenConnected;return this.doUpdateItems(E,y)}doUpdateItems(y,E){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${E.insert?(0,M.mapToString)(E.insert):"0"}), delete(${E.delete?(0,M.setToString)(E.delete):"0"})`),this.transaction(y,()=>{const m=E.insert,p=E.delete;if(m&&m.size>0){const t=[];t.push([]);let w=0;m.forEach((b,S)=>{let P=t[w];P.length>I.MAX_HOST_PARAMETERS&&(w++,P=[],t.push(P)),P.push(S,b)}),t.forEach(b=>{this.prepare(y,`INSERT INTO ItemTable VALUES ${new Array(b.length/2).fill("(?,?)").join(",")}`,S=>S.run(b),()=>{const S=[];let P=0;return m.forEach((c,a)=>{S.push(a),P+=c.length}),`Keys: ${S.join(", ")} Length: ${P}`})})}if(p&&p.size){const t=[];t.push([]);let w=0;p.forEach(b=>{let S=t[w];S.length>I.MAX_HOST_PARAMETERS&&(w++,S=[],t.push(S)),S.push(b)}),t.forEach(b=>{this.prepare(y,`DELETE FROM ItemTable WHERE key IN (${new Array(b.length).fill("?").join(",")})`,S=>S.run(b),()=>{const S=[];return p.forEach(P=>{S.push(P)}),`Keys: ${S.join(", ")}`})})}})}async close(y){this.logger.trace(`[storage ${this.name}] close()`);const E=await this.whenConnected;return this.doClose(E,y)}doClose(y,E){return new Promise((m,p)=>{y.db.close(t=>(t&&this.handleSQLiteError(y,`[storage ${this.name}] close(): ${t}`),this.path===I.IN_MEMORY_PATH?m():!y.isErroneous&&!y.isInMemory?this.backup().then(m,w=>(this.logger.error(`[storage ${this.name}] backup(): ${w}`),m())):typeof E=="function"?n.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(w=>{const b=()=>this.doClose(w,void 0);return this.doUpdateItems(w,{insert:E()}).then(()=>b(),S=>(b(),Promise.reject(S)))})).then(m,p):p(t||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const y=this.toBackupPath(this.path);return n.Promises.copy(this.path,y,{preserveSymlinks:!1})}toBackupPath(y){return`${y}.backup`}async checkIntegrity(y){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${y})`);const E=await this.whenConnected,m=await this.get(E,y?"PRAGMA integrity_check":"PRAGMA quick_check"),p=y?m.integrity_check:m.quick_check;return E.isErroneous?`${p} (last error: ${E.lastError})`:E.isInMemory?`${p} (in-memory!)`:p}async connect(y,E=!0){this.logger.trace(`[storage ${this.name}] open(${y}, retryOnBusy: ${E})`);try{return await this.doConnect(y)}catch(m){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${m}`),m.code==="SQLITE_BUSY"&&E)return await(0,v.timeout)(I.BUSY_OPEN_TIMEOUT),this.connect(y,!1);try{await n.Promises.unlink(y);try{await n.Promises.rename(this.toBackupPath(y),y)}catch(p){}return await this.doConnect(y)}catch(p){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${p}`),this.doConnect(I.IN_MEMORY_PATH)}}}handleSQLiteError(y,E){y.isErroneous=!0,y.lastError=E,this.logger.error(E)}doConnect(y){return new Promise((E,m)=>{new Promise((p,t)=>{H(["@vscode/sqlite3"],p,t)}).then(p=>{const t={db:new(this.logger.isTracing?p.verbose().Database:p.Database)(y,w=>w?t.db?t.db.close(()=>m(w)):m(w):this.exec(t,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>E(t),b=>t.db.close(()=>m(b)))),isInMemory:y===I.IN_MEMORY_PATH};t.db.on("error",w=>this.handleSQLiteError(t,`[storage ${this.name}] Error (event): ${w}`)),this.logger.isTracing&&t.db.on("trace",w=>this.logger.trace(`[storage ${this.name}] Trace (event): ${w}`))},m)})}exec(y,E){return new Promise((m,p)=>{y.db.exec(E,t=>t?(this.handleSQLiteError(y,`[storage ${this.name}] exec(): ${t}`),p(t)):m())})}get(y,E){return new Promise((m,p)=>{y.db.get(E,(t,w)=>t?(this.handleSQLiteError(y,`[storage ${this.name}] get(): ${t}`),p(t)):m(w))})}all(y,E){return new Promise((m,p)=>{y.db.all(E,(t,w)=>t?(this.handleSQLiteError(y,`[storage ${this.name}] all(): ${t}`),p(t)):m(w))})}transaction(y,E){return new Promise((m,p)=>{y.db.serialize(()=>{y.db.run("BEGIN TRANSACTION"),E(),y.db.run("END TRANSACTION",t=>t?(this.handleSQLiteError(y,`[storage ${this.name}] transaction(): ${t}`),p(t)):m())})})}prepare(y,E,m,p){const t=y.db.prepare(E),w=b=>{this.handleSQLiteError(y,`[storage ${this.name}] prepare(): ${b} (${E}). Details: ${p()}`)};t.on("error",w),m(t),t.finalize(b=>{b&&w(b),t.removeListener("error",w)})}}e.SQLiteStorageDatabase=I,I.IN_MEMORY_PATH=":memory:",I.BUSY_OPEN_TIMEOUT=2e3,I.MAX_HOST_PARAMETERS=256;class d{constructor(y){y&&typeof y.logTrace=="function"&&process.env[d.VSCODE_TRACE_STORAGE]&&(this.logTrace=y.logTrace),y&&typeof y.logError=="function"&&(this.logError=y.logError)}get isTracing(){return!!this.logTrace}trace(y){this.logTrace&&this.logTrace(y)}error(y){this.logError&&this.logError(y)}}d.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(Q[127],J([12,11]),function(H,e){return H.create("vs/base/common/date",e)}),define(Q[128],J([0,1,127]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const D=60,M=D*60,C=M*24,n=C*7,I=C*30,d=C*365;function f(E,m){typeof E!="number"&&(E=E.getTime());const p=Math.round((new Date().getTime()-E)/1e3);if(p<-30)return(0,v.localize)(0,null,f(new Date().getTime()+p*1e3,!1));if(p<30)return(0,v.localize)(1,null);let t;return p<D?(t=p,m?t===1?(0,v.localize)(2,null,t):(0,v.localize)(3,null,t):t===1?(0,v.localize)(4,null,t):(0,v.localize)(5,null,t)):p<M?(t=Math.floor(p/D),m?t===1?(0,v.localize)(6,null,t):(0,v.localize)(7,null,t):t===1?(0,v.localize)(8,null,t):(0,v.localize)(9,null,t)):p<C?(t=Math.floor(p/M),m?t===1?(0,v.localize)(10,null,t):(0,v.localize)(11,null,t):t===1?(0,v.localize)(12,null,t):(0,v.localize)(13,null,t)):p<n?(t=Math.floor(p/C),m?t===1?(0,v.localize)(14,null,t):(0,v.localize)(15,null,t):t===1?(0,v.localize)(16,null,t):(0,v.localize)(17,null,t)):p<I?(t=Math.floor(p/n),m?t===1?(0,v.localize)(18,null,t):(0,v.localize)(19,null,t):t===1?(0,v.localize)(20,null,t):(0,v.localize)(21,null,t)):p<d?(t=Math.floor(p/I),m?t===1?(0,v.localize)(22,null,t):(0,v.localize)(23,null,t):t===1?(0,v.localize)(24,null,t):(0,v.localize)(25,null,t)):(t=Math.floor(p/d),m?t===1?(0,v.localize)(26,null,t):(0,v.localize)(27,null,t):t===1?(0,v.localize)(28,null,t):(0,v.localize)(29,null,t))}e.fromNow=f;function y(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=y}),define(Q[129],J([12,11]),function(H,e){return H.create("vs/base/common/errorMessage",e)}),define(Q[44],J([0,1,30,13,129]),function(H,e,v,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function C(f,y){return y&&(f.stack||f.stacktrace)?M.localize(0,null,I(f),n(f.stack)||n(f.stacktrace)):I(f)}function n(f){return Array.isArray(f)?f.join(`
`):f}function I(f){return typeof f.code=="string"&&typeof f.errno=="number"&&typeof f.syscall=="string"?M.localize(1,null,f.message):f.message||M.localize(2,null)}function d(f=null,y=!1){if(!f)return M.localize(3,null);if(Array.isArray(f)){const E=v.coalesce(f),m=d(E[0],y);return E.length>1?M.localize(4,null,m,E.length):m}if(D.isString(f))return f;if(f.detail){const E=f.detail;if(E.error)return C(E.error,y);if(E.exception)return C(E.exception,y)}return f.stack?C(f,y):f.message?f.message:M.localize(5,null)}e.toErrorMessage=d}),define(Q[130],J([12,11]),function(H,e){return H.create("vs/base/common/keybindingLabels",e)}),define(Q[131],J([0,1,130]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserSettingsLabelProvider=e.ElectronAcceleratorLabelProvider=e.AriaLabelProvider=e.UILabelProvider=e.ModifierLabelProvider=void 0;class D{constructor(n,I,d=I){this.modifierLabels=[null],this.modifierLabels[2]=n,this.modifierLabels[1]=I,this.modifierLabels[3]=d}toLabel(n,I,d){if(I.length===0)return null;const f=[];for(let y=0,E=I.length;y<E;y++){const m=I[y],p=d(m);if(p===null)return null;f[y]=M(m,p,this.modifierLabels[n])}return f.join(" ")}}e.ModifierLabelProvider=D,e.UILabelProvider=new D({ctrlKey:"\u2303",shiftKey:"\u21E7",altKey:"\u2325",metaKey:"\u2318",separator:""},{ctrlKey:v.localize(0,null),shiftKey:v.localize(1,null),altKey:v.localize(2,null),metaKey:v.localize(3,null),separator:"+"},{ctrlKey:v.localize(4,null),shiftKey:v.localize(5,null),altKey:v.localize(6,null),metaKey:v.localize(7,null),separator:"+"}),e.AriaLabelProvider=new D({ctrlKey:v.localize(8,null),shiftKey:v.localize(9,null),altKey:v.localize(10,null),metaKey:v.localize(11,null),separator:"+"},{ctrlKey:v.localize(12,null),shiftKey:v.localize(13,null),altKey:v.localize(14,null),metaKey:v.localize(15,null),separator:"+"},{ctrlKey:v.localize(16,null),shiftKey:v.localize(17,null),altKey:v.localize(18,null),metaKey:v.localize(19,null),separator:"+"}),e.ElectronAcceleratorLabelProvider=new D({ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Cmd",separator:"+"},{ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Super",separator:"+"}),e.UserSettingsLabelProvider=new D({ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"cmd",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"win",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"meta",separator:"+"});function M(C,n,I){if(n===null)return"";const d=[];return C.ctrlKey&&d.push(I.ctrlKey),C.shiftKey&&d.push(I.shiftKey),C.altKey&&d.push(I.altKey),C.metaKey&&d.push(I.metaKey),n!==""&&d.push(n),d.join(I.separator)}}),define(Q[132],J([12,11]),function(H,e){return H.create("vs/base/node/processes",e)}),define(Q[72],J([0,1,43,33,10,47,8,3,32,80,13,115,21,132]),function(H,e,v,D,M,C,n,I,d,f,y,E,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return f.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return f.TerminateResponseCode}});function t(s){switch(s){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function w(s,u){if(I.isWindows)try{const r={stdio:["pipe","pipe","ignore"]};u&&(r.cwd=u);const i=v.execFile("taskkill",["/T","/F","/PID",s.pid.toString()],r);return new Promise(o=>{i.once("error",h=>{o({success:!1,error:h})}),i.once("exit",(h,g)=>{o(h===0?{success:!0}:{success:!1,code:h!==null?h:1})})})}catch(r){return Promise.resolve({success:!1,error:r,code:r.status?t(r.status):1})}else if(I.isLinux||I.isMacintosh)try{const r=M.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",H).fsPath;return new Promise(i=>{v.execFile(r,[s.pid.toString()],{encoding:"utf8",shell:!0},(o,h,g)=>{i(o?{success:!1,error:o}:{success:!0})})})}catch(r){return Promise.resolve({success:!1,error:r})}else s.kill("SIGKILL");return Promise.resolve({success:!0})}function b(s){!s||(delete s.DEBUG,I.isMacintosh&&delete s.DYLD_LIBRARY_PATH,I.isLinux&&delete s.LD_PRELOAD)}e.removeDangerousEnvVariables=b;function S(s=d.env){return s.comspec||"cmd.exe"}e.getWindowsShell=S;class P{constructor(u,r,i,o){if(r!==void 0&&i!==void 0&&o!==void 0)this.cmd=u,this.args=r,this.shell=i,this.options=o;else{const h=u;this.cmd=h.command,this.shell=h.isShellCommand,this.args=h.args.slice(0),this.options=h.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const h=Object.create(null);Object.keys(d.env).forEach(g=>{h[g]=d.env[g]}),Object.keys(this.options.env).forEach(g=>{h[g]=this.options.env[g]}),this.options.env=h}}getSanitizedCommand(){let u=this.cmd.toLowerCase();const r=u.lastIndexOf(n.sep);return r!==-1&&(u=u.substring(r+1)),P.WellKnowCommands[u]?u:"other"}start(u){return I.isWindows&&(this.options&&this.options.cwd&&D.isUNC(this.options.cwd)||!this.options&&D.isUNC(d.cwd()))?Promise.reject(new Error(p.localize(0,null))):this.useExec().then(r=>{let i,o;const h=new Promise((g,k)=>{i=g,o=k});if(r){let g=this.cmd;this.args&&(g=g+" "+this.args.join(" ")),this.childProcess=v.exec(g,this.options,(k,L,R)=>{this.childProcess=null;const W=k;W&&W.killed?o({killed:this.terminateRequested,stdout:L.toString(),stderr:R.toString()}):this.handleExec(i,u,k,L,R)})}else{let g=null;const k=L=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(L,i,u,o);const R={terminated:this.terminateRequested};y.isNumber(L)&&(R.cmdCode=L),i(R)};if(this.shell&&I.isWindows){const L=C.deepClone(this.options);L.windowsVerbatimArguments=!0,L.detached=!1;let R=!1,W=!1;const j=[];let x=this.ensureQuotes(this.cmd);j.push(x.value),R=x.quoted,this.args&&this.args.forEach(oe=>{x=this.ensureQuotes(oe),j.push(x.value),W=W&&x.quoted});const ne=["/s","/c"];R?W?ne.push('"'+j.join(" ")+'"'):j.length>1?ne.push('"'+j[0]+'" '+j.slice(1).join(" ")):ne.push('"'+j[0]+'"'):ne.push(j.join(" ")),g=v.spawn(S(),ne,L)}else this.cmd&&(g=v.spawn(this.cmd,this.args,this.options));g&&(this.childProcess=g,this.childProcessPromise=Promise.resolve(g),this.pidResolve&&(this.pidResolve(y.isNumber(g.pid)?g.pid:-1),this.pidResolve=void 0),g.on("error",L=>{this.childProcess=null,o({terminated:this.terminateRequested,error:L})}),g.pid&&(this.childProcess.on("close",k),this.handleSpawn(g,i,u,o,!0)))}return h})}handleClose(u,r,i,o){}ensureQuotes(u){return P.regexp.test(u)?{value:'"'+u+'"',quoted:!0}:{value:u,quoted:u.length>0&&u[0]==='"'&&u[u.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(u=>u.pid,u=>-1):new Promise(u=>{this.pidResolve=u})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(u=>(this.terminateRequested=!0,w(u,this.options.cwd).then(r=>(r.success&&(this.childProcess=null),r))),u=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(u=>{if(!this.shell||!I.isWindows)return u(!1);const r=v.spawn(S(),["/s","/c"]);r.on("error",i=>u(!0)),r.on("exit",i=>u(!1))})}}e.AbstractProcess=P,P.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},P.regexp=/^[^"].* .*[^"]/;class c extends P{constructor(u,r,i,o){super(u,r,i,o);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(u,r,i,o,h){[o,h].forEach((g,k)=>{const L=new E.LineDecoder;L.write(g).forEach(j=>{r({line:j,source:k===0?0:1})});const W=L.end();W&&r({line:W,source:k===0?0:1})}),u({terminated:this.terminateRequested,error:i})}handleSpawn(u,r,i,o,h){const g=new E.LineDecoder,k=new E.LineDecoder;u.stdout.on("data",L=>{g.write(L).forEach(W=>i({line:W,source:0}))}),u.stderr.on("data",L=>{k.write(L).forEach(W=>i({line:W,source:1}))}),this.stdoutLineDecoder=g,this.stderrLineDecoder=k}handleClose(u,r,i,o){const h=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;h&&i({line:h,source:0});const g=this.stderrLineDecoder?this.stderrLineDecoder.end():null;g&&i({line:g,source:1})}}e.LineProcess=c;function a(s){let u=[],r=!1;const i=function(o){if(r){u.push(o);return}(!s.send(o,g=>{if(g&&console.error(g),r=!1,u.length>0){const k=u.slice(0);u=[],k.forEach(L=>i(L))}})||I.isWindows)&&(r=!0)};return{send:i}}e.createQueuedSender=a;var l;(function(s){async function u(r,i,o){if(n.isAbsolute(r))return r;if(i===void 0&&(i=d.cwd()),n.dirname(r)!=="."||(o===void 0&&y.isString(d.env.PATH)&&(o=d.env.PATH.split(n.delimiter)),o===void 0||o.length===0))return n.join(i,r);async function g(k){if(await m.Promises.exists(k)){let L;try{L=await m.Promises.stat(k)}catch(R){R.message.startsWith("EACCES")&&(L=await m.Promises.lstat(k))}return L?!L.isDirectory():!1}return!1}for(let k of o){let L;if(n.isAbsolute(k)?L=n.join(k,r):L=n.join(i,k,r),await g(L))return L;let R=L+".com";if(await g(R)||(R=L+".exe",await g(R)))return R}return n.join(i,r)}s.findExecutable=u})(l=e.win32||(e.win32={}))}),define(Q[133],J([0,1,26,3,119,72]),function(H,e,v,D,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function n(p,t){return p===1?D.isWindows?E():C.getWindowsShell(t):f(p,t)}e.getSystemShell=n;function I(p,t){return p===1?D.isWindows?m(t):C.getWindowsShell(t):f(p,t)}e.getSystemShellSync=I;let d=null;function f(p,t){if(D.isLinux&&p===2||D.isMacintosh&&p===3)return"/bin/bash";if(!d){let w;if(D.isWindows)w="/bin/bash";else{if(w=t.SHELL,!w)try{w=(0,v.userInfo)().shell}catch(b){}w||(w="sh"),w==="/bin/false"&&(w="/bin/bash")}d=w}return d}let y=null;async function E(){return y||(y=(await(0,M.getFirstAvailablePowerShellInstallation)()).exePath),y}function m(p){if(y)return y;const t=D.isWindows&&parseFloat((0,v.release)())>=10,w=p.hasOwnProperty("PROCESSOR_ARCHITEW6432"),b=`${p.windir}\\${w?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return t?b:C.getWindowsShell(p)}}),define(Q[87],J([0,1,43,9,17,23,110,16,4,2,47,72,35]),function(H,e,v,D,M,C,n,I,d,f,y,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class p extends m.ChannelServer{constructor(b){super({send:S=>{try{process.send&&process.send(S.buffer.toString("base64"))}catch(P){}},onMessage:d.Event.fromNodeEventEmitter(process,"message",S=>M.VSBuffer.wrap(Buffer.from(S,"base64")))},b);process.once("disconnect",()=>this.dispose())}}e.Server=p;class t{constructor(b,S){this.modulePath=b,this.options=S,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new d.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const P=S&&S.timeout?S.timeout:6e4;this.disposeDelayer=new D.Delayer(P),this.child=null,this._client=null}getChannel(b){const S=this;return{call(P,c,a){return S.requestPromise(b,P,c,a)},listen(P,c){return S.requestEvent(b,P,c)}}}requestPromise(b,S,P,c=C.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(c.isCancellationRequested)return Promise.reject(I.canceled());this.disposeDelayer.cancel();const a=this.getCachedChannel(b),l=(0,D.createCancelablePromise)(r=>a.call(S,P,r)),s=c.onCancellationRequested(()=>l.cancel()),u=(0,f.toDisposable)(()=>l.cancel());return this.activeRequests.add(u),l.finally(()=>{s.dispose(),this.activeRequests.delete(u),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),l}requestEvent(b,S,P){if(!this.disposeDelayer)return d.Event.None;this.disposeDelayer.cancel();let c;const a=new d.Emitter({onFirstListenerAdd:()=>{c=this.getCachedChannel(b).listen(S,P)(a.fire,a),this.activeRequests.add(c)},onLastListenerRemove:()=>{this.activeRequests.delete(c),c.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return a.event}get client(){if(!this._client){const b=this.options&&this.options.args?this.options.args:[],S=Object.create(null);S.env={...(0,y.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(S.env={...S.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(S.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(S.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(S.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),S.execArgv===void 0&&(S.execArgv=process.execArgv.filter(i=>!/^--inspect(-brk)?=/.test(i))),(0,E.removeDangerousEnvVariables)(S.env),this.child=(0,v.fork)(this.modulePath,b,S);const P=new d.Emitter;d.Event.fromNodeEventEmitter(this.child,"message",i=>i)(i=>{if((0,n.isRemoteConsoleLog)(i)){(0,n.log)(i,`IPC Library: ${this.options.serverName}`);return}P.fire(M.VSBuffer.wrap(Buffer.from(i,"base64")))});const a=this.options.useQueue?(0,E.createQueuedSender)(this.child):this.child,l=i=>this.child&&this.child.connected&&a.send(i.buffer.toString("base64")),s=P.event,u={send:l,onMessage:s};this._client=new m.ChannelClient(u);const r=()=>this.disposeClient();process.once("exit",r),this.child.on("error",i=>console.warn('IPC "'+this.options.serverName+'" errored with '+i)),this.child.on("exit",(i,o)=>{process.removeListener("exit",r),this.activeRequests.forEach(h=>(0,f.dispose)(h)),this.activeRequests.clear(),i!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+i+" and signal "+o),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:i,signal:o})})}return this._client}getCachedChannel(b){let S=this.channels.get(b);return S||(S=this.client.getChannel(b),this.channels.set(b,S)),S}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=t}),define(Q[134],J([12,11]),function(H,e){return H.create("vs/code/electron-main/app",e)}),define(Q[135],J([12,11]),function(H,e){return H.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Q[136],J([12,11]),function(H,e){return H.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(Q[137],J([12,11]),function(H,e){return H.create("vs/platform/environment/node/argv",e)}),define(Q[138],J([12,11]),function(H,e){return H.create("vs/platform/environment/node/argvHelper",e)}),define(Q[139],J([12,11]),function(H,e){return H.create("vs/platform/environment/node/shellEnv",e)}),define(Q[140],J([12,11]),function(H,e){return H.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Q[141],J([12,11]),function(H,e){return H.create("vs/platform/extensions/common/extensionValidator",e)}),define(Q[142],J([12,11]),function(H,e){return H.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Q[143],J([12,11]),function(H,e){return H.create("vs/platform/files/common/fileService",e)}),define(Q[144],J([12,11]),function(H,e){return H.create("vs/platform/files/common/files",e)}),define(Q[145],J([12,11]),function(H,e){return H.create("vs/platform/files/common/io",e)}),define(Q[146],J([12,11]),function(H,e){return H.create("vs/platform/files/electron-main/diskFileSystemProviderIpc",e)}),define(Q[147],J([12,11]),function(H,e){return H.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Q[148],J([12,11]),function(H,e){return H.create("vs/platform/issue/electron-main/issueMainService",e)}),define(Q[149],J([12,11]),function(H,e){return H.create("vs/platform/menubar/electron-main/menubar",e)}),define(Q[150],J([12,11]),function(H,e){return H.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(Q[151],J([12,11]),function(H,e){return H.create("vs/platform/request/common/request",e)}),define(Q[152],J([12,11]),function(H,e){return H.create("vs/platform/telemetry/common/telemetryService",e)}),define(Q[153],J([12,11]),function(H,e){return H.create("vs/platform/update/common/update.config.contribution",e)}),define(Q[154],J([12,11]),function(H,e){return H.create("vs/platform/windows/electron-main/window",e)}),define(Q[155],J([12,11]),function(H,e){return H.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(Q[156],J([12,11]),function(H,e){return H.create("vs/platform/workspaces/common/workspaces",e)}),define(Q[157],J([12,11]),function(H,e){return H.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(Q[158],J([12,11]),function(H,e){return H.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(Q[159],J([0,1,4,2]),function(H,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class M{constructor(){this._onCloseEmitter=new v.Emitter,this._onReloadEmitter=new v.Emitter,this._onTerminateEmitter=new v.Emitter,this._onAttachEmitter=new v.Emitter}call(I,d,f){switch(d){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:f[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:f[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:f[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:f[0],port:f[1],subId:f[2]}))}throw new Error("Method not implemented.")}listen(I,d,f){switch(d){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=M,M.ChannelName="extensionhostdebugservice";class C extends D.Disposable{constructor(I){super();this.channel=I}reload(I){this.channel.call("reload",[I])}get onReload(){return this.channel.listen("reload")}close(I){this.channel.call("close",[I])}get onClose(){return this.channel.listen("close")}attachSession(I,d,f){this.channel.call("attach",[I,d,f])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(I,d){this.channel.call("terminate",[I,d])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(I,d){return this.channel.call("openExtensionDevelopmentHostWindow",[I,d])}}e.ExtensionHostDebugChannelClient=C}),define(Q[160],J([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowDriverRegistryChannelClient=e.WindowDriverChannelClient=e.WindowDriverChannel=void 0;class v{constructor(n){this.driver=n}listen(n,I){throw new Error(`No event found: ${I}`)}call(n,I,d){switch(I){case"click":return this.driver.click(d[0],d[1],d[2]);case"doubleClick":return this.driver.doubleClick(d);case"setValue":return this.driver.setValue(d[0],d[1]);case"getTitle":return this.driver.getTitle();case"isActiveElement":return this.driver.isActiveElement(d);case"getElements":return this.driver.getElements(d[0],d[1]);case"getElementXY":return this.driver.getElementXY(d[0],d[1],d[2]);case"typeInEditor":return this.driver.typeInEditor(d[0],d[1]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(d);case"writeInTerminal":return this.driver.writeInTerminal(d[0],d[1]);case"getLocaleInfo":return this.driver.getLocaleInfo();case"getLocalizedStrings":return this.driver.getLocalizedStrings()}throw new Error(`Call not found: ${I}`)}}e.WindowDriverChannel=v;class D{constructor(n){this.channel=n}click(n,I,d){return this.channel.call("click",[n,I,d])}doubleClick(n){return this.channel.call("doubleClick",n)}setValue(n,I){return this.channel.call("setValue",[n,I])}getTitle(){return this.channel.call("getTitle")}isActiveElement(n){return this.channel.call("isActiveElement",n)}getElements(n,I){return this.channel.call("getElements",[n,I])}getElementXY(n,I,d){return this.channel.call("getElementXY",[n,I,d])}typeInEditor(n,I){return this.channel.call("typeInEditor",[n,I])}getTerminalBuffer(n){return this.channel.call("getTerminalBuffer",n)}writeInTerminal(n,I){return this.channel.call("writeInTerminal",[n,I])}getLocaleInfo(){return this.channel.call("getLocaleInfo")}getLocalizedStrings(){return this.channel.call("getLocalizedStrings")}}e.WindowDriverChannelClient=D;class M{constructor(n){this.channel=n}registerWindowDriver(n){return this.channel.call("registerWindowDriver",n)}reloadWindowDriver(n){return this.channel.call("reloadWindowDriver",n)}}e.WindowDriverRegistryChannelClient=M}),define(Q[161],J([0,1,128,46,10,8,32,15,7]),function(H,e,v,D,M,C,n,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class f{constructor(w,b,S){this._args=w,this.paths=b,this.productService=S}get appRoot(){return(0,C.dirname)(M.FileAccess.asFileUri("",H).fsPath)}get userHome(){return d.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return d.URI.file((0,C.join)(this.userDataPath,"User"))}get tmpDir(){return d.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,I.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,I.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const w=(0,v.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,C.join)(this.userDataPath,"logs",w)}return this.args.logsPath}get userDataSyncLogResource(){return d.URI.file((0,C.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.joinPath)(d.URI.file((0,C.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return d.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return d.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,I.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,I.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const w=n.env.VSCODE_PORTABLE;return w?d.URI.file((0,C.join)(w,"argv.json")):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,I.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return d.URI.file((0,C.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,C.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const w=this.args["builtin-extensions-dir"];return w?(0,C.resolve)(w):(0,C.normalize)((0,C.join)(M.FileAccess.asFileUri("",H).fsPath,"..","extensions"))}get extensionsDownloadPath(){const w=this.args["extensions-download-dir"];return w?(0,C.resolve)(w):(0,C.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const w=this.args["extensions-dir"];if(w)return(0,C.resolve)(w);const b=n.env.VSCODE_EXTENSIONS;if(b)return b;const S=n.env.VSCODE_PORTABLE;return S?(0,C.join)(S,"extensions"):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const w=this.args.extensionDevelopmentPath;if(Array.isArray(w))return w.map(b=>/^[^:/?#]+?:\/\//.test(b)?d.URI.parse(b):d.URI.file((0,C.normalize)(b)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(w=>w==="ui"||w==="workspace"||w==="web"?w:"workspace")}get extensionTestsLocationURI(){const w=this.args.extensionTestsPath;if(w)return/^[^:/?#]+?:\/\//.test(w)?d.URI.parse(w):d.URI.file((0,C.normalize)(w))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const w=this.args["disable-extension"];if(w){if(typeof w=="string")return[w];if(Array.isArray(w)&&w.length>0)return w}return!1}get debugExtensionHost(){return y(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!n.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,I.joinPath)(d.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return d.URI.file((0,C.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}he([D.memoize],f.prototype,"appRoot",null),he([D.memoize],f.prototype,"userHome",null),he([D.memoize],f.prototype,"userDataPath",null),he([D.memoize],f.prototype,"appSettingsHome",null),he([D.memoize],f.prototype,"tmpDir",null),he([D.memoize],f.prototype,"userRoamingDataHome",null),he([D.memoize],f.prototype,"settingsResource",null),he([D.memoize],f.prototype,"userDataSyncHome",null),he([D.memoize],f.prototype,"userDataSyncLogResource",null),he([D.memoize],f.prototype,"sync",null),he([D.memoize],f.prototype,"machineSettingsResource",null),he([D.memoize],f.prototype,"globalStorageHome",null),he([D.memoize],f.prototype,"workspaceStorageHome",null),he([D.memoize],f.prototype,"keybindingsResource",null),he([D.memoize],f.prototype,"keyboardLayoutResource",null),he([D.memoize],f.prototype,"argvResource",null),he([D.memoize],f.prototype,"snippetsHome",null),he([D.memoize],f.prototype,"isExtensionDevelopment",null),he([D.memoize],f.prototype,"untitledWorkspacesHome",null),he([D.memoize],f.prototype,"installSourcePath",null),he([D.memoize],f.prototype,"builtinExtensionsPath",null),he([D.memoize],f.prototype,"extensionsPath",null),he([D.memoize],f.prototype,"extensionDevelopmentLocationURI",null),he([D.memoize],f.prototype,"extensionDevelopmentKind",null),he([D.memoize],f.prototype,"extensionTestsLocationURI",null),he([D.memoize],f.prototype,"debugExtensionHost",null),he([D.memoize],f.prototype,"serviceMachineIdResource",null),he([D.memoize],f.prototype,"telemetryLogResource",null),he([D.memoize],f.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=f;function y(t,w){return p(t["inspect-extensions"],t["inspect-brk-extensions"],5870,w,t.debugId,t.extensionEnvironment)}e.parseExtensionHostPort=y;function E(t,w){return p(t["inspect-search"],t["inspect-brk-search"],5876,w,t.extensionEnvironment)}e.parseSearchPort=E;function m(t,w){return p(t["inspect-ptyhost"],t["inspect-brk-ptyhost"],5877,w,t.extensionEnvironment)}e.parsePtyHostPort=m;function p(t,w,b,S,P,c){const l=Number(w||t)||(S?null:b),s=l?Boolean(!!w):!1;let u;if(c)try{u=JSON.parse(c)}catch{}return{port:l,break:s,debugId:P,env:u}}}),define(Q[88],J([0,1,246,3,137]),function(H,e,v,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const C={o:(0,M.localize)(0,null),e:(0,M.localize)(1,null),t:(0,M.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,M.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,M.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,M.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,M.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,M.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,M.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,M.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,M.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,M.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,M.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,M.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,M.localize)(14,null)},category:{type:"string",cat:"e",description:(0,M.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,M.localize)(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,M.localize)(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,M.localize)(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,M.localize)(19,null)},verbose:{type:"boolean",cat:"t",description:(0,M.localize)(20,null)},log:{type:"string",cat:"t",args:"level",description:(0,M.localize)(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,M.localize)(22,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,M.localize)(23,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,M.localize)(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,M.localize)(25,null)},sync:{type:"string",cat:"t",description:(0,M.localize)(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,M.localize)(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,M.localize)(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,M.localize)(29,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,M.localize)(30,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,M.localize)(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const n={onUnknownOption:()=>{},onMultipleValues:()=>{}};function I(t,w,b=n){const S={},P=[],c=[];for(let u in w){const r=w[u];r.alias&&(S[u]=r.alias),r.type==="string"||r.type==="string[]"?(P.push(u),r.deprecates&&P.push(r.deprecates)):r.type==="boolean"&&(c.push(u),r.deprecates&&c.push(r.deprecates))}const a=v(t,{string:P,boolean:c,alias:S}),l={},s=a;l._=a._.map(u=>String(u)).filter(u=>u.length>0),delete s._;for(let u in w){const r=w[u];r.alias&&delete s[r.alias];let i=s[u];r.deprecates&&s.hasOwnProperty(r.deprecates)&&(i||(i=s[r.deprecates]),delete s[r.deprecates]),typeof i!="undefined"&&(r.type==="string[]"?i&&!Array.isArray(i)&&(i=[i]):r.type==="string"&&Array.isArray(i)&&(i=i.pop(),b.onMultipleValues(u,i)),l[u]=i),delete s[u]}for(let u in s)b.onUnknownOption(u);return l}e.parseArgs=I;function d(t,w){let b="";return w.args&&(Array.isArray(w.args)?b=` <${w.args.join("> <")}>`:b=` <${w.args}>`),w.alias?`-${w.alias} --${t}${b}`:`--${t}${b}`}function f(t,w){let b=0,S=[];for(const l in t){const s=t[l],u=d(l,s);b=Math.max(b,u.length),S.push([u,s.description])}let P=b+2+1;if(w-P<25)return S.reduce((l,s)=>l.concat([`  ${s[0]}`,`      ${s[1]}`]),[]);let c=w-P-1,a=[];for(const l of S){let s=l[0],u=E(l[1],c),r=y(P-s.length-2);a.push("  "+s+r+u[0]);for(let i=1;i<u.length;i++)a.push(y(P)+u[i])}return a}e.formatOptions=f;function y(t){return" ".repeat(t)}function E(t,w){let b=[];for(;t.length;){let S=t.length<w?t.length:t.lastIndexOf(" ",w),P=t.slice(0,S).trim();t=t.slice(S),b.push(P)}return b}function m(t,w,b,S,P=!0){const c=process.stdout.isTTY&&process.stdout.columns||80;let a=[`${t} ${b}`];a.push(""),a.push(`${(0,M.localize)(32,null)}: ${w} [${(0,M.localize)(33,null)}][${(0,M.localize)(34,null)}...]`),a.push(""),P&&(D.isWindows?a.push((0,M.localize)(35,null,w)):a.push((0,M.localize)(36,null,w)),a.push(""));const l={};for(const s in S){const u=S[s];if(u.description&&u.cat){let r=l[u.cat];r||(l[u.cat]=r={}),r[s]=u}}for(let s in l){const u=s;let r=l[u];r&&(a.push(C[u]),a.push(...f(r,c)),a.push(""))}return a.join(`
`)}e.buildHelpMessage=m;function p(t,w){return`${t||(0,M.localize)(37,null)}
${w||(0,M.localize)(38,null)}
${process.arch}`}e.buildVersionMessage=p}),define(Q[162],J([0,1,62,159,88]),function(H,e,v,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class C extends D.ExtensionHostDebugBroadcastChannel{constructor(I){super();this.windowsMainService=I}call(I,d,f){return d==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(f[0],f[1]):super.call(I,d,f)}async openExtensionDevelopmentHostWindow(I,d){const f=(0,M.parseArgs)(I,M.OPTIONS);f.debugRenderer=d;const y=f.extensionDevelopmentPath;if(!y)return{success:!1};const[E]=this.windowsMainService.openExtensionDevelopmentHostWindow(y,{context:5,cli:f});if(!d)return{success:!0};const m=E.win;if(!m)return{success:!0};const p=m.webContents.debugger;let t=p.isAttached()?Infinity:0;const w=(0,v.createServer)(b=>{t++==0&&p.attach();let S=!1;const P=l=>{S||b.write(JSON.stringify(l)+"\0")},c=(l,s,u,r)=>P({method:s,params:u,sessionId:r});m.on("close",()=>{p.removeListener("message",c),b.end(),S=!0}),p.addListener("message",c);let a=Buffer.alloc(0);b.on("data",l=>{a=Buffer.concat([a,l]);for(let s=a.indexOf(0);s!==-1;s=a.indexOf(0)){let u;try{const r=a.slice(0,s).toString("utf8");a=a.slice(s+1),u=JSON.parse(r)}catch(r){console.error("error reading cdp line",r)}p.sendCommand(u.method,u.params,u.sessionId).then(r=>P({id:u.id,sessionId:u.sessionId,result:r})).catch(r=>P({id:u.id,sessionId:u.sessionId,error:{code:0,message:r.message}}))}}),b.on("error",l=>{console.error("error on cdp pipe:",l)}),b.on("close",()=>{S=!0,--t==0&&p.detach()})});return await new Promise(b=>w.listen(0,b)),m.on("close",()=>w.close()),{rendererDebugPort:w.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=C}),function(){"use strict";function H(e,v,D,M){function C(I){const d=n(I),f=[d];return e.isAbsolute(d)||f.unshift(M),e.resolve(...f)}function n(I){const d=process.env.VSCODE_PORTABLE;if(d)return e.join(d,"user-data");let f=process.env.VSCODE_APPDATA;if(f)return e.join(f,D);const y=I["user-data-dir"];if(y)return y;switch(process.platform){case"win32":if(f=process.env.APPDATA,!f){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");f=e.join(E,"AppData","Roaming")}break;case"darwin":f=e.join(v.homedir(),"Library","Application Support");break;case"linux":f=process.env.XDG_CONFIG_HOME||e.join(v.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(f,D)}return{getUserDataPath:C}}if(typeof define=="function")define(Q[163],J([0,247,26,10,15,32]),function(e,v,D,M,C,n){const I=C.dirname(M.FileAccess.asFileUri("",e)),d=e.__$__nodeRequire(C.joinPath(I,"package.json").fsPath);return H(v,D,d.name,n.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),v=require("path"),D=require("os");module.exports=H(v,D,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Q[164],J([0,1,26,161,163]),function(H,e,v,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class C extends D.AbstractNativeEnvironmentService{constructor(I,d){super(I,{homeDir:(0,v.homedir)(),tmpDir:(0,v.tmpdir)(),userDataDir:(0,M.getUserDataPath)(I)},d)}}e.NativeEnvironmentService=C}),define(Q[165],J([0,1,28,26,8]),function(H,e,v,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function C(n){const I=(0,M.join)((0,D.tmpdir)(),Math.random().toString(36).replace(/[^a-z]+/g,"").substr(0,10));try{return v.writeFileSync(I,""),n&&console.log(`Marker file for --wait created: ${I}`),I}catch(d){n&&console.error(`Failed to create marker file for --wait: ${d}`);return}}e.createWaitMarkerFile=C}),define(Q[166],J([0,1,141]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,M=/^-(\d{4})(\d{2})(\d{2})$/;function C(m){return m=m.trim(),m==="*"||D.test(m)}e.isValidVersionStr=C;function n(m){if(!C(m))return null;if(m=m.trim(),m==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let p=m.match(D);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=n;function I(m){if(!m)return null;let p=m.majorBase,t=m.majorMustEqual,w=m.minorBase,b=m.minorMustEqual,S=m.patchBase,P=m.patchMustEqual;m.hasCaret&&(p===0||(b=!1),P=!1);let c=0;if(m.preRelease){const a=M.exec(m.preRelease);if(a){const[,l,s,u]=a;c=Date.UTC(Number(l),Number(s)-1,Number(u))}}return{majorBase:p,majorMustEqual:t,minorBase:w,minorMustEqual:b,patchBase:S,patchMustEqual:P,isMinimum:m.hasGreaterEquals,notBefore:c}}e.normalizeVersion=I;function d(m,p,t){let w;typeof m=="string"?w=I(n(m)):w=m;let b;p instanceof Date?b=p.getTime():typeof p=="string"&&(b=new Date(p).getTime());let S;if(typeof t=="string"?S=I(n(t)):S=t,!w||!S)return!1;let P=w.majorBase,c=w.minorBase,a=w.patchBase,l=S.majorBase,s=S.minorBase,u=S.patchBase,r=S.notBefore,i=S.majorMustEqual,o=S.minorMustEqual,h=S.patchMustEqual;return S.isMinimum?P>l?!0:P<l?!1:c>s?!0:c<s||b&&b<r?!1:a>=u:(P===1&&l===0&&(!i||!o||!h)&&(l=1,s=0,u=0,i=!0,o=!1,h=!1),P<l?!1:P>l?!i:c<s?!1:c>s?!o:a<u?!1:a>u?!h:!(b&&b<r))}e.isValidVersion=d;function f(m,p,t,w){return t.isBuiltin||typeof t.main=="undefined"?!0:E(m,p,t.engines.vscode,w)}e.isValidExtensionVersion=f;function y(m,p,t){return m==="*"||E(p,t,m)}e.isEngineValid=y;function E(m,p,t,w=[]){let b=I(n(t));if(!b)return w.push(v.localize(0,null,t)),!1;if(b.majorBase===0){if(!b.majorMustEqual||!b.minorMustEqual)return w.push(v.localize(1,null,t)),!1}else if(!b.majorMustEqual)return w.push(v.localize(2,null,t)),!1;return d(m,p,b)?!0:(w.push(v.localize(3,null,m,t)),!1)}}),define(Q[167],J([0,1,4,2,17,60,23]),function(H,e,v,D,M,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProviderChannel=void 0;class I extends D.Disposable{constructor(f,y){super();this.provider=f,this.logService=y,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(f,y,E){const m=this.getUriTransformer(f);switch(y){case"stat":return this.stat(m,E[0]);case"readdir":return this.readdir(m,E[0]);case"open":return this.open(m,E[0],E[1]);case"close":return this.close(E[0]);case"read":return this.read(E[0],E[1],E[2]);case"readFile":return this.readFile(m,E[0]);case"write":return this.write(E[0],E[1],E[2],E[3],E[4]);case"writeFile":return this.writeFile(m,E[0],E[1],E[2]);case"rename":return this.rename(m,E[0],E[1],E[2]);case"copy":return this.copy(m,E[0],E[1],E[2]);case"mkdir":return this.mkdir(m,E[0]);case"delete":return this.delete(m,E[0],E[1]);case"watch":return this.watch(m,E[0],E[1],E[2],E[3]);case"unwatch":return this.unwatch(E[0],E[1])}throw new Error(`IPC Command ${y} not found`)}listen(f,y,E){const m=this.getUriTransformer(f);switch(y){case"fileChange":return this.onFileChange(m,E[0]);case"readFileStream":return this.onReadFileStream(m,E[0],E[1])}throw new Error(`Unknown event ${y}`)}stat(f,y){const E=this.transformIncoming(f,y,!0);return this.provider.stat(E)}readdir(f,y){const E=this.transformIncoming(f,y);return this.provider.readdir(E)}async readFile(f,y){const E=this.transformIncoming(f,y,!0),m=await this.provider.readFile(E);return M.VSBuffer.wrap(m)}onReadFileStream(f,y,E){const m=this.transformIncoming(f,y,!0),p=new n.CancellationTokenSource,t=new v.Emitter({onLastListenerRemove:()=>{p.cancel()}}),w=this.provider.readFileStream(m,E,p.token);return(0,C.listenStream)(w,{onData:b=>t.fire(M.VSBuffer.wrap(b)),onError:b=>t.fire(b),onEnd:()=>{t.fire("end"),t.dispose(),p.dispose()}}),t.event}writeFile(f,y,E,m){const p=this.transformIncoming(f,y);return this.provider.writeFile(p,E.buffer,m)}open(f,y,E){const m=this.transformIncoming(f,y,!0);return this.provider.open(m,E)}close(f){return this.provider.close(f)}async read(f,y,E){const m=M.VSBuffer.alloc(E),p=0,t=await this.provider.read(f,y,m.buffer,p,E);return[m,t]}write(f,y,E,m,p){return this.provider.write(f,y,E.buffer,m,p)}mkdir(f,y){const E=this.transformIncoming(f,y);return this.provider.mkdir(E)}delete(f,y,E){const m=this.transformIncoming(f,y);return this.provider.delete(m,E)}rename(f,y,E,m){const p=this.transformIncoming(f,y),t=this.transformIncoming(f,E);return this.provider.rename(p,t,m)}copy(f,y,E,m){const p=this.transformIncoming(f,y),t=this.transformIncoming(f,E);return this.provider.copy(p,t,m)}onFileChange(f,y){const E=new v.Emitter({onFirstListenerAdd:()=>{this.sessionToWatcher.set(y,this.createSessionFileWatcher(f,E))},onLastListenerRemove:()=>{(0,D.dispose)(this.sessionToWatcher.get(y)),this.sessionToWatcher.delete(y)}});return E.event}async watch(f,y,E,m,p){const t=this.sessionToWatcher.get(y);if(t){const w=this.transformIncoming(f,m),b=t.watch(E,w,p);this.watchRequests.set(y+E,b)}}async unwatch(f,y){const E=f+y,m=this.watchRequests.get(E);m&&((0,D.dispose)(m),this.watchRequests.delete(E))}dispose(){super.dispose(),this.watchRequests.forEach(f=>(0,D.dispose)(f)),this.watchRequests.clear(),this.sessionToWatcher.forEach(f=>(0,D.dispose)(f)),this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=I}),define(Q[73],J([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class v{constructor(M,C=[],n=!1){this.ctor=M,this.staticArguments=C,this.supportsDelayedInstantiation=n}}e.SyncDescriptor=v}),define(Q[168],J([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class v{constructor(C){this.incoming=new Map,this.outgoing=new Map,this.data=C}}e.Node=v;class D{constructor(C){this._hashFn=C,this._nodes=new Map}roots(){const C=[];for(let n of this._nodes.values())n.outgoing.size===0&&C.push(n);return C}insertEdge(C,n){const I=this.lookupOrInsertNode(C),d=this.lookupOrInsertNode(n);I.outgoing.set(this._hashFn(n),d),d.incoming.set(this._hashFn(C),I)}removeNode(C){const n=this._hashFn(C);this._nodes.delete(n);for(let I of this._nodes.values())I.outgoing.delete(n),I.incoming.delete(n)}lookupOrInsertNode(C){const n=this._hashFn(C);let I=this._nodes.get(n);return I||(I=new v(C),this._nodes.set(n,I)),I}lookup(C){return this._nodes.get(this._hashFn(C))}isEmpty(){return this._nodes.size===0}toString(){let C=[];for(let[n,I]of this._nodes)C.push(`${n}, (incoming)[${[...I.incoming.keys()].join(", ")}], (outgoing)[${[...I.outgoing.keys()].join(",")}]`);return C.join(`
`)}findCycleSlow(){for(let[C,n]of this._nodes){const I=new Set([C]),d=this._findCycle(n,I);if(d)return d}}_findCycle(C,n){for(let[I,d]of C.outgoing){if(n.has(I))return[...n,I].join(" -> ");n.add(I);const f=this._findCycle(d,n);if(f)return f;n.delete(I)}}}e.Graph=D}),define(Q[5],J([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var v;(function(n){n.serviceIds=new Map,n.DI_TARGET="$di$target",n.DI_DEPENDENCIES="$di$dependencies";function I(d){return d[n.DI_DEPENDENCIES]||[]}n.getServiceDependencies=I})(v=e._util||(e._util={})),e.IInstantiationService=M("instantiationService");function D(n,I,d,f){I[v.DI_TARGET]===I?I[v.DI_DEPENDENCIES].push({id:n,index:d,optional:f}):(I[v.DI_DEPENDENCIES]=[{id:n,index:d,optional:f}],I[v.DI_TARGET]=I)}function M(n){if(v.serviceIds.has(n))return v.serviceIds.get(n);const I=function(d,f,y){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");D(I,d,y,!1)};return I.toString=()=>n,v.serviceIds.set(n,I),I}e.createDecorator=M;function C(n){return n}e.refineServiceDecorator=C}),define(Q[74],J([0,1,5]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,v.createDecorator)(e.ID);function D(M){return!!M.hostName&&!!M.errorMessage}e.isRemoteDiagnosticError=D}),define(Q[89],J([0,1,5]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,v.createDecorator)("encryptionMainService");class D{constructor(C){this.machineId=C}encryption(){return new Promise((C,n)=>H(["vscode-encrypt"],C,n))}async encrypt(C){try{return(await this.encryption()).encrypt(this.machineId,C)}catch(n){return C}}async decrypt(C){try{return(await this.encryption()).decrypt(this.machineId,C)}catch(n){return C}}}e.EncryptionMainService=D}),define(Q[48],J([0,1,5]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,v.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,v.refineServiceDecorator)(e.IEnvironmentService)}),define(Q[169],J([0,1,10,140,5]),function(H,e,v,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var C;(function(c){c.WIN32_X64="win32-x64",c.WIN32_IA32="win32-ia32",c.WIN32_ARM64="win32-arm64",c.LINUX_X64="linux-x64",c.LINUX_ARM64="linux-arm64",c.LINUX_ARMHF="linux-armhf",c.ALPINE_X64="alpine-x64",c.ALPINE_ARM64="alpine-arm64",c.DARWIN_X64="darwin-x64",c.DARWIN_ARM64="darwin-arm64",c.WEB="web",c.UNIVERSAL="universal",c.UNKNOWN="unknown",c.UNDEFINED="undefined"})(C=e.TargetPlatform||(e.TargetPlatform={}));function n(c){switch(c){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=n;function I(c){switch(c){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=I;function d(c,a){switch(c){case 3:return a==="x64"?"win32-x64":a==="ia32"?"win32-ia32":a==="arm64"?"win32-arm64":"unknown";case 2:return a==="x64"?"linux-x64":a==="arm64"?"linux-arm64":a==="arm"?"linux-armhf":"unknown";case"alpine":return a==="x64"?"alpine-x64":a==="arm64"?"alpine-arm64":"unknown";case 1:return a==="x64"?"darwin-x64":a==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=d;function f(c,a){return a==="web"&&!c.includes("web")}e.isNotWebExtensionInWebTargetPlatform=f;function y(c,a,l){return f(a,l)?!1:c==="undefined"||c==="universal"?!0:c==="unknown"?!1:c===l?!0:E(l).includes(c)}e.isTargetPlatformCompatible=y;function E(c){switch(c){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=E;function m(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}e.isIExtensionIdentifier=m;var p;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(p=e.SortBy||(e.SortBy={}));var t;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(t=e.SortOrder||(e.SortOrder={}));var w;(function(c){c.Install="install",c.Uninstall="uninstall"})(w=e.StatisticType||(e.StatisticType={}));var b;(function(c){c[c.None=0]="None",c[c.Install=1]="Install",c[c.Update=2]="Update"})(b=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,M.createDecorator)("extensionGalleryService");var S;(function(c){c.Unsupported="Unsupported",c.Malicious="Malicious",c.Incompatible="Incompatible",c.Invalid="Invalid",c.Download="Download",c.Extract="Extract",c.Delete="Delete",c.Rename="Rename",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Internal="Internal"})(S=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class P extends Error{constructor(a,l){super(a);this.code=l,this.name=l}}e.ExtensionManagementError=P,e.IExtensionManagementService=(0,M.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,M.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,M.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=v.FileAccess.asBrowserUri("./media/defaultIcon.png",H).toString(!0),e.ExtensionsLabel=(0,D.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,D.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,M.createDecorator)("IExtensionManagementCLIService")}),define(Q[170],J([0,1,5]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,v.createDecorator)("extensionUrlTrustService")}),define(Q[171],J([0,1,5]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,v.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(Q[90],J([0,1,5]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,v.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,v.createDecorator)("externalTerminal")}),define(Q[172],J([0,1,43,10,8,3,80,21,72,142,90]),function(H,e,v,D,M,C,n,I,d,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const E=f.localize(0,null);class m{async getDefaultTerminalForPlatforms(){return{windows:p.getDefaultTerminalWindows(),linux:await w.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class p extends m{openTerminal(a,l){return this.spawnTerminal(v,a,d.getWindowsShell(),l)}spawnTerminal(a,l,s,u){const r=l.windowsExec||p.getDefaultTerminalWindows();u&&u[1]===":"&&(u=u[0].toUpperCase()+u.substr(1));const i=M.basename(r).toLowerCase();if(i==="cmder"||i==="cmder.exe")return a.spawn(r,u?[u]:void 0),Promise.resolve(void 0);const o=["/c","start","/wait"];return r.indexOf(" ")>=0&&o.push('""'),o.push(r),(i==="wt"||i==="wt.exe")&&o.push("-d ."),new Promise((h,g)=>{const k=b(process),L=a.spawn(s,o,{cwd:u,env:k});L.on("error",g),L.on("exit",()=>h())})}runInTerminal(a,l,s,u,r){const i="windowsExec"in r&&r.windowsExec?r.windowsExec:p.getDefaultTerminalWindows();return new Promise((o,h)=>{const g=`"${l} - ${E}"`,k=`""${s.join('" "')}" & pause"`,L=["/c","start",g,"/wait",i,"/c",k],R=Object.assign({},b(process),u);Object.keys(R).filter(x=>R[x]===null).forEach(x=>delete R[x]);const W={cwd:l,env:R,windowsVerbatimArguments:!0};v.spawn(p.CMD,L,W).on("error",x=>{h(S(x))}),o(void 0)})}static getDefaultTerminalWindows(){if(!p._DEFAULT_TERMINAL_WINDOWS){const a=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");p._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${a?"Sysnative":"System32"}\\cmd.exe`}return p._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=p,p.CMD="cmd.exe";class t extends m{openTerminal(a,l){return this.spawnTerminal(v,a,l)}runInTerminal(a,l,s,u,r){const i=r.osxExec||y.DEFAULT_TERMINAL_OSX;return new Promise((o,h)=>{if(i===y.DEFAULT_TERMINAL_OSX||i==="iTerm.app"){const g=i===y.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",L=[D.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${g}.scpt`,H).fsPath,"-t",a||E,"-w",l];for(let j of s)L.push("-a"),L.push(j);if(u){const j=Object.assign({},b(process),u);for(let x in j){const ne=j[x];ne===null?(L.push("-u"),L.push(x)):(L.push("-e"),L.push(`${x}=${ne}`))}}let R="";const W=v.spawn(t.OSASCRIPT,L);W.on("error",j=>{h(S(j))}),W.stderr.on("data",j=>{R+=j.toString()}),W.on("exit",j=>{if(j===0)o(void 0);else if(R){const x=R.split(`
`,1);h(new Error(x[0]))}else h(new Error(f.localize(1,null,g,j)))})}else h(new Error(f.localize(2,null,i)))})}spawnTerminal(a,l,s){const u=l.osxExec||y.DEFAULT_TERMINAL_OSX;return new Promise((r,i)=>{const o=["-a",u];s&&o.push(s);const h=b(process),g=a.spawn("/usr/bin/open",o,{cwd:s,env:h});g.on("error",i),g.on("exit",()=>r())})}}e.MacExternalTerminalService=t,t.OSASCRIPT="/usr/bin/osascript";class w extends m{openTerminal(a,l){return this.spawnTerminal(v,a,l)}runInTerminal(a,l,s,u,r){const i=r.linuxExec?Promise.resolve(r.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((o,h)=>{let g=[];i.then(k=>{k.indexOf("gnome-terminal")>=0?g.push("-x"):g.push("-e"),g.push("bash"),g.push("-c");const L=`${P(s)}; echo; read -p "${w.WAIT_MESSAGE}" -n1;`;g.push(`''${L}''`);const R=Object.assign({},b(process),u);Object.keys(R).filter(ne=>R[ne]===null).forEach(ne=>delete R[ne]);const W={cwd:l,env:R};let j="";const x=v.spawn(k,g,W);x.on("error",ne=>{h(S(ne))}),x.stderr.on("data",ne=>{j+=ne.toString()}),x.on("exit",ne=>{if(ne===0)o(void 0);else if(j){const oe=j.split(`
`,1);h(new Error(oe[0]))}else h(new Error(f.localize(4,null,k,ne)))})})})}static async getDefaultTerminalLinuxReady(){if(!w._DEFAULT_TERMINAL_LINUX_READY)if(!C.isLinux)w._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const a=await I.Promises.exists("/etc/debian_version");w._DEFAULT_TERMINAL_LINUX_READY=new Promise(l=>{a?l("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?l("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?l("konsole"):process.env.COLORTERM?l(process.env.COLORTERM):process.env.TERM?l(process.env.TERM):l("xterm")})}return w._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(a,l,s){const u=l.linuxExec?Promise.resolve(l.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((r,i)=>{u.then(o=>{const h=b(process),g=a.spawn(o,[],{cwd:s,env:h});g.on("error",i),g.on("exit",()=>r())})})}}e.LinuxExternalTerminalService=w,w.WAIT_MESSAGE=f.localize(3,null);function b(c){const a={...c.env};return(0,n.sanitizeProcessEnvironment)(a),a}function S(c){return"errno"in c&&c.errno==="ENOENT"&&"path"in c&&typeof c.path=="string"?new Error(f.localize(5,null,c.path)):c}function P(c){let a="";for(let l of c)l.indexOf(" ")>=0?a+='"'+l+'"':a+=l,a+=" ";return a}}),define(Q[18],J([0,1,40,8,25,13,7,144,5]),function(H,e,v,D,M,C,n,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,d.createDecorator)("fileService");function f(T){return T.create===!0}e.isFileOpenForWriteOptions=f;var y;(function(T){T[T.Unknown=0]="Unknown",T[T.File=1]="File",T[T.Directory=2]="Directory",T[T.SymbolicLink=64]="SymbolicLink"})(y=e.FileType||(e.FileType={}));var E;(function(T){T[T.Readonly=1]="Readonly"})(E=e.FilePermission||(e.FilePermission={}));var m;(function(T){T[T.FileReadWrite=2]="FileReadWrite",T[T.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",T[T.FileReadStream=16]="FileReadStream",T[T.FileFolderCopy=8]="FileFolderCopy",T[T.PathCaseSensitive=1024]="PathCaseSensitive",T[T.Readonly=2048]="Readonly",T[T.Trash=4096]="Trash",T[T.FileWriteUnlock=8192]="FileWriteUnlock"})(m=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function p(T){return!!(T.capabilities&2)}e.hasReadWriteCapability=p;function t(T){return!!(T.capabilities&8)}e.hasFileFolderCopyCapability=t;function w(T){return!!(T.capabilities&4)}e.hasOpenReadWriteCloseCapability=w;function b(T){return!!(T.capabilities&16)}e.hasFileReadStreamCapability=b;var S;(function(T){T.FileExists="EntryExists",T.FileNotFound="EntryNotFound",T.FileNotADirectory="EntryNotADirectory",T.FileIsADirectory="EntryIsADirectory",T.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",T.FileTooLarge="EntryTooLarge",T.FileWriteLocked="EntryWriteLocked",T.NoPermissions="NoPermissions",T.Unavailable="Unavailable",T.Unknown="Unknown"})(S=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class P extends Error{constructor(B,q){super(B);this.code=q}}e.FileSystemProviderError=P;function c(T,B){const q=new P(T.toString(),B);return l(q,B),q}e.createFileSystemProviderError=c;function a(T){return T||c((0,I.localize)(0,null),S.Unknown)}e.ensureFileSystemProviderError=a;function l(T,B){return T.name=B?`${B} (FileSystemError)`:"FileSystemError",T}e.markAsFileSystemProviderError=l;function s(T){if(!T)return S.Unknown;if(T instanceof P)return T.code;const B=/^(.+) \(FileSystemError\)$/.exec(T.name);if(!B)return S.Unknown;switch(B[1]){case S.FileExists:return S.FileExists;case S.FileIsADirectory:return S.FileIsADirectory;case S.FileNotADirectory:return S.FileNotADirectory;case S.FileNotFound:return S.FileNotFound;case S.FileExceedsMemoryLimit:return S.FileExceedsMemoryLimit;case S.FileTooLarge:return S.FileTooLarge;case S.FileWriteLocked:return S.FileWriteLocked;case S.NoPermissions:return S.NoPermissions;case S.Unavailable:return S.Unavailable}return S.Unknown}e.toFileSystemProviderErrorCode=s;function u(T){if(T instanceof k)return T.fileOperationResult;switch(s(T)){case S.FileNotFound:return 1;case S.FileIsADirectory:return 0;case S.FileNotADirectory:return 10;case S.FileWriteLocked:return 5;case S.NoPermissions:return 6;case S.FileExists:return 4;case S.FileExceedsMemoryLimit:return 9;case S.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=u;var r;(function(T){T[T.CREATE=0]="CREATE",T[T.DELETE=1]="DELETE",T[T.MOVE=2]="MOVE",T[T.COPY=3]="COPY"})(r=e.FileOperation||(e.FileOperation={}));class i{constructor(B,q,U){this.resource=B,this.operation=q,this.target=U}isOperation(B){return this.operation===B}}e.FileOperationEvent=i;var o;(function(T){T[T.UPDATED=0]="UPDATED",T[T.ADDED=1]="ADDED",T[T.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class h{constructor(B,q){this.added=void 0,this.updated=void 0,this.deleted=void 0;const U=new Map;for(const N of B){const _=U.get(N.type);_?_.push([N.resource,N]):U.set(N.type,[[N.resource,N]])}for(const[N,_]of U)switch(N){case 1:this.added=v.TernarySearchTree.forUris(()=>q),this.added.fill(_);break;case 0:this.updated=v.TernarySearchTree.forUris(()=>q),this.updated.fill(_);break;case 2:this.deleted=v.TernarySearchTree.forUris(()=>q),this.deleted.fill(_);break}}contains(B,...q){return this.doContains(B,{includeChildren:!1},...q)}affects(B,...q){return this.doContains(B,{includeChildren:!0},...q)}doContains(B,q,...U){if(!B)return!1;const N=U.length>0;return!!((!N||U.includes(1))&&(this.added?.get(B)||q.includeChildren&&this.added?.findSuperstr(B))||(!N||U.includes(0))&&(this.updated?.get(B)||q.includeChildren&&this.updated?.findSuperstr(B))||(!N||U.includes(2))&&(this.deleted?.findSubstr(B)||q.includeChildren&&this.deleted?.findSuperstr(B)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=h;function g(T,B,q){return!T||!B||T===B||B.length>T.length?!1:(B.charAt(B.length-1)!==D.sep&&(B+=D.sep),q?(0,M.startsWithIgnoreCase)(T,B):T.indexOf(B)===0)}e.isParent=g;class k extends Error{constructor(B,q,U){super(B);this.fileOperationResult=q,this.options=U}}e.FileOperationError=k;class L extends k{constructor(B,q,U){super(B,2,U);this.stat=q}}e.NotModifiedSinceFileOperationError=L;var R;(function(T){T[T.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",T[T.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",T[T.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",T[T.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",T[T.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",T[T.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",T[T.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",T[T.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",T[T.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",T[T.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",T[T.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",T[T.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(R=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var W;(function(T){T[T.FILE=0]="FILE",T[T.FOLDER=1]="FOLDER",T[T.ROOT_FOLDER=2]="ROOT_FOLDER"})(W=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function j(T){if(!(typeof T.size!="number"||typeof T.mtime!="number"))return T.mtime.toString(29)+T.size.toString(31)}e.etag=j;async function x(T,B){if(!B.hasProvider(n.URI.from({scheme:T.scheme})))return new Promise(q=>{const U=B.onDidChangeFileSystemProviderRegistrations(N=>{N.scheme===T.scheme&&N.added&&(U.dispose(),q())})})}e.whenProviderRegistered=x,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ne{static formatSize(B){return(0,C.isNumber)(B)||(B=0),B<ne.KB?(0,I.localize)(1,null,B.toFixed(0)):B<ne.MB?(0,I.localize)(2,null,(B/ne.KB).toFixed(2)):B<ne.GB?(0,I.localize)(3,null,(B/ne.MB).toFixed(2)):B<ne.TB?(0,I.localize)(4,null,(B/ne.GB).toFixed(2)):(0,I.localize)(5,null,(B/ne.TB).toFixed(2))}}e.ByteSize=ne,ne.KB=1024,ne.MB=ne.KB*ne.KB,ne.GB=ne.MB*ne.KB,ne.TB=ne.GB*ne.KB;var oe;(function(T){T[T.IA32=0]="IA32",T[T.OTHER=1]="OTHER"})(oe=e.Arch||(e.Arch={}));function G(T){return{maxFileSize:T===0?300*ne.MB:16*ne.GB,maxHeapSize:T===0?700*ne.MB:2*700*ne.MB}}e.getPlatformLimits=G}),define(Q[54],J([0,1,248,138,88,18]),function(H,e,v,D,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function n(m,p){const t={onUnknownOption:b=>{console.warn((0,D.localize)(0,null,b))},onMultipleValues:(b,S)=>{console.warn((0,D.localize)(1,null,b,S))}},w=(0,M.parseArgs)(m,M.OPTIONS,p?t:void 0);return w.goto&&w._.forEach(b=>v(/^(\w:)?[^:]+(:\d*){0,2}$/.test(b),(0,D.localize)(2,null))),w["max-memory"]&&v(parseInt(w["max-memory"])>=C.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${C.MIN_MAX_MEMORY_SIZE_MB} MB.`),w}function I(m){const p=m.findIndex(t=>!/^-/.test(t));if(p>-1)return[...m.slice(0,p),...m.slice(p+1)]}function d(m){let[,...p]=m;process.env.VSCODE_DEV&&(p=I(p)||[]);const t=!E(process.env);return n(p,t)}e.parseMainProcessArgv=d;function f(m){const[,,...p]=m;return n(p,!0)}e.parseCLIProcessArgv=f;function y(m,...p){const t=m.indexOf("--");return t===-1?m.push(...p):m.splice(t,0,...p),m}e.addArg=y;function E(m){return m.VSCODE_CLI==="1"}e.isLaunchedFromCli=E}),define(Q[91],J([0,1,43,8,139,23,44,16,3,31,133,54,9]),function(H,e,v,D,M,C,n,I,d,f,y,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;const p=1e4;let t;async function w(S,P,c){return P["force-disable-user-env"]?(S.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):d.isWindows?(S.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,E.isLaunchedFromCli)(c)&&!P["force-user-env"]?(S.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,E.isLaunchedFromCli)(c)?S.trace("resolveShellEnv(): running (--force-user-env)"):S.trace("resolveShellEnv(): running (macOS/Linux)"),t||(t=m.Promises.withAsyncBody(async(a,l)=>{const s=new C.CancellationTokenSource,u=setTimeout(()=>{s.dispose(!0),l(new Error((0,M.localize)(0,null)))},p);try{a(await b(S,s.token))}catch(r){!(0,I.isPromiseCanceledError)(r)&&!s.token.isCancellationRequested?l(new Error((0,M.localize)(1,null,(0,n.toErrorMessage)(r)))):a({})}finally{clearTimeout(u),s.dispose()}})),t)}e.resolveShellEnv=w;async function b(S,P){const c=process.env.ELECTRON_RUN_AS_NODE;S.trace("getUnixShellEnvironment#runAsNode",c);const a=process.env.ELECTRON_NO_ATTACH_CONSOLE;S.trace("getUnixShellEnvironment#noAttach",a);const l=(0,f.generateUuid)().replace(/-/g,"").substr(0,12),s=new RegExp(l+"(.*)"+l),u={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};S.trace("getUnixShellEnvironment#env",u);const r=await(0,y.getSystemShell)(d.OS,u);return S.trace("getUnixShellEnvironment#shell",r),new Promise((i,o)=>{if(P.isCancellationRequested)return o((0,I.canceled)());const h=(0,D.basename)(r);let g,k;const L=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(h)?(g=`& '${process.execPath}' ${L} -p '''${l}'' + JSON.stringify(process.env) + ''${l}'''`,k=["-Login","-Command"]):(g=`'${process.execPath}' ${L} -p '"${l}" + JSON.stringify(process.env) + "${l}"'`,h==="tcsh"?k=["-ic"]:k=["-ilc"]),S.trace("getUnixShellEnvironment#spawn",JSON.stringify(k),g);const R=(0,v.spawn)(r,[...k,g],{detached:!0,stdio:["ignore","pipe","pipe"],env:u});P.onCancellationRequested(()=>(R.kill(),o((0,I.canceled)()))),R.on("error",x=>{S.error("getUnixShellEnvironment#errorChildProcess",(0,n.toErrorMessage)(x)),o(x)});const W=[];R.stdout.on("data",x=>W.push(x));const j=[];R.stderr.on("data",x=>j.push(x)),R.on("close",(x,ne)=>{const oe=Buffer.concat(W).toString("utf8");S.trace("getUnixShellEnvironment#raw",oe);const G=Buffer.concat(j).toString("utf8");if(G.trim()&&S.trace("getUnixShellEnvironment#stderr",G),x||ne)return o(new Error((0,M.localize)(2,null,x,ne)));const T=s.exec(oe),B=T?T[1]:"{}";try{const q=JSON.parse(B);c?q.ELECTRON_RUN_AS_NODE=c:delete q.ELECTRON_RUN_AS_NODE,a?q.ELECTRON_NO_ATTACH_CONSOLE=a:delete q.ELECTRON_NO_ATTACH_CONSOLE,delete q.XDG_RUNTIME_DIR,S.trace("getUnixShellEnvironment#result",q),i(q)}catch(q){S.error("getUnixShellEnvironment#errorCaught",(0,n.toErrorMessage)(q)),o(q)}})})}}),define(Q[92],J([0,1,17,16,145,18]),function(H,e,v,D,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function n(y,E,m,p,t,w){let b;try{await I(y,E,m,p,t,w)}catch(S){b=S}finally{b&&t.errorTransformer&&(b=t.errorTransformer(b)),typeof b!="undefined"&&m.error(b),m.end()}}e.readFileIntoStream=n;async function I(y,E,m,p,t,w){d(w);const b=await y.open(E,{create:!1});try{d(w);let S=0,P=0,c=t&&typeof t.length=="number"?t.length:void 0,a=v.VSBuffer.alloc(Math.min(t.bufferSize,typeof c=="number"?c:t.bufferSize)),l=t&&typeof t.position=="number"?t.position:0,s=0;do P=await y.read(b,l,a.buffer,s,a.byteLength-s),l+=P,s+=P,S+=P,typeof c=="number"&&(c-=P),s===a.byteLength&&(await m.write(p(a)),a=v.VSBuffer.alloc(Math.min(t.bufferSize,typeof c=="number"?c:t.bufferSize)),s=0);while(P>0&&(typeof c!="number"||c>0)&&d(w)&&f(S,t));if(s>0){let u=s;typeof c=="number"&&(u=Math.min(s,c)),m.write(p(a.slice(0,u)))}}catch(S){throw(0,C.ensureFileSystemProviderError)(S)}finally{await y.close(b)}}function d(y){if(y.isCancellationRequested)throw(0,D.canceled)();return!0}function f(y,E){if(E?.limits){if(typeof E.limits.memory=="number"&&y>E.limits.memory)throw(0,C.createFileSystemProviderError)((0,M.localize)(0,null),C.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof E.limits.size=="number"&&y>E.limits.size)throw(0,C.createFileSystemProviderError)((0,M.localize)(1,null),C.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Q[55],J([0,1,2,3,7,18]),function(H,e,v,D,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.coalesceEvents=e.toFileChanges=e.WatcherService=e.AbstractWatcherService=void 0;class n extends v.Disposable{constructor(m,p,t){super();this.onFileChanges=m,this.onLogMessage=p,this.verboseLogging=t,this.serviceDisposables=this._register(new v.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const m=new v.DisposableStore;this.serviceDisposables.value=m,this.service=this.createService(m),this.service.setVerboseLogging(this.verboseLogging),m.add(this.service.onDidChangeFile(p=>this.onFileChanges(p))),m.add(this.service.onDidLogMessage(p=>this.onLogMessage(p))),m.add(this.service.onDidError(p=>this.onError(p)))}onError(m){this.restartCounter<n.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${m}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${m}`)}restart(m){this.restartCounter++,this.init(),this.watch(m)}async watch(m){this.requests=m,await this.service?.watch(m)}async setVerboseLogging(m){this.verboseLogging=m,await this.service?.setVerboseLogging(m)}error(m){this.onLogMessage({type:"error",message:`[File Watcher (parcel)] ${m}`})}dispose(){return this.service=void 0,super.dispose()}}e.AbstractWatcherService=n,n.MAX_RESTARTS=5;class I extends v.Disposable{}e.WatcherService=I;function d(E){return E.map(m=>({type:m.type,resource:M.URI.file(m.path)}))}e.toFileChanges=d;function f(E){const m=new y;for(const p of E)m.processEvent(p);return m.coalesce()}e.coalesceEvents=f;class y{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(m){return D.isLinux?m.path:m.path.toLowerCase()}processEvent(m){const p=this.mapPathToChange.get(this.toKey(m));let t=!1;if(p){const w=p.type,b=m.type;p.path!==m.path&&m.type===2?t=!0:w===1&&b===2?(this.mapPathToChange.delete(this.toKey(m)),this.coalesced.delete(p)):w===2&&b===1?p.type=0:w===1&&b===0||(p.type=b)}else t=!0;t&&(this.coalesced.add(m),this.mapPathToChange.set(this.toKey(m),m))}coalesce(){const m=[],p=[];return Array.from(this.coalesced).filter(t=>t.type!==2?(m.push(t),!1):!0).sort((t,w)=>t.path.length-w.path.length).filter(t=>p.some(w=>(0,C.isParent)(t.path,w,!D.isLinux))?!1:(p.push(t.path),!0)).concat(m)}}}),define(Q[93],J([0,1,9,2,8,82,21,120,55]),function(H,e,v,D,M,C,n,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class f extends D.Disposable{constructor(E,m,p,t){super();this.path=E,this.onDidFilesChange=m,this.onLogMessage=p,this.verboseLogging=t,this.fileChangesDelayer=this._register(new v.ThrottledDelayer(I.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(E){this.verboseLogging=E}async startWatching(){try{const{stat:E,symbolicLink:m}=await n.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let p=this.path;if(m)try{p=await(0,C.realpath)(p)}catch(t){if(this.onError(t),m.dangling)return}E.isDirectory()?this._register((0,I.watchFolder)(p,(t,w)=>{this.onFileChange({type:t==="changed"?0:t==="added"?1:2,path:(0,M.join)(this.path,(0,M.basename)(w))})},t=>this.onError(t))):this._register((0,I.watchFile)(p,t=>{this.onFileChange({type:t==="changed"?0:2,path:this.path})},t=>this.onError(t)))}catch(E){E.code!=="ENOENT"&&this.onError(E)}}onFileChange(E){this.fileChangesBuffer.push(E),this.verboseLogging&&this.onVerbose(`${E.type===1?"[ADDED]":E.type===2?"[DELETED]":"[CHANGED]"} ${E.path}`),this.fileChangesDelayer.trigger(async()=>{const m=this.fileChangesBuffer;this.fileChangesBuffer=[];const p=(0,d.coalesceEvents)(m);if(this.verboseLogging)for(const t of p)this.onVerbose(`>> normalized ${t.type===1?"[ADDED]":t.type===2?"[DELETED]":"[CHANGED]"} ${t.path}`);p.length>0&&this.onDidFilesChange(p)})}onError(E){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${E}`})}onVerbose(E){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${E}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=f}),define(Q[173],J([0,1,10,35,87,55]),function(H,e,v,D,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class n extends C.WatcherService{constructor(d,f,y){super();this.onDidFilesChange=d,this.onLogMessage=f,this.verboseLogging=y,this.isDisposed=!1,this.startWatching()}startWatching(){const d=this._register(new M.Client(v.FileAccess.asFileUri("bootstrap-fork",H).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherServiceNSFW"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this.service=D.ProxyChannel.toService((0,D.getNextTickChannel)(d.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(f=>!this.isDisposed&&this.onDidFilesChange(f))),this._register(this.service.onDidLogMessage(f=>this.onLogMessage(f)))}async setVerboseLogging(d){this.verboseLogging=d,this.isDisposed||await this.service?.setVerboseLogging(d)}error(d){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${d}`})}async watch(d){this.isDisposed||await this.service?.watch(d)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=n}),define(Q[174],J([0,1,10,35,87,55]),function(H,e,v,D,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class n extends C.AbstractWatcherService{constructor(d,f,y){super(d,f,y);this.init()}createService(d){const f=d.add(new M.Client(v.FileAccess.asFileUri("bootstrap-fork",H).fsPath,{serverName:"File Watcher (parcel, node.js)",args:["--type=watcherServiceParcel"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/parcel/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return d.add(f.onDidProcessExit(({code:y,signal:E})=>this.onError(`terminated by itself with code ${y}, signal: ${E}`))),D.ProxyChannel.toService((0,D.getNextTickChannel)(f.getChannel("watcher")))}}e.FileWatcher=n}),define(Q[75],J([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class v{constructor(...M){this._entries=new Map;for(let[C,n]of M)this.set(C,n)}set(M,C){const n=this._entries.get(M);return this._entries.set(M,C),n}has(M){return this._entries.has(M)}get(M){return this._entries.get(M)}}e.ServiceCollection=v}),define(Q[175],J([0,1,9,16,73,168,5,75]),function(H,e,v,D,M,C,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const d=!1;class f extends Error{constructor(t){super("cyclic dependency between services");this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class y{constructor(t=new I.ServiceCollection,w=!1,b){this._activeInstantiations=new Set,this._services=t,this._strict=w,this._parent=b,this._services.set(n.IInstantiationService,this)}createChild(t){return new y(t,this._strict,this)}invokeFunction(t,...w){let b=m.traceInvocation(t),S=!1;try{return t({get:c=>{if(S)throw(0,D.illegalState)("service accessor is only valid during the invocation of its target method");const a=this._getOrCreateServiceInstance(c,b);if(!a)throw new Error(`[invokeFunction] unknown service '${c}'`);return a}},...w)}finally{S=!0,b.stop()}}createInstance(t,...w){let b,S;return t instanceof M.SyncDescriptor?(b=m.traceCreation(t.ctor),S=this._createInstance(t.ctor,t.staticArguments.concat(w),b)):(b=m.traceCreation(t),S=this._createInstance(t,w,b)),b.stop(),S}_createInstance(t,w=[],b){let S=n._util.getServiceDependencies(t).sort((a,l)=>a.index-l.index),P=[];for(const a of S){let l=this._getOrCreateServiceInstance(a.id,b);if(!l&&this._strict&&!a.optional)throw new Error(`[createInstance] ${t.name} depends on UNKNOWN service ${a.id}.`);P.push(l)}let c=S.length>0?S[0].index:w.length;if(w.length!==c){console.warn(`[createInstance] First service dependency of ${t.name} at position ${c+1} conflicts with ${w.length} static arguments`);let a=c-w.length;a>0?w=w.concat(new Array(a)):w=w.slice(0,c)}return new t(...[...w,...P])}_setServiceInstance(t,w){if(this._services.get(t)instanceof M.SyncDescriptor)this._services.set(t,w);else if(this._parent)this._parent._setServiceInstance(t,w);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(t){let w=this._services.get(t);return!w&&this._parent?this._parent._getServiceInstanceOrDescriptor(t):w}_getOrCreateServiceInstance(t,w){let b=this._getServiceInstanceOrDescriptor(t);return b instanceof M.SyncDescriptor?this._safeCreateAndCacheServiceInstance(t,b,w.branch(t,!0)):(w.branch(t,!1),b)}_safeCreateAndCacheServiceInstance(t,w,b){if(this._activeInstantiations.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this._activeInstantiations.add(t);try{return this._createAndCacheServiceInstance(t,w,b)}finally{this._activeInstantiations.delete(t)}}_createAndCacheServiceInstance(t,w,b){const S=new C.Graph(a=>a.id.toString());let P=0;const c=[{id:t,desc:w,_trace:b}];for(;c.length;){const a=c.pop();if(S.lookupOrInsertNode(a),P++>1e3)throw new f(S);for(let l of n._util.getServiceDependencies(a.desc.ctor)){let s=this._getServiceInstanceOrDescriptor(l.id);if(!s&&!l.optional&&console.warn(`[createInstance] ${t} depends on ${l.id} which is NOT registered.`),s instanceof M.SyncDescriptor){const u={id:l.id,desc:s,_trace:a._trace.branch(l.id,!0)};S.insertEdge(a,u),c.push(u)}}}for(;;){const a=S.roots();if(a.length===0){if(!S.isEmpty())throw new f(S);break}for(const{data:l}of a){if(this._getServiceInstanceOrDescriptor(l.id)instanceof M.SyncDescriptor){const u=this._createServiceInstanceWithOwner(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this._setServiceInstance(l.id,u)}S.removeNode(l)}}return this._getServiceInstanceOrDescriptor(t)}_createServiceInstanceWithOwner(t,w,b=[],S,P){if(this._services.get(t)instanceof M.SyncDescriptor)return this._createServiceInstance(w,b,S,P);if(this._parent)return this._parent._createServiceInstanceWithOwner(t,w,b,S,P);throw new Error(`illegalState - creating UNKNOWN service instance ${w.name}`)}_createServiceInstance(t,w=[],b,S){if(b){const P=new v.IdleValue(()=>this._createInstance(t,w,S));return new Proxy(Object.create(null),{get(c,a){if(a in c)return c[a];let l=P.value,s=l[a];return typeof s!="function"||(s=s.bind(l),c[a]=s),s},set(c,a,l){return P.value[a]=l,!0}})}else return this._createInstance(t,w,S)}}e.InstantiationService=y;var E;(function(p){p[p.Creation=0]="Creation",p[p.Invocation=1]="Invocation",p[p.Branch=2]="Branch"})(E||(E={}));class m{constructor(t,w){this.type=t,this.name=w,this._start=Date.now(),this._dep=[]}static traceInvocation(t){return d?new m(1,t.name||t.toString().substring(0,42).replace(/\n/g,"")):m._None}static traceCreation(t){return d?new m(0,t.name):m._None}branch(t,w){let b=new m(2,t.toString());return this._dep.push([t,w,b]),b}stop(){let t=Date.now()-this._start;m._totals+=t;let w=!1;function b(P,c){let a=[],l=new Array(P+1).join("	");for(const[s,u,r]of c._dep)if(u&&r){w=!0,a.push(`${l}CREATES -> ${s}`);let i=b(P+1,r);i&&a.push(i)}else a.push(`${l}uses -> ${s}`);return a.join(`
`)}let S=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${b(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${m._totals.toFixed(2)}ms)`];(t>2||w)&&console.log(S.join(`
`))}}m._None=new class extends m{constructor(){super(-1,null)}stop(){}branch(){return this}},m._totals=0}),define(Q[176],J([0,1,16,131,59]),function(H,e,v,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseResolvedKeybinding=void 0;class C extends M.ResolvedKeybinding{constructor(I,d){super();if(d.length===0)throw(0,v.illegalArgument)("parts");this._os=I,this._parts=d}getLabel(){return D.UILabelProvider.toLabel(this._os,this._parts,I=>this._getLabel(I))}getAriaLabel(){return D.AriaLabelProvider.toLabel(this._os,this._parts,I=>this._getAriaLabel(I))}getElectronAccelerator(){return this._parts.length>1||this._parts[0].isDuplicateModifierCase()?null:D.ElectronAcceleratorLabelProvider.toLabel(this._os,this._parts,I=>this._getElectronAccelerator(I))}getUserSettingsLabel(){return D.UserSettingsLabelProvider.toLabel(this._os,this._parts,I=>this._getUserSettingsLabel(I))}isWYSIWYG(){return this._parts.every(I=>this._isWYSIWYG(I))}isChord(){return this._parts.length>1}getParts(){return this._parts.map(I=>this._getPart(I))}_getPart(I){return new M.ResolvedKeybindingPart(I.ctrlKey,I.shiftKey,I.altKey,I.metaKey,this._getLabel(I),this._getAriaLabel(I))}getDispatchParts(){return this._parts.map(I=>this._getDispatchPart(I))}getSingleModifierDispatchParts(){return this._parts.map(I=>this._getSingleModifierDispatchPart(I))}}e.BaseResolvedKeybinding=C}),define(Q[177],J([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeElementsAfterNulls=e.ResolvedKeybindingItem=void 0;class v{constructor(C,n,I,d,f,y,E){this._resolvedKeybindingItemBrand=void 0,this.resolvedKeybinding=C,this.keypressParts=C?D(C.getDispatchParts()):[],C&&this.keypressParts.length===0&&(this.keypressParts=D(C.getSingleModifierDispatchParts())),this.bubble=n?n.charCodeAt(0)===94:!1,this.command=this.bubble?n.substr(1):n,this.commandArgs=I,this.when=d,this.isDefault=f,this.extensionId=y,this.isBuiltinExtension=E}}e.ResolvedKeybindingItem=v;function D(M){let C=[];for(let n=0,I=M.length;n<I;n++){const d=M[n];if(!d)return C;C.push(d)}return C}e.removeElementsAfterNulls=D}),define(Q[178],J([0,1,79,59,176,177]),function(H,e,v,D,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USLayoutResolvedKeybinding=void 0;class n extends M.BaseResolvedKeybinding{constructor(d,f){super(f,d.parts)}_keyCodeToUILabel(d){if(this._os===2)switch(d){case 15:return"\u2190";case 16:return"\u2191";case 17:return"\u2192";case 18:return"\u2193"}return v.KeyCodeUtils.toString(d)}_getLabel(d){return d.isDuplicateModifierCase()?"":this._keyCodeToUILabel(d.keyCode)}_getAriaLabel(d){return d.isDuplicateModifierCase()?"":v.KeyCodeUtils.toString(d.keyCode)}_getElectronAccelerator(d){return v.KeyCodeUtils.toElectronAccelerator(d.keyCode)}_getUserSettingsLabel(d){if(d.isDuplicateModifierCase())return"";const f=v.KeyCodeUtils.toUserSettingsUS(d.keyCode);return f&&f.toLowerCase()}_isWYSIWYG(){return!0}_getDispatchPart(d){return n.getDispatchStr(d)}static getDispatchStr(d){if(d.isModifierKey())return null;let f="";return d.ctrlKey&&(f+="ctrl+"),d.shiftKey&&(f+="shift+"),d.altKey&&(f+="alt+"),d.metaKey&&(f+="meta+"),f+=v.KeyCodeUtils.toString(d.keyCode),f}_getSingleModifierDispatchPart(d){return d.keyCode===5&&!d.shiftKey&&!d.altKey&&!d.metaKey?"ctrl":d.keyCode===4&&!d.ctrlKey&&!d.altKey&&!d.metaKey?"shift":d.keyCode===6&&!d.ctrlKey&&!d.shiftKey&&!d.metaKey?"alt":d.keyCode===57&&!d.ctrlKey&&!d.shiftKey&&!d.altKey?"meta":null}static _scanCodeToKeyCode(d){const f=v.IMMUTABLE_CODE_TO_KEY_CODE[d];if(f!==-1)return f;switch(d){case 10:return 31;case 11:return 32;case 12:return 33;case 13:return 34;case 14:return 35;case 15:return 36;case 16:return 37;case 17:return 38;case 18:return 39;case 19:return 40;case 20:return 41;case 21:return 42;case 22:return 43;case 23:return 44;case 24:return 45;case 25:return 46;case 26:return 47;case 27:return 48;case 28:return 49;case 29:return 50;case 30:return 51;case 31:return 52;case 32:return 53;case 33:return 54;case 34:return 55;case 35:return 56;case 36:return 22;case 37:return 23;case 38:return 24;case 39:return 25;case 40:return 26;case 41:return 27;case 42:return 28;case 43:return 29;case 44:return 30;case 45:return 21;case 51:return 83;case 52:return 81;case 53:return 87;case 54:return 89;case 55:return 88;case 56:return 0;case 57:return 80;case 58:return 90;case 59:return 86;case 60:return 82;case 61:return 84;case 62:return 85;case 106:return 92}return 0}static _resolveSimpleUserBinding(d){if(!d)return null;if(d instanceof D.SimpleKeybinding)return d;const f=this._scanCodeToKeyCode(d.scanCode);return f===0?null:new D.SimpleKeybinding(d.ctrlKey,d.shiftKey,d.altKey,d.metaKey,f)}static resolveUserBinding(d,f){const y=(0,C.removeElementsAfterNulls)(d.map(E=>this._resolveSimpleUserBinding(E)));return y.length>0?[new n(new D.ChordKeybinding(y),f)]:[]}}e.USLayoutResolvedKeybinding=n}),define(Q[179],J([0,1,9]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.handleVetos=void 0;function D(M,C){if(M.length===0)return Promise.resolve(!1);const n=[];let I=!1;for(let d of M){if(d===!0)return Promise.resolve(!0);(0,v.isThenable)(d)&&n.push(d.then(f=>{f&&(I=!0)},f=>{C(f),I=!0}))}return v.Promises.settled(n).then(()=>I)}e.handleVetos=D}),define(Q[6],J([0,1,44,4,2,3,5]),function(H,e,v,D,M,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,n.createDecorator)("logService"),e.ILoggerService=(0,n.createDecorator)("loggerService");function I(){return new Date().toISOString()}var d;(function(u){u[u.Trace=0]="Trace",u[u.Debug=1]="Debug",u[u.Info=2]="Info",u[u.Warning=3]="Warning",u[u.Error=4]="Error",u[u.Critical=5]="Critical",u[u.Off=6]="Off"})(d=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=d.Info;function f(u,r,i){switch(r){case d.Trace:u.trace(i);break;case d.Debug:u.debug(i);break;case d.Info:u.info(i);break;case d.Warning:u.warn(i);break;case d.Error:u.error(i);break;case d.Critical:u.critical(i);break;default:throw new Error("Invalid log level")}}e.log=f;function y(u){let r="";for(let i=0;i<u.length;i++){let o=u[i];if(typeof o=="object")try{o=JSON.stringify(o)}catch(h){}r+=(i>0?" ":"")+o}return r}e.format=y;class E extends M.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new D.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(r){this.level!==r&&(this.level=r,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=E;class m extends E{constructor(r){super();this.logAlways=r}checkLogLevel(r){return this.logAlways||this.getLevel()<=r}trace(r,...i){this.checkLogLevel(d.Trace)&&this.log(d.Trace,y([r,...i]))}debug(r,...i){this.checkLogLevel(d.Debug)&&this.log(d.Debug,y([r,...i]))}info(r,...i){this.checkLogLevel(d.Info)&&this.log(d.Info,y([r,...i]))}warn(r,...i){this.checkLogLevel(d.Warning)&&this.log(d.Warning,y([r,...i]))}error(r,...i){if(this.checkLogLevel(d.Error))if(r instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=r.stack,this.log(d.Error,y(o))}else this.log(d.Error,y([r,...i]))}critical(r,...i){this.checkLogLevel(d.Critical)&&this.log(d.Critical,y([r,...i]))}flush(){}}e.AbstractMessageLogger=m;class p extends E{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r),this.useColors=!C.isWindows}trace(r,...i){this.getLevel()<=d.Trace&&(this.useColors?console.log(`[90m[main ${I()}][0m`,r,...i):console.log(`[main ${I()}]`,r,...i))}debug(r,...i){this.getLevel()<=d.Debug&&(this.useColors?console.log(`[90m[main ${I()}][0m`,r,...i):console.log(`[main ${I()}]`,r,...i))}info(r,...i){this.getLevel()<=d.Info&&(this.useColors?console.log(`[90m[main ${I()}][0m`,r,...i):console.log(`[main ${I()}]`,r,...i))}warn(r,...i){this.getLevel()<=d.Warning&&(this.useColors?console.warn(`[93m[main ${I()}][0m`,r,...i):console.warn(`[main ${I()}]`,r,...i))}error(r,...i){this.getLevel()<=d.Error&&(this.useColors?console.error(`[91m[main ${I()}][0m`,r,...i):console.error(`[main ${I()}]`,r,...i))}critical(r,...i){this.getLevel()<=d.Critical&&(this.useColors?console.error(`[90m[main ${I()}][0m`,r,...i):console.error(`[main ${I()}]`,r,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=p;class t extends E{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r)}trace(r,...i){this.getLevel()<=d.Trace&&console.log("%cTRACE","color: #888",r,...i)}debug(r,...i){this.getLevel()<=d.Debug&&console.log("%cDEBUG","background: #eee; color: #888",r,...i)}info(r,...i){this.getLevel()<=d.Info&&console.log("%c INFO","color: #33f",r,...i)}warn(r,...i){this.getLevel()<=d.Warning&&console.log("%c WARN","color: #993",r,...i)}error(r,...i){this.getLevel()<=d.Error&&console.log("%c  ERR","color: #f33",r,...i)}critical(r,...i){this.getLevel()<=d.Critical&&console.log("%cCRITI","background: #f33; color: white",r,...i)}dispose(){}flush(){}}e.ConsoleLogger=t;class w extends E{constructor(r,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=r,this.setLevel(i)}trace(r,...i){this.getLevel()<=d.Trace&&this.adapter.log(d.Trace,[this.extractMessage(r),...i])}debug(r,...i){this.getLevel()<=d.Debug&&this.adapter.log(d.Debug,[this.extractMessage(r),...i])}info(r,...i){this.getLevel()<=d.Info&&this.adapter.log(d.Info,[this.extractMessage(r),...i])}warn(r,...i){this.getLevel()<=d.Warning&&this.adapter.log(d.Warning,[this.extractMessage(r),...i])}error(r,...i){this.getLevel()<=d.Error&&this.adapter.log(d.Error,[this.extractMessage(r),...i])}critical(r,...i){this.getLevel()<=d.Critical&&this.adapter.log(d.Critical,[this.extractMessage(r),...i])}extractMessage(r){return typeof r=="string"?r:(0,v.toErrorMessage)(r,this.getLevel()<=d.Trace)}dispose(){}flush(){}}e.AdapterLogger=w;class b extends E{constructor(r){super();this.logServices=r,r.length&&this.setLevel(r[0].getLevel())}setLevel(r){for(const i of this.logServices)i.setLevel(r);super.setLevel(r)}trace(r,...i){for(const o of this.logServices)o.trace(r,...i)}debug(r,...i){for(const o of this.logServices)o.debug(r,...i)}info(r,...i){for(const o of this.logServices)o.info(r,...i)}warn(r,...i){for(const o of this.logServices)o.warn(r,...i)}error(r,...i){for(const o of this.logServices)o.error(r,...i)}critical(r,...i){for(const o of this.logServices)o.critical(r,...i)}flush(){for(const r of this.logServices)r.flush()}dispose(){for(const r of this.logServices)r.dispose()}}e.MultiplexLogService=b;class S extends M.Disposable{constructor(r){super();this.logger=r,this._register(r)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(r){this.logger.setLevel(r)}getLevel(){return this.logger.getLevel()}trace(r,...i){this.logger.trace(r,...i)}debug(r,...i){this.logger.debug(r,...i)}info(r,...i){this.logger.info(r,...i)}warn(r,...i){this.logger.warn(r,...i)}error(r,...i){this.logger.error(r,...i)}critical(r,...i){this.logger.critical(r,...i)}flush(){this.logger.flush()}}e.LogService=S;class P extends M.Disposable{constructor(r,i){super();this.logLevel=r,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(h=>h.setLevel(o))}))}getLogger(r){return this.loggers.get(r.toString())}createLogger(r,i){let o=this.loggers.get(r.toString());return o||(o=this.doCreateLogger(r,i?.always?d.Trace:this.logLevel,i),this.loggers.set(r.toString(),o),i?.always||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(r=>r.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=P;class c{constructor(){this.onDidChangeLogLevel=new D.Emitter().event}setLevel(r){}getLevel(){return d.Info}trace(r,...i){}debug(r,...i){}info(r,...i){}warn(r,...i){}error(r,...i){}critical(r,...i){}dispose(){}flush(){}}e.NullLogService=c;function a(u){if(u.verbose)return d.Trace;if(typeof u.logLevel=="string"){const r=l(u.logLevel.toLowerCase());if(r!==void 0)return r}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=a;function l(u){switch(u){case"trace":return d.Trace;case"debug":return d.Debug;case"info":return d.Info;case"warn":return d.Warning;case"error":return d.Error;case"critical":return d.Critical;case"off":return d.Off}}e.parseLogLevel=l;function s(u){switch(u){case d.Trace:return"trace";case d.Debug:return"debug";case d.Info:return"info";case d.Warning:return"warn";case d.Error:return"error";case d.Critical:return"critical";case d.Off:return"off"}}e.LogLevelToString=s});var ee=this&&this.__param||function(H,e){return function(v,D){e(v,D,H)}};define(Q[180],J([0,1,9,17,39,78,48,18,5,6]),function(H,e,v,D,M,C,n,I,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserConfigurationFileService=e.IUserConfigurationFileService=e.UserConfigurationFileServiceId=e.UserConfigurationErrorCode=void 0;var y;(function(m){m.ERROR_INVALID_FILE="ERROR_INVALID_FILE",m.ERROR_FILE_MODIFIED_SINCE="ERROR_FILE_MODIFIED_SINCE"})(y=e.UserConfigurationErrorCode||(e.UserConfigurationErrorCode={})),e.UserConfigurationFileServiceId="IUserConfigurationFileService",e.IUserConfigurationFileService=(0,d.createDecorator)(e.UserConfigurationFileServiceId);let E=class{constructor(p,t,w){this.environmentService=p,this.fileService=t,this.logService=w,this.queue=new v.Queue}async updateSettings(p,t){return this.queue.queue(()=>this.doWrite(p,t))}async doWrite(p,t){this.logService.trace(`${e.UserConfigurationFileServiceId}#write`,this.environmentService.settingsResource.toString(),p);const{value:w,mtime:b,etag:S}=await this.fileService.readFile(this.environmentService.settingsResource,{atomic:!0});let P=w.toString();const c=[];if((0,M.parse)(P,c,{allowTrailingComma:!0,allowEmptyContent:!0}),c.length)throw new Error("ERROR_INVALID_FILE");const a=this.getEdits(p,P,t)[0];if(a){P=P.substring(0,a.offset)+a.content+P.substring(a.offset+a.length);try{await this.fileService.writeFile(this.environmentService.settingsResource,D.VSBuffer.fromString(P),{etag:S,mtime:b})}catch(l){if(l.fileOperationResult===3)throw new Error("ERROR_FILE_MODIFIED_SINCE")}}}async write(p,t){return this.queue.queue(async()=>{await this.fileService.writeFile(this.environmentService.settingsResource,p,t)})}getEdits({value:p,path:t},w,b){return t.length?(0,C.setProperty)(w,t,p,b):[{content:JSON.stringify(p,null,b.insertSpaces&&b.tabSize?" ".repeat(b.tabSize):"	"),length:w.length,offset:0}]}};E=he([ee(0,n.IEnvironmentService),ee(1,I.IFileService),ee(2,f.ILogService)],E),e.UserConfigurationFileService=E}),define(Q[181],J([0,1,30,9,16,4,2,8,55,6]),function(H,e,v,D,M,C,n,I,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class y extends n.Disposable{constructor(m){super();this.logService=m,this._onDidErrorOccur=this._register(new C.Emitter),this.onDidErrorOccur=this._onDidErrorOccur.event,this._onDidChangeFile=this._register(new C.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new D.ThrottledDelayer(0))}watch(m,p){return p.recursive?this.watchRecursive(m,p):this.watchNonRecursive(m)}watchRecursive(m,p){const t={path:this.toFilePath(m),excludes:p.excludes},w=(0,v.insert)(this.recursiveFoldersToWatch,t);return this.refreshRecursiveWatchers(),(0,n.toDisposable)(()=>{w(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(()=>this.doRefreshRecursiveWatchers()).catch(m=>(0,M.onUnexpectedError)(m))}doRefreshRecursiveWatchers(){return this.recursiveWatcher||(this.recursiveWatcher=this._register(this.createRecursiveWatcher(m=>this._onDidChangeFile.fire((0,d.toFileChanges)(m)),m=>this.onWatcherLogMessage(m),this.logService.getLevel()===f.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher?.setVerboseLogging(this.logService.getLevel()===f.LogLevel.Trace)}))),this.doWatch(this.recursiveWatcher,this.recursiveFoldersToWatch)}doWatch(m,p){return m.watch(p)}watchNonRecursive(m){const p=this.createNonRecursiveWatcher(this.toFilePath(m),w=>this._onDidChangeFile.fire((0,d.toFileChanges)(w)),w=>this.onWatcherLogMessage(w),this.logService.getLevel()===f.LogLevel.Trace),t=this.logService.onDidChangeLogLevel(()=>{p.setVerboseLogging(this.logService.getLevel()===f.LogLevel.Trace)});return(0,n.combinedDisposable)(p,t)}onWatcherLogMessage(m){m.type==="error"&&this._onDidErrorOccur.fire(m.message),this.logService[m.type](m.message)}toFilePath(m){return(0,I.normalize)(m.fsPath)}}e.AbstractDiskFileSystemProvider=y}),define(Q[182],J([0,1,30,9,17,23,4,69,2,40,10,63,15,60,143,18,92,6]),function(H,e,v,D,M,C,n,I,d,f,y,E,m,p,t,w,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let P=class Ke extends d.Disposable{constructor(a){super();this.logService=a,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new n.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new n.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new n.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new n.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new n.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new n.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new n.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new D.ThrottledWorker(Ke.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ke.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ke.FILE_EVENTS_THROTTLING.coolDownDelay,l=>this._onDidFilesChange.fire(new w.FileChangesEvent(l,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new D.ThrottledWorker(Ke.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ke.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ke.FILE_EVENTS_THROTTLING.coolDownDelay,l=>this._onDidFilesChange.fire(new w.FileChangesEvent(l,!0)))),this.watchedResources=f.TernarySearchTree.forUris(l=>{const s=this.getProvider(l.scheme);return s?!this.isPathCaseSensitive(s):!1}),this.writeQueue=this._register(new D.ResourceQueue)}registerProvider(a,l){if(this.provider.has(a))throw new Error(`A filesystem provider for the scheme '${a}' is already registered.`);(0,E.mark)(`code/registerFilesystem/${a}`),this.provider.set(a,l),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:a,provider:l});const s=new d.DisposableStore;return s.add(l.onDidChangeFile(u=>this.onDidChangeFile(u,this.isPathCaseSensitive(l)))),s.add(l.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:l,scheme:a}))),typeof l.onDidErrorOccur=="function"&&s.add(l.onDidErrorOccur(u=>this._onError.fire(new Error(u)))),(0,d.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:a,provider:l}),this.provider.delete(a),(0,d.dispose)(s)})}getProvider(a){return this.provider.get(a)}async activateProvider(a){const l=[];this._onWillActivateFileSystemProvider.fire({scheme:a,join(s){l.push(s)}}),!this.provider.has(a)&&await D.Promises.settled(l)}async canHandleResource(a){return await this.activateProvider(a.scheme),this.hasProvider(a)}hasProvider(a){return this.provider.has(a.scheme)}hasCapability(a,l){const s=this.provider.get(a.scheme);return!!(s&&s.capabilities&l)}listCapabilities(){return I.Iterable.map(this.provider,([a,l])=>({scheme:a,capabilities:l.capabilities}))}async withProvider(a){if(!(0,m.isAbsolutePath)(a))throw new w.FileOperationError((0,t.localize)(0,null,this.resourceForError(a)),8);await this.activateProvider(a.scheme);const l=this.provider.get(a.scheme);if(!l){const s=new Error;throw s.name="ENOPRO",s.message=(0,t.localize)(1,null,a.toString()),s}return l}async withReadProvider(a){const l=await this.withProvider(a);if((0,w.hasOpenReadWriteCloseCapability)(l)||(0,w.hasReadWriteCapability)(l)||(0,w.hasFileReadStreamCapability)(l))return l;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(a){const l=await this.withProvider(a);if((0,w.hasOpenReadWriteCloseCapability)(l)||(0,w.hasReadWriteCapability)(l))return l;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(a,l){try{return await this.doResolveFile(a,l)}catch(s){throw(0,w.toFileSystemProviderErrorCode)(s)===w.FileSystemProviderErrorCode.FileNotFound?new w.FileOperationError((0,t.localize)(2,null,this.resourceForError(a)),1):(0,w.ensureFileSystemProviderError)(s)}}async doResolveFile(a,l){const s=await this.withProvider(a),u=this.isPathCaseSensitive(s),r=l?.resolveTo,i=l?.resolveSingleChildDescendants,o=l?.resolveMetadata,h=await s.stat(a);let g;return this.toFileStat(s,a,h,void 0,!!o,(k,L)=>(g||(g=f.TernarySearchTree.forUris(()=>!u),g.set(a,!0),r&&g.fill(!0,r)),g.get(k.resource)||g.findSuperstr(k.resource.with({query:null,fragment:null}))?!0:k.isDirectory&&i?L===1:!1))}async toFileStat(a,l,s,u,r,i){const{providerExtUri:o}=this.getExtUri(a),h={resource:l,name:o.basename(l),isFile:(s.type&w.FileType.File)!=0,isDirectory:(s.type&w.FileType.Directory)!=0,isSymbolicLink:(s.type&w.FileType.SymbolicLink)!=0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:Boolean((s.permissions??0)&w.FilePermission.Readonly)||Boolean(a.capabilities&2048),etag:(0,w.etag)({mtime:s.mtime,size:s.size})};if(h.isDirectory&&i(h,u)){try{const g=await a.readdir(l),k=await D.Promises.settled(g.map(async([L,R])=>{try{const W=o.joinPath(l,L),j=r?await a.stat(W):{type:R};return await this.toFileStat(a,W,j,g.length,r,i)}catch(W){return this.logService.trace(W),null}}));h.children=(0,v.coalesce)(k)}catch(g){this.logService.trace(g),h.children=[]}return h}return h}async resolveAll(a){return D.Promises.settled(a.map(async l=>{try{return{stat:await this.doResolveFile(l.resource,l.options),success:!0}}catch(s){return this.logService.trace(s),{stat:void 0,success:!1}}}))}async exists(a){const l=await this.withProvider(a);try{return!!await l.stat(a)}catch(s){return!1}}async canCreateFile(a,l){try{await this.doValidateCreateFile(a,l)}catch(s){return s}return!0}async doValidateCreateFile(a,l){if(!l?.overwrite&&await this.exists(a))throw new w.FileOperationError((0,t.localize)(3,null,this.resourceForError(a)),3,l)}async createFile(a,l=M.VSBuffer.fromString(""),s){await this.doValidateCreateFile(a,s);const u=await this.writeFile(a,l);return this._onDidRunOperation.fire(new w.FileOperationEvent(a,0,u)),u}async writeFile(a,l,s){const u=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),{providerExtUri:r}=this.getExtUri(u);try{await this.validateWriteFile(u,a,s)||await this.mkdirp(u,r.dirname(a));let o;if((0,w.hasReadWriteCapability)(u)&&!(l instanceof M.VSBuffer))if((0,p.isReadableStream)(l)){const h=await(0,p.peekStream)(l,3);h.ended?o=M.VSBuffer.concat(h.buffer):o=h}else o=(0,p.peekReadable)(l,h=>M.VSBuffer.concat(h),3);else o=l;!(0,w.hasOpenReadWriteCloseCapability)(u)||(0,w.hasReadWriteCapability)(u)&&o instanceof M.VSBuffer?await this.doWriteUnbuffered(u,a,s,o):await this.doWriteBuffered(u,a,s,o instanceof M.VSBuffer?(0,M.bufferToReadable)(o):o)}catch(i){throw new w.FileOperationError((0,t.localize)(4,null,this.resourceForError(a),(0,w.ensureFileSystemProviderError)(i).toString()),(0,w.toFileOperationResult)(i),s)}return this.resolve(a,{resolveMetadata:!0})}async validateWriteFile(a,l,s){if(!!s?.unlock&&!(a.capabilities&8192))throw new Error((0,t.localize)(5,null,this.resourceForError(l)));let r;try{r=await a.stat(l)}catch(i){return}if((r.type&w.FileType.Directory)!=0)throw new w.FileOperationError((0,t.localize)(6,null,this.resourceForError(l)),0,s);if(this.throwIfFileIsReadonly(l,r),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==w.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&s.mtime<r.mtime&&s.etag!==(0,w.etag)({mtime:s.mtime,size:r.size}))throw new w.FileOperationError((0,t.localize)(7,null),3,s);return r}async readFile(a,l){const s=await this.withReadProvider(a);return l?.atomic?this.doReadFileAtomic(s,a,l):this.doReadFile(s,a,l)}async doReadFileAtomic(a,l,s){return new Promise((u,r)=>{this.writeQueue.queueFor(l,this.getExtUri(a).providerExtUri).queue(async()=>{try{const i=await this.doReadFile(a,l,s);u(i)}catch(i){r(i)}})})}async doReadFile(a,l,s){const u=await this.doReadFileStream(a,l,{...s,preferUnbuffered:!0});return{...u,value:await(0,M.streamToBuffer)(u.value)}}async readFileStream(a,l){const s=await this.withReadProvider(a);return this.doReadFileStream(s,a,l)}async doReadFileStream(a,l,s){const u=new C.CancellationTokenSource,r=this.validateReadFile(l,s).then(o=>o,o=>{throw u.cancel(),o});let i;try{return typeof s?.etag=="string"&&s.etag!==w.ETAG_DISABLED&&await r,!((0,w.hasOpenReadWriteCloseCapability)(a)||(0,w.hasFileReadStreamCapability)(a))||(0,w.hasReadWriteCapability)(a)&&s?.preferUnbuffered?i=this.readFileUnbuffered(a,l,s):(0,w.hasFileReadStreamCapability)(a)?i=this.readFileStreamed(a,l,u.token,s):i=this.readFileBuffered(a,l,u.token,s),{...await r,value:i}}catch(o){i&&await(0,p.consumeStream)(i);const h=(0,t.localize)(8,null,this.resourceForError(l),(0,w.ensureFileSystemProviderError)(o).toString());throw o instanceof w.NotModifiedSinceFileOperationError?new w.NotModifiedSinceFileOperationError(h,o.stat,s):new w.FileOperationError(h,(0,w.toFileOperationResult)(o),s)}}readFileStreamed(a,l,s,u=Object.create(null)){const r=a.readFileStream(l,u,s);return(0,p.transform)(r,{data:i=>i instanceof M.VSBuffer?i:M.VSBuffer.wrap(i),error:i=>new w.FileOperationError((0,t.localize)(9,null,this.resourceForError(l),(0,w.ensureFileSystemProviderError)(i).toString()),(0,w.toFileOperationResult)(i),u)},i=>M.VSBuffer.concat(i))}readFileBuffered(a,l,s,u=Object.create(null)){const r=(0,M.newWriteableBufferStream)();return(0,b.readFileIntoStream)(a,l,r,i=>i,{...u,bufferSize:this.BUFFER_SIZE,errorTransformer:i=>new w.FileOperationError((0,t.localize)(10,null,this.resourceForError(l),(0,w.ensureFileSystemProviderError)(i).toString()),(0,w.toFileOperationResult)(i),u)},s),r}readFileUnbuffered(a,l,s){const u=(0,p.newWriteableStream)(r=>M.VSBuffer.concat(r));return(async()=>{try{let r=await a.readFile(l);typeof s?.position=="number"&&(r=r.slice(s.position)),typeof s?.length=="number"&&(r=r.slice(0,s.length)),this.validateReadFileLimits(l,r.byteLength,s),u.end(M.VSBuffer.wrap(r))}catch(r){u.error(r),u.end()}})(),u}async validateReadFile(a,l){const s=await this.resolve(a,{resolveMetadata:!0});if(s.isDirectory)throw new w.FileOperationError((0,t.localize)(11,null,this.resourceForError(a)),0,l);if(typeof l?.etag=="string"&&l.etag!==w.ETAG_DISABLED&&l.etag===s.etag)throw new w.NotModifiedSinceFileOperationError((0,t.localize)(12,null),s,l);return this.validateReadFileLimits(a,s.size,l),s}validateReadFileLimits(a,l,s){if(s?.limits){let u;if(typeof s.limits.memory=="number"&&l>s.limits.memory&&(u=9),typeof s.limits.size=="number"&&l>s.limits.size&&(u=7),typeof u=="number")throw new w.FileOperationError((0,t.localize)(13,null,this.resourceForError(a)),u)}}async canMove(a,l,s){return this.doCanMoveCopy(a,l,"move",s)}async canCopy(a,l,s){return this.doCanMoveCopy(a,l,"copy",s)}async doCanMoveCopy(a,l,s,u){if(a.toString()!==l.toString())try{const r=s==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a):await this.withReadProvider(a),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l);await this.doValidateMoveCopy(r,a,i,l,s,u)}catch(r){return r}return!0}async move(a,l,s){const u=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),i=await this.doMoveCopy(u,a,r,l,"move",!!s),o=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(a,i==="move"?2:3,o)),o}async copy(a,l,s){const u=await this.withReadProvider(a),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),i=await this.doMoveCopy(u,a,r,l,"copy",!!s),o=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(a,i==="copy"?3:2,o)),o}async doMoveCopy(a,l,s,u,r,i){if(l.toString()===u.toString())return r;const{exists:o,isSameResourceWithDifferentPathCase:h}=await this.doValidateMoveCopy(a,l,s,u,r,i);if(o&&!h&&i&&await this.del(u,{recursive:!0}),await this.mkdirp(s,this.getExtUri(s).providerExtUri.dirname(u)),r==="copy"){if(a===s&&(0,w.hasFileFolderCopyCapability)(a))await a.copy(l,u,{overwrite:i});else{const g=await this.resolve(l);g.isDirectory?await this.doCopyFolder(a,g,s,u):await this.doCopyFile(a,l,s,u)}return r}else return a===s?(await a.rename(l,u,{overwrite:i}),r):(await this.doMoveCopy(a,l,s,u,"copy",i),await this.del(l,{recursive:!0}),"copy")}async doCopyFile(a,l,s,u){if((0,w.hasOpenReadWriteCloseCapability)(a)&&(0,w.hasOpenReadWriteCloseCapability)(s))return this.doPipeBuffered(a,l,s,u);if((0,w.hasOpenReadWriteCloseCapability)(a)&&(0,w.hasReadWriteCapability)(s))return this.doPipeBufferedToUnbuffered(a,l,s,u);if((0,w.hasReadWriteCapability)(a)&&(0,w.hasOpenReadWriteCloseCapability)(s))return this.doPipeUnbufferedToBuffered(a,l,s,u);if((0,w.hasReadWriteCapability)(a)&&(0,w.hasReadWriteCapability)(s))return this.doPipeUnbuffered(a,l,s,u)}async doCopyFolder(a,l,s,u){await s.mkdir(u),Array.isArray(l.children)&&await D.Promises.settled(l.children.map(async r=>{const i=this.getExtUri(s).providerExtUri.joinPath(u,r.name);return r.isDirectory?this.doCopyFolder(a,await this.resolve(r.resource),s,i):this.doCopyFile(a,r.resource,s,i)}))}async doValidateMoveCopy(a,l,s,u,r,i){let o=!1;if(a===s){const{providerExtUri:g,isPathCaseSensitive:k}=this.getExtUri(a);if(k||(o=g.isEqual(l,u)),o&&r==="copy")throw new Error((0,t.localize)(14,null,this.resourceForError(l),this.resourceForError(u)));if(!o&&g.isEqualOrParent(u,l))throw new Error((0,t.localize)(15,null,this.resourceForError(l),this.resourceForError(u)))}const h=await this.exists(u);if(h&&!o){if(!i)throw new w.FileOperationError((0,t.localize)(16,null,this.resourceForError(l),this.resourceForError(u)),4);if(a===s){const{providerExtUri:g}=this.getExtUri(a);if(g.isEqualOrParent(l,u))throw new Error((0,t.localize)(17,null,this.resourceForError(l),this.resourceForError(u)))}}return{exists:h,isSameResourceWithDifferentPathCase:o}}getExtUri(a){const l=this.isPathCaseSensitive(a);return{providerExtUri:l?m.extUri:m.extUriIgnorePathCase,isPathCaseSensitive:l}}isPathCaseSensitive(a){return!!(a.capabilities&1024)}async createFolder(a){const l=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);await this.mkdirp(l,a);const s=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(a,0,s)),s}async mkdirp(a,l){const s=[],{providerExtUri:u}=this.getExtUri(a);for(;!u.isEqual(l,u.dirname(l));)try{if(((await a.stat(l)).type&w.FileType.Directory)==0)throw new Error((0,t.localize)(18,null,this.resourceForError(l)));break}catch(r){if((0,w.toFileSystemProviderErrorCode)(r)!==w.FileSystemProviderErrorCode.FileNotFound)throw r;s.push(u.basename(l)),l=u.dirname(l)}for(let r=s.length-1;r>=0;r--){l=u.joinPath(l,s[r]);try{await a.mkdir(l)}catch(i){if((0,w.toFileSystemProviderErrorCode)(i)!==w.FileSystemProviderErrorCode.FileExists)throw i}}}async canDelete(a,l){try{await this.doValidateDelete(a,l)}catch(s){return s}return!0}async doValidateDelete(a,l){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);if(!!l?.useTrash&&!(s.capabilities&4096))throw new Error((0,t.localize)(19,null,this.resourceForError(a)));let r;try{r=await s.stat(a)}catch(o){}if(r)this.throwIfFileIsReadonly(a,r);else throw new w.FileOperationError((0,t.localize)(20,null,this.resourceForError(a)),1);if(!!!l?.recursive){const o=await this.resolve(a);if(o.isDirectory&&Array.isArray(o.children)&&o.children.length>0)throw new Error((0,t.localize)(21,null,this.resourceForError(a)))}return s}async del(a,l){const s=await this.doValidateDelete(a,l),u=!!l?.useTrash,r=!!l?.recursive;await s.delete(a,{recursive:r,useTrash:u}),this._onDidRunOperation.fire(new w.FileOperationEvent(a,1))}onDidChangeFile(a,l){this._onDidChangeFilesRaw.fire({changes:a});let s,u;{for(const r of a)this.watchedResources.has(r.resource)?(s||(s=[]),s.push(r)):(u||(u=[]),u.push(r));s&&this._onDidFilesChange.fire(new w.FileChangesEvent(s,!l))}if(u){const r=l?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!r.work(u)&&Ke.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${u.length}, most recent change: ${u[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),r.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${r.pending}, most recent change: ${u[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(a,l={recursive:!1,excludes:[]}){const s=new d.DisposableStore;let u=!1,r=()=>{u=!0};return s.add((0,d.toDisposable)(()=>r())),this.doWatch(a,l).then(i=>{u?(0,d.dispose)(i):r=()=>(0,d.dispose)(i)},i=>this.logService.error(i)),l.recursive||(this.watchedResources.set(a,(this.watchedResources.get(a)??0)+1),s.add((0,d.toDisposable)(()=>{const i=this.watchedResources.get(a);typeof i=="number"&&(i<=1?this.watchedResources.delete(a):this.watchedResources.set(a,i-1))}))),s}async doWatch(a,l){const s=await this.withProvider(a),u=this.toWatchKey(s,a,l);let r=this.activeWatchers.get(u);return r||(r={count:0,disposable:s.watch(a,l)},this.activeWatchers.set(u,r)),r.count+=1,(0,d.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,d.dispose)(r.disposable),this.activeWatchers.delete(u)))})}toWatchKey(a,l,s){const{providerExtUri:u}=this.getExtUri(a);return[u.getComparisonKey(l),String(s.recursive),s.excludes.join()].join()}dispose(){super.dispose();for(const[,a]of this.activeWatchers)(0,d.dispose)(a.disposable);this.activeWatchers.clear()}async doWriteBuffered(a,l,s,u){return this.writeQueue.queueFor(l,this.getExtUri(a).providerExtUri).queue(async()=>{const r=await a.open(l,{create:!0,unlock:s?.unlock??!1});try{(0,p.isReadableStream)(u)||(0,p.isReadableBufferedStream)(u)?await this.doWriteStreamBufferedQueued(a,r,u):await this.doWriteReadableBufferedQueued(a,r,u)}catch(i){throw(0,w.ensureFileSystemProviderError)(i)}finally{await a.close(r)}})}async doWriteStreamBufferedQueued(a,l,s){let u=0,r;if((0,p.isReadableBufferedStream)(s)){if(s.buffer.length>0){const i=M.VSBuffer.concat(s.buffer);await this.doWriteBuffer(a,l,i,i.byteLength,u,0),u+=i.byteLength}if(s.ended)return;r=s.stream}else r=s;return new Promise((i,o)=>{(0,p.listenStream)(r,{onData:async h=>{r.pause();try{await this.doWriteBuffer(a,l,h,h.byteLength,u,0)}catch(g){return o(g)}u+=h.byteLength,setTimeout(()=>r.resume())},onError:h=>o(h),onEnd:()=>i()})})}async doWriteReadableBufferedQueued(a,l,s){let u=0,r;for(;(r=s.read())!==null;)await this.doWriteBuffer(a,l,r,r.byteLength,u,0),u+=r.byteLength}async doWriteBuffer(a,l,s,u,r,i){let o=0;for(;o<u;)o+=await a.write(l,r+o,s.buffer,i+o,u-o)}async doWriteUnbuffered(a,l,s,u){return this.writeQueue.queueFor(l,this.getExtUri(a).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(a,l,s,u))}async doWriteUnbufferedQueued(a,l,s,u){let r;u instanceof M.VSBuffer?r=u:(0,p.isReadableStream)(u)?r=await(0,M.streamToBuffer)(u):(0,p.isReadableBufferedStream)(u)?r=await(0,M.bufferedStreamToBuffer)(u):r=(0,M.readableToBuffer)(u),await a.writeFile(l,r.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1})}async doPipeBuffered(a,l,s,u){return this.writeQueue.queueFor(u,this.getExtUri(s).providerExtUri).queue(()=>this.doPipeBufferedQueued(a,l,s,u))}async doPipeBufferedQueued(a,l,s,u){let r,i;try{r=await a.open(l,{create:!1}),i=await s.open(u,{create:!0,unlock:!1});const o=M.VSBuffer.alloc(this.BUFFER_SIZE);let h=0,g=0,k=0;do k=await a.read(r,h,o.buffer,g,o.byteLength-g),await this.doWriteBuffer(s,i,o,k,h,g),h+=k,g+=k,g===o.byteLength&&(g=0);while(k>0)}catch(o){throw(0,w.ensureFileSystemProviderError)(o)}finally{await D.Promises.settled([typeof r=="number"?a.close(r):Promise.resolve(),typeof i=="number"?s.close(i):Promise.resolve()])}}async doPipeUnbuffered(a,l,s,u){return this.writeQueue.queueFor(u,this.getExtUri(s).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(a,l,s,u))}async doPipeUnbufferedQueued(a,l,s,u){return s.writeFile(u,await a.readFile(l),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(a,l,s,u){return this.writeQueue.queueFor(u,this.getExtUri(s).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(a,l,s,u))}async doPipeUnbufferedToBufferedQueued(a,l,s,u){const r=await s.open(u,{create:!0,unlock:!1});try{const i=await a.readFile(l);await this.doWriteBuffer(s,r,M.VSBuffer.wrap(i),i.byteLength,0,0)}catch(i){throw(0,w.ensureFileSystemProviderError)(i)}finally{await s.close(r)}}async doPipeBufferedToUnbuffered(a,l,s,u){const r=await(0,M.streamToBuffer)(this.readFileBuffered(a,l,C.CancellationToken.None));await this.doWriteUnbuffered(s,u,void 0,r)}throwIfFileSystemIsReadonly(a,l){if(a.capabilities&2048)throw new w.FileOperationError((0,t.localize)(22,null,this.resourceForError(l)),6);return a}throwIfFileIsReadonly(a,l){if((l.permissions??0)&w.FilePermission.Readonly)throw new w.FileOperationError((0,t.localize)(23,null,this.resourceForError(a)),6)}resourceForError(a){return a.scheme===y.Schemas.file?a.fsPath:a.toString(!0)}};P.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},P=he([ee(0,S.ILogService)],P),e.FileService=P}),define(Q[183],J([0,1,14,146,3,7,18,93,8,2,55,6,167,112]),function(H,e,v,D,M,C,n,I,d,f,y,E,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class t extends m.AbstractDiskFileSystemProviderChannel{constructor(S,P){super(S,P)}getUriTransformer(S){return p.DefaultURITransformer}transformIncoming(S,P){return C.URI.revive(P)}async delete(S,P,c){if(!c.useTrash)return super.delete(S,P,c);const a=this.transformIncoming(S,P),l=(0,d.normalize)(a.fsPath);try{await v.shell.trashItem(l)}catch(s){throw(0,n.createFileSystemProviderError)(M.isWindows?(0,D.localize)(0,null,(0,d.basename)(l)):(0,D.localize)(1,null,(0,d.basename)(l)),n.FileSystemProviderErrorCode.Unknown)}}createSessionFileWatcher(S,P){return new w(P,this.logService)}}e.DiskFileSystemProviderChannel=t;class w extends f.Disposable{constructor(S,P){super();this.sessionEmitter=S,this.logService=P,this.watcherRequests=new Map}watch(S,P,c){if(c.recursive)throw(0,n.createFileSystemProviderError)("Recursive watcher is not supported from main process",n.FileSystemProviderErrorCode.Unavailable);const a=new f.DisposableStore;this.watcherRequests.set(S,a),a.add((0,f.toDisposable)(()=>this.watcherRequests.delete(S)));const l=a.add(new I.FileWatcher((0,d.normalize)(P.fsPath),s=>this.sessionEmitter.fire((0,y.toFileChanges)(s)),s=>this.onWatcherLogMessage(s),this.logService.getLevel()===E.LogLevel.Trace));return a.add(this.logService.onDidChangeLogLevel(()=>{l.setVerboseLogging(this.logService.getLevel()===E.LogLevel.Trace)})),a}onWatcherLogMessage(S){S.type==="error"&&this.sessionEmitter.fire(S.message),this.logService[S.type](S.message)}dispose(){super.dispose(),this.watcherRequests.forEach(S=>(0,f.dispose)(S)),this.watcherRequests.clear()}}}),define(Q[94],J([0,1,28,249,9,17,4,33,8,3,15,60,21,147,18,92,93,173,174,181,44]),function(H,e,v,D,M,C,n,I,d,f,y,E,m,p,t,w,b,S,P,c,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,D.gracefulify)(v)}catch(s){console.error(`Error enabling graceful-fs: ${(0,a.toErrorMessage)(s)}`)}})();class l extends c.AbstractDiskFileSystemProvider{constructor(u,r){super(u);this.options=r,this.onDidChangeCapabilities=n.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,f.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(u){try{const{stat:r,symbolicLink:i}=await m.SymlinkSupport.stat(this.toFilePath(u));return{type:this.toType(r,i),ctime:r.birthtime.getTime(),mtime:r.mtime.getTime(),size:r.size}}catch(r){throw this.toFileSystemProviderError(r)}}async readdir(u){try{const r=await m.Promises.readdir(this.toFilePath(u),{withFileTypes:!0}),i=[];return await Promise.all(r.map(async o=>{try{let h;o.isSymbolicLink()?h=(await this.stat((0,y.joinPath)(u,o.name))).type:h=this.toType(o),i.push([o.name,h])}catch(h){this.logService.trace(h)}})),i}catch(r){throw this.toFileSystemProviderError(r)}}toType(u,r){let i;return r?.dangling?i=t.FileType.Unknown:u.isFile()?i=t.FileType.File:u.isDirectory()?i=t.FileType.Directory:i=t.FileType.Unknown,r&&(i|=t.FileType.SymbolicLink),i}async readFile(u){try{const r=this.toFilePath(u);return await m.Promises.readFile(r)}catch(r){throw this.toFileSystemProviderError(r)}}readFileStream(u,r,i){const o=(0,E.newWriteableStream)(h=>C.VSBuffer.concat(h.map(g=>C.VSBuffer.wrap(g))).buffer);return(0,w.readFileIntoStream)(this,u,o,h=>h.buffer,{...r,bufferSize:256*1024},i),o}async writeFile(u,r,i){let o;try{const h=this.toFilePath(u);if(!i.create||!i.overwrite){if(await m.Promises.exists(h)){if(!i.overwrite)throw(0,t.createFileSystemProviderError)((0,p.localize)(0,null),t.FileSystemProviderErrorCode.FileExists)}else if(!i.create)throw(0,t.createFileSystemProviderError)((0,p.localize)(1,null),t.FileSystemProviderErrorCode.FileNotFound)}o=await this.open(u,{create:!0,unlock:i.unlock}),await this.write(o,0,r,0,r.byteLength)}catch(h){throw await this.toFileSystemProviderWriteError(u,h)}finally{typeof o=="number"&&await this.close(o)}}async open(u,r){try{const i=this.toFilePath(u);if((0,t.isFileOpenForWriteOptions)(r)&&r.unlock)try{const{stat:g}=await m.SymlinkSupport.stat(i);g.mode&128||await m.Promises.chmod(i,g.mode|128)}catch(g){this.logService.trace(g)}let o;if((0,t.isFileOpenForWriteOptions)(r)){if(f.isWindows)try{await m.Promises.truncate(i,0),o="r+"}catch(g){g.code!=="ENOENT"&&this.logService.trace(g)}o||(o="w")}else o="r";const h=await m.Promises.open(i,o);return this.mapHandleToPos.set(h,0),(0,t.isFileOpenForWriteOptions)(r)&&this.writeHandles.set(h,u),h}catch(i){throw(0,t.isFileOpenForWriteOptions)(r)?await this.toFileSystemProviderWriteError(u,i):this.toFileSystemProviderError(i)}}async close(u){try{if(this.mapHandleToPos.delete(u),this.writeHandles.delete(u)&&this.canFlush)try{await m.Promises.fdatasync(u)}catch(r){this.canFlush=!1,this.logService.error(r)}return await m.Promises.close(u)}catch(r){throw this.toFileSystemProviderError(r)}}async read(u,r,i,o,h){const g=this.normalizePos(u,r);let k=null;try{const L=await m.Promises.read(u,i,o,h,g);return typeof L=="number"?k=L:k=L.bytesRead,k}catch(L){throw this.toFileSystemProviderError(L)}finally{this.updatePos(u,g,k)}}normalizePos(u,r){return r===this.mapHandleToPos.get(u)?null:r}updatePos(u,r,i){const o=this.mapHandleToPos.get(u);typeof o=="number"&&(typeof r=="number"||(typeof i=="number"?this.mapHandleToPos.set(u,o+i):this.mapHandleToPos.delete(u)))}async write(u,r,i,o,h){return(0,M.retry)(()=>this.doWrite(u,r,i,o,h),100,3)}async doWrite(u,r,i,o,h){const g=this.normalizePos(u,r);let k=null;try{const L=await m.Promises.write(u,i,o,h,g);return typeof L=="number"?k=L:k=L.bytesWritten,k}catch(L){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(u),L)}finally{this.updatePos(u,g,k)}}async mkdir(u){try{await m.Promises.mkdir(this.toFilePath(u))}catch(r){throw this.toFileSystemProviderError(r)}}async delete(u,r){try{const i=this.toFilePath(u);await this.doDelete(i,r)}catch(i){throw this.toFileSystemProviderError(i)}}async doDelete(u,r){r.recursive?await m.Promises.rm(u,m.RimRafMode.MOVE):await m.Promises.unlink(u)}async rename(u,r,i){const o=this.toFilePath(u),h=this.toFilePath(r);if(o!==h)try{await this.validateTargetDeleted(u,r,"move",i.overwrite),await m.Promises.move(o,h)}catch(g){throw(g.code==="EINVAL"||g.code==="EBUSY"||g.code==="ENAMETOOLONG")&&(g=new Error((0,p.localize)(2,null,(0,d.basename)(o),(0,d.basename)((0,d.dirname)(h)),g.toString()))),this.toFileSystemProviderError(g)}}async copy(u,r,i){const o=this.toFilePath(u),h=this.toFilePath(r);if(o!==h)try{await this.validateTargetDeleted(u,r,"copy",i.overwrite),await m.Promises.copy(o,h,{preserveSymlinks:!0})}catch(g){throw(g.code==="EINVAL"||g.code==="EBUSY"||g.code==="ENAMETOOLONG")&&(g=new Error((0,p.localize)(3,null,(0,d.basename)(o),(0,d.basename)((0,d.dirname)(h)),g.toString()))),this.toFileSystemProviderError(g)}}async validateTargetDeleted(u,r,i,o){const h=this.toFilePath(u),g=this.toFilePath(r);let k=!1;if(!!(this.capabilities&1024)||(k=(0,I.isEqual)(h,g,!0)),k&&i==="copy")throw(0,t.createFileSystemProviderError)((0,p.localize)(4,null),t.FileSystemProviderErrorCode.FileExists);if(!k&&await m.Promises.exists(g)){if(!o)throw(0,t.createFileSystemProviderError)((0,p.localize)(5,null),t.FileSystemProviderErrorCode.FileExists);await this.delete(r,{recursive:!0,useTrash:!1})}}createRecursiveWatcher(u,r,i){let o,h=!1;return this.options?.watcher?.usePolling?h=!1:h=this.options?.legacyWatcher==="on",h?o=S.FileWatcher:o=P.FileWatcher,new o(g=>u(g),g=>r(g),i,this.options?.watcher)}doWatch(u,r){const i=this.options?.watcher?.usePolling;if(i===!0)for(const o of r)o.pollingInterval=this.options?.watcher?.pollingInterval??5e3;else if(Array.isArray(i))for(const o of r)i.includes(o.path)&&(o.pollingInterval=this.options?.watcher?.pollingInterval??5e3);return super.doWatch(u,r)}createNonRecursiveWatcher(u,r,i,o){return new b.FileWatcher(u,h=>r(h),h=>i(h),o)}toFileSystemProviderError(u){if(u instanceof t.FileSystemProviderError)return u;let r;switch(u.code){case"ENOENT":r=t.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=t.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=t.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=t.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=t.FileSystemProviderErrorCode.NoPermissions;break;default:r=t.FileSystemProviderErrorCode.Unknown}return(0,t.createFileSystemProviderError)(u,r)}async toFileSystemProviderWriteError(u,r){let i=this.toFileSystemProviderError(r);if(u&&i.code===t.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await m.SymlinkSupport.stat(this.toFilePath(u));o.mode&128||(i=(0,t.createFileSystemProviderError)(r,t.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.logService.trace(o)}return i}}e.DiskFileSystemProvider=l}),define(Q[95],J([0,1,6]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function D(C,n){switch(n){case v.LogLevel.Trace:return C.trace;case v.LogLevel.Debug:return C.debug;case v.LogLevel.Info:return C.info;case v.LogLevel.Warning:return C.warn;case v.LogLevel.Error:return C.error;case v.LogLevel.Critical:return C.critical;default:throw new Error("Invalid log level")}}class M extends v.AbstractLogger{constructor(n=v.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(n),this._register(this.onDidChangeLogLevel(I=>{this._logger&&this._logger.setLevel(I)}))}set logger(n){this._logger=n;for(const{level:I,args:d}of this.buffer)D(n,I).apply(n,d);this.buffer=[]}_log(n,...I){this._logger?D(this._logger,n).apply(this._logger,I):this.getLevel()<=n&&this.buffer.push({level:n,args:I})}trace(n,...I){this._log(v.LogLevel.Trace,n,...I)}debug(n,...I){this._log(v.LogLevel.Debug,n,...I)}info(n,...I){this._log(v.LogLevel.Info,n,...I)}warn(n,...I){this._log(v.LogLevel.Warning,n,...I)}error(n,...I){this._log(v.LogLevel.Error,n,...I)}critical(n,...I){this._log(v.LogLevel.Critical,n,...I)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=M}),define(Q[184],J([0,1,9,17,15,18,5,95,6]),function(H,e,v,D,M,C,n,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const f=5*C.ByteSize.MB;let y=class extends d.AbstractLogger{constructor(p,t,w,b,S){super();this.name=p,this.resource=t,this.donotUseFormatters=b,this.fileService=S,this.backupIndex=1,this.setLevel(w),this.queue=this._register(new v.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=d.LogLevel.Trace&&this._log(d.LogLevel.Trace,(0,d.format)(arguments))}debug(){this.getLevel()<=d.LogLevel.Debug&&this._log(d.LogLevel.Debug,(0,d.format)(arguments))}info(){this.getLevel()<=d.LogLevel.Info&&this._log(d.LogLevel.Info,(0,d.format)(arguments))}warn(){this.getLevel()<=d.LogLevel.Warning&&this._log(d.LogLevel.Warning,(0,d.format)(arguments))}error(){if(this.getLevel()<=d.LogLevel.Error){const p=arguments[0];if(p instanceof Error){const t=Array.prototype.slice.call(arguments);t[0]=p.stack,this._log(d.LogLevel.Error,(0,d.format)(t))}else this._log(d.LogLevel.Error,(0,d.format)(arguments))}}critical(){this.getLevel()<=d.LogLevel.Critical&&this._log(d.LogLevel.Critical,(0,d.format)(arguments))}flush(){}async initialize(){try{await this.fileService.createFile(this.resource)}catch(p){if(p.fileOperationResult!==3)throw p}}_log(p,t){this.queue.queue(async()=>{await this.initializePromise;let w=await this.loadContent();w.length>f&&(await this.fileService.writeFile(this.getBackupResource(),D.VSBuffer.fromString(w)),w=""),this.donotUseFormatters?w+=t:w+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(p)}] ${t}
`,await this.fileService.writeFile(this.resource,D.VSBuffer.fromString(w))})}getCurrentTimestamp(){const p=b=>b<10?`0${b}`:b,t=b=>b<10?`00${b}`:b<100?`0${b}`:b,w=new Date;return`${w.getFullYear()}-${p(w.getMonth()+1)}-${p(w.getDate())} ${p(w.getHours())}:${p(w.getMinutes())}:${p(w.getSeconds())}.${t(w.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,M.joinPath)((0,M.dirname)(this.resource),`${(0,M.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch(p){return""}}stringifyLogLevel(p){switch(p){case d.LogLevel.Critical:return"critical";case d.LogLevel.Debug:return"debug";case d.LogLevel.Error:return"error";case d.LogLevel.Info:return"info";case d.LogLevel.Trace:return"trace";case d.LogLevel.Warning:return"warning"}return""}};y=he([ee(4,C.IFileService)],y),e.FileLogger=y;let E=class extends d.AbstractLoggerService{constructor(p,t,w){super(p.getLevel(),p.onDidChangeLogLevel);this.instantiationService=t,this.fileService=w}doCreateLogger(p,t,w){const b=new I.BufferLogService(t);return(0,C.whenProviderRegistered)(p,this.fileService).then(()=>b.logger=this.instantiationService.createInstance(y,w?.name||(0,M.basename)(p),p,b.getLevel(),!!w?.donotUseFormatters)),b}};E=he([ee(0,d.ILogService),ee(1,n.IInstantiationService),ee(2,C.IFileService)],E),e.FileLoggerService=E}),define(Q[185],J([0,1,4,7,6]),function(H,e,v,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class C{constructor(m){this.service=m,this.onDidChangeLogLevel=v.Event.buffer(m.onDidChangeLogLevel,!0)}listen(m,p){switch(p){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${p}`)}async call(m,p,t){switch(p){case"setLevel":return this.service.setLevel(t)}throw new Error(`Call not found: ${p}`)}}e.LogLevelChannel=C;class n{constructor(m){this.channel=m}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(m){n.setLevel(this.channel,m)}static setLevel(m,p){return m.call("setLevel",p)}}e.LogLevelChannelClient=n;class I{constructor(m){this.loggerService=m,this.loggers=new Map}listen(m,p){throw new Error(`Event not found: ${p}`)}async call(m,p,t){switch(p){case"createLogger":this.createLogger(D.URI.revive(t[0]),t[1]);return;case"log":return this.log(D.URI.revive(t[0]),t[1]);case"consoleLog":return this.consoleLog(t[0],t[1])}throw new Error(`Call not found: ${p}`)}createLogger(m,p){this.loggers.set(m.toString(),this.loggerService.createLogger(m,p))}consoleLog(m,p){let t=console.log;switch(m){case M.LogLevel.Error:t=console.error;break;case M.LogLevel.Warning:t=console.warn;break;case M.LogLevel.Info:t=console.info;break}t.call(console,...p)}log(m,p){const t=this.loggers.get(m.toString());if(!t)throw new Error("Create the logger before logging");for(const[w,b]of p)(0,M.log)(t,w,b)}}e.LoggerChannel=I;class d extends M.AbstractLoggerService{constructor(m,p,t){super(m,p);this.channel=t}createConsoleMainLogger(){return new M.AdapterLogger({log:(m,p)=>{this.channel.call("consoleLog",[m,p])}})}doCreateLogger(m,p,t){return new f(this.channel,m,p,t)}}e.LoggerChannelClient=d;class f extends M.AbstractMessageLogger{constructor(m,p,t,w){super(w?.always);this.channel=m,this.file=p,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(t),this.channel.call("createLogger",[p,w]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(m,p){const t=[[m,p]];this.isLoggerCreated?this.doLog(t):this.buffer.push(...t)}doLog(m){this.channel.call("log",[this.file,m])}}class y extends M.LogService{constructor(m,p){super(p);this.parent=m,this._register(m.onDidChangeLogLevel(t=>p.setLevel(t)))}setLevel(m){super.setLevel(m),this.parent.setLevel(m)}}e.FollowerLogService=y}),define(Q[96],J([0,1,18,6]),function(H,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function M(d,f,y,E,m){try{const p=await new Promise((w,b)=>{H(["spdlog"],w,b)});p.setFlushOn(D.LogLevel.Trace);const t=await p.createAsyncRotatingLogger(d,f,y,E);return m&&t.clearFormatters(),t}catch(p){console.error(p)}return null}function C(d,f,y,E){const m=H.__$__nodeRequire("spdlog");return m.setFlushOn(D.LogLevel.Trace),m.createRotatingLogger(d,f,y,E)}e.createRotatingLogger=C;function n(d,f,y){switch(f){case D.LogLevel.Trace:d.trace(y);break;case D.LogLevel.Debug:d.debug(y);break;case D.LogLevel.Info:d.info(y);break;case D.LogLevel.Warning:d.warn(y);break;case D.LogLevel.Error:d.error(y);break;case D.LogLevel.Critical:d.critical(y);break;default:throw new Error("Invalid log level")}}class I extends D.AbstractMessageLogger{constructor(f,y,E,m,p){super();this.buffer=[],this.setLevel(p),this._loggerCreationPromise=this._createSpdLogLogger(f,y,E,m),this._register(this.onDidChangeLogLevel(t=>{this._logger&&this._logger.setLevel(t)}))}async _createSpdLogLogger(f,y,E,m){const p=E?6:1,t=30/p*v.ByteSize.MB,w=await M(f,y,t,p,m);if(w){this._logger=w,this._logger.setLevel(this.getLevel());for(const{level:b,message:S}of this.buffer)n(this._logger,b,S);this.buffer=[]}}log(f,y){this._logger?n(this._logger,f,y):this.getLevel()<=f&&this.buffer.push({level:f,message:y})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=I}),define(Q[186],J([0,1,10,15,31,18,184,6,96]),function(H,e,v,D,M,C,n,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let f=class extends I.AbstractLoggerService{constructor(E,m){super(E.getLevel(),E.onDidChangeLogLevel);this.fileService=m}doCreateLogger(E,m,p){return E.scheme===v.Schemas.file?new d.SpdLogLogger(p?.name||(0,M.generateUuid)(),E.fsPath,!p?.donotRotate,!!p?.donotUseFormatters,m):new n.FileLogger(p?.name??(0,D.basename)(E),E,m,!!p?.donotUseFormatters,this.fileService)}};f=he([ee(0,I.ILogService),ee(1,C.IFileService)],f),e.LoggerService=f}),define(Q[187],J([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function v(n){return n.submenu!==void 0}e.isMenubarMenuItemSubmenu=v;function D(n){return n.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=D;function M(n){return n.uri!==void 0}e.isMenubarMenuItemRecentAction=M;function C(n){return!v(n)&&!D(n)&&!M(n)}e.isMenubarMenuItemAction=C}),define(Q[56],J([0,1,10,3,32,15]),function(H,e,v,D,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let n;if(typeof D.globals.vscode!="undefined"&&typeof D.globals.vscode.context!="undefined"){const I=D.globals.vscode.context.configuration();if(I)n=I.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof H?.__$__nodeRequire=="function"){const I=(0,C.dirname)(v.FileAccess.asFileUri("",H));n=H.__$__nodeRequire((0,C.joinPath)(I,"product.json").fsPath);const d=H.__$__nodeRequire((0,C.joinPath)(I,"package.json").fsPath);M.env.VSCODE_DEV&&Object.assign(n,{nameShort:`${n.nameShort} Dev`,nameLong:`${n.nameLong} Dev`,dataFolderName:`${n.dataFolderName}-dev`}),Object.assign(n,{version:d.version})}else n={},Object.keys(n).length===0&&Object.assign(n,{version:"1.63.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=n}),define(Q[22],J([0,1,5]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,v.createDecorator)("productService")}),define(Q[188],J([0,1,61,6,22]),function(H,e,v,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let C=class{constructor(I,d){this.productService=I,this.logService=d,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(I,d){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const f=/^(.*)#([^#]+)$/.exec(d);if(!f)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",d),!1;const[,y,E]=f;let m=this.trustedExtensionUrlPublicKeys.get(I);if(!m){if(m=this.productService.trustedExtensionUrlPublicKeys[I],!m||m.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",I),!1;this.trustedExtensionUrlPublicKeys.set(I,[...m])}const p=Buffer.from(decodeURIComponent(E),"base64");if(p.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",d),!1;const t=p.slice(0,6),w=p.readUIntBE(0,6),b=Date.now()-w;if(b<0||b>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",d),!1;const S=p.slice(6),P=v.createVerify("SHA256");P.write(t),P.write(Buffer.from(y)),P.end();for(let c=0;c<m.length;c++){let a=m[c];if(a!==null){if(typeof a=="string")try{a=v.createPublicKey({key:Buffer.from(a,"base64"),format:"der",type:"spki"}),m[c]=a}catch(l){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${c+1} for ${I}:`,l),m[c]=null;continue}if(P.verify(a,S))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",d),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",d),!1}};C=he([ee(0,M.IProductService),ee(1,D.ILogService)],C),e.ExtensionUrlTrustService=C}),define(Q[57],J([0,1,5]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,v.createDecorator)("protocolMainService")}),define(Q[189],J([0,1,14,2,40,10,3,15,7,31,48,6]),function(H,e,v,D,M,C,n,I,d,f,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let m=class extends D.Disposable{constructor(t,w){super();this.logService=w,this.validRoots=M.TernarySearchTree.forUris(()=>!n.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp"]),this.addValidFileRoot(d.URI.file(t.appRoot)),this.addValidFileRoot(d.URI.file(t.extensionsPath)),this.addValidFileRoot(t.globalStorageHome),this.addValidFileRoot(t.workspaceStorageHome),this.handleProtocols()}handleProtocols(){const{defaultSession:t}=v.session;t.protocol.registerFileProtocol(C.Schemas.vscodeFileResource,(w,b)=>this.handleResourceRequest(w,b)),t.protocol.interceptFileProtocol(C.Schemas.file,(w,b)=>this.handleFileRequest(w,b)),this._register((0,D.toDisposable)(()=>{t.protocol.unregisterProtocol(C.Schemas.vscodeFileResource),t.protocol.uninterceptProtocol(C.Schemas.file)}))}addValidFileRoot(t){return this.validRoots.get(t)?D.Disposable.None:(this.validRoots.set(t,!0),(0,D.toDisposable)(()=>this.validRoots.delete(t)))}handleFileRequest(t,w){const b=d.URI.parse(t.url);return this.logService.error(`Refused to load resource ${b.fsPath} from ${C.Schemas.file}: protocol (original URL: ${t.url})`),w({error:-3})}handleResourceRequest(t,w){const b=d.URI.parse(t.url),S=C.FileAccess.asFileUri(b);return this.validRoots.findSubstr(S)?w({path:S.fsPath}):this.validExtensions.has((0,I.extname)(S))?w({path:S.fsPath}):(this.logService.error(`${C.Schemas.vscodeFileResource}: Refused to load resource ${S.fsPath} from ${C.Schemas.vscodeFileResource}: protocol (original URL: ${t.url})`),w({error:-3}))}createIPCObjectUrl(){let t;const w=d.URI.from({scheme:"vscode",path:(0,f.generateUuid)()}),b=w.toString(),S=async()=>t;return v.ipcMain.handle(b,S),this.logService.trace(`IPC Object URL: Registered new channel ${b}.`),{resource:w,update:P=>t=P,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${b}.`),v.ipcMain.removeHandler(b)}}}};m=he([ee(0,y.INativeEnvironmentService),ee(1,E.ILogService)],m),e.ProtocolMainService=m}),define(Q[37],J([0,1,104,13]),function(H,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class M{constructor(){this.data=new Map}add(n,I){v.ok(D.isString(n)),v.ok(D.isObject(I)),v.ok(!this.data.has(n),"There is already an extension with this id"),this.data.set(n,I)}knows(n){return this.data.has(n)}as(n){return this.data.get(n)||null}}e.Registry=new M}),define(Q[190],J([0,1,4,37]),function(H,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function M(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class C{constructor(){this._onDidChangeSchema=new v.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(d,f){this.schemasById[M(d)]=f,this._onDidChangeSchema.fire(d)}notifySchemaChanged(d){this._onDidChangeSchema.fire(d)}getSchemaContributions(){return{schemas:this.schemasById}}}const n=new C;D.Registry.add(e.Extensions.JSONContribution,n)}),define(Q[49],J([0,1,30,4,13,135,190,37]),function(H,e,v,D,M,C,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var d;(function(P){P.Multiline="multilineText",P.Singleline="singlelineText"})(d=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var f;(function(P){P[P.APPLICATION=1]="APPLICATION",P[P.MACHINE=2]="MACHINE",P[P.WINDOW=3]="WINDOW",P[P.RESOURCE=4]="RESOURCE",P[P.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",P[P.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(f=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const y=I.Registry.as(n.Extensions.JSONContribution);class E{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new D.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new D.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:C.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(c,a=!0){this.registerConfigurations([c],a)}registerConfigurations(c,a=!0){const l=this.doRegisterConfigurations(c,a);y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}deregisterConfigurations(c){const a=this.doDeregisterConfigurations(c);y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}updateConfigurations({add:c,remove:a}){const l=[];l.push(...this.doDeregisterConfigurations(a)),l.push(...this.doRegisterConfigurations(c,!1)),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,v.distinct)(l))}registerDefaultConfigurations(c){const a=[],l=[];for(const s of c)for(const u in s)if(a.push(u),e.OVERRIDE_PROPERTY_PATTERN.test(u)){this.defaultValues[u]={...this.defaultValues[u]||{},...s[u]};const r={type:"object",default:this.defaultValues[u],description:C.localize(1,null,u),$ref:e.resourceLanguageSettingsSchemaId};l.push(p(u)),this.configurationProperties[u]=r,this.defaultLanguageConfigurationOverridesNode.properties[u]=r}else{this.defaultValues[u]=s[u];const r=this.configurationProperties[u];r&&(this.updatePropertyDefaultValue(u,r),this.updateSchema(u,r))}this.registerOverrideIdentifiers(l),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}deregisterDefaultConfigurations(c){const a=[];for(const l of c)for(const s in l)if(a.push(s),delete this.defaultValues[s],e.OVERRIDE_PROPERTY_PATTERN.test(s))delete this.configurationProperties[s],delete this.defaultLanguageConfigurationOverridesNode.properties[s];else{const u=this.configurationProperties[s];u&&(this.updatePropertyDefaultValue(s,u),this.updateSchema(s,u))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}notifyConfigurationSchemaUpdated(...c){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(c){for(const a of c)this.overrideIdentifiers.add(a);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(c,a){const l=[];return c.forEach(s=>{l.push(...this.validateAndRegisterProperties(s,a,s.extensionInfo)),this.configurationContributors.push(s),this.registerJSONConfiguration(s)}),l}doDeregisterConfigurations(c){const a=[],l=s=>{if(s.properties)for(const u in s.properties)a.push(u),delete this.configurationProperties[u],this.removeFromSchema(u,s.properties[u]);s.allOf&&s.allOf.forEach(u=>l(u))};for(const s of c){l(s);const u=this.configurationContributors.indexOf(s);u!==-1&&this.configurationContributors.splice(u,1)}return a}validateAndRegisterProperties(c,a=!0,l,s=3){s=M.isUndefinedOrNull(c.scope)?s:c.scope;let u=[],r=c.properties;if(r)for(let o in r){if(a&&b(o)){delete r[o];continue}const h=r[o];if(this.updatePropertyDefaultValue(o,h),e.OVERRIDE_PROPERTY_PATTERN.test(o)?h.scope=void 0:(h.scope=M.isUndefinedOrNull(h.scope)?s:h.scope,h.restricted=M.isUndefinedOrNull(h.restricted)?!!l?.restrictedConfigurations?.includes(o):h.restricted),r[o].hasOwnProperty("included")&&!r[o].included){this.excludedConfigurationProperties[o]=r[o],delete r[o];continue}else this.configurationProperties[o]=r[o];!r[o].deprecationMessage&&r[o].markdownDeprecationMessage&&(r[o].deprecationMessage=r[o].markdownDeprecationMessage),u.push(o)}let i=c.allOf;if(i)for(let o of i)u.push(...this.validateAndRegisterProperties(o,a,l,s));return u}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(c){const a=l=>{let s=l.properties;if(s)for(const r in s)this.updateSchema(r,s[r]);let u=l.allOf;u&&u.forEach(a)};a(c)}updateSchema(c,a){switch(e.allSettings.properties[c]=a,a.scope){case 1:e.applicationSettings.properties[c]=a;break;case 2:e.machineSettings.properties[c]=a;break;case 6:e.machineOverridableSettings.properties[c]=a;break;case 3:e.windowSettings.properties[c]=a;break;case 4:e.resourceSettings.properties[c]=a;break;case 5:e.resourceSettings.properties[c]=a,this.resourceLanguageSettingsSchema.properties[c]=a;break}}removeFromSchema(c,a){switch(delete e.allSettings.properties[c],a.scope){case 1:delete e.applicationSettings.properties[c];break;case 2:delete e.machineSettings.properties[c];break;case 6:delete e.machineOverridableSettings.properties[c];break;case 3:delete e.windowSettings.properties[c];break;case 4:case 5:delete e.resourceSettings.properties[c];break}}updateOverridePropertyPatternKey(){for(const c of this.overrideIdentifiers.values()){const a=`[${c}]`,l={type:"object",description:C.localize(2,null),errorMessage:C.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(a,l),e.allSettings.properties[a]=l,e.applicationSettings.properties[a]=l,e.machineSettings.properties[a]=l,e.machineOverridableSettings.properties[a]=l,e.windowSettings.properties[a]=l,e.resourceSettings.properties[a]=l}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(c,a){let l=this.defaultValues[c];M.isUndefined(l)&&(l=a.default),M.isUndefined(l)&&(l=t(a.type)),a.default=l}}const m="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(m);function p(P){return P.substring(1,P.length-1)}e.overrideIdentifierFromKey=p;function t(P){switch(Array.isArray(P)?P[0]:P){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=t;const w=new E;I.Registry.add(e.Extensions.Configuration,w);function b(P){return P.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(P)?C.localize(5,null,P):w.getConfigurationProperties()[P]!==void 0?C.localize(6,null,P):null:C.localize(4,null)}e.validateProperty=b;function S(){const P=[],c=w.getConfigurationProperties();for(const a of Object.keys(c))P.push([a,c[a].scope]);return P.push(["launch",4]),P.push(["task",4]),P}e.getScopes=S}),define(Q[19],J([0,1,13,7,49,5,37]),function(H,e,v,D,M,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,C.createDecorator)("configurationService");function I(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof D.URI)}e.isConfigurationOverrides=I;var d;(function(l){l[l.USER=1]="USER",l[l.USER_LOCAL=2]="USER_LOCAL",l[l.USER_REMOTE=3]="USER_REMOTE",l[l.WORKSPACE=4]="WORKSPACE",l[l.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",l[l.DEFAULT=6]="DEFAULT",l[l.MEMORY=7]="MEMORY"})(d=e.ConfigurationTarget||(e.ConfigurationTarget={}));function f(l){switch(l){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=f;function y(l,s){const u=[];for(const r of Object.keys(l))if(M.OVERRIDE_PROPERTY_PATTERN.test(r)){const i={};for(const o in l[r])i[o]=l[r][o];u.push({identifiers:[(0,M.overrideIdentifierFromKey)(r).trim()],keys:Object.keys(i),contents:E(i,s)})}return u}e.toOverrides=y;function E(l,s){const u=Object.create(null);for(let r in l)m(u,r,l[r],s);return u}e.toValuesTree=E;function m(l,s,u,r){const i=s.split("."),o=i.pop();let h=l;for(let g=0;g<i.length;g++){let k=i[g],L=h[k];switch(typeof L){case"undefined":L=h[k]=Object.create(null);break;case"object":break;default:r(`Ignoring ${s} as ${i.slice(0,g+1).join(".")} is ${JSON.stringify(L)}`);return}h=L}if(typeof h=="object"&&h!==null)try{h[o]=u}catch(g){r(`Ignoring ${s} as ${i.join(".")} is ${JSON.stringify(h)}`)}else r(`Ignoring ${s} as ${i.join(".")} is ${JSON.stringify(h)}`)}e.addToValueTree=m;function p(l,s){const u=s.split(".");t(l,u)}e.removeFromValueTree=p;function t(l,s){const u=s.shift();if(s.length===0){delete l[u];return}if(Object.keys(l).indexOf(u)!==-1){const r=l[u];typeof r=="object"&&!Array.isArray(r)&&(t(r,s),Object.keys(r).length===0&&delete l[u])}}function w(l,s,u){function r(h,g){let k=h;for(const L of g){if(typeof k!="object"||k===null)return;k=k[L]}return k}const i=s.split("."),o=r(l,i);return typeof o=="undefined"?u:o}e.getConfigurationValue=w;function b(l,s,u){Object.keys(s).forEach(r=>{r!=="__proto__"&&(r in l?v.isObject(l[r])&&v.isObject(s[r])?b(l[r],s[r],u):u&&(l[r]=s[r]):l[r]=s[r])})}e.merge=b;function S(){const l=n.Registry.as(M.Extensions.Configuration).getConfigurationProperties();return Object.keys(l)}e.getConfigurationKeys=S;function P(){const l=Object.create(null),s=n.Registry.as(M.Extensions.Configuration).getConfigurationProperties();for(let u in s){let r=s[u].default;m(l,u,r,i=>console.error(`Conflict in default settings: ${i}`))}return l}e.getDefaultValues=P;function c(l){return`[${l}]`}e.keyFromOverrideIdentifier=c;function a(l,s,u){const r=l.inspect(s),i=l.inspect(u);return typeof r.userValue!="undefined"||typeof r.workspaceValue!="undefined"||typeof r.workspaceFolderValue!="undefined"?r.value:typeof i.userValue!="undefined"||typeof i.workspaceValue!="undefined"||typeof i.workspaceFolderValue!="undefined"?i.value:r.defaultValue}e.getMigratedSettingValue=a}),define(Q[191],J([0,1,30,4,39,2,40,47,13,7,19,49,37]),function(H,e,v,D,M,C,n,I,d,f,y,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class p{constructor(r={},i=[],o=[]){this._contents=r,this._keys=i,this._overrides=o,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(r){return r?(0,y.getConfigurationValue)(this.contents,r):this.contents}getOverrideValue(r,i){const o=this.getContentsForOverrideIdentifer(i);return o?r?(0,y.getConfigurationValue)(o,r):o:void 0}getKeysForOverrideIdentifier(r){const i=[];for(const o of this.overrides)o.identifiers.includes(r)&&i.push(...o.keys);return v.distinct(i)}getAllOverrideIdentifiers(){const r=[];for(const i of this.overrides)r.push(...i.identifiers);return v.distinct(r)}override(r){let i=this.overrideConfigurations.get(r);return i||(i=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,i)),i}merge(...r){const i=I.deepClone(this.contents),o=I.deepClone(this.overrides),h=[...this.keys];for(const g of r){this.mergeContents(i,g.contents);for(const k of g.overrides){const[L]=o.filter(R=>v.equals(R.identifiers,k.identifiers));L?(this.mergeContents(L.contents,k.contents),L.keys.push(...k.keys),L.keys=v.distinct(L.keys)):o.push(I.deepClone(k))}for(const k of g.keys)h.indexOf(k)===-1&&h.push(k)}return new p(i,h,o)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(r){const i=this.getContentsForOverrideIdentifer(r);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let o={};for(const h of v.distinct([...Object.keys(this.contents),...Object.keys(i)])){let g=this.contents[h],k=i[h];k&&(typeof g=="object"&&typeof k=="object"?(g=I.deepClone(g),this.mergeContents(g,k)):g=k),o[h]=g}return new p(o,this.keys,this.overrides)}mergeContents(r,i){for(const o of Object.keys(i)){if(o in r&&d.isObject(r[o])&&d.isObject(i[o])){this.mergeContents(r[o],i[o]);continue}r[o]=I.deepClone(i[o])}}checkAndFreeze(r){return this.isFrozen&&!Object.isFrozen(r)?I.deepFreeze(r):r}getContentsForOverrideIdentifer(r){let i=null,o=null;const h=g=>{g&&(o?this.mergeContents(o,g):o=g)};for(const g of this.overrides)v.equals(g.identifiers,[r])?i=g.contents:g.identifiers.includes(r)&&h(g.contents);return h(i),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,i){this.addKey(r),(0,y.addToValueTree)(this.contents,r,i,o=>{throw new Error(o)})}removeValue(r){this.removeKey(r)&&(0,y.removeFromValueTree)(this.contents,r)}addKey(r){let i=this.keys.length;for(let o=0;o<i;o++)r.indexOf(this.keys[o])===0&&(i=o);this.keys.splice(i,1,r)}removeKey(r){let i=this.keys.indexOf(r);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=p;class t extends p{constructor(){const r=(0,y.getDefaultValues)(),i=(0,y.getConfigurationKeys)(),o=[];for(const h of Object.keys(r))E.OVERRIDE_PROPERTY_PATTERN.test(h)&&o.push({identifiers:[(0,E.overrideIdentifierFromKey)(h).trim()],keys:Object.keys(r[h]),contents:(0,y.toValuesTree)(r[h],g=>console.error(`Conflict in default settings file: ${g}`))});super(r,i,o)}}e.DefaultConfigurationModel=t;class w{constructor(r){this._name=r,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new p}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,i){if(!d.isUndefinedOrNull(r)){const o=this.doParseContent(r);this.parseRaw(o,i)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,i){this._raw=r;const{contents:o,keys:h,overrides:g,restricted:k}=this.doParseRaw(r,i);this._configurationModel=new p(o,h,g),this._restrictedConfigurations=k||[]}doParseContent(r){let i={},o=null,h=[],g=[],k=[];function L(W){Array.isArray(h)?h.push(W):o!==null&&(h[o]=W)}let R={onObjectBegin:()=>{let W={};L(W),g.push(h),h=W,o=null},onObjectProperty:W=>{o=W},onObjectEnd:()=>{h=g.pop()},onArrayBegin:()=>{let W=[];L(W),g.push(h),h=W,o=null},onArrayEnd:()=>{h=g.pop()},onLiteralValue:L,onError:(W,j,x)=>{k.push({error:W,offset:j,length:x})}};if(r)try{M.visit(r,R),i=h[0]||{}}catch(W){console.error(`Error while parsing settings file ${this._name}: ${W}`),this._parseErrors=[W]}return i}doParseRaw(r,i){const o=m.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),h=this.filter(r,o,!0,i);r=h.raw;const g=(0,y.toValuesTree)(r,R=>console.error(`Conflict in settings file ${this._name}: ${R}`)),k=Object.keys(r),L=(0,y.toOverrides)(r,R=>console.error(`Conflict in settings file ${this._name}: ${R}`));return{contents:g,keys:k,overrides:L,restricted:h.restricted}}filter(r,i,o,h){if(!h?.scopes&&!h?.skipRestricted)return{raw:r,restricted:[]};const g={},k=[];for(let L in r)if(E.OVERRIDE_PROPERTY_PATTERN.test(L)&&o){const R=this.filter(r[L],i,!1,h);g[L]=R.raw,k.push(...R.restricted)}else{const R=i[L],W=R?typeof R.scope!="undefined"?R.scope:3:void 0;R?.restricted&&k.push(L),(W===void 0||h.scopes===void 0||h.scopes.includes(W))&&(h.skipRestricted&&R?.restricted||(g[L]=r[L]))}return{raw:g,restricted:k}}}e.ConfigurationModelParser=w;class b extends C.Disposable{constructor(r,i,o,h){super();this.userSettingsResource=r,this.scopes=i,this.fileService=h,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new w(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(o.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(D.Event.filter(this.fileService.onDidFilesChange,g=>g.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(r){return new p}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=b;class S{constructor(r,i,o=new p,h=new p,g=new n.ResourceMap,k=new p,L=new n.ResourceMap,R=!0){this._defaultConfiguration=r,this._localUserConfiguration=i,this._remoteUserConfiguration=o,this._workspaceConfiguration=h,this._folderConfigurations=g,this._memoryConfiguration=k,this._memoryConfigurationByResource=L,this._freeze=R,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new n.ResourceMap,this._userConfiguration=null}getValue(r,i,o){return this.getConsolidateConfigurationModel(i,o).getValue(r)}updateValue(r,i,o={}){let h;o.resource?(h=this._memoryConfigurationByResource.get(o.resource),h||(h=new p,this._memoryConfigurationByResource.set(o.resource,h))):h=this._memoryConfiguration,i===void 0?h.removeValue(r):h.setValue(r,i),o.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,i,o){const h=this.getConsolidateConfigurationModel(i,o),g=this.getFolderConfigurationModelForResource(i.resource,o),k=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,L=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this._defaultConfiguration.freeze().getValue(r),R=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.userConfiguration.freeze().getValue(r),W=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.localUserConfiguration.freeze().getValue(r),j=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.remoteUserConfiguration.freeze().getValue(r),x=o?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this._workspaceConfiguration.freeze().getValue(r):void 0,ne=g?i.overrideIdentifier?g.freeze().override(i.overrideIdentifier).getValue(r):g.freeze().getValue(r):void 0,oe=i.overrideIdentifier?k.override(i.overrideIdentifier).getValue(r):k.getValue(r),G=h.getValue(r),T=v.distinct(v.flatten(h.overrides.map(B=>B.identifiers))).filter(B=>h.getOverrideValue(r,B)!==void 0);return{defaultValue:L,userValue:R,userLocalValue:W,userRemoteValue:j,workspaceValue:x,workspaceFolderValue:ne,memoryValue:oe,value:G,default:L!==void 0?{value:this._defaultConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,user:R!==void 0?{value:this.userConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,userLocal:W!==void 0?{value:this.localUserConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,userRemote:j!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,workspace:x!==void 0?{value:this._workspaceConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,workspaceFolder:ne!==void 0?{value:g?.freeze().getValue(r),override:i.overrideIdentifier?g?.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,memory:oe!==void 0?{value:k.getValue(r),override:i.overrideIdentifier?k.getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:T.length?T:void 0}}keys(r){const i=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,i){this._folderConfigurations.set(r,i),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,i){const o=[];for(const h of i)if(E.OVERRIDE_PROPERTY_PATTERN.test(h)){const g=(0,E.overrideIdentifierFromKey)(h),k=this._defaultConfiguration.getKeysForOverrideIdentifier(g),L=r.getKeysForOverrideIdentifier(g),R=[...L.filter(W=>k.indexOf(W)===-1),...k.filter(W=>L.indexOf(W)===-1),...k.filter(W=>!I.equals(this._defaultConfiguration.override(g).getValue(W),r.override(g).getValue(W)))];o.push([g,R])}return this.updateDefaultConfiguration(r),{keys:i,overrides:o}}compareAndUpdateLocalUserConfiguration(r){const{added:i,updated:o,removed:h,overrides:g}=l(this.localUserConfiguration,r),k=[...i,...o,...h];return k.length&&this.updateLocalUserConfiguration(r),{keys:k,overrides:g}}compareAndUpdateRemoteUserConfiguration(r){const{added:i,updated:o,removed:h,overrides:g}=l(this.remoteUserConfiguration,r);let k=[...i,...o,...h];return k.length&&this.updateRemoteUserConfiguration(r),{keys:k,overrides:g}}compareAndUpdateWorkspaceConfiguration(r){const{added:i,updated:o,removed:h,overrides:g}=l(this.workspaceConfiguration,r);let k=[...i,...o,...h];return k.length&&this.updateWorkspaceConfiguration(r),{keys:k,overrides:g}}compareAndUpdateFolderConfiguration(r,i){const o=this.folderConfigurations.get(r),{added:h,updated:g,removed:k,overrides:L}=l(o,i);let R=[...h,...g,...k];return(R.length||!o)&&this.updateFolderConfiguration(r,i),{keys:R,overrides:L}}compareAndDeleteFolderConfiguration(r){const i=this.folderConfigurations.get(r);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:o,updated:h,removed:g,overrides:k}=l(i,void 0);return{keys:[...o,...h,...g],overrides:k}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(r,i){let o=this.getConsolidatedConfigurationModelForResource(r,i);return r.overrideIdentifier?o.override(r.overrideIdentifier):o}getConsolidatedConfigurationModelForResource({resource:r},i){let o=this.getWorkspaceConsolidatedConfiguration();if(i&&r){const h=i.getFolder(r);h&&(o=this.getFolderConsolidatedConfiguration(h.uri)||o);const g=this._memoryConfigurationByResource.get(r);g&&(o=o.merge(g))}return o}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let i=this._foldersConsolidatedConfigurations.get(r);if(!i){const o=this.getWorkspaceConsolidatedConfiguration(),h=this._folderConfigurations.get(r);h?(i=o.merge(h),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(r,i)):i=o}return i}getFolderConfigurationModelForResource(r,i){if(i&&r){const o=i.getFolder(r);if(o)return this._folderConfigurations.get(o.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,i)=>{const{contents:o,overrides:h,keys:g}=this._folderConfigurations.get(i);return r.push([i,{contents:o,overrides:h,keys:g}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>r.add(i)),this.userConfiguration.freeze().keys.forEach(i=>r.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(o=>r.add(o))),[...r.values()]}allOverrideIdentifiers(){const r=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(o=>r.add(o))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(o=>i.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(o=>i.add(o)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(o=>i.add(o)),this._folderConfigurations.forEach(o=>o.getKeysForOverrideIdentifier(r).forEach(h=>i.add(h))),[...i.values()]}static parse(r){const i=this.parseConfigurationModel(r.defaults),o=this.parseConfigurationModel(r.user),h=this.parseConfigurationModel(r.workspace),g=r.folders.reduce((k,L)=>(k.set(f.URI.revive(L[0]),this.parseConfigurationModel(L[1])),k),new n.ResourceMap);return new S(i,o,new p,h,g,new p,new n.ResourceMap,!1)}static parseConfigurationModel(r){return new p(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=S;function P(...u){if(u.length===0)return{keys:[],overrides:[]};if(u.length===1)return u[0];const r=new Set,i=new Map;for(const h of u)h.keys.forEach(g=>r.add(g)),h.overrides.forEach(([g,k])=>{const L=(0,n.getOrSet)(i,g,new Set);k.forEach(R=>L.add(R))});const o=[];return i.forEach((h,g)=>o.push([g,[...h.values()]])),{keys:[...r.values()],overrides:o}}e.mergeChanges=P;class c{constructor(r,i,o,h){this.change=r,this.previous=i,this.currentConfiguraiton=o,this.currentWorkspace=h,this._previousConfiguration=void 0;const g=new Set;r.keys.forEach(L=>g.add(L)),r.overrides.forEach(([,L])=>L.forEach(R=>g.add(R))),this.affectedKeys=[...g.values()];const k=new p;this.affectedKeys.forEach(L=>k.setValue(L,{})),this.affectedKeysTree=k.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=S.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(r,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,r)){if(i){const o=this.previousConfiguration?this.previousConfiguration.getValue(r,i,this.previous?.workspace):void 0,h=this.currentConfiguraiton.getValue(r,i,this.currentWorkspace);return!I.equals(o,h)}return!0}return!1}doesAffectedKeysTreeContains(r,i){let o=(0,y.toValuesTree)({[i]:!0},()=>{}),h;for(;typeof o=="object"&&(h=Object.keys(o)[0]);){if(r=r[h],!r)return!1;o=o[h]}return!0}}e.ConfigurationChangeEvent=c;class a extends c{constructor(r,i,o,h){super({keys:r.allKeys(),overrides:[]},void 0,r,i);this.source=o,this.sourceConfig=h}}e.AllKeysConfigurationChangeEvent=a;function l(u,r){const{added:i,removed:o,updated:h}=s(r,u),g=[],k=u?.getAllOverrideIdentifiers()||[],L=r?.getAllOverrideIdentifiers()||[];if(r){const R=L.filter(W=>!k.includes(W));for(const W of R)g.push([W,r.getKeysForOverrideIdentifier(W)])}if(u){const R=k.filter(W=>!L.includes(W));for(const W of R)g.push([W,u.getKeysForOverrideIdentifier(W)])}if(r&&u){for(const R of k)if(L.includes(R)){const W=s({contents:u.getOverrideValue(void 0,R)||{},keys:u.getKeysForOverrideIdentifier(R)},{contents:r.getOverrideValue(void 0,R)||{},keys:r.getKeysForOverrideIdentifier(R)});g.push([R,[...W.added,...W.removed,...W.updated]])}}return{added:i,removed:o,updated:h,overrides:g}}function s(u,r){const i=u?r?u.keys.filter(g=>r.keys.indexOf(g)===-1):[...u.keys]:[],o=r?u?r.keys.filter(g=>u.keys.indexOf(g)===-1):[...r.keys]:[],h=[];if(u&&r){for(const g of r.keys)if(u.keys.indexOf(g)!==-1){const k=(0,y.getConfigurationValue)(r.contents,g),L=(0,y.getConfigurationValue)(u.contents,g);I.equals(k,L)||h.push(g)}}return{added:i,removed:o,updated:h}}}),define(Q[192],J([0,1,9,4,2,15,19,191,49,37]),function(H,e,v,D,M,C,n,I,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class y extends M.Disposable{constructor(m,p){super();this.settingsResource=m,this._onDidChangeConfiguration=this._register(new D.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new I.UserSettings(this.settingsResource,void 0,C.extUriBiasedIgnorePathCase,p)),this.configuration=new I.Configuration(new I.DefaultConfigurationModel,new I.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new v.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(f.Registry.as(d.Extensions.Configuration).onDidUpdateConfiguration(t=>this.onDidDefaultConfigurationChange(t))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const m=await this.userConfiguration.loadConfiguration();this.configuration=new I.Configuration(new I.DefaultConfigurationModel,m)}getConfigurationData(){return this.configuration.toData()}getValue(m,p){const t=typeof m=="string"?m:void 0,w=(0,n.isConfigurationOverrides)(m)?m:(0,n.isConfigurationOverrides)(p)?p:{};return this.configuration.getValue(t,w,void 0)}updateValue(m,p,t,w){return Promise.reject(new Error("not supported"))}inspect(m){return this.configuration.inspect(m,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const m=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(m)}onDidChangeUserConfiguration(m){const p=this.configuration.toData(),t=this.configuration.compareAndUpdateLocalUserConfiguration(m);this.trigger(t,p,1)}onDidDefaultConfigurationChange(m){const p=this.configuration.toData(),t=this.configuration.compareAndUpdateDefaultConfiguration(new I.DefaultConfigurationModel,m);this.trigger(t,p,6)}trigger(m,p,t){const w=new I.ConfigurationChangeEvent(m,{data:p},this.configuration);w.source=t,w.sourceConfig=this.getTargetConfiguration(t),this._onDidChangeConfiguration.fire(w)}getTargetConfiguration(m){switch(m){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=y}),define(Q[193],J([0,1,5]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,v.createDecorator)("remoteAuthorityResolverService");var D;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound"})(D=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class M extends Error{constructor(n,I=D.Unknown,d){super(n);this._message=n,this._code=I,this._detail=d,this.isHandled=I===D.NotAvailable&&d===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,M.prototype)}static isTemporarilyNotAvailable(n){return n instanceof M&&n._code===D.TemporarilyNotAvailable}static isNoResolverFound(n){return n instanceof M&&n._code===D.NoResolverFound}static isHandled(n){return n instanceof M&&n.isHandled}}e.RemoteAuthorityResolverError=M}),define(Q[194],J([0,1,9,17,23,16,4,2,31,84,193]),function(H,e,v,D,M,C,n,I,d,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const E=30*1e3;var m;(function(F){F[F.Management=1]="Management",F[F.ExtensionHost=2]="ExtensionHost",F[F.Tunnel=3]="Tunnel"})(m=e.ConnectionType||(e.ConnectionType={}));function p(F){switch(F){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function t(F){const A=new M.CancellationTokenSource;return setTimeout(()=>A.cancel(),F),A.token}function w(F,A){if(F.isCancellationRequested||A.isCancellationRequested)return M.CancellationToken.Cancelled;const O=new M.CancellationTokenSource;return F.onCancellationRequested(()=>O.cancel()),A.onCancellationRequested(()=>O.cancel()),O.token}class b{constructor(A){this._state="pending",this._disposables=new I.DisposableStore,this.promise=new Promise((O,$)=>{this._resolvePromise=O,this._rejectPromise=$}),A.isCancellationRequested?this._timeout():this._disposables.add(A.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(A){this._state==="pending"?this._disposables.add(A):A.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const A=new Error("Time limit reached");return A.code="ETIMEDOUT",A.syscall="connect",A}resolve(A){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(A))}reject(A){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(A))}}function S(F,A){const O=new b(A);return O.registerDisposable(F.onControlMessage($=>{const X=JSON.parse($.toString()),V=q(X);V?O.reject(V):O.resolve(X)})),O.promise}function P(F,A,O,$,X,V){const z=new b(V);return A.connect(O,$,X,(Z,te)=>{z.didTimeout?(Z&&F.error(Z),te?.dispose()):Z||!te?z.reject(Z):z.resolve(te)}),z.promise}function c(F,A){const O=new b(A);return F.then($=>{O.didTimeout||O.resolve($)},$=>{O.didTimeout||O.reject($)}),O.promise}async function a(F,A,O,$){const X=_(F,A);F.logService.trace(`${X} 1/6. invoking socketFactory.connect().`);let V;try{V=await P(F.logService,F.socketFactory,F.host,F.port,`reconnectionToken=${F.reconnectionToken}&reconnection=${F.reconnectionProtocol?"true":"false"}`,$)}catch(se){throw F.logService.error(`${X} socketFactory.connect() failed or timed out. Error:`),F.logService.error(se),se}F.logService.trace(`${X} 2/6. socketFactory.connect() was successful.`);let z,Z;F.reconnectionProtocol?(F.reconnectionProtocol.beginAcceptReconnection(V,null),z=F.reconnectionProtocol,Z=!1):(z=new f.PersistentProtocol(V,null),Z=!0),F.logService.trace(`${X} 3/6. sending AuthRequest control message.`);const te=await c(F.signService.createNewMessage((0,d.generateUuid)()),$),ce={type:"auth",auth:F.connectionToken||"00000000000000000000",data:te.data};z.sendControl(D.VSBuffer.fromString(JSON.stringify(ce)));try{const se=await S(z,w($,t(1e4)));if(se.type!=="sign"||typeof se.data!="string"){const de=new Error("Unexpected handshake message");throw de.code="VSCODE_CONNECTION_ERROR",de}if(F.logService.trace(`${X} 4/6. received SignRequest control message.`),!await c(F.signService.validate(te,se.signedData),$)){const de=new Error("Refused to connect to unsupported server");throw de.code="VSCODE_CONNECTION_ERROR",de}const ae=await c(F.signService.sign(se.data),$),ue={type:"connectionType",commit:F.commit,signedData:ae,desiredConnectionType:A};return O&&(ue.args=O),F.logService.trace(`${X} 5/6. sending ConnectionTypeRequest control message.`),z.sendControl(D.VSBuffer.fromString(JSON.stringify(ue))),{protocol:z,ownsProtocol:Z}}catch(se){throw se&&se.code==="ETIMEDOUT"&&(F.logService.error(`${X} the handshake timed out. Error:`),F.logService.error(se)),se&&se.code==="VSCODE_CONNECTION_ERROR"&&(F.logService.error(`${X} received error control message when negotiating connection. Error:`),F.logService.error(se)),Z&&B(z),se}}async function l(F,A,O,$){const X=Date.now(),V=_(F,A),{protocol:z,ownsProtocol:Z}=await a(F,A,O,$),te=new b($);return te.registerDisposable(z.onControlMessage(ce=>{const se=JSON.parse(ce.toString()),ie=q(se);ie?(F.logService.error(`${V} received error control message when negotiating connection. Error:`),F.logService.error(ie),Z&&B(z),te.reject(ie)):(F.reconnectionProtocol&&F.reconnectionProtocol.endAcceptReconnection(),F.logService.trace(`${V} 6/6. handshake finished, connection is up and running after ${Y(X)}!`),te.resolve({protocol:z,firstMessage:se}))})),te.promise}async function s(F,A){const{protocol:O}=await l(F,1,void 0,A);return{protocol:O}}async function u(F,A,O){const{protocol:$,firstMessage:X}=await l(F,2,A,O),V=X&&X.debugPort;return{protocol:$,debugPort:V}}async function r(F,A,O){const $=Date.now(),X=_(F,3),{protocol:V}=await a(F,3,A,O);return F.logService.trace(`${X} 6/6. handshake finished, connection is up and running after ${Y($)}!`),V}async function i(F,A,O){const{host:$,port:X,connectionToken:V}=await F.addressProvider.getAddress();return{commit:F.commit,host:$,port:X,connectionToken:V,reconnectionToken:A,reconnectionProtocol:O,socketFactory:F.socketFactory,signService:F.signService,logService:F.logService}}async function o(F,A,O){try{const $=(0,d.generateUuid)(),X=await i(F,$,null),{protocol:V}=await s(X,M.CancellationToken.None);return new G(F,A,O,$,V)}catch($){throw F.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),F.logService.error($),oe.triggerPermanentFailure(0,0,y.RemoteAuthorityResolverError.isHandled($)),$}}e.connectRemoteAgentManagement=o;async function h(F,A){try{const O=(0,d.generateUuid)(),$=await i(F,O,null),{protocol:X,debugPort:V}=await u($,A,M.CancellationToken.None);return new T(F,A,O,X,V)}catch(O){throw F.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),F.logService.error(O),oe.triggerPermanentFailure(0,0,y.RemoteAuthorityResolverError.isHandled(O)),O}}e.connectRemoteAgentExtensionHost=h;async function g(F,A,O){const $=await i(F,(0,d.generateUuid)(),null);return await r($,{host:A,port:O},M.CancellationToken.None)}e.connectRemoteAgentTunnel=g;function k(F){return(0,v.createCancelablePromise)(A=>new Promise((O,$)=>{const X=setTimeout(O,F*1e3);A.onCancellationRequested(()=>{clearTimeout(X),O()})}))}var L;(function(F){F[F.ConnectionLost=0]="ConnectionLost",F[F.ReconnectionWait=1]="ReconnectionWait",F[F.ReconnectionRunning=2]="ReconnectionRunning",F[F.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",F[F.ConnectionGain=4]="ConnectionGain"})(L=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class R{constructor(A,O){this.reconnectionToken=A,this.millisSinceLastIncomingData=O,this.type=0}}e.ConnectionLostEvent=R;class W{constructor(A,O,$,X){this.reconnectionToken=A,this.millisSinceLastIncomingData=O,this.durationSeconds=$,this.cancellableTimer=X,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=W;class j{constructor(A,O,$){this.reconnectionToken=A,this.millisSinceLastIncomingData=O,this.attempt=$,this.type=2}}e.ReconnectionRunningEvent=j;class x{constructor(A,O,$){this.reconnectionToken=A,this.millisSinceLastIncomingData=O,this.attempt=$,this.type=4}}e.ConnectionGainEvent=x;class ne{constructor(A,O,$,X){this.reconnectionToken=A,this.millisSinceLastIncomingData=O,this.attempt=$,this.handled=X,this.type=3}}e.ReconnectionPermanentFailureEvent=ne;class oe extends I.Disposable{constructor(A,O,$,X){super();this._connectionType=A,this._onDidStateChange=this._register(new n.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=O,this.reconnectionToken=$,this.protocol=X,this._isReconnecting=!1,this._onDidStateChange.fire(new x(this.reconnectionToken,0,0)),this._register(X.onSocketClose(V=>{const z=N(this._connectionType,this.reconnectionToken,!0);V?V.type===0?(this._options.logService.info(`${z} received socket close event (hadError: ${V.hadError}).`),V.error&&this._options.logService.error(V.error)):(this._options.logService.info(`${z} received socket close event (wasClean: ${V.wasClean}, code: ${V.code}, reason: ${V.reason}).`),V.event&&this._options.logService.error(V.event)):this._options.logService.info(`${z} received socket close event.`),this._beginReconnecting()})),this._register(X.onSocketTimeout(()=>{const V=N(this._connectionType,this.reconnectionToken,!0);this._options.logService.trace(`${V} received socket timeout event.`),this._beginReconnecting()})),oe._instances.push(this),oe._permanentFailure&&this._gotoPermanentFailure(oe._permanentFailureMillisSinceLastIncomingData,oe._permanentFailureAttempt,oe._permanentFailureHandled)}static triggerPermanentFailure(A,O,$){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=A,this._permanentFailureAttempt=O,this._permanentFailureHandled=$,this._instances.forEach(X=>X._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(oe._permanentFailure)return;const A=N(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${A} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new R(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const O=[0,5,5,10,10,10,10,10,30];let $=-1;do{$++;const X=$<O.length?O[$]:O[O.length-1];try{if(X>0){const z=k(X);this._onDidStateChange.fire(new W(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),X,z)),this._options.logService.info(`${A} waiting for ${X} seconds before reconnecting...`);try{await z}catch{}}if(oe._permanentFailure){this._options.logService.error(`${A} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),$+1)),this._options.logService.info(`${A} resolving connection...`);const V=await i(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${A} connecting to ${V.host}:${V.port}...`),await this._reconnect(V,t(E)),this._options.logService.info(`${A} reconnected!`),this._onDidStateChange.fire(new x(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),$+1));break}catch(V){if(V.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${A} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(V),oe.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),$+1,!1);break}if($>360){this._options.logService.error(`${A} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(V),oe.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),$+1,!1);break}if(y.RemoteAuthorityResolverError.isTemporarilyNotAvailable(V)){this._options.logService.info(`${A} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if((V.code==="ETIMEDOUT"||V.code==="ENETUNREACH"||V.code==="ECONNREFUSED"||V.code==="ECONNRESET")&&V.syscall==="connect"){this._options.logService.info(`${A} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if((0,C.isPromiseCanceledError)(V)){this._options.logService.info(`${A} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if(V instanceof y.RemoteAuthorityResolverError){this._options.logService.error(`${A} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(V),oe.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),$+1,y.RemoteAuthorityResolverError.isHandled(V));break}this._options.logService.error(`${A} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(V),oe.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),$+1,!1);break}}while(!oe._permanentFailure)}_gotoPermanentFailure(A,O,$){this._onDidStateChange.fire(new ne(this.reconnectionToken,A,O,$)),B(this.protocol)}}oe._permanentFailure=!1,oe._permanentFailureMillisSinceLastIncomingData=0,oe._permanentFailureAttempt=0,oe._permanentFailureHandled=!1,oe._instances=[];class G extends oe{constructor(A,O,$,X,V){super(1,A,X,V);this.client=this._register(new f.Client(V,{remoteAuthority:O,clientId:$},A.ipcLogger))}async _reconnect(A,O){await s(A,O)}}e.ManagementPersistentConnection=G;class T extends oe{constructor(A,O,$,X,V){super(2,A,$,X);this._startArguments=O,this.debugPort=V}async _reconnect(A,O){await u(A,this._startArguments,O)}}e.ExtensionHostPersistentConnection=T;function B(F){try{F.acceptDisconnect();const A=F.getSocket();F.dispose(),A.dispose()}catch(A){(0,C.onUnexpectedError)(A)}}function q(F){if(F&&F.type==="error"){const A=new Error(`Connection error: ${F.reason}`);return A.code="VSCODE_CONNECTION_ERROR",A}return null}function U(F,A){for(;F.length<A;)F+=" ";return F}function N(F,A,O){return`[remote-connection][${U(p(F),13)}][${A.substr(0,5)}\u2026][${O?"reconnect":"initial"}]`}function _(F,A){return`${N(A,F.reconnectionToken,!!F.reconnectionProtocol)}[${F.host}:${F.port}]`}function Y(F){return`${Date.now()-F} ms`}}),define(Q[64],J([0,1,10]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function D(f){return f.scheme===v.Schemas.vscodeRemote?f.authority:void 0}e.getRemoteAuthority=D;function M(f){if(!f)return;const y=f.indexOf("+");return y<0?f:f.substr(0,y)}e.getRemoteName=M;function C(f){return f.scheme!==v.Schemas.file&&f.scheme!==v.Schemas.vscodeRemote}e.isVirtualResource=C;function n(f){if(f.folders.length)return f.folders.every(y=>C(y.uri))?f.folders[0].uri:void 0;if(f.configuration&&C(f.configuration))return f.configuration}e.getVirtualWorkspaceLocation=n;function I(f){return n(f)?.scheme}e.getVirtualWorkspaceScheme=I;function d(f){return n(f)!==void 0}e.isVirtualWorkspace=d}),define(Q[195],J([0,1,25,5,64]),function(H,e,v,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function C(m){if(typeof m=="object"&&m!==null&&m.supported!==!0)return m.description}e.getWorkspaceSupportTypeMessage=C;function n(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(!m.uuid||typeof m.uuid=="string")}e.isIExtensionIdentifier=n,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var I;(function(m){m[m.System=0]="System",m[m.User=1]="User"})(I=e.ExtensionType||(e.ExtensionType={}));class d{constructor(p){this.value=p,this._lower=p.toLowerCase()}static equals(p,t){if(typeof p=="undefined"||p===null)return typeof t=="undefined"||t===null;if(typeof t=="undefined"||t===null)return!1;if(typeof p=="string"||typeof t=="string"){let w=typeof p=="string"?p:p.value,b=typeof t=="string"?t:t.value;return v.equalsIgnoreCase(w,b)}return p._lower===t._lower}static toKey(p){return typeof p=="string"?p.toLowerCase():p._lower}}e.ExtensionIdentifier=d;function f(m){return m.contributes&&m.contributes.localizations?m.contributes.localizations.length>0:!1}e.isLanguagePackExtension=f;function y(m){return m.contributes&&m.contributes.authentication?m.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=y;function E(m,p){if(p){const t=`onResolveRemoteAuthority:${(0,M.getRemoteName)(p)}`;return m.activationEvents?.indexOf(t)!==-1}return!1}e.isResolverExtension=E,e.IBuiltinExtensionsScannerService=(0,D.createDecorator)("IBuiltinExtensionsScannerService")}),define(Q[196],J([0,1,25,195]),function(H,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function M(t,w){return t.uuid&&w.uuid?t.uuid===w.uuid:t.id===w.id?!0:(0,v.compareIgnoreCase)(t.id,w.id)===0}e.areSameExtensions=M;class C{constructor(w,b){this.version=b,this.id=w.id,this.uuid=w.uuid}key(){return`${this.id}-${this.version}`}equals(w){return w instanceof C?M(this,w)&&this.version===w.version:!1}}e.ExtensionIdentifierWithVersion=C;function n(t,w){return`${t}.${w}`}e.getExtensionId=n;function I(t){return t.toLocaleLowerCase()}e.adoptToGalleryExtensionId=I;function d(t,w){return I(n(t,w))}e.getGalleryExtensionId=d;function f(t,w){const b=[],S=P=>{for(const c of b)if(c.some(a=>M(w(a),w(P))))return c;return null};for(const P of t){const c=S(P);c?c.push(P):b.push([P])}return b}e.groupByExtension=f;function y(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=y;function E(t){return{id:t.identifier.id,name:t.name,galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),...t.telemetryData}}e.getGalleryExtensionTelemetryData=E,e.BetterMergeId=new D.ExtensionIdentifier("pprice.better-merge");function m(t){const w=new Set;for(const b of t)b.malicious&&w.add(b.id.id);return w}e.getMaliciousExtensionsSet=m;function p(t,w){const b=[],S=w.manifest.extensionDependencies?.slice(0)??[];for(;S.length;){const P=S.shift();if(P&&b.every(c=>!M(c.identifier,{id:P}))){const c=t.filter(a=>M(a.identifier,{id:P}));c.length===1&&(b.push(c[0]),S.push(...c[0].manifest.extensionDependencies?.slice(0)??[]))}}return b}e.getExtensionDependencies=p}),define(Q[97],J([0,1,4,3,5,6]),function(H,e,v,D,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,M.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,M.createDecorator)("sharedTunnelsService");var n;(function(t){t.Http="http",t.Https="https"})(n=e.TunnelProtocol||(e.TunnelProtocol={}));var I;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})(I=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var d;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(d=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function f(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const w=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(!!w)return{address:w[1],port:+w[2]}}e.extractLocalHostUriMetaDataForPortMapping=f,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function y(t){return e.LOCALHOST_ADDRESSES.indexOf(t)>=0}e.isLocalhost=y,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function E(t){return e.ALL_INTERFACES_ADDRESSES.indexOf(t)>=0}e.isAllInterfaces=E;function m(t,w){return w?w!==1&&t<1024:!D.isWindows&&t<1024}e.isPortPrivileged=m;let p=class{constructor(w){this.logService=w,this._onTunnelOpened=new v.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new v.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new v.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(w,b){return this._tunnelProvider=w,w?(this._canElevate=b.elevation,this._privacyOptions=b.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const w=[],b=Array.from(this._tunnels.values());for(let S of b){const P=Array.from(S.values());for(let c of P){const a=await c.value;a&&w.push(a)}}return w}async dispose(){for(const w of this._tunnels.values()){for(const{value:b}of w.values())await b.then(S=>S?.dispose());w.clear()}this._tunnels.clear()}openTunnel(w,b,S,P,c=!1,a=I.Private,l){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${b}:${S} on local port ${P}.`),!w)return;b||(b="localhost");const s=this.retainOrCreateTunnel(w,b,S,P,c,a,l);return s?s.then(u=>{if(!u){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(b,S);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(u);return(u.tunnelRemoteHost!==b||u.tunnelRemotePort!==S)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),s)}makeTunnel(w){return{tunnelRemotePort:w.tunnelRemotePort,tunnelRemoteHost:w.tunnelRemoteHost,tunnelLocalPort:w.tunnelLocalPort,localAddress:w.localAddress,privacy:w.privacy,protocol:w.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${w.tunnelRemoteHost}:${w.tunnelRemotePort} `);const b=this._tunnels.get(w.tunnelRemoteHost);if(b){const S=b.get(w.tunnelRemotePort);S&&(S.refcount--,await this.tryDisposeTunnel(w.tunnelRemoteHost,w.tunnelRemotePort,S))}}}}async tryDisposeTunnel(w,b,S){if(S.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${w}:${b}.`);const P=S.value.then(async c=>{c&&(await c.dispose(!0),this._onTunnelClosed.fire({host:c.tunnelRemoteHost,port:c.tunnelRemotePort}))});return this._tunnels.has(w)&&this._tunnels.get(w).delete(b),P}}async closeTunnel(w,b){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${w}:${b} `);const S=this._tunnels.get(w);if(S&&S.has(b)){const P=S.get(b);P.refcount=0,await this.tryDisposeTunnel(w,b,P)}}addTunnelToMap(w,b,S){this._tunnels.has(w)||this._tunnels.set(w,new Map),this._tunnels.get(w).set(b,{refcount:1,value:S})}async removeEmptyTunnelFromMap(w,b){const S=this._tunnels.get(w);S&&(await S.get(b)||S.delete(b),S.size===0&&this._tunnels.delete(w))}getTunnelFromMap(w,b){let S=[w];y(w)?(S.push(...e.LOCALHOST_ADDRESSES),S.push(...e.ALL_INTERFACES_ADDRESSES)):E(w)&&S.push(...e.ALL_INTERFACES_ADDRESSES);const P=S.map(c=>this._tunnels.get(c));for(const c of P){const a=c?.get(b);if(a)return a}}canTunnel(w){return!!f(w)}createWithProvider(w,b,S,P,c,a,l){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${b}:${S} on local port ${P}.`);const u={elevationRequired:c?m(P===void 0?S:P):!1},r={remoteAddress:{host:b,port:S},localAddressPort:P,privacy:a,public:a!==I.Private,protocol:l},i=w.forwardPort(r,u);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),i&&this.addTunnelToMap(b,S,i),i}};p=he([ee(0,C.ILogService)],p),e.AbstractTunnelService=p}),define(Q[50],J([0,1,17,151,49,5,37]),function(H,e,v,D,M,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,C.createDecorator)("requestService");function I(t){return t.res.statusCode&&t.res.statusCode>=200&&t.res.statusCode<300||t.res.statusCode===1223}e.isSuccess=I;function d(t){return t.res.statusCode===204}async function f(t){if(!I(t))throw new Error("Server returned "+t.res.statusCode);return d(t)?null:(await(0,v.streamToBuffer)(t.stream)).toString()}e.asText=f;async function y(t){if(!I(t))throw new Error("Server returned "+t.res.statusCode);if(d(t))return null;const b=(await(0,v.streamToBuffer)(t.stream)).toString();try{return JSON.parse(b)}catch(S){throw S.message+=`:
`+b,S}}e.asJson=y;function E(t){p(t)}e.updateProxyConfigurationsScope=E;let m;function p(t){const w=n.Registry.as(M.Extensions.Configuration),b=m;m={id:"http",order:15,title:(0,D.localize)(0,null),type:"object",scope:t,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,D.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,D.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,D.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,D.localize)(4,null),(0,D.localize)(5,null),(0,D.localize)(6,null),(0,D.localize)(7,null)],default:"override",description:(0,D.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,D.localize)(9,null),restricted:!0}}},w.updateConfigurations({add:[m],remove:b?[b]:[]})}p(2)}),define(Q[197],J([0,1,198,13]),function(H,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function M(n,I){return n.protocol==="http:"?I.HTTP_PROXY||I.http_proxy||null:n.protocol==="https:"&&(I.HTTPS_PROXY||I.https_proxy||I.HTTP_PROXY||I.http_proxy)||null}async function C(n,I,d={}){const f=(0,v.parse)(n),y=d.proxyUrl||M(f,I);if(!y)return null;const E=(0,v.parse)(y);if(!/^https?:$/.test(E.protocol||""))return null;const m={host:E.hostname||"",port:E.port||(E.protocol==="https"?"443":"80"),auth:E.auth,rejectUnauthorized:(0,D.isBoolean)(d.strictSSL)?d.strictSSL:!0};return f.protocol==="http:"?new(await new Promise((p,t)=>{H(["http-proxy-agent"],p,t)}))(m):new(await new Promise((p,t)=>{H(["https-proxy-agent"],p,t)}))(m)}e.getProxyAgent=C}),define(Q[199],J([0,1,17,31]),function(H,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function M(C,n,I){let d=I&&I.get("storage.serviceMachineId",0)||null;if(d)return d;try{const y=(await n.readFile(C.serviceMachineIdResource)).value.toString();d=(0,D.isUUID)(y)?y:null}catch(f){d=null}if(!d){d=(0,D.generateUuid)();try{await n.writeFile(C.serviceMachineIdResource,v.VSBuffer.fromString(d))}catch(f){}}return I&&I.store("storage.serviceMachineId",d,0,1),d}e.getServiceMachineId=M}),define(Q[76],J([0,1,5]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,v.createDecorator)(e.SIGN_SERVICE_ID)}),define(Q[200],J([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class v{constructor(){this.validators=new Map}vsda(){return new Promise((M,C)=>H(["vsda"],M,C))}async createNewMessage(M){try{const C=await this.vsda(),n=new C.validator;if(n){const I=String(v._nextId++);return this.validators.set(I,n),{id:I,data:n.createNewMessage(M)}}}catch(C){}return{id:"",data:M}}async validate(M,C){if(!M.id)return!0;const n=this.validators.get(M.id);if(!n)return!1;this.validators.delete(M.id);try{return n.validate(C)==="ok"}catch(I){return!1}}async sign(M){try{const C=await this.vsda(),n=new C.signer;if(n)return n.sign(M)}catch(C){}return M}}e.SignService=v,v._nextId=1}),define(Q[38],J([0,1,5]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,v.createDecorator)("stateMainService")}),define(Q[20],J([0,1,14,9,4,2,3,32,13,5,179,6,38]),function(H,e,v,D,M,C,n,I,d,f,y,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,f.createDecorator)("lifecycleMainService");var p;(function(w){w[w.Starting=1]="Starting",w[w.Ready=2]="Ready",w[w.AfterWindowOpen=3]="AfterWindowOpen"})(p=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let t=class ht extends C.Disposable{constructor(b,S){super();this.logService=b,this.stateMainService=S,this._onBeforeShutdown=this._register(new M.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new M.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new M.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new M.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._onBeforeUnloadWindow=this._register(new M.Emitter),this.onBeforeUnloadWindow=this._onBeforeUnloadWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(ht.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(ht.QUIT_AND_RESTART_KEY)}registerListeners(){const b=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),n.isMacintosh&&this.windowCounter===0&&this.fireOnWillShutdown())};v.app.addListener("before-quit",b);const S=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!n.isMacintosh)&&v.app.quit()};v.app.addListener("window-all-closed",S),v.app.once("will-quit",P=>{this.logService.trace("Lifecycle#app.on(will-quit)"),P.preventDefault(),this.fireOnWillShutdown().finally(()=>{this.resolvePendingQuitPromise(!1),v.app.removeListener("before-quit",b),v.app.removeListener("window-all-closed",S),v.app.quit()})})}fireOnWillShutdown(){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const b=[];return this._onWillShutdown.fire({join(S){b.push(S)}}),this.pendingWillShutdownPromise=(async()=>{try{await D.Promises.settled(b)}catch(S){this.logService.error(S)}try{await this.stateMainService.close()}catch(S){this.logService.error(S)}})(),this.pendingWillShutdownPromise}set phase(b){if(b<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===b)return;this.logService.trace(`lifecycle (main): phase changed (value: ${b})`),this._phase=b;const S=this.phaseWhen.get(this._phase);S&&(S.open(),this.phaseWhen.delete(this._phase))}async when(b){if(b<=this._phase)return;let S=this.phaseWhen.get(b);S||(S=new D.Barrier,this.phaseWhen.set(b,S)),await S.wait()}registerWindow(b){const S=new C.DisposableStore;this.windowCounter++,S.add(b.onWillLoad(c=>this._onWillLoadWindow.fire({window:b,workspace:c.workspace,reason:c.reason})));const P=(0,d.assertIsDefined)(b.win);P.on("close",c=>{const a=b.id;if(this.windowToCloseRequest.has(a)){this.windowToCloseRequest.delete(a);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${b.id}`),c.preventDefault(),this.unload(b,1).then(l=>{if(l){this.windowToCloseRequest.delete(a);return}this.windowToCloseRequest.add(a),this.logService.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${a}`),this._onBeforeCloseWindow.fire(b),b.close()})}),P.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${b.id}`),this.windowCounter--,S.dispose(),this.windowCounter===0&&(!n.isMacintosh||this._quitRequested)&&this.fireOnWillShutdown()})}async reload(b,S){await this.unload(b,3)||b.reload(S)}async unload(b,S){if(!b.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${b.id}`);const P=this._quitRequested?2:S;let c=await this.onBeforeUnloadWindowInRenderer(b,P);return c?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${b.id})`),this.handleWindowUnloadVeto(c)):(c=await this.onBeforeUnloadWindowInMain(b,P),c?(this.logService.trace(`Lifecycle#unload() - veto in main (window ID ${b.id})`),this.handleWindowUnloadVeto(c)):(this.logService.trace(`Lifecycle#unload() - no veto (window ID ${b.id})`),await this.onWillUnloadWindowInRenderer(b,P),!1))}handleWindowUnloadVeto(b){return b?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(b){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(b),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(b,S){return new Promise(P=>{const c=this.oneTimeListenerTokenGenerator++,a=`vscode:ok${c}`,l=`vscode:cancel${c}`;v.ipcMain.once(a,()=>{P(!1)}),v.ipcMain.once(l,()=>{P(!0)}),b.send("vscode:onBeforeUnload",{okChannel:a,cancelChannel:l,reason:S})})}onBeforeUnloadWindowInMain(b,S){const P=[];return this._onBeforeUnloadWindow.fire({reason:S,window:b,veto(c){P.push(c)}}),(0,y.handleVetos)(P,c=>this.logService.error(c))}onWillUnloadWindowInRenderer(b,S){return new Promise(P=>{const a=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;v.ipcMain.once(a,()=>P()),b.send("vscode:onWillUnload",{replyChannel:a,reason:S})})}quit(b){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - will restart: ${b}`),b&&this.stateMainService.setItem(ht.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(S=>{this.pendingQuitPromiseResolve=S,this.logService.trace("Lifecycle#quit() - calling app.quit()"),v.app.quit()}),this.pendingQuitPromise)}async relaunch(b){this.logService.trace("Lifecycle#relaunch()");const S=process.argv.slice(1);if(b?.addArgs&&S.push(...b.addArgs),b?.removeArgs)for(const a of b.removeArgs){const l=S.indexOf(a);l>=0&&S.splice(l,1)}const P=()=>{try{if(n.isWindows){const a=(0,I.cwd)();a!==process.cwd()&&process.chdir(a)}}catch(a){this.logService.error(a)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),v.app.relaunch({args:S})};v.app.once("quit",P),await this.quit(!0)&&v.app.removeListener("quit",P)}async kill(b){this.logService.trace("Lifecycle#kill()"),await this.fireOnWillShutdown(),await Promise.race([(0,D.timeout)(1e3),(async()=>{for(const S of v.BrowserWindow.getAllWindows())if(S&&!S.isDestroyed()){let P;S.webContents&&!S.webContents.isDestroyed()?P=new Promise(c=>S.once("closed",c)):P=Promise.resolve(),S.destroy(),await P}})()]),v.app.exit(b)}};t.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",t=he([ee(0,E.ILogService),ee(1,m.IStateMainService)],t),e.LifecycleMainService=t}),define(Q[201],J([0,1,4,2,5,20]),function(H,e,v,D,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,M.createDecorator)("keyboardLayoutMainService");let n=class extends D.Disposable{constructor(f){super();this._onDidChangeKeyboardLayout=this._register(new v.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,f.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const f=await new Promise((y,E)=>{H(["native-keymap"],y,E)});this._keyboardLayoutData=I(f),f.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=I(f),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};n=he([ee(0,C.ILifecycleMainService)],n),e.KeyboardLayoutMainService=n;function I(d){const f=d.getKeyMap(),y=d.getCurrentKeyboardLayout();return{keyboardMapping:f,keyboardLayoutInfo:y}}}),define(Q[98],J([0,1,9,4,2,63,13,86,5]),function(H,e,v,D,M,C,n,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const f="__$__targetStorageMarker";e.IStorageService=(0,d.createDecorator)("storageService");var y;(function(b){b[b.NONE=0]="NONE",b[b.SHUTDOWN=1]="SHUTDOWN"})(y=e.WillSaveStateReason||(e.WillSaveStateReason={}));var E;(function(b){b[b.GLOBAL=0]="GLOBAL",b[b.WORKSPACE=1]="WORKSPACE"})(E=e.StorageScope||(e.StorageScope={}));var m;(function(b){b[b.USER=0]="USER",b[b.MACHINE=1]="MACHINE"})(m=e.StorageTarget||(e.StorageTarget={}));class p extends M.Disposable{constructor(S={flushInterval:p.DEFAULT_FLUSH_INTERVAL}){super();this.options=S,this._onDidChangeValue=this._register(new D.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new D.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new D.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new v.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new M.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,v.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,M.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,C.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,C.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(S,P){P===f?(S===0?this._globalKeyTargets=void 0:S===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:S})):this._onDidChangeValue.fire({scope:S,key:P,target:this.getKeyTargets(S)[P]})}emitWillSaveState(S){this._onWillSaveState.fire({reason:S})}get(S,P,c){return this.getStorage(P)?.get(S,c)}getBoolean(S,P,c){return this.getStorage(P)?.getBoolean(S,c)}getNumber(S,P,c){return this.getStorage(P)?.getNumber(S,c)}store(S,P,c,a){if((0,n.isUndefinedOrNull)(P)){this.remove(S,c);return}this.withPausedEmitters(()=>{this.updateKeyTarget(S,c,a),this.getStorage(c)?.set(S,P)})}remove(S,P){this.withPausedEmitters(()=>{this.updateKeyTarget(S,P,void 0),this.getStorage(P)?.delete(S)})}withPausedEmitters(S){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{S()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(S,P){const c=[],a=this.getKeyTargets(S);for(const l of Object.keys(a))a[l]===P&&c.push(l);return c}updateKeyTarget(S,P,c){const a=this.getKeyTargets(P);typeof c=="number"?a[S]!==c&&(a[S]=c,this.getStorage(P)?.set(f,JSON.stringify(a))):typeof a[S]=="number"&&(delete a[S],this.getStorage(P)?.set(f,JSON.stringify(a)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(S){return S===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(S){const P=this.get(f,S);if(P)try{return JSON.parse(P)}catch(c){}return Object.create(null)}isNew(S){return this.getBoolean(e.IS_NEW_KEY,S)===!0}async flush(S=y.NONE){this._onWillSaveState.fire({reason:S});const P=this.getStorage(0),c=this.getStorage(1);switch(S){case y.NONE:await v.Promises.settled([P?.whenFlushed()??Promise.resolve(),c?.whenFlushed()??Promise.resolve()]);break;case y.SHUTDOWN:await v.Promises.settled([P?.flush(0)??Promise.resolve(),c?.flush(0)??Promise.resolve()]);break}}async logStorage(){const S=this.getStorage(0)?.items??new Map,P=this.getStorage(1)?.items??new Map;return w(S,P,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=p,p.DEFAULT_FLUSH_INTERVAL=60*1e3;class t extends p{constructor(){super();this.globalStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(S=>this.emitDidChangeValue(1,S))),this._register(this.globalStorage.onDidChangeStorage(S=>this.emitDidChangeValue(0,S)))}getStorage(S){return S===0?this.globalStorage:this.workspaceStorage}getLogDetails(S){return S===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(S){}}e.InMemoryStorageService=t;async function w(b,S,P,c){const a=h=>{try{return JSON.parse(h)}catch(g){return h}},l=new Map,s=new Map;b.forEach((h,g)=>{l.set(g,h),s.set(g,a(h))});const u=new Map,r=new Map;S.forEach((h,g)=>{u.set(g,h),r.set(g,a(h))}),console.group(`Storage: Global (path: ${P})`);let i=[];l.forEach((h,g)=>{i.push({key:g,value:h})}),console.table(i),console.groupEnd(),console.log(s),console.group(`Storage: Workspace (path: ${c})`);let o=[];u.forEach((h,g)=>{o.push({key:g,value:h})}),console.table(o),console.groupEnd(),console.log(r)}e.logStorage=w}),define(Q[202],J([0,1,3,32,7,31]),function(H,e,v,D,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function n(f){if(v.platform===2&&/^penguin(\.|$)/i.test(f))return"chromebook"}async function I(f,y,E,m,p,t,w,b,S,P){const c=Object.create(null);c["common.machineId"]=w,c.sessionID=(0,C.generateUuid)()+Date.now(),c.commitHash=p,c.version=t,c["common.platformVersion"]=(y||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),c["common.platform"]=(0,v.PlatformToString)(v.platform),c["common.nodePlatform"]=D.platform,c["common.nodeArch"]=m,c["common.product"]=P||"desktop";const a=d(b||[]);a&&(c["common.msftInternal"]=a);let l=0;const s=Date.now();Object.defineProperties(c,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-s,enumerable:!0},"common.sequence":{get:()=>l++,enumerable:!0}}),v.isLinuxSnap&&(c["common.snap"]="true");const u=n(E);u&&(c["common.platformDetail"]=u);try{const r=await f.readFile(M.URI.file(S));c["common.source"]=r.value.toString().slice(0,30)}catch(r){}return c}e.resolveCommonProperties=I;function d(f){const y=D.env.USERDNSDOMAIN;if(!y)return!1;const E=y.toLowerCase();return f.some(m=>E===m)}e.verifyMicrosoftInternalDomain=d}),define(Q[29],J([0,1,5]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,v.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,v.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var D;(function(C){C[C.NONE=0]="NONE",C[C.CRASH=1]="CRASH",C[C.ERROR=2]="ERROR",C[C.USAGE=3]="USAGE"})(D=e.TelemetryLevel||(e.TelemetryLevel={}));var M;(function(C){C.OFF="off",C.CRASH="crash",C.ERROR="error",C.ON="all"})(M=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Q[203],J([0,1,26,69,9,39,10,8,3,7,71,21,83,74,18,22,29]),function(H,e,v,D,M,C,n,I,d,f,y,E,m,p,t,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function S(s,u){const r=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],i=new Map,o=new Map,h=2e4;function g(R,W,j,x){const ne=W.substring(R.length+1);return M.Promises.withAsyncBody(async oe=>{let G;try{G=await E.Promises.readdir(W,{withFileTypes:!0})}catch(q){oe();return}if(x.count>=h){x.count+=G.length,x.maxReached=!0,oe();return}let T=G.length;if(T===0){oe();return}let B=G;x.count+G.length>h&&(x.maxReached=!0,T=h-x.count,B=G.slice(0,T)),x.count+=G.length;for(const q of B)if(q.isDirectory()){if(j.includes(q.name)||await g(R,(0,I.join)(W,q.name),j,x),--T==0){oe();return}}else{const U=q.name.lastIndexOf(".");if(U>=0){const N=q.name.substring(U+1);N&&i.set(N,(i.get(N)??0)+1)}for(const N of r)N.relativePathPattern?.test(ne)!==!1&&N.filePattern.test(q.name)&&o.set(N.tag,(o.get(N.tag)??0)+1);if(--T==0){oe();return}}})}const k={count:0,maxReached:!1};await g(s,s,u,k);const L=await a(s);return{configFiles:P(o),fileTypes:P(i),fileCount:k.count,maxFilesReached:k.maxReached,launchConfigFiles:L}}e.collectWorkspaceStats=S;function P(s){return[...D.Iterable.map(s.entries(),([u,r])=>({name:u,count:r}))].sort((u,r)=>r.count-u.count)}function c(){const s={os:`${v.type()} ${v.arch()} ${v.release()}`,memory:`${(v.totalmem()/t.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/t.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(y.virtualMachineHint.value()*100)}%`},u=v.cpus();return u&&u.length>0&&(s.cpus=`${u[0].model} (${u.length} x ${u[0].speed})`),s}e.getMachineInfo=c;async function a(s){try{const u=new Map,r=(0,I.join)(s,".vscode","launch.json"),i=await E.Promises.readFile(r),o=[],h=(0,C.parse)(i.toString(),o);if(o.length)return console.log(`Unable to parse ${r}`),[];if((0,C.getNodeType)(h)==="object"&&h.configurations)for(const g of h.configurations){const k=g.type;k&&(u.has(k)?u.set(k,u.get(k)+1):u.set(k,1))}return P(u)}catch(u){return[]}}e.collectLaunchConfigs=a;let l=class{constructor(u,r){this.telemetryService=u,this.productService=r}formatMachineInfo(u){const r=[];return r.push(`OS Version:       ${u.os}`),r.push(`CPUs:             ${u.cpus}`),r.push(`Memory (System):  ${u.memory}`),r.push(`VM:               ${u.vmHint}`),r.join(`
`)}formatEnvironment(u){const r=[];r.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),r.push(`OS Version:       ${v.type()} ${v.arch()} ${v.release()}`);const i=v.cpus();return i&&i.length>0&&r.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),r.push(`Memory (System):  ${(v.totalmem()/t.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/t.ByteSize.GB).toFixed(2)}GB free)`),d.isWindows||r.push(`Load (avg):       ${v.loadavg().map(o=>Math.round(o)).join(", ")}`),r.push(`VM:               ${Math.round(y.virtualMachineHint.value()*100)}%`),r.push(`Screen Reader:    ${u.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${u.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.expandGPUFeatures(u.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(u,r){return Promise.all([(0,m.listProcesses)(u.mainPID),this.formatWorkspaceMetadata(u)]).then(async i=>{let[o,h]=i,g=this.formatProcessList(u,o);return r.forEach(k=>{if((0,p.isRemoteDiagnosticError)(k))g+=`
${k.errorMessage}`,h+=`
${k.errorMessage}`;else if(g+=`

Remote: ${k.hostName}`,k.processes&&(g+=`
${this.formatProcessList(u,k.processes)}`),k.workspaceMetadata){h+=`
|  Remote: ${k.hostName}`;for(const L of Object.keys(k.workspaceMetadata)){const R=k.workspaceMetadata[L];let W=`${R.fileCount} files`;R.maxFilesReached&&(W=`more than ${W}`),h+=`|    Folder (${L}): ${W}`,h+=this.formatWorkspaceStats(R)}}}),{processInfo:g,workspaceInfo:h}})}async getSystemInfo(u,r){const{memory:i,vmHint:o,os:h,cpus:g}=c(),k={os:h,memory:i,cpus:g,vmHint:o,processArgs:`${u.mainArguments.join(" ")}`,gpuStatus:u.gpuFeatureStatus,screenReader:`${u.screenReader?"yes":"no"}`,remoteData:r};return d.isWindows||(k.load=`${v.loadavg().map(L=>Math.round(L)).join(", ")}`),d.isLinux&&(k.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(k)}async getDiagnostics(u,r){const i=[];return(0,m.listProcesses)(u.mainPID).then(async o=>(i.push(""),i.push(this.formatEnvironment(u)),i.push(""),i.push(this.formatProcessList(u,o)),u.windows.some(h=>h.folderURIs&&h.folderURIs.length>0&&!h.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.formatWorkspaceMetadata(u))),r.forEach(h=>{if((0,p.isRemoteDiagnosticError)(h))i.push(`
${h.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${h.hostName}`),i.push(this.formatMachineInfo(h.machineInfo)),h.processes&&i.push(this.formatProcessList(u,h.processes)),h.workspaceMetadata)for(const g of Object.keys(h.workspaceMetadata)){const k=h.workspaceMetadata[g];let L=`${k.fileCount} files`;k.maxFilesReached&&(L=`more than ${L}`),i.push(`Folder (${g}): ${L}`),i.push(this.formatWorkspaceStats(k))}}),i.push(""),i.push(""),i.join(`
`)))}formatWorkspaceStats(u){const r=[],i=60;let o=0;const h=(R,W)=>{const j=` ${R}(${W})`;o+j.length>i?(r.push(g),g="|                 ",o=g.length):o+=j.length,g+=j};let g="|      File types:";const k=10;let L=u.fileTypes.length>k?k:u.fileTypes.length;for(let R=0;R<L;R++){const W=u.fileTypes[R];h(W.name,W.count)}if(r.push(g),u.configFiles.length>=0&&(g="|      Conf files:",o=0,u.configFiles.forEach(R=>{h(R.name,R.count)}),r.push(g)),u.launchConfigFiles.length>0){let R="|      Launch Configs:";u.launchConfigFiles.forEach(W=>{R+=W.count>1?` ${W.name}(${W.count})`:` ${W.name}`}),r.push(R)}return r.join(`
`)}expandGPUFeatures(u){const r=Math.max(...Object.keys(u).map(i=>i.length));return Object.keys(u).map(i=>`${i}:  ${" ".repeat(r-i.length)}  ${u[i]}`).join(`
                  `)}formatWorkspaceMetadata(u){const r=[],i=[];return u.windows.forEach(o=>{o.folderURIs.length===0||!!o.remoteAuthority||(r.push(`|  Window (${o.title})`),o.folderURIs.forEach(h=>{const g=f.URI.revive(h);if(g.scheme===n.Schemas.file){const k=g.fsPath;i.push(S(k,["node_modules",".git"]).then(L=>{let R=`${L.fileCount} files`;L.maxFilesReached&&(R=`more than ${R}`),r.push(`|    Folder (${(0,I.basename)(k)}): ${R}`),r.push(this.formatWorkspaceStats(L))}).catch(L=>{r.push(`|      Error: Unable to collect workspace stats for folder ${k} (${L.toString()})`)}))}else r.push(`|    Folder (${g.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(o=>r.join(`
`)).catch(o=>`Unable to collect workspace stats: ${o}`)}formatProcessList(u,r){const i=new Map;u.windows.forEach(h=>i.set(h.pid,h.title));const o=[];return o.push("CPU %	Mem MB	   PID	Process"),r&&this.formatProcessItem(u.mainPID,i,o,r,0),o.join(`
`)}formatProcessItem(u,r,i,o,h){const g=h===0;let k;g?k=o.pid===u?`${this.productService.applicationName} main`:"remote agent":(k=`${"  ".repeat(h)} ${o.name}`,o.name==="window"&&(k=`${k} (${r.get(o.pid)})`));const L=process.platform==="win32"?o.mem:v.totalmem()*(o.mem/100);i.push(`${o.load.toFixed(0).padStart(5," ")}	${(L/t.ByteSize.MB).toFixed(0).padStart(6," ")}	${o.pid.toFixed(0).padStart(6," ")}	${k}`),Array.isArray(o.children)&&o.children.forEach(R=>this.formatProcessItem(u,r,i,R,h+1))}async reportWorkspaceStats(u){for(const{uri:r}of u.folders){const i=f.URI.revive(r);if(i.scheme!==n.Schemas.file)continue;const o=i.fsPath;try{const h=await S(o,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":u.telemetryId,rendererSessionId:u.rendererSessionId}),h.fileTypes.forEach(g=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:u.rendererSessionId,type:g.name,count:g.count})}),h.launchConfigFiles.forEach(g=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:u.rendererSessionId,type:g.name,count:g.count})}),h.configFiles.forEach(g=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:u.rendererSessionId,type:g.name,count:g.count})})}catch{}}}};l=he([ee(0,b.ITelemetryService),ee(1,w.IProductService)],l),e.DiagnosticsService=l}),define(Q[204],J([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class v{constructor(C){this.appenders=C}listen(C,n){throw new Error(`Event not found: ${n}`)}call(C,n,{eventName:I,data:d}){return this.appenders.forEach(f=>f.log(I,d)),Promise.resolve(null)}}e.TelemetryAppenderChannel=v;class D{constructor(C){this.channel=C}log(C,n){return this.channel.call("log",{eventName:C,data:n}).then(void 0,I=>`Failed to log telemetry: ${console.warn(I)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=D}),define(Q[65],J([0,1,47,13,19,29]),function(H,e,v,D,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class n{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(S,P){return Promise.resolve(void 0)}publicLog2(S,P){return this.publicLog(S,P)}publicLogError(S,P){return Promise.resolve(void 0)}publicLogError2(S,P){return this.publicLogError(S,P)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=n,e.NullTelemetryService=new n;class I{async publicLog(S,P,c){}async publicLogError(S,P,c){}}e.NullEndpointTelemetryService=I,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function d(b,S){return S.onDidChangeConfiguration(P=>{P.source!==6&&b.publicLog2("updateConfiguration",{configurationSource:(0,M.ConfigurationTargetToString)(P.source),configurationKeys:t(P.sourceConfig)})})}e.configurationTelemetry=d;function f(b,S){return!(S.disableTelemetry||!b.enableTelemetry)}e.supportsTelemetry=f;function y(b){const S=b.getValue(C.TELEMETRY_SETTING_ID),P=b.getValue("telemetry.enableCrashReporter");if(b.getValue(C.TELEMETRY_OLD_SETTING_ID)===!1||P===!1)return 0;switch(S??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=y;function E(b){const S=Object.create(null),P=Object.create(null),c=Object.create(null);p(b,c);for(let a in c){a=a.length>150?a.substr(a.length-149):a;const l=c[a];typeof l=="number"?P[a]=l:typeof l=="boolean"?P[a]=l?1:0:typeof l=="string"?(l.length>8192&&console.warn(`Telemetry property: ${a} has been trimmed to 8192, the original length is ${l.length}`),S[a]=l.substring(0,8191)):typeof l!="undefined"&&l!==null&&(S[a]=l)}return{properties:S,measurements:P}}e.validateTelemetryData=E;function m(b){if(!b)return"none";let S="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(c=>{b.indexOf(`${c}+`)===0&&(S=c)}),S}e.cleanRemoteAuthority=m;function p(b,S,P=0,c){if(!!b)for(let a of Object.getOwnPropertyNames(b)){const l=b[a],s=c?c+a:a;Array.isArray(l)?S[s]=(0,v.safeStringify)(l):l instanceof Date?S[s]=l.toISOString():(0,D.isObject)(l)?P<2?p(l,S,P+1,s+"."):S[s]=(0,v.safeStringify)(l):S[s]=l}}function t(b){if(!b)return[];const S=[];return w(S,"",b),S}function w(b,S,P){P&&typeof P=="object"&&!Array.isArray(P)?Object.keys(P).forEach(c=>w(b,S?`${S}.${c}`:c,P[c])):b.push(S)}}),define(Q[205],J([0,1,30,23,16,47,3,32,7,19,48,169,196,166,18,6,22,50,199,98,29,65]),function(H,e,v,D,M,C,n,I,d,f,y,E,m,p,t,w,b,S,P,c,a,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const s=n.isWeb?"web":(0,E.getTargetPlatform)(n.platform,I.arch);var u;(function(V){V[V.None=0]="None",V[V.IncludeVersions=1]="IncludeVersions",V[V.IncludeFiles=2]="IncludeFiles",V[V.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",V[V.IncludeSharedAccounts=8]="IncludeSharedAccounts",V[V.IncludeVersionProperties=16]="IncludeVersionProperties",V[V.ExcludeNonValidated=32]="ExcludeNonValidated",V[V.IncludeInstallationTargets=64]="IncludeInstallationTargets",V[V.IncludeAssetUri=128]="IncludeAssetUri",V[V.IncludeStatistics=256]="IncludeStatistics",V[V.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",V[V.Unpublished=4096]="Unpublished"})(u||(u={}));function r(...V){return String(V.reduce((z,Z)=>z|Z,0))}var i;(function(V){V[V.Tag=1]="Tag",V[V.ExtensionId=4]="ExtensionId",V[V.Category=5]="Category",V[V.ExtensionName=7]="ExtensionName",V[V.Target=8]="Target",V[V.Featured=9]="Featured",V[V.SearchText=10]="SearchText",V[V.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},h={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},k={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:u.None,criteria:[],assetTypes:[]};class L{constructor(z=k){this.state=z}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(z,Z=this.state.pageSize){return new L({...this.state,pageNumber:z,pageSize:Z})}withFilter(z,...Z){const te=[...this.state.criteria,...Z.length?Z.map(ce=>({filterType:z,value:ce})):[{filterType:z}]];return new L({...this.state,criteria:te})}withSortBy(z){return new L({...this.state,sortBy:z})}withSortOrder(z){return new L({...this.state,sortOrder:z})}withFlags(...z){return new L({...this.state,flags:z.reduce((Z,te)=>Z|te,0)})}withAssetTypes(...z){return new L({...this.state,assetTypes:z})}get raw(){const{criteria:z,pageNumber:Z,pageSize:te,sortBy:ce,sortOrder:se,flags:ie,assetTypes:ae}=this.state;return{filters:[{criteria:z,pageNumber:Z,pageSize:te,sortBy:ce,sortOrder:se}],assetTypes:ae,flags:ie}}get searchText(){const z=this.state.criteria.filter(Z=>Z.filterType===i.SearchText)[0];return z&&z.value?z.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(z=>String(z.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function R(V,z){const Z=(V||[]).filter(te=>te.statisticName===z)[0];return Z?Z.value:0}function W(V){const z="Microsoft.VisualStudio.Code.Translation.";return V.files.filter(te=>te.assetType.indexOf(z)===0).reduce((te,ce)=>{const se=oe(V,ce.assetType);return se&&te.push([ce.assetType.substring(z.length),se]),te},[])}function j(V){if(V.properties){const z=V.properties.filter(ce=>ce.key===o.Repository),Z=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),te=z.filter(ce=>Z.test(ce.value))[0];return te?{uri:te.value,fallbackUri:te.value}:null}return oe(V,o.Repository)}function x(V){return{uri:`${V.fallbackAssetUri}/${o.VSIX}?redirect=true${V.targetPlatform?`&targetPlatform=${V.targetPlatform}`:""}`,fallbackUri:`${V.fallbackAssetUri}/${o.VSIX}${V.targetPlatform?`?targetPlatform=${V.targetPlatform}`:""}`}}function ne(V){const z=oe(V,o.Icon);if(z)return z;const Z=E.DefaultIconPath;return{uri:Z,fallbackUri:Z}}function oe(V,z){return V.files.filter(te=>te.assetType===z)[0]?{uri:`${V.assetUri}/${z}`,fallbackUri:`${V.fallbackAssetUri}/${z}`}:null}function G(V,z){const Z=V.properties?V.properties.filter(ce=>ce.key===z):[],te=Z.length>0&&Z[0].value;return te?te.split(",").map(ce=>(0,m.adoptToGalleryExtensionId)(ce)):[]}function T(V){const z=V.properties?V.properties.filter(Z=>Z.key===h.Engine):[];return z.length>0&&z[0].value||""}function B(V){const z=V.properties?V.properties.filter(te=>te.key===h.LocalizedLanguages):[],Z=z.length>0&&z[0].value||"";return Z?Z.split(","):[]}function q(V){return V.indexOf("preview")!==-1}function U(V){return V.targetPlatform?(0,E.toTargetPlatform)(V.targetPlatform):"undefined"}function N(V){const z=(0,v.distinct)(V.versions.map(U)),Z=!!V.tags?.includes(E.WEB_EXTENSION_TAG),te=z.indexOf("web");return Z?te===-1&&z.push("web"):te!==-1&&z.splice(te,1),z}function _(V,z){const Z=(0,E.getFallbackTargetPlarforms)(z);for(let te=0;te<V.length;te++){const ce=V[te];if(ce.version===V[te-1]?.version){let se=te;const ie=U(ce);if(ie===z)for(;se>0&&V[se-1].version===ce.version;)se--;else if(Z.includes(ie))for(;se>0&&V[se-1].version===ce.version&&U(V[se-1])!==z;)se--;se!==te&&(V.splice(te,1),V.splice(se,0,ce))}}return V}e.sortExtensionVersions=_;function Y(V,z,Z,te,ce){const se=N(V);let ie=V.versions[0];return ie=V.versions.find(ae=>ae.version===ie.version&&(0,E.isTargetPlatformCompatible)(U(ae),se,ce))||ie,F(V,ie,se,z,Z,te)}function F(V,z,Z,te,ce,se){const ie={manifest:oe(z,o.Manifest),readme:oe(z,o.Details),changelog:oe(z,o.Changelog),license:oe(z,o.License),repository:j(z),download:x(z),icon:ne(z),coreTranslations:W(z)};return{identifier:{id:(0,m.getGalleryExtensionId)(V.publisher.publisherName,V.extensionName),uuid:V.extensionId},name:V.extensionName,version:z.version,displayName:V.displayName,publisherId:V.publisher.publisherId,publisher:V.publisher.publisherName,publisherDisplayName:V.publisher.displayName,publisherDomain:V.publisher.domain?{link:V.publisher.domain,verified:!!V.publisher.isDomainVerified}:void 0,description:V.shortDescription||"",installCount:R(V.statistics,"install"),rating:R(V.statistics,"averagerating"),ratingCount:R(V.statistics,"ratingcount"),categories:V.categories||[],tags:V.tags||[],releaseDate:Date.parse(V.releaseDate),lastUpdated:Date.parse(V.lastUpdated),allTargetPlatforms:Z,assets:ie,properties:{dependencies:G(z,h.Dependency),extensionPack:G(z,h.ExtensionPack),engine:T(z),localizedLanguages:B(z),targetPlatform:U(z)},preview:q(V.flags),telemetryData:{index:(ce.pageNumber-1)*ce.pageSize+te,querySource:se}}}let A=class{constructor(z,Z,te,ce,se,ie,ae,ue){this.requestService=Z,this.logService=te,this.environmentService=ce,this.telemetryService=se,this.fileService=ie,this.productService=ae,this.configurationService=ue;const de=ae.extensionsGallery;this.extensionsGalleryUrl=de&&de.serviceUrl,this.extensionsControlUrl=de&&de.controlUrl,this.commonHeadersPromise=X(ae.version,ae,this.environmentService,this.configurationService,this.fileService,z)}api(z=""){return`${this.extensionsGalleryUrl}${z}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(z,Z){const te=[];let ce=new L().withFlags(u.IncludeAssetUri,u.IncludeStatistics,u.IncludeCategoryAndTags,u.IncludeFiles,u.IncludeVersionProperties).withPage(1,z.length).withFilter(i.Target,"Microsoft.VisualStudio.Code").withFilter(i.ExtensionName,...z.map(({id:ie})=>ie.toLowerCase()));z.every(ie=>!ie.version)&&(ce=ce.withFlags(u.IncludeAssetUri,u.IncludeStatistics,u.IncludeCategoryAndTags,u.IncludeFiles,u.IncludeVersionProperties,u.IncludeLatestVersionOnly));const{galleryExtensions:se}=await this.queryGallery(ce,s,D.CancellationToken.None);for(let ie=0;ie<se.length;ie++){const ae=se[ie];if(!ae.versions.length)continue;const ue=(0,m.getGalleryExtensionId)(ae.publisher.publisherName,ae.extensionName),de=z.find(ve=>(0,m.areSameExtensions)(ve,{id:ue}))?.version;if(de){const ve=ae.versions.find(Pe=>Pe.version===de);ve&&te.push(F(ae,ve,N(ae),ie,ce))}else te.push(Y(ae,ie,ce,void 0,s))}return te}async getCompatibleExtension(z,Z){const te=(0,E.isIExtensionIdentifier)(z)?null:z;if(te){if((0,E.isNotWebExtensionInWebTargetPlatform)(te.allTargetPlatforms,Z))return null;if(await this.isExtensionCompatible(te,Z))return te}const{id:ce,uuid:se}=te?te.identifier:z;let ie=new L().withFlags(u.IncludeAssetUri,u.IncludeStatistics,u.IncludeCategoryAndTags,u.IncludeFiles,u.IncludeVersionProperties).withPage(1,1).withFilter(i.Target,"Microsoft.VisualStudio.Code");se?ie=ie.withFilter(i.ExtensionId,se):ie=ie.withFilter(i.ExtensionName,ce);const{galleryExtensions:ae}=await this.queryGallery(ie,Z,D.CancellationToken.None),[ue]=ae;if(!ue||!ue.versions.length)return null;const de=N(ue);if((0,E.isNotWebExtensionInWebTargetPlatform)(de,Z))return null;for(let ve of ue.versions){if(!T(ve)){const Pe=await this.getEngine(ve);ve={...ve,properties:[...ve.properties||[],{key:h.Engine,value:Pe}]}}if(await this.isRawExtensionVersionCompatible(ve,de,Z))return F(ue,ve,de,0,ie)}return null}async isExtensionCompatible(z,Z){if(!(0,E.isTargetPlatformCompatible)(z.properties.targetPlatform,z.allTargetPlatforms,Z))return!1;let te=z.properties.engine;if(!te){const ce=await this.getManifest(z,D.CancellationToken.None);if(!ce)throw new Error("Manifest was not found");te=ce.engines.vscode}return(0,p.isEngineValid)(te,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(z,Z,te){if(!(0,E.isTargetPlatformCompatible)(U(z),Z,te))return!1;const ce=await this.getEngine(z);return(0,p.isEngineValid)(ce,this.productService.version,this.productService.date)}async query(z,Z){const te=D.CancellationToken.isCancellationToken(z)?{}:z,ce=D.CancellationToken.isCancellationToken(z)?z:Z;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let se=te.text||"";const ie=(0,C.getOrDefault)(te,pe=>pe.pageSize,50);let ae=new L().withFlags(u.IncludeLatestVersionOnly,u.IncludeAssetUri,u.IncludeStatistics,u.IncludeCategoryAndTags,u.IncludeFiles,u.IncludeVersionProperties).withPage(1,ie).withFilter(i.Target,"Microsoft.VisualStudio.Code");se?(se=se.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(pe,ge,be)=>(ae=ae.withFilter(i.Category,be||ge),"")),se=se.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(pe,ge,be)=>(ae=ae.withFilter(i.Tag,be||ge),"")),se=se.replace(/\bfeatured(\s+|\b|$)/g,()=>(ae=ae.withFilter(i.Featured),"")),se=se.trim(),se&&(se=se.length<200?se:se.substring(0,200),ae=ae.withFilter(i.SearchText,se)),ae=ae.withSortBy(0)):te.ids?ae=ae.withFilter(i.ExtensionId,...te.ids):te.names?ae=ae.withFilter(i.ExtensionName,...te.names):ae=ae.withSortBy(4),typeof te.sortBy=="number"&&(ae=ae.withSortBy(te.sortBy)),typeof te.sortOrder=="number"&&(ae=ae.withSortOrder(te.sortOrder));const{galleryExtensions:ue,total:de}=await this.queryGallery(ae,s,ce),ve=ue.map((pe,ge)=>Y(pe,ge,ae,te.source,s)),Pe=async(pe,ge)=>{if(ge.isCancellationRequested)throw(0,M.canceled)();const be=ae.withPage(pe+1),{galleryExtensions:ke}=await this.queryGallery(be,s,ge);return ke.map((Ae,We)=>Y(Ae,We,be,te.source,s))};return{firstPage:ve,total:de,pageSize:ae.pageSize,getPage:Pe}}async queryGallery(z,Z,te){if(!this.isEnabled())throw new Error("No extension gallery service configured.");z=z.withFlags(z.flags,u.ExcludeNonValidated).withFilter(i.ExcludeWithFlags,r(u.Unpublished));const ce=await this.commonHeadersPromise,se=JSON.stringify(z.raw),ie={...ce,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(se.length)},ae=new Date().getTime();let ue,de,ve=0;try{if(ue=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:se,headers:ie},te),ue.res.statusCode&&ue.res.statusCode>=400&&ue.res.statusCode<500)return{galleryExtensions:[],total:ve};const Pe=await(0,S.asJson)(ue);if(Pe){const pe=Pe.results[0],ge=pe.extensions;ge.forEach(ke=>_(ke.versions,Z));const be=pe.resultMetadata&&pe.resultMetadata.filter(ke=>ke.metadataType==="ResultCount")[0];return ve=be&&be.metadataItems.filter(ke=>ke.name==="TotalCount")[0].count||0,{galleryExtensions:ge,total:ve}}return{galleryExtensions:[],total:ve}}catch(Pe){throw de=Pe,Pe}finally{this.telemetryService.publicLog2("galleryService:query",{...z.telemetryData,requestBodySize:String(se.length),duration:new Date().getTime()-ae,success:!!ue&&(0,S.isSuccess)(ue),responseBodySize:ue?.res.headers["Content-Length"],statusCode:ue?String(ue.res.statusCode):void 0,errorCode:de?(0,M.isPromiseCanceledError)(de)?"canceled":(0,M.getErrorMessage)(de).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ve)})}}async reportStatistic(z,Z,te,ce){if(!this.isEnabled())return;const se=n.isWeb?this.api(`/itemName/${z}.${Z}/version/${te}/statType/${ce==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${z}/extensions/${Z}/${te}/stats?statType=${ce}`),ie=n.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ue={...await this.commonHeadersPromise,Accept:ie};try{await this.requestService.request({type:"POST",url:se,headers:ue},D.CancellationToken.None)}catch(de){}}async download(z,Z,te){this.logService.trace("ExtensionGalleryService#download",z.identifier.id);const ce=(0,m.getGalleryExtensionTelemetryData)(z),se=new Date().getTime(),ie=ve=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...ce,duration:ve}),ae=te===1?"install":te===2?"update":"",ue=ae?{uri:`${z.assets.download.uri}${d.URI.parse(z.assets.download.uri).query?"&":"?"}${ae}=true`,fallbackUri:`${z.assets.download.fallbackUri}${d.URI.parse(z.assets.download.fallbackUri).query?"&":"?"}${ae}=true`}:z.assets.download,de=await this.getAsset(ue);await this.fileService.writeFile(Z,de.stream),ie(new Date().getTime()-se)}async getReadme(z,Z){if(z.assets.readme){const te=await this.getAsset(z.assets.readme,{},Z);return await(0,S.asText)(te)||""}return""}async getManifest(z,Z){if(z.assets.manifest){const te=await this.getAsset(z.assets.manifest,{},Z),ce=await(0,S.asText)(te);return ce?JSON.parse(ce):null}return null}async getManifestFromRawExtensionVersion(z,Z){const te=oe(z,o.Manifest);if(!te)throw new Error("Manifest was not found");const ce={"Accept-Encoding":"gzip"},se=await this.getAsset(te,{headers:ce});return await(0,S.asJson)(se)}async getCoreTranslation(z,Z){const te=z.assets.coreTranslations.filter(ce=>ce[0]===Z.toUpperCase())[0];if(te){const ce=await this.getAsset(te[1]),se=await(0,S.asText)(ce);return se?JSON.parse(se):null}return null}async getChangelog(z,Z){if(z.assets.changelog){const te=await this.getAsset(z.assets.changelog,{},Z);return await(0,S.asText)(te)||""}return""}async getAllCompatibleVersions(z,Z){let te=new L().withFlags(u.IncludeVersions,u.IncludeCategoryAndTags,u.IncludeFiles,u.IncludeVersionProperties).withPage(1,1).withFilter(i.Target,"Microsoft.VisualStudio.Code");z.identifier.uuid?te=te.withFilter(i.ExtensionId,z.identifier.uuid):te=te.withFilter(i.ExtensionName,z.identifier.id);const{galleryExtensions:ce}=await this.queryGallery(te,Z,D.CancellationToken.None);if(!ce.length)return[];const se=N(ce[0]);if((0,E.isNotWebExtensionInWebTargetPlatform)(se,Z))return[];const ie=[];for(const ae of ce[0].versions)try{ie[ie.length-1]?.version!==ae.version&&await this.isRawExtensionVersionCompatible(ae,se,Z)&&ie.push({version:ae.version,date:ae.lastUpdated})}catch(ue){}return ie}async getAsset(z,Z={},te=D.CancellationToken.None){const ce=await this.commonHeadersPromise,se={type:"GET"},ie={...ce,...Z.headers||{}};Z={...Z,...se,headers:ie};const ae=z.uri,ue=z.fallbackUri,de={...Z,url:ae};try{const ve=await this.requestService.request(de,te);if(ve.res.statusCode===200)return ve;const Pe=await(0,S.asText)(ve);throw new Error(`Expected 200, got back ${ve.res.statusCode} instead.

${Pe}`)}catch(ve){if((0,M.isPromiseCanceledError)(ve))throw ve;const Pe=(0,M.getErrorMessage)(ve);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ae,message:Pe});const pe={...Z,url:ue};return this.requestService.request(pe,te)}}async getEngine(z){let Z=T(z);if(!Z){const te=await this.getManifestFromRawExtensionVersion(z,D.CancellationToken.None);if(!te)throw new Error("Manifest was not found");Z=te.engines.vscode}return Z}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const z=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},D.CancellationToken.None);if(z.res.statusCode!==200)throw new Error("Could not get extensions report.");const Z=await(0,S.asJson)(z),te=new Map;if(Z)for(const ce of Z.malicious){const se=te.get(ce)||{id:{id:ce},malicious:!0,slow:!1};se.malicious=!0,te.set(ce,se)}return[...te.values()]}};A=he([ee(1,S.IRequestService),ee(2,w.ILogService),ee(3,y.IEnvironmentService),ee(4,a.ITelemetryService),ee(5,t.IFileService),ee(6,b.IProductService),ee(7,f.IConfigurationService)],A);let O=class extends A{constructor(z,Z,te,ce,se,ie,ae,ue){super(z,Z,te,ce,se,ie,ae,ue)}};O=he([ee(0,c.IStorageService),ee(1,S.IRequestService),ee(2,w.ILogService),ee(3,y.IEnvironmentService),ee(4,a.ITelemetryService),ee(5,t.IFileService),ee(6,b.IProductService),ee(7,f.IConfigurationService)],O),e.ExtensionGalleryService=O;let $=class extends A{constructor(z,Z,te,ce,se,ie,ae){super(void 0,z,Z,te,ce,se,ie,ae)}};$=he([ee(0,S.IRequestService),ee(1,w.ILogService),ee(2,y.IEnvironmentService),ee(3,a.ITelemetryService),ee(4,t.IFileService),ee(5,b.IProductService),ee(6,f.IConfigurationService)],$),e.ExtensionGalleryServiceWithNoStorageService=$;async function X(V,z,Z,te,ce,se){const ie={"X-Market-Client-Id":`VSCode ${V}`,"User-Agent":`VSCode ${V}`},ae=await(0,P.getServiceMachineId)(Z,ce,se);return(0,l.supportsTelemetry)(z,Z)&&(0,l.getTelemetryLevel)(te)===3&&(ie["X-Market-User-Id"]=ae),ie}e.resolveMarketplaceHeaders=X}),define(Q[206],J([0,1,2,47,3,25,152,19,49,56,37,29,65]),function(H,e,v,D,M,C,n,I,d,f,y,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let p=class{constructor(b,S){this._configurationService=S,this._experimentProperties={},this._disposables=new v.DisposableStore,this._cleanupPatterns=[],this._appenders=b.appenders,this._commonProperties=b.commonProperties||Promise.resolve({}),this._piiPaths=b.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!b.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let P of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,C.escapeRegExpCharacters)(P),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(P=>{const c=/^[a-f0-9]+$/i.test(P["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!c})})}setExperimentProperty(b,S){this._experimentProperties[b]=S}_updateTelemetryLevel(){this._telemetryLevel=(0,m.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const b=await this._commonProperties;let S=b.sessionID,P=b["common.machineId"],c=b["common.firstSessionDate"],a=b["common.msftInternal"];return{sessionId:S,machineId:P,firstSessionDate:c,msftInternal:a}}dispose(){this._disposables.dispose()}_log(b,S,P,c){return this.telemetryLevel<S?Promise.resolve(void 0):this._commonProperties.then(a=>{P=(0,D.mixin)(P,a),P=(0,D.mixin)(P,this._experimentProperties),P=(0,D.cloneAndChange)(P,l=>{if(typeof l=="string")return this._cleanupInfo(l,c)}),this._appenders.forEach(l=>l.log(b,P))},a=>{console.error(a)})}publicLog(b,S,P){return this._log(b,3,S,P)}publicLog2(b,S,P){return this.publicLog(b,S,P)}publicLogError(b,S){return this.sendErrorTelemetry?this._log(b,2,S,!0):Promise.resolve(void 0)}publicLogError2(b,S){return this.publicLogError(b,S)}_anonymizeFilePaths(b){let S=b;const P=[];for(let s of this._cleanupPatterns)for(;;){const u=s.exec(b);if(!u)break;P.push([u.index,s.lastIndex])}const c=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,a=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(S="";;){const s=a.exec(b);if(!s)break;!c.test(s[0])&&P.every(([u,r])=>s.index<u||s.index>=r)&&(S+=b.substring(l,s.index)+"<REDACTED: user-file-path>",l=a.lastIndex)}return l<b.length&&(S+=b.substr(l)),S}_removePropertiesWithPossibleUserInfo(b){if(!b)return b;const S=b.toLowerCase(),P=/@[a-zA-Z0-9-.]+/;return/\S*(key|token|sig|password|passwd|pwd)[="':\s]+\S*/.test(S)?"<REDACTED: secret>":P.test(S)?"<REDACTED: email>":b}_cleanupInfo(b,S){let P=b;S&&(P=this._anonymizeFilePaths(P));for(let c of this._cleanupPatterns)P=P.replace(c,"");return P=this._removePropertiesWithPossibleUserInfo(P),P}};p.IDLE_START_EVENT_NAME="UserIdleStart",p.IDLE_STOP_EVENT_NAME="UserIdleStop",p=he([ee(1,I.IConfigurationService)],p),e.TelemetryService=p;function t(){const w=(0,n.localize)(0,null,f.default.nameLong),b=f.default.privacyStatementUrl?(0,n.localize)(2,null,"https://aka.ms/vscode-telemetry",f.default.privacyStatementUrl):(0,n.localize)(1,null,"https://aka.ms/vscode-telemetry"),S=M.isWeb?"":(0,n.localize)(3,null),P=(0,n.localize)(4,null),c=(0,n.localize)(5,null),a=(0,n.localize)(6,null),l=(0,n.localize)(7,null),s=`
|       | ${P} | ${c} | ${a} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,u=(0,n.localize)(8,null);return`
${w} ${b} ${S}

&nbsp;

${l}
${s}

&nbsp;

${u}
`}y.Registry.as(d.Extensions.Configuration).registerConfiguration({id:E.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,n.localize)(9,null),properties:{[E.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,n.localize)(10,null),(0,n.localize)(11,null),(0,n.localize)(12,null),(0,n.localize)(13,null)],markdownDescription:t(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),y.Registry.as(d.Extensions.Configuration).registerConfiguration({id:E.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,n.localize)(14,null),properties:{[E.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:f.default.privacyStatementUrl?(0,n.localize)(16,null,f.default.nameLong,f.default.privacyStatementUrl):(0,n.localize)(15,null,f.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,n.localize)(17,null,`\`#${E.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Q[207],J([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var v;(function(D){D.DARK="dark",D.LIGHT="light",D.HIGH_CONTRAST="hc"})(v=e.ColorScheme||(e.ColorScheme={}))}),define(Q[208],J([0,1,109,4,2,5,37,207]),function(H,e,v,D,M,C,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,C.createDecorator)("themeService");var d;(function(b){function S(P){return P&&typeof P=="object"&&typeof P.id=="string"}b.isThemeColor=S})(d=e.ThemeColor||(e.ThemeColor={}));function f(b){return{id:b}}e.themeColorFromId=f;var y;(function(b){function S(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color=="undefined"||d.isThemeColor(r.color))}b.isThemeIcon=S;const P=new RegExp(`^\\$\\((${v.CSSIcon.iconNameExpression}(?:${v.CSSIcon.iconModifierExpression})?)\\)$`);function c(r){const i=P.exec(r);if(!i)return;let[,o]=i;return{id:o}}b.fromString=c;function a(r,i){let o=r.id;const h=o.lastIndexOf("~");return h!==-1&&(o=o.substring(0,h)),i&&(o=`${o}~${i}`),{id:o}}b.modify=a;function l(r){const i=r.id.lastIndexOf("~");if(i!==-1)return r.id.substring(i+1)}b.getModifier=l;function s(r,i){return r.id===i.id&&r.color?.id===i.color?.id}b.isEqual=s;function u(r,i){return{id:r.id,color:i?f(i):void 0}}b.asThemeIcon=u,b.asClassNameArray=v.CSSIcon.asClassNameArray,b.asClassName=v.CSSIcon.asClassName,b.asCSSSelector=v.CSSIcon.asCSSSelector})(y=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=v.Codicon.file,e.FolderThemeIcon=v.Codicon.folder;function E(b){switch(b){case I.ColorScheme.DARK:return"vs-dark";case I.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=E,e.Extensions={ThemingContribution:"base.contributions.theming"};class m{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new D.Emitter}onColorThemeChange(S){return this.themingParticipants.push(S),this.onThemingParticipantAddedEmitter.fire(S),(0,M.toDisposable)(()=>{const P=this.themingParticipants.indexOf(S);this.themingParticipants.splice(P,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let p=new m;n.Registry.add(e.Extensions.ThemingContribution,p);function t(b){return p.onColorThemeChange(b)}e.registerThemingParticipant=t;class w extends M.Disposable{constructor(S){super();this.themeService=S,this.theme=S.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(P=>this.onThemeChange(P)))}onThemeChange(S){this.theme=S,this.updateStyles()}updateStyles(){}getColor(S,P){let c=this.theme.getColor(S);return c&&P&&(c=P(c,this.theme)),c?c.toString():null}}e.Themable=w}),define(Q[66],J([0,1,14,3,5,38]),function(H,e,v,D,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const n="#FFFFFF",I="#1E1E1E",d="#000000",f="theme",y="themeBackground",E="windowSplash";e.IThemeMainService=(0,M.createDecorator)("themeMainService");let m=class{constructor(t){this.stateMainService=t}getBackgroundColor(){if((D.isWindows||D.isMacintosh)&&v.nativeTheme.shouldUseInvertedColorScheme)return d;let t=this.stateMainService.getItem(y,null);if(!t){let w;(D.isWindows||D.isMacintosh)&&v.nativeTheme.shouldUseInvertedColorScheme?w="hc-black":w=this.stateMainService.getItem(f,"vs-dark").split(" ")[0],t=w==="hc-black"?d:w==="vs"?n:I}return D.isMacintosh&&t.toUpperCase()===I&&(t="#171717"),t}saveWindowSplash(t,w){this.stateMainService.setItems([{key:f,data:w.baseTheme},{key:y,data:w.colorInfo.background},{key:E,data:w}]),typeof t=="number"&&this.updateBackgroundColor(t,w)}updateBackgroundColor(t,w){for(const b of v.BrowserWindow.getAllWindows())if(b.id===t){b.setBackgroundColor(w.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(E)}};m=he([ee(0,C.IStateMainService)],m),e.ThemeMainService=m}),define(Q[41],J([0,1,5]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var D;(function(C){C.Uninitialized="uninitialized",C.Idle="idle",C.CheckingForUpdates="checking for updates",C.AvailableForDownload="available for download",C.Downloading="downloading",C.Downloaded="downloaded",C.Updating="updating",C.Ready="ready"})(D=e.StateType||(e.StateType={}));var M;(function(C){C[C.Setup=0]="Setup",C[C.Archive=1]="Archive",C[C.Snap=2]="Snap"})(M=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(C,n)=>({type:"idle",updateType:C,error:n}),CheckingForUpdates:C=>({type:"checking for updates",explicit:C}),AvailableForDownload:C=>({type:"available for download",update:C}),Downloading:C=>({type:"downloading",update:C}),Downloaded:C=>({type:"downloaded",update:C}),Updating:C=>({type:"updating",update:C}),Ready:C=>({type:"ready",update:C})},e.IUpdateService=(0,v.createDecorator)("updateService")}),define(Q[209],J([0,1,3,153,49,37]),function(H,e,v,D,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),C.Registry.as(M.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,D.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,D.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,D.localize)(2,null),(0,D.localize)(3,null),(0,D.localize)(4,null),(0,D.localize)(5,null)]},"update.channel":{type:"string",default:"default",scope:1,description:(0,D.localize)(6,null),deprecationMessage:(0,D.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,D.localize)(8,null),description:(0,D.localize)(9,null),included:v.isWindows&&!v.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,D.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(Q[210],J([0,1,4,41]),function(H,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class M{constructor(I){this.service=I}listen(I,d){switch(d){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${d}`)}call(I,d,f){switch(d){case"checkForUpdates":return this.service.checkForUpdates(f);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion()}throw new Error(`Call not found: ${d}`)}}e.UpdateChannel=M;class C{constructor(I){this.channel=I,this._onStateChange=new v.Emitter,this.onStateChange=this._onStateChange.event,this._state=D.State.Uninitialized,this.channel.listen("onStateChange")(d=>this.state=d),this.channel.call("_getInitialState").then(d=>this.state=d)}get state(){return this._state}set state(I){this._state=I,this._onStateChange.fire(I)}checkForUpdates(I){return this.channel.call("checkForUpdates",I)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}}e.UpdateChannelClient=C}),define(Q[99],J([0,1,5]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,v.createDecorator)("urlService")}),define(Q[211],J([0,1,7]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class D{constructor(I){this.handler=I}listen(I,d){throw new Error(`Event not found: ${d}`)}call(I,d,f){switch(d){case"handleURL":return this.handler.handleURL(v.URI.revive(f[0]),f[1])}throw new Error(`Call not found: ${d}`)}}e.URLHandlerChannel=D;class M{constructor(I){this.channel=I}handleURL(I,d){return this.channel.call("handleURL",[I.toJSON(),d])}}e.URLHandlerChannelClient=M;class C{constructor(I){this.next=I}async routeCall(I,d,f,y){if(d!=="handleURL")throw new Error(`Call not found: ${d}`);if(f){const E=v.URI.revive(f);if(E&&E.query){const m=/\bwindowId=(\d+)/.exec(E.query);if(m){const p=m[1],t=new RegExp(`window:${p}`),w=I.connections.find(b=>t.test(b.ctx));if(w)return w}}}return this.next.routeCall(I,d,f,y)}routeEvent(I,d){throw new Error(`Event not found: ${d}`)}}e.URLHandlerRouter=C}),define(Q[212],J([0,1,9,2,7,22]),function(H,e,v,D,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class n extends D.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(f,y){const E=[...this.handlers.values()];return(0,v.first)(E.map(m=>()=>m.handleURL(f,y)),void 0,!1).then(m=>m||!1)}registerHandler(f){return this.handlers.add(f),(0,D.toDisposable)(()=>this.handlers.delete(f))}}e.AbstractURLService=n;let I=class extends n{constructor(f){super();this.productService=f}create(f){let{authority:y,path:E,query:m,fragment:p}=f||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return y&&E&&E.indexOf("/")!==0&&(E=`/${E}`),M.URI.from({scheme:this.productService.urlProtocol,authority:y,path:E,query:m,fragment:p})}};I=he([ee(0,C.IProductService)],I),e.NativeURLService=I}),define(Q[213],J([0,1,14,9,4,2,3,7]),function(H,e,v,D,M,C,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function d(y){try{return I.URI.parse(y)}catch(E){return null}}class f{constructor(E,m,p,t,w){if(this.urlService=m,this.uris=[],this.retryCount=0,this.flushDisposable=C.Disposable.None,this.disposables=new C.DisposableStore,this.uris=E,n.isWindows){const P=t.isBuilt?[]:[`"${t.appRoot}"`];P.push("--open-url","--"),v.app.setAsDefaultProtocolClient(w.urlProtocol,process.execPath,P)}const b=M.Event.map(M.Event.fromNodeEventEmitter(v.app,"open-url",(P,c)=>({event:P,url:c})),({event:P,url:c})=>(P.preventDefault(),c));this.disposables.add(b(P=>{const c=d(P);!c||this.urlService.open(c,{originalUrl:P})})),p.getWindows().filter(P=>P.isReady).length>0?this.flush():M.Event.once(p.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const E=[];for(const m of this.uris)await this.urlService.open(m.uri,{originalUrl:m.url})||E.push(m);E.length!==0&&(this.uris=E,this.flushDisposable=(0,D.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=f}),define(Q[214],J([0,1,5]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,v.createDecorator)("webviewManagerService")}),define(Q[215],J([0,1,14,2,10,7]),function(H,e,v,D,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class n extends D.Disposable{constructor(){super();const d=this.handleWebviewRequest.bind(this);v.protocol.registerFileProtocol(M.Schemas.vscodeWebview,d)}handleWebviewRequest(d,f){try{const y=C.URI.parse(d.url),E=n.validWebviewFilePaths.get(y.path);if(typeof E=="string"){const m=`vs/workbench/contrib/webview/browser/pre/${E}`,p=M.FileAccess.asFileUri(m,H);return f(decodeURIComponent(p.fsPath))}else return f({error:-10})}catch{}return f({error:-2})}}e.WebviewProtocolProvider=n,n.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/main.js","main.js"],["/service-worker.js","service-worker.js"]])}),define(Q[67],J([0,1,3]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function D(f){return!!f.workspaceUri}e.isWorkspaceToOpen=D;function M(f){return!!f.folderUri}e.isFolderToOpen=M;function C(f){return!!f.fileUri}e.isFileToOpen=C;function n(f){const y=I(f),E=f.getValue("window.menuBarVisibility");return E==="default"||y==="native"&&E==="compact"||v.isMacintosh&&v.isNative?"classic":E}e.getMenuBarVisibility=n;function I(f){if(v.isWeb)return"custom";const y=f.getValue("window");if(y){if(v.isMacintosh&&y.nativeTabs===!0||v.isMacintosh&&y.nativeFullScreen===!1)return"native";const p=f.getValue("workbench.colorCustomizations");if(p?.["window.activeBorder"]||p?.["window.inactiveBorder"])return"custom";const t=y.titleBarStyle;if(t==="native"||t==="custom")return t}return v.isLinux?"native":"custom"}e.getTitleBarStyle=I;function d(f=0){return Math.pow(1.2,f)}e.zoomLevelToZoomFactor=d}),define(Q[36],J([0,1,5]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWindowsMainService=e.WindowError=e.WindowMode=e.defaultWindowState=e.OpenContext=e.UnloadReason=e.LoadReason=void 0;var D;(function(f){f[f.INITIAL=1]="INITIAL",f[f.LOAD=2]="LOAD",f[f.RELOAD=3]="RELOAD"})(D=e.LoadReason||(e.LoadReason={}));var M;(function(f){f[f.CLOSE=1]="CLOSE",f[f.QUIT=2]="QUIT",f[f.RELOAD=3]="RELOAD",f[f.LOAD=4]="LOAD"})(M=e.UnloadReason||(e.UnloadReason={}));var C;(function(f){f[f.CLI=0]="CLI",f[f.DOCK=1]="DOCK",f[f.MENU=2]="MENU",f[f.DIALOG=3]="DIALOG",f[f.DESKTOP=4]="DESKTOP",f[f.API=5]="API"})(C=e.OpenContext||(e.OpenContext={}));const n=function(f=1){return{width:1024,height:768,mode:f}};e.defaultWindowState=n;var I;(function(f){f[f.Maximized=0]="Maximized",f[f.Normal=1]="Normal",f[f.Minimized=2]="Minimized",f[f.Fullscreen=3]="Fullscreen"})(I=e.WindowMode||(e.WindowMode={}));var d;(function(f){f[f.UNRESPONSIVE=1]="UNRESPONSIVE",f[f.CRASHED=2]="CRASHED",f[f.LOAD=3]="LOAD"})(d=e.WindowError||(e.WindowError={})),e.IWindowsMainService=(0,v.createDecorator)("windowsMainService")}),define(Q[216],J([0,1,14,4,2,215,36]),function(H,e,v,D,M,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let I=class extends M.Disposable{constructor(f){super();this.windowsMainService=f,this._onFoundInFrame=this._register(new D.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new C.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(f,y){let E;if(typeof f.windowId=="number"){const{windowId:m}=f,p=this.windowsMainService.getWindowById(m);if(!p?.win)throw new Error(`Invalid windowId: ${m}`);E=p.win.webContents}else{const{webContentsId:m}=f;if(E=v.webContents.fromId(m),!E)throw new Error(`Invalid webContentsId: ${m}`)}E.isDestroyed()||E.setIgnoreMenuShortcuts(y)}async findInFrame(f,y,E,m){const p=this.getFrameByName(f,y),t=p;if(typeof t.findInFrame=="function"){t.findInFrame(E,{findNext:m.findNext,forward:m.forward});const w=(b,S)=>{S.finalUpdate&&(this._onFoundInFrame.fire(S),p.removeListener("found-in-frame",w))};p.on("found-in-frame",w)}}async stopFindInFrame(f,y,E){const p=this.getFrameByName(f,y);typeof p.stopFindInFrame=="function"&&p.stopFindInFrame(E.keepSelection?"keepSelection":"clearSelection")}getFrameByName(f,y){const E=this.windowsMainService.getWindowById(f.windowId);if(!E?.win)throw new Error(`Invalid windowId: ${f}`);const m=E.win.webContents.mainFrame.framesInSubtree.find(p=>p.name===y);if(!m)throw new Error(`Unknown frame: ${y}`);return m}};I=he([ee(0,n.IWindowsMainService)],I),e.WebviewMainService=I}),define(Q[217],J([0,1,9,4,2]),function(H,e,v,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class C extends M.Disposable{constructor({onDidOpenWindow:I,onDidFocusWindow:d,getActiveWindowId:f}){super();this.disposables=this._register(new M.DisposableStore),D.Event.latch(D.Event.any(I,d))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,v.createCancelablePromise)(()=>f()),(async()=>{try{const E=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:E}catch(E){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(I){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=I}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=C}),define(Q[218],J([0,1,40,15,7,5]),function(H,e,v,D,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,C.createDecorator)("contextService");var n;(function(m){m[m.EMPTY=1]="EMPTY",m[m.FOLDER=2]="FOLDER",m[m.WORKSPACE=3]="WORKSPACE"})(n=e.WorkbenchState||(e.WorkbenchState={}));function I(m){const p=m;return!!(p&&typeof p=="object"&&typeof p.id=="string"&&Array.isArray(p.folders))}e.isWorkspace=I;function d(m){const p=m;return!!(p&&typeof p=="object"&&M.URI.isUri(p.uri)&&typeof p.name=="string"&&typeof p.toResource=="function")}e.isWorkspaceFolder=d;class f{constructor(p,t,w,b,S){this._id=p,this._transient=w,this._configuration=b,this._ignorePathCasing=S,this._foldersMap=v.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=t}update(p){this._id=p.id,this._configuration=p.configuration,this._transient=p.transient,this._ignorePathCasing=p._ignorePathCasing,this.folders=p.folders}get folders(){return this._folders}set folders(p){this._folders=p,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(p){this._configuration=p}getFolder(p){return p&&this._foldersMap.findSubstr(p.with({scheme:p.scheme,authority:p.authority,path:p.path}))||null}updateFoldersMap(){this._foldersMap=v.TernarySearchTree.forUris(this._ignorePathCasing);for(const p of this.folders)this._foldersMap.set(p.uri,p)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=f;class y{constructor(p,t){this.raw=t,this.uri=p.uri,this.index=p.index,this.name=p.name}toResource(p){return(0,D.joinPath)(this.uri,p)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=y;function E(m){return new y({uri:m,index:0,name:(0,D.basenameOrAuthority)(m)},{uri:m.toString()})}e.toWorkspaceFolder=E}),define(Q[27],J([0,1,33,39,78,34,10,8,3,15,7,156,5,64,218]),function(H,e,v,D,M,C,n,I,d,f,y,E,m,p,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const w=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,E.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function b(T){return(typeof T=="string"?(0,I.extname)(T):(0,f.extname)(T))===w}e.hasWorkspaceFileExtension=b,e.IWorkspacesService=(0,m.createDecorator)("workspacesService");function S(T){return T.hasOwnProperty("workspace")}e.isRecentWorkspace=S;function P(T){return T.hasOwnProperty("folderUri")}e.isRecentFolder=P;function c(T){return T.hasOwnProperty("fileUri")}e.isRecentFile=c;function a(T){const B=T;return typeof B?.id=="string"&&y.URI.isUri(B.uri)}e.isSingleFolderWorkspaceIdentifier=a;function l(T){if(T.configuration)return{id:T.id,configPath:T.configuration};if(T.folders.length===1)return{id:T.id,uri:T.folders[0].uri}}e.toWorkspaceIdentifier=l;function s(T){const B=T;return typeof B?.id=="string"&&y.URI.isUri(B.configPath)}e.isWorkspaceIdentifier=s;function u(T){const B=T;if(B?.uri)return{id:B.id,uri:y.URI.revive(B.uri)};const q=T;if(q?.configPath)return{id:q.id,configPath:y.URI.revive(q.configPath)};if(T?.id)return{id:T.id}}e.reviveIdentifier=u;function r(T,B){return f.extUriBiasedIgnorePathCase.isEqualOrParent(T,B.untitledWorkspacesHome)}e.isUntitledWorkspace=r;function i(T){return o(T)||h(T)}e.isStoredWorkspaceFolder=i;function o(T){const B=T;return typeof B?.path=="string"&&(!B.name||typeof B.name=="string")}e.isRawFileWorkspaceFolder=o;function h(T){const B=T;return typeof B?.uri=="string"&&(!B.name||typeof B.name=="string")}e.isRawUriWorkspaceFolder=h;function g(T,B,q,U,N=!d.isWindows,_){if(T.scheme!==U.scheme)return{name:q,uri:T.toString(!0)};let Y=B?void 0:_.relativePath(U,T);if(Y!==void 0)Y.length===0?Y=".":d.isWindows&&T.scheme===n.Schemas.file&&!N&&(Y=Y.replace(/\//g,"\\"));else if(T.scheme===n.Schemas.file)Y=T.fsPath,d.isWindows&&(Y=(0,C.normalizeDriveLetter)(Y),N&&(Y=(0,v.toSlashes)(Y)));else{if(!_.isEqualAuthority(T.authority,U.authority))return{name:q,uri:T.toString(!0)};Y=T.path}return{name:q,path:Y}}e.getStoredWorkspaceFolder=g;function k(T,B,q){let U=[],N=new Set;const _=q.dirname(B);for(let Y of T){let F;if(o(Y))Y.path&&(F=q.resolvePath(_,Y.path));else if(h(Y))try{F=y.URI.parse(Y.uri),F.path[0]!=="/"&&(F=F.with({path:"/"+F.path}))}catch(A){console.warn(A)}if(F){let A=q.getComparisonKey(F);if(!N.has(A)){N.add(A);const O=Y.name||q.basenameOrAuthority(F);U.push(new t.WorkspaceFolder({uri:F,name:O,index:U.length},Y))}}}return U}e.toWorkspaceFolders=k;function L(T,B,q,U,N){let _=R(B,T);const Y=N.dirname(B),F=N.dirname(U),A=[],O=W(_.folders);for(const z of _.folders){const Z=o(z)?N.resolvePath(Y,z.path):y.URI.parse(z.uri);let te;q?te=!1:te=!o(z)||(0,I.isAbsolute)(z.path),A.push(g(Z,te,z.name,F,O,N))}const $={insertSpaces:!1,tabSize:4,eol:d.isLinux||d.isMacintosh?`
`:`\r
`},X=M.setProperty(T,["folders"],A,$);let V=M.applyEdits(T,X);return(0,f.isEqualAuthority)(_.remoteAuthority,(0,p.getRemoteAuthority)(U))&&(V=M.applyEdits(V,M.removeProperty(V,["remoteAuthority"],$))),V}e.rewriteWorkspaceFileForNewLocation=L;function R(T,B){let q=D.parse(B);if(q&&Array.isArray(q.folders))q.folders=q.folders.filter(U=>i(U));else throw new Error(`${T} looks like an invalid workspace file.`);return q}function W(T){return d.isWindows?T.some(B=>o(B)&&B.path.indexOf("/")>=0):!0}e.useSlashForPath=W;function j(T){return T.workspace&&typeof T.workspace=="object"&&typeof T.workspace.id=="string"&&typeof T.workspace.configPath=="string"}function x(T){return typeof T.folderUri=="string"}function ne(T){return typeof T.fileUri=="string"}function oe(T,B){const q={workspaces:[],files:[]};if(T){const U=function(_,Y){for(let F=0;F<_.length;F++)try{Y(_[F],F)}catch(A){B.warn(`Error restoring recent entry ${JSON.stringify(_[F])}: ${A.toString()}. Skip entry.`)}},N=T;if(Array.isArray(N.entries))U(N.entries,_=>{const Y=_.label,F=_.remoteAuthority;j(_)?q.workspaces.push({label:Y,remoteAuthority:F,workspace:{id:_.workspace.id,configPath:y.URI.parse(_.workspace.configPath)}}):x(_)?q.workspaces.push({label:Y,remoteAuthority:F,folderUri:y.URI.parse(_.folderUri)}):ne(_)&&q.files.push({label:Y,remoteAuthority:F,fileUri:y.URI.parse(_.fileUri)})});else{const _=T;Array.isArray(_.workspaces3)&&U(_.workspaces3,(Y,F)=>{const A=Array.isArray(_.workspaceLabels)&&_.workspaceLabels[F]||void 0;typeof Y=="object"&&typeof Y.id=="string"&&typeof Y.configURIPath=="string"?q.workspaces.push({label:A,workspace:{id:Y.id,configPath:y.URI.parse(Y.configURIPath)}}):typeof Y=="string"&&q.workspaces.push({label:A,folderUri:y.URI.parse(Y)})}),Array.isArray(_.files2)&&U(_.files2,(Y,F)=>{const A=Array.isArray(_.fileLabels)&&_.fileLabels[F]||void 0;typeof Y=="string"&&q.files.push({label:A,fileUri:y.URI.parse(Y)})})}}return q}e.restoreRecentlyOpened=oe;function G(T){const B={entries:[]};for(const q of T.workspaces)P(q)?B.entries.push({folderUri:q.folderUri.toString(),label:q.label,remoteAuthority:q.remoteAuthority}):B.entries.push({workspace:{id:q.workspace.id,configPath:q.workspace.configPath.toString()},label:q.label,remoteAuthority:q.remoteAuthority});for(const q of T.files)B.entries.push({fileUri:q.fileUri.toString(),label:q.label,remoteAuthority:q.remoteAuthority});return B}e.toStoreData=G}),define(Q[51],J([0,1,5,27]),function(H,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.IBackupMainService=void 0,e.IBackupMainService=(0,v.createDecorator)("backupMainService");function M(C){const n=C;return n&&(0,D.isWorkspaceIdentifier)(n.workspace)}e.isWorkspaceBackupInfo=M}),define(Q[52],J([0,1,14,9,81,34,2,70,8,3,13,21,136,5,6,38,27]),function(H,e,v,D,M,C,n,I,d,f,y,E,m,p,t,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,p.createDecorator)("dialogMainService");let S=class wt{constructor(c,a){this.stateMainService=c,this.logService=a,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new D.Queue}pickFileFolder(c,a){return this.doPick({...c,pickFolders:!0,pickFiles:!0,title:(0,m.localize)(0,null)},a)}pickFolder(c,a){return this.doPick({...c,pickFolders:!0,title:(0,m.localize)(1,null)},a)}pickFile(c,a){return this.doPick({...c,pickFiles:!0,title:(0,m.localize)(2,null)},a)}pickWorkspace(c,a){const l=(0,m.localize)(3,null),s=(0,C.mnemonicButtonLabel)((0,m.localize)(4,null)),u=b.WORKSPACE_FILTER;return this.doPick({...c,pickFiles:!0,title:l,filters:u,buttonLabel:s},a)}async doPick(c,a){const l={title:c.title,buttonLabel:c.buttonLabel,filters:c.filters};l.defaultPath=c.defaultPath||this.stateMainService.getItem(wt.workingDirPickerStorageKey),(typeof c.pickFiles=="boolean"||typeof c.pickFolders=="boolean")&&(l.properties=void 0,c.pickFiles&&c.pickFolders&&(l.properties=["multiSelections","openDirectory","openFile","createDirectory"])),l.properties||(l.properties=["multiSelections",c.pickFolders?"openDirectory":"openFile","createDirectory"]),f.isMacintosh&&l.properties.push("treatPackageAsDirectory");const s=a||v.BrowserWindow.getFocusedWindow(),u=await this.showOpenDialog(l,(0,y.withNullAsUndefined)(s));if(u&&u.filePaths&&u.filePaths.length>0)return this.stateMainService.setItem(wt.workingDirPickerStorageKey,(0,d.dirname)(u.filePaths[0])),u.filePaths}getWindowDialogQueue(c){if(c){let a=this.windowDialogQueues.get(c.id);return a||(a=new D.Queue,this.windowDialogQueues.set(c.id,a)),a}else return this.noWindowDialogueQueue}showMessageBox(c,a){return this.getWindowDialogQueue(a).queue(async()=>a?v.dialog.showMessageBox(a,c):v.dialog.showMessageBox(c))}async showSaveDialog(c,a){const l=this.acquireFileDialogLock(c,a);if(!l)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(a).queue(async()=>{let s;return a?s=await v.dialog.showSaveDialog(a,c):s=await v.dialog.showSaveDialog(c),s.filePath=this.normalizePath(s.filePath),s})}finally{(0,n.dispose)(l)}}normalizePath(c){return c&&f.isMacintosh&&(c=(0,I.normalizeNFC)(c)),c}normalizePaths(c){return c.map(a=>this.normalizePath(a))}async showOpenDialog(c,a){c.defaultPath&&(await E.Promises.exists(c.defaultPath)||(c.defaultPath=void 0));const l=this.acquireFileDialogLock(c,a);if(!l)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(a).queue(async()=>{let s;return a?s=await v.dialog.showOpenDialog(a,c):s=await v.dialog.showOpenDialog(c),s.filePaths=this.normalizePaths(s.filePaths),s})}finally{(0,n.dispose)(l)}}acquireFileDialogLock(c,a){if(!a)return n.Disposable.None;let l=this.windowFileDialogLocks.get(a.id);l||(l=new Set,this.windowFileDialogLocks.set(a.id,l));const s=(0,M.hash)(c);if(!l.has(s))return l.add(s),(0,n.toDisposable)(()=>{l?.delete(s),l?.size===0&&this.windowFileDialogLocks.delete(a.id)})}};S.workingDirPickerStorageKey="pickerWorkingDir",S=he([ee(0,w.IStateMainService),ee(1,t.ILogService)],S),e.DialogMainService=S}),define(Q[219],J([0,1,4,2,27]),function(H,e,v,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class C extends D.Disposable{constructor(I,d){super();this.logService=I,this.storageMainService=d,this._onDidChangeGlobalStorage=this._register(new v.Emitter),this.onDidChangeGlobalStorage=this._onDidChangeGlobalStorage.event,this.registerGlobalStorageListeners()}registerGlobalStorageListeners(){this._register(v.Event.debounce(this.storageMainService.globalStorage.onDidChangeStorage,(I,d)=>(I?I.push(d):I=[d],I),C.STORAGE_CHANGE_DEBOUNCE_TIME)(I=>{I.length&&this._onDidChangeGlobalStorage.fire(this.serializeGlobalStorageEvents(I))}))}serializeGlobalStorageEvents(I){const d=new Map,f=new Set;return I.forEach(y=>{const E=this.storageMainService.globalStorage.get(y.key);typeof E=="string"?d.set(y.key,E):f.add(y.key)}),{changed:Array.from(d.entries()),deleted:Array.from(f.values())}}listen(I,d){switch(d){case"onDidChangeGlobalStorage":return this.onDidChangeGlobalStorage}throw new Error(`Event not found: ${d}`)}async call(I,d,f){const y=(0,M.reviveIdentifier)(f.workspace),E=await this.withStorageInitialized(y);switch(d){case"getItems":return Array.from(E.items.entries());case"updateItems":{const m=f;if(m.insert)for(const[p,t]of m.insert)E.set(p,t);m.delete&&m.delete.forEach(p=>E.delete(p));break}case"close":{if(y)return E.close();break}default:throw new Error(`Call not found: ${d}`)}}async withStorageInitialized(I){const d=I?this.storageMainService.workspaceStorage(I):this.storageMainService.globalStorage;try{await d.init()}catch(f){this.logService.error(`StorageIPC#init: Unable to init ${I?"workspace":"global"} storage due to ${f}`)}return d}}e.StorageDatabaseChannel=C,C.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(Q[220],J([0,1,4,2,8,21,86,126,6,98,29,27]),function(H,e,v,D,M,C,n,I,d,f,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspaceStorageMain=e.GlobalStorageMain=void 0;class m extends D.Disposable{constructor(b){super();this.logService=b,this._onDidChangeStorage=this._register(new v.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new v.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this.storage=new n.Storage(new n.InMemoryStorageDatabase),this.initializePromise=void 0}init(){return this.initializePromise||(this.initializePromise=(async()=>{try{const b=await this.doCreate();this.storage.dispose(),this.storage=b,this._register(b.onDidChangeStorage(P=>this._onDidChangeStorage.fire({key:P}))),await this.doInit(b);const S=b.getBoolean(f.IS_NEW_KEY);S===void 0?b.set(f.IS_NEW_KEY,!0):S&&b.set(f.IS_NEW_KEY,!1)}catch(b){this.logService.error(`StorageMain#initialize(): Unable to init storage due to ${b}`)}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===d.LogLevel.Trace?b=>this.logService.trace(b):void 0,logError:b=>this.logService.error(b)}}doInit(b){return b.init()}get items(){return this.storage.items}get(b,S){return this.storage.get(b,S)}set(b,S){return this.storage.set(b,S)}delete(b){return this.storage.delete(b)}async close(){this.initializePromise&&await this.initializePromise,await this.storage.close(),this._onDidCloseStorage.fire()}}class p extends m{constructor(b,S,P){super(S);this.options=b,this.environmentService=P}async doCreate(){let b;return this.options.useInMemoryStorage?b=I.SQLiteStorageDatabase.IN_MEMORY_PATH:b=(0,M.join)(this.environmentService.globalStorageHome.fsPath,p.STORAGE_NAME),new n.Storage(new I.SQLiteStorageDatabase(b,{logging:this.createLoggingOptions()}))}async doInit(b){await super.doInit(b),this.updateTelemetryState(b)}updateTelemetryState(b){b.get(y.firstSessionDateStorageKey,void 0)===void 0&&b.set(y.firstSessionDateStorageKey,new Date().toUTCString());const P=b.get(y.currentSessionDateStorageKey,void 0),c=new Date().toUTCString();b.set(y.lastSessionDateStorageKey,typeof P=="undefined"?null:P),b.set(y.currentSessionDateStorageKey,c)}}e.GlobalStorageMain=p,p.STORAGE_NAME="state.vscdb";class t extends m{constructor(b,S,P,c){super(P);this.workspace=b,this.options=S,this.environmentService=c}async doCreate(){const{storageFilePath:b,wasCreated:S}=await this.prepareWorkspaceStorageFolder();return new n.Storage(new I.SQLiteStorageDatabase(b,{logging:this.createLoggingOptions()}),{hint:S?n.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:I.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const b=(0,M.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),S=(0,M.join)(b,t.WORKSPACE_STORAGE_NAME);return await C.Promises.exists(b)?{storageFilePath:S,wasCreated:!1}:(await C.Promises.mkdir(b,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(b),{storageFilePath:S,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(b){let S;if((0,E.isSingleFolderWorkspaceIdentifier)(this.workspace)?S={folder:this.workspace.uri.toString()}:(0,E.isWorkspaceIdentifier)(this.workspace)&&(S={workspace:this.workspace.configPath.toString()}),S)try{const P=(0,M.join)(b,t.WORKSPACE_META_NAME);await C.Promises.exists(P)||await C.Promises.writeFile(P,JSON.stringify(S,void 0,2))}catch(P){this.logService.error(`StorageMain#ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${P}`)}}}e.WorkspaceStorageMain=t,t.WORKSPACE_STORAGE_NAME="state.vscdb",t.WORKSPACE_META_NAME="workspace.json"}),define(Q[100],J([0,1,42,2,48,5,20,6,220]),function(H,e,v,D,M,C,n,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,C.createDecorator)("storageMainService");let f=class extends D.Disposable{constructor(E,m,p){super();this.logService=E,this.environmentService=m,this.lifecycleMainService=p,this.globalStorage=this.createGlobalStorage(),this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.globalStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(async E=>{E.workspace&&this.workspaceStorage(E.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(E=>{E.join(this.globalStorage.close());for(const[,m]of this.mapWorkspaceToStorage)E.join(m.close())}))}createGlobalStorage(){if(this.globalStorage)return this.globalStorage;this.logService.trace("StorageMainService: creating global storage");const E=new d.GlobalStorageMain(this.getStorageOptions(),this.logService,this.environmentService);return(0,v.once)(E.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed global storage")}),E}createWorkspaceStorage(E){return new d.WorkspaceStorageMain(E,this.getStorageOptions(),this.logService,this.environmentService)}workspaceStorage(E){let m=this.mapWorkspaceToStorage.get(E.id);return m||(this.logService.trace(`StorageMainService: creating workspace storage (${E.id})`),m=this.createWorkspaceStorage(E),this.mapWorkspaceToStorage.set(E.id,m),(0,v.once)(m.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${E.id})`),this.mapWorkspaceToStorage.delete(E.id)})),m}};f=he([ee(0,I.ILogService),ee(1,M.IEnvironmentService),ee(2,n.ILifecycleMainService)],f),e.StorageMainService=f}),define(Q[101],J([0,1,15,7,27]),function(H,e,v,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function C(d,f,y){for(const m of d){const p=m.openedWorkspace;if((0,M.isWorkspaceIdentifier)(p)){const t=y(p);if(t){if(t.folders.some(w=>v.extUriBiasedIgnorePathCase.isEqualOrParent(f,w.uri)))return m}else if(v.extUriBiasedIgnorePathCase.isEqualOrParent(f,p.configPath))return m}}const E=d.filter(m=>(0,M.isSingleFolderWorkspaceIdentifier)(m.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqualOrParent(f,m.openedWorkspace.uri));if(E.length)return E.sort((m,p)=>-(m.openedWorkspace.uri.path.length-p.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=C;function n(d,f){for(const y of d)if((0,M.isWorkspaceIdentifier)(y.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqual(y.openedWorkspace.configPath,f)||(0,M.isSingleFolderWorkspaceIdentifier)(y.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqual(y.openedWorkspace.uri,f))return y}e.findWindowOnWorkspaceOrFolder=n;function I(d,f){const y=E=>f.some(m=>v.extUriBiasedIgnorePathCase.isEqual(D.URI.file(m),D.URI.file(E)));for(const E of d)if(E.config?.extensionDevelopmentPath?.some(m=>y(m)))return E}e.findWindowOnExtensionDevelopmentPath=I}),define(Q[221],J([0,1,14,2,3,15,7,19,20,6,38,36,27]),function(H,e,v,D,M,C,n,I,d,f,y,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let p=class pt extends D.Disposable{constructor(c,a,l,s,u){super();this.windowsMainService=c,this.stateMainService=a,this.lifecycleMainService=l,this.logService=s,this.configurationService=u,this._state=t(this.stateMainService.getItem(pt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){v.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(c=>this.onBeforeCloseWindow(c)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(c=>{c.newCount-c.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(c=>this.onBeforeCloseWindow(c))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const c={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!c.lastActiveWindow){let s=this.windowsMainService.getLastActiveWindow();(!s||s.isExtensionDevelopmentHost)&&(s=this.windowsMainService.getWindows().find(u=>!u.isExtensionDevelopmentHost)),s&&(c.lastActiveWindow=this.toWindowState(s))}const a=this.windowsMainService.getWindows().find(s=>s.isExtensionDevelopmentHost&&!s.isExtensionTestHost);a&&(c.lastPluginDevelopmentHostWindow=this.toWindowState(a)),this.windowsMainService.getWindowCount()>1&&(c.openedWindows=this.windowsMainService.getWindows().filter(s=>!s.isExtensionDevelopmentHost).map(s=>this.toWindowState(s)));const l=b(c);this.stateMainService.setItem(pt.windowsStateStorageKey,l),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",l)}onBeforeCloseWindow(c){if(this.lifecycleMainService.quitRequested)return;const a=this.toWindowState(c);c.isExtensionDevelopmentHost&&!c.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=a:!c.isExtensionDevelopmentHost&&c.openedWorkspace&&this._state.openedWindows.forEach(l=>{const s=(0,m.isWorkspaceIdentifier)(c.openedWorkspace)&&l.workspace?.id===c.openedWorkspace.id,u=(0,m.isSingleFolderWorkspaceIdentifier)(c.openedWorkspace)&&l.folderUri&&C.extUriBiasedIgnorePathCase.isEqual(l.folderUri,c.openedWorkspace.uri);(s||u)&&(l.uiState=a.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=a)}toWindowState(c){return{workspace:(0,m.isWorkspaceIdentifier)(c.openedWorkspace)?c.openedWorkspace:void 0,folderUri:(0,m.isSingleFolderWorkspaceIdentifier)(c.openedWorkspace)?c.openedWorkspace.uri:void 0,backupPath:c.backupPath,remoteAuthority:c.remoteAuthority,uiState:c.serializeWindowState()}}getNewWindowState(c){const a=this.doGetNewWindowState(c),l=this.configurationService.getValue("window");let s;return a.hasDefaultState?s=!!(l?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(l.newWindowDimensions)>=0):(s=!!(this.lifecycleMainService.wasRestarted||l?.restoreFullscreen),s&&M.isMacintosh&&this.windowsMainService.getWindows().some(u=>u.isFullScreen)&&(s=!1)),a.mode===3&&!s&&(a.mode=1),a}doGetNewWindowState(c){const a=this.windowsMainService.getLastActiveWindow();if(!c.extensionTestsPath){if(!!c.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const o=c.workspace;if((0,m.isWorkspaceIdentifier)(o)){const g=this.state.openedWindows.filter(k=>k.workspace&&k.workspace.id===o.id).map(k=>k.uiState);if(g.length)return g[0]}if((0,m.isSingleFolderWorkspaceIdentifier)(o)){const g=this.state.openedWindows.filter(k=>k.folderUri&&C.extUriBiasedIgnorePathCase.isEqual(k.folderUri,o.uri)).map(k=>k.uiState);if(g.length)return g[0]}else if(c.backupPath){const g=this.state.openedWindows.filter(k=>k.backupPath===c.backupPath).map(k=>k.uiState);if(g.length)return g[0]}const h=this.lastClosedState||this.state.lastActiveWindow;if(!a&&h)return h.uiState}let l;const s=v.screen.getAllDisplays();if(s.length===1)l=s[0];else{if(M.isMacintosh){const o=v.screen.getCursorScreenPoint();l=v.screen.getDisplayNearestPoint(o)}!l&&a&&(l=v.screen.getDisplayMatching(a.getBounds())),l||(l=v.screen.getPrimaryDisplay()||s[0])}let u=(0,E.defaultWindowState)();u.x=Math.round(l.bounds.x+l.bounds.width/2-u.width/2),u.y=Math.round(l.bounds.y+l.bounds.height/2-u.height/2);const r=this.configurationService.getValue("window");let i=!0;if(r?.newWindowDimensions){if(r.newWindowDimensions==="maximized")u.mode=0,i=!1;else if(r.newWindowDimensions==="fullscreen")u.mode=3,i=!1;else if((r.newWindowDimensions==="inherit"||r.newWindowDimensions==="offset")&&a){const o=a.serializeWindowState();o.mode===3?u.mode=3:u=o,i=u.mode!==3&&r.newWindowDimensions==="offset"}}return i&&(u=this.ensureNoOverlap(u)),u.hasDefaultState=!0,u}ensureNoOverlap(c){if(this.windowsMainService.getWindows().length===0)return c;c.x=typeof c.x=="number"?c.x:0,c.y=typeof c.y=="number"?c.y:0;const a=this.windowsMainService.getWindows().map(l=>l.getBounds());for(;a.some(l=>l.x===c.x||l.y===c.y);)c.x+=30,c.y+=30;return c}};p.windowsStateStorageKey="windowsState",p=he([ee(0,E.IWindowsMainService),ee(1,y.IStateMainService),ee(2,d.ILifecycleMainService),ee(3,f.ILogService),ee(4,I.IConfigurationService)],p),e.WindowsStateHandler=p;function t(P){const c={openedWindows:[]},a=P||{openedWindows:[]};return a.lastActiveWindow&&(c.lastActiveWindow=w(a.lastActiveWindow)),a.lastPluginDevelopmentHostWindow&&(c.lastPluginDevelopmentHostWindow=w(a.lastPluginDevelopmentHostWindow)),Array.isArray(a.openedWindows)&&(c.openedWindows=a.openedWindows.map(l=>w(l))),c}e.restoreWindowsState=t;function w(P){const c={uiState:P.uiState};return P.backupPath&&(c.backupPath=P.backupPath),P.remoteAuthority&&(c.remoteAuthority=P.remoteAuthority),P.folder&&(c.folderUri=n.URI.parse(P.folder)),P.workspaceIdentifier&&(c.workspace={id:P.workspaceIdentifier.id,configPath:n.URI.parse(P.workspaceIdentifier.configURIPath)}),c}function b(P){return{lastActiveWindow:P.lastActiveWindow&&S(P.lastActiveWindow),lastPluginDevelopmentHostWindow:P.lastPluginDevelopmentHostWindow&&S(P.lastPluginDevelopmentHostWindow),openedWindows:P.openedWindows.map(c=>S(c))}}e.getWindowsStateStoreData=b;function S(P){return{workspaceIdentifier:P.workspace&&{id:P.workspace.id,configURIPath:P.workspace.configPath.toString()},folder:P.folderUri&&P.folderUri.toString(),backupPath:P.backupPath,remoteAuthority:P.remoteAuthority,uiState:P.uiState}}}),define(Q[102],J([0,1,61,28,10,3,15]),function(H,e,v,D,M,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=void 0;function I(f){function y(){let E=f.scheme===M.Schemas.file?(0,n.originalFSPath)(f):f.toString();return C.isLinux||(E=E.toLowerCase()),(0,v.createHash)("md5").update(E).digest("hex")}return{id:y(),configPath:f}}e.getWorkspaceIdentifier=I;function d(f,y){function E(){if(f.scheme!==M.Schemas.file)return(0,v.createHash)("md5").update(f.toString()).digest("hex");if(!y)try{y=(0,D.statSync)(f.fsPath)}catch(t){return}let p;return C.isLinux?p=y.ino:C.isMacintosh?p=y.birthtime.getTime():C.isWindows&&(typeof y.birthtimeMs=="number"?p=Math.floor(y.birthtimeMs):p=y.birthtime.getTime()),(0,v.createHash)("md5").update(f.fsPath).update(p?String(p):"").digest("hex")}const m=E();if(typeof m=="string")return{id:m,uri:f}}e.getSingleFolderWorkspaceIdentifier=d}),define(Q[222],J([0,1,16,10,6,250,113,20]),function(H,e,v,D,M,C,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerMainProcessExtensionHostStarter=void 0;class d{constructor(m,p){this._worker=new C.Worker(D.FileAccess.asFileUri("vs/platform/extensions/node/extensionHostStarterWorkerMain.js",H).fsPath),this._worker.on("message",m),this._worker.on("error",p)}getId(){return 1}postMessage(m,p){this._worker.postMessage(m,p)}dispose(){this._worker.terminate()}}let f=class{constructor(m){this._logService=m}async logInfo(m){this._logService.info(m)}};f=he([ee(0,M.ILogService)],f);let y=class{constructor(m,p){this._logService=m,this._shutdown=!1,this._proxy=null;const t={create:(w,b,S)=>{const P=new d(b,S);return P.postMessage(w,[]),P}};this._worker=new n.SimpleWorkerClient(t,"vs/platform/extensions/node/extensionHostStarterWorker",new f(this._logService)),this._initialize(),p.onWillShutdown(w=>{this._shutdown=!0,this._proxy&&w.join(this._proxy.waitForAllExit(6e3))})}dispose(){}async _initialize(){this._proxy=await this._worker.getProxyObject(),this._logService.info("ExtensionHostStarterWorker created")}onDynamicStdout(m){return this._proxy.onDynamicStdout(m)}onDynamicStderr(m){return this._proxy.onDynamicStderr(m)}onDynamicMessage(m){return this._proxy.onDynamicMessage(m)}onDynamicError(m){return this._proxy.onDynamicError(m)}onDynamicExit(m){return this._proxy.onDynamicExit(m)}async createExtensionHost(){const m=await this._worker.getProxyObject();if(this._shutdown)throw(0,v.canceled)();return m.createExtensionHost()}async start(m,p){const t=await this._worker.getProxyObject();if(this._shutdown)throw(0,v.canceled)();return t.start(m,p)}async enableInspectPort(m){const p=await this._worker.getProxyObject();if(this._shutdown)throw(0,v.canceled)();return p.enableInspectPort(m)}async kill(m){const p=await this._worker.getProxyObject();if(this._shutdown)throw(0,v.canceled)();return p.kill(m)}};y=he([ee(0,M.ILogService),ee(1,I.ILifecycleMainService)],y),e.WorkerMainProcessExtensionHostStarter=y}),define(Q[58],J([0,1,61,62,26,17,16,4,2,8,3,31,35,84,223]),function(H,e,v,D,M,C,n,I,d,f,y,E,m,p,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class w{constructor(g){this.socket=g,this._errorListener=k=>{if(k){if(k.code==="EPIPE")return;(0,n.onUnexpectedError)(k)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(g){const k=L=>g(C.VSBuffer.wrap(L));return this.socket.on("data",k),{dispose:()=>this.socket.off("data",k)}}onClose(g){const k=L=>{g({type:0,hadError:L,error:void 0})};return this.socket.on("close",k),{dispose:()=>this.socket.off("close",k)}}onEnd(g){return this.socket.on("end",g),{dispose:()=>this.socket.off("end",g)}}write(g){if(!this.socket.destroyed)try{this.socket.write(g.buffer,k=>{if(k){if(k.code==="EPIPE")return;(0,n.onUnexpectedError)(k)}})}catch(k){if(k.code==="EPIPE")return;(0,n.onUnexpectedError)(k)}}end(){this.socket.end()}drain(){return new Promise((g,k)=>{if(this.socket.bufferSize===0){g();return}const L=()=>{this.socket.off("close",L),this.socket.off("end",L),this.socket.off("error",L),this.socket.off("timeout",L),this.socket.off("drain",L),g()};this.socket.on("close",L),this.socket.on("end",L),this.socket.on("error",L),this.socket.on("timeout",L),this.socket.on("drain",L)})}}e.NodeSocket=w;var b;(function(h){h[h.MinHeaderByteSize=2]="MinHeaderByteSize"})(b||(b={}));var S;(function(h){h[h.PeekHeader=1]="PeekHeader",h[h.ReadHeader=2]="ReadHeader",h[h.ReadBody=3]="ReadBody",h[h.Fin=4]="Fin"})(S||(S={}));class P extends d.Disposable{constructor(g,k,L,R){super();this._onDidZlibFlush=this._register(new I.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new I.Emitter),this._onClose=this._register(new I.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=g,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=k,this._recordInflateBytes=R,k?(this._zlibInflate=t.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",W=>{console.error(W),(0,n.onUnexpectedError)(W),this._onClose.fire({type:0,hadError:!0,error:W})}),this._zlibInflate.on("data",W=>{this._pendingInflateData.push(W)}),L&&(this._zlibInflate.write(L.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=t.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",W=>{console.error(W),(0,n.onUnexpectedError)(W),this._onClose.fire({type:0,hadError:!0,error:W})}),this._zlibDeflate.on("data",W=>{this._pendingDeflateData.push(W)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new p.ChunkStream,this._register(this.socket.onData(W=>this._acceptChunk(W))),this._register(this.socket.onClose(W=>this._onClose.fire(W)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?C.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):C.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(g){return this._onData.event(g)}onClose(g){return this._onClose.event(g)}onEnd(g){return this.socket.onEnd(g)}write(g){this._totalOutgoingDataBytes+=g.byteLength,this._zlibDeflate?(this._zlibDeflate.write(g.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let k=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,k=k.slice(0,k.length-4),this._isEnded||this._write(C.VSBuffer.wrap(k),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(g,!1)}_write(g,k){let L=2;g.byteLength<126?L+=0:g.byteLength<2**16?L+=2:L+=8;const R=C.VSBuffer.alloc(L);if(k?R.writeUInt8(194,0):R.writeUInt8(130,0),g.byteLength<126)R.writeUInt8(g.byteLength,1);else if(g.byteLength<2**16){R.writeUInt8(126,1);let W=1;R.writeUInt8(g.byteLength>>>8&255,++W),R.writeUInt8(g.byteLength>>>0&255,++W)}else{R.writeUInt8(127,1);let W=1;R.writeUInt8(0,++W),R.writeUInt8(0,++W),R.writeUInt8(0,++W),R.writeUInt8(0,++W),R.writeUInt8(g.byteLength>>>24&255,++W),R.writeUInt8(g.byteLength>>>16&255,++W),R.writeUInt8(g.byteLength>>>8&255,++W),R.writeUInt8(g.byteLength>>>0&255,++W)}this._totalOutgoingWireBytes+=R.byteLength+g.byteLength,this.socket.write(C.VSBuffer.concat([R,g]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(g){if(g.byteLength!==0){for(this._totalIncomingWireBytes+=g.byteLength,this._incomingData.acceptChunk(g);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const k=this._incomingData.peek(this._state.readLen),L=k.readUInt8(0),R=(L&128)>>>7,W=(L&64)>>>6,j=k.readUInt8(1),x=(j&128)>>>7,ne=j&127;this._state.state=2,this._state.readLen=2+(x?4:0)+(ne===126?2:0)+(ne===127?8:0),this._state.fin=R,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(W)),this._state.firstFrameOfMessage=Boolean(R),this._state.mask=0}else if(this._state.state===2){const k=this._incomingData.read(this._state.readLen),L=k.readUInt8(1),R=(L&128)>>>7;let W=L&127,j=1;W===126?W=k.readUInt8(++j)*2**8+k.readUInt8(++j):W===127&&(W=k.readUInt8(++j)*0+k.readUInt8(++j)*0+k.readUInt8(++j)*0+k.readUInt8(++j)*0+k.readUInt8(++j)*2**24+k.readUInt8(++j)*2**16+k.readUInt8(++j)*2**8+k.readUInt8(++j));let x=0;R&&(x=k.readUInt8(++j)*2**24+k.readUInt8(++j)*2**16+k.readUInt8(++j)*2**8+k.readUInt8(++j)),this._state.state=3,this._state.readLen=W,this._state.mask=x}else if(this._state.state===3){const k=this._incomingData.read(this._state.readLen);c(k,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate&&this._state.compressed?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(k.buffer)),this._zlibInflate.write(k.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const L=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=L.length,this._onData.fire(C.VSBuffer.wrap(L))})):(this._totalIncomingDataBytes+=k.byteLength,this._onData.fire(k))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await I.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=P;function c(h,g){if(g===0)return;let k=h.byteLength>>>2;for(let ne=0;ne<k;ne++){const oe=h.readUInt32BE(ne*4);h.writeUInt32BE(oe^g,ne*4)}let L=k*4,R=h.byteLength-L;const W=g>>>24&255,j=g>>>16&255,x=g>>>8&255;R>=1&&h.writeUInt8(h.readUInt8(L)^W,L),R>=2&&h.writeUInt8(h.readUInt8(L+1)^j,L+1),R>=3&&h.writeUInt8(h.readUInt8(L+2)^x,L+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const a={[2]:107,[1]:103};function l(){const h=(0,E.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${h}-sock`;let g;return e.XDG_RUNTIME_DIR?g=(0,f.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${h}.sock`):g=(0,f.join)((0,M.tmpdir)(),`vscode-ipc-${h}.sock`),u(g),g}e.createRandomIPCHandle=l;function s(h,g,k){const L=(0,v.createHash)("md5").update(h).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${L}-${k}-${g}-sock`;let R;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?R=(0,f.join)(e.XDG_RUNTIME_DIR,`vscode-${L.substr(0,8)}-${k}-${g}.sock`):R=(0,f.join)(h,`${k}-${g}.sock`),u(R),R}e.createStaticIPCHandle=s;function u(h){const g=a[y.platform];typeof g=="number"&&h.length>=g&&console.warn(`WARNING: IPC handle "${h}" is longer than ${g} chars, try a shorter --user-data-dir`)}class r extends m.IPCServer{constructor(g){super(r.toClientConnectionEvent(g));this.server=g}static toClientConnectionEvent(g){const k=I.Event.fromNodeEventEmitter(g,"connection");return I.Event.map(k,L=>({protocol:new p.Protocol(new w(L)),onDidClientDisconnect:I.Event.once(I.Event.fromNodeEventEmitter(L,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=r;function i(h){return new Promise((g,k)=>{const L=(0,D.createServer)();L.on("error",k),L.listen(h,()=>{L.removeListener("error",k),g(new r(L))})})}e.serve=i;function o(h,g){return new Promise((k,L)=>{const R=(0,D.createConnection)(h,()=>{R.removeListener("error",L),k(p.Client.fromSocket(new w(R),g))});R.once("error",L)})}e.connect=o}),define(Q[224],J([0,1,58]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.WindowDriverRegistryChannel=e.DriverChannelClient=e.DriverChannel=void 0;class D{constructor(d){this.driver=d}listen(d,f){throw new Error("No event found")}call(d,f,y){switch(f){case"getWindowIds":return this.driver.getWindowIds();case"capturePage":return this.driver.capturePage(y);case"reloadWindow":return this.driver.reloadWindow(y);case"exitApplication":return this.driver.exitApplication();case"dispatchKeybinding":return this.driver.dispatchKeybinding(y[0],y[1]);case"click":return this.driver.click(y[0],y[1],y[2],y[3]);case"doubleClick":return this.driver.doubleClick(y[0],y[1]);case"setValue":return this.driver.setValue(y[0],y[1],y[2]);case"getTitle":return this.driver.getTitle(y[0]);case"isActiveElement":return this.driver.isActiveElement(y[0],y[1]);case"getElements":return this.driver.getElements(y[0],y[1],y[2]);case"getElementXY":return this.driver.getElementXY(y[0],y[1],y[2]);case"typeInEditor":return this.driver.typeInEditor(y[0],y[1],y[2]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(y[0],y[1]);case"writeInTerminal":return this.driver.writeInTerminal(y[0],y[1],y[2]);case"getLocaleInfo":return this.driver.getLocaleInfo(y);case"getLocalizedStrings":return this.driver.getLocalizedStrings(y)}throw new Error(`Call not found: ${f}`)}}e.DriverChannel=D;class M{constructor(d){this.channel=d}getWindowIds(){return this.channel.call("getWindowIds")}capturePage(d){return this.channel.call("capturePage",d)}reloadWindow(d){return this.channel.call("reloadWindow",d)}exitApplication(){return this.channel.call("exitApplication")}dispatchKeybinding(d,f){return this.channel.call("dispatchKeybinding",[d,f])}click(d,f,y,E){return this.channel.call("click",[d,f,y,E])}doubleClick(d,f){return this.channel.call("doubleClick",[d,f])}setValue(d,f,y){return this.channel.call("setValue",[d,f,y])}getTitle(d){return this.channel.call("getTitle",[d])}isActiveElement(d,f){return this.channel.call("isActiveElement",[d,f])}getElements(d,f,y){return this.channel.call("getElements",[d,f,y])}getElementXY(d,f,y,E){return this.channel.call("getElementXY",[d,f,y,E])}typeInEditor(d,f,y){return this.channel.call("typeInEditor",[d,f,y])}getTerminalBuffer(d,f){return this.channel.call("getTerminalBuffer",[d,f])}writeInTerminal(d,f,y){return this.channel.call("writeInTerminal",[d,f,y])}getLocaleInfo(d){return this.channel.call("getLocaleInfo",d)}getLocalizedStrings(d){return this.channel.call("getLocalizedStrings",d)}}e.DriverChannelClient=M;class C{constructor(d){this.registry=d}listen(d,f){throw new Error(`Event not found: ${f}`)}call(d,f,y){switch(f){case"registerWindowDriver":return this.registry.registerWindowDriver(y);case"reloadWindowDriver":return this.registry.reloadWindowDriver(y)}throw new Error(`Call not found: ${f}`)}}e.WindowDriverRegistryChannel=C;async function n(I){const d=await(0,v.connect)(I,"driverClient"),f=d.getChannel("driver"),y=new M(f);return{client:d,driver:y}}e.connect=n}),define(Q[225],J([0,1,9,4,106,59,2,3,35,58,160,224,178,20,36]),function(H,e,v,D,M,C,n,I,d,f,y,E,m,p,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serve=e.Driver=void 0;function w(P){return P<21}let b=class{constructor(c,a,l,s){this.windowServer=c,this.options=a,this.windowsMainService=l,this.lifecycleMainService=s,this.registeredWindowIds=new Set,this.reloadingWindowIds=new Set,this.onDidReloadingChange=new D.Emitter}async registerWindowDriver(c){return this.registeredWindowIds.add(c),this.reloadingWindowIds.delete(c),this.onDidReloadingChange.fire(),this.options}async reloadWindowDriver(c){this.reloadingWindowIds.add(c)}async getWindowIds(){return this.windowsMainService.getWindows().map(c=>c.id).filter(c=>this.registeredWindowIds.has(c)&&!this.reloadingWindowIds.has(c))}async capturePage(c){await this.whenUnfrozen(c);const a=this.windowsMainService.getWindowById(c);if(!a?.win)throw new Error("Invalid window");return(await a.win.webContents.capturePage()).toPNG().toString("base64")}async reloadWindow(c){await this.whenUnfrozen(c);const a=this.windowsMainService.getWindowById(c);if(!a)throw new Error("Invalid window");this.reloadingWindowIds.add(c),this.lifecycleMainService.reload(a)}exitApplication(){return this.lifecycleMainService.quit()}async dispatchKeybinding(c,a){await this.whenUnfrozen(c);const l=M.KeybindingParser.parseUserBinding(a);for(let s of l)await this._dispatchKeybinding(c,s)}async _dispatchKeybinding(c,a){if(a instanceof C.ScanCodeBinding)throw new Error("ScanCodeBindings not supported");const l=this.windowsMainService.getWindowById(c);if(!l?.win)throw new Error("Invalid window");const s=l.win.webContents,u=new C.SimpleKeybinding(!1,!1,!1,!1,a.keyCode),i=new m.USLayoutResolvedKeybinding(u.toChord(),I.OS).getElectronAccelerator(),o=[];a.ctrlKey&&o.push("ctrl"),a.metaKey&&o.push("meta"),a.shiftKey&&o.push("shift"),a.altKey&&o.push("alt"),s.sendInputEvent({type:"keyDown",keyCode:i,modifiers:o}),w(a.keyCode)||s.sendInputEvent({type:"char",keyCode:i,modifiers:o}),s.sendInputEvent({type:"keyUp",keyCode:i,modifiers:o}),await(0,v.timeout)(100)}async click(c,a,l,s){await(await this.getWindowDriver(c)).click(a,l,s)}async doubleClick(c,a){await(await this.getWindowDriver(c)).doubleClick(a)}async setValue(c,a,l){await(await this.getWindowDriver(c)).setValue(a,l)}async getTitle(c){return await(await this.getWindowDriver(c)).getTitle()}async isActiveElement(c,a){return await(await this.getWindowDriver(c)).isActiveElement(a)}async getElements(c,a,l){return await(await this.getWindowDriver(c)).getElements(a,l)}async getElementXY(c,a,l,s){return await(await this.getWindowDriver(c)).getElementXY(a,l,s)}async typeInEditor(c,a,l){await(await this.getWindowDriver(c)).typeInEditor(a,l)}async getTerminalBuffer(c,a){return await(await this.getWindowDriver(c)).getTerminalBuffer(a)}async writeInTerminal(c,a,l){await(await this.getWindowDriver(c)).writeInTerminal(a,l)}async getLocaleInfo(c){return await(await this.getWindowDriver(c)).getLocaleInfo()}async getLocalizedStrings(c){return await(await this.getWindowDriver(c)).getLocalizedStrings()}async getWindowDriver(c){await this.whenUnfrozen(c);const a=`window:${c}`,l=new d.StaticRouter(u=>u===a),s=this.windowServer.getChannel("windowDriver",l);return new y.WindowDriverChannelClient(s)}async whenUnfrozen(c){for(;this.reloadingWindowIds.has(c);)await D.Event.toPromise(this.onDidReloadingChange.event)}};b=he([ee(2,t.IWindowsMainService),ee(3,p.ILifecycleMainService)],b),e.Driver=b;async function S(P,c,a,l){const s=a.driverVerbose,u=l.createInstance(b,P,{verbose:s}),r=new E.WindowDriverRegistryChannel(u);P.registerChannel("windowDriverRegistry",r);const i=await(0,f.serve)(c),o=new E.DriverChannel(u);return i.registerChannel("driver",o),(0,n.combinedDisposable)(i,P)}e.serve=S}),define(Q[24],J([0,1,46,8,58,48,164,5]),function(H,e,v,D,M,C,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,I.refineServiceDecorator)(C.IEnvironmentService);class d extends n.NativeEnvironmentService{get cachedLanguagesPath(){return(0,D.join)(this.userDataPath,"clp")}get backupHome(){return(0,D.join)(this.userDataPath,"Backups")}get backupWorkspacesPath(){return(0,D.join)(this.backupHome,"workspaces.json")}get mainIPCHandle(){return(0,M.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,D.join)(this.userDataPath,"code.lock")}get sandbox(){return!!this.args.__sandbox}get driverVerbose(){return!!this.args["driver-verbose"]}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}he([v.memoize],d.prototype,"cachedLanguagesPath",null),he([v.memoize],d.prototype,"backupHome",null),he([v.memoize],d.prototype,"backupWorkspacesPath",null),he([v.memoize],d.prototype,"mainIPCHandle",null),he([v.memoize],d.prototype,"mainLockfile",null),he([v.memoize],d.prototype,"sandbox",null),he([v.memoize],d.prototype,"driverVerbose",null),he([v.memoize],d.prototype,"disableUpdates",null),he([v.memoize],d.prototype,"disableKeytar",null),he([v.memoize],d.prototype,"codeCachePath",null),he([v.memoize],d.prototype,"useCodeCache",null),e.EnvironmentMainService=d}),define(Q[226],J([0,1,61,28,33,10,8,3,15,7,21,51,19,24,18,6,27]),function(H,e,v,D,M,C,n,I,d,f,y,E,m,p,t,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let S=class{constructor(c,a,l){this.configurationService=a,this.logService=l,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=d.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(s,u)=>(0,M.isEqual)(s,u,!I.isLinux)},this.backupHome=c.backupHome,this.workspacesJsonPath=c.backupWorkspacesPath}async initialize(){let c;try{c=JSON.parse(await y.Promises.readFile(this.workspacesJsonPath,"utf8"))}catch(s){c=Object.create(null)}this.emptyWindows=await this.validateEmptyWorkspaces(c.emptyWorkspaceInfos);let a=[];try{Array.isArray(c.rootURIWorkspaces)&&(a=c.rootURIWorkspaces.map(s=>({workspace:{id:s.id,configPath:f.URI.parse(s.configURIPath)},remoteAuthority:s.remoteAuthority})))}catch(s){}this.workspaces=await this.validateWorkspaces(a);let l=[];try{Array.isArray(c.folderURIWorkspaces)&&(l=c.folderURIWorkspaces.map(s=>f.URI.parse(s)))}catch(s){}this.folders=await this.validateFolders(l),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==t.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===t.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||t.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(c,a){this.workspaces.some(s=>c.workspace.id===s.workspace.id)||(this.workspaces.push(c),this.saveSync());const l=this.getBackupPath(c.workspace.id);return a&&this.moveBackupFolderSync(l,a),l}moveBackupFolderSync(c,a){if(D.existsSync(c)&&this.convertToEmptyWindowBackupSync(c),D.existsSync(a))try{D.renameSync(a,c)}catch(l){this.logService.error(`Backup: Could not move backup folder to new location: ${l.toString()}`)}}unregisterWorkspaceBackupSync(c){const a=c.id,l=this.workspaces.findIndex(s=>s.workspace.id===a);l!==-1&&(this.workspaces.splice(l,1),this.saveSync())}registerFolderBackupSync(c){return this.folders.some(a=>this.backupUriComparer.isEqual(c,a))||(this.folders.push(c),this.saveSync()),this.getBackupPath(this.getFolderHash(c))}unregisterFolderBackupSync(c){const a=this.folders.findIndex(l=>this.backupUriComparer.isEqual(c,l));a!==-1&&(this.folders.splice(a,1),this.saveSync())}registerEmptyWindowBackupSync(c,a){const l=c||this.getRandomEmptyWindowId();return this.emptyWindows.some(s=>!!s.backupFolder&&this.backupPathComparer.isEqual(s.backupFolder,l))||(this.emptyWindows.push({backupFolder:l,remoteAuthority:a}),this.saveSync()),this.getBackupPath(l)}unregisterEmptyWindowBackupSync(c){const a=this.emptyWindows.findIndex(l=>!!l.backupFolder&&this.backupPathComparer.isEqual(l.backupFolder,c));a!==-1&&(this.emptyWindows.splice(a,1),this.saveSync())}getBackupPath(c){return(0,n.join)(this.backupHome,c)}async validateWorkspaces(c){if(!Array.isArray(c))return[];const a=new Set,l=[];for(let s of c){const u=s.workspace;if(!(0,b.isWorkspaceIdentifier)(u))return[];if(!a.has(u.id)){a.add(u.id);const r=this.getBackupPath(u.id);await this.doHasBackups(r)?u.configPath.scheme!==C.Schemas.file||await y.Promises.exists(u.configPath.fsPath)?l.push(s):await this.convertToEmptyWindowBackup(r):await this.deleteStaleBackup(r)}}return l}async validateFolders(c){if(!Array.isArray(c))return[];const a=[],l=new Set;for(let s of c){const u=this.backupUriComparer.getComparisonKey(s);if(!l.has(u)){l.add(u);const r=this.getBackupPath(this.getFolderHash(s));await this.doHasBackups(r)?s.scheme!==C.Schemas.file||await y.Promises.exists(s.fsPath)?a.push(s):await this.convertToEmptyWindowBackup(r):await this.deleteStaleBackup(r)}}return a}async validateEmptyWorkspaces(c){if(!Array.isArray(c))return[];const a=[],l=new Set;for(let s of c){const u=s.backupFolder;if(typeof u!="string")return[];if(!l.has(u)){l.add(u);const r=this.getBackupPath(u);await this.doHasBackups(r)?a.push(s):await this.deleteStaleBackup(r)}}return a}async deleteStaleBackup(c){try{await y.Promises.exists(c)&&await y.Promises.rm(c,y.RimRafMode.MOVE)}catch(a){this.logService.error(`Backup: Could not delete stale backup: ${a.toString()}`)}}async convertToEmptyWindowBackup(c){let a=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(s=>!!s.backupFolder&&this.backupPathComparer.isEqual(s.backupFolder,a));)a=this.getRandomEmptyWindowId();const l=this.getBackupPath(a);try{await y.Promises.rename(c,l)}catch(s){return this.logService.error(`Backup: Could not rename backup folder: ${s.toString()}`),!1}return this.emptyWindows.push({backupFolder:a}),!0}convertToEmptyWindowBackupSync(c){let a=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(s=>!!s.backupFolder&&this.backupPathComparer.isEqual(s.backupFolder,a));)a=this.getRandomEmptyWindowId();const l=this.getBackupPath(a);try{D.renameSync(c,l)}catch(s){return this.logService.error(`Backup: Could not rename backup folder: ${s.toString()}`),!1}return this.emptyWindows.push({backupFolder:a}),!0}async getDirtyWorkspaces(){const c=[];for(const a of this.workspaces)await this.hasBackups(a)&&c.push(a.workspace);for(const a of this.folders)await this.hasBackups(a)&&c.push(a);return c}hasBackups(c){let a;return f.URI.isUri(c)?a=this.getBackupPath(this.getFolderHash(c)):(0,E.isWorkspaceBackupInfo)(c)?a=this.getBackupPath(c.workspace.id):a=c.backupFolder,this.doHasBackups(a)}async doHasBackups(c){try{const a=await y.Promises.readdir(c);for(const l of a)try{if((await y.Promises.readdir((0,n.join)(c,l))).length>0)return!0}catch(s){}}catch(a){}return!1}saveSync(){try{(0,y.writeFileSync)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(c){this.logService.error(`Backup: Could not save workspaces.json: ${c.toString()}`)}}async save(){try{await y.Promises.writeFile(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(c){this.logService.error(`Backup: Could not save workspaces.json: ${c.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(c=>({id:c.workspace.id,configURIPath:c.workspace.configPath.toString(),remoteAuthority:c.remoteAuthority})),folderURIWorkspaces:this.folders.map(c=>c.toString()),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(c){let a;return c.scheme===C.Schemas.file?a=I.isLinux?c.fsPath:c.fsPath.toLowerCase():a=c.toString().toLowerCase(),(0,v.createHash)("md5").update(a).digest("hex")}};S=he([ee(0,p.IEnvironmentMainService),ee(1,m.IConfigurationService),ee(2,w.ILogService)],S),e.BackupMainService=S}),define(Q[227],J([0,1,62,58]),function(H,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(M,C,n,I){const d=y=>I(y,void 0),f=v.createConnection({host:M,port:C},()=>{f.removeListener("error",d);const y=Buffer.alloc(16);for(let t=0;t<16;t++)y[t]=Math.round(Math.random()*256);const E=y.toString("base64");let m=[`GET ws://${/:/.test(M)?`[${M}]`:M}:${C}/?${n}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${E}`];f.write(m.join(`\r
`)+`\r
\r
`);const p=t=>{t.toString().indexOf(`\r
\r
`)>=0&&(f.off("data",p),I(void 0,new D.NodeSocket(f)))};f.on("data",p)});f.once("error",d)}}}),define(Q[228],J([0,1,62,118,227,9,2,19,6,22,194,97,76]),function(H,e,v,D,M,C,n,I,d,f,y,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function p(P,c,a,l,s){let u;for(let r=3;r&&(u&&u.dispose(),u=await new t(P,c,a,l,s).waitForReady(),!(s&&D.BROWSER_RESTRICTED_PORTS[s]||!D.BROWSER_RESTRICTED_PORTS[u.tunnelLocalPort]));r--);return u}class t extends n.Disposable{constructor(c,a,l,s,u){super();this.defaultTunnelHost=a,this.suggestedLocalPort=u,this.privacy=E.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=c,this._server=v.createServer(),this._barrier=new C.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=r=>this._onConnection(r),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=s,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(a=>{a()})}async waitForReady(){let c=await(0,D.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),a=null;return this._server.listen(c,this.defaultTunnelHost),await this._barrier.wait(),a=this._server.address(),a||(c=0,this._server.listen(c,this.defaultTunnelHost),await this._barrier.wait(),a=this._server.address()),this.tunnelLocalPort=a.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${a.port}`,this}async _onConnection(c){c.pause();const a=(0,E.isLocalhost)(this.tunnelRemoteHost)||(0,E.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,l=await(0,y.connectRemoteAgentTunnel)(this._options,a,this.tunnelRemotePort),s=l.getSocket().socket,u=l.readEntireBuffer();l.dispose(),u.byteLength>0&&c.write(u.buffer),c.on("end",()=>{this._socketsDispose.delete(c.localAddress),s.end()}),c.on("close",()=>s.end()),c.on("error",()=>{this._socketsDispose.delete(c.localAddress),s.destroy()}),s.on("end",()=>c.end()),s.on("close",()=>c.end()),s.on("error",()=>{c.destroy()}),c.pipe(s),s.pipe(c),this._socketsDispose.set(c.localAddress,()=>{c.end(),s.end()})}}let w=class extends E.AbstractTunnelService{constructor(c,a,l,s,u){super(a);this.socketFactory=c,this.signService=l,this.productService=s,this.configurationService=u}get defaultTunnelHost(){const c=this.configurationService.getValue("remote.localPortHost");return!c||c==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(c,a,l,s,u,r,i){const o=this.getTunnelFromMap(a,l);if(o)return++o.refcount,o.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,a,l,s,u,r,i);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${a}:${l} on local port ${s}.`);const h={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:c,signService:this.signService,logService:this.logService,ipcLogger:null},g=p(h,this.defaultTunnelHost,a,l,s);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(a,l,g),g}}};w=he([ee(1,d.ILogService),ee(2,m.ISignService),ee(3,f.IProductService),ee(4,I.IConfigurationService)],w),e.BaseTunnelService=w;let b=class extends w{constructor(c,a,l,s){super(M.nodeSocketFactory,c,a,l,s)}};b=he([ee(0,d.ILogService),ee(1,m.ISignService),ee(2,f.IProductService),ee(3,I.IConfigurationService)],b),e.TunnelService=b;let S=class extends n.Disposable{constructor(c,a,l,s){super();this.logService=c,this.productService=a,this.signService=l,this.configurationService=s,this._tunnelServices=new Map}async openTunnel(c,a,l,s,u,r,i,o){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${l}:${s} on local port ${u}.`),!this._tunnelServices.has(c)){const h=new b(this.logService,this.signService,this.productService,this.configurationService);this._register(h),this._tunnelServices.set(c,h),h.onTunnelClosed(async()=>{(await h.tunnels).length===0&&(h.dispose(),this._tunnelServices.delete(c))})}return this._tunnelServices.get(c).openTunnel(a,l,s,u,r,i,o)}};S=he([ee(0,d.ILogService),ee(1,f.IProductService),ee(2,m.ISignService),ee(3,I.IConfigurationService)],S),e.SharedTunnelsService=S}),define(Q[229],J([0,1,198,9,17,16,2,13,19,48,91,6,197,223]),function(H,e,v,D,M,C,n,I,d,f,y,E,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let t=class extends n.Disposable{constructor(b,S,P){super();this.environmentService=S,this.logService=P,this.configure(b.getValue()),this._register(b.onDidChangeConfiguration(()=>this.configure(b.getValue()),this))}configure(b){this.proxyUrl=b.http&&b.http.proxy,this.strictSSL=!!(b.http&&b.http.proxyStrictSSL),this.authorization=b.http&&b.http.proxyAuthorization}async request(b,S){this.logService.trace("RequestService#request",b.url);const{proxyUrl:P,strictSSL:c}=this;let a;try{a=await(0,y.resolveShellEnv)(this.logService,this.environmentService.args,process.env)}catch(u){this.logService.error("RequestService#request resolving shell environment failed",u)}const l={...process.env,...a},s=b.agent?b.agent:await(0,m.getProxyAgent)(b.url||"",l,{proxyUrl:P,strictSSL:c});return b.agent=s,b.strictSSL=c,this.authorization&&(b.headers={...b.headers||{},"Proxy-Authorization":this.authorization}),this._request(b,S)}async getNodeRequest(b){return((0,v.parse)(b.url).protocol==="https:"?await new Promise((c,a)=>{H(["https"],c,a)}):await new Promise((c,a)=>{H(["http"],c,a)})).request}_request(b,S){return D.Promises.withAsyncBody(async(P,c)=>{let a;const l=(0,v.parse)(b.url),s=b.getRawRequest?b.getRawRequest(b):await this.getNodeRequest(b),u={hostname:l.hostname,port:l.port?parseInt(l.port):l.protocol==="https:"?443:80,protocol:l.protocol,path:l.path,method:b.type||"GET",headers:b.headers,agent:b.agent,rejectUnauthorized:(0,I.isBoolean)(b.strictSSL)?b.strictSSL:!0};b.user&&b.password&&(u.auth=b.user+":"+b.password),a=s(u,r=>{const i=(0,I.isNumber)(b.followRedirects)?b.followRedirects:3;if(r.statusCode&&r.statusCode>=300&&r.statusCode<400&&i>0&&r.headers.location)this._request({...b,url:r.headers.location,followRedirects:i-1},S).then(P,c);else{let o=r;r.headers["content-encoding"]==="gzip"&&(o=r.pipe((0,p.createGunzip)())),P({res:r,stream:(0,M.streamToBufferReadableStream)(o)})}}),a.on("error",c),b.timeout&&a.setTimeout(b.timeout),b.data&&typeof b.data=="string"&&a.write(b.data),a.end(),S.onCancellationRequested(()=>{a.abort(),c((0,C.canceled)())})})}async resolveProxy(b){}};t=he([ee(0,d.IConfigurationService),ee(1,f.INativeEnvironmentService),ee(2,E.ILogService)],t),e.RequestService=t}),define(Q[230],J([0,1,14,229]),function(H,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function M(n){return v.net.request}class C extends D.RequestService{request(I,d){return super.request({...I||{},getRawRequest:M},d)}}e.RequestMainService=C}),define(Q[231],J([0,1,14,9,4,2,10,13,85,24,20,6,56,57,66,44]),function(H,e,v,D,M,C,n,I,d,f,y,E,m,p,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let b=class extends C.Disposable{constructor(P,c,a,l,s,u,r){super();this.machineId=P,this.userEnv=c,this.environmentMainService=a,this.lifecycleMainService=l,this.logService=s,this.themeMainService=u,this.protocolMainService=r,this.firstWindowConnectionBarrier=new D.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new M.Emitter),this.onDidError=M.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){v.ipcMain.on("vscode:createSharedProcessMessageChannel",(P,c)=>this.onWindowConnection(P,c)),v.ipcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(P,c)=>this.onWorkerConnection(P,c)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(P,c){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const a=await this.connect();if(P.sender.isDestroyed())return a.close();P.sender.postMessage("vscode:createSharedProcessMessageChannelResult",c,[a])}onWorkerConnection(P,c){this.logService.trace("SharedProcess: onWorkerConnection",c);const a=new C.DisposableStore,l=u=>{!this.isAlive()||(this.logService.trace(`SharedProcess: disposing worker (reason: '${u}')`,c),a.dispose(),this.send("vscode:electron-main->shared-process=disposeWorker",c))},s=v.BrowserWindow.fromId(c.reply.windowId);if(!s||s.isDestroyed()||s.webContents.isDestroyed()||!c.reply.channel){l("unavailable");return}a.add(M.Event.filter(this.lifecycleMainService.onWillLoadWindow,u=>u.window.win===s)(()=>l("load"))),a.add(M.Event.fromNodeEventEmitter(s,"closed")(()=>l("closed"))),s.webContents.postMessage(c.reply.channel,c.reply.nonce,P.ports)}onWillShutdown(){const P=this.window;!P||(this.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(P.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{P.close()}catch(c){}this.window=void 0},0))}send(P,...c){if(!this.isAlive()){this.logService.warn(`Sending IPC message to channel '${P}' for shared process window that is destroyed`);return}try{this.window?.webContents.send(P,...c)}catch(a){this.logService.warn(`Error sending IPC message to channel '${P}' of shared process: ${(0,w.toErrorMessage)(a)}`)}}whenReady(){return this._whenReady||(this._whenReady=new Promise(P=>v.ipcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),P()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(P=>v.ipcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),P()}))})()),this._whenIpcReady}createWindow(){const P=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new v.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:n.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",H).fsPath,additionalArguments:[`--vscode-window-config=${P.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,images:!1,webgl:!1,disableBlinkFeatures:"Auxclick"}}),P.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:m.default}),this.window.loadURL(n.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",H).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=P=>{this.logService.trace("SharedProcess#close prevented"),P.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(P,c)=>this._onDidError.fire({type:2,details:c})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(P,c,a)=>this._onDidError.fire({type:3,details:{reason:a,exitCode:c}})))}async connect(){await this.whenIpcReady;const P=(0,I.assertIsDefined)(this.window);return(0,d.connect)(P)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}isAlive(){const P=this.window;return P?!P.isDestroyed()&&!P.webContents.isDestroyed():!1}};b=he([ee(2,f.IEnvironmentMainService),ee(3,y.ILifecycleMainService),ee(4,E.ILogService),ee(5,t.IThemeMainService),ee(6,p.IProtocolMainService)],b),e.SharedProcess=b}),define(Q[232],J([0,1,9,17,8,13,7,24,18,6]),function(H,e,v,D,M,C,n,I,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=e.FileStorage=void 0;class y{constructor(p,t,w){this.storagePath=p,this.logService=t,this.fileService=w,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new v.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(p){p.fileOperationResult!==1&&this.logService.error(p)}}getItem(p,t){const w=this.storage[p];return(0,C.isUndefinedOrNull)(w)?t:w}setItem(p,t){this.setItems([{key:p,data:t}])}setItems(p){let t=!1;for(const{key:w,data:b}of p)this.storage[w]!==b&&((0,C.isUndefinedOrNull)(b)?(0,C.isUndefined)(this.storage[w])||(this.storage[w]=void 0,t=!0):(this.storage[w]=b,t=!0));t&&this.save()}removeItem(p){(0,C.isUndefined)(this.storage[p])||(this.storage[p]=void 0,this.save())}async save(p){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),p)}async doSave(){if(!this.initializing)return;await this.initializing;const p=JSON.stringify(this.storage,null,4);if(p!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,D.VSBuffer.fromString(p)),this.lastSavedStorageContents=p}catch(t){this.logService.error(t)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=y;let E=class Et{constructor(p,t,w){this.fileStorage=new y(n.URI.file((0,M.join)(p.userDataPath,Et.STATE_FILE)),t,w)}async init(){return this.fileStorage.init()}getItem(p,t){return this.fileStorage.getItem(p,t)}setItem(p,t){this.fileStorage.setItem(p,t)}setItems(p){this.fileStorage.setItems(p)}removeItem(p){this.fileStorage.removeItem(p)}close(){return this.fileStorage.close()}};E.STATE_FILE="storage.json",E=he([ee(0,I.IEnvironmentMainService),ee(1,f.ILogService),ee(2,d.IFileService)],E),e.StateMainService=E}),define(Q[77],J([0,1,9,23,4,19,24,20,6,22,50,41]),function(H,e,v,D,M,C,n,I,d,f,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function m(t,w,b){return`${b.updateUrl}/api/update/${t}/${w}/${b.commit}`}e.createUpdateURL=m;let p=class{constructor(w,b,S,P,c,a){this.lifecycleMainService=w,this.configurationService=b,this.environmentMainService=S,this.requestService=P,this.logService=c,this.productService=a,this._state=E.State.Uninitialized,this._onStateChange=new M.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(w){this.logService.info("update#setState",w.type),this._state=w,this._onStateChange.fire(w)}initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const w=this.getUpdateMode(),b=this.getProductQuality(w);if(!b){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(b),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(E.State.Idle(this.getUpdateType())),w==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}w==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,S=>this.logService.error(S))}getUpdateMode(){return(0,C.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel")}getProductQuality(w){return w==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(w=60*60*1e3){return(0,v.timeout)(w).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(w){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(w)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(w){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(w=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${w}`),!w&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){if(this.url){if(this.getUpdateMode()==="none")return!1}else return;return(await this.requestService.request({url:this.url},D.CancellationToken.None)).res.statusCode===204}getUpdateType(){return 1}doQuitAndInstall(){}};p=he([ee(0,I.ILifecycleMainService),ee(1,C.IConfigurationService),ee(2,n.IEnvironmentMainService),ee(3,y.IRequestService),ee(4,d.ILogService),ee(5,f.IProductService)],p),e.AbstractUpdateService=p}),define(Q[233],J([0,1,14,46,4,2,19,24,20,6,22,50,29,41,77]),function(H,e,v,D,M,C,n,I,d,f,y,E,m,p,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let w=class extends t.AbstractUpdateService{constructor(S,P,c,a,l,s,u){super(S,P,a,l,s,u);this.telemetryService=c,this.disposables=new C.DisposableStore}get onRawError(){return M.Event.fromNodeEventEmitter(v.autoUpdater,"error",(S,P)=>P)}get onRawUpdateNotAvailable(){return M.Event.fromNodeEventEmitter(v.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return M.Event.fromNodeEventEmitter(v.autoUpdater,"update-available",(S,P,c)=>({url:P,version:c,productVersion:c}))}get onRawUpdateDownloaded(){return M.Event.fromNodeEventEmitter(v.autoUpdater,"update-downloaded",(S,P,c,a)=>({releaseNotes:P,version:c,productVersion:c,date:a}))}initialize(){super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(S){this.logService.error("UpdateService error:",S);const c=(this.state.type==="checking for updates"?this.state.explicit:!0)?S:void 0;this.setState(p.State.Idle(1,c))}buildUpdateFeedUrl(S){let P;this.productService.darwinUniversalAssetId?P=this.productService.darwinUniversalAssetId:P=process.arch==="x64"?"darwin":"darwin-arm64";const c=(0,t.createUpdateURL)(P,S,this.productService);try{v.autoUpdater.setFeedURL({url:c})}catch(a){this.logService.error("Failed to set update feed URL",a);return}return c}doCheckForUpdates(S){this.setState(p.State.CheckingForUpdates(S)),v.autoUpdater.checkForUpdates()}onUpdateAvailable(S){this.state.type==="checking for updates"&&this.setState(p.State.Downloading(S))}onUpdateDownloaded(S){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:S.version}),this.setState(p.State.Ready(S)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(p.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),v.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};he([D.memoize],w.prototype,"onRawError",null),he([D.memoize],w.prototype,"onRawUpdateNotAvailable",null),he([D.memoize],w.prototype,"onRawUpdateAvailable",null),he([D.memoize],w.prototype,"onRawUpdateDownloaded",null),w=he([ee(0,d.ILifecycleMainService),ee(1,n.IConfigurationService),ee(2,m.ITelemetryService),ee(3,I.IEnvironmentMainService),ee(4,E.IRequestService),ee(5,f.ILogService),ee(6,y.IProductService)],w),e.DarwinUpdateService=w}),define(Q[234],J([0,1,43,28,9,4,8,24,20,6,29,41]),function(H,e,v,D,M,C,n,I,d,f,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let m=class{constructor(w,b,S){if(this.lifecycleMainService=w,this.logService=S,this._state=E.State.Uninitialized,this._onStateChange=new C.Emitter,this.onStateChange=this._onStateChange.event,b.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(E.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,P=>this.logService.error(P))}get state(){return this._state}setState(w){this.logService.info("update#setState",w.type),this._state=w,this._onStateChange.fire(w)}scheduleCheckForUpdates(w=60*60*1e3){return(0,M.timeout)(w).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(w){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(w)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(w){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(w=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${w}`),!w&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}};m=he([ee(0,d.ILifecycleMainService),ee(1,I.IEnvironmentMainService),ee(2,f.ILogService)],m);let p=class extends m{constructor(w,b,S,P,c,a){super(S,P,c);this.snap=w,this.snapRevision=b,this.telemetryService=a;const l=(0,D.watch)(n.dirname(this.snap)),s=C.Event.fromNodeEventEmitter(l,"change",(o,h)=>h),u=C.Event.filter(s,o=>o==="current"),i=C.Event.debounce(u,(o,h)=>h,2e3)(()=>this.checkForUpdates(!1));S.onWillShutdown(()=>{i.dispose(),l.close()})}doCheckForUpdates(){this.setState(E.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(w=>{w?this.setState(E.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(E.State.Idle(2)))},w=>{this.logService.error(w),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(E.State.Idle(2,w.message||w))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,v.spawn)("sleep 3 && "+n.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const w=await new Promise((S,P)=>(0,D.realpath)(`${n.dirname(this.snap)}/current`,(c,a)=>c?P(c):S(a))),b=n.basename(w);return this.snapRevision!==b}isLatestVersion(){return this.isUpdateAvailable().then(void 0,w=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};p=he([ee(2,d.ILifecycleMainService),ee(3,I.IEnvironmentMainService),ee(4,f.ILogService),ee(5,y.ITelemetryService)],p),e.SnapUpdateService=p}),define(Q[45],J([0,1,14,28,4,39,34,2,10,8,3,15,13,21,158,51,52,24,5,6,22,101,27,102]),function(H,e,v,D,M,C,n,I,d,f,y,E,m,p,t,w,b,S,P,c,a,l,s,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,P.createDecorator)("workspacesManagementMainService");let r=class extends I.Disposable{constructor(o,h,g,k,L){super();this.environmentMainService=o,this.logService=h,this.backupMainService=g,this.dialogMainService=k,this.productService=L,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new M.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new M.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(o){return this.doResolveLocalWorkspace(o,h=>(0,D.readFileSync)(h,"utf8"))}resolveLocalWorkspace(o){return this.doResolveLocalWorkspace(o,h=>p.Promises.readFile(h,"utf8"))}doResolveLocalWorkspace(o,h){if(!!this.isWorkspacePath(o)&&o.scheme===d.Schemas.file)try{const g=h(o.fsPath);return g instanceof Promise?g.then(k=>this.doResolveWorkspace(o,k),k=>{}):this.doResolveWorkspace(o,g)}catch{return}}isWorkspacePath(o){return(0,s.isUntitledWorkspace)(o,this.environmentMainService)||(0,s.hasWorkspaceFileExtension)(o)}doResolveWorkspace(o,h){try{const g=this.doParseStoredWorkspace(o,h),k=(0,u.getWorkspaceIdentifier)(o);return{id:k.id,configPath:k.configPath,folders:(0,s.toWorkspaceFolders)(g.folders,k.configPath,E.extUriBiasedIgnorePathCase),remoteAuthority:g.remoteAuthority,transient:g.transient}}catch(g){this.logService.warn(g.toString())}}doParseStoredWorkspace(o,h){const g=(0,C.parse)(h);if(g&&Array.isArray(g.folders))g.folders=g.folders.filter(k=>(0,s.isStoredWorkspaceFolder)(k));else throw new Error(`${o.toString(!0)} looks like an invalid workspace file.`);return g}async createUntitledWorkspace(o,h){const{workspace:g,storedWorkspace:k}=this.newUntitledWorkspace(o,h),L=g.configPath.fsPath;return await p.Promises.mkdir((0,f.dirname)(L),{recursive:!0}),await p.Promises.writeFile(L,JSON.stringify(k,null,"	")),g}createUntitledWorkspaceSync(o,h){const{workspace:g,storedWorkspace:k}=this.newUntitledWorkspace(o,h),L=g.configPath.fsPath;return(0,D.mkdirSync)((0,f.dirname)(L),{recursive:!0}),(0,p.writeFileSync)(L,JSON.stringify(k,null,"	")),g}newUntitledWorkspace(o=[],h){const g=(Date.now()+Math.round(Math.random()*1e3)).toString(),k=(0,E.joinPath)(this.untitledWorkspacesHome,g),L=(0,E.joinPath)(k,s.UNTITLED_WORKSPACE_NAME),R=[];for(const W of o)R.push((0,s.getStoredWorkspaceFolder)(W.uri,!0,W.name,k,!y.isWindows,E.extUriBiasedIgnorePathCase));return{workspace:(0,u.getWorkspaceIdentifier)(L),storedWorkspace:{folders:R,remoteAuthority:h}}}async getWorkspaceIdentifier(o){return(0,u.getWorkspaceIdentifier)(o)}isUntitledWorkspace(o){return(0,s.isUntitledWorkspace)(o.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(o){!this.isUntitledWorkspace(o)||(this.doDeleteUntitledWorkspaceSync(o),this._onDidDeleteUntitledWorkspace.fire(o))}async deleteUntitledWorkspace(o){this.deleteUntitledWorkspaceSync(o)}doDeleteUntitledWorkspaceSync(o){const h=(0,E.originalFSPath)(o.configPath);try{(0,p.rimrafSync)((0,f.dirname)(h));const g=(0,f.join)(this.environmentMainService.workspaceStorageHome.fsPath,o.id);(0,D.existsSync)(g)&&(0,p.writeFileSync)((0,f.join)(g,"obsolete"),"")}catch(g){this.logService.warn(`Unable to delete untitled workspace ${h} (${g}).`)}}getUntitledWorkspacesSync(){const o=[];try{const h=(0,p.readdirSync)(this.untitledWorkspacesHome.fsPath).map(g=>(0,E.joinPath)(this.untitledWorkspacesHome,g,s.UNTITLED_WORKSPACE_NAME));for(const g of h){const k=(0,u.getWorkspaceIdentifier)(g),L=this.resolveLocalWorkspaceSync(g);L?o.push({workspace:k,remoteAuthority:L.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(k)}}catch(h){h.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${h}).`)}return o}async enterWorkspace(o,h,g){if(!o||!o.win||!o.isReady||!await this.isValidTargetWorkspacePath(o,h,g))return;const L=this.doEnterWorkspace(o,(0,u.getWorkspaceIdentifier)(g));if(!!L)return this._onDidEnterWorkspace.fire({window:o,workspace:L.workspace}),L}async isValidTargetWorkspacePath(o,h,g){if(!g)return!0;if((0,s.isWorkspaceIdentifier)(o.openedWorkspace)&&E.extUriBiasedIgnorePathCase.isEqual(o.openedWorkspace.configPath,g))return!1;if((0,l.findWindowOnWorkspaceOrFolder)(h,g)){const k={title:this.productService.nameLong,type:"info",buttons:[(0,n.mnemonicButtonLabel)((0,t.localize)(0,null))],message:(0,t.localize)(1,null,(0,E.basename)(g)),detail:(0,t.localize)(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(k,(0,m.withNullAsUndefined)(v.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(o,h){if(!o.config)return;o.focus();let g;return o.config.extensionDevelopmentPath||(g=this.backupMainService.registerWorkspaceBackupSync({workspace:h,remoteAuthority:o.remoteAuthority},o.config.backupPath)),(0,s.isWorkspaceIdentifier)(o.openedWorkspace)&&this.isUntitledWorkspace(o.openedWorkspace)&&this.deleteUntitledWorkspaceSync(o.openedWorkspace),o.config.workspace=h,o.config.backupPath=g,{workspace:h,backupPath:g}}};r=he([ee(0,S.IEnvironmentMainService),ee(1,c.ILogService),ee(2,w.IBackupMainService),ee(3,b.IDialogMainService),ee(4,a.IProductService)],r),e.WorkspacesManagementMainService=r}),define(Q[103],J([0,1,14,30,23,3,13,7,21,19,54,5,6,99,36,27,45]),function(H,e,v,D,M,C,n,I,d,f,y,E,m,p,t,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,E.createDecorator)(e.ID);let S=class{constructor(c,a,l,s,u){this.logService=c,this.windowsMainService=a,this.urlService=l,this.workspacesManagementMainService=s,this.configurationService=u}async start(c,a){this.logService.trace("Received data from other instance: ",c,a),C.isMacintosh&&v.app.focus({steal:!0});const l=this.parseOpenUrl(c);if(l.length){let s=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(s=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),s.then(()=>{for(const{uri:u,url:r}of l)this.urlService.open(u,{originalUrl:r})})}else return this.startOpenWindow(c,a)}parseOpenUrl(c){return c["open-url"]&&c._urls&&c._urls.length>0?(0,D.coalesce)(c._urls.map(a=>{try{return{uri:I.URI.parse(a),url:a}}catch(l){return null}})):[]}async startOpenWindow(c,a){const l=(0,y.isLaunchedFromCli)(a)?0:4;let s=[];const u=c.wait&&c.waitMarkerFilePath?I.URI.file(c.waitMarkerFilePath):void 0,r=c.remote||void 0,i={context:l,cli:c,userEnv:a,waitMarkerFileURI:u,remoteAuthority:r};if(c.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(c.extensionDevelopmentPath,i);else if(!c._.length&&!c["folder-uri"]&&!c["file-uri"]){let o=!1;if(c["new-window"]||c["unity-launch"])o=!0;else if(c["reuse-window"])o=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":o=!0;break;case"off":o=!1;break;default:o=!C.isMacintosh}if(o)s=this.windowsMainService.open({...i,forceNewWindow:!0,forceEmpty:!0});else{const h=this.windowsMainService.getLastActiveWindow();h?(this.windowsMainService.openExistingWindow(h,i),s=[h]):s=this.windowsMainService.open({...i,forceEmpty:!0})}}else s=this.windowsMainService.open({...i,forceNewWindow:c["new-window"],preferNewWindow:!c["reuse-window"]&&!c.wait,forceReuseWindow:c["reuse-window"],diffMode:c.diff,addMode:c.add,noRecentEntry:!!c["skip-add-to-recently-opened"],gotoLineMode:c.goto});if(u&&s.length===1&&s[0])return Promise.race([s[0].whenClosedOrLoaded,(0,d.whenDeleted)(u.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const c=[];return v.BrowserWindow.getAllWindows().forEach(a=>{const l=this.windowsMainService.getWindowById(a.id);l?c.push(this.codeWindowToInfo(l)):c.push(this.browserWindowToInfo(a))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:c,screenReader:!!v.app.accessibilitySupportEnabled,gpuFeatureStatus:v.app.getGPUFeatureStatus()}}async getRemoteDiagnostics(c){const a=this.windowsMainService.getWindows();return(await Promise.all(a.map(s=>new Promise(u=>{const r=s.remoteAuthority;if(r){const i=`vscode:getDiagnosticInfoResponse${s.id}`,o={includeProcesses:c.includeProcesses,folders:c.includeWorkspaceMetadata?this.getFolderURIs(s):void 0};s.sendWhenReady("vscode:getDiagnosticInfo",M.CancellationToken.None,{replyChannel:i,args:o}),v.ipcMain.once(i,(h,g)=>{g||u({hostName:r,errorMessage:`Unable to resolve connection to '${r}'.`}),u(g)}),setTimeout(()=>{u({hostName:r,errorMessage:`Fetching remote diagnostics for '${r}' timed out.`})},5e3)}else u(void 0)})))).filter(s=>!!s)}getFolderURIs(c){const a=[],l=c.openedWorkspace;if((0,w.isSingleFolderWorkspaceIdentifier)(l))a.push(l.uri);else if((0,w.isWorkspaceIdentifier)(l)){const s=this.workspacesManagementMainService.resolveLocalWorkspaceSync(l.configPath);s&&s.folders.forEach(r=>{a.push(r.uri)})}return a}codeWindowToInfo(c){const a=this.getFolderURIs(c),l=(0,n.assertIsDefined)(c.win);return this.browserWindowToInfo(l,a,c.remoteAuthority)}browserWindowToInfo(c,a=[],l){return{pid:c.webContents.getOSProcessId(),title:c.getTitle(),folderURIs:a,remoteAuthority:l}}};S=he([ee(0,m.ILogService),ee(1,t.IWindowsMainService),ee(2,p.IURLService),ee(3,b.IWorkspacesManagementMainService),ee(4,f.IConfigurationService)],S),e.LaunchMainService=S}),define(Q[53],J([0,1,43,14,26,117,46,4,34,2,10,8,3,7,82,71,21,150,52,24,5,20,6,22,29,66,36,27,45]),function(H,e,v,D,M,C,n,I,d,f,y,E,m,p,t,w,b,S,P,c,a,l,s,u,r,i,o,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,a.createDecorator)("nativeHostMainService");let k=class dt extends f.Disposable{constructor(R,W,j,x,ne,oe,G,T,B,q){super();this.sharedProcess=R,this.windowsMainService=W,this.dialogMainService=j,this.lifecycleMainService=x,this.environmentMainService=ne,this.telemetryService=oe,this.logService=G,this.productService=T,this.themeMainService=B,this.workspacesManagementMainService=q,this.onDidOpenWindow=I.Event.map(this.windowsMainService.onDidOpenWindow,U=>U.id),this.onDidMaximizeWindow=I.Event.filter(I.Event.fromNodeEventEmitter(D.app,"browser-window-maximize",(U,N)=>N.id),U=>!!this.windowsMainService.getWindowById(U)),this.onDidUnmaximizeWindow=I.Event.filter(I.Event.fromNodeEventEmitter(D.app,"browser-window-unmaximize",(U,N)=>N.id),U=>!!this.windowsMainService.getWindowById(U)),this.onDidBlurWindow=I.Event.filter(I.Event.fromNodeEventEmitter(D.app,"browser-window-blur",(U,N)=>N.id),U=>!!this.windowsMainService.getWindowById(U)),this.onDidFocusWindow=I.Event.any(I.Event.map(I.Event.filter(I.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),U=>!!U),U=>U.id),I.Event.filter(I.Event.fromNodeEventEmitter(D.app,"browser-window-focus",(U,N)=>N.id),U=>!!this.windowsMainService.getWindowById(U))),this.onDidResumeOS=I.Event.fromNodeEventEmitter(D.powerMonitor,"resume"),this._onDidChangeColorScheme=this._register(new I.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,this._onDidChangePassword=this._register(new I.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=I.Event.debounce(I.Event.any(I.Event.filter(I.Event.fromNodeEventEmitter(D.screen,"display-metrics-changed",(U,N,_)=>_),U=>!(Array.isArray(U)&&U.length===1&&U[0]==="workArea")),I.Event.fromNodeEventEmitter(D.screen,"display-added"),I.Event.fromNodeEventEmitter(D.screen,"display-removed")),()=>{},100),this.registerListeners()}registerListeners(){D.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire(this.osColorScheme)})}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(W=>({id:W.id,workspace:W.openedWorkspace,title:W.win?.getTitle()??"",filename:W.getRepresentedFilename(),dirty:W.isDocumentEdited()}))}async getWindowCount(R){return this.windowsMainService.getWindowCount()}async getActiveWindowId(R){const W=D.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(W)return W.id}openWindow(R,W,j){return Array.isArray(W)?this.doOpenWindow(R,W,j):this.doOpenEmptyWindow(R,W)}async doOpenWindow(R,W,j=Object.create(null)){W.length>0&&this.windowsMainService.open({context:5,contextWindowId:R,urisToOpen:W,cli:this.environmentMainService.args,forceNewWindow:j.forceNewWindow,forceReuseWindow:j.forceReuseWindow,preferNewWindow:j.preferNewWindow,diffMode:j.diffMode,addMode:j.addMode,gotoLineMode:j.gotoLineMode,noRecentEntry:j.noRecentEntry,waitMarkerFileURI:j.waitMarkerFileURI,remoteAuthority:j.remoteAuthority||void 0})}async doOpenEmptyWindow(R,W){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:R},W)}async toggleFullScreen(R){const W=this.windowById(R);W&&W.toggleFullScreen()}async handleTitleDoubleClick(R){const W=this.windowById(R);W&&W.handleTitleDoubleClick()}async isMaximized(R){const W=this.windowById(R);return W?.win?W.win.isMaximized():!1}async maximizeWindow(R){const W=this.windowById(R);W?.win&&W.win.maximize()}async unmaximizeWindow(R){const W=this.windowById(R);W?.win&&W.win.unmaximize()}async minimizeWindow(R){const W=this.windowById(R);W?.win&&W.win.minimize()}async focusWindow(R,W){W&&typeof W.windowId=="number"&&(R=W.windowId);const j=this.windowById(R);j&&j.focus({force:W?.force??!1})}async setMinimumSize(R,W,j){const x=this.windowById(R);if(x?.win){const[ne,oe]=x.win.getSize(),[G,T]=x.win.getMinimumSize(),[B,q]=[W??G,j??T],[U,N]=[Math.max(ne,B),Math.max(oe,q)];(G!==B||T!==q)&&x.win.setMinimumSize(B,q),(ne!==U||oe!==N)&&x.win.setSize(U,N)}}async saveWindowSplash(R,W){this.themeMainService.saveWindowSplash(R,W)}async installShellCommand(R){const{source:W,target:j}=await this.getShellCommandLink();try{const{symbolicLink:x}=await b.SymlinkSupport.stat(W);if(x&&!x.dangling){const ne=await(0,t.realpath)(W);if(j===ne)return}await b.Promises.unlink(W)}catch(x){if(x.code!=="ENOENT")throw x}try{await b.Promises.symlink(j,W)}catch(x){if(x.code!=="EACCES"&&x.code!=="ENOENT")throw x;const{response:ne}=await this.showMessageBox(R,{title:this.productService.nameLong,type:"info",message:(0,S.localize)(0,null,this.productService.nameShort),buttons:[(0,d.mnemonicButtonLabel)((0,S.localize)(1,null)),(0,d.mnemonicButtonLabel)((0,S.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(ne===0)try{const oe=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${j}' '${W}'\\" with administrator privileges"`;await(0,C.promisify)(v.exec)(oe)}catch(oe){throw new Error((0,S.localize)(3,null,W))}}}async uninstallShellCommand(R){const{source:W}=await this.getShellCommandLink();try{await b.Promises.unlink(W)}catch(j){switch(j.code){case"EACCES":const{response:x}=await this.showMessageBox(R,{title:this.productService.nameLong,type:"info",message:(0,S.localize)(4,null,this.productService.nameShort),buttons:[(0,d.mnemonicButtonLabel)((0,S.localize)(5,null)),(0,d.mnemonicButtonLabel)((0,S.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(x===0)try{const ne=`osascript -e "do shell script \\"rm '${W}'\\" with administrator privileges"`;await(0,C.promisify)(v.exec)(ne)}catch(ne){throw new Error((0,S.localize)(7,null,W))}break;case"ENOENT":break;default:throw j}}}async getShellCommandLink(){const R=(0,E.resolve)(this.environmentMainService.appRoot,"bin","code"),W=`/usr/local/bin/${this.productService.applicationName}`;if(!await b.Promises.exists(R))throw new Error((0,S.localize)(8,null,R));return{source:W,target:R}}async showMessageBox(R,W){return this.dialogMainService.showMessageBox(W,this.toBrowserWindow(R))}async showSaveDialog(R,W){return this.dialogMainService.showSaveDialog(W,this.toBrowserWindow(R))}async showOpenDialog(R,W){return this.dialogMainService.showOpenDialog(W,this.toBrowserWindow(R))}toBrowserWindow(R){const W=this.windowById(R);if(W?.win)return W.win}async pickFileFolderAndOpen(R,W){const j=await this.dialogMainService.pickFileFolder(W);j&&(this.sendPickerTelemetry(j,W.telemetryEventName||"openFileFolder",W.telemetryExtraData),this.doOpenPicked(await Promise.all(j.map(async x=>await b.SymlinkSupport.existsDirectory(x)?{folderUri:p.URI.file(x)}:{fileUri:p.URI.file(x)})),W,R))}async pickFolderAndOpen(R,W){const j=await this.dialogMainService.pickFolder(W);j&&(this.sendPickerTelemetry(j,W.telemetryEventName||"openFolder",W.telemetryExtraData),this.doOpenPicked(j.map(x=>({folderUri:p.URI.file(x)})),W,R))}async pickFileAndOpen(R,W){const j=await this.dialogMainService.pickFile(W);j&&(this.sendPickerTelemetry(j,W.telemetryEventName||"openFile",W.telemetryExtraData),this.doOpenPicked(j.map(x=>({fileUri:p.URI.file(x)})),W,R))}async pickWorkspaceAndOpen(R,W){const j=await this.dialogMainService.pickWorkspace(W);j&&(this.sendPickerTelemetry(j,W.telemetryEventName||"openWorkspace",W.telemetryExtraData),this.doOpenPicked(j.map(x=>({workspaceUri:p.URI.file(x)})),W,R))}doOpenPicked(R,W,j){this.windowsMainService.open({context:3,contextWindowId:j,cli:this.environmentMainService.args,urisToOpen:R,forceNewWindow:W.forceNewWindow})}sendPickerTelemetry(R,W,j){const x=R?R.length:0;this.telemetryService.publicLog(W,{...j,outcome:x?"success":"canceled",numberOfPaths:x})}async showItemInFolder(R,W){D.shell.showItemInFolder(W)}async setRepresentedFilename(R,W){const j=this.windowById(R);j&&j.setRepresentedFilename(W)}async setDocumentEdited(R,W){const j=this.windowById(R);j&&j.setDocumentEdited(W)}async openExternal(R,W){return m.isLinuxSnap?this.safeSnapOpenExternal(W):D.shell.openExternal(W),!0}safeSnapOpenExternal(R){const W=process.env.GDK_PIXBUF_MODULE_FILE,j=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,D.shell.openExternal(R),process.env.GDK_PIXBUF_MODULE_FILE=W,process.env.GDK_PIXBUF_MODULEDIR=j}moveItemToTrash(R,W){return D.shell.trashItem(W)}async isAdmin(){let R;return m.isWindows?R=(await new Promise((W,j)=>{H(["native-is-elevated"],W,j)}))():R=process.getuid()===0,R}async writeElevated(R,W,j,x){const ne=await new Promise((oe,G)=>{H(["sudo-prompt"],oe,G)});return new Promise((oe,G)=>{const T=[`"${this.cliPath}"`];x?.unlock&&T.push("--file-chmod"),T.push("--file-write",`"${W.fsPath}"`,`"${j.fsPath}"`);const B={name:this.productService.nameLong.replace("-",""),icns:m.isMacintosh&&this.environmentMainService.isBuilt?(0,E.join)((0,E.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};ne.exec(T.join(" "),B,(q,U,N)=>{U&&this.logService.trace(`[sudo-prompt] received stdout: ${U}`),N&&this.logService.trace(`[sudo-prompt] received stderr: ${N}`),q?G(q):oe(void 0)})})}get cliPath(){return m.isWindows?this.environmentMainService.isBuilt?(0,E.join)((0,E.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,E.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):m.isLinux?this.environmentMainService.isBuilt?(0,E.join)((0,E.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,E.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,E.join)(this.environmentMainService.appRoot,"bin","code"):(0,E.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,M.totalmem)(),freemem:(0,M.freemem)(),loadavg:(0,M.loadavg)()}}async getOSProperties(){return{arch:(0,M.arch)(),platform:(0,M.platform)(),release:(0,M.release)(),type:(0,M.type)(),cpus:(0,M.cpus)()}}async getOSVirtualMachineHint(){return w.virtualMachineHint.value()}get osColorScheme(){return{highContrast:D.nativeTheme.shouldUseInvertedColorScheme||D.nativeTheme.shouldUseHighContrastColors,dark:D.nativeTheme.shouldUseDarkColors}}async getOSColorScheme(){return this.osColorScheme}async killProcess(R,W,j){process.kill(W,j)}async readClipboardText(R,W){return D.clipboard.readText(W)}async writeClipboardText(R,W,j){return D.clipboard.writeText(W,j)}async readClipboardFindText(R){return D.clipboard.readFindText()}async writeClipboardFindText(R,W){return D.clipboard.writeFindText(W)}async writeClipboardBuffer(R,W,j,x){return D.clipboard.writeBuffer(W,Buffer.from(j),x)}async readClipboardBuffer(R,W){return D.clipboard.readBuffer(W)}async hasClipboard(R,W,j){return D.clipboard.has(W,j)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){D.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){D.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){D.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){D.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){D.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(R,W){const j=this.windowById(R);j&&j.updateTouchBar(W)}async notifyReady(R){const W=this.windowById(R);W&&W.setReady()}async relaunch(R,W){return this.lifecycleMainService.relaunch(W)}async reload(R,W){const j=this.windowById(R);if(j){if((0,h.isWorkspaceIdentifier)(j.openedWorkspace)){const x=j.openedWorkspace.configPath;if(x.scheme===y.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(x))?.transient)return this.openWindow(j.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(j,W?.disableExtensions!==void 0?{_:[],"disable-extensions":W.disableExtensions}:void 0)}}async closeWindow(R){this.closeWindowById(R,R)}async closeWindowById(R,W){const j=this.windowById(W);if(j?.win)return j.win.close()}async quit(R){const W=this.windowsMainService.getLastActiveWindow();W?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&W.win?W.win.close():this.lifecycleMainService.quit()}async exit(R,W){await this.lifecycleMainService.kill(W)}async resolveProxy(R,W){const x=this.windowById(R)?.win?.webContents?.session;if(x)return x.resolveProxy(W)}async openDevTools(R,W){const j=this.windowById(R);j?.win&&j.win.webContents.openDevTools(W)}async toggleDevTools(R){const W=this.windowById(R);W?.win&&W.win.webContents.toggleDevTools()}async sendInputEvent(R,W){const j=this.windowById(R);j?.win&&(W.type==="mouseDown"||W.type==="mouseUp")&&j.win.webContents.sendInputEvent(W)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(R,W,j,x){if(!m.isWindows)return;const ne=await new Promise((oe,G)=>{H(["vscode-windows-registry"],oe,G)});try{return ne.GetStringRegKey(W,j,x)}catch{return}}async getPassword(R,W,j){const x=await this.withKeytar(),ne=await x.getPassword(W,j);if(ne)try{let{content:oe,hasNextChunk:G}=JSON.parse(ne);if(!oe||!G)return ne;let T=1;for(;G;){const B=await x.getPassword(W,`${j}-${T}`),q=JSON.parse(B);oe+=q.content,G=q.hasNextChunk,T++}return oe}catch{return ne}return ne}async setPassword(R,W,j,x){const ne=await this.withKeytar(),oe=3,G=async(T,B,q)=>{let U=0,N;for(;U<oe;)try{await ne.setPassword(T,B,q);return}catch(_){N=_,this.logService.warn("Error attempting to set a password: ",_),U++,await new Promise(Y=>setTimeout(Y,200))}throw N};if(m.isWindows&&x.length>dt.MAX_PASSWORD_LENGTH){let T=0,B=0,q=!0;for(;q;){const U=x.substring(T,T+dt.PASSWORD_CHUNK_SIZE);T+=dt.PASSWORD_CHUNK_SIZE,q=x.length-T>0;const N={content:U,hasNextChunk:q};await G(W,B?`${j}-${B}`:j,JSON.stringify(N)),B++}}else await G(W,j,x);this._onDidChangePassword.fire({service:W,account:j})}async deletePassword(R,W,j){const ne=await(await this.withKeytar()).deletePassword(W,j);return ne&&this._onDidChangePassword.fire({service:W,account:j}),ne}async findPassword(R,W){return(await this.withKeytar()).findPassword(W)}async findCredentials(R,W){return(await this.withKeytar()).findCredentials(W)}async withKeytar(){if(this.environmentMainService.disableKeytar)throw new Error("keytar has been disabled via --disable-keytar option");return await new Promise((R,W)=>{H(["keytar"],R,W)})}windowById(R){if(typeof R=="number")return this.windowsMainService.getWindowById(R)}};k.MAX_PASSWORD_LENGTH=2500,k.PASSWORD_CHUNK_SIZE=k.MAX_PASSWORD_LENGTH-100,he([n.memoize],k.prototype,"cliPath",null),k=he([ee(1,o.IWindowsMainService),ee(2,P.IDialogMainService),ee(3,l.ILifecycleMainService),ee(4,c.IEnvironmentMainService),ee(5,r.ITelemetryService),ee(6,s.ILogService),ee(7,u.IProductService),ee(8,i.IThemeMainService),ee(9,g.IWorkspacesManagementMainService)],k),e.NativeHostMainService=k}),define(Q[235],J([0,1,14,23,4,81,2,31,89,6,53,22,36]),function(H,e,v,D,M,C,n,I,d,f,y,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var p;(function(w){w[w.Initial=1]="Initial",w[w.StoredCredentialsUsed=2]="StoredCredentialsUsed",w[w.LoginDialogShown=3]="LoginDialogShown"})(p||(p={}));let t=class extends n.Disposable{constructor(b,S,P,c,a){super();this.logService=b,this.windowsMainService=S,this.nativeHostMainService=P,this.encryptionMainService=c,this.productService=a,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=p.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const b=M.Event.fromNodeEventEmitter(v.app,"login",(S,P,c,a,l)=>({event:S,webContents:P,req:c,authInfo:a,callback:l}));this._register(b(this.onLogin,this))}async onLogin({event:b,authInfo:S,req:P,callback:c}){if(!S.isProxy)return;if(!this.pendingProxyResolve&&this.state===p.LoginDialogShown&&P.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}b.preventDefault();let a;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),a=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(S);try{a=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}c(a?.username,a?.password)}async resolveProxyCredentials(b){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const S=await this.doResolveProxyCredentials(b);if(S)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),S;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(b){this.logService.trace("auth#doResolveProxyCredentials - enter",b);const S=String((0,C.hash)({scheme:b.scheme,host:b.host,port:b.port}));let P,c;try{const u=await this.nativeHostMainService.getPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,S);if(u){const r=JSON.parse(await this.encryptionMainService.decrypt(u));P=r.username,c=r.password}}catch(u){this.logService.error(u)}if(this.state!==p.StoredCredentialsUsed&&typeof P=="string"&&typeof c=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=p.StoredCredentialsUsed,{username:P,password:c};const a=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!a){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${a.id} to handle proxy login`);const l={authInfo:b,username:this.sessionCredentials?.username??P,password:this.sessionCredentials?.password??c,replyChannel:`vscode:proxyAuthResponse:${(0,I.generateUuid)()}`};a.sendWhenReady("vscode:openProxyAuthenticationDialog",D.CancellationToken.None,l),this.state=p.LoginDialogShown;const s=await new Promise(u=>{const r=async(i,o,h)=>{if(o===l.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${a.id}`),a.win?.webContents.off("ipc-message",r),h){const g={username:h.username,password:h.password};try{if(h.remember){const k=await this.encryptionMainService.encrypt(JSON.stringify(g));await this.nativeHostMainService.setPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,S,k)}else await this.nativeHostMainService.deletePassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,S)}catch(k){this.logService.error(k)}u({username:g.username,password:g.password})}else u(void 0)};a.win?.webContents.on("ipc-message",r)});return this.sessionCredentials=s,s}};t=he([ee(0,f.ILogService),ee(1,m.IWindowsMainService),ee(2,y.INativeHostMainService),ee(3,d.IEncryptionMainService),ee(4,E.IProductService)],t),e.ProxyAuthHandler=t}),define(Q[236],J([0,1,14,26,34,2,10,3,83,148,74,52,24,5,103,6,53,56,22,57,67]),function(H,e,v,D,M,C,n,I,d,f,y,E,m,p,t,w,b,S,P,c,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,p.createDecorator)("issueMainService");let l=class It{constructor(u,r,i,o,h,g,k,L,R){this.userEnv=u,this.environmentMainService=r,this.launchMainService=i,this.logService=o,this.diagnosticsService=h,this.dialogMainService=g,this.nativeHostMainService=k,this.protocolMainService=L,this.productService=R,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){v.ipcMain.on("vscode:issueSystemInfoRequest",async u=>{const[r,i]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),o=await this.diagnosticsService.getSystemInfo(r,i);this.safeSend(u,"vscode:issueSystemInfoResponse",o)}),v.ipcMain.on("vscode:listProcesses",async u=>{const r=[];try{const i=await this.launchMainService.getMainProcessId();r.push({name:(0,f.localize)(0,null),rootProcess:await(0,d.listProcesses)(i)}),(await this.launchMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(h=>{(0,y.isRemoteDiagnosticError)(h)?r.push({name:h.hostName,rootProcess:h}):h.processes&&r.push({name:h.hostName,rootProcess:h.processes})})}catch(i){this.logService.error(`Listing processes failed: ${i}`)}this.safeSend(u,"vscode:listProcessesResponse",r)}),v.ipcMain.on("vscode:issueReporterClipboard",async u=>{const r={title:this.productService.nameLong,message:(0,f.localize)(1,null),type:"warning",buttons:[(0,M.mnemonicButtonLabel)((0,f.localize)(2,null)),(0,M.mnemonicButtonLabel)((0,f.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const i=await this.dialogMainService.showMessageBox(r,this.issueReporterWindow);this.safeSend(u,"vscode:issueReporterClipboardResponse",i.response===0)}}),v.ipcMain.on("vscode:issuePerformanceInfoRequest",async u=>{const r=await this.getPerformanceInfo();this.safeSend(u,"vscode:issuePerformanceInfoResponse",r)}),v.ipcMain.on("vscode:issueReporterConfirmClose",async()=>{const u={title:this.productService.nameLong,message:(0,f.localize)(4,null),type:"warning",buttons:[(0,M.mnemonicButtonLabel)((0,f.localize)(5,null)),(0,M.mnemonicButtonLabel)((0,f.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(u,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),v.ipcMain.on("vscode:workbenchCommand",(u,r)=>{const{id:i,from:o,args:h}=r;let g;switch(o){case"issueReporter":g=this.issueReporterParentWindow;break;case"processExplorer":g=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${o}`)}g&&g.webContents.send("vscode:runAction",{id:i,from:o,args:h})}),v.ipcMain.on("vscode:openExternal",(u,r)=>{this.nativeHostMainService.openExternal(void 0,r)}),v.ipcMain.on("vscode:closeIssueReporter",u=>{this.issueReporterWindow&&this.issueReporterWindow.close()}),v.ipcMain.on("vscode:closeProcessExplorer",u=>{this.processExplorerWindow&&this.processExplorerWindow.close()}),v.ipcMain.on("vscode:windowsInfoRequest",async u=>{const r=await this.launchMainService.getMainProcessInfo();this.safeSend(u,"vscode:windowsInfoResponse",r.windows)})}safeSend(u,r,...i){u.sender.isDestroyed()||u.sender.send(r,...i)}async openReporter(u){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=v.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const r=new C.DisposableStore,i=r.add(this.protocolMainService.createIPCObjectUrl()),o=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(o,i,{backgroundColor:u.styles.backgroundColor,title:(0,f.localize)(7,null),zoomLevel:u.zoomLevel,alwaysOnTop:!1}),i.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:u,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,D.type)(),arch:(0,D.arch)(),release:(0,D.release)()},product:S.default}),this.issueReporterWindow.loadURL(n.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",H).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,r.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,r.dispose())})}this.issueReporterWindow?.focus()}async openProcessExplorer(u){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=v.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const r=new C.DisposableStore,i=r.add(this.protocolMainService.createIPCObjectUrl()),o=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(o,i,{backgroundColor:u.styles.backgroundColor,title:(0,f.localize)(8,null),zoomLevel:u.zoomLevel,alwaysOnTop:!0}),i.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:u,product:S.default}),this.processExplorerWindow.loadURL(n.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",H).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,r.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,r.dispose())})}this.processExplorerWindow?.focus()}createBrowserWindow(u,r,i){const o=new v.BrowserWindow({fullscreen:!1,skipTaskbar:!0,resizable:!0,width:u.width,height:u.height,minWidth:300,minHeight:200,x:u.x,y:u.y,title:i.title,backgroundColor:i.backgroundColor||It.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:n.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",H).fsPath,additionalArguments:[`--vscode-window-config=${r.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,a.zoomLevelToZoomFactor)(i.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:i.alwaysOnTop});return o.setMenuBarVisibility(!1),o}async getSystemStatus(){const[u,r]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(u,r)}getWindowPosition(u,r,i){let o;const h=v.screen.getAllDisplays();if(h.length===1)o=h[0];else{if(I.isMacintosh){const L=v.screen.getCursorScreenPoint();o=v.screen.getDisplayNearestPoint(L)}!o&&u&&(o=v.screen.getDisplayMatching(u.getBounds())),o||(o=v.screen.getPrimaryDisplay()||h[0])}const g={width:r,height:i},k=o.bounds;return g.x=k.x+k.width/2-g.width/2,g.y=k.y+k.height/2-g.height/2,k.width>0&&k.height>0&&(g.x<k.x&&(g.x=k.x),g.y<k.y&&(g.y=k.y),g.x>k.x+k.width&&(g.x=k.x),g.y>k.y+k.height&&(g.y=k.y),g.width>k.width&&(g.width=k.width),g.height>k.height&&(g.height=k.height)),g}async getPerformanceInfo(){try{const[u,r]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(u,r)}catch(u){throw this.logService.warn("issueService#getPerformanceInfo ",u.message),u}}};l.DEFAULT_BACKGROUND_COLOR="#1E1E1E",l=he([ee(1,m.IEnvironmentMainService),ee(2,t.ILaunchMainService),ee(3,w.ILogService),ee(4,y.IDiagnosticsService),ee(5,E.IDialogMainService),ee(6,b.INativeHostMainService),ee(7,c.IProtocolMainService),ee(8,P.IProductService)],l),e.IssueMainService=l}),define(Q[237],J([0,1,23,19,24,20,6,53,22,50,29,41,77]),function(H,e,v,D,M,C,n,I,d,f,y,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let p=class extends m.AbstractUpdateService{constructor(w,b,S,P,c,a,l,s){super(w,b,P,c,a,s);this.telemetryService=S,this.nativeHostMainService=l}buildUpdateFeedUrl(w){return(0,m.createUpdateURL)(`linux-${process.arch}`,w,this.productService)}doCheckForUpdates(w){!this.url||(this.setState(E.State.CheckingForUpdates(w)),this.requestService.request({url:this.url},v.CancellationToken.None).then(f.asJson).then(b=>{!b||!b.url||!b.version||!b.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!w}),this.setState(E.State.Idle(1))):this.setState(E.State.AvailableForDownload(b))}).then(void 0,b=>{this.logService.error(b),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!w});const S=w?b.message||b:void 0;this.setState(E.State.Idle(1,S))}))}async doDownloadUpdate(w){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):w.update.url&&this.nativeHostMainService.openExternal(void 0,w.update.url),this.setState(E.State.Idle(1))}};p=he([ee(0,C.ILifecycleMainService),ee(1,D.IConfigurationService),ee(2,y.ITelemetryService),ee(3,M.IEnvironmentMainService),ee(4,f.IRequestService),ee(5,n.ILogService),ee(6,I.INativeHostMainService),ee(7,d.IProductService)],p),e.LinuxUpdateService=p}),define(Q[238],J([0,1,43,28,26,9,23,46,8,7,114,21,19,24,18,20,6,53,22,50,29,41,77]),function(H,e,v,D,M,C,n,I,d,f,y,E,m,p,t,w,b,S,P,c,a,l,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function u(h,g=1e3){for(;!h();)await(0,C.timeout)(g)}let r;function i(){return typeof r=="undefined"&&(r=D.existsSync(d.join(d.dirname(process.execPath),"unins000.exe"))?0:1),r}let o=class extends s.AbstractUpdateService{constructor(g,k,L,R,W,j,x,ne,oe){super(g,k,R,W,j,oe);this.telemetryService=L,this.fileService=x,this.nativeHostMainService=ne}get cachePath(){const g=d.join((0,M.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return E.Promises.mkdir(g,{recursive:!0}).then(()=>g)}initialize(){super.initialize(),i()===0&&this.telemetryService.publicLog("update:win32SetupTarget",{target:this.productService.target})}buildUpdateFeedUrl(g){let k="win32";return process.arch!=="ia32"&&(k+=`-${process.arch}`),i()===1?k+="-archive":this.productService.target==="user"&&(k+="-user"),(0,s.createUpdateURL)(k,g,this.productService)}doCheckForUpdates(g){!this.url||(this.setState(l.State.CheckingForUpdates(g)),this.requestService.request({url:this.url},n.CancellationToken.None).then(c.asJson).then(k=>{const L=i();return!k||!k.url||!k.version||!k.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!g}),this.setState(l.State.Idle(L)),Promise.resolve(null)):L===1?(this.setState(l.State.AvailableForDownload(k)),Promise.resolve(null)):(this.setState(l.State.Downloading(k)),this.cleanup(k.version).then(()=>this.getUpdatePackagePath(k.version).then(R=>E.Promises.exists(R).then(W=>{if(W)return Promise.resolve(R);const j=k.url,x=k.hash,ne=`${R}.tmp`;return this.requestService.request({url:j},n.CancellationToken.None).then(oe=>this.fileService.writeFile(f.URI.file(ne),oe.stream)).then(x?()=>(0,y.checksum)(ne,k.hash):()=>{}).then(()=>E.Promises.rename(ne,R)).then(()=>R)})).then(R=>{const W=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:R},W&&k.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(l.State.Downloaded(k)):this.setState(l.State.Ready(k))})))}).then(void 0,k=>{this.logService.error(k),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!g});const L=g?k.message||k:void 0;this.setState(l.State.Idle(i(),L))}))}async doDownloadUpdate(g){g.update.url&&this.nativeHostMainService.openExternal(void 0,g.update.url),this.setState(l.State.Idle(i()))}async getUpdatePackagePath(g){const k=await this.cachePath;return d.join(k,`CodeSetup-${this.productService.quality}-${g}.exe`)}async cleanup(g=null){const k=g?j=>!new RegExp(`${this.productService.quality}-${g}\\.exe$`).test(j):()=>!0,L=await this.cachePath,W=(await E.Promises.readdir(L)).filter(k).map(async j=>{try{await E.Promises.unlink(d.join(L,j))}catch(x){}});await Promise.all(W)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const g=this.state.update;this.setState(l.State.Updating(g));const k=await this.cachePath;this.availableUpdate.updateFilePath=d.join(k,`CodeSetup-${this.productService.quality}-${g.version}.flag`),await E.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,v.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(l.State.Idle(i()))});const R=`${this.productService.win32MutexName}-ready`,W=await new Promise((j,x)=>{H(["windows-mutex"],j,x)});u(()=>W.isActive(R)).then(()=>this.setState(l.State.Ready(g)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?D.unlinkSync(this.availableUpdate.updateFilePath):(0,v.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return i()}};he([I.memoize],o.prototype,"cachePath",null),o=he([ee(0,w.ILifecycleMainService),ee(1,m.IConfigurationService),ee(2,a.ITelemetryService),ee(3,p.IEnvironmentMainService),ee(4,c.IRequestService),ee(5,b.ILogService),ee(6,t.IFileService),ee(7,S.INativeHostMainService),ee(8,P.IProductService)],o),e.Win32UpdateService=o}),define(Q[239],J([0,1,14,9,23,44,4,34,2,10,8,63,3,7,154,51,19,52,24,54,205,18,20,6,22,57,100,29,208,66,67,36,27,45]),function(H,e,v,D,M,C,n,I,d,f,y,E,m,p,t,w,b,S,P,c,a,l,s,u,r,i,o,h,g,k,L,R,W,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var x;(function(oe){oe[oe.NONE=0]="NONE",oe[oe.LOADING=1]="LOADING",oe[oe.NAVIGATING=2]="NAVIGATING",oe[oe.READY=3]="READY"})(x||(x={}));let ne=class extends d.Disposable{constructor(G,T,B,q,U,N,_,Y,F,A,O,$,X,V,z){super();this.logService=T,this.environmentMainService=B,this.fileService=q,this.configurationService=N,this.themeMainService=_,this.workspacesManagementMainService=Y,this.backupMainService=F,this.telemetryService=A,this.dialogMainService=O,this.lifecycleMainService=$,this.productService=X,this.protocolMainService=V,this.windowsMainService=z,this._onWillLoad=this._register(new n.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new n.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidClose=this._register(new n.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new n.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[Z,te]=this.restoreWindowState(G.state);this.windowState=Z,this.logService.trace("window#ctor: using window state",Z);const ce=this.windowState.mode===0||this.windowState.mode===3,se=this.configurationService.getValue("window"),ie={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:L.WindowMinimumSize.WIDTH,minHeight:L.WindowMinimumSize.HEIGHT,show:!ce,title:this.productService.nameLong,webPreferences:{preload:f.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",H).fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,L.zoomLevelToZoomFactor)(se?.zoomLevel),...this.environmentMainService.sandbox?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}}};m.isLinux?ie.icon=(0,y.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):m.isWindows&&!this.environmentMainService.isBuilt&&(ie.icon=(0,y.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),m.isMacintosh&&!this.useNativeFullScreen()&&(ie.fullscreenable=!1),m.isMacintosh&&(ie.acceptFirstMouse=!0,se?.clickThroughInactive===!1&&(ie.acceptFirstMouse=!1));const ae=m.isMacintosh&&se?.nativeTabs===!0;ae&&(ie.tabbingIdentifier=this.productService.nameShort);const ue=(0,L.getTitleBarStyle)(this.configurationService)==="custom";if(ue&&(ie.titleBarStyle="hidden",this.hiddenTitleBarStyle=!0,m.isMacintosh||(ie.frame=!1)),(0,E.mark)("code/willCreateCodeBrowserWindow"),this._win=new v.BrowserWindow(ie),(0,E.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),m.isMacintosh&&ue&&this._win.setSheetOffset(22),m.isMacintosh&&te&&(!ae||v.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(de=>typeof de=="number")){const de=this.windowState;this._win.setBounds({width:de.width,height:de.height,x:de.x,y:de.y})}ce&&((0,E.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.isVisible()||this._win.show(),(0,E.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.marketplaceHeadersPromise=(0,a.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,{get:Z=>U.globalStorage.get(Z),store:(Z,te)=>U.globalStorage.set(Z,te)}),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this.currentConfig?.backupPath}get openedWorkspace(){return this.currentConfig?.workspace}get remoteAuthority(){return this.currentConfig?.remoteAuthority}get config(){return this.currentConfig}get hasHiddenTitleBarStyle(){return!!this.hiddenTitleBarStyle}get isExtensionDevelopmentHost(){return!!this.currentConfig?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.currentConfig?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.currentConfig?.debugId}setRepresentedFilename(G){m.isMacintosh?this._win.setRepresentedFilename(G):this.representedFilename=G}getRepresentedFilename(){return m.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(G){m.isMacintosh&&this._win.setDocumentEdited(G),this.documentEdited=G}isDocumentEdited(){return m.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(G){m.isMacintosh&&G?.force&&v.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.readyState=3;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(G=>{if(this.isReady)return G(this);this.whenReadyCallbacks.push(G)})}get isReady(){return this.readyState===3}get whenClosedOrLoaded(){return new Promise(G=>{function T(){B.dispose(),q.dispose(),G()}const B=this.onDidClose(()=>T()),q=this.onWillLoad(()=>T())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(U,N)=>this.onWindowError(2,N)),this._win.webContents.on("did-fail-load",(U,N,_)=>this.onWindowError(3,{reason:_,exitCode:N})),this._win.webContents.on("will-prevent-unload",U=>{U.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()});const G=new Set([f.Schemas.file,f.Schemas.vscodeFileResource,f.Schemas.vscodeRemoteResource,"devtools"]),T=U=>{for(let N=U;N;N=N.parent)if(N.url.startsWith(`${f.Schemas.vscodeWebview}://`))return!0;return!1},B=U=>U.resourceType==="xhr"||T(U.frame);this._win.webContents.session.webRequest.onBeforeRequest((U,N)=>{const _=p.URI.parse(U.url);return _.path.endsWith(".svg")&&!G.has(_.scheme)?N({cancel:!B(U)}):N({cancel:!1})}),this._win.webContents.session.webRequest.onHeadersReceived((U,N)=>{const _=U.responseHeaders,Y=_["content-type"]||_["Content-Type"];if(Y&&Array.isArray(Y)){const F=p.URI.parse(U.url);if(F.path.endsWith(".svg")&&G.has(F.scheme))return _["Content-Type"]=["image/svg+xml"],N({cancel:!1,responseHeaders:_});if(!F.path.includes(f.Schemas.vscodeRemoteResource)&&Y.some(A=>A.toLowerCase().includes("image/svg")))return N({cancel:!B(U)})}return N({cancel:!1})}),this._win.webContents.on("did-finish-load",()=>{this.readyState=1,this.pendingLoadConfig&&(this.currentConfig=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",U=>{this.currentConfig&&(this.currentConfig.maximized=!0),v.app.emit("browser-window-maximize",U,this._win)}),this._win.on("unmaximize",U=>{this.currentConfig&&(this.currentConfig.maximized=!1),v.app.emit("browser-window-unmaximize",U,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",M.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",M.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(()=>this.onConfigurationUpdated())),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(U=>this.onDidDeleteUntitledWorkspace(U)));const q=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:q},async(U,N)=>{const _=await this.marketplaceHeadersPromise;N({cancel:!1,requestHeaders:Object.assign(U.requestHeaders,_)})})}async onWindowError(G,T){switch(G){case 2:this.logService.error(`CodeWindow: renderer process crashed (reason: ${T?.reason||"<unknown>"}, code: ${T?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${T?.reason||"<unknown>"}, code: ${T?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:G,reason:T?.reason,code:T?.exitCode}),G){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(G===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const B=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,I.mnemonicButtonLabel)((0,t.localize)(0,null)),(0,I.mnemonicButtonLabel)((0,t.localize)(1,null)),(0,I.mnemonicButtonLabel)((0,t.localize)(2,null))],message:(0,t.localize)(3,null),detail:(0,t.localize)(4,null),noLink:!0,defaultId:0,cancelId:1},this._win);if(B.response!==1){const q=B.response===0;this.destroyWindow(q)}}else if(G===2){let B;T?B=(0,t.localize)(6,null,T.reason,T.exitCode??"<unknown>"):B=(0,t.localize)(5,null);const U=(await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,I.mnemonicButtonLabel)((0,t.localize)(7,null)),(0,I.mnemonicButtonLabel)((0,t.localize)(8,null))],message:B,detail:(0,t.localize)(9,null),noLink:!0,defaultId:0},this._win)).response===0;this.destroyWindow(U)}break}}destroyWindow(G){if(this._onDidDestroy.fire(),this._win?.destroy(),G&&this.config){let T,B;(0,W.isSingleFolderWorkspaceIdentifier)(this.openedWorkspace)?T={folderUri:this.openedWorkspace.uri}:(0,W.isWorkspaceIdentifier)(this.openedWorkspace)?T={workspaceUri:this.openedWorkspace.configPath}:B=!0;const[q]=this.windowsMainService.open({context:5,userEnv:this.config.userEnv,cli:{...this.environmentMainService.args,_:[]},urisToOpen:T?[T]:void 0,forceEmpty:B,forceNewWindow:!0});q.focus()}}onDidDeleteUntitledWorkspace(G){this.openedWorkspace?.id===G.id&&this.currentConfig&&(this.currentConfig.workspace=void 0)}onConfigurationUpdated(){const G=this.getMenuBarVisibility();G!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=G,this.setMenuBarVisibility(G));let T=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;T?.endsWith("/")&&(T=T.substr(0,T.length-1));const B=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((T||"").indexOf("@")===-1&&(T!==this.currentHttpProxy||B!==this.currentNoProxy)){this.currentHttpProxy=T,this.currentNoProxy=B;const q=T||"",U=B?`${B},<local>`:"<local>";this.logService.trace(`Setting proxy to '${q}', bypassing '${U}'`),this._win.webContents.session.setProxy({proxyRules:q,proxyBypassRules:U,pacScript:""})}}addTabbedWindow(G){m.isMacintosh&&G.win&&this._win.addTabbedWindow(G.win)}load(G,T=Object.create(null)){this.isDocumentEdited()&&(!T.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),T.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(G,T),this.readyState===0?this.currentConfig=G:(this.pendingLoadConfig=G,this.readyState=2),this._win.loadURL(f.FileAccess.asBrowserUri(this.environmentMainService.sandbox?"vs/code/electron-sandbox/workbench/workbench.html":"vs/code/electron-browser/workbench/workbench.html",H).toString(!0));const B=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new D.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:G.workspace,reason:T.isReload?3:B?2:1})}updateConfiguration(G,T){const B=(this.currentConfig??this.pendingLoadConfig)?.userEnv;if(B){const q=(0,c.isLaunchedFromCli)(B)&&!(0,c.isLaunchedFromCli)(G.userEnv),U=this.isExtensionDevelopmentHost;(q||U)&&(G.userEnv={...B,...G.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(G.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),T.disableExtensions!==void 0&&(G["disable-extensions"]=T.disableExtensions),G.fullscreen=this.isFullScreen,G.maximized=this._win.isMaximized(),G.partsSplash=this.themeMainService.getWindowSplash(),(0,E.mark)("code/willOpenNewWindow"),G.perfMarks=(0,E.getMarks)(),this.configObjectUrl.update(G)}async reload(G){const T=Object.assign({},this.currentConfig);T.workspace=await this.validateWorkspaceBeforeReload(T),delete T.filesToOpenOrCreate,delete T.filesToDiff,delete T.filesToWait,this.isExtensionDevelopmentHost&&G&&(T.verbose=G.verbose,T.debugId=G.debugId,T.extensionEnvironment=G.extensionEnvironment,T["inspect-extensions"]=G["inspect-extensions"],T["inspect-brk-extensions"]=G["inspect-brk-extensions"],T["extensions-dir"]=G["extensions-dir"]),T.isInitialStartup=!1,this.load(T,{isReload:!0,disableExtensions:G?.["disable-extensions"]})}async validateWorkspaceBeforeReload(G){if((0,W.isWorkspaceIdentifier)(G.workspace)){const T=G.workspace.configPath;if(T.scheme===f.Schemas.file&&!await this.fileService.exists(T))return}else if((0,W.isSingleFolderWorkspaceIdentifier)(G.workspace)){const T=G.workspace.uri;if(T.scheme===f.Schemas.file&&!await this.fileService.exists(T))return}return G.workspace}serializeWindowState(){if(!this._win)return(0,R.defaultWindowState)();if(this.isFullScreen){let B;try{B=v.screen.getDisplayMatching(this.getBounds())}catch(N){}const q=(0,R.defaultWindowState)();return{mode:3,display:B?B.id:void 0,width:this.windowState.width||q.width,height:this.windowState.height||q.height,x:this.windowState.x||0,y:this.windowState.y||0}}const G=Object.create(null);let T;if(!m.isMacintosh&&this._win.isMaximized()?T=0:T=1,T===0?G.mode=0:G.mode=1,T===1||T===0){let B;T===1?B=this.getBounds():B=this._win.getNormalBounds(),G.x=B.x,G.y=B.y,G.width=B.width,G.height=B.height}return G}restoreWindowState(G){(0,E.mark)("code/willRestoreCodeWindowState");let T=!1;if(G)try{const B=v.screen.getAllDisplays();T=B.length>1,G=this.validateWindowState(G,B)}catch(B){this.logService.warn(`Unexpected error validating window state: ${B}
${B.stack}`)}return(0,E.mark)("code/didRestoreCodeWindowState"),[G||(0,R.defaultWindowState)(),T]}validateWindowState(G,T){if(this.logService.trace(`window#validateWindowState: validating window state on ${T.length} display(s)`,G),typeof G.x!="number"||typeof G.y!="number"||typeof G.width!="number"||typeof G.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(G.width<=0||G.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(T.length===1){const U=this.getWorkingArea(T[0]);if(U){let N=function(){!G||typeof G.x!="number"||typeof G.y!="number"||!U||(G.x<U.x&&(G.x=U.x),G.y<U.y&&(G.y=U.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",U),N(),G.width>U.width&&(G.width=U.width),G.height>U.height&&(G.height=U.height),G.x>U.x+U.width-128&&(G.x=U.x+U.width-G.width),G.y>U.y+U.height-128&&(G.y=U.y+U.height-G.height),N()}return G}if(G.display&&G.mode===3){const U=T.find(N=>N.id===G.display);if(U&&typeof U.bounds?.x=="number"&&typeof U.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const N=(0,R.defaultWindowState)(3);return N.x=U.bounds.x,N.y=U.bounds.y,N}}let B,q;try{B=v.screen.getDisplayMatching({x:G.x,y:G.y,width:G.width,height:G.height}),q=this.getWorkingArea(B)}catch(U){}if(B&&q&&G.x+G.width>q.x&&G.y+G.height>q.y&&G.x<q.x+q.width&&G.y<q.y+q.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",q),G}getWorkingArea(G){if(G.workArea.width>0&&G.workArea.height>0)return G.workArea;if(G.bounds.width>0&&G.bounds.height>0)return G.bounds}getBounds(){const[G,T]=this._win.getPosition(),[B,q]=this._win.getSize();return{x:G,y:T,width:B,height:q}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(G){this.useNativeFullScreen()?this.setNativeFullScreen(G):this.setSimpleFullScreen(G),this.sendWhenReady(G?"vscode:enterFullScreen":"vscode:leaveFullScreen",M.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(G){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(G)}setSimpleFullScreen(G){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(G),this._win.webContents.focus()}useNativeFullScreen(){const G=this.configurationService.getValue("window");return!G||typeof G.nativeFullScreen!="boolean"||G.nativeTabs?!0:G.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let G=(0,L.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(G)<0&&(G="classic"),G}setMenuBarVisibility(G,T=!0){m.isMacintosh||(G==="toggle"&&T&&this.send("vscode:showInfoMessage",(0,t.localize)(10,null)),G==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(G)}):this.doSetMenuBarVisibility(G))}doSetMenuBarVisibility(G){const T=this.isFullScreen;switch(G){case"classic":this._win.setMenuBarVisibility(!T),this._win.autoHideMenuBar=T;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(m.isMacintosh)switch(v.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win&&this._win.close()}sendWhenReady(G,T,...B){this.isReady?this.send(G,...B):this.ready().then(()=>{T.isCancellationRequested||this.send(G,...B)})}send(G,...T){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${G}' for window that is destroyed`);return}try{this._win.webContents.send(G,...T)}catch(B){this.logService.warn(`Error sending IPC message to channel '${G}' of window ${this._id}: ${(0,C.toErrorMessage)(B)}`)}}}updateTouchBar(G){!m.isMacintosh||this.touchBarGroups.forEach((T,B)=>{const q=G[B];T.segments=this.createTouchBarGroupSegments(q)})}createTouchBar(){if(!!m.isMacintosh){for(let G=0;G<10;G++){const T=this.createTouchBarGroup();this.touchBarGroups.push(T)}this._win.setTouchBar(new v.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(G=[]){const T=this.createTouchBarGroupSegments(G),B=new v.TouchBar.TouchBarSegmentedControl({segments:T,mode:"buttons",segmentStyle:"automatic",change:q=>{this.sendWhenReady("vscode:runAction",M.CancellationToken.None,{id:B.segments[q].id,from:"touchbar"})}});return B}createTouchBarGroupSegments(G=[]){return G.map(B=>{let q;B.icon&&!g.ThemeIcon.isThemeIcon(B.icon)&&B.icon?.dark?.scheme===f.Schemas.file&&(q=v.nativeImage.createFromPath(p.URI.revive(B.icon.dark).fsPath),q.isEmpty()&&(q=void 0));let U;return typeof B.title=="string"?U=B.title:U=B.title.value,{id:B.id,label:q?void 0:U,icon:q}})}dispose(){super.dispose(),this._win=null}};ne=he([ee(1,u.ILogService),ee(2,P.IEnvironmentMainService),ee(3,l.IFileService),ee(4,o.IStorageMainService),ee(5,b.IConfigurationService),ee(6,k.IThemeMainService),ee(7,j.IWorkspacesManagementMainService),ee(8,w.IBackupMainService),ee(9,h.ITelemetryService),ee(10,S.IDialogMainService),ee(11,s.ILifecycleMainService),ee(12,r.IProductService),ee(13,i.IProtocolMainService),ee(14,R.IWindowsMainService)],ne),e.CodeWindow=ne}),define(Q[68],J([0,1,14,30,9,4,34,2,10,3,15,7,21,157,5,20,6,38,27,45]),function(H,e,v,D,M,C,n,I,d,f,y,E,m,p,t,w,b,S,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,t.createDecorator)("workspacesHistoryMainService");let a=class $e extends I.Disposable{constructor(s,u,r,i){super();this.stateMainService=s,this.logService=u,this.workspacesManagementMainService=r,this.lifecycleMainService=i,this._onDidChangeRecentlyOpened=this._register(new C.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new M.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(s=>this.addRecentlyOpened([{workspace:s.workspace}])))}handleWindowsJumpList(){!f.isWindows||(this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}addRecentlyOpened(s){const u=[],r=[];for(let i of s)if((0,P.isRecentWorkspace)(i))!this.workspacesManagementMainService.isUntitledWorkspace(i.workspace)&&this.indexOfWorkspace(u,i.workspace)===-1&&u.push(i);else if((0,P.isRecentFolder)(i))this.indexOfFolder(u,i.folderUri)===-1&&u.push(i);else{const o=this.indexOfFile(r,i.fileUri)>=0,h=i.fileUri.scheme===d.Schemas.file&&$e.COMMON_FILES_FILTER.indexOf((0,y.basename)(i.fileUri))>=0;!o&&!h&&(r.push(i),f.isWindows&&i.fileUri.scheme===d.Schemas.file&&v.app.addRecentDocument(i.fileUri.fsPath))}this.addEntriesFromStorage(u,r),u.length>$e.MAX_TOTAL_RECENT_ENTRIES&&(u.length=$e.MAX_TOTAL_RECENT_ENTRIES),r.length>$e.MAX_TOTAL_RECENT_ENTRIES&&(r.length=$e.MAX_TOTAL_RECENT_ENTRIES),this.saveRecentlyOpened({workspaces:u,files:r}),this._onDidChangeRecentlyOpened.fire(),f.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}removeRecentlyOpened(s){const u=h=>{const g=this.location(h);for(const k of s)if(y.extUriBiasedIgnorePathCase.isEqual(k,g))return!1;return!0},r=this.getRecentlyOpened(),i=r.workspaces.filter(u),o=r.files.filter(u);(i.length!==r.workspaces.length||o.length!==r.files.length)&&(this.saveRecentlyOpened({files:o,workspaces:i}),this._onDidChangeRecentlyOpened.fire(),f.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async updateMacOSRecentDocuments(){if(!f.isMacintosh)return;v.app.clearRecentDocuments();const s=this.getRecentlyOpened(),u=[];let r=0;for(let o=0;o<s.workspaces.length&&r<$e.MAX_MACOS_DOCK_RECENT_WORKSPACES;o++){const h=this.location(s.workspaces[o]);if(h.scheme===d.Schemas.file){const g=(0,y.originalFSPath)(h);await m.Promises.exists(g)&&(u.push(g),r++)}}const i=[];for(let o=0;o<s.files.length&&r<$e.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;o++){const h=this.location(s.files[o]);if(h.scheme===d.Schemas.file){const g=(0,y.originalFSPath)(h);if($e.COMMON_FILES_FILTER.includes((0,y.basename)(h))||u.includes(g))continue;await m.Promises.exists(g)&&(i.push(g),r++)}}i.reverse().forEach(o=>v.app.addRecentDocument(o)),u.reverse().forEach(o=>v.app.addRecentDocument(o))}clearRecentlyOpened(){this.saveRecentlyOpened({workspaces:[],files:[]}),v.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}getRecentlyOpened(s){const u=[],r=[],i=s?.config?.workspace;(0,P.isWorkspaceIdentifier)(i)&&!this.workspacesManagementMainService.isUntitledWorkspace(i)?u.push({workspace:i}):(0,P.isSingleFolderWorkspaceIdentifier)(i)&&u.push({folderUri:i.uri});const o=s?.config?.filesToOpenOrCreate;if(o)for(let h of o){const g=h.fileUri;g&&this.indexOfFile(r,g)===-1&&r.push({fileUri:g})}return this.addEntriesFromStorage(u,r),{workspaces:u,files:r}}addEntriesFromStorage(s,u){let r=this.getRecentlyOpenedFromStorage();for(let i of r.workspaces){let o=(0,P.isRecentFolder)(i)?this.indexOfFolder(s,i.folderUri):this.indexOfWorkspace(s,i.workspace);o>=0?s[o].label=s[o].label||i.label:s.push(i)}for(let i of r.files){let o=this.indexOfFile(u,i.fileUri);o>=0?u[o].label=u[o].label||i.label:u.push(i)}}getRecentlyOpenedFromStorage(){const s=this.stateMainService.getItem($e.recentlyOpenedStorageKey);return(0,P.restoreRecentlyOpened)(s,this.logService)}saveRecentlyOpened(s){const u=(0,P.toStoreData)(s);this.stateMainService.setItem($e.recentlyOpenedStorageKey,u)}updateWindowsJumpList(){if(!f.isWindows)return;const s=[];if(s.push({type:"tasks",items:[{type:"task",title:(0,p.localize)(0,null),description:(0,p.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),this.getRecentlyOpened().workspaces.length>0){let u=[];for(let o of v.app.getJumpListSettings().removedItems){const h=o.args;if(h){const g=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(h);g&&u.push(E.URI.parse(g[2]))}}this.removeRecentlyOpened(u);let r=!1;const i=(0,D.coalesce)(this.getRecentlyOpened().workspaces.slice(0,$e.MAX_WINDOWS_JUMP_LIST_ENTRIES).map(o=>{const h=(0,P.isRecentWorkspace)(o)?o.workspace:o.folderUri,{title:g,description:k}=this.getWindowsJumpListLabel(h,o.label);let L;return E.URI.isUri(h)?L=`--folder-uri "${h.toString()}"`:(r=!0,L=`--file-uri "${h.configPath.toString()}"`),{type:"task",title:g.substr(0,255),description:k.substr(0,255),program:process.execPath,args:L,iconPath:"explorer.exe",iconIndex:0}}));i.length>0&&s.push({type:"custom",name:r?(0,p.localize)(2,null):(0,p.localize)(3,null),items:i})}s.push({type:"recent"});try{v.app.setJumpList(s)}catch(u){this.logService.warn("updateWindowsJumpList#setJumpList",u)}}getWindowsJumpListLabel(s,u){if(u)return{title:(0,n.splitName)(u).name,description:u};if(E.URI.isUri(s))return{title:(0,y.basename)(s),description:this.renderJumpListPathDescription(s)};if(this.workspacesManagementMainService.isUntitledWorkspace(s))return{title:(0,p.localize)(4,null),description:""};let r=(0,y.basename)(s.configPath);return r.endsWith(P.WORKSPACE_EXTENSION)&&(r=r.substr(0,r.length-P.WORKSPACE_EXTENSION.length-1)),{title:(0,p.localize)(5,null,r),description:this.renderJumpListPathDescription(s.configPath)}}renderJumpListPathDescription(s){return s.scheme==="file"?(0,n.normalizeDriveLetter)(s.fsPath):s.toString()}location(s){return(0,P.isRecentFolder)(s)?s.folderUri:(0,P.isRecentFile)(s)?s.fileUri:s.workspace.configPath}indexOfWorkspace(s,u){return s.findIndex(r=>(0,P.isRecentWorkspace)(r)&&r.workspace.id===u.id)}indexOfFolder(s,u){return s.findIndex(r=>(0,P.isRecentFolder)(r)&&y.extUriBiasedIgnorePathCase.isEqual(r.folderUri,u))}indexOfFile(s,u){return s.findIndex(r=>y.extUriBiasedIgnorePathCase.isEqual(r.fileUri,u))}};a.MAX_TOTAL_RECENT_ENTRIES=500,a.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,a.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,a.MAX_WINDOWS_JUMP_LIST_ENTRIES=7,a.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],a.recentlyOpenedStorageKey="openedPathsList",a=he([ee(0,S.IStateMainService),ee(1,b.ILogService),ee(2,c.IWorkspacesManagementMainService),ee(3,w.ILifecycleMainService)],a),e.WorkspacesHistoryMainService=a}),define(Q[240],J([0,1,14,9,23,34,3,7,149,19,24,20,6,187,53,22,38,29,41,67,36,68]),function(H,e,v,D,M,C,n,I,d,f,y,E,m,p,t,w,b,S,P,c,a,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const s="menu";let u=class vt{constructor(o,h,g,k,L,R,W,j,x,ne,oe){this.updateService=o,this.configurationService=h,this.windowsMainService=g,this.environmentMainService=k,this.telemetryService=L,this.workspacesHistoryMainService=R,this.stateMainService=W,this.lifecycleMainService=j,this.logService=x,this.nativeHostMainService=ne,this.productService=oe,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new D.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new D.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(n.isMacintosh||(0,c.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const o=this.stateMainService.getItem(vt.lastKnownMenubarStorageKey);o&&(o.menus&&(this.menubarMenus=o.menus),o.keybindings&&(this.keybindings=o.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(R,W,j)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:W?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(R,W,j)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:W?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(R,W,j)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(j),telemetryExtraData:{from:s}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(R,W,j)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(j),telemetryExtraData:{from:s}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const o=this.productService.twitterUrl;o&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(o,"openTwitterUrl"));const h=this.productService.requestFeatureUrl;h&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(h,"openUserVoiceUrl"));const g=this.productService.reportIssueUrl;g&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(g,"openReportIssues"));const k=this.productService.licenseUrl;k&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(n.language){const R=k.indexOf("?")>0?"&":"?";this.openUrl(`${k}${R}lang=${n.language}`,"openLicenseUrl")}else this.openUrl(k,"openLicenseUrl")});const L=this.productService.privacyStatementUrl;L&&k&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(L,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(o=>this.onDidChangeWindowsCount(o)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){let o=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof o!="boolean"?!0:o}get currentEnableNativeTabs(){if(!n.isMacintosh)return!1;let o=this.configurationService.getValue("window.nativeTabs");return typeof o!="boolean"?!1:o}updateMenu(o,h){this.menubarMenus=o.menus,this.keybindings=o.keybindings,this.stateMainService.setItem(vt.lastKnownMenubarStorageKey,o),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(o){!n.isMacintosh||(o.oldCount===0&&o.newCount>0||o.oldCount>0&&o.newCount===0)&&(this.closedLastWindow=o.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!n.isMacintosh||(this.noActiveWindow=!v.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const o=v.Menu.getApplicationMenu();if(o&&this.oldMenus.push(o),Object.keys(this.menubarMenus).length===0){v.Menu.setApplicationMenu(n.isMacintosh?new v.Menu:null);return}const h=new v.Menu;let g;if(n.isMacintosh){const L=new v.Menu;g=new v.MenuItem({label:this.productService.nameShort,submenu:L}),this.setMacApplicationMenu(L),h.append(g)}if(n.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const L=new v.Menu;L.append(new v.MenuItem({label:this.mnemonicLabel(d.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),v.app.dock.setMenu(L)}if(this.shouldDrawMenu("File")){const L=new v.Menu,R=new v.MenuItem({label:this.mnemonicLabel(d.localize(1,null)),submenu:L});this.setMenuById(L,"File"),h.append(R)}if(this.shouldDrawMenu("Edit")){const L=new v.Menu,R=new v.MenuItem({label:this.mnemonicLabel(d.localize(2,null)),submenu:L});this.setMenuById(L,"Edit"),h.append(R)}if(this.shouldDrawMenu("Selection")){const L=new v.Menu,R=new v.MenuItem({label:this.mnemonicLabel(d.localize(3,null)),submenu:L});this.setMenuById(L,"Selection"),h.append(R)}if(this.shouldDrawMenu("View")){const L=new v.Menu,R=new v.MenuItem({label:this.mnemonicLabel(d.localize(4,null)),submenu:L});this.setMenuById(L,"View"),h.append(R)}if(this.shouldDrawMenu("Go")){const L=new v.Menu,R=new v.MenuItem({label:this.mnemonicLabel(d.localize(5,null)),submenu:L});this.setMenuById(L,"Go"),h.append(R)}if(this.shouldDrawMenu("Run")){const L=new v.Menu,R=new v.MenuItem({label:this.mnemonicLabel(d.localize(6,null)),submenu:L});this.setMenuById(L,"Run"),h.append(R)}if(this.shouldDrawMenu("Terminal")){const L=new v.Menu,R=new v.MenuItem({label:this.mnemonicLabel(d.localize(7,null)),submenu:L});this.setMenuById(L,"Terminal"),h.append(R)}let k;if(this.shouldDrawMenu("Window")){const L=new v.Menu;k=new v.MenuItem({label:this.mnemonicLabel(d.localize(8,null)),submenu:L,role:"window"}),this.setMacWindowMenu(L)}if(k&&h.append(k),this.shouldDrawMenu("Help")){const L=new v.Menu,R=new v.MenuItem({label:this.mnemonicLabel(d.localize(9,null)),submenu:L,role:"help"});this.setMenuById(L,"Help"),h.append(R)}h.items&&h.items.length>0?v.Menu.setApplicationMenu(h):v.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(o){const h=this.createMenuItem(d.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),g=this.getUpdateMenuItems();let k;if(this.shouldDrawMenu("Preferences")){const G=new v.Menu;this.setMenuById(G,"Preferences"),k=new v.MenuItem({label:this.mnemonicLabel(d.localize(11,null)),submenu:G})}const L=new v.Menu,R=new v.MenuItem({label:d.localize(12,null),role:"services",submenu:L}),W=new v.MenuItem({label:d.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),j=new v.MenuItem({label:d.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),x=new v.MenuItem({label:d.localize(15,null),role:"unhide"}),ne=new v.MenuItem(this.likeAction("workbench.action.quit",{label:d.localize(16,null,this.productService.nameLong),click:()=>{const G=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!v.BrowserWindow.getFocusedWindow()||G?.isMinimized())&&this.nativeHostMainService.quit(void 0)}})),oe=[h];oe.push(...g),k&&oe.push(r(),k),oe.push(r(),R,r(),W,j,x,r(),ne),oe.forEach(G=>o.append(G))}shouldDrawMenu(o){if(!n.isMacintosh&&(0,c.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(o){case"File":case"Help":if(n.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[o];case"Window":if(n.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[o]}}setMenu(o,h){h.forEach(g=>{if((0,p.isMenubarMenuItemSeparator)(g))o.append(r());else if((0,p.isMenubarMenuItemSubmenu)(g)){const k=new v.Menu,L=new v.MenuItem({label:this.mnemonicLabel(g.label),submenu:k});this.setMenu(k,g.submenu.items),o.append(L)}else(0,p.isMenubarMenuItemRecentAction)(g)?o.append(this.createOpenRecentMenuItem(g)):(0,p.isMenubarMenuItemAction)(g)&&(g.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(o),n.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[g.id]?o.append(new v.MenuItem(this.likeAction(g.id,{label:this.mnemonicLabel(g.label),click:this.fallbackMenuHandlers[g.id]}))):o.append(this.createMenuItem(g.label,g.id,!1,g.checked)):o.append(this.createMenuItem(g.label,g.id,g.enabled!==!1,!!g.checked)):o.append(this.createMenuItem(g.label,g.id,g.enabled!==!1,!!g.checked)))})}setMenuById(o,h){this.menubarMenus&&this.menubarMenus[h]&&this.setMenu(o,this.menubarMenus[h].items)}insertCheckForUpdatesItems(o){const h=this.getUpdateMenuItems();h.length&&(h.forEach(g=>o.append(g)),o.append(r()))}createOpenRecentMenuItem(o){const h=I.URI.revive(o.uri),g=o.id,k=g==="openRecentFile"?{fileUri:h}:g==="openRecentWorkspace"?{workspaceUri:h}:{folderUri:h};return new v.MenuItem(this.likeAction(g,{label:o.label,click:(L,R,W)=>{const j=this.isOptionClick(W);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[k],forceNewWindow:j,gotoLineMode:!1,remoteAuthority:o.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([h])}},!1))}isOptionClick(o){return!!(o&&(!n.isMacintosh&&(o.ctrlKey||o.shiftKey)||n.isMacintosh&&(o.metaKey||o.altKey)))}createRoleMenuItem(o,h,g){const k={label:this.mnemonicLabel(o),role:g,enabled:!0};return new v.MenuItem(this.withKeybinding(h,k))}setMacWindowMenu(o){const h=new v.MenuItem({label:d.localize(17,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),g=new v.MenuItem({label:d.localize(18,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),k=new v.MenuItem({label:d.localize(19,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),L=this.createMenuItem(d.localize(20,null),"workbench.action.switchWindow"),R=[];this.currentEnableNativeTabs&&(R.push(r()),R.push(this.createMenuItem(d.localize(21,null),"workbench.action.newWindowTab")),R.push(this.createRoleMenuItem(d.localize(22,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),R.push(this.createRoleMenuItem(d.localize(23,null),"workbench.action.showNextWindowTab","selectNextTab")),R.push(this.createRoleMenuItem(d.localize(24,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),R.push(this.createRoleMenuItem(d.localize(25,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[h,g,r(),L,...R,r(),k].forEach(W=>o.append(W))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new v.MenuItem({label:this.mnemonicLabel(d.localize(26,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new v.MenuItem({label:d.localize(27,null),enabled:!1})];case"available for download":return[new v.MenuItem({label:this.mnemonicLabel(d.localize(28,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new v.MenuItem({label:d.localize(29,null),enabled:!1})];case"downloaded":return[new v.MenuItem({label:this.mnemonicLabel(d.localize(30,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new v.MenuItem({label:d.localize(31,null),enabled:!1})];case"ready":return[new v.MenuItem({label:this.mnemonicLabel(d.localize(32,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(o,h,g,k){const L=this.mnemonicLabel(o),R=typeof h=="function"?h:(oe,G,T)=>{const B=oe?oe.userSettingsLabel:null;let q=h;Array.isArray(h)&&(q=this.isOptionClick(T)?h[1]:h[0]),B&&T.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:B}):this.runActionInRenderer({type:"commandId",commandId:q})},W=typeof g=="boolean"?g:this.windowsMainService.getWindowCount()>0,j=typeof k=="boolean"?k:!1,x={label:L,click:R,enabled:W};j&&(x.type="checkbox",x.checked=j);let ne;return typeof h=="string"?ne=h:Array.isArray(h)&&(ne=h[0]),n.isMacintosh&&(ne==="editor.action.clipboardCutAction"?x.role="cut":ne==="editor.action.clipboardCopyAction"?x.role="copy":ne==="editor.action.clipboardPasteAction"&&(x.role="paste"),ne==="undo"?x.click=this.makeContextAwareClickHandler(R,{inDevTools:oe=>oe.undo(),inNoWindow:()=>v.Menu.sendActionToFirstResponder("undo:")}):ne==="redo"?x.click=this.makeContextAwareClickHandler(R,{inDevTools:oe=>oe.redo(),inNoWindow:()=>v.Menu.sendActionToFirstResponder("redo:")}):ne==="editor.action.selectAll"&&(x.click=this.makeContextAwareClickHandler(R,{inDevTools:oe=>oe.selectAll(),inNoWindow:()=>v.Menu.sendActionToFirstResponder("selectAll:")}))),new v.MenuItem(this.withKeybinding(ne,x))}makeContextAwareClickHandler(o,h){return(g,k,L)=>{const R=v.BrowserWindow.getFocusedWindow();if(!R)return h.inNoWindow();if(R.webContents.isDevToolsFocused()&&R.webContents.devToolsWebContents)return h.inDevTools(R.webContents.devToolsWebContents);o(g,k||R,L)}}runActionInRenderer(o){let h=v.BrowserWindow.getFocusedWindow();if(!h){const k=this.windowsMainService.getLastActiveWindow();k?.isMinimized()&&(h=k.win)}const g=h?this.windowsMainService.getWindowById(h.id):void 0;if(g){if(this.logService.trace("menubar#runActionInRenderer",o),n.isMacintosh&&!this.environmentMainService.isBuilt&&!g.isReady&&(o.type==="commandId"&&o.commandId==="workbench.action.toggleDevTools"||o.type!=="commandId"&&o.userSettingsLabel==="alt+cmd+i"))return;if(o.type==="commandId"){const k={id:o.commandId,from:"menu"};g.sendWhenReady("vscode:runAction",M.CancellationToken.None,k)}else{const k={userSettingsLabel:o.userSettingsLabel};g.sendWhenReady("vscode:runKeybinding",M.CancellationToken.None,k)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",o)}withKeybinding(o,h){const g=typeof o=="string"?this.keybindings[o]:void 0;if(g?.label){if(g.isNative!==!1)h.accelerator=g.label,h.userSettingsLabel=g.userSettingsLabel;else if(typeof h.label=="string"){const k=h.label.indexOf("[");k>=0?h.label=`${h.label.substr(0,k)} [${g.label}]`:h.label=`${h.label} [${g.label}]`}}else h.accelerator=void 0;return h}likeAction(o,h,g=!h.accelerator){g&&(h=this.withKeybinding(o,h));const k=h.click;return h.click=(L,R,W)=>{this.reportMenuActionTelemetry(o),k&&k(L,R,W)},h}openUrl(o,h){this.nativeHostMainService.openExternal(void 0,o),this.reportMenuActionTelemetry(h)}reportMenuActionTelemetry(o){this.telemetryService.publicLog2("workbenchActionExecuted",{id:o,from:s})}mnemonicLabel(o){return(0,C.mnemonicMenuLabel)(o,!this.currentEnableMenuBarMnemonics)}};u.lastKnownMenubarStorageKey="lastKnownMenubarData",u=he([ee(0,P.IUpdateService),ee(1,f.IConfigurationService),ee(2,a.IWindowsMainService),ee(3,y.IEnvironmentMainService),ee(4,S.ITelemetryService),ee(5,l.IWorkspacesHistoryMainService),ee(6,b.IStateMainService),ee(7,E.ILifecycleMainService),ee(8,m.ILogService),ee(9,t.INativeHostMainService),ee(10,w.IProductService)],u),e.Menubar=u;function r(){return new v.MenuItem({type:"separator"})}}),define(Q[241],J([0,1,5,20,6,240]),function(H,e,v,D,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,v.createDecorator)("menubarMainService");let n=class{constructor(d,f,y){this.instantiationService=d,this.lifecycleMainService=f,this.logService=y,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(C.Menubar)}async updateMenubar(d,f){this.logService.trace("menubarService#updateMenubar",d),(await this.menubar).updateMenu(f,d)}};n=he([ee(0,v.IInstantiationService),ee(1,D.ILifecycleMainService),ee(2,M.ILogService)],n),e.MenubarMainService=n}),define(Q[242],J([0,1,14,28,26,30,23,4,33,42,34,2,10,8,63,3,32,15,13,7,155,51,19,52,24,18,5,20,6,56,22,57,64,38,67,239,101,221,27,102,68,45]),function(H,e,v,D,M,C,n,I,d,f,y,E,m,p,t,w,b,S,P,c,a,l,s,u,r,i,o,h,g,k,L,R,W,j,x,ne,oe,G,T,B,q,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function N(F){return(0,T.isWorkspaceIdentifier)(F?.workspace)}function _(F){return(0,T.isSingleFolderWorkspaceIdentifier)(F?.workspace)}let Y=class xe extends E.Disposable{constructor(A,O,$,X,V,z,Z,te,ce,se,ie,ae,ue,de,ve){super();this.machineId=A,this.initialUserEnv=O,this.logService=$,this.stateMainService=X,this.environmentMainService=V,this.lifecycleMainService=z,this.backupMainService=Z,this.configurationService=te,this.workspacesHistoryMainService=ce,this.workspacesManagementMainService=se,this.instantiationService=ie,this.dialogMainService=ae,this.fileService=ue,this.productService=de,this.protocolMainService=ve,this._onDidOpenWindow=this._register(new I.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new I.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new I.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new I.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this.windowsStateHandler=this._register(new G.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(A=>this._onDidSignalReadyWindow.fire(A.window))),this._register(this.onDidSignalReadyWindow(A=>{if(A.config?.extensionDevelopmentPath||A.config?.extensionTestsPath){const O=new E.DisposableStore;if(O.add(I.Event.any(A.onDidClose,A.onDidDestroy)(()=>O.dispose())),A.config.extensionDevelopmentPath)for(const $ of A.config.extensionDevelopmentPath)O.add(this.protocolMainService.addValidFileRoot(c.URI.file($)));A.config.extensionTestsPath&&O.add(this.protocolMainService.addValidFileRoot(c.URI.file(A.config.extensionTestsPath)))}}))}openEmptyWindow(A,O){let $=this.environmentMainService.args;const X=O?.remoteAuthority||void 0,V=!0,z=O?.forceReuseWindow,Z=!z;return this.open({...A,cli:$,forceEmpty:V,forceNewWindow:Z,forceReuseWindow:z,remoteAuthority:X})}openExistingWindow(A,O){A.focus(),this.handleWaitMarkerFile(O,[A])}open(A){this.logService.trace("windowsManager#open"),A.addMode&&(A.initialStartup||!this.getLastActiveWindow())&&(A.addMode=!1);const O=[],$=[],X=[],V=[],z=[];let Z,te=0;const ce=this.getPathsToOpen(A);this.logService.trace("windowsManager#open pathsToOpen",ce);for(const ue of ce)_(ue)?A.addMode?O.push(ue):$.push(ue):N(ue)?X.push(ue):ue.fileUri?(Z||(Z={filesToOpenOrCreate:[],filesToDiff:[],remoteAuthority:ue.remoteAuthority}),Z.filesToOpenOrCreate.push(ue)):ue.backupPath?z.push({backupFolder:(0,p.basename)(ue.backupPath),remoteAuthority:ue.remoteAuthority}):te++;A.diffMode&&Z&&Z.filesToOpenOrCreate.length>=2&&(Z.filesToDiff=Z.filesToOpenOrCreate.slice(0,2),Z.filesToOpenOrCreate=[]),Z&&A.waitMarkerFileURI&&(Z.filesToWait={paths:[...Z.filesToDiff,...Z.filesToOpenOrCreate],waitMarkerFileUri:A.waitMarkerFileURI}),A.initialStartup?(V.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),X.push(...V),z.push(...this.backupMainService.getEmptyWindowBackupPaths())):z.length=0;const{windows:se,filesOpenedInWindow:ie}=this.doOpen(A,X,$,z,te,Z,O);if(this.logService.trace(`windowsManager#open used window count ${se.length} (workspacesToOpen: ${X.length}, foldersToOpen: ${$.length}, emptyToRestore: ${z.length}, emptyToOpen: ${te})`),se.length>1)if(ie)ie.focus();else{const ue=this.windowsStateHandler.state.lastActiveWindow&&!A.forceEmpty&&!A.cli._.length&&!A.cli["file-uri"]&&!A.cli["folder-uri"]&&!(A.urisToOpen&&A.urisToOpen.length);let de=!0,ve=!0;if(ue){const Pe=se.filter(pe=>this.windowsStateHandler.state.lastActiveWindow&&pe.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);Pe.length&&(Pe[0].focus(),de=!1,ve=!1)}if(de)for(let Pe=se.length-1;Pe>=0;Pe--){const pe=se[Pe];if(!(pe.openedWorkspace&&V.some(ge=>pe.openedWorkspace&&ge.workspace.id===pe.openedWorkspace.id)||pe.backupPath&&z.some(ge=>pe.backupPath&&ge.backupFolder===(0,p.basename)(pe.backupPath)))){pe.focus(),ve=!1;break}}ve&&se[se.length-1].focus()}const ae=Z&&Z.filesToDiff.length>0;if(!se.some(ue=>ue.isExtensionDevelopmentHost)&&!ae&&!A.noRecentEntry){const ue=[];for(const de of ce)N(de)&&!de.transient?ue.push({label:de.label,workspace:de.workspace,remoteAuthority:de.remoteAuthority}):_(de)?ue.push({label:de.label,folderUri:de.workspace.uri,remoteAuthority:de.remoteAuthority}):de.fileUri&&ue.push({label:de.label,fileUri:de.fileUri,remoteAuthority:de.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(ue)}return this.handleWaitMarkerFile(A,se),se}handleWaitMarkerFile(A,O){const $=A.waitMarkerFileURI;A.context===0&&$&&O.length===1&&O[0]&&(async()=>{await O[0].whenClosedOrLoaded;try{await this.fileService.del($)}catch(X){}})()}doOpen(A,O,$,X,V,z,Z){const te=[];let ce;function se(pe,ge){te.push(pe),ge&&(ce=pe,z=void 0)}let{openFolderInNewWindow:ie,openFilesInNewWindow:ae}=this.shouldOpenNewWindow(A);if(!A.initialStartup&&Z.length>0){const pe=Z[0].remoteAuthority,ge=this.getLastActiveWindowForAuthority(pe);ge&&se(this.doAddFoldersToExistingWindow(ge,Z.map(be=>be.workspace.uri)))}const ue=$.length+O.length+X.length;if(z&&ue===0){const pe=z.filesToOpenOrCreate[0]||z.filesToDiff[0],ge=this.getWindows().filter(ke=>z&&(0,S.isEqualAuthority)(ke.remoteAuthority,z.remoteAuthority));let be;pe?.fileUri&&!ae&&((A.context===4||A.context===0||A.context===1)&&(be=(0,oe.findWindowOnFile)(ge,pe.fileUri,ke=>ke.configPath.scheme===m.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(ke.configPath):void 0)),be||(be=this.doGetLastActiveWindow(ge))),be?(0,T.isWorkspaceIdentifier)(be.openedWorkspace)?O.push({workspace:be.openedWorkspace,remoteAuthority:be.remoteAuthority}):(0,T.isSingleFolderWorkspaceIdentifier)(be.openedWorkspace)?$.push({workspace:be.openedWorkspace,remoteAuthority:be.remoteAuthority}):se(this.doOpenFilesInExistingWindow(A,be,z),!0):se(this.openInBrowserWindow({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,filesToOpen:z,forceNewWindow:!0,remoteAuthority:z.remoteAuthority,forceNewTabbedWindow:A.forceNewTabbedWindow}),!0)}const de=(0,C.distinct)(O,pe=>pe.workspace.id);if(de.length>0){const pe=(0,C.coalesce)(de.map(ge=>(0,oe.findWindowOnWorkspaceOrFolder)(this.getWindows(),ge.workspace.configPath)));if(pe.length>0){const ge=pe[0],be=(0,S.isEqualAuthority)(z?.remoteAuthority,ge.remoteAuthority)?z:void 0;se(this.doOpenFilesInExistingWindow(A,ge,be),!!be),ie=!0}de.forEach(ge=>{if(pe.some(Ae=>Ae.openedWorkspace&&Ae.openedWorkspace.id===ge.workspace.id))return;const be=ge.remoteAuthority,ke=(0,S.isEqualAuthority)(z?.remoteAuthority,be)?z:void 0;se(this.doOpenFolderOrWorkspace(A,ge,ie,ke),!!ke),ie=!0})}const ve=(0,C.distinct)($,pe=>S.extUriBiasedIgnorePathCase.getComparisonKey(pe.workspace.uri));if(ve.length>0){const pe=(0,C.coalesce)(ve.map(ge=>(0,oe.findWindowOnWorkspaceOrFolder)(this.getWindows(),ge.workspace.uri)));if(pe.length>0){const ge=pe[0],be=(0,S.isEqualAuthority)(z?.remoteAuthority,ge.remoteAuthority)?z:void 0;se(this.doOpenFilesInExistingWindow(A,ge,be),!!be),ie=!0}ve.forEach(ge=>{if(pe.some(Ae=>(0,T.isSingleFolderWorkspaceIdentifier)(Ae.openedWorkspace)&&S.extUriBiasedIgnorePathCase.isEqual(Ae.openedWorkspace.uri,ge.workspace.uri)))return;const be=ge.remoteAuthority,ke=(0,S.isEqualAuthority)(z?.remoteAuthority,be)?z:void 0;se(this.doOpenFolderOrWorkspace(A,ge,ie,ke),!!ke),ie=!0})}const Pe=(0,C.distinct)(X,pe=>pe.backupFolder);if(Pe.length>0&&Pe.forEach(pe=>{const ge=pe.remoteAuthority,be=(0,S.isEqualAuthority)(z?.remoteAuthority,ge)?z:void 0;se(this.openInBrowserWindow({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,filesToOpen:be,remoteAuthority:ge,forceNewWindow:!0,forceNewTabbedWindow:A.forceNewTabbedWindow,emptyWindowBackupInfo:pe}),!!be),ie=!0}),te.length===0||z){z&&!V&&V++;const pe=z?z.remoteAuthority:A.remoteAuthority;for(let ge=0;ge<V;ge++)se(this.doOpenEmpty(A,ie,pe,z),!!z),ie=!0}return{windows:(0,C.distinct)(te),filesOpenedInWindow:ce}}doOpenFilesInExistingWindow(A,O,$){this.logService.trace("windowsManager#doOpenFilesInExistingWindow"),O.focus();const X={filesToOpenOrCreate:$?.filesToOpenOrCreate,filesToDiff:$?.filesToDiff,filesToWait:$?.filesToWait,termProgram:A?.userEnv?.TERM_PROGRAM};return O.sendWhenReady("vscode:openFiles",n.CancellationToken.None,X),O}doAddFoldersToExistingWindow(A,O){this.logService.trace("windowsManager#doAddFoldersToExistingWindow"),A.focus();const $={foldersToAdd:O};return A.sendWhenReady("vscode:addFolders",n.CancellationToken.None,$),A}doOpenEmpty(A,O,$,X,V){return!O&&!V&&typeof A.contextWindowId=="number"&&(V=this.getWindowById(A.contextWindowId)),this.openInBrowserWindow({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:$,forceNewWindow:O,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:X,windowToUse:V})}doOpenFolderOrWorkspace(A,O,$,X,V){return!$&&!V&&typeof A.contextWindowId=="number"&&(V=this.getWindowById(A.contextWindowId)),this.openInBrowserWindow({workspace:O.workspace,userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:O.remoteAuthority,forceNewWindow:$,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:X,windowToUse:V})}getPathsToOpen(A){let O,$=!1,X=!1;if(A.urisToOpen&&A.urisToOpen.length>0?(O=this.doExtractPathsFromAPI(A),$=!0):A.forceEmpty?O=[Object.create(null)]:A.cli._.length||A.cli["folder-uri"]||A.cli["file-uri"]?(O=this.doExtractPathsFromCLI(A.cli),O.length===0&&O.push(Object.create(null)),$=!0):(O=this.doGetPathsFromLastSession(),O.length===0&&O.push(Object.create(null)),X=!0),!A.addMode&&$){const V=O.filter(z=>_(z));if(V.length>1){const z=V[0].remoteAuthority;if(V.every(Z=>(0,S.isEqualAuthority)(Z.remoteAuthority,z))){const Z=this.workspacesManagementMainService.createUntitledWorkspaceSync(V.map(te=>({uri:te.workspace.uri})));O.push({workspace:Z,remoteAuthority:z}),O=O.filter(te=>!_(te))}}}return A.initialStartup&&!X&&this.configurationService.getValue("window")?.restoreWindows==="preserve"&&O.unshift(...this.doGetPathsFromLastSession().filter(V=>N(V)||_(V)||V.backupPath)),O}doExtractPathsFromAPI(A){const O=[],$={gotoLineMode:A.gotoLineMode,remoteAuthority:A.remoteAuthority};for(const X of(0,C.coalesce)(A.urisToOpen||[])){const V=this.resolveOpenable(X,$);if(V)V.label=X.label,O.push(V);else{const z=this.resourceFromOpenable(X),Z={title:this.productService.nameLong,type:"info",buttons:[(0,y.mnemonicButtonLabel)((0,a.localize)(0,null))],defaultId:0,message:z.scheme===m.Schemas.file?(0,a.localize)(1,null):(0,a.localize)(2,null),detail:z.scheme===m.Schemas.file?(0,a.localize)(3,null,(0,y.getPathLabel)(z.fsPath,this.environmentMainService)):(0,a.localize)(4,null,z.toString()),noLink:!0};this.dialogMainService.showMessageBox(Z,(0,P.withNullAsUndefined)(v.BrowserWindow.getFocusedWindow()))}}return O}doExtractPathsFromCLI(A){const O=[],$={ignoreFileNotFound:!0,gotoLineMode:A.goto,remoteAuthority:A.remote||void 0,forceOpenWorkspaceAsFile:!1},X=A["folder-uri"];if(X)for(const Z of X){const te=this.cliArgToUri(Z);if(te){const ce=this.resolveOpenable({folderUri:te},$);ce&&O.push(ce)}}const V=A["file-uri"];if(V)for(const Z of V){const te=this.cliArgToUri(Z);if(te){const ce=this.resolveOpenable((0,T.hasWorkspaceFileExtension)(Z)?{workspaceUri:te}:{fileUri:te},$);ce&&O.push(ce)}}const z=A._;for(const Z of z){const te=$.remoteAuthority?this.doResolvePathRemote(Z,$):this.doResolveFilePath(Z,$);te&&O.push(te)}return O}cliArgToUri(A){try{const O=c.URI.parse(A);if(!O.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${A}`);return}return O}catch(O){this.logService.error(`Invalid URI input string: ${A}, ${O.message}`)}}doGetPathsFromLastSession(){const A=this.getRestoreWindowsSetting();switch(A){case"none":return[];case"one":case"all":case"preserve":case"folders":const O=[];A!=="one"&&O.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&O.push(this.windowsStateHandler.state.lastActiveWindow);const $=[];for(const X of O)if(X.workspace){const V=this.resolveOpenable({workspaceUri:X.workspace.configPath},{remoteAuthority:X.remoteAuthority,rejectTransientWorkspaces:!0});N(V)&&$.push(V)}else if(X.folderUri){const V=this.resolveOpenable({folderUri:X.folderUri},{remoteAuthority:X.remoteAuthority});_(V)&&$.push(V)}else A!=="folders"&&X.backupPath&&$.push({backupPath:X.backupPath,remoteAuthority:X.remoteAuthority});return $}}getRestoreWindowsSetting(){let A;return this.lifecycleMainService.wasRestarted?A="all":(A=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(A)||(A="all")),A}resolveOpenable(A,O=Object.create(null)){let $=this.resourceFromOpenable(A);return $.scheme===m.Schemas.file?((0,x.isFileToOpen)(A)&&(O={...O,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath($.fsPath,O)):this.doResolveRemoteOpenable(A,O)}doResolveRemoteOpenable(A,O){let $=this.resourceFromOpenable(A);const X=(0,W.getRemoteAuthority)($)||O.remoteAuthority;if($=(0,S.removeTrailingPathSeparator)((0,S.normalizePath)($)),(0,x.isFileToOpen)(A)){if(O.gotoLineMode){const{path:V,line:z,column:Z}=(0,d.parseLineAndColumnAware)($.path);return{fileUri:$.with({path:V}),selection:z?{startLineNumber:z,startColumn:Z||1}:void 0,remoteAuthority:X}}return{fileUri:$,remoteAuthority:X}}else if((0,x.isWorkspaceToOpen)(A))return{workspace:(0,B.getWorkspaceIdentifier)($),remoteAuthority:X};return{workspace:(0,B.getSingleFolderWorkspaceIdentifier)($),remoteAuthority:X}}resourceFromOpenable(A){return(0,x.isWorkspaceToOpen)(A)?A.workspaceUri:(0,x.isFolderToOpen)(A)?A.folderUri:A.fileUri}doResolveFilePath(A,O){let $,X;O.gotoLineMode&&({path:A,line:$,column:X}=(0,d.parseLineAndColumnAware)(A)),A=(0,d.sanitizeFilePath)((0,p.normalize)(A),(0,b.cwd)());try{const V=(0,D.statSync)(A);if(V.isFile()){if(!O.forceOpenWorkspaceAsFile){const z=this.workspacesManagementMainService.resolveLocalWorkspaceSync(c.URI.file(A));if(z)return z.transient&&O.rejectTransientWorkspaces?void 0:{workspace:{id:z.id,configPath:z.configPath},type:i.FileType.File,exists:!0,remoteAuthority:z.remoteAuthority,transient:z.transient}}return{fileUri:c.URI.file(A),type:i.FileType.File,exists:!0,selection:$?{startLineNumber:$,startColumn:X||1}:void 0}}else{if(V.isDirectory())return{workspace:(0,B.getSingleFolderWorkspaceIdentifier)(c.URI.file(A),V),type:i.FileType.Directory,exists:!0};if(!w.isWindows&&A==="/dev/null")return{fileUri:c.URI.file(A),type:i.FileType.File,exists:!0}}}catch(V){const z=c.URI.file(A);if(this.workspacesHistoryMainService.removeRecentlyOpened([z]),O.ignoreFileNotFound)return{fileUri:z,type:i.FileType.File,exists:!1}}}doResolvePathRemote(A,O){const $=A.charCodeAt(0),X=O.remoteAuthority;let V,z;O.gotoLineMode&&({path:A,line:V,column:z}=(0,d.parseLineAndColumnAware)(A)),$!==47&&((0,d.isWindowsDriveLetter)($)&&A.charCodeAt(A.charCodeAt(1))===58&&(A=(0,d.toSlashes)(A)),A=`/${A}`);const Z=c.URI.from({scheme:m.Schemas.vscodeRemote,authority:X,path:A});if(A.charCodeAt(A.length-1)!==47){if((0,T.hasWorkspaceFileExtension)(A))return O.forceOpenWorkspaceAsFile?{fileUri:Z,selection:V?{startLineNumber:V,startColumn:z||1}:void 0,remoteAuthority:O.remoteAuthority}:{workspace:(0,B.getWorkspaceIdentifier)(Z),remoteAuthority:X};if(O.gotoLineMode||p.posix.basename(A).indexOf(".")!==-1)return{fileUri:Z,selection:V?{startLineNumber:V,startColumn:z||1}:void 0,remoteAuthority:X}}return{workspace:(0,B.getSingleFolderWorkspaceIdentifier)(Z),remoteAuthority:X}}shouldOpenNewWindow(A){const O=this.configurationService.getValue("window"),$=O?.openFoldersInNewWindow||"default",X=O?.openFilesInNewWindow||"off";let V=(A.preferNewWindow||A.forceNewWindow)&&!A.forceReuseWindow;!A.forceNewWindow&&!A.forceReuseWindow&&($==="on"||$==="off")&&(V=$==="on");let z=!1;return A.forceNewWindow||A.forceReuseWindow?z=!!A.forceNewWindow&&!A.forceReuseWindow:(w.isMacintosh?A.context===1&&(z=!0):A.context!==3&&A.context!==2&&!(A.userEnv&&A.userEnv.TERM_PROGRAM==="vscode")&&(z=!0),!A.cli.extensionDevelopmentPath&&(X==="on"||X==="off")&&(z=X==="on")),{openFolderInNewWindow:!!V,openFilesInNewWindow:z}}openExtensionDevelopmentHostWindow(A,O){const $=(0,oe.findWindowOnExtensionDevelopmentPath)(this.getWindows(),A);if($)return this.lifecycleMainService.reload($,O.cli),$.focus(),[$];let X=O.cli["folder-uri"]||[],V=O.cli["file-uri"]||[],z=O.cli._;if(!z.length&&!X.length&&!V.length&&!O.cli.extensionTestsPath){const se=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,ie=se&&(se.workspace||se.folderUri);ie&&(c.URI.isUri(ie)?ie.scheme===m.Schemas.file?z=[ie.fsPath]:X=[ie.toString()]:ie.configPath.scheme===m.Schemas.file?z=[(0,S.originalFSPath)(ie.configPath)]:V=[ie.configPath.toString()])}let Z=O.remoteAuthority;for(const se of A)if(se.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ie=c.URI.parse(se),ae=(0,W.getRemoteAuthority)(ie);ae&&(Z?ae!==Z&&this.logService.error("more than one extension development path authority"):Z=ae)}z=z.filter(se=>{const ie=c.URI.file(se);return(0,oe.findWindowOnWorkspaceOrFolder)(this.getWindows(),ie)?!1:(0,S.isEqualAuthority)((0,W.getRemoteAuthority)(ie),Z)}),X=X.filter(se=>{const ie=this.cliArgToUri(se);return ie&&!!(0,oe.findWindowOnWorkspaceOrFolder)(this.getWindows(),ie)?!1:ie?(0,S.isEqualAuthority)((0,W.getRemoteAuthority)(ie),Z):!1}),V=V.filter(se=>{const ie=this.cliArgToUri(se);return ie&&!!(0,oe.findWindowOnWorkspaceOrFolder)(this.getWindows(),ie)?!1:ie?(0,S.isEqualAuthority)((0,W.getRemoteAuthority)(ie),Z):!1}),O.cli._=z,O.cli["folder-uri"]=X,O.cli["file-uri"]=V;const te=!z.length&&!X.length&&!V.length,ce={context:O.context,cli:O.cli,forceNewWindow:!0,forceEmpty:te,userEnv:O.userEnv,noRecentEntry:!0,waitMarkerFileURI:O.waitMarkerFileURI,remoteAuthority:Z};return this.open(ce)}openInBrowserWindow(A){const O=this.configurationService.getValue("window"),$={...this.environmentMainService.args,...A.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:A.emptyWindowBackupInfo?(0,p.join)(this.environmentMainService.backupHome,A.emptyWindowBackupInfo.backupFolder):void 0,homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:A.remoteAuthority,workspace:A.workspace,userEnv:{...this.initialUserEnv,...A.userEnv},filesToOpenOrCreate:A.filesToOpen?.filesToOpenOrCreate,filesToDiff:A.filesToOpen?.filesToDiff,filesToWait:A.filesToOpen?.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:k.default,isInitialStartup:A.initialStartup,perfMarks:(0,t.getMarks)(),os:{release:(0,M.release)(),hostname:(0,M.hostname)()},zoomLevel:typeof O?.zoomLevel=="number"?O.zoomLevel:void 0,legacyWatcher:this.configurationService.getValue("files.legacyWatcher"),experimentalSandboxedFileService:this.configurationService.getValue("files.experimentalSandboxedFileService"),autoDetectHighContrast:O?.autoDetectHighContrast??!0,accessibilitySupport:v.app.accessibilitySupportEnabled,colorScheme:{dark:v.nativeTheme.shouldUseDarkColors,highContrast:v.nativeTheme.shouldUseInvertedColorScheme||v.nativeTheme.shouldUseHighContrastColors}};let X;if(!A.forceNewWindow&&!A.forceNewTabbedWindow&&(X=A.windowToUse||this.getLastActiveWindow(),X&&X.focus()),X){const V=X.config;!$.extensionDevelopmentPath&&V&&!!V.extensionDevelopmentPath&&($.extensionDevelopmentPath=V.extensionDevelopmentPath,$.verbose=V.verbose,$["inspect-brk-extensions"]=V["inspect-brk-extensions"],$.debugId=V.debugId,$.extensionEnvironment=V.extensionEnvironment,$["inspect-extensions"]=V["inspect-extensions"],$["extensions-dir"]=V["extensions-dir"])}else{const V=this.windowsStateHandler.getNewWindowState($);(0,t.mark)("code/willCreateCodeWindow");const z=X=this.instantiationService.createInstance(ne.CodeWindow,{state:V,extensionDevelopmentPath:$.extensionDevelopmentPath,isExtensionTestHost:!!$.extensionTestsPath});if((0,t.mark)("code/didCreateCodeWindow"),A.forceNewTabbedWindow){const te=this.getLastActiveWindow();te&&te.addTabbedWindow(z)}xe.WINDOWS.push(z),this._onDidOpenWindow.fire(z),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,f.once)(z.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(z)),(0,f.once)(z.onDidClose)(()=>this.onWindowClosed(z)),(0,f.once)(z.onDidDestroy)(()=>this._onDidDestroyWindow.fire(z));const Z=(0,P.assertIsDefined)(z.win?.webContents);Z.removeAllListeners("devtools-reload-page"),Z.on("devtools-reload-page",()=>this.lifecycleMainService.reload(z)),this.lifecycleMainService.registerWindow(z)}return $.windowId=X.id,X.isReady?this.lifecycleMainService.unload(X,4).then(V=>{V||this.doOpenInBrowserWindow(X,$,A)}):this.doOpenInBrowserWindow(X,$,A),X}doOpenInBrowserWindow(A,O,$){if(!O.extensionDevelopmentPath)if((0,T.isWorkspaceIdentifier)(O.workspace))O.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:O.workspace,remoteAuthority:O.remoteAuthority});else if((0,T.isSingleFolderWorkspaceIdentifier)(O.workspace))O.backupPath=this.backupMainService.registerFolderBackupSync(O.workspace.uri);else{const X=$.emptyWindowBackupInfo&&$.emptyWindowBackupInfo.backupFolder;O.backupPath=this.backupMainService.registerEmptyWindowBackupSync(X,O.remoteAuthority)}A.load(O)}onWindowClosed(A){const O=xe.WINDOWS.indexOf(A);xe.WINDOWS.splice(O,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const A=v.BrowserWindow.getFocusedWindow();if(A)return this.getWindowById(A.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(A){return this.doGetLastActiveWindow(this.getWindows().filter(O=>(0,S.isEqualAuthority)(O.remoteAuthority,A)))}doGetLastActiveWindow(A){const O=Math.max.apply(Math,A.map($=>$.lastFocusTime));return A.find($=>$.lastFocusTime===O)}sendToFocused(A,...O){const $=this.getFocusedWindow()||this.getLastActiveWindow();$&&$.sendWhenReady(A,n.CancellationToken.None,...O)}sendToAll(A,O,$){for(const X of this.getWindows())$&&$.indexOf(X.id)>=0||X.sendWhenReady(A,n.CancellationToken.None,O)}getWindows(){return xe.WINDOWS}getWindowCount(){return xe.WINDOWS.length}getWindowById(A){const O=this.getWindows().filter($=>$.id===A);return(0,C.firstOrDefault)(O)}getWindowByWebContents(A){const O=v.BrowserWindow.fromWebContents(A);if(!!O)return this.getWindowById(O.id)}};Y.WINDOWS=[],Y=he([ee(2,g.ILogService),ee(3,j.IStateMainService),ee(4,r.IEnvironmentMainService),ee(5,h.ILifecycleMainService),ee(6,l.IBackupMainService),ee(7,s.IConfigurationService),ee(8,q.IWorkspacesHistoryMainService),ee(9,U.IWorkspacesManagementMainService),ee(10,o.IInstantiationService),ee(11,u.IDialogMainService),ee(12,i.IFileService),ee(13,L.IProductService),ee(14,R.IProtocolMainService)],Y),e.WindowsMainService=Y}),define(Q[243],J([0,1,51,36,68,45]),function(H,e,v,D,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let n=class{constructor(d,f,y,E){this.workspacesManagementMainService=d,this.windowsMainService=f,this.workspacesHistoryMainService=y,this.backupMainService=E,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(d,f){const y=this.windowsMainService.getWindowById(d);if(y)return this.workspacesManagementMainService.enterWorkspace(y,this.windowsMainService.getWindows(),f)}createUntitledWorkspace(d,f,y){return this.workspacesManagementMainService.createUntitledWorkspace(f,y)}deleteUntitledWorkspace(d,f){return this.workspacesManagementMainService.deleteUntitledWorkspace(f)}getWorkspaceIdentifier(d,f){return this.workspacesManagementMainService.getWorkspaceIdentifier(f)}async getRecentlyOpened(d){return this.workspacesHistoryMainService.getRecentlyOpened(this.windowsMainService.getWindowById(d))}async addRecentlyOpened(d,f){return this.workspacesHistoryMainService.addRecentlyOpened(f)}async removeRecentlyOpened(d,f){return this.workspacesHistoryMainService.removeRecentlyOpened(f)}async clearRecentlyOpened(d){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};n=he([ee(0,C.IWorkspacesManagementMainService),ee(1,D.IWindowsMainService),ee(2,M.IWorkspacesHistoryMainService),ee(3,v.IBackupMainService)],n),e.WorkspacesMainService=n}),define(Q[244],J([0,1,14,28,26,17,44,16,33,42,39,34,2,10,8,3,15,13,7,31,71,122,35,125,85,235,134,51,226,19,180,162,74,52,225,89,24,54,91,170,188,171,222,90,172,18,183,94,73,5,75,236,201,103,20,6,185,241,53,22,64,231,76,38,219,100,202,29,204,206,65,41,210,233,237,234,238,99,211,212,213,214,216,36,242,217,27,68,243,45]),function(H,e,v,D,M,C,n,I,d,f,y,E,m,p,t,w,b,S,P,c,a,l,s,u,r,i,o,h,g,k,L,R,W,j,x,ne,oe,G,T,B,q,U,N,_,Y,F,A,O,$,X,V,z,Z,te,ce,se,ie,ae,ue,de,ve,Pe,pe,ge,be,ke,Ae,We,Fe,et,Ge,He,Xe,at,tt,K,re,le,we,Ee,De,Oe,_e,Ne,Be,Ve,it,yt,kt,St){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let ft=class extends m.Disposable{constructor(fe,ye,Se,me,Ie,Me,Ce,Le,Re,je){super();this.mainProcessNodeIpcServer=fe,this.userEnv=ye,this.mainInstantiationService=Se,this.logService=me,this.environmentMainService=Ie,this.lifecycleMainService=Me,this.configurationService=Ce,this.stateMainService=Le,this.fileService=Re,this.productService=je,this.configureSession(),this.registerListeners()}configureSession(){const fe=me=>me?.startsWith(`${p.Schemas.vscodeWebview}://`),ye=new Set(["clipboard-read","clipboard-sanitized-write"]);v.session.defaultSession.setPermissionRequestHandler((me,Ie,Me,Ce)=>fe(Ce.requestingUrl)?Me(ye.has(Ie)):Me(!1)),v.session.defaultSession.setPermissionCheckHandler((me,Ie,Me,Ce)=>fe(Ce.requestingUrl)?ye.has(Ie):!1);const Se=v.session.defaultSession;typeof Se.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&Se.setCodeCachePath((0,t.join)(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){(0,I.setUnexpectedErrorHandler)(Se=>this.onUnexpectedError(Se)),process.on("uncaughtException",Se=>(0,I.onUnexpectedError)(Se)),process.on("unhandledRejection",Se=>(0,I.onUnexpectedError)(Se)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,l.registerContextMenuListener)(),v.app.on("accessibility-support-changed",(Se,me)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",me)}),v.app.on("activate",(Se,me)=>{this.logService.trace("app#activate"),me||this.windowsMainService?.openEmptyWindow({context:1})}),v.app.on("web-contents-created",(Se,me)=>{me.on("will-navigate",Ie=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Ie.preventDefault()}),me.setWindowOpenHandler(({url:Ie})=>(this.nativeHostMainService?.openExternal(void 0,Ie),{action:"deny"}))});let fe=[],ye;v.app.on("open-file",(Se,me)=>{this.logService.trace("app#open-file: ",me),Se.preventDefault(),fe.push(this.getWindowOpenableFromPathSync(me)),ye!==void 0&&(clearTimeout(ye),ye=void 0),ye=setTimeout(()=>{this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:fe,gotoLineMode:!1,preferNewWindow:!0}),fe=[],ye=void 0},100)}),v.app.on("new-window-for-tab",()=>{this.windowsMainService?.openEmptyWindow({context:4})}),v.ipcMain.handle("vscode:fetchShellEnv",Se=>{const me=this.windowsMainService?.getWindowByWebContents(Se.sender);let Ie,Me;return me?.config?(Ie=me.config,Me={...process.env,...me.config.userEnv}):(Ie=this.environmentMainService.args,Me=process.env),this.resolveShellEnvironment(Ie,Me,!1)}),v.ipcMain.handle("vscode:writeNlsFile",(Se,me,Ie)=>{const Me=this.validateNlsPath([me]);if(!Me||typeof Ie!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(Me,C.VSBuffer.fromString(Ie))}),v.ipcMain.handle("vscode:readNlsFile",async(Se,...me)=>{const Ie=this.validateNlsPath(me);if(!Ie)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Ie)).value.toString()}),v.ipcMain.on("vscode:toggleDevTools",Se=>Se.sender.toggleDevTools()),v.ipcMain.on("vscode:openDevTools",Se=>Se.sender.openDevTools()),v.ipcMain.on("vscode:reloadWindow",Se=>Se.sender.reload())}validateNlsPath(fe){let ye;for(const Se of fe)typeof Se=="string"&&(typeof ye!="string"?ye=Se:ye=(0,t.join)(ye,Se));if(!(typeof ye!="string"||!(0,t.isAbsolute)(ye)||!(0,d.isEqualOrParent)(ye,this.environmentMainService.cachedLanguagesPath,!w.isLinux)))return P.URI.file(ye)}onUnexpectedError(fe){if(fe){const ye={message:`[uncaught exception in main]: ${fe.message}`,stack:fe.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(ye))}this.logService.error(`[uncaught exception in main]: ${fe}`),fe.stack&&this.logService.error(fe.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const fe=this.productService.win32AppUserModelId;w.isWindows&&fe&&v.app.setAppUserModelId(fe);try{w.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!v.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&v.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Re){this.logService.error(Re)}const ye=new u.Server;this.logService.trace("Resolving machine identifier...");const Se=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${Se}`);const{sharedProcess:me,sharedProcessReady:Ie,sharedProcessClient:Me}=this.setupSharedProcess(Se),Ce=await this.initServices(Se,me,Ie);if(this.environmentMainService.driverHandle){const Re=await(0,x.serve)(ye,this.environmentMainService.driverHandle,this.environmentMainService,Ce);this.logService.info("Driver started at:",this.environmentMainService.driverHandle),this._register(Re)}this._register(Ce.createInstance(i.ProxyAuthHandler)),Ce.invokeFunction(Re=>this.initChannels(Re,ye,Me));const Le=Ce.invokeFunction(Re=>this.openFirstWindow(Re,ye));Ce.invokeFunction(Re=>this.afterWindowOpen(Re,me)),this.environmentMainService.args.trace&&Ce.invokeFunction(Re=>this.stopTracingEventually(Re,Le))}async resolveMachineId(){let fe=this.stateMainService.getItem(We.machineIdKey);return(!fe||w.isMacintosh&&fe==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(fe=await(0,a.getMachineId)(),this.stateMainService.setItem(We.machineIdKey,fe)),fe}setupSharedProcess(fe){const ye=this._register(this.mainInstantiationService.createInstance(Pe.SharedProcess,fe,this.userEnv)),Se=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Ie=await ye.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new r.Client(Ie,"main")})(),me=(async()=>(await ye.whenReady(),Se))();return{sharedProcess:ye,sharedProcessReady:me,sharedProcessClient:Se}}async initServices(fe,ye,Se){const me=new V.ServiceCollection;switch(process.platform){case"win32":me.set(He.IUpdateService,new $.SyncDescriptor(re.Win32UpdateService));break;case"linux":w.isLinuxSnap?me.set(He.IUpdateService,new $.SyncDescriptor(K.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):me.set(He.IUpdateService,new $.SyncDescriptor(tt.LinuxUpdateService));break;case"darwin":me.set(He.IUpdateService,new $.SyncDescriptor(at.DarwinUpdateService));break}me.set(Ne.IWindowsMainService,new $.SyncDescriptor(Be.WindowsMainService,[fe,this.userEnv])),me.set(j.IDialogMainService,new $.SyncDescriptor(j.DialogMainService)),me.set(te.ILaunchMainService,new $.SyncDescriptor(te.LaunchMainService)),me.set(W.IDiagnosticsService,s.ProxyChannel.toService((0,s.getDelayedChannel)(Se.then(Me=>Me.getChannel("diagnostics"))))),me.set(z.IIssueMainService,new $.SyncDescriptor(z.IssueMainService,[this.userEnv])),me.set(ne.IEncryptionMainService,new $.SyncDescriptor(ne.EncryptionMainService,[fe])),me.set(Z.IKeyboardLayoutMainService,new $.SyncDescriptor(Z.KeyboardLayoutMainService)),me.set(ue.INativeHostMainService,new $.SyncDescriptor(ue.NativeHostMainService,[ye])),me.set(Oe.IWebviewManagerService,new $.SyncDescriptor(_e.WebviewMainService)),me.set(it.IWorkspacesService,new $.SyncDescriptor(kt.WorkspacesMainService)),me.set(St.IWorkspacesManagementMainService,new $.SyncDescriptor(St.WorkspacesManagementMainService)),me.set(yt.IWorkspacesHistoryMainService,new $.SyncDescriptor(yt.WorkspacesHistoryMainService)),me.set(ae.IMenubarMainService,new $.SyncDescriptor(ae.MenubarMainService)),me.set(B.IExtensionUrlTrustService,new $.SyncDescriptor(q.ExtensionUrlTrustService)),me.set(U.IExtensionHostStarter,new $.SyncDescriptor(N.WorkerMainProcessExtensionHostStarter)),me.set(ke.IStorageMainService,new $.SyncDescriptor(ke.StorageMainService)),w.isWindows?me.set(_.IExternalTerminalMainService,new $.SyncDescriptor(Y.WindowsExternalTerminalService)):w.isMacintosh?me.set(_.IExternalTerminalMainService,new $.SyncDescriptor(Y.MacExternalTerminalService)):w.isLinux&&me.set(_.IExternalTerminalMainService,new $.SyncDescriptor(Y.LinuxExternalTerminalService));const Ie=new g.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(me.set(h.IBackupMainService,Ie),me.set(le.IURLService,new $.SyncDescriptor(Ee.NativeURLService)),(0,Ge.supportsTelemetry)(this.productService,this.environmentMainService)){const Me=(0,s.getDelayedChannel)(Se.then(Ye=>Ye.getChannel("telemetryAppender"))),Ce=new Fe.TelemetryAppenderClient(Me),Le=(0,Ae.resolveCommonProperties)(this.fileService,(0,M.release)(),(0,M.hostname)(),process.arch,this.productService.commit,this.productService.version,fe,this.productService.msftInternalDomains,this.environmentMainService.installSourcePath),Re=[this.environmentMainService.appRoot,this.environmentMainService.extensionsPath],je={appenders:[Ce],commonProperties:Le,piiPaths:Re,sendErrorTelemetry:!0};me.set(We.ITelemetryService,new $.SyncDescriptor(et.TelemetryService,[je]))}else me.set(We.ITelemetryService,Ge.NullTelemetryService);return await Ie.initialize(),this.mainInstantiationService.createChild(me)}initChannels(fe,ye,Se){const me=s.ProxyChannel.fromService(fe.get(te.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",me);const Ie=this.fileService.getProvider(p.Schemas.file);(0,S.assertType)(Ie instanceof O.DiskFileSystemProvider);const Me=new A.DiskFileSystemProviderChannel(Ie,this.logService);ye.registerChannel("localFilesystem",Me);const Ce=new L.UserConfigurationFileService(this.environmentMainService,this.fileService,this.logService);ye.registerChannel(L.UserConfigurationFileServiceId,s.ProxyChannel.fromService(Ce)),Se.then(ze=>ze.registerChannel(L.UserConfigurationFileServiceId,s.ProxyChannel.fromService(Ce)));const Le=new Xe.UpdateChannel(fe.get(He.IUpdateService));ye.registerChannel("update",Le);const Re=s.ProxyChannel.fromService(fe.get(z.IIssueMainService));ye.registerChannel("issue",Re);const je=s.ProxyChannel.fromService(fe.get(ne.IEncryptionMainService));ye.registerChannel("encryption",je);const Ye=s.ProxyChannel.fromService(fe.get(pe.ISignService));ye.registerChannel("sign",Ye);const nt=s.ProxyChannel.fromService(fe.get(Z.IKeyboardLayoutMainService));ye.registerChannel("keyboardLayout",nt),this.nativeHostMainService=fe.get(ue.INativeHostMainService);const Qe=s.ProxyChannel.fromService(this.nativeHostMainService);ye.registerChannel("nativeHost",Qe),Se.then(ze=>ze.registerChannel("nativeHost",Qe));const gt=s.ProxyChannel.fromService(fe.get(it.IWorkspacesService));ye.registerChannel("workspaces",gt);const Ue=s.ProxyChannel.fromService(fe.get(ae.IMenubarMainService));ye.registerChannel("menubar",Ue);const ct=s.ProxyChannel.fromService(fe.get(le.IURLService));ye.registerChannel("url",ct);const rt=s.ProxyChannel.fromService(fe.get(B.IExtensionUrlTrustService));ye.registerChannel("extensionUrlTrust",rt);const st=s.ProxyChannel.fromService(fe.get(Oe.IWebviewManagerService));ye.registerChannel("webview",st);const ot=this._register(new be.StorageDatabaseChannel(this.logService,fe.get(ke.IStorageMainService)));ye.registerChannel("storage",ot),Se.then(ze=>ze.registerChannel("storage",ot));const lt=s.ProxyChannel.fromService(fe.get(_.IExternalTerminalMainService));ye.registerChannel("externalTerminal",lt);const Je=new ie.LogLevelChannel(fe.get(se.ILogService));ye.registerChannel("logLevel",Je),Se.then(ze=>ze.registerChannel("logLevel",Je));const Ze=new ie.LoggerChannel(fe.get(se.ILoggerService));ye.registerChannel("logger",Ze),Se.then(ze=>ze.registerChannel("logger",Ze));const ut=new R.ElectronExtensionHostDebugBroadcastChannel(fe.get(Ne.IWindowsMainService));ye.registerChannel("extensionhostdebugservice",ut);const Te=s.ProxyChannel.fromService(fe.get(U.IExtensionHostStarter));ye.registerChannel(U.ipcExtensionHostStarterChannelName,Te)}openFirstWindow(fe,ye){const Se=this.windowsMainService=fe.get(Ne.IWindowsMainService),me=fe.get(le.IURLService),Ie=fe.get(ue.INativeHostMainService);this.lifecycleMainService.phase=2;const Me=[],Ce=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(Te=>{try{return{uri:P.URI.parse(Te),url:Te}}catch{return}}).filter(Te=>{if(!Te||this.shouldBlockURI(Te.uri))return!1;const ze=this.getWindowOpenableFromProtocolLink(Te.uri);return ze?(Me.push(ze),!1):!0}),Le=this,Re=this.environmentMainService,je=this.productService;me.registerHandler({async handleURL(Te,ze){if(Te.scheme===je.urlProtocol&&Te.path==="workspace"&&(Te=Te.with({authority:"file",path:P.URI.parse(Te.query).path,query:""})),Le.shouldBlockURI(Te))return!0;const bt=Le.getWindowOpenableFromProtocolLink(Te);if(bt){const[mt]=Se.open({context:5,cli:{...Re.args},urisToOpen:[bt],gotoLineMode:!0});return mt.focus(),!0}if(w.isMacintosh&&Se.getWindowCount()===0){const[mt]=Se.open({context:5,cli:{...Re.args},forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,ve.getRemoteAuthority)(Te)});return await mt.ready(),me.open(Te,ze)}return!1}});const Ye=this._register(new Ve.ActiveWindowManager({onDidOpenWindow:Ie.onDidOpenWindow,onDidFocusWindow:Ie.onDidFocusWindow,getActiveWindowId:()=>Ie.getActiveWindowId(-1)})),nt=new s.StaticRouter(Te=>Ye.getActiveClientId().then(ze=>Te===ze)),Qe=new we.URLHandlerRouter(nt),gt=ye.getChannel("urlHandler",Qe);me.registerHandler(new we.URLHandlerChannelClient(gt)),this._register(new De.ElectronURLListener(Ce,me,Se,this.environmentMainService,this.productService));const Ue=this.environmentMainService.args,ct=global.macOpenFiles,rt=(0,G.isLaunchedFromCli)(process.env)?0:4,st=Ue._.length,ot=!!Ue["folder-uri"],lt=!!Ue["file-uri"],Je=Ue["skip-add-to-recently-opened"]===!0,Ze=Ue.wait&&Ue.waitMarkerFilePath?P.URI.file(Ue.waitMarkerFilePath):void 0,ut=Ue.remote||void 0;return Me.length>0?Se.open({context:rt,cli:Ue,urisToOpen:Me,gotoLineMode:!0,initialStartup:!0}):Ue["new-window"]&&!st&&!ot&&!lt?Se.open({context:rt,cli:Ue,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Je,waitMarkerFileURI:Ze,initialStartup:!0,remoteAuthority:ut}):ct.length&&!st&&!ot&&!lt?Se.open({context:1,cli:Ue,urisToOpen:ct.map(Te=>this.getWindowOpenableFromPathSync(Te)),noRecentEntry:Je,waitMarkerFileURI:Ze,initialStartup:!0}):Se.open({context:rt,cli:Ue,forceNewWindow:Ue["new-window"]||!st&&Ue["unity-launch"],diffMode:Ue.diff,noRecentEntry:Je,waitMarkerFileURI:Ze,gotoLineMode:Ue.goto,initialStartup:!0,remoteAuthority:ut})}shouldBlockURI(fe){return!!(fe.authority===p.Schemas.file&&w.isWindows&&v.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,E.mnemonicButtonLabel)((0,o.localize)(0,null)),(0,E.mnemonicButtonLabel)((0,o.localize)(1,null))],defaultId:0,cancelId:1,message:(0,o.localize)(2,null,(0,E.getPathLabel)(fe.fsPath,this.environmentMainService),this.productService.nameShort),detail:(0,o.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(fe){if(!!fe.path){if(fe.authority===p.Schemas.file){const ye=P.URI.file(fe.fsPath);return(0,it.hasWorkspaceFileExtension)(ye)?{workspaceUri:ye}:{fileUri:ye}}else if(fe.authority===p.Schemas.vscodeRemote){const ye=fe.path.indexOf(t.posix.sep,1);if(ye!==-1){const Se=fe.path.substring(1,ye),me=fe.path.substring(ye),Ie=P.URI.from({scheme:p.Schemas.vscodeRemote,authority:Se,path:me,query:fe.query,fragment:fe.fragment});return(0,it.hasWorkspaceFileExtension)(me)?{workspaceUri:Ie}:/:[\d]+$/.test(me)?{fileUri:Ie}:{folderUri:Ie}}}}}getWindowOpenableFromPathSync(fe){try{if((0,D.statSync)(fe).isDirectory())return{folderUri:P.URI.file(fe)};if((0,it.hasWorkspaceFileExtension)(fe))return{workspaceUri:P.URI.file(fe)}}catch(ye){}return{fileUri:P.URI.file(fe)}}async afterWindowOpen(fe,ye){this.lifecycleMainService.phase=3;let Se=!1;(0,f.once)(this.lifecycleMainService.onWillShutdown)(()=>Se=!0);const me=fe.get(We.ITelemetryService);this._register(ye.onDidError(({type:Ce,details:Le})=>{let Re;switch(Ce){case 1:Re="SharedProcess: detected unresponsive window";break;case 2:Re=`SharedProcess: crashed (detail: ${Le?.reason??"<unknown>"}, code: ${Le?.exitCode??"<unknown>"})`;break;case 3:Re=`SharedProcess: failed to load (detail: ${Le?.reason??"<unknown>"}, code: ${Le?.exitCode??"<unknown>"})`;break}(0,I.onUnexpectedError)(new Error(Re)),me.publicLog2("sharedprocesserror",{type:Ce,reason:Le?.reason,code:Le?.exitCode,visible:ye.isVisible(),shuttingdown:Se})}));const Ie=this.productService.win32MutexName;if(w.isWindows&&Ie)try{const Ce=H.__$__nodeRequire("windows-mutex").Mutex,Le=new Ce(Ie);(0,f.once)(this.lifecycleMainService.onWillShutdown)(()=>Le.release())}catch(Ce){this.logService.error(Ce)}v.protocol.registerHttpProtocol(p.Schemas.vscodeRemoteResource,(Ce,Le)=>{Le({url:Ce.url.replace(/^vscode-remote-resource:/,"http:"),method:Ce.method})});const Me=fe.get(He.IUpdateService);(Me instanceof re.Win32UpdateService||Me instanceof tt.LinuxUpdateService||Me instanceof at.DarwinUpdateService)&&Me.initialize(),this.resolveShellEnvironment(this.environmentMainService.args,process.env,!0);try{const Le=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse((0,y.stripComments)(Le))["enable-crash-reporter"]===void 0){const Ye=(0,Ge.getTelemetryLevel)(this.configurationService)>=1,nt=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Ye},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,c.generateUuid)()}"`,"}"],Qe=Le.substring(0,Le.length-2).concat(`,
`,nt.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,C.VSBuffer.fromString(Qe))}}catch(Ce){this.logService.error(Ce)}}async resolveShellEnvironment(fe,ye,Se){try{return await(0,T.resolveShellEnv)(this.logService,fe,ye)}catch(me){const Ie=(0,n.toErrorMessage)(me);Se?this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",Ie):this.logService.error(Ie)}return{}}stopTracingEventually(fe,ye){this.logService.info("Tracing: waiting for windows to get ready...");const Se=fe.get(j.IDialogMainService);let me=!1;const Ie=async Ce=>{if(me)return;me=!0;const Le=await v.contentTracing.stopRecording((0,b.joinPath)(this.environmentMainService.userHome,`${this.productService.applicationName}-${Math.random().toString(16).slice(-4)}.trace.txt`).fsPath);Ce?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${Le}`):Se.showMessageBox({title:this.productService.nameLong,type:"info",message:(0,o.localize)(4,null),detail:(0,o.localize)(5,null,Le),buttons:[(0,E.mnemonicButtonLabel)((0,o.localize)(6,null))],defaultId:0,noLink:!0},(0,S.withNullAsUndefined)(v.BrowserWindow.getFocusedWindow()))},Me=setTimeout(()=>Ie(!0),3e4);Promise.all(ye.map(Ce=>Ce.ready())).then(()=>{clearTimeout(Me),Ie(!1)})}};ft=he([ee(2,X.IInstantiationService),ee(3,se.ILogService),ee(4,oe.IEnvironmentMainService),ee(5,ce.ILifecycleMainService),ee(6,k.IConfigurationService),ee(7,ge.IStateMainService),ee(8,F.IFileService),ee(9,de.IProductService)],ft),e.CodeApplication=ft}),define(Q[251],J([0,1,14,28,30,9,44,16,33,42,34,10,8,63,3,32,25,21,35,58,244,11,19,192,203,24,54,165,18,182,94,73,175,75,20,95,6,186,96,56,22,57,189,97,228,50,230,76,200,38,232,65,66,209]),function(H,e,v,D,M,C,n,I,d,f,y,E,m,p,t,w,b,S,P,c,a,l,s,u,r,i,o,h,g,k,L,R,W,j,x,ne,oe,G,T,B,q,U,N,_,Y,F,A,O,$,X,V,z,Z){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class te{main(){try{this.startup()}catch(ie){console.error(ie.message),v.app.exit(1)}}async startup(){(0,I.setUnexpectedErrorHandler)(ge=>console.error(ge));const[ie,ae,ue,de,ve,Pe,pe]=this.createServices();try{try{await this.initServices(ue,de,ve)}catch(ge){throw this.handleStartupDataDirError(ue,pe.nameLong,ge),ge}await ie.invokeFunction(async ge=>{const be=ge.get(oe.ILogService),ke=ge.get(x.ILifecycleMainService),Ae=ge.get(g.IFileService),We=await this.claimInstance(be,ue,ke,ie,pe,!0);return S.Promises.writeFile(ue.mainLockfile,String(process.pid)).catch(Fe=>{be.warn(`Error writing main lockfile: ${Fe.stack}`)}),Pe.logger=new T.SpdLogLogger("main",(0,m.join)(ue.logsPath,"main.log"),!0,!1,Pe.getLevel()),(0,f.once)(ke.onWillShutdown)(Fe=>{Ae.dispose(),de.dispose(),Fe.join(S.Promises.unlink(ue.mainLockfile).catch(()=>{}))}),ie.createInstance(a.CodeApplication,We,ae).startup()})}catch(ge){ie.invokeFunction(this.quit,ge)}}createServices(){const ie=new j.ServiceCollection,ae={_serviceBrand:void 0,...B.default};ie.set(q.IProductService,ae);const ue=new i.EnvironmentMainService(this.resolveArgs(),ae),de=this.patchEnvironment(ue);ie.set(i.IEnvironmentMainService,ue);const ve=new ne.BufferLogService,Pe=new oe.MultiplexLogService([new oe.ConsoleMainLogger((0,oe.getLogLevel)(ue)),ve]);process.once("exit",()=>Pe.dispose()),ie.set(oe.ILogService,Pe);const pe=new k.FileService(Pe);ie.set(g.IFileService,pe);const ge=new L.DiskFileSystemProvider(Pe);pe.registerProvider(E.Schemas.file,ge),ie.set(oe.ILoggerService,new G.LoggerService(Pe,pe));const be=new u.ConfigurationService(ue.settingsResource,pe);ie.set(s.IConfigurationService,be),ie.set(x.ILifecycleMainService,new R.SyncDescriptor(x.LifecycleMainService));const ke=new V.StateMainService(ue,Pe,pe);return ie.set(X.IStateMainService,ke),ie.set(F.IRequestService,new R.SyncDescriptor(A.RequestMainService)),ie.set(Z.IThemeMainService,new R.SyncDescriptor(Z.ThemeMainService)),ie.set(O.ISignService,new R.SyncDescriptor($.SignService)),ie.set(_.ITunnelService,new R.SyncDescriptor(Y.TunnelService)),ie.set(U.IProtocolMainService,new R.SyncDescriptor(N.ProtocolMainService)),[new W.InstantiationService(ie,!0),de,ue,be,ke,ve,ae]}patchEnvironment(ie){const ae={VSCODE_IPC_HOOK:ie.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(ue=>{const de=process.env[ue];typeof de=="string"&&(ae[ue]=de)}),Object.assign(process.env,ae),ae}initServices(ie,ae,ue){return C.Promises.settled([Promise.all([ie.extensionsPath,ie.codeCachePath,ie.logsPath,ie.globalStorageHome.fsPath,ie.workspaceStorageHome.fsPath,ie.backupHome].map(de=>de?S.Promises.mkdir(de,{recursive:!0}):void 0)),ae.initialize(),ue.init()])}async claimInstance(ie,ae,ue,de,ve,Pe){let pe;try{(0,p.mark)("code/willStartMainServer"),pe=await(0,c.serve)(ae.mainIPCHandle),(0,p.mark)("code/didStartMainServer"),(0,f.once)(ue.onWillShutdown)(()=>pe.dispose())}catch(ge){if(ge.code!=="EADDRINUSE")throw this.handleStartupDataDirError(ae,ve.nameLong,ge),ge;let be;try{be=await(0,c.connect)(ae.mainIPCHandle,"main")}catch(We){if(!Pe||t.isWindows||We.code!=="ECONNREFUSED")throw We.code==="EPERM"&&this.showStartupWarningDialog((0,l.localize)(0,null,ve.nameShort),(0,l.localize)(1,null),ve.nameLong),We;try{(0,D.unlinkSync)(ae.mainIPCHandle)}catch(Fe){throw ie.warn("Could not delete obsolete instance handle",Fe),Fe}return this.claimInstance(ie,ae,ue,de,ve,!1)}if(ae.extensionTestsLocationURI&&!ae.debugExtensionHost.break){const We="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw ie.error(We),be.dispose(),new Error(We)}let ke;!ae.args.wait&&!ae.args.status&&(ke=setTimeout(()=>{this.showStartupWarningDialog((0,l.localize)(2,null,ve.nameShort),(0,l.localize)(3,null),ve.nameLong)},1e4));const Ae=P.ProxyChannel.toService(be.getChannel("launch"),{disableMarshalling:!0});if(ae.args.status)return de.invokeFunction(async()=>{const We=new r.DiagnosticsService(z.NullTelemetryService,ve),Fe=await Ae.getMainProcessInfo(),et=await Ae.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Ge=await We.getDiagnostics(Fe,et);throw console.log(Ge),new I.ExpectedError});throw t.isWindows&&await this.windowsAllowSetForegroundWindow(Ae,ie),ie.trace("Sending env to running instance..."),await Ae.start(ae.args,process.env),be.dispose(),ke&&clearTimeout(ke),new I.ExpectedError("Sent env to running instance. Terminating...")}if(ae.args.status)throw ie.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new I.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),pe}handleStartupDataDirError(ie,ae,ue){if(ue.code==="EACCES"||ue.code==="EPERM"){const de=(0,M.coalesce)([ie.userDataPath,ie.extensionsPath,c.XDG_RUNTIME_DIR]).map(ve=>(0,y.getPathLabel)(ve,ie));this.showStartupWarningDialog((0,l.localize)(4,null),(0,l.localize)(5,null,(0,n.toErrorMessage)(ue),de.join(`
`)),ae)}}showStartupWarningDialog(ie,ae,ue){v.dialog.showMessageBoxSync({title:ue,type:"warning",buttons:[(0,y.mnemonicButtonLabel)((0,l.localize)(6,null))],message:ie,detail:ae,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(ie,ae){if(t.isWindows){const ue=await ie.getMainProcessId();ae.trace("Sending some foreground love to the running instance:",ue);try{(await new Promise((de,ve)=>{H(["windows-foreground-love"],de,ve)})).allowSetForegroundWindow(ue)}catch(de){ae.error(de)}}}quit(ie,ae){const ue=ie.get(oe.ILogService),de=ie.get(x.ILifecycleMainService);let ve=0;ae&&(ae.isExpected?ae.message&&ue.trace(ae.message):(ve=1,ae.stack?ue.error(ae.stack):ue.error(`Startup error: ${ae.toString()}`))),de.kill(ve)}resolveArgs(){const ie=this.validatePaths((0,o.parseMainProcessArgv)(process.argv));if(ie.wait&&!ie.waitMarkerFilePath){const ae=(0,h.createWaitMarkerFile)(ie.verbose);ae&&((0,o.addArg)(process.argv,"--waitMarkerFilePath",ae),ie.waitMarkerFilePath=ae)}return ie}validatePaths(ie){if(ie["open-url"]&&(ie._urls=ie._,ie._=[]),!ie.remote){const ae=this.doValidatePaths(ie._,ie.goto);ie._=ae}return ie}doValidatePaths(ie,ae){const ue=(0,w.cwd)(),de=ie.map(pe=>{let ge=String(pe),be;ae&&(be=(0,d.parseLineAndColumnAware)(ge),ge=be.path),ge&&(ge=this.preparePath(ue,ge));const ke=(0,d.sanitizeFilePath)(ge,ue),Ae=(0,m.basename)(ke);return Ae&&!(0,d.isValidBasename)(Ae)?null:ae&&be?(be.path=ke,this.toPath(be)):ke}),ve=t.isWindows||t.isMacintosh,Pe=(0,M.distinct)(de,pe=>pe&&ve?pe.toLowerCase():pe||"");return(0,M.coalesce)(Pe)}preparePath(ie,ae){return t.isWindows&&(ae=(0,b.rtrim)(ae,'"')),ae=(0,b.trim)((0,b.trim)(ae," "),"	"),t.isWindows&&(ae=(0,m.resolve)(ie,ae),ae=(0,b.rtrim)(ae,".")),ae}toPath(ie){const ae=[ie.path];return typeof ie.line=="number"&&ae.push(String(ie.line)),typeof ie.column=="number"&&ae.push(String(ie.column)),ae.join(":")}}new te().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/6a25ae3a24929f35aabf8a051531c0716032e0a0/core/vs/code/electron-main/main.js.map
