/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var fe=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/network","vs/platform/log/common/log","vs/base/common/platform","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/async","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/map","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/platform/extensions/common/extensions","vs/base/node/pfs","vs/workbench/services/extensions/common/extensions","vs/base/common/extpath","vs/base/common/glob","vs/base/common/uuid","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostTerminalService","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","child_process","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/range","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/hash","vs/base/common/severity","vs/editor/common/core/position","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTunnelService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDebugService","vs/base/common/assert","vs/base/common/collections","vs/base/common/decorators","vs/base/common/json","vs/base/common/marshalling","fs","vs/platform/remote/common/remoteHosts","vs/platform/theme/common/themeService","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/numbers","vs/base/common/normalization","vs/base/common/labels","os","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/workbench/api/common/cache","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/linkedList","vs/base/common/processes","vs/base/common/stream","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/uint","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/mime","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/base/node/processes","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/tunnel","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/common/views","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/output/common/output","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","https","tls","vscode-proxy-agent","events","vscode-regexpp","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],me=function(Y){for(var e=[],g=0,L=Y.length;g<L;g++)e[g]=fe[Y[g]];return e};define(fe[58],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function g(L,y){if(!L)throw new Error(y?`Assertion failed (${y})`:"Assertion Failed")}e.ok=g}),define(fe[59],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const g=Object.prototype.hasOwnProperty;function L(T){const I=[];for(let c in T)g.call(T,c)&&I.push(T[c]);return I}e.values=L;function y(T,I){for(let c in T)if(g.call(T,c)&&I({key:c,value:T[c]},function(){delete T[c]})===!1)return}e.forEach=y;function C(T,I){const c=Object.create(null);for(const p of T){const f=I(p);let v=c[f];v||(v=c[f]=[]),v.push(p)}return c}e.groupBy=C;function i(T){const I=Object.create(null);return T&&T.forEach((c,p)=>{I[p]=c}),I}e.fromMap=i;function k(T,I){const c=[],p=[];for(let f of T)I.has(f)||c.push(f);for(let f of I)T.has(f)||p.push(f);return{removed:c,added:p}}e.diffSets=k;function _(T,I){const c=[],p=[];for(let[f,v]of T)I.has(f)||c.push(v);for(let[f,v]of I)T.has(f)||p.push(v);return{removed:c,added:p}}e.diffMaps=_;class D{constructor(){this.map=new Map}add(I,c){let p=this.map.get(I);p||(p=new Set,this.map.set(I,p)),p.add(c)}delete(I,c){const p=this.map.get(I);!p||(p.delete(c),p.size===0&&this.map.delete(I))}forEach(I,c){const p=this.map.get(I);!p||p.forEach(c)}}e.SetMap=D}),define(fe[60],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function g(i){return(k,_,D)=>{let T=null,I=null;if(typeof D.value=="function"?(T="value",I=D.value):typeof D.get=="function"&&(T="get",I=D.get),!I)throw new Error("not supported");D[T]=i(I,_)}}e.createDecorator=g;function L(i,k,_){let D=null,T=null;if(typeof _.value=="function"?(D="value",T=_.value,T.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof _.get=="function"&&(D="get",T=_.get),!T)throw new Error("not supported");const I=`$memoize$${k}`;_[D]=function(...c){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:T.apply(this,c)}),this[I]}}e.memoize=L;function y(i,k,_){return g((D,T)=>{const I=`$debounce$${T}`,c=`$debounce$result$${T}`;return function(...p){this[c]||(this[c]=_?_():void 0),clearTimeout(this[I]),k&&(this[c]=k(this[c],...p),p=[this[c]]),this[I]=setTimeout(()=>{D.apply(this,p),this[c]=_?_():void 0},i)}})}e.debounce=y;function C(i,k,_){return g((D,T)=>{const I=`$throttle$timer$${T}`,c=`$throttle$result$${T}`,p=`$throttle$lastRun$${T}`,f=`$throttle$pending$${T}`;return function(...v){if(this[c]||(this[c]=_?_():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),k&&(this[c]=k(this[c],...v)),this[f])return;const S=this[p]+i;S<=Date.now()?(this[p]=Date.now(),D.apply(this,[this[c]]),this[c]=_?_():void 0):(this[f]=!0,this[I]=setTimeout(()=>{this[f]=!1,this[p]=Date.now(),D.apply(this,[this[c]]),this[c]=_?_():void 0},S-Date.now()))}})}e.throttle=C}),define(fe[18],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class g{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(a){setTimeout(()=>{throw a.stack?new Error(a.message+`

`+a.stack):a},0)}}addListener(a){return this.listeners.push(a),()=>{this._removeListener(a)}}emit(a){this.listeners.forEach(b=>{b(a)})}_removeListener(a){this.listeners.splice(this.listeners.indexOf(a),1)}setUnexpectedErrorHandler(a){this.unexpectedErrorHandler=a}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(a){this.unexpectedErrorHandler(a),this.emit(a)}onUnexpectedExternalError(a){this.unexpectedErrorHandler(a)}}e.ErrorHandler=g,e.errorHandler=new g;function L(m){e.errorHandler.setUnexpectedErrorHandler(m)}e.setUnexpectedErrorHandler=L;function y(m){_(m)||e.errorHandler.onUnexpectedError(m)}e.onUnexpectedError=y;function C(m){_(m)||e.errorHandler.onUnexpectedExternalError(m)}e.onUnexpectedExternalError=C;function i(m){if(m instanceof Error){let{name:a,message:b}=m;const n=m.stacktrace||m.stack;return{$isError:!0,name:a,message:b,stack:n}}return m}e.transformErrorForSerialization=i;const k="Canceled";function _(m){return m instanceof Error&&m.name===k&&m.message===k}e.isPromiseCanceledError=_;class D extends Error{constructor(){super(k);this.name=this.message}}e.CancellationError=D;function T(){const m=new Error(k);return m.name=m.message,m}e.canceled=T;function I(m){return m?new Error(`Illegal argument: ${m}`):new Error("Illegal argument")}e.illegalArgument=I;function c(m){return m?new Error(`Illegal state: ${m}`):new Error("Illegal state")}e.illegalState=c;function p(m){return m?new Error(`readonly property '${m} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=p;function f(m){const a=new Error(`${m} has been disposed`);return a.name="DISPOSED",a}e.disposed=f;function v(m){return m?m.message?m.message:m.stack?m.stack.split(`
`)[0]:String(m):"Error"}e.getErrorMessage=v;class S extends Error{constructor(a){super("NotImplemented");a&&(this.message=a)}}e.NotImplementedError=S;class P extends Error{constructor(a){super("NotSupported");a&&(this.message=a)}}e.NotSupportedError=P;class w extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=w;function s(m){const a=m;return a instanceof Error&&Array.isArray(a.actions)}e.isErrorWithActions=s;function r(m,a=Object.create(null)){const b=new Error(m);return a.actions&&(b.actions=a.actions),b}e.createErrorWithActions=r}),define(fe[15],me([0,1,18]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L(j,X=0){return j[j.length-(1+X)]}e.tail=L;function y(j){if(j.length===0)throw new Error("Invalid tail call");return[j.slice(0,j.length-1),j[j.length-1]]}e.tail2=y;function C(j,X,Q=(de,Se)=>de===Se){if(j===X)return!0;if(!j||!X||j.length!==X.length)return!1;for(let de=0,Se=j.length;de<Se;de++)if(!Q(j[de],X[de]))return!1;return!0}e.equals=C;function i(j,X,Q){let de=0,Se=j.length-1;for(;de<=Se;){const De=(de+Se)/2|0,Pe=Q(j[De],X);if(Pe<0)de=De+1;else if(Pe>0)Se=De-1;else return De}return-(de+1)}e.binarySearch=i;function k(j,X){let Q=0,de=j.length;if(de===0)return 0;for(;Q<de;){const Se=Math.floor((Q+de)/2);X(j[Se])?de=Se:Q=Se+1}return Q}e.findFirstInSorted=k;function _(j,X,Q){if(j=j|0,j>=X.length)throw new TypeError("invalid index");let de=X[Math.floor(X.length*Math.random())],Se=[],De=[],Pe=[];for(let Be of X){const We=Q(Be,de);We<0?Se.push(Be):We>0?De.push(Be):Pe.push(Be)}return j<Se.length?_(j,Se,Q):j<Se.length+Pe.length?Pe[0]:_(j-(Se.length+Pe.length),De,Q)}e.quickSelect=_;function D(j,X){const Q=[];let de;for(const Se of j.slice(0).sort(X))!de||X(de[0],Se)!==0?(de=[Se],Q.push(de)):de.push(Se);return Q}e.groupBy=D;function T(j,X,Q){const de=[];function Se(Be,We,He){if(We===0&&He.length===0)return;const G=de[de.length-1];G&&G.start+G.deleteCount===Be?(G.deleteCount+=We,G.toInsert.push(...He)):de.push({start:Be,deleteCount:We,toInsert:He})}let De=0,Pe=0;for(;;){if(De===j.length){Se(De,0,X.slice(Pe));break}if(Pe===X.length){Se(De,j.length-De,[]);break}const Be=j[De],We=X[Pe],He=Q(Be,We);He===0?(De+=1,Pe+=1):He<0?(Se(De,1,[]),De+=1):He>0&&(Se(De,0,[We]),Pe+=1)}return de}e.sortedDiff=T;function I(j,X,Q){const de=T(j,X,Q),Se=[],De=[];for(const Pe of de)Se.push(...j.slice(Pe.start,Pe.start+Pe.deleteCount)),De.push(...Pe.toInsert);return{removed:Se,added:De}}e.delta=I;function c(j,X,Q){if(Q===0)return[];const de=j.slice(0,Q).sort(X);return f(j,X,de,Q,j.length),de}e.top=c;function p(j,X,Q,de,Se){return Q===0?Promise.resolve([]):new Promise((De,Pe)=>{(async()=>{const Be=j.length,We=j.slice(0,Q).sort(X);for(let He=Q,G=Math.min(Q+de,Be);He<Be;He=G,G=Math.min(G+de,Be)){if(He>Q&&await new Promise(ee=>setTimeout(ee)),Se&&Se.isCancellationRequested)throw(0,g.canceled)();f(j,X,We,He,G)}return We})().then(De,Pe)})}e.topAsync=p;function f(j,X,Q,de,Se){for(const De=Q.length;de<Se;de++){const Pe=j[de];if(X(Pe,Q[De-1])<0){Q.pop();const Be=k(Q,We=>X(Pe,We)<0);Q.splice(Be,0,Pe)}}}function v(j){return j.filter(X=>!!X)}e.coalesce=v;function S(j){let X=0;for(let Q=0;Q<j.length;Q++)j[Q]&&(j[X]=j[Q],X+=1);j.length=X}e.coalesceInPlace=S;function P(j,X,Q){j.splice(Q,0,j.splice(X,1)[0])}e.move=P;function w(j){return!Array.isArray(j)||j.length===0}e.isFalsyOrEmpty=w;function s(j){return Array.isArray(j)&&j.length>0}e.isNonEmptyArray=s;function r(j,X=Q=>Q){const Q=new Set;return j.filter(de=>{const Se=X(de);return Q.has(Se)?!1:(Q.add(Se),!0)})}e.distinct=r;function m(j){const X=Object.create(null);return Q=>{const de=j(Q);return X[de]?!1:(X[de]=!0,!0)}}e.uniqueFilter=m;function a(j,X){const Q=b(j,X);if(Q!==-1)return j[Q]}e.findLast=a;function b(j,X){for(let Q=j.length-1;Q>=0;Q--){const de=j[Q];if(X(de))return Q}return-1}e.lastIndex=b;function n(j,X){return j.length>0?j[0]:X}e.firstOrDefault=n;function t(j,X,Q=(de,Se)=>de===Se){let de=0;for(let Se=0,De=Math.min(j.length,X.length);Se<De&&Q(j[Se],X[Se]);Se++)de++;return de}e.commonPrefixLength=t;function l(j){return[].concat(...j)}e.flatten=l;function d(j,X){let Q=typeof X=="number"?j:0;typeof X=="number"?Q=j:(Q=0,X=j);const de=[];if(Q<=X)for(let Se=Q;Se<X;Se++)de.push(Se);else for(let Se=Q;Se>X;Se--)de.push(Se);return de}e.range=d;function o(j,X,Q){return j.reduce((de,Se)=>(de[X(Se)]=Q?Q(Se):Se,de),Object.create(null))}e.index=o;function h(j,X){return j.push(X),()=>u(j,X)}e.insert=h;function u(j,X){const Q=j.indexOf(X);if(Q>-1)return j.splice(Q,1),X}e.remove=u;function E(j,X,Q){const de=j.slice(0,X),Se=j.slice(X);return de.concat(Q,Se)}e.arrayInsert=E;function A(j,X){let Q;if(typeof X=="number"){let de=X;Q=()=>{const Se=Math.sin(de++)*179426549;return Se-Math.floor(Se)}}else Q=Math.random;for(let de=j.length-1;de>0;de-=1){const Se=Math.floor(Q()*(de+1)),De=j[de];j[de]=j[Se],j[Se]=De}}e.shuffle=A;function R(j,X){const Q=j.indexOf(X);Q>-1&&(j.splice(Q,1),j.unshift(X))}e.pushToStart=R;function B(j,X){const Q=j.indexOf(X);Q>-1&&(j.splice(Q,1),j.push(X))}e.pushToEnd=B;function x(j,X){return Array.isArray(j)?j.map(X):X(j)}e.mapArrayOrNot=x;function F(j){return Array.isArray(j)?j:[j]}e.asArray=F;function $(j){return j[Math.floor(Math.random()*j.length)]}e.getRandomElement=$;function M(j,X){for(const Q of j){const de=X(Q);if(de!==void 0)return de}}e.mapFind=M;function H(j,X,Q){const de=U(j,X),Se=j.length,De=Q.length;j.length=Se+De;for(let Pe=Se-1;Pe>=de;Pe--)j[Pe+De]=j[Pe];for(let Pe=0;Pe<De;Pe++)j[Pe+de]=Q[Pe]}e.insertInto=H;function N(j,X,Q,de){const Se=U(j,X),De=j.splice(Se,Q);return H(j,Se,de),De}e.splice=N;function U(j,X){return X<0?Math.max(X+j.length,0):Math.min(X,j.length)}function V(j,X){let Q=Number.MAX_SAFE_INTEGER,de=0;return j.forEach((Se,De)=>{const Pe=X(Se);Pe<Q&&(Q=Pe,de=De)}),de}e.minIndex=V;function O(j,X){let Q=Number.MIN_SAFE_INTEGER,de=0;return j.forEach((Se,De)=>{const Pe=X(Se);Pe>Q&&(Q=Pe,de=De)}),de}e.maxIndex=O;class W{constructor(X){this.items=X,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(X){let Q=this.firstIdx;for(;Q<this.items.length&&X(this.items[Q]);)Q++;const de=Q===this.firstIdx?null:this.items.slice(this.firstIdx,Q);return this.firstIdx=Q,de}takeFromEndWhile(X){let Q=this.lastIdx;for(;Q>=0&&X(this.items[Q]);)Q--;const de=Q===this.lastIdx?null:this.items.slice(Q+1,this.lastIdx+1);return this.lastIdx=Q,de}peek(){return this.items[this.firstIdx]}dequeue(){const X=this.items[this.firstIdx];return this.firstIdx++,X}takeCount(X){const Q=this.items.slice(this.firstIdx,this.firstIdx+X);return this.firstIdx+=X,Q}}e.ArrayQueue=W}),define(fe[76],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function g(L){const y=this;let C=!1,i;return function(){return C||(C=!0,i=L.apply(y,arguments)),i}}e.once=g}),define(fe[77],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class g{constructor(y){this._prefix=y,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=g,e.defaultGenerator=new g("id#")}),define(fe[78],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var g;(function(L){function y(m){return m&&typeof m=="object"&&typeof m[Symbol.iterator]=="function"}L.is=y;const C=Object.freeze([]);function i(){return C}L.empty=i;function*k(m){yield m}L.single=k;function _(m){return m||C}L.from=_;function D(m){return!m||m[Symbol.iterator]().next().done===!0}L.isEmpty=D;function T(m){return m[Symbol.iterator]().next().value}L.first=T;function I(m,a){for(const b of m)if(a(b))return!0;return!1}L.some=I;function c(m,a){for(const b of m)if(a(b))return b}L.find=c;function*p(m,a){for(const b of m)a(b)&&(yield b)}L.filter=p;function*f(m,a){let b=0;for(const n of m)yield a(n,b++)}L.map=f;function*v(...m){for(const a of m)for(const b of a)yield b}L.concat=v;function*S(m){for(const a of m)for(const b of a)yield b}L.concatNested=S;function P(m,a,b){let n=b;for(const t of m)n=a(n,t);return n}L.reduce=P;function*w(m,a,b=m.length){for(a<0&&(a+=m.length),b<0?b+=m.length:b>m.length&&(b=m.length);a<b;a++)yield m[a]}L.slice=w;function s(m,a=Number.POSITIVE_INFINITY){const b=[];if(a===0)return[b,m];const n=m[Symbol.iterator]();for(let t=0;t<a;t++){const l=n.next();if(l.done)return[b,L.empty()];b.push(l.value)}return[b,{[Symbol.iterator](){return n}}]}L.consume=s;function r(m,a,b=(n,t)=>n===t){const n=m[Symbol.iterator](),t=a[Symbol.iterator]();for(;;){const l=n.next(),d=t.next();if(l.done!==d.done)return!1;if(l.done)return!0;if(!b(l.value,d.value))return!1}}L.equals=r})(g=e.Iterable||(e.Iterable={}))}),define(fe[61],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var g;(function(a){a[a.None=0]="None",a[a.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",a[a.UnexpectedEndOfString=2]="UnexpectedEndOfString",a[a.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",a[a.InvalidUnicode=4]="InvalidUnicode",a[a.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",a[a.InvalidCharacter=6]="InvalidCharacter"})(g=e.ScanError||(e.ScanError={}));var L;(function(a){a[a.OpenBraceToken=1]="OpenBraceToken",a[a.CloseBraceToken=2]="CloseBraceToken",a[a.OpenBracketToken=3]="OpenBracketToken",a[a.CloseBracketToken=4]="CloseBracketToken",a[a.CommaToken=5]="CommaToken",a[a.ColonToken=6]="ColonToken",a[a.NullKeyword=7]="NullKeyword",a[a.TrueKeyword=8]="TrueKeyword",a[a.FalseKeyword=9]="FalseKeyword",a[a.StringLiteral=10]="StringLiteral",a[a.NumericLiteral=11]="NumericLiteral",a[a.LineCommentTrivia=12]="LineCommentTrivia",a[a.BlockCommentTrivia=13]="BlockCommentTrivia",a[a.LineBreakTrivia=14]="LineBreakTrivia",a[a.Trivia=15]="Trivia",a[a.Unknown=16]="Unknown",a[a.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var y;(function(a){a[a.InvalidSymbol=1]="InvalidSymbol",a[a.InvalidNumberFormat=2]="InvalidNumberFormat",a[a.PropertyNameExpected=3]="PropertyNameExpected",a[a.ValueExpected=4]="ValueExpected",a[a.ColonExpected=5]="ColonExpected",a[a.CommaExpected=6]="CommaExpected",a[a.CloseBraceExpected=7]="CloseBraceExpected",a[a.CloseBracketExpected=8]="CloseBracketExpected",a[a.EndOfFileExpected=9]="EndOfFileExpected",a[a.InvalidCommentToken=10]="InvalidCommentToken",a[a.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",a[a.UnexpectedEndOfString=12]="UnexpectedEndOfString",a[a.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",a[a.InvalidUnicode=14]="InvalidUnicode",a[a.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",a[a.InvalidCharacter=16]="InvalidCharacter"})(y=e.ParseErrorCode||(e.ParseErrorCode={}));var C;(function(a){a.DEFAULT={allowTrailingComma:!0}})(C=e.ParseOptions||(e.ParseOptions={}));function i(a,b=!1){let n=0,t=a.length,l="",d=0,o=16,h=0;function u($){let M=0,H=0;for(;M<$;){const N=a.charCodeAt(n);if(N>=48&&N<=57)H=H*16+N-48;else if(N>=65&&N<=70)H=H*16+N-65+10;else if(N>=97&&N<=102)H=H*16+N-97+10;else break;n++,M++}return M<$&&(H=-1),H}function E($){n=$,l="",d=0,o=16,h=0}function A(){const $=n;if(a.charCodeAt(n)===48)n++;else for(n++;n<a.length&&D(a.charCodeAt(n));)n++;if(n<a.length&&a.charCodeAt(n)===46)if(n++,n<a.length&&D(a.charCodeAt(n)))for(n++;n<a.length&&D(a.charCodeAt(n));)n++;else return h=3,a.substring($,n);let M=n;if(n<a.length&&(a.charCodeAt(n)===69||a.charCodeAt(n)===101))if(n++,(n<a.length&&a.charCodeAt(n)===43||a.charCodeAt(n)===45)&&n++,n<a.length&&D(a.charCodeAt(n))){for(n++;n<a.length&&D(a.charCodeAt(n));)n++;M=n}else h=3;return a.substring($,M)}function R(){let $="",M=n;for(;;){if(n>=t){$+=a.substring(M,n),h=2;break}const H=a.charCodeAt(n);if(H===34){$+=a.substring(M,n),n++;break}if(H===92){if($+=a.substring(M,n),n++,n>=t){h=2;break}switch(a.charCodeAt(n++)){case 34:$+='"';break;case 92:$+="\\";break;case 47:$+="/";break;case 98:$+="\b";break;case 102:$+="\f";break;case 110:$+=`
`;break;case 114:$+="\r";break;case 116:$+="	";break;case 117:const U=u(4);U>=0?$+=String.fromCharCode(U):h=4;break;default:h=5}M=n;continue}if(H>=0&&H<=31)if(_(H)){$+=a.substring(M,n),h=2;break}else h=6;n++}return $}function B(){if(l="",h=0,d=n,n>=t)return d=t,o=17;let $=a.charCodeAt(n);if(k($)){do n++,l+=String.fromCharCode($),$=a.charCodeAt(n);while(k($));return o=15}if(_($))return n++,l+=String.fromCharCode($),$===13&&a.charCodeAt(n)===10&&(n++,l+=`
`),o=14;switch($){case 123:return n++,o=1;case 125:return n++,o=2;case 91:return n++,o=3;case 93:return n++,o=4;case 58:return n++,o=6;case 44:return n++,o=5;case 34:return n++,l=R(),o=10;case 47:const M=n-1;if(a.charCodeAt(n+1)===47){for(n+=2;n<t&&!_(a.charCodeAt(n));)n++;return l=a.substring(M,n),o=12}if(a.charCodeAt(n+1)===42){n+=2;const H=t-1;let N=!1;for(;n<H;){if(a.charCodeAt(n)===42&&a.charCodeAt(n+1)===47){n+=2,N=!0;break}n++}return N||(n++,h=1),l=a.substring(M,n),o=13}return l+=String.fromCharCode($),n++,o=16;case 45:if(l+=String.fromCharCode($),n++,n===t||!D(a.charCodeAt(n)))return o=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=A(),o=11;default:for(;n<t&&x($);)n++,$=a.charCodeAt(n);if(d!==n){switch(l=a.substring(d,n),l){case"true":return o=8;case"false":return o=9;case"null":return o=7}return o=16}return l+=String.fromCharCode($),n++,o=16}}function x($){if(k($)||_($))return!1;switch($){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function F(){let $;do $=B();while($>=12&&$<=15);return $}return{setPosition:E,getPosition:()=>n,scan:b?F:B,getToken:()=>o,getTokenValue:()=>l,getTokenOffset:()=>d,getTokenLength:()=>n-d,getTokenError:()=>h}}e.createScanner=i;function k(a){return a===32||a===9||a===11||a===12||a===160||a===5760||a>=8192&&a<=8203||a===8239||a===8287||a===12288||a===65279}function _(a){return a===10||a===13||a===8232||a===8233}function D(a){return a>=48&&a<=57}var T;(function(a){a[a.nullCharacter=0]="nullCharacter",a[a.maxAsciiCharacter=127]="maxAsciiCharacter",a[a.lineFeed=10]="lineFeed",a[a.carriageReturn=13]="carriageReturn",a[a.lineSeparator=8232]="lineSeparator",a[a.paragraphSeparator=8233]="paragraphSeparator",a[a.nextLine=133]="nextLine",a[a.space=32]="space",a[a.nonBreakingSpace=160]="nonBreakingSpace",a[a.enQuad=8192]="enQuad",a[a.emQuad=8193]="emQuad",a[a.enSpace=8194]="enSpace",a[a.emSpace=8195]="emSpace",a[a.threePerEmSpace=8196]="threePerEmSpace",a[a.fourPerEmSpace=8197]="fourPerEmSpace",a[a.sixPerEmSpace=8198]="sixPerEmSpace",a[a.figureSpace=8199]="figureSpace",a[a.punctuationSpace=8200]="punctuationSpace",a[a.thinSpace=8201]="thinSpace",a[a.hairSpace=8202]="hairSpace",a[a.zeroWidthSpace=8203]="zeroWidthSpace",a[a.narrowNoBreakSpace=8239]="narrowNoBreakSpace",a[a.ideographicSpace=12288]="ideographicSpace",a[a.mathematicalSpace=8287]="mathematicalSpace",a[a.ogham=5760]="ogham",a[a._=95]="_",a[a.$=36]="$",a[a._0=48]="_0",a[a._1=49]="_1",a[a._2=50]="_2",a[a._3=51]="_3",a[a._4=52]="_4",a[a._5=53]="_5",a[a._6=54]="_6",a[a._7=55]="_7",a[a._8=56]="_8",a[a._9=57]="_9",a[a.a=97]="a",a[a.b=98]="b",a[a.c=99]="c",a[a.d=100]="d",a[a.e=101]="e",a[a.f=102]="f",a[a.g=103]="g",a[a.h=104]="h",a[a.i=105]="i",a[a.j=106]="j",a[a.k=107]="k",a[a.l=108]="l",a[a.m=109]="m",a[a.n=110]="n",a[a.o=111]="o",a[a.p=112]="p",a[a.q=113]="q",a[a.r=114]="r",a[a.s=115]="s",a[a.t=116]="t",a[a.u=117]="u",a[a.v=118]="v",a[a.w=119]="w",a[a.x=120]="x",a[a.y=121]="y",a[a.z=122]="z",a[a.A=65]="A",a[a.B=66]="B",a[a.C=67]="C",a[a.D=68]="D",a[a.E=69]="E",a[a.F=70]="F",a[a.G=71]="G",a[a.H=72]="H",a[a.I=73]="I",a[a.J=74]="J",a[a.K=75]="K",a[a.L=76]="L",a[a.M=77]="M",a[a.N=78]="N",a[a.O=79]="O",a[a.P=80]="P",a[a.Q=81]="Q",a[a.R=82]="R",a[a.S=83]="S",a[a.T=84]="T",a[a.U=85]="U",a[a.V=86]="V",a[a.W=87]="W",a[a.X=88]="X",a[a.Y=89]="Y",a[a.Z=90]="Z",a[a.ampersand=38]="ampersand",a[a.asterisk=42]="asterisk",a[a.at=64]="at",a[a.backslash=92]="backslash",a[a.bar=124]="bar",a[a.caret=94]="caret",a[a.closeBrace=125]="closeBrace",a[a.closeBracket=93]="closeBracket",a[a.closeParen=41]="closeParen",a[a.colon=58]="colon",a[a.comma=44]="comma",a[a.dot=46]="dot",a[a.doubleQuote=34]="doubleQuote",a[a.equals=61]="equals",a[a.exclamation=33]="exclamation",a[a.greaterThan=62]="greaterThan",a[a.lessThan=60]="lessThan",a[a.minus=45]="minus",a[a.openBrace=123]="openBrace",a[a.openBracket=91]="openBracket",a[a.openParen=40]="openParen",a[a.percent=37]="percent",a[a.plus=43]="plus",a[a.question=63]="question",a[a.semicolon=59]="semicolon",a[a.singleQuote=39]="singleQuote",a[a.slash=47]="slash",a[a.tilde=126]="tilde",a[a.backspace=8]="backspace",a[a.formFeed=12]="formFeed",a[a.byteOrderMark=65279]="byteOrderMark",a[a.tab=9]="tab",a[a.verticalTab=11]="verticalTab"})(T||(T={}));function I(a,b){const n=[],t=new Object;let l;const d={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function h(u,E,A,R){d.value=u,d.offset=E,d.length=A,d.type=R,d.colonOffset=void 0,l=d}try{s(a,{onObjectBegin:(u,E)=>{if(b<=u)throw t;l=void 0,o=b>u,n.push("")},onObjectProperty:(u,E,A)=>{if(b<E||(h(u,E,A,"property"),n[n.length-1]=u,b<=E+A))throw t},onObjectEnd:(u,E)=>{if(b<=u)throw t;l=void 0,n.pop()},onArrayBegin:(u,E)=>{if(b<=u)throw t;l=void 0,n.push(0)},onArrayEnd:(u,E)=>{if(b<=u)throw t;l=void 0,n.pop()},onLiteralValue:(u,E,A)=>{if(b<E||(h(u,E,A,m(u)),b<=E+A))throw t},onSeparator:(u,E,A)=>{if(b<=E)throw t;if(u===":"&&l&&l.type==="property")l.colonOffset=E,o=!1,l=void 0;else if(u===","){const R=n[n.length-1];typeof R=="number"?n[n.length-1]=R+1:(o=!0,n[n.length-1]=""),l=void 0}}})}catch(u){if(u!==t)throw u}return{path:n,previousNode:l,isAtPropertyKey:o,matches:u=>{let E=0;for(let A=0;E<u.length&&A<n.length;A++)if(u[E]===n[A]||u[E]==="*")E++;else if(u[E]!=="**")return!1;return E===u.length}}}e.getLocation=I;function c(a,b=[],n=C.DEFAULT){let t=null,l=[];const d=[];function o(u){Array.isArray(l)?l.push(u):t!==null&&(l[t]=u)}return s(a,{onObjectBegin:()=>{const u={};o(u),d.push(l),l=u,t=null},onObjectProperty:u=>{t=u},onObjectEnd:()=>{l=d.pop()},onArrayBegin:()=>{const u=[];o(u),d.push(l),l=u,t=null},onArrayEnd:()=>{l=d.pop()},onLiteralValue:o,onError:(u,E,A)=>{b.push({error:u,offset:E,length:A})}},n),l[0]}e.parse=c;function p(a,b=[],n=C.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(u){t.type==="property"&&(t.length=u-t.offset,t=t.parent)}function d(u){return t.children.push(u),u}s(a,{onObjectBegin:u=>{t=d({type:"object",offset:u,length:-1,parent:t,children:[]})},onObjectProperty:(u,E,A)=>{t=d({type:"property",offset:E,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:u,offset:E,length:A,parent:t})},onObjectEnd:(u,E)=>{t.length=u+E-t.offset,t=t.parent,l(u+E)},onArrayBegin:(u,E)=>{t=d({type:"array",offset:u,length:-1,parent:t,children:[]})},onArrayEnd:(u,E)=>{t.length=u+E-t.offset,t=t.parent,l(u+E)},onLiteralValue:(u,E,A)=>{d({type:m(u),offset:E,length:A,parent:t,value:u}),l(E+A)},onSeparator:(u,E,A)=>{t.type==="property"&&(u===":"?t.colonOffset=E:u===","&&l(E))},onError:(u,E,A)=>{b.push({error:u,offset:E,length:A})}},n);const h=t.children[0];return h&&delete h.parent,h}e.parseTree=p;function f(a,b){if(!a)return;let n=a;for(let t of b)if(typeof t=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let l=!1;for(const d of n.children)if(Array.isArray(d.children)&&d.children[0].value===t){n=d.children[1],l=!0;break}if(!l)return}else{const l=t;if(n.type!=="array"||l<0||!Array.isArray(n.children)||l>=n.children.length)return;n=n.children[l]}return n}e.findNodeAtLocation=f;function v(a){if(!a.parent||!a.parent.children)return[];const b=v(a.parent);if(a.parent.type==="property"){const n=a.parent.children[0].value;b.push(n)}else if(a.parent.type==="array"){const n=a.parent.children.indexOf(a);n!==-1&&b.push(n)}return b}e.getNodePath=v;function S(a){switch(a.type){case"array":return a.children.map(S);case"object":const b=Object.create(null);for(let n of a.children){const t=n.children[1];t&&(b[n.children[0].value]=S(t))}return b;case"null":case"string":case"number":case"boolean":return a.value;default:return}}e.getNodeValue=S;function P(a,b,n=!1){return b>=a.offset&&b<a.offset+a.length||n&&b===a.offset+a.length}e.contains=P;function w(a,b,n=!1){if(P(a,b,n)){const t=a.children;if(Array.isArray(t))for(let l=0;l<t.length&&t[l].offset<=b;l++){const d=w(t[l],b,n);if(d)return d}return a}}e.findNodeAtOffset=w;function s(a,b,n=C.DEFAULT){const t=i(a,!1);function l(Q){return Q?()=>Q(t.getTokenOffset(),t.getTokenLength()):()=>!0}function d(Q){return Q?de=>Q(de,t.getTokenOffset(),t.getTokenLength()):()=>!0}const o=l(b.onObjectBegin),h=d(b.onObjectProperty),u=l(b.onObjectEnd),E=l(b.onArrayBegin),A=l(b.onArrayEnd),R=d(b.onLiteralValue),B=d(b.onSeparator),x=l(b.onComment),F=d(b.onError),$=n&&n.disallowComments,M=n&&n.allowTrailingComma;function H(){for(;;){const Q=t.scan();switch(t.getTokenError()){case 4:N(14);break;case 5:N(15);break;case 3:N(13);break;case 1:$||N(11);break;case 2:N(12);break;case 6:N(16);break}switch(Q){case 12:case 13:$?N(10):x();break;case 16:N(1);break;case 15:case 14:break;default:return Q}}}function N(Q,de=[],Se=[]){if(F(Q),de.length+Se.length>0){let De=t.getToken();for(;De!==17;){if(de.indexOf(De)!==-1){H();break}else if(Se.indexOf(De)!==-1)break;De=H()}}}function U(Q){const de=t.getTokenValue();return Q?R(de):h(de),H(),!0}function V(){switch(t.getToken()){case 11:let Q=0;try{Q=JSON.parse(t.getTokenValue()),typeof Q!="number"&&(N(2),Q=0)}catch(de){N(2)}R(Q);break;case 7:R(null);break;case 8:R(!0);break;case 9:R(!1);break;default:return!1}return H(),!0}function O(){return t.getToken()!==10?(N(3,[],[2,5]),!1):(U(!1),t.getToken()===6?(B(":"),H(),X()||N(4,[],[2,5])):N(5,[],[2,5]),!0)}function W(){o(),H();let Q=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(Q||N(4,[],[]),B(","),H(),t.getToken()===2&&M)break}else Q&&N(6,[],[]);O()||N(4,[],[2,5]),Q=!0}return u(),t.getToken()!==2?N(7,[2],[]):H(),!0}function j(){E(),H();let Q=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(Q||N(4,[],[]),B(","),H(),t.getToken()===4&&M)break}else Q&&N(6,[],[]);X()||N(4,[],[4,5]),Q=!0}return A(),t.getToken()!==4?N(8,[4],[]):H(),!0}function X(){switch(t.getToken()){case 3:return j();case 1:return W();case 10:return U(!0);default:return V()}}return H(),t.getToken()===17?n.allowEmptyContent?!0:(N(4,[],[]),!1):X()?(t.getToken()!==17&&N(9,[],[]),!0):(N(4,[],[]),!1)}e.visit=s;function r(a,b){let n=i(a),t=[],l,d=0,o;do switch(o=n.getPosition(),l=n.scan(),l){case 12:case 13:case 17:d!==o&&t.push(a.substring(d,o)),b!==void 0&&t.push(n.getTokenValue().replace(/[^\r\n]/g,b)),d=n.getPosition();break}while(l!==17);return t.join("")}e.stripComments=r;function m(a){switch(typeof a){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(a){if(Array.isArray(a))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=m}),define(fe[139],me([0,1,61]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(_,D,T){let I,c,p,f,v;if(D){for(f=D.offset,v=f+D.length,p=f;p>0&&!k(_,p-1);)p--;let d=v;for(;d<_.length&&!k(_,d);)d++;c=_.substring(p,d),I=C(c,T)}else c=_,I=0,p=0,f=0,v=_.length;const S=i(T,_);let P=!1,w=0,s;T.insertSpaces?s=y(" ",T.tabSize||4):s="	";const r=(0,g.createScanner)(c,!1);let m=!1;function a(){return S+y(s,I+w)}function b(){let d=r.scan();for(P=!1;d===15||d===14;)P=P||d===14,d=r.scan();return m=d===16||r.getTokenError()!==0,d}const n=[];function t(d,o,h){!m&&o<v&&h>f&&_.substring(o,h)!==d&&n.push({offset:o,length:h-o,content:d})}let l=b();if(l!==17){const d=r.getTokenOffset()+p,o=y(s,I);t(o,p,d)}for(;l!==17;){let d=r.getTokenOffset()+r.getTokenLength()+p,o=b(),h="";for(;!P&&(o===12||o===13);){const E=r.getTokenOffset()+p;t(" ",d,E),d=r.getTokenOffset()+r.getTokenLength()+p,h=o===12?a():"",o=b()}if(o===2)l!==1&&(w--,h=a());else if(o===4)l!==3&&(w--,h=a());else{switch(l){case 3:case 1:w++,h=a();break;case 5:case 12:h=a();break;case 13:P?h=a():h=" ";break;case 6:h=" ";break;case 10:if(o===6){h="";break}case 7:case 8:case 9:case 11:case 2:case 4:o===12||o===13?h=" ":o!==5&&o!==17&&(m=!0);break;case 16:m=!0;break}P&&(o===12||o===13)&&(h=a())}const u=r.getTokenOffset()+p;t(h,d,u),l=o}return n}e.format=L;function y(_,D){let T="";for(let I=0;I<D;I++)T+=_;return T}function C(_,D){let T=0,I=0;const c=D.tabSize||4;for(;T<_.length;){const p=_.charAt(T);if(p===" ")I++;else if(p==="	")I+=c;else break;T++}return Math.floor(I/c)}function i(_,D){for(let T=0;T<D.length;T++){const I=D.charAt(T);if(I==="\r")return T+1<D.length&&D.charAt(T+1)===`
`?`\r
`:"\r";if(I===`
`)return`
`}return _&&_.eol||`
`}e.getEOL=i;function k(_,D){return`\r
`.indexOf(_.charAt(D))!==-1}e.isEOL=k}),define(fe[140],me([0,1,61,139]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function y(D,T,I){return C(D,T,void 0,I)}e.removeProperty=y;function C(D,T,I,c,p){const f=T.slice(),v=[],S=(0,g.parseTree)(D,v);let P,w;for(;f.length>0&&(w=f.pop(),P=(0,g.findNodeAtLocation)(S,f),P===void 0&&I!==void 0);)typeof w=="string"?I={[w]:I}:I=[I];if(P)if(P.type==="object"&&typeof w=="string"&&Array.isArray(P.children)){const s=(0,g.findNodeAtLocation)(P,[w]);if(s!==void 0)if(I===void 0){if(!s.parent)throw new Error("Malformed AST");const r=P.children.indexOf(s.parent);let m,a=s.parent.offset+s.parent.length;if(r>0){const b=P.children[r-1];m=b.offset+b.length}else m=P.offset+1,P.children.length>1&&(a=P.children[1].offset);return i(D,{offset:m,length:a-m,content:""},c)}else return i(D,{offset:s.offset,length:s.length,content:JSON.stringify(I)},c);else{if(I===void 0)return[];const r=`${JSON.stringify(w)}: ${JSON.stringify(I)}`,m=p?p(P.children.map(b=>b.children[0].value)):P.children.length;let a;if(m>0){const b=P.children[m-1];a={offset:b.offset+b.length,length:0,content:","+r}}else P.children.length===0?a={offset:P.offset+1,length:0,content:r}:a={offset:P.offset+1,length:0,content:r+","};return i(D,a,c)}}else if(P.type==="array"&&typeof w=="number"&&Array.isArray(P.children))if(I!==void 0){const s=`${JSON.stringify(I)}`;let r;if(P.children.length===0||w===0)r={offset:P.offset+1,length:0,content:P.children.length===0?s:s+","};else{const m=w===-1||w>P.children.length?P.children.length:w,a=P.children[m-1];r={offset:a.offset+a.length,length:0,content:","+s}}return i(D,r,c)}else{const s=w,r=P.children[s];let m;if(P.children.length===1)m={offset:P.offset+1,length:P.length-2,content:""};else if(P.children.length-1===s){const a=P.children[s-1],b=a.offset+a.length,n=P.offset+P.length;m={offset:b,length:n-2-b,content:""}}else m={offset:r.offset,length:P.children[s+1].offset-r.offset,content:""};return i(D,m,c)}else throw new Error(`Can not add ${typeof w!="number"?"index":"property"} to parent of type ${P.type}`);else{if(I===void 0)throw new Error("Can not delete in empty document");return i(D,{offset:S?S.offset:0,length:S?S.length:0,content:JSON.stringify(I)},c)}}e.setProperty=C;function i(D,T,I){let c=k(D,T),p=T.offset,f=T.offset+T.content.length;if(T.length===0||T.content.length===0){for(;p>0&&!(0,L.isEOL)(c,p-1);)p--;for(;f<c.length&&!(0,L.isEOL)(c,f);)f++}const v=(0,L.format)(c,{offset:p,length:f-p},I);for(let P=v.length-1;P>=0;P--){const w=v[P];c=k(c,w),p=Math.min(p,w.offset),f=Math.max(f,w.offset+w.length),f+=w.content.length-w.length}const S=D.length-(c.length-f)-p;return[{offset:p,length:S,content:c.substring(p,f)}]}e.withFormatting=i;function k(D,T){return D.substring(0,T.offset)+T.content+D.substring(T.offset+T.length)}e.applyEdit=k;function _(D,T){let I=T.slice(0).sort((p,f)=>{const v=p.offset-f.offset;return v===0?p.length-f.length:v}),c=D.length;for(let p=I.length-1;p>=0;p--){let f=I[p];if(f.offset+f.length<=c)D=k(D,f);else throw new Error("Overlapping edit");c=f.offset}return D}e.applyEdits=_}),define(fe[141],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class g{constructor(y){this.executor=y,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(y){this._error=y}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(y){return new g(()=>y(this.getValue()))}}e.Lazy=g}),define(fe[6],me([0,1,76,78]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const y=!1;let C=null;function i(t){C=t}if(e.setDisposableTracker=i,y){const t="__is_disposable_tracked__";i(new class{trackDisposable(l){const d=new Error("Potentially leaked disposable").stack;setTimeout(()=>{l[t]||console.log(d)},3e3)}setParent(l,d){if(l&&l!==w.None)try{l[t]=!0}catch{}}markAsDisposed(l){if(l&&l!==w.None)try{l[t]=!0}catch{}}markAsSingleton(l){}})}function k(t){return C?.trackDisposable(t),t}function _(t){C?.markAsDisposed(t)}function D(t,l){C?.setParent(t,l)}function T(t,l){if(!!C)for(const d of t)C.setParent(d,l)}function I(t){return C?.markAsSingleton(t),t}e.markAsSingleton=I;class c extends Error{constructor(l){super(`Encountered errors while disposing of store. Errors: [${l.join(", ")}]`);this.errors=l}}e.MultiDisposeError=c;function p(t){return typeof t.dispose=="function"&&t.dispose.length===0}e.isDisposable=p;function f(t){if(L.Iterable.is(t)){let l=[];for(const d of t)if(d)try{d.dispose()}catch(o){l.push(o)}if(l.length===1)throw l[0];if(l.length>1)throw new c(l);return Array.isArray(t)?[]:t}else if(t)return t.dispose(),t}e.dispose=f;function v(...t){const l=S(()=>f(t));return T(t,l),l}e.combinedDisposable=v;function S(t){const l=k({dispose:(0,g.once)(()=>{_(l),t()})});return l}e.toDisposable=S;class P{constructor(){this._toDispose=new Set,this._isDisposed=!1,k(this)}dispose(){this._isDisposed||(_(this),this._isDisposed=!0,this.clear())}clear(){try{f(this._toDispose.values())}finally{this._toDispose.clear()}}add(l){if(!l)return l;if(l===this)throw new Error("Cannot register a disposable on itself!");return D(l,this),this._isDisposed?P.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(l),l}}e.DisposableStore=P,P.DISABLE_DISPOSED_WARNING=!1;class w{constructor(){this._store=new P,k(this),D(this._store,this)}dispose(){_(this),this._store.dispose()}_register(l){if(l===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(l)}}e.Disposable=w,w.None=Object.freeze({dispose(){}});class s{constructor(){this._isDisposed=!1,k(this)}get value(){return this._isDisposed?void 0:this._value}set value(l){this._isDisposed||l===this._value||(this._value?.dispose(),l&&D(l,this),this._value=l)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,_(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const l=this._value;return this._value=void 0,l&&D(l,null),l}}e.MutableDisposable=s;class r{constructor(l){this._disposable=l,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=r;class m{constructor(){this.references=new Map}acquire(l,...d){let o=this.references.get(l);o||(o={counter:0,object:this.createReferencedObject(l,...d)},this.references.set(l,o));const{object:h}=o,u=(0,g.once)(()=>{--o.counter==0&&(this.destroyReferencedObject(l,o.object),this.references.delete(l))});return o.counter++,{object:h,dispose:u}}}e.ReferenceCollection=m;class a{constructor(l){this.referenceCollection=l}async acquire(l,...d){const o=this.referenceCollection.acquire(l,...d);try{return{object:await o.object,dispose:()=>o.dispose()}}catch(h){throw o.dispose(),h}}}e.AsyncReferenceCollection=a;class b{constructor(l){this.object=l}dispose(){}}e.ImmortalReference=b;function n(t){const l=new P;try{t(l)}finally{l.dispose()}}e.disposeOnReturn=n}),define(fe[94],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class g{constructor(C){this.element=C,this.next=g.Undefined,this.prev=g.Undefined}}g.Undefined=new g(void 0);class L{constructor(){this._first=g.Undefined,this._last=g.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===g.Undefined}clear(){let C=this._first;for(;C!==g.Undefined;){const i=C.next;C.prev=g.Undefined,C.next=g.Undefined,C=i}this._first=g.Undefined,this._last=g.Undefined,this._size=0}unshift(C){return this._insert(C,!1)}push(C){return this._insert(C,!0)}_insert(C,i){const k=new g(C);if(this._first===g.Undefined)this._first=k,this._last=k;else if(i){const D=this._last;this._last=k,k.prev=D,D.next=k}else{const D=this._first;this._first=k,k.next=D,D.prev=k}this._size+=1;let _=!1;return()=>{_||(_=!0,this._remove(k))}}shift(){if(this._first!==g.Undefined){const C=this._first.element;return this._remove(this._first),C}}pop(){if(this._last!==g.Undefined){const C=this._last.element;return this._remove(this._last),C}}_remove(C){if(C.prev!==g.Undefined&&C.next!==g.Undefined){const i=C.prev;i.next=C.next,C.next.prev=i}else C.prev===g.Undefined&&C.next===g.Undefined?(this._first=g.Undefined,this._last=g.Undefined):C.next===g.Undefined?(this._last=this._last.prev,this._last.next=g.Undefined):C.prev===g.Undefined&&(this._first=this._first.next,this._first.prev=g.Undefined);this._size-=1}*[Symbol.iterator](){let C=this._first;for(;C!==g.Undefined;)yield C.element,C=C.next}}e.LinkedList=L}),function(Y,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(Y=typeof globalThis!="undefined"?globalThis:Y||self,Y.marked=e())}(this,function(){"use strict";function Y(Re,ve){for(var Te=0;Te<ve.length;Te++){var se=ve[Te];se.enumerable=se.enumerable||!1,se.configurable=!0,"value"in se&&(se.writable=!0),Object.defineProperty(Re,se.key,se)}}function e(Re,ve,Te){return ve&&Y(Re.prototype,ve),Te&&Y(Re,Te),Re}function g(Re,ve){if(!!Re){if(typeof Re=="string")return L(Re,ve);var Te=Object.prototype.toString.call(Re).slice(8,-1);if(Te==="Object"&&Re.constructor&&(Te=Re.constructor.name),Te==="Map"||Te==="Set")return Array.from(Re);if(Te==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Te))return L(Re,ve)}}function L(Re,ve){(ve==null||ve>Re.length)&&(ve=Re.length);for(var Te=0,se=new Array(ve);Te<ve;Te++)se[Te]=Re[Te];return se}function y(Re,ve){var Te=typeof Symbol!="undefined"&&Re[Symbol.iterator]||Re["@@iterator"];if(Te)return(Te=Te.call(Re)).next.bind(Te);if(Array.isArray(Re)||(Te=g(Re))||ve&&Re&&typeof Re.length=="number"){Te&&(Re=Te);var se=0;return function(){return se>=Re.length?{done:!0}:{done:!1,value:Re[se++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var C={exports:{}};function i(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function k(Re){C.exports.defaults=Re}C.exports={defaults:i(),getDefaults:i,changeDefaults:k};var _=/[&<>"']/,D=/[&<>"']/g,T=/[<>"']|&(?!#?\w+;)/,I=/[<>"']|&(?!#?\w+;)/g,c={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},p=function(ve){return c[ve]};function f(Re,ve){if(ve){if(_.test(Re))return Re.replace(D,p)}else if(T.test(Re))return Re.replace(I,p);return Re}var v=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function S(Re){return Re.replace(v,function(ve,Te){return Te=Te.toLowerCase(),Te==="colon"?":":Te.charAt(0)==="#"?Te.charAt(1)==="x"?String.fromCharCode(parseInt(Te.substring(2),16)):String.fromCharCode(+Te.substring(1)):""})}var P=/(^|[^\[])\^/g;function w(Re,ve){Re=Re.source||Re,ve=ve||"";var Te={replace:function(ue,be){return be=be.source||be,be=be.replace(P,"$1"),Re=Re.replace(ue,be),Te},getRegex:function(){return new RegExp(Re,ve)}};return Te}var s=/[^\w:]/g,r=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function m(Re,ve,Te){if(Re){var se;try{se=decodeURIComponent(S(Te)).replace(s,"").toLowerCase()}catch(ue){return null}if(se.indexOf("javascript:")===0||se.indexOf("vbscript:")===0||se.indexOf("data:")===0)return null}ve&&!r.test(Te)&&(Te=l(ve,Te));try{Te=encodeURI(Te).replace(/%25/g,"%")}catch(ue){return null}return Te}var a={},b=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,t=/^([^:]+:\/*[^/]*)[\s\S]*$/;function l(Re,ve){a[" "+Re]||(b.test(Re)?a[" "+Re]=Re+"/":a[" "+Re]=u(Re,"/",!0)),Re=a[" "+Re];var Te=Re.indexOf(":")===-1;return ve.substring(0,2)==="//"?Te?ve:Re.replace(n,"$1")+ve:ve.charAt(0)==="/"?Te?ve:Re.replace(t,"$1")+ve:Re+ve}var d={exec:function(){}};function o(Re){for(var ve=1,Te,se;ve<arguments.length;ve++){Te=arguments[ve];for(se in Te)Object.prototype.hasOwnProperty.call(Te,se)&&(Re[se]=Te[se])}return Re}function h(Re,ve){var Te=Re.replace(/\|/g,function(be,we,Fe){for(var qe=!1,ze=we;--ze>=0&&Fe[ze]==="\\";)qe=!qe;return qe?"|":" |"}),se=Te.split(/ \|/),ue=0;if(se[0].trim()||se.shift(),se[se.length-1].trim()||se.pop(),se.length>ve)se.splice(ve);else for(;se.length<ve;)se.push("");for(;ue<se.length;ue++)se[ue]=se[ue].trim().replace(/\\\|/g,"|");return se}function u(Re,ve,Te){var se=Re.length;if(se===0)return"";for(var ue=0;ue<se;){var be=Re.charAt(se-ue-1);if(be===ve&&!Te)ue++;else if(be!==ve&&Te)ue++;else break}return Re.substr(0,se-ue)}function E(Re,ve){if(Re.indexOf(ve[1])===-1)return-1;for(var Te=Re.length,se=0,ue=0;ue<Te;ue++)if(Re[ue]==="\\")ue++;else if(Re[ue]===ve[0])se++;else if(Re[ue]===ve[1]&&(se--,se<0))return ue;return-1}function A(Re){Re&&Re.sanitize&&!Re.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function R(Re,ve){if(ve<1)return"";for(var Te="";ve>1;)ve&1&&(Te+=Re),ve>>=1,Re+=Re;return Te+Re}var B={escape:f,unescape:S,edit:w,cleanUrl:m,resolveUrl:l,noopTest:d,merge:o,splitCells:h,rtrim:u,findClosingBracket:E,checkSanitizeDeprecation:A,repeatString:R},x=C.exports.defaults,F=B.rtrim,$=B.splitCells,M=B.escape,H=B.findClosingBracket;function N(Re,ve,Te,se){var ue=ve.href,be=ve.title?M(ve.title):null,we=Re[1].replace(/\\([\[\]])/g,"$1");if(Re[0].charAt(0)!=="!"){se.state.inLink=!0;var Fe={type:"link",raw:Te,href:ue,title:be,text:we,tokens:se.inlineTokens(we,[])};return se.state.inLink=!1,Fe}else return{type:"image",raw:Te,href:ue,title:be,text:M(we)}}function U(Re,ve){var Te=Re.match(/^(\s+)(?:```)/);if(Te===null)return ve;var se=Te[1];return ve.split(`
`).map(function(ue){var be=ue.match(/^\s+/);if(be===null)return ue;var we=be[0];return we.length>=se.length?ue.slice(se.length):ue}).join(`
`)}var V=function(){function Re(Te){this.options=Te||x}var ve=Re.prototype;return ve.space=function(se){var ue=this.rules.block.newline.exec(se);if(ue)return ue[0].length>1?{type:"space",raw:ue[0]}:{raw:`
`}},ve.code=function(se){var ue=this.rules.block.code.exec(se);if(ue){var be=ue[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ue[0],codeBlockStyle:"indented",text:this.options.pedantic?be:F(be,`
`)}}},ve.fences=function(se){var ue=this.rules.block.fences.exec(se);if(ue){var be=ue[0],we=U(be,ue[3]||"");return{type:"code",raw:be,lang:ue[2]?ue[2].trim():ue[2],text:we}}},ve.heading=function(se){var ue=this.rules.block.heading.exec(se);if(ue){var be=ue[2].trim();if(/#$/.test(be)){var we=F(be,"#");(this.options.pedantic||!we||/ $/.test(we))&&(be=we.trim())}var Fe={type:"heading",raw:ue[0],depth:ue[1].length,text:be,tokens:[]};return this.lexer.inline(Fe.text,Fe.tokens),Fe}},ve.hr=function(se){var ue=this.rules.block.hr.exec(se);if(ue)return{type:"hr",raw:ue[0]}},ve.blockquote=function(se){var ue=this.rules.block.blockquote.exec(se);if(ue){var be=ue[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ue[0],tokens:this.lexer.blockTokens(be,[]),text:be}}},ve.list=function(se){var ue=this.rules.block.list.exec(se);if(ue){var be,we,Fe,qe,ze,Ye,ct,xe,ge,Ee,ae=ue[1].trim(),K=ae.length>1,Ce={type:"list",raw:"",ordered:K,start:K?+ae.slice(0,-1):"",loose:!1,items:[]};ae=K?"\\d{1,9}\\"+ae.slice(-1):"\\"+ae,this.options.pedantic&&(ae=K?ae:"[*+-]");for(var Le=new RegExp("^( {0,3}"+ae+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");se&&!(this.rules.block.hr.test(se)||!(ue=Le.exec(se)));){ge=ue[2].split(`
`),this.options.pedantic?(qe=2,Ee=ge[0].trimLeft()):(qe=ue[2].search(/[^ ]/),qe=ue[1].length+(qe>4?1:qe),Ee=ge[0].slice(qe-ue[1].length)),Ye=!1,be=ue[0],!ge[0]&&/^ *$/.test(ge[1])&&(be=ue[1]+ge.slice(0,2).join(`
`)+`
`,Ce.loose=!0,ge=[]);var it=new RegExp("^ {0,"+Math.min(3,qe-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(ze=1;ze<ge.length;ze++){if(xe=ge[ze],this.options.pedantic&&(xe=xe.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),it.test(xe)){be=ue[1]+ge.slice(0,ze).join(`
`)+`
`;break}if(!Ye){xe.trim()||(Ye=!0),xe.search(/[^ ]/)>=qe?Ee+=`
`+xe.slice(qe):Ee+=`
`+xe;continue}if(xe.search(/[^ ]/)>=qe||!xe.trim()){Ee+=`
`+xe.slice(qe);continue}else{be=ue[1]+ge.slice(0,ze).join(`
`)+`
`;break}}Ce.loose||(ct?Ce.loose=!0:/\n *\n *$/.test(be)&&(ct=!0)),this.options.gfm&&(we=/^\[[ xX]\] /.exec(Ee),we&&(Fe=we[0]!=="[ ] ",Ee=Ee.replace(/^\[[ xX]\] +/,""))),Ce.items.push({type:"list_item",raw:be,task:!!we,checked:Fe,loose:!1,text:Ee}),Ce.raw+=be,se=se.slice(be.length)}Ce.items[Ce.items.length-1].raw=be.trimRight(),Ce.items[Ce.items.length-1].text=Ee.trimRight(),Ce.raw=Ce.raw.trimRight();var Ge=Ce.items.length;for(ze=0;ze<Ge;ze++)this.lexer.state.top=!1,Ce.items[ze].tokens=this.lexer.blockTokens(Ce.items[ze].text,[]),Ce.items[ze].tokens.some(function(mt){return mt.type==="space"})&&(Ce.loose=!0,Ce.items[ze].loose=!0);return Ce}},ve.html=function(se){var ue=this.rules.block.html.exec(se);if(ue){var be={type:"html",raw:ue[0],pre:!this.options.sanitizer&&(ue[1]==="pre"||ue[1]==="script"||ue[1]==="style"),text:ue[0]};return this.options.sanitize&&(be.type="paragraph",be.text=this.options.sanitizer?this.options.sanitizer(ue[0]):M(ue[0]),be.tokens=[],this.lexer.inline(be.text,be.tokens)),be}},ve.def=function(se){var ue=this.rules.block.def.exec(se);if(ue){ue[3]&&(ue[3]=ue[3].substring(1,ue[3].length-1));var be=ue[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:be,raw:ue[0],href:ue[2],title:ue[3]}}},ve.table=function(se){var ue=this.rules.block.table.exec(se);if(ue){var be={type:"table",header:$(ue[1]).map(function(ct){return{text:ct}}),align:ue[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ue[3]?ue[3].replace(/\n$/,"").split(`
`):[]};if(be.header.length===be.align.length){be.raw=ue[0];var we=be.align.length,Fe,qe,ze,Ye;for(Fe=0;Fe<we;Fe++)/^ *-+: *$/.test(be.align[Fe])?be.align[Fe]="right":/^ *:-+: *$/.test(be.align[Fe])?be.align[Fe]="center":/^ *:-+ *$/.test(be.align[Fe])?be.align[Fe]="left":be.align[Fe]=null;for(we=be.rows.length,Fe=0;Fe<we;Fe++)be.rows[Fe]=$(be.rows[Fe],be.header.length).map(function(ct){return{text:ct}});for(we=be.header.length,qe=0;qe<we;qe++)be.header[qe].tokens=[],this.lexer.inlineTokens(be.header[qe].text,be.header[qe].tokens);for(we=be.rows.length,qe=0;qe<we;qe++)for(Ye=be.rows[qe],ze=0;ze<Ye.length;ze++)Ye[ze].tokens=[],this.lexer.inlineTokens(Ye[ze].text,Ye[ze].tokens);return be}}},ve.lheading=function(se){var ue=this.rules.block.lheading.exec(se);if(ue){var be={type:"heading",raw:ue[0],depth:ue[2].charAt(0)==="="?1:2,text:ue[1],tokens:[]};return this.lexer.inline(be.text,be.tokens),be}},ve.paragraph=function(se){var ue=this.rules.block.paragraph.exec(se);if(ue){var be={type:"paragraph",raw:ue[0],text:ue[1].charAt(ue[1].length-1)===`
`?ue[1].slice(0,-1):ue[1],tokens:[]};return this.lexer.inline(be.text,be.tokens),be}},ve.text=function(se){var ue=this.rules.block.text.exec(se);if(ue){var be={type:"text",raw:ue[0],text:ue[0],tokens:[]};return this.lexer.inline(be.text,be.tokens),be}},ve.escape=function(se){var ue=this.rules.inline.escape.exec(se);if(ue)return{type:"escape",raw:ue[0],text:M(ue[1])}},ve.tag=function(se){var ue=this.rules.inline.tag.exec(se);if(ue)return!this.lexer.state.inLink&&/^<a /i.test(ue[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ue[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ue[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ue[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ue[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ue[0]):M(ue[0]):ue[0]}},ve.link=function(se){var ue=this.rules.inline.link.exec(se);if(ue){var be=ue[2].trim();if(!this.options.pedantic&&/^</.test(be)){if(!/>$/.test(be))return;var we=F(be.slice(0,-1),"\\");if((be.length-we.length)%2==0)return}else{var Fe=H(ue[2],"()");if(Fe>-1){var qe=ue[0].indexOf("!")===0?5:4,ze=qe+ue[1].length+Fe;ue[2]=ue[2].substring(0,Fe),ue[0]=ue[0].substring(0,ze).trim(),ue[3]=""}}var Ye=ue[2],ct="";if(this.options.pedantic){var xe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ye);xe&&(Ye=xe[1],ct=xe[3])}else ct=ue[3]?ue[3].slice(1,-1):"";return Ye=Ye.trim(),/^</.test(Ye)&&(this.options.pedantic&&!/>$/.test(be)?Ye=Ye.slice(1):Ye=Ye.slice(1,-1)),N(ue,{href:Ye&&Ye.replace(this.rules.inline._escapes,"$1"),title:ct&&ct.replace(this.rules.inline._escapes,"$1")},ue[0],this.lexer)}},ve.reflink=function(se,ue){var be;if((be=this.rules.inline.reflink.exec(se))||(be=this.rules.inline.nolink.exec(se))){var we=(be[2]||be[1]).replace(/\s+/g," ");if(we=ue[we.toLowerCase()],!we||!we.href){var Fe=be[0].charAt(0);return{type:"text",raw:Fe,text:Fe}}return N(be,we,be[0],this.lexer)}},ve.emStrong=function(se,ue,be){be===void 0&&(be="");var we=this.rules.inline.emStrong.lDelim.exec(se);if(!!we&&!(we[3]&&be.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Fe=we[1]||we[2]||"";if(!Fe||Fe&&(be===""||this.rules.inline.punctuation.exec(be))){var qe=we[0].length-1,ze,Ye,ct=qe,xe=0,ge=we[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ge.lastIndex=0,ue=ue.slice(-1*se.length+qe);(we=ge.exec(ue))!=null;)if(ze=we[1]||we[2]||we[3]||we[4]||we[5]||we[6],!!ze){if(Ye=ze.length,we[3]||we[4]){ct+=Ye;continue}else if((we[5]||we[6])&&qe%3&&!((qe+Ye)%3)){xe+=Ye;continue}if(ct-=Ye,!(ct>0)){if(Ye=Math.min(Ye,Ye+ct+xe),Math.min(qe,Ye)%2){var Ee=se.slice(1,qe+we.index+Ye);return{type:"em",raw:se.slice(0,qe+we.index+Ye+1),text:Ee,tokens:this.lexer.inlineTokens(Ee,[])}}var ae=se.slice(2,qe+we.index+Ye-1);return{type:"strong",raw:se.slice(0,qe+we.index+Ye+1),text:ae,tokens:this.lexer.inlineTokens(ae,[])}}}}}},ve.codespan=function(se){var ue=this.rules.inline.code.exec(se);if(ue){var be=ue[2].replace(/\n/g," "),we=/[^ ]/.test(be),Fe=/^ /.test(be)&&/ $/.test(be);return we&&Fe&&(be=be.substring(1,be.length-1)),be=M(be,!0),{type:"codespan",raw:ue[0],text:be}}},ve.br=function(se){var ue=this.rules.inline.br.exec(se);if(ue)return{type:"br",raw:ue[0]}},ve.del=function(se){var ue=this.rules.inline.del.exec(se);if(ue)return{type:"del",raw:ue[0],text:ue[2],tokens:this.lexer.inlineTokens(ue[2],[])}},ve.autolink=function(se,ue){var be=this.rules.inline.autolink.exec(se);if(be){var we,Fe;return be[2]==="@"?(we=M(this.options.mangle?ue(be[1]):be[1]),Fe="mailto:"+we):(we=M(be[1]),Fe=we),{type:"link",raw:be[0],text:we,href:Fe,tokens:[{type:"text",raw:we,text:we}]}}},ve.url=function(se,ue){var be;if(be=this.rules.inline.url.exec(se)){var we,Fe;if(be[2]==="@")we=M(this.options.mangle?ue(be[0]):be[0]),Fe="mailto:"+we;else{var qe;do qe=be[0],be[0]=this.rules.inline._backpedal.exec(be[0])[0];while(qe!==be[0]);we=M(be[0]),be[1]==="www."?Fe="http://"+we:Fe=we}return{type:"link",raw:be[0],text:we,href:Fe,tokens:[{type:"text",raw:we,text:we}]}}},ve.inlineText=function(se,ue){var be=this.rules.inline.text.exec(se);if(be){var we;return this.lexer.state.inRawBlock?we=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(be[0]):M(be[0]):be[0]:we=M(this.options.smartypants?ue(be[0]):be[0]),{type:"text",raw:be[0],text:we}}},Re}(),O=B.noopTest,W=B.edit,j=B.merge,X={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:O,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};X._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,X._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,X.def=W(X.def).replace("label",X._label).replace("title",X._title).getRegex(),X.bullet=/(?:[*+-]|\d{1,9}[.)])/,X.listItemStart=W(/^( *)(bull) */).replace("bull",X.bullet).getRegex(),X.list=W(X.list).replace(/bull/g,X.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+X.def.source+")").getRegex(),X._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",X._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,X.html=W(X.html,"i").replace("comment",X._comment).replace("tag",X._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),X.paragraph=W(X._paragraph).replace("hr",X.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",X._tag).getRegex(),X.blockquote=W(X.blockquote).replace("paragraph",X.paragraph).getRegex(),X.normal=j({},X),X.gfm=j({},X.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),X.gfm.table=W(X.gfm.table).replace("hr",X.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",X._tag).getRegex(),X.pedantic=j({},X.normal,{html:W(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",X._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:O,paragraph:W(X.normal._paragraph).replace("hr",X.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",X.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var Q={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:O,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:O,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};Q._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",Q.punctuation=W(Q.punctuation).replace(/punctuation/g,Q._punctuation).getRegex(),Q.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,Q.escapedEmSt=/\\\*|\\_/g,Q._comment=W(X._comment).replace("(?:-->|$)","-->").getRegex(),Q.emStrong.lDelim=W(Q.emStrong.lDelim).replace(/punct/g,Q._punctuation).getRegex(),Q.emStrong.rDelimAst=W(Q.emStrong.rDelimAst,"g").replace(/punct/g,Q._punctuation).getRegex(),Q.emStrong.rDelimUnd=W(Q.emStrong.rDelimUnd,"g").replace(/punct/g,Q._punctuation).getRegex(),Q._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,Q._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,Q._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,Q.autolink=W(Q.autolink).replace("scheme",Q._scheme).replace("email",Q._email).getRegex(),Q._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,Q.tag=W(Q.tag).replace("comment",Q._comment).replace("attribute",Q._attribute).getRegex(),Q._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,Q._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,Q._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,Q.link=W(Q.link).replace("label",Q._label).replace("href",Q._href).replace("title",Q._title).getRegex(),Q.reflink=W(Q.reflink).replace("label",Q._label).getRegex(),Q.reflinkSearch=W(Q.reflinkSearch,"g").replace("reflink",Q.reflink).replace("nolink",Q.nolink).getRegex(),Q.normal=j({},Q),Q.pedantic=j({},Q.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:W(/^!?\[(label)\]\((.*?)\)/).replace("label",Q._label).getRegex(),reflink:W(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",Q._label).getRegex()}),Q.gfm=j({},Q.normal,{escape:W(Q.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),Q.gfm.url=W(Q.gfm.url,"i").replace("email",Q.gfm._extended_email).getRegex(),Q.breaks=j({},Q.gfm,{br:W(Q.br).replace("{2,}","*").getRegex(),text:W(Q.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var de={block:X,inline:Q},Se=V,De=C.exports.defaults,Pe=de.block,Be=de.inline,We=B.repeatString;function He(Re){return Re.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function G(Re){var ve="",Te,se,ue=Re.length;for(Te=0;Te<ue;Te++)se=Re.charCodeAt(Te),Math.random()>.5&&(se="x"+se.toString(16)),ve+="&#"+se+";";return ve}var ee=function(){function Re(Te){this.tokens=[],this.tokens.links=Object.create(null),this.options=Te||De,this.options.tokenizer=this.options.tokenizer||new Se,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var se={block:Pe.normal,inline:Be.normal};this.options.pedantic?(se.block=Pe.pedantic,se.inline=Be.pedantic):this.options.gfm&&(se.block=Pe.gfm,this.options.breaks?se.inline=Be.breaks:se.inline=Be.gfm),this.tokenizer.rules=se}Re.lex=function(se,ue){var be=new Re(ue);return be.lex(se)},Re.lexInline=function(se,ue){var be=new Re(ue);return be.inlineTokens(se)};var ve=Re.prototype;return ve.lex=function(se){se=se.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(se,this.tokens);for(var ue;ue=this.inlineQueue.shift();)this.inlineTokens(ue.src,ue.tokens);return this.tokens},ve.blockTokens=function(se,ue){var be=this;ue===void 0&&(ue=[]),this.options.pedantic&&(se=se.replace(/^ +$/gm,""));for(var we,Fe,qe,ze;se;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ct){return(we=ct.call({lexer:be},se,ue))?(se=se.substring(we.raw.length),ue.push(we),!0):!1}))){if(we=this.tokenizer.space(se)){se=se.substring(we.raw.length),we.type&&ue.push(we);continue}if(we=this.tokenizer.code(se)){se=se.substring(we.raw.length),Fe=ue[ue.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.text,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):ue.push(we);continue}if(we=this.tokenizer.fences(se)){se=se.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.heading(se)){se=se.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.hr(se)){se=se.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.blockquote(se)){se=se.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.list(se)){se=se.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.html(se)){se=se.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.def(se)){se=se.substring(we.raw.length),Fe=ue[ue.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.raw,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):this.tokens.links[we.tag]||(this.tokens.links[we.tag]={href:we.href,title:we.title});continue}if(we=this.tokenizer.table(se)){se=se.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.lheading(se)){se=se.substring(we.raw.length),ue.push(we);continue}if(qe=se,this.options.extensions&&this.options.extensions.startBlock&&function(){var ct=Infinity,xe=se.slice(1),ge=void 0;be.options.extensions.startBlock.forEach(function(Ee){ge=Ee.call({lexer:this},xe),typeof ge=="number"&&ge>=0&&(ct=Math.min(ct,ge))}),ct<Infinity&&ct>=0&&(qe=se.substring(0,ct+1))}(),this.state.top&&(we=this.tokenizer.paragraph(qe))){Fe=ue[ue.length-1],ze&&Fe.type==="paragraph"?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):ue.push(we),ze=qe.length!==se.length,se=se.substring(we.raw.length);continue}if(we=this.tokenizer.text(se)){se=se.substring(we.raw.length),Fe=ue[ue.length-1],Fe&&Fe.type==="text"?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):ue.push(we);continue}if(se){var Ye="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(Ye);break}else throw new Error(Ye)}}return this.state.top=!0,ue},ve.inline=function(se,ue){this.inlineQueue.push({src:se,tokens:ue})},ve.inlineTokens=function(se,ue){var be=this;ue===void 0&&(ue=[]);var we,Fe,qe,ze=se,Ye,ct,xe;if(this.tokens.links){var ge=Object.keys(this.tokens.links);if(ge.length>0)for(;(Ye=this.tokenizer.rules.inline.reflinkSearch.exec(ze))!=null;)ge.includes(Ye[0].slice(Ye[0].lastIndexOf("[")+1,-1))&&(ze=ze.slice(0,Ye.index)+"["+We("a",Ye[0].length-2)+"]"+ze.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ye=this.tokenizer.rules.inline.blockSkip.exec(ze))!=null;)ze=ze.slice(0,Ye.index)+"["+We("a",Ye[0].length-2)+"]"+ze.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ye=this.tokenizer.rules.inline.escapedEmSt.exec(ze))!=null;)ze=ze.slice(0,Ye.index)+"++"+ze.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;se;)if(ct||(xe=""),ct=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ae){return(we=ae.call({lexer:be},se,ue))?(se=se.substring(we.raw.length),ue.push(we),!0):!1}))){if(we=this.tokenizer.escape(se)){se=se.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.tag(se)){se=se.substring(we.raw.length),Fe=ue[ue.length-1],Fe&&we.type==="text"&&Fe.type==="text"?(Fe.raw+=we.raw,Fe.text+=we.text):ue.push(we);continue}if(we=this.tokenizer.link(se)){se=se.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.reflink(se,this.tokens.links)){se=se.substring(we.raw.length),Fe=ue[ue.length-1],Fe&&we.type==="text"&&Fe.type==="text"?(Fe.raw+=we.raw,Fe.text+=we.text):ue.push(we);continue}if(we=this.tokenizer.emStrong(se,ze,xe)){se=se.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.codespan(se)){se=se.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.br(se)){se=se.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.del(se)){se=se.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.autolink(se,G)){se=se.substring(we.raw.length),ue.push(we);continue}if(!this.state.inLink&&(we=this.tokenizer.url(se,G))){se=se.substring(we.raw.length),ue.push(we);continue}if(qe=se,this.options.extensions&&this.options.extensions.startInline&&function(){var ae=Infinity,K=se.slice(1),Ce=void 0;be.options.extensions.startInline.forEach(function(Le){Ce=Le.call({lexer:this},K),typeof Ce=="number"&&Ce>=0&&(ae=Math.min(ae,Ce))}),ae<Infinity&&ae>=0&&(qe=se.substring(0,ae+1))}(),we=this.tokenizer.inlineText(qe,He)){se=se.substring(we.raw.length),we.raw.slice(-1)!=="_"&&(xe=we.raw.slice(-1)),ct=!0,Fe=ue[ue.length-1],Fe&&Fe.type==="text"?(Fe.raw+=we.raw,Fe.text+=we.text):ue.push(we);continue}if(se){var Ee="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(Ee);break}else throw new Error(Ee)}}return ue},e(Re,null,[{key:"rules",get:function(){return{block:Pe,inline:Be}}}]),Re}(),ie=C.exports.defaults,le=B.cleanUrl,Z=B.escape,re=function(){function Re(Te){this.options=Te||ie}var ve=Re.prototype;return ve.code=function(se,ue,be){var we=(ue||"").match(/\S*/)[0];if(this.options.highlight){var Fe=this.options.highlight(se,we);Fe!=null&&Fe!==se&&(be=!0,se=Fe)}return se=se.replace(/\n$/,"")+`
`,we?'<pre><code class="'+this.options.langPrefix+Z(we,!0)+'">'+(be?se:Z(se,!0))+`</code></pre>
`:"<pre><code>"+(be?se:Z(se,!0))+`</code></pre>
`},ve.blockquote=function(se){return`<blockquote>
`+se+`</blockquote>
`},ve.html=function(se){return se},ve.heading=function(se,ue,be,we){return this.options.headerIds?"<h"+ue+' id="'+this.options.headerPrefix+we.slug(be)+'">'+se+"</h"+ue+`>
`:"<h"+ue+">"+se+"</h"+ue+`>
`},ve.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ve.list=function(se,ue,be){var we=ue?"ol":"ul",Fe=ue&&be!==1?' start="'+be+'"':"";return"<"+we+Fe+`>
`+se+"</"+we+`>
`},ve.listitem=function(se){return"<li>"+se+`</li>
`},ve.checkbox=function(se){return"<input "+(se?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ve.paragraph=function(se){return"<p>"+se+`</p>
`},ve.table=function(se,ue){return ue&&(ue="<tbody>"+ue+"</tbody>"),`<table>
<thead>
`+se+`</thead>
`+ue+`</table>
`},ve.tablerow=function(se){return`<tr>
`+se+`</tr>
`},ve.tablecell=function(se,ue){var be=ue.header?"th":"td",we=ue.align?"<"+be+' align="'+ue.align+'">':"<"+be+">";return we+se+"</"+be+`>
`},ve.strong=function(se){return"<strong>"+se+"</strong>"},ve.em=function(se){return"<em>"+se+"</em>"},ve.codespan=function(se){return"<code>"+se+"</code>"},ve.br=function(){return this.options.xhtml?"<br/>":"<br>"},ve.del=function(se){return"<del>"+se+"</del>"},ve.link=function(se,ue,be){if(se=le(this.options.sanitize,this.options.baseUrl,se),se===null)return be;var we='<a href="'+Z(se)+'"';return ue&&(we+=' title="'+ue+'"'),we+=">"+be+"</a>",we},ve.image=function(se,ue,be){if(se=le(this.options.sanitize,this.options.baseUrl,se),se===null)return be;var we='<img src="'+se+'" alt="'+be+'"';return ue&&(we+=' title="'+ue+'"'),we+=this.options.xhtml?"/>":">",we},ve.text=function(se){return se},Re}(),pe=function(){function Re(){}var ve=Re.prototype;return ve.strong=function(se){return se},ve.em=function(se){return se},ve.codespan=function(se){return se},ve.del=function(se){return se},ve.html=function(se){return se},ve.text=function(se){return se},ve.link=function(se,ue,be){return""+be},ve.image=function(se,ue,be){return""+be},ve.br=function(){return""},Re}(),Me=function(){function Re(){this.seen={}}var ve=Re.prototype;return ve.serialize=function(se){return se.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ve.getNextSafeSlug=function(se,ue){var be=se,we=0;if(this.seen.hasOwnProperty(be)){we=this.seen[se];do we++,be=se+"-"+we;while(this.seen.hasOwnProperty(be))}return ue||(this.seen[se]=we,this.seen[be]=0),be},ve.slug=function(se,ue){ue===void 0&&(ue={});var be=this.serialize(se);return this.getNextSafeSlug(be,ue.dryrun)},Re}(),je=re,Ke=pe,Ze=Me,rt=C.exports.defaults,lt=B.unescape,ye=function(){function Re(Te){this.options=Te||rt,this.options.renderer=this.options.renderer||new je,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Ke,this.slugger=new Ze}Re.parse=function(se,ue){var be=new Re(ue);return be.parse(se)},Re.parseInline=function(se,ue){var be=new Re(ue);return be.parseInline(se)};var ve=Re.prototype;return ve.parse=function(se,ue){ue===void 0&&(ue=!0);var be="",we,Fe,qe,ze,Ye,ct,xe,ge,Ee,ae,K,Ce,Le,it,Ge,mt,yt,_t,gt,bt=se.length;for(we=0;we<bt;we++){if(ae=se[we],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ae.type]&&(gt=this.options.extensions.renderers[ae.type].call({parser:this},ae),gt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ae.type))){be+=gt||"";continue}switch(ae.type){case"space":continue;case"hr":{be+=this.renderer.hr();continue}case"heading":{be+=this.renderer.heading(this.parseInline(ae.tokens),ae.depth,lt(this.parseInline(ae.tokens,this.textRenderer)),this.slugger);continue}case"code":{be+=this.renderer.code(ae.text,ae.lang,ae.escaped);continue}case"table":{for(ge="",xe="",ze=ae.header.length,Fe=0;Fe<ze;Fe++)xe+=this.renderer.tablecell(this.parseInline(ae.header[Fe].tokens),{header:!0,align:ae.align[Fe]});for(ge+=this.renderer.tablerow(xe),Ee="",ze=ae.rows.length,Fe=0;Fe<ze;Fe++){for(ct=ae.rows[Fe],xe="",Ye=ct.length,qe=0;qe<Ye;qe++)xe+=this.renderer.tablecell(this.parseInline(ct[qe].tokens),{header:!1,align:ae.align[qe]});Ee+=this.renderer.tablerow(xe)}be+=this.renderer.table(ge,Ee);continue}case"blockquote":{Ee=this.parse(ae.tokens),be+=this.renderer.blockquote(Ee);continue}case"list":{for(K=ae.ordered,Ce=ae.start,Le=ae.loose,ze=ae.items.length,Ee="",Fe=0;Fe<ze;Fe++)Ge=ae.items[Fe],mt=Ge.checked,yt=Ge.task,it="",Ge.task&&(_t=this.renderer.checkbox(mt),Le?Ge.tokens.length>0&&Ge.tokens[0].type==="paragraph"?(Ge.tokens[0].text=_t+" "+Ge.tokens[0].text,Ge.tokens[0].tokens&&Ge.tokens[0].tokens.length>0&&Ge.tokens[0].tokens[0].type==="text"&&(Ge.tokens[0].tokens[0].text=_t+" "+Ge.tokens[0].tokens[0].text)):Ge.tokens.unshift({type:"text",text:_t}):it+=_t),it+=this.parse(Ge.tokens,Le),Ee+=this.renderer.listitem(it,yt,mt);be+=this.renderer.list(Ee,K,Ce);continue}case"html":{be+=this.renderer.html(ae.text);continue}case"paragraph":{be+=this.renderer.paragraph(this.parseInline(ae.tokens));continue}case"text":{for(Ee=ae.tokens?this.parseInline(ae.tokens):ae.text;we+1<bt&&se[we+1].type==="text";)ae=se[++we],Ee+=`
`+(ae.tokens?this.parseInline(ae.tokens):ae.text);be+=ue?this.renderer.paragraph(Ee):Ee;continue}default:{var vt='Token with "'+ae.type+'" type was not found.';if(this.options.silent){console.error(vt);return}else throw new Error(vt)}}}return be},ve.parseInline=function(se,ue){ue=ue||this.renderer;var be="",we,Fe,qe,ze=se.length;for(we=0;we<ze;we++){if(Fe=se[we],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Fe.type]&&(qe=this.options.extensions.renderers[Fe.type].call({parser:this},Fe),qe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Fe.type))){be+=qe||"";continue}switch(Fe.type){case"escape":{be+=ue.text(Fe.text);break}case"html":{be+=ue.html(Fe.text);break}case"link":{be+=ue.link(Fe.href,Fe.title,this.parseInline(Fe.tokens,ue));break}case"image":{be+=ue.image(Fe.href,Fe.title,Fe.text);break}case"strong":{be+=ue.strong(this.parseInline(Fe.tokens,ue));break}case"em":{be+=ue.em(this.parseInline(Fe.tokens,ue));break}case"codespan":{be+=ue.codespan(Fe.text);break}case"br":{be+=ue.br();break}case"del":{be+=ue.del(this.parseInline(Fe.tokens,ue));break}case"text":{be+=ue.text(Fe.text);break}default:{var Ye='Token with "'+Fe.type+'" type was not found.';if(this.options.silent){console.error(Ye);return}else throw new Error(Ye)}}}return be},Re}(),at=ee,J=ye,ne=V,_e=re,Qe=pe,et=Me,ce=B.merge,Ie=B.checkSanitizeDeprecation,Ue=B.escape,Xe=C.exports.getDefaults,nt=C.exports.changeDefaults,ft=C.exports.defaults;function tt(Re,ve,Te){if(typeof Re=="undefined"||Re===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Re!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Re)+", string expected");if(typeof ve=="function"&&(Te=ve,ve=null),ve=ce({},tt.defaults,ve||{}),Ie(ve),Te){var se=ve.highlight,ue;try{ue=at.lex(Re,ve)}catch(qe){return Te(qe)}var be=function(ze){var Ye;if(!ze)try{ve.walkTokens&&tt.walkTokens(ue,ve.walkTokens),Ye=J.parse(ue,ve)}catch(ct){ze=ct}return ve.highlight=se,ze?Te(ze):Te(null,Ye)};if(!se||se.length<3||(delete ve.highlight,!ue.length))return be();var we=0;tt.walkTokens(ue,function(qe){qe.type==="code"&&(we++,setTimeout(function(){se(qe.text,qe.lang,function(ze,Ye){if(ze)return be(ze);Ye!=null&&Ye!==qe.text&&(qe.text=Ye,qe.escaped=!0),we--,we===0&&be()})},0))}),we===0&&be();return}try{var Fe=at.lex(Re,ve);return ve.walkTokens&&tt.walkTokens(Fe,ve.walkTokens),J.parse(Fe,ve)}catch(qe){if(qe.message+=`
Please report this to https://github.com/markedjs/marked.`,ve.silent)return"<p>An error occurred:</p><pre>"+Ue(qe.message+"",!0)+"</pre>";throw qe}}tt.options=tt.setOptions=function(Re){return ce(tt.defaults,Re),nt(tt.defaults),tt},tt.getDefaults=Xe,tt.defaults=ft,tt.use=function(){for(var Re=this,ve=arguments.length,Te=new Array(ve),se=0;se<ve;se++)Te[se]=arguments[se];var ue=ce.apply(void 0,[{}].concat(Te)),be=tt.defaults.extensions||{renderers:{},childTokens:{}},we;Te.forEach(function(Fe){if(Fe.extensions&&(we=!0,Fe.extensions.forEach(function(ze){if(!ze.name)throw new Error("extension name required");if(ze.renderer){var Ye=be.renderers?be.renderers[ze.name]:null;Ye?be.renderers[ze.name]=function(){for(var ct=arguments.length,xe=new Array(ct),ge=0;ge<ct;ge++)xe[ge]=arguments[ge];var Ee=ze.renderer.apply(this,xe);return Ee===!1&&(Ee=Ye.apply(this,xe)),Ee}:be.renderers[ze.name]=ze.renderer}if(ze.tokenizer){if(!ze.level||ze.level!=="block"&&ze.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");be[ze.level]?be[ze.level].unshift(ze.tokenizer):be[ze.level]=[ze.tokenizer],ze.start&&(ze.level==="block"?be.startBlock?be.startBlock.push(ze.start):be.startBlock=[ze.start]:ze.level==="inline"&&(be.startInline?be.startInline.push(ze.start):be.startInline=[ze.start]))}ze.childTokens&&(be.childTokens[ze.name]=ze.childTokens)})),Fe.renderer&&function(){var ze=tt.defaults.renderer||new _e,Ye=function(ge){var Ee=ze[ge];ze[ge]=function(){for(var ae=arguments.length,K=new Array(ae),Ce=0;Ce<ae;Ce++)K[Ce]=arguments[Ce];var Le=Fe.renderer[ge].apply(ze,K);return Le===!1&&(Le=Ee.apply(ze,K)),Le}};for(var ct in Fe.renderer)Ye(ct);ue.renderer=ze}(),Fe.tokenizer&&function(){var ze=tt.defaults.tokenizer||new ne,Ye=function(ge){var Ee=ze[ge];ze[ge]=function(){for(var ae=arguments.length,K=new Array(ae),Ce=0;Ce<ae;Ce++)K[Ce]=arguments[Ce];var Le=Fe.tokenizer[ge].apply(ze,K);return Le===!1&&(Le=Ee.apply(ze,K)),Le}};for(var ct in Fe.tokenizer)Ye(ct);ue.tokenizer=ze}(),Fe.walkTokens){var qe=tt.defaults.walkTokens;ue.walkTokens=function(ze){Fe.walkTokens.call(Re,ze),qe&&qe(ze)}}we&&(ue.extensions=be),tt.setOptions(ue)})},tt.walkTokens=function(Re,ve){for(var Te=function(){var we=ue.value;switch(ve(we),we.type){case"table":{for(var Fe=y(we.header),qe;!(qe=Fe()).done;){var ze=qe.value;tt.walkTokens(ze.tokens,ve)}for(var Ye=y(we.rows),ct;!(ct=Ye()).done;)for(var xe=ct.value,ge=y(xe),Ee;!(Ee=ge()).done;){var ae=Ee.value;tt.walkTokens(ae.tokens,ve)}break}case"list":{tt.walkTokens(we.items,ve);break}default:tt.defaults.extensions&&tt.defaults.extensions.childTokens&&tt.defaults.extensions.childTokens[we.type]?tt.defaults.extensions.childTokens[we.type].forEach(function(K){tt.walkTokens(we[K],ve)}):we.tokens&&tt.walkTokens(we.tokens,ve)}},se=y(Re),ue;!(ue=se()).done;)Te()},tt.parseInline=function(Re,ve){if(typeof Re=="undefined"||Re===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Re!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Re)+", string expected");ve=ce({},tt.defaults,ve||{}),Ie(ve);try{var Te=at.lexInline(Re,ve);return ve.walkTokens&&tt.walkTokens(Te,ve.walkTokens),J.parseInline(Te,ve)}catch(se){if(se.message+=`
Please report this to https://github.com/markedjs/marked.`,ve.silent)return"<p>An error occurred:</p><pre>"+Ue(se.message+"",!0)+"</pre>";throw se}},tt.Parser=J,tt.parser=J.parse,tt.Renderer=_e,tt.TextRenderer=Qe,tt.Lexer=at,tt.lexer=at.lex,tt.Tokenizer=ne,tt.Slugger=et,tt.parse=tt;var ut=tt;return ut}),define(fe[79],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function g(i,k,_){return Math.min(Math.max(i,k),_)}e.clamp=g;function L(i,k){return(k+i%k)%k}e.rot=L;class y{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=y;class C{constructor(){this._n=1,this._val=0}update(k){return this._val=this._val+(k-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=C}),function(){function Y(y){const C=[];typeof y=="number"&&C.push("code/timeOrigin",y);function i(_){C.push(_,Date.now())}function k(){const _=[];for(let D=0;D<C.length;D+=2)_.push({name:C[D],startTime:C[D+1]});return _}return{mark:i,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?Y():{mark(y){performance.mark(y)},getMarks(){let y=performance.timeOrigin;typeof y!="number"&&(y=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const C=[{name:"code/timeOrigin",startTime:Math.round(y)}];for(const i of performance.getEntriesByType("mark"))C.push({name:i.name,startTime:Math.round(y+i.startTime)});return C}};if(typeof process=="object"){const y=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Y(y)}else return console.trace("perf-util loaded in UNKNOWN environment"),Y()}function g(y){return y.MonacoPerformanceMarks||(y.MonacoPerformanceMarks=e()),y.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return g(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=g(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=g(L))}(),define(fe[12],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const g="en";let L=!1,y=!1,C=!1,i=!1,k=!1,_=!1,D=!1,T,I=g,c,p;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let f;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?f=e.globals.vscode.process:typeof process!="undefined"&&(f=process);const v=typeof f?.versions?.electron=="string"&&f.type==="renderer";if(e.isElectronSandboxed=v&&f?.sandboxed,typeof navigator=="object"&&!v)p=navigator.userAgent,L=p.indexOf("Windows")>=0,y=p.indexOf("Macintosh")>=0,D=(p.indexOf("Macintosh")>=0||p.indexOf("iPad")>=0||p.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,C=p.indexOf("Linux")>=0,_=!0,T=navigator.language,I=T;else if(typeof f=="object"){L=f.platform==="win32",y=f.platform==="darwin",C=f.platform==="linux",i=C&&!!f.env.SNAP&&!!f.env.SNAP_REVISION,T=g,I=g;const n=f.env.VSCODE_NLS_CONFIG;if(n)try{const t=JSON.parse(n),l=t.availableLanguages["*"];T=t.locale,I=l||g,c=t._translationsConfigFile}catch(t){}k=!0}else console.error("Unable to resolve platform.");var S;(function(n){n[n.Web=0]="Web",n[n.Mac=1]="Mac",n[n.Linux=2]="Linux",n[n.Windows=3]="Windows"})(S=e.Platform||(e.Platform={}));function P(n){switch(n){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=P;let w=0;y?w=1:L?w=3:C&&(w=2),e.isWindows=L,e.isMacintosh=y,e.isLinux=C,e.isLinuxSnap=i,e.isNative=k,e.isWeb=_,e.isIOS=D,e.platform=w,e.userAgent=p,e.language=I;var s;(function(n){function t(){return e.language}n.value=t;function l(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}n.isDefaultVariant=l;function d(){return e.language==="en"}n.isDefault=d})(s=e.Language||(e.Language={})),e.locale=T,e.translationsConfigFile=c,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let l=[];e.globals.addEventListener("message",o=>{if(o.data&&o.data.vscodeSetImmediateId)for(let h=0,u=l.length;h<u;h++){const E=l[h];if(E.id===o.data.vscodeSetImmediateId){l.splice(h,1),E.callback();return}}});let d=0;return o=>{const h=++d;l.push({id:h,callback:o}),e.globals.postMessage({vscodeSetImmediateId:h},"*")}}if(typeof f?.nextTick=="function")return f.nextTick.bind(f);const t=Promise.resolve();return l=>t.then(l)}();var r;(function(n){n[n.Windows=1]="Windows",n[n.Macintosh=2]="Macintosh",n[n.Linux=3]="Linux"})(r=e.OperatingSystem||(e.OperatingSystem={})),e.OS=y||D?2:L?1:3;let m=!0,a=!1;function b(){if(!a){a=!0;const n=new Uint8Array(2);n[0]=1,n[1]=2,m=new Uint16Array(n.buffer)[0]===(2<<8)+1}return m}e.isLittleEndian=b}),define(fe[38],me([0,1,12]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.nextTick=e.platform=e.env=e.cwd=void 0;let L;if(typeof g.globals.vscode!="undefined"&&typeof g.globals.vscode.process!="undefined"){const y=g.globals.vscode.process;L={get platform(){return y.platform},get arch(){return y.arch},get env(){return y.env},cwd(){return y.cwd()},nextTick(C){return(0,g.setImmediate)(C)}}}else typeof process!="undefined"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(y){return process.nextTick(y)}}:L={get platform(){return g.isWindows?"win32":g.isMacintosh?"darwin":"linux"},get arch(){},nextTick(y){return(0,g.setImmediate)(y)},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.nextTick=L.nextTick,e.arch=L.arch}),define(fe[9],me([0,1,38]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,y=97,C=90,i=122,k=46,_=47,D=92,T=58,I=63;class c extends Error{constructor(r,m,a){let b;typeof m=="string"&&m.indexOf("not ")===0?(b="must not be",m=m.replace(/^not /,"")):b="must be";const n=r.indexOf(".")!==-1?"property":"argument";let t=`The "${r}" ${n} ${b} of type ${m}`;t+=`. Received type ${typeof a}`,super(t),this.code="ERR_INVALID_ARG_TYPE"}}function p(s,r){if(typeof s!="string")throw new c(r,"string",s)}function f(s){return s===_||s===D}function v(s){return s===_}function S(s){return s>=L&&s<=C||s>=y&&s<=i}function P(s,r,m,a){let b="",n=0,t=-1,l=0,d=0;for(let o=0;o<=s.length;++o){if(o<s.length)d=s.charCodeAt(o);else{if(a(d))break;d=_}if(a(d)){if(!(t===o-1||l===1))if(l===2){if(b.length<2||n!==2||b.charCodeAt(b.length-1)!==k||b.charCodeAt(b.length-2)!==k){if(b.length>2){const h=b.lastIndexOf(m);h===-1?(b="",n=0):(b=b.slice(0,h),n=b.length-1-b.lastIndexOf(m)),t=o,l=0;continue}else if(b.length!==0){b="",n=0,t=o,l=0;continue}}r&&(b+=b.length>0?`${m}..`:"..",n=2)}else b.length>0?b+=`${m}${s.slice(t+1,o)}`:b=s.slice(t+1,o),n=o-t-1;t=o,l=0}else d===k&&l!==-1?++l:l=-1}return b}function w(s,r){if(r===null||typeof r!="object")throw new c("pathObject","Object",r);const m=r.dir||r.root,a=r.base||`${r.name||""}${r.ext||""}`;return m?m===r.root?`${m}${a}`:`${m}${s}${a}`:a}e.win32={resolve(...s){let r="",m="",a=!1;for(let b=s.length-1;b>=-1;b--){let n;if(b>=0){if(n=s[b],p(n,"path"),n.length===0)continue}else r.length===0?n=g.cwd():(n=g.env[`=${r}`]||g.cwd(),(n===void 0||n.slice(0,2).toLowerCase()!==r.toLowerCase()&&n.charCodeAt(2)===D)&&(n=`${r}\\`));const t=n.length;let l=0,d="",o=!1;const h=n.charCodeAt(0);if(t===1)f(h)&&(l=1,o=!0);else if(f(h))if(o=!0,f(n.charCodeAt(1))){let u=2,E=u;for(;u<t&&!f(n.charCodeAt(u));)u++;if(u<t&&u!==E){const A=n.slice(E,u);for(E=u;u<t&&f(n.charCodeAt(u));)u++;if(u<t&&u!==E){for(E=u;u<t&&!f(n.charCodeAt(u));)u++;(u===t||u!==E)&&(d=`\\\\${A}\\${n.slice(E,u)}`,l=u)}}}else l=1;else S(h)&&n.charCodeAt(1)===T&&(d=n.slice(0,2),l=2,t>2&&f(n.charCodeAt(2))&&(o=!0,l=3));if(d.length>0)if(r.length>0){if(d.toLowerCase()!==r.toLowerCase())continue}else r=d;if(a){if(r.length>0)break}else if(m=`${n.slice(l)}\\${m}`,a=o,o&&r.length>0)break}return m=P(m,!a,"\\",f),a?`${r}\\${m}`:`${r}${m}`||"."},normalize(s){p(s,"path");const r=s.length;if(r===0)return".";let m=0,a,b=!1;const n=s.charCodeAt(0);if(r===1)return v(n)?"\\":s;if(f(n))if(b=!0,f(s.charCodeAt(1))){let l=2,d=l;for(;l<r&&!f(s.charCodeAt(l));)l++;if(l<r&&l!==d){const o=s.slice(d,l);for(d=l;l<r&&f(s.charCodeAt(l));)l++;if(l<r&&l!==d){for(d=l;l<r&&!f(s.charCodeAt(l));)l++;if(l===r)return`\\\\${o}\\${s.slice(d)}\\`;l!==d&&(a=`\\\\${o}\\${s.slice(d,l)}`,m=l)}}}else m=1;else S(n)&&s.charCodeAt(1)===T&&(a=s.slice(0,2),m=2,r>2&&f(s.charCodeAt(2))&&(b=!0,m=3));let t=m<r?P(s.slice(m),!b,"\\",f):"";return t.length===0&&!b&&(t="."),t.length>0&&f(s.charCodeAt(r-1))&&(t+="\\"),a===void 0?b?`\\${t}`:t:b?`${a}\\${t}`:`${a}${t}`},isAbsolute(s){p(s,"path");const r=s.length;if(r===0)return!1;const m=s.charCodeAt(0);return f(m)||r>2&&S(m)&&s.charCodeAt(1)===T&&f(s.charCodeAt(2))},join(...s){if(s.length===0)return".";let r,m;for(let n=0;n<s.length;++n){const t=s[n];p(t,"path"),t.length>0&&(r===void 0?r=m=t:r+=`\\${t}`)}if(r===void 0)return".";let a=!0,b=0;if(typeof m=="string"&&f(m.charCodeAt(0))){++b;const n=m.length;n>1&&f(m.charCodeAt(1))&&(++b,n>2&&(f(m.charCodeAt(2))?++b:a=!1))}if(a){for(;b<r.length&&f(r.charCodeAt(b));)b++;b>=2&&(r=`\\${r.slice(b)}`)}return e.win32.normalize(r)},relative(s,r){if(p(s,"from"),p(r,"to"),s===r)return"";const m=e.win32.resolve(s),a=e.win32.resolve(r);if(m===a||(s=m.toLowerCase(),r=a.toLowerCase(),s===r))return"";let b=0;for(;b<s.length&&s.charCodeAt(b)===D;)b++;let n=s.length;for(;n-1>b&&s.charCodeAt(n-1)===D;)n--;const t=n-b;let l=0;for(;l<r.length&&r.charCodeAt(l)===D;)l++;let d=r.length;for(;d-1>l&&r.charCodeAt(d-1)===D;)d--;const o=d-l,h=t<o?t:o;let u=-1,E=0;for(;E<h;E++){const R=s.charCodeAt(b+E);if(R!==r.charCodeAt(l+E))break;R===D&&(u=E)}if(E!==h){if(u===-1)return a}else{if(o>h){if(r.charCodeAt(l+E)===D)return a.slice(l+E+1);if(E===2)return a.slice(l+E)}t>h&&(s.charCodeAt(b+E)===D?u=E:E===2&&(u=3)),u===-1&&(u=0)}let A="";for(E=b+u+1;E<=n;++E)(E===n||s.charCodeAt(E)===D)&&(A+=A.length===0?"..":"\\..");return l+=u,A.length>0?`${A}${a.slice(l,d)}`:(a.charCodeAt(l)===D&&++l,a.slice(l,d))},toNamespacedPath(s){if(typeof s!="string")return s;if(s.length===0)return"";const r=e.win32.resolve(s);if(r.length<=2)return s;if(r.charCodeAt(0)===D){if(r.charCodeAt(1)===D){const m=r.charCodeAt(2);if(m!==I&&m!==k)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(S(r.charCodeAt(0))&&r.charCodeAt(1)===T&&r.charCodeAt(2)===D)return`\\\\?\\${r}`;return s},dirname(s){p(s,"path");const r=s.length;if(r===0)return".";let m=-1,a=0;const b=s.charCodeAt(0);if(r===1)return f(b)?s:".";if(f(b)){if(m=a=1,f(s.charCodeAt(1))){let l=2,d=l;for(;l<r&&!f(s.charCodeAt(l));)l++;if(l<r&&l!==d){for(d=l;l<r&&f(s.charCodeAt(l));)l++;if(l<r&&l!==d){for(d=l;l<r&&!f(s.charCodeAt(l));)l++;if(l===r)return s;l!==d&&(m=a=l+1)}}}}else S(b)&&s.charCodeAt(1)===T&&(m=r>2&&f(s.charCodeAt(2))?3:2,a=m);let n=-1,t=!0;for(let l=r-1;l>=a;--l)if(f(s.charCodeAt(l))){if(!t){n=l;break}}else t=!1;if(n===-1){if(m===-1)return".";n=m}return s.slice(0,n)},basename(s,r){r!==void 0&&p(r,"ext"),p(s,"path");let m=0,a=-1,b=!0,n;if(s.length>=2&&S(s.charCodeAt(0))&&s.charCodeAt(1)===T&&(m=2),r!==void 0&&r.length>0&&r.length<=s.length){if(r===s)return"";let t=r.length-1,l=-1;for(n=s.length-1;n>=m;--n){const d=s.charCodeAt(n);if(f(d)){if(!b){m=n+1;break}}else l===-1&&(b=!1,l=n+1),t>=0&&(d===r.charCodeAt(t)?--t==-1&&(a=n):(t=-1,a=l))}return m===a?a=l:a===-1&&(a=s.length),s.slice(m,a)}for(n=s.length-1;n>=m;--n)if(f(s.charCodeAt(n))){if(!b){m=n+1;break}}else a===-1&&(b=!1,a=n+1);return a===-1?"":s.slice(m,a)},extname(s){p(s,"path");let r=0,m=-1,a=0,b=-1,n=!0,t=0;s.length>=2&&s.charCodeAt(1)===T&&S(s.charCodeAt(0))&&(r=a=2);for(let l=s.length-1;l>=r;--l){const d=s.charCodeAt(l);if(f(d)){if(!n){a=l+1;break}continue}b===-1&&(n=!1,b=l+1),d===k?m===-1?m=l:t!==1&&(t=1):m!==-1&&(t=-1)}return m===-1||b===-1||t===0||t===1&&m===b-1&&m===a+1?"":s.slice(m,b)},format:w.bind(null,"\\"),parse(s){p(s,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return r;const m=s.length;let a=0,b=s.charCodeAt(0);if(m===1)return f(b)?(r.root=r.dir=s,r):(r.base=r.name=s,r);if(f(b)){if(a=1,f(s.charCodeAt(1))){let u=2,E=u;for(;u<m&&!f(s.charCodeAt(u));)u++;if(u<m&&u!==E){for(E=u;u<m&&f(s.charCodeAt(u));)u++;if(u<m&&u!==E){for(E=u;u<m&&!f(s.charCodeAt(u));)u++;u===m?a=u:u!==E&&(a=u+1)}}}}else if(S(b)&&s.charCodeAt(1)===T){if(m<=2)return r.root=r.dir=s,r;if(a=2,f(s.charCodeAt(2))){if(m===3)return r.root=r.dir=s,r;a=3}}a>0&&(r.root=s.slice(0,a));let n=-1,t=a,l=-1,d=!0,o=s.length-1,h=0;for(;o>=a;--o){if(b=s.charCodeAt(o),f(b)){if(!d){t=o+1;break}continue}l===-1&&(d=!1,l=o+1),b===k?n===-1?n=o:h!==1&&(h=1):n!==-1&&(h=-1)}return l!==-1&&(n===-1||h===0||h===1&&n===l-1&&n===t+1?r.base=r.name=s.slice(t,l):(r.name=s.slice(t,n),r.base=s.slice(t,l),r.ext=s.slice(n,l))),t>0&&t!==a?r.dir=s.slice(0,t-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...s){let r="",m=!1;for(let a=s.length-1;a>=-1&&!m;a--){const b=a>=0?s[a]:g.cwd();p(b,"path"),b.length!==0&&(r=`${b}/${r}`,m=b.charCodeAt(0)===_)}return r=P(r,!m,"/",v),m?`/${r}`:r.length>0?r:"."},normalize(s){if(p(s,"path"),s.length===0)return".";const r=s.charCodeAt(0)===_,m=s.charCodeAt(s.length-1)===_;return s=P(s,!r,"/",v),s.length===0?r?"/":m?"./":".":(m&&(s+="/"),r?`/${s}`:s)},isAbsolute(s){return p(s,"path"),s.length>0&&s.charCodeAt(0)===_},join(...s){if(s.length===0)return".";let r;for(let m=0;m<s.length;++m){const a=s[m];p(a,"path"),a.length>0&&(r===void 0?r=a:r+=`/${a}`)}return r===void 0?".":e.posix.normalize(r)},relative(s,r){if(p(s,"from"),p(r,"to"),s===r||(s=e.posix.resolve(s),r=e.posix.resolve(r),s===r))return"";const m=1,a=s.length,b=a-m,n=1,t=r.length-n,l=b<t?b:t;let d=-1,o=0;for(;o<l;o++){const u=s.charCodeAt(m+o);if(u!==r.charCodeAt(n+o))break;u===_&&(d=o)}if(o===l)if(t>l){if(r.charCodeAt(n+o)===_)return r.slice(n+o+1);if(o===0)return r.slice(n+o)}else b>l&&(s.charCodeAt(m+o)===_?d=o:o===0&&(d=0));let h="";for(o=m+d+1;o<=a;++o)(o===a||s.charCodeAt(o)===_)&&(h+=h.length===0?"..":"/..");return`${h}${r.slice(n+d)}`},toNamespacedPath(s){return s},dirname(s){if(p(s,"path"),s.length===0)return".";const r=s.charCodeAt(0)===_;let m=-1,a=!0;for(let b=s.length-1;b>=1;--b)if(s.charCodeAt(b)===_){if(!a){m=b;break}}else a=!1;return m===-1?r?"/":".":r&&m===1?"//":s.slice(0,m)},basename(s,r){r!==void 0&&p(r,"ext"),p(s,"path");let m=0,a=-1,b=!0,n;if(r!==void 0&&r.length>0&&r.length<=s.length){if(r===s)return"";let t=r.length-1,l=-1;for(n=s.length-1;n>=0;--n){const d=s.charCodeAt(n);if(d===_){if(!b){m=n+1;break}}else l===-1&&(b=!1,l=n+1),t>=0&&(d===r.charCodeAt(t)?--t==-1&&(a=n):(t=-1,a=l))}return m===a?a=l:a===-1&&(a=s.length),s.slice(m,a)}for(n=s.length-1;n>=0;--n)if(s.charCodeAt(n)===_){if(!b){m=n+1;break}}else a===-1&&(b=!1,a=n+1);return a===-1?"":s.slice(m,a)},extname(s){p(s,"path");let r=-1,m=0,a=-1,b=!0,n=0;for(let t=s.length-1;t>=0;--t){const l=s.charCodeAt(t);if(l===_){if(!b){m=t+1;break}continue}a===-1&&(b=!1,a=t+1),l===k?r===-1?r=t:n!==1&&(n=1):r!==-1&&(n=-1)}return r===-1||a===-1||n===0||n===1&&r===a-1&&r===m+1?"":s.slice(r,a)},format:w.bind(null,"/"),parse(s){p(s,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return r;const m=s.charCodeAt(0)===_;let a;m?(r.root="/",a=1):a=0;let b=-1,n=0,t=-1,l=!0,d=s.length-1,o=0;for(;d>=a;--d){const h=s.charCodeAt(d);if(h===_){if(!l){n=d+1;break}continue}t===-1&&(l=!1,t=d+1),h===k?b===-1?b=d:o!==1&&(o=1):b!==-1&&(o=-1)}if(t!==-1){const h=n===0&&m?1:n;b===-1||o===0||o===1&&b===t-1&&b===n+1?r.base=r.name=s.slice(h,t):(r.name=s.slice(h,b),r.base=s.slice(h,t),r.ext=s.slice(b,t))}return n>0?r.dir=s.slice(0,n-1):m&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=g.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=g.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=g.platform==="win32"?e.win32.join:e.posix.join,e.resolve=g.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=g.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=g.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=g.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=g.platform==="win32"?e.win32.extname:e.posix.extname,e.format=g.platform==="win32"?e.win32.format:e.posix.format,e.parse=g.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=g.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=g.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=g.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(fe[95],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var g;(function(C){C[C.stdout=0]="stdout",C[C.stderr=1]="stderr"})(g=e.Source||(e.Source={}));var L;(function(C){C[C.Success=0]="Success",C[C.Unknown=1]="Unknown",C[C.AccessDenied=2]="AccessDenied",C[C.ProcessNotFound=3]="ProcessNotFound"})(L=e.TerminateResponseCode||(e.TerminateResponseCode={}));function y(C,...i){const k=i.reduce((T,I)=>(T[I]=!0,T),{}),_=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(C).filter(T=>!k[T]).forEach(T=>{for(let I=0;I<_.length;I++)if(T.search(_[I])!==-1){delete C[T];break}})}e.sanitizeProcessEnvironment=y}),define(fe[47],me([0,1,12]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=g.globals.performance&&typeof g.globals.performance.now=="function";class y{constructor(i){this._highResolution=L&&i,this._startTime=this._now(),this._stopTime=-1}static create(i=!0){return new y(i)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?g.globals.performance.now():Date.now()}}e.StopWatch=y}),define(fe[3],me([0,1,18,76,6,94,47]),function(Y,e,g,L,y,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var k;(function(r){r.None=()=>y.Disposable.None;function m(M){return(H,N=null,U)=>{let V=!1,O;return O=M(W=>{if(!V)return O?O.dispose():V=!0,H.call(N,W)},null,U),V&&O.dispose(),O}}r.once=m;function a(M,H){return o((N,U=null,V)=>M(O=>N.call(U,H(O)),null,V))}r.map=a;function b(M,H){return o((N,U=null,V)=>M(O=>{H(O),N.call(U,O)},null,V))}r.forEach=b;function n(M,H){return o((N,U=null,V)=>M(O=>H(O)&&N.call(U,O),null,V))}r.filter=n;function t(M){return M}r.signal=t;function l(...M){return(H,N=null,U)=>(0,y.combinedDisposable)(...M.map(V=>V(O=>H.call(N,O),null,U)))}r.any=l;function d(M,H,N){let U=N;return a(M,V=>(U=H(U,V),U))}r.reduce=d;function o(M){let H;const N=new c({onFirstListenerAdd(){H=M(N.fire,N)},onLastListenerRemove(){H.dispose()}});return N.event}function h(M,H,N=100,U=!1,V){let O,W,j,X=0;const Q=new c({leakWarningThreshold:V,onFirstListenerAdd(){O=M(de=>{X++,W=H(W,de),U&&!j&&(Q.fire(W),W=void 0),clearTimeout(j),j=setTimeout(()=>{const Se=W;W=void 0,j=void 0,(!U||X>1)&&Q.fire(Se),X=0},N)})},onLastListenerRemove(){O.dispose()}});return Q.event}r.debounce=h;function u(M,H=(N,U)=>N===U){let N=!0,U;return n(M,V=>{const O=N||!H(V,U);return N=!1,U=V,O})}r.latch=u;function E(M,H){return[r.filter(M,H),r.filter(M,N=>!H(N))]}r.split=E;function A(M,H=!1,N=[]){let U=N.slice(),V=M(j=>{U?U.push(j):W.fire(j)});const O=()=>{U&&U.forEach(j=>W.fire(j)),U=null},W=new c({onFirstListenerAdd(){V||(V=M(j=>W.fire(j)))},onFirstListenerDidAdd(){U&&(H?setTimeout(O):O())},onLastListenerRemove(){V&&V.dispose(),V=null}});return W.event}r.buffer=A;class R{constructor(H){this.event=H}map(H){return new R(a(this.event,H))}forEach(H){return new R(b(this.event,H))}filter(H){return new R(n(this.event,H))}reduce(H,N){return new R(d(this.event,H,N))}latch(){return new R(u(this.event))}debounce(H,N=100,U=!1,V){return new R(h(this.event,H,N,U,V))}on(H,N,U){return this.event(H,N,U)}once(H,N,U){return m(this.event)(H,N,U)}}function B(M){return new R(M)}r.chain=B;function x(M,H,N=U=>U){const U=(...j)=>W.fire(N(...j)),V=()=>M.on(H,U),O=()=>M.removeListener(H,U),W=new c({onFirstListenerAdd:V,onLastListenerRemove:O});return W.event}r.fromNodeEventEmitter=x;function F(M,H,N=U=>U){const U=(...j)=>W.fire(N(...j)),V=()=>M.addEventListener(H,U),O=()=>M.removeEventListener(H,U),W=new c({onFirstListenerAdd:V,onLastListenerRemove:O});return W.event}r.fromDOMEventEmitter=F;function $(M){return new Promise(H=>m(M)(H))}r.toPromise=$})(k=e.Event||(e.Event={}));class _{constructor(m){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${m}_${_._idPool++}`}start(m){this._stopWatch=new i.StopWatch(!0),this._listenerCount=m}stop(){if(this._stopWatch){const m=this._stopWatch.elapsed();this._elapsedOverall+=m,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${m.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}_._idPool=0;let D=-1;function T(r){const m=D;return D=r,{dispose(){D=m}}}e.setGlobalLeakWarningThreshold=T;class I{constructor(m,a=Math.random().toString(18).slice(2,5)){this.customThreshold=m,this.name=a,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(m){let a=D;if(typeof this.customThreshold=="number"&&(a=this.customThreshold),a<=0||m<a)return;this._stacks||(this._stacks=new Map);const b=new Error().stack.split(`
`).slice(3).join(`
`),n=this._stacks.get(b)||0;if(this._stacks.set(b,n+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=a*.5;let t,l=0;for(const[d,o]of this._stacks)(!t||l<o)&&(t=d,l=o);console.warn(`[${this.name}] potential listener LEAK detected, having ${m} listeners already. MOST frequent listener (${l}):`),console.warn(t)}return()=>{const t=this._stacks.get(b)||0;this._stacks.set(b,t-1)}}}class c{constructor(m){this._disposed=!1,this._options=m,this._leakageMon=D>0?new I(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new _(this._options._profName):void 0}get event(){return this._event||(this._event=(m,a,b)=>{this._listeners||(this._listeners=new C.LinkedList);const n=this._listeners.isEmpty();n&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const t=this._listeners.push(a?[m,a]:m);n&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,m,a);const l=this._leakageMon?.check(this._listeners.size),d=(0,y.toDisposable)(()=>{l&&l(),this._disposed||(t(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return b instanceof y.DisposableStore?b.add(d):Array.isArray(b)&&b.push(d),d}),this._event}fire(m){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new C.LinkedList);for(let a of this._listeners)this._deliveryQueue.push([a,m]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[a,b]=this._deliveryQueue.shift();try{typeof a=="function"?a.call(void 0,b):a[0].call(a[1],b)}catch(n){(0,g.onUnexpectedError)(n)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=c;class p extends c{async fireAsync(m,a,b){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new C.LinkedList);for(const n of this._listeners)this._asyncDeliveryQueue.push([n,m]);for(;this._asyncDeliveryQueue.size>0&&!a.isCancellationRequested;){const[n,t]=this._asyncDeliveryQueue.shift(),l=[],d={...t,waitUntil:o=>{if(Object.isFrozen(l))throw new Error("waitUntil can NOT be called asynchronous");b&&(o=b(o,typeof n=="function"?n:n[0])),l.push(o)}};try{typeof n=="function"?n.call(void 0,d):n[0].call(n[1],d)}catch(o){(0,g.onUnexpectedError)(o);continue}Object.freeze(l),await Promise.allSettled(l).then(o=>{for(const h of o)h.status==="rejected"&&(0,g.onUnexpectedError)(h.reason)})}}}}e.AsyncEmitter=p;class f extends c{constructor(m){super(m);this._isPaused=0,this._eventQueue=new C.LinkedList,this._mergeFn=m?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const m=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(m))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(m){this._listeners&&(this._isPaused!==0?this._eventQueue.push(m):super.fire(m))}}e.PauseableEmitter=f;class v extends f{constructor(m){super(m);this._delay=m.delay??100}fire(m){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(m)}}e.DebounceEmitter=v;class S extends c{constructor(m){super(m);this._queuedEvents=[],this._mergeFn=m?.merge}fire(m){this._queuedEvents.push(m),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(a=>super.fire(a)),this._queuedEvents=[]})}}e.MicrotaskEmitter=S;class P{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new c({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(m){const a={event:m,listener:null};this.events.push(a),this.hasListeners&&this.hook(a);const b=()=>{this.hasListeners&&this.unhook(a);const n=this.events.indexOf(a);this.events.splice(n,1)};return(0,y.toDisposable)((0,L.once)(b))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(m=>this.hook(m))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(m=>this.unhook(m))}hook(m){m.listener=m.event(a=>this.emitter.fire(a))}unhook(m){m.listener&&m.listener.dispose(),m.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=P;class w{constructor(){this.buffers=[]}wrapEvent(m){return(a,b,n)=>m(t=>{const l=this.buffers[this.buffers.length-1];l?l.push(()=>a.call(b,t)):a.call(b,t)},void 0,n)}bufferEvents(m){const a=[];this.buffers.push(a);const b=m();return this.buffers.pop(),a.forEach(n=>n()),b}}e.EventBufferer=w;class s{constructor(){this.listening=!1,this.inputEvent=k.None,this.inputEventListener=y.Disposable.None,this.emitter=new c({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(m){this.inputEvent=m,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=m(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=s}),define(fe[21],me([0,1,3]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(k,_){const D=setTimeout(k.bind(_),0);return{dispose(){clearTimeout(D)}}});var y;(function(k){function _(D){return D===k.None||D===k.Cancelled||D instanceof C?!0:!D||typeof D!="object"?!1:typeof D.isCancellationRequested=="boolean"&&typeof D.onCancellationRequested=="function"}k.isCancellationToken=_,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:g.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(y=e.CancellationToken||(e.CancellationToken={}));class C{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new g.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class i{constructor(_){this._token=void 0,this._parentListener=void 0,this._parentListener=_&&_.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new C),this._token}cancel(){this._token?this._token instanceof C&&this._token.cancel():this._token=y.Cancelled}dispose(_=!1){_&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof C&&this._token.dispose():this._token=y.None}}e.CancellationTokenSource=i}),define(fe[48],me([0,1,3]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new g.Emitter}add(T){const I=this._icons.get(T.id);I?T.description?I.description=T.description:console.error(`Duplicate registration of codicon ${T.id}`):(this._icons.set(T.id,T),this._onDidRegister.fire(T))}get(T){return this._icons.get(T)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const y=new L;e.iconRegistry=y;function C(D){return D?D.replace(/\$\((.*?)\)/g,(T,I)=>` ${I} `).trim():""}e.getCodiconAriaLabel=C;class i{constructor(T,I,c){this.id=T,this.definition=I,this.description=c,y.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=i,i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",i.add.definition),i.gistNew=new i("gist-new",i.add.definition),i.repoCreate=new i("repo-create",i.add.definition),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.debugContinueSmall=new i("debug-continue-small",{fontCharacter:"\\ebe0"}),i.beakerStop=new i("beaker-stop",{fontCharacter:"\\ebe1"}),i.graphLine=new i("graph-line",{fontCharacter:"\\ebe2"}),i.graphScatter=new i("graph-scatter",{fontCharacter:"\\ebe3"}),i.pieChart=new i("pie-chart",{fontCharacter:"\\ebe4"}),i.bracket=new i("bracket",i.json.definition),i.bracketDot=new i("bracket-dot",{fontCharacter:"\\ebe5"}),i.bracketError=new i("bracket-error",{fontCharacter:"\\ebe6"}),i.lockSmall=new i("lock-small",{fontCharacter:"\\ebe7"}),i.azureDevops=new i("azure-devops",{fontCharacter:"\\ebe8"}),i.verifiedFilled=new i("verified-filled",{fontCharacter:"\\ebe9"}),i.newLine=new i("newline",{fontCharacter:"\\ebea"}),i.dialogError=new i("dialog-error",i.error.definition),i.dialogWarning=new i("dialog-warning",i.warning.definition),i.dialogInfo=new i("dialog-info",i.info.definition),i.dialogClose=new i("dialog-close",i.close.definition),i.treeItemExpanded=new i("tree-item-expanded",i.chevronDown.definition),i.treeFilterOnTypeOn=new i("tree-filter-on-type-on",i.listFilter.definition),i.treeFilterOnTypeOff=new i("tree-filter-on-type-off",i.listSelection.definition),i.treeFilterClear=new i("tree-filter-clear",i.close.definition),i.treeItemLoading=new i("tree-item-loading",i.loading.definition),i.menuSelection=new i("menu-selection",i.check.definition),i.menuSubmenu=new i("menu-submenu",i.chevronRight.definition),i.menuBarMore=new i("menubar-more",i.more.definition),i.scrollbarButtonLeft=new i("scrollbar-button-left",i.triangleLeft.definition),i.scrollbarButtonRight=new i("scrollbar-button-right",i.triangleRight.definition),i.scrollbarButtonUp=new i("scrollbar-button-up",i.triangleUp.definition),i.scrollbarButtonDown=new i("scrollbar-button-down",i.triangleDown.definition),i.toolBarMore=new i("toolbar-more",i.more.definition),i.quickInputBack=new i("quick-input-back",i.arrowLeft.definition);function k(D,T){const I=["codicon","codicon-"+D];return T&&I.push("codicon-modifier-"+T),I}e.getClassNamesArray=k;var _;(function(D){D.iconNameSegment="[A-Za-z0-9]+",D.iconNameExpression="[A-Za-z0-9-]+",D.iconModifierExpression="~[A-Za-z]+",D.iconNameCharacter="[A-Za-z0-9~-]";const T=new RegExp(`^(${D.iconNameExpression})(${D.iconModifierExpression})?$`);function I(f){if(f instanceof i)return["codicon","codicon-"+f.id];const v=T.exec(f.id);if(!v)return I(i.error);let[,S,P]=v;const w=["codicon","codicon-"+S];return P&&w.push("codicon-modifier-"+P.substr(1)),w}D.asClassNameArray=I;function c(f){return I(f).join(" ")}D.asClassName=c;function p(f){return"."+I(f).join(".")}D.asCSSSelector=p})(_=e.CSSIcon||(e.CSSIcon={}))}),define(fe[96],me([0,1,18,6]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function y(s){const r=s;return r?[r.on,r.pause,r.resume,r.destroy].every(m=>typeof m=="function"):!1}e.isReadableStream=y;function C(s){const r=s;return r?y(r.stream)&&Array.isArray(r.buffer)&&typeof r.ended=="boolean":!1}e.isReadableBufferedStream=C;function i(s,r){return new k(s,r)}e.newWriteableStream=i;class k{constructor(r,m){this.reducer=r,this.options=m,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(r){if(!this.state.destroyed){if(this.state.flowing)this.emitData(r);else if(this.buffer.data.push(r),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(m=>this.pendingWritePromises.push(m))}}error(r){this.state.destroyed||(this.state.flowing?this.emitError(r):this.buffer.error.push(r))}end(r){this.state.destroyed||(typeof r!="undefined"&&this.write(r),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(r){this.listeners.data.slice(0).forEach(m=>m(r))}emitError(r){this.listeners.error.length===0?(0,g.onUnexpectedError)(r):this.listeners.error.slice(0).forEach(m=>m(r))}emitEnd(){this.listeners.end.slice(0).forEach(r=>r())}on(r,m){if(!this.state.destroyed)switch(r){case"data":this.listeners.data.push(m),this.resume();break;case"end":this.listeners.end.push(m),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(m),this.state.flowing&&this.flowErrors();break}}removeListener(r,m){if(this.state.destroyed)return;let a;switch(r){case"data":a=this.listeners.data;break;case"end":a=this.listeners.end;break;case"error":a=this.listeners.error;break}if(a){const b=a.indexOf(m);b>=0&&a.splice(b,1)}}flowData(){if(this.buffer.data.length>0){const r=this.reducer(this.buffer.data);this.emitData(r),this.buffer.data.length=0;const m=[...this.pendingWritePromises];this.pendingWritePromises.length=0,m.forEach(a=>a())}}flowErrors(){if(this.listeners.error.length>0){for(const r of this.buffer.error)this.emitError(r);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function _(s,r){const m=[];let a;for(;(a=s.read())!==null;)m.push(a);return r(m)}e.consumeReadable=_;function D(s,r,m){const a=[];let b;for(;(b=s.read())!==null&&a.length<m;)a.push(b);return b===null&&a.length>0?r(a):{read:()=>{if(a.length>0)return a.shift();if(typeof b!="undefined"){const n=b;return b=void 0,n}return s.read()}}}e.peekReadable=D;function T(s,r){return new Promise((m,a)=>{const b=[];I(s,{onData:n=>{r&&b.push(n)},onError:n=>{r?a(n):m(void 0)},onEnd:()=>{m(r?r(b):void 0)}})})}e.consumeStream=T;function I(s,r){s.on("error",m=>r.onError(m)),s.on("end",()=>r.onEnd()),s.on("data",m=>r.onData(m))}e.listenStream=I;function c(s,r){return new Promise((m,a)=>{const b=new L.DisposableStore,n=[],t=o=>{if(n.push(o),n.length>r)return b.dispose(),s.pause(),m({stream:s,buffer:n,ended:!1})},l=o=>a(o),d=()=>m({stream:s,buffer:n,ended:!0});b.add((0,L.toDisposable)(()=>s.removeListener("error",l))),s.on("error",l),b.add((0,L.toDisposable)(()=>s.removeListener("end",d))),s.on("end",d),b.add((0,L.toDisposable)(()=>s.removeListener("data",t))),s.on("data",t)})}e.peekStream=c;function p(s,r){const m=i(r);return m.end(s),m}e.toStream=p;function f(){const s=i(()=>{throw new Error("not supported")});return s.end(),s}e.emptyStream=f;function v(s){let r=!1;return{read:()=>r?null:(r=!0,s)}}e.toReadable=v;function S(s,r,m){const a=i(m);return I(s,{onData:b=>a.write(r.data(b)),onError:b=>a.error(r.error?r.error(b):b),onEnd:()=>a.end()}),a}e.transform=S;function P(s,r,m){let a=!1;return{read:()=>{const b=r.read();return a?b:(a=!0,b!==null?m([s,b]):s)}}}e.prefixedReadable=P;function w(s,r,m){let a=!1;const b=i(m);return I(r,{onData:n=>a?b.write(n):(a=!0,b.write(m([s,n]))),onError:n=>b.error(n),onEnd:()=>{a||(a=!0,b.write(s)),b.end()}}),b}e.prefixedStream=w}),define(fe[22],me([0,1,96]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer!="undefined";let y,C;class i{constructor(t){this.buffer=t,this.byteLength=this.buffer.byteLength}static alloc(t){return L?new i(Buffer.allocUnsafe(t)):new i(new Uint8Array(t))}static wrap(t){return L&&!Buffer.isBuffer(t)&&(t=Buffer.from(t.buffer,t.byteOffset,t.byteLength)),new i(t)}static fromString(t,l){return!(l?.dontUseNodeBuffer||!1)&&L?new i(Buffer.from(t)):(y||(y=new TextEncoder),new i(y.encode(t)))}static concat(t,l){if(typeof l=="undefined"){l=0;for(let h=0,u=t.length;h<u;h++)l+=t[h].byteLength}const d=i.alloc(l);let o=0;for(let h=0,u=t.length;h<u;h++){const E=t[h];d.set(E,o),o+=E.byteLength}return d}toString(){return L?this.buffer.toString():(C||(C=new TextDecoder),C.decode(this.buffer))}slice(t,l){return new i(this.buffer.subarray(t,l))}set(t,l){t instanceof i?this.buffer.set(t.buffer,l):this.buffer.set(t,l)}readUInt32BE(t){return D(this.buffer,t)}writeUInt32BE(t,l){T(this.buffer,t,l)}readUInt32LE(t){return I(this.buffer,t)}writeUInt32LE(t,l){c(this.buffer,t,l)}readUInt8(t){return p(this.buffer,t)}writeUInt8(t,l){f(this.buffer,t,l)}}e.VSBuffer=i;function k(n,t){return n[t+0]<<0>>>0|n[t+1]<<8>>>0}e.readUInt16LE=k;function _(n,t,l){n[l+0]=t&255,t=t>>>8,n[l+1]=t&255}e.writeUInt16LE=_;function D(n,t){return n[t]*2**24+n[t+1]*2**16+n[t+2]*2**8+n[t+3]}e.readUInt32BE=D;function T(n,t,l){n[l+3]=t,t=t>>>8,n[l+2]=t,t=t>>>8,n[l+1]=t,t=t>>>8,n[l]=t}e.writeUInt32BE=T;function I(n,t){return n[t+0]<<0>>>0|n[t+1]<<8>>>0|n[t+2]<<16>>>0|n[t+3]<<24>>>0}e.readUInt32LE=I;function c(n,t,l){n[l+0]=t&255,t=t>>>8,n[l+1]=t&255,t=t>>>8,n[l+2]=t&255,t=t>>>8,n[l+3]=t&255}e.writeUInt32LE=c;function p(n,t){return n[t]}e.readUInt8=p;function f(n,t,l){n[l]=t}e.writeUInt8=f;function v(n){return g.consumeReadable(n,t=>i.concat(t))}e.readableToBuffer=v;function S(n){return g.toReadable(n)}e.bufferToReadable=S;function P(n){return g.consumeStream(n,t=>i.concat(t))}e.streamToBuffer=P;async function w(n){return n.ended?i.concat(n.buffer):i.concat([...n.buffer,await P(n.stream)])}e.bufferedStreamToBuffer=w;function s(n){return g.toStream(n,t=>i.concat(t))}e.bufferToStream=s;function r(n){return g.transform(n,{data:t=>typeof t=="string"?i.fromString(t):i.wrap(t)},t=>i.concat(t))}e.streamToBufferReadableStream=r;function m(n){return g.newWriteableStream(t=>i.concat(t),n)}e.newWriteableBufferStream=m;function a(n,t){return g.prefixedReadable(n,t,l=>i.concat(l))}e.prefixedBufferReadable=a;function b(n,t){return g.prefixedStream(n,t,l=>i.concat(l))}e.prefixedBufferStream=b}),define(fe[8],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function g(ce){return!ce||typeof ce!="string"?!0:ce.trim().length===0}e.isFalsyOrWhitespace=g;const L=/{(\d+)}/g;function y(ce,...Ie){return Ie.length===0?ce:ce.replace(L,function(Ue,Xe){const nt=parseInt(Xe,10);return isNaN(nt)||nt<0||nt>=Ie.length?Ue:Ie[nt]})}e.format=y;const C=/{([^}]+)}/g;function i(ce,Ie){return ce.replace(C,(Ue,Xe)=>Ie[Xe]??Ue)}e.format2=i;function k(ce){return ce.replace(/[<>&]/g,function(Ie){switch(Ie){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ie}})}e.escape=k;function _(ce){return ce.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=_;function D(ce,Ie){let Ue=0;const Xe=Ie.charCodeAt(0);for(let nt=ce.length-1;nt>=0;nt--)ce.charCodeAt(nt)===Xe&&Ue++;return Ue}e.count=D;function T(ce,Ie,Ue="\u2026"){return ce.length<=Ie?ce:`${ce.substr(0,Ie)}${Ue}`}e.truncate=T;function I(ce,Ie=" "){const Ue=c(ce,Ie);return p(Ue,Ie)}e.trim=I;function c(ce,Ie){if(!ce||!Ie)return ce;const Ue=Ie.length;if(Ue===0||ce.length===0)return ce;let Xe=0;for(;ce.indexOf(Ie,Xe)===Xe;)Xe=Xe+Ue;return ce.substring(Xe)}e.ltrim=c;function p(ce,Ie){if(!ce||!Ie)return ce;const Ue=Ie.length,Xe=ce.length;if(Ue===0||Xe===0)return ce;let nt=Xe,ft=-1;for(;ft=ce.lastIndexOf(Ie,nt-1),!(ft===-1||ft+Ue!==nt);){if(ft===0)return"";nt=ft}return ce.substring(0,nt)}e.rtrim=p;function f(ce){return ce.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=f;function v(ce){return ce.replace(/\*/g,"")}e.stripWildcards=v;function S(ce,Ie,Ue={}){if(!ce)throw new Error("Cannot create regex from empty string");Ie||(ce=_(ce)),Ue.wholeWord&&(/\B/.test(ce.charAt(0))||(ce="\\b"+ce),/\B/.test(ce.charAt(ce.length-1))||(ce=ce+"\\b"));let Xe="";return Ue.global&&(Xe+="g"),Ue.matchCase||(Xe+="i"),Ue.multiline&&(Xe+="m"),Ue.unicode&&(Xe+="u"),new RegExp(ce,Xe)}e.createRegExp=S;function P(ce){return ce.source==="^"||ce.source==="^$"||ce.source==="$"||ce.source==="^\\s*$"?!1:!!(ce.exec("")&&ce.lastIndex===0)}e.regExpLeadsToEndlessLoop=P;function w(ce){return!!ce.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=w;function s(ce){return(ce.global?"g":"")+(ce.ignoreCase?"i":"")+(ce.multiline?"m":"")+(ce.unicode?"u":"")}e.regExpFlags=s;function r(ce){return ce.split(/\r\n|\r|\n/)}e.splitLines=r;function m(ce){for(let Ie=0,Ue=ce.length;Ie<Ue;Ie++){const Xe=ce.charCodeAt(Ie);if(Xe!==32&&Xe!==9)return Ie}return-1}e.firstNonWhitespaceIndex=m;function a(ce,Ie=0,Ue=ce.length){for(let Xe=Ie;Xe<Ue;Xe++){const nt=ce.charCodeAt(Xe);if(nt!==32&&nt!==9)return ce.substring(Ie,Xe)}return ce.substring(Ie,Ue)}e.getLeadingWhitespace=a;function b(ce,Ie=ce.length-1){for(let Ue=Ie;Ue>=0;Ue--){const Xe=ce.charCodeAt(Ue);if(Xe!==32&&Xe!==9)return Ue}return-1}e.lastNonWhitespaceIndex=b;function n(ce,Ie){return ce<Ie?-1:ce>Ie?1:0}e.compare=n;function t(ce,Ie,Ue=0,Xe=ce.length,nt=0,ft=Ie.length){for(;Ue<Xe&&nt<ft;Ue++,nt++){let Re=ce.charCodeAt(Ue),ve=Ie.charCodeAt(nt);if(Re<ve)return-1;if(Re>ve)return 1}const tt=Xe-Ue,ut=ft-nt;return tt<ut?-1:tt>ut?1:0}e.compareSubstring=t;function l(ce,Ie){return d(ce,Ie,0,ce.length,0,Ie.length)}e.compareIgnoreCase=l;function d(ce,Ie,Ue=0,Xe=ce.length,nt=0,ft=Ie.length){for(;Ue<Xe&&nt<ft;Ue++,nt++){let Re=ce.charCodeAt(Ue),ve=Ie.charCodeAt(nt);if(Re===ve)continue;if(Re>=128||ve>=128)return t(ce.toLowerCase(),Ie.toLowerCase(),Ue,Xe,nt,ft);o(Re)&&(Re-=32),o(ve)&&(ve-=32);const Te=Re-ve;if(Te!==0)return Te}const tt=Xe-Ue,ut=ft-nt;return tt<ut?-1:tt>ut?1:0}e.compareSubstringIgnoreCase=d;function o(ce){return ce>=97&&ce<=122}e.isLowerAsciiLetter=o;function h(ce){return ce>=65&&ce<=90}e.isUpperAsciiLetter=h;function u(ce,Ie){return ce.length===Ie.length&&d(ce,Ie)===0}e.equalsIgnoreCase=u;function E(ce,Ie){const Ue=Ie.length;return Ie.length>ce.length?!1:d(ce,Ie,0,Ue)===0}e.startsWithIgnoreCase=E;function A(ce,Ie){let Ue,Xe=Math.min(ce.length,Ie.length);for(Ue=0;Ue<Xe;Ue++)if(ce.charCodeAt(Ue)!==Ie.charCodeAt(Ue))return Ue;return Xe}e.commonPrefixLength=A;function R(ce,Ie){let Ue,Xe=Math.min(ce.length,Ie.length);const nt=ce.length-1,ft=Ie.length-1;for(Ue=0;Ue<Xe;Ue++)if(ce.charCodeAt(nt-Ue)!==Ie.charCodeAt(ft-Ue))return Ue;return Xe}e.commonSuffixLength=R;function B(ce){return 55296<=ce&&ce<=56319}e.isHighSurrogate=B;function x(ce){return 56320<=ce&&ce<=57343}e.isLowSurrogate=x;function F(ce,Ie){return(ce-55296<<10)+(Ie-56320)+65536}e.computeCodePoint=F;function $(ce,Ie,Ue){const Xe=ce.charCodeAt(Ue);if(B(Xe)&&Ue+1<Ie){const nt=ce.charCodeAt(Ue+1);if(x(nt))return F(Xe,nt)}return Xe}e.getNextCodePoint=$;function M(ce,Ie){const Ue=ce.charCodeAt(Ie-1);if(x(Ue)&&Ie>1){const Xe=ce.charCodeAt(Ie-2);if(B(Xe))return F(Xe,Ue)}return Ue}function H(ce,Ie){const Ue=ye.getInstance(),Xe=Ie,nt=ce.length,ft=$(ce,nt,Ie);Ie+=ft>=65536?2:1;let tt=Ue.getGraphemeBreakType(ft);for(;Ie<nt;){const ut=$(ce,nt,Ie),Re=Ue.getGraphemeBreakType(ut);if(rt(tt,Re))break;Ie+=ut>=65536?2:1,tt=Re}return Ie-Xe}e.nextCharLength=H;function N(ce,Ie){const Ue=ye.getInstance(),Xe=Ie,nt=M(ce,Ie);Ie-=nt>=65536?2:1;let ft=Ue.getGraphemeBreakType(nt);for(;Ie>0;){const tt=M(ce,Ie),ut=Ue.getGraphemeBreakType(tt);if(rt(ut,ft))break;Ie-=tt>=65536?2:1,ft=ut}return Xe-Ie}e.prevCharLength=N;function U(ce,Ie){const Ue=ye.getInstance(),Xe=ce.length,nt=Ie,ft=$(ce,Xe,Ie),tt=Ue.getGraphemeBreakType(ft);Ie+=ft>=65536?2:1;let ut=tt;for(;Ie<Xe;){const ve=$(ce,Xe,Ie),Te=Ue.getGraphemeBreakType(ve);if(rt(ut,Te))break;Ie+=ve>=65536?2:1,ut=Te}const Re=Ie;for(Ie=nt,ut=tt;Ie>0;){const ve=M(ce,Ie),Te=Ue.getGraphemeBreakType(ve);if(rt(Te,ut))break;Ie-=ve>=65536?2:1,ut=Te}return[Ie,Re]}function V(ce,Ie){return Ie>0&&x(ce.charCodeAt(Ie))?U(ce,Ie-1):U(ce,Ie)}e.getCharContainingOffset=V;const O=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function W(ce){return O.test(ce)}e.containsRTL=W;const j=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function X(ce){return j.test(ce)}e.containsEmoji=X;const Q=/^[\t\n\r\x20-\x7E]*$/;function de(ce){return Q.test(ce)}e.isBasicASCII=de,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Se(ce){return e.UNUSUAL_LINE_TERMINATORS.test(ce)}e.containsUnusualLineTerminators=Se;function De(ce){for(let Ie=0,Ue=ce.length;Ie<Ue;Ie++)if(Pe(ce.charCodeAt(Ie)))return!0;return!1}e.containsFullWidthCharacter=De;function Pe(ce){return ce>=11904&&ce<=55215||ce>=63744&&ce<=64255||ce>=65281&&ce<=65374}e.isFullWidthCharacter=Pe;function Be(ce){return ce>=127462&&ce<=127487||ce===8986||ce===8987||ce===9200||ce===9203||ce>=9728&&ce<=10175||ce===11088||ce===11093||ce>=127744&&ce<=128591||ce>=128640&&ce<=128764||ce>=128992&&ce<=129003||ce>=129280&&ce<=129535||ce>=129648&&ce<=129750}e.isEmojiImprecise=Be;function We(ce,Ie){if(ce.length<Ie)return ce;const Ue=/\b/g;let Xe=0;for(;Ue.test(ce)&&!(ce.length-Ue.lastIndex<Ie);)Xe=Ue.lastIndex,Ue.lastIndex+=1;return ce.substring(Xe).replace(/^\s/,"")}e.lcut=We;const He=/\x1B\x5B[12]?K/g,G=/\x1b\[\d+m/g,ee=/\x1b\[0?m/g;function ie(ce){return ce&&(ce=ce.replace(He,""),ce=ce.replace(G,""),ce=ce.replace(ee,"")),ce}e.removeAnsiEscapeCodes=ie,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function le(ce){return!!(ce&&ce.length>0&&ce.charCodeAt(0)===65279)}e.startsWithUTF8BOM=le;function Z(ce){return le(ce)?ce.substr(1):ce}e.stripUTF8BOM=Z;function re(ce,Ie){if(!ce||!Ie||ce.length<Ie.length)return!1;const Ue=Ie.length,Xe=ce.toLowerCase();let nt=0,ft=-1;for(;nt<Ue;){const tt=Xe.indexOf(Ie[nt],ft+1);if(tt<0)return!1;ft=tt,nt++}return!0}e.fuzzyContains=re;function pe(ce,Ie=!1){return ce?(Ie&&(ce=ce.replace(/\\./g,"")),ce.toLowerCase()!==ce):!1}e.containsUppercaseCharacter=pe;function Me(ce){return ce.charAt(0).toUpperCase()+ce.slice(1)}e.uppercaseFirstLetter=Me;function je(ce,Ie=1){if(Ie===0)return"";let Ue=-1;do Ue=ce.indexOf(`
`,Ue+1),Ie--;while(Ie>0&&Ue>=0);return Ue===-1?ce:(ce[Ue-1]==="\r"&&Ue--,ce.substr(0,Ue))}e.getNLines=je;function Ke(ce){const Ie=90-65+1;return ce=ce%(2*Ie),ce<Ie?String.fromCharCode(97+ce):String.fromCharCode(65+ce-Ie)}e.singleLetterHash=Ke;function Ze(ce){return ye.getInstance().getGraphemeBreakType(ce)}e.getGraphemeBreakType=Ze;function rt(ce,Ie){return ce===0?Ie!==5&&Ie!==7:ce===2&&Ie===3?!1:ce===4||ce===2||ce===3||Ie===4||Ie===2||Ie===3?!0:!(ce===8&&(Ie===8||Ie===9||Ie===11||Ie===12)||(ce===11||ce===9)&&(Ie===9||Ie===10)||(ce===12||ce===10)&&Ie===10||Ie===5||Ie===13||Ie===7||ce===1||ce===13&&Ie===14||ce===6&&Ie===6)}e.breakBetweenGraphemeBreakType=rt;var lt;(function(ce){ce[ce.Other=0]="Other",ce[ce.Prepend=1]="Prepend",ce[ce.CR=2]="CR",ce[ce.LF=3]="LF",ce[ce.Control=4]="Control",ce[ce.Extend=5]="Extend",ce[ce.Regional_Indicator=6]="Regional_Indicator",ce[ce.SpacingMark=7]="SpacingMark",ce[ce.L=8]="L",ce[ce.V=9]="V",ce[ce.T=10]="T",ce[ce.LV=11]="LV",ce[ce.LVT=12]="LVT",ce[ce.ZWJ=13]="ZWJ",ce[ce.Extended_Pictographic=14]="Extended_Pictographic"})(lt=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ye{constructor(){this._data=at()}static getInstance(){return ye._INSTANCE||(ye._INSTANCE=new ye),ye._INSTANCE}getGraphemeBreakType(Ie){if(Ie<32)return Ie===10?3:Ie===13?2:4;if(Ie<127)return 0;const Ue=this._data,Xe=Ue.length/3;let nt=1;for(;nt<=Xe;)if(Ie<Ue[3*nt])nt=2*nt;else if(Ie>Ue[3*nt+1])nt=2*nt+1;else return Ue[3*nt+2];return 0}}ye._INSTANCE=null;function at(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function J(ce,Ie){if(ce===0)return 0;const Ue=ne(ce,Ie);if(Ue!==void 0)return Ue;const Xe=M(Ie,ce);return ce-=_e(Xe),ce}e.getLeftDeleteOffset=J;function ne(ce,Ie){let Ue=M(Ie,ce);for(ce-=_e(Ue);Qe(Ue)||Ue===65039||Ue===8419;){if(ce===0)return;Ue=M(Ie,ce),ce-=_e(Ue)}if(!!Be(Ue)){if(ce>=0){const Xe=M(Ie,ce);Xe===8205&&(ce-=_e(Xe))}return ce}}function _e(ce){return ce>=65536?2:1}function Qe(ce){return 127995<=ce&&ce<=127999}var et;(function(ce){ce[ce.zwj=8205]="zwj",ce[ce.emojiVariantSelector=65039]="emojiVariantSelector",ce[ce.enclosingKeyCap=8419]="enclosingKeyCap"})(et||(et={})),e.noBreakWhitespace="\xA0"}),define(fe[49],me([0,1,8]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function L(P){return y(P,0)}e.hash=L;function y(P,w){switch(typeof P){case"object":return P===null?C(349,w):Array.isArray(P)?_(P,w):D(P,w);case"string":return k(P,w);case"boolean":return i(P,w);case"number":return C(P,w);case"undefined":return C(937,w);default:return C(617,w)}}e.doHash=y;function C(P,w){return(w<<5)-w+P|0}e.numberHash=C;function i(P,w){return C(P?433:863,w)}function k(P,w){w=C(149417,w);for(let s=0,r=P.length;s<r;s++)w=C(P.charCodeAt(s),w);return w}e.stringHash=k;function _(P,w){return w=C(104579,w),P.reduce((s,r)=>y(r,s),w)}function D(P,w){return w=C(181387,w),Object.keys(P).sort().reduce((s,r)=>(s=k(r,s),y(P[r],s)),w)}class T{constructor(){this._value=0}get value(){return this._value}hash(w){return this._value=y(w,this._value),this._value}}e.Hasher=T;var I;(function(P){P[P.BLOCK_SIZE=64]="BLOCK_SIZE",P[P.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function c(P,w,s=32){const r=s-w,m=~((1<<r)-1);return(P<<w|(m&P)>>>r)>>>0}function p(P,w=0,s=P.byteLength,r=0){for(let m=0;m<s;m++)P[w+m]=r}function f(P,w,s="0"){for(;P.length<w;)P=s+P;return P}function v(P,w=32){return P instanceof ArrayBuffer?Array.from(new Uint8Array(P)).map(s=>s.toString(16).padStart(2,"0")).join(""):f((P>>>0).toString(16),w/4)}e.toHexString=v;class S{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(w){const s=w.length;if(s===0)return;const r=this._buff;let m=this._buffLen,a=this._leftoverHighSurrogate,b,n;for(a!==0?(b=a,n=-1,a=0):(b=w.charCodeAt(0),n=0);;){let t=b;if(g.isHighSurrogate(b))if(n+1<s){const l=w.charCodeAt(n+1);g.isLowSurrogate(l)?(n++,t=g.computeCodePoint(b,l)):t=65533}else{a=b;break}else g.isLowSurrogate(b)&&(t=65533);if(m=this._push(r,m,t),n++,n<s)b=w.charCodeAt(n);else break}this._buffLen=m,this._leftoverHighSurrogate=a}_push(w,s,r){return r<128?w[s++]=r:r<2048?(w[s++]=192|(r&1984)>>>6,w[s++]=128|(r&63)>>>0):r<65536?(w[s++]=224|(r&61440)>>>12,w[s++]=128|(r&4032)>>>6,w[s++]=128|(r&63)>>>0):(w[s++]=240|(r&1835008)>>>18,w[s++]=128|(r&258048)>>>12,w[s++]=128|(r&4032)>>>6,w[s++]=128|(r&63)>>>0),s>=64&&(this._step(),s-=64,this._totalLen+=64,w[0]=w[64+0],w[1]=w[64+1],w[2]=w[64+2]),s}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),v(this._h0)+v(this._h1)+v(this._h2)+v(this._h3)+v(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,p(this._buff,this._buffLen),this._buffLen>56&&(this._step(),p(this._buff));const w=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(w/4294967296),!1),this._buffDV.setUint32(60,w%4294967296,!1),this._step()}_step(){const w=S._bigBlock32,s=this._buffDV;for(let o=0;o<64;o+=4)w.setUint32(o,s.getUint32(o,!1),!1);for(let o=64;o<320;o+=4)w.setUint32(o,c(w.getUint32(o-12,!1)^w.getUint32(o-32,!1)^w.getUint32(o-56,!1)^w.getUint32(o-64,!1),1),!1);let r=this._h0,m=this._h1,a=this._h2,b=this._h3,n=this._h4,t,l,d;for(let o=0;o<80;o++)o<20?(t=m&a|~m&b,l=1518500249):o<40?(t=m^a^b,l=1859775393):o<60?(t=m&a|m&b|a&b,l=2400959708):(t=m^a^b,l=3395469782),d=c(r,5)+t+n+l+w.getUint32(o*4,!1)&4294967295,n=b,b=a,a=c(m,30),m=r,r=d;this._h0=this._h0+r&4294967295,this._h1=this._h1+m&4294967295,this._h2=this._h2+a&4294967295,this._h3=this._h3+b&4294967295,this._h4=this._h4+n&4294967295}}e.StringSHA1=S,S._bigBlock32=new DataView(new ArrayBuffer(320))});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,L,y){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?y.call(Y,g):y?y.value=g:e.set(Y,g),g},Ne=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[24],me([0,1,15,8]),function(Y,e,g,L){"use strict";var y,C,i;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function k(n,t,l){let d=n.get(t);return d===void 0&&(d=l,n.set(t,d)),d}e.getOrSet=k;function _(n){const t=[];return n.forEach((l,d)=>{t.push(`${d} => ${l}`)}),`Map(${n.size}) {${t.join(", ")}}`}e.mapToString=_;function D(n){const t=[];return n.forEach(l=>{t.push(l)}),`Set(${n.size}) {${t.join(", ")}}`}e.setToString=D;class T{constructor(){this._value="",this._pos=0}reset(t){return this._value=t,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(t){const l=t.charCodeAt(0),d=this._value.charCodeAt(this._pos);return l-d}value(){return this._value[this._pos]}}e.StringIterator=T;class I{constructor(t=!0){this._caseSensitive=t}reset(t){return this._value=t,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(t)this._from++;else break;else t=!1;return this}cmp(t){return this._caseSensitive?(0,L.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=I;class c{constructor(t=!0,l=!0){this._splitOnBackslash=t,this._caseSensitive=l}reset(t){return this._value=t.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++){const l=this._value.charCodeAt(this._to);if(l===47||this._splitOnBackslash&&l===92)if(t)this._from++;else break;else t=!1}return this}cmp(t){return this._caseSensitive?(0,L.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=c;var p;(function(n){n[n.Scheme=1]="Scheme",n[n.Authority=2]="Authority",n[n.Path=3]="Path",n[n.Query=4]="Query",n[n.Fragment=5]="Fragment"})(p||(p={}));class f{constructor(t){this._ignorePathCasing=t,this._states=[],this._stateIdx=0}reset(t){return this._value=t,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new c(!1,!this._ignorePathCasing(t)),this._pathIterator.reset(t.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(t){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(t,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(t,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(t);if(this._states[this._stateIdx]===4)return(0,L.compare)(t,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(t,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=f;class v{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const t=this.right;return this.right=t.left,t.left=this,this.updateHeight(),t.updateHeight(),t}rotateRight(){const t=this.left;return this.left=t.right,t.right=this,this.updateHeight(),t.updateHeight(),t}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var S;(function(n){n[n.Left=-1]="Left",n[n.Mid=0]="Mid",n[n.Right=1]="Right"})(S||(S={}));class P{constructor(t){this._iter=t}static forUris(t=()=>!1){return new P(new f(t))}static forPaths(){return new P(new c)}static forStrings(){return new P(new T)}static forConfigKeys(){return new P(new I)}clear(){this._root=void 0}fill(t,l){if(l){const d=l.slice(0);(0,g.shuffle)(d);for(let o of d)this.set(o,t)}else{const d=t.slice(0);(0,g.shuffle)(d);for(let o of d)this.set(o[0],o[1])}}set(t,l){const d=this._iter.reset(t);let o;this._root||(this._root=new v,this._root.segment=d.value());const h=[];for(o=this._root;;){const E=d.cmp(o.segment);if(E>0)o.left||(o.left=new v,o.left.segment=d.value()),h.push([-1,o]),o=o.left;else if(E<0)o.right||(o.right=new v,o.right.segment=d.value()),h.push([1,o]),o=o.right;else if(d.hasNext())d.next(),o.mid||(o.mid=new v,o.mid.segment=d.value()),h.push([0,o]),o=o.mid;else break}const u=o.value;o.value=l,o.key=t;for(let E=h.length-1;E>=0;E--){const A=h[E][1];A.updateHeight();const R=A.balanceFactor();if(R<-1||R>1){const B=h[E][0],x=h[E+1][0];if(B===1&&x===1)h[E][1]=A.rotateLeft();else if(B===-1&&x===-1)h[E][1]=A.rotateRight();else if(B===1&&x===-1)A.right=h[E+1][1]=h[E+1][1].rotateRight(),h[E][1]=A.rotateLeft();else if(B===-1&&x===1)A.left=h[E+1][1]=h[E+1][1].rotateLeft(),h[E][1]=A.rotateRight();else throw new Error;if(E>0)switch(h[E-1][0]){case-1:h[E-1][1].left=h[E][1];break;case 1:h[E-1][1].right=h[E][1];break;case 0:h[E-1][1].mid=h[E][1];break}else this._root=h[0][1]}}return u}get(t){return this._getNode(t)?.value}_getNode(t){const l=this._iter.reset(t);let d=this._root;for(;d;){const o=l.cmp(d.segment);if(o>0)d=d.left;else if(o<0)d=d.right;else if(l.hasNext())l.next(),d=d.mid;else break}return d}has(t){const l=this._getNode(t);return!(l?.value===void 0&&l?.mid===void 0)}delete(t){return this._delete(t,!1)}deleteSuperstr(t){return this._delete(t,!0)}_delete(t,l){const d=this._iter.reset(t),o=[];let h=this._root;for(;h;){const u=d.cmp(h.segment);if(u>0)o.push([-1,h]),h=h.left;else if(u<0)o.push([1,h]),h=h.right;else if(d.hasNext())d.next(),o.push([0,h]),h=h.mid;else break}if(!!h){if(l?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const u=this._min(h.right),{key:E,value:A,segment:R}=u;this._delete(u.key,!1),h.key=E,h.value=A,h.segment=R}else{const u=h.left??h.right;if(o.length>0){const[E,A]=o[o.length-1];switch(E){case-1:A.left=u;break;case 0:A.mid=u;break;case 1:A.right=u;break}}else this._root=u}for(let u=o.length-1;u>=0;u--){const E=o[u][1];E.updateHeight();const A=E.balanceFactor();if(A>1?(E.right.balanceFactor()>=0||(E.right=o[u+1][1]=o[u+1][1].rotateRight()),o[u][1]=E.rotateLeft()):A<-1&&(E.left.balanceFactor()<=0||(E.left=o[u+1][1]=o[u+1][1].rotateLeft()),o[u][1]=E.rotateRight()),u>0)switch(o[u-1][0]){case-1:o[u-1][1].left=o[u][1];break;case 1:o[u-1][1].right=o[u][1];break;case 0:o[u-1][1].mid=o[u][1];break}else this._root=o[0][1]}}}_min(t){for(;t.left;)t=t.left;return t}findSubstr(t){const l=this._iter.reset(t);let d=this._root,o;for(;d;){const h=l.cmp(d.segment);if(h>0)d=d.left;else if(h<0)d=d.right;else if(l.hasNext())l.next(),o=d.value||o,d=d.mid;else break}return d&&d.value||o}findSuperstr(t){const l=this._iter.reset(t);let d=this._root;for(;d;){const o=l.cmp(d.segment);if(o>0)d=d.left;else if(o<0)d=d.right;else if(l.hasNext())l.next(),d=d.mid;else return d.mid?this._entries(d.mid):void 0}}forEach(t){for(const[l,d]of this)t(d,l)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(t){!t||(t.left&&(yield*this._entries(t.left)),t.value&&(yield[t.key,t.value]),t.mid&&(yield*this._entries(t.mid)),t.right&&(yield*this._entries(t.right)))}_isBalanced(){const t=l=>{if(!l)return!0;const d=l.balanceFactor();return d<-1||d>1?!1:t(l.left)&&t(l.right)};return t(this._root)}}e.TernarySearchTree=P;class w{constructor(t,l){this.uri=t,this.value=l}}class s{constructor(t,l){this[y]="ResourceMap",t instanceof s?(this.map=new Map(t.map),this.toKey=l??s.defaultToKey):(this.map=new Map,this.toKey=t??s.defaultToKey)}set(t,l){return this.map.set(this.toKey(t),new w(t,l)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,l){typeof l!="undefined"&&(t=t.bind(l));for(let[d,o]of this.map)t(o.value,o.uri,this)}*values(){for(let t of this.map.values())yield t.value}*keys(){for(let t of this.map.values())yield t.uri}*entries(){for(let t of this.map.values())yield[t.uri,t.value]}*[(y=Symbol.toStringTag,Symbol.iterator)](){for(let[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=s,s.defaultToKey=n=>n.toString();var r;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})(r=e.Touch||(e.Touch={}));class m{constructor(){this[C]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,l=0){const d=this._map.get(t);if(!!d)return l!==0&&this.touch(d,l),d.value}set(t,l,d=0){let o=this._map.get(t);if(o)o.value=l,d!==0&&this.touch(o,d);else{switch(o={key:t,value:l,next:void 0,previous:void 0},d){case 0:this.addItemLast(o);break;case 1:this.addItemFirst(o);break;case 2:this.addItemLast(o);break;default:this.addItemLast(o);break}this._map.set(t,o),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const l=this._map.get(t);if(!!l)return this._map.delete(t),this.removeItem(l),this._size--,l.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,l){const d=this._state;let o=this._head;for(;o;){if(l?t.bind(l)(o.value,o.key,this):t(o.value,o.key,this),this._state!==d)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const t=this,l=this._state;let d=this._head;const o={[Symbol.iterator](){return o},next(){if(t._state!==l)throw new Error("LinkedMap got modified during iteration.");if(d){const h={value:d.key,done:!1};return d=d.next,h}else return{value:void 0,done:!0}}};return o}values(){const t=this,l=this._state;let d=this._head;const o={[Symbol.iterator](){return o},next(){if(t._state!==l)throw new Error("LinkedMap got modified during iteration.");if(d){const h={value:d.value,done:!1};return d=d.next,h}else return{value:void 0,done:!0}}};return o}entries(){const t=this,l=this._state;let d=this._head;const o={[Symbol.iterator](){return o},next(){if(t._state!==l)throw new Error("LinkedMap got modified during iteration.");if(d){const h={value:[d.key,d.value],done:!1};return d=d.next,h}else return{value:void 0,done:!0}}};return o}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let l=this._head,d=this.size;for(;l&&d>t;)this._map.delete(l.key),l=l.next,d--;this._head=l,this._size=d,l&&(l.previous=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const l=t.next,d=t.previous;if(!l||!d)throw new Error("Invalid list");l.previous=d,d.next=l}t.next=void 0,t.previous=void 0,this._state++}touch(t,l){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(l!==1&&l!==2)){if(l===1){if(t===this._head)return;const d=t.next,o=t.previous;t===this._tail?(o.next=void 0,this._tail=o):(d.previous=o,o.next=d),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(l===2){if(t===this._tail)return;const d=t.next,o=t.previous;t===this._head?(d.previous=void 0,this._head=d):(d.previous=o,o.next=d),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((l,d)=>{t.push([d,l])}),t}fromJSON(t){this.clear();for(const[l,d]of t)this.set(l,d)}}e.LinkedMap=m;class a extends m{constructor(t,l=1){super();this._limit=t,this._ratio=Math.min(Math.max(0,l),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,l=2){return super.get(t,l)}peek(t){return super.get(t,0)}set(t,l){return super.set(t,l,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=a;class b{constructor(t){i.set(this,void 0),st(this,i,t,"f")}get size(){return Ne(this,i,"f").size}forEach(t,l){Ne(this,i,"f").forEach(t,l)}get(t){return Ne(this,i,"f").get(t)}has(t){return Ne(this,i,"f").has(t)}entries(){return Ne(this,i,"f").entries()}keys(){return Ne(this,i,"f").keys()}values(){return Ne(this,i,"f").values()}[(i=new WeakMap,Symbol.iterator)](){return Ne(this,i,"f").entries()}}e.ReadonlyMapView=b}),define(fe[97],me([0,1,24,8]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function y(...Z){return function(re,pe){for(let Me=0,je=Z.length;Me<je;Me++){const Ke=Z[Me](re,pe);if(Ke)return Ke}return null}}e.or=y,e.matchesStrictPrefix=C.bind(void 0,!1),e.matchesPrefix=C.bind(void 0,!0);function C(Z,re,pe){if(!pe||pe.length<re.length)return null;let Me;return Z?Me=L.startsWithIgnoreCase(pe,re):Me=pe.indexOf(re)===0,Me?re.length>0?[{start:0,end:re.length}]:[]:null}function i(Z,re){const pe=re.toLowerCase().indexOf(Z.toLowerCase());return pe===-1?null:[{start:pe,end:pe+Z.length}]}e.matchesContiguousSubString=i;function k(Z,re){return _(Z.toLowerCase(),re.toLowerCase(),0,0)}e.matchesSubString=k;function _(Z,re,pe,Me){if(pe===Z.length)return[];if(Me===re.length)return null;if(Z[pe]===re[Me]){let je=null;return(je=_(Z,re,pe+1,Me+1))?P({start:Me,end:Me+1},je):null}return _(Z,re,pe,Me+1)}function D(Z){return 97<=Z&&Z<=122}function T(Z){return 65<=Z&&Z<=90}e.isUpper=T;function I(Z){return 48<=Z&&Z<=57}function c(Z){return Z===32||Z===9||Z===10||Z===13}const p=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(Z=>p.add(Z.charCodeAt(0)));function f(Z){return c(Z)||p.has(Z)}function v(Z,re){return Z===re||f(Z)&&f(re)}function S(Z){return D(Z)||T(Z)||I(Z)}function P(Z,re){return re.length===0?re=[Z]:Z.end===re[0].start?re[0].start=Z.start:re.unshift(Z),re}function w(Z,re){for(let pe=re;pe<Z.length;pe++){const Me=Z.charCodeAt(pe);if(T(Me)||I(Me)||pe>0&&!S(Z.charCodeAt(pe-1)))return pe}return Z.length}function s(Z,re,pe,Me){if(pe===Z.length)return[];if(Me===re.length)return null;if(Z[pe]!==re[Me].toLowerCase())return null;{let je=null,Ke=Me+1;for(je=s(Z,re,pe+1,Me+1);!je&&(Ke=w(re,Ke))<re.length;)je=s(Z,re,pe+1,Ke),Ke++;return je===null?null:P({start:Me,end:Me+1},je)}}function r(Z){let re=0,pe=0,Me=0,je=0,Ke=0;for(let at=0;at<Z.length;at++)Ke=Z.charCodeAt(at),T(Ke)&&re++,D(Ke)&&pe++,S(Ke)&&Me++,I(Ke)&&je++;const Ze=re/Z.length,rt=pe/Z.length,lt=Me/Z.length,ye=je/Z.length;return{upperPercent:Ze,lowerPercent:rt,alphaPercent:lt,numericPercent:ye}}function m(Z){const{upperPercent:re,lowerPercent:pe}=Z;return pe===0&&re>.6}function a(Z){const{upperPercent:re,lowerPercent:pe,alphaPercent:Me,numericPercent:je}=Z;return pe>.2&&re<.8&&Me>.6&&je<.2}function b(Z){let re=0,pe=0,Me=0,je=0;for(let Ke=0;Ke<Z.length;Ke++)Me=Z.charCodeAt(Ke),T(Me)&&re++,D(Me)&&pe++,c(Me)&&je++;return(re===0||pe===0)&&je===0?Z.length<=30:re<=5}function n(Z,re){if(!re||(re=re.trim(),re.length===0)||!b(Z)||re.length>60)return null;const pe=r(re);if(!a(pe)){if(!m(pe))return null;re=re.toLowerCase()}let Me=null,je=0;for(Z=Z.toLowerCase();je<re.length&&(Me=s(Z,re,0,je))===null;)je=w(re,je+1);return Me}e.matchesCamelCase=n;function t(Z,re,pe=!1){if(!re||re.length===0)return null;let Me=null,je=0;for(Z=Z.toLowerCase(),re=re.toLowerCase();je<re.length&&(Me=l(Z,re,0,je,pe))===null;)je=d(re,je+1);return Me}e.matchesWords=t;function l(Z,re,pe,Me,je){if(pe===Z.length)return[];if(Me===re.length)return null;if(v(Z.charCodeAt(pe),re.charCodeAt(Me))){let Ke=null,Ze=Me+1;if(Ke=l(Z,re,pe+1,Me+1,je),!je)for(;!Ke&&(Ze=d(re,Ze))<re.length;)Ke=l(Z,re,pe+1,Ze,je),Ze++;return Ke===null?null:P({start:Me,end:Me+1},Ke)}else return null}function d(Z,re){for(let pe=re;pe<Z.length;pe++)if(f(Z.charCodeAt(pe))||pe>0&&f(Z.charCodeAt(pe-1)))return pe;return Z.length}const o=y(e.matchesPrefix,n,i),h=y(e.matchesPrefix,n,k),u=new g.LRUCache(1e4);function E(Z,re,pe=!1){if(typeof Z!="string"||typeof re!="string")return null;let Me=u.get(Z);Me||(Me=new RegExp(L.convertSimple2RegExpPattern(Z),"i"),u.set(Z,Me));const je=Me.exec(re);return je?[{start:je.index,end:je.index+je[0].length}]:pe?h(Z,re):o(Z,re)}e.matchesFuzzy=E;function A(Z,re){const pe=Be(Z,Z.toLowerCase(),0,re,re.toLowerCase(),0,!0);return pe?B(pe):null}e.matchesFuzzy2=A;function R(Z,re,pe,Me,je,Ke){const Ze=Math.min(13,Z.length);for(;pe<Ze;pe++){const rt=Be(Z,re,pe,Me,je,Ke,!1);if(rt)return rt}return[0,Ke]}e.anyScore=R;function B(Z){if(typeof Z=="undefined")return[];const re=[],pe=Z[1];for(let Me=Z.length-1;Me>1;Me--){const je=Z[Me]+pe,Ke=re[re.length-1];Ke&&Ke.end===je?Ke.end=je+1:re.push({start:je,end:je+1})}return re}e.createMatches=B;const x=128;function F(){const Z=[],re=[];for(let pe=0;pe<=x;pe++)re[pe]=0;for(let pe=0;pe<=x;pe++)Z.push(re.slice(0));return Z}function $(Z){const re=[];for(let pe=0;pe<=Z;pe++)re[pe]=0;return re}const M=$(2*x),H=$(2*x),N=F(),U=F(),V=F(),O=!1;function W(Z,re,pe,Me,je){function Ke(rt,lt,ye=" "){for(;rt.length<lt;)rt=ye+rt;return rt}let Ze=` |   |${Me.split("").map(rt=>Ke(rt,3)).join("|")}
`;for(let rt=0;rt<=pe;rt++)rt===0?Ze+=" |":Ze+=`${re[rt-1]}|`,Ze+=Z[rt].slice(0,je+1).map(lt=>Ke(lt.toString(),3)).join("|")+`
`;return Ze}function j(Z,re,pe,Me){Z=Z.substr(re),pe=pe.substr(Me),console.log(W(U,Z,Z.length,pe,pe.length)),console.log(W(V,Z,Z.length,pe,pe.length)),console.log(W(N,Z,Z.length,pe,pe.length))}function X(Z,re){if(re<0||re>=Z.length)return!1;const pe=Z.codePointAt(re);switch(pe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!L.isEmojiImprecise(pe)}}function Q(Z,re){if(re<0||re>=Z.length)return!1;switch(Z.charCodeAt(re)){case 32:case 9:return!0;default:return!1}}function de(Z,re,pe){return re[Z]!==pe[Z]}function Se(Z,re,pe,Me,je,Ke,Ze=!1){for(;re<pe&&je<Ke;)Z[re]===Me[je]&&(Ze&&(M[re]=je),re+=1),je+=1;return re===pe}e.isPatternInWord=Se;var De;(function(Z){Z[Z.Diag=1]="Diag",Z[Z.Left=2]="Left",Z[Z.LeftLeft=3]="LeftLeft"})(De||(De={}));var Pe;(function(Z){Z.Default=[-100,0];function re(pe){return!pe||pe.length===2&&pe[0]===-100&&pe[1]===0}Z.isDefault=re})(Pe=e.FuzzyScore||(e.FuzzyScore={}));function Be(Z,re,pe,Me,je,Ke,Ze){const rt=Z.length>x?x:Z.length,lt=Me.length>x?x:Me.length;if(pe>=rt||Ke>=lt||rt-pe>lt-Ke||!Se(re,pe,rt,je,Ke,lt,!0))return;We(rt,lt,pe,Ke,re,je);let ye=1,at=1,J=pe,ne=Ke;const _e=[!1];for(ye=1,J=pe;J<rt;ye++,J++){const Ue=M[J],Xe=H[J],nt=J+1<rt?H[J+1]:lt;for(at=Ue-Ke+1,ne=Ue;ne<nt;at++,ne++){let ft=Number.MIN_SAFE_INTEGER,tt=!1;ne<=Xe&&(ft=He(Z,re,J,pe,Me,je,ne,lt,Ke,N[ye-1][at-1]===0,_e));let ut=0;ft!==Number.MAX_SAFE_INTEGER&&(tt=!0,ut=ft+U[ye-1][at-1]);const Re=ne>Ue,ve=Re?U[ye][at-1]+(N[ye][at-1]>0?-5:0):0,Te=ne>Ue+1&&N[ye][at-1]>0,se=Te?U[ye][at-2]+(N[ye][at-2]>0?-5:0):0;if(Te&&(!Re||se>=ve)&&(!tt||se>=ut))U[ye][at]=se,V[ye][at]=3,N[ye][at]=0;else if(Re&&(!tt||ve>=ut))U[ye][at]=ve,V[ye][at]=2,N[ye][at]=0;else if(tt)U[ye][at]=ut,V[ye][at]=1,N[ye][at]=N[ye-1][at-1]+1;else throw new Error("not possible")}}if(O&&j(Z,pe,Me,Ke),!_e[0]&&!Ze)return;ye--,at--;const Qe=[U[ye][at],Ke];let et=0,ce=0;for(;ye>=1;){let Ue=at;do{const Xe=V[ye][Ue];if(Xe===3)Ue=Ue-2;else if(Xe===2)Ue=Ue-1;else break}while(Ue>=1);et>1&&re[pe+ye-1]===je[Ke+at-1]&&!de(Ue+Ke-1,Me,je)&&et+1>N[ye][Ue]&&(Ue=at),Ue===at?et++:et=1,ce||(ce=Ue),ye--,at=Ue-1,Qe.push(at)}lt===rt&&(Qe[0]+=2);const Ie=ce-rt;return Qe[0]-=Ie,Qe}e.fuzzyScore=Be;function We(Z,re,pe,Me,je,Ke){let Ze=Z-1,rt=re-1;for(;Ze>=pe&&rt>=Me;)je[Ze]===Ke[rt]&&(H[Ze]=rt,Ze--),rt--}function He(Z,re,pe,Me,je,Ke,Ze,rt,lt,ye,at){if(re[pe]!==Ke[Ze])return Number.MIN_SAFE_INTEGER;let J=1,ne=!1;return Ze===pe-Me?J=Z[pe]===je[Ze]?7:5:de(Ze,je,Ke)&&(Ze===0||!de(Ze-1,je,Ke))?(J=Z[pe]===je[Ze]?7:5,ne=!0):X(Ke,Ze)&&(Ze===0||!X(Ke,Ze-1))?J=5:(X(Ke,Ze-1)||Q(Ke,Ze-1))&&(J=5,ne=!0),J>1&&pe===Me&&(at[0]=!0),ne||(ne=de(Ze,je,Ke)||X(Ke,Ze-1)||Q(Ke,Ze-1)),pe===Me?Ze>lt&&(J-=ne?3:5):ye?J+=ne?2:0:J+=ne?0:1,Ze+1===rt&&(J-=ne?3:5),J}function G(Z,re,pe,Me,je,Ke,Ze){return ie(Z,re,pe,Me,je,Ke,!0,Ze)}e.fuzzyScoreGracefulAggressive=G;function ee(Z,re,pe,Me,je,Ke,Ze){return ie(Z,re,pe,Me,je,Ke,!1,Ze)}e.fuzzyScoreGraceful=ee;function ie(Z,re,pe,Me,je,Ke,Ze,rt){let lt=Be(Z,re,pe,Me,je,Ke,rt);if(lt&&!Ze)return lt;if(Z.length>=3){const ye=Math.min(7,Z.length-1);for(let at=pe+1;at<ye;at++){const J=le(Z,at);if(J){const ne=Be(J,J.toLowerCase(),pe,Me,je,Ke,rt);ne&&(ne[0]-=3,(!lt||ne[0]>lt[0])&&(lt=ne))}}}return lt}function le(Z,re){if(re+1>=Z.length)return;const pe=Z[re],Me=Z[re+1];if(pe!==Me)return Z.slice(0,re)+Me+pe+Z.slice(re+2)}}),define(fe[142],me([0,1,48,97,8]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const C=new RegExp(`\\$\\(${g.CSSIcon.iconNameExpression}(?:${g.CSSIcon.iconModifierExpression})?\\)`,"g"),i=new RegExp(g.CSSIcon.iconNameCharacter),k=new RegExp(`(\\\\)?${C.source}`,"g");function _(S){return S.replace(k,(P,w)=>w?P:`\\${P}`)}e.escapeIcons=_;const D=new RegExp(`\\\\${C.source}`,"g");function T(S){return S.replace(D,P=>`\\${P}`)}e.markdownEscapeEscapedIcons=T;const I=new RegExp(`(\\s)?(\\\\)?${C.source}(\\s)?`,"g");function c(S){return S.indexOf(e.iconStartMarker)===-1?S:S.replace(I,(P,w,s,r)=>s?P:w||r||"")}e.stripIcons=c;function p(S){const P=S.indexOf(e.iconStartMarker);return P===-1?{text:S}:f(S,P)}e.parseLabelWithIcons=p;function f(S,P){const w=[];let s="";function r(o){if(o){s+=o;for(const h of o)w.push(b)}}let m=-1,a="",b=0,n,t,l=P;const d=S.length;for(r(S.substr(0,P));l<d;)n=S[l],t=S[l+1],n===e.iconStartMarker[0]&&t===e.iconStartMarker[1]?(m=l,r(a),a=e.iconStartMarker,l++):n===")"&&m!==-1?(b+=l-m+1,m=-1,a=""):m!==-1?i.test(n)?a+=n:(r(a),m=-1,a=""):r(n),l++;return r(a),{text:s,iconOffsets:w}}function v(S,P,w=!1){const{text:s,iconOffsets:r}=P;if(!r||r.length===0)return(0,L.matchesFuzzy)(S,s,w);const m=(0,y.ltrim)(s," "),a=s.length-m.length,b=(0,L.matchesFuzzy)(S,m,w);if(b)for(const n of b){const t=r[n.start+a]+a;n.start+=t,n.end+=t}return b}e.matchesFuzzyIconAware=v}),define(fe[98],me([0,1,18,142]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var y;(function(c){c[c.Paragraph=0]="Paragraph",c[c.Break=1]="Break"})(y=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class C{constructor(p="",f=!1){if(this.value=p,typeof this.value!="string")throw(0,g.illegalArgument)("value");typeof f=="boolean"?(this.isTrusted=f,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=f.isTrusted??void 0,this.supportThemeIcons=f.supportThemeIcons??!1,this.supportHtml=f.supportHtml??!1)}appendText(p,f=0){return this.value+=D(this.supportThemeIcons?(0,L.escapeIcons)(p):p).replace(/([ \t]+)/g,(v,S)=>"&nbsp;".repeat(S.length)).replace(/\>/gm,"\\>").replace(/\n/g,f===1?`\\
`:`

`),this}appendMarkdown(p){return this.value+=p,this}appendCodeblock(p,f){return this.value+="\n```",this.value+=p,this.value+=`
`,this.value+=f,this.value+="\n```\n",this}}e.MarkdownString=C;function i(c){return k(c)?!c.value:Array.isArray(c)?c.every(i):!0}e.isEmptyMarkdownString=i;function k(c){return c instanceof C?!0:c&&typeof c=="object"?typeof c.value=="string"&&(typeof c.isTrusted=="boolean"||c.isTrusted===void 0)&&(typeof c.supportThemeIcons=="boolean"||c.supportThemeIcons===void 0):!1}e.isMarkdownString=k;function _(c,p){return c===p?!0:!c||!p?!1:c.value===p.value&&c.isTrusted===p.isTrusted&&c.supportThemeIcons===p.supportThemeIcons}e.markdownStringEqual=_;function D(c){return c.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=D;function T(c){return c&&c.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=T;function I(c){const p=[],f=c.split("|").map(S=>S.trim());c=f[0];const v=f[1];if(v){const S=/height=(\d+)/.exec(v),P=/width=(\d+)/.exec(v),w=S?S[1]:"",s=P?P[1]:"",r=isFinite(parseInt(s)),m=isFinite(parseInt(w));r&&p.push(`width="${s}"`),m&&p.push(`height="${w}"`)}return{href:c,dimensions:p}}e.parseHrefAndDimensions=I}),define(fe[80],me([0,1,24]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new g.LRUCache(1e4);function y(D){return _(D,"NFC",L)}e.normalizeNFC=y;const C=new g.LRUCache(1e4);function i(D){return _(D,"NFD",C)}e.normalizeNFD=i;const k=/[^\u0000-\u0080]/;function _(D,T,I){if(!D)return D;const c=I.get(D);if(c)return c;let p;return k.test(D)?p=D.normalize(T):p=D,I.set(D,p),p}e.removeAccents=function(){const D=/[\u0300-\u036f]/g;return function(T){return i(T).replace(D,"")}}()}),define(fe[50],me([0,1,8]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(y){y[y.Ignore=0]="Ignore",y[y.Info=1]="Info",y[y.Warning=2]="Warning",y[y.Error=3]="Error"})(L||(L={})),function(y){const C="error",i="warning",k="warn",_="info",D="ignore";function T(c){return c?g.equalsIgnoreCase(C,c)?y.Error:g.equalsIgnoreCase(i,c)||g.equalsIgnoreCase(k,c)?y.Warning:g.equalsIgnoreCase(_,c)?y.Info:y.Ignore:y.Ignore}y.fromValue=T;function I(c){switch(c){case y.Error:return C;case y.Warning:return i;case y.Info:return _;default:return D}}y.toString=I}(L||(L={})),e.default=L}),define(fe[13],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function g(h){return Array.isArray(h)}e.isArray=g;function L(h){return typeof h=="string"}e.isString=L;function y(h){return Array.isArray(h)&&h.every(u=>L(u))}e.isStringArray=y;function C(h){return typeof h=="object"&&h!==null&&!Array.isArray(h)&&!(h instanceof RegExp)&&!(h instanceof Date)}e.isObject=C;function i(h){return typeof h=="number"&&!isNaN(h)}e.isNumber=i;function k(h){return!!h&&typeof h[Symbol.iterator]=="function"}e.isIterable=k;function _(h){return h===!0||h===!1}e.isBoolean=_;function D(h){return typeof h=="undefined"}e.isUndefined=D;function T(h){return!I(h)}e.isDefined=T;function I(h){return D(h)||h===null}e.isUndefinedOrNull=I;function c(h,u){if(!h)throw new Error(u?`Unexpected type, expected '${u}'`:"Unexpected type")}e.assertType=c;function p(h){if(I(h))throw new Error("Assertion Failed: argument is undefined or null");return h}e.assertIsDefined=p;function f(...h){const u=[];for(let E=0;E<h.length;E++){const A=h[E];if(I(A))throw new Error(`Assertion Failed: argument at index ${E} is undefined or null`);u.push(A)}return u}e.assertAllDefined=f;const v=Object.prototype.hasOwnProperty;function S(h){if(!C(h))return!1;for(let u in h)if(v.call(h,u))return!1;return!0}e.isEmptyObject=S;function P(h){return typeof h=="function"}e.isFunction=P;function w(...h){return h.length>0&&h.every(P)}e.areFunctions=w;function s(h,u){const E=Math.min(h.length,u.length);for(let A=0;A<E;A++)r(h[A],u[A])}e.validateConstraints=s;function r(h,u){if(L(u)){if(typeof h!==u)throw new Error(`argument does not match constraint: typeof ${u}`)}else if(P(u)){try{if(h instanceof u)return}catch{}if(!I(h)&&h.constructor===u||u.length===1&&u.call(void 0,h)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=r;function m(h){let u=[],E=Object.getPrototypeOf(h);for(;Object.prototype!==E;)u=u.concat(Object.getOwnPropertyNames(E)),E=Object.getPrototypeOf(E);return u}e.getAllPropertyNames=m;function a(h){const u=[];for(const E of m(h))typeof h[E]=="function"&&u.push(E);return u}e.getAllMethodNames=a;function b(h,u){const E=R=>function(){const B=Array.prototype.slice.call(arguments,0);return u(R,B)};let A={};for(const R of h)A[R]=E(R);return A}e.createProxyObject=b;function n(h){return h===null?void 0:h}e.withNullAsUndefined=n;function t(h){return typeof h=="undefined"?null:h}e.withUndefinedAsNull=t;function l(h){return class{constructor(){return new Proxy({},{get(u,E){if(u[E])return u[E];throw new Error(`Not Implemented: ${h}->${String(E)}`)}})}}}e.NotImplementedProxy=l;function d(h,u="Unreachable"){throw new Error(u)}e.assertNever=d;function o(h){return!!h&&typeof h.then=="function"&&typeof h.catch=="function"}e.isPromise=o}),define(fe[30],me([0,1,9,12,8,13]),function(Y,e,g,L,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function i(n){return n===47||n===92}e.isPathSeparator=i;function k(n){return n.replace(/[\\/]/g,g.posix.sep)}e.toSlashes=k;function _(n){return n.indexOf("/")===-1&&(n=k(n)),/^[a-zA-Z]:(\/|$)/.test(n)&&(n="/"+n),n}e.toPosixPath=_;function D(n,t=g.posix.sep){if(!n)return"";const l=n.length,d=n.charCodeAt(0);if(i(d)){if(i(n.charCodeAt(1))&&!i(n.charCodeAt(2))){let h=3;const u=h;for(;h<l&&!i(n.charCodeAt(h));h++);if(u!==h&&!i(n.charCodeAt(h+1))){for(h+=1;h<l;h++)if(i(n.charCodeAt(h)))return n.slice(0,h+1).replace(/[\\/]/g,t)}}return t}else if(P(d)&&n.charCodeAt(1)===58)return i(n.charCodeAt(2))?n.slice(0,2)+t:n.slice(0,2);let o=n.indexOf("://");if(o!==-1){for(o+=3;o<l;o++)if(i(n.charCodeAt(o)))return n.slice(0,o+1)}return""}e.getRoot=D;function T(n){if(!L.isWindows||!n||n.length<5)return!1;let t=n.charCodeAt(0);if(t!==92||(t=n.charCodeAt(1),t!==92))return!1;let l=2;const d=l;for(;l<n.length&&(t=n.charCodeAt(l),t!==92);l++);return!(d===l||(t=n.charCodeAt(l+1),isNaN(t)||t===92))}e.isUNC=T;const I=/[\\/:\*\?"<>\|]/g,c=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(n,t=L.isWindows){const l=t?I:c;return!(!n||n.length===0||/^\s+$/.test(n)||(l.lastIndex=0,l.test(n))||t&&p.test(n)||n==="."||n===".."||t&&n[n.length-1]==="."||t&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=f;function v(n,t,l){const d=n===t;return!l||d?d:!n||!t?!1:(0,y.equalsIgnoreCase)(n,t)}e.isEqual=v;function S(n,t,l,d=g.sep){if(n===t)return!0;if(!n||!t||t.length>n.length)return!1;if(l){if(!(0,y.startsWithIgnoreCase)(n,t))return!1;if(t.length===n.length)return!0;let h=t.length;return t.charAt(t.length-1)===d&&h--,n.charAt(h)===d}return t.charAt(t.length-1)!==d&&(t+=d),n.indexOf(t)===0}e.isEqualOrParent=S;function P(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=P;function w(n,t){return L.isWindows&&n.endsWith(":")&&(n+=g.sep),(0,g.isAbsolute)(n)||(n=(0,g.join)(t,n)),n=(0,g.normalize)(n),L.isWindows?(n=(0,y.rtrim)(n,g.sep),n.endsWith(":")&&(n+=g.sep)):(n=(0,y.rtrim)(n,g.sep),n||(n=g.sep)),n}e.sanitizeFilePath=w;function s(n){const t=(0,g.normalize)(n);return L.isWindows?n.length>3?!1:r(t)&&(n.length===2||t.charCodeAt(2)===92):t===g.posix.sep}e.isRootOrDriveLetter=s;function r(n,t){return(t!==void 0?t:L.isWindows)?P(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=r;function m(n){return r(n)?n[0]:void 0}e.getDriveLetter=m;function a(n,t,l){return t.length>n.length?-1:n===t?0:(l&&(n=n.toLowerCase(),t=t.toLowerCase()),n.indexOf(t))}e.indexOfPath=a;function b(n){const t=n.split(":");let l,d,o;if(t.forEach(h=>{const u=Number(h);(0,C.isNumber)(u)?d===void 0?d=u:o===void 0&&(o=u):l=l?[l,h].join(":"):h}),!l)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:l,line:d!==void 0?d:void 0,column:o!==void 0?o:d!==void 0?1:void 0}}e.parseLineAndColumnAware=b}),define(fe[25],me([0,1,13]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(v){if(!v||typeof v!="object"||v instanceof RegExp)return v;const S=Array.isArray(v)?[]:{};return Object.keys(v).forEach(P=>{v[P]&&typeof v[P]=="object"?S[P]=L(v[P]):S[P]=v[P]}),S}e.deepClone=L;function y(v){if(!v||typeof v!="object")return v;const S=[v];for(;S.length>0;){const P=S.shift();Object.freeze(P);for(const w in P)if(C.call(P,w)){const s=P[w];typeof s=="object"&&!Object.isFrozen(s)&&S.push(s)}}return v}e.deepFreeze=y;const C=Object.prototype.hasOwnProperty;function i(v,S){return k(v,S,new Set)}e.cloneAndChange=i;function k(v,S,P){if((0,g.isUndefinedOrNull)(v))return v;const w=S(v);if(typeof w!="undefined")return w;if((0,g.isArray)(v)){const s=[];for(const r of v)s.push(k(r,S,P));return s}if((0,g.isObject)(v)){if(P.has(v))throw new Error("Cannot clone recursive data-structure");P.add(v);const s={};for(let r in v)C.call(v,r)&&(s[r]=k(v[r],S,P));return P.delete(v),s}return v}function _(v,S,P=!0){return(0,g.isObject)(v)?((0,g.isObject)(S)&&Object.keys(S).forEach(w=>{w in v?P&&((0,g.isObject)(v[w])&&(0,g.isObject)(S[w])?_(v[w],S[w],P):v[w]=S[w]):v[w]=S[w]}),v):S}e.mixin=_;function D(v,S){if(v===S)return!0;if(v==null||S===null||S===void 0||typeof v!=typeof S||typeof v!="object"||Array.isArray(v)!==Array.isArray(S))return!1;let P,w;if(Array.isArray(v)){if(v.length!==S.length)return!1;for(P=0;P<v.length;P++)if(!D(v[P],S[P]))return!1}else{const s=[];for(w in v)s.push(w);s.sort();const r=[];for(w in S)r.push(w);if(r.sort(),!D(s,r))return!1;for(P=0;P<s.length;P++)if(!D(v[s[P]],S[s[P]]))return!1}return!0}e.equals=D;function T(v){const S=new Set;return JSON.stringify(v,(P,w)=>{if((0,g.isObject)(w)||Array.isArray(w)){if(S.has(w))return"[Circular]";S.add(w)}return w})}e.safeStringify=T;function I(v,S,P){const w=S(v);return typeof w=="undefined"?P:w}e.getOrDefault=I;function c(v,S){const P=Object.create(null);return!v||!S||Object.keys(S).forEach(s=>{const r=v[s],m=S[s];D(r,m)||(P[s]=m)}),P}e.distinct=c;function p(v,S){const P=S.toLowerCase(),w=Object.keys(v).find(s=>s.toLowerCase()===P);return w?v[w]:v[S]}e.getCaseInsensitive=p;function f(v,S){const P=Object.create(null);for(const[w,s]of Object.entries(v))S(w,s)&&(P[w]=s);return P}e.filter=f}),define(fe[99],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var g;(function(C){C[C.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",C[C.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",C[C.MAX_UINT_8=255]="MAX_UINT_8",C[C.MAX_UINT_16=65535]="MAX_UINT_16",C[C.MAX_UINT_32=4294967295]="MAX_UINT_32",C[C.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(g=e.Constants||(e.Constants={}));function L(C){return C<0?0:C>255?255:C|0}e.toUint8=L;function y(C){return C<0?0:C>4294967295?4294967295:C|0}e.toUint32=y}),define(fe[2],me([0,1,9,12]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const y=/^\w[\w\d+.-]*$/,C=/^\//,i=/^\/\//;function k(n,t){if(!n.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!y.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!C.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(i.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function _(n,t){return!n&&!t?"file":n}function D(n,t){switch(n){case"https":case"http":case"file":t?t[0]!==I&&(t=I+t):t=I;break}return t}const T="",I="/",c=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class p{constructor(t,l,d,o,h,u=!1){typeof t=="object"?(this.scheme=t.scheme||T,this.authority=t.authority||T,this.path=t.path||T,this.query=t.query||T,this.fragment=t.fragment||T):(this.scheme=_(t,u),this.authority=l||T,this.path=D(this.scheme,d||T),this.query=o||T,this.fragment=h||T,k(this,u))}static isUri(t){return t instanceof p?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}get fsPath(){return s(this,!1)}with(t){if(!t)return this;let{scheme:l,authority:d,path:o,query:h,fragment:u}=t;return l===void 0?l=this.scheme:l===null&&(l=T),d===void 0?d=this.authority:d===null&&(d=T),o===void 0?o=this.path:o===null&&(o=T),h===void 0?h=this.query:h===null&&(h=T),u===void 0?u=this.fragment:u===null&&(u=T),l===this.scheme&&d===this.authority&&o===this.path&&h===this.query&&u===this.fragment?this:new v(l,d,o,h,u)}static parse(t,l=!1){const d=c.exec(t);return d?new v(d[2]||T,b(d[4]||T),b(d[5]||T),b(d[7]||T),b(d[9]||T),l):new v(T,T,T,T,T)}static file(t){let l=T;if(L.isWindows&&(t=t.replace(/\\/g,I)),t[0]===I&&t[1]===I){const d=t.indexOf(I,2);d===-1?(l=t.substring(2),t=I):(l=t.substring(2,d),t=t.substring(d)||I)}return new v("file",l,t,T,T)}static from(t){const l=new v(t.scheme,t.authority,t.path,t.query,t.fragment);return k(l,!0),l}static joinPath(t,...l){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let d;return L.isWindows&&t.scheme==="file"?d=p.file(g.win32.join(s(t,!0),...l)).path:d=g.posix.join(t.path,...l),t.with({path:d})}toString(t=!1){return r(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof p)return t;{const l=new v(t);return l._formatted=t.external,l._fsPath=t._sep===f?t.fsPath:null,l}}else return t}}e.URI=p;const f=L.isWindows?1:void 0;class v extends p{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=s(this,!1)),this._fsPath}toString(t=!1){return t?r(this,!0):(this._formatted||(this._formatted=r(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=f),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const S={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function P(n,t){let l,d=-1;for(let o=0;o<n.length;o++){const h=n.charCodeAt(o);if(h>=97&&h<=122||h>=65&&h<=90||h>=48&&h<=57||h===45||h===46||h===95||h===126||t&&h===47)d!==-1&&(l+=encodeURIComponent(n.substring(d,o)),d=-1),l!==void 0&&(l+=n.charAt(o));else{l===void 0&&(l=n.substr(0,o));const u=S[h];u!==void 0?(d!==-1&&(l+=encodeURIComponent(n.substring(d,o)),d=-1),l+=u):d===-1&&(d=o)}}return d!==-1&&(l+=encodeURIComponent(n.substring(d))),l!==void 0?l:n}function w(n){let t;for(let l=0;l<n.length;l++){const d=n.charCodeAt(l);d===35||d===63?(t===void 0&&(t=n.substr(0,l)),t+=S[d]):t!==void 0&&(t+=n[l])}return t!==void 0?t:n}function s(n,t){let l;return n.authority&&n.path.length>1&&n.scheme==="file"?l=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?t?l=n.path.substr(1):l=n.path[1].toLowerCase()+n.path.substr(2):l=n.path,L.isWindows&&(l=l.replace(/\//g,"\\")),l}e.uriToFsPath=s;function r(n,t){const l=t?w:P;let d="",{scheme:o,authority:h,path:u,query:E,fragment:A}=n;if(o&&(d+=o,d+=":"),(h||o==="file")&&(d+=I,d+=I),h){let R=h.indexOf("@");if(R!==-1){const B=h.substr(0,R);h=h.substr(R+1),R=B.indexOf(":"),R===-1?d+=l(B,!1):(d+=l(B.substr(0,R),!1),d+=":",d+=l(B.substr(R+1),!1)),d+="@"}h=h.toLowerCase(),R=h.indexOf(":"),R===-1?d+=l(h,!1):(d+=l(h.substr(0,R),!1),d+=h.substr(R))}if(u){if(u.length>=3&&u.charCodeAt(0)===47&&u.charCodeAt(2)===58){const R=u.charCodeAt(1);R>=65&&R<=90&&(u=`/${String.fromCharCode(R+32)}:${u.substr(3)}`)}else if(u.length>=2&&u.charCodeAt(1)===58){const R=u.charCodeAt(0);R>=65&&R<=90&&(u=`${String.fromCharCode(R+32)}:${u.substr(2)}`)}d+=l(u,!0)}return E&&(d+="?",d+=l(E,!1)),A&&(d+="#",d+=t?A:P(A,!1)),d}function m(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+m(n.substr(3)):n}}const a=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function b(n){return n.match(a)?n.replace(a,t=>m(t)):n}}),define(fe[62],me([0,1,22,8,2]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function C(T){return JSON.stringify(T,_)}e.stringify=C;function i(T){let I=JSON.parse(T);return I=D(I),I}e.parse=i;var k;(function(T){T[T.Uri=1]="Uri",T[T.Regexp=2]="Regexp",T[T.ScmResource=3]="ScmResource",T[T.ScmResourceGroup=4]="ScmResourceGroup",T[T.ScmProvider=5]="ScmProvider",T[T.CommentController=6]="CommentController",T[T.CommentThread=7]="CommentThread",T[T.CommentThreadReply=8]="CommentThreadReply",T[T.CommentNode=9]="CommentNode",T[T.CommentThreadNode=10]="CommentThreadNode",T[T.TimelineActionContext=11]="TimelineActionContext",T[T.NotebookCellActionContext=12]="NotebookCellActionContext",T[T.TestItemContext=13]="TestItemContext"})(k=e.MarshalledId||(e.MarshalledId={}));function _(T,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,L.regExpFlags)(I)}:I}function D(T,I=0){if(!T||I>200)return T;if(typeof T=="object"){switch(T.$mid){case 1:return y.URI.revive(T);case 2:return new RegExp(T.source,T.flags)}if(T instanceof g.VSBuffer||T instanceof Uint8Array)return T;if(Array.isArray(T))for(let c=0;c<T.length;++c)T[c]=D(T[c],I+1);else for(const c in T)Object.hasOwnProperty.call(T,c)&&(T[c]=D(T[c],I+1))}return T}e.revive=D}),define(fe[10],me([0,1,12,2]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var y;(function(k){k.inMemory="inmemory",k.vscode="vscode",k.internal="private",k.walkThrough="walkThrough",k.walkThroughSnippet="walkThroughSnippet",k.http="http",k.https="https",k.file="file",k.mailto="mailto",k.untitled="untitled",k.data="data",k.command="command",k.vscodeRemote="vscode-remote",k.vscodeRemoteResource="vscode-remote-resource",k.userData="vscode-userdata",k.vscodeCustomEditor="vscode-custom-editor",k.vscodeNotebook="vscode-notebook",k.vscodeNotebookCell="vscode-notebook-cell",k.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",k.vscodeNotebookCellOutput="vscode-notebook-cell-output",k.vscodeInteractive="vscode-interactive",k.vscodeInteractiveInput="vscode-interactive-input",k.vscodeSettings="vscode-settings",k.vscodeWorkspaceTrust="vscode-workspace-trust",k.vscodeTerminal="vscode-terminal",k.webviewPanel="webview-panel",k.vscodeWebview="vscode-webview",k.extension="extension",k.vscodeFileResource="vscode-file",k.tmp="tmp",k.vsls="vsls"})(y=e.Schemas||(e.Schemas={}));class C{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(_){this._preferredWebSchema=_}setDelegate(_){this._delegate=_}set(_,D,T){this._hosts[_]=D,this._ports[_]=T}setConnectionToken(_,D){this._connectionTokens[_]=D}rewrite(_){if(this._delegate)return this._delegate(_);const D=_.authority;let T=this._hosts[D];T&&T.indexOf(":")!==-1&&(T=`[${T}]`);const I=this._ports[D],c=this._connectionTokens[D];let p=`path=${encodeURIComponent(_.path)}`;return typeof c=="string"&&(p+=`&tkn=${encodeURIComponent(c)}`),L.URI.from({scheme:g.isWeb?this._preferredWebSchema:y.vscodeRemoteResource,authority:`${T}:${I}`,path:"/vscode-remote-resource",query:p})}}e.RemoteAuthorities=new C;class i{asBrowserUri(_,D){const T=this.toUri(_,D);return T.scheme===y.vscodeRemote?e.RemoteAuthorities.rewrite(T):T.scheme===y.file&&(g.isNative||typeof g.globals.importScripts=="function"&&g.globals.origin===`${y.vscodeFileResource}://${i.FALLBACK_AUTHORITY}`)?T.with({scheme:y.vscodeFileResource,authority:T.authority||i.FALLBACK_AUTHORITY,query:null,fragment:null}):T}asFileUri(_,D){const T=this.toUri(_,D);return T.scheme===y.vscodeFileResource?T.with({scheme:y.file,authority:T.authority!==i.FALLBACK_AUTHORITY?T.authority:null,query:null,fragment:null}):T}toUri(_,D){return L.URI.isUri(_)?_:L.URI.parse(D.toUrl(_))}}i.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new i}),define(fe[23],me([0,1,30,10,9,12,8,2]),function(Y,e,g,L,y,C,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function _(p){return(0,k.uriToFsPath)(p,!0)}e.originalFSPath=_;class D{constructor(f){this._ignorePathCasing=f}compare(f,v,S=!1){return f===v?0:(0,i.compare)(this.getComparisonKey(f,S),this.getComparisonKey(v,S))}isEqual(f,v,S=!1){return f===v?!0:!f||!v?!1:this.getComparisonKey(f,S)===this.getComparisonKey(v,S)}getComparisonKey(f,v=!1){return f.with({path:this._ignorePathCasing(f)?f.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing(f){return this._ignorePathCasing(f)}isEqualOrParent(f,v,S=!1){if(f.scheme===v.scheme){if(f.scheme===L.Schemas.file)return g.isEqualOrParent(_(f),_(v),this._ignorePathCasing(f))&&f.query===v.query&&(S||f.fragment===v.fragment);if((0,e.isEqualAuthority)(f.authority,v.authority))return g.isEqualOrParent(f.path,v.path,this._ignorePathCasing(f),"/")&&f.query===v.query&&(S||f.fragment===v.fragment)}return!1}joinPath(f,...v){return k.URI.joinPath(f,...v)}basenameOrAuthority(f){return(0,e.basename)(f)||f.authority}basename(f){return y.posix.basename(f.path)}extname(f){return y.posix.extname(f.path)}dirname(f){if(f.path.length===0)return f;let v;return f.scheme===L.Schemas.file?v=k.URI.file(y.dirname(_(f))).path:(v=y.posix.dirname(f.path),f.authority&&v.length&&v.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),v="/")),f.with({path:v})}normalizePath(f){if(!f.path.length)return f;let v;return f.scheme===L.Schemas.file?v=k.URI.file(y.normalize(_(f))).path:v=y.posix.normalize(f.path),f.with({path:v})}relativePath(f,v){if(f.scheme!==v.scheme||!(0,e.isEqualAuthority)(f.authority,v.authority))return;if(f.scheme===L.Schemas.file){const w=y.relative(_(f),_(v));return C.isWindows?g.toSlashes(w):w}let S=f.path||"/",P=v.path||"/";if(this._ignorePathCasing(f)){let w=0;for(const s=Math.min(S.length,P.length);w<s&&!(S.charCodeAt(w)!==P.charCodeAt(w)&&S.charAt(w).toLowerCase()!==P.charAt(w).toLowerCase());w++);S=P.substr(0,w)+S.substr(w)}return y.posix.relative(S,P)}resolvePath(f,v){if(f.scheme===L.Schemas.file){const S=k.URI.file(y.resolve(_(f),v));return f.with({authority:S.authority,path:S.path})}return v=g.toPosixPath(v),f.with({path:y.posix.resolve(f.path,v)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,v){return f===v||f!==void 0&&v!==void 0&&(0,i.equalsIgnoreCase)(f,v)}hasTrailingPathSeparator(f,v=y.sep){if(f.scheme===L.Schemas.file){const S=_(f);return S.length>g.getRoot(S).length&&S[S.length-1]===v}else{const S=f.path;return S.length>1&&S.charCodeAt(S.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,v=y.sep){return(0,e.hasTrailingPathSeparator)(f,v)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,v=y.sep){let S=!1;if(f.scheme===L.Schemas.file){const P=_(f);S=P!==void 0&&P.length===g.getRoot(P).length&&P[P.length-1]===v}else{v="/";const P=f.path;S=P.length===1&&P.charCodeAt(P.length-1)===47}return!S&&!(0,e.hasTrailingPathSeparator)(f,v)?f.with({path:f.path+"/"}):f}}e.ExtUri=D,e.extUri=new D(()=>!1),e.extUriBiasedIgnorePathCase=new D(p=>p.scheme===L.Schemas.file?!C.isLinux:!0),e.extUriIgnorePathCase=new D(p=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function T(p,f){const v=[];for(let S=0;S<p.length;S++){const P=f(p[S]);p.some((w,s)=>s===S?!1:(0,e.isEqualOrParent)(P,f(w)))||v.push(p[S])}return v}e.distinctParents=T;var I;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function f(v){const S=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(s=>{const[r,m]=s.split(":");r&&m&&S.set(r,m)});const w=v.path.substring(0,v.path.indexOf(";"));return w&&S.set(p.META_DATA_MIME,w),S}p.parseMetaData=f})(I=e.DataUri||(e.DataUri={}));function c(p,f,v){if(f){let S=p.path;return S&&S[0]!==y.posix.sep&&(S=y.posix.sep+S),p.with({scheme:v,authority:f,path:S})}return p.with({scheme:v})}e.toLocalResource=c}),define(fe[16],me([0,1,21,18,3,6,23]),function(Y,e,g,L,y,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function k(N){return!!N&&typeof N.then=="function"}e.isThenable=k;function _(N){const U=new g.CancellationTokenSource,V=N(U.token),O=new Promise((W,j)=>{const X=U.token.onCancellationRequested(()=>{X.dispose(),U.dispose(),j((0,L.canceled)())});Promise.resolve(V).then(Q=>{X.dispose(),U.dispose(),W(Q)},Q=>{X.dispose(),U.dispose(),j(Q)})});return new class{cancel(){U.cancel()}then(W,j){return O.then(W,j)}catch(W){return this.then(void 0,W)}finally(W){return O.finally(W)}}}e.createCancelablePromise=_;function D(N,U,V){return Promise.race([N,new Promise(O=>U.onCancellationRequested(()=>O(V)))])}e.raceCancellation=D;async function T(N){let U=-1;const V=N.map((W,j)=>W.then(X=>(U=j,X))),O=await Promise.race(V);return N.forEach((W,j)=>{j!==U&&W.cancel()}),O}e.raceCancellablePromises=T;function I(N,U,V){let O;const W=setTimeout(()=>{O?.(void 0),V?.()},U);return Promise.race([N.finally(()=>clearTimeout(W)),new Promise(j=>O=j)])}e.raceTimeout=I;function c(N){return new Promise((U,V)=>{const O=N();k(O)?O.then(U,V):U(O)})}e.asPromise=c;class p{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(U){if(this.activePromise){if(this.queuedPromiseFactory=U,!this.queuedPromise){const V=()=>{this.queuedPromise=null;const O=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,O};this.queuedPromise=new Promise(O=>{this.activePromise.then(V,V).then(O)})}return new Promise((V,O)=>{this.queuedPromise.then(V,O)})}return this.activePromise=U(),new Promise((V,O)=>{this.activePromise.then(W=>{this.activePromise=null,V(W)},W=>{this.activePromise=null,O(W)})})}}e.Throttler=p;class f{constructor(){this.current=Promise.resolve(null)}queue(U){return this.current=this.current.then(()=>U(),()=>U())}}e.Sequencer=f;class v{constructor(){this.promiseMap=new Map}queue(U,V){const W=(this.promiseMap.get(U)??Promise.resolve()).catch(()=>{}).then(V).finally(()=>{this.promiseMap.get(U)===W&&this.promiseMap.delete(U)});return this.promiseMap.set(U,W),W}}e.SequencerByKey=v;class S{constructor(U){this.defaultDelay=U,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(U,V=this.defaultDelay){return this.task=U,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((O,W)=>{this.doResolve=O,this.doReject=W}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const O=this.task;return this.task=null,O()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},V),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,L.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=S;class P{constructor(U){this.delayer=new S(U),this.throttler=new p}trigger(U,V){return this.delayer.trigger(()=>this.throttler.queue(U),V)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=P;class w{constructor(){this._isOpen=!1,this._promise=new Promise((U,V)=>{this._completePromise=U})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=w;class s extends w{constructor(U){super();this._timeout=setTimeout(()=>this.open(),U)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=s;function r(N,U){return U?new Promise((V,O)=>{const W=setTimeout(()=>{j.dispose(),V()},N),j=U.onCancellationRequested(()=>{clearTimeout(W),j.dispose(),O((0,L.canceled)())})}):_(V=>r(N,V))}e.timeout=r;function m(N,U=0){const V=setTimeout(N,U);return(0,C.toDisposable)(()=>clearTimeout(V))}e.disposableTimeout=m;function a(N){const U=[];let V=0;const O=N.length;function W(){return V<O?N[V++]():null}function j(X){X!=null&&U.push(X);const Q=W();return Q?Q.then(j):Promise.resolve(U)}return Promise.resolve(null).then(j)}e.sequence=a;function b(N,U=O=>!!O,V=null){let O=0;const W=N.length,j=()=>{if(O>=W)return Promise.resolve(V);const X=N[O++];return Promise.resolve(X()).then(de=>U(de)?Promise.resolve(de):j())};return j()}e.first=b;function n(N,U=O=>!!O,V=null){if(N.length===0)return Promise.resolve(V);let O=N.length;const W=()=>{O=-1;for(const j of N)j.cancel?.()};return new Promise((j,X)=>{for(const Q of N)Q.then(de=>{--O>=0&&U(de)?(W(),j(de)):O===0&&j(V)}).catch(de=>{--O>=0&&(W(),X(de))})})}e.firstParallel=n;class t{constructor(U){this._size=0,this.maxDegreeOfParalellism=U,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new y.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(U){return this._size++,new Promise((V,O)=>{this.outstandingPromises.push({factory:U,c:V,e:O}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const U=this.outstandingPromises.shift();this.runningPromises++;const V=U.factory();V.then(U.c,U.e),V.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=t;class l extends t{constructor(){super(1)}}e.Queue=l;class d{constructor(){this.queues=new Map}queueFor(U,V=i.extUri){const O=V.getComparisonKey(U);let W=this.queues.get(O);return W||(W=new l,y.Event.once(W.onFinished)(()=>{W?.dispose(),this.queues.delete(O)}),this.queues.set(O,W)),W}dispose(){this.queues.forEach(U=>U.dispose()),this.queues.clear()}}e.ResourceQueue=d;class o{constructor(U,V){this._token=-1,typeof U=="function"&&typeof V=="number"&&this.setIfNotSet(U,V)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(U,V){this.cancel(),this._token=setTimeout(()=>{this._token=-1,U()},V)}setIfNotSet(U,V){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,U()},V))}}e.TimeoutTimer=o;class h{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(U,V){this.cancel(),this._token=setInterval(()=>{U()},V)}}e.IntervalTimer=h;class u{constructor(U,V){this.timeoutToken=-1,this.runner=U,this.timeout=V,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(U=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,U)}get delay(){return this.timeout}set delay(U){this.timeout=U}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=u;class E{constructor(U,V){V%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${V}ms is not a multiple of 1000ms.`),this.runner=U,this.timeout=V,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(U=this.timeout){U%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${U}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(U/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=E;class A extends u{constructor(U,V){super(U,V);this.units=[]}work(U){this.units.push(U),this.isScheduled()||this.schedule()}doRun(){const U=this.units;this.units=[],this.runner&&this.runner(U)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=A;class R extends C.Disposable{constructor(U,V,O,W){super();this.maxWorkChunkSize=U,this.maxPendingWork=V,this.throttleDelay=O,this.handler=W,this.pendingWork=[],this.throttler=this._register(new C.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(U){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+U.length>this.maxPendingWork)return!1}else if(this.pending+U.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...U),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new u(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=R,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=N=>{const U=setTimeout(()=>{const O=Date.now()+15;N(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,O-Date.now())}}))});let V=!1;return{dispose(){V||(V=!0,clearTimeout(U))}}}:e.runWhenIdle=(N,U)=>{const V=requestIdleCallback(N,typeof U=="number"?{timeout:U}:void 0);let O=!1;return{dispose(){O||(O=!0,cancelIdleCallback(V))}}}}();class B{constructor(U){this._didRun=!1,this._executor=()=>{try{this._value=U()}catch(V){this._error=V}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=B;async function x(N,U,V){let O;for(let W=0;W<V;W++)try{return await N()}catch(j){O=j,await r(U)}throw O}e.retry=x;class F{hasPending(U){return this._pending?typeof U=="number"?this._pending.taskId===U:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(U,V,O){return this._pending={taskId:U,cancel:()=>O?.(),promise:V},V.then(()=>this.donePending(U),()=>this.donePending(U)),V}donePending(U){this._pending&&U===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const U=this._next;this._next=void 0,U.run().then(U.promiseResolve,U.promiseReject)}}setNext(U){if(this._next)this._next.run=U;else{let V,O;const W=new Promise((j,X)=>{V=j,O=X});this._next={run:U,promise:W,promiseResolve:V,promiseReject:O}}return this._next.promise}}e.TaskSequentializer=F;class ${constructor(U){this.interval=U,this.lastIncrementTime=0,this.value=0}increment(){const U=Date.now();return U-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=U,this.value=0),this.value++,this.value}}e.IntervalCounter=$;class M{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((U,V)=>{this.completeCallback=U,this.errorCallback=V})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(U){return new Promise(V=>{this.completeCallback(U),this.resolved=!0,V()})}error(U){return new Promise(V=>{this.errorCallback(U),this.rejected=!0,V()})}cancel(){new Promise(U=>{this.errorCallback((0,L.canceled)()),this.rejected=!0,U()})}}e.DeferredPromise=M;var H;(function(N){async function U(O){let W;const j=await Promise.all(O.map(X=>X.then(Q=>Q,Q=>{W||(W=Q)})));if(typeof W!="undefined")throw W;return j}N.settled=U;function V(O){return new Promise(async(W,j)=>{try{await O(W,j)}catch(X){j(X)}})}N.withAsyncBody=V})(H=e.Promises||(e.Promises={}))}),define(fe[100],me([0,1,16,9]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const y=new g.IdleValue(()=>{const u=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:u,collatorIsNumeric:u.resolvedOptions().numeric}}),C=new g.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),i=new g.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function k(u,E,A=!1){const R=u||"",B=E||"",x=y.value.collator.compare(R,B);return y.value.collatorIsNumeric&&x===0&&R!==B?R<B?-1:1:x}e.compareFileNames=k;function _(u,E){const A=C.value.collator;return u=u||"",E=E||"",m(A,u,E)}e.compareFileNamesDefault=_;function D(u,E){const A=C.value.collator;return u=u||"",E=E||"",t(u,E)||m(A,u,E)}e.compareFileNamesUpper=D;function T(u,E){const A=C.value.collator;return u=u||"",E=E||"",n(u,E)||m(A,u,E)}e.compareFileNamesLower=T;function I(u,E){return u=u||"",E=E||"",u===E?0:u<E?-1:1}e.compareFileNamesUnicode=I;function c(u,E,A=!1){A||(u=u&&u.toLowerCase(),E=E&&E.toLowerCase());const[R,B]=s(u),[x,F]=s(E);return R!==x?R<x?-1:1:B===F?0:B<F?-1:1}e.noIntlCompareFileNames=c;function p(u,E){const[A,R]=s(u),[B,x]=s(E);let F=y.value.collator.compare(R,x);if(F===0){if(y.value.collatorIsNumeric&&R!==x)return R<x?-1:1;if(F=y.value.collator.compare(A,B),y.value.collatorIsNumeric&&F===0&&A!==B)return A<B?-1:1}return F}e.compareFileExtensions=p;function f(u,E){u=u||"",E=E||"";const A=r(u),R=r(E),B=C.value.collator,x=i.value.collator;return m(x,A,R)||m(B,u,E)}e.compareFileExtensionsDefault=f;function v(u,E){u=u||"",E=E||"";const A=r(u),R=r(E),B=C.value.collator,x=i.value.collator;return m(x,A,R)||t(u,E)||m(B,u,E)}e.compareFileExtensionsUpper=v;function S(u,E){u=u||"",E=E||"";const A=r(u),R=r(E),B=C.value.collator,x=i.value.collator;return m(x,A,R)||n(u,E)||m(B,u,E)}e.compareFileExtensionsLower=S;function P(u,E){u=u||"",E=E||"";const A=r(u).toLowerCase(),R=r(E).toLowerCase();return A!==R?A<R?-1:1:u!==E?u<E?-1:1:0}e.compareFileExtensionsUnicode=P;const w=/^(.*?)(\.([^.]*))?$/;function s(u,E=!1){const A=u?w.exec(u):[];let R=[A&&A[1]||"",A&&A[3]||""];return E&&(!R[0]&&R[1]||R[0]&&R[0].charAt(0)===".")&&(R=[R[0]+"."+R[1],""]),R}function r(u){const E=u?w.exec(u):[];return E&&E[1]&&E[1].charAt(0)!=="."&&E[3]||""}function m(u,E,A){let R=u.compare(E,A);return R!==0?R:E.length!==A.length?E.length<A.length?-1:1:0}function a(u){const E=u.charAt(0);return E.toLocaleUpperCase()!==E}function b(u){const E=u.charAt(0);return E.toLocaleLowerCase()!==E}function n(u,E){return a(u)&&b(E)?-1:b(u)&&a(E)?1:0}function t(u,E){return b(u)&&a(E)?-1:a(u)&&b(E)?1:0}function l(u,E,A=!1){return A||(u=u&&u.toLowerCase(),E=E&&E.toLowerCase()),u===E?0:u<E?-1:1}function d(u,E,A=!1){const R=u.split(L.sep),B=E.split(L.sep),x=R.length-1,F=B.length-1;let $,M;for(let H=0;;H++){if($=x===H,M=F===H,$&&M)return k(R[H],B[H],A);if($)return-1;if(M)return 1;const N=l(R[H],B[H],A);if(N!==0)return N}}e.comparePaths=d;function o(u,E,A){const R=u.toLowerCase(),B=E.toLowerCase(),x=h(u,E,A);if(x)return x;const F=R.endsWith(A),$=B.endsWith(A);if(F!==$)return F?-1:1;const M=k(R,B);return M!==0?M:R.localeCompare(B)}e.compareAnything=o;function h(u,E,A){const R=u.toLowerCase(),B=E.toLowerCase(),x=R.startsWith(A),F=B.startsWith(A);if(x!==F)return x?-1:1;if(x&&F){if(R.length<B.length)return-1;if(R.length>B.length)return 1}return 0}e.compareByPrefix=h}),define(fe[101],me([0,1,100,97,49,9,12,8]),function(Y,e,g,L,y,C,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const _=0,D=[_,[]];function T(N,U,V,O){if(!N||!U)return D;const W=N.length,j=U.length;if(W<j)return D;const X=N.toLowerCase();return I(U,V,j,N,X,W,O)}e.scoreFuzzy=T;function I(N,U,V,O,W,j,X){const Q=[],de=[];for(let Be=0;Be<V;Be++){const We=Be*j,He=We-j,G=Be>0,ee=N[Be],ie=U[Be];for(let le=0;le<j;le++){const Z=le>0,re=We+le,pe=re-1,Me=He+le-1,je=Z?Q[pe]:0,Ke=G&&Z?Q[Me]:0,Ze=G&&Z?de[Me]:0;let rt;!Ke&&G?rt=0:rt=c(ee,ie,O,W,le,Ze),rt&&Ke+rt>=je&&(X||G||W.startsWith(U,le))?(de[re]=Ze+1,Q[re]=Ke+rt):(de[re]=_,Q[re]=je)}}const Se=[];let De=V-1,Pe=j-1;for(;De>=0&&Pe>=0;){const Be=De*j+Pe;de[Be]===_||(Se.push(Pe),De--),Pe--}return[Q[V*j-1],Se.reverse()]}function c(N,U,V,O,W,j){let X=0;if(!p(U,O[W]))return X;if(X+=1,j>0&&(X+=j*5),N===V[W]&&(X+=1),W===0)X+=8;else{const Q=f(V.charCodeAt(W-1));Q?X+=Q:(0,L.isUpper)(V.charCodeAt(W))&&j===0&&(X+=2)}return X}function p(N,U){return N===U?!0:N==="/"||N==="\\"?U==="/"||U==="\\":!1}function f(N){switch(N){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const v=[void 0,[]];function S(N,U,V=0,O=0){const W=U;return W.values&&W.values.length>1?P(N,W.values,V,O):w(N,U,V,O)}e.scoreFuzzy2=S;function P(N,U,V,O){let W=0;const j=[];for(const X of U){const[Q,de]=w(N,X,V,O);if(typeof Q!="number")return v;W+=Q,j.push(...de)}return[W,h(j)]}function w(N,U,V,O){const W=(0,L.fuzzyScore)(U.original,U.originalLowercase,V,N,N.toLowerCase(),O,!0);return W?[W[0],(0,L.createMatches)(W)]:v}const s=Object.freeze({score:0}),r=1<<18,m=1<<17,a=1<<16;function b(N,U,V,O){const W=O.values?O.values:[O];return(0,y.hash)({[O.normalized]:{values:W.map(X=>({value:X.normalized,expectContiguousMatch:X.expectContiguousMatch})),label:N,description:U,allowNonContiguousMatches:V}})}function n(N,U,V,O,W){if(!N||!U.normalized)return s;const j=O.getItemLabel(N);if(!j)return s;const X=O.getItemDescription(N),Q=b(j,X,V,U),de=W[Q];if(de)return de;const Se=t(j,X,O.getItemPath(N),U,V);return W[Q]=Se,Se}e.scoreItemFuzzy=n;function t(N,U,V,O,W){const j=!V||!O.containsPathSeparator;return V&&(i.isLinux?O.pathNormalized===V:(0,k.equalsIgnoreCase)(O.pathNormalized,V))?{score:r,labelMatch:[{start:0,end:N.length}],descriptionMatch:U?[{start:0,end:U.length}]:void 0}:O.values&&O.values.length>1?l(N,U,V,O.values,j,W):d(N,U,V,O,j,W)}function l(N,U,V,O,W,j){let X=0;const Q=[],de=[];for(const Se of O){const{score:De,labelMatch:Pe,descriptionMatch:Be}=d(N,U,V,Se,W,j);if(De===_)return s;X+=De,Pe&&Q.push(...Pe),Be&&de.push(...Be)}return{score:X,labelMatch:h(Q),descriptionMatch:h(de)}}function d(N,U,V,O,W,j){if(W||!U){const[X,Q]=T(N,O.normalized,O.normalizedLowercase,j&&!O.expectContiguousMatch);if(X){const de=(0,L.matchesPrefix)(O.normalized,N);let Se;return de?(Se=m,Se+=Math.round(O.normalized.length/N.length*100)):Se=a,{score:Se+X,labelMatch:de||o(Q)}}}if(U){let X=U;V&&(X=`${U}${C.sep}`);const Q=X.length,de=`${X}${N}`,[Se,De]=T(de,O.normalized,O.normalizedLowercase,j&&!O.expectContiguousMatch);if(Se){const Pe=o(De),Be=[],We=[];return Pe.forEach(He=>{He.start<Q&&He.end>Q?(Be.push({start:0,end:He.end-Q}),We.push({start:He.start,end:Q})):He.start>=Q?Be.push({start:He.start-Q,end:He.end-Q}):We.push(He)}),{score:Se,labelMatch:Be,descriptionMatch:We}}}return s}function o(N){const U=[];if(!N)return U;let V;for(const O of N)V&&V.end===O?V.end+=1:(V={start:O,end:O+1},U.push(V));return U}function h(N){const U=N.sort((W,j)=>W.start-j.start),V=[];let O;for(const W of U)!O||!u(O,W)?(O=W,V.push(W)):(O.start=Math.min(O.start,W.start),O.end=Math.max(O.end,W.end));return V}function u(N,U){return!(N.end<U.start||U.end<N.start)}function E(N,U,V,O,W,j){const X=n(N,V,O,W,j),Q=n(U,V,O,W,j),de=X.score,Se=Q.score;if((de===r||Se===r)&&de!==Se)return de===r?-1:1;if(de>a||Se>a){if(de!==Se)return de>Se?-1:1;if(de<m&&Se<m){const ee=R(X.labelMatch,Q.labelMatch);if(ee!==0)return ee}const He=W.getItemLabel(N)||"",G=W.getItemLabel(U)||"";if(He.length!==G.length)return He.length-G.length}if(de!==Se)return de>Se?-1:1;const De=Array.isArray(X.labelMatch)&&X.labelMatch.length>0,Pe=Array.isArray(Q.labelMatch)&&Q.labelMatch.length>0;if(De&&!Pe)return-1;if(Pe&&!De)return 1;const Be=A(N,X,W),We=A(U,Q,W);return Be&&We&&Be!==We?We>Be?-1:1:B(N,U,V,W)}e.compareItemsByFuzzyScore=E;function A(N,U,V){let O=-1,W=-1;if(U.descriptionMatch&&U.descriptionMatch.length?O=U.descriptionMatch[0].start:U.labelMatch&&U.labelMatch.length&&(O=U.labelMatch[0].start),U.labelMatch&&U.labelMatch.length){if(W=U.labelMatch[U.labelMatch.length-1].end,U.descriptionMatch&&U.descriptionMatch.length){const j=V.getItemDescription(N);j&&(W+=j.length)}}else U.descriptionMatch&&U.descriptionMatch.length&&(W=U.descriptionMatch[U.descriptionMatch.length-1].end);return W-O}function R(N,U){if(!N&&!U||(!N||!N.length)&&(!U||!U.length))return 0;if(!U||!U.length)return-1;if(!N||!N.length)return 1;const V=N[0].start,W=N[N.length-1].end-V,j=U[0].start,Q=U[U.length-1].end-j;return W===Q?0:Q<W?1:-1}function B(N,U,V,O){const W=O.getItemLabel(N)||"",j=O.getItemLabel(U)||"",X=O.getItemDescription(N),Q=O.getItemDescription(U),de=W.length+(X?X.length:0),Se=j.length+(Q?Q.length:0);if(de!==Se)return de-Se;const De=O.getItemPath(N),Pe=O.getItemPath(U);return De&&Pe&&De.length!==Pe.length?De.length-Pe.length:W!==j?(0,g.compareAnything)(W,j,V.normalized):X&&Q&&X!==Q?(0,g.compareAnything)(X,Q,V.normalized):De&&Pe&&De!==Pe?(0,g.compareAnything)(De,Pe,V.normalized):0}function x(N){return N.startsWith('"')&&N.endsWith('"')}const F=" ";function $(N){typeof N!="string"&&(N="");const U=N.toLowerCase(),{pathNormalized:V,normalized:O,normalizedLowercase:W}=M(N),j=V.indexOf(C.sep)>=0,X=x(N);let Q;const de=N.split(F);if(de.length>1)for(const Se of de){const De=x(Se),{pathNormalized:Pe,normalized:Be,normalizedLowercase:We}=M(Se);Be&&(Q||(Q=[]),Q.push({original:Se,originalLowercase:Se.toLowerCase(),pathNormalized:Pe,normalized:Be,normalizedLowercase:We,expectContiguousMatch:De}))}return{original:N,originalLowercase:U,pathNormalized:V,normalized:O,normalizedLowercase:W,values:Q,containsPathSeparator:j,expectContiguousMatch:X}}e.prepareQuery=$;function M(N){let U;i.isWindows?U=N.replace(/\//g,C.sep):U=N.replace(/\\/g,C.sep);const V=(0,k.stripWildcards)(U).replace(/\s|"/g,"");return{pathNormalized:U,normalized:V,normalizedLowercase:V.toLowerCase()}}function H(N){return Array.isArray(N)?$(N.map(U=>U.original).join(F)):$(N.original)}e.pieceToQuery=H}),define(fe[31],me([0,1,16,30,24,9,8]),function(Y,e,g,L,y,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function k(){return Object.create(null)}e.getEmptyExpression=k;const _="**",D="/",T="[/\\\\]",I="[^/\\\\]",c=/\//g;function p(O){switch(O){case 0:return"";case 1:return`${I}*?`;default:return`(?:${T}|${I}+${T}|${T}${I}+)*?`}}function f(O,W){if(!O)return[];const j=[];let X=!1,Q=!1,de="";for(const Se of O){switch(Se){case W:if(!X&&!Q){j.push(de),de="";continue}break;case"{":X=!0;break;case"}":X=!1;break;case"[":Q=!0;break;case"]":Q=!1;break}de+=Se}return de&&j.push(de),j}e.splitGlobAware=f;function v(O){if(!O)return"";let W="";const j=f(O,D);if(j.every(X=>X===_))W=".*";else{let X=!1;j.forEach((Q,de)=>{if(Q===_){X||(W+=p(2),X=!0);return}let Se=!1,De="",Pe=!1,Be="";for(const We of Q){if(We!=="}"&&Se){De+=We;continue}if(Pe&&(We!=="]"||!Be)){let He;We==="-"?He=We:(We==="^"||We==="!")&&!Be?He="^":We===D?He="":He=i.escapeRegExpCharacters(We),Be+=He;continue}switch(We){case"{":Se=!0;continue;case"[":Pe=!0;continue;case"}":W+=`(?:${f(De,",").map(ee=>v(ee)).join("|")})`,Se=!1,De="";break;case"]":W+="["+Be+"]",Pe=!1,Be="";break;case"?":W+=I;continue;case"*":W+=p(1);continue;default:W+=i.escapeRegExpCharacters(We)}}de<j.length-1&&(j[de+1]!==_||de+2<j.length)&&(W+=T),X=!1})}return W}const S=/^\*\*\/\*\.[\w\.-]+$/,P=/^\*\*\/([\w\.-]+)\/?$/,w=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,s=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,r=/^\*\*((\/[\w\.-]+)+)\/?$/,m=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,a=new y.LRUCache(1e4),b=function(){return!1},n=function(){return null};function t(O,W){if(!O)return n;let j;typeof O!="string"?j=O.pattern:j=O,j=j.trim();const X=`${j}_${!!W.trimForExclusions}`;let Q=a.get(X);if(Q)return l(Q,O);let de;if(S.test(j)){const Se=j.substr(4);Q=function(De,Pe){return typeof De=="string"&&De.endsWith(Se)?j:null}}else(de=P.exec(d(j,W)))?Q=o(de[1],j):(W.trimForExclusions?s:w).test(j)?Q=h(j,W):(de=r.exec(d(j,W)))?Q=u(de[1].substr(1),j,!0):(de=m.exec(d(j,W)))?Q=u(de[1],j,!1):Q=E(j);return a.set(X,Q),l(Q,O)}function l(O,W){return typeof W=="string"?O:function(j,X){return L.isEqualOrParent(j,W.base)?O(C.relative(W.base,j),X):null}}function d(O,W){return W.trimForExclusions&&O.endsWith("/**")?O.substr(0,O.length-2):O}function o(O,W){const j=`/${O}`,X=`\\${O}`,Q=function(Se,De){return typeof Se!="string"?null:De?De===O?W:null:Se===O||Se.endsWith(j)||Se.endsWith(X)?W:null},de=[O];return Q.basenames=de,Q.patterns=[W],Q.allBasenames=de,Q}function h(O,W){const j=V(O.slice(1,-1).split(",").map(De=>t(De,W)).filter(De=>De!==n),O),X=j.length;if(!X)return n;if(X===1)return j[0];const Q=function(De,Pe){for(let Be=0,We=j.length;Be<We;Be++)if(j[Be](De,Pe))return O;return null},de=j.find(De=>!!De.allBasenames);de&&(Q.allBasenames=de.allBasenames);const Se=j.reduce((De,Pe)=>Pe.allPaths?De.concat(Pe.allPaths):De,[]);return Se.length&&(Q.allPaths=Se),Q}function u(O,W,j){const X=C.sep===C.posix.sep,Q=X?O:O.replace(c,C.sep),de=C.sep+Q,Se=C.posix.sep+O,De=j?function(Pe,Be){return typeof Pe=="string"&&(Pe===Q||Pe.endsWith(de)||!X&&(Pe===O||Pe.endsWith(Se)))?W:null}:function(Pe,Be){return typeof Pe=="string"&&(Pe===Q||!X&&Pe===O)?W:null};return De.allPaths=[(j?"*/":"./")+O],De}function E(O){try{const W=new RegExp(`^${v(O)}$`);return function(j){return W.lastIndex=0,typeof j=="string"&&W.test(j)?O:null}}catch(W){return n}}function A(O,W,j){return!O||typeof W!="string"?!1:R(O)(W,void 0,j)}e.match=A;function R(O,W={}){if(!O)return b;if(typeof O=="string"||$(O)){const j=t(O,W);if(j===n)return b;const X=function(Q,de){return!!j(Q,de)};return j.allBasenames&&(X.allBasenames=j.allBasenames),j.allPaths&&(X.allPaths=j.allPaths),X}return N(O,W)}e.parse=R;function B(O){if(!O)return;let W;return j=>(W||(W=(O()||Promise.resolve([])).then(X=>X?F(X):{})),W.then(X=>!!X[j]))}e.hasSiblingPromiseFn=B;function x(O){if(!O)return;let W;return j=>{if(!W){const X=O();W=X?F(X):{}}return!!W[j]}}e.hasSiblingFn=x;function F(O){const W={};for(const j of O)W[j]=!0;return W}function $(O){const W=O;return W&&typeof W.base=="string"&&typeof W.pattern=="string"}e.isRelativePattern=$;function M(O){return O.allBasenames||[]}e.getBasenameTerms=M;function H(O){return O.allPaths||[]}e.getPathTerms=H;function N(O,W){const j=V(Object.getOwnPropertyNames(O).map(De=>U(De,O[De],W)).filter(De=>De!==n)),X=j.length;if(!X)return n;if(!j.some(De=>!!De.requiresSiblings)){if(X===1)return j[0];const De=function(We,He){for(let G=0,ee=j.length;G<ee;G++){const ie=j[G](We,He);if(ie)return ie}return null},Pe=j.find(We=>!!We.allBasenames);Pe&&(De.allBasenames=Pe.allBasenames);const Be=j.reduce((We,He)=>He.allPaths?We.concat(He.allPaths):We,[]);return Be.length&&(De.allPaths=Be),De}const Q=function(De,Pe,Be){let We;for(let He=0,G=j.length;He<G;He++){const ee=j[He];ee.requiresSiblings&&Be&&(Pe||(Pe=C.basename(De)),We||(We=Pe.substr(0,Pe.length-C.extname(De).length)));const ie=ee(De,Pe,We,Be);if(ie)return ie}return null},de=j.find(De=>!!De.allBasenames);de&&(Q.allBasenames=de.allBasenames);const Se=j.reduce((De,Pe)=>Pe.allPaths?De.concat(Pe.allPaths):De,[]);return Se.length&&(Q.allPaths=Se),Q}function U(O,W,j){if(W===!1)return n;const X=t(O,j);if(X===n)return n;if(typeof W=="boolean")return X;if(W){const Q=W.when;if(typeof Q=="string"){const de=(Se,De,Pe,Be)=>{if(!Be||!X(Se,De))return null;const We=Q.replace("$(basename)",Pe),He=Be(We);return(0,g.isThenable)(He)?He.then(G=>G?O:null):He?O:null};return de.requiresSiblings=!0,de}}return X}function V(O,W){const j=O.filter(De=>!!De.basenames);if(j.length<2)return O;const X=j.reduce((De,Pe)=>{const Be=Pe.basenames;return Be?De.concat(Be):De},[]);let Q;if(W){Q=[];for(let De=0,Pe=X.length;De<Pe;De++)Q.push(W)}else Q=j.reduce((De,Pe)=>{const Be=Pe.patterns;return Be?De.concat(Be):De},[]);const de=function(De,Pe){if(typeof De!="string")return null;if(!Pe){let We;for(We=De.length;We>0;We--){const He=De.charCodeAt(We-1);if(He===47||He===92)break}Pe=De.substr(We)}const Be=X.indexOf(Pe);return Be!==-1?Q[Be]:null};de.basenames=X,de.patterns=Q,de.allBasenames=X;const Se=O.filter(De=>!De.basenames);return Se.push(de),Se}}),define(fe[81],me([0,1,30,10,9,12,23,8,2]),function(Y,e,g,L,y,C,i,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function D(t,l,d){if(typeof t=="string"&&(t=_.URI.file(t)),d){const h=d.getWorkspaceFolder(t);if(h){const u=d.getWorkspace().folders.length>1;let E;if((0,i.isEqual)(h.uri,t)?E="":E=(0,i.relativePath)(h.uri,t),u){const A=h.name?h.name:(0,i.basename)(h.uri);E=E?A+" \u2022 "+E:A}return E}}if(t.scheme!==L.Schemas.file&&t.scheme!==L.Schemas.untitled)return t.with({query:null,fragment:null}).toString(!0);if((0,g.hasDriveLetter)(t.fsPath))return(0,y.normalize)(I(t.fsPath));let o=(0,y.normalize)(t.fsPath);return!C.isWindows&&l?.userHome&&(o=p(o,l.userHome.fsPath)),o}e.getPathLabel=D;function T(t){if(!t)return;typeof t=="string"&&(t=_.URI.file(t));const l=(0,i.basename)(t)||(t.scheme===L.Schemas.file?t.fsPath:t.path);return C.isWindows&&(0,g.isRootOrDriveLetter)(l)?I(l):l}e.getBaseLabel=T;function I(t,l){return(0,g.hasDriveLetter)(t,l)?t.charAt(0).toUpperCase()+t.slice(1):t}e.normalizeDriveLetter=I;let c=Object.create(null);function p(t,l){if(C.isWindows||!t||!l)return t;let d=c.original===l?c.normalized:void 0;return d||(d=`${(0,k.rtrim)(l,y.posix.sep)}${y.posix.sep}`,c={original:l,normalized:d}),(C.isLinux?t.startsWith(d):(0,k.startsWithIgnoreCase)(t,d))&&(t=`~/${t.substr(d.length)}`),t}e.tildify=p;function f(t,l){return t.replace(/^~($|\/|\\)/,`${l}$1`)}e.untildify=f;const v="\u2026",S="\\\\",P="~";function w(t,l=y.sep){const d=new Array(t.length);let o=!1;for(let h=0;h<t.length;h++){let u=t[h];if(u===""){d[h]=`.${l}`;continue}if(!u){d[h]=u;continue}o=!0;let E="";u.indexOf(S)===0?(E=u.substr(0,u.indexOf(S)+S.length),u=u.substr(u.indexOf(S)+S.length)):u.indexOf(l)===0?(E=u.substr(0,u.indexOf(l)+l.length),u=u.substr(u.indexOf(l)+l.length)):u.indexOf(P)===0&&(E=u.substr(0,u.indexOf(P)+P.length),u=u.substr(u.indexOf(P)+P.length));const A=u.split(l);for(let R=1;o&&R<=A.length;R++)for(let B=A.length-R;o&&B>=0;B--){o=!1;let x=A.slice(B,B+R).join(l);for(let F=0;!o&&F<t.length;F++)if(F!==h&&t[F]&&t[F].indexOf(x)>-1){const $=B+R===A.length,M=B>0&&t[F].indexOf(l)>-1?l+x:x,H=t[F].endsWith(M);o=!$||H}if(!o){let F="";(A[0].endsWith(":")||E!=="")&&(B===1&&(B=0,R++,x=A[0]+l+x),B>0&&(F=A[0]+l),F=E+F),B>0&&(F=F+v+l),F=F+x,B+R<A.length&&(F=F+l+v),d[h]=F}}o&&(d[h]=u)}return d}e.shorten=w;var s;(function(t){t[t.TEXT=0]="TEXT",t[t.VARIABLE=1]="VARIABLE",t[t.SEPARATOR=2]="SEPARATOR"})(s||(s={}));function r(t,l=Object.create(null)){const d=[];let o=!1,h="";for(const u of t)if(u==="$"||o&&u==="{")h&&d.push({value:h,type:s.TEXT}),h="",o=!0;else if(u==="}"&&o){const E=l[h];if(typeof E=="string")E.length&&d.push({value:E,type:s.VARIABLE});else if(E){const A=d[d.length-1];(!A||A.type!==s.SEPARATOR)&&d.push({value:E.label,type:s.SEPARATOR})}h="",o=!1}else h+=u;return h&&!o&&d.push({value:h,type:s.TEXT}),d.filter((u,E)=>{if(u.type===s.SEPARATOR){const A=d[E-1],R=d[E+1];return[A,R].every(B=>B&&(B.type===s.VARIABLE||B.type===s.TEXT)&&B.value.length>0)}return!0}).map(u=>u.value).join("")}e.template=r;function m(t,l){return C.isMacintosh||l?t.replace(/\(&&\w\)|&&/g,"").replace(/&/g,C.isMacintosh?"&":"&&"):t.replace(/&&|&/g,d=>d==="&"?"&&":"&")}e.mnemonicMenuLabel=m;function a(t,l){return C.isMacintosh||l?t.replace(/\(&&\w\)|&&/g,""):C.isWindows?t.replace(/&&|&/g,d=>d==="&"?"&&":"&"):t.replace(/&&/g,"_")}e.mnemonicButtonLabel=a;function b(t){return t.replace(/&/g,"&&")}e.unmnemonicLabel=b;function n(t){const l=t.indexOf("/")!==-1?y.posix:y.win32,d=l.basename(t),o=l.dirname(t);return d.length?{name:d,parentPath:o}:{name:o,parentPath:""}}e.splitName=n}),define(fe[102],me([0,1,31,10,9,23,8]),function(Y,e,g,L,y,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var k;(function(t){t.text="text/plain",t.binary="application/octet-stream",t.unknown="application/unknown",t.markdown="text/markdown",t.latex="text/latex"})(k=e.Mimes||(e.Mimes={}));let _=[],D=[],T=[];function I(t,l=!1){const d=c(t);_.push(d),d.userConfigured?T.push(d):D.push(d),l&&!d.userConfigured&&_.forEach(o=>{o.mime===d.mime||o.userConfigured||(d.extension&&o.extension===d.extension&&console.warn(`Overwriting extension <<${d.extension}>> to now point to mime <<${d.mime}>>`),d.filename&&o.filename===d.filename&&console.warn(`Overwriting filename <<${d.filename}>> to now point to mime <<${d.mime}>>`),d.filepattern&&o.filepattern===d.filepattern&&console.warn(`Overwriting filepattern <<${d.filepattern}>> to now point to mime <<${d.mime}>>`),d.firstline&&o.firstline===d.firstline&&console.warn(`Overwriting firstline <<${d.firstline}>> to now point to mime <<${d.mime}>>`))})}e.registerTextMime=I;function c(t){return{id:t.id,mime:t.mime,filename:t.filename,extension:t.extension,filepattern:t.filepattern,firstline:t.firstline,userConfigured:t.userConfigured,filenameLowercase:t.filename?t.filename.toLowerCase():void 0,extensionLowercase:t.extension?t.extension.toLowerCase():void 0,filepatternLowercase:t.filepattern?(0,g.parse)(t.filepattern.toLowerCase()):void 0,filepatternOnPath:t.filepattern?t.filepattern.indexOf(y.posix.sep)>=0:!1}}function p(t){t?(_=_.filter(l=>!l.userConfigured),T=[]):(_=[],D=[],T=[])}e.clearTextMimes=p;function f(t,l){let d;if(t)switch(t.scheme){case L.Schemas.file:d=t.fsPath;break;case L.Schemas.data:d=C.DataUri.parseMetaData(t).get(C.DataUri.META_DATA_LABEL);break;default:d=t.path}if(!d)return[k.unknown];d=d.toLowerCase();const o=(0,y.basename)(d),h=v(d,o,T);if(h)return[h,k.text];const u=v(d,o,D);if(u)return[u,k.text];if(l){const E=S(l);if(E)return[E,k.text]}return[k.unknown]}e.guessMimeTypes=f;function v(t,l,d){let o=null,h=null,u=null;for(let E=d.length-1;E>=0;E--){const A=d[E];if(l===A.filenameLowercase){o=A;break}if(A.filepattern&&(!h||A.filepattern.length>h.filepattern.length)){const R=A.filepatternOnPath?t:l;A.filepatternLowercase?.(R)&&(h=A)}A.extension&&(!u||A.extension.length>u.extension.length)&&l.endsWith(A.extensionLowercase)&&(u=A)}return o?o.mime:h?h.mime:u?u.mime:null}function S(t){if((0,i.startsWithUTF8BOM)(t)&&(t=t.substr(1)),t.length>0)for(let l=_.length-1;l>=0;l--){const d=_[l];if(!d.firstline)continue;const o=t.match(d.firstline);if(o&&o.length>0)return d.mime}return null}function P(t){return t?typeof t=="string"?t===k.binary||t===k.text||t===k.unknown:t.length===1&&P(t[0]):!0}e.isUnspecific=P;const w={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},s={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function r(t){const l=(0,y.extname)(t),d=w[l.toLowerCase()];return d!==void 0?d:m(t)}e.getMediaOrTextMime=r;function m(t){const l=(0,y.extname)(t);return s[l.toLowerCase()]}e.getMediaMime=m;function a(t){for(const l in s)if(s[l]===t)return l}e.getExtensionForMimeType=a;const b=/^(.+)\/(.+?)(;.+)?$/;function n(t,l){const d=b.exec(t);return d?`${d[1].toLowerCase()}/${d[2].toLowerCase()}${d[3]??""}`:l?void 0:t}e.normalizeMimeType=n}),define(fe[103],me([0,1,2]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function L(T){return T.toJSON()}class y{constructor(I){this._uriTransformer=I}transformIncoming(I){const c=this._uriTransformer.transformIncoming(I);return c===I?I:L(g.URI.from(c))}transformOutgoing(I){const c=this._uriTransformer.transformOutgoing(I);return c===I?I:L(g.URI.from(c))}transformOutgoingURI(I){const c=this._uriTransformer.transformOutgoing(I);return c===I?I:g.URI.from(c)}transformOutgoingScheme(I){return this._uriTransformer.transformOutgoingScheme(I)}}e.URITransformer=y,e.DefaultURITransformer=new class{transformIncoming(T){return T}transformOutgoing(T){return T}transformOutgoingURI(T){return T}transformOutgoingScheme(T){return T}};function C(T,I,c){if(!T||c>200)return null;if(typeof T=="object"){if(T instanceof g.URI)return I.transformOutgoing(T);for(let p in T)if(Object.hasOwnProperty.call(T,p)){const f=C(T[p],I,c+1);f!==null&&(T[p]=f)}}return null}function i(T,I){const c=C(T,I,0);return c===null?T:c}e.transformOutgoingURIs=i;function k(T,I,c,p){if(!T||p>200)return null;if(typeof T=="object"){if(T.$mid===1)return c?g.URI.revive(I.transformIncoming(T)):I.transformIncoming(T);for(let f in T)if(Object.hasOwnProperty.call(T,f)){const v=k(T[f],I,c,p+1);v!==null&&(T[f]=v)}}return null}function _(T,I){const c=k(T,I,!1,0);return c===null?T:c}e.transformIncomingURIs=_;function D(T,I){const c=k(T,I,!0,0);return c===null?T:c}e.transformAndReviveIncomingURIs=D}),define(fe[32],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const g=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(_){return g.test(_)}e.isUUID=L;const y=new Uint8Array(16),C=[];for(let _=0;_<256;_++)C.push(_.toString(16).padStart(2,"0"));let i;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?i=crypto.getRandomValues.bind(crypto):i=function(_){for(let D=0;D<_.length;D++)_[D]=Math.floor(Math.random()*256);return _};function k(){i(y),y[6]=y[6]&15|64,y[8]=y[8]&63|128;let _=0,D="";return D+=C[y[_++]],D+=C[y[_++]],D+=C[y[_++]],D+=C[y[_++]],D+="-",D+=C[y[_++]],D+=C[y[_++]],D+="-",D+=C[y[_++]],D+=C[y[_++]],D+="-",D+=C[y[_++]],D+=C[y[_++]],D+="-",D+=C[y[_++]],D+=C[y[_++]],D+=C[y[_++]],D+=C[y[_++]],D+=C[y[_++]],D+=C[y[_++]],D}e.generateUuid=k}),define(fe[143],me([0,1,104]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(C="utf8"){this.stringDecoder=new g.StringDecoder(C),this.remaining=null}write(C){const i=[],k=this.remaining?this.remaining+this.stringDecoder.write(C):this.stringDecoder.write(C);if(k.length<1)return i;let _=0,D,T=_;for(;T<k.length;)if(D=k.charCodeAt(T),D===13||D===10){if(i.push(k.substring(_,T)),T++,T<k.length){const I=D;D=k.charCodeAt(T),(I===13&&D===10||I===10&&D===13)&&T++}_=T}else T++;return this.remaining=_<k.length?k.substr(_):null,i}end(){return this.remaining}}e.LineDecoder=L}),define(fe[28],me([0,1,63,82,293,16,30,80,9,12,23,2,32]),function(Y,e,g,L,y,C,i,k,_,D,T,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var p;(function(M){M[M.UNLINK=0]="UNLINK",M[M.MOVE=1]="MOVE"})(p=e.RimRafMode||(e.RimRafMode={}));async function f(M,H=p.UNLINK){if((0,i.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");return H===p.UNLINK?S(M):v(M)}async function v(M){try{const H=(0,_.join)((0,L.tmpdir)(),(0,c.generateUuid)());try{await e.Promises.rename(M,H)}catch(N){return S(M)}S(H).catch(N=>{})}catch(H){if(H.code!=="ENOENT")throw H}}async function S(M){return e.Promises.rmdir(M,{recursive:!0,maxRetries:3})}function P(M){if((0,i.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");g.rmdirSync(M,{recursive:!0})}e.rimrafSync=P;async function w(M,H){return m(await(H?s(M):(0,y.promisify)(g.readdir)(M)))}async function s(M){try{return await(0,y.promisify)(g.readdir)(M,{withFileTypes:!0})}catch(U){console.warn("[node.js fs] readdir with filetypes failed with error: ",U)}const H=[],N=await w(M);for(const U of N){let V=!1,O=!1,W=!1;try{const j=await e.Promises.lstat((0,_.join)(M,U));V=j.isFile(),O=j.isDirectory(),W=j.isSymbolicLink()}catch(j){console.warn("[node.js fs] unexpected error from lstat after readdir: ",j)}H.push({name:U,isFile:()=>V,isDirectory:()=>O,isSymbolicLink:()=>W})}return H}function r(M){return m(g.readdirSync(M))}e.readdirSync=r;function m(M){return M.map(H=>typeof H=="string"?D.isMacintosh?(0,k.normalizeNFC)(H):H:(H.name=D.isMacintosh?(0,k.normalizeNFC)(H.name):H.name,H))}async function a(M){const H=await w(M),N=[];for(const U of H)await n.existsDirectory((0,_.join)(M,U))&&N.push(U);return N}function b(M,H=1e3){return new Promise(N=>{let U=!1;const V=setInterval(()=>{U||(U=!0,g.access(M,O=>{U=!1,O&&(clearInterval(V),N(void 0))}))},H)})}e.whenDeleted=b;var n;(function(M){async function H(V){let O;try{if(O=await e.Promises.lstat(V),!O.isSymbolicLink())return{stat:O}}catch(W){}try{return{stat:await e.Promises.stat(V),symbolicLink:O?.isSymbolicLink()?{dangling:!1}:void 0}}catch(W){if(W.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};if(D.isWindows&&W.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(V)),symbolicLink:{dangling:!1}}}catch(j){if(j.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};throw j}throw W}}M.stat=H;async function N(V){try{const{stat:O,symbolicLink:W}=await M.stat(V);return O.isFile()&&W?.dangling!==!0}catch(O){}return!1}M.existsFile=N;async function U(V){try{const{stat:O,symbolicLink:W}=await M.stat(V);return O.isDirectory()&&W?.dangling!==!0}catch(O){}return!1}M.existsDirectory=U})(n=e.SymlinkSupport||(e.SymlinkSupport={}));const t=new C.ResourceQueue;function l(M,H,N){return t.queueFor(I.URI.file(M),T.extUriBiasedIgnorePathCase).queue(()=>{const U=u(N);return new Promise((V,O)=>o(M,H,U,W=>W?O(W):V()))})}let d=!0;function o(M,H,N,U){if(!d)return g.writeFile(M,H,{mode:N.mode,flag:N.flag},U);g.open(M,N.flag,N.mode,(V,O)=>{if(V)return U(V);g.writeFile(O,H,W=>{if(W)return g.close(O,()=>U(W));g.fdatasync(O,j=>(j&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",j),d=!1),g.close(O,X=>U(X))))})})}function h(M,H,N){const U=u(N);if(!d)return g.writeFileSync(M,H,{mode:U.mode,flag:U.flag});const V=g.openSync(M,U.flag,U.mode);try{g.writeFileSync(V,H);try{g.fdatasyncSync(V)}catch(O){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",O),d=!1}}finally{g.closeSync(V)}}e.writeFileSync=h;function u(M){return M?{mode:typeof M.mode=="number"?M.mode:438,flag:typeof M.flag=="string"?M.flag:"w"}:{mode:438,flag:"w"}}async function E(M,H){if(M===H)return;async function N(U){try{const V=await e.Promises.lstat(U);if(V.isDirectory()||V.isSymbolicLink())return;await e.Promises.utimes(U,V.atime,new Date)}catch(V){}}try{await e.Promises.rename(M,H),await N(H)}catch(U){if(M.toLowerCase()!==H.toLowerCase()&&U.code==="EXDEV"||M.endsWith("."))await A(M,H,{preserveSymlinks:!1}),await f(M,p.MOVE),await N(H);else throw U}}async function A(M,H,N){return B(M,H,{root:{source:M,target:H},options:N,handledSourcePaths:new Set})}const R=511;async function B(M,H,N){if(N.handledSourcePaths.has(M))return;N.handledSourcePaths.add(M);const{stat:U,symbolicLink:V}=await n.stat(M);if(V){if(N.options.preserveSymlinks)try{return await $(M,H,N)}catch(O){console.warn("[node.js fs] copy of symlink failed: ",O)}if(V.dangling)return}return U.isDirectory()?x(M,H,U.mode&R,N):F(M,H,U.mode&R)}async function x(M,H,N,U){await e.Promises.mkdir(H,{recursive:!0,mode:N});const V=await w(M);for(const O of V)await B((0,_.join)(M,O),(0,_.join)(H,O),U)}async function F(M,H,N){await e.Promises.copyFile(M,H),await e.Promises.chmod(H,N)}async function $(M,H,N){let U=await e.Promises.readlink(M);(0,i.isEqualOrParent)(U,N.root.source,!D.isLinux)&&(U=(0,_.join)(N.root.target,U.substr(N.root.source.length+1))),await e.Promises.symlink(U,H)}e.Promises=new class{get access(){return(0,y.promisify)(g.access)}get stat(){return(0,y.promisify)(g.stat)}get lstat(){return(0,y.promisify)(g.lstat)}get utimes(){return(0,y.promisify)(g.utimes)}get read(){return(0,y.promisify)(g.read)}get readFile(){return(0,y.promisify)(g.readFile)}get write(){return(0,y.promisify)(g.write)}get appendFile(){return(0,y.promisify)(g.appendFile)}get fdatasync(){return(0,y.promisify)(g.fdatasync)}get truncate(){return(0,y.promisify)(g.truncate)}get rename(){return(0,y.promisify)(g.rename)}get copyFile(){return(0,y.promisify)(g.copyFile)}get open(){return(0,y.promisify)(g.open)}get close(){return(0,y.promisify)(g.close)}get symlink(){return(0,y.promisify)(g.symlink)}get readlink(){return(0,y.promisify)(g.readlink)}get chmod(){return(0,y.promisify)(g.chmod)}get mkdir(){return(0,y.promisify)(g.mkdir)}get unlink(){return(0,y.promisify)(g.unlink)}get rmdir(){return(0,y.promisify)(g.rmdir)}get realpath(){return(0,y.promisify)(g.realpath)}async exists(M){try{return await e.Promises.access(M),!0}catch{return!1}}get readdir(){return w}get readDirsInDir(){return a}get writeFile(){return l}get rm(){return f}get move(){return E}get copy(){return A}}}),define(fe[105],me([0,1,63,9,8,28]),function(Y,e,g,L,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function i(T){const I=(0,L.dirname)(T);if(T===I)return T;const c=((0,L.basename)(T)||T).toLowerCase();try{const f=(0,C.readdirSync)(I).filter(v=>v.toLowerCase()===c);if(f.length===1){const v=i(I);if(v)return(0,L.join)(v,f[0])}else if(f.length>1){const v=f.indexOf(c);if(v>=0){const S=i(I);if(S)return(0,L.join)(S,f[v])}}}catch(p){}return null}e.realcaseSync=i;async function k(T){try{return await C.Promises.realpath(T)}catch(I){const c=D(T);return await C.Promises.access(c,g.constants.R_OK),c}}e.realpath=k;function _(T){try{return g.realpathSync(T)}catch(I){const c=D(T);return g.accessSync(c,g.constants.R_OK),c}}e.realpathSync=_;function D(T){return(0,y.rtrim)((0,L.normalize)(T),L.sep)}});var Ve=this&&this.__decorate||function(Y,e,g,L){var y=arguments.length,C=y<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,g):L,i;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")C=Reflect.decorate(Y,e,g,L);else for(var k=Y.length-1;k>=0;k--)(i=Y[k])&&(C=(y<3?i(C):y>3?i(e,g,C):i(e,g))||C);return y>3&&C&&Object.defineProperty(e,g,C),C};define(fe[106],me([0,1,15,16,22,21,60,18,3,6,62,8,13]),function(Y,e,g,L,y,C,i,k,_,D,T,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var p;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})(p=e.RequestType||(e.RequestType={}));function f(V){switch(V){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var v;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(v=e.ResponseType||(e.ResponseType={}));function S(V){switch(V){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var P;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(P||(P={}));class w{constructor(O){this.buffer=O,this.pos=0}read(O){const W=this.buffer.slice(this.pos,this.pos+O);return this.pos+=W.byteLength,W}}class s{constructor(){this.buffers=[]}get buffer(){return y.VSBuffer.concat(this.buffers)}write(O){this.buffers.push(O)}}var r;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object"})(r||(r={}));function m(V){const O=y.VSBuffer.alloc(4);return O.writeUInt32BE(V,0),O}function a(V){return V.read(4).readUInt32BE(0)}function b(V){const O=y.VSBuffer.alloc(1);return O.writeUInt8(V,0),O}const n={Undefined:b(r.Undefined),String:b(r.String),Buffer:b(r.Buffer),VSBuffer:b(r.VSBuffer),Array:b(r.Array),Object:b(r.Object)},t=typeof Buffer!="undefined";function l(V,O){if(typeof O=="undefined")V.write(n.Undefined);else if(typeof O=="string"){const W=y.VSBuffer.fromString(O);V.write(n.String),V.write(m(W.byteLength)),V.write(W)}else if(t&&Buffer.isBuffer(O)){const W=y.VSBuffer.wrap(O);V.write(n.Buffer),V.write(m(W.byteLength)),V.write(W)}else if(O instanceof y.VSBuffer)V.write(n.VSBuffer),V.write(m(O.byteLength)),V.write(O);else if(Array.isArray(O)){V.write(n.Array),V.write(m(O.length));for(const W of O)l(V,W)}else{const W=y.VSBuffer.fromString(JSON.stringify(O));V.write(n.Object),V.write(m(W.byteLength)),V.write(W)}}function d(V){switch(V.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return V.read(a(V)).toString();case r.Buffer:return V.read(a(V)).buffer;case r.VSBuffer:return V.read(a(V));case r.Array:{const W=a(V),j=[];for(let X=0;X<W;X++)j.push(d(V));return j}case r.Object:return JSON.parse(V.read(a(V)).toString())}}class o{constructor(O,W,j=null,X=1e3){this.protocol=O,this.ctx=W,this.logger=j,this.timeoutDelay=X,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(Q=>this.onRawMessage(Q)),this.sendResponse({type:200})}registerChannel(O,W){this.channels.set(O,W),setTimeout(()=>this.flushPendingRequests(O),0)}sendResponse(O){switch(O.type){case 200:{const W=this.send([O.type]);this.logger&&this.logger.logOutgoing(W,0,1,S(O.type));return}case 201:case 202:case 204:case 203:{const W=this.send([O.type,O.id],O.data);this.logger&&this.logger.logOutgoing(W,O.id,1,S(O.type),O.data);return}}}send(O,W=void 0){const j=new s;return l(j,O),l(j,W),this.sendBuffer(j.buffer)}sendBuffer(O){try{return this.protocol.send(O),O.byteLength}catch(W){return 0}}onRawMessage(O){const W=new w(O),j=d(W),X=d(W),Q=j[0];switch(Q){case 100:return this.logger&&this.logger.logIncoming(O.byteLength,j[1],1,`${f(Q)}: ${j[2]}.${j[3]}`,X),this.onPromise({type:Q,id:j[1],channelName:j[2],name:j[3],arg:X});case 102:return this.logger&&this.logger.logIncoming(O.byteLength,j[1],1,`${f(Q)}: ${j[2]}.${j[3]}`,X),this.onEventListen({type:Q,id:j[1],channelName:j[2],name:j[3],arg:X});case 101:return this.logger&&this.logger.logIncoming(O.byteLength,j[1],1,`${f(Q)}`),this.disposeActiveRequest({type:Q,id:j[1]});case 103:return this.logger&&this.logger.logIncoming(O.byteLength,j[1],1,`${f(Q)}`),this.disposeActiveRequest({type:Q,id:j[1]})}}onPromise(O){const W=this.channels.get(O.channelName);if(!W){this.collectPendingRequest(O);return}const j=new C.CancellationTokenSource;let X;try{X=W.call(this.ctx,O.name,O.arg,j.token)}catch(Se){X=Promise.reject(Se)}const Q=O.id;X.then(Se=>{this.sendResponse({id:Q,data:Se,type:201}),this.activeRequests.delete(O.id)},Se=>{Se instanceof Error?this.sendResponse({id:Q,data:{message:Se.message,name:Se.name,stack:Se.stack?Se.stack.split?Se.stack.split(`
`):Se.stack:void 0},type:202}):this.sendResponse({id:Q,data:Se,type:203}),this.activeRequests.delete(O.id)});const de=(0,D.toDisposable)(()=>j.cancel());this.activeRequests.set(O.id,de)}onEventListen(O){const W=this.channels.get(O.channelName);if(!W){this.collectPendingRequest(O);return}const j=O.id,Q=W.listen(this.ctx,O.name,O.arg)(de=>this.sendResponse({id:j,data:de,type:204}));this.activeRequests.set(O.id,Q)}disposeActiveRequest(O){const W=this.activeRequests.get(O.id);W&&(W.dispose(),this.activeRequests.delete(O.id))}collectPendingRequest(O){let W=this.pendingRequests.get(O.channelName);W||(W=[],this.pendingRequests.set(O.channelName,W));const j=setTimeout(()=>{console.error(`Unknown channel: ${O.channelName}`),O.type===100&&this.sendResponse({id:O.id,data:{name:"Unknown channel",message:`Channel name '${O.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);W.push({request:O,timeoutTimer:j})}flushPendingRequests(O){const W=this.pendingRequests.get(O);if(W){for(const j of W)switch(clearTimeout(j.timeoutTimer),j.request.type){case 100:this.onPromise(j.request);break;case 102:this.onEventListen(j.request);break}this.pendingRequests.delete(O)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(O=>O.dispose()),this.activeRequests.clear()}}e.ChannelServer=o;var h;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(h=e.RequestInitiator||(e.RequestInitiator={}));class u{constructor(O,W=null){this.protocol=O,this.isDisposed=!1,this.state=P.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new _.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(j=>this.onBuffer(j)),this.logger=W}getChannel(O){const W=this;return{call(j,X,Q){return W.isDisposed?Promise.reject(k.canceled()):W.requestPromise(O,j,X,Q)},listen(j,X){return W.isDisposed?Promise.reject(k.canceled()):W.requestEvent(O,j,X)}}}requestPromise(O,W,j,X=C.CancellationToken.None){const Q=this.lastRequestId++,Se={id:Q,type:100,channelName:O,name:W,arg:j};if(X.isCancellationRequested)return Promise.reject(k.canceled());let De;return new Promise((Be,We)=>{if(X.isCancellationRequested)return We(k.canceled());const He=()=>{const le=Z=>{switch(Z.type){case 201:this.handlers.delete(Q),Be(Z.data);break;case 202:this.handlers.delete(Q);const re=new Error(Z.data.message);re.stack=Z.data.stack,re.name=Z.data.name,We(re);break;case 203:this.handlers.delete(Q),We(Z.data);break}};this.handlers.set(Q,le),this.sendRequest(Se)};let G=null;this.state===P.Idle?He():(G=(0,L.createCancelablePromise)(le=>this.whenInitialized()),G.then(()=>{G=null,He()}));const ee=()=>{G?(G.cancel(),G=null):this.sendRequest({id:Q,type:101}),We(k.canceled())},ie=X.onCancellationRequested(ee);De=(0,D.combinedDisposable)((0,D.toDisposable)(ee),ie),this.activeRequests.add(De)}).finally(()=>{this.activeRequests.delete(De)})}requestEvent(O,W,j){const X=this.lastRequestId++,de={id:X,type:102,channelName:O,name:W,arg:j};let Se=null;const De=new _.Emitter({onFirstListenerAdd:()=>{Se=(0,L.createCancelablePromise)(Be=>this.whenInitialized()),Se.then(()=>{Se=null,this.activeRequests.add(De),this.sendRequest(de)})},onLastListenerRemove:()=>{Se?(Se.cancel(),Se=null):(this.activeRequests.delete(De),this.sendRequest({id:X,type:103}))}}),Pe=Be=>De.fire(Be.data);return this.handlers.set(X,Pe),De.event}sendRequest(O){switch(O.type){case 100:case 102:{const W=this.send([O.type,O.id,O.channelName,O.name],O.arg);this.logger&&this.logger.logOutgoing(W,O.id,0,`${f(O.type)}: ${O.channelName}.${O.name}`,O.arg);return}case 101:case 103:{const W=this.send([O.type,O.id]);this.logger&&this.logger.logOutgoing(W,O.id,0,f(O.type));return}}}send(O,W=void 0){const j=new s;return l(j,O),l(j,W),this.sendBuffer(j.buffer)}sendBuffer(O){try{return this.protocol.send(O),O.byteLength}catch(W){return 0}}onBuffer(O){const W=new w(O),j=d(W),X=d(W),Q=j[0];switch(Q){case 200:return this.logger&&this.logger.logIncoming(O.byteLength,0,0,S(Q)),this.onResponse({type:j[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(O.byteLength,j[1],0,S(Q),X),this.onResponse({type:j[0],id:j[1],data:X})}}onResponse(O){if(O.type===200){this.state=P.Idle,this._onDidInitialize.fire();return}const W=this.handlers.get(O.id);W&&W(O)}get onDidInitializePromise(){return _.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===P.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(O=>O.dispose()),this.activeRequests.clear()}}Ve([i.memoize],u.prototype,"onDidInitializePromise",null),e.ChannelClient=u;class E{constructor(O){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new _.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new _.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,O(({protocol:W,onDidClientDisconnect:j})=>{_.Event.once(W.onMessage)(Q=>{const de=new w(Q),Se=d(de),De=new o(W,Se),Pe=new u(W);this.channels.forEach((We,He)=>De.registerChannel(He,We));const Be={channelServer:De,channelClient:Pe,ctx:Se};this._connections.add(Be),this._onDidAddConnection.fire(Be),j(()=>{De.dispose(),Pe.dispose(),this._connections.delete(Be),this._onDidRemoveConnection.fire(Be)})})})}get connections(){const O=[];return this._connections.forEach(W=>O.push(W)),O}getChannel(O,W){const j=this;return{call(X,Q,de){let Se;if((0,c.isFunction)(W)){let Pe=(0,g.getRandomElement)(j.connections.filter(W));Se=Pe?Promise.resolve(Pe):_.Event.toPromise(_.Event.filter(j.onDidAddConnection,W))}else Se=W.routeCall(j,X,Q);const De=Se.then(Pe=>Pe.channelClient.getChannel(O));return R(De).call(X,Q,de)},listen(X,Q){if((0,c.isFunction)(W))return j.getMulticastEvent(O,W,X,Q);const de=W.routeEvent(j,X,Q).then(Se=>Se.channelClient.getChannel(O));return R(de).listen(X,Q)}}}getMulticastEvent(O,W,j,X){const Q=this;let de=new D.DisposableStore;const Se=new _.Emitter({onFirstListenerAdd:()=>{de=new D.DisposableStore;const De=new _.EventMultiplexer,Pe=new Map,Be=He=>{const ee=He.channelClient.getChannel(O).listen(j,X),ie=De.add(ee);Pe.set(He,ie)},We=He=>{const G=Pe.get(He);!G||(G.dispose(),Pe.delete(He))};Q.connections.filter(W).forEach(Be),_.Event.filter(Q.onDidAddConnection,W)(Be,void 0,de),Q.onDidRemoveConnection(We,void 0,de),De.event(Se.fire,Se,de),de.add(De)},onLastListenerRemove:()=>{de.dispose()}});return Se.event}registerChannel(O,W){this.channels.set(O,W),this._connections.forEach(j=>{j.channelServer.registerChannel(O,W)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=E;class A{constructor(O,W,j=null){const X=new s;l(X,W),O.send(X.buffer),this.channelClient=new u(O,j),this.channelServer=new o(O,W,j)}getChannel(O){return this.channelClient.getChannel(O)}registerChannel(O,W){this.channelServer.registerChannel(O,W)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=A;function R(V){return{call(O,W,j){return V.then(X=>X.call(O,W,j))},listen(O,W){const j=new _.Relay;return V.then(X=>j.input=X.listen(O,W)),j.event}}}e.getDelayedChannel=R;function B(V){let O=!1;return{call(W,j,X){return O?V.call(W,j,X):(0,L.timeout)(0).then(()=>O=!0).then(()=>V.call(W,j,X))},listen(W,j){if(O)return V.listen(W,j);const X=new _.Relay;return(0,L.timeout)(0).then(()=>O=!0).then(()=>X.input=V.listen(W,j)),X.event}}}e.getNextTickChannel=B;class x{constructor(O){this.fn=O}routeCall(O){return this.route(O)}routeEvent(O){return this.route(O)}async route(O){for(const W of O.connections)if(await Promise.resolve(this.fn(W.ctx)))return Promise.resolve(W);return await _.Event.toPromise(O.onDidAddConnection),await this.route(O)}}e.StaticRouter=x;var F;(function(V){function O(Q,de){const Se=Q,De=de&&de.disableMarshalling,Pe=new Map;for(const Be in Se)j(Be)&&Pe.set(Be,_.Event.buffer(Se[Be],!0));return new class{listen(Be,We,He){const G=Pe.get(We);if(G)return G;if(X(We)){const ee=Se[We];if(typeof ee=="function")return ee.call(Se,He)}throw new Error(`Event not found: ${We}`)}call(Be,We,He){const G=Se[We];if(typeof G=="function"){if(!De&&Array.isArray(He))for(let ee=0;ee<He.length;ee++)He[ee]=(0,T.revive)(He[ee]);return G.apply(Se,He)}throw new Error(`Method not found: ${We}`)}}}V.fromService=O;function W(Q,de){const Se=de&&de.disableMarshalling;return new Proxy({},{get(De,Pe){if(typeof Pe=="string")return de?.properties?.has(Pe)?de.properties.get(Pe):X(Pe)?function(Be){return Q.listen(Pe,Be)}:j(Pe)?Q.listen(Pe):async function(...Be){let We;de&&!(0,c.isUndefinedOrNull)(de.context)?We=[de.context,...Be]:We=Be;const He=await Q.call(Pe,We);return Se?He:(0,T.revive)(He)};throw new Error(`Property not found: ${String(Pe)}`)}})}V.toService=W;function j(Q){return Q[0]==="o"&&Q[1]==="n"&&I.isUpperAsciiLetter(Q.charCodeAt(2))}function X(Q){return/^onDynamic/.test(Q)&&I.isUpperAsciiLetter(Q.charCodeAt(9))}})(F=e.ProxyChannel||(e.ProxyChannel={}));const $=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function M(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){let O=V.toString();if(O!=="[object Object]")return O}return V}function H(V){return Array.isArray(V)?V.map(M):M(V)}function N(V,O,W,j,X,Q,de){de=H(de);const Se=$[X],De=Se[j%Se.length];let Pe=[`%c[${V}]%c[${String(O).padStart(7," ")}]%c[len: ${String(W).padStart(5," ")}]%c${String(j).padStart(5," ")} - ${Q}`,"color: darkgreen","color: grey","color: grey",`color: ${De}`];/\($/.test(Q)?(Pe=Pe.concat(de),Pe.push(")")):Pe.push(de),console.log.apply(console,Pe)}e.logWithColors=N;class U{constructor(O,W){this._outgoingPrefix=O,this._incomingPrefix=W,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(O,W,j,X,Q){this._totalOutgoing+=O,N(this._outgoingPrefix,this._totalOutgoing,O,W,j,X,Q)}logIncoming(O,W,j,X,Q){this._totalIncoming+=O,N(this._incomingPrefix,this._totalIncoming,O,W,j,X,Q)}}e.IPCLogger=U}),define(fe[107],me([0,1,22,3,6,12,38,106]),function(Y,e,g,L,y,C,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var _;(function(n){n[n.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",n[n.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(_=e.SocketCloseEventType||(e.SocketCloseEventType={}));let D=null;function T(){return D||(D=g.VSBuffer.alloc(0)),D}class I{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(t){this._chunks.push(t),this._totalLength+=t.byteLength}read(t){return this._read(t,!0)}peek(t){return this._read(t,!1)}_read(t,l){if(t===0)return T();if(t>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===t){const u=this._chunks[0];return l&&(this._chunks.shift(),this._totalLength-=t),u}if(this._chunks[0].byteLength>t){const u=this._chunks[0].slice(0,t);return l&&(this._chunks[0]=this._chunks[0].slice(t),this._totalLength-=t),u}let d=g.VSBuffer.alloc(t),o=0,h=0;for(;t>0;){const u=this._chunks[h];if(u.byteLength>t){const E=u.slice(0,t);d.set(E,o),o+=t,l&&(this._chunks[h]=u.slice(t),this._totalLength-=t),t-=t}else d.set(u,o),o+=u.byteLength,l?(this._chunks.shift(),this._totalLength-=u.byteLength):h++,t-=u.byteLength}return d}}e.ChunkStream=I;var c;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.KeepAlive=4]="KeepAlive",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest"})(c||(c={}));var p;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",n[n.KeepAliveTime=5e3]="KeepAliveTime",n[n.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(p=e.ProtocolConstants||(e.ProtocolConstants={}));class f{constructor(t,l,d,o){this.type=t,this.id=l,this.ack=d,this.data=o,this.writtenTime=0}get size(){return this.data.byteLength}}class v extends y.Disposable{constructor(t){super();this._onMessage=this._register(new L.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=t,this._isDisposed=!1,this._incomingData=new I,this._register(this._socket.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(t){if(!(!t||t.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(t);this._incomingData.byteLength>=this._state.readLen;){const l=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=l.readUInt32BE(9),this._state.messageType=l.readUInt8(0),this._state.id=l.readUInt32BE(1),this._state.ack=l.readUInt32BE(5);else{const d=this._state.messageType,o=this._state.id,h=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new f(d,o,h,l)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class S{constructor(t){this._isDisposed=!1,this._socket=t,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(t){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(t){if(this._isDisposed)return;t.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=g.VSBuffer.alloc(13);l.writeUInt8(t.type,0),l.writeUInt32BE(t.id,1),l.writeUInt32BE(t.ack,5),l.writeUInt32BE(t.data.byteLength,9),this._writeSoon(l,t.data)}_bufferAdd(t,l){const d=this._totalLength===0;return this._data.push(t,l),this._totalLength+=t.byteLength+l.byteLength,d}_bufferTake(){const t=g.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,t}_writeSoon(t,l){this._bufferAdd(t,l)&&C.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class P extends y.Disposable{constructor(t){super();this._onMessage=new L.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=t,this._socketWriter=this._register(new S(this._socket)),this._socketReader=this._register(new v(this._socket)),this._register(this._socketReader.onMessage(l=>{l.type===1&&this._onMessage.fire(l.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(t){this._socketWriter.write(new f(1,0,0,t))}}e.Protocol=P;class w extends k.IPCClient{constructor(t,l,d=null){super(t,l,d);this.protocol=t}static fromSocket(t,l){return new w(new P(t),l)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const t=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),t.end()}}e.Client=w;class s{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new L.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,i.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(t){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(t):this._emitter.fire(t):this._bufferedMessages.push(t)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=s;class r{constructor(t){this.data=t,this.next=null}}class m{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let t=[],l=0,d=this._first;for(;d;)t[l++]=d.data,d=d.next;return t}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(t){const l=new r(t);if(!this._first){this._first=l,this._last=l;return}this._last.next=l,this._last=l}}class a{constructor(){this.lastRuns=[];const t=Date.now();for(let l=0;l<a._HISTORY_LENGTH;l++)this.lastRuns[l]=t-1e3*l;setInterval(()=>{for(let l=a._HISTORY_LENGTH;l>=1;l--)this.lastRuns[l]=this.lastRuns[l-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return a._INSTANCE||(a._INSTANCE=new a),a._INSTANCE}load(){const t=Date.now(),l=(1+a._HISTORY_LENGTH)*1e3;let d=0;for(let o=0;o<a._HISTORY_LENGTH;o++)t-this.lastRuns[o]<=l&&d++;return 1-d/a._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}a._HISTORY_LENGTH=10,a._INSTANCE=null;class b{constructor(t,l=null,d=a.getInstance()){this._onControlMessage=new s,this.onControlMessage=this._onControlMessage.event,this._onMessage=new s,this.onMessage=this._onMessage.event,this._onDidDispose=new s,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new s,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new s,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=d,this._isReconnecting=!1,this._outgoingUnackMsg=new m,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=t,this._socketWriter=new S(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(o=>this._receiveMessage(o))),this._socketDisposables.push(this._socket.onClose(o=>this._onSocketClose.fire(o))),l&&this._socketReader.acceptChunk(l),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,y.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const t=new f(5,0,0,T());this._socketWriter.write(t),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const t=Date.now()-this._socketWriter.lastWriteTime;if(t>=5e3){const l=new f(4,0,0,T());this._socketWriter.write(l),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-t+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const t=Date.now()-this._socketReader.lastReadTime;if(t>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-t,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(t,l){this._isReconnecting=!0,this._socketDisposables=(0,y.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=t,this._socketWriter=new S(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(d=>this._receiveMessage(d))),this._socketDisposables.push(this._socket.onClose(d=>this._onSocketClose.fire(d))),this._socketReader.acceptChunk(l)}endAcceptReconnection(){this._isReconnecting=!1;const t=this._outgoingUnackMsg.toArray();for(let l=0,d=t.length;l<d;l++)this._socketWriter.write(t[l]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(t){if(t.ack>this._outgoingAckId){this._outgoingAckId=t.ack;do{const l=this._outgoingUnackMsg.peek();if(l&&l.id<=t.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(t.type===1){if(t.id>this._incomingMsgId)if(t.id!==this._incomingMsgId+1){const l=Date.now();l-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=l,this._socketWriter.write(new f(6,0,0,T())))}else this._incomingMsgId=t.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(t.data)}else if(t.type===2)this._onControlMessage.fire(t.data);else if(t.type===5)this._onDidDispose.fire();else if(t.type===6){const l=this._outgoingUnackMsg.toArray();for(let d=0,o=l.length;d<o;d++)this._socketWriter.write(l[d]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(t){const l=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const d=new f(1,l,this._incomingAckId,t);this._outgoingUnackMsg.push(d),this._isReconnecting||(this._socketWriter.write(d),this._recvAckCheck())}sendControl(t){const l=new f(2,0,0,t);this._socketWriter.write(l)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const t=Date.now()-this._incomingMsgLastTime;if(t>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-t+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const t=this._outgoingUnackMsg.peek(),l=Date.now()-t.writtenTime;if(l>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-l,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const t=new f(3,0,this._incomingAckId,T());this._socketWriter.write(t)}}e.PersistentProtocol=b}),define(fe[108],me([0,1,99]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class L{constructor(k){let _=(0,g.toUint8)(k);this._defaultValue=_,this._asciiMap=L._createAsciiMap(_),this._map=new Map}static _createAsciiMap(k){let _=new Uint8Array(256);for(let D=0;D<256;D++)_[D]=k;return _}set(k,_){let D=(0,g.toUint8)(_);k>=0&&k<256?this._asciiMap[k]=D:this._map.set(k,D)}get(k){return k>=0&&k<256?this._asciiMap[k]:this._map.get(k)||this._defaultValue}}e.CharacterClassifier=L;var y;(function(i){i[i.False=0]="False",i[i.True=1]="True"})(y||(y={}));class C{constructor(){this._actual=new L(0)}add(k){this._actual.set(k,1)}has(k){return this._actual.get(k)===1}}e.CharacterSet=C}),define(fe[144],me([0,1,108]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var L;(function(i){i[i.Regular=0]="Regular",i[i.Whitespace=1]="Whitespace",i[i.WordSeparator=2]="WordSeparator"})(L=e.WordCharacterClass||(e.WordCharacterClass={}));class y extends g.CharacterClassifier{constructor(k){super(0);for(let _=0,D=k.length;_<D;_++)this.set(k.charCodeAt(_),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=y;function C(i){let k={};return _=>(k.hasOwnProperty(_)||(k[_]=i(_)),k[_])}e.getMapForWordSeparators=C(i=>new y(i))}),define(fe[51],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class g{constructor(y,C){this.lineNumber=y,this.column=C}with(y=this.lineNumber,C=this.column){return y===this.lineNumber&&C===this.column?this:new g(y,C)}delta(y=0,C=0){return this.with(this.lineNumber+y,this.column+C)}equals(y){return g.equals(this,y)}static equals(y,C){return!y&&!C?!0:!!y&&!!C&&y.lineNumber===C.lineNumber&&y.column===C.column}isBefore(y){return g.isBefore(this,y)}static isBefore(y,C){return y.lineNumber<C.lineNumber?!0:C.lineNumber<y.lineNumber?!1:y.column<C.column}isBeforeOrEqual(y){return g.isBeforeOrEqual(this,y)}static isBeforeOrEqual(y,C){return y.lineNumber<C.lineNumber?!0:C.lineNumber<y.lineNumber?!1:y.column<=C.column}static compare(y,C){let i=y.lineNumber|0,k=C.lineNumber|0;if(i===k){let _=y.column|0,D=C.column|0;return _-D}return i-k}clone(){return new g(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(y){return new g(y.lineNumber,y.column)}static isIPosition(y){return y&&typeof y.lineNumber=="number"&&typeof y.column=="number"}}e.Position=g}),define(fe[42],me([0,1,51]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class L{constructor(C,i,k,_){C>k||C===k&&i>_?(this.startLineNumber=k,this.startColumn=_,this.endLineNumber=C,this.endColumn=i):(this.startLineNumber=C,this.startColumn=i,this.endLineNumber=k,this.endColumn=_)}isEmpty(){return L.isEmpty(this)}static isEmpty(C){return C.startLineNumber===C.endLineNumber&&C.startColumn===C.endColumn}containsPosition(C){return L.containsPosition(this,C)}static containsPosition(C,i){return!(i.lineNumber<C.startLineNumber||i.lineNumber>C.endLineNumber||i.lineNumber===C.startLineNumber&&i.column<C.startColumn||i.lineNumber===C.endLineNumber&&i.column>C.endColumn)}containsRange(C){return L.containsRange(this,C)}static containsRange(C,i){return!(i.startLineNumber<C.startLineNumber||i.endLineNumber<C.startLineNumber||i.startLineNumber>C.endLineNumber||i.endLineNumber>C.endLineNumber||i.startLineNumber===C.startLineNumber&&i.startColumn<C.startColumn||i.endLineNumber===C.endLineNumber&&i.endColumn>C.endColumn)}strictContainsRange(C){return L.strictContainsRange(this,C)}static strictContainsRange(C,i){return!(i.startLineNumber<C.startLineNumber||i.endLineNumber<C.startLineNumber||i.startLineNumber>C.endLineNumber||i.endLineNumber>C.endLineNumber||i.startLineNumber===C.startLineNumber&&i.startColumn<=C.startColumn||i.endLineNumber===C.endLineNumber&&i.endColumn>=C.endColumn)}plusRange(C){return L.plusRange(this,C)}static plusRange(C,i){let k,_,D,T;return i.startLineNumber<C.startLineNumber?(k=i.startLineNumber,_=i.startColumn):i.startLineNumber===C.startLineNumber?(k=i.startLineNumber,_=Math.min(i.startColumn,C.startColumn)):(k=C.startLineNumber,_=C.startColumn),i.endLineNumber>C.endLineNumber?(D=i.endLineNumber,T=i.endColumn):i.endLineNumber===C.endLineNumber?(D=i.endLineNumber,T=Math.max(i.endColumn,C.endColumn)):(D=C.endLineNumber,T=C.endColumn),new L(k,_,D,T)}intersectRanges(C){return L.intersectRanges(this,C)}static intersectRanges(C,i){let k=C.startLineNumber,_=C.startColumn,D=C.endLineNumber,T=C.endColumn,I=i.startLineNumber,c=i.startColumn,p=i.endLineNumber,f=i.endColumn;return k<I?(k=I,_=c):k===I&&(_=Math.max(_,c)),D>p?(D=p,T=f):D===p&&(T=Math.min(T,f)),k>D||k===D&&_>T?null:new L(k,_,D,T)}equalsRange(C){return L.equalsRange(this,C)}static equalsRange(C,i){return!!C&&!!i&&C.startLineNumber===i.startLineNumber&&C.startColumn===i.startColumn&&C.endLineNumber===i.endLineNumber&&C.endColumn===i.endColumn}getEndPosition(){return L.getEndPosition(this)}static getEndPosition(C){return new g.Position(C.endLineNumber,C.endColumn)}getStartPosition(){return L.getStartPosition(this)}static getStartPosition(C){return new g.Position(C.startLineNumber,C.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(C,i){return new L(this.startLineNumber,this.startColumn,C,i)}setStartPosition(C,i){return new L(C,i,this.endLineNumber,this.endColumn)}collapseToStart(){return L.collapseToStart(this)}static collapseToStart(C){return new L(C.startLineNumber,C.startColumn,C.startLineNumber,C.startColumn)}static fromPositions(C,i=C){return new L(C.lineNumber,C.column,i.lineNumber,i.column)}static lift(C){return C?new L(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn):null}static isIRange(C){return C&&typeof C.startLineNumber=="number"&&typeof C.startColumn=="number"&&typeof C.endLineNumber=="number"&&typeof C.endColumn=="number"}static areIntersectingOrTouching(C,i){return!(C.endLineNumber<i.startLineNumber||C.endLineNumber===i.startLineNumber&&C.endColumn<i.startColumn||i.endLineNumber<C.startLineNumber||i.endLineNumber===C.startLineNumber&&i.endColumn<C.startColumn)}static areIntersecting(C,i){return!(C.endLineNumber<i.startLineNumber||C.endLineNumber===i.startLineNumber&&C.endColumn<=i.startColumn||i.endLineNumber<C.startLineNumber||i.endLineNumber===C.startLineNumber&&i.endColumn<=C.startColumn)}static compareRangesUsingStarts(C,i){if(C&&i){const D=C.startLineNumber|0,T=i.startLineNumber|0;if(D===T){const I=C.startColumn|0,c=i.startColumn|0;if(I===c){const p=C.endLineNumber|0,f=i.endLineNumber|0;if(p===f){const v=C.endColumn|0,S=i.endColumn|0;return v-S}return p-f}return I-c}return D-T}return(C?1:0)-(i?1:0)}static compareRangesUsingEnds(C,i){return C.endLineNumber===i.endLineNumber?C.endColumn===i.endColumn?C.startLineNumber===i.startLineNumber?C.startColumn-i.startColumn:C.startLineNumber-i.startLineNumber:C.endColumn-i.endColumn:C.endLineNumber-i.endLineNumber}static spansMultipleLines(C){return C.endLineNumber>C.startLineNumber}}e.Range=L}),define(fe[145],me([0,1,51,42]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var y;(function(i){i[i.LTR=0]="LTR",i[i.RTL=1]="RTL"})(y=e.SelectionDirection||(e.SelectionDirection={}));class C extends L.Range{constructor(k,_,D,T){super(k,_,D,T);this.selectionStartLineNumber=k,this.selectionStartColumn=_,this.positionLineNumber=D,this.positionColumn=T}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(k){return C.selectionsEqual(this,k)}static selectionsEqual(k,_){return k.selectionStartLineNumber===_.selectionStartLineNumber&&k.selectionStartColumn===_.selectionStartColumn&&k.positionLineNumber===_.positionLineNumber&&k.positionColumn===_.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(k,_){return this.getDirection()===0?new C(this.startLineNumber,this.startColumn,k,_):new C(k,_,this.startLineNumber,this.startColumn)}getPosition(){return new g.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new g.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(k,_){return this.getDirection()===0?new C(k,_,this.endLineNumber,this.endColumn):new C(this.endLineNumber,this.endColumn,k,_)}static fromPositions(k,_=k){return new C(k.lineNumber,k.column,_.lineNumber,_.column)}static fromRange(k,_){return _===0?new C(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn):new C(k.endLineNumber,k.endColumn,k.startLineNumber,k.startColumn)}static liftSelection(k){return new C(k.selectionStartLineNumber,k.selectionStartColumn,k.positionLineNumber,k.positionColumn)}static selectionsArrEqual(k,_){if(k&&!_||!k&&_)return!1;if(!k&&!_)return!0;if(k.length!==_.length)return!1;for(let D=0,T=k.length;D<T;D++)if(!this.selectionsEqual(k[D],_[D]))return!1;return!0}static isISelection(k){return k&&typeof k.selectionStartLineNumber=="number"&&typeof k.selectionStartColumn=="number"&&typeof k.positionLineNumber=="number"&&typeof k.positionColumn=="number"}static createWithDirection(k,_,D,T,I){return I===0?new C(k,_,D,T):new C(D,T,k,_)}}e.Selection=C}),define(fe[109],me([0,1,25]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.IndentGuideHorizontalLine=e.IndentGuide=e.HorizontalGuidesState=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var L;(function(w){w[w.Left=1]="Left",w[w.Center=2]="Center",w[w.Right=4]="Right",w[w.Full=7]="Full"})(L=e.OverviewRulerLane||(e.OverviewRulerLane={}));var y;(function(w){w[w.Inline=1]="Inline",w[w.Gutter=2]="Gutter"})(y=e.MinimapPosition||(e.MinimapPosition={}));var C;(function(w){w[w.TextDefined=0]="TextDefined",w[w.LF=1]="LF",w[w.CRLF=2]="CRLF"})(C=e.EndOfLinePreference||(e.EndOfLinePreference={}));var i;(function(w){w[w.LF=1]="LF",w[w.CRLF=2]="CRLF"})(i=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var k;(function(w){w[w.LF=0]="LF",w[w.CRLF=1]="CRLF"})(k=e.EndOfLineSequence||(e.EndOfLineSequence={}));class _{constructor(s){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,s.tabSize|0),this.indentSize=s.tabSize|0,this.insertSpaces=Boolean(s.insertSpaces),this.defaultEOL=s.defaultEOL|0,this.trimAutoWhitespace=Boolean(s.trimAutoWhitespace),this.bracketPairColorizationOptions=s.bracketPairColorizationOptions}equals(s){return this.tabSize===s.tabSize&&this.indentSize===s.indentSize&&this.insertSpaces===s.insertSpaces&&this.defaultEOL===s.defaultEOL&&this.trimAutoWhitespace===s.trimAutoWhitespace&&(0,g.equals)(this.bracketPairColorizationOptions,s.bracketPairColorizationOptions)}createChangeEvent(s){return{tabSize:this.tabSize!==s.tabSize,indentSize:this.indentSize!==s.indentSize,insertSpaces:this.insertSpaces!==s.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==s.trimAutoWhitespace}}}e.TextModelResolvedOptions=_;class D{constructor(s,r){this._findMatchBrand=void 0,this.range=s,this.matches=r}}e.FindMatch=D;var T;(function(w){w[w.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",w[w.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",w[w.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",w[w.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(T=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var I;(function(w){w[w.Disabled=0]="Disabled",w[w.EnabledForActive=1]="EnabledForActive",w[w.Enabled=2]="Enabled"})(I=e.HorizontalGuidesState||(e.HorizontalGuidesState={}));class c{constructor(s,r,m){this.visibleColumn=s,this.className=r,this.horizontalLine=m}}e.IndentGuide=c;class p{constructor(s,r){this.top=s,this.endColumn=r}}e.IndentGuideHorizontalLine=p;var f;(function(w){w[w.Left=0]="Left",w[w.Right=1]="Right",w[w.None=2]="None"})(f=e.PositionAffinity||(e.PositionAffinity={}));var v;(function(w){w[w.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(v=e.ModelConstants||(e.ModelConstants={}));class S{constructor(s,r,m,a,b,n){this.identifier=s,this.range=r,this.text=m,this.forceMoveMarkers=a,this.isAutoWhitespaceEdit=b,this._isTracked=n}}e.ValidAnnotatedEditOperation=S;class P{constructor(s,r,m){this.reverseEdits=s,this.changes=r,this.trimAutoWhitespaceLineNumbers=m}}e.ApplyEditsResult=P}),define(fe[146],me([0,1,8,144,51,42,109]),function(Y,e,g,L,y,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const k=999;class _{constructor(s,r,m,a){this.searchString=s,this.isRegex=r,this.matchCase=m,this.wordSeparators=a}parseSearchRequest(){if(this.searchString==="")return null;let s;this.isRegex?s=D(this.searchString):s=this.searchString.indexOf(`
`)>=0;let r=null;try{r=g.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:s,global:!0,unicode:!0})}catch(a){return null}if(!r)return null;let m=!this.isRegex&&!s;return m&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(m=this.matchCase),new T(r,this.wordSeparators?(0,L.getMapForWordSeparators)(this.wordSeparators):null,m?this.searchString:null)}}e.SearchParams=_;function D(w){if(!w||w.length===0)return!1;for(let s=0,r=w.length;s<r;s++)if(w.charCodeAt(s)===92){if(s++,s>=r)break;const a=w.charCodeAt(s);if(a===110||a===114||a===87)return!0}return!1}e.isMultilineRegexSource=D;class T{constructor(s,r,m){this.regex=s,this.wordSeparators=r,this.simpleSearch=m}}e.SearchData=T;function I(w,s,r){if(!r)return new i.FindMatch(w,null);let m=[];for(let a=0,b=s.length;a<b;a++)m[a]=s[a];return new i.FindMatch(w,m)}e.createFindMatch=I;class c{constructor(s){let r=[],m=0;for(let a=0,b=s.length;a<b;a++)s.charCodeAt(a)===10&&(r[m++]=a);this._lineFeedsOffsets=r}findLineFeedCountBeforeOffset(s){const r=this._lineFeedsOffsets;let m=0,a=r.length-1;if(a===-1||s<=r[0])return 0;for(;m<a;){const b=m+((a-m)/2>>0);r[b]>=s?a=b-1:r[b+1]>=s?(m=b,a=b):m=b+1}return m+1}}class p{static findMatches(s,r,m,a,b){const n=r.parseSearchRequest();return n?n.regex.multiline?this._doFindMatchesMultiline(s,m,new P(n.wordSeparators,n.regex),a,b):this._doFindMatchesLineByLine(s,m,n,a,b):[]}static _getMultilineMatchRange(s,r,m,a,b,n){let t,l=0;a?(l=a.findLineFeedCountBeforeOffset(b),t=r+b+l):t=r+b;let d;if(a){let E=a.findLineFeedCountBeforeOffset(b+n.length)-l;d=t+n.length+E}else d=t+n.length;const o=s.getPositionAt(t),h=s.getPositionAt(d);return new C.Range(o.lineNumber,o.column,h.lineNumber,h.column)}static _doFindMatchesMultiline(s,r,m,a,b){const n=s.getOffsetAt(r.getStartPosition()),t=s.getValueInRange(r,1),l=s.getEOL()===`\r
`?new c(t):null,d=[];let o=0,h;for(m.reset(0);h=m.next(t);)if(d[o++]=I(this._getMultilineMatchRange(s,n,t,l,h.index,h[0]),h,a),o>=b)return d;return d}static _doFindMatchesLineByLine(s,r,m,a,b){const n=[];let t=0;if(r.startLineNumber===r.endLineNumber){const d=s.getLineContent(r.startLineNumber).substring(r.startColumn-1,r.endColumn-1);return t=this._findMatchesInLine(m,d,r.startLineNumber,r.startColumn-1,t,n,a,b),n}const l=s.getLineContent(r.startLineNumber).substring(r.startColumn-1);t=this._findMatchesInLine(m,l,r.startLineNumber,r.startColumn-1,t,n,a,b);for(let d=r.startLineNumber+1;d<r.endLineNumber&&t<b;d++)t=this._findMatchesInLine(m,s.getLineContent(d),d,0,t,n,a,b);if(t<b){const d=s.getLineContent(r.endLineNumber).substring(0,r.endColumn-1);t=this._findMatchesInLine(m,d,r.endLineNumber,0,t,n,a,b)}return n}static _findMatchesInLine(s,r,m,a,b,n,t,l){const d=s.wordSeparators;if(!t&&s.simpleSearch){const u=s.simpleSearch,E=u.length,A=r.length;let R=-E;for(;(R=r.indexOf(u,R+E))!==-1;)if((!d||S(d,r,A,R,E))&&(n[b++]=new i.FindMatch(new C.Range(m,R+1+a,m,R+1+E+a),null),b>=l))return b;return b}const o=new P(s.wordSeparators,s.regex);let h;o.reset(0);do if(h=o.next(r),h&&(n[b++]=I(new C.Range(m,h.index+1+a,m,h.index+1+h[0].length+a),h,t),b>=l))return b;while(h);return b}static findNextMatch(s,r,m,a){const b=r.parseSearchRequest();if(!b)return null;const n=new P(b.wordSeparators,b.regex);return b.regex.multiline?this._doFindNextMatchMultiline(s,m,n,a):this._doFindNextMatchLineByLine(s,m,n,a)}static _doFindNextMatchMultiline(s,r,m,a){const b=new y.Position(r.lineNumber,1),n=s.getOffsetAt(b),t=s.getLineCount(),l=s.getValueInRange(new C.Range(b.lineNumber,b.column,t,s.getLineMaxColumn(t)),1),d=s.getEOL()===`\r
`?new c(l):null;m.reset(r.column-1);let o=m.next(l);return o?I(this._getMultilineMatchRange(s,n,l,d,o.index,o[0]),o,a):r.lineNumber!==1||r.column!==1?this._doFindNextMatchMultiline(s,new y.Position(1,1),m,a):null}static _doFindNextMatchLineByLine(s,r,m,a){const b=s.getLineCount(),n=r.lineNumber,t=s.getLineContent(n),l=this._findFirstMatchInLine(m,t,n,r.column,a);if(l)return l;for(let d=1;d<=b;d++){const o=(n+d-1)%b,h=s.getLineContent(o+1),u=this._findFirstMatchInLine(m,h,o+1,1,a);if(u)return u}return null}static _findFirstMatchInLine(s,r,m,a,b){s.reset(a-1);const n=s.next(r);return n?I(new C.Range(m,n.index+1,m,n.index+1+n[0].length),n,b):null}static findPreviousMatch(s,r,m,a){const b=r.parseSearchRequest();if(!b)return null;const n=new P(b.wordSeparators,b.regex);return b.regex.multiline?this._doFindPreviousMatchMultiline(s,m,n,a):this._doFindPreviousMatchLineByLine(s,m,n,a)}static _doFindPreviousMatchMultiline(s,r,m,a){const b=this._doFindMatchesMultiline(s,new C.Range(1,1,r.lineNumber,r.column),m,a,10*k);if(b.length>0)return b[b.length-1];const n=s.getLineCount();return r.lineNumber!==n||r.column!==s.getLineMaxColumn(n)?this._doFindPreviousMatchMultiline(s,new y.Position(n,s.getLineMaxColumn(n)),m,a):null}static _doFindPreviousMatchLineByLine(s,r,m,a){const b=s.getLineCount(),n=r.lineNumber,t=s.getLineContent(n).substring(0,r.column-1),l=this._findLastMatchInLine(m,t,n,a);if(l)return l;for(let d=1;d<=b;d++){const o=(b+n-d-1)%b,h=s.getLineContent(o+1),u=this._findLastMatchInLine(m,h,o+1,a);if(u)return u}return null}static _findLastMatchInLine(s,r,m,a){let b=null,n;for(s.reset(0);n=s.next(r);)b=I(new C.Range(m,n.index+1,m,n.index+1+n[0].length),n,a);return b}}e.TextModelSearch=p;function f(w,s,r,m,a){if(m===0)return!0;const b=s.charCodeAt(m-1);if(w.get(b)!==0||b===13||b===10)return!0;if(a>0){const n=s.charCodeAt(m);if(w.get(n)!==0)return!0}return!1}function v(w,s,r,m,a){if(m+a===r)return!0;const b=s.charCodeAt(m+a);if(w.get(b)!==0||b===13||b===10)return!0;if(a>0){const n=s.charCodeAt(m+a-1);if(w.get(n)!==0)return!0}return!1}function S(w,s,r,m,a){return f(w,s,r,m,a)&&v(w,s,r,m,a)}e.isValidMatch=S;class P{constructor(s,r){this._wordSeparators=s,this._searchRegex=r,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(s){this._searchRegex.lastIndex=s,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(s){const r=s.length;let m;do{if(this._prevMatchStartIndex+this._prevMatchLength===r||(m=this._searchRegex.exec(s),!m))return null;const a=m.index,b=m[0].length;if(a===this._prevMatchStartIndex&&b===this._prevMatchLength){if(b===0){g.getNextCodePoint(s,r,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=a,this._prevMatchLength=b,!this._wordSeparators||S(this._wordSeparators,s,r,a,b))return m}while(m);return null}}e.Searcher=P}),define(fe[110],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function g(k=""){let _="(-?\\d*\\.\\d\\w*)|([^";for(const D of e.USUAL_WORD_SEPARATORS)k.indexOf(D)>=0||(_+="\\"+D);return _+="\\s]+)",new RegExp(_,"g")}e.DEFAULT_WORD_REGEXP=g();function L(k){let _=e.DEFAULT_WORD_REGEXP;if(k&&k instanceof RegExp)if(k.global)_=k;else{let D="g";k.ignoreCase&&(D+="i"),k.multiline&&(D+="m"),k.unicode&&(D+="u"),_=new RegExp(k.source,D)}return _.lastIndex=0,_}e.ensureValidWordDefinition=L;const y={maxLen:1e3,windowSize:15,timeBudget:150};function C(k,_,D,T,I=y){if(D.length>I.maxLen){let S=k-I.maxLen/2;return S<0?S=0:T+=S,D=D.substring(S,k+I.maxLen/2),C(k,_,D,T,I)}const c=Date.now(),p=k-1-T;let f=-1,v=null;for(let S=1;!(Date.now()-c>=I.timeBudget);S++){const P=p-I.windowSize*S;_.lastIndex=Math.max(0,P);const w=i(_,D,p,f);if(!w&&v||(v=w,P<=0))break;f=P}if(v){let S={word:v[0],startColumn:T+1+v.index,endColumn:T+1+v.index+v[0].length};return _.lastIndex=0,S}return null}e.getWordAtText=C;function i(k,_,D,T){let I;for(;I=k.exec(_);){const c=I.index||0;if(c<=D&&k.lastIndex>=D)return I;if(T>0&&c>T)return null}return null}}),define(fe[147],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var g;(function(i){i[i.None=0]="None",i[i.Indent=1]="Indent",i[i.IndentOutdent=2]="IndentOutdent",i[i.Outdent=3]="Outdent"})(g=e.IndentAction||(e.IndentAction={}));class L{constructor(k){if(this._standardAutoClosingPairConditionalBrand=void 0,this.open=k.open,this.close=k.close,this._standardTokenMask=0,Array.isArray(k.notIn))for(let _=0,D=k.notIn.length;_<D;_++)switch(k.notIn[_]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(k){return(this._standardTokenMask&k)==0}}e.StandardAutoClosingPairConditional=L;class y{constructor(k){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const _ of k)C(this.autoClosingPairsOpenByStart,_.open.charAt(0),_),C(this.autoClosingPairsOpenByEnd,_.open.charAt(_.open.length-1),_),C(this.autoClosingPairsCloseByStart,_.close.charAt(0),_),C(this.autoClosingPairsCloseByEnd,_.close.charAt(_.close.length-1),_),_.close.length===1&&_.open.length===1&&C(this.autoClosingPairsCloseSingleChar,_.close,_)}}e.AutoClosingPairs=y;function C(i,k,_){i.has(k)?i.get(k).push(_):i.set(k,[_])}}),define(fe[83],me([0,1,31,9]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function y(C,i,k,_){if(Array.isArray(C)){let D=0;for(const T of C){const I=y(T,i,k,_);if(I===10)return I;I>D&&(D=I)}return D}else{if(typeof C=="string")return _?C==="*"?5:C===k?10:0:0;if(C){const{language:D,pattern:T,scheme:I,hasAccessToAllModels:c}=C;if(!_&&!c)return 0;let p=0;if(I)if(I===i.scheme)p=10;else if(I==="*")p=5;else return 0;if(D)if(D===k)p=10;else if(D==="*")p=Math.max(p,5);else return 0;if(T){let f;if(typeof T=="string"?f=T:f={...T,base:(0,L.normalize)(T.base)},f===i.fsPath||(0,g.match)(f,i.fsPath))p=10;else return 0}return p}else return 0}}e.score=y}),define(fe[148],me([0,1,108]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var L;(function(p){p[p.Invalid=0]="Invalid",p[p.Start=1]="Start",p[p.H=2]="H",p[p.HT=3]="HT",p[p.HTT=4]="HTT",p[p.HTTP=5]="HTTP",p[p.F=6]="F",p[p.FI=7]="FI",p[p.FIL=8]="FIL",p[p.BeforeColon=9]="BeforeColon",p[p.AfterColon=10]="AfterColon",p[p.AlmostThere=11]="AlmostThere",p[p.End=12]="End",p[p.Accept=13]="Accept",p[p.LastKnownState=14]="LastKnownState"})(L=e.State||(e.State={}));class y{constructor(f,v,S){const P=new Uint8Array(f*v);for(let w=0,s=f*v;w<s;w++)P[w]=S;this._data=P,this.rows=f,this.cols=v}get(f,v){return this._data[f*this.cols+v]}set(f,v,S){this._data[f*this.cols+v]=S}}e.Uint8Matrix=y;class C{constructor(f){let v=0,S=0;for(let w=0,s=f.length;w<s;w++){let[r,m,a]=f[w];m>v&&(v=m),r>S&&(S=r),a>S&&(S=a)}v++,S++;let P=new y(S,v,0);for(let w=0,s=f.length;w<s;w++){let[r,m,a]=f[w];P.set(r,m,a)}this._states=P,this._maxCharCode=v}nextState(f,v){return v<0||v>=this._maxCharCode?0:this._states.get(f,v)}}e.StateMachine=C;let i=null;function k(){return i===null&&(i=new C([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),i}var _;(function(p){p[p.None=0]="None",p[p.ForceTermination=1]="ForceTermination",p[p.CannotEndIn=2]="CannotEndIn"})(_||(_={}));let D=null;function T(){if(D===null){D=new g.CharacterClassifier(0);const p=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let v=0;v<p.length;v++)D.set(p.charCodeAt(v),1);const f=".,;";for(let v=0;v<f.length;v++)D.set(f.charCodeAt(v),2)}return D}class I{static _createLink(f,v,S,P,w){let s=w-1;do{const r=v.charCodeAt(s);if(f.get(r)!==2)break;s--}while(s>P);if(P>0){const r=v.charCodeAt(P-1),m=v.charCodeAt(s);(r===40&&m===41||r===91&&m===93||r===123&&m===125)&&s--}return{range:{startLineNumber:S,startColumn:P+1,endLineNumber:S,endColumn:s+2},url:v.substring(P,s+1)}}static computeLinks(f,v=k()){const S=T();let P=[];for(let w=1,s=f.getLineCount();w<=s;w++){const r=f.getLineContent(w),m=r.length;let a=0,b=0,n=0,t=1,l=!1,d=!1,o=!1,h=!1;for(;a<m;){let u=!1;const E=r.charCodeAt(a);if(t===13){let A;switch(E){case 40:l=!0,A=0;break;case 41:A=l?0:1;break;case 91:o=!0,d=!0,A=0;break;case 93:o=!1,A=d?0:1;break;case 123:h=!0,A=0;break;case 125:A=h?0:1;break;case 39:A=n===34||n===96?0:1;break;case 34:A=n===39||n===96?0:1;break;case 96:A=n===39||n===34?0:1;break;case 42:A=n===42?1:0;break;case 124:A=n===124?1:0;break;case 32:A=o?0:1;break;default:A=S.get(E)}A===1&&(P.push(I._createLink(S,r,w,b,a)),u=!0)}else if(t===12){let A;E===91?(d=!0,A=0):A=S.get(E),A===1?u=!0:t=13}else t=v.nextState(t,E),t===0&&(u=!0);u&&(t=1,l=!1,d=!1,h=!1,b=a+1,n=E),a++}t===13&&P.push(I._createLink(S,r,w,b,m))}return P}}e.LinkComputer=I;function c(p){return!p||typeof p.getLineCount!="function"||typeof p.getLineContent!="function"?[]:I.computeLinks(p)}e.computeLinks=c}),define(fe[149],me([0,1,3,6]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class y{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new g.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(i){this._onDidChange.fire({changedLanguages:i,changedColorMap:!1})}register(i,k){return this._map.set(i,k),this.fire([i]),(0,L.toDisposable)(()=>{this._map.get(i)===k&&(this._map.delete(i),this.fire([i]))})}registerPromise(i,k){let _=null,D=!1;return this._promises.set(i,k.then(T=>{this._promises.delete(i),!(D||!T)&&(_=this.register(i,T))})),(0,L.toDisposable)(()=>{D=!0,_&&_.dispose()})}getPromise(i){const k=this.get(i);if(k)return Promise.resolve(k);const _=this._promises.get(i);return _?_.then(D=>this.get(i)):null}get(i){return this._map.get(i)||null}setColorMap(i){this._colorMap=i,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=y}),define(fe[111],me([0,1,22,12]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var y;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(y||(y={}));function C(I){for(let c=0,p=I.length;c<p;c+=4){const f=I[c+0],v=I[c+1],S=I[c+2],P=I[c+3];I[c+0]=P,I[c+1]=S,I[c+2]=v,I[c+3]=f}}function i(I){const c=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return L.isLittleEndian()||C(c),g.VSBuffer.wrap(c)}function k(I){const c=I.buffer;if(L.isLittleEndian()||C(c),c.byteOffset%4==0)return new Uint32Array(c.buffer,c.byteOffset,c.length/4);{const p=new Uint8Array(c.byteLength);return p.set(c),new Uint32Array(p.buffer,p.byteOffset,p.length/4)}}function _(I){const c=new Uint32Array(D(I));let p=0;if(c[p++]=I.id,I.type==="full")c[p++]=1,c[p++]=I.data.length,c.set(I.data,p),p+=I.data.length;else{c[p++]=2,c[p++]=I.deltas.length;for(const f of I.deltas)c[p++]=f.start,c[p++]=f.deleteCount,f.data?(c[p++]=f.data.length,c.set(f.data,p),p+=f.data.length):c[p++]=0}return i(c)}e.encodeSemanticTokensDto=_;function D(I){let c=0;if(c+=1+1,I.type==="full")c+=1+I.data.length;else{c+=1,c+=(1+1+1)*I.deltas.length;for(const p of I.deltas)p.data&&(c+=p.data.length)}return c}function T(I){const c=k(I);let p=0;const f=c[p++];if(c[p++]===1){const w=c[p++],s=c.subarray(p,p+w);return p+=w,{id:f,type:"full",data:s}}const S=c[p++];let P=[];for(let w=0;w<S;w++){const s=c[p++],r=c[p++],m=c[p++];let a;m>0&&(a=c.subarray(p,p+m),p+=m),P[w]={start:s,deleteCount:r,data:a}}return{id:f,type:"delta",deltas:P}}e.decodeSemanticTokensDto=T}),define(fe[112],me([0,1,15,99]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class y{constructor(_){this.values=_,this.prefixSum=new Uint32Array(_.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(_,D){_=(0,L.toUint32)(_);const T=this.values,I=this.prefixSum,c=D.length;return c===0?!1:(this.values=new Uint32Array(T.length+c),this.values.set(T.subarray(0,_),0),this.values.set(T.subarray(_),_+c),this.values.set(D,_),_-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=_-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(I.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(_,D){return _=(0,L.toUint32)(_),D=(0,L.toUint32)(D),this.values[_]===D?!1:(this.values[_]=D,_-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=_-1),!0)}removeValues(_,D){_=(0,L.toUint32)(_),D=(0,L.toUint32)(D);const T=this.values,I=this.prefixSum;if(_>=T.length)return!1;let c=T.length-_;return D>=c&&(D=c),D===0?!1:(this.values=new Uint32Array(T.length-D),this.values.set(T.subarray(0,_),0),this.values.set(T.subarray(_+D),_),this.prefixSum=new Uint32Array(this.values.length),_-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=_-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(I.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(_){return _<0?0:(_=(0,L.toUint32)(_),this._getPrefixSum(_))}_getPrefixSum(_){if(_<=this.prefixSumValidIndex[0])return this.prefixSum[_];let D=this.prefixSumValidIndex[0]+1;D===0&&(this.prefixSum[0]=this.values[0],D++),_>=this.values.length&&(_=this.values.length-1);for(let T=D;T<=_;T++)this.prefixSum[T]=this.prefixSum[T-1]+this.values[T];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],_),this.prefixSum[_]}getIndexOf(_){_=Math.floor(_),this.getTotalSum();let D=0,T=this.values.length-1,I=0,c=0,p=0;for(;D<=T;)if(I=D+(T-D)/2|0,c=this.prefixSum[I],p=c-this.values[I],_<p)T=I-1;else if(_>=c)D=I+1;else break;return new i(I,_-p)}}e.PrefixSumComputer=y;class C{constructor(_){this._values=_,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(_){return this._ensureValid(),_===0?0:this._prefixSum[_-1]}getIndexOf(_){this._ensureValid();const D=this._indexBySum[_],T=D>0?this._prefixSum[D-1]:0;return new i(D,_-T)}removeValues(_,D){this._values.splice(_,D),this._invalidate(_)}insertValues(_,D){this._values=(0,g.arrayInsert)(this._values,_,D),this._invalidate(_)}_invalidate(_){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,_-1)}_ensureValid(){if(!this._isValid){for(let _=this._validEndIndex+1,D=this._values.length;_<D;_++){const T=this._values[_],I=_>0?this._prefixSum[_-1]:0;this._prefixSum[_]=I+T;for(let c=0;c<T;c++)this._indexBySum[I+c]=_}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(_,D){this._values[_]!==D&&(this._values[_]=D,this._invalidate(_))}}e.ConstantTimePrefixSumComputer=C;class i{constructor(_,D){this.index=_,this.remainder=D,this._prefixSumIndexOfResultBrand=void 0,this.index=_,this.remainder=D}}e.PrefixSumIndexOfResult=i}),define(fe[150],me([0,1,8,51,112]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class C{constructor(k,_,D,T){this._uri=k,this._lines=_,this._eol=D,this._versionId=T,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(k){k.eol&&k.eol!==this._eol&&(this._eol=k.eol,this._lineStarts=null);const _=k.changes;for(const D of _)this._acceptDeleteRange(D.range),this._acceptInsertText(new L.Position(D.range.startLineNumber,D.range.startColumn),D.text);this._versionId=k.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const k=this._eol.length,_=this._lines.length,D=new Uint32Array(_);for(let T=0;T<_;T++)D[T]=this._lines[T].length+k;this._lineStarts=new y.PrefixSumComputer(D)}}_setLineText(k,_){this._lines[k]=_,this._lineStarts&&this._lineStarts.setValue(k,this._lines[k].length+this._eol.length)}_acceptDeleteRange(k){if(k.startLineNumber===k.endLineNumber){if(k.startColumn===k.endColumn)return;this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.startLineNumber-1].substring(k.endColumn-1));return}this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.endLineNumber-1].substring(k.endColumn-1)),this._lines.splice(k.startLineNumber,k.endLineNumber-k.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(k.startLineNumber,k.endLineNumber-k.startLineNumber)}_acceptInsertText(k,_){if(_.length===0)return;let D=(0,g.splitLines)(_);if(D.length===1){this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+D[0]+this._lines[k.lineNumber-1].substring(k.column-1));return}D[D.length-1]+=this._lines[k.lineNumber-1].substring(k.column-1),this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+D[0]);let T=new Uint32Array(D.length-1);for(let I=1;I<D.length;I++)this._lines.splice(k.lineNumber+I-1,0,D[I]),T[I-1]=D[I].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(k.lineNumber,T)}}e.MirrorTextModel=C}),define(fe[151],me([19,20]),function(Y,e){return Y.create("vs/base/common/date",e)}),define(fe[152],me([0,1,151]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,y=L*60,C=y*24,i=C*7,k=C*30,_=C*365;function D(I,c){typeof I!="number"&&(I=I.getTime());const p=Math.round((new Date().getTime()-I)/1e3);if(p<-30)return(0,g.localize)(0,null,D(new Date().getTime()+p*1e3,!1));if(p<30)return(0,g.localize)(1,null);let f;return p<L?(f=p,c?f===1?(0,g.localize)(2,null,f):(0,g.localize)(3,null,f):f===1?(0,g.localize)(4,null,f):(0,g.localize)(5,null,f)):p<y?(f=Math.floor(p/L),c?f===1?(0,g.localize)(6,null,f):(0,g.localize)(7,null,f):f===1?(0,g.localize)(8,null,f):(0,g.localize)(9,null,f)):p<C?(f=Math.floor(p/y),c?f===1?(0,g.localize)(10,null,f):(0,g.localize)(11,null,f):f===1?(0,g.localize)(12,null,f):(0,g.localize)(13,null,f)):p<i?(f=Math.floor(p/C),c?f===1?(0,g.localize)(14,null,f):(0,g.localize)(15,null,f):f===1?(0,g.localize)(16,null,f):(0,g.localize)(17,null,f)):p<k?(f=Math.floor(p/i),c?f===1?(0,g.localize)(18,null,f):(0,g.localize)(19,null,f):f===1?(0,g.localize)(20,null,f):(0,g.localize)(21,null,f)):p<_?(f=Math.floor(p/k),c?f===1?(0,g.localize)(22,null,f):(0,g.localize)(23,null,f):f===1?(0,g.localize)(24,null,f):(0,g.localize)(25,null,f)):(f=Math.floor(p/_),c?f===1?(0,g.localize)(26,null,f):(0,g.localize)(27,null,f):f===1?(0,g.localize)(28,null,f):(0,g.localize)(29,null,f))}e.fromNow=D;function T(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=T}),define(fe[153],me([19,20]),function(Y,e){return Y.create("vs/base/common/errorMessage",e)}),define(fe[52],me([0,1,15,13,153]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function C(D,T){return T&&(D.stack||D.stacktrace)?y.localize(0,null,k(D),i(D.stack)||i(D.stacktrace)):k(D)}function i(D){return Array.isArray(D)?D.join(`
`):D}function k(D){return typeof D.code=="string"&&typeof D.errno=="number"&&typeof D.syscall=="string"?y.localize(1,null,D.message):D.message||y.localize(2,null)}function _(D=null,T=!1){if(!D)return y.localize(3,null);if(Array.isArray(D)){const I=g.coalesce(D),c=_(I[0],T);return I.length>1?y.localize(4,null,c,I.length):c}if(L.isString(D))return D;if(D.detail){const I=D.detail;if(I.error)return C(I.error,T);if(I.exception)return C(I.exception,T)}return D.stack?C(D,T):D.message?D.message:y.localize(5,null)}e.toErrorMessage=_}),define(fe[154],me([19,20]),function(Y,e){return Y.create("vs/base/node/processes",e)}),define(fe[113],me([0,1,39,30,10,25,9,12,38,95,13,143,28,154]),function(Y,e,g,L,y,C,i,k,_,D,T,I,c,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return D.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return D.TerminateResponseCode}});function f(a){switch(a){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function v(a,b){if(k.isWindows)try{const n={stdio:["pipe","pipe","ignore"]};b&&(n.cwd=b);const t=g.execFile("taskkill",["/T","/F","/PID",a.pid.toString()],n);return new Promise(l=>{t.once("error",d=>{l({success:!1,error:d})}),t.once("exit",(d,o)=>{l(d===0?{success:!0}:{success:!1,code:d!==null?d:1})})})}catch(n){return Promise.resolve({success:!1,error:n,code:n.status?f(n.status):1})}else if(k.isLinux||k.isMacintosh)try{const n=y.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",Y).fsPath;return new Promise(t=>{g.execFile(n,[a.pid.toString()],{encoding:"utf8",shell:!0},(l,d,o)=>{t(l?{success:!1,error:l}:{success:!0})})})}catch(n){return Promise.resolve({success:!1,error:n})}else a.kill("SIGKILL");return Promise.resolve({success:!0})}function S(a){!a||(delete a.DEBUG,k.isMacintosh&&delete a.DYLD_LIBRARY_PATH,k.isLinux&&delete a.LD_PRELOAD)}e.removeDangerousEnvVariables=S;function P(a=_.env){return a.comspec||"cmd.exe"}e.getWindowsShell=P;class w{constructor(b,n,t,l){if(n!==void 0&&t!==void 0&&l!==void 0)this.cmd=b,this.args=n,this.shell=t,this.options=l;else{const d=b;this.cmd=d.command,this.shell=d.isShellCommand,this.args=d.args.slice(0),this.options=d.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const d=Object.create(null);Object.keys(_.env).forEach(o=>{d[o]=_.env[o]}),Object.keys(this.options.env).forEach(o=>{d[o]=this.options.env[o]}),this.options.env=d}}getSanitizedCommand(){let b=this.cmd.toLowerCase();const n=b.lastIndexOf(i.sep);return n!==-1&&(b=b.substring(n+1)),w.WellKnowCommands[b]?b:"other"}start(b){return k.isWindows&&(this.options&&this.options.cwd&&L.isUNC(this.options.cwd)||!this.options&&L.isUNC(_.cwd()))?Promise.reject(new Error(p.localize(0,null))):this.useExec().then(n=>{let t,l;const d=new Promise((o,h)=>{t=o,l=h});if(n){let o=this.cmd;this.args&&(o=o+" "+this.args.join(" ")),this.childProcess=g.exec(o,this.options,(h,u,E)=>{this.childProcess=null;const A=h;A&&A.killed?l({killed:this.terminateRequested,stdout:u.toString(),stderr:E.toString()}):this.handleExec(t,b,h,u,E)})}else{let o=null;const h=u=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(u,t,b,l);const E={terminated:this.terminateRequested};T.isNumber(u)&&(E.cmdCode=u),t(E)};if(this.shell&&k.isWindows){const u=C.deepClone(this.options);u.windowsVerbatimArguments=!0,u.detached=!1;let E=!1,A=!1;const R=[];let B=this.ensureQuotes(this.cmd);R.push(B.value),E=B.quoted,this.args&&this.args.forEach(F=>{B=this.ensureQuotes(F),R.push(B.value),A=A&&B.quoted});const x=["/s","/c"];E?A?x.push('"'+R.join(" ")+'"'):R.length>1?x.push('"'+R[0]+'" '+R.slice(1).join(" ")):x.push('"'+R[0]+'"'):x.push(R.join(" ")),o=g.spawn(P(),x,u)}else this.cmd&&(o=g.spawn(this.cmd,this.args,this.options));o&&(this.childProcess=o,this.childProcessPromise=Promise.resolve(o),this.pidResolve&&(this.pidResolve(T.isNumber(o.pid)?o.pid:-1),this.pidResolve=void 0),o.on("error",u=>{this.childProcess=null,l({terminated:this.terminateRequested,error:u})}),o.pid&&(this.childProcess.on("close",h),this.handleSpawn(o,t,b,l,!0)))}return d})}handleClose(b,n,t,l){}ensureQuotes(b){return w.regexp.test(b)?{value:'"'+b+'"',quoted:!0}:{value:b,quoted:b.length>0&&b[0]==='"'&&b[b.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(b=>b.pid,b=>-1):new Promise(b=>{this.pidResolve=b})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(b=>(this.terminateRequested=!0,v(b,this.options.cwd).then(n=>(n.success&&(this.childProcess=null),n))),b=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(b=>{if(!this.shell||!k.isWindows)return b(!1);const n=g.spawn(P(),["/s","/c"]);n.on("error",t=>b(!0)),n.on("exit",t=>b(!1))})}}e.AbstractProcess=w,w.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},w.regexp=/^[^"].* .*[^"]/;class s extends w{constructor(b,n,t,l){super(b,n,t,l);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(b,n,t,l,d){[l,d].forEach((o,h)=>{const u=new I.LineDecoder;u.write(o).forEach(R=>{n({line:R,source:h===0?0:1})});const A=u.end();A&&n({line:A,source:h===0?0:1})}),b({terminated:this.terminateRequested,error:t})}handleSpawn(b,n,t,l,d){const o=new I.LineDecoder,h=new I.LineDecoder;b.stdout.on("data",u=>{o.write(u).forEach(A=>t({line:A,source:0}))}),b.stderr.on("data",u=>{h.write(u).forEach(A=>t({line:A,source:1}))}),this.stdoutLineDecoder=o,this.stderrLineDecoder=h}handleClose(b,n,t,l){const d=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;d&&t({line:d,source:0});const o=this.stderrLineDecoder?this.stderrLineDecoder.end():null;o&&t({line:o,source:1})}}e.LineProcess=s;function r(a){let b=[],n=!1;const t=function(l){if(n){b.push(l);return}(!a.send(l,o=>{if(o&&console.error(o),n=!1,b.length>0){const h=b.slice(0);b=[],h.forEach(u=>t(u))}})||k.isWindows)&&(n=!0)};return{send:t}}e.createQueuedSender=r;var m;(function(a){async function b(n,t,l){if(i.isAbsolute(n))return n;if(t===void 0&&(t=_.cwd()),i.dirname(n)!=="."||(l===void 0&&T.isString(_.env.PATH)&&(l=_.env.PATH.split(i.delimiter)),l===void 0||l.length===0))return i.join(t,n);async function o(h){if(await c.Promises.exists(h)){let u;try{u=await c.Promises.stat(h)}catch(E){E.message.startsWith("EACCES")&&(u=await c.Promises.lstat(h))}return u?!u.isDirectory():!1}return!1}for(let h of l){let u;if(i.isAbsolute(h)?u=i.join(h,n):u=i.join(t,h,n),await o(u))return u;let E=u+".com";if(await o(E)||(E=u+".exe",await o(E)))return E}return i.join(t,n)}a.findExecutable=b})(m=e.win32||(e.win32={}))}),define(fe[155],me([19,20]),function(Y,e){return Y.create("vs/editor/common/config/editorOptions",e)}),define(fe[114],me([0,1,155,12,110]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var C;(function(J){J[J.None=0]="None",J[J.Keep=1]="Keep",J[J.Brackets=2]="Brackets",J[J.Advanced=3]="Advanced",J[J.Full=4]="Full"})(C=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class i{constructor(ne){this._values=ne}hasChanged(ne){return this._values[ne]}}e.ConfigurationChangedEvent=i;class k{constructor(){this._values=[]}_read(ne){return this._values[ne]}get(ne){return this._values[ne]}_write(ne,_e){this._values[ne]=_e}}e.ValidatedEditorOptions=k;class _{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=_;class D{constructor(ne,_e,Qe,et){this.id=ne,this.name=_e,this.defaultValue=Qe,this.schema=et}compute(ne,_e,Qe){return Qe}}class T{constructor(ne,_e=null){this.schema=void 0,this.id=ne,this.name="_never_",this.defaultValue=void 0,this.deps=_e}validate(ne){return this.defaultValue}}class I{constructor(ne,_e,Qe,et){this.id=ne,this.name=_e,this.defaultValue=Qe,this.schema=et}validate(ne){return typeof ne=="undefined"?this.defaultValue:ne}compute(ne,_e,Qe){return Qe}}function c(J,ne){return typeof J=="undefined"?ne:J==="false"?!1:Boolean(J)}e.boolean=c;class p extends I{constructor(ne,_e,Qe,et=void 0){typeof et!="undefined"&&(et.type="boolean",et.default=Qe),super(ne,_e,Qe,et)}validate(ne){return c(ne,this.defaultValue)}}function f(J,ne,_e,Qe){if(typeof J=="undefined")return ne;let et=parseInt(J,10);return isNaN(et)?ne:(et=Math.max(_e,et),et=Math.min(Qe,et),et|0)}e.clampedInt=f;class v extends I{constructor(ne,_e,Qe,et,ce,Ie=void 0){typeof Ie!="undefined"&&(Ie.type="integer",Ie.default=Qe,Ie.minimum=et,Ie.maximum=ce),super(ne,_e,Qe,Ie),this.minimum=et,this.maximum=ce}static clampedInt(ne,_e,Qe,et){return f(ne,_e,Qe,et)}validate(ne){return v.clampedInt(ne,this.defaultValue,this.minimum,this.maximum)}}class S extends I{constructor(ne,_e,Qe,et,ce){typeof ce!="undefined"&&(ce.type="number",ce.default=Qe),super(ne,_e,Qe,ce),this.validationFn=et}static clamp(ne,_e,Qe){return ne<_e?_e:ne>Qe?Qe:ne}static float(ne,_e){if(typeof ne=="number")return ne;if(typeof ne=="undefined")return _e;const Qe=parseFloat(ne);return isNaN(Qe)?_e:Qe}validate(ne){return this.validationFn(S.float(ne,this.defaultValue))}}class P extends I{static string(ne,_e){return typeof ne!="string"?_e:ne}constructor(ne,_e,Qe,et=void 0){typeof et!="undefined"&&(et.type="string",et.default=Qe),super(ne,_e,Qe,et)}validate(ne){return P.string(ne,this.defaultValue)}}function w(J,ne,_e){return typeof J!="string"||_e.indexOf(J)===-1?ne:J}e.stringSet=w;class s extends I{constructor(ne,_e,Qe,et,ce=void 0){typeof ce!="undefined"&&(ce.type="string",ce.enum=et,ce.default=Qe),super(ne,_e,Qe,ce),this._allowedValues=et}validate(ne){return w(ne,this.defaultValue,this._allowedValues)}}class r extends D{constructor(ne,_e,Qe,et,ce,Ie,Ue=void 0){typeof Ue!="undefined"&&(Ue.type="string",Ue.enum=ce,Ue.default=et),super(ne,_e,Qe,Ue),this._allowedValues=ce,this._convert=Ie}validate(ne){return typeof ne!="string"?this.defaultValue:this._allowedValues.indexOf(ne)===-1?this.defaultValue:this._convert(ne)}}function m(J){switch(J){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class a extends D{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[g.localize(0,null),g.localize(1,null),g.localize(2,null)],default:"auto",description:g.localize(3,null)})}validate(ne){switch(ne){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ne,_e,Qe){return Qe===0?ne.accessibilitySupport:Qe}}class b extends D{constructor(){const ne={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",ne,{"editor.comments.insertSpace":{type:"boolean",default:ne.insertSpace,description:g.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ne.ignoreEmptyLines,description:g.localize(5,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const _e=ne;return{insertSpace:c(_e.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:c(_e.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var n;(function(J){J[J.Hidden=0]="Hidden",J[J.Blink=1]="Blink",J[J.Smooth=2]="Smooth",J[J.Phase=3]="Phase",J[J.Expand=4]="Expand",J[J.Solid=5]="Solid"})(n=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function t(J){switch(J){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var l;(function(J){J[J.Line=1]="Line",J[J.Block=2]="Block",J[J.Underline=3]="Underline",J[J.LineThin=4]="LineThin",J[J.BlockOutline=5]="BlockOutline",J[J.UnderlineThin=6]="UnderlineThin"})(l=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function d(J){switch(J){case l.Line:return"line";case l.Block:return"block";case l.Underline:return"underline";case l.LineThin:return"line-thin";case l.BlockOutline:return"block-outline";case l.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=d;function o(J){switch(J){case"line":return l.Line;case"block":return l.Block;case"underline":return l.Underline;case"line-thin":return l.LineThin;case"block-outline":return l.BlockOutline;case"underline-thin":return l.UnderlineThin}}class h extends T{constructor(){super(126,[65,33])}compute(ne,_e,Qe){const et=["monaco-editor"];return _e.get(33)&&et.push(_e.get(33)),ne.extraEditorClassName&&et.push(ne.extraEditorClassName),_e.get(65)==="default"?et.push("mouse-default"):_e.get(65)==="copy"&&et.push("mouse-copy"),_e.get(99)&&et.push("showUnused"),_e.get(124)&&et.push("showDeprecated"),et.join(" ")}}class u extends p{constructor(){super(32,"emptySelectionClipboard",!0,{description:g.localize(6,null)})}compute(ne,_e,Qe){return Qe&&ne.emptySelectionClipboard}}class E extends D{constructor(){const ne={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",ne,{"editor.find.cursorMoveOnType":{type:"boolean",default:ne.cursorMoveOnType,description:g.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ne.seedSearchStringFromSelection,enumDescriptions:[g.localize(8,null),g.localize(9,null),g.localize(10,null)],description:g.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ne.autoFindInSelection,enumDescriptions:[g.localize(12,null),g.localize(13,null),g.localize(14,null)],description:g.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ne.globalFindClipboard,description:g.localize(16,null),included:L.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ne.addExtraSpaceOnTop,description:g.localize(17,null)},"editor.find.loop":{type:"boolean",default:ne.loop,description:g.localize(18,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const _e=ne;return{cursorMoveOnType:c(_e.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ne.seedSearchStringFromSelection=="boolean"?ne.seedSearchStringFromSelection?"always":"never":w(_e.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ne.autoFindInSelection=="boolean"?ne.autoFindInSelection?"always":"never":w(_e.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:c(_e.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:c(_e.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:c(_e.loop,this.defaultValue.loop)}}}class A extends D{constructor(){super(44,"fontLigatures",A.OFF,{anyOf:[{type:"boolean",description:g.localize(19,null)},{type:"string",description:g.localize(20,null)}],description:g.localize(21,null),default:!1})}validate(ne){return typeof ne=="undefined"?this.defaultValue:typeof ne=="string"?ne==="false"?A.OFF:ne==="true"?A.ON:ne:Boolean(ne)?A.ON:A.OFF}}e.EditorFontLigatures=A,A.OFF='"liga" off, "calt" off',A.ON='"liga" on, "calt" on';class R extends T{constructor(){super(43)}compute(ne,_e,Qe){return ne.fontInfo}}class B extends I{constructor(){super(45,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:g.localize(22,null)})}validate(ne){let _e=S.float(ne,this.defaultValue);return _e===0?e.EDITOR_FONT_DEFAULTS.fontSize:S.clamp(_e,6,100)}compute(ne,_e,Qe){return ne.fontInfo.fontSize}}class x extends D{constructor(){super(46,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:x.MINIMUM_VALUE,maximum:x.MAXIMUM_VALUE,errorMessage:g.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:x.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:g.localize(24,null)})}validate(ne){return ne==="normal"||ne==="bold"?ne:String(v.clampedInt(ne,e.EDITOR_FONT_DEFAULTS.fontWeight,x.MINIMUM_VALUE,x.MAXIMUM_VALUE))}}x.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],x.MINIMUM_VALUE=1,x.MAXIMUM_VALUE=1e3;class F extends D{constructor(){const ne={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},_e={type:"string",enum:["peek","gotoAndPeek","goto"],default:ne.multiple,enumDescriptions:[g.localize(25,null),g.localize(26,null),g.localize(27,null)]},Qe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(50,"gotoLocation",ne,{"editor.gotoLocation.multiple":{deprecationMessage:g.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:g.localize(29,null),..._e},"editor.gotoLocation.multipleTypeDefinitions":{description:g.localize(30,null),..._e},"editor.gotoLocation.multipleDeclarations":{description:g.localize(31,null),..._e},"editor.gotoLocation.multipleImplementations":{description:g.localize(32,null),..._e},"editor.gotoLocation.multipleReferences":{description:g.localize(33,null),..._e},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ne.alternativeDefinitionCommand,enum:Qe,description:g.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ne.alternativeTypeDefinitionCommand,enum:Qe,description:g.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ne.alternativeDeclarationCommand,enum:Qe,description:g.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ne.alternativeImplementationCommand,enum:Qe,description:g.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ne.alternativeReferenceCommand,enum:Qe,description:g.localize(38,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const _e=ne;return{multiple:w(_e.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:_e.multipleDefinitions??w(_e.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:_e.multipleTypeDefinitions??w(_e.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:_e.multipleDeclarations??w(_e.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:_e.multipleImplementations??w(_e.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:_e.multipleReferences??w(_e.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:P.string(_e.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:P.string(_e.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:P.string(_e.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:P.string(_e.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:P.string(_e.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class $ extends D{constructor(){const ne={enabled:!0,delay:300,sticky:!0,above:!0};super(52,"hover",ne,{"editor.hover.enabled":{type:"boolean",default:ne.enabled,description:g.localize(39,null)},"editor.hover.delay":{type:"number",default:ne.delay,description:g.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:ne.sticky,description:g.localize(41,null)},"editor.hover.above":{type:"boolean",default:ne.above,description:g.localize(42,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const _e=ne;return{enabled:c(_e.enabled,this.defaultValue.enabled),delay:v.clampedInt(_e.delay,this.defaultValue.delay,0,1e4),sticky:c(_e.sticky,this.defaultValue.sticky),above:c(_e.above,this.defaultValue.above)}}}var M;(function(J){J[J.None=0]="None",J[J.Text=1]="Text",J[J.Blocks=2]="Blocks"})(M=e.RenderMinimap||(e.RenderMinimap={}));class H extends T{constructor(){super(129,[49,57,37,64,91,59,60,93,116,119,120,121,2])}compute(ne,_e,Qe){return H.computeLayout(_e,{memory:ne.memory,outerWidth:ne.outerWidth,outerHeight:ne.outerHeight,isDominatedByLongLines:ne.isDominatedByLongLines,lineHeight:ne.fontInfo.lineHeight,viewLineCount:ne.viewLineCount,lineNumbersDigitCount:ne.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ne.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ne.fontInfo.maxDigitWidth,pixelRatio:ne.pixelRatio})}static computeContainedMinimapLineCount(ne){const _e=ne.height/ne.lineHeight,Qe=ne.scrollBeyondLastLine?_e-1:0,et=(ne.viewLineCount+Qe)/(ne.pixelRatio*ne.height),ce=Math.floor(ne.viewLineCount/et);return{typicalViewportLineCount:_e,extraLinesBeyondLastLine:Qe,desiredRatio:et,minimapLineCount:ce}}static _computeMinimapLayout(ne,_e){const Qe=ne.outerWidth,et=ne.outerHeight,ce=ne.pixelRatio;if(!ne.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ce*et),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:et};const Ie=_e.stableMinimapLayoutInput,Ue=Ie&&ne.outerHeight===Ie.outerHeight&&ne.lineHeight===Ie.lineHeight&&ne.typicalHalfwidthCharacterWidth===Ie.typicalHalfwidthCharacterWidth&&ne.pixelRatio===Ie.pixelRatio&&ne.scrollBeyondLastLine===Ie.scrollBeyondLastLine&&ne.minimap.enabled===Ie.minimap.enabled&&ne.minimap.side===Ie.minimap.side&&ne.minimap.size===Ie.minimap.size&&ne.minimap.showSlider===Ie.minimap.showSlider&&ne.minimap.renderCharacters===Ie.minimap.renderCharacters&&ne.minimap.maxColumn===Ie.minimap.maxColumn&&ne.minimap.scale===Ie.minimap.scale&&ne.verticalScrollbarWidth===Ie.verticalScrollbarWidth&&ne.isViewportWrapping===Ie.isViewportWrapping,Xe=ne.lineHeight,nt=ne.typicalHalfwidthCharacterWidth,ft=ne.scrollBeyondLastLine,tt=ne.minimap.renderCharacters;let ut=ce>=2?Math.round(ne.minimap.scale*2):ne.minimap.scale;const Re=ne.minimap.maxColumn,ve=ne.minimap.size,Te=ne.minimap.side,se=ne.verticalScrollbarWidth,ue=ne.viewLineCount,be=ne.remainingWidth,we=ne.isViewportWrapping,Fe=tt?2:3;let qe=Math.floor(ce*et);const ze=qe/ce;let Ye=!1,ct=!1,xe=Fe*ut,ge=ut/ce,Ee=1;if(ve==="fill"||ve==="fit"){const{typicalViewportLineCount:mt,extraLinesBeyondLastLine:yt,desiredRatio:_t,minimapLineCount:gt}=H.computeContainedMinimapLineCount({viewLineCount:ue,scrollBeyondLastLine:ft,height:et,lineHeight:Xe,pixelRatio:ce});if(ue/gt>1)Ye=!0,ct=!0,ut=1,xe=1,ge=ut/ce;else{let vt=!1,Tt=ut+1;if(ve==="fit"){const Dt=Math.ceil((ue+yt)*xe);we&&Ue&&be<=_e.stableFitRemainingWidth?(vt=!0,Tt=_e.stableFitMaxMinimapScale):vt=Dt>qe}if(ve==="fill"||vt){Ye=!0;const Dt=ut;xe=Math.min(Xe*ce,Math.max(1,Math.floor(1/_t))),we&&Ue&&be<=_e.stableFitRemainingWidth&&(Tt=_e.stableFitMaxMinimapScale),ut=Math.min(Tt,Math.max(1,Math.floor(xe/Fe))),ut>Dt&&(Ee=Math.min(2,ut/Dt)),ge=ut/ce/Ee,qe=Math.ceil(Math.max(mt,ue+yt)*xe),we?(_e.stableMinimapLayoutInput=ne,_e.stableFitRemainingWidth=be,_e.stableFitMaxMinimapScale=ut):(_e.stableMinimapLayoutInput=null,_e.stableFitRemainingWidth=0)}}}const ae=Math.floor(Re*ge),K=Math.min(ae,Math.max(0,Math.floor((be-se-2)*ge/(nt+ge)))+e.MINIMAP_GUTTER_WIDTH);let Ce=Math.floor(ce*K);const Le=Ce/ce;Ce=Math.floor(Ce*Ee);const it=tt?1:2,Ge=Te==="left"?0:Qe-K-se;return{renderMinimap:it,minimapLeft:Ge,minimapWidth:K,minimapHeightIsEditorHeight:Ye,minimapIsSampling:ct,minimapScale:ut,minimapLineHeight:xe,minimapCanvasInnerWidth:Ce,minimapCanvasInnerHeight:qe,minimapCanvasOuterWidth:Le,minimapCanvasOuterHeight:ze}}static computeLayout(ne,_e){const Qe=_e.outerWidth|0,et=_e.outerHeight|0,ce=_e.lineHeight|0,Ie=_e.lineNumbersDigitCount|0,Ue=_e.typicalHalfwidthCharacterWidth,Xe=_e.maxDigitWidth,nt=_e.pixelRatio,ft=_e.viewLineCount,tt=ne.get(121),ut=tt==="inherit"?ne.get(120):tt,Re=ut==="inherit"?ne.get(116):ut,ve=ne.get(119),Te=ne.get(2),se=_e.isDominatedByLongLines,ue=ne.get(49),be=ne.get(59).renderType!==0,we=ne.get(60),Fe=ne.get(93),qe=ne.get(64),ze=ne.get(91),Ye=ze.verticalScrollbarSize,ct=ze.verticalHasArrows,xe=ze.arrowSize,ge=ze.horizontalScrollbarSize,Ee=ne.get(57),ae=ne.get(37);let K;if(typeof Ee=="string"&&/^\d+(\.\d+)?ch$/.test(Ee)){const kt=parseFloat(Ee.substr(0,Ee.length-2));K=v.clampedInt(kt*Ue,0,0,1e3)}else K=v.clampedInt(Ee,0,0,1e3);ae&&(K+=16);let Ce=0;if(be){const kt=Math.max(Ie,we);Ce=Math.round(kt*Xe)}let Le=0;ue&&(Le=ce);let it=0,Ge=it+Le,mt=Ge+Ce,yt=mt+K;const _t=Qe-Le-Ce-K;let gt=!1,bt=!1,vt=-1;Te!==2&&(ut==="inherit"&&se?(gt=!0,bt=!0):Re==="on"||Re==="bounded"?bt=!0:Re==="wordWrapColumn"&&(vt=ve));const Tt=H._computeMinimapLayout({outerWidth:Qe,outerHeight:et,lineHeight:ce,typicalHalfwidthCharacterWidth:Ue,pixelRatio:nt,scrollBeyondLastLine:Fe,minimap:qe,verticalScrollbarWidth:Ye,viewLineCount:ft,remainingWidth:_t,isViewportWrapping:bt},_e.memory||new _);Tt.renderMinimap!==0&&Tt.minimapLeft===0&&(it+=Tt.minimapWidth,Ge+=Tt.minimapWidth,mt+=Tt.minimapWidth,yt+=Tt.minimapWidth);const Dt=_t-Tt.minimapWidth,Bt=Math.max(1,Math.floor((Dt-Ye-2)/Ue)),Vt=ct?xe:0;return bt&&(vt=Math.max(1,Bt),Re==="bounded"&&(vt=Math.min(vt,ve))),{width:Qe,height:et,glyphMarginLeft:it,glyphMarginWidth:Le,lineNumbersLeft:Ge,lineNumbersWidth:Ce,decorationsLeft:mt,decorationsWidth:K,contentLeft:yt,contentWidth:Dt,minimap:Tt,viewportColumn:Bt,isWordWrapMinified:gt,isViewportWrapping:bt,wrappingColumn:vt,verticalScrollbarWidth:Ye,horizontalScrollbarHeight:ge,overviewRuler:{top:Vt,width:Ye,height:et-2*Vt,right:0}}}}e.EditorLayoutInfoComputer=H;class N extends D{constructor(){const ne={enabled:!0};super(56,"lightbulb",ne,{"editor.lightbulb.enabled":{type:"boolean",default:ne.enabled,description:g.localize(43,null)}})}validate(ne){return!ne||typeof ne!="object"?this.defaultValue:{enabled:c(ne.enabled,this.defaultValue.enabled)}}}class U extends D{constructor(){const ne={enabled:!0,fontSize:0,fontFamily:""};super(125,"inlayHints",ne,{"editor.inlayHints.enabled":{type:"boolean",default:ne.enabled,description:g.localize(44,null)},"editor.inlayHints.fontSize":{type:"number",default:ne.fontSize,markdownDescription:g.localize(45,null)},"editor.inlayHints.fontFamily":{type:"string",default:ne.fontFamily,markdownDescription:g.localize(46,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const _e=ne;return{enabled:c(_e.enabled,this.defaultValue.enabled),fontSize:v.clampedInt(_e.fontSize,this.defaultValue.fontSize,0,100),fontFamily:P.string(_e.fontFamily,this.defaultValue.fontFamily)}}}class V extends S{constructor(){super(58,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ne=>S.clamp(ne,0,150),{markdownDescription:g.localize(47,null)})}compute(ne,_e,Qe){return ne.fontInfo.lineHeight}}class O extends D{constructor(){const ne={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(64,"minimap",ne,{"editor.minimap.enabled":{type:"boolean",default:ne.enabled,description:g.localize(48,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[g.localize(49,null),g.localize(50,null),g.localize(51,null)],default:ne.size,description:g.localize(52,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ne.side,description:g.localize(53,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ne.showSlider,description:g.localize(54,null)},"editor.minimap.scale":{type:"number",default:ne.scale,minimum:1,maximum:3,enum:[1,2,3],description:g.localize(55,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ne.renderCharacters,description:g.localize(56,null)},"editor.minimap.maxColumn":{type:"number",default:ne.maxColumn,description:g.localize(57,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const _e=ne;return{enabled:c(_e.enabled,this.defaultValue.enabled),size:w(_e.size,this.defaultValue.size,["proportional","fill","fit"]),side:w(_e.side,this.defaultValue.side,["right","left"]),showSlider:w(_e.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:c(_e.renderCharacters,this.defaultValue.renderCharacters),scale:v.clampedInt(_e.scale,1,1,3),maxColumn:v.clampedInt(_e.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function W(J){return J==="ctrlCmd"?L.isMacintosh?"metaKey":"ctrlKey":"altKey"}class j extends D{constructor(){super(74,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(58,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(59,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const _e=ne;return{top:v.clampedInt(_e.top,0,0,1e3),bottom:v.clampedInt(_e.bottom,0,0,1e3)}}}class X extends D{constructor(){const ne={enabled:!0,cycle:!1};super(75,"parameterHints",ne,{"editor.parameterHints.enabled":{type:"boolean",default:ne.enabled,description:g.localize(60,null)},"editor.parameterHints.cycle":{type:"boolean",default:ne.cycle,description:g.localize(61,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const _e=ne;return{enabled:c(_e.enabled,this.defaultValue.enabled),cycle:c(_e.cycle,this.defaultValue.cycle)}}}class Q extends T{constructor(){super(127)}compute(ne,_e,Qe){return ne.pixelRatio}}class de extends D{constructor(){const ne={other:!0,comments:!1,strings:!1};super(78,"quickSuggestions",ne,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:ne.strings,description:g.localize(62,null)},comments:{type:"boolean",default:ne.comments,description:g.localize(63,null)},other:{type:"boolean",default:ne.other,description:g.localize(64,null)}}}],default:ne,description:g.localize(65,null)});this.defaultValue=ne}validate(ne){if(typeof ne=="boolean")return ne;if(ne&&typeof ne=="object"){const _e=ne,Qe={other:c(_e.other,this.defaultValue.other),comments:c(_e.comments,this.defaultValue.comments),strings:c(_e.strings,this.defaultValue.strings)};return Qe.other&&Qe.comments&&Qe.strings?!0:!Qe.other&&!Qe.comments&&!Qe.strings?!1:Qe}return this.defaultValue}}var Se;(function(J){J[J.Off=0]="Off",J[J.On=1]="On",J[J.Relative=2]="Relative",J[J.Interval=3]="Interval",J[J.Custom=4]="Custom"})(Se=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class De extends D{constructor(){super(59,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[g.localize(66,null),g.localize(67,null),g.localize(68,null),g.localize(69,null)],default:"on",description:g.localize(70,null)})}validate(ne){let _e=this.defaultValue.renderType,Qe=this.defaultValue.renderFn;return typeof ne!="undefined"&&(typeof ne=="function"?(_e=4,Qe=ne):ne==="interval"?_e=3:ne==="relative"?_e=2:ne==="on"?_e=1:_e=0),{renderType:_e,renderFn:Qe}}}function Pe(J){const ne=J.get(86);return ne==="editable"?J.get(80):ne!=="on"}e.filterValidationDecorations=Pe;class Be extends D{constructor(){const ne=[],_e={type:"number",description:g.localize(71,null)};super(90,"rulers",ne,{type:"array",items:{anyOf:[_e,{type:["object"],properties:{column:_e,color:{type:"string",description:g.localize(72,null),format:"color-hex"}}}]},default:ne,description:g.localize(73,null)})}validate(ne){if(Array.isArray(ne)){let _e=[];for(let Qe of ne)if(typeof Qe=="number")_e.push({column:v.clampedInt(Qe,0,0,1e4),color:null});else if(Qe&&typeof Qe=="object"){const et=Qe;_e.push({column:v.clampedInt(et.column,0,0,1e4),color:et.color})}return _e.sort((Qe,et)=>Qe.column-et.column),_e}return this.defaultValue}}function We(J,ne){if(typeof J!="string")return ne;switch(J){case"hidden":return 2;case"visible":return 3;default:return 1}}class He extends D{constructor(){const ne={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(91,"scrollbar",ne,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[g.localize(74,null),g.localize(75,null),g.localize(76,null)],default:"auto",description:g.localize(77,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[g.localize(78,null),g.localize(79,null),g.localize(80,null)],default:"auto",description:g.localize(81,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ne.verticalScrollbarSize,description:g.localize(82,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ne.horizontalScrollbarSize,description:g.localize(83,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ne.scrollByPage,description:g.localize(84,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const _e=ne,Qe=v.clampedInt(_e.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),et=v.clampedInt(_e.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:v.clampedInt(_e.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:We(_e.vertical,this.defaultValue.vertical),horizontal:We(_e.horizontal,this.defaultValue.horizontal),useShadows:c(_e.useShadows,this.defaultValue.useShadows),verticalHasArrows:c(_e.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:c(_e.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:c(_e.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:c(_e.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Qe,horizontalSliderSize:v.clampedInt(_e.horizontalSliderSize,Qe,0,1e3),verticalScrollbarSize:et,verticalSliderSize:v.clampedInt(_e.verticalSliderSize,et,0,1e3),scrollByPage:c(_e.scrollByPage,this.defaultValue.scrollByPage)}}}class G extends D{constructor(){const ne={enabled:!0,mode:"subwordSmart"};super(54,"inlineSuggest",ne,{"editor.inlineSuggest.enabled":{type:"boolean",default:ne.enabled,description:g.localize(85,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const _e=ne;return{enabled:c(_e.enabled,this.defaultValue.enabled),mode:w(_e.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class ee extends D{constructor(){const ne={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",ne,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ne.enabled,description:g.localize(86,null)}})}validate(ne){return!ne||typeof ne!="object"?this.defaultValue:{enabled:c(ne.enabled,this.defaultValue.enabled)}}}class ie extends D{constructor(){const ne={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",ne,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[g.localize(87,null),g.localize(88,null),g.localize(89,null)],default:ne.bracketPairs,description:g.localize(90,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[g.localize(91,null),g.localize(92,null),g.localize(93,null)],default:ne.bracketPairsHorizontal,description:g.localize(94,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ne.highlightActiveBracketPair,description:g.localize(95,null)},"editor.guides.indentation":{type:"boolean",default:ne.indentation,description:g.localize(96,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:ne.highlightActiveIndentation,description:g.localize(97,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const _e=ne;return{bracketPairs:le(_e.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:le(_e.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:c(_e.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:c(_e.indentation,this.defaultValue.indentation),highlightActiveIndentation:c(_e.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}function le(J,ne,_e){const Qe=_e.indexOf(J);return Qe===-1?ne:_e[Qe]}class Z extends D{constructor(){const ne={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(105,"suggest",ne,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[g.localize(98,null),g.localize(99,null)],default:ne.insertMode,description:g.localize(100,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ne.filterGraceful,description:g.localize(101,null)},"editor.suggest.localityBonus":{type:"boolean",default:ne.localityBonus,description:g.localize(102,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ne.shareSuggestSelections,markdownDescription:g.localize(103,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ne.snippetsPreventQuickSuggestions,description:g.localize(104,null)},"editor.suggest.showIcons":{type:"boolean",default:ne.showIcons,description:g.localize(105,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ne.showStatusBar,description:g.localize(106,null)},"editor.suggest.preview":{type:"boolean",default:ne.preview,description:g.localize(107,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ne.showInlineDetails,description:g.localize(108,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:g.localize(109,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:g.localize(110,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:g.localize(111,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:g.localize(112,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:g.localize(113,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:g.localize(114,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:g.localize(115,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:g.localize(116,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:g.localize(117,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:g.localize(118,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:g.localize(119,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:g.localize(120,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:g.localize(121,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:g.localize(122,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:g.localize(123,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:g.localize(124,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:g.localize(125,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:g.localize(126,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:g.localize(127,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:g.localize(128,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:g.localize(129,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:g.localize(130,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:g.localize(131,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:g.localize(132,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:g.localize(133,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:g.localize(134,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:g.localize(135,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:g.localize(136,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:g.localize(137,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:g.localize(138,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:g.localize(139,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const _e=ne;return{insertMode:w(_e.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:c(_e.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:c(_e.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:c(_e.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:c(_e.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:c(_e.showIcons,this.defaultValue.showIcons),showStatusBar:c(_e.showStatusBar,this.defaultValue.showStatusBar),preview:c(_e.preview,this.defaultValue.preview),previewMode:w(_e.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:c(_e.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:c(_e.showMethods,this.defaultValue.showMethods),showFunctions:c(_e.showFunctions,this.defaultValue.showFunctions),showConstructors:c(_e.showConstructors,this.defaultValue.showConstructors),showDeprecated:c(_e.showDeprecated,this.defaultValue.showDeprecated),showFields:c(_e.showFields,this.defaultValue.showFields),showVariables:c(_e.showVariables,this.defaultValue.showVariables),showClasses:c(_e.showClasses,this.defaultValue.showClasses),showStructs:c(_e.showStructs,this.defaultValue.showStructs),showInterfaces:c(_e.showInterfaces,this.defaultValue.showInterfaces),showModules:c(_e.showModules,this.defaultValue.showModules),showProperties:c(_e.showProperties,this.defaultValue.showProperties),showEvents:c(_e.showEvents,this.defaultValue.showEvents),showOperators:c(_e.showOperators,this.defaultValue.showOperators),showUnits:c(_e.showUnits,this.defaultValue.showUnits),showValues:c(_e.showValues,this.defaultValue.showValues),showConstants:c(_e.showConstants,this.defaultValue.showConstants),showEnums:c(_e.showEnums,this.defaultValue.showEnums),showEnumMembers:c(_e.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:c(_e.showKeywords,this.defaultValue.showKeywords),showWords:c(_e.showWords,this.defaultValue.showWords),showColors:c(_e.showColors,this.defaultValue.showColors),showFiles:c(_e.showFiles,this.defaultValue.showFiles),showReferences:c(_e.showReferences,this.defaultValue.showReferences),showFolders:c(_e.showFolders,this.defaultValue.showFolders),showTypeParameters:c(_e.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:c(_e.showSnippets,this.defaultValue.showSnippets),showUsers:c(_e.showUsers,this.defaultValue.showUsers),showIssues:c(_e.showIssues,this.defaultValue.showIssues)}}}class re extends D{constructor(){super(101,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:g.localize(140,null),default:!0,type:"boolean"}})}validate(ne){return!ne||typeof ne!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:c(ne.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class pe extends T{constructor(){super(128,[80])}compute(ne,_e,Qe){return _e.get(80)?!0:ne.tabFocusMode}}var Me;(function(J){J[J.None=0]="None",J[J.Same=1]="Same",J[J.Indent=2]="Indent",J[J.DeepIndent=3]="DeepIndent"})(Me=e.WrappingIndent||(e.WrappingIndent={}));function je(J){switch(J){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class Ke extends T{constructor(){super(130,[129])}compute(ne,_e,Qe){const et=_e.get(129);return{isDominatedByLongLines:ne.isDominatedByLongLines,isWordWrapMinified:et.isWordWrapMinified,isViewportWrapping:et.isViewportWrapping,wrappingColumn:et.wrappingColumn}}}const Ze="Consolas, 'Courier New', monospace",rt="Menlo, Monaco, 'Courier New', monospace",lt="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:L.isMacintosh?rt:L.isLinux?lt:Ze,fontWeight:"normal",fontSize:L.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function ye(J){return e.editorOptionsRegistry[J.id]=J,J}var at;(function(J){J[J.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",J[J.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",J[J.accessibilitySupport=2]="accessibilitySupport",J[J.accessibilityPageSize=3]="accessibilityPageSize",J[J.ariaLabel=4]="ariaLabel",J[J.autoClosingBrackets=5]="autoClosingBrackets",J[J.autoClosingDelete=6]="autoClosingDelete",J[J.autoClosingOvertype=7]="autoClosingOvertype",J[J.autoClosingQuotes=8]="autoClosingQuotes",J[J.autoIndent=9]="autoIndent",J[J.automaticLayout=10]="automaticLayout",J[J.autoSurround=11]="autoSurround",J[J.bracketPairColorization=12]="bracketPairColorization",J[J.guides=13]="guides",J[J.codeLens=14]="codeLens",J[J.codeLensFontFamily=15]="codeLensFontFamily",J[J.codeLensFontSize=16]="codeLensFontSize",J[J.colorDecorators=17]="colorDecorators",J[J.columnSelection=18]="columnSelection",J[J.comments=19]="comments",J[J.contextmenu=20]="contextmenu",J[J.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",J[J.cursorBlinking=22]="cursorBlinking",J[J.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",J[J.cursorStyle=24]="cursorStyle",J[J.cursorSurroundingLines=25]="cursorSurroundingLines",J[J.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",J[J.cursorWidth=27]="cursorWidth",J[J.disableLayerHinting=28]="disableLayerHinting",J[J.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",J[J.domReadOnly=30]="domReadOnly",J[J.dragAndDrop=31]="dragAndDrop",J[J.emptySelectionClipboard=32]="emptySelectionClipboard",J[J.extraEditorClassName=33]="extraEditorClassName",J[J.fastScrollSensitivity=34]="fastScrollSensitivity",J[J.find=35]="find",J[J.fixedOverflowWidgets=36]="fixedOverflowWidgets",J[J.folding=37]="folding",J[J.foldingStrategy=38]="foldingStrategy",J[J.foldingHighlight=39]="foldingHighlight",J[J.foldingImportsByDefault=40]="foldingImportsByDefault",J[J.unfoldOnClickAfterEndOfLine=41]="unfoldOnClickAfterEndOfLine",J[J.fontFamily=42]="fontFamily",J[J.fontInfo=43]="fontInfo",J[J.fontLigatures=44]="fontLigatures",J[J.fontSize=45]="fontSize",J[J.fontWeight=46]="fontWeight",J[J.formatOnPaste=47]="formatOnPaste",J[J.formatOnType=48]="formatOnType",J[J.glyphMargin=49]="glyphMargin",J[J.gotoLocation=50]="gotoLocation",J[J.hideCursorInOverviewRuler=51]="hideCursorInOverviewRuler",J[J.hover=52]="hover",J[J.inDiffEditor=53]="inDiffEditor",J[J.inlineSuggest=54]="inlineSuggest",J[J.letterSpacing=55]="letterSpacing",J[J.lightbulb=56]="lightbulb",J[J.lineDecorationsWidth=57]="lineDecorationsWidth",J[J.lineHeight=58]="lineHeight",J[J.lineNumbers=59]="lineNumbers",J[J.lineNumbersMinChars=60]="lineNumbersMinChars",J[J.linkedEditing=61]="linkedEditing",J[J.links=62]="links",J[J.matchBrackets=63]="matchBrackets",J[J.minimap=64]="minimap",J[J.mouseStyle=65]="mouseStyle",J[J.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",J[J.mouseWheelZoom=67]="mouseWheelZoom",J[J.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",J[J.multiCursorModifier=69]="multiCursorModifier",J[J.multiCursorPaste=70]="multiCursorPaste",J[J.occurrencesHighlight=71]="occurrencesHighlight",J[J.overviewRulerBorder=72]="overviewRulerBorder",J[J.overviewRulerLanes=73]="overviewRulerLanes",J[J.padding=74]="padding",J[J.parameterHints=75]="parameterHints",J[J.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",J[J.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",J[J.quickSuggestions=78]="quickSuggestions",J[J.quickSuggestionsDelay=79]="quickSuggestionsDelay",J[J.readOnly=80]="readOnly",J[J.renameOnType=81]="renameOnType",J[J.renderControlCharacters=82]="renderControlCharacters",J[J.renderFinalNewline=83]="renderFinalNewline",J[J.renderLineHighlight=84]="renderLineHighlight",J[J.renderLineHighlightOnlyWhenFocus=85]="renderLineHighlightOnlyWhenFocus",J[J.renderValidationDecorations=86]="renderValidationDecorations",J[J.renderWhitespace=87]="renderWhitespace",J[J.revealHorizontalRightPadding=88]="revealHorizontalRightPadding",J[J.roundedSelection=89]="roundedSelection",J[J.rulers=90]="rulers",J[J.scrollbar=91]="scrollbar",J[J.scrollBeyondLastColumn=92]="scrollBeyondLastColumn",J[J.scrollBeyondLastLine=93]="scrollBeyondLastLine",J[J.scrollPredominantAxis=94]="scrollPredominantAxis",J[J.selectionClipboard=95]="selectionClipboard",J[J.selectionHighlight=96]="selectionHighlight",J[J.selectOnLineNumbers=97]="selectOnLineNumbers",J[J.showFoldingControls=98]="showFoldingControls",J[J.showUnused=99]="showUnused",J[J.snippetSuggestions=100]="snippetSuggestions",J[J.smartSelect=101]="smartSelect",J[J.smoothScrolling=102]="smoothScrolling",J[J.stickyTabStops=103]="stickyTabStops",J[J.stopRenderingLineAfter=104]="stopRenderingLineAfter",J[J.suggest=105]="suggest",J[J.suggestFontSize=106]="suggestFontSize",J[J.suggestLineHeight=107]="suggestLineHeight",J[J.suggestOnTriggerCharacters=108]="suggestOnTriggerCharacters",J[J.suggestSelection=109]="suggestSelection",J[J.tabCompletion=110]="tabCompletion",J[J.tabIndex=111]="tabIndex",J[J.unusualLineTerminators=112]="unusualLineTerminators",J[J.useShadowDOM=113]="useShadowDOM",J[J.useTabStops=114]="useTabStops",J[J.wordSeparators=115]="wordSeparators",J[J.wordWrap=116]="wordWrap",J[J.wordWrapBreakAfterCharacters=117]="wordWrapBreakAfterCharacters",J[J.wordWrapBreakBeforeCharacters=118]="wordWrapBreakBeforeCharacters",J[J.wordWrapColumn=119]="wordWrapColumn",J[J.wordWrapOverride1=120]="wordWrapOverride1",J[J.wordWrapOverride2=121]="wordWrapOverride2",J[J.wrappingIndent=122]="wrappingIndent",J[J.wrappingStrategy=123]="wrappingStrategy",J[J.showDeprecated=124]="showDeprecated",J[J.inlayHints=125]="inlayHints",J[J.editorClassName=126]="editorClassName",J[J.pixelRatio=127]="pixelRatio",J[J.tabFocusMode=128]="tabFocusMode",J[J.layoutInfo=129]="layoutInfo",J[J.wrappingInfo=130]="wrappingInfo"})(at=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ye(new p(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:g.localize(141,null)})),acceptSuggestionOnEnter:ye(new s(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",g.localize(142,null),""],markdownDescription:g.localize(143,null)})),accessibilitySupport:ye(new a),accessibilityPageSize:ye(new v(3,"accessibilityPageSize",10,1,1073741824,{description:g.localize(144,null)})),ariaLabel:ye(new P(4,"ariaLabel",g.localize(145,null))),autoClosingBrackets:ye(new s(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(146,null),g.localize(147,null),""],description:g.localize(148,null)})),autoClosingDelete:ye(new s(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",g.localize(149,null),""],description:g.localize(150,null)})),autoClosingOvertype:ye(new s(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",g.localize(151,null),""],description:g.localize(152,null)})),autoClosingQuotes:ye(new s(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(153,null),g.localize(154,null),""],description:g.localize(155,null)})),autoIndent:ye(new r(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],m,{enumDescriptions:[g.localize(156,null),g.localize(157,null),g.localize(158,null),g.localize(159,null),g.localize(160,null)],description:g.localize(161,null)})),automaticLayout:ye(new p(10,"automaticLayout",!1)),autoSurround:ye(new s(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[g.localize(162,null),g.localize(163,null),g.localize(164,null),""],description:g.localize(165,null)})),bracketPairColorization:ye(new ee),bracketPairGuides:ye(new ie),stickyTabStops:ye(new p(103,"stickyTabStops",!1,{description:g.localize(166,null)})),codeLens:ye(new p(14,"codeLens",!0,{description:g.localize(167,null)})),codeLensFontFamily:ye(new P(15,"codeLensFontFamily","",{description:g.localize(168,null)})),codeLensFontSize:ye(new v(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:g.localize(169,null)})),colorDecorators:ye(new p(17,"colorDecorators",!0,{description:g.localize(170,null)})),columnSelection:ye(new p(18,"columnSelection",!1,{description:g.localize(171,null)})),comments:ye(new b),contextmenu:ye(new p(20,"contextmenu",!0)),copyWithSyntaxHighlighting:ye(new p(21,"copyWithSyntaxHighlighting",!0,{description:g.localize(172,null)})),cursorBlinking:ye(new r(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],t,{description:g.localize(173,null)})),cursorSmoothCaretAnimation:ye(new p(23,"cursorSmoothCaretAnimation",!1,{description:g.localize(174,null)})),cursorStyle:ye(new r(24,"cursorStyle",l.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],o,{description:g.localize(175,null)})),cursorSurroundingLines:ye(new v(25,"cursorSurroundingLines",0,0,1073741824,{description:g.localize(176,null)})),cursorSurroundingLinesStyle:ye(new s(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[g.localize(177,null),g.localize(178,null)],description:g.localize(179,null)})),cursorWidth:ye(new v(27,"cursorWidth",0,0,1073741824,{markdownDescription:g.localize(180,null)})),disableLayerHinting:ye(new p(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:ye(new p(29,"disableMonospaceOptimizations",!1)),domReadOnly:ye(new p(30,"domReadOnly",!1)),dragAndDrop:ye(new p(31,"dragAndDrop",!0,{description:g.localize(181,null)})),emptySelectionClipboard:ye(new u),extraEditorClassName:ye(new P(33,"extraEditorClassName","")),fastScrollSensitivity:ye(new S(34,"fastScrollSensitivity",5,J=>J<=0?5:J,{markdownDescription:g.localize(182,null)})),find:ye(new E),fixedOverflowWidgets:ye(new p(36,"fixedOverflowWidgets",!1)),folding:ye(new p(37,"folding",!0,{description:g.localize(183,null)})),foldingStrategy:ye(new s(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[g.localize(184,null),g.localize(185,null)],description:g.localize(186,null)})),foldingHighlight:ye(new p(39,"foldingHighlight",!0,{description:g.localize(187,null)})),foldingImportsByDefault:ye(new p(40,"foldingImportsByDefault",!1,{description:g.localize(188,null)})),unfoldOnClickAfterEndOfLine:ye(new p(41,"unfoldOnClickAfterEndOfLine",!1,{description:g.localize(189,null)})),fontFamily:ye(new P(42,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:g.localize(190,null)})),fontInfo:ye(new R),fontLigatures2:ye(new A),fontSize:ye(new B),fontWeight:ye(new x),formatOnPaste:ye(new p(47,"formatOnPaste",!1,{description:g.localize(191,null)})),formatOnType:ye(new p(48,"formatOnType",!1,{description:g.localize(192,null)})),glyphMargin:ye(new p(49,"glyphMargin",!0,{description:g.localize(193,null)})),gotoLocation:ye(new F),hideCursorInOverviewRuler:ye(new p(51,"hideCursorInOverviewRuler",!1,{description:g.localize(194,null)})),hover:ye(new $),inDiffEditor:ye(new p(53,"inDiffEditor",!1)),letterSpacing:ye(new S(55,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,J=>S.clamp(J,-5,20),{description:g.localize(195,null)})),lightbulb:ye(new N),lineDecorationsWidth:ye(new I(57,"lineDecorationsWidth",10)),lineHeight:ye(new V),lineNumbers:ye(new De),lineNumbersMinChars:ye(new v(60,"lineNumbersMinChars",5,1,300)),linkedEditing:ye(new p(61,"linkedEditing",!1,{description:g.localize(196,null)})),links:ye(new p(62,"links",!0,{description:g.localize(197,null)})),matchBrackets:ye(new s(63,"matchBrackets","always",["always","near","never"],{description:g.localize(198,null)})),minimap:ye(new O),mouseStyle:ye(new s(65,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ye(new S(66,"mouseWheelScrollSensitivity",1,J=>J===0?1:J,{markdownDescription:g.localize(199,null)})),mouseWheelZoom:ye(new p(67,"mouseWheelZoom",!1,{markdownDescription:g.localize(200,null)})),multiCursorMergeOverlapping:ye(new p(68,"multiCursorMergeOverlapping",!0,{description:g.localize(201,null)})),multiCursorModifier:ye(new r(69,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],W,{markdownEnumDescriptions:[g.localize(202,null),g.localize(203,null)],markdownDescription:g.localize(204,null)})),multiCursorPaste:ye(new s(70,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[g.localize(205,null),g.localize(206,null)],markdownDescription:g.localize(207,null)})),occurrencesHighlight:ye(new p(71,"occurrencesHighlight",!0,{description:g.localize(208,null)})),overviewRulerBorder:ye(new p(72,"overviewRulerBorder",!0,{description:g.localize(209,null)})),overviewRulerLanes:ye(new v(73,"overviewRulerLanes",3,0,3)),padding:ye(new j),parameterHints:ye(new X),peekWidgetDefaultFocus:ye(new s(76,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[g.localize(210,null),g.localize(211,null)],description:g.localize(212,null)})),definitionLinkOpensInPeek:ye(new p(77,"definitionLinkOpensInPeek",!1,{description:g.localize(213,null)})),quickSuggestions:ye(new de),quickSuggestionsDelay:ye(new v(79,"quickSuggestionsDelay",10,0,1073741824,{description:g.localize(214,null)})),readOnly:ye(new p(80,"readOnly",!1)),renameOnType:ye(new p(81,"renameOnType",!1,{description:g.localize(215,null),markdownDeprecationMessage:g.localize(216,null)})),renderControlCharacters:ye(new p(82,"renderControlCharacters",!0,{description:g.localize(217,null),restricted:!0})),renderFinalNewline:ye(new p(83,"renderFinalNewline",!0,{description:g.localize(218,null)})),renderLineHighlight:ye(new s(84,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",g.localize(219,null)],description:g.localize(220,null)})),renderLineHighlightOnlyWhenFocus:ye(new p(85,"renderLineHighlightOnlyWhenFocus",!1,{description:g.localize(221,null)})),renderValidationDecorations:ye(new s(86,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ye(new s(87,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",g.localize(222,null),g.localize(223,null),g.localize(224,null),""],description:g.localize(225,null)})),revealHorizontalRightPadding:ye(new v(88,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:ye(new p(89,"roundedSelection",!0,{description:g.localize(226,null)})),rulers:ye(new Be),scrollbar:ye(new He),scrollBeyondLastColumn:ye(new v(92,"scrollBeyondLastColumn",5,0,1073741824,{description:g.localize(227,null)})),scrollBeyondLastLine:ye(new p(93,"scrollBeyondLastLine",!0,{description:g.localize(228,null)})),scrollPredominantAxis:ye(new p(94,"scrollPredominantAxis",!0,{description:g.localize(229,null)})),selectionClipboard:ye(new p(95,"selectionClipboard",!0,{description:g.localize(230,null),included:L.isLinux})),selectionHighlight:ye(new p(96,"selectionHighlight",!0,{description:g.localize(231,null)})),selectOnLineNumbers:ye(new p(97,"selectOnLineNumbers",!0)),showFoldingControls:ye(new s(98,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[g.localize(232,null),g.localize(233,null)],description:g.localize(234,null)})),showUnused:ye(new p(99,"showUnused",!0,{description:g.localize(235,null)})),showDeprecated:ye(new p(124,"showDeprecated",!0,{description:g.localize(236,null)})),inlayHints:ye(new U),snippetSuggestions:ye(new s(100,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[g.localize(237,null),g.localize(238,null),g.localize(239,null),g.localize(240,null)],description:g.localize(241,null)})),smartSelect:ye(new re),smoothScrolling:ye(new p(102,"smoothScrolling",!1,{description:g.localize(242,null)})),stopRenderingLineAfter:ye(new v(104,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ye(new Z),inlineSuggest:ye(new G),suggestFontSize:ye(new v(106,"suggestFontSize",0,0,1e3,{markdownDescription:g.localize(243,null)})),suggestLineHeight:ye(new v(107,"suggestLineHeight",0,0,1e3,{markdownDescription:g.localize(244,null)})),suggestOnTriggerCharacters:ye(new p(108,"suggestOnTriggerCharacters",!0,{description:g.localize(245,null)})),suggestSelection:ye(new s(109,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[g.localize(246,null),g.localize(247,null),g.localize(248,null)],description:g.localize(249,null)})),tabCompletion:ye(new s(110,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[g.localize(250,null),g.localize(251,null),g.localize(252,null)],description:g.localize(253,null)})),tabIndex:ye(new v(111,"tabIndex",0,-1,1073741824)),unusualLineTerminators:ye(new s(112,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[g.localize(254,null),g.localize(255,null),g.localize(256,null)],description:g.localize(257,null)})),useShadowDOM:ye(new p(113,"useShadowDOM",!0)),useTabStops:ye(new p(114,"useTabStops",!0,{description:g.localize(258,null)})),wordSeparators:ye(new P(115,"wordSeparators",y.USUAL_WORD_SEPARATORS,{description:g.localize(259,null)})),wordWrap:ye(new s(116,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[g.localize(260,null),g.localize(261,null),g.localize(262,null),g.localize(263,null)],description:g.localize(264,null)})),wordWrapBreakAfterCharacters:ye(new P(117,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ye(new P(118,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ye(new v(119,"wordWrapColumn",80,1,1073741824,{markdownDescription:g.localize(265,null)})),wordWrapOverride1:ye(new s(120,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ye(new s(121,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:ye(new r(122,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],je,{enumDescriptions:[g.localize(266,null),g.localize(267,null),g.localize(268,null),g.localize(269,null)],description:g.localize(270,null)})),wrappingStrategy:ye(new s(123,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[g.localize(271,null),g.localize(272,null)],description:g.localize(273,null)})),editorClassName:ye(new h),pixelRatio:ye(new Q),tabFocusMode:ye(new pe),layoutInfo:ye(new H),wrappingInfo:ye(new Ke)}}),define(fe[156],me([19,20]),function(Y,e){return Y.create("vs/platform/configuration/common/configurationRegistry",e)}),define(fe[157],me([19,20]),function(Y,e){return Y.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(fe[158],me([19,20]),function(Y,e){return Y.create("vs/platform/extensions/common/extensionValidator",e)}),define(fe[159],me([19,20]),function(Y,e){return Y.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(fe[160],me([19,20]),function(Y,e){return Y.create("vs/platform/files/common/files",e)}),define(fe[161],me([19,20]),function(Y,e){return Y.create("vs/platform/markers/common/markers",e)}),define(fe[162],me([19,20]),function(Y,e){return Y.create("vs/platform/theme/common/iconRegistry",e)}),define(fe[163],me([19,20]),function(Y,e){return Y.create("vs/platform/workspaces/common/workspaces",e)}),define(fe[164],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(fe[165],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostExtensionService",e)}),define(fe[166],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostProgress",e)}),define(fe[167],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostStatusBar",e)}),define(fe[168],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostTerminalService",e)}),define(fe[169],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostTreeViews",e)}),define(fe[170],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostWorkspace",e)}),define(fe[171],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/node/extHostDebugService",e)}),define(fe[172],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/node/extHostTunnelService",e)}),define(fe[173],me([19,20]),function(Y,e){return Y.create("vs/workbench/common/editor",e)}),define(fe[174],me([19,20]),function(Y,e){return Y.create("vs/workbench/common/views",e)}),define(fe[175],me([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(fe[176],me([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(fe[177],me([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(fe[178],me([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(fe[179],me([19,20]),function(Y,e){return Y.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(fe[180],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var g;(function(i){i[i.ACTIVATE=1]="ACTIVATE",i[i.RESTORE=2]="RESTORE",i[i.PRESERVE=3]="PRESERVE"})(g=e.EditorActivation||(e.EditorActivation={}));var L;(function(i){i[i.PICK=0]="PICK",i[i.DISABLED=1]="DISABLED",i[i.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(L=e.EditorResolution||(e.EditorResolution={}));var y;(function(i){i[i.API=0]="API",i[i.USER=1]="USER"})(y=e.EditorOpenContext||(e.EditorOpenContext={}));var C;(function(i){i[i.Center=0]="Center",i[i.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",i[i.NearTop=2]="NearTop",i[i.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(C=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(fe[181],me([0,1,158]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,y=/^-(\d{4})(\d{2})(\d{2})$/;function C(c){return c=c.trim(),c==="*"||L.test(c)}e.isValidVersionStr=C;function i(c){if(!C(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let p=c.match(L);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=i;function k(c){if(!c)return null;let p=c.majorBase,f=c.majorMustEqual,v=c.minorBase,S=c.minorMustEqual,P=c.patchBase,w=c.patchMustEqual;c.hasCaret&&(p===0||(S=!1),w=!1);let s=0;if(c.preRelease){const r=y.exec(c.preRelease);if(r){const[,m,a,b]=r;s=Date.UTC(Number(m),Number(a)-1,Number(b))}}return{majorBase:p,majorMustEqual:f,minorBase:v,minorMustEqual:S,patchBase:P,patchMustEqual:w,isMinimum:c.hasGreaterEquals,notBefore:s}}e.normalizeVersion=k;function _(c,p,f){let v;typeof c=="string"?v=k(i(c)):v=c;let S;p instanceof Date?S=p.getTime():typeof p=="string"&&(S=new Date(p).getTime());let P;if(typeof f=="string"?P=k(i(f)):P=f,!v||!P)return!1;let w=v.majorBase,s=v.minorBase,r=v.patchBase,m=P.majorBase,a=P.minorBase,b=P.patchBase,n=P.notBefore,t=P.majorMustEqual,l=P.minorMustEqual,d=P.patchMustEqual;return P.isMinimum?w>m?!0:w<m?!1:s>a?!0:s<a||S&&S<n?!1:r>=b:(w===1&&m===0&&(!t||!l||!d)&&(m=1,a=0,b=0,t=!0,l=!1,d=!1),w<m?!1:w>m?!t:s<a?!1:s>a?!l:r<b?!1:r>b?!d:!(S&&S<n))}e.isValidVersion=_;function D(c,p,f,v){return f.isBuiltin||typeof f.main=="undefined"?!0:I(c,p,f.engines.vscode,v)}e.isValidExtensionVersion=D;function T(c,p,f){return c==="*"||I(p,f,c)}e.isEngineValid=T;function I(c,p,f,v=[]){let S=k(i(f));if(!S)return v.push(g.localize(0,null,f)),!1;if(S.majorBase===0){if(!S.majorMustEqual||!S.minorMustEqual)return v.push(g.localize(1,null,f)),!1}else if(!S.majorMustEqual)return v.push(g.localize(2,null,f)),!1;return _(c,p,S)?!0:(v.push(g.localize(3,null,c,f)),!1)}}),define(fe[115],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class g{constructor(y,C=[],i=!1){this.ctor=y,this.staticArguments=C,this.supportsDelayedInstantiation=i}}e.SyncDescriptor=g}),define(fe[84],me([0,1,115]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const L=[];function y(i,k,_){k instanceof g.SyncDescriptor||(k=new g.SyncDescriptor(k,[],_)),L.push([i,k])}e.registerSingleton=y;function C(){return L}e.getSingletonServiceDescriptors=C}),define(fe[182],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class g{constructor(C){this.incoming=new Map,this.outgoing=new Map,this.data=C}}e.Node=g;class L{constructor(C){this._hashFn=C,this._nodes=new Map}roots(){const C=[];for(let i of this._nodes.values())i.outgoing.size===0&&C.push(i);return C}insertEdge(C,i){const k=this.lookupOrInsertNode(C),_=this.lookupOrInsertNode(i);k.outgoing.set(this._hashFn(i),_),_.incoming.set(this._hashFn(C),k)}removeNode(C){const i=this._hashFn(C);this._nodes.delete(i);for(let k of this._nodes.values())k.outgoing.delete(i),k.incoming.delete(i)}lookupOrInsertNode(C){const i=this._hashFn(C);let k=this._nodes.get(i);return k||(k=new g(C),this._nodes.set(i,k)),k}lookup(C){return this._nodes.get(this._hashFn(C))}isEmpty(){return this._nodes.size===0}toString(){let C=[];for(let[i,k]of this._nodes)C.push(`${i}, (incoming)[${[...k.incoming.keys()].join(", ")}], (outgoing)[${[...k.outgoing.keys()].join(",")}]`);return C.join(`
`)}findCycleSlow(){for(let[C,i]of this._nodes){const k=new Set([C]),_=this._findCycle(i,k);if(_)return _}}_findCycle(C,i){for(let[k,_]of C.outgoing){if(i.has(k))return[...i,k].join(" -> ");i.add(k);const D=this._findCycle(_,i);if(D)return D;i.delete(k)}}}e.Graph=L}),define(fe[4],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var g;(function(i){i.serviceIds=new Map,i.DI_TARGET="$di$target",i.DI_DEPENDENCIES="$di$dependencies";function k(_){return _[i.DI_DEPENDENCIES]||[]}i.getServiceDependencies=k})(g=e._util||(e._util={})),e.IInstantiationService=y("instantiationService");function L(i,k,_,D){k[g.DI_TARGET]===k?k[g.DI_DEPENDENCIES].push({id:i,index:_,optional:D}):(k[g.DI_DEPENDENCIES]=[{id:i,index:_,optional:D}],k[g.DI_TARGET]=k)}function y(i){if(g.serviceIds.has(i))return g.serviceIds.get(i);const k=function(_,D,T){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(k,_,T,!1)};return k.toString=()=>i,g.serviceIds.set(i,k),k}e.createDecorator=y;function C(i){return i}e.refineServiceDecorator=C}),define(fe[183],me([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,g.createDecorator)("modelService");function L(y){return!y.isTooLargeForSyncing()&&!y.isForSimpleWidget}e.shouldSynchronizeModel=L}),define(fe[184],me([0,1,3,49,6,24,79,83,183]),function(Y,e,g,L,y,C,i,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function D(v){return typeof v=="string"?!1:Array.isArray(v)?v.every(D):!!v.exclusive}class T{constructor(){this._clock=0,this._entries=[],this._onDidChange=new g.Emitter}get onDidChange(){return this._onDidChange.event}register(S,P){let w={selector:S,provider:P,_score:-1,_time:this._clock++};return this._entries.push(w),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,y.toDisposable)(()=>{if(w){let s=this._entries.indexOf(w);s>=0&&(this._entries.splice(s,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),w=void 0)}})}has(S){return this.all(S).length>0}all(S){if(!S)return[];this._updateScores(S);const P=[];for(let w of this._entries)w._score>0&&P.push(w.provider);return P}ordered(S){const P=[];return this._orderedForEach(S,w=>P.push(w.provider)),P}orderedGroups(S){const P=[];let w,s;return this._orderedForEach(S,r=>{w&&s===r._score?w.push(r.provider):(s=r._score,w=[r.provider],P.push(w))}),P}_orderedForEach(S,P){if(!!S){this._updateScores(S);for(const w of this._entries)w._score>0&&P(w)}}_updateScores(S){let P={uri:S.uri.toString(),language:S.getLanguageId()};if(!(this._lastCandidate&&this._lastCandidate.language===P.language&&this._lastCandidate.uri===P.uri)){this._lastCandidate=P;for(let w of this._entries)if(w._score=(0,k.score)(w.selector,S.uri,S.getLanguageId(),(0,_.shouldSynchronizeModel)(S)),D(w.selector)&&w._score>0){for(let s of this._entries)s._score=0;w._score=1e3;break}this._entries.sort(T._compareByScoreAndTime)}}static _compareByScoreAndTime(S,P){return S._score<P._score?1:S._score>P._score?-1:S._time<P._time?1:S._time>P._time?-1:0}}e.LanguageFeatureRegistry=T;const I=new WeakMap;let c=0;function p(v){let S=I.get(v);return S===void 0&&(S=++c,I.set(v,S)),S}class f{constructor(S,P,w=Number.MAX_SAFE_INTEGER){this._registry=S,this.min=P,this.max=w,this._cache=new C.LRUCache(50,.7)}_key(S){return S.id+this._registry.all(S).reduce((P,w)=>(0,L.doHash)(p(w),P),0)}_clamp(S){return S===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(S*1.3)))}get(S){const P=this._key(S),w=this._cache.get(P);return this._clamp(w?.value)}update(S,P){const w=this._key(S);let s=this._cache.get(w);return s||(s=new i.MovingAverage,this._cache.set(w,s)),s.update(P),this.get(S)}}e.LanguageFeatureRequestDelays=f}),define(fe[85],me([0,1,2,42,184,149,48]),function(Y,e,g,L,y,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var k;(function(u){u[u.Null=0]="Null",u[u.PlainText=1]="PlainText"})(k=e.LanguageId||(e.LanguageId={}));var _;(function(u){u[u.NotSet=-1]="NotSet",u[u.None=0]="None",u[u.Italic=1]="Italic",u[u.Bold=2]="Bold",u[u.Underline=4]="Underline"})(_=e.FontStyle||(e.FontStyle={}));var D;(function(u){u[u.None=0]="None",u[u.DefaultForeground=1]="DefaultForeground",u[u.DefaultBackground=2]="DefaultBackground"})(D=e.ColorId||(e.ColorId={}));var T;(function(u){u[u.Other=0]="Other",u[u.Comment=1]="Comment",u[u.String=2]="String",u[u.RegEx=4]="RegEx"})(T=e.StandardTokenType||(e.StandardTokenType={}));var I;(function(u){u[u.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",u[u.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",u[u.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",u[u.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",u[u.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",u[u.ITALIC_MASK=2048]="ITALIC_MASK",u[u.BOLD_MASK=4096]="BOLD_MASK",u[u.UNDERLINE_MASK=8192]="UNDERLINE_MASK",u[u.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",u[u.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",u[u.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",u[u.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",u[u.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",u[u.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",u[u.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",u[u.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",u[u.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",u[u.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(I=e.MetadataConsts||(e.MetadataConsts={}));class c{static getLanguageId(E){return(E&255)>>>0}static getTokenType(E){return(E&1792)>>>8}static getFontStyle(E){return(E&14336)>>>11}static getForeground(E){return(E&8372224)>>>14}static getBackground(E){return(E&4286578688)>>>23}static getClassNameFromMetadata(E){let A=this.getForeground(E),R="mtk"+A,B=this.getFontStyle(E);return B&1&&(R+=" mtki"),B&2&&(R+=" mtkb"),B&4&&(R+=" mtku"),R}static getInlineStyleFromMetadata(E,A){const R=this.getForeground(E),B=this.getFontStyle(E);let x=`color: ${A[R]};`;return B&1&&(x+="font-style: italic;"),B&2&&(x+="font-weight: bold;"),B&4&&(x+="text-decoration: underline;"),x}}e.TokenMetadata=c;var p;(function(u){u[u.Method=0]="Method",u[u.Function=1]="Function",u[u.Constructor=2]="Constructor",u[u.Field=3]="Field",u[u.Variable=4]="Variable",u[u.Class=5]="Class",u[u.Struct=6]="Struct",u[u.Interface=7]="Interface",u[u.Module=8]="Module",u[u.Property=9]="Property",u[u.Event=10]="Event",u[u.Operator=11]="Operator",u[u.Unit=12]="Unit",u[u.Value=13]="Value",u[u.Constant=14]="Constant",u[u.Enum=15]="Enum",u[u.EnumMember=16]="EnumMember",u[u.Keyword=17]="Keyword",u[u.Text=18]="Text",u[u.Color=19]="Color",u[u.File=20]="File",u[u.Reference=21]="Reference",u[u.Customcolor=22]="Customcolor",u[u.Folder=23]="Folder",u[u.TypeParameter=24]="TypeParameter",u[u.User=25]="User",u[u.Issue=26]="Issue",u[u.Snippet=27]="Snippet"})(p=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let u=Object.create(null);return u[0]="symbol-method",u[1]="symbol-function",u[2]="symbol-constructor",u[3]="symbol-field",u[4]="symbol-variable",u[5]="symbol-class",u[6]="symbol-struct",u[7]="symbol-interface",u[8]="symbol-module",u[9]="symbol-property",u[10]="symbol-event",u[11]="symbol-operator",u[12]="symbol-unit",u[13]="symbol-value",u[14]="symbol-constant",u[15]="symbol-enum",u[16]="symbol-enum-member",u[17]="symbol-keyword",u[27]="symbol-snippet",u[18]="symbol-text",u[19]="symbol-color",u[20]="symbol-file",u[21]="symbol-reference",u[22]="symbol-customcolor",u[23]="symbol-folder",u[24]="symbol-type-parameter",u[25]="account",u[26]="issues",function(E){const A=u[E];let R=A&&i.iconRegistry.get(A);return R||(console.info("No codicon found for CompletionItemKind "+E),R=i.Codicon.symbolProperty),R.classNames}}(),e.completionKindFromString=function(){let u=Object.create(null);return u.method=0,u.function=1,u.constructor=2,u.field=3,u.variable=4,u.class=5,u.struct=6,u.interface=7,u.module=8,u.property=9,u.event=10,u.operator=11,u.unit=12,u.value=13,u.constant=14,u.enum=15,u["enum-member"]=16,u.enumMember=16,u.keyword=17,u.snippet=27,u.text=18,u.color=19,u.file=20,u.reference=21,u.customcolor=22,u.folder=23,u["type-parameter"]=24,u.typeParameter=24,u.account=25,u.issue=26,function(E,A){let R=u[E];return typeof R=="undefined"&&!A&&(R=9),R}}();var f;(function(u){u[u.Deprecated=1]="Deprecated"})(f=e.CompletionItemTag||(e.CompletionItemTag={}));var v;(function(u){u[u.KeepWhitespace=1]="KeepWhitespace",u[u.InsertAsSnippet=4]="InsertAsSnippet"})(v=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var S;(function(u){u[u.Invoke=0]="Invoke",u[u.TriggerCharacter=1]="TriggerCharacter",u[u.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(S=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var P;(function(u){u[u.Automatic=0]="Automatic",u[u.Explicit=1]="Explicit"})(P=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var w;(function(u){u[u.Invoke=1]="Invoke",u[u.Auto=2]="Auto"})(w=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var s;(function(u){u[u.Invoke=1]="Invoke",u[u.TriggerCharacter=2]="TriggerCharacter",u[u.ContentChange=3]="ContentChange"})(s=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var r;(function(u){u[u.Text=0]="Text",u[u.Read=1]="Read",u[u.Write=2]="Write"})(r=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function m(u){return u&&g.URI.isUri(u.uri)&&L.Range.isIRange(u.range)&&(L.Range.isIRange(u.originSelectionRange)||L.Range.isIRange(u.targetSelectionRange))}e.isLocationLink=m;var a;(function(u){u[u.File=0]="File",u[u.Module=1]="Module",u[u.Namespace=2]="Namespace",u[u.Package=3]="Package",u[u.Class=4]="Class",u[u.Method=5]="Method",u[u.Property=6]="Property",u[u.Field=7]="Field",u[u.Constructor=8]="Constructor",u[u.Enum=9]="Enum",u[u.Interface=10]="Interface",u[u.Function=11]="Function",u[u.Variable=12]="Variable",u[u.Constant=13]="Constant",u[u.String=14]="String",u[u.Number=15]="Number",u[u.Boolean=16]="Boolean",u[u.Array=17]="Array",u[u.Object=18]="Object",u[u.Key=19]="Key",u[u.Null=20]="Null",u[u.EnumMember=21]="EnumMember",u[u.Struct=22]="Struct",u[u.Event=23]="Event",u[u.Operator=24]="Operator",u[u.TypeParameter=25]="TypeParameter"})(a=e.SymbolKind||(e.SymbolKind={}));var b;(function(u){u[u.Deprecated=1]="Deprecated"})(b=e.SymbolTag||(e.SymbolTag={}));var n;(function(u){const E=new Map;E.set("file",0),E.set("module",1),E.set("namespace",2),E.set("package",3),E.set("class",4),E.set("method",5),E.set("property",6),E.set("field",7),E.set("constructor",8),E.set("enum",9),E.set("interface",10),E.set("function",11),E.set("variable",12),E.set("constant",13),E.set("string",14),E.set("number",15),E.set("boolean",16),E.set("array",17),E.set("object",18),E.set("key",19),E.set("null",20),E.set("enum-member",21),E.set("struct",22),E.set("event",23),E.set("operator",24),E.set("type-parameter",25);const A=new Map;A.set(0,"file"),A.set(1,"module"),A.set(2,"namespace"),A.set(3,"package"),A.set(4,"class"),A.set(5,"method"),A.set(6,"property"),A.set(7,"field"),A.set(8,"constructor"),A.set(9,"enum"),A.set(10,"interface"),A.set(11,"function"),A.set(12,"variable"),A.set(13,"constant"),A.set(14,"string"),A.set(15,"number"),A.set(16,"boolean"),A.set(17,"array"),A.set(18,"object"),A.set(19,"key"),A.set(20,"null"),A.set(21,"enum-member"),A.set(22,"struct"),A.set(23,"event"),A.set(24,"operator"),A.set(25,"type-parameter");function R(F){return E.get(F)}u.fromString=R;function B(F){return A.get(F)}u.toString=B;function x(F,$){const M=A.get(F);let H=M&&i.iconRegistry.get("symbol-"+M);return H||(console.info("No codicon found for SymbolKind "+F),H=i.Codicon.symbolProperty),`${$?"inline":"block"} ${H.classNames}`}u.toCssClassName=x})(n=e.SymbolKinds||(e.SymbolKinds={}));class t{constructor(E){this.value=E}}e.FoldingRangeKind=t,t.Comment=new t("comment"),t.Imports=new t("imports"),t.Region=new t("region");var l;(function(u){u[u.Collapsed=0]="Collapsed",u[u.Expanded=1]="Expanded"})(l=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var d;(function(u){u[u.Editing=0]="Editing",u[u.Preview=1]="Preview"})(d=e.CommentMode||(e.CommentMode={}));var o;(function(u){u[u.Other=0]="Other",u[u.Type=1]="Type",u[u.Parameter=2]="Parameter"})(o=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new y.LanguageFeatureRegistry,e.RenameProviderRegistry=new y.LanguageFeatureRegistry,e.CompletionProviderRegistry=new y.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new y.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new y.LanguageFeatureRegistry,e.HoverProviderRegistry=new y.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new y.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new y.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new y.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new y.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new y.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new y.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new y.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new y.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new y.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new y.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new y.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new y.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new y.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new y.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new y.LanguageFeatureRegistry,e.LinkProviderRegistry=new y.LanguageFeatureRegistry,e.ColorProviderRegistry=new y.LanguageFeatureRegistry,e.SelectionRangeRegistry=new y.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new y.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new y.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new y.LanguageFeatureRegistry,e.TokenizationRegistry=new C.TokenizationRegistryImpl;var h;(function(u){u[u.None=0]="None",u[u.Option=1]="Option",u[u.Default=2]="Default",u[u.Preferred=3]="Preferred"})(h=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(fe[53],me([0,1,12,8,4]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let C=g.userAgent||"";const i=new Map;i.set("false",!1),i.set("true",!0),i.set("isMac",g.isMacintosh),i.set("isLinux",g.isLinux),i.set("isWindows",g.isWindows),i.set("isWeb",g.isWeb),i.set("isMacNative",g.isMacintosh&&!g.isWeb),i.set("isEdge",C.indexOf("Edg/")>=0),i.set("isFirefox",C.indexOf("Firefox")>=0),i.set("isChrome",C.indexOf("Chrome")>=0),i.set("isSafari",C.indexOf("Safari")>=0);const k=Object.prototype.hasOwnProperty;var _;(function(x){x[x.False=0]="False",x[x.True=1]="True",x[x.Defined=2]="Defined",x[x.Not=3]="Not",x[x.Equals=4]="Equals",x[x.NotEquals=5]="NotEquals",x[x.And=6]="And",x[x.Regex=7]="Regex",x[x.NotRegex=8]="NotRegex",x[x.Or=9]="Or",x[x.In=10]="In",x[x.NotIn=11]="NotIn",x[x.Greater=12]="Greater",x[x.GreaterEquals=13]="GreaterEquals",x[x.Smaller=14]="Smaller",x[x.SmallerEquals=15]="SmallerEquals"})(_=e.ContextKeyExprType||(e.ContextKeyExprType={}));class D{static false(){return c.INSTANCE}static true(){return p.INSTANCE}static has(F){return f.create(F)}static equals(F,$){return v.create(F,$)}static notEquals(F,$){return w.create(F,$)}static regex(F,$){return t.create(F,$)}static in(F,$){return S.create(F,$)}static not(F){return s.create(F)}static and(...F){return o.create(F,null)}static or(...F){return h.create(F,null,!0)}static greater(F,$){return m.create(F,$)}static greaterEquals(F,$){return a.create(F,$)}static smaller(F,$){return b.create(F,$)}static smallerEquals(F,$){return n.create(F,$)}static deserialize(F,$=!1){if(!!F)return this._deserializeOrExpression(F,$)}static _deserializeOrExpression(F,$){let M=F.split("||");return h.create(M.map(H=>this._deserializeAndExpression(H,$)),null,!0)}static _deserializeAndExpression(F,$){let M=F.split("&&");return o.create(M.map(H=>this._deserializeOne(H,$)),null)}static _deserializeOne(F,$){if(F=F.trim(),F.indexOf("!=")>=0){let M=F.split("!=");return w.create(M[0].trim(),this._deserializeValue(M[1],$))}if(F.indexOf("==")>=0){let M=F.split("==");return v.create(M[0].trim(),this._deserializeValue(M[1],$))}if(F.indexOf("=~")>=0){let M=F.split("=~");return t.create(M[0].trim(),this._deserializeRegexValue(M[1],$))}if(F.indexOf(" in ")>=0){let M=F.split(" in ");return S.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(F)){const M=F.split(">=");return a.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(F)){const M=F.split(">");return m.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(F)){const M=F.split("<=");return n.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(F)){const M=F.split("<");return b.create(M[0].trim(),M[1].trim())}return/^\!\s*/.test(F)?s.create(F.substr(1).trim()):f.create(F)}static _deserializeValue(F,$){if(F=F.trim(),F==="true")return!0;if(F==="false")return!1;let M=/^'([^']*)'$/.exec(F);return M?M[1].trim():F}static _deserializeRegexValue(F,$){if((0,L.isFalsyOrWhitespace)(F)){if($)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let M=F.indexOf("/"),H=F.lastIndexOf("/");if(M===H||M<0){if($)throw new Error(`bad regexp-value '${F}', missing /-enclosure`);return console.warn(`bad regexp-value '${F}', missing /-enclosure`),null}let N=F.slice(M+1,H),U=F[H+1]==="i"?"i":"";try{return new RegExp(N,U)}catch(V){if($)throw new Error(`bad regexp-value '${F}', parse error: ${V}`);return console.warn(`bad regexp-value '${F}', parse error: ${V}`),null}}}e.ContextKeyExpr=D;function T(x,F){const $=x?x.substituteConstants():void 0,M=F?F.substituteConstants():void 0;return!$&&!M?!0:!$||!M?!1:$.equals(M)}e.expressionsAreEqualWithConstantSubstitution=T;function I(x,F){return x.cmp(F)}class c{constructor(){this.type=0}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!1}serialize(){return"false"}keys(){return[]}map(F){return this}negate(){return p.INSTANCE}}e.ContextKeyFalseExpr=c,c.INSTANCE=new c;class p{constructor(){this.type=1}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!0}serialize(){return"true"}keys(){return[]}map(F){return this}negate(){return c.INSTANCE}}e.ContextKeyTrueExpr=p,p.INSTANCE=new p;class f{constructor(F,$){this.key=F,this.negated=$,this.type=2}static create(F,$=null){const M=i.get(F);return typeof M=="boolean"?M?p.INSTANCE:c.INSTANCE:new f(F,$)}cmp(F){return F.type!==this.type?this.type-F.type:E(this.key,F.key)}equals(F){return F.type===this.type?this.key===F.key:!1}substituteConstants(){const F=i.get(this.key);return typeof F=="boolean"?F?p.INSTANCE:c.INSTANCE:this}evaluate(F){return!!F.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(F){return F.mapDefined(this.key)}negate(){return this.negated||(this.negated=s.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=f;class v{constructor(F,$,M){this.key=F,this.value=$,this.negated=M,this.type=4}static create(F,$,M=null){if(typeof $=="boolean")return $?f.create(F,M):s.create(F,M);const H=i.get(F);return typeof H=="boolean"?$===(H?"true":"false")?p.INSTANCE:c.INSTANCE:new v(F,$,M)}cmp(F){return F.type!==this.type?this.type-F.type:A(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){const F=i.get(this.key);if(typeof F=="boolean"){const $=F?"true":"false";return this.value===$?p.INSTANCE:c.INSTANCE}return this}evaluate(F){return F.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(F){return F.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=w.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=v;class S{constructor(F,$){this.key=F,this.valueKey=$,this.type=10,this.negated=null}static create(F,$){return new S(F,$)}cmp(F){return F.type!==this.type?this.type-F.type:A(this.key,this.valueKey,F.key,F.valueKey)}equals(F){return F.type===this.type?this.key===F.key&&this.valueKey===F.valueKey:!1}substituteConstants(){return this}evaluate(F){const $=F.getValue(this.valueKey),M=F.getValue(this.key);return Array.isArray($)?$.indexOf(M)>=0:typeof M=="string"&&typeof $=="object"&&$!==null?k.call($,M):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(F){return F.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=P.create(this)),this.negated}}e.ContextKeyInExpr=S;class P{constructor(F){this._actual=F,this.type=11}static create(F){return new P(F)}cmp(F){return F.type!==this.type?this.type-F.type:this._actual.cmp(F._actual)}equals(F){return F.type===this.type?this._actual.equals(F._actual):!1}substituteConstants(){return this}evaluate(F){return!this._actual.evaluate(F)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(F){return new P(this._actual.map(F))}negate(){return this._actual}}e.ContextKeyNotInExpr=P;class w{constructor(F,$,M){this.key=F,this.value=$,this.negated=M,this.type=5}static create(F,$,M=null){if(typeof $=="boolean")return $?s.create(F,M):f.create(F,M);const H=i.get(F);return typeof H=="boolean"?$===(H?"true":"false")?c.INSTANCE:p.INSTANCE:new w(F,$,M)}cmp(F){return F.type!==this.type?this.type-F.type:A(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){const F=i.get(this.key);if(typeof F=="boolean"){const $=F?"true":"false";return this.value===$?c.INSTANCE:p.INSTANCE}return this}evaluate(F){return F.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(F){return F.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=v.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=w;class s{constructor(F,$){this.key=F,this.negated=$,this.type=3}static create(F,$=null){const M=i.get(F);return typeof M=="boolean"?M?c.INSTANCE:p.INSTANCE:new s(F,$)}cmp(F){return F.type!==this.type?this.type-F.type:E(this.key,F.key)}equals(F){return F.type===this.type?this.key===F.key:!1}substituteConstants(){const F=i.get(this.key);return typeof F=="boolean"?F?c.INSTANCE:p.INSTANCE:this}evaluate(F){return!F.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(F){return F.mapNot(this.key)}negate(){return this.negated||(this.negated=f.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=s;function r(x,F){if(typeof x=="string"){const $=parseFloat(x);isNaN($)||(x=$)}return typeof x=="string"||typeof x=="number"?F(x):c.INSTANCE}class m{constructor(F,$,M){this.key=F,this.value=$,this.negated=M,this.type=12}static create(F,$,M=null){return r($,H=>new m(F,H,M))}cmp(F){return F.type!==this.type?this.type-F.type:A(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(F){return F.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=n.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=m;class a{constructor(F,$,M){this.key=F,this.value=$,this.negated=M,this.type=13}static create(F,$,M=null){return r($,H=>new a(F,H,M))}cmp(F){return F.type!==this.type?this.type-F.type:A(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(F){return F.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=b.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=a;class b{constructor(F,$,M){this.key=F,this.value=$,this.negated=M,this.type=14}static create(F,$,M=null){return r($,H=>new b(F,H,M))}cmp(F){return F.type!==this.type?this.type-F.type:A(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(F){return F.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=b;class n{constructor(F,$,M){this.key=F,this.value=$,this.negated=M,this.type=15}static create(F,$,M=null){return r($,H=>new n(F,H,M))}cmp(F){return F.type!==this.type?this.type-F.type:A(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(F){return F.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=m.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=n;class t{constructor(F,$){this.key=F,this.regexp=$,this.type=7,this.negated=null}static create(F,$){return new t(F,$)}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.key<F.key)return-1;if(this.key>F.key)return 1;const $=this.regexp?this.regexp.source:"",M=F.regexp?F.regexp.source:"";return $<M?-1:$>M?1:0}equals(F){if(F.type===this.type){const $=this.regexp?this.regexp.source:"",M=F.regexp?F.regexp.source:"";return this.key===F.key&&$===M}return!1}substituteConstants(){return this}evaluate(F){let $=F.getValue(this.key);return this.regexp?this.regexp.test($):!1}serialize(){const F=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${F}`}keys(){return[this.key]}map(F){return F.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=l.create(this)),this.negated}}e.ContextKeyRegexExpr=t;class l{constructor(F){this._actual=F,this.type=8}static create(F){return new l(F)}cmp(F){return F.type!==this.type?this.type-F.type:this._actual.cmp(F._actual)}equals(F){return F.type===this.type?this._actual.equals(F._actual):!1}substituteConstants(){return this}evaluate(F){return!this._actual.evaluate(F)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(F){return new l(this._actual.map(F))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=l;function d(x){let F=null;for(let $=0,M=x.length;$<M;$++){const H=x[$].substituteConstants();if(x[$]!==H&&F===null){F=[];for(let N=0;N<$;N++)F[N]=x[N]}F!==null&&(F[$]=H)}return F===null?x:F}class o{constructor(F,$){this.expr=F,this.negated=$,this.type=6}static create(F,$){return o._normalizeArr(F,$)}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let $=0,M=this.expr.length;$<M;$++){const H=I(this.expr[$],F.expr[$]);if(H!==0)return H}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let $=0,M=this.expr.length;$<M;$++)if(!this.expr[$].equals(F.expr[$]))return!1;return!0}return!1}substituteConstants(){const F=d(this.expr);return F===this.expr?this:o.create(F,this.negated)}evaluate(F){for(let $=0,M=this.expr.length;$<M;$++)if(!this.expr[$].evaluate(F))return!1;return!0}static _normalizeArr(F,$){const M=[];let H=!1;for(const N of F)if(!!N){if(N.type===1){H=!0;continue}if(N.type===0)return c.INSTANCE;if(N.type===6){M.push(...N.expr);continue}M.push(N)}if(M.length===0&&H)return p.INSTANCE;if(M.length!==0){if(M.length===1)return M[0];M.sort(I);for(let N=1;N<M.length;N++)M[N-1].equals(M[N])&&(M.splice(N,1),N--);if(M.length===1)return M[0];for(;M.length>1;){const N=M[M.length-1];if(N.type!==9)break;M.pop();const U=M.pop(),V=M.length===0,O=h.create(N.expr.map(W=>o.create([W,U],null)),null,V);O&&(M.push(O),M.sort(I))}return M.length===1?M[0]:new o(M,$)}}serialize(){return this.expr.map(F=>F.serialize()).join(" && ")}keys(){const F=[];for(let $ of this.expr)F.push(...$.keys());return F}map(F){return new o(this.expr.map($=>$.map(F)),null)}negate(){if(!this.negated){const F=[];for(let $ of this.expr)F.push($.negate());this.negated=h.create(F,this,!0)}return this.negated}}class h{constructor(F,$){this.expr=F,this.negated=$,this.type=9}static create(F,$,M){return h._normalizeArr(F,$,M)}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let $=0,M=this.expr.length;$<M;$++){const H=I(this.expr[$],F.expr[$]);if(H!==0)return H}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let $=0,M=this.expr.length;$<M;$++)if(!this.expr[$].equals(F.expr[$]))return!1;return!0}return!1}substituteConstants(){const F=d(this.expr);return F===this.expr?this:h.create(F,this.negated,!1)}evaluate(F){for(let $=0,M=this.expr.length;$<M;$++)if(this.expr[$].evaluate(F))return!0;return!1}static _normalizeArr(F,$,M){let H=[],N=!1;if(F){for(let U=0,V=F.length;U<V;U++){const O=F[U];if(!!O){if(O.type===0){N=!0;continue}if(O.type===1)return p.INSTANCE;if(O.type===9){H=H.concat(O.expr);continue}H.push(O)}}if(H.length===0&&N)return c.INSTANCE;H.sort(I)}if(H.length!==0){if(H.length===1)return H[0];for(let U=1;U<H.length;U++)H[U-1].equals(H[U])&&(H.splice(U,1),U--);if(H.length===1)return H[0];if(M){for(let U=0;U<H.length;U++)for(let V=U+1;V<H.length;V++)R(H[U],H[V])&&(H.splice(V,1),V--);if(H.length===1)return H[0]}return new h(H,$)}}serialize(){return this.expr.map(F=>F.serialize()).join(" || ")}keys(){const F=[];for(let $ of this.expr)F.push(...$.keys());return F}map(F){return new h(this.expr.map($=>$.map(F)),null)}negate(){if(!this.negated){let F=[];for(let $ of this.expr)F.push($.negate());for(;F.length>1;){const $=F.shift(),M=F.shift(),H=[];for(const U of B($))for(const V of B(M))H.push(o.create([U,V],null));const N=F.length===0;F.unshift(h.create(H,null,N))}this.negated=F[0]}return this.negated}}class u extends f{constructor(F,$,M){super(F,null);this._defaultValue=$,typeof M=="object"?u._info.push({...M,key:F}):M!==!0&&u._info.push({key:F,description:M,type:$!=null?typeof $:void 0})}static all(){return u._info.values()}bindTo(F){return F.createKey(this.key,this._defaultValue)}getValue(F){return F.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(F){return v.create(this.key,F)}notEqualsTo(F){return w.create(this.key,F)}}e.RawContextKey=u,u._info=[],e.IContextKeyService=(0,y.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function E(x,F){return x<F?-1:x>F?1:0}function A(x,F,$,M){return x<$?-1:x>$?1:F<M?-1:F>M?1:0}function R(x,F){if(F.type===6&&x.type!==9&&x.type!==6){for(const H of F.expr)if(x.equals(H))return!0}const $=x.negate(),M=B($).concat(B(F));M.sort(I);for(let H=0;H<M.length;H++){const U=M[H].negate();for(let V=H+1;V<M.length;V++){const O=M[V];if(U.equals(O))return!0}}return!1}e.implies=R;function B(x){return x.type===9?x.expr:[x]}}),define(fe[185],me([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,g.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,g.refineServiceDecorator)(e.IEnvironmentService)}),define(fe[186],me([0,1,10,157,4]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var C;(function(s){s.WIN32_X64="win32-x64",s.WIN32_IA32="win32-ia32",s.WIN32_ARM64="win32-arm64",s.LINUX_X64="linux-x64",s.LINUX_ARM64="linux-arm64",s.LINUX_ARMHF="linux-armhf",s.ALPINE_X64="alpine-x64",s.ALPINE_ARM64="alpine-arm64",s.DARWIN_X64="darwin-x64",s.DARWIN_ARM64="darwin-arm64",s.WEB="web",s.UNIVERSAL="universal",s.UNKNOWN="unknown",s.UNDEFINED="undefined"})(C=e.TargetPlatform||(e.TargetPlatform={}));function i(s){switch(s){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=i;function k(s){switch(s){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=k;function _(s,r){switch(s){case 3:return r==="x64"?"win32-x64":r==="ia32"?"win32-ia32":r==="arm64"?"win32-arm64":"unknown";case 2:return r==="x64"?"linux-x64":r==="arm64"?"linux-arm64":r==="arm"?"linux-armhf":"unknown";case"alpine":return r==="x64"?"alpine-x64":r==="arm64"?"alpine-arm64":"unknown";case 1:return r==="x64"?"darwin-x64":r==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=_;function D(s,r){return r==="web"&&!s.includes("web")}e.isNotWebExtensionInWebTargetPlatform=D;function T(s,r,m){return D(r,m)?!1:s==="undefined"||s==="universal"?!0:s==="unknown"?!1:s===m?!0:I(m).includes(s)}e.isTargetPlatformCompatible=T;function I(s){switch(s){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=I;function c(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(!s.uuid||typeof s.uuid=="string")}e.isIExtensionIdentifier=c;var p;(function(s){s[s.NoneOrRelevance=0]="NoneOrRelevance",s[s.LastUpdatedDate=1]="LastUpdatedDate",s[s.Title=2]="Title",s[s.PublisherName=3]="PublisherName",s[s.InstallCount=4]="InstallCount",s[s.PublishedDate=10]="PublishedDate",s[s.AverageRating=6]="AverageRating",s[s.WeightedRating=12]="WeightedRating"})(p=e.SortBy||(e.SortBy={}));var f;(function(s){s[s.Default=0]="Default",s[s.Ascending=1]="Ascending",s[s.Descending=2]="Descending"})(f=e.SortOrder||(e.SortOrder={}));var v;(function(s){s.Install="install",s.Uninstall="uninstall"})(v=e.StatisticType||(e.StatisticType={}));var S;(function(s){s[s.None=0]="None",s[s.Install=1]="Install",s[s.Update=2]="Update"})(S=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,y.createDecorator)("extensionGalleryService");var P;(function(s){s.Unsupported="Unsupported",s.Malicious="Malicious",s.Incompatible="Incompatible",s.Invalid="Invalid",s.Download="Download",s.Extract="Extract",s.Delete="Delete",s.Rename="Rename",s.CorruptZip="CorruptZip",s.IncompleteZip="IncompleteZip",s.Internal="Internal"})(P=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class w extends Error{constructor(r,m){super(r);this.code=m,this.name=m}}e.ExtensionManagementError=w,e.IExtensionManagementService=(0,y.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,y.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,y.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=g.FileAccess.asBrowserUri("./media/defaultIcon.png",Y).toString(!0),e.ExtensionsLabel=(0,L.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,L.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,y.createDecorator)("IExtensionManagementCLIService")}),define(fe[187],me([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,g.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,g.createDecorator)("externalTerminal")}),define(fe[188],me([0,1,39,10,9,12,95,28,113,159,187]),function(Y,e,g,L,y,C,i,k,_,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const I=D.localize(0,null);class c{async getDefaultTerminalForPlatforms(){return{windows:p.getDefaultTerminalWindows(),linux:await v.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class p extends c{openTerminal(r,m){return this.spawnTerminal(g,r,_.getWindowsShell(),m)}spawnTerminal(r,m,a,b){const n=m.windowsExec||p.getDefaultTerminalWindows();b&&b[1]===":"&&(b=b[0].toUpperCase()+b.substr(1));const t=y.basename(n).toLowerCase();if(t==="cmder"||t==="cmder.exe")return r.spawn(n,b?[b]:void 0),Promise.resolve(void 0);const l=["/c","start","/wait"];return n.indexOf(" ")>=0&&l.push('""'),l.push(n),(t==="wt"||t==="wt.exe")&&l.push("-d ."),new Promise((d,o)=>{const h=S(process),u=r.spawn(a,l,{cwd:b,env:h});u.on("error",o),u.on("exit",()=>d())})}runInTerminal(r,m,a,b,n){const t="windowsExec"in n&&n.windowsExec?n.windowsExec:p.getDefaultTerminalWindows();return new Promise((l,d)=>{const o=`"${m} - ${I}"`,h=`""${a.join('" "')}" & pause"`,u=["/c","start",o,"/wait",t,"/c",h],E=Object.assign({},S(process),b);Object.keys(E).filter(B=>E[B]===null).forEach(B=>delete E[B]);const A={cwd:m,env:E,windowsVerbatimArguments:!0};g.spawn(p.CMD,u,A).on("error",B=>{d(P(B))}),l(void 0)})}static getDefaultTerminalWindows(){if(!p._DEFAULT_TERMINAL_WINDOWS){const r=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");p._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${r?"Sysnative":"System32"}\\cmd.exe`}return p._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=p,p.CMD="cmd.exe";class f extends c{openTerminal(r,m){return this.spawnTerminal(g,r,m)}runInTerminal(r,m,a,b,n){const t=n.osxExec||T.DEFAULT_TERMINAL_OSX;return new Promise((l,d)=>{if(t===T.DEFAULT_TERMINAL_OSX||t==="iTerm.app"){const o=t===T.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",u=[L.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${o}.scpt`,Y).fsPath,"-t",r||I,"-w",m];for(let R of a)u.push("-a"),u.push(R);if(b){const R=Object.assign({},S(process),b);for(let B in R){const x=R[B];x===null?(u.push("-u"),u.push(B)):(u.push("-e"),u.push(`${B}=${x}`))}}let E="";const A=g.spawn(f.OSASCRIPT,u);A.on("error",R=>{d(P(R))}),A.stderr.on("data",R=>{E+=R.toString()}),A.on("exit",R=>{if(R===0)l(void 0);else if(E){const B=E.split(`
`,1);d(new Error(B[0]))}else d(new Error(D.localize(1,null,o,R)))})}else d(new Error(D.localize(2,null,t)))})}spawnTerminal(r,m,a){const b=m.osxExec||T.DEFAULT_TERMINAL_OSX;return new Promise((n,t)=>{const l=["-a",b];a&&l.push(a);const d=S(process),o=r.spawn("/usr/bin/open",l,{cwd:a,env:d});o.on("error",t),o.on("exit",()=>n())})}}e.MacExternalTerminalService=f,f.OSASCRIPT="/usr/bin/osascript";class v extends c{openTerminal(r,m){return this.spawnTerminal(g,r,m)}runInTerminal(r,m,a,b,n){const t=n.linuxExec?Promise.resolve(n.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((l,d)=>{let o=[];t.then(h=>{h.indexOf("gnome-terminal")>=0?o.push("-x"):o.push("-e"),o.push("bash"),o.push("-c");const u=`${w(a)}; echo; read -p "${v.WAIT_MESSAGE}" -n1;`;o.push(`''${u}''`);const E=Object.assign({},S(process),b);Object.keys(E).filter(x=>E[x]===null).forEach(x=>delete E[x]);const A={cwd:m,env:E};let R="";const B=g.spawn(h,o,A);B.on("error",x=>{d(P(x))}),B.stderr.on("data",x=>{R+=x.toString()}),B.on("exit",x=>{if(x===0)l(void 0);else if(R){const F=R.split(`
`,1);d(new Error(F[0]))}else d(new Error(D.localize(4,null,h,x)))})})})}static async getDefaultTerminalLinuxReady(){if(!v._DEFAULT_TERMINAL_LINUX_READY)if(!C.isLinux)v._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const r=await k.Promises.exists("/etc/debian_version");v._DEFAULT_TERMINAL_LINUX_READY=new Promise(m=>{r?m("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?m("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?m("konsole"):process.env.COLORTERM?m(process.env.COLORTERM):process.env.TERM?m(process.env.TERM):m("xterm")})}return v._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(r,m,a){const b=m.linuxExec?Promise.resolve(m.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((n,t)=>{b.then(l=>{const d=S(process),o=r.spawn(l,[],{cwd:a,env:d});o.on("error",t),o.on("exit",()=>n())})})}}e.LinuxExternalTerminalService=v,v.WAIT_MESSAGE=D.localize(3,null);function S(s){const r={...s.env};return(0,i.sanitizeProcessEnvironment)(r),r}function P(s){return"errno"in s&&s.errno==="ENOENT"&&"path"in s&&typeof s.path=="string"?new Error(D.localize(5,null,s.path)):s}function w(s){let r="";for(let m of s)m.indexOf(" ")>=0?r+='"'+m+'"':r+=m,r+=" ";return r}}),define(fe[43],me([0,1,24,9,8,13,2,160,4]),function(Y,e,g,L,y,C,i,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,_.createDecorator)("fileService");function D(M){return M.create===!0}e.isFileOpenForWriteOptions=D;var T;(function(M){M[M.Unknown=0]="Unknown",M[M.File=1]="File",M[M.Directory=2]="Directory",M[M.SymbolicLink=64]="SymbolicLink"})(T=e.FileType||(e.FileType={}));var I;(function(M){M[M.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var c;(function(M){M[M.FileReadWrite=2]="FileReadWrite",M[M.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",M[M.FileReadStream=16]="FileReadStream",M[M.FileFolderCopy=8]="FileFolderCopy",M[M.PathCaseSensitive=1024]="PathCaseSensitive",M[M.Readonly=2048]="Readonly",M[M.Trash=4096]="Trash",M[M.FileWriteUnlock=8192]="FileWriteUnlock"})(c=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function p(M){return!!(M.capabilities&2)}e.hasReadWriteCapability=p;function f(M){return!!(M.capabilities&8)}e.hasFileFolderCopyCapability=f;function v(M){return!!(M.capabilities&4)}e.hasOpenReadWriteCloseCapability=v;function S(M){return!!(M.capabilities&16)}e.hasFileReadStreamCapability=S;var P;(function(M){M.FileExists="EntryExists",M.FileNotFound="EntryNotFound",M.FileNotADirectory="EntryNotADirectory",M.FileIsADirectory="EntryIsADirectory",M.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",M.FileTooLarge="EntryTooLarge",M.FileWriteLocked="EntryWriteLocked",M.NoPermissions="NoPermissions",M.Unavailable="Unavailable",M.Unknown="Unknown"})(P=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class w extends Error{constructor(H,N){super(H);this.code=N}}e.FileSystemProviderError=w;function s(M,H){const N=new w(M.toString(),H);return m(N,H),N}e.createFileSystemProviderError=s;function r(M){return M||s((0,k.localize)(0,null),P.Unknown)}e.ensureFileSystemProviderError=r;function m(M,H){return M.name=H?`${H} (FileSystemError)`:"FileSystemError",M}e.markAsFileSystemProviderError=m;function a(M){if(!M)return P.Unknown;if(M instanceof w)return M.code;const H=/^(.+) \(FileSystemError\)$/.exec(M.name);if(!H)return P.Unknown;switch(H[1]){case P.FileExists:return P.FileExists;case P.FileIsADirectory:return P.FileIsADirectory;case P.FileNotADirectory:return P.FileNotADirectory;case P.FileNotFound:return P.FileNotFound;case P.FileExceedsMemoryLimit:return P.FileExceedsMemoryLimit;case P.FileTooLarge:return P.FileTooLarge;case P.FileWriteLocked:return P.FileWriteLocked;case P.NoPermissions:return P.NoPermissions;case P.Unavailable:return P.Unavailable}return P.Unknown}e.toFileSystemProviderErrorCode=a;function b(M){if(M instanceof h)return M.fileOperationResult;switch(a(M)){case P.FileNotFound:return 1;case P.FileIsADirectory:return 0;case P.FileNotADirectory:return 10;case P.FileWriteLocked:return 5;case P.NoPermissions:return 6;case P.FileExists:return 4;case P.FileExceedsMemoryLimit:return 9;case P.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=b;var n;(function(M){M[M.CREATE=0]="CREATE",M[M.DELETE=1]="DELETE",M[M.MOVE=2]="MOVE",M[M.COPY=3]="COPY"})(n=e.FileOperation||(e.FileOperation={}));class t{constructor(H,N,U){this.resource=H,this.operation=N,this.target=U}isOperation(H){return this.operation===H}}e.FileOperationEvent=t;var l;(function(M){M[M.UPDATED=0]="UPDATED",M[M.ADDED=1]="ADDED",M[M.DELETED=2]="DELETED"})(l=e.FileChangeType||(e.FileChangeType={}));class d{constructor(H,N){this.added=void 0,this.updated=void 0,this.deleted=void 0;const U=new Map;for(const V of H){const O=U.get(V.type);O?O.push([V.resource,V]):U.set(V.type,[[V.resource,V]])}for(const[V,O]of U)switch(V){case 1:this.added=g.TernarySearchTree.forUris(()=>N),this.added.fill(O);break;case 0:this.updated=g.TernarySearchTree.forUris(()=>N),this.updated.fill(O);break;case 2:this.deleted=g.TernarySearchTree.forUris(()=>N),this.deleted.fill(O);break}}contains(H,...N){return this.doContains(H,{includeChildren:!1},...N)}affects(H,...N){return this.doContains(H,{includeChildren:!0},...N)}doContains(H,N,...U){if(!H)return!1;const V=U.length>0;return!!((!V||U.includes(1))&&(this.added?.get(H)||N.includeChildren&&this.added?.findSuperstr(H))||(!V||U.includes(0))&&(this.updated?.get(H)||N.includeChildren&&this.updated?.findSuperstr(H))||(!V||U.includes(2))&&(this.deleted?.findSubstr(H)||N.includeChildren&&this.deleted?.findSuperstr(H)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=d;function o(M,H,N){return!M||!H||M===H||H.length>M.length?!1:(H.charAt(H.length-1)!==L.sep&&(H+=L.sep),N?(0,y.startsWithIgnoreCase)(M,H):M.indexOf(H)===0)}e.isParent=o;class h extends Error{constructor(H,N,U){super(H);this.fileOperationResult=N,this.options=U}}e.FileOperationError=h;class u extends h{constructor(H,N,U){super(H,2,U);this.stat=N}}e.NotModifiedSinceFileOperationError=u;var E;(function(M){M[M.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",M[M.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",M[M.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",M[M.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",M[M.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",M[M.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",M[M.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",M[M.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",M[M.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",M[M.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",M[M.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",M[M.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(E=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var A;(function(M){M[M.FILE=0]="FILE",M[M.FOLDER=1]="FOLDER",M[M.ROOT_FOLDER=2]="ROOT_FOLDER"})(A=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function R(M){if(!(typeof M.size!="number"||typeof M.mtime!="number"))return M.mtime.toString(29)+M.size.toString(31)}e.etag=R;async function B(M,H){if(!H.hasProvider(i.URI.from({scheme:M.scheme})))return new Promise(N=>{const U=H.onDidChangeFileSystemProviderRegistrations(V=>{V.scheme===M.scheme&&V.added&&(U.dispose(),N())})})}e.whenProviderRegistered=B,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class x{static formatSize(H){return(0,C.isNumber)(H)||(H=0),H<x.KB?(0,k.localize)(1,null,H.toFixed(0)):H<x.MB?(0,k.localize)(2,null,(H/x.KB).toFixed(2)):H<x.GB?(0,k.localize)(3,null,(H/x.MB).toFixed(2)):H<x.TB?(0,k.localize)(4,null,(H/x.GB).toFixed(2)):(0,k.localize)(5,null,(H/x.TB).toFixed(2))}}e.ByteSize=x,x.KB=1024,x.MB=x.KB*x.KB,x.GB=x.MB*x.KB,x.TB=x.GB*x.KB;var F;(function(M){M[M.IA32=0]="IA32",M[M.OTHER=1]="OTHER"})(F=e.Arch||(e.Arch={}));function $(M){return{maxFileSize:M===0?300*x.MB:16*x.GB,maxHeapSize:M===0?700*x.MB:2*700*x.MB}}e.getPlatformLimits=$}),define(fe[86],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class g{constructor(...y){this._entries=new Map;for(let[C,i]of y)this.set(C,i)}set(y,C){const i=this._entries.get(y);return this._entries.set(y,C),i}has(y){return this._entries.has(y)}get(y){return this._entries.get(y)}}e.ServiceCollection=g}),define(fe[189],me([0,1,16,18,115,182,4,86]),function(Y,e,g,L,y,C,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const _=!1;class D extends Error{constructor(f){super("cyclic dependency between services");this.message=f.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${f.toString()}`}}class T{constructor(f=new k.ServiceCollection,v=!1,S){this._activeInstantiations=new Set,this._services=f,this._strict=v,this._parent=S,this._services.set(i.IInstantiationService,this)}createChild(f){return new T(f,this._strict,this)}invokeFunction(f,...v){let S=c.traceInvocation(f),P=!1;try{return f({get:s=>{if(P)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const r=this._getOrCreateServiceInstance(s,S);if(!r)throw new Error(`[invokeFunction] unknown service '${s}'`);return r}},...v)}finally{P=!0,S.stop()}}createInstance(f,...v){let S,P;return f instanceof y.SyncDescriptor?(S=c.traceCreation(f.ctor),P=this._createInstance(f.ctor,f.staticArguments.concat(v),S)):(S=c.traceCreation(f),P=this._createInstance(f,v,S)),S.stop(),P}_createInstance(f,v=[],S){let P=i._util.getServiceDependencies(f).sort((r,m)=>r.index-m.index),w=[];for(const r of P){let m=this._getOrCreateServiceInstance(r.id,S);if(!m&&this._strict&&!r.optional)throw new Error(`[createInstance] ${f.name} depends on UNKNOWN service ${r.id}.`);w.push(m)}let s=P.length>0?P[0].index:v.length;if(v.length!==s){console.warn(`[createInstance] First service dependency of ${f.name} at position ${s+1} conflicts with ${v.length} static arguments`);let r=s-v.length;r>0?v=v.concat(new Array(r)):v=v.slice(0,s)}return new f(...[...v,...w])}_setServiceInstance(f,v){if(this._services.get(f)instanceof y.SyncDescriptor)this._services.set(f,v);else if(this._parent)this._parent._setServiceInstance(f,v);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(f){let v=this._services.get(f);return!v&&this._parent?this._parent._getServiceInstanceOrDescriptor(f):v}_getOrCreateServiceInstance(f,v){let S=this._getServiceInstanceOrDescriptor(f);return S instanceof y.SyncDescriptor?this._safeCreateAndCacheServiceInstance(f,S,v.branch(f,!0)):(v.branch(f,!1),S)}_safeCreateAndCacheServiceInstance(f,v,S){if(this._activeInstantiations.has(f))throw new Error(`illegal state - RECURSIVELY instantiating service '${f}'`);this._activeInstantiations.add(f);try{return this._createAndCacheServiceInstance(f,v,S)}finally{this._activeInstantiations.delete(f)}}_createAndCacheServiceInstance(f,v,S){const P=new C.Graph(r=>r.id.toString());let w=0;const s=[{id:f,desc:v,_trace:S}];for(;s.length;){const r=s.pop();if(P.lookupOrInsertNode(r),w++>1e3)throw new D(P);for(let m of i._util.getServiceDependencies(r.desc.ctor)){let a=this._getServiceInstanceOrDescriptor(m.id);if(!a&&!m.optional&&console.warn(`[createInstance] ${f} depends on ${m.id} which is NOT registered.`),a instanceof y.SyncDescriptor){const b={id:m.id,desc:a,_trace:r._trace.branch(m.id,!0)};P.insertEdge(r,b),s.push(b)}}}for(;;){const r=P.roots();if(r.length===0){if(!P.isEmpty())throw new D(P);break}for(const{data:m}of r){if(this._getServiceInstanceOrDescriptor(m.id)instanceof y.SyncDescriptor){const b=this._createServiceInstanceWithOwner(m.id,m.desc.ctor,m.desc.staticArguments,m.desc.supportsDelayedInstantiation,m._trace);this._setServiceInstance(m.id,b)}P.removeNode(m)}}return this._getServiceInstanceOrDescriptor(f)}_createServiceInstanceWithOwner(f,v,S=[],P,w){if(this._services.get(f)instanceof y.SyncDescriptor)return this._createServiceInstance(v,S,P,w);if(this._parent)return this._parent._createServiceInstanceWithOwner(f,v,S,P,w);throw new Error(`illegalState - creating UNKNOWN service instance ${v.name}`)}_createServiceInstance(f,v=[],S,P){if(S){const w=new g.IdleValue(()=>this._createInstance(f,v,P));return new Proxy(Object.create(null),{get(s,r){if(r in s)return s[r];let m=w.value,a=m[r];return typeof a!="function"||(a=a.bind(m),s[r]=a),a},set(s,r,m){return w.value[r]=m,!0}})}else return this._createInstance(f,v,P)}}e.InstantiationService=T;var I;(function(p){p[p.Creation=0]="Creation",p[p.Invocation=1]="Invocation",p[p.Branch=2]="Branch"})(I||(I={}));class c{constructor(f,v){this.type=f,this.name=v,this._start=Date.now(),this._dep=[]}static traceInvocation(f){return _?new c(1,f.name||f.toString().substring(0,42).replace(/\n/g,"")):c._None}static traceCreation(f){return _?new c(0,f.name):c._None}branch(f,v){let S=new c(2,f.toString());return this._dep.push([f,v,S]),S}stop(){let f=Date.now()-this._start;c._totals+=f;let v=!1;function S(w,s){let r=[],m=new Array(w+1).join("	");for(const[a,b,n]of s._dep)if(b&&n){v=!0,r.push(`${m}CREATES -> ${a}`);let t=S(w+1,n);t&&r.push(t)}else r.push(`${m}uses -> ${a}`);return r.join(`
`)}let P=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${S(1,this)}`,`DONE, took ${f.toFixed(2)}ms (grand total ${c._totals.toFixed(2)}ms)`];(f>2||v)&&console.log(P.join(`
`))}}c._None=new class extends c{constructor(){super(-1,null)}stop(){}branch(){return this}},c._totals=0}),define(fe[11],me([0,1,52,3,6,12,4]),function(Y,e,g,L,y,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,i.createDecorator)("logService"),e.ILoggerService=(0,i.createDecorator)("loggerService");function k(){return new Date().toISOString()}var _;(function(b){b[b.Trace=0]="Trace",b[b.Debug=1]="Debug",b[b.Info=2]="Info",b[b.Warning=3]="Warning",b[b.Error=4]="Error",b[b.Critical=5]="Critical",b[b.Off=6]="Off"})(_=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=_.Info;function D(b,n,t){switch(n){case _.Trace:b.trace(t);break;case _.Debug:b.debug(t);break;case _.Info:b.info(t);break;case _.Warning:b.warn(t);break;case _.Error:b.error(t);break;case _.Critical:b.critical(t);break;default:throw new Error("Invalid log level")}}e.log=D;function T(b){let n="";for(let t=0;t<b.length;t++){let l=b[t];if(typeof l=="object")try{l=JSON.stringify(l)}catch(d){}n+=(t>0?" ":"")+l}return n}e.format=T;class I extends y.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(n){this.level!==n&&(this.level=n,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=I;class c extends I{constructor(n){super();this.logAlways=n}checkLogLevel(n){return this.logAlways||this.getLevel()<=n}trace(n,...t){this.checkLogLevel(_.Trace)&&this.log(_.Trace,T([n,...t]))}debug(n,...t){this.checkLogLevel(_.Debug)&&this.log(_.Debug,T([n,...t]))}info(n,...t){this.checkLogLevel(_.Info)&&this.log(_.Info,T([n,...t]))}warn(n,...t){this.checkLogLevel(_.Warning)&&this.log(_.Warning,T([n,...t]))}error(n,...t){if(this.checkLogLevel(_.Error))if(n instanceof Error){const l=Array.prototype.slice.call(arguments);l[0]=n.stack,this.log(_.Error,T(l))}else this.log(_.Error,T([n,...t]))}critical(n,...t){this.checkLogLevel(_.Critical)&&this.log(_.Critical,T([n,...t]))}flush(){}}e.AbstractMessageLogger=c;class p extends I{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n),this.useColors=!C.isWindows}trace(n,...t){this.getLevel()<=_.Trace&&(this.useColors?console.log(`[90m[main ${k()}][0m`,n,...t):console.log(`[main ${k()}]`,n,...t))}debug(n,...t){this.getLevel()<=_.Debug&&(this.useColors?console.log(`[90m[main ${k()}][0m`,n,...t):console.log(`[main ${k()}]`,n,...t))}info(n,...t){this.getLevel()<=_.Info&&(this.useColors?console.log(`[90m[main ${k()}][0m`,n,...t):console.log(`[main ${k()}]`,n,...t))}warn(n,...t){this.getLevel()<=_.Warning&&(this.useColors?console.warn(`[93m[main ${k()}][0m`,n,...t):console.warn(`[main ${k()}]`,n,...t))}error(n,...t){this.getLevel()<=_.Error&&(this.useColors?console.error(`[91m[main ${k()}][0m`,n,...t):console.error(`[main ${k()}]`,n,...t))}critical(n,...t){this.getLevel()<=_.Critical&&(this.useColors?console.error(`[90m[main ${k()}][0m`,n,...t):console.error(`[main ${k()}]`,n,...t))}dispose(){}flush(){}}e.ConsoleMainLogger=p;class f extends I{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n)}trace(n,...t){this.getLevel()<=_.Trace&&console.log("%cTRACE","color: #888",n,...t)}debug(n,...t){this.getLevel()<=_.Debug&&console.log("%cDEBUG","background: #eee; color: #888",n,...t)}info(n,...t){this.getLevel()<=_.Info&&console.log("%c INFO","color: #33f",n,...t)}warn(n,...t){this.getLevel()<=_.Warning&&console.log("%c WARN","color: #993",n,...t)}error(n,...t){this.getLevel()<=_.Error&&console.log("%c  ERR","color: #f33",n,...t)}critical(n,...t){this.getLevel()<=_.Critical&&console.log("%cCRITI","background: #f33; color: white",n,...t)}dispose(){}flush(){}}e.ConsoleLogger=f;class v extends I{constructor(n,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=n,this.setLevel(t)}trace(n,...t){this.getLevel()<=_.Trace&&this.adapter.log(_.Trace,[this.extractMessage(n),...t])}debug(n,...t){this.getLevel()<=_.Debug&&this.adapter.log(_.Debug,[this.extractMessage(n),...t])}info(n,...t){this.getLevel()<=_.Info&&this.adapter.log(_.Info,[this.extractMessage(n),...t])}warn(n,...t){this.getLevel()<=_.Warning&&this.adapter.log(_.Warning,[this.extractMessage(n),...t])}error(n,...t){this.getLevel()<=_.Error&&this.adapter.log(_.Error,[this.extractMessage(n),...t])}critical(n,...t){this.getLevel()<=_.Critical&&this.adapter.log(_.Critical,[this.extractMessage(n),...t])}extractMessage(n){return typeof n=="string"?n:(0,g.toErrorMessage)(n,this.getLevel()<=_.Trace)}dispose(){}flush(){}}e.AdapterLogger=v;class S extends I{constructor(n){super();this.logServices=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const t of this.logServices)t.setLevel(n);super.setLevel(n)}trace(n,...t){for(const l of this.logServices)l.trace(n,...t)}debug(n,...t){for(const l of this.logServices)l.debug(n,...t)}info(n,...t){for(const l of this.logServices)l.info(n,...t)}warn(n,...t){for(const l of this.logServices)l.warn(n,...t)}error(n,...t){for(const l of this.logServices)l.error(n,...t)}critical(n,...t){for(const l of this.logServices)l.critical(n,...t)}flush(){for(const n of this.logServices)n.flush()}dispose(){for(const n of this.logServices)n.dispose()}}e.MultiplexLogService=S;class P extends y.Disposable{constructor(n){super();this.logger=n,this._register(n)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(n){this.logger.setLevel(n)}getLevel(){return this.logger.getLevel()}trace(n,...t){this.logger.trace(n,...t)}debug(n,...t){this.logger.debug(n,...t)}info(n,...t){this.logger.info(n,...t)}warn(n,...t){this.logger.warn(n,...t)}error(n,...t){this.logger.error(n,...t)}critical(n,...t){this.logger.critical(n,...t)}flush(){this.logger.flush()}}e.LogService=P;class w extends y.Disposable{constructor(n,t){super();this.logLevel=n,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(t(l=>{this.logLevel=l,this.logLevelChangeableLoggers.forEach(d=>d.setLevel(l))}))}getLogger(n){return this.loggers.get(n.toString())}createLogger(n,t){let l=this.loggers.get(n.toString());return l||(l=this.doCreateLogger(n,t?.always?_.Trace:this.logLevel,t),this.loggers.set(n.toString(),l),t?.always||this.logLevelChangeableLoggers.push(l)),l}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(n=>n.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=w;class s{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(n){}getLevel(){return _.Info}trace(n,...t){}debug(n,...t){}info(n,...t){}warn(n,...t){}error(n,...t){}critical(n,...t){}dispose(){}flush(){}}e.NullLogService=s;function r(b){if(b.verbose)return _.Trace;if(typeof b.logLevel=="string"){const n=m(b.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=r;function m(b){switch(b){case"trace":return _.Trace;case"debug":return _.Debug;case"info":return _.Info;case"warn":return _.Warning;case"error":return _.Error;case"critical":return _.Critical;case"off":return _.Off}}e.parseLogLevel=m;function a(b){switch(b){case _.Trace:return"trace";case _.Debug:return"debug";case _.Info:return"info";case _.Warning:return"warn";case _.Error:return"error";case _.Critical:return"critical";case _.Off:return"off"}}e.LogLevelToString=a}),define(fe[190],me([0,1,43,11]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function y(_,D,T,I,c){try{const p=await new Promise((v,S)=>{Y(["spdlog"],v,S)});p.setFlushOn(L.LogLevel.Trace);const f=await p.createAsyncRotatingLogger(_,D,T,I);return c&&f.clearFormatters(),f}catch(p){console.error(p)}return null}function C(_,D,T,I){const c=Y.__$__nodeRequire("spdlog");return c.setFlushOn(L.LogLevel.Trace),c.createRotatingLogger(_,D,T,I)}e.createRotatingLogger=C;function i(_,D,T){switch(D){case L.LogLevel.Trace:_.trace(T);break;case L.LogLevel.Debug:_.debug(T);break;case L.LogLevel.Info:_.info(T);break;case L.LogLevel.Warning:_.warn(T);break;case L.LogLevel.Error:_.error(T);break;case L.LogLevel.Critical:_.critical(T);break;default:throw new Error("Invalid log level")}}class k extends L.AbstractMessageLogger{constructor(D,T,I,c,p){super();this.buffer=[],this.setLevel(p),this._loggerCreationPromise=this._createSpdLogLogger(D,T,I,c),this._register(this.onDidChangeLogLevel(f=>{this._logger&&this._logger.setLevel(f)}))}async _createSpdLogLogger(D,T,I,c){const p=I?6:1,f=30/p*g.ByteSize.MB,v=await y(D,T,f,p,c);if(v){this._logger=v,this._logger.setLevel(this.getLevel());for(const{level:S,message:P}of this.buffer)i(this._logger,S,P);this.buffer=[]}}log(D,T){this._logger?i(this._logger,D,T):this.getLevel()<=D&&this.buffer.push({level:D,message:T})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=k}),define(fe[116],me([0,1,50,161,4]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var C;(function(_){_[_.Unnecessary=1]="Unnecessary",_[_.Deprecated=2]="Deprecated"})(C=e.MarkerTag||(e.MarkerTag={}));var i;(function(_){_[_.Hint=1]="Hint",_[_.Info=2]="Info",_[_.Warning=4]="Warning",_[_.Error=8]="Error"})(i=e.MarkerSeverity||(e.MarkerSeverity={})),function(_){function D(f,v){return v-f}_.compare=D;const T=Object.create(null);T[_.Error]=(0,L.localize)(0,null),T[_.Warning]=(0,L.localize)(1,null),T[_.Info]=(0,L.localize)(2,null);function I(f){return T[f]||""}_.toString=I;function c(f){switch(f){case g.default.Error:return _.Error;case g.default.Warning:return _.Warning;case g.default.Info:return _.Info;case g.default.Ignore:return _.Hint}}_.fromSeverity=c;function p(f){switch(f){case _.Error:return g.default.Error;case _.Warning:return g.default.Warning;case _.Info:return g.default.Info;case _.Hint:return g.default.Ignore}}_.toSeverity=p}(i=e.MarkerSeverity||(e.MarkerSeverity={}));var k;(function(_){const D="";function T(c){return I(c,!0)}_.makeKey=T;function I(c,p){let f=[D];return c.source?f.push(c.source.replace("\xA6","\\\xA6")):f.push(D),c.code?typeof c.code=="string"?f.push(c.code.replace("\xA6","\\\xA6")):f.push(c.code.value.replace("\xA6","\\\xA6")):f.push(D),c.severity!==void 0&&c.severity!==null?f.push(i.toString(c.severity)):f.push(D),c.message&&p?f.push(c.message.replace("\xA6","\\\xA6")):f.push(D),c.startLineNumber!==void 0&&c.startLineNumber!==null?f.push(c.startLineNumber.toString()):f.push(D),c.startColumn!==void 0&&c.startColumn!==null?f.push(c.startColumn.toString()):f.push(D),c.endLineNumber!==void 0&&c.endLineNumber!==null?f.push(c.endLineNumber.toString()):f.push(D),c.endColumn!==void 0&&c.endColumn!==null?f.push(c.endColumn.toString()):f.push(D),f.push(D),f.join("\xA6")}_.makeKeyOptionalMessage=I})(k=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,y.createDecorator)("markerService")}),define(fe[191],me([0,1,3,50,4]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=L.default,e.INotificationService=(0,y.createDecorator)("notificationService");var C;(function(D){D[D.WORKSPACE=0]="WORKSPACE",D[D.GLOBAL=1]="GLOBAL"})(C=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var i;(function(D){D[D.OFF=0]="OFF",D[D.SILENT=1]="SILENT",D[D.ERROR=2]="ERROR"})(i=e.NotificationsFilter||(e.NotificationsFilter={}));class k{constructor(){this.progress=new _,this.onDidClose=g.Event.None,this.onDidChangeVisibility=g.Event.None}updateSeverity(T){}updateMessage(T){}updateActions(T){}close(){}}e.NoOpNotification=k;class _{infinite(){}done(){}total(T){}worked(T){}}e.NoOpProgress=_}),define(fe[192],me([0,1,6,8,2,4]),function(Y,e,g,L,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,C.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return g.Disposable.None},registerValidator(){return g.Disposable.None},registerExternalUriResolver(){return g.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return g.Disposable.None},async open(){return!1},async resolveExternalUri(_){return{resolved:_,dispose(){}}}});function i(_,D){return y.URI.isUri(_)?(0,L.equalsIgnoreCase)(_.scheme,D):(0,L.startsWithIgnoreCase)(_,D+":")}e.matchesScheme=i;function k(_,...D){return D.some(T=>i(_,T))}e.matchesSomeScheme=k}),define(fe[193],me([0,1,10,12,38,23]),function(Y,e,g,L,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let i;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const k=L.globals.vscode.context.configuration();if(k)i=k.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof Y?.__$__nodeRequire=="function"){const k=(0,C.dirname)(g.FileAccess.asFileUri("",Y));i=Y.__$__nodeRequire((0,C.joinPath)(k,"product.json").fsPath);const _=Y.__$__nodeRequire((0,C.joinPath)(k,"package.json").fsPath);y.env.VSCODE_DEV&&Object.assign(i,{nameShort:`${i.nameShort} Dev`,nameLong:`${i.nameLong} Dev`,dataFolderName:`${i.dataFolderName}-dev`}),Object.assign(i,{version:_.version})}else i={},Object.keys(i).length===0&&Object.assign(i,{version:"1.63.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=i});var $e=this&&this.__param||function(Y,e){return function(g,L){e(g,L,Y)}};define(fe[117],me([0,1,16,21,6,4]),function(Y,e,g,L,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,C.createDecorator)("progressService");var i;(function(T){T[T.Explorer=1]="Explorer",T[T.Scm=3]="Scm",T[T.Extensions=5]="Extensions",T[T.Window=10]="Window",T[T.Notification=15]="Notification",T[T.Dialog=20]="Dialog"})(i=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class k{constructor(I){this.callback=I}get value(){return this._value}report(I){this._value=I,this.callback(this._value)}}e.Progress=k,k.None=Object.freeze({report(){}});let _=class extends y.Disposable{constructor(I,c){super();this.deferred=new g.DeferredPromise,c.withProgress(I,p=>(this.reporter=p,this.lastStep&&p.report(this.lastStep),this.deferred.p)),this._register((0,y.toDisposable)(()=>this.deferred.complete()))}report(I){this.reporter?this.reporter.report(I):this.lastStep=I}};_=Ve([$e(1,e.IProgressService)],_),e.UnmanagedProgress=_;class D extends y.Disposable{constructor(I){super();this.progressIndicator=I,this.currentOperationId=0,this.currentOperationDisposables=this._register(new y.DisposableStore)}start(I){this.stop();const c=++this.currentOperationId,p=new L.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{c===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},I),this.currentOperationDisposables.add((0,y.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,y.toDisposable)(()=>p.cancel())),this.currentOperationDisposables.add((0,y.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:c,token:p.token,stop:()=>this.doStop(c),isCurrent:()=>this.currentOperationId===c}}stop(){this.doStop(this.currentOperationId)}doStop(I){this.currentOperationId===I&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=D,e.IEditorProgressService=(0,C.createDecorator)("editorProgressService")}),define(fe[35],me([0,1,58,13]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class y{constructor(){this.data=new Map}add(i,k){g.ok(L.isString(i)),g.ok(L.isObject(k)),g.ok(!this.data.has(i),"There is already an extension with this id"),this.data.set(i,k)}knows(i){return this.data.has(i)}as(i){return this.data.get(i)||null}}e.Registry=new y}),define(fe[118],me([0,1,3,35]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function y(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class C{constructor(){this._onDidChangeSchema=new g.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(_,D){this.schemasById[y(_)]=D,this._onDidChangeSchema.fire(_)}notifySchemaChanged(_){this._onDidChangeSchema.fire(_)}getSchemaContributions(){return{schemas:this.schemasById}}}const i=new C;L.Registry.add(e.Extensions.JSONContribution,i)}),define(fe[87],me([0,1,15,3,13,156,118,35]),function(Y,e,g,L,y,C,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var _;(function(w){w.Multiline="multilineText",w.Singleline="singlelineText"})(_=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var D;(function(w){w[w.APPLICATION=1]="APPLICATION",w[w.MACHINE=2]="MACHINE",w[w.WINDOW=3]="WINDOW",w[w.RESOURCE=4]="RESOURCE",w[w.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",w[w.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(D=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const T=k.Registry.as(i.Extensions.JSONContribution);class I{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new L.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new L.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:C.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},T.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(s,r=!0){this.registerConfigurations([s],r)}registerConfigurations(s,r=!0){const m=this.doRegisterConfigurations(s,r);T.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(m)}deregisterConfigurations(s){const r=this.doDeregisterConfigurations(s);T.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(r)}updateConfigurations({add:s,remove:r}){const m=[];m.push(...this.doDeregisterConfigurations(r)),m.push(...this.doRegisterConfigurations(s,!1)),T.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,g.distinct)(m))}registerDefaultConfigurations(s){const r=[],m=[];for(const a of s)for(const b in a)if(r.push(b),e.OVERRIDE_PROPERTY_PATTERN.test(b)){this.defaultValues[b]={...this.defaultValues[b]||{},...a[b]};const n={type:"object",default:this.defaultValues[b],description:C.localize(1,null,b),$ref:e.resourceLanguageSettingsSchemaId};m.push(p(b)),this.configurationProperties[b]=n,this.defaultLanguageConfigurationOverridesNode.properties[b]=n}else{this.defaultValues[b]=a[b];const n=this.configurationProperties[b];n&&(this.updatePropertyDefaultValue(b,n),this.updateSchema(b,n))}this.registerOverrideIdentifiers(m),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(r)}deregisterDefaultConfigurations(s){const r=[];for(const m of s)for(const a in m)if(r.push(a),delete this.defaultValues[a],e.OVERRIDE_PROPERTY_PATTERN.test(a))delete this.configurationProperties[a],delete this.defaultLanguageConfigurationOverridesNode.properties[a];else{const b=this.configurationProperties[a];b&&(this.updatePropertyDefaultValue(a,b),this.updateSchema(a,b))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(r)}notifyConfigurationSchemaUpdated(...s){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(s){for(const r of s)this.overrideIdentifiers.add(r);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(s,r){const m=[];return s.forEach(a=>{m.push(...this.validateAndRegisterProperties(a,r,a.extensionInfo)),this.configurationContributors.push(a),this.registerJSONConfiguration(a)}),m}doDeregisterConfigurations(s){const r=[],m=a=>{if(a.properties)for(const b in a.properties)r.push(b),delete this.configurationProperties[b],this.removeFromSchema(b,a.properties[b]);a.allOf&&a.allOf.forEach(b=>m(b))};for(const a of s){m(a);const b=this.configurationContributors.indexOf(a);b!==-1&&this.configurationContributors.splice(b,1)}return r}validateAndRegisterProperties(s,r=!0,m,a=3){a=y.isUndefinedOrNull(s.scope)?a:s.scope;let b=[],n=s.properties;if(n)for(let l in n){if(r&&S(l)){delete n[l];continue}const d=n[l];if(this.updatePropertyDefaultValue(l,d),e.OVERRIDE_PROPERTY_PATTERN.test(l)?d.scope=void 0:(d.scope=y.isUndefinedOrNull(d.scope)?a:d.scope,d.restricted=y.isUndefinedOrNull(d.restricted)?!!m?.restrictedConfigurations?.includes(l):d.restricted),n[l].hasOwnProperty("included")&&!n[l].included){this.excludedConfigurationProperties[l]=n[l],delete n[l];continue}else this.configurationProperties[l]=n[l];!n[l].deprecationMessage&&n[l].markdownDeprecationMessage&&(n[l].deprecationMessage=n[l].markdownDeprecationMessage),b.push(l)}let t=s.allOf;if(t)for(let l of t)b.push(...this.validateAndRegisterProperties(l,r,m,a));return b}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(s){const r=m=>{let a=m.properties;if(a)for(const n in a)this.updateSchema(n,a[n]);let b=m.allOf;b&&b.forEach(r)};r(s)}updateSchema(s,r){switch(e.allSettings.properties[s]=r,r.scope){case 1:e.applicationSettings.properties[s]=r;break;case 2:e.machineSettings.properties[s]=r;break;case 6:e.machineOverridableSettings.properties[s]=r;break;case 3:e.windowSettings.properties[s]=r;break;case 4:e.resourceSettings.properties[s]=r;break;case 5:e.resourceSettings.properties[s]=r,this.resourceLanguageSettingsSchema.properties[s]=r;break}}removeFromSchema(s,r){switch(delete e.allSettings.properties[s],r.scope){case 1:delete e.applicationSettings.properties[s];break;case 2:delete e.machineSettings.properties[s];break;case 6:delete e.machineOverridableSettings.properties[s];break;case 3:delete e.windowSettings.properties[s];break;case 4:case 5:delete e.resourceSettings.properties[s];break}}updateOverridePropertyPatternKey(){for(const s of this.overrideIdentifiers.values()){const r=`[${s}]`,m={type:"object",description:C.localize(2,null),errorMessage:C.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(r,m),e.allSettings.properties[r]=m,e.applicationSettings.properties[r]=m,e.machineSettings.properties[r]=m,e.machineOverridableSettings.properties[r]=m,e.windowSettings.properties[r]=m,e.resourceSettings.properties[r]=m}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(s,r){let m=this.defaultValues[s];y.isUndefined(m)&&(m=r.default),y.isUndefined(m)&&(m=f(r.type)),r.default=m}}const c="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(c);function p(w){return w.substring(1,w.length-1)}e.overrideIdentifierFromKey=p;function f(w){switch(Array.isArray(w)?w[0]:w){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=f;const v=new I;k.Registry.add(e.Extensions.Configuration,v);function S(w){return w.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(w)?C.localize(5,null,w):v.getConfigurationProperties()[w]!==void 0?C.localize(6,null,w):null:C.localize(4,null)}e.validateProperty=S;function P(){const w=[],s=v.getConfigurationProperties();for(const r of Object.keys(s))w.push([r,s[r].scope]);return w.push(["launch",4]),w.push(["task",4]),w}e.getScopes=P}),define(fe[119],me([0,1,13,2,87,4,35]),function(Y,e,g,L,y,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,C.createDecorator)("configurationService");function k(m){return m&&typeof m=="object"&&(!m.overrideIdentifier||typeof m.overrideIdentifier=="string")&&(!m.resource||m.resource instanceof L.URI)}e.isConfigurationOverrides=k;var _;(function(m){m[m.USER=1]="USER",m[m.USER_LOCAL=2]="USER_LOCAL",m[m.USER_REMOTE=3]="USER_REMOTE",m[m.WORKSPACE=4]="WORKSPACE",m[m.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",m[m.DEFAULT=6]="DEFAULT",m[m.MEMORY=7]="MEMORY"})(_=e.ConfigurationTarget||(e.ConfigurationTarget={}));function D(m){switch(m){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=D;function T(m,a){const b=[];for(const n of Object.keys(m))if(y.OVERRIDE_PROPERTY_PATTERN.test(n)){const t={};for(const l in m[n])t[l]=m[n][l];b.push({identifiers:[(0,y.overrideIdentifierFromKey)(n).trim()],keys:Object.keys(t),contents:I(t,a)})}return b}e.toOverrides=T;function I(m,a){const b=Object.create(null);for(let n in m)c(b,n,m[n],a);return b}e.toValuesTree=I;function c(m,a,b,n){const t=a.split("."),l=t.pop();let d=m;for(let o=0;o<t.length;o++){let h=t[o],u=d[h];switch(typeof u){case"undefined":u=d[h]=Object.create(null);break;case"object":break;default:n(`Ignoring ${a} as ${t.slice(0,o+1).join(".")} is ${JSON.stringify(u)}`);return}d=u}if(typeof d=="object"&&d!==null)try{d[l]=b}catch(o){n(`Ignoring ${a} as ${t.join(".")} is ${JSON.stringify(d)}`)}else n(`Ignoring ${a} as ${t.join(".")} is ${JSON.stringify(d)}`)}e.addToValueTree=c;function p(m,a){const b=a.split(".");f(m,b)}e.removeFromValueTree=p;function f(m,a){const b=a.shift();if(a.length===0){delete m[b];return}if(Object.keys(m).indexOf(b)!==-1){const n=m[b];typeof n=="object"&&!Array.isArray(n)&&(f(n,a),Object.keys(n).length===0&&delete m[b])}}function v(m,a,b){function n(d,o){let h=d;for(const u of o){if(typeof h!="object"||h===null)return;h=h[u]}return h}const t=a.split("."),l=n(m,t);return typeof l=="undefined"?b:l}e.getConfigurationValue=v;function S(m,a,b){Object.keys(a).forEach(n=>{n!=="__proto__"&&(n in m?g.isObject(m[n])&&g.isObject(a[n])?S(m[n],a[n],b):b&&(m[n]=a[n]):m[n]=a[n])})}e.merge=S;function P(){const m=i.Registry.as(y.Extensions.Configuration).getConfigurationProperties();return Object.keys(m)}e.getConfigurationKeys=P;function w(){const m=Object.create(null),a=i.Registry.as(y.Extensions.Configuration).getConfigurationProperties();for(let b in a){let n=a[b].default;c(m,b,n,t=>console.error(`Conflict in default settings: ${t}`))}return m}e.getDefaultValues=w;function s(m){return`[${m}]`}e.keyFromOverrideIdentifier=s;function r(m,a,b){const n=m.inspect(a),t=m.inspect(b);return typeof n.userValue!="undefined"||typeof n.workspaceValue!="undefined"||typeof n.workspaceFolderValue!="undefined"?n.value:typeof t.userValue!="undefined"||typeof t.workspaceValue!="undefined"||typeof t.workspaceFolderValue!="undefined"?t.value:n.defaultValue}e.getMigratedSettingValue=r}),define(fe[194],me([0,1,15,3,61,6,24,25,13,2,119,87,35]),function(Y,e,g,L,y,C,i,k,_,D,T,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class p{constructor(n={},t=[],l=[]){this._contents=n,this._keys=t,this._overrides=l,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(n){return n?(0,T.getConfigurationValue)(this.contents,n):this.contents}getOverrideValue(n,t){const l=this.getContentsForOverrideIdentifer(t);return l?n?(0,T.getConfigurationValue)(l,n):l:void 0}getKeysForOverrideIdentifier(n){const t=[];for(const l of this.overrides)l.identifiers.includes(n)&&t.push(...l.keys);return g.distinct(t)}getAllOverrideIdentifiers(){const n=[];for(const t of this.overrides)n.push(...t.identifiers);return g.distinct(n)}override(n){let t=this.overrideConfigurations.get(n);return t||(t=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,t)),t}merge(...n){const t=k.deepClone(this.contents),l=k.deepClone(this.overrides),d=[...this.keys];for(const o of n){this.mergeContents(t,o.contents);for(const h of o.overrides){const[u]=l.filter(E=>g.equals(E.identifiers,h.identifiers));u?(this.mergeContents(u.contents,h.contents),u.keys.push(...h.keys),u.keys=g.distinct(u.keys)):l.push(k.deepClone(h))}for(const h of o.keys)d.indexOf(h)===-1&&d.push(h)}return new p(t,d,l)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(n){const t=this.getContentsForOverrideIdentifer(n);if(!t||typeof t!="object"||!Object.keys(t).length)return this;let l={};for(const d of g.distinct([...Object.keys(this.contents),...Object.keys(t)])){let o=this.contents[d],h=t[d];h&&(typeof o=="object"&&typeof h=="object"?(o=k.deepClone(o),this.mergeContents(o,h)):o=h),l[d]=o}return new p(l,this.keys,this.overrides)}mergeContents(n,t){for(const l of Object.keys(t)){if(l in n&&_.isObject(n[l])&&_.isObject(t[l])){this.mergeContents(n[l],t[l]);continue}n[l]=k.deepClone(t[l])}}checkAndFreeze(n){return this.isFrozen&&!Object.isFrozen(n)?k.deepFreeze(n):n}getContentsForOverrideIdentifer(n){let t=null,l=null;const d=o=>{o&&(l?this.mergeContents(l,o):l=o)};for(const o of this.overrides)g.equals(o.identifiers,[n])?t=o.contents:o.identifiers.includes(n)&&d(o.contents);return d(t),l}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(n,t){this.addKey(n),(0,T.addToValueTree)(this.contents,n,t,l=>{throw new Error(l)})}removeValue(n){this.removeKey(n)&&(0,T.removeFromValueTree)(this.contents,n)}addKey(n){let t=this.keys.length;for(let l=0;l<t;l++)n.indexOf(this.keys[l])===0&&(t=l);this.keys.splice(t,1,n)}removeKey(n){let t=this.keys.indexOf(n);return t!==-1?(this.keys.splice(t,1),!0):!1}}e.ConfigurationModel=p;class f extends p{constructor(){const n=(0,T.getDefaultValues)(),t=(0,T.getConfigurationKeys)(),l=[];for(const d of Object.keys(n))I.OVERRIDE_PROPERTY_PATTERN.test(d)&&l.push({identifiers:[(0,I.overrideIdentifierFromKey)(d).trim()],keys:Object.keys(n[d]),contents:(0,T.toValuesTree)(n[d],o=>console.error(`Conflict in default settings file: ${o}`))});super(n,t,l)}}e.DefaultConfigurationModel=f;class v{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new p}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,t){if(!_.isUndefinedOrNull(n)){const l=this.doParseContent(n);this.parseRaw(l,t)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,t){this._raw=n;const{contents:l,keys:d,overrides:o,restricted:h}=this.doParseRaw(n,t);this._configurationModel=new p(l,d,o),this._restrictedConfigurations=h||[]}doParseContent(n){let t={},l=null,d=[],o=[],h=[];function u(A){Array.isArray(d)?d.push(A):l!==null&&(d[l]=A)}let E={onObjectBegin:()=>{let A={};u(A),o.push(d),d=A,l=null},onObjectProperty:A=>{l=A},onObjectEnd:()=>{d=o.pop()},onArrayBegin:()=>{let A=[];u(A),o.push(d),d=A,l=null},onArrayEnd:()=>{d=o.pop()},onLiteralValue:u,onError:(A,R,B)=>{h.push({error:A,offset:R,length:B})}};if(n)try{y.visit(n,E),t=d[0]||{}}catch(A){console.error(`Error while parsing settings file ${this._name}: ${A}`),this._parseErrors=[A]}return t}doParseRaw(n,t){const l=c.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),d=this.filter(n,l,!0,t);n=d.raw;const o=(0,T.toValuesTree)(n,E=>console.error(`Conflict in settings file ${this._name}: ${E}`)),h=Object.keys(n),u=(0,T.toOverrides)(n,E=>console.error(`Conflict in settings file ${this._name}: ${E}`));return{contents:o,keys:h,overrides:u,restricted:d.restricted}}filter(n,t,l,d){if(!d?.scopes&&!d?.skipRestricted)return{raw:n,restricted:[]};const o={},h=[];for(let u in n)if(I.OVERRIDE_PROPERTY_PATTERN.test(u)&&l){const E=this.filter(n[u],t,!1,d);o[u]=E.raw,h.push(...E.restricted)}else{const E=t[u],A=E?typeof E.scope!="undefined"?E.scope:3:void 0;E?.restricted&&h.push(u),(A===void 0||d.scopes===void 0||d.scopes.includes(A))&&(d.skipRestricted&&E?.restricted||(o[u]=n[u]))}return{raw:o,restricted:h}}}e.ConfigurationModelParser=v;class S extends C.Disposable{constructor(n,t,l,d){super();this.userSettingsResource=n,this.scopes=t,this.fileService=d,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new v(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(l.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(L.Event.filter(this.fileService.onDidFilesChange,o=>o.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(n){return new p}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=S;class P{constructor(n,t,l=new p,d=new p,o=new i.ResourceMap,h=new p,u=new i.ResourceMap,E=!0){this._defaultConfiguration=n,this._localUserConfiguration=t,this._remoteUserConfiguration=l,this._workspaceConfiguration=d,this._folderConfigurations=o,this._memoryConfiguration=h,this._memoryConfigurationByResource=u,this._freeze=E,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new i.ResourceMap,this._userConfiguration=null}getValue(n,t,l){return this.getConsolidateConfigurationModel(t,l).getValue(n)}updateValue(n,t,l={}){let d;l.resource?(d=this._memoryConfigurationByResource.get(l.resource),d||(d=new p,this._memoryConfigurationByResource.set(l.resource,d))):d=this._memoryConfiguration,t===void 0?d.removeValue(n):d.setValue(n,t),l.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,t,l){const d=this.getConsolidateConfigurationModel(t,l),o=this.getFolderConfigurationModelForResource(t.resource,l),h=t.resource?this._memoryConfigurationByResource.get(t.resource)||this._memoryConfiguration:this._memoryConfiguration,u=t.overrideIdentifier?this._defaultConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this._defaultConfiguration.freeze().getValue(n),E=t.overrideIdentifier?this.userConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this.userConfiguration.freeze().getValue(n),A=t.overrideIdentifier?this.localUserConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this.localUserConfiguration.freeze().getValue(n),R=t.overrideIdentifier?this.remoteUserConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this.remoteUserConfiguration.freeze().getValue(n),B=l?t.overrideIdentifier?this._workspaceConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this._workspaceConfiguration.freeze().getValue(n):void 0,x=o?t.overrideIdentifier?o.freeze().override(t.overrideIdentifier).getValue(n):o.freeze().getValue(n):void 0,F=t.overrideIdentifier?h.override(t.overrideIdentifier).getValue(n):h.getValue(n),$=d.getValue(n),M=g.distinct(g.flatten(d.overrides.map(H=>H.identifiers))).filter(H=>d.getOverrideValue(n,H)!==void 0);return{defaultValue:u,userValue:E,userLocalValue:A,userRemoteValue:R,workspaceValue:B,workspaceFolderValue:x,memoryValue:F,value:$,default:u!==void 0?{value:this._defaultConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,user:E!==void 0?{value:this.userConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,userLocal:A!==void 0?{value:this.localUserConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,userRemote:R!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,workspace:B!==void 0?{value:this._workspaceConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,workspaceFolder:x!==void 0?{value:o?.freeze().getValue(n),override:t.overrideIdentifier?o?.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,memory:F!==void 0?{value:h.getValue(n),override:t.overrideIdentifier?h.getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,overrideIdentifiers:M.length?M:void 0}}keys(n){const t=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,t){this._folderConfigurations.set(n,t),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,t){const l=[];for(const d of t)if(I.OVERRIDE_PROPERTY_PATTERN.test(d)){const o=(0,I.overrideIdentifierFromKey)(d),h=this._defaultConfiguration.getKeysForOverrideIdentifier(o),u=n.getKeysForOverrideIdentifier(o),E=[...u.filter(A=>h.indexOf(A)===-1),...h.filter(A=>u.indexOf(A)===-1),...h.filter(A=>!k.equals(this._defaultConfiguration.override(o).getValue(A),n.override(o).getValue(A)))];l.push([o,E])}return this.updateDefaultConfiguration(n),{keys:t,overrides:l}}compareAndUpdateLocalUserConfiguration(n){const{added:t,updated:l,removed:d,overrides:o}=m(this.localUserConfiguration,n),h=[...t,...l,...d];return h.length&&this.updateLocalUserConfiguration(n),{keys:h,overrides:o}}compareAndUpdateRemoteUserConfiguration(n){const{added:t,updated:l,removed:d,overrides:o}=m(this.remoteUserConfiguration,n);let h=[...t,...l,...d];return h.length&&this.updateRemoteUserConfiguration(n),{keys:h,overrides:o}}compareAndUpdateWorkspaceConfiguration(n){const{added:t,updated:l,removed:d,overrides:o}=m(this.workspaceConfiguration,n);let h=[...t,...l,...d];return h.length&&this.updateWorkspaceConfiguration(n),{keys:h,overrides:o}}compareAndUpdateFolderConfiguration(n,t){const l=this.folderConfigurations.get(n),{added:d,updated:o,removed:h,overrides:u}=m(l,t);let E=[...d,...o,...h];return(E.length||!l)&&this.updateFolderConfiguration(n,t),{keys:E,overrides:u}}compareAndDeleteFolderConfiguration(n){const t=this.folderConfigurations.get(n);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:l,updated:d,removed:o,overrides:h}=m(t,void 0);return{keys:[...l,...d,...o],overrides:h}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(n,t){let l=this.getConsolidatedConfigurationModelForResource(n,t);return n.overrideIdentifier?l.override(n.overrideIdentifier):l}getConsolidatedConfigurationModelForResource({resource:n},t){let l=this.getWorkspaceConsolidatedConfiguration();if(t&&n){const d=t.getFolder(n);d&&(l=this.getFolderConsolidatedConfiguration(d.uri)||l);const o=this._memoryConfigurationByResource.get(n);o&&(l=l.merge(o))}return l}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let t=this._foldersConsolidatedConfigurations.get(n);if(!t){const l=this.getWorkspaceConsolidatedConfiguration(),d=this._folderConfigurations.get(n);d?(t=l.merge(d),this._freeze&&(t=t.freeze()),this._foldersConsolidatedConfigurations.set(n,t)):t=l}return t}getFolderConfigurationModelForResource(n,t){if(t&&n){const l=t.getFolder(n);if(l)return this._folderConfigurations.get(l.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,t)=>{const{contents:l,overrides:d,keys:o}=this._folderConfigurations.get(t);return n.push([t,{contents:l,overrides:d,keys:o}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.freeze().keys.forEach(t=>n.add(t)),this.userConfiguration.freeze().keys.forEach(t=>n.add(t)),this._workspaceConfiguration.freeze().keys.forEach(t=>n.add(t)),this._folderConfigurations.forEach(t=>t.freeze().keys.forEach(l=>n.add(l))),[...n.values()]}allOverrideIdentifiers(){const n=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this._folderConfigurations.forEach(t=>t.freeze().getAllOverrideIdentifiers().forEach(l=>n.add(l))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const t=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(l=>t.add(l)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(l=>t.add(l)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(l=>t.add(l)),this._folderConfigurations.forEach(l=>l.getKeysForOverrideIdentifier(n).forEach(d=>t.add(d))),[...t.values()]}static parse(n){const t=this.parseConfigurationModel(n.defaults),l=this.parseConfigurationModel(n.user),d=this.parseConfigurationModel(n.workspace),o=n.folders.reduce((h,u)=>(h.set(D.URI.revive(u[0]),this.parseConfigurationModel(u[1])),h),new i.ResourceMap);return new P(t,l,new p,d,o,new p,new i.ResourceMap,!1)}static parseConfigurationModel(n){return new p(n.contents,n.keys,n.overrides).freeze()}}e.Configuration=P;function w(...b){if(b.length===0)return{keys:[],overrides:[]};if(b.length===1)return b[0];const n=new Set,t=new Map;for(const d of b)d.keys.forEach(o=>n.add(o)),d.overrides.forEach(([o,h])=>{const u=(0,i.getOrSet)(t,o,new Set);h.forEach(E=>u.add(E))});const l=[];return t.forEach((d,o)=>l.push([o,[...d.values()]])),{keys:[...n.values()],overrides:l}}e.mergeChanges=w;class s{constructor(n,t,l,d){this.change=n,this.previous=t,this.currentConfiguraiton=l,this.currentWorkspace=d,this._previousConfiguration=void 0;const o=new Set;n.keys.forEach(u=>o.add(u)),n.overrides.forEach(([,u])=>u.forEach(E=>o.add(E))),this.affectedKeys=[...o.values()];const h=new p;this.affectedKeys.forEach(u=>h.setValue(u,{})),this.affectedKeysTree=h.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=P.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,t){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,n)){if(t){const l=this.previousConfiguration?this.previousConfiguration.getValue(n,t,this.previous?.workspace):void 0,d=this.currentConfiguraiton.getValue(n,t,this.currentWorkspace);return!k.equals(l,d)}return!0}return!1}doesAffectedKeysTreeContains(n,t){let l=(0,T.toValuesTree)({[t]:!0},()=>{}),d;for(;typeof l=="object"&&(d=Object.keys(l)[0]);){if(n=n[d],!n)return!1;l=l[d]}return!0}}e.ConfigurationChangeEvent=s;class r extends s{constructor(n,t,l,d){super({keys:n.allKeys(),overrides:[]},void 0,n,t);this.source=l,this.sourceConfig=d}}e.AllKeysConfigurationChangeEvent=r;function m(b,n){const{added:t,removed:l,updated:d}=a(n,b),o=[],h=b?.getAllOverrideIdentifiers()||[],u=n?.getAllOverrideIdentifiers()||[];if(n){const E=u.filter(A=>!h.includes(A));for(const A of E)o.push([A,n.getKeysForOverrideIdentifier(A)])}if(b){const E=h.filter(A=>!u.includes(A));for(const A of E)o.push([A,b.getKeysForOverrideIdentifier(A)])}if(n&&b){for(const E of h)if(u.includes(E)){const A=a({contents:b.getOverrideValue(void 0,E)||{},keys:b.getKeysForOverrideIdentifier(E)},{contents:n.getOverrideValue(void 0,E)||{},keys:n.getKeysForOverrideIdentifier(E)});o.push([E,[...A.added,...A.removed,...A.updated]])}}return{added:t,removed:l,updated:d,overrides:o}}function a(b,n){const t=b?n?b.keys.filter(o=>n.keys.indexOf(o)===-1):[...b.keys]:[],l=n?b?n.keys.filter(o=>b.keys.indexOf(o)===-1):[...n.keys]:[],d=[];if(b&&n){for(const o of n.keys)if(b.keys.indexOf(o)!==-1){const h=(0,T.getConfigurationValue)(n.contents,o),u=(0,T.getConfigurationValue)(b.contents,o);k.equals(h,u)||d.push(o)}}return{added:t,removed:l,updated:d}}}),define(fe[120],me([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,g.createDecorator)("remoteAuthorityResolverService");var L;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound"})(L=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class y extends Error{constructor(i,k=L.Unknown,_){super(i);this._message=i,this._code=k,this._detail=_,this.isHandled=k===L.NotAvailable&&_===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,y.prototype)}static isTemporarilyNotAvailable(i){return i instanceof y&&i._code===L.TemporarilyNotAvailable}static isNoResolverFound(i){return i instanceof y&&i._code===L.NoResolverFound}static isHandled(i){return i instanceof y&&i.isHandled}}e.RemoteAuthorityResolverError=y}),define(fe[64],me([0,1,10]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function L(D){return D.scheme===g.Schemas.vscodeRemote?D.authority:void 0}e.getRemoteAuthority=L;function y(D){if(!D)return;const T=D.indexOf("+");return T<0?D:D.substr(0,T)}e.getRemoteName=y;function C(D){return D.scheme!==g.Schemas.file&&D.scheme!==g.Schemas.vscodeRemote}e.isVirtualResource=C;function i(D){if(D.folders.length)return D.folders.every(T=>C(T.uri))?D.folders[0].uri:void 0;if(D.configuration&&C(D.configuration))return D.configuration}e.getVirtualWorkspaceLocation=i;function k(D){return i(D)?.scheme}e.getVirtualWorkspaceScheme=k;function _(D){return i(D)!==void 0}e.isVirtualWorkspace=_}),define(fe[27],me([0,1,8,4,64]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function C(c){if(typeof c=="object"&&c!==null&&c.supported!==!0)return c.description}e.getWorkspaceSupportTypeMessage=C;function i(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}e.isIExtensionIdentifier=i,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var k;(function(c){c[c.System=0]="System",c[c.User=1]="User"})(k=e.ExtensionType||(e.ExtensionType={}));class _{constructor(p){this.value=p,this._lower=p.toLowerCase()}static equals(p,f){if(typeof p=="undefined"||p===null)return typeof f=="undefined"||f===null;if(typeof f=="undefined"||f===null)return!1;if(typeof p=="string"||typeof f=="string"){let v=typeof p=="string"?p:p.value,S=typeof f=="string"?f:f.value;return g.equalsIgnoreCase(v,S)}return p._lower===f._lower}static toKey(p){return typeof p=="string"?p.toLowerCase():p._lower}}e.ExtensionIdentifier=_;function D(c){return c.contributes&&c.contributes.localizations?c.contributes.localizations.length>0:!1}e.isLanguagePackExtension=D;function T(c){return c.contributes&&c.contributes.authentication?c.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=T;function I(c,p){if(p){const f=`onResolveRemoteAuthority:${(0,y.getRemoteName)(p)}`;return c.activationEvents?.indexOf(f)!==-1}return!1}e.isResolverExtension=I,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(fe[195],me([0,1,8,27]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function y(f,v){return f.uuid&&v.uuid?f.uuid===v.uuid:f.id===v.id?!0:(0,g.compareIgnoreCase)(f.id,v.id)===0}e.areSameExtensions=y;class C{constructor(v,S){this.version=S,this.id=v.id,this.uuid=v.uuid}key(){return`${this.id}-${this.version}`}equals(v){return v instanceof C?y(this,v)&&this.version===v.version:!1}}e.ExtensionIdentifierWithVersion=C;function i(f,v){return`${f}.${v}`}e.getExtensionId=i;function k(f){return f.toLocaleLowerCase()}e.adoptToGalleryExtensionId=k;function _(f,v){return k(i(f,v))}e.getGalleryExtensionId=_;function D(f,v){const S=[],P=w=>{for(const s of S)if(s.some(r=>y(v(r),v(w))))return s;return null};for(const w of f){const s=P(w);s?s.push(w):S.push([w])}return S}e.groupByExtension=D;function T(f){return{id:f.identifier.id,name:f.manifest.name,galleryId:null,publisherId:f.publisherId,publisherName:f.manifest.publisher,publisherDisplayName:f.publisherDisplayName,dependencies:f.manifest.extensionDependencies&&f.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=T;function I(f){return{id:f.identifier.id,name:f.name,galleryId:f.identifier.uuid,publisherId:f.publisherId,publisherName:f.publisher,publisherDisplayName:f.publisherDisplayName,dependencies:!!(f.properties.dependencies&&f.properties.dependencies.length>0),...f.telemetryData}}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function c(f){const v=new Set;for(const S of f)S.malicious&&v.add(S.id.id);return v}e.getMaliciousExtensionsSet=c;function p(f,v){const S=[],P=v.manifest.extensionDependencies?.slice(0)??[];for(;P.length;){const w=P.shift();if(w&&S.every(s=>!y(s.identifier,{id:w}))){const s=f.filter(r=>y(r.identifier,{id:w}));s.length===1&&(S.push(s[0]),P.push(...s[0].manifest.extensionDependencies?.slice(0)??[]))}}return S}e.getExtensionDependencies=p}),define(fe[121],me([0,1,3,12,4,11]),function(Y,e,g,L,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,y.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,y.createDecorator)("sharedTunnelsService");var i;(function(f){f.Http="http",f.Https="https"})(i=e.TunnelProtocol||(e.TunnelProtocol={}));var k;(function(f){f.ConstantPrivate="constantPrivate",f.Private="private",f.Public="public"})(k=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var _;(function(f){f[f.Notify=1]="Notify",f[f.OpenBrowser=2]="OpenBrowser",f[f.OpenPreview=3]="OpenPreview",f[f.Silent=4]="Silent",f[f.Ignore=5]="Ignore",f[f.OpenBrowserOnce=6]="OpenBrowserOnce"})(_=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function D(f){if(f.scheme!=="http"&&f.scheme!=="https")return;const v=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(f.authority);if(!!v)return{address:v[1],port:+v[2]}}e.extractLocalHostUriMetaDataForPortMapping=D,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function T(f){return e.LOCALHOST_ADDRESSES.indexOf(f)>=0}e.isLocalhost=T,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function I(f){return e.ALL_INTERFACES_ADDRESSES.indexOf(f)>=0}e.isAllInterfaces=I;function c(f,v){return v?v!==1&&f<1024:!L.isWindows&&f<1024}e.isPortPrivileged=c;let p=class{constructor(v){this.logService=v,this._onTunnelOpened=new g.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new g.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new g.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(v,S){return this._tunnelProvider=v,v?(this._canElevate=S.elevation,this._privacyOptions=S.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const v=[],S=Array.from(this._tunnels.values());for(let P of S){const w=Array.from(P.values());for(let s of w){const r=await s.value;r&&v.push(r)}}return v}async dispose(){for(const v of this._tunnels.values()){for(const{value:S}of v.values())await S.then(P=>P?.dispose());v.clear()}this._tunnels.clear()}openTunnel(v,S,P,w,s=!1,r=k.Private,m){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${S}:${P} on local port ${w}.`),!v)return;S||(S="localhost");const a=this.retainOrCreateTunnel(v,S,P,w,s,r,m);return a?a.then(b=>{if(!b){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(S,P);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const n=this.makeTunnel(b);return(b.tunnelRemoteHost!==S||b.tunnelRemotePort!==P)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(n),n}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),a)}makeTunnel(v){return{tunnelRemotePort:v.tunnelRemotePort,tunnelRemoteHost:v.tunnelRemoteHost,tunnelLocalPort:v.tunnelLocalPort,localAddress:v.localAddress,privacy:v.privacy,protocol:v.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${v.tunnelRemoteHost}:${v.tunnelRemotePort} `);const S=this._tunnels.get(v.tunnelRemoteHost);if(S){const P=S.get(v.tunnelRemotePort);P&&(P.refcount--,await this.tryDisposeTunnel(v.tunnelRemoteHost,v.tunnelRemotePort,P))}}}}async tryDisposeTunnel(v,S,P){if(P.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${v}:${S}.`);const w=P.value.then(async s=>{s&&(await s.dispose(!0),this._onTunnelClosed.fire({host:s.tunnelRemoteHost,port:s.tunnelRemotePort}))});return this._tunnels.has(v)&&this._tunnels.get(v).delete(S),w}}async closeTunnel(v,S){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${v}:${S} `);const P=this._tunnels.get(v);if(P&&P.has(S)){const w=P.get(S);w.refcount=0,await this.tryDisposeTunnel(v,S,w)}}addTunnelToMap(v,S,P){this._tunnels.has(v)||this._tunnels.set(v,new Map),this._tunnels.get(v).set(S,{refcount:1,value:P})}async removeEmptyTunnelFromMap(v,S){const P=this._tunnels.get(v);P&&(await P.get(S)||P.delete(S),P.size===0&&this._tunnels.delete(v))}getTunnelFromMap(v,S){let P=[v];T(v)?(P.push(...e.LOCALHOST_ADDRESSES),P.push(...e.ALL_INTERFACES_ADDRESSES)):I(v)&&P.push(...e.ALL_INTERFACES_ADDRESSES);const w=P.map(s=>this._tunnels.get(s));for(const s of w){const r=s?.get(S);if(r)return r}}canTunnel(v){return!!D(v)}createWithProvider(v,S,P,w,s,r,m){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${S}:${P} on local port ${w}.`);const b={elevationRequired:s?c(w===void 0?P:w):!1},n={remoteAddress:{host:S,port:P},localAddressPort:w,privacy:r,public:r!==k.Private,protocol:m},t=v.forwardPort(n,b);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),t&&this.addTunnelToMap(S,P,t),t}};p=Ve([$e(0,C.ILogService)],p),e.AbstractTunnelService=p}),define(fe[196],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class g{constructor(){this.validators=new Map}vsda(){return new Promise((y,C)=>Y(["vsda"],y,C))}async createNewMessage(y){try{const C=await this.vsda(),i=new C.validator;if(i){const k=String(g._nextId++);return this.validators.set(k,i),{id:k,data:i.createNewMessage(y)}}}catch(C){}return{id:"",data:y}}async validate(y,C){if(!y.id)return!0;const i=this.validators.get(y.id);if(!i)return!1;this.validators.delete(y.id);try{return i.validate(C)==="ok"}catch(k){return!1}}async sign(y){try{const C=await this.vsda(),i=new C.signer;if(i)return i.sign(y)}catch(C){}return y}}e.SignService=g,g._nextId=1}),define(fe[197],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class g{constructor(y){this._callback=y,this._terminalBufferMap=new Map}dispose(){for(const y of this._terminalBufferMap.values())y.dispose()}startBuffering(y,C,i=5){let k;return k=C(_=>{const D=typeof _=="string"?_:_.data;let T=this._terminalBufferMap.get(y);if(T){T.data.push(D);return}const I=setTimeout(()=>this.flushBuffer(y),i);T={data:[D],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(y),k.dispose()}},this._terminalBufferMap.set(y,T)}),k}stopBuffering(y){const C=this._terminalBufferMap.get(y);C&&C.dispose()}flushBuffer(y){const C=this._terminalBufferMap.get(y);C&&(this._terminalBufferMap.delete(y),this._callback(y,C.data.join("")))}}e.TerminalDataBufferer=g}),define(fe[198],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var g;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(g=e.ColorScheme||(e.ColorScheme={}))}),define(fe[65],me([0,1,48,3,6,4,35,198]),function(Y,e,g,L,y,C,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,C.createDecorator)("themeService");var _;(function(S){function P(w){return w&&typeof w=="object"&&typeof w.id=="string"}S.isThemeColor=P})(_=e.ThemeColor||(e.ThemeColor={}));function D(S){return{id:S}}e.themeColorFromId=D;var T;(function(S){function P(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color=="undefined"||_.isThemeColor(n.color))}S.isThemeIcon=P;const w=new RegExp(`^\\$\\((${g.CSSIcon.iconNameExpression}(?:${g.CSSIcon.iconModifierExpression})?)\\)$`);function s(n){const t=w.exec(n);if(!t)return;let[,l]=t;return{id:l}}S.fromString=s;function r(n,t){let l=n.id;const d=l.lastIndexOf("~");return d!==-1&&(l=l.substring(0,d)),t&&(l=`${l}~${t}`),{id:l}}S.modify=r;function m(n){const t=n.id.lastIndexOf("~");if(t!==-1)return n.id.substring(t+1)}S.getModifier=m;function a(n,t){return n.id===t.id&&n.color?.id===t.color?.id}S.isEqual=a;function b(n,t){return{id:n.id,color:t?D(t):void 0}}S.asThemeIcon=b,S.asClassNameArray=g.CSSIcon.asClassNameArray,S.asClassName=g.CSSIcon.asClassName,S.asCSSSelector=g.CSSIcon.asCSSSelector})(T=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=g.Codicon.file,e.FolderThemeIcon=g.Codicon.folder;function I(S){switch(S){case k.ColorScheme.DARK:return"vs-dark";case k.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=I,e.Extensions={ThemingContribution:"base.contributions.theming"};class c{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new L.Emitter}onColorThemeChange(P){return this.themingParticipants.push(P),this.onThemingParticipantAddedEmitter.fire(P),(0,y.toDisposable)(()=>{const w=this.themingParticipants.indexOf(P);this.themingParticipants.splice(w,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let p=new c;i.Registry.add(e.Extensions.ThemingContribution,p);function f(S){return p.onColorThemeChange(S)}e.registerThemingParticipant=f;class v extends y.Disposable{constructor(P){super();this.themeService=P,this.theme=P.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(w=>this.onThemeChange(w)))}onThemeChange(P){this.theme=P,this.updateStyles()}updateStyles(){}getColor(P,w){let s=this.theme.getColor(P);return s&&w&&(s=w(s,this.theme)),s?s.toString():null}}e.Themable=v}),define(fe[199],me([0,1,16,48,3,162,118,35,65]),function(Y,e,g,L,y,C,i,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class D{constructor(){this._onDidChange=new y.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,C.localize)(0,null)},fontCharacter:{type:"string",description:(0,C.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${L.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(P,w,s,r){const m=this.iconsById[P];if(m){if(s&&!m.description){m.description=s,this.iconSchema.properties[P].markdownDescription=`${s} $(${P})`;const n=this.iconReferenceSchema.enum.indexOf(P);n!==-1&&(this.iconReferenceSchema.enumDescriptions[n]=s),this._onDidChange.fire()}return m}let a={id:P,description:s,defaults:w,deprecationMessage:r};this.iconsById[P]=a;let b={$ref:"#/definitions/icons"};return r&&(b.deprecationMessage=r),s&&(b.markdownDescription=`${s}: $(${P})`),this.iconSchema.properties[P]=b,this.iconReferenceSchema.enum.push(P),this.iconReferenceSchema.enumDescriptions.push(s||""),this._onDidChange.fire(),{id:P}}deregisterIcon(P){delete this.iconsById[P],delete this.iconSchema.properties[P];const w=this.iconReferenceSchema.enum.indexOf(P);w!==-1&&(this.iconReferenceSchema.enum.splice(w,1),this.iconReferenceSchema.enumDescriptions.splice(w,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(P=>this.iconsById[P])}getIcon(P){return this.iconsById[P]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(P,w){const s=this.iconFontsById[P];if(s)return s;let r={id:P,definition:w};return this.iconFontsById[P]=r,this._onDidChange.fire(),r}deregisterIconFont(P){delete this.iconFontsById[P]}getIconFonts(){return Object.keys(this.iconFontsById).map(P=>this.iconFontsById[P])}getIconFont(P){return this.iconFontsById[P]}toString(){const P=(m,a)=>m.id.localeCompare(a.id),w=m=>{for(;_.ThemeIcon.isThemeIcon(m.defaults);)m=this.iconsById[m.defaults.id];return`codicon codicon-${m?m.id:""}`};let s=[];s.push("| preview     | identifier                        | default codicon ID                | description"),s.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const r=Object.keys(this.iconsById).map(m=>this.iconsById[m]);for(const m of r.filter(a=>!!a.description).sort(P))s.push(`|<i class="${w(m)}"></i>|${m.id}|${_.ThemeIcon.isThemeIcon(m.defaults)?m.defaults.id:m.id}|${m.description||""}|`);s.push("| preview     | identifier                        "),s.push("| ----------- | --------------------------------- |");for(const m of r.filter(a=>!_.ThemeIcon.isThemeIcon(a.defaults)).sort(P))s.push(`|<i class="${w(m)}"></i>|${m.id}|`);return s.join(`
`)}}const T=new D;k.Registry.add(e.Extensions.IconContribution,T);function I(S,P,w,s){return T.registerIcon(S,P,w,s)}e.registerIcon=I;function c(){return T}e.getIconRegistry=c;function p(){for(const S of L.iconRegistry.all)T.registerIcon(S.id,S.definition,S.description);L.iconRegistry.onDidRegister(S=>T.registerIcon(S.id,S.definition,S.description))}p(),e.iconsSchemaId="vscode://schemas/icons";let f=k.Registry.as(i.Extensions.JSONContribution);f.registerSchema(e.iconsSchemaId,T.getIconSchema());const v=new g.RunOnceScheduler(()=>f.notifySchemaChanged(e.iconsSchemaId),200);T.onDidChange(()=>{v.isScheduled()||v.schedule()}),e.widgetClose=I("widget-close",L.Codicon.close,(0,C.localize)(2,null)),e.gotoPreviousLocation=I("goto-previous-location",L.Codicon.arrowUp,(0,C.localize)(3,null)),e.gotoNextLocation=I("goto-next-location",L.Codicon.arrowDown,(0,C.localize)(4,null)),e.syncing=_.ThemeIcon.modify(L.Codicon.sync,"spin"),e.spinningLoading=_.ThemeIcon.modify(L.Codicon.loading,"spin")}),define(fe[44],me([0,1,24,23,2,4]),function(Y,e,g,L,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,C.createDecorator)("contextService");var i;(function(c){c[c.EMPTY=1]="EMPTY",c[c.FOLDER=2]="FOLDER",c[c.WORKSPACE=3]="WORKSPACE"})(i=e.WorkbenchState||(e.WorkbenchState={}));function k(c){const p=c;return!!(p&&typeof p=="object"&&typeof p.id=="string"&&Array.isArray(p.folders))}e.isWorkspace=k;function _(c){const p=c;return!!(p&&typeof p=="object"&&y.URI.isUri(p.uri)&&typeof p.name=="string"&&typeof p.toResource=="function")}e.isWorkspaceFolder=_;class D{constructor(p,f,v,S,P){this._id=p,this._transient=v,this._configuration=S,this._ignorePathCasing=P,this._foldersMap=g.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=f}update(p){this._id=p.id,this._configuration=p.configuration,this._transient=p.transient,this._ignorePathCasing=p._ignorePathCasing,this.folders=p.folders}get folders(){return this._folders}set folders(p){this._folders=p,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(p){this._configuration=p}getFolder(p){return p&&this._foldersMap.findSubstr(p.with({scheme:p.scheme,authority:p.authority,path:p.path}))||null}updateFoldersMap(){this._foldersMap=g.TernarySearchTree.forUris(this._ignorePathCasing);for(const p of this.folders)this._foldersMap.set(p.uri,p)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=D;class T{constructor(p,f){this.raw=f,this.uri=p.uri,this.index=p.index,this.name=p.name}toResource(p){return(0,L.joinPath)(this.uri,p)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=T;function I(c){return new T({uri:c,index:0,name:(0,L.basenameOrAuthority)(c)},{uri:c.toString()})}e.toWorkspaceFolder=I}),define(fe[200],me([0,1,30,61,140,81,10,9,12,23,2,163,4,64,44]),function(Y,e,g,L,y,C,i,k,_,D,T,I,c,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const v=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,I.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function S(M){return(typeof M=="string"?(0,k.extname)(M):(0,D.extname)(M))===v}e.hasWorkspaceFileExtension=S,e.IWorkspacesService=(0,c.createDecorator)("workspacesService");function P(M){return M.hasOwnProperty("workspace")}e.isRecentWorkspace=P;function w(M){return M.hasOwnProperty("folderUri")}e.isRecentFolder=w;function s(M){return M.hasOwnProperty("fileUri")}e.isRecentFile=s;function r(M){const H=M;return typeof H?.id=="string"&&T.URI.isUri(H.uri)}e.isSingleFolderWorkspaceIdentifier=r;function m(M){if(M.configuration)return{id:M.id,configPath:M.configuration};if(M.folders.length===1)return{id:M.id,uri:M.folders[0].uri}}e.toWorkspaceIdentifier=m;function a(M){const H=M;return typeof H?.id=="string"&&T.URI.isUri(H.configPath)}e.isWorkspaceIdentifier=a;function b(M){const H=M;if(H?.uri)return{id:H.id,uri:T.URI.revive(H.uri)};const N=M;if(N?.configPath)return{id:N.id,configPath:T.URI.revive(N.configPath)};if(M?.id)return{id:M.id}}e.reviveIdentifier=b;function n(M,H){return D.extUriBiasedIgnorePathCase.isEqualOrParent(M,H.untitledWorkspacesHome)}e.isUntitledWorkspace=n;function t(M){return l(M)||d(M)}e.isStoredWorkspaceFolder=t;function l(M){const H=M;return typeof H?.path=="string"&&(!H.name||typeof H.name=="string")}e.isRawFileWorkspaceFolder=l;function d(M){const H=M;return typeof H?.uri=="string"&&(!H.name||typeof H.name=="string")}e.isRawUriWorkspaceFolder=d;function o(M,H,N,U,V=!_.isWindows,O){if(M.scheme!==U.scheme)return{name:N,uri:M.toString(!0)};let W=H?void 0:O.relativePath(U,M);if(W!==void 0)W.length===0?W=".":_.isWindows&&M.scheme===i.Schemas.file&&!V&&(W=W.replace(/\//g,"\\"));else if(M.scheme===i.Schemas.file)W=M.fsPath,_.isWindows&&(W=(0,C.normalizeDriveLetter)(W),V&&(W=(0,g.toSlashes)(W)));else{if(!O.isEqualAuthority(M.authority,U.authority))return{name:N,uri:M.toString(!0)};W=M.path}return{name:N,path:W}}e.getStoredWorkspaceFolder=o;function h(M,H,N){let U=[],V=new Set;const O=N.dirname(H);for(let W of M){let j;if(l(W))W.path&&(j=N.resolvePath(O,W.path));else if(d(W))try{j=T.URI.parse(W.uri),j.path[0]!=="/"&&(j=j.with({path:"/"+j.path}))}catch(X){console.warn(X)}if(j){let X=N.getComparisonKey(j);if(!V.has(X)){V.add(X);const Q=W.name||N.basenameOrAuthority(j);U.push(new f.WorkspaceFolder({uri:j,name:Q,index:U.length},W))}}}return U}e.toWorkspaceFolders=h;function u(M,H,N,U,V){let O=E(H,M);const W=V.dirname(H),j=V.dirname(U),X=[],Q=A(O.folders);for(const Pe of O.folders){const Be=l(Pe)?V.resolvePath(W,Pe.path):T.URI.parse(Pe.uri);let We;N?We=!1:We=!l(Pe)||(0,k.isAbsolute)(Pe.path),X.push(o(Be,We,Pe.name,j,Q,V))}const de={insertSpaces:!1,tabSize:4,eol:_.isLinux||_.isMacintosh?`
`:`\r
`},Se=y.setProperty(M,["folders"],X,de);let De=y.applyEdits(M,Se);return(0,D.isEqualAuthority)(O.remoteAuthority,(0,p.getRemoteAuthority)(U))&&(De=y.applyEdits(De,y.removeProperty(De,["remoteAuthority"],de))),De}e.rewriteWorkspaceFileForNewLocation=u;function E(M,H){let N=L.parse(H);if(N&&Array.isArray(N.folders))N.folders=N.folders.filter(U=>t(U));else throw new Error(`${M} looks like an invalid workspace file.`);return N}function A(M){return _.isWindows?M.some(H=>l(H)&&H.path.indexOf("/")>=0):!0}e.useSlashForPath=A;function R(M){return M.workspace&&typeof M.workspace=="object"&&typeof M.workspace.id=="string"&&typeof M.workspace.configPath=="string"}function B(M){return typeof M.folderUri=="string"}function x(M){return typeof M.fileUri=="string"}function F(M,H){const N={workspaces:[],files:[]};if(M){const U=function(O,W){for(let j=0;j<O.length;j++)try{W(O[j],j)}catch(X){H.warn(`Error restoring recent entry ${JSON.stringify(O[j])}: ${X.toString()}. Skip entry.`)}},V=M;if(Array.isArray(V.entries))U(V.entries,O=>{const W=O.label,j=O.remoteAuthority;R(O)?N.workspaces.push({label:W,remoteAuthority:j,workspace:{id:O.workspace.id,configPath:T.URI.parse(O.workspace.configPath)}}):B(O)?N.workspaces.push({label:W,remoteAuthority:j,folderUri:T.URI.parse(O.folderUri)}):x(O)&&N.files.push({label:W,remoteAuthority:j,fileUri:T.URI.parse(O.fileUri)})});else{const O=M;Array.isArray(O.workspaces3)&&U(O.workspaces3,(W,j)=>{const X=Array.isArray(O.workspaceLabels)&&O.workspaceLabels[j]||void 0;typeof W=="object"&&typeof W.id=="string"&&typeof W.configURIPath=="string"?N.workspaces.push({label:X,workspace:{id:W.id,configPath:T.URI.parse(W.configURIPath)}}):typeof W=="string"&&N.workspaces.push({label:X,folderUri:T.URI.parse(W)})}),Array.isArray(O.files2)&&U(O.files2,(W,j)=>{const X=Array.isArray(O.fileLabels)&&O.fileLabels[j]||void 0;typeof W=="string"&&N.files.push({label:X,fileUri:T.URI.parse(W)})})}}return N}e.restoreRecentlyOpened=F;function $(M){const H={entries:[]};for(const N of M.workspaces)w(N)?H.entries.push({folderUri:N.folderUri.toString(),label:N.label,remoteAuthority:N.remoteAuthority}):H.entries.push({workspace:{id:N.workspace.id,configPath:N.workspace.configPath.toString()},label:N.label,remoteAuthority:N.remoteAuthority});for(const N of M.files)H.entries.push({fileUri:N.fileUri.toString(),label:N.label,remoteAuthority:N.remoteAuthority});return H}e.toStoreData=$}),define(fe[88],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class g{constructor(y){this.id=y,this._data=new Map,this._idPool=1}add(y){const C=this._idPool++;return this._data.set(C,y),this.logDebugInfo(),C}get(y,C){return this._data.has(y)?this._data.get(y)[C]:void 0}delete(y){this._data.delete(y),this.logDebugInfo()}logDebugInfo(){!g.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=g,g.enableDebugLogging=!1}),define(fe[45],me([0,1,10,23,4]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class C{constructor(){this._systemSchemes=new Set(Object.keys(g.Schemas)),this._providerInfo=new Map,this.extUri=new L.ExtUri(k=>{const _=this._providerInfo.get(k.scheme);return!(_===void 0||_&1024)})}$acceptProviderInfos(k,_){_===null?this._providerInfo.delete(k):this._providerInfo.set(k,_)}isFreeScheme(k){return!this._providerInfo.has(k)&&!this._systemSchemes.has(k)}getCapabilities(k){return this._providerInfo.get(k)}}e.ExtHostFileSystemInfo=C,e.IExtHostFileSystemInfo=(0,y.createDecorator)("IExtHostFileSystemInfo")}),define(fe[26],me([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,g.createDecorator)("IExtHostInitDataService")}),define(fe[201],me([0,1,16]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class L{constructor(i,k,_){this._deferredPromises=new Map,this._id=i,this._shared=k,this._storage=_,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(D=>(this._value=D,this)),this._storageListener=this._storage.onDidChangeStorage(D=>{D.shared===this._shared&&D.key===this._id&&(this._value=D.value)}),this._scheduler=new g.RunOnceScheduler(()=>{const D=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const T of D.values())T.complete()}catch(T){for(const I of D.values())I.error(T)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,i])=>i!==void 0).map(([i])=>i)}get whenReady(){return this._init}get(i,k){let _=this._value[i];return typeof _=="undefined"&&(_=k),_}update(i,k){this._value[i]=k;let _=this._deferredPromises.get(i);if(_!==void 0)return _.p;const D=new g.DeferredPromise;return this._deferredPromises.set(i,D),this._scheduler.isScheduled()||this._scheduler.schedule(),D.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=L;class y extends L{constructor(i,k){super(i.identifier.value,!0,k);this._extension=i}setKeysForSync(i){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},i)}}e.ExtensionGlobalMemento=y}),define(fe[202],me([0,1,3,2,11]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let C=class{constructor(k,_){this._logService=k,this._notebooksAndEditors=_,this._onDidChangeNotebookDocumentMetadata=new g.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new g.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(k,_,D){this._notebooksAndEditors.getNotebookDocument(L.URI.revive(k)).acceptModelChanged(_.value,D)}$acceptDirtyStateChanged(k,_){this._notebooksAndEditors.getNotebookDocument(L.URI.revive(k)).acceptDirty(_)}$acceptModelSaved(k){const _=this._notebooksAndEditors.getNotebookDocument(L.URI.revive(k));this._onDidSaveNotebookDocument.fire(_.apiNotebook)}$acceptDocumentPropertiesChanged(k,_){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",k.path,_);const D=this._notebooksAndEditors.getNotebookDocument(L.URI.revive(k));D.acceptDocumentPropertiesChanged(_),_.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:D.apiNotebook})}};C=Ve([$e(0,y.ILogService)],C),e.ExtHostNotebookDocuments=C}),define(fe[14],me([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,g.createDecorator)("IExtHostRpcService");class L{constructor(C){this.getProxy=C.getProxy.bind(C),this.set=C.set.bind(C),this.assertRegistered=C.assertRegistered.bind(C),this.drain=C.drain.bind(C)}}e.ExtHostRpcService=L});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,L,y){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?y.call(Y,g):y?y.value=g:e.set(Y,g),g},Ne=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[203],me([0,1,27,3]),function(Y,e,g,L){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class C{constructor(k,_){y.set(this,void 0),this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this._id=g.ExtensionIdentifier.toKey(k.identifier),st(this,y,_,"f"),Ne(this,y,"f").onDidChangePassword(D=>{D.extensionId===this._id&&this._onDidChange.fire({key:D.key})})}get(k){return Ne(this,y,"f").get(this._id,k)}store(k,_){return Ne(this,y,"f").store(this._id,k,_)}delete(k){return Ne(this,y,"f").delete(this._id,k)}}e.ExtensionSecrets=C,y=new WeakMap}),define(fe[122],me([0,1,4,3]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class y{constructor(){this._onDidChangeTelemetryEnabled=new L.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(i){this._enabled=i}$onDidChangeTelemetryEnabled(i){this._enabled=i,this._onDidChangeTelemetryEnabled.fire(i)}}e.ExtHostTelemetry=y,e.IExtHostTelemetry=(0,g.createDecorator)("IExtHostTelemetry")}),define(fe[66],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var g;(function(w){w[w.Upsert=0]="Upsert",w[w.RemoveChild=1]="RemoveChild",w[w.Invalidated=2]="Invalidated",w[w.SetProp=3]="SetProp",w[w.Bulk=4]="Bulk"})(g=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const L=new WeakMap,y=(w,s)=>{const r={controllerId:s};return L.set(w,r),r};e.createPrivateApiFor=y;const C=w=>L.get(w);e.getPrivateApiFor=C;const i=(w,s,r,m)=>{let a=r;return{enumerable:!0,configurable:!1,get(){return a},set(b){if(!m(a,b)){const n=a;a=b,w.listener?.({op:3,key:s,value:b,previous:n})}}}},k=(w,s)=>w===s,_={range:(w,s)=>w===s?!0:!w||!s?!1:w.isEqual(s),label:k,description:k,busy:k,error:k,canResolveChildren:k,tags:(w,s)=>!(w.length!==s.length||w.some(r=>!s.find(m=>r.id===m.id)))},D=Object.keys(_),T=(w,s)=>({range:i(w,"range",void 0,_.range),label:i(w,"label",s,_.label),description:i(w,"description",void 0,_.description),canResolveChildren:i(w,"canResolveChildren",!1,_.canResolveChildren),busy:i(w,"busy",!1,_.busy),error:i(w,"error",void 0,_.error),tags:i(w,"tags",[],_.tags)}),I=(w,s)=>{const r=new Map;for(const m of D)_[m](w[m],s[m])||r.set(m,s[m]);return r};e.diffTestItems=I;class c extends Error{constructor(s){super(`Attempted to insert a duplicate test item ID ${s}`)}}e.DuplicateTestItemError=c;class p extends Error{constructor(s){super(`TestItem with ID "${s}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=p;class f extends Error{constructor(s,r,m){super(`TestItem with ID "${s}" is from controller "${r}" and cannot be added as a child of an item from controller "${m}".`)}}e.MixedTestItemController=f;const v=w=>{const s=(0,e.getPrivateApiFor)(w);let r=new Map;return{get size(){return r.size},forEach(m,a){for(const b of r.values())m.call(a,b,this)},replace(m){const a=new Map,b=new Set(r.keys()),n={op:4,ops:[]};for(const t of m){if(!(t instanceof S))throw new p(t.id);const l=(0,e.getPrivateApiFor)(t).controllerId;if(l!==s.controllerId)throw new f(t.id,l,s.controllerId);if(a.has(t.id))throw new c(t.id);a.set(t.id,t),b.delete(t.id),n.ops.push({op:0,item:t})}for(const t of b.keys())n.ops.push({op:1,id:t});s.listener?.(n),r=a},add(m){if(!(m instanceof S))throw new p(m.id);r.set(m.id,m),s.listener?.({op:0,item:m})},delete(m){r.delete(m)&&s.listener?.({op:1,id:m})},get(m){return r.get(m)},toJSON(){return Array.from(r.values())},[Symbol.iterator](){return r.values()}}};class S{constructor(s,r,m,a){if(r.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(r)} symbol`);const b=(0,e.createPrivateApiFor)(this,s);Object.defineProperties(this,{id:{value:r,enumerable:!0,writable:!1},uri:{value:a,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return b.parent instanceof P?void 0:b.parent}},children:{value:v(this),enumerable:!0,writable:!1},...T(b,m)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=S;class P extends S{constructor(s,r){super(s,s,r,void 0)}}e.TestItemRootImpl=P}),define(fe[54],me([0,1,4,121,3,14]),function(Y,e,g,L,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var i;(function(_){function D(I){return{remoteAddress:I.remoteAddress,localAddress:I.localAddress,public:!!I.public,privacy:I.privacy??(I.public?L.TunnelPrivacyId.Public:L.TunnelPrivacyId.Private),protocol:I.protocol}}_.fromApiTunnel=D;function T(I){return{remoteAddress:{host:I.tunnelRemoteHost,port:I.tunnelRemotePort},localAddress:I.localAddress,public:I.privacy!==L.TunnelPrivacyId.ConstantPrivate&&I.privacy!==L.TunnelPrivacyId.ConstantPrivate,privacy:I.privacy,protocol:I.protocol}}_.fromServiceTunnel=T})(i=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,g.createDecorator)("IExtHostTunnelService");let k=class{constructor(D){this.onDidChangeTunnels=new y.Emitter().event}async $applyCandidateFilter(D){return D}async openTunnel(D,T){}async getTunnels(){return[]}async setTunnelExtensionFunctions(D){return{dispose:()=>{}}}registerPortsAttributesProvider(D,T){return{dispose:()=>{}}}async $providePortAttributes(D,T,I,c,p){return[]}async $forwardPort(D,T){}async $closeTunnel(D){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};k=Ve([$e(0,C.IExtHostRpcService)],k),e.ExtHostTunnelService=k});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,L,y){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?y.call(Y,g):y?y.value=g:e.set(Y,g),g},Ne=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[7],me([0,1,15,18,98,24,102,8,13,2,32,43,120]),function(Y,e,g,L,y,C,i,k,_,D,T,I,c){"use strict";var p,f,v,S,P,w,s,r,m,a,b,n,t,l,d,o,h,u,E,A;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function R(q){function z(){return Reflect.construct(q,arguments,this.constructor)}return Object.defineProperty(z,"name",Object.getOwnPropertyDescriptor(q,"name")),Object.setPrototypeOf(z,q),Object.setPrototypeOf(z.prototype,q.prototype),z}let B=P=class{constructor(z){p.set(this,void 0),st(this,p,z,"f")}static from(...z){let oe=z;return new P(function(){if(oe){for(const ke of oe)ke&&typeof ke.dispose=="function"&&ke.dispose();oe=void 0}})}dispose(){typeof Ne(this,p,"f")=="function"&&(Ne(this,p,"f").call(this),st(this,p,void 0,"f"))}};p=new WeakMap,B=P=Ve([R],B),e.Disposable=B;let x=w=class{constructor(z,oe){if(z<0)throw(0,L.illegalArgument)("line must be non-negative");if(oe<0)throw(0,L.illegalArgument)("character must be non-negative");this._line=z,this._character=oe}static Min(...z){if(z.length===0)throw new TypeError;let oe=z[0];for(let ke=1;ke<z.length;ke++){const Je=z[ke];Je.isBefore(oe)&&(oe=Je)}return oe}static Max(...z){if(z.length===0)throw new TypeError;let oe=z[0];for(let ke=1;ke<z.length;ke++){const Je=z[ke];Je.isAfter(oe)&&(oe=Je)}return oe}static isPosition(z){if(!z)return!1;if(z instanceof w)return!0;let{line:oe,character:ke}=z;return typeof oe=="number"&&typeof ke=="number"}get line(){return this._line}get character(){return this._character}isBefore(z){return this._line<z._line?!0:z._line<this._line?!1:this._character<z._character}isBeforeOrEqual(z){return this._line<z._line?!0:z._line<this._line?!1:this._character<=z._character}isAfter(z){return!this.isBeforeOrEqual(z)}isAfterOrEqual(z){return!this.isBefore(z)}isEqual(z){return this._line===z._line&&this._character===z._character}compareTo(z){return this._line<z._line?-1:this._line>z.line?1:this._character<z._character?-1:this._character>z._character?1:0}translate(z,oe=0){if(z===null||oe===null)throw(0,L.illegalArgument)();let ke;return typeof z=="undefined"?ke=0:typeof z=="number"?ke=z:(ke=typeof z.lineDelta=="number"?z.lineDelta:0,oe=typeof z.characterDelta=="number"?z.characterDelta:0),ke===0&&oe===0?this:new w(this.line+ke,this.character+oe)}with(z,oe=this.character){if(z===null||oe===null)throw(0,L.illegalArgument)();let ke;return typeof z=="undefined"?ke=this.line:typeof z=="number"?ke=z:(ke=typeof z.line=="number"?z.line:this.line,oe=typeof z.character=="number"?z.character:this.character),ke===this.line&&oe===this.character?this:new w(ke,oe)}toJSON(){return{line:this.line,character:this.character}}};x=w=Ve([R],x),e.Position=x;let F=s=class{constructor(z,oe,ke,Je){let ot,dt;if(typeof z=="number"&&typeof oe=="number"&&typeof ke=="number"&&typeof Je=="number"?(ot=new x(z,oe),dt=new x(ke,Je)):z instanceof x&&oe instanceof x&&(ot=z,dt=oe),!ot||!dt)throw new Error("Invalid arguments");ot.isBefore(dt)?(this._start=ot,this._end=dt):(this._start=dt,this._end=ot)}static isRange(z){return z instanceof s?!0:z?x.isPosition(z.start)&&x.isPosition(z.end):!1}get start(){return this._start}get end(){return this._end}contains(z){return z instanceof s?this.contains(z._start)&&this.contains(z._end):z instanceof x?!(z.isBefore(this._start)||this._end.isBefore(z)):!1}isEqual(z){return this._start.isEqual(z._start)&&this._end.isEqual(z._end)}intersection(z){const oe=x.Max(z.start,this._start),ke=x.Min(z.end,this._end);if(!oe.isAfter(ke))return new s(oe,ke)}union(z){if(this.contains(z))return this;if(z.contains(this))return z;const oe=x.Min(z.start,this._start),ke=x.Max(z.end,this.end);return new s(oe,ke)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(z,oe=this.end){if(z===null||oe===null)throw(0,L.illegalArgument)();let ke;return z?x.isPosition(z)?ke=z:(ke=z.start||this.start,oe=z.end||this.end):ke=this.start,ke.isEqual(this._start)&&oe.isEqual(this.end)?this:new s(ke,oe)}toJSON(){return[this.start,this.end]}};F=s=Ve([R],F),e.Range=F;let $=r=class extends F{constructor(z,oe,ke,Je){let ot,dt;if(typeof z=="number"&&typeof oe=="number"&&typeof ke=="number"&&typeof Je=="number"?(ot=new x(z,oe),dt=new x(ke,Je)):z instanceof x&&oe instanceof x&&(ot=z,dt=oe),!ot||!dt)throw new Error("Invalid arguments");super(ot,dt);this._anchor=ot,this._active=dt}static isSelection(z){return z instanceof r?!0:z?F.isRange(z)&&x.isPosition(z.anchor)&&x.isPosition(z.active)&&typeof z.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};$=r=Ve([R],$),e.Selection=$;class M{constructor(z,oe,ke){if(typeof z!="string"||z.length===0)throw(0,L.illegalArgument)("host");if(typeof oe!="number"||oe===0||Math.round(oe)!==oe)throw(0,L.illegalArgument)("port");if(typeof ke!="undefined"&&(typeof ke!="string"||ke.length===0||!/^[0-9A-Za-z\-]+$/.test(ke)))throw(0,L.illegalArgument)("connectionToken");this.host=z,this.port=Math.round(oe),this.connectionToken=ke}}e.ResolvedAuthority=M;class H extends Error{constructor(z,oe=c.RemoteAuthorityResolverErrorCode.Unknown,ke){super(z);this._message=z,this._code=oe,this._detail=ke,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,H.prototype)}static NotAvailable(z,oe){return new H(z,c.RemoteAuthorityResolverErrorCode.NotAvailable,oe)}static TemporarilyNotAvailable(z){return new H(z,c.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=H;var N;(function(q){q[q.LF=1]="LF",q[q.CRLF=2]="CRLF"})(N=e.EndOfLine||(e.EndOfLine={}));var U;(function(q){q[q.Replace=1]="Replace",q[q.Append=2]="Append",q[q.Prepend=3]="Prepend"})(U=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let V=m=class{constructor(z,oe){this._range=z,this._newText=oe}static isTextEdit(z){return z instanceof m?!0:z?F.isRange(z)&&typeof z.newText=="string":!1}static replace(z,oe){return new m(z,oe)}static insert(z,oe){return m.replace(new F(z,z),oe)}static delete(z){return m.replace(z,"")}static setEndOfLine(z){const oe=new m(new F(new x(0,0),new x(0,0)),"");return oe.newEol=z,oe}get range(){return this._range}set range(z){if(z&&!F.isRange(z))throw(0,L.illegalArgument)("range");this._range=z}get newText(){return this._newText||""}set newText(z){if(z&&typeof z!="string")throw(0,L.illegalArgument)("newText");this._newText=z}get newEol(){return this._newEol}set newEol(z){if(z&&typeof z!="number")throw(0,L.illegalArgument)("newEol");this._newEol=z}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};V=m=Ve([R],V),e.TextEdit=V;var O;(function(q){q[q.File=1]="File",q[q.Text=2]="Text",q[q.Cell=3]="Cell",q[q.CellReplace=5]="CellReplace"})(O=e.FileEditType||(e.FileEditType={}));let W=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(z,oe,ke,Je){this._edits.push({_type:1,from:z,to:oe,options:ke,metadata:Je})}createFile(z,oe,ke){this._edits.push({_type:1,from:void 0,to:z,options:oe,metadata:ke})}deleteFile(z,oe,ke){this._edits.push({_type:1,from:z,to:void 0,options:oe,metadata:ke})}replaceNotebookMetadata(z,oe,ke){this._edits.push({_type:3,metadata:ke,uri:z,edit:{editType:5,metadata:oe},notebookMetadata:oe})}replaceNotebookCells(z,oe,ke,Je,ot){let dt,pt,It=[],Rt;if(zt.isNotebookRange(oe)&&Oe.isNotebookCellDataArray(ke)&&!Oe.isNotebookCellDataArray(Je)?(dt=oe.start,pt=oe.end,It=ke,Rt=Je):typeof oe=="number"&&typeof ke=="number"&&Oe.isNotebookCellDataArray(Je)&&(dt=oe,pt=ke,It=Je,Rt=ot),dt===void 0||pt===void 0)throw new Error("Invalid arguments");(dt!==pt||It.length>0)&&this._edits.push({_type:5,uri:z,index:dt,count:pt-dt,cells:It,metadata:Rt})}replaceNotebookCellMetadata(z,oe,ke,Je){this._edits.push({_type:3,metadata:Je,uri:z,edit:{editType:8,index:oe,metadata:ke}})}replace(z,oe,ke,Je){this._edits.push({_type:2,uri:z,edit:new V(oe,ke),metadata:Je})}insert(z,oe,ke,Je){this.replace(z,new F(oe,oe),ke,Je)}delete(z,oe,ke){this.replace(z,oe,"",ke)}has(z){return this._edits.some(oe=>oe._type===2&&oe.uri.toString()===z.toString())}set(z,oe){if(oe)for(const ke of oe)ke&&this._edits.push({_type:2,uri:z,edit:ke});else{for(let ke=0;ke<this._edits.length;ke++){const Je=this._edits[ke];Je._type===2&&Je.uri.toString()===z.toString()&&(this._edits[ke]=void 0)}(0,g.coalesceInPlace)(this._edits)}}get(z){const oe=[];for(let ke of this._edits)ke._type===2&&ke.uri.toString()===z.toString()&&oe.push(ke.edit);return oe}entries(){const z=new C.ResourceMap;for(let oe of this._edits)if(oe._type===2){let ke=z.get(oe.uri);ke||(ke=[oe.uri,[]],z.set(oe.uri,ke)),ke[1].push(oe.edit)}return[...z.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};W=Ve([R],W),e.WorkspaceEdit=W;let j=a=class{constructor(z){this._tabstop=1,this.value=z||""}static isSnippetString(z){return z instanceof a?!0:z?typeof z.value=="string":!1}static _escape(z){return z.replace(/\$|}|\\/g,"\\$&")}appendText(z){return this.value+=a._escape(z),this}appendTabstop(z=this._tabstop++){return this.value+="$",this.value+=z,this}appendPlaceholder(z,oe=this._tabstop++){if(typeof z=="function"){const ke=new a;ke._tabstop=this._tabstop,z(ke),this._tabstop=ke._tabstop,z=ke.value}else z=a._escape(z);return this.value+="${",this.value+=oe,this.value+=":",this.value+=z,this.value+="}",this}appendChoice(z,oe=this._tabstop++){const ke=z.map(Je=>Je.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=oe,this.value+="|",this.value+=ke,this.value+="|}",this}appendVariable(z,oe){if(typeof oe=="function"){const ke=new a;ke._tabstop=this._tabstop,oe(ke),this._tabstop=ke._tabstop,oe=ke.value}else typeof oe=="string"&&(oe=oe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=z,oe&&(this.value+=":",this.value+=oe),this.value+="}",this}};j=a=Ve([R],j),e.SnippetString=j;var X;(function(q){q[q.Unnecessary=1]="Unnecessary",q[q.Deprecated=2]="Deprecated"})(X=e.DiagnosticTag||(e.DiagnosticTag={}));var Q;(function(q){q[q.Hint=3]="Hint",q[q.Information=2]="Information",q[q.Warning=1]="Warning",q[q.Error=0]="Error"})(Q=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let de=b=class{constructor(z,oe){if(this.uri=z,oe)if(oe instanceof F)this.range=oe;else if(oe instanceof x)this.range=new F(oe,oe);else throw new Error("Illegal argument")}static isLocation(z){return z instanceof b?!0:z?F.isRange(z.range)&&D.URI.isUri(z.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};de=b=Ve([R],de),e.Location=de;let Se=class{constructor(z,oe){this.location=z,this.message=oe}static is(z){return z?typeof z.message=="string"&&z.location&&F.isRange(z.location.range)&&D.URI.isUri(z.location.uri):!1}static isEqual(z,oe){return z===oe?!0:!z||!oe?!1:z.message===oe.message&&z.location.range.isEqual(oe.location.range)&&z.location.uri.toString()===oe.location.uri.toString()}};Se=Ve([R],Se),e.DiagnosticRelatedInformation=Se;let De=class{constructor(z,oe,ke=Q.Error){if(!F.isRange(z))throw new TypeError("range must be set");if(!oe)throw new TypeError("message must be set");this.range=z,this.message=oe,this.severity=ke}toJSON(){return{severity:Q[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(z,oe){return z===oe?!0:!z||!oe?!1:z.message===oe.message&&z.severity===oe.severity&&z.code===oe.code&&z.severity===oe.severity&&z.source===oe.source&&z.range.isEqual(oe.range)&&(0,g.equals)(z.tags,oe.tags)&&(0,g.equals)(z.relatedInformation,oe.relatedInformation,Se.isEqual)}};De=Ve([R],De),e.Diagnostic=De;let Pe=class{constructor(z,oe){if(!z)throw new Error("Illegal argument, contents must be defined");Array.isArray(z)?this.contents=z:this.contents=[z],this.range=oe}};Pe=Ve([R],Pe),e.Hover=Pe;var Be;(function(q){q[q.Text=0]="Text",q[q.Read=1]="Read",q[q.Write=2]="Write"})(Be=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let We=class{constructor(z,oe=Be.Text){this.range=z,this.kind=oe}toJSON(){return{range:this.range,kind:Be[this.kind]}}};We=Ve([R],We),e.DocumentHighlight=We;var He;(function(q){q[q.File=0]="File",q[q.Module=1]="Module",q[q.Namespace=2]="Namespace",q[q.Package=3]="Package",q[q.Class=4]="Class",q[q.Method=5]="Method",q[q.Property=6]="Property",q[q.Field=7]="Field",q[q.Constructor=8]="Constructor",q[q.Enum=9]="Enum",q[q.Interface=10]="Interface",q[q.Function=11]="Function",q[q.Variable=12]="Variable",q[q.Constant=13]="Constant",q[q.String=14]="String",q[q.Number=15]="Number",q[q.Boolean=16]="Boolean",q[q.Array=17]="Array",q[q.Object=18]="Object",q[q.Key=19]="Key",q[q.Null=20]="Null",q[q.EnumMember=21]="EnumMember",q[q.Struct=22]="Struct",q[q.Event=23]="Event",q[q.Operator=24]="Operator",q[q.TypeParameter=25]="TypeParameter"})(He=e.SymbolKind||(e.SymbolKind={}));var G;(function(q){q[q.Deprecated=1]="Deprecated"})(G=e.SymbolTag||(e.SymbolTag={}));let ee=n=class{constructor(z,oe,ke,Je,ot){this.name=z,this.kind=oe,this.containerName=ot,typeof ke=="string"&&(this.containerName=ke),Je instanceof de?this.location=Je:ke instanceof F&&(this.location=new de(Je,ke)),n.validate(this)}static validate(z){if(!z.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:He[this.kind],location:this.location,containerName:this.containerName}}};ee=n=Ve([R],ee),e.SymbolInformation=ee;let ie=t=class{constructor(z,oe,ke,Je,ot){this.name=z,this.detail=oe,this.kind=ke,this.range=Je,this.selectionRange=ot,this.children=[],t.validate(this)}static validate(z){if(!z.name)throw new Error("name must not be falsy");if(!z.range.contains(z.selectionRange))throw new Error("selectionRange must be contained in fullRange");z.children&&z.children.forEach(t.validate)}};ie=t=Ve([R],ie),e.DocumentSymbol=ie;var le;(function(q){q[q.Invoke=1]="Invoke",q[q.Automatic=2]="Automatic"})(le=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let Z=class{constructor(z,oe){this.title=z,this.kind=oe}};Z=Ve([R],Z),e.CodeAction=Z;let re=l=class{constructor(z){this.value=z}append(z){return new l(this.value?this.value+l.sep+z:z)}intersects(z){return this.contains(z)||z.contains(this)}contains(z){return this.value===z.value||z.value.startsWith(this.value+l.sep)}};re.sep=".",re=l=Ve([R],re),e.CodeActionKind=re,re.Empty=new re(""),re.QuickFix=re.Empty.append("quickfix"),re.Refactor=re.Empty.append("refactor"),re.RefactorExtract=re.Refactor.append("extract"),re.RefactorInline=re.Refactor.append("inline"),re.RefactorRewrite=re.Refactor.append("rewrite"),re.Source=re.Empty.append("source"),re.SourceOrganizeImports=re.Source.append("organizeImports"),re.SourceFixAll=re.Source.append("fixAll");let pe=class{constructor(z,oe){if(this.range=z,this.parent=oe,oe&&!oe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};pe=Ve([R],pe),e.SelectionRange=pe;class Me{constructor(z,oe,ke,Je,ot,dt){this.kind=z,this.name=oe,this.detail=ke,this.uri=Je,this.range=ot,this.selectionRange=dt}}e.CallHierarchyItem=Me;class je{constructor(z,oe){this.fromRanges=oe,this.from=z}}e.CallHierarchyIncomingCall=je;class Ke{constructor(z,oe){this.fromRanges=oe,this.to=z}}e.CallHierarchyOutgoingCall=Ke;var Ze;(function(q){q[q.Information=0]="Information",q[q.Warning=1]="Warning",q[q.Error=2]="Error"})(Ze=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let rt=class{constructor(z,oe){this.range=z,this.command=oe}get isResolved(){return!!this.command}};rt=Ve([R],rt),e.CodeLens=rt;let lt=d=class{constructor(z,oe=!1){f.set(this,void 0),st(this,f,new y.MarkdownString(z,{supportThemeIcons:oe}),"f")}static isMarkdownString(z){return z instanceof d?!0:z&&z.appendCodeblock&&z.appendMarkdown&&z.appendText&&z.value!==void 0}get value(){return Ne(this,f,"f").value}set value(z){Ne(this,f,"f").value=z}get isTrusted(){return Ne(this,f,"f").isTrusted}set isTrusted(z){Ne(this,f,"f").isTrusted=z}get supportThemeIcons(){return Ne(this,f,"f").supportThemeIcons}set supportThemeIcons(z){Ne(this,f,"f").supportThemeIcons=z}get supportHtml(){return Ne(this,f,"f").supportHtml}set supportHtml(z){Ne(this,f,"f").supportHtml=z}appendText(z){return Ne(this,f,"f").appendText(z),this}appendMarkdown(z){return Ne(this,f,"f").appendMarkdown(z),this}appendCodeblock(z,oe){return Ne(this,f,"f").appendCodeblock(oe??"",z),this}};f=new WeakMap,lt=d=Ve([R],lt),e.MarkdownString=lt;let ye=class{constructor(z,oe){this.label=z,this.documentation=oe}};ye=Ve([R],ye),e.ParameterInformation=ye;let at=class{constructor(z,oe){this.label=z,this.documentation=oe,this.parameters=[]}};at=Ve([R],at),e.SignatureInformation=at;let J=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};J=Ve([R],J),e.SignatureHelp=J;var ne;(function(q){q[q.Invoke=1]="Invoke",q[q.TriggerCharacter=2]="TriggerCharacter",q[q.ContentChange=3]="ContentChange"})(ne=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var _e;(function(q){q[q.Other=0]="Other",q[q.Type=1]="Type",q[q.Parameter=2]="Parameter"})(_e=e.InlayHintKind||(e.InlayHintKind={}));let Qe=class{constructor(z,oe,ke){this.text=z,this.position=oe,this.kind=ke}};Qe=Ve([R],Qe),e.InlayHint=Qe;var et;(function(q){q[q.Invoke=0]="Invoke",q[q.TriggerCharacter=1]="TriggerCharacter",q[q.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(et=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ce;(function(q){q[q.Text=0]="Text",q[q.Method=1]="Method",q[q.Function=2]="Function",q[q.Constructor=3]="Constructor",q[q.Field=4]="Field",q[q.Variable=5]="Variable",q[q.Class=6]="Class",q[q.Interface=7]="Interface",q[q.Module=8]="Module",q[q.Property=9]="Property",q[q.Unit=10]="Unit",q[q.Value=11]="Value",q[q.Enum=12]="Enum",q[q.Keyword=13]="Keyword",q[q.Snippet=14]="Snippet",q[q.Color=15]="Color",q[q.File=16]="File",q[q.Reference=17]="Reference",q[q.Folder=18]="Folder",q[q.EnumMember=19]="EnumMember",q[q.Constant=20]="Constant",q[q.Struct=21]="Struct",q[q.Event=22]="Event",q[q.Operator=23]="Operator",q[q.TypeParameter=24]="TypeParameter",q[q.User=25]="User",q[q.Issue=26]="Issue"})(ce=e.CompletionItemKind||(e.CompletionItemKind={}));var Ie;(function(q){q[q.Deprecated=1]="Deprecated"})(Ie=e.CompletionItemTag||(e.CompletionItemTag={}));let Ue=class{constructor(z,oe){this.label=z,this.kind=oe}toJSON(){return{label:this.label,kind:this.kind&&ce[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ue=Ve([R],Ue),e.CompletionItem=Ue;let Xe=class{constructor(z=[],oe=!1){this.items=z,this.isIncomplete=oe}};Xe=Ve([R],Xe),e.CompletionList=Xe;let nt=class{constructor(z,oe,ke){this.text=z,this.range=oe,this.command=ke}};nt=Ve([R],nt),e.InlineSuggestion=nt;let ft=class{constructor(z){this.items=z}};ft=Ve([R],ft),e.InlineSuggestions=ft;var tt;(function(q){q[q.Active=-1]="Active",q[q.Beside=-2]="Beside",q[q.One=1]="One",q[q.Two=2]="Two",q[q.Three=3]="Three",q[q.Four=4]="Four",q[q.Five=5]="Five",q[q.Six=6]="Six",q[q.Seven=7]="Seven",q[q.Eight=8]="Eight",q[q.Nine=9]="Nine"})(tt=e.ViewColumn||(e.ViewColumn={}));var ut;(function(q){q[q.Left=1]="Left",q[q.Right=2]="Right"})(ut=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Re;(function(q){q[q.Off=0]="Off",q[q.On=1]="On",q[q.Relative=2]="Relative"})(Re=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ve;(function(q){q[q.Manual=1]="Manual",q[q.AfterDelay=2]="AfterDelay",q[q.FocusOut=3]="FocusOut"})(ve=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Te;(function(q){q[q.Default=0]="Default",q[q.InCenter=1]="InCenter",q[q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",q[q.AtTop=3]="AtTop"})(Te=e.TextEditorRevealType||(e.TextEditorRevealType={}));var se;(function(q){q[q.Keyboard=1]="Keyboard",q[q.Mouse=2]="Mouse",q[q.Command=3]="Command"})(se=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ue;(function(q){q[q.Undo=1]="Undo",q[q.Redo=2]="Redo"})(ue=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var be;(function(q){q[q.OpenOpen=0]="OpenOpen",q[q.ClosedClosed=1]="ClosedClosed",q[q.OpenClosed=2]="OpenClosed",q[q.ClosedOpen=3]="ClosedOpen"})(be=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(q){function z(oe){switch(oe){case"keyboard":return q.Keyboard;case"mouse":return q.Mouse;case"api":return q.Command}}q.fromValue=z}(se=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let we=class{constructor(z,oe){if(oe&&!D.URI.isUri(oe))throw(0,L.illegalArgument)("target");if(!F.isRange(z)||z.isEmpty)throw(0,L.illegalArgument)("range");this.range=z,this.target=oe}};we=Ve([R],we),e.DocumentLink=we;let Fe=class{constructor(z,oe,ke,Je){this.red=z,this.green=oe,this.blue=ke,this.alpha=Je}};Fe=Ve([R],Fe),e.Color=Fe;let qe=class{constructor(z,oe){if(oe&&!(oe instanceof Fe))throw(0,L.illegalArgument)("color");if(!F.isRange(z)||z.isEmpty)throw(0,L.illegalArgument)("range");this.range=z,this.color=oe}};qe=Ve([R],qe),e.ColorInformation=qe;let ze=class{constructor(z){if(!z||typeof z!="string")throw(0,L.illegalArgument)("label");this.label=z}};ze=Ve([R],ze),e.ColorPresentation=ze;var Ye;(function(q){q[q.RGB=0]="RGB",q[q.HEX=1]="HEX",q[q.HSL=2]="HSL"})(Ye=e.ColorFormat||(e.ColorFormat={}));var ct;(function(q){q[q.Error=0]="Error",q[q.Warning=1]="Warning",q[q.Information=2]="Information"})(ct=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class xe{constructor(z,oe,ke){if(this.startIndex=z,this.length=oe,this.tooltip=ke,typeof z!="number"||z<0)throw(0,L.illegalArgument)("startIndex");if(typeof oe!="number"||oe<1)throw(0,L.illegalArgument)("length");if(ke!==void 0&&typeof ke!="string")throw(0,L.illegalArgument)("tooltip")}}e.TerminalLink=xe;var ge;(function(q){q[q.Panel=1]="Panel",q[q.Editor=2]="Editor"})(ge=e.TerminalLocation||(e.TerminalLocation={}));class Ee{constructor(z){this.options=z,typeof z!="object"&&(0,L.illegalArgument)("options")}}e.TerminalProfile=Ee;var ae;(function(q){q[q.Always=1]="Always",q[q.Silent=2]="Silent",q[q.Never=3]="Never"})(ae=e.TaskRevealKind||(e.TaskRevealKind={}));var K;(function(q){q[q.Shared=1]="Shared",q[q.Dedicated=2]="Dedicated",q[q.New=3]="New"})(K=e.TaskPanelKind||(e.TaskPanelKind={}));let Ce=o=class{constructor(z,oe){if(this.label=oe,typeof z!="string"||typeof oe!="string")throw(0,L.illegalArgument)("name");this._id=z}static from(z){switch(z){case"clean":return o.Clean;case"build":return o.Build;case"rebuild":return o.Rebuild;case"test":return o.Test;default:return}}get id(){return this._id}};Ce.Clean=new o("clean","Clean"),Ce.Build=new o("build","Build"),Ce.Rebuild=new o("rebuild","Rebuild"),Ce.Test=new o("test","Test"),Ce=o=Ve([R],Ce),e.TaskGroup=Ce;function Le(q){let z="";for(let oe=0;oe<q.length;oe++)z+=q[oe].replace(/,/g,",,")+",";return z}let it=class{constructor(z,oe,ke){if(typeof z!="string")throw(0,L.illegalArgument)("process");this._args=[],this._process=z,oe!==void 0&&(Array.isArray(oe)?(this._args=oe,this._options=ke):this._options=oe)}get process(){return this._process}set process(z){if(typeof z!="string")throw(0,L.illegalArgument)("process");this._process=z}get args(){return this._args}set args(z){Array.isArray(z)||(z=[]),this._args=z}get options(){return this._options}set options(z){this._options=z}computeId(){const z=[];if(z.push("process"),this._process!==void 0&&z.push(this._process),this._args&&this._args.length>0)for(let oe of this._args)z.push(oe);return Le(z)}};it=Ve([R],it),e.ProcessExecution=it;let Ge=class{constructor(z,oe,ke){if(this._args=[],Array.isArray(oe)){if(!z)throw(0,L.illegalArgument)("command can't be undefined or null");if(typeof z!="string"&&typeof z.value!="string")throw(0,L.illegalArgument)("command");this._command=z,this._args=oe,this._options=ke}else{if(typeof z!="string")throw(0,L.illegalArgument)("commandLine");this._commandLine=z,this._options=oe}}get commandLine(){return this._commandLine}set commandLine(z){if(typeof z!="string")throw(0,L.illegalArgument)("commandLine");this._commandLine=z}get command(){return this._command?this._command:""}set command(z){if(typeof z!="string"&&typeof z.value!="string")throw(0,L.illegalArgument)("command");this._command=z}get args(){return this._args}set args(z){this._args=z||[]}get options(){return this._options}set options(z){this._options=z}computeId(){const z=[];if(z.push("shell"),this._commandLine!==void 0&&z.push(this._commandLine),this._command!==void 0&&z.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let oe of this._args)z.push(typeof oe=="string"?oe:oe.value);return Le(z)}};Ge=Ve([R],Ge),e.ShellExecution=Ge;var mt;(function(q){q[q.Escape=1]="Escape",q[q.Strong=2]="Strong",q[q.Weak=3]="Weak"})(mt=e.ShellQuoting||(e.ShellQuoting={}));var yt;(function(q){q[q.Global=1]="Global",q[q.Workspace=2]="Workspace"})(yt=e.TaskScope||(e.TaskScope={}));class _t{constructor(z){this._callback=z}computeId(){return"customExecution"+(0,T.generateUuid)()}set callback(z){this._callback=z}get callback(){return this._callback}}e.CustomExecution=_t;let gt=h=class{constructor(z,oe,ke,Je,ot,dt){this.__deprecated=!1,this._definition=this.definition=z;let pt;typeof oe=="string"?(this._name=this.name=oe,this._source=this.source=ke,this.execution=Je,pt=ot,this.__deprecated=!0):oe===yt.Global||oe===yt.Workspace?(this.target=oe,this._name=this.name=ke,this._source=this.source=Je,this.execution=ot,pt=dt):(this.target=oe,this._name=this.name=ke,this._source=this.source=Je,this.execution=ot,pt=dt),typeof pt=="string"?(this._problemMatchers=[pt],this._hasDefinedMatchers=!0):Array.isArray(pt)?(this._problemMatchers=pt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(z){this.__id=z}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof it?this._definition={type:h.ProcessType,id:this._execution.computeId()}:this._execution instanceof Ge?this._definition={type:h.ShellType,id:this._execution.computeId()}:this._execution instanceof _t?this._definition={type:h.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:h.EmptyType,id:(0,T.generateUuid)()}}get definition(){return this._definition}set definition(z){if(z==null)throw(0,L.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=z}get scope(){return this._scope}set target(z){this.clear(),this._scope=z}get name(){return this._name}set name(z){if(typeof z!="string")throw(0,L.illegalArgument)("name");this.clear(),this._name=z}get execution(){return this._execution}set execution(z){z===null&&(z=void 0),this.clear(),this._execution=z;const oe=this._definition.type;(h.EmptyType===oe||h.ProcessType===oe||h.ShellType===oe||h.ExtensionCallbackType===oe)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(z){if(Array.isArray(z))this.clear(),this._problemMatchers=z,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(z){z!==!0&&z!==!1&&(z=!1),this.clear(),this._isBackground=z}get source(){return this._source}set source(z){if(typeof z!="string"||z.length===0)throw(0,L.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=z}get group(){return this._group}set group(z){z===null&&(z=void 0),this.clear(),this._group=z}get detail(){return this._detail}set detail(z){z===null&&(z=void 0),this._detail=z}get presentationOptions(){return this._presentationOptions}set presentationOptions(z){z==null&&(z=Object.create(null)),this.clear(),this._presentationOptions=z}get runOptions(){return this._runOptions}set runOptions(z){z==null&&(z=Object.create(null)),this.clear(),this._runOptions=z}};gt.ExtensionCallbackType="customExecution",gt.ProcessType="process",gt.ShellType="shell",gt.EmptyType="$empty",gt=h=Ve([R],gt),e.Task=gt;var bt;(function(q){q[q.SourceControl=1]="SourceControl",q[q.Window=10]="Window",q[q.Notification=15]="Notification"})(bt=e.ProgressLocation||(e.ProgressLocation={}));let vt=class{constructor(z,oe=Tt.None){this.collapsibleState=oe,D.URI.isUri(z)?this.resourceUri=z:this.label=z}};vt=Ve([R],vt),e.TreeItem=vt;var Tt;(function(q){q[q.None=0]="None",q[q.Collapsed=1]="Collapsed",q[q.Expanded=2]="Expanded"})(Tt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Dt=class{constructor(z,oe){this.id=z,this.color=oe}};Dt=Ve([R],Dt),e.ThemeIcon=Dt,Dt.File=new Dt("file"),Dt.Folder=new Dt("folder");let Bt=class{constructor(z){this.id=z}};Bt=Ve([R],Bt),e.ThemeColor=Bt;var Vt;(function(q){q[q.Global=1]="Global",q[q.Workspace=2]="Workspace",q[q.WorkspaceFolder=3]="WorkspaceFolder"})(Vt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let kt=class{constructor(z,oe){if(typeof z!="string"&&(!z||!D.URI.isUri(z)&&!D.URI.isUri(z.uri)))throw(0,L.illegalArgument)("base");if(typeof oe!="string")throw(0,L.illegalArgument)("pattern");typeof z=="string"?(this.baseFolder=D.URI.file(z),this.base=z):D.URI.isUri(z)?(this.baseFolder=z,this.base=z.fsPath):(this.baseFolder=z.uri,this.base=z.uri.fsPath),this.pattern=oe}};kt=Ve([R],kt),e.RelativePattern=kt;let $t=class{constructor(z,oe,ke,Je){this.enabled=typeof z=="boolean"?z:!0,typeof oe=="string"&&(this.condition=oe),typeof ke=="string"&&(this.hitCondition=ke),typeof Je=="string"&&(this.logMessage=Je)}get id(){return this._id||(this._id=(0,T.generateUuid)()),this._id}};$t=Ve([R],$t),e.Breakpoint=$t;let ti=class extends $t{constructor(z,oe,ke,Je,ot){super(oe,ke,Je,ot);if(z===null)throw(0,L.illegalArgument)("location");this.location=z}};ti=Ve([R],ti),e.SourceBreakpoint=ti;let St=class extends $t{constructor(z,oe,ke,Je,ot){super(oe,ke,Je,ot);this.functionName=z}};St=Ve([R],St),e.FunctionBreakpoint=St;let Qt=class extends $t{constructor(z,oe,ke,Je,ot,dt,pt){super(Je,ot,dt,pt);if(!oe)throw(0,L.illegalArgument)("dataId");this.label=z,this.dataId=oe,this.canPersist=ke}};Qt=Ve([R],Qt),e.DataBreakpoint=Qt;let jt=class{constructor(z,oe,ke){this.command=z,this.args=oe||[],this.options=ke}};jt=Ve([R],jt),e.DebugAdapterExecutable=jt;let ii=class{constructor(z,oe){this.port=z,this.host=oe}};ii=Ve([R],ii),e.DebugAdapterServer=ii;let ni=class{constructor(z){this.path=z}};ni=Ve([R],ni),e.DebugAdapterNamedPipeServer=ni;let At=class{constructor(z){this.implementation=z}};At=Ve([R],At),e.DebugAdapterInlineImplementation=At;let Xt=class{constructor(z,oe){this.range=z,this.expression=oe}};Xt=Ve([R],Xt),e.EvaluatableExpression=Xt;var wi;(function(q){q[q.Automatic=0]="Automatic",q[q.Explicit=1]="Explicit"})(wi=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Wt=class{constructor(z,oe){this.range=z,this.text=oe}};Wt=Ve([R],Wt),e.InlineValueText=Wt;let Ht=class{constructor(z,oe,ke=!0){this.range=z,this.variableName=oe,this.caseSensitiveLookup=ke}};Ht=Ve([R],Ht),e.InlineValueVariableLookup=Ht;let wt=class{constructor(z,oe){this.range=z,this.expression=oe}};wt=Ve([R],wt),e.InlineValueEvaluatableExpression=wt;let ri=class{constructor(z,oe){this.frameId=z,this.stoppedLocation=oe}};ri=Ve([R],ri),e.InlineValueContext=ri;var Ot;(function(q){q[q.Changed=1]="Changed",q[q.Created=2]="Created",q[q.Deleted=3]="Deleted"})(Ot=e.FileChangeType||(e.FileChangeType={}));let Nt=u=class extends Error{constructor(z,oe=I.FileSystemProviderErrorCode.Unknown,ke){super(D.URI.isUri(z)?z.toString(!0):z);this.code=ke?.name??"Unknown",(0,I.markAsFileSystemProviderError)(this,oe),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,u.prototype),typeof Error.captureStackTrace=="function"&&typeof ke=="function"&&Error.captureStackTrace(this,ke)}static FileExists(z){return new u(z,I.FileSystemProviderErrorCode.FileExists,u.FileExists)}static FileNotFound(z){return new u(z,I.FileSystemProviderErrorCode.FileNotFound,u.FileNotFound)}static FileNotADirectory(z){return new u(z,I.FileSystemProviderErrorCode.FileNotADirectory,u.FileNotADirectory)}static FileIsADirectory(z){return new u(z,I.FileSystemProviderErrorCode.FileIsADirectory,u.FileIsADirectory)}static NoPermissions(z){return new u(z,I.FileSystemProviderErrorCode.NoPermissions,u.NoPermissions)}static Unavailable(z){return new u(z,I.FileSystemProviderErrorCode.Unavailable,u.Unavailable)}};Nt=u=Ve([R],Nt),e.FileSystemError=Nt;let Yt=class{constructor(z,oe,ke){this.start=z,this.end=oe,this.kind=ke}};Yt=Ve([R],Yt),e.FoldingRange=Yt;var bi;(function(q){q[q.Comment=1]="Comment",q[q.Imports=2]="Imports",q[q.Region=3]="Region"})(bi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var di;(function(q){q[q.Collapsed=0]="Collapsed",q[q.Expanded=1]="Expanded"})(di=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Ei;(function(q){q[q.Editing=0]="Editing",q[q.Preview=1]="Preview"})(Ei=e.CommentMode||(e.CommentMode={}));class hi{constructor(z,oe=[]){this.tokenTypes=z,this.tokenModifiers=oe}}e.SemanticTokensLegend=hi;function Jt(q){return typeof q=="undefined"||(0,_.isStringArray)(q)}class si{constructor(z){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,z){this._hasLegend=!0;for(let oe=0,ke=z.tokenTypes.length;oe<ke;oe++)this._tokenTypeStrToInt.set(z.tokenTypes[oe],oe);for(let oe=0,ke=z.tokenModifiers.length;oe<ke;oe++)this._tokenModifierStrToInt.set(z.tokenModifiers[oe],oe)}}push(z,oe,ke,Je,ot){if(typeof z=="number"&&typeof oe=="number"&&typeof ke=="number"&&typeof Je=="number"&&(typeof ot=="number"||typeof ot=="undefined"))return typeof ot=="undefined"&&(ot=0),this._pushEncoded(z,oe,ke,Je,ot);if(F.isRange(z)&&typeof oe=="string"&&Jt(ke))return this._push(z,oe,ke);throw(0,L.illegalArgument)()}_push(z,oe,ke){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(z.start.line!==z.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(oe))throw new Error("`tokenType` is not in the provided legend");const Je=z.start.line,ot=z.start.character,dt=z.end.character-z.start.character,pt=this._tokenTypeStrToInt.get(oe);let It=0;if(ke)for(const Rt of ke){if(!this._tokenModifierStrToInt.has(Rt))throw new Error("`tokenModifier` is not in the provided legend");const Ft=this._tokenModifierStrToInt.get(Rt);It|=1<<Ft>>>0}this._pushEncoded(Je,ot,dt,pt,It)}_pushEncoded(z,oe,ke,Je,ot){if(this._dataIsSortedAndDeltaEncoded&&(z<this._prevLine||z===this._prevLine&&oe<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const It=this._data.length/5|0;let Rt=0,Ft=0;for(let Mt=0;Mt<It;Mt++){let Ut=this._data[5*Mt],li=this._data[5*Mt+1];Ut===0?(Ut=Rt,li+=Ft):Ut+=Rt,this._data[5*Mt]=Ut,this._data[5*Mt+1]=li,Rt=Ut,Ft=li}}let dt=z,pt=oe;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(dt-=this._prevLine,dt===0&&(pt-=this._prevChar)),this._data[this._dataLen++]=dt,this._data[this._dataLen++]=pt,this._data[this._dataLen++]=ke,this._data[this._dataLen++]=Je,this._data[this._dataLen++]=ot,this._prevLine=z,this._prevChar=oe}static _sortAndDeltaEncode(z){let oe=[];const ke=z.length/5|0;for(let pt=0;pt<ke;pt++)oe[pt]=pt;oe.sort((pt,It)=>{const Rt=z[5*pt],Ft=z[5*It];if(Rt===Ft){const Mt=z[5*pt+1],Ut=z[5*It+1];return Mt-Ut}return Rt-Ft});const Je=new Uint32Array(z.length);let ot=0,dt=0;for(let pt=0;pt<ke;pt++){const It=5*oe[pt],Rt=z[It+0],Ft=z[It+1],Mt=z[It+2],Ut=z[It+3],li=z[It+4],Bi=Rt-ot,Ki=Bi===0?Ft-dt:Ft,ui=5*pt;Je[ui+0]=Bi,Je[ui+1]=Ki,Je[ui+2]=Mt,Je[ui+3]=Ut,Je[ui+4]=li,ot=Rt,dt=Ft}return Je}build(z){return this._dataIsSortedAndDeltaEncoded?new qt(new Uint32Array(this._data),z):new qt(si._sortAndDeltaEncode(this._data),z)}}e.SemanticTokensBuilder=si;class qt{constructor(z,oe){this.resultId=oe,this.data=z}}e.SemanticTokens=qt;class oi{constructor(z,oe,ke){this.start=z,this.deleteCount=oe,this.data=ke}}e.SemanticTokensEdit=oi;class _i{constructor(z,oe){this.resultId=oe,this.edits=z}}e.SemanticTokensEdits=_i;var Si;(function(q){q[q.Separate=0]="Separate",q[q.MergeWithParent=1]="MergeWithParent"})(Si=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Gt;(function(q){q[q.Initial=1]="Initial",q[q.Dynamic=2]="Dynamic"})(Gt=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Zt=class{constructor(){}};Zt.Back={iconPath:new Dt("arrow-left")},Zt=Ve([R],Zt),e.QuickInputButtons=Zt;var Ci;(function(q){q[q.Default=1]="Default",q[q.Separator=2]="Separator"})(Ci=e.QuickPickItemKind||(e.QuickPickItemKind={}));var yi;(function(q){q[q.UI=1]="UI",q[q.Workspace=2]="Workspace"})(yi=e.ExtensionKind||(e.ExtensionKind={}));class Di{constructor(z,oe,ke){this.badge=z,this.tooltip=oe,this.color=ke}static validate(z){if(z.badge){let oe=(0,k.nextCharLength)(z.badge,0);if(oe<z.badge.length&&(oe+=(0,k.nextCharLength)(z.badge,oe)),z.badge.length>oe)throw new Error("The 'badge'-property must be undefined or a short character")}if(!z.color&&!z.badge&&!z.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=Di;let Kt=class{constructor(z){this.kind=z}};Kt=Ve([R],Kt),e.ColorTheme=Kt;var fi;(function(q){q[q.Light=1]="Light",q[q.Dark=2]="Dark",q[q.HighContrast=3]="HighContrast"})(fi=e.ColorThemeKind||(e.ColorThemeKind={}));class zt{constructor(z,oe){if(z<0)throw(0,L.illegalArgument)("start must be positive");if(oe<0)throw(0,L.illegalArgument)("end must be positive");z<=oe?(this._start=z,this._end=oe):(this._start=oe,this._end=z)}static isNotebookRange(z){return z instanceof zt?!0:z?typeof z.start=="number"&&typeof z.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(z){let oe=this._start,ke=this._end;return z.start!==void 0&&(oe=z.start),z.end!==void 0&&(ke=z.end),oe===this._start&&ke===this._end?this:new zt(oe,ke)}}e.NotebookRange=zt;class Oe{constructor(z,oe,ke,Je,ot,dt,pt){this.kind=z,this.value=oe,this.languageId=ke,this.mime=Je,this.outputs=ot??[],this.metadata=dt,this.executionSummary=pt,Oe.validate(this)}static validate(z){if(typeof z.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof z.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof z.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(z){return Array.isArray(z)&&z.every(oe=>Oe.isNotebookCellData(oe))}static isNotebookCellData(z){return!0}}e.NotebookCellData=Oe;class ai{constructor(z){this.cells=z}}e.NotebookData=ai;class Lt{constructor(z,oe){this.data=z,this.mime=oe;const ke=(0,i.normalizeMimeType)(oe,!0);if(!ke)throw new Error(`INVALID mime type: ${oe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=ke}static isNotebookCellOutputItem(z){return z instanceof Lt?!0:z?typeof z.mime=="string"&&z.data instanceof Uint8Array:!1}static error(z){const oe={name:z.name,message:z.message,stack:z.stack};return Lt.json(oe,"application/vnd.code.notebook.error")}static stdout(z){return Lt.text(z,"application/vnd.code.notebook.stdout")}static stderr(z){return Lt.text(z,"application/vnd.code.notebook.stderr")}static bytes(z,oe="application/octet-stream"){return new Lt(z,oe)}static text(z,oe=i.Mimes.text){const ke=Ne(Lt,v,"f",S).encode(String(z));return new Lt(ke,oe)}static json(z,oe="application/json"){const ke=JSON.stringify(z,void 0,"	");return Lt.text(ke,oe)}}e.NotebookCellOutputItem=Lt,v=Lt,S={value:new TextEncoder};class Et{constructor(z,oe,ke){this.items=Et.ensureUniqueMimeTypes(z,!0),typeof oe=="string"?(this.id=oe,this.metadata=ke):(this.id=(0,T.generateUuid)(),this.metadata=oe??ke)}static isNotebookCellOutput(z){return z instanceof Et?!0:!z||typeof z!="object"?!1:typeof z.id=="string"&&(0,_.isArray)(z.items)}static ensureUniqueMimeTypes(z,oe=!1){const ke=new Set,Je=new Set;for(let ot=0;ot<z.length;ot++){const dt=z[ot],pt=(0,i.normalizeMimeType)(dt.mime);if(!ke.has(pt)){ke.add(pt);continue}Je.add(ot),oe&&console.warn(`DUPLICATED mime type '${dt.mime}' will be dropped`)}return Je.size===0?z:z.filter((ot,dt)=>!Je.has(dt))}}e.NotebookCellOutput=Et;var ki;(function(q){q[q.Markup=1]="Markup",q[q.Code=2]="Code"})(ki=e.NotebookCellKind||(e.NotebookCellKind={}));var Ii;(function(q){q[q.Idle=1]="Idle",q[q.Pending=2]="Pending",q[q.Executing=3]="Executing"})(Ii=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var mi;(function(q){q[q.Left=1]="Left",q[q.Right=2]="Right"})(mi=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var gi;(function(q){q[q.Default=0]="Default",q[q.InCenter=1]="InCenter",q[q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",q[q.AtTop=3]="AtTop"})(gi=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Pi{constructor(z,oe){this.text=z,this.alignment=oe}}e.NotebookCellStatusBarItem=Pi;var Ti;(function(q){q[q.Default=1]="Default",q[q.Preferred=2]="Preferred"})(Ti=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Ai{constructor(z,oe=[]){this.uri=z,this.provides=(0,g.asArray)(oe)}}e.NotebookRendererScript=Ai;let ci=class{constructor(z,oe){this.label=z,this.timestamp=oe}};ci=Ve([R],ci),e.TimelineItem=ci;var pi;(function(q){q[q.Production=1]="Production",q[q.Development=2]="Development",q[q.Test=3]="Test"})(pi=e.ExtensionMode||(e.ExtensionMode={}));var Ri;(function(q){q[q.Node=1]="Node",q[q.Webworker=2]="Webworker"})(Ri=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Li;(function(q){q[q.Other=0]="Other",q[q.Comment=1]="Comment",q[q.String=2]="String",q[q.RegEx=4]="RegEx"})(Li=e.StandardTokenType||(e.StandardTokenType={}));class Fi{constructor(z,oe){this.ranges=z,this.wordPattern=oe}}e.LinkedEditingRanges=Fi;class Mi{constructor(z,oe){this._port=z,this._autoForwardAction=oe}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Mi;var Oi;(function(q){q[q.Queued=1]="Queued",q[q.Running=2]="Running",q[q.Passed=3]="Passed",q[q.Failed=4]="Failed",q[q.Skipped=5]="Skipped",q[q.Errored=6]="Errored"})(Oi=e.TestResultState||(e.TestResultState={}));var te;(function(q){q[q.Run=1]="Run",q[q.Debug=2]="Debug",q[q.Coverage=3]="Coverage"})(te=e.TestRunProfileKind||(e.TestRunProfileKind={}));let he=class{constructor(z=void 0,oe=void 0,ke=void 0){this.include=z,this.exclude=oe,this.profile=ke}};he=Ve([R],he),e.TestRunRequest=he;let Ae=E=class{constructor(z){this.message=z}static diff(z,oe,ke){const Je=new E(z);return Je.expectedOutput=oe,Je.actualOutput=ke,Je}};Ae=E=Ve([R],Ae),e.TestMessage=Ae;let ht=class{constructor(z){this.id=z}};ht=Ve([R],ht),e.TestTag=ht;let Ct=class{constructor(z,oe){this.covered=z,this.total=oe}};Ct=Ve([R],Ct),e.CoveredCount=Ct;let Pt=A=class{constructor(z,oe,ke,Je){this.uri=z,this.statementCoverage=oe,this.branchCoverage=ke,this.functionCoverage=Je}static fromDetails(z,oe){const ke=new Ct(0,0),Je=new Ct(0,0),ot=new Ct(0,0);for(const pt of oe)if("branches"in pt){ke.total+=1,ke.covered+=pt.executionCount>0?1:0;for(const It of pt.branches)Je.total+=1,Je.covered+=It.executionCount>0?1:0}else ot.total+=1,ot.covered+=pt.executionCount>0?1:0;const dt=new A(z,ke,Je.total>0?Je:void 0,ot.total>0?ot:void 0);return dt.detailedCoverage=oe,dt}};Pt=A=Ve([R],Pt),e.FileCoverage=Pt;let Ni=class{constructor(z,oe,ke=[]){this.executionCount=z,this.location=oe,this.branches=ke}};Ni=Ve([R],Ni),e.StatementCoverage=Ni;let Ui=class{constructor(z,oe){this.executionCount=z,this.location=oe}};Ui=Ve([R],Ui),e.BranchCoverage=Ui;let xi=class{constructor(z,oe){this.executionCount=z,this.location=oe}};xi=Ve([R],xi),e.FunctionCoverage=xi;var Vi;(function(q){q[q.None=0]="None",q[q.Option=1]="Option",q[q.Default=2]="Default",q[q.Preferred=3]="Preferred"})(Vi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var ji;(function(q){q[q.Untrusted=0]="Untrusted",q[q.Trusted=1]="Trusted",q[q.Unspecified=2]="Unspecified"})(ji=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var qi;(function(q){q[q.Notify=1]="Notify",q[q.OpenBrowser=2]="OpenBrowser",q[q.OpenPreview=3]="OpenPreview",q[q.Silent=4]="Silent",q[q.Ignore=5]="Ignore",q[q.OpenBrowserOnce=6]="OpenBrowserOnce"})(qi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Gi{constructor(z,oe,ke,Je,ot,dt){this.kind=z,this.name=oe,this.detail=ke,this.uri=Je,this.range=ot,this.selectionRange=dt}}e.TypeHierarchyItem=Gi}),define(fe[123],me([0,1,58,10,8,150,110,7,15]),function(Y,e,g,L,y,C,i,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const D=new Map;function T(f,v){v?D.set(f,v):D.delete(f)}e.setWordDefinitionFor=T;function I(f){return D.get(f)}e.getWordDefinitionFor=I;class c extends C.MirrorTextModel{constructor(v,S,P,w,s,r,m,a){super(S,P,w,s);this._proxy=v,this._languageId=r,this._isDirty=m,this._notebook=a,this._isDisposed=!1}dispose(){(0,g.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(v){return(0,_.equals)(this._lines,v)}get document(){if(!this._document){const v=this;this._document={get uri(){return v._uri},get fileName(){return v._uri.fsPath},get isUntitled(){return v._uri.scheme===L.Schemas.untitled},get languageId(){return v._languageId},get version(){return v._versionId},get isClosed(){return v._isDisposed},get isDirty(){return v._isDirty},get notebook(){return v._notebook},save(){return v._save()},getText(S){return S?v._getTextInRange(S):v.getText()},get eol(){return v._eol===`
`?k.EndOfLine.LF:k.EndOfLine.CRLF},get lineCount(){return v._lines.length},lineAt(S){return v._lineAt(S)},offsetAt(S){return v._offsetAt(S)},positionAt(S){return v._positionAt(S)},validateRange(S){return v._validateRange(S)},validatePosition(S){return v._validatePosition(S)},getWordRangeAtPosition(S,P){return v._getWordRangeAtPosition(S,P)}}}return Object.freeze(this._document)}_acceptLanguageId(v){(0,g.ok)(!this._isDisposed),this._languageId=v}_acceptIsDirty(v){(0,g.ok)(!this._isDisposed),this._isDirty=v}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(v){const S=this._validateRange(v);if(S.isEmpty)return"";if(S.isSingleLine)return this._lines[S.start.line].substring(S.start.character,S.end.character);const P=this._eol,w=S.start.line,s=S.end.line,r=[];r.push(this._lines[w].substring(S.start.character));for(let m=w+1;m<s;m++)r.push(this._lines[m]);return r.push(this._lines[s].substring(0,S.end.character)),r.join(P)}_lineAt(v){let S;if(v instanceof k.Position?S=v.line:typeof v=="number"&&(S=v),typeof S!="number"||S<0||S>=this._lines.length||Math.floor(S)!==S)throw new Error("Illegal value for `line`");return new p(S,this._lines[S],S===this._lines.length-1)}_offsetAt(v){return v=this._validatePosition(v),this._ensureLineStarts(),this._lineStarts.getPrefixSum(v.line-1)+v.character}_positionAt(v){v=Math.floor(v),v=Math.max(0,v),this._ensureLineStarts();const S=this._lineStarts.getIndexOf(v),P=this._lines[S.index].length;return new k.Position(S.index,Math.min(S.remainder,P))}_validateRange(v){if(!(v instanceof k.Range))throw new Error("Invalid argument");const S=this._validatePosition(v.start),P=this._validatePosition(v.end);return S===v.start&&P===v.end?v:new k.Range(S.line,S.character,P.line,P.character)}_validatePosition(v){if(!(v instanceof k.Position))throw new Error("Invalid argument");if(this._lines.length===0)return v.with(0,0);let{line:S,character:P}=v,w=!1;if(S<0)S=0,P=0,w=!0;else if(S>=this._lines.length)S=this._lines.length-1,P=this._lines[S].length,w=!0;else{const s=this._lines[S].length;P<0?(P=0,w=!0):P>s&&(P=s,w=!0)}return w?new k.Position(S,P):v}_getWordRangeAtPosition(v,S){const P=this._validatePosition(v);if(!S)S=I(this._languageId);else if((0,y.regExpLeadsToEndlessLoop)(S))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${S.source}' because it matches the empty string.`);const w=(0,i.getWordAtText)(P.character+1,(0,i.ensureValidWordDefinition)(S),this._lines[P.line],0);if(w)return new k.Range(P.line,w.startColumn-1,P.line,w.endColumn-1)}}e.ExtHostDocumentData=c;class p{constructor(v,S,P){this._line=v,this._text=S,this._isLastLine=P}get lineNumber(){return this._line}get text(){return this._text}get range(){return new k.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new k.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=p}),define(fe[204],me([0,1,7,3,112,6,83,24,2,32]),function(Y,e,g,L,y,C,i,k,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class T{constructor(c,p,f,v){this._notebook=f,this._selector=v,this._disposables=new C.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this.uri=_.URI.from({scheme:"vscode-concat-doc",path:(0,D.generateUuid)()}),this._init(),this._disposables.add(p.onDidChangeDocument(P=>{const w=this._cellUris.get(P.document.uri);w!==void 0&&(this._cellLengths.setValue(w,this._cells[w].document.getText().length+1),this._cellLines.setValue(w,this._cells[w].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const S=P=>{P===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(c.onDidChangeNotebookCells(P=>S(P.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new k.ResourceMap;const c=[],p=[];for(const f of this._notebook.getCells())f.kind===g.NotebookCellKind.Code&&(!this._selector||(0,i.score)(this._selector,f.document.uri,f.document.languageId,!0))&&(this._cellUris.set(f.document.uri,this._cells.length),this._cells.push(f),c.push(f.document.getText().length+1),p.push(f.document.lineCount));this._cellLengths=new y.PrefixSumComputer(new Uint32Array(c)),this._cellLines=new y.PrefixSumComputer(new Uint32Array(p))}get version(){return this._versionId}getText(c){if(!c){let w="";for(const s of this._cells)w+=s.document.getText()+`
`;return w=w.slice(0,-1),w}if(c.isEmpty)return"";const p=this.locationAt(c.start),f=this.locationAt(c.end),v=this._cellUris.get(p.uri),S=this._cellUris.get(f.uri);if(v===void 0||S===void 0)return"";if(v===S)return this._cells[v].document.getText(new g.Range(p.range.start,f.range.end));const P=[this._cells[v].document.getText(new g.Range(p.range.start,new g.Position(this._cells[v].document.lineCount,0)))];for(let w=v+1;w<S;w++)P.push(this._cells[w].document.getText());return P.push(this._cells[S].document.getText(new g.Range(new g.Position(0,0),f.range.end))),P.join(`
`)}offsetAt(c){const p=this._cellLines.getIndexOf(c.line),f=this._cellLengths.getPrefixSum(p.index-1),v=this._cells[p.index].document.offsetAt(c.with(p.remainder));return f+v}positionAt(c){if(typeof c=="number"){const f=this._cellLengths.getIndexOf(c),v=this._cellLines.getPrefixSum(f.index-1);return this._cells[f.index].document.positionAt(f.remainder).translate(v)}const p=this._cellUris.get(c.uri);if(p!==void 0){const f=this._cellLines.getPrefixSum(p-1);return new g.Position(f+c.range.start.line,c.range.start.character)}return new g.Position(0,0)}locationAt(c){g.Range.isRange(c)||(c=new g.Range(c,c));const p=this._cellLines.getIndexOf(c.start.line);let f=p;c.isEmpty||(f=this._cellLines.getIndexOf(c.end.line));const v=new g.Position(p.remainder,c.start.character),S=new g.Position(f.remainder,c.end.character),P=new g.Range(v,S),w=this._cells[p.index];return new g.Location(w.document.uri,w.document.validateRange(P))}contains(c){return this._cellUris.has(c)}validateRange(c){const p=this.validatePosition(c.start),f=this.validatePosition(c.end);return c.with(p,f)}validatePosition(c){const p=this._cellLines.getIndexOf(c.line),f=new g.Position(p.remainder,c.character),v=this._cells[p.index].document.validatePosition(f),S=this._cellLines.getPrefixSum(p.index-1);return new g.Position(S+v.line,v.character)}}e.ExtHostNotebookConcatDocument=T}),define(fe[205],me([0,1,7,14,3]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let C=class{constructor(k){this._actual=new g.ColorTheme(g.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new y.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(k){let _=k==="light"?g.ColorThemeKind.Light:k==="dark"?g.ColorThemeKind.Dark:g.ColorThemeKind.HighContrast;this._actual=new g.ColorTheme(_),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};C=Ve([$e(0,L.IExtHostRpcService)],C),e.ExtHostTheming=C}),define(fe[67],me([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,g.createDecorator)("IURITransformerService");class L{constructor(C){C?(this.transformIncoming=C.transformIncoming.bind(C),this.transformOutgoing=C.transformOutgoing.bind(C),this.transformOutgoingURI=C.transformOutgoingURI.bind(C),this.transformOutgoingScheme=C.transformOutgoingScheme.bind(C)):(this.transformIncoming=i=>i,this.transformOutgoing=i=>i,this.transformOutgoingURI=i=>i,this.transformOutgoingScheme=i=>i)}}e.URITransformerService=L}),define(fe[206],me([0,1,22]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class L{constructor(){this.buffers=[]}add(_){let D=this.buffers.indexOf(_);return D<0&&(D=this.buffers.length,this.buffers.push(_)),D}}function y(k,_){if(_.serializeBuffersForPostMessage){const D=new L,T=(p,f)=>{if(f instanceof ArrayBuffer){const v=D.add(f);return{$$vscode_array_buffer_reference$$:!0,index:v}}else if(ArrayBuffer.isView(f)){const v=C(f);if(v){const S=D.add(f.buffer);return{$$vscode_array_buffer_reference$$:!0,index:S,view:{type:v,byteLength:f.byteLength,byteOffset:f.byteOffset}}}}return f},I=JSON.stringify(k,T),c=D.buffers.map(p=>{const f=new Uint8Array(p);return g.VSBuffer.wrap(f)});return{message:I,buffers:c}}else return{message:JSON.stringify(k),buffers:[]}}e.serializeWebviewMessage=y;function C(k){switch(k.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function i(k,_){const D=_.map(c=>{const p=new ArrayBuffer(c.byteLength);return new Uint8Array(p).set(c.buffer),p}),T=_.length?(c,p)=>{if(typeof p=="object"&&p.$$vscode_array_buffer_reference$$){const f=p,{index:v}=f,S=D[v];if(f.view)switch(f.view.type){case 1:return new Int8Array(S,f.view.byteOffset,f.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(S,f.view.byteOffset,f.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(S,f.view.byteOffset,f.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(S,f.view.byteOffset,f.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(S,f.view.byteOffset,f.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(S,f.view.byteOffset,f.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(S,f.view.byteOffset,f.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(S,f.view.byteOffset,f.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(S,f.view.byteOffset,f.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(S,f.view.byteOffset,f.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(S,f.view.byteOffset,f.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return S}return p}:void 0;return{message:JSON.parse(k,T),arrayBuffers:D}}e.deserializeWebviewMessage=i}),define(fe[207],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var g;(function(L){function y(i){const k={items:new Map};return i.types.forEach((_,D)=>{k.items.set(_,{asString:async()=>i.items[D].asString})}),k}L.toITreeDataTransfer=y;async function C(i){const k={types:[],items:[]},_=Array.from(i.items.entries());for(const D of _)k.types.push(D[0]),k.items.push({asString:await D[1].asString()});return k}L.toTreeDataTransferDTO=C})(g=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(fe[89],me([0,1,10,2]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function y(k,_){return k.scheme===g.Schemas.http||k.scheme===g.Schemas.https?k:(_&&_.authority&&_.isRemote&&k.scheme===g.Schemas.file&&(k=L.URI.from({scheme:g.Schemas.vscodeRemote,authority:_.authority,path:k.path})),L.URI.from({scheme:g.Schemas.https,authority:`${k.scheme}+${C(k.authority)}.${e.webviewRootResourceAuthority}`,path:k.path,fragment:k.fragment,query:k.query}))}e.asWebviewUri=y;function C(k){return k.replace(/./g,_=>{const D=_.charCodeAt(0);return D>=97&&D<=122||D>=65&&D<=90||D>=48&&D<=57?_:"-"+D.toString(16).padStart(4,"0")})}function i(k){return k.replace(/-([0-9a-f]{4})/g,(_,D)=>String.fromCharCode(parseInt(D,16)))}e.decodeAuthority=i}),define(fe[208],me([0,1,3,6,89]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class C{constructor(k,_,D){this._proxy=k,this._editors=_,this._initData=D,this._handlePool=0,this._disposables=new L.DisposableStore,this._insets=new Map,this._disposables.add(_.onDidChangeVisibleTextEditors(()=>{const T=_.getVisibleTextEditors();for(const I of this._insets.values())T.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this._insets.forEach(k=>k.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(k,_,D,T,I){let c;for(const s of this._editors.getVisibleTextEditors(!0))if(s.value===k){c=s;break}if(!c)throw new Error("not a visible editor");const p=this,f=this._handlePool++,v=new g.Emitter,S=new g.Emitter,P=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(s){return(0,y.asWebviewUri)(s,p._initData.remote)}get cspSource(){return y.webviewGenericCspSource}set options(s){this._options=s,p._proxy.$setOptions(f,s)}get options(){return this._options}set html(s){this._html=s,p._proxy.$setHtml(f,s)}get html(){return this._html}get onDidReceiveMessage(){return v.event}postMessage(s){return p._proxy.$postMessage(f,s)}},w=new class{constructor(){this.editor=k,this.line=_,this.height=D,this.webview=P,this.onDidDispose=S.event}dispose(){p._insets.has(f)&&(p._insets.delete(f),p._proxy.$disposeEditorInset(f),S.fire(),S.dispose(),v.dispose())}};return this._proxy.$createEditorInset(f,c.id,c.value.document.uri,_+1,D,T||{},I.identifier,I.extensionLocation),this._insets.set(f,{editor:k,inset:w,onDidReceiveMessage:v}),w}$onDidDispose(k){const _=this._insets.get(k);_&&_.inset.dispose()}$onDidReceiveMessage(k,_){const D=this._insets.get(k);D&&D.onDidReceiveMessage.fire(_)}}e.ExtHostEditorInsets=C}),define(fe[209],me([0,1,173,13,2,6,4,53,35,43,15,10]),function(Y,e,g,L,y,C,i,k,_,D,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.SideBySideEditorActiveContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,g.localize)(0,null),providerDisplayName:(0,g.localize)(1,null)},e.ActiveEditorDirtyContext=new k.RawContextKey("activeEditorIsDirty",!1,(0,g.localize)(2,null)),e.ActiveEditorPinnedContext=new k.RawContextKey("activeEditorIsNotPreview",!1,(0,g.localize)(3,null)),e.ActiveEditorStickyContext=new k.RawContextKey("activeEditorIsPinned",!1,(0,g.localize)(4,null)),e.ActiveEditorReadonlyContext=new k.RawContextKey("activeEditorIsReadonly",!1,(0,g.localize)(5,null)),e.ActiveEditorCanRevertContext=new k.RawContextKey("activeEditorCanRevert",!1,(0,g.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new k.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new k.RawContextKey("activeEditor",null,{type:"string",description:(0,g.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new k.RawContextKey("activeEditorAvailableEditorIds","",(0,g.localize)(8,null)),e.TextCompareEditorVisibleContext=new k.RawContextKey("textCompareEditorVisible",!1,(0,g.localize)(9,null)),e.TextCompareEditorActiveContext=new k.RawContextKey("textCompareEditorActive",!1,(0,g.localize)(10,null)),e.SideBySideEditorActiveContext=new k.RawContextKey("sideBySideEditorActive",!1,(0,g.localize)(11,null)),e.EditorGroupEditorsCountContext=new k.RawContextKey("groupEditorsCount",0,(0,g.localize)(12,null)),e.ActiveEditorGroupEmptyContext=new k.RawContextKey("activeEditorGroupEmpty",!1,(0,g.localize)(13,null)),e.ActiveEditorGroupIndexContext=new k.RawContextKey("activeEditorGroupIndex",0,(0,g.localize)(14,null)),e.ActiveEditorGroupLastContext=new k.RawContextKey("activeEditorGroupLast",!1,(0,g.localize)(15,null)),e.ActiveEditorGroupLockedContext=new k.RawContextKey("activeEditorGroupLocked",!1,(0,g.localize)(16,null)),e.MultipleEditorGroupsContext=new k.RawContextKey("multipleEditorGroups",!1,(0,g.localize)(17,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new k.RawContextKey("editorIsOpen",!1,(0,g.localize)(18,null)),e.InEditorZenModeContext=new k.RawContextKey("inZenMode",!1,(0,g.localize)(19,null)),e.IsCenteredLayoutContext=new k.RawContextKey("isCenteredLayout",!1,(0,g.localize)(20,null)),e.SplitEditorsVertically=new k.RawContextKey("splitEditorsVertically",!1,(0,g.localize)(21,null)),e.EditorAreaVisibleContext=new k.RawContextKey("editorAreaVisible",!0,(0,g.localize)(22,null)),e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function c(x,F,$){for(const M of $.visibleEditorPanes)if(M.group.id===F&&x.matches(M.input))return M.getViewState()}e.findViewStateForEditor=c;function p(x){if(m(x))return!1;const F=x;return y.URI.isUri(F?.resource)}e.isResourceEditorInput=p;function f(x){if(m(x))return!1;const F=x;return F?.original!==void 0&&F.modified!==void 0}e.isResourceDiffEditorInput=f;function v(x){if(m(x)||f(x))return!1;const F=x;return F?.primary!==void 0&&F.secondary!==void 0}e.isResourceSideBySideEditorInput=v;function S(x){if(m(x))return!1;const F=x;return F?F.resource===void 0||F.resource.scheme===I.Schemas.untitled||F.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=S;var P;(function(x){x[x.SHORT=0]="SHORT",x[x.MEDIUM=1]="MEDIUM",x[x.LONG=2]="LONG"})(P=e.Verbosity||(e.Verbosity={}));var w;(function(x){x[x.EXPLICIT=1]="EXPLICIT",x[x.AUTO=2]="AUTO",x[x.FOCUS_CHANGE=3]="FOCUS_CHANGE",x[x.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(w=e.SaveReason||(e.SaveReason={}));var s;(function(x){x[x.None=0]="None",x[x.Readonly=2]="Readonly",x[x.Untitled=4]="Untitled",x[x.Singleton=8]="Singleton",x[x.RequiresTrust=16]="RequiresTrust",x[x.CanSplitInGroup=32]="CanSplitInGroup",x[x.ForceDescription=64]="ForceDescription"})(s=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class r extends C.Disposable{}e.AbstractEditorInput=r;function m(x){return x instanceof r}e.isEditorInput=m;function a(x){const F=x;return y.URI.isUri(F?.preferredResource)}function b(x){const F=x;return m(F?.primary)&&m(F?.secondary)}e.isSideBySideEditorInput=b;function n(x){const F=x;return m(F?.modified)&&m(F?.original)}e.isDiffEditorInput=n;function t(x){return m(x?.editor)}e.isEditorInputWithOptions=t;function l(x){const F=x;return t(x)&&F?.group!==void 0}e.isEditorInputWithOptionsAndGroup=l;function d(x){const F=x;return typeof F?.groupId=="number"&&m(F.editor)}e.isEditorIdentifier=d;var o;(function(x){x[x.UNKNOWN=0]="UNKNOWN",x[x.REPLACE=1]="REPLACE",x[x.MOVE=2]="MOVE",x[x.UNPIN=3]="UNPIN"})(o=e.EditorCloseContext||(e.EditorCloseContext={}));var h;(function(x){x[x.PRIMARY=1]="PRIMARY",x[x.SECONDARY=2]="SECONDARY",x[x.BOTH=3]="BOTH",x[x.ANY=4]="ANY"})(h=e.SideBySideEditor||(e.SideBySideEditor={}));class u{getOriginalUri(F,$){if(!F)return;if($?.supportSideBySide){const{primary:H,secondary:N}=this.getSideEditors(F);if(H&&N){if($?.supportSideBySide===h.BOTH)return{primary:this.getOriginalUri(H,{filterByScheme:$.filterByScheme}),secondary:this.getOriginalUri(N,{filterByScheme:$.filterByScheme})};if($?.supportSideBySide===h.ANY)return this.getOriginalUri(H,{filterByScheme:$.filterByScheme})??this.getOriginalUri(N,{filterByScheme:$.filterByScheme});F=$.supportSideBySide===h.PRIMARY?H:N}}if(f(F)||v(F))return;const M=a(F)?F.preferredResource:F.resource;return!M||!$||!$.filterByScheme?M:this.filterUri(M,$.filterByScheme)}getSideEditors(F){return b(F)||v(F)?{primary:F.primary,secondary:F.secondary}:n(F)||f(F)?{primary:F.modified,secondary:F.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(F,$){if(!F)return;if($?.supportSideBySide){const{primary:H,secondary:N}=this.getSideEditors(F);if(H&&N){if($?.supportSideBySide===h.BOTH)return{primary:this.getCanonicalUri(H,{filterByScheme:$.filterByScheme}),secondary:this.getCanonicalUri(N,{filterByScheme:$.filterByScheme})};if($?.supportSideBySide===h.ANY)return this.getCanonicalUri(H,{filterByScheme:$.filterByScheme})??this.getCanonicalUri(N,{filterByScheme:$.filterByScheme});F=$.supportSideBySide===h.PRIMARY?H:N}}if(f(F)||v(F))return;const M=F.resource;return!M||!$||!$.filterByScheme?M:this.filterUri(M,$.filterByScheme)}filterUri(F,$){if(Array.isArray($)){if($.some(M=>F.scheme===M))return F}else if($===F.scheme)return F}}e.EditorResourceAccessor=new u;var E;(function(x){x[x.LEFT=0]="LEFT",x[x.RIGHT=1]="RIGHT"})(E=e.CloseDirection||(e.CloseDirection={}));class A{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(F){const $=this.instantiationService=F.get(i.IInstantiationService);for(const[M,H]of this.editorSerializerConstructors)this.createEditorSerializer(M,H,$);this.editorSerializerConstructors.clear()}createEditorSerializer(F,$,M){const H=M.createInstance($);this.editorSerializerInstances.set(F,H)}registerFileEditorFactory(F){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=F}getFileEditorFactory(){return(0,L.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(F,$){if(this.editorSerializerConstructors.has(F)||this.editorSerializerInstances.has(F))throw new Error(`A editor serializer with type ID '${F}' was already registered.`);return this.instantiationService?this.createEditorSerializer(F,$,this.instantiationService):this.editorSerializerConstructors.set(F,$),(0,C.toDisposable)(()=>{this.editorSerializerConstructors.delete(F),this.editorSerializerInstances.delete(F)})}getEditorSerializer(F){return this.editorSerializerInstances.get(typeof F=="string"?F:F.typeId)}}_.Registry.add(e.EditorExtensions.EditorFactory,new A);async function R(x,F){if(!x||!x.length)return[];const $=await Promise.all(x.map(async M=>{const H=y.URI.revive(M.fileUri);if(!H||!await F.canHandleResource(H))return;let U=M.exists,V=M.type;if(typeof U!="boolean"||typeof V!="number")try{V=(await F.resolve(H)).isFile?D.FileType.File:D.FileType.Unknown,U=!0}catch{U=!1}if(!U&&M.openOnlyIfExists||V!==D.FileType.File)return;const O={selection:U?M.selection:void 0,pinned:!0,override:M.editorOverrideId};let W;return U?W={resource:H,options:O}:W={resource:H,options:O,forceUntitled:!0},W}));return(0,T.coalesce)($)}e.pathsToEditors=R;var B;(function(x){x[x.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",x[x.SEQUENTIAL=1]="SEQUENTIAL"})(B=e.EditorsOrder||(e.EditorsOrder={}))}),define(fe[210],me([0,1,3,53,174,4,6,24,35,15,59,25,48,199]),function(Y,e,g,L,y,C,i,k,_,D,T,I,c,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TREE_ITEM_DATA_TRANSFER_TYPE=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,p.registerIcon)("default-view-icon",c.Codicon.window,(0,y.localize)(0,null));var f;(function(l){l.ViewContainersRegistry="workbench.registry.view.containers",l.ViewsRegistry="workbench.registry.view"})(f=e.Extensions||(e.Extensions={}));var v;(function(l){l[l.Sidebar=0]="Sidebar",l[l.Panel=1]="Panel",l[l.AuxiliaryBar=2]="AuxiliaryBar"})(v=e.ViewContainerLocation||(e.ViewContainerLocation={})),e.ViewContainerLocations=[0,1,2];function S(l){switch(l){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=S;function P(l){return`viewContainer.${l}.enabled`}e.getEnabledViewContainerContextKey=P;class w extends i.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new g.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new g.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,D.flatten)([...this.viewContainers.values()])}registerViewContainer(d,o,h){const u=this.get(d.id);if(u)return u;const E=d;return E.openCommandActionDescriptor=h?.donotRegisterOpenCommand?void 0:E.openCommandActionDescriptor??{id:E.id},(0,k.getOrSet)(this.viewContainers,o,[]).push(E),h?.isDefault&&this.defaultViewContainers.push(E),this._onDidRegister.fire({viewContainer:E,viewContainerLocation:o}),E}deregisterViewContainer(d){for(const o of this.viewContainers.keys()){const h=this.viewContainers.get(o),u=h?.indexOf(d);if(u!==-1){h?.splice(u,1),h.length===0&&this.viewContainers.delete(o),this._onDidDeregister.fire({viewContainer:d,viewContainerLocation:o});return}}}get(d){return this.all.filter(o=>o.id===d)[0]}getViewContainers(d){return[...this.viewContainers.get(d)||[]]}getViewContainerLocation(d){return[...this.viewContainers.keys()].filter(o=>this.getViewContainers(o).filter(h=>h?.id===d.id).length>0)[0]}getDefaultViewContainer(d){return this.defaultViewContainers.find(o=>this.getViewContainerLocation(o)===d)}}_.Registry.add(f.ViewContainersRegistry,new w);var s;(function(l){l.Open="2_open",l.Debug="4_debug",l.SCM="5_scm",l.More="9_more"})(s=e.ViewContentGroups||(e.ViewContentGroups={}));function r(l,d){const o=l.group??s.More,h=d.group??s.More;return o!==h?o.localeCompare(h):(l.order??5)-(d.order??5)}class m extends i.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new g.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new g.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new g.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new g.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new T.SetMap}registerViews(d,o){this.registerViews2([{views:d,viewContainer:o}])}registerViews2(d){d.forEach(({views:o,viewContainer:h})=>this.addViews(o,h)),this._onViewsRegistered.fire(d)}deregisterViews(d,o){const h=this.removeViews(d,o);h.length&&this._onViewsDeregistered.fire({views:h,viewContainer:o})}moveViews(d,o){for(const h of this._views.keys())if(h!==o){const u=this.removeViews(d,h);u.length&&(this.addViews(u,o),this._onDidChangeContainer.fire({views:u,from:h,to:o}))}}getViews(d){return this._views.get(d)||[]}getView(d){for(const o of this._viewContainers){const h=(this._views.get(o)||[]).filter(u=>u.id===d)[0];if(h)return h}return null}getViewContainer(d){for(const o of this._viewContainers)if((this._views.get(o)||[]).filter(u=>u.id===d)[0])return o;return null}registerViewWelcomeContent(d,o){return this._viewWelcomeContents.add(d,o),this._onDidChangeViewWelcomeContent.fire(d),(0,i.toDisposable)(()=>{this._viewWelcomeContents.delete(d,o),this._onDidChangeViewWelcomeContent.fire(d)})}registerViewWelcomeContent2(d,o){const h=new Map;for(const[u,E]of o)this._viewWelcomeContents.add(d,E),h.set(u,(0,i.toDisposable)(()=>{this._viewWelcomeContents.delete(d,E),this._onDidChangeViewWelcomeContent.fire(d)}));return this._onDidChangeViewWelcomeContent.fire(d),h}getViewWelcomeContent(d){const o=[];return this._viewWelcomeContents.forEach(d,h=>o.push(h)),o.sort(r)}addViews(d,o){let h=this._views.get(o);h||(h=[],this._views.set(o,h),this._viewContainers.push(o));for(const u of d){if(this.getView(u.id)!==null)throw new Error((0,y.localize)(1,null,u.id));h.push(u)}}removeViews(d,o){const h=this._views.get(o);if(!h)return[];const u=[],E=[];for(const A of h)d.includes(A)?u.push(A):E.push(A);return u.length&&(E.length?this._views.set(o,E):(this._views.delete(o),this._viewContainers.splice(this._viewContainers.indexOf(o),1))),u}}_.Registry.add(f.ViewsRegistry,new m),e.IViewsService=(0,C.createDecorator)("viewsService"),e.FocusedViewContext=new L.RawContextKey("focusedView","",(0,y.localize)(2,null));function a(l){return`view.${l}.visible`}e.getVisbileViewContextKey=a,e.IViewDescriptorService=(0,C.createDecorator)("viewDescriptorService");var b;(function(l){l[l.Default=0]="Default",l[l.Expand=1]="Expand"})(b=e.ViewVisibilityState||(e.ViewVisibilityState={}));var n;(function(l){l[l.None=0]="None",l[l.Collapsed=1]="Collapsed",l[l.Expanded=2]="Expanded"})(n=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class t{constructor(d,o){this.resolved=!1,this._hasResolve=!1,(0,I.mixin)(this,d),this._hasResolve=!!o,this.resolve=async h=>{if(o&&!this.resolved){const u=await o(h);u&&(this.tooltip=this.tooltip??u.tooltip,this.command=this.command??u.command)}h.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=t,e.TREE_ITEM_DATA_TRANSFER_TYPE="text/treeitems"}),define(fe[124],me([0,1,3,16,175]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class C{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new g.Emitter,this._onExit=new g.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(k){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=k}onEvent(k){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=k}onRequest(k){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=k}sendResponse(k){k.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${k.command}`)):this.internalSend("response",k)}sendRequest(k,_,D,T){const I={command:k};if(_&&Object.keys(_).length>0&&(I.arguments=_),this.internalSend("request",I),typeof T=="number"){const c=setTimeout(()=>{clearTimeout(c);const p=this.pendingRequests.get(I.seq);if(p){this.pendingRequests.delete(I.seq);const f={type:"response",seq:0,request_seq:I.seq,success:!1,command:k,message:(0,y.localize)(0,null,T,k)};p(f)}},T)}return D&&this.pendingRequests.set(I.seq,D),I.seq}acceptMessage(k){this.messageCallback?this.messageCallback(k):(this.queue.push(k),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(k,_){return k.type!=="event"||_.type!=="event"}async processQueue(){let k;for(;this.queue.length;){if((!k||this.needsTaskBoundaryBetween(this.queue[0],k))&&await(0,L.timeout)(0),k=this.queue.shift(),!k)return;switch(k.type){case"event":this.eventCallback&&this.eventCallback(k);break;case"request":this.requestCallback&&this.requestCallback(k);break;case"response":const _=k,D=this.pendingRequests.get(_.request_seq);D&&(this.pendingRequests.delete(_.request_seq),D(_));break}}}internalSend(k,_){_.type=k,_.seq=this.sequence++,this.sendMessage(_)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const k=new Map;this.pendingRequests.forEach((_,D)=>k.set(D,_)),await(0,L.timeout)(500),k.forEach((_,D)=>{_({type:"response",seq:0,request_seq:D,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(D)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=C}),define(fe[211],me([0,1,8,2,9,25,10]),function(Y,e,g,L,y,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const k=/{([^}]+)}/g;function _(n,t,l){return n.replace(k,function(d,o){return t&&o.length>0&&o[0]!=="_"?d:l&&l.hasOwnProperty(o)?l[o]:d})}e.formatPII=_;function D(n){const t={};for(const l of Object.keys(n))l.startsWith("!")||(t[l]=n[l]);return t}e.filterExceptionsFromTelemetry=D;function T(n){return n.configuration.request==="attach"&&!I(n)&&(!n.parentSession||T(n.parentSession))}e.isSessionAttach=T;function I(n){let t=n.configuration.type;if(!!t)return t==="vslsShare"&&(t=n.configuration.adapterProxy.configuration.type),(0,g.equalsIgnoreCase)(t,"extensionhost")||(0,g.equalsIgnoreCase)(t,"pwa-extensionhost")?n:n.parentSession?I(n.parentSession):void 0}e.getExtensionHostDebugSession=I;function c(n){return n.type&&(n.label||n.program||n.runtime)}e.isDebuggerMainContribution=c;function p(n,t,l){let d,o=0,h=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,u=null;for(;u=h.exec(n);){let E=u.index+1,A=E+u[0].length;if(E<=t&&A>=l){d=u[0],o=E;break}}if(d){let E=/\w+/g,A=null;for(;(A=E.exec(d))&&!(A.index+1+o+A[0].length>=l););A&&(d=d.substring(0,E.lastIndex))}return d?{start:o,end:o+d.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=p;const f=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function v(n){return!!(n&&n.match(f))}e.isUri=v;function S(n){if(typeof n.path=="string"&&!(typeof n.sourceReference=="number"&&n.sourceReference>0)){if(v(n.path))return L.URI.parse(n.path);if((0,y.isAbsolute)(n.path))return L.URI.file(n.path)}return n.path}function P(n){if(typeof n.path=="object"){const t=L.URI.revive(n.path);if(t)return t.scheme===i.Schemas.file?t.fsPath:t.toString()}return n.path}function w(n,t){const l=t?S:P,d=(0,C.deepClone)(n);return r(d,(o,h)=>{o&&h&&(h.path=l(h))}),d}e.convertToDAPaths=w;function s(n,t){const l=t?S:P,d=(0,C.deepClone)(n);return r(d,(o,h)=>{!o&&h&&(h.path=l(h))}),d}e.convertToVSCPaths=s;function r(n,t){switch(n.type){case"event":const l=n;switch(l.event){case"output":t(!1,l.body.source);break;case"loadedSource":t(!1,l.body.source);break;case"breakpoint":t(!1,l.body.breakpoint.source);break;default:break}break;case"request":const d=n;switch(d.command){case"setBreakpoints":t(!0,d.arguments.source);break;case"breakpointLocations":t(!0,d.arguments.source);break;case"source":t(!0,d.arguments.source);break;case"gotoTargets":t(!0,d.arguments.source);break;case"launchVSCode":d.arguments.args.forEach(h=>t(!1,h));break;default:break}break;case"response":const o=n;if(o.success&&o.body)switch(o.command){case"stackTrace":o.body.stackFrames.forEach(h=>t(!1,h.source));break;case"loadedSources":o.body.sources.forEach(h=>t(!1,h));break;case"scopes":o.body.scopes.forEach(h=>t(!1,h.source));break;case"setFunctionBreakpoints":o.body.breakpoints.forEach(h=>t(!1,h.source));break;case"setBreakpoints":o.body.breakpoints.forEach(h=>t(!1,h.source));break;default:break}break}}function m(n){return n.filter(t=>!t.presentation?.hidden).sort((t,l)=>t.presentation?l.presentation?t.presentation.group?l.presentation.group?t.presentation.group!==l.presentation.group?t.presentation.group.localeCompare(l.presentation.group):a(t.presentation.order,l.presentation.order):-1:l.presentation.group?1:a(t.presentation.order,l.presentation.order):-1:l.presentation?1:0)}e.getVisibleAndSorted=m;function a(n,t){return typeof n!="number"?typeof t!="number"?0:1:typeof t!="number"?-1:n-t}async function b(n,t){const l=n.getValue("debug.saveBeforeStart",{overrideIdentifier:t.activeTextEditorMode});if(l!=="none"&&(await t.saveAll(),l==="allEditorsInActiveGroup")){const d=t.activeEditorPane;d&&await t.save({editor:d.input,groupId:d.group.id})}await n.reloadConfiguration()}e.saveAllBeforeDebugStart=b}),define(fe[212],me([0,1,28,39,176,125,9,8,25,12,186,124]),function(Y,e,g,L,y,C,i,k,_,D,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class c extends I.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(w,s){this.outputStream=s,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,w.on("data",r=>this.handleData(r))}sendMessage(w){if(this.outputStream){const s=JSON.stringify(w);this.outputStream.write(`Content-Length: ${Buffer.byteLength(s,"utf8")}${c.TWO_CRLF}${s}`,"utf8")}}handleData(w){for(this.rawData=Buffer.concat([this.rawData,w]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const s=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,s.length>0)try{this.acceptMessage(JSON.parse(s))}catch(r){this._onError.fire(new Error((r.message||r)+`
`+s))}continue}}else{const s=this.rawData.indexOf(c.TWO_CRLF);if(s!==-1){const m=this.rawData.toString("utf8",0,s).split(c.HEADER_LINESEPARATOR);for(const a of m){const b=a.split(c.HEADER_FIELDSEPARATOR);b[0]==="Content-Length"&&(this.contentLength=Number(b[1]))}this.rawData=this.rawData.slice(s+c.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=c,c.TWO_CRLF=`\r
\r
`,c.HEADER_LINESEPARATOR=/\r?\n/,c.HEADER_FIELDSEPARATOR=/: */;class p extends c{startSession(){return new Promise((w,s)=>{let r=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),w(),r=!0}),this.socket.on("close",()=>{r?this._onError.fire(new Error("connection closed")):s(new Error("connection closed"))}),this.socket.on("error",m=>{r?this._onError.fire(m):s(m)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=p;class f extends p{constructor(w){super();this.adapterServer=w}createConnection(w){return C.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",w)}}e.SocketDebugAdapter=f;class v extends p{constructor(w){super();this.adapterServer=w}createConnection(w){return C.createConnection(this.adapterServer.path,w)}}e.NamedPipeDebugAdapter=v;class S extends c{constructor(w,s,r){super();this.adapterExecutable=w,this.debugType=s,this.outputService=r}async startSession(){const w=this.adapterExecutable.command,s=this.adapterExecutable.args,r=this.adapterExecutable.options||{};try{if(w)if(i.isAbsolute(w)){if(!await g.Promises.exists(w))throw new Error(y.localize(0,null,w))}else w.indexOf("/")<0&&w.indexOf("\\")<0;else throw new Error(y.localize(1,null,this.debugType));let m=process.env;if(r.env&&Object.keys(r.env).length>0&&(m=_.mixin(_.deepClone(process.env),r.env)),w==="node")if(Array.isArray(s)&&s.length>0){const b=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,n={env:m,execArgv:b?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};r.cwd&&(n.cwd=r.cwd);const t=L.fork(s[0],s.slice(1),n);if(!t.pid)throw new Error(y.localize(2,null,s[0]));this.serverProcess=t}else throw new Error(y.localize(3,null));else{const b={env:m};r.cwd&&(b.cwd=r.cwd),this.serverProcess=L.spawn(w,s,b)}this.serverProcess.on("error",b=>{this._onError.fire(b)}),this.serverProcess.on("exit",(b,n)=>{this._onExit.fire(b)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",b=>{this._onError.fire(b)}),this.serverProcess.stdin.on("error",b=>{this._onError.fire(b)});const a=this.outputService;if(a){const b=n=>n.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",n=>{const t=a.getChannel(T.ExtensionsChannelId);t&&t.append(b(n))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(m){this._onError.fire(m)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),D.isWindows?new Promise((w,s)=>{const r=L.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(m,a,b){if(m)return s(m)});r.on("exit",w),r.on("error",s)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(w,s){if(!w)return;const r=Object.create(null);w.runtime&&(w.runtime.indexOf("./")===0?r.runtime=i.join(s,w.runtime):r.runtime=w.runtime),w.runtimeArgs&&(r.runtimeArgs=w.runtimeArgs),w.program&&(i.isAbsolute(w.program)?r.program=w.program:r.program=i.join(s,w.program)),w.args&&(r.args=w.args);const m=w;return m.win&&(r.win=S.extract(m.win,s)),m.winx86&&(r.winx86=S.extract(m.winx86,s)),m.windows&&(r.windows=S.extract(m.windows,s)),m.osx&&(r.osx=S.extract(m.osx,s)),m.linux&&(r.linux=S.extract(m.linux,s)),r}static platformAdapterExecutable(w,s){let r=Object.create(null);s=s.toLowerCase();for(const l of w)if(l.contributes){const d=l.contributes.debuggers;d&&d.length>0&&d.filter(o=>typeof o.type=="string"&&k.equalsIgnoreCase(o.type,s)).forEach(o=>{const h=S.extract(o,l.extensionLocation.fsPath);r=_.mixin(r,h,l.isBuiltin)})}let m;D.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?m=r.winx86||r.win||r.windows:D.isWindows?m=r.win||r.windows:D.isMacintosh?m=r.osx:D.isLinux&&(m=r.linux),m=m||r;let a=m.program||r.program;const b=m.args||r.args;let n=m.runtime||r.runtime;const t=m.runtimeArgs||r.runtimeArgs;if(n)return{type:"executable",command:n,args:(t||[]).concat(typeof a=="string"?[a]:[]).concat(b||[])};if(a)return{type:"executable",command:a,args:b||[]}}}e.ExecutableDebugAdapter=S}),define(fe[213],me([0,1,39,12,30,188]),function(Y,e,g,L,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;function i(c,p){return new Promise((f,v)=>{let S="";const P=g.spawn(c,p);P.pid&&P.stdout.on("data",w=>{S+=w.toString()}),P.on("error",w=>{v(w)}),P.on("close",w=>{f(S)})})}let k;function _(c,p){if(!k)if(L.isWindows)k=new C.WindowsExternalTerminalService;else if(L.isMacintosh)k=new C.MacExternalTerminalService;else if(L.isLinux)k=new C.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const f=p.getConfiguration("terminal");return k.runInTerminal(c.title,c.cwd,c.args,c.env||{},f.external||{})}e.runInExternalTerminal=_;async function D(c){if(c)if(L.isWindows){const p=await new Promise((f,v)=>{Y(["windows-process-tree"],f,v)});return new Promise(f=>{p.getProcessTree(c,v=>{f(v.children.length>0)})})}else return i("/usr/bin/pgrep",["-lP",String(c)]).then(p=>{const f=p.trim();return!(f.length===0||f.indexOf(" tmux")>=0)},p=>!0);return Promise.resolve(!0)}e.hasChildProcesses=D;var T;(function(c){c[c.cmd=0]="cmd",c[c.powershell=1]="powershell",c[c.bash=2]="bash"})(T||(T={}));function I(c,p,f,v){c=c.trim().toLowerCase();let S;c.indexOf("powershell")>=0||c.indexOf("pwsh")>=0?S=1:c.indexOf("cmd.exe")>=0?S=0:c.indexOf("bash")>=0?S=2:L.isWindows?S=0:S=2;let P,w=" ";switch(S){case 1:if(P=r=>(r=r.replace(/\'/g,"''"),r.length>0&&r.charAt(r.length-1)==="\\"?`'${r}\\'`:`'${r}'`),f){const r=(0,y.getDriveLetter)(f);r&&(w+=`${r}:; `),w+=`cd ${P(f)}; `}if(v)for(let r in v){const m=v[r];m===null?w+=`Remove-Item env:${r}; `:w+=`\${env:${r}}='${m}'; `}if(p.length>0){const r=P(p.shift());w+=r[0]==="'"?`& ${r} `:`${r} `;for(let m of p)w+=`${P(m)} `}break;case 0:if(P=r=>(r=r.replace(/\"/g,'""'),r.indexOf(" ")>=0||r.indexOf('"')>=0||r.length===0?`"${r}"`:r),f){const r=(0,y.getDriveLetter)(f);r&&(w+=`${r}: && `),w+=`cd ${P(f)} && `}if(v){w+='cmd /C "';for(let r in v){let m=v[r];m===null?w+=`set "${r}=" && `:(m=m.replace(/[\^\&\|\<\>]/g,a=>`^${a}`),w+=`set "${r}=${m}" && `)}}for(let r of p)w+=`${P(r)} `;v&&(w+='"');break;case 2:P=r=>(r=r.replace(/(["'\\\$])/g,"\\$1"),r.indexOf(" ")>=0||r.indexOf(";")>=0||r.length===0?`"${r}"`:r);const s=r=>/[^\w@%\/+=,.:^-]/.test(r)?`'${r.replace(/'/g,"'\\''")}'`:r;if(f&&(w+=`cd ${P(f)} ; `),v){w+="/usr/bin/env";for(let r in v){const m=v[r];m===null?w+=` -u ${s(r)}`:w+=` ${s(`${r}=${m}`)}`}w+=" "}for(let r of p)w+=`${P(r)} `;break}return w}e.prepareCommand=I}),define(fe[126],me([0,1,31,78,102,10,9,12,53]),function(Y,e,g,L,y,C,i,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var D;(function(E){E[E.Markup=1]="Markup",E[E.Code=2]="Code"})(D=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",y.Mimes.latex,y.Mimes.markdown,"image/png","image/jpeg",y.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[y.Mimes.latex,y.Mimes.markdown,"application/json",y.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["vscode.ipynb"])],["ms-toolsai.jupyter-renderers",new Set(["vscode.ipynb"])]]),e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var T;(function(E){E[E.Running=1]="Running",E[E.Idle=2]="Idle"})(T=e.NotebookRunState||(e.NotebookRunState={}));var I;(function(E){E[E.Pending=2]="Pending",E[E.Executing=3]="Executing"})(I=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var c;(function(E){E[E.WithHardKernelDependency=0]="WithHardKernelDependency",E[E.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",E[E.Pure=2]="Pure",E[E.Never=3]="Never"})(c=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var p;(function(E){E.Always="always",E.Never="never",E.Optional="optional"})(p=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var f;(function(E){E[E.ModelChange=1]="ModelChange",E[E.Move=2]="Move",E[E.ChangeLanguage=5]="ChangeLanguage",E[E.Initialize=6]="Initialize",E[E.ChangeCellMetadata=7]="ChangeCellMetadata",E[E.Output=8]="Output",E[E.OutputItem=9]="OutputItem",E[E.ChangeCellContent=10]="ChangeCellContent",E[E.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",E[E.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",E[E.ChangeCellMime=13]="ChangeCellMime",E[E.Unknown=100]="Unknown"})(f=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var v;(function(E){E[E.Handle=0]="Handle",E[E.Index=1]="Index"})(v=e.SelectionStateType||(e.SelectionStateType={}));var S;(function(E){E[E.Replace=1]="Replace",E[E.Output=2]="Output",E[E.Metadata=3]="Metadata",E[E.CellLanguage=4]="CellLanguage",E[E.DocumentMetadata=5]="DocumentMetadata",E[E.Move=6]="Move",E[E.OutputItems=7]="OutputItems",E[E.PartialMetadata=8]="PartialMetadata",E[E.PartialInternalMetadata=9]="PartialInternalMetadata"})(S=e.CellEditType||(e.CellEditType={}));var P;(function(E){E.scheme=C.Schemas.vscodeNotebookCell;const A=/^ch(\d{7,})/;function R(M,H){return M.with({scheme:E.scheme,fragment:`ch${H.toString().padStart(7,"0")}${M.scheme!==C.Schemas.file?M.scheme:""}`})}E.generate=R;function B(M){if(M.scheme!==E.scheme)return;const H=A.exec(M.fragment);return H?{handle:Number(H[1]),notebook:M.with({scheme:M.fragment.substr(H[0].length)||C.Schemas.file,fragment:null})}:void 0}E.parse=B;function x(M){if(M.scheme!==C.Schemas.vscodeNotebookCellMetadata)return;const H=A.exec(M.fragment);return H?{handle:Number(H[1]),notebook:M.with({scheme:M.fragment.substr(H[0].length)||C.Schemas.file,fragment:null})}:void 0}E.parseCellMetadataUri=x;function F(M,H,N){return M.with({scheme:N,fragment:`ch${H.toString().padStart(7,"0")}${M.scheme!==C.Schemas.file?M.scheme:""}`})}E.generateCellUri=F;function $(M,H){if(M.scheme!==H)return;const N=A.exec(M.fragment);return N?{handle:Number(N[1]),notebook:M.with({scheme:M.fragment.substr(N[0].length)||C.Schemas.file,fragment:null})}:void 0}E.parseCellUri=$})(P=e.CellUri||(e.CellUri={}));const w=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[y.Mimes.latex,{alwaysSecure:!0,supportedByCore:!0}],[y.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function s(E){return w.get(E)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=s;function r(E){return w.get(E)?.supportedByCore??!1}e.mimeTypeSupportedByCore=r;function m(E){return w.get(E)?.mergeable??!1}e.mimeTypeIsMergeable=m;const a=E=>k.isWindows?E.replace(/\//g,"\\"):E;class b{constructor(A=[],R=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=R,this.order=[...new Set(A)].map(B=>({pattern:B,matches:g.parse(a(B))}))}sort(A){const R=new Map(L.Iterable.map(A,x=>[x,a(x)]));let B=[];for(const{matches:x}of this.order)for(const[F,$]of R)if(x($)){B.push(F),R.delete(F);break}return R.size&&(B=B.concat([...R.keys()].sort((x,F)=>this.defaultOrder.indexOf(x)-this.defaultOrder.indexOf(F)))),B}prioritize(A,R){const B=this.findIndex(A);if(B===-1){this.order.unshift({pattern:A,matches:g.parse(a(A))});return}const x=new Set(R.map($=>this.findIndex($,B)));x.delete(-1);const F=Array.from(x).sort();this.order.splice(B+1,0,...F.map($=>this.order[$]));for(let $=F.length-1;$>=0;$--)this.order.splice(F[$],1)}toArray(){return this.order.map(A=>A.pattern)}findIndex(A,R=this.order.length){const B=a(A);for(let x=0;x<R;x++)if(this.order[x].matches(B))return x;return-1}}e.MimeTypeDisplayOrder=b;function n(E,A,R,B=(x,F)=>x===F){const x=[];function F(H,N,U){if(N===0&&U.length===0)return;const V=x[x.length-1];V&&V.start+V.deleteCount===H?(V.deleteCount+=N,V.toInsert.push(...U)):x.push({start:H,deleteCount:N,toInsert:U})}let $=0,M=0;for(;;){if($===E.length){F($,0,A.slice(M));break}if(M===A.length){F($,E.length-$,[]);break}const H=E[$],N=A[M];if(B(H,N)){$+=1,M+=1;continue}R(N)?(F($,1,[]),$+=1):(F($,0,[N]),M+=1)}return x}e.diff=n,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new _.RawContextKey("notebookEditorCursorAtBoundary","none");var t;(function(E){E.default="default",E.option="option"})(t=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function l(E){const A=E;return!!((typeof A.include=="string"||g.isRelativePattern(A.include))&&(typeof A.exclude=="string"||g.isRelativePattern(A.exclude)))}e.isDocumentExcludePattern=l;function d(E,A,R){if(Array.isArray(E.viewType)&&E.viewType.indexOf(A)>=0||E.viewType===A)return!0;if(E.filenamePattern){let B=l(E.filenamePattern)?E.filenamePattern.include:E.filenamePattern,x=l(E.filenamePattern)?E.filenamePattern.exclude:void 0;if(g.match(B,(0,i.basename)(R.fsPath).toLowerCase()))return!(x&&g.match(x,(0,i.basename)(R.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=d;class o{constructor(A){this.textModel=A}getElements(){const A=new Int32Array(this.textModel.cells.length);for(let R=0;R<this.textModel.cells.length;R++)A[R]=this.textModel.cells[R].getHashValue();return A}}e.CellSequence=o,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize"};var h;(function(E){E[E.Left=1]="Left",E[E.Right=2]="Right"})(h=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class u{static create(A){return`${u._prefix}${A}`}static parse(A){if(A.startsWith(u._prefix))return A.substr(u._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=u,u._prefix="notebook/"}),define(fe[214],me([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var L;(function(y){y[y.Output=1]="Output",y[y.OutputItems=2]="OutputItems",y[y.ExecutionState=3]="ExecutionState",y[y.Complete=4]="Complete"})(L=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,g.createDecorator)("INotebookExecutionService")}),define(fe[215],me([0,1,4,53]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new L.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new L.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new L.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,g.createDecorator)(e.OUTPUT_SERVICE_ID);var y;(function(C){C[C.Append=1]="Append",C[C.Replace=2]="Replace",C[C.Clear=3]="Clear"})(y=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={}))}),define(fe[216],me([0,1,178,4,53]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new y.RawContextKey("customExecutionSupported",!0,g.localize(0,null)),e.ShellExecutionSupportedContext=new y.RawContextKey("shellExecutionSupported",!1,g.localize(1,null)),e.ProcessExecutionSupportedContext=new y.RawContextKey("processExecutionSupported",!1,g.localize(2,null)),e.ITaskService=(0,L.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(fe[217],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function g(y){return[...y.entries()]}e.serializeEnvironmentVariableCollection=g;function L(y){return new Map(y)}e.deserializeEnvironmentVariableCollection=L}),define(fe[127],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var g;(function(I){I[I.Unset=0]="Unset",I[I.Queued=1]="Queued",I[I.Running=2]="Running",I[I.Passed=3]="Passed",I[I.Failed=4]="Failed",I[I.Skipped=5]="Skipped",I[I.Errored=6]="Errored"})(g=e.TestResultState||(e.TestResultState={}));var L;(function(I){I[I.Run=2]="Run",I[I.Debug=4]="Debug",I[I.Coverage=8]="Coverage",I[I.HasNonDefaultProfile=16]="HasNonDefaultProfile",I[I.HasConfigurable=32]="HasConfigurable"})(L=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var y;(function(I){I[I.Error=0]="Error",I[I.Info=1]="Info"})(y=e.TestMessageType||(e.TestMessageType={}));var C;(function(I){I[I.NotExpandable=0]="NotExpandable",I[I.Expandable=1]="Expandable",I[I.BusyExpanding=2]="BusyExpanding",I[I.Expanded=3]="Expanded"})(C=e.TestItemExpandState||(e.TestItemExpandState={}));const i=(I,c)=>{c.expand!==void 0&&(I.expand=c.expand),c.item!==void 0&&(I.item=I.item?Object.assign(I.item,c.item):c.item)};e.applyTestItemUpdate=i;var k;(function(I){I[I.Function=0]="Function",I[I.Statement=1]="Statement"})(k=e.DetailType||(e.DetailType={}));var _;(function(I){I[I.Add=0]="Add",I[I.Update=1]="Update",I[I.Remove=2]="Remove",I[I.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",I[I.Retire=4]="Retire",I[I.AddTag=5]="AddTag",I[I.RemoveTag=6]="RemoveTag"})(_=e.TestDiffOpType||(e.TestDiffOpType={}));class D{add(c){}update(c){}remove(c,p){}complete(){}}e.IncrementalChangeCollector=D;class T{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(c){const p=this.createChangeCollector();for(const f of c)switch(f[0]){case 0:{const v=f[1];if(v.parent){if(this.items.has(v.parent)){const S=this.items.get(v.parent);S.children.add(v.item.extId);const P=this.createItem(v,S);this.items.set(v.item.extId,P),p.add(P)}}else{const S=this.createItem(v);this.roots.add(S),this.items.set(v.item.extId,S),p.add(S)}v.expand===2&&this.busyControllerCount++;break}case 1:{const v=f[1],S=this.items.get(v.extId);if(!S)break;v.expand!==void 0&&(S.expand===2&&this.busyControllerCount--,v.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(S,v),p.update(S);break}case 2:{const v=this.items.get(f[1]);if(!v)break;v.parent?this.items.get(v.parent).children.delete(v.item.extId):this.roots.delete(v);const S=[[f[1]]];for(;S.length;)for(const P of S.pop()){const w=this.items.get(P);w&&(S.push(w.children),this.items.delete(P),p.remove(w,w!==v),w.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(f[1]);break;case 3:this.updatePendingRoots(f[1]);break;case 5:this._tags.set(f[1].id,f[1]);break;case 6:this._tags.delete(f[1]);break}p.complete()}retireTest(c){}updatePendingRoots(c){this.pendingRootCount+=c}createChangeCollector(){return new D}}e.AbstractIncrementalTestCollection=T}),define(fe[90],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var g;(function(C){C.Delimiter="\0"})(g=e.TestIdPathParts||(e.TestIdPathParts={}));var L;(function(C){C[C.IsSame=0]="IsSame",C[C.Disconnected=1]="Disconnected",C[C.IsChild=2]="IsChild",C[C.IsParent=3]="IsParent"})(L=e.TestPosition||(e.TestPosition={}));class y{constructor(i,k=i.length){if(this.path=i,this.viewEnd=k,i.length===0||k<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(i,k,_=i.parent){if(i.id===k)return new y([k]);let D=[i.id];for(let T=_;T&&T.id!==k;T=T.parent)D.push(T.id);return D.push(k),new y(D.reverse())}static isRoot(i){return!i.includes("\0")}static fromString(i){return new y(i.split("\0"))}static join(i,k){return new y([...i.path,k])}static joinToString(i,k){return i.toString()+"\0"+k}static compare(i,k){return i===k?0:k.startsWith(i+"\0")?2:i.startsWith(k+"\0")?3:1}get parentId(){return this.viewEnd>1?new y(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let i=1;i<=this.viewEnd;i++)yield new y(this.path,i)}compare(i){if(typeof i=="string")return y.compare(this.toString(),i);for(let k=0;k<i.viewEnd&&k<this.viewEnd;k++)if(i.path[k]!==this.path[k])return 1;return i.viewEnd>this.viewEnd?2:i.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let i=1;i<this.viewEnd;i++)this.stringifed+="\0",this.stringifed+=this.path[i]}return this.stringifed}}e.TestId=y}),define(fe[218],me([0,1,9,38,13,25,12,81,179]),function(Y,e,g,L,y,C,i,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class D{constructor(I,c,p){this._contributedVariables=new Map,this._context=I,this._labelService=c,p&&(this._envVariablesPromise=p.then(f=>this.prepareEnv(f)))}prepareEnv(I){if(i.isWindows){const c=Object.create(null);return Object.keys(I).forEach(p=>{c[p.toLowerCase()]=I[p]}),c}return I}resolveWithEnvironment(I,c,p){return this.recursiveResolve(this.prepareEnv(I),c?c.uri:void 0,p)}async resolveAsync(I,c){return this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,c)}async resolveAnyBase(I,c,p,f){const v=C.deepClone(c);return i.isWindows&&v.windows?Object.keys(v.windows).forEach(S=>v[S]=v.windows[S]):i.isMacintosh&&v.osx?Object.keys(v.osx).forEach(S=>v[S]=v.osx[S]):i.isLinux&&v.linux&&Object.keys(v.linux).forEach(S=>v[S]=v.linux[S]),delete v.windows,delete v.osx,delete v.linux,this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,v,p,f)}async resolveAnyAsync(I,c,p){return this.resolveAnyBase(I,c,p)}async resolveAnyMap(I,c,p){const f=new Map;return{newConfig:await this.resolveAnyBase(I,c,p,f),resolvedVariables:f}}resolveWithInteractionReplace(I,c,p,f){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(I,c,p,f){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(I,c){if(this._contributedVariables.has(I))throw new Error("Variable "+I+" is contributed twice.");this._contributedVariables.set(I,c)}recursiveResolve(I,c,p,f,v){if(y.isString(p))return this.resolveString(I,c,p,f,v);if(y.isArray(p))return p.map(S=>this.recursiveResolve(I,c,S,f,v));if(y.isObject(p)){let S=Object.create(null);return Object.keys(p).forEach(P=>{const w=this.resolveString(I,c,P,f,v);S[w]=this.recursiveResolve(I,c,p[P],f,v)}),S}return p}resolveString(I,c,p,f,v){return p.replace(D.VARIABLE_REGEXP,(P,w)=>{if(w.includes(D.VARIABLE_LHS))return P;let s=this.evaluateSingleVariable(I,P,w,c,f);return v&&v.set(w,s),s!==P&&y.isString(s)&&s.match(D.VARIABLE_REGEXP)&&(s=this.resolveString(I,c,s,f,v)),s})}fsPath(I){return this._labelService?this._labelService.getUriLabel(I,{noPrefix:!0}):I.fsPath}evaluateSingleVariable(I,c,p,f,v){let S;const P=p.split(":");P.length>1&&(p=P[0],S=P[1]);const w=()=>{const m=this._context.getFilePath();if(m)return m;throw new Error((0,_.localize)(0,null,c))},s=()=>{const m=w();if(this._context.getWorkspaceFolderPathForFile){const a=this._context.getWorkspaceFolderPathForFile();if(a)return a}throw new Error((0,_.localize)(1,null,c,g.basename(m)))},r=()=>{if(S){const m=this._context.getFolderUri(S);if(m)return m;throw new Error((0,_.localize)(2,null,c,S))}if(f)return f;throw this._context.getWorkspaceFolderCount()>1?new Error((0,_.localize)(3,null,c)):new Error((0,_.localize)(4,null,c))};switch(p){case"env":if(S){if(I){const m=I[i.isWindows?S.toLowerCase():S];if(y.isString(m))return m}return""}throw new Error((0,_.localize)(5,null,c));case"config":if(S){const m=this._context.getConfigurationValue(f,S);if(y.isUndefinedOrNull(m))throw new Error((0,_.localize)(6,null,c,S));if(y.isObject(m))throw new Error((0,_.localize)(7,null,c,S));return m}throw new Error((0,_.localize)(8,null,c));case"command":return this.resolveFromMap(c,S,v,"command");case"input":return this.resolveFromMap(c,S,v,"input");default:switch(p){case"workspaceRoot":case"workspaceFolder":return(0,k.normalizeDriveLetter)(this.fsPath(r()));case"cwd":return f||S?(0,k.normalizeDriveLetter)(this.fsPath(r())):L.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return g.basename(this.fsPath(r()));case"lineNumber":const m=this._context.getLineNumber();if(m)return m;throw new Error((0,_.localize)(9,null,c));case"selectedText":const a=this._context.getSelectedText();if(a)return a;throw new Error((0,_.localize)(10,null,c));case"file":return w();case"fileWorkspaceFolder":return s();case"relativeFile":return f||S?g.relative(this.fsPath(r()),w()):w();case"relativeFileDirname":const b=g.dirname(w());if(f||S){const d=g.relative(this.fsPath(r()),b);return d.length===0?".":d}return b;case"fileDirname":return g.dirname(w());case"fileExtname":return g.extname(w());case"fileBasename":return g.basename(w());case"fileBasenameNoExtension":const n=g.basename(w());return n.slice(0,n.length-g.extname(n).length);case"fileDirnameBasename":return g.basename(g.dirname(w()));case"execPath":const t=this._context.getExecPath();return t||c;case"execInstallFolder":const l=this._context.getAppRoot();return l||c;case"pathSeparator":return g.sep;default:try{const d=S?`${p}:${S}`:p;return this.resolveFromMap(c,d,v,void 0)}catch(d){return c}}}}resolveFromMap(I,c,p,f){if(c&&p){const v=f===void 0?p[c]:p[f+":"+c];if(typeof v=="string")return v;throw new Error((0,_.localize)(11,null,I))}return I}}e.AbstractVariableResolverService=D,D.VARIABLE_LHS="${",D.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(fe[128],me([0,1,4,209]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,g.createDecorator)("editorGroupsService");var y;(function(v){v[v.UP=0]="UP",v[v.DOWN=1]="DOWN",v[v.LEFT=2]="LEFT",v[v.RIGHT=3]="RIGHT"})(y=e.GroupDirection||(e.GroupDirection={}));var C;(function(v){v[v.HORIZONTAL=0]="HORIZONTAL",v[v.VERTICAL=1]="VERTICAL"})(C=e.GroupOrientation||(e.GroupOrientation={}));var i;(function(v){v[v.FIRST=0]="FIRST",v[v.LAST=1]="LAST",v[v.NEXT=2]="NEXT",v[v.PREVIOUS=3]="PREVIOUS"})(i=e.GroupLocation||(e.GroupLocation={}));var k;(function(v){v[v.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",v[v.EVEN=1]="EVEN",v[v.TOGGLE=2]="TOGGLE"})(k=e.GroupsArrangement||(e.GroupsArrangement={}));var _;(function(v){v[v.COPY_EDITORS=0]="COPY_EDITORS",v[v.MOVE_EDITORS=1]="MOVE_EDITORS"})(_=e.MergeGroupMode||(e.MergeGroupMode={}));function D(v){const S=v;return(0,L.isEditorInput)(S?.editor)&&(0,L.isEditorInput)(S?.replacement)}e.isEditorReplacement=D;var T;(function(v){v[v.CREATION_TIME=0]="CREATION_TIME",v[v.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",v[v.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(T=e.GroupsOrder||(e.GroupsOrder={}));var I;(function(v){v[v.GROUP_ACTIVE=0]="GROUP_ACTIVE",v[v.GROUP_INDEX=1]="GROUP_INDEX",v[v.GROUP_LOCKED=2]="GROUP_LOCKED",v[v.EDITOR_OPEN=3]="EDITOR_OPEN",v[v.EDITOR_CLOSE=4]="EDITOR_CLOSE",v[v.EDITOR_MOVE=5]="EDITOR_MOVE",v[v.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",v[v.EDITOR_LABEL=7]="EDITOR_LABEL",v[v.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",v[v.EDITOR_PIN=9]="EDITOR_PIN",v[v.EDITOR_STICKY=10]="EDITOR_STICKY",v[v.EDITOR_DIRTY=11]="EDITOR_DIRTY"})(I=e.GroupChangeKind||(e.GroupChangeKind={}));var c;(function(v){v[v.NEW_EDITOR=1]="NEW_EDITOR",v[v.MOVE_EDITOR=2]="MOVE_EDITOR",v[v.COPY_EDITOR=3]="COPY_EDITOR"})(c=e.OpenEditorContext||(e.OpenEditorContext={}));function p(v){const S=v;return!!S&&typeof S.id=="number"&&Array.isArray(S.editors)}e.isEditorGroup=p;function f(v){return v.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=f}),define(fe[219],me([0,1,4,128]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,g.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function y(C){const i=C;return typeof C=="number"||(0,L.isEditorGroup)(i)}e.isPreferredGroup=y}),define(fe[17],me([0,1,15,22,98,294,62,25,13,2,42,85,180,116,66,126,90,219,7]),function(Y,e,g,L,y,C,i,k,_,D,T,I,c,p,f,v,S,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var s;(function(ge){function Ee(K){const{selectionStartLineNumber:Ce,selectionStartColumn:Le,positionLineNumber:it,positionColumn:Ge}=K,mt=new w.Position(Ce-1,Le-1),yt=new w.Position(it-1,Ge-1);return new w.Selection(mt,yt)}ge.to=Ee;function ae(K){const{anchor:Ce,active:Le}=K;return{selectionStartLineNumber:Ce.line+1,selectionStartColumn:Ce.character+1,positionLineNumber:Le.line+1,positionColumn:Le.character+1}}ge.from=ae})(s=e.Selection||(e.Selection={}));var r;(function(ge){function Ee(K){if(!K)return;const{start:Ce,end:Le}=K;return{startLineNumber:Ce.line+1,startColumn:Ce.character+1,endLineNumber:Le.line+1,endColumn:Le.character+1}}ge.from=Ee;function ae(K){if(!K)return;const{startLineNumber:Ce,startColumn:Le,endLineNumber:it,endColumn:Ge}=K;return new w.Range(Ce-1,Le-1,it-1,Ge-1)}ge.to=ae})(r=e.Range||(e.Range={}));var m;(function(ge){function Ee(ae){switch(ae){case 1:return w.StandardTokenType.Comment;case 0:return w.StandardTokenType.Other;case 4:return w.StandardTokenType.RegEx;case 2:return w.StandardTokenType.String}}ge.to=Ee})(m=e.TokenType||(e.TokenType={}));var a;(function(ge){function Ee(K){return new w.Position(K.lineNumber-1,K.column-1)}ge.to=Ee;function ae(K){return{lineNumber:K.line+1,column:K.character+1}}ge.from=ae})(a=e.Position||(e.Position={}));var b;(function(ge){function Ee(Ce,Le){return(0,g.coalesce)((0,g.asArray)(Ce).map(it=>ae(it,Le)))}ge.from=Ee;function ae(Ce,Le){if(typeof Ce=="string")return{$serialized:!0,language:Ce};if(Ce)return{$serialized:!0,language:Ce.language,scheme:K(Ce.scheme,Le),pattern:typeof Ce.pattern=="undefined"?void 0:ce.from(Ce.pattern),exclusive:Ce.exclusive}}function K(Ce,Le){return Le&&typeof Ce=="string"?Le.transformOutgoingScheme(Ce):Ce}})(b=e.DocumentSelector||(e.DocumentSelector={}));var n;(function(ge){function Ee(K){switch(K){case w.DiagnosticTag.Unnecessary:return 1;case w.DiagnosticTag.Deprecated:return 2}}ge.from=Ee;function ae(K){switch(K){case 1:return w.DiagnosticTag.Unnecessary;case 2:return w.DiagnosticTag.Deprecated;default:return}}ge.to=ae})(n=e.DiagnosticTag||(e.DiagnosticTag={}));var t;(function(ge){function Ee(K){let Ce;return K.code&&((0,_.isString)(K.code)||(0,_.isNumber)(K.code)?Ce=String(K.code):Ce={value:String(K.code.value),target:K.code.target}),{...r.from(K.range),message:K.message,source:K.source,code:Ce,severity:d.from(K.severity),relatedInformation:K.relatedInformation&&K.relatedInformation.map(l.from),tags:Array.isArray(K.tags)?(0,g.coalesce)(K.tags.map(n.from)):void 0}}ge.from=Ee;function ae(K){const Ce=new w.Diagnostic(r.to(K),K.message,d.to(K.severity));return Ce.source=K.source,Ce.code=(0,_.isString)(K.code)?K.code:K.code?.value,Ce.relatedInformation=K.relatedInformation&&K.relatedInformation.map(l.to),Ce.tags=K.tags&&(0,g.coalesce)(K.tags.map(n.to)),Ce}ge.to=ae})(t=e.Diagnostic||(e.Diagnostic={}));var l;(function(ge){function Ee(K){return{...r.from(K.location.range),message:K.message,resource:K.location.uri}}ge.from=Ee;function ae(K){return new w.DiagnosticRelatedInformation(new w.Location(K.resource,r.to(K)),K.message)}ge.to=ae})(l=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var d;(function(ge){function Ee(K){switch(K){case w.DiagnosticSeverity.Error:return p.MarkerSeverity.Error;case w.DiagnosticSeverity.Warning:return p.MarkerSeverity.Warning;case w.DiagnosticSeverity.Information:return p.MarkerSeverity.Info;case w.DiagnosticSeverity.Hint:return p.MarkerSeverity.Hint}return p.MarkerSeverity.Error}ge.from=Ee;function ae(K){switch(K){case p.MarkerSeverity.Info:return w.DiagnosticSeverity.Information;case p.MarkerSeverity.Warning:return w.DiagnosticSeverity.Warning;case p.MarkerSeverity.Error:return w.DiagnosticSeverity.Error;case p.MarkerSeverity.Hint:return w.DiagnosticSeverity.Hint;default:return w.DiagnosticSeverity.Error}}ge.to=ae})(d=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var o;(function(ge){function Ee(K){return typeof K=="number"&&K>=w.ViewColumn.One?K-1:K===w.ViewColumn.Beside?P.SIDE_GROUP:P.ACTIVE_GROUP}ge.from=Ee;function ae(K){if(typeof K=="number"&&K>=0)return K+1;throw new Error("invalid 'EditorGroupColumn'")}ge.to=ae})(o=e.ViewColumn||(e.ViewColumn={}));function h(ge){return typeof ge.range!="undefined"}function u(ge){return ge.length===0?!0:!!h(ge[0])}e.isDecorationOptionsArr=u;var E;(function(ge){function Ee(Ge){return Ge.map(ge.from)}ge.fromMany=Ee;function ae(Ge){return Ge&&typeof Ge=="object"&&typeof Ge.language=="string"&&typeof Ge.value=="string"}function K(Ge){let mt;if(ae(Ge)){const{language:bt,value:vt}=Ge;mt={value:"```"+bt+`
`+vt+"\n```\n"}}else w.MarkdownString.isMarkdownString(Ge)?mt={value:Ge.value,isTrusted:Ge.isTrusted,supportThemeIcons:Ge.supportThemeIcons,supportHtml:Ge.supportHtml}:typeof Ge=="string"?mt={value:Ge}:mt={value:""};const yt=Object.create(null);mt.uris=yt;const _t=bt=>{try{let vt=D.URI.parse(bt,!0);vt=vt.with({query:Ce(vt.query,yt)}),yt[bt]=vt}catch(vt){}return""},gt=new C.Renderer;return gt.link=_t,gt.image=bt=>_t(y.parseHrefAndDimensions(bt).href),C(mt.value,{renderer:gt}),mt}ge.from=K;function Ce(Ge,mt){if(!Ge)return Ge;let yt;try{yt=(0,i.parse)(Ge)}catch(gt){}if(!yt)return Ge;let _t=!1;return yt=(0,k.cloneAndChange)(yt,gt=>{if(D.URI.isUri(gt)){const bt=`__uri_${Math.random().toString(16).slice(2,8)}`;return mt[bt]=gt,_t=!0,bt}else return}),_t?JSON.stringify(yt):Ge}function Le(Ge){const mt=new w.MarkdownString(Ge.value,Ge.supportThemeIcons);return mt.isTrusted=Ge.isTrusted,mt.supportHtml=Ge.supportHtml,mt}ge.to=Le;function it(Ge){if(!!Ge)return typeof Ge=="string"?Ge:ge.from(Ge)}ge.fromStrict=it})(E=e.MarkdownString||(e.MarkdownString={}));function A(ge){return u(ge)?ge.map(Ee=>({range:r.from(Ee.range),hoverMessage:Array.isArray(Ee.hoverMessage)?E.fromMany(Ee.hoverMessage):Ee.hoverMessage?E.from(Ee.hoverMessage):void 0,renderOptions:Ee.renderOptions})):ge.map(Ee=>({range:r.from(Ee)}))}e.fromRangeOrRangeWithMessage=A;function R(ge){return typeof ge=="undefined"?ge:typeof ge=="string"?D.URI.file(ge):ge}e.pathOrURIToURI=R;var B;(function(ge){function Ee(ae){return typeof ae=="undefined"?ae:{contentText:ae.contentText,contentIconPath:ae.contentIconPath?R(ae.contentIconPath):void 0,border:ae.border,borderColor:ae.borderColor,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,color:ae.color,backgroundColor:ae.backgroundColor,margin:ae.margin,width:ae.width,height:ae.height}}ge.from=Ee})(B=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var x;(function(ge){function Ee(ae){return typeof ae=="undefined"?ae:{backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?R(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?B.from(ae.before):void 0,after:ae.after?B.from(ae.after):void 0}}ge.from=Ee})(x=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var F;(function(ge){function Ee(ae){if(typeof ae=="undefined")return ae;switch(ae){case w.DecorationRangeBehavior.OpenOpen:return 0;case w.DecorationRangeBehavior.ClosedClosed:return 1;case w.DecorationRangeBehavior.OpenClosed:return 2;case w.DecorationRangeBehavior.ClosedOpen:return 3}}ge.from=Ee})(F=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var $;(function(ge){function Ee(ae){return{isWholeLine:ae.isWholeLine,rangeBehavior:ae.rangeBehavior?F.from(ae.rangeBehavior):void 0,overviewRulerLane:ae.overviewRulerLane,light:ae.light?x.from(ae.light):void 0,dark:ae.dark?x.from(ae.dark):void 0,backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?R(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?B.from(ae.before):void 0,after:ae.after?B.from(ae.after):void 0}}ge.from=Ee})($=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var M;(function(ge){function Ee(K){return{text:K.newText,eol:K.newEol&&J.from(K.newEol),range:r.from(K.range)}}ge.from=Ee;function ae(K){const Ce=new w.TextEdit(r.to(K.range),K.text);return Ce.newEol=typeof K.eol=="undefined"?void 0:J.to(K.eol),Ce}ge.to=ae})(M=e.TextEdit||(e.TextEdit={}));var H;(function(ge){function Ee(K,Ce,Le){const it={edits:[]};if(K instanceof w.WorkspaceEdit)for(let Ge of K._allEntries())if(Ge._type===1)it.edits.push({_type:1,oldUri:Ge.from,newUri:Ge.to,options:Ge.options,metadata:Ge.metadata});else if(Ge._type===2){const mt=Ce?.getDocument(Ge.uri);it.edits.push({_type:2,resource:Ge.uri,edit:M.from(Ge.edit),modelVersionId:mt?.version,metadata:Ge.metadata})}else Ge._type===3?it.edits.push({_type:3,metadata:Ge.metadata,resource:Ge.uri,edit:Ge.edit,notebookMetadata:Ge.notebookMetadata,notebookVersionId:Le?.getNotebookDocument(Ge.uri,!0)?.apiNotebook.version}):Ge._type===5&&it.edits.push({_type:3,metadata:Ge.metadata,resource:Ge.uri,notebookVersionId:Le?.getNotebookDocument(Ge.uri,!0)?.apiNotebook.version,edit:{editType:1,index:Ge.index,count:Ge.count,cells:Ge.cells.map(tt.from)}});return it}ge.from=Ee;function ae(K){const Ce=new w.WorkspaceEdit;for(const Le of K.edits)Le.edit?Ce.replace(D.URI.revive(Le.resource),r.to(Le.edit.range),Le.edit.text):Ce.renameFile(D.URI.revive(Le.oldUri),D.URI.revive(Le.newUri),Le.options);return Ce}ge.to=ae})(H=e.WorkspaceEdit||(e.WorkspaceEdit={}));var N;(function(ge){const Ee=Object.create(null);Ee[w.SymbolKind.File]=0,Ee[w.SymbolKind.Module]=1,Ee[w.SymbolKind.Namespace]=2,Ee[w.SymbolKind.Package]=3,Ee[w.SymbolKind.Class]=4,Ee[w.SymbolKind.Method]=5,Ee[w.SymbolKind.Property]=6,Ee[w.SymbolKind.Field]=7,Ee[w.SymbolKind.Constructor]=8,Ee[w.SymbolKind.Enum]=9,Ee[w.SymbolKind.Interface]=10,Ee[w.SymbolKind.Function]=11,Ee[w.SymbolKind.Variable]=12,Ee[w.SymbolKind.Constant]=13,Ee[w.SymbolKind.String]=14,Ee[w.SymbolKind.Number]=15,Ee[w.SymbolKind.Boolean]=16,Ee[w.SymbolKind.Array]=17,Ee[w.SymbolKind.Object]=18,Ee[w.SymbolKind.Key]=19,Ee[w.SymbolKind.Null]=20,Ee[w.SymbolKind.EnumMember]=21,Ee[w.SymbolKind.Struct]=22,Ee[w.SymbolKind.Event]=23,Ee[w.SymbolKind.Operator]=24,Ee[w.SymbolKind.TypeParameter]=25;function ae(Ce){return typeof Ee[Ce]=="number"?Ee[Ce]:6}ge.from=ae;function K(Ce){for(const Le in Ee)if(Ee[Le]===Ce)return Number(Le);return w.SymbolKind.Property}ge.to=K})(N=e.SymbolKind||(e.SymbolKind={}));var U;(function(ge){function Ee(K){switch(K){case w.SymbolTag.Deprecated:return 1}}ge.from=Ee;function ae(K){switch(K){case 1:return w.SymbolTag.Deprecated}}ge.to=ae})(U=e.SymbolTag||(e.SymbolTag={}));var V;(function(ge){function Ee(K){return{name:K.name,kind:N.from(K.kind),tags:K.tags&&K.tags.map(U.from),containerName:K.containerName,location:Q.from(K.location)}}ge.from=Ee;function ae(K){const Ce=new w.SymbolInformation(K.name,N.to(K.kind),K.containerName,Q.to(K.location));return Ce.tags=K.tags&&K.tags.map(U.to),Ce}ge.to=ae})(V=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var O;(function(ge){function Ee(K){const Ce={name:K.name||"!!MISSING: name!!",detail:K.detail,range:r.from(K.range),selectionRange:r.from(K.selectionRange),kind:N.from(K.kind),tags:K.tags?.map(U.from)??[]};return K.children&&(Ce.children=K.children.map(Ee)),Ce}ge.from=Ee;function ae(K){const Ce=new w.DocumentSymbol(K.name,K.detail,N.to(K.kind),r.to(K.range),r.to(K.selectionRange));return(0,g.isNonEmptyArray)(K.tags)&&(Ce.tags=K.tags.map(U.to)),K.children&&(Ce.children=K.children.map(ae)),Ce}ge.to=ae})(O=e.DocumentSymbol||(e.DocumentSymbol={}));var W;(function(ge){function Ee(K){const Ce=new w.CallHierarchyItem(N.to(K.kind),K.name,K.detail||"",D.URI.revive(K.uri),r.to(K.range),r.to(K.selectionRange));return Ce._sessionId=K._sessionId,Ce._itemId=K._itemId,Ce}ge.to=Ee;function ae(K,Ce,Le){if(Ce=Ce??K._sessionId,Le=Le??K._itemId,Ce===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Ce,_itemId:Le,name:K.name,detail:K.detail,kind:N.from(K.kind),uri:K.uri,range:r.from(K.range),selectionRange:r.from(K.selectionRange),tags:K.tags?.map(U.from)}}ge.from=ae})(W=e.CallHierarchyItem||(e.CallHierarchyItem={}));var j;(function(ge){function Ee(ae){return new w.CallHierarchyIncomingCall(W.to(ae.from),ae.fromRanges.map(K=>r.to(K)))}ge.to=Ee})(j=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var X;(function(ge){function Ee(ae){return new w.CallHierarchyOutgoingCall(W.to(ae.to),ae.fromRanges.map(K=>r.to(K)))}ge.to=Ee})(X=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var Q;(function(ge){function Ee(K){return{range:K.range&&r.from(K.range),uri:K.uri}}ge.from=Ee;function ae(K){return new w.Location(D.URI.revive(K.uri),r.to(K.range))}ge.to=ae})(Q=e.location||(e.location={}));var de;(function(ge){function Ee(K){const Ce=K,Le=K;return{originSelectionRange:Ce.originSelectionRange?r.from(Ce.originSelectionRange):void 0,uri:Ce.targetUri?Ce.targetUri:Le.uri,range:r.from(Ce.targetRange?Ce.targetRange:Le.range),targetSelectionRange:Ce.targetSelectionRange?r.from(Ce.targetSelectionRange):void 0}}ge.from=Ee;function ae(K){return{targetUri:D.URI.revive(K.uri),targetRange:r.to(K.range),targetSelectionRange:K.targetSelectionRange?r.to(K.targetSelectionRange):void 0,originSelectionRange:K.originSelectionRange?r.to(K.originSelectionRange):void 0}}ge.to=ae})(de=e.DefinitionLink||(e.DefinitionLink={}));var Se;(function(ge){function Ee(K){return{range:r.from(K.range),contents:E.fromMany(K.contents)}}ge.from=Ee;function ae(K){return new w.Hover(K.contents.map(E.to),r.to(K.range))}ge.to=ae})(Se=e.Hover||(e.Hover={}));var De;(function(ge){function Ee(K){return{range:r.from(K.range),expression:K.expression}}ge.from=Ee;function ae(K){return new w.EvaluatableExpression(r.to(K.range),K.expression)}ge.to=ae})(De=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Pe;(function(ge){function Ee(K){if(K instanceof w.InlineValueText)return{type:"text",range:r.from(K.range),text:K.text};if(K instanceof w.InlineValueVariableLookup)return{type:"variable",range:r.from(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};if(K instanceof w.InlineValueEvaluatableExpression)return{type:"expression",range:r.from(K.range),expression:K.expression};throw new Error("Unknown 'InlineValue' type")}ge.from=Ee;function ae(K){switch(K.type){case"text":return{range:r.to(K.range),text:K.text};case"variable":return{range:r.to(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};case"expression":return{range:r.to(K.range),expression:K.expression}}}ge.to=ae})(Pe=e.InlineValue||(e.InlineValue={}));var Be;(function(ge){function Ee(K){return{frameId:K.frameId,stoppedLocation:r.from(K.stoppedLocation)}}ge.from=Ee;function ae(K){return new w.InlineValueContext(K.frameId,r.to(K.stoppedLocation))}ge.to=ae})(Be=e.InlineValueContext||(e.InlineValueContext={}));var We;(function(ge){function Ee(K){return{range:r.from(K.range),kind:K.kind}}ge.from=Ee;function ae(K){return new w.DocumentHighlight(r.to(K.range),K.kind)}ge.to=ae})(We=e.DocumentHighlight||(e.DocumentHighlight={}));var He;(function(ge){function Ee(ae){switch(ae){case 1:return w.CompletionTriggerKind.TriggerCharacter;case 2:return w.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return w.CompletionTriggerKind.Invoke}}ge.to=Ee})(He=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var G;(function(ge){function Ee(ae){return{triggerKind:He.to(ae.triggerKind),triggerCharacter:ae.triggerCharacter}}ge.to=Ee})(G=e.CompletionContext||(e.CompletionContext={}));var ee;(function(ge){function Ee(K){switch(K){case w.CompletionItemTag.Deprecated:return 1}}ge.from=Ee;function ae(K){switch(K){case 1:return w.CompletionItemTag.Deprecated}}ge.to=ae})(ee=e.CompletionItemTag||(e.CompletionItemTag={}));var ie;(function(ge){const Ee=new Map([[w.CompletionItemKind.Method,0],[w.CompletionItemKind.Function,1],[w.CompletionItemKind.Constructor,2],[w.CompletionItemKind.Field,3],[w.CompletionItemKind.Variable,4],[w.CompletionItemKind.Class,5],[w.CompletionItemKind.Interface,7],[w.CompletionItemKind.Struct,6],[w.CompletionItemKind.Module,8],[w.CompletionItemKind.Property,9],[w.CompletionItemKind.Unit,12],[w.CompletionItemKind.Value,13],[w.CompletionItemKind.Constant,14],[w.CompletionItemKind.Enum,15],[w.CompletionItemKind.EnumMember,16],[w.CompletionItemKind.Keyword,17],[w.CompletionItemKind.Snippet,27],[w.CompletionItemKind.Text,18],[w.CompletionItemKind.Color,19],[w.CompletionItemKind.File,20],[w.CompletionItemKind.Reference,21],[w.CompletionItemKind.Folder,23],[w.CompletionItemKind.Event,10],[w.CompletionItemKind.Operator,11],[w.CompletionItemKind.TypeParameter,24],[w.CompletionItemKind.Issue,26],[w.CompletionItemKind.User,25]]);function ae(Le){return Ee.get(Le)??9}ge.from=ae;const K=new Map([[0,w.CompletionItemKind.Method],[1,w.CompletionItemKind.Function],[2,w.CompletionItemKind.Constructor],[3,w.CompletionItemKind.Field],[4,w.CompletionItemKind.Variable],[5,w.CompletionItemKind.Class],[7,w.CompletionItemKind.Interface],[6,w.CompletionItemKind.Struct],[8,w.CompletionItemKind.Module],[9,w.CompletionItemKind.Property],[12,w.CompletionItemKind.Unit],[13,w.CompletionItemKind.Value],[14,w.CompletionItemKind.Constant],[15,w.CompletionItemKind.Enum],[16,w.CompletionItemKind.EnumMember],[17,w.CompletionItemKind.Keyword],[27,w.CompletionItemKind.Snippet],[18,w.CompletionItemKind.Text],[19,w.CompletionItemKind.Color],[20,w.CompletionItemKind.File],[21,w.CompletionItemKind.Reference],[23,w.CompletionItemKind.Folder],[10,w.CompletionItemKind.Event],[11,w.CompletionItemKind.Operator],[24,w.CompletionItemKind.TypeParameter],[25,w.CompletionItemKind.User],[26,w.CompletionItemKind.Issue]]);function Ce(Le){return K.get(Le)??w.CompletionItemKind.Property}ge.to=Ce})(ie=e.CompletionItemKind||(e.CompletionItemKind={}));var le;(function(ge){function Ee(ae,K){const Ce=new w.CompletionItem(ae.label);return Ce.insertText=ae.insertText,Ce.kind=ie.to(ae.kind),Ce.tags=ae.tags?.map(ee.to),Ce.detail=ae.detail,Ce.documentation=y.isMarkdownString(ae.documentation)?E.to(ae.documentation):ae.documentation,Ce.sortText=ae.sortText,Ce.filterText=ae.filterText,Ce.preselect=ae.preselect,Ce.commitCharacters=ae.commitCharacters,T.Range.isIRange(ae.range)?Ce.range=r.to(ae.range):typeof ae.range=="object"&&(Ce.range={inserting:r.to(ae.range.insert),replacing:r.to(ae.range.replace)}),Ce.keepWhitespace=typeof ae.insertTextRules=="undefined"?!1:Boolean(ae.insertTextRules&1),typeof ae.insertTextRules!="undefined"&&ae.insertTextRules&4?Ce.insertText=new w.SnippetString(ae.insertText):(Ce.insertText=ae.insertText,Ce.textEdit=Ce.range instanceof w.Range?new w.TextEdit(Ce.range,Ce.insertText):void 0),ae.additionalTextEdits&&ae.additionalTextEdits.length>0&&(Ce.additionalTextEdits=ae.additionalTextEdits.map(Le=>M.to(Le))),Ce.command=K&&ae.command?K.fromInternal(ae.command):void 0,Ce}ge.to=Ee})(le=e.CompletionItem||(e.CompletionItem={}));var Z;(function(ge){function Ee(K){return{label:K.label,documentation:K.documentation?E.fromStrict(K.documentation):void 0}}ge.from=Ee;function ae(K){return{label:K.label,documentation:y.isMarkdownString(K.documentation)?E.to(K.documentation):K.documentation}}ge.to=ae})(Z=e.ParameterInformation||(e.ParameterInformation={}));var re;(function(ge){function Ee(K){return{label:K.label,documentation:K.documentation?E.fromStrict(K.documentation):void 0,parameters:Array.isArray(K.parameters)?K.parameters.map(Z.from):[],activeParameter:K.activeParameter}}ge.from=Ee;function ae(K){return{label:K.label,documentation:y.isMarkdownString(K.documentation)?E.to(K.documentation):K.documentation,parameters:Array.isArray(K.parameters)?K.parameters.map(Z.to):[],activeParameter:K.activeParameter}}ge.to=ae})(re=e.SignatureInformation||(e.SignatureInformation={}));var pe;(function(ge){function Ee(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(re.from):[]}}ge.from=Ee;function ae(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(re.to):[]}}ge.to=ae})(pe=e.SignatureHelp||(e.SignatureHelp={}));var Me;(function(ge){function Ee(K){return{text:K.text,position:a.from(K.position),kind:je.from(K.kind??w.InlayHintKind.Other),whitespaceBefore:K.whitespaceBefore,whitespaceAfter:K.whitespaceAfter}}ge.from=Ee;function ae(K){const Ce=new w.InlayHint(K.text,a.to(K.position),je.to(K.kind));return Ce.whitespaceAfter=K.whitespaceAfter,Ce.whitespaceBefore=K.whitespaceBefore,Ce}ge.to=ae})(Me=e.InlayHint||(e.InlayHint={}));var je;(function(ge){function Ee(K){return K}ge.from=Ee;function ae(K){return K}ge.to=ae})(je=e.InlayHintKind||(e.InlayHintKind={}));var Ke;(function(ge){function Ee(K){return{range:r.from(K.range),url:K.target,tooltip:K.tooltip}}ge.from=Ee;function ae(K){let Ce;if(K.url)try{Ce=typeof K.url=="string"?D.URI.parse(K.url,!0):D.URI.revive(K.url)}catch(Le){}return new w.DocumentLink(r.to(K.range),Ce)}ge.to=ae})(Ke=e.DocumentLink||(e.DocumentLink={}));var Ze;(function(ge){function Ee(K){const Ce=new w.ColorPresentation(K.label);return K.textEdit&&(Ce.textEdit=M.to(K.textEdit)),K.additionalTextEdits&&(Ce.additionalTextEdits=K.additionalTextEdits.map(Le=>M.to(Le))),Ce}ge.to=Ee;function ae(K){return{label:K.label,textEdit:K.textEdit?M.from(K.textEdit):void 0,additionalTextEdits:K.additionalTextEdits?K.additionalTextEdits.map(Ce=>M.from(Ce)):void 0}}ge.from=ae})(Ze=e.ColorPresentation||(e.ColorPresentation={}));var rt;(function(ge){function Ee(K){return new w.Color(K[0],K[1],K[2],K[3])}ge.to=Ee;function ae(K){return[K.red,K.green,K.blue,K.alpha]}ge.from=ae})(rt=e.Color||(e.Color={}));var lt;(function(ge){function Ee(K){return{range:r.from(K.range)}}ge.from=Ee;function ae(K){return new w.SelectionRange(r.to(K.range))}ge.to=ae})(lt=e.SelectionRange||(e.SelectionRange={}));var ye;(function(ge){function Ee(ae){switch(ae){case 2:return w.TextDocumentSaveReason.AfterDelay;case 1:return w.TextDocumentSaveReason.Manual;case 3:case 4:return w.TextDocumentSaveReason.FocusOut}}ge.to=Ee})(ye=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var at;(function(ge){function Ee(K){switch(K){case w.TextEditorLineNumbersStyle.Off:return 0;case w.TextEditorLineNumbersStyle.Relative:return 2;case w.TextEditorLineNumbersStyle.On:default:return 1}}ge.from=Ee;function ae(K){switch(K){case 0:return w.TextEditorLineNumbersStyle.Off;case 2:return w.TextEditorLineNumbersStyle.Relative;case 1:default:return w.TextEditorLineNumbersStyle.On}}ge.to=ae})(at=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var J;(function(ge){function Ee(K){if(K===w.EndOfLine.CRLF)return 1;if(K===w.EndOfLine.LF)return 0}ge.from=Ee;function ae(K){if(K===1)return w.EndOfLine.CRLF;if(K===0)return w.EndOfLine.LF}ge.to=ae})(J=e.EndOfLine||(e.EndOfLine={}));var ne;(function(ge){function Ee(ae){if(typeof ae=="object")return ae.viewId;switch(ae){case w.ProgressLocation.SourceControl:return 3;case w.ProgressLocation.Window:return 10;case w.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ge.from=Ee})(ne=e.ProgressLocation||(e.ProgressLocation={}));var _e;(function(ge){function Ee(ae){const K={start:ae.start+1,end:ae.end+1};return ae.kind&&(K.kind=Qe.from(ae.kind)),K}ge.from=Ee})(_e=e.FoldingRange||(e.FoldingRange={}));var Qe;(function(ge){function Ee(ae){if(ae)switch(ae){case w.FoldingRangeKind.Comment:return I.FoldingRangeKind.Comment;case w.FoldingRangeKind.Imports:return I.FoldingRangeKind.Imports;case w.FoldingRangeKind.Region:return I.FoldingRangeKind.Region}}ge.from=Ee})(Qe=e.FoldingRangeKind||(e.FoldingRangeKind={}));var et;(function(ge){function Ee(ae){if(ae)return{pinned:typeof ae.preview=="boolean"?!ae.preview:void 0,inactive:ae.background,preserveFocus:ae.preserveFocus,selection:typeof ae.selection=="object"?r.from(ae.selection):void 0,override:typeof ae.override=="boolean"?c.EditorResolution.DISABLED:void 0}}ge.from=Ee})(et=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var ce;(function(ge){function Ee(K){return K instanceof w.RelativePattern||typeof K=="string"?K:ae(K)?new w.RelativePattern(K.base,K.pattern):K}ge.from=Ee;function ae(K){const Ce=K;return Ce&&typeof Ce.base=="string"&&typeof Ce.pattern=="string"}})(ce=e.GlobPattern||(e.GlobPattern={}));var Ie;(function(ge){function Ee(ae){if(ae){if(Array.isArray(ae))return ae.map(Ee);if(typeof ae=="string")return ae;{const K=ae;return{language:K.language,scheme:K.scheme,pattern:typeof K.pattern=="undefined"?void 0:ce.from(K.pattern),exclusive:K.exclusive}}}else return}ge.from=Ee})(Ie=e.LanguageSelector||(e.LanguageSelector={}));var Ue;(function(ge){function Ee(K){return{start:K.start,end:K.end}}ge.from=Ee;function ae(K){return new w.NotebookRange(K.start,K.end)}ge.to=ae})(Ue=e.NotebookRange||(e.NotebookRange={}));var Xe;(function(ge){function Ee(K){return{timing:typeof K.runStartTime=="number"&&typeof K.runEndTime=="number"?{startTime:K.runStartTime,endTime:K.runEndTime}:void 0,executionOrder:K.executionOrder,success:K.lastRunSuccess}}ge.to=Ee;function ae(K){return{lastRunSuccess:K.success,runStartTime:K.timing?.startTime,runEndTime:K.timing?.endTime,executionOrder:K.executionOrder}}ge.from=ae})(Xe=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var nt;(function(ge){function Ee(K){switch(K){case w.NotebookCellKind.Markup:return v.CellKind.Markup;case w.NotebookCellKind.Code:default:return v.CellKind.Code}}ge.from=Ee;function ae(K){switch(K){case v.CellKind.Markup:return w.NotebookCellKind.Markup;case v.CellKind.Code:default:return w.NotebookCellKind.Code}}ge.to=ae})(nt=e.NotebookCellKind||(e.NotebookCellKind={}));var ft;(function(ge){function Ee(K){const Ce={metadata:K.metadata??Object.create(null),cells:[]};for(let Le of K.cells)w.NotebookCellData.validate(Le),Ce.cells.push(tt.from(Le));return Ce}ge.from=Ee;function ae(K){const Ce=new w.NotebookData(K.cells.map(tt.to));return(0,_.isEmptyObject)(K.metadata)||(Ce.metadata=K.metadata),Ce}ge.to=ae})(ft=e.NotebookData||(e.NotebookData={}));var tt;(function(ge){function Ee(K){return{cellKind:nt.from(K.kind),language:K.languageId,mime:K.mime,source:K.value,metadata:K.metadata,internalMetadata:Xe.from(K.executionSummary??{}),outputs:K.outputs?K.outputs.map(Re.from):[]}}ge.from=Ee;function ae(K){return new w.NotebookCellData(nt.to(K.cellKind),K.source,K.language,K.mime,K.outputs?K.outputs.map(Re.to):void 0,K.metadata,K.internalMetadata?Xe.to(K.internalMetadata):void 0)}ge.to=ae})(tt=e.NotebookCellData||(e.NotebookCellData={}));var ut;(function(ge){function Ee(K){return{mime:K.mime,valueBytes:L.VSBuffer.wrap(K.data)}}ge.from=Ee;function ae(K){return new w.NotebookCellOutputItem(K.valueBytes.buffer,K.mime)}ge.to=ae})(ut=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Re;(function(ge){function Ee(K){return{outputId:K.id,items:K.items.map(ut.from),metadata:K.metadata}}ge.from=Ee;function ae(K){const Ce=K.items.map(ut.to);return new w.NotebookCellOutput(Ce,K.outputId,K.metadata)}ge.to=ae})(Re=e.NotebookCellOutput||(e.NotebookCellOutput={}));var ve;(function(ge){function Ee(Le){if(Le!=null){if(Le instanceof w.RelativePattern||typeof Le=="string")return Le;if(Ce(Le))return new w.RelativePattern(Le.base,Le.pattern);if(K(Le))return{include:ce.from(Le.include)||void 0,exclude:ce.from(Le.exclude)||void 0}}}ge.from=Ee;function ae(Le){return typeof Le=="string"?Le:Ce(Le)?{base:Le.base,pattern:Le.pattern}:{include:Le.include,exclude:Le.exclude}}ge.to=ae;function K(Le){const it=Le,Ge=ce.from(it.include);if(!(Ge&&Ge instanceof w.RelativePattern||typeof Ge=="string"))return!1;const mt=ce.from(it.exclude);return!!(mt&&mt instanceof w.RelativePattern||typeof mt=="string")}function Ce(Le){const it=Le;return it&&typeof it.base=="string"&&typeof it.pattern=="string"}})(ve=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Te;(function(ge){function Ee(ae){return{backgroundColor:ae.backgroundColor,borderColor:ae.borderColor,top:ae.top?B.from(ae.top):void 0}}ge.from=Ee})(Te=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var se;(function(ge){function Ee(ae,K,Ce){const Le=typeof ae.command=="string"?{title:"",command:ae.command}:ae.command;return{alignment:ae.alignment===w.NotebookCellStatusBarAlignment.Left?1:2,command:K.toInternal(Le,Ce),text:ae.text,tooltip:ae.tooltip,accessibilityInformation:ae.accessibilityInformation,priority:ae.priority}}ge.from=Ee})(se=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var ue;(function(ge){function Ee(ae){return{transientOutputs:ae?.transientOutputs??!1,transientCellMetadata:ae?.transientCellMetadata??{},transientDocumentMetadata:ae?.transientDocumentMetadata??{}}}ge.from=Ee})(ue=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var be;(function(ge){function Ee(K){return{uri:K.uri,provides:K.provides}}ge.from=Ee;function ae(K){return new w.NotebookRendererScript(D.URI.revive(K.uri),K.provides)}ge.to=ae})(be=e.NotebookRendererScript||(e.NotebookRendererScript={}));var we;(function(ge){function Ee(K){return{message:E.fromStrict(K.message)||"",type:0,expected:K.expectedOutput,actual:K.actualOutput,location:K.location?Q.from(K.location):void 0}}ge.from=Ee;function ae(K){const Ce=new w.TestMessage(typeof K.message=="string"?K.message:E.to(K.message));return Ce.actualOutput=K.actual,Ce.expectedOutput=K.expected,Ce.location=K.location?Q.to(K.location):void 0,Ce}ge.to=ae})(we=e.TestMessage||(e.TestMessage={}));var Fe;(function(ge){let Ee;(function(ae){ae.Delimiter="\0"})(Ee||(Ee={})),ge.namespace=(ae,K)=>ae+"\0"+K,ge.denamespace=ae=>{const K=ae.indexOf("\0");return{ctrlId:ae.slice(0,K),tagId:ae.slice(K+1)}}})(Fe=e.TestTag||(e.TestTag={}));var qe;(function(ge){function Ee(Le){const it=(0,f.getPrivateApiFor)(Le).controllerId;return{extId:S.TestId.fromExtHostTestItem(Le,it).toString(),label:Le.label,uri:Le.uri,tags:Le.tags.map(Ge=>Fe.namespace(it,Ge.id)),range:r.from(Le.range)||null,description:Le.description||null,error:Le.error&&E.fromStrict(Le.error)||null}}ge.from=Ee;function ae(Le){return{parent:void 0,error:void 0,id:S.TestId.fromString(Le.extId).localId,label:Le.label,uri:D.URI.revive(Le.uri),tags:(Le.tags||[]).map(it=>{const{tagId:Ge}=Fe.denamespace(it);return new w.TestTag(Ge)}),range:r.to(Le.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Le.description||void 0}}ge.toPlain=ae;function K(Le){const it=S.TestId.fromString(Le.extId),Ge=new f.TestItemImpl(it.controllerId,it.localId,Le.label,D.URI.revive(Le.uri));return Ge.range=r.to(Le.range||void 0),Ge.description=Le.description||void 0,Ge}function Ce(Le){let it;for(const Ge of Le.tests){const mt=K(Ge.item);(0,f.getPrivateApiFor)(mt).parent=it,it=mt}return it}ge.toItemFromContext=Ce})(qe=e.TestItem||(e.TestItem={})),function(ge){function Ee(K){return{id:K.id}}ge.from=Ee;function ae(K){return new w.TestTag(K.id)}ge.to=ae}(Fe=e.TestTag||(e.TestTag={}));var ze;(function(ge){const Ee=(K,Ce)=>{const Le={...qe.toPlain(K.item),parent:void 0,taskStates:K.tasks.map(it=>({state:it.state,duration:it.duration,messages:it.messages.filter(Ge=>Ge.type===0).map(we.to)})),children:K.children.map(it=>Ce.get(it)).filter(_.isDefined).map(it=>Ee(it,Ce))};for(const it of Le.children)it.parent=Le;return Le};function ae(K){const Ce=[],Le=new Map;for(const it of K.items)Le.set(it.item.extId,it),K.request.targets.some(Ge=>Ge.controllerId===it.controllerId&&Ge.testIds.includes(it.item.extId))&&Ce.push(it);return{completedAt:K.completedAt,results:Ce.map(it=>Ee(it,Le))}}ge.to=ae})(ze=e.TestResults||(e.TestResults={}));var Ye;(function(ge){function Ee(Le){return{covered:Le.covered,total:Le.covered}}function ae(Le){return"line"in Le?a.from(Le):r.from(Le)}function K(Le){return"branches"in Le?{count:Le.executionCount,location:ae(Le.location),type:1,branches:Le.branches.length?Le.branches.map(it=>({count:it.executionCount,location:it.location&&ae(it.location)})):void 0}:{type:0,count:Le.executionCount,location:ae(Le.location)}}ge.fromDetailed=K;function Ce(Le){return{uri:Le.uri,statement:Ee(Le.statementCoverage),branch:Le.branchCoverage&&Ee(Le.branchCoverage),function:Le.functionCoverage&&Ee(Le.functionCoverage),details:Le.detailedCoverage?.map(K)}}ge.fromFile=Ce})(Ye=e.TestCoverage||(e.TestCoverage={}));var ct;(function(ge){function Ee(ae){switch(ae){case 1:return w.CodeActionTriggerKind.Invoke;case 2:return w.CodeActionTriggerKind.Automatic}}ge.to=Ee})(ct=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var xe;(function(ge){function Ee(K){const Ce=new w.TypeHierarchyItem(N.to(K.kind),K.name,K.detail||"",D.URI.revive(K.uri),r.to(K.range),r.to(K.selectionRange));return Ce._sessionId=K._sessionId,Ce._itemId=K._itemId,Ce}ge.to=Ee;function ae(K,Ce,Le){if(Ce=Ce??K._sessionId,Le=Le??K._itemId,Ce===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Ce,_itemId:Le,kind:N.from(K.kind),name:K.name,detail:K.detail??"",uri:K.uri,range:r.from(K.range),selectionRange:r.from(K.selectionRange),tags:K.tags?.map(U.from)}}ge.from=ae})(xe=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(fe[220],me([0,1,2,18,7,17,94]),function(Y,e,g,L,y,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class k{constructor(D,T,I,c={timeout:1500,errors:3}){this._logService=D,this._documents=T,this._mainThreadBulkEdits=I,this._thresholds=c,this._callbacks=new i.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(D){return(T,I,c)=>{const f={dispose:this._callbacks.push([T,I,D])};return Array.isArray(c)&&c.push(f),f}}async $participateInSave(D,T){const I=g.URI.revive(D);let c=!1;const p=setTimeout(()=>c=!0,this._thresholds.timeout),f=[];try{for(let v of[...this._callbacks]){if(c)break;const S=this._documents.getDocument(I),P=await this._deliverEventAsyncAndBlameBadListeners(v,{document:S,reason:C.TextDocumentSaveReason.to(T)});f.push(P)}}finally{clearTimeout(p)}return f}_deliverEventAsyncAndBlameBadListeners([D,T,I],c){const p=this._badListeners.get(D);return typeof p=="number"&&p>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(I,D,T,c).then(()=>!0,f=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this._logService.error(f),!(f instanceof Error)||f.message!=="concurrent_edits"){const v=this._badListeners.get(D);this._badListeners.set(D,v?v+1:1),typeof v=="number"&&v>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(D,T,I,c){const p=[],f=Date.now(),{document:v,reason:S}=c,{version:P}=v,w=Object.freeze({document:v,reason:S,waitUntil(s){if(Object.isFrozen(p))throw(0,L.illegalState)("waitUntil can not be called async");p.push(Promise.resolve(s))}});try{T.apply(I,[w])}catch(s){return Promise.reject(s)}return Object.freeze(p),new Promise((s,r)=>{const m=setTimeout(()=>r(new Error("timeout")),this._thresholds.timeout);return Promise.all(p).then(a=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' finished after ${Date.now()-f}ms`),clearTimeout(m),s(a)}).catch(a=>{clearTimeout(m),r(a)})}).then(s=>{const r={edits:[]};for(const m of s)if(Array.isArray(m)&&m.every(a=>a instanceof y.TextEdit))for(const{newText:a,newEol:b,range:n}of m)r.edits.push({_type:2,resource:v.uri,edit:{range:n&&C.Range.from(n),text:a,eol:b&&C.EndOfLine.from(b)}});if(r.edits.length!==0)return P===v.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(r):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=k}),define(fe[221],me([0,1,3,31,2,17,7]),function(Y,e,g,L,y,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class k{constructor(T,I,c,p,f){this._onDidCreate=new g.Emitter,this._onDidChange=new g.Emitter,this._onDidDelete=new g.Emitter,this._config=0,c&&(this._config+=1),p&&(this._config+=2),f&&(this._config+=4);const v=(0,L.parse)(I),S=T(P=>{if(!c)for(let w of P.created){const s=y.URI.revive(w);v(s.fsPath)&&this._onDidCreate.fire(s)}if(!p)for(let w of P.changed){const s=y.URI.revive(w);v(s.fsPath)&&this._onDidChange.fire(s)}if(!f)for(let w of P.deleted){const s=y.URI.revive(w);v(s.fsPath)&&this._onDidDelete.fire(s)}});this._disposable=i.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,S)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class _{constructor(T,I,c){this._logService=I,this._extHostDocumentsAndEditors=c,this._onFileSystemEvent=new g.Emitter,this._onDidRenameFile=new g.Emitter,this._onDidCreateFile=new g.Emitter,this._onDidDeleteFile=new g.Emitter,this._onWillRenameFile=new g.AsyncEmitter,this._onWillCreateFile=new g.AsyncEmitter,this._onWillDeleteFile=new g.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(T,I,c,p){return new k(this._onFileSystemEvent.event,T,I,c,p)}$onFileEvent(T){this._onFileSystemEvent.fire(T)}$onDidRunFileOperation(T,I){switch(T){case 2:this._onDidRenameFile.fire(Object.freeze({files:I.map(c=>({oldUri:y.URI.revive(c.source),newUri:y.URI.revive(c.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:I.map(c=>y.URI.revive(c.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:I.map(c=>y.URI.revive(c.target))}));break;default:}}getOnWillRenameFileEvent(T){return this._createWillExecuteEvent(T,this._onWillRenameFile)}getOnWillCreateFileEvent(T){return this._createWillExecuteEvent(T,this._onWillCreateFile)}getOnWillDeleteFileEvent(T){return this._createWillExecuteEvent(T,this._onWillDeleteFile)}_createWillExecuteEvent(T,I){return(c,p,f)=>{const v=function(P){c.call(p,P)};return v.extension=T,I.event(v,void 0,f)}}async $onWillRunFileOperation(T,I,c,p){switch(T){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:I.map(f=>({oldUri:y.URI.revive(f.source),newUri:y.URI.revive(f.target)}))},c,p);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:I.map(f=>y.URI.revive(f.target))},c,p);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:I.map(f=>y.URI.revive(f.target))},c,p)}}async _fireWillEvent(T,I,c,p){const f=new Set,v=[];if(await T.fireAsync(I,p,async(P,w)=>{const s=Date.now(),r=await Promise.resolve(P);r instanceof i.WorkspaceEdit&&(v.push(r),f.add(w.extension.displayName??w.extension.identifier.value)),Date.now()-s>c&&this._logService.warn("SLOW file-participant",w.extension.identifier)}),p.isCancellationRequested||v.length===0)return;const S={edits:[]};for(let P of v){let{edits:w}=C.WorkspaceEdit.from(P,this._extHostDocumentsAndEditors);S.edits=S.edits.concat(w)}return{edit:S,extensionNames:Array.from(f)}}}e.ExtHostFileSystemEventService=_}),define(fe[222],me([0,1,10,25,2,17,7,126]),function(Y,e,g,L,y,C,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class _{constructor(c,p,f,v){this.start=c,this.deletedCount=p,this.deletedItems=f,this.items=v}static asApiEvents(c){return c.map(p=>({start:p.start,deletedCount:p.deletedCount,deletedItems:p.deletedItems,items:p.items.map(f=>f.apiCell)}))}}class D{constructor(c,p,f){this.notebook=c,this._extHostDocument=p,this._cellData=f,this.handle=f.handle,this.uri=y.URI.revive(f.uri),this.cellKind=f.cellKind,this._outputs=f.outputs.map(C.NotebookCellOutput.to),this._internalMetadata=f.internalMetadata??{},this._metadata=Object.freeze(f.metadata??{}),this._previousResult=Object.freeze(C.NotebookCellExecutionSummary.to(f.internalMetadata??{}))}static asModelAddData(c,p){return{EOL:p.eol,lines:p.source,languageId:p.language,uri:p.uri,isDirty:!1,versionId:1,notebook:c}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const c=this,p=this._extHostDocument.getDocument(this.uri);if(!p)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return c.notebook.getCellIndex(c)},notebook:c.notebook.apiNotebook,kind:C.NotebookCellKind.to(this._cellData.cellKind),document:p.document,get mime(){return c._mime},set mime(f){c._mime=f},get outputs(){return c._outputs.slice(0)},get metadata(){return c._metadata},get executionSummary(){return c._previousResult}})}return this._apiCell}setOutputs(c){this._outputs=c.map(C.NotebookCellOutput.to)}setOutputItems(c,p,f){const v=f.map(C.NotebookCellOutputItem.to),S=this._outputs.find(P=>P.id===c);S&&(p||(S.items.length=0),S.items.push(...v))}setMetadata(c){this._metadata=Object.freeze(c)}setInternalMetadata(c){this._internalMetadata=c,this._previousResult=Object.freeze(C.NotebookCellExecutionSummary.to(c))}setMime(c){}}e.ExtHostCell=D;class T{constructor(c,p,f,v,S,P){this._proxy=c,this._textDocumentsAndEditors=p,this._textDocuments=f,this._emitter=v,this.uri=S,this.handle=T._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=P.viewType,this._metadata=Object.freeze(P.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,P.cells]],!0),this._versionId=P.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const c=this;this._notebook={get uri(){return c.uri},get version(){return c._versionId},get notebookType(){return c._notebookType},get isDirty(){return c._isDirty},get isUntitled(){return c.uri.scheme===g.Schemas.untitled},get isClosed(){return c._disposed},get metadata(){return c._metadata},get cellCount(){return c._cells.length},cellAt(p){return p=c._validateIndex(p),c._cells[p].apiCell},getCells(p){return(p?c._getCells(p):c._cells).map(v=>v.apiCell)},save(){return c._save()}}}return this._notebook}updateBackup(c){this._backup?.delete(),this._backup=c}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(c){c.metadata&&(this._metadata=Object.freeze({...this._metadata,...c.metadata}))}acceptDirty(c){this._isDirty=c}acceptModelChanged(c,p){this._versionId=c.versionId,this._isDirty=p;for(const f of c.rawEvents)f.kind===k.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(f.changes,!1):f.kind===k.NotebookCellsChangeType.Move?this._moveCell(f.index,f.newIdx):f.kind===k.NotebookCellsChangeType.Output?this._setCellOutputs(f.index,f.outputs):f.kind===k.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(f.index,f.outputId,f.append,f.outputItems):f.kind===k.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(f.index,f.language):f.kind===k.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(f.index,f.mime):f.kind===k.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(f.index,f.metadata):f.kind===k.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(f.index,f.internalMetadata)}_validateIndex(c){return c=c|0,c<0?0:c>=this._cells.length?this._cells.length-1:c}_validateRange(c){let p=c.start|0,f=c.end|0;return p<0&&(p=0),f>this._cells.length&&(f=this._cells.length),c.with({start:p,end:f})}_getCells(c){c=this._validateRange(c);const p=[];for(let f=c.start;f<c.end;f++)p.push(this._cells[f]);return p}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(c,p){if(this._disposed)return;const f=[],v=[],S=[];c.reverse().forEach(P=>{const s=P[2].map(a=>{const b=new D(this,this._textDocumentsAndEditors,a);return p||v.push(D.asModelAddData(this.apiNotebook,a)),b}),r=new _(P[0],P[1],[],s),m=this._cells.splice(P[0],P[1],...s);for(const a of m)S.push(a.uri),r.deletedItems.push(a.apiCell);f.push(r)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:v,removedDocuments:S}),p||this._emitter.emitModelChange((0,L.deepFreeze)({document:this.apiNotebook,changes:_.asApiEvents(f)}))}_moveCell(c,p){const f=this._cells.splice(c,1);this._cells.splice(p,0,...f);const v=[new _(c,1,f.map(S=>S.apiCell),[]),new _(p,0,[],f)];this._emitter.emitModelChange((0,L.deepFreeze)({document:this.apiNotebook,changes:_.asApiEvents(v)}))}_setCellOutputs(c,p){const f=this._cells[c];f.setOutputs(p),this._emitter.emitCellOutputsChange((0,L.deepFreeze)({document:this.apiNotebook,cells:[f.apiCell]}))}_setCellOutputItems(c,p,f,v){const S=this._cells[c];S.setOutputItems(p,f,v),this._emitter.emitCellOutputsChange((0,L.deepFreeze)({document:this.apiNotebook,cells:[S.apiCell]}))}_changeCellLanguage(c,p){const f=this._cells[c];f.apiCell.document.languageId!==p&&this._textDocuments.$acceptModelModeChanged(f.uri,p)}_changeCellMime(c,p){const f=this._cells[c];f.apiCell.mime=p}_changeCellMetadata(c,p){const f=this._cells[c],v=f.apiCell.metadata;f.setMetadata(p);const S=f.apiCell.metadata;(0,L.equals)(v,S)||this._emitter.emitCellMetadataChange((0,L.deepFreeze)({document:this.apiNotebook,cell:f.apiCell}))}_changeCellInternalMetadata(c,p){const f=this._cells[c],v=f.internalMetadata;if(f.setInternalMetadata(p),v.runState!==p.runState){const S=p.runState??i.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,L.deepFreeze)({document:this.apiNotebook,cell:f.apiCell,state:S}))}}getCellFromApiCell(c){return this._cells.find(p=>p.apiCell===c)}getCellFromIndex(c){return this._cells[c]}getCell(c){return this._cells.find(p=>p.handle===c)}getCellIndex(c){return this._cells.indexOf(c)}}e.ExtHostNotebookDocument=T,T._handlePool=0}),define(fe[129],me([0,1,7,17,18]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class C{constructor(_){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=_}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(_){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:_})}replaceCellMetadata(_,D){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:_,metadata:D})}replaceCells(_,D,T){this._throwIfFinalized(),!(_===D&&T.length===0)&&this._collectedEdits.push({editType:1,index:_,count:D-_,cells:T.map(L.NotebookCellData.from)})}}class i{constructor(_,D,T,I,c,p){this.id=_,this._proxy=D,this.notebookData=T,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=c,this._visibleRanges=I,this._viewColumn=p}get apiEditor(){if(!this._editor){const _=this;this._editor={get document(){return _.notebookData.apiNotebook},get selections(){return _._selections},set selections(D){if(!Array.isArray(D)||!D.every(g.NotebookRange.isNotebookRange))throw(0,y.illegalArgument)("selections");_._selections=D,_._trySetSelections(D)},get visibleRanges(){return _._visibleRanges},revealRange(D,T){_._proxy.$tryRevealRange(_.id,L.NotebookRange.from(D),T??g.NotebookEditorRevealType.Default)},get viewColumn(){return _._viewColumn},edit(D){const T=new C(this.document.version);return D(T),_._applyEdit(T.finalize())},setDecorations(D,T){return _.setDecorations(D,T)}},i.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(_){this._visible=_}_acceptVisibleRanges(_){this._visibleRanges=_}_acceptSelections(_){this._selections=_}_trySetSelections(_){this._proxy.$trySetSelections(this.id,_.map(L.NotebookRange.from))}_acceptViewColumn(_){this._viewColumn=_}_applyEdit(_){if(_.cellEdits.length===0)return Promise.resolve(!0);const D=[];let T=-1;for(let I=0;I<_.cellEdits.length;I++){if(T<0){D.push(_.cellEdits[I]),T++;continue}const p=D[T],f=_.cellEdits[I];if(p.editType===1&&f.editType===1&&p.index===f.index){p.cells.push(..._.cellEdits[I].cells),p.count+=_.cellEdits[I].count;continue}D.push(_.cellEdits[I]),T++}return this._proxy.$tryApplyEdits(this.id,_.documentVersionId,D)}setDecorations(_,D){if(!(D.isEmpty&&!this._hasDecorationsForKey.has(_.key)))return D.isEmpty?this._hasDecorationsForKey.delete(_.key):this._hasDecorationsForKey.add(_.key),this._proxy.$trySetDecorations(this.id,L.NotebookRange.from(D),_.key)}}e.ExtHostNotebookEditor=i,i.apiEditorsToExtHost=new WeakMap}),define(fe[223],me([0,1,17,117,166,21,60,18]),function(Y,e,g,L,y,C,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class _{constructor(c){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=c}async withProgress(c,p,f){const v=this._handles++,{title:S,location:P,cancellable:w}=p,s={label:(0,y.localize)(0,null,c.displayName||c.name),id:c.identifier.value};return this._proxy.$startProgress(v,{location:g.ProgressLocation.from(P),title:S,source:s,cancellable:w},c).catch(k.onUnexpectedExternalError),this._withProgress(v,f,!!w)}_withProgress(c,p,f){let v;f&&(v=new C.CancellationTokenSource,this._mapHandleToCancellationSource.set(c,v));const S=w=>{this._proxy.$progressEnd(w),this._mapHandleToCancellationSource.delete(w),v&&v.dispose()};let P;try{P=p(new T(this._proxy,c),f&&v?v.token:C.CancellationToken.None)}catch(w){throw S(c),w}return P.then(w=>S(c),w=>S(c)),P}$acceptProgressCanceled(c){const p=this._mapHandleToCancellationSource.get(c);p&&(p.cancel(),this._mapHandleToCancellationSource.delete(c))}}e.ExtHostProgress=_;function D(I,c){return I.message=c.message,typeof c.increment=="number"&&(typeof I.increment=="number"?I.increment+=c.increment:I.increment=c.increment),I}class T extends L.Progress{constructor(c,p){super(f=>this.throttledReport(f));this._proxy=c,this._handle=p}throttledReport(c){this._proxy.$progressReport(this._handle,c)}}Ve([(0,i.throttle)(100,(I,c)=>D(I,c),()=>Object.create(null))],T.prototype,"throttledReport",null)}),define(fe[130],me([0,1,58,18,77,17,7]),function(Y,e,g,L,y,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class k{constructor(c,p,f){const v=k._Keys.nextId();c.$registerTextEditorDecorationType(p.identifier,v,C.DecorationRenderOptions.from(f)),this.value=Object.freeze({key:v,dispose(){c.$removeTextEditorDecorationType(v)}})}}e.TextEditorDecorationType=k,k._Keys=new y.IdGenerator("TextEditorDecorationType");class _{constructor(c,p){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=c,this._documentVersionId=c.version,this._undoStopBefore=p.undoStopBefore,this._undoStopAfter=p.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(c,p){this._throwIfFinalized();let f=null;if(c instanceof i.Position)f=new i.Range(c,c);else if(c instanceof i.Range)f=c;else throw new Error("Unrecognized location");this._pushEdit(f,p,!1)}insert(c,p){this._throwIfFinalized(),this._pushEdit(new i.Range(c,c),p,!0)}delete(c){this._throwIfFinalized();let p=null;if(c instanceof i.Range)p=c;else throw new Error("Unrecognized location");this._pushEdit(p,null,!0)}_pushEdit(c,p,f){const v=this._document.validateRange(c);this._collectedEdits.push({range:v,text:p,forceMoveMarkers:f})}setEndOfLine(c){if(this._throwIfFinalized(),c!==i.EndOfLine.LF&&c!==i.EndOfLine.CRLF)throw(0,L.illegalArgument)("endOfLine");this._setEndOfLine=c}}e.TextEditorEdit=_;class D{constructor(c,p,f,v){this._proxy=c,this._id=p,this._accept(f),this._logService=v;const S=this;this.value={get tabSize(){return S._tabSize},set tabSize(P){S._setTabSize(P)},get insertSpaces(){return S._insertSpaces},set insertSpaces(P){S._setInsertSpaces(P)},get cursorStyle(){return S._cursorStyle},set cursorStyle(P){S._setCursorStyle(P)},get lineNumbers(){return S._lineNumbers},set lineNumbers(P){S._setLineNumbers(P)}}}_accept(c){this._tabSize=c.tabSize,this._insertSpaces=c.insertSpaces,this._cursorStyle=c.cursorStyle,this._lineNumbers=C.TextEditorLineNumbersStyle.to(c.lineNumbers)}_validateTabSize(c){if(c==="auto")return"auto";if(typeof c=="number"){const p=Math.floor(c);return p>0?p:null}if(typeof c=="string"){const p=parseInt(c,10);return isNaN(p)?null:p>0?p:null}return null}_setTabSize(c){const p=this._validateTabSize(c);if(p!==null){if(typeof p=="number"){if(this._tabSize===p)return;this._tabSize=p}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:p}))}}_validateInsertSpaces(c){return c==="auto"?"auto":c==="false"?!1:Boolean(c)}_setInsertSpaces(c){const p=this._validateInsertSpaces(c);if(typeof p=="boolean"){if(this._insertSpaces===p)return;this._insertSpaces=p}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:p}))}_setCursorStyle(c){this._cursorStyle!==c&&(this._cursorStyle=c,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:c})))}_setLineNumbers(c){this._lineNumbers!==c&&(this._lineNumbers=c,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:C.TextEditorLineNumbersStyle.from(c)})))}assign(c){const p={};let f=!1;if(typeof c.tabSize!="undefined"){const v=this._validateTabSize(c.tabSize);v==="auto"?(f=!0,p.tabSize=v):typeof v=="number"&&this._tabSize!==v&&(this._tabSize=v,f=!0,p.tabSize=v)}if(typeof c.insertSpaces!="undefined"){const v=this._validateInsertSpaces(c.insertSpaces);v==="auto"?(f=!0,p.insertSpaces=v):this._insertSpaces!==v&&(this._insertSpaces=v,f=!0,p.insertSpaces=v)}typeof c.cursorStyle!="undefined"&&this._cursorStyle!==c.cursorStyle&&(this._cursorStyle=c.cursorStyle,f=!0,p.cursorStyle=c.cursorStyle),typeof c.lineNumbers!="undefined"&&this._lineNumbers!==c.lineNumbers&&(this._lineNumbers=c.lineNumbers,f=!0,p.lineNumbers=C.TextEditorLineNumbersStyle.from(c.lineNumbers)),f&&this._warnOnError(this._proxy.$trySetOptions(this._id,p))}_warnOnError(c){c.catch(p=>this._logService.warn(p))}}e.ExtHostTextEditorOptions=D;class T{constructor(c,p,f,v,S,P,w,s){this.id=c,this._proxy=p,this._logService=f,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=S,this._options=new D(this._proxy,this.id,P,f),this._visibleRanges=w,this._viewColumn=s;const r=this;this.value=Object.freeze({get document(){return v.getValue()},set document(m){throw(0,L.readonly)("document")},get selection(){return r._selections&&r._selections[0]},set selection(m){if(!(m instanceof i.Selection))throw(0,L.illegalArgument)("selection");r._selections=[m],r._trySetSelection()},get selections(){return r._selections},set selections(m){if(!Array.isArray(m)||m.some(a=>!(a instanceof i.Selection)))throw(0,L.illegalArgument)("selections");r._selections=m,r._trySetSelection()},get visibleRanges(){return r._visibleRanges},set visibleRanges(m){throw(0,L.readonly)("visibleRanges")},get options(){return r._options.value},set options(m){r._disposed||r._options.assign(m)},get viewColumn(){return r._viewColumn},set viewColumn(m){throw(0,L.readonly)("viewColumn")},edit(m,a={undoStopBefore:!0,undoStopAfter:!0}){if(r._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const b=new _(v.getValue(),a);return m(b),r._applyEdit(b)},insertSnippet(m,a,b={undoStopBefore:!0,undoStopAfter:!0}){if(r._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let n;if(!a||Array.isArray(a)&&a.length===0)n=r._selections.map(t=>C.Range.from(t));else if(a instanceof i.Position){const{lineNumber:t,column:l}=C.Position.from(a);n=[{startLineNumber:t,startColumn:l,endLineNumber:t,endColumn:l}]}else if(a instanceof i.Range)n=[C.Range.from(a)];else{n=[];for(const t of a)if(t instanceof i.Range)n.push(C.Range.from(t));else{const{lineNumber:l,column:d}=C.Position.from(t);n.push({startLineNumber:l,startColumn:d,endLineNumber:l,endColumn:d})}}return p.$tryInsertSnippet(c,m.value,n,b)},setDecorations(m,a){const b=a.length===0;b&&!r._hasDecorationsForKey.has(m.key)||(b?r._hasDecorationsForKey.delete(m.key):r._hasDecorationsForKey.add(m.key),r._runOnProxy(()=>{if(C.isDecorationOptionsArr(a))return p.$trySetDecorations(c,m.key,C.fromRangeOrRangeWithMessage(a));{const n=new Array(4*a.length);for(let t=0,l=a.length;t<l;t++){const d=a[t];n[4*t]=d.start.line+1,n[4*t+1]=d.start.character+1,n[4*t+2]=d.end.line+1,n[4*t+3]=d.end.character+1}return p.$trySetDecorationsFast(c,m.key,n)}}))},revealRange(m,a){r._runOnProxy(()=>p.$tryRevealRange(c,C.Range.from(m),a||i.TextEditorRevealType.Default))},show(m){p.$tryShowEditor(c,C.ViewColumn.from(m))},hide(){p.$tryHideEditor(c)}})}dispose(){(0,g.ok)(!this._disposed),this._disposed=!0}_acceptOptions(c){(0,g.ok)(!this._disposed),this._options._accept(c)}_acceptVisibleRanges(c){(0,g.ok)(!this._disposed),this._visibleRanges=c}_acceptViewColumn(c){(0,g.ok)(!this._disposed),this._viewColumn=c}_acceptSelections(c){(0,g.ok)(!this._disposed),this._selections=c}async _trySetSelection(){const c=this._selections.map(C.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,c)),this.value}_applyEdit(c){const p=c.finalize();if(p.edits.length===0&&!p.setEndOfLine)return Promise.resolve(!0);const f=p.edits.map(S=>S.range);f.sort((S,P)=>S.end.line===P.end.line?S.end.character===P.end.character?S.start.line===P.start.line?S.start.character-P.start.character:S.start.line-P.start.line:S.end.character-P.end.character:S.end.line-P.end.line);for(let S=0,P=f.length-1;S<P;S++){const w=f[S].end;if(f[S+1].start.isBefore(w))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const v=p.edits.map(S=>({range:C.Range.from(S.range),text:S.text,forceMoveMarkers:S.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,p.documentVersionId,v,{setEndOfLine:typeof p.setEndOfLine=="number"?C.EndOfLine.from(p.setEndOfLine):void 0,undoStopBefore:p.undoStopBefore,undoStopAfter:p.undoStopAfter})}_runOnProxy(c){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):c().then(()=>this,p=>(p instanceof Error&&p.name==="DISPOSED"||this._logService.warn(p),null))}}e.ExtHostTextEditor=T}),define(fe[224],me([0,1,169,23,2,3,6,210,16,7,13,15,17,21,207]),function(Y,e,g,L,y,C,i,k,_,D,T,I,c,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function v(w,s){if((0,T.isString)(w))return{label:w};if(w&&typeof w=="object"&&typeof w.label=="string"){let r;return Array.isArray(w.highlights)&&(r=w.highlights.filter(m=>m.length===2&&typeof m[0]=="number"&&typeof m[1]=="number"),r=r.length?r:void 0),{label:w.label,highlights:r}}}class S{constructor(s,r,m){this._proxy=s,this.commands=r,this.logService=m,this.treeViews=new Map;function a(b){return b&&b.$treeViewId&&b.$treeItemHandle}r.registerArgumentProcessor({processArgument:b=>a(b)?this.convertArgument(b):Array.isArray(b)&&b.length>0?b.map(n=>a(n)?this.convertArgument(n):n):b})}registerTreeDataProvider(s,r,m){const a=this.createTreeView(s,{treeDataProvider:r},m);return{dispose:()=>a.dispose()}}createTreeView(s,r,m){if(!r||!r.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const a=r.dragAndDropController!==void 0,b=this._proxy.$registerTreeViewDataProvider(s,{showCollapseAll:!!r.showCollapseAll,canSelectMany:!!r.canSelectMany,canDragAndDrop:a}),n=this.createExtHostTreeView(s,r,m);return{get onDidCollapseElement(){return n.onDidCollapseElement},get onDidExpandElement(){return n.onDidExpandElement},get selection(){return n.selectedElements},get onDidChangeSelection(){return n.onDidChangeSelection},get visible(){return n.visible},get onDidChangeVisibility(){return n.onDidChangeVisibility},get message(){return n.message},set message(t){n.message=t},get title(){return n.title},set title(t){n.title=t},get description(){return n.description},set description(t){n.description=t},reveal:(t,l)=>n.reveal(t,l),dispose:async()=>{await b,this.treeViews.delete(s),n.dispose()}}}$getChildren(s,r){const m=this.treeViews.get(s);return m?m.getChildren(r):Promise.reject(new Error((0,g.localize)(0,null,s)))}async $onDrop(s,r,m){const a=this.treeViews.get(s);if(!a)return Promise.reject(new Error((0,g.localize)(1,null,s)));const b=f.TreeDataTransferConverter.toITreeDataTransfer(r);if(b.items.has(k.TREE_ITEM_DATA_TRANSFER_TYPE)){const t=JSON.parse(await b.items.get(k.TREE_ITEM_DATA_TRANSFER_TYPE).asString()).map(l=>a.getExtensionElement(l)).filter(l=>!!l);t.length>0?b.items.set(k.TREE_ITEM_DATA_TRANSFER_TYPE,{asString:async()=>JSON.stringify(t)}):b.items.delete(k.TREE_ITEM_DATA_TRANSFER_TYPE)}return a.onDrop(b,m)}async $hasResolve(s){const r=this.treeViews.get(s);if(!r)throw new Error((0,g.localize)(2,null,s));return r.hasResolve}$resolve(s,r,m){const a=this.treeViews.get(s);if(!a)throw new Error((0,g.localize)(3,null,s));return a.resolveTreeItem(r,m)}$setExpanded(s,r,m){const a=this.treeViews.get(s);if(!a)throw new Error((0,g.localize)(4,null,s));a.setExpanded(r,m)}$setSelection(s,r){const m=this.treeViews.get(s);if(!m)throw new Error((0,g.localize)(5,null,s));m.setSelection(r)}$setVisible(s,r){const m=this.treeViews.get(s);if(!m)throw new Error((0,g.localize)(6,null,s));m.setVisible(r)}createExtHostTreeView(s,r,m){const a=new P(s,r,this._proxy,this.commands.converter,this.logService,m);return this.treeViews.set(s,a),a}convertArgument(s){const r=this.treeViews.get(s.$treeViewId);return r?r.getExtensionElement(s.$treeItemHandle):null}}e.ExtHostTreeViews=S;class P extends i.Disposable{constructor(s,r,m,a,b,n){super();if(this.viewId=s,this.proxy=m,this.commands=a,this.logService=b,this.extension=n,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new C.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new C.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new C.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new C.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new C.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new p.CancellationTokenSource,n.contributes&&n.contributes.views)for(const d in n.contributes.views)for(const o of n.contributes.views[d])o.id===s&&(this._title=o.name);this.dataProvider=r.treeDataProvider,this.dndController=r.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(d=>this._onDidChangeData.fire({message:!1,element:d}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(d=>this._onDidChangeData.fire({message:!1,element:d})));let t,l;this._register(C.Event.debounce(this._onDidChangeData.event,(d,o)=>(d||(d={message:!1,elements:[]}),o.element!==!1&&(t||(t=new Promise(h=>l=h),this.refreshPromise=this.refreshPromise.then(()=>t)),Array.isArray(o.element)?d.elements.push(...o.element):d.elements.push(o.element)),o.message&&(d.message=!0),d),200,!0)(({message:d,elements:o})=>{o.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const h=l;return t=null,this.refresh(o).then(()=>h())})),d&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(s=>this.getExtensionElement(s)).filter(s=>!(0,T.isUndefinedOrNull)(s))}async getChildren(s){const r=s?this.getExtensionElement(s):void 0;if(s&&!r)return this.logService.error(`No tree item with id '${s}' found.`),Promise.resolve([]);let m=this.getChildrenNodes(s);return m||(m=await this.fetchChildrenNodes(r)),m?m.map(a=>a.item):void 0}getExtensionElement(s){return this.elements.get(s)}reveal(s,r){r=r||{select:!0,focus:!1};const m=(0,T.isUndefinedOrNull)(r.select)?!0:r.select,a=(0,T.isUndefinedOrNull)(r.focus)?!1:r.focus,b=(0,T.isUndefinedOrNull)(r.expand)?!1:r.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):s?this.refreshPromise.then(()=>this.resolveUnknownParentChain(s)).then(n=>this.resolveTreeNode(s,n[n.length-1]).then(t=>this.proxy.$reveal(this.viewId,{item:t.item,parentChain:n.map(l=>l.item)},{select:m,focus:a,expand:b})),n=>this.logService.error(n)):this.proxy.$reveal(this.viewId,void 0,{select:m,focus:a,expand:b})}get message(){return this._message}set message(s){this._message=s,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(s){this._title=s,this.proxy.$setTitle(this.viewId,s,this._description)}get description(){return this._description}set description(s){this._description=s,this.proxy.$setTitle(this.viewId,this._title,s)}setExpanded(s,r){const m=this.getExtensionElement(s);m&&(r?this._onDidExpandElement.fire(Object.freeze({element:m})):this._onDidCollapseElement.fire(Object.freeze({element:m})))}setSelection(s){(0,I.equals)(this._selectedHandles,s)||(this._selectedHandles=s,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(s){s!==this._visible&&(this._visible=s,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onDrop(s,r){const m=this.getExtensionElement(r);if(!!m)return(0,_.asPromise)(()=>this.dndController?.onDrop(s,m))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(s,r){if(!this.dataProvider.resolveTreeItem)return;const m=this.elements.get(s);if(m){const a=this.nodes.get(m);if(a){const b=await this.dataProvider.resolveTreeItem(a.extensionItem,m,r)??a.extensionItem;return a.item.tooltip=this.getTooltip(b.tooltip),a.item.command=this.getCommand(a.disposableStore,b.command),a.item}}}resolveUnknownParentChain(s){return this.resolveParent(s).then(r=>r?this.resolveUnknownParentChain(r).then(m=>this.resolveTreeNode(r,m[m.length-1]).then(a=>(m.push(a),m))):Promise.resolve([]))}resolveParent(s){const r=this.nodes.get(s);return r?Promise.resolve(r.parent?this.elements.get(r.parent.item.handle):void 0):(0,_.asPromise)(()=>this.dataProvider.getParent(s))}resolveTreeNode(s,r){const m=this.nodes.get(s);return m?Promise.resolve(m):(0,_.asPromise)(()=>this.dataProvider.getTreeItem(s)).then(a=>this.createHandle(s,a,r,!0)).then(a=>this.getChildren(r?r.item.handle:void 0).then(()=>{const b=this.getExtensionElement(a);if(b){const n=this.nodes.get(b);if(n)return Promise.resolve(n)}throw new Error(`Cannot resolve tree item for element ${a}`)}))}getChildrenNodes(s){if(s){let r;if(typeof s=="string"){const m=this.getExtensionElement(s);r=m?this.nodes.get(m):void 0}else r=s;return r&&r.children||void 0}return this.roots}async fetchChildrenNodes(s){this.clearChildren(s);const r=new p.CancellationTokenSource(this._refreshCancellationSource.token);try{const m=s?this.nodes.get(s):void 0,a=await this.dataProvider.getChildren(s);if(r.token.isCancellationRequested)return;const b=await Promise.all((0,I.coalesce)(a||[]).map(async n=>{const t=await this.dataProvider.getTreeItem(n);return t&&!r.token.isCancellationRequested?this.createAndRegisterTreeNode(n,t,m):null}));return r.token.isCancellationRequested?void 0:(0,I.coalesce)(b)}finally{r.dispose()}}refresh(s){if(s.some(m=>!m))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new p.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const m=this.getHandlesToRefresh(s);if(m.length)return this.refreshHandles(m)}return Promise.resolve(void 0)}getHandlesToRefresh(s){const r=new Set,m=s.map(b=>this.nodes.get(b));for(const b of m)if(b&&!r.has(b.item.handle)){let n=b;for(;n&&n.parent&&m.findIndex(t=>n&&n.parent&&t&&t.item.handle===n.parent.item.handle)===-1;){const t=this.elements.get(n.parent.item.handle);n=t?this.nodes.get(t):void 0}n&&!n.parent&&r.add(b.item.handle)}const a=[];return r.forEach(b=>{const n=this.elements.get(b);if(n){const t=this.nodes.get(n);t&&(!t.parent||!r.has(t.parent.item.handle))&&a.push(b)}}),a}refreshHandles(s){const r={};return Promise.all(s.map(m=>this.refreshNode(m).then(a=>{a&&(r[m]=a.item)}))).then(()=>Object.keys(r).length?this.proxy.$refresh(this.viewId,r):void 0)}refreshNode(s){const r=this.getExtensionElement(s);if(r){const m=this.nodes.get(r);if(m)return this.clearChildren(r),(0,_.asPromise)(()=>this.dataProvider.getTreeItem(r)).then(a=>{if(a){const b=this.createTreeNode(r,a,m.parent);return this.updateNodeCache(r,b,m,m.parent),m.dispose(),b}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(s,r,m){const a=this.createTreeNode(s,r,m);if(r.id&&this.elements.has(a.item.handle))throw new Error((0,g.localize)(7,null,r.id));return this.addNodeToCache(s,a),this.addNodeToParentCache(a,m),a}getTooltip(s){return D.MarkdownString.isMarkdownString(s)?c.MarkdownString.from(s):s}getCommand(s,r){return r?this.commands.toInternal(r,s):void 0}createTreeNode(s,r,m){const a=new i.DisposableStore,b=this.createHandle(s,r,m),n=this.getLightIconPath(r);return{item:{handle:b,parentHandle:m?m.item.handle:void 0,label:v(r.label,this.extension),description:r.description,resourceUri:r.resourceUri,tooltip:this.getTooltip(r.tooltip),command:this.getCommand(a,r.command),contextValue:r.contextValue,icon:n,iconDark:this.getDarkIconPath(r)||n,themeIcon:this.getThemeIcon(r),collapsibleState:(0,T.isUndefinedOrNull)(r.collapsibleState)?D.TreeItemCollapsibleState.None:r.collapsibleState,accessibilityInformation:r.accessibilityInformation},extensionItem:r,parent:m,children:void 0,disposableStore:a,dispose(){a.dispose()}}}getThemeIcon(s){return s.iconPath instanceof D.ThemeIcon?s.iconPath:void 0}createHandle(s,{id:r,label:m,resourceUri:a},b,n){if(r)return`${P.ID_HANDLE_PREFIX}/${r}`;const t=v(m,this.extension),l=b?b.item.handle:P.LABEL_HANDLE_PREFIX;let d=t?t.label:a?(0,L.basename)(a):"";d=d.indexOf("/")!==-1?d.replace("/","//"):d;const o=this.nodes.has(s)?this.nodes.get(s).item.handle:void 0,h=this.getChildrenNodes(b)||[];let u,E=0;do{if(u=`${l}/${E}:${d}`,n||!this.elements.has(u)||o===u)break;E++}while(E<=h.length);return u}getLightIconPath(s){if(s.iconPath&&!(s.iconPath instanceof D.ThemeIcon))return typeof s.iconPath=="string"||y.URI.isUri(s.iconPath)?this.getIconPath(s.iconPath):this.getIconPath(s.iconPath.light)}getDarkIconPath(s){if(s.iconPath&&!(s.iconPath instanceof D.ThemeIcon)&&s.iconPath.dark)return this.getIconPath(s.iconPath.dark)}getIconPath(s){return y.URI.isUri(s)?s:y.URI.file(s)}addNodeToCache(s,r){this.elements.set(r.item.handle,s),this.nodes.set(s,r)}updateNodeCache(s,r,m,a){this.elements.delete(r.item.handle),this.nodes.delete(s),r.item.handle!==m.item.handle&&this.elements.delete(m.item.handle),this.addNodeToCache(s,r);const b=this.getChildrenNodes(a)||[],n=b.filter(t=>t.item.handle===m.item.handle)[0];n&&b.splice(b.indexOf(n),1,r)}addNodeToParentCache(s,r){r?(r.children||(r.children=[]),r.children.push(s)):(this.roots||(this.roots=[]),this.roots.push(s))}clearChildren(s){if(s){const r=this.nodes.get(s);if(r){if(r.children)for(const m of r.children){const a=this.elements.get(m.item.handle);a&&this.clear(a)}r.children=void 0}}else this.clearAll()}clear(s){const r=this.nodes.get(s);if(r){if(r.children)for(const m of r.children){const a=this.elements.get(m.item.handle);a&&this.clear(a)}this.nodes.delete(s),this.elements.delete(r.item.handle),r.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(s=>s.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}P.LABEL_HANDLE_PREFIX="0",P.ID_HANDLE_PREFIX="1"}),define(fe[225],me([0,1,16,3,6,13,66,17,127,90]),function(Y,e,g,L,y,C,i,k,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class T extends y.Disposable{constructor(c){super();this.controllerId=c,this.debounceSendDiff=this._register(new g.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new L.Emitter),this.root=new i.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(c){this._resolveHandler=c;for(const p of this.tree.values())this.updateExpandability(p)}collectDiff(){const c=this.diff;return this.diff=[],c}pushDiff(c){const p=this.diff[this.diff.length-1];if(p&&c[0]===1){if(p[0]===1&&p[1].extId===c[1].extId){(0,_.applyTestItemUpdate)(p[1],c[1]);return}if(p[0]===0&&p[1].item.extId===c[1].extId){(0,_.applyTestItemUpdate)(p[1],c[1]);return}}this.diff.push(c),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(c,p){const f=this.tree.get(c);if(!!f){if((f.expandLevels===void 0||p>f.expandLevels)&&(f.expandLevels=p),f.expand===1){const v=this.resolveChildren(f);return v.isOpen()?this.expandChildren(f,p-1):v.wait().then(()=>this.expandChildren(f,p-1))}else if(f.expand===3)return f.resolveBarrier?.isOpen()===!1?f.resolveBarrier.wait().then(()=>this.expandChildren(f,p-1)):this.expandChildren(f,p-1)}}dispose(){for(const c of this.tree.values())(0,i.getPrivateApiFor)(c.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(c,p){switch(p.op){case 2:this.pushDiff([4,c.fullId.toString()]);break;case 1:this.removeItem(D.TestId.joinToString(c.fullId,p.id));break;case 0:this.upsertItem(p.item,c);break;case 4:for(const w of p.ops)this.onTestItemEvent(c,w);break;case 3:const{key:f,value:v,previous:S}=p,P=c.fullId.toString();switch(f){case"canResolveChildren":this.updateExpandability(c);break;case"tags":this.diffTagRefs(v,S,P);break;case"range":this.pushDiff([1,{extId:P,item:{range:k.Range.from(v)}}]);break;case"error":this.pushDiff([1,{extId:P,item:{error:k.MarkdownString.fromStrict(v)||null}}]);break;default:this.pushDiff([1,{extId:P,item:{[f]:v??null}}]);break}break;default:(0,C.assertNever)(p)}}upsertItem(c,p){if(!(c instanceof i.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${c.id} did not`);const f=D.TestId.fromExtHostTestItem(c,this.root.id,p?.actual),v=(0,i.getPrivateApiFor)(c);v.parent&&v.parent!==p?.actual&&v.parent.children.delete(c.id);let S=this.tree.get(f.toString());if(!S){S={fullId:f,actual:c,parent:p?f.parentId:null,expandLevels:p?.expandLevels?p.expandLevels-1:void 0,expand:0},c.tags.forEach(this.incrementTagRefs,this),this.tree.set(S.fullId.toString(),S),this.setItemParent(c,p),this.pushDiff([0,{parent:S.parent&&S.parent.toString(),controllerId:this.controllerId,expand:S.expand,item:k.TestItem.from(c)}]),this.connectItemAndChildren(c,S,p);return}if(S.actual===c){this.connectItem(c,S,p);return}const P=S.actual.children,w=S.actual,s=(0,i.diffTestItems)(w,c);(0,i.getPrivateApiFor)(w).listener=void 0,S.actual=c,S.expand=0;for(const[r,m]of s)this.onTestItemEvent(S,{op:3,key:r,value:m,previous:w[r]});this.connectItemAndChildren(c,S,p);for(const r of P)c.children.get(r.id)||this.removeItem(D.TestId.joinToString(f,r.id))}diffTagRefs(c,p,f){const v=new Set(p.map(S=>S.id));for(const S of c)v.delete(S.id)||this.incrementTagRefs(S);this.pushDiff([1,{extId:f,item:{tags:c.map(S=>k.TestTag.namespace(this.controllerId,S.id))}}]),v.forEach(this.decrementTagRefs,this)}incrementTagRefs(c){const p=this.tags.get(c.id);p?p.refCount++:(this.tags.set(c.id,{refCount:1}),this.pushDiff([5,{id:k.TestTag.namespace(this.controllerId,c.id),ctrlLabel:this.root.label}]))}decrementTagRefs(c){const p=this.tags.get(c);p&&!--p.refCount&&(this.tags.delete(c),this.pushDiff([6,k.TestTag.namespace(this.controllerId,c)]))}setItemParent(c,p){(0,i.getPrivateApiFor)(c).parent=p&&p.actual!==this.root?p.actual:void 0}connectItem(c,p,f){this.setItemParent(c,f);const v=(0,i.getPrivateApiFor)(c);v.parent=f?.actual,v.listener=S=>this.onTestItemEvent(p,S),this.updateExpandability(p)}connectItemAndChildren(c,p,f){this.connectItem(c,p,f);for(const v of c.children)this.upsertItem(v,p)}updateExpandability(c){let p;this._resolveHandler?c.resolveBarrier?p=c.resolveBarrier.isOpen()?3:2:p=c.actual.canResolveChildren?1:0:p=0,p!==c.expand&&(c.expand=p,this.pushDiff([1,{extId:c.fullId.toString(),expand:p}]),p===1&&c.expandLevels!==void 0&&this.resolveChildren(c))}expandChildren(c,p){if(p<0)return;const f=[];for(const v of c.actual.children){const S=this.expand(D.TestId.joinToString(c.fullId,v.id),p);(0,g.isThenable)(S)&&f.push(S)}if(f.length)return Promise.all(f).then(()=>{})}resolveChildren(c){if(c.resolveBarrier)return c.resolveBarrier;if(!this._resolveHandler){const S=new g.Barrier;return S.open(),S}c.expand=2,this.pushExpandStateUpdate(c);const p=c.resolveBarrier=new g.Barrier,f=S=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),c.actual!==this.root&&(c.actual.error=S.stack||S.message||String(S))};let v;try{v=this._resolveHandler(c.actual===this.root?void 0:c.actual)}catch(S){f(S)}return(0,g.isThenable)(v)?v.catch(f).then(()=>{p.open(),this.updateExpandability(c)}):(p.open(),this.updateExpandability(c)),c.resolveBarrier}pushExpandStateUpdate(c){this.pushDiff([1,{extId:c.fullId.toString(),expand:c.expand}])}removeItem(c){const p=this.tree.get(c);if(!p)throw new Error("attempting to remove non-existent child");this.pushDiff([2,c]);const f=[p];for(;f.length;){const v=f.pop();if(!!v){(0,i.getPrivateApiFor)(v.actual).listener=void 0;for(const S of v.actual.tags)this.decrementTagRefs(S.id);this.tree.delete(v.fullId.toString());for(const S of v.actual.children)f.push(this.tree.get(D.TestId.joinToString(v.fullId,S.id)))}}}flushDiff(){const c=this.collectDiff();c.length&&this.diffOpEmitter.fire(c)}}e.SingleUseTestCollection=T}),define(fe[226],me([0,1,4,185]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,g.refineServiceDecorator)(L.IEnvironmentService)}),define(fe[227],me([0,1,27,3,9]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class C{constructor(T){this.removedDueToLooping=T}}e.DeltaExtensionsResult=C;class i{constructor(T){this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=T,this._initialize()}_initialize(){this._extensionDescriptions.sort(_),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const T of this._extensionDescriptions){if(this._extensionsMap.has(g.ExtensionIdentifier.toKey(T.identifier))){console.error("Extension `"+T.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(g.ExtensionIdentifier.toKey(T.identifier),T),this._extensionsArr.push(T),Array.isArray(T.activationEvents))for(let I of T.activationEvents)I==="onUri"&&(I=`onUri:${g.ExtensionIdentifier.toKey(T.identifier)}`),this._activationMap.has(I)||this._activationMap.set(I,[]),this._activationMap.get(I).push(T)}}keepOnly(T){const I=new Set;T.forEach(c=>I.add(g.ExtensionIdentifier.toKey(c))),this._extensionDescriptions=this._extensionDescriptions.filter(c=>I.has(g.ExtensionIdentifier.toKey(c.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(T,I){T.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(T));const c=i._findLoopingExtensions(this._extensionDescriptions);if(I=I.concat(c.map(p=>p.identifier)),I.length>0){const p=new Set;I.forEach(f=>p.add(g.ExtensionIdentifier.toKey(f))),this._extensionDescriptions=this._extensionDescriptions.filter(f=>!p.has(g.ExtensionIdentifier.toKey(f.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new C(c)}static _findLoopingExtensions(T){const I=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(S){this._nodesSet.has(S)||(this._nodesSet.add(S),this._nodesArr.push(S))}addArc(S,P){this.addNode(S),this.addNode(P),this._arcs.has(S)?this._arcs.get(S).push(P):this._arcs.set(S,[P])}getArcs(S){return this._arcs.has(S)?this._arcs.get(S):[]}hasOnlyGoodArcs(S,P){const w=I.getArcs(S);for(let s=0;s<w.length;s++)if(!P.has(w[s]))return!1;return!0}getNodes(){return this._nodesArr}};let c=new Map;for(let S of T){const P=g.ExtensionIdentifier.toKey(S.identifier);if(c.set(P,S),S.extensionDependencies)for(let w of S.extensionDependencies){const s=g.ExtensionIdentifier.toKey(w);I.addArc(P,s)}}let p=new Set;I.getNodes().filter(S=>I.getArcs(S).length===0).forEach(S=>p.add(S));let f=I.getNodes().filter(S=>!p.has(S)),v;do{v=!1;for(let S=0;S<f.length;S++){const P=f[S];I.hasOnlyGoodArcs(P,p)&&(f.splice(S,1),S--,p.add(P),v=!0)}}while(v);return f.map(S=>c.get(S))}containsActivationEvent(T){return this._activationMap.has(T)}containsExtension(T){return this._extensionsMap.has(g.ExtensionIdentifier.toKey(T))}getExtensionDescriptionsForActivationEvent(T){const I=this._activationMap.get(T);return I?I.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(T){const I=this._extensionsMap.get(g.ExtensionIdentifier.toKey(T));return I||void 0}}e.ExtensionDescriptionRegistry=i;var k;(function(D){D[D.Builtin=0]="Builtin",D[D.User=1]="User",D[D.Dev=2]="Dev"})(k||(k={}));function _(D,T){const I=D.isBuiltin?0:D.isUnderDevelopment?2:1,c=T.isBuiltin?0:T.isUnderDevelopment?2:1;if(I!==c)return I-c;const p=y.posix.basename(D.extensionLocation.path),f=y.posix.basename(T.extensionLocation.path);return p<f?-1:p>f?1:0}}),define(fe[228],me([0,1,22]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var L;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(L=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var y;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(y=e.MessageType||(e.MessageType={}));function C(k){const _=g.VSBuffer.alloc(1);switch(k){case 0:_.writeUInt8(1,0);break;case 1:_.writeUInt8(2,0);break;case 2:_.writeUInt8(3,0);break}return _}e.createMessageOfType=C;function i(k,_){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return _===0;case 2:return _===1;case 3:return _===2;default:return!1}}e.isMessageOfType=i}),define(fe[29],me([0,1,3,2,4,27,195]),function(Y,e,g,L,y,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new C.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:L.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,y.createDecorator)("extensionService");var k;(function(r){r[r.None=0]="None",r[r.LocalProcess=1]="LocalProcess",r[r.LocalWebWorker=2]="LocalWebWorker",r[r.Remote=3]="Remote"})(k=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function _(r){switch(r){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=_;class D{constructor(m){this.dependency=m}}e.MissingExtensionDependency=D;var T;(function(r){r[r.LocalProcess=0]="LocalProcess",r[r.LocalWebWorker=1]="LocalWebWorker",r[r.Remote=2]="Remote"})(T=e.ExtensionHostKind||(e.ExtensionHostKind={}));function I(r){switch(r){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=I;function c(r,m){return r.enabledApiProposals?.includes(m)?!0:Boolean(r.enableProposedApi)}e.isProposedApiEnabled=c;function p(r,m){if(!c(r,m))throw new Error(`Extension '${r.identifier.value}' CANNOT use API proposal: ${m}.
According to its package.json#enabledApiProposals-property it wants: ${r.enabledApiProposals?.join(", ")??"<none>"}.
 You MUST start in extension development mode or use the following command line switch: --enable-proposed-api ${r.identifier.value}`)}e.checkProposedApiEnabled=p;class f{constructor(m,a,b,n){this.codeLoadingTime=m,this.activateCallTime=a,this.activateResolvedTime=b,this.activationReason=n}}e.ActivationTimes=f;class v{constructor(m,a){this.description=m,this.value=a}}e.ExtensionPointContribution=v,e.ExtensionHostLogFileName="exthost";var S;(function(r){r[r.Normal=0]="Normal",r[r.Immediate=1]="Immediate"})(S=e.ActivationKind||(e.ActivationKind={}));function P(r){return{type:r.isBuiltin?0:1,isBuiltin:r.isBuiltin||r.isUserBuiltin,identifier:{id:(0,i.getGalleryExtensionId)(r.publisher,r.name),uuid:r.uuid},manifest:r,location:r.extensionLocation}}e.toExtension=P;function w(r,m){return{identifier:new C.ExtensionIdentifier(r.identifier.id),isBuiltin:r.type===0,isUserBuiltin:r.type===1&&r.isBuiltin,isUnderDevelopment:!!m,extensionLocation:r.location,...r.manifest,uuid:r.identifier.uuid}}e.toExtensionDescription=w;class s{constructor(){this.onDidRegisterExtensions=g.Event.None,this.onDidChangeExtensionsStatus=g.Event.None,this.onDidChangeExtensions=g.Event.None,this.onWillActivateByEvent=g.Event.None,this.onDidChangeResponsiveChange=g.Event.None}activateByEvent(m){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(m){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(m){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(m){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(m,a){return Promise.resolve()}_onWillActivateExtension(m){}_onDidActivateExtension(m,a,b,n,t){}_onDidActivateExtensionError(m,a){}_onExtensionRuntimeError(m,a){}_onExtensionHostExit(m){}}e.NullExtensionService=s}),define(fe[229],me([0,1,27,29,11]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const C=Promise.resolve(void 0);class i{constructor(f,v,S,P){this.startup=f,this.codeLoadingTime=v,this.activateCallTime=S,this.activateResolvedTime=P}}e.ExtensionActivationTimes=i,i.NONE=new i(!1,-1,-1,-1);class k{constructor(f){this._startup=f,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(f,v){return f===-1||v===-1?-1:v-f}build(){return new i(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=k;class _{constructor(f,v,S,P,w,s){this.activationFailed=f,this.activationFailedError=v,this.activationTimes=S,this.module=P,this.exports=w,this.subscriptions=s}}e.ActivatedExtension=_;class D extends _{constructor(f){super(!1,null,f,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=D;class T extends _{constructor(){super(!1,null,i.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=T;class I extends _{constructor(f){super(!0,f,i.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=I;let c=class{constructor(f,v,S,P,w){this._logService=w,this._registry=f,this._resolvedExtensionsSet=new Set,v.forEach(s=>this._resolvedExtensionsSet.add(g.ExtensionIdentifier.toKey(s))),this._hostExtensionsMap=new Map,S.forEach(s=>this._hostExtensionsMap.set(g.ExtensionIdentifier.toKey(s),s)),this._host=P,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(f){const v=g.ExtensionIdentifier.toKey(f);return this._activatedExtensions.has(v)}getActivatedExtension(f){const v=g.ExtensionIdentifier.toKey(f),S=this._activatedExtensions.get(v);if(!S)throw new Error("Extension `"+f.value+"` is not known or not activated");return S}activateByEvent(f,v){if(this._alreadyActivatedEvents[f])return C;const S=this._registry.getExtensionDescriptionsForActivationEvent(f);return this._activateExtensions(S.map(P=>({id:P.identifier,reason:{startup:v,extensionId:P.identifier,activationEvent:f}}))).then(()=>{this._alreadyActivatedEvents[f]=!0})}activateById(f,v){const S=this._registry.getExtensionDescription(f);if(!S)throw new Error("Extension `"+f+"` is not known");return this._activateExtensions([{id:S.identifier,reason:v}])}_handleActivateRequest(f,v,S){if(this._hostExtensionsMap.has(g.ExtensionIdentifier.toKey(f.id))){v[g.ExtensionIdentifier.toKey(f.id)]=f;return}const P=this._registry.getExtensionDescription(f.id);if(!P){const r=new Error(`Cannot activate unknown extension '${f.id.value}'`);this._host.onExtensionActivationError(f.id,r,new L.MissingExtensionDependency(f.id.value)),this._activatedExtensions.set(g.ExtensionIdentifier.toKey(f.id),new I(r));return}const w=typeof P.extensionDependencies=="undefined"?[]:P.extensionDependencies;let s=!0;for(let r=0,m=w.length;r<m;r++){const a=w[r];if(this._resolvedExtensionsSet.has(g.ExtensionIdentifier.toKey(a)))continue;const b=this._activatedExtensions.get(g.ExtensionIdentifier.toKey(a));if(b&&!b.activationFailed)continue;if(b&&b.activationFailed){const d=P.displayName||P.identifier.value,o=this._registry.getExtensionDescription(a),h=o&&o.displayName||a,u=new Error(`Cannot activate the '${d}' extension because its dependency '${h}' failed to activate`);u.detail=b.activationFailedError,this._host.onExtensionActivationError(P.identifier,u,null),this._activatedExtensions.set(g.ExtensionIdentifier.toKey(P.identifier),new I(u));return}if(this._hostExtensionsMap.has(g.ExtensionIdentifier.toKey(a))){s=!1,v[g.ExtensionIdentifier.toKey(a)]={id:this._hostExtensionsMap.get(g.ExtensionIdentifier.toKey(a)),reason:f.reason};continue}const n=this._registry.getExtensionDescription(a);if(n){if(!n.main&&!n.browser)continue;s=!1,v[g.ExtensionIdentifier.toKey(a)]={id:n.identifier,reason:f.reason};continue}const t=P.displayName||P.identifier.value,l=new Error(`Cannot activate the '${t}' extension because it depends on unknown extension '${a}'`);this._host.onExtensionActivationError(P.identifier,l,new L.MissingExtensionDependency(a)),this._activatedExtensions.set(g.ExtensionIdentifier.toKey(P.identifier),new I(l));return}s?v[g.ExtensionIdentifier.toKey(P.identifier)]=f:S.push(f)}_activateExtensions(f){if(f.length===0||(f=f.filter(w=>!this._activatedExtensions.has(g.ExtensionIdentifier.toKey(w.id))),f.length===0))return Promise.resolve(void 0);const v=Object.create(null),S=[];for(let w=0,s=f.length;w<s;w++)this._handleActivateRequest(f[w],v,S);for(let w=0,s=S.length;w<s;w++){const r=g.ExtensionIdentifier.toKey(S[w].id);v[r]&&delete v[r]}const P=Object.keys(v).map(w=>v[w]);return S.length===0?Promise.all(P.map(w=>this._activateExtension(w.id,w.reason))).then(w=>{}):this._activateExtensions(P).then(w=>this._activateExtensions(S))}_activateExtension(f,v){const S=g.ExtensionIdentifier.toKey(f);if(this._activatedExtensions.has(S))return Promise.resolve(void 0);const P=this._activatingExtensions.get(S);if(P)return P;const w=this._host.actualActivateExtension(f,v).then(void 0,s=>{const r=new Error;return s&&s.name&&(r.name=s.name),s&&s.message?r.message=`Activating extension '${f.value}' failed: ${s.message}.`:r.message=`Activating extension '${f.value}' failed: ${s}.`,s&&s.stack&&(r.stack=s.stack),this._host.onExtensionActivationError(f,r,null),this._logService.error(`Activating extension ${f.value} failed due to an error:`),this._logService.error(s),new I(s)}).then(s=>{this._activatedExtensions.set(S,s),this._activatingExtensions.delete(S)});return this._activatingExtensions.set(S,w),w}};c=Ve([$e(4,y.ILogService)],c),e.ExtensionsActivator=c}),define(fe[230],me([0,1,11,26,29]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let C=class extends g.LogService{constructor(k,_){super(k.createLogger(_.logFile,{name:y.ExtensionHostLogFileName}))}};C=Ve([$e(0,g.ILoggerService),$e(1,L.IExtHostInitDataService)],C),e.ExtHostLogService=C}),define(fe[231],me([0,1,18]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class L{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((C,i)=>{this._actualOk=C,this._actualErr=i,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(C){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=C,this._actual&&this._actualOk(C))}resolveErr(C){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=C,this._actual?this._actualErr(C):(0,g.onUnexpectedError)(C))}then(C,i){return this._ensureActual().then(C,i)}catch(C){return this._ensureActual().then(void 0,C)}finally(C){return this._ensureActual().finally(C)}}e.LazyPromise=L}),define(fe[55],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class g{constructor(D,T){this._proxyIdentifierBrand=void 0,this.isMain=D,this.sid=T,this.nid=++g.count}}e.ProxyIdentifier=g,g.count=0;const L=[];function y(_){const D=new g(!0,_);return L[D.nid]=D,D}e.createMainContextProxyIdentifier=y;function C(_){const D=new g(!1,_);return L[D.nid]=D,D}e.createExtHostContextProxyIdentifier=C;function i(_){return L[_].sid}e.getStringIdentifierForProxy=i;class k{constructor(D){this.value=D}}e.SerializableObjectWithBuffers=k}),define(fe[5],me([0,1,62,2,55]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var C;(function(s){s[s.Desktop=1]="Desktop",s[s.Web=2]="Web"})(C=e.UIKind||(e.UIKind={}));var i;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(i=e.TextEditorRevealType||(e.TextEditorRevealType={}));var k;(function(s){s[s.Editable=0]="Editable",s[s.SupportsHotExit=1]="SupportsHotExit"})(k=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var _;(function(s){s[s.Int8Array=1]="Int8Array",s[s.Uint8Array=2]="Uint8Array",s[s.Uint8ClampedArray=3]="Uint8ClampedArray",s[s.Int16Array=4]="Int16Array",s[s.Uint16Array=5]="Uint16Array",s[s.Int32Array=6]="Int32Array",s[s.Uint32Array=7]="Uint32Array",s[s.Float32Array=8]="Float32Array",s[s.Float64Array=9]="Float64Array",s[s.BigInt64Array=10]="BigInt64Array",s[s.BigUint64Array=11]="BigUint64Array"})(_=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var D;(function(s){s[s.Text=1]="Text",s[s.Error=2]="Error",s[s.Rich=3]="Rich"})(D=e.CellOutputKind||(e.CellOutputKind={}));var T;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(T=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var I;(function(s){s[s.None=0]="None",s[s.Process=1]="Process",s[s.Output=2]="Output"})(I=e.CandidatePortSource||(e.CandidatePortSource={}));var c;(function(s){s.name="$ident";function r(a,b){return Object.defineProperty(a,s.name,{value:b,enumerable:!0}),a}s.mixin=r;function m(a){return a[s.name]}s.of=m})(c=e.ObjectIdentifier||(e.ObjectIdentifier={}));class p{static mixin(r){return r._id=p._n++,r}}e.IdObject=p,p._n=0;var f;(function(s){s.label="a",s.kind="b",s.detail="c",s.documentation="d",s.sortText="e",s.filterText="f",s.preselect="g",s.insertText="h",s.insertTextRules="i",s.range="j",s.commitCharacters="k",s.additionalTextEdits="l",s.command="m",s.kindModifier="n"})(f=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var v;(function(s){s.defaultRanges="a",s.completions="b",s.isIncomplete="c",s.duration="d"})(v=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var S;(function(s){s[s.File=1]="File",s[s.Text=2]="Text",s[s.Cell=3]="Cell"})(S=e.WorkspaceEditType||(e.WorkspaceEditType={}));function P(s){if(s&&s.edits)for(const r of s.edits)typeof r.resource=="object"?r.resource=L.URI.revive(r.resource):(r.newUri=L.URI.revive(r.newUri),r.oldUri=L.URI.revive(r.oldUri)),r.metadata&&r.metadata.iconPath&&(r.metadata=(0,g.revive)(r.metadata));return s}e.reviveWorkspaceEditDto=P;var w;(function(s){s[s.Workspace=0]="Workspace",s[s.TextDocument=1]="TextDocument"})(w=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,y.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,y.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,y.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,y.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,y.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,y.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,y.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,y.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,y.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,y.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,y.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,y.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,y.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,y.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,y.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,y.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,y.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,y.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,y.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,y.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,y.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,y.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,y.createMainContextProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,y.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,y.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,y.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,y.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,y.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,y.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,y.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,y.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,y.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,y.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,y.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,y.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,y.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,y.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,y.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,y.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,y.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,y.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,y.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,y.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,y.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,y.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,y.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,y.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,y.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,y.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,y.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,y.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,y.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,y.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,y.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,y.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,y.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,y.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,y.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,y.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,y.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,y.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,y.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,y.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,y.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,y.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,y.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,y.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,y.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,y.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,y.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,y.createExtHostContextProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,y.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,y.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,y.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,y.createExtHostContextProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,y.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,y.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,y.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,y.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,y.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,y.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,y.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,y.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,y.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,y.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,y.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,y.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,y.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,y.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,y.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,y.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,y.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,y.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,y.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,y.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,y.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,y.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,y.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,y.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,y.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,y.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,y.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,y.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,y.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,y.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,y.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,y.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(fe[91],me([0,1,5,3,4]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class C{constructor(k){this._onDidChangePassword=new L.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=k.getProxy(g.MainContext.MainThreadSecretState)}async $onDidChangePassword(k){this._onDidChangePassword.fire(k)}get(k,_){return this._proxy.$getPassword(k,_)}store(k,_,D){return this._proxy.$setPassword(k,_,D)}delete(k,_){return this._proxy.$deletePassword(k,_)}}e.ExtHostSecretState=C,e.IExtHostSecretState=(0,y.createDecorator)("IExtHostSecretState")}),define(fe[68],me([0,1,4,11,5,14]),function(Y,e,g,L,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,g.createDecorator)("IExtHostApiDeprecationService");let i=class{constructor(_,D){this._extHostLogService=D,this._reportedUsages=new Set,this._telemetryShape=_.getProxy(y.MainContext.MainThreadTelemetry)}report(_,D,T){const I=this.getUsageKey(_,D);this._reportedUsages.has(I)||(this._reportedUsages.add(I),D.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${_}' is deprecated. ${T}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:D.identifier.value,apiId:_}))}getUsageKey(_,D){return`${_}-${D.identifier.value}`}};i=Ve([$e(0,C.IExtHostRpcService),$e(1,L.ILogService)],i),e.ExtHostApiDeprecationService=i,e.NullApiDeprecationService=Object.freeze(new class{report(k,_,D){}})}),define(fe[232],me([0,1,3,5,7,27]),function(Y,e,g,L,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class i{constructor(_){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new g.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=_.getProxy(L.MainContext.MainThreadAuthentication)}$setProviders(_){return this._providers=_,Promise.resolve()}async getSession(_,D,T,I={}){const c=C.ExtensionIdentifier.toKey(_.identifier),p=this._inFlightRequests.get(c)||[],f=[...T].sort().join(" ");let v=p.find(S=>S.scopes===f);if(v)return v.result;{const S=this._getSession(_,c,D,T,I);v={scopes:f,result:S},p.push(v),this._inFlightRequests.set(c,p);try{await S}finally{const P=p.findIndex(w=>w.scopes===f);P>-1&&(p.splice(P),this._inFlightRequests.set(c,p))}return S}}async _getSession(_,D,T,I,c={}){await this._proxy.$ensureProvider(T);const p=_.displayName||_.name;return this._proxy.$getSession(T,I,D,p,c)}async removeSession(_,D){const T=this._authenticationProviders.get(_);return T?T.provider.removeSession(D):this._proxy.$removeSession(_,D)}registerAuthenticationProvider(_,D,T,I){if(this._authenticationProviders.get(_))throw new Error(`An authentication provider with id '${_}' is already registered.`);this._authenticationProviders.set(_,{label:D,provider:T,options:I??{supportsMultipleAccounts:!1}}),this._providers.find(p=>p.id===_)||this._providers.push({id:_,label:D});const c=T.onDidChangeSessions(p=>{this._proxy.$sendDidChangeSessions(_,{added:p.added??[],changed:p.changed??[],removed:p.removed??[]})});return this._proxy.$registerAuthenticationProvider(_,D,I?.supportsMultipleAccounts??!1),new y.Disposable(()=>{c.dispose(),this._authenticationProviders.delete(_);const p=this._providers.findIndex(f=>f.id===_);p>-1&&this._providers.splice(p),this._proxy.$unregisterAuthenticationProvider(_)})}$createSession(_,D){const T=this._authenticationProviders.get(_);if(T)return Promise.resolve(T.provider.createSession(D));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$removeSession(_,D){const T=this._authenticationProviders.get(_);if(T)return Promise.resolve(T.provider.removeSession(D));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$getSessions(_,D){const T=this._authenticationProviders.get(_);if(T)return Promise.resolve(T.provider.getSessions(D));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$onDidChangeAuthenticationSessions(_,D){return this._onDidChangeSessions.fire({provider:{id:_,label:D}}),Promise.resolve()}}e.ExtHostAuthentication=i}),define(fe[233],me([0,1,5,14,17]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let C=class{constructor(k,_){this._extHostDocumentsAndEditors=_,this._proxy=k.getProxy(g.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(k){const _=y.WorkspaceEdit.from(k,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(_)}};C=Ve([$e(0,L.IExtHostRpcService)],C),e.ExtHostBulkEdits=C}),define(fe[234],me([0,1,5]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class L{constructor(C){const i=C.getProxy(g.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return i.$readText()},writeText(k){return i.$writeText(k)}})}}e.ExtHostClipboard=L}),define(fe[40],me([0,1,13,7,17,25,5,15,11,62,42,51,2,6,4,14,66,22,55,52]),function(Y,e,g,L,y,C,i,k,_,D,T,I,c,p,f,v,S,P,w,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let r=class{constructor(l,d){this._commands=new Map,this._apiCommands=new Map,this._proxy=l.getProxy(i.MainContext.MainThreadCommands),this._logService=d,this.converter=new m(this,o=>{const h=this._apiCommands.get(o);return h?.result===b.Void?h:void 0},d),this._argumentProcessors=[{processArgument(o){return(0,D.revive)(o)}},{processArgument(o){return(0,C.cloneAndChange)(o,function(h){if(T.Range.isIRange(h))return y.Range.to(h);if(I.Position.isIPosition(h))return y.Position.to(h);if(T.Range.isIRange(h.range)&&c.URI.isUri(h.uri))return y.location.to(h);if(h instanceof P.VSBuffer)return h.buffer.buffer;if(!Array.isArray(h))return h})}}]}registerArgumentProcessor(l){this._argumentProcessors.push(l)}registerApiCommand(l){const d=this.registerCommand(!1,l.id,async(...o)=>{const h=l.args.map((E,A)=>{if(!E.validate(o[A]))throw new Error(`Invalid argument '${E.name}' when running '${l.id}', received: ${o[A]}`);return E.convert(o[A])}),u=await this.executeCommand(l.internalId,...h);return l.result.convert(u,o,this.converter)},void 0,{description:l.description,args:l.args,returns:l.result.description});return this._apiCommands.set(l.id,l),new L.Disposable(()=>{d.dispose(),this._apiCommands.delete(l.id)})}registerCommand(l,d,o,h,u,E){if(this._logService.trace("ExtHostCommands#registerCommand",d),!d.trim().length)throw new Error("invalid id");if(this._commands.has(d))throw new Error(`command '${d}' already exists`);return this._commands.set(d,{callback:o,thisArg:h,description:u,extension:E}),l&&this._proxy.$registerCommand(d),new L.Disposable(()=>{this._commands.delete(d)&&l&&this._proxy.$unregisterCommand(d)})}executeCommand(l,...d){return this._logService.trace("ExtHostCommands#executeCommand",l),this._doExecuteCommand(l,d,!0)}async _doExecuteCommand(l,d,o){if(this._commands.has(l))return this._executeContributedCommand(l,d,!1);{let h=!1;const u=(0,C.cloneAndChange)(d,function(E){if(E instanceof L.Position)return y.Position.from(E);if(E instanceof L.Range)return y.Range.from(E);if(E instanceof L.Location)return y.location.from(E);if(L.NotebookRange.isNotebookRange(E))return y.NotebookRange.from(E);if(E instanceof ArrayBuffer)return h=!0,P.VSBuffer.wrap(new Uint8Array(E));if(E instanceof Uint8Array)return h=!0,P.VSBuffer.wrap(E);if(!Array.isArray(E))return E});try{const E=await this._proxy.$executeCommand(l,h?new w.SerializableObjectWithBuffers(u):u,o);return(0,D.revive)(E)}catch(E){if(E instanceof Error&&E.message==="$executeCommand:retry")return this._doExecuteCommand(l,d,!1);throw E}}}async _executeContributedCommand(l,d,o){const h=this._commands.get(l);if(!h)throw new Error("Unknown command");let{callback:u,thisArg:E,description:A}=h;if(A)for(let R=0;R<A.args.length;R++)try{(0,g.validateConstraint)(d[R],A.args[R].constraint)}catch(B){throw new Error(`Running the contributed command: '${l}' failed. Illegal argument '${A.args[R].name}' - ${A.args[R].description}`)}try{return await u.apply(E,d)}catch(R){if(l===this.converter.delegatingCommandId){const B=this.converter.getActualCommand(...d);B&&(l=B.command)}throw this._logService.error(R,l,h.extension?.identifier),o?new class extends Error{constructor(){super((0,s.toErrorMessage)(R));this.id=l,this.source=h.extension?.displayName??h.extension?.name}}:R}}$executeContributedCommand(l,...d){return this._logService.trace("ExtHostCommands#$executeContributedCommand",l),this._commands.has(l)?(d=d.map(o=>this._argumentProcessors.reduce((h,u)=>u.processArgument(h),o)),this._executeContributedCommand(l,d,!0)):Promise.reject(new Error(`Contributed command '${l}' does not exist.`))}getCommands(l=!1){return this._logService.trace("ExtHostCommands#getCommands",l),this._proxy.$getCommands().then(d=>(l&&(d=d.filter(o=>o[0]!=="_")),d))}$getContributedCommandHandlerDescriptions(){const l=Object.create(null);for(let[d,o]of this._commands){let{description:h}=o;h&&(l[d]=h)}return Promise.resolve(l)}};r=Ve([$e(0,v.IExtHostRpcService),$e(1,_.ILogService)],r),e.ExtHostCommands=r,e.IExtHostCommands=(0,f.createDecorator)("IExtHostCommands");class m{constructor(l,d,o){this._commands=l,this._lookupApiCommand=d,this._logService=o,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(l,d){if(!l)return;const o={$ident:void 0,id:l.command,title:l.title,tooltip:l.tooltip};if(!l.command)return o;const h=this._lookupApiCommand(l.command);if(h)o.id=h.internalId,o.arguments=h.args.map((u,E)=>u.convert(l.arguments&&l.arguments[E]));else if((0,k.isNonEmptyArray)(l.arguments)){const u=++this._cachIdPool;this._cache.set(u,l),d.add((0,p.toDisposable)(()=>{this._cache.delete(u),this._logService.trace("CommandsConverter#DISPOSE",u)})),o.$ident=u,o.id=this.delegatingCommandId,o.arguments=[u],this._logService.trace("CommandsConverter#CREATE",l.command,u)}return o}fromInternal(l){const d=i.ObjectIdentifier.of(l);return typeof d=="number"?this._cache.get(d):{command:l.id,title:l.title,arguments:l.arguments}}getActualCommand(...l){return this._cache.get(l[0])}_executeConvertedCommand(...l){const d=this.getActualCommand(...l);return this._logService.trace("CommandsConverter#EXECUTE",l[0],d?d.command:"MISSING"),d?this._commands.executeCommand(d.command,...d.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=m;class a{constructor(l,d,o,h){this.name=l,this.description=d,this.validate=o,this.convert=h}optional(){return new a(this.name,`(optional) ${this.description}`,l=>l==null||this.validate(l),l=>l===void 0?void 0:l===null?null:this.convert(l))}with(l,d){return new a(l??this.name,d??this.description,this.validate,this.convert)}}e.ApiCommandArgument=a,a.Uri=new a("uri","Uri of a text document",t=>c.URI.isUri(t),t=>t),a.Position=new a("position","A position in a text document",t=>L.Position.isPosition(t),y.Position.from),a.Range=new a("range","A range in a text document",t=>L.Range.isRange(t),y.Range.from),a.Selection=new a("selection","A selection in a text document",t=>L.Selection.isSelection(t),y.Selection.from),a.Number=new a("number","",t=>typeof t=="number",t=>t),a.String=new a("string","",t=>typeof t=="string",t=>t),a.CallHierarchyItem=new a("item","A call hierarchy item",t=>t instanceof L.CallHierarchyItem,y.CallHierarchyItem.from),a.TypeHierarchyItem=new a("item","A type hierarchy item",t=>t instanceof L.TypeHierarchyItem,y.TypeHierarchyItem.from),a.TestItem=new a("testItem","A VS Code TestItem",t=>t instanceof S.TestItemImpl,y.TestItem.from);class b{constructor(l,d){this.description=l,this.convert=d}}e.ApiCommandResult=b,b.Void=new b("no result",t=>t);class n{constructor(l,d,o,h,u){this.id=l,this.internalId=d,this.description=o,this.args=h,this.result=u}}e.ApiCommand=n}),define(fe[235],me([0,1,17,7,85,40,15,111]),function(Y,e,g,L,y,C,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const _=[new C.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",T(g.DocumentHighlight.to))),new C.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(c,p)=>{if((0,i.isFalsyOrEmpty)(c))return;class f extends L.SymbolInformation{static to(S){const P=new f(S.name,g.SymbolKind.to(S.kind),S.containerName||"",new L.Location(p[0],g.Range.to(S.range)));return P.detail=S.detail,P.range=P.location.range,P.selectionRange=g.Range.to(S.selectionRange),P.children=S.children?S.children.map(f.to):[],P}}return c.map(f.to)})),new C.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("options","Formatting options",c=>!0,c=>c)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(g.TextEdit.to))),new C.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range,new C.ApiCommandArgument("options","Formatting options",c=>!0,c=>c)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(g.TextEdit.to))),new C.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,new C.ApiCommandArgument("ch","Trigger character",c=>typeof c=="string",c=>c),new C.ApiCommandArgument("options","Formatting options",c=>!0,c=>c)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(g.TextEdit.to))),new C.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new C.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new C.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new C.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new C.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location-instances.",T(g.location.to))),new C.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Hover-instances.",T(g.Hover.to))),new C.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("position","A position in a text document",c=>Array.isArray(c)&&c.every(p=>L.Position.isPosition(p)),c=>c.map(g.Position.from))],new C.ApiCommandResult("A promise that resolves to an array of ranges.",c=>c.map(p=>{let f;for(const v of p.reverse())f=new L.SelectionRange(g.Range.to(v),f);return f}))),new C.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[C.ApiCommandArgument.String.with("query","Search string")],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",c=>{const p=[];if(Array.isArray(c))for(let f of c)p.push(...f[1].map(g.WorkspaceSymbol.to));return p})),new C.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A CallHierarchyItem or undefined",c=>c.map(g.CallHierarchyItem.to))),new C.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",c=>c.map(g.CallHierarchyIncomingCall.to))),new C.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",c=>c.map(g.CallHierarchyOutgoingCall.to))),new C.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to a range and placeholder text.",c=>{if(!!c)return{range:g.Range.to(c.range),placeholder:c.text}})),new C.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("newName","The new symbol name")],new C.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",c=>{if(!!c){if(c.rejectReason)throw new Error(c.rejectReason);return g.WorkspaceEdit.to(c)}})),new C.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new C.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",c=>c.map(g.DocumentLink.to))),new C.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",c=>{if(!!c)return new L.SemanticTokensLegend(c.tokenTypes,c.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const p=(0,k.decodeSemanticTokensDto)(c);if(p.type==="full")return new L.SemanticTokens(p.data,void 0)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range.optional()],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",c=>{if(!!c)return new L.SemanticTokensLegend(c.tokenTypes,c.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const p=(0,k.decodeSemanticTokensDto)(c);if(p.type==="full")return new L.SemanticTokens(p.data,void 0)})),new C.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new C.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(c,p,f)=>{if(!c)return new L.CompletionList([]);const v=c.suggestions.map(S=>g.CompletionItem.to(S,f));return new L.CompletionList(v,c.incomplete)})),new C.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new C.ApiCommandResult("A promise that resolves to SignatureHelp.",c=>{if(c)return g.SignatureHelp.to(c)})),new C.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new C.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(c,p,f)=>T(v=>new L.CodeLens(g.Range.to(v.range),v.command&&f.fromInternal(v.command)))(c))),new C.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",c=>L.Range.isRange(c),c=>L.Selection.isSelection(c)?g.Selection.from(c):g.Range.from(c)),C.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new C.ApiCommandResult("A promise that resolves to an array of Command-instances.",(c,p,f)=>T(v=>{if(v._isSynthetic){if(!v.command)throw new Error("Synthetic code actions must have a command");return f.fromInternal(v.command)}else{const S=new L.CodeAction(v.title,v.kind?new L.CodeActionKind(v.kind):void 0);return v.edit&&(S.edit=g.WorkspaceEdit.to(v.edit)),v.command&&(S.command=f.fromInternal(v.command)),S.isPreferred=v.isPreferred,S}})(c))),new C.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",c=>c?c.map(p=>new L.ColorInformation(g.Range.to(p.range),g.Color.to(p.color))):[])),new C.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new C.ApiCommandArgument("color","The color to show and insert",c=>c instanceof L.Color,g.Color.from),new C.ApiCommandArgument("context","Context object with uri and range",c=>!0,c=>({uri:c.uri,range:g.Range.from(c.range)}))],new C.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",c=>c?c.map(g.ColorPresentation.to):[])),new C.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of Inlay objects",c=>c.map(g.InlayHint.to))),new C.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new C.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",T(c=>({viewType:c.viewType,displayName:c.displayName,options:{transientOutputs:c.options.transientOutputs,transientCellMetadata:c.options.transientCellMetadata,transientDocumentMetadata:c.options.transientDocumentMetadata},filenamePattern:c.filenamePattern.map(p=>g.NotebookExclusiveDocumentPattern.to(p))})))),new C.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of InlineValue objects",c=>c.map(g.InlineValue.to))),new C.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[c,void 0]:[g.ViewColumn.from(c.viewColumn),g.TextEditorOpenOptions.from(c)])).optional(),C.ApiCommandArgument.String.with("label","").optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[C.ApiCommandArgument.Uri.with("resource","Resource to open"),C.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[c,void 0]:[g.ViewColumn.from(c.viewColumn),g.TextEditorOpenOptions.from(c)])).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[C.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),C.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),C.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="object",c=>c&&[g.ViewColumn.from(c.viewColumn),g.TextEditorOpenOptions.from(c)]).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A TypeHierarchyItem or undefined",c=>c.map(g.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A TypeHierarchyItem or undefined",c=>c.map(g.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A TypeHierarchyItem or undefined",c=>c.map(g.TypeHierarchyItem.to))),new C.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[C.ApiCommandArgument.TestItem],C.ApiCommandResult.Void)];class D{static register(p){_.forEach(p.registerApiCommand,p)}}e.ExtHostApiCommands=D;function T(c){return p=>{if(Array.isArray(p))return p.map(c)}}function I(c){if(!Array.isArray(c))return;const p=[];for(const f of c)y.isLocationLink(f)?p.push(g.DefinitionLink.to(f)):p.push(g.location.to(f));return p}}),define(fe[236],me([0,1,16,60,3,6,2,85,27,17,7,5]),function(Y,e,g,L,y,C,i,k,_,D,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function c(p,f,v){const S=p.getProxy(I.MainContext.MainThreadComments);class P{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,f.registerArgumentProcessor({processArgument:t=>{if(t&&t.$mid===6){const l=this._commentControllers.get(t.handle);return l||t}else if(t&&t.$mid===7){const l=this._commentControllers.get(t.commentControlHandle);if(!l)return t;const d=l.getCommentThread(t.commentThreadHandle);return d||t}else if(t&&t.$mid===8){const l=this._commentControllers.get(t.thread.commentControlHandle);if(!l)return t;const d=l.getCommentThread(t.thread.commentThreadHandle);return d?{thread:d,text:t.text}:t}else if(t&&t.$mid===9){const l=this._commentControllers.get(t.thread.commentControlHandle);if(!l)return t;const d=l.getCommentThread(t.thread.commentThreadHandle);if(!d)return t;let o=t.commentUniqueId,h=d.getCommentByUniqueId(o);return h||t}else if(t&&t.$mid===10){const l=this._commentControllers.get(t.thread.commentControlHandle);if(!l)return t;const d=l.getCommentThread(t.thread.commentThreadHandle);if(!d)return t;let o=t.text,h=t.commentUniqueId,u=d.getCommentByUniqueId(h);return u?(u.body=o,u):t}return t}})}createCommentController(t,l,d){const o=P.handlePool++,h=new s(t,o,l,d);this._commentControllers.set(h.handle,h);const u=this._commentControllersByExtension.get(_.ExtensionIdentifier.toKey(t.identifier))||[];return u.push(h),this._commentControllersByExtension.set(_.ExtensionIdentifier.toKey(t.identifier),u),h.value}$createCommentThreadTemplate(t,l,d){const o=this._commentControllers.get(t);!o||o.$createCommentThreadTemplate(l,d)}async $updateCommentThreadTemplate(t,l,d){const o=this._commentControllers.get(t);!o||o.$updateCommentThreadTemplate(l,d)}$deleteCommentThread(t,l){const d=this._commentControllers.get(t);d&&d.$deleteCommentThread(l)}$provideCommentingRanges(t,l,d){const o=this._commentControllers.get(t);if(!o||!o.commentingRangeProvider)return Promise.resolve(void 0);const h=v.getDocument(i.URI.revive(l));return(0,g.asPromise)(()=>o.commentingRangeProvider.provideCommentingRanges(h,d)).then(u=>u?u.map(E=>D.Range.from(E)):void 0)}$toggleReaction(t,l,d,o,h){const u=this._commentControllers.get(t);return!u||!u.reactionHandler?Promise.resolve(void 0):(0,g.asPromise)(()=>{const E=u.getCommentThread(l);if(E){const A=E.getCommentByUniqueId(o.uniqueIdInThread);if(u!==void 0&&A&&u.reactionHandler)return u.reactionHandler(A,a(h))}return Promise.resolve(void 0)})}dispose(){}}P.handlePool=0;class w{constructor(t,l,d,o,h,u,E){this._commentControllerHandle=l,this._id=d,this._uri=o,this._range=h,this._comments=u,this.handle=w._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new y.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new C.MutableDisposable,this._acceptInputDisposables.value=new C.DisposableStore,this._id===void 0&&(this._id=`${t}.${this.handle}`),S.$createCommentThread(l,this.handle,this._id,this._uri,D.Range.from(this._range),E),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=u,this._localDisposables.push({dispose:()=>{S.$deleteCommentThread(l,this.handle)}});const A=this;this.value={get uri(){return A.uri},get range(){return A.range},set range(R){A.range=R},get comments(){return A.comments},set comments(R){A.comments=R},get collapsibleState(){return A.collapsibleState},set collapsibleState(R){A.collapsibleState=R},get canReply(){return A.canReply},set canReply(R){A.canReply=R},get contextValue(){return A.contextValue},set contextValue(R){A.contextValue=R},get label(){return A.label},set label(R){A.label=R},dispose:()=>{A.dispose()}}}set threadId(t){this._id=t}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(t){t.isEqual(this._range)||(this._range=t,this.modifications.range=t,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(t){this._canReply!==t&&(this._canReply=t,this.modifications.canReply=t,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(t){this._label=t,this.modifications.label=t,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(t){this._contextValue=t,this.modifications.contextValue=t,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(t){this._comments=t,this.modifications.comments=t,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(t){this._collapseState=t,this.modifications.collapsibleState=t,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new C.DisposableStore);const t=d=>Object.prototype.hasOwnProperty.call(this.modifications,d),l={};t("range")&&(l.range=D.Range.from(this._range)),t("label")&&(l.label=this.label),t("contextValue")&&(l.contextValue=this.contextValue??null),t("comments")&&(l.comments=this._comments.map(d=>r(this,d,this._commentsMap))),t("collapsibleState")&&(l.collapseState=b(this._collapseState)),t("canReply")&&(l.canReply=this.canReply),this.modifications={},S.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,l)}getCommentByUniqueId(t){for(let l of this._commentsMap){let d=l[0],o=l[1];if(t===o)return d}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(t=>t.dispose())}}w._handlePool=0,Ve([(0,L.debounce)(100)],w.prototype,"eventuallyUpdateCommentThread",null);class s{constructor(t,l,d,o){this._extension=t,this._handle=l,this._id=d,this._label=o,this._threads=new Map,S.$registerCommentController(this.handle,d,o);const h=this;this.value=Object.freeze({id:h.id,label:h.label,get options(){return h.options},set options(u){h.options=u},get commentingRangeProvider(){return h.commentingRangeProvider},set commentingRangeProvider(u){h.commentingRangeProvider=u},get reactionHandler(){return h.reactionHandler},set reactionHandler(u){h.reactionHandler=u},createCommentThread(u,E,A){return h.createCommentThread(u,E,A).value},dispose:()=>{h.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{S.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(t){this._commentingRangeProvider=t,S.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(t){this._reactionHandler=t,S.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!t})}get options(){return this._options}set options(t){this._options=t,S.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(t,l,d,o){if(typeof t=="string"){const h=new w(this.id,this.handle,t,l,d,o,this._extension.identifier);return this._threads.set(h.handle,h),h}else{const h=new w(this.id,this.handle,void 0,t,l,d,this._extension.identifier);return this._threads.set(h.handle,h),h}}$createCommentThreadTemplate(t,l){const d=new w(this.id,this.handle,void 0,i.URI.revive(t),D.Range.to(l),[],this._extension.identifier);return d.collapsibleState=k.CommentThreadCollapsibleState.Expanded,this._threads.set(d.handle,d),d}$updateCommentThreadTemplate(t,l){let d=this._threads.get(t);d&&(d.range=D.Range.to(l))}$deleteCommentThread(t){let l=this._threads.get(t);l&&l.dispose(),this._threads.delete(t)}getCommentThread(t){return this._threads.get(t)}dispose(){this._threads.forEach(t=>{t.dispose()}),this._localDisposables.forEach(t=>t.dispose())}}function r(n,t,l){let d=l.get(t);d||(d=++n.commentHandle,l.set(t,d));const o=t.author&&t.author.iconPath?t.author.iconPath.toString():void 0;return{mode:t.mode,contextValue:t.contextValue,uniqueIdInThread:d,body:D.MarkdownString.from(t.body),userName:t.author.name,userIconPath:o,label:t.label,commentReactions:t.reactions?t.reactions.map(h=>m(h)):void 0}}function m(n){return{label:n.label,iconPath:n.iconPath?D.pathOrURIToURI(n.iconPath):void 0,count:n.count,hasReacted:n.authorHasReacted}}function a(n){return{label:n.label||"",count:n.count||0,iconPath:n.iconPath?i.URI.revive(n.iconPath):"",authorHasReacted:n.hasReacted||!1}}function b(n){if(n!==void 0)switch(n){case T.CommentThreadCollapsibleState.Expanded:return k.CommentThreadCollapsibleState.Expanded;case T.CommentThreadCollapsibleState.Collapsed:return k.CommentThreadCollapsibleState.Collapsed}return k.CommentThreadCollapsibleState.Collapsed}return new P}e.createExtHostComments=c}),define(fe[131],me([0,1,2,5,7,4,14,11,15,8,9]),function(Y,e,g,L,y,C,i,k,_,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let I=class vi{constructor(p,f){this._logService=f,this._provider=new Map,this._proxy=p.getProxy(L.MainContext.MainThreadDecorations)}registerFileDecorationProvider(p,f){const v=vi._handlePool++;this._provider.set(v,{provider:p,extensionId:f}),this._proxy.$registerDecorationProvider(v,f.value);const S=p.onDidChangeFileDecorations&&p.onDidChangeFileDecorations(P=>{if(!P){this._proxy.$onDidChange(v,null);return}let w=(0,_.asArray)(P);if(w.length<=vi._maxEventSize){this._proxy.$onDidChange(v,w);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",f.value,w.length);const s=w.map(a=>({uri:a,rank:(0,D.count)(a.path,"/")})),r=(0,_.groupBy)(s,(a,b)=>a.rank-b.rank||(0,D.compare)(a.uri.path,b.uri.path));let m=[];e:for(let a of r){let b;for(let n of a){let t=(0,T.dirname)(n.uri.path);if(b!==t&&(b=t,m.push(n.uri)>=vi._maxEventSize))break e}}this._proxy.$onDidChange(v,m)});return new y.Disposable(()=>{S?.dispose(),this._proxy.$unregisterDecorationProvider(v),this._provider.delete(v)})}async $provideDecorations(p,f,v){if(!this._provider.has(p))return Object.create(null);const S=Object.create(null),{provider:P,extensionId:w}=this._provider.get(p);return await Promise.all(f.map(async s=>{try{const{uri:r,id:m}=s,a=await Promise.resolve(P.provideFileDecoration(g.URI.revive(r),v));if(!a)return;try{y.FileDecoration.validate(a),S[m]=[a.propagate,a.tooltip,a.badge,a.color]}catch(b){this._logService.warn(`INVALID decoration from extension '${w.value}': ${b}`)}}catch(r){this._logService.error(r)}})),S}};I._handlePool=0,I._maxEventSize=250,I=Ve([$e(0,i.IExtHostRpcService),$e(1,k.ILogService)],I),e.ExtHostDecorations=I,e.IExtHostDecorations=(0,C.createDecorator)("IExtHostDecorations")});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,L,y){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?y.call(Y,g):y?y.value=g:e.set(Y,g),g},Ne=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[237],me([0,1,164,116,2,5,7,17,3,11,24,45]),function(Y,e,g,L,y,C,i,k,_,D,T,I){"use strict";var c,p,f;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class v{constructor(w,s,r,m,a,b){this._name=w,this._owner=s,this._maxDiagnosticsPerFile=r,c.set(this,void 0),p.set(this,void 0),f.set(this,void 0),this._isDisposed=!1,st(this,f,new T.ResourceMap(n=>m.getComparisonKey(n)),"f"),st(this,c,a,"f"),st(this,p,b,"f")}dispose(){this._isDisposed||(Ne(this,p,"f").fire([...Ne(this,f,"f").keys()]),Ne(this,c,"f")&&Ne(this,c,"f").$clear(this._owner),Ne(this,f,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(w,s){if(!w){this.clear();return}this._checkDisposed();let r=[];if(y.URI.isUri(w)){if(!s){this.delete(w);return}Ne(this,f,"f").set(w,s.slice()),r=[w]}else if(Array.isArray(w)){r=[];let a;w=[...w].sort(v._compareIndexedTuplesByUri);for(const b of w){const[n,t]=b;if((!a||n.toString()!==a.toString())&&(a&&Ne(this,f,"f").get(a).length===0&&Ne(this,f,"f").delete(a),a=n,r.push(n),Ne(this,f,"f").set(n,[])),t){const l=Ne(this,f,"f").get(n);l&&l.push(...t)}else{const l=Ne(this,f,"f").get(n);l&&(l.length=0)}}}if(Ne(this,p,"f").fire(r),!Ne(this,c,"f"))return;const m=[];for(let a of r){let b=[];const n=Ne(this,f,"f").get(a);if(n)if(n.length>this._maxDiagnosticsPerFile){b=[];const t=[i.DiagnosticSeverity.Error,i.DiagnosticSeverity.Warning,i.DiagnosticSeverity.Information,i.DiagnosticSeverity.Hint];e:for(let l=0;l<4;l++)for(let d of n)if(d.severity===t[l]&&b.push(k.Diagnostic.from(d))===this._maxDiagnosticsPerFile)break e;b.push({severity:L.MarkerSeverity.Info,message:(0,g.localize)(0,null,n.length-this._maxDiagnosticsPerFile),startLineNumber:b[b.length-1].startLineNumber,startColumn:b[b.length-1].startColumn,endLineNumber:b[b.length-1].endLineNumber,endColumn:b[b.length-1].endColumn})}else b=n.map(t=>k.Diagnostic.from(t));m.push([a,b])}Ne(this,c,"f").$changeMany(this._owner,m)}delete(w){this._checkDisposed(),Ne(this,p,"f").fire([w]),Ne(this,f,"f").delete(w),Ne(this,c,"f")&&Ne(this,c,"f").$changeMany(this._owner,[[w,void 0]])}clear(){this._checkDisposed(),Ne(this,p,"f").fire([...Ne(this,f,"f").keys()]),Ne(this,f,"f").clear(),Ne(this,c,"f")&&Ne(this,c,"f").$clear(this._owner)}forEach(w,s){this._checkDisposed();for(let r of Ne(this,f,"f").keys())w.apply(s,[r,this.get(r),this])}get(w){this._checkDisposed();const s=Ne(this,f,"f").get(w);return Array.isArray(s)?Object.freeze(s.slice(0)):[]}has(w){return this._checkDisposed(),Array.isArray(Ne(this,f,"f").get(w))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(w,s){return w[0].toString()<s[0].toString()?-1:w[0].toString()>s[0].toString()?1:0}}e.DiagnosticCollection=v,c=new WeakMap,p=new WeakMap,f=new WeakMap;let S=class ei{constructor(w,s,r){this._logService=s,this._fileSystemInfoService=r,this._collections=new Map,this._onDidChangeDiagnostics=new _.DebounceEmitter({merge:m=>m.flat(),delay:50}),this.onDidChangeDiagnostics=_.Event.map(this._onDidChangeDiagnostics.event,ei._mapper),this._proxy=w.getProxy(C.MainContext.MainThreadDiagnostics)}static _mapper(w){const s=new T.ResourceMap;for(const r of w)s.set(r,r);return{uris:Object.freeze(Array.from(s.values()))}}createDiagnosticCollection(w,s){const{_collections:r,_proxy:m,_onDidChangeDiagnostics:a,_logService:b,_fileSystemInfoService:n}=this,t=new class{$changeMany(o,h){m.$changeMany(o,h),b.trace("[DiagnosticCollection] change many (extension, owner, uris)",w.value,o,h.length===0?"CLEARING":h)}$clear(o){m.$clear(o),b.trace("[DiagnosticCollection] remove all (extension, owner)",w.value,o)}dispose(){m.dispose()}};let l;if(!s)s="_generated_diagnostic_collection_name_#"+ei._idPool++,l=s;else if(!r.has(s))l=s;else{this._logService.warn(`DiagnosticCollection with name '${s}' does already exist.`);do l=s+ei._idPool++;while(r.has(l))}return new class extends v{constructor(){super(s,l,ei._maxDiagnosticsPerFile,n.extUri,t,a);r.set(l,this)}dispose(){super.dispose(),r.delete(l)}}}getDiagnostics(w){if(w)return this._getDiagnostics(w);{const s=new Map,r=[];for(const m of this._collections.values())m.forEach((a,b)=>{let n=s.get(a.toString());typeof n=="undefined"&&(n=r.length,s.set(a.toString(),n),r.push([a,[]])),r[n][1]=r[n][1].concat(...b)});return r}}_getDiagnostics(w){let s=[];for(let r of this._collections.values())r.has(w)&&(s=s.concat(r.get(w)));return s}$acceptMarkersChange(w){if(!this._mirrorCollection){const s="_generated_mirror",r=new v(s,s,ei._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(s,r),this._mirrorCollection=r}for(const[s,r]of w)this._mirrorCollection.set(y.URI.revive(s),r.map(k.Diagnostic.to))}};S._idPool=0,S._maxDiagnosticsPerFile=1e3,S=Ve([$e(1,D.ILogService),$e(2,I.IExtHostFileSystemInfo)],S),e.ExtHostDiagnostics=S}),define(fe[238],me([0,1,2,5]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class y{constructor(i){this._proxy=i.getProxy(L.MainContext.MainThreadDialogs)}showOpenDialog(i){return this._proxy.$showOpenDialog(i).then(k=>k?k.map(_=>g.URI.revive(_)):void 0)}showSaveDialog(i){return this._proxy.$showSaveDialog(i).then(k=>k?g.URI.revive(k):void 0)}}e.ExtHostDialogs=y}),define(fe[239],me([0,1,18,2,7,5,10,21,8]),function(Y,e,g,L,y,C,i,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class D{constructor(I,c,p){this._documentsAndEditors=c,this._logService=p,this._documentContentProviders=new Map,this._proxy=I.getProxy(C.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,c){if(Object.keys(i.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const p=D._handlePool++;this._documentContentProviders.set(p,c),this._proxy.$registerTextContentProvider(p,I);let f;return typeof c.onDidChange=="function"&&(f=c.onDidChange(v=>{if(v.scheme!==I){this._logService.warn(`Provider for scheme '${I}' is firing event for schema '${v.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(v)&&this.$provideTextDocumentContent(p,v).then(S=>{if(!S&&typeof S!="string")return;const P=this._documentsAndEditors.getDocument(v);if(!P)return;const w=(0,_.splitLines)(S);if(!P.equalLines(w))return this._proxy.$onVirtualDocumentChange(v,S)},g.onUnexpectedError)})),new y.Disposable(()=>{this._documentContentProviders.delete(p)&&this._proxy.$unregisterTextContentProvider(p),f&&(f.dispose(),f=void 0)})}$provideTextDocumentContent(I,c){const p=this._documentContentProviders.get(I);return p?Promise.resolve(p.provideTextDocumentContent(L.URI.revive(c),k.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${c.scheme}`))}}e.ExtHostDocumentContentProvider=D,D._handlePool=0}),define(fe[240],me([0,1,3,6,2,5,123,17,13,25,7]),function(Y,e,g,L,y,C,i,k,_,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class I{constructor(p,f){this._onDidAddDocument=new g.Emitter,this._onDidRemoveDocument=new g.Emitter,this._onDidChangeDocument=new g.Emitter,this._onDidSaveDocument=new g.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new L.DisposableStore,this._documentLoader=new Map,this._proxy=p.getProxy(C.MainContext.MainThreadDocuments),this._documentsAndEditors=f,this._documentsAndEditors.onDidRemoveDocuments(v=>{for(const S of v)this._onDidRemoveDocument.fire(S.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(v=>{for(const S of v)this._onDidAddDocument.fire(S.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(p){if(!p)return;const f=this._documentsAndEditors.getDocument(p);if(f)return f}getDocument(p){const f=this.getDocumentData(p);if(!f?.document)throw new Error(`Unable to retrieve document from URI '${p}'`);return f.document}ensureDocumentData(p){const f=this._documentsAndEditors.getDocument(p);if(f)return Promise.resolve(f);let v=this._documentLoader.get(p.toString());return v||(v=this._proxy.$tryOpenDocument(p).then(S=>{this._documentLoader.delete(p.toString());const P=y.URI.revive(S);return(0,_.assertIsDefined)(this._documentsAndEditors.getDocument(P))},S=>(this._documentLoader.delete(p.toString()),Promise.reject(S))),this._documentLoader.set(p.toString(),v)),v}createDocumentData(p){return this._proxy.$tryCreateDocument(p).then(f=>y.URI.revive(f))}$acceptModelModeChanged(p,f){const v=y.URI.revive(p),S=this._documentsAndEditors.getDocument(v);if(!S)throw new Error("unknown document");this._onDidRemoveDocument.fire(S.document),S._acceptLanguageId(f),this._onDidAddDocument.fire(S.document)}$acceptModelSaved(p){const f=y.URI.revive(p),v=this._documentsAndEditors.getDocument(f);if(!v)throw new Error("unknown document");this.$acceptDirtyStateChanged(p,!1),this._onDidSaveDocument.fire(v.document)}$acceptDirtyStateChanged(p,f){const v=y.URI.revive(p),S=this._documentsAndEditors.getDocument(v);if(!S)throw new Error("unknown document");S._acceptIsDirty(f),this._onDidChangeDocument.fire({document:S.document,contentChanges:[],reason:void 0})}$acceptModelChanged(p,f,v){const S=y.URI.revive(p),P=this._documentsAndEditors.getDocument(S);if(!P)throw new Error("unknown document");P._acceptIsDirty(v),P.onEvents(f);let w;f.isUndoing?w=T.TextDocumentChangeReason.Undo:f.isRedoing&&(w=T.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,D.deepFreeze)({document:P.document,contentChanges:f.changes.map(s=>({range:k.Range.to(s.range),rangeOffset:s.rangeOffset,rangeLength:s.rangeLength,text:s.text})),reason:w}))}setWordDefinitionFor(p,f){(0,i.setWordDefinitionFor)(p,f)}}e.ExtHostDocuments=I}),define(fe[46],me([0,1,58,3,6,2,4,5,123,14,130,17,11,24,10,78,141]),function(Y,e,g,L,y,C,i,k,_,D,T,I,c,p,f,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class P{constructor(r){this.value=r,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let w=class{constructor(r,m){this._extHostRpc=r,this._logService=m,this._activeEditorId=null,this._editors=new Map,this._documents=new p.ResourceMap,this._onDidAddDocuments=new L.Emitter,this._onDidRemoveDocuments=new L.Emitter,this._onDidChangeVisibleTextEditors=new L.Emitter,this._onDidChangeActiveTextEditor=new L.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(r){this.acceptDocumentsAndEditorsDelta(r)}acceptDocumentsAndEditorsDelta(r){const m=[],a=[],b=[];if(r.removedDocuments)for(const n of r.removedDocuments){const t=C.URI.revive(n),l=this._documents.get(t);l?.unref()&&(this._documents.delete(t),m.push(l.value))}if(r.addedDocuments)for(const n of r.addedDocuments){const t=C.URI.revive(n.uri);let l=this._documents.get(t);if(l&&t.scheme!==f.Schemas.vscodeNotebookCell&&t.scheme!==f.Schemas.vscodeInteractiveInput)throw new Error(`document '${t} already exists!'`);l||(l=new P(new _.ExtHostDocumentData(this._extHostRpc.getProxy(k.MainContext.MainThreadDocuments),t,n.lines,n.EOL,n.versionId,n.languageId,n.isDirty,n.notebook)),this._documents.set(t,l),a.push(l.value)),l.ref()}if(r.removedEditors)for(const n of r.removedEditors){const t=this._editors.get(n);this._editors.delete(n),t&&b.push(t)}if(r.addedEditors)for(const n of r.addedEditors){const t=C.URI.revive(n.documentUri);g.ok(this._documents.has(t),`document '${t}' does not exist`),g.ok(!this._editors.has(n.id),`editor '${n.id}' already exists!`);const l=this._documents.get(t).value,d=new T.ExtHostTextEditor(n.id,this._extHostRpc.getProxy(k.MainContext.MainThreadTextEditors),this._logService,new S.Lazy(()=>l.document),n.selections.map(I.Selection.to),n.options,n.visibleRanges.map(o=>I.Range.to(o)),typeof n.editorPosition=="number"?I.ViewColumn.to(n.editorPosition):void 0);this._editors.set(n.id,d)}r.newActiveEditor!==void 0&&(g.ok(r.newActiveEditor===null||this._editors.has(r.newActiveEditor),`active editor '${r.newActiveEditor}' does not exist`),this._activeEditorId=r.newActiveEditor),(0,y.dispose)(m),(0,y.dispose)(b),r.removedDocuments&&this._onDidRemoveDocuments.fire(m),r.addedDocuments&&this._onDidAddDocuments.fire(a),(r.removedEditors||r.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(n=>n.value)),r.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(r){return this._documents.get(r)?.value}allDocuments(){return v.Iterable.map(this._documents.values(),r=>r.value)}getEditor(r){return this._editors.get(r)}activeEditor(r){if(!this._activeEditorId)return;const m=this._editors.get(this._activeEditorId);return r?m:m?.value}allEditors(){return[...this._editors.values()]}};w=Ve([$e(0,D.IExtHostRpcService),$e(1,c.ILogService)],w),e.ExtHostDocumentsAndEditors=w,e.IExtHostDocumentsAndEditors=(0,i.createDecorator)("IExtHostDocumentsAndEditors")}),define(fe[56],me([0,1,17,5,2,3,4,14,16]),function(Y,e,g,L,y,C,i,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,i.createDecorator)("IExtHostEditorTabs");let D=class{constructor(I){this._onDidChangeTabs=new C.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new C.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[],this._proxy=I.getProxy(L.MainContext.MainThreadEditorTabs)}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(I){let c=-1;this._tabs=I.map((f,v)=>(f.isActive&&(c=v),Object.freeze({label:f.label,viewColumn:g.ViewColumn.to(f.viewColumn),index:v,resource:y.URI.revive(f.resource),additionalResourcesAndViewIds:f.additionalResourcesAndViewIds.map(({resource:S,viewId:P})=>({resource:y.URI.revive(S),viewId:P})),viewId:f.editorId,isActive:f.isActive,move:async(S,P)=>{this._proxy.$moveTab(f,S,g.ViewColumn.from(P)),await(0,_.raceTimeout)(C.Event.toPromise(this._onDidChangeTabs.event),1e3)},close:async()=>{await this._proxy.$closeTab(f),await(0,_.raceTimeout)(C.Event.toPromise(this._onDidChangeTabs.event),1e3)}}))),this._tabs=this._tabs.sort((f,v)=>f.viewColumn===v.viewColumn?f.index-v.index:f.viewColumn-v.viewColumn);const p=this._activeTab;this._activeTab=c===-1?void 0:this._tabs[c],this._activeTab!==p&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}};D=Ve([$e(0,k.IExtHostRpcService)],D),e.ExtHostEditorTabs=D}),define(fe[241],me([0,1,2,5,6,7,17,148,8,22,29]),function(Y,e,g,L,y,C,i,k,_,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class I{constructor(){this._schemes=[]}add(f){this._stateMachine=void 0,this._schemes.push(f)}delete(f){const v=this._schemes.indexOf(f);v>=0&&(this._schemes.splice(v,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const f=this._schemes.sort(),v=[];let S,P,w=14,s=14;for(const r of f){let m=S?(0,_.commonPrefixLength)(S,r):0;for(m===0?P=1:P=s;m<r.length;m++)m+1===r.length?(w=s,s=9):s+=1,v.push([P,r.toUpperCase().charCodeAt(m),s]),v.push([P,r.toLowerCase().charCodeAt(m),s]),P=s;S=r,s=w}v.push([9,58,10]),v.push([10,47,12]),this._stateMachine=new k.StateMachine(v)}}provideDocumentLinks(f){this._initStateMachine();const v=[],S=k.LinkComputer.computeLinks({getLineContent(P){return f.lineAt(P-1).text},getLineCount(){return f.lineCount}},this._stateMachine);for(const P of S){const w=i.DocumentLink.to(P);w.target&&v.push(w)}return v}}class c{constructor(f,v){this._extHostLanguageFeatures=v,this._linkProvider=new I,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=f.getProxy(L.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(f,v,S,P={}){if(this._registeredSchemes.has(v))throw new Error(`a provider for the scheme '${v}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const w=this._handlePool++;this._linkProvider.add(v),this._registeredSchemes.add(v),this._fsProvider.set(w,S);let s=2;P.isCaseSensitive&&(s+=1024),P.isReadonly&&(s+=2048),typeof S.copy=="function"&&(s+=8),typeof S.open=="function"&&typeof S.close=="function"&&typeof S.read=="function"&&typeof S.write=="function"&&((0,T.checkProposedApiEnabled)(f,"fsChunks"),s+=4),this._proxy.$registerFileSystemProvider(w,v,s).catch(m=>{console.error(`FAILED to register filesystem provider of ${f.identifier.value}-extension for the scheme ${v}`),console.error(m)});const r=S.onDidChangeFile(m=>{const a=[];for(const b of m){let{uri:n,type:t}=b;if(n.scheme!==v)continue;let l;switch(t){case C.FileChangeType.Changed:l=0;break;case C.FileChangeType.Created:l=1;break;case C.FileChangeType.Deleted:l=2;break;default:throw new Error("Unknown FileChangeType")}a.push({resource:n,type:l})}this._proxy.$onFileSystemChange(w,a)});return(0,y.toDisposable)(()=>{r.dispose(),this._linkProvider.delete(v),this._registeredSchemes.delete(v),this._fsProvider.delete(w),this._proxy.$unregisterProvider(w)})}static _asIStat(f){const{type:v,ctime:S,mtime:P,size:w,permissions:s}=f;return{type:v,ctime:S,mtime:P,size:w,permissions:s}}$stat(f,v){return Promise.resolve(this._getFsProvider(f).stat(g.URI.revive(v))).then(S=>c._asIStat(S))}$readdir(f,v){return Promise.resolve(this._getFsProvider(f).readDirectory(g.URI.revive(v)))}$readFile(f,v){return Promise.resolve(this._getFsProvider(f).readFile(g.URI.revive(v))).then(S=>D.VSBuffer.wrap(S))}$writeFile(f,v,S,P){return Promise.resolve(this._getFsProvider(f).writeFile(g.URI.revive(v),S.buffer,P))}$delete(f,v,S){return Promise.resolve(this._getFsProvider(f).delete(g.URI.revive(v),S))}$rename(f,v,S,P){return Promise.resolve(this._getFsProvider(f).rename(g.URI.revive(v),g.URI.revive(S),P))}$copy(f,v,S,P){const w=this._getFsProvider(f);if(!w.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(w.copy(g.URI.revive(v),g.URI.revive(S),P))}$mkdir(f,v){return Promise.resolve(this._getFsProvider(f).createDirectory(g.URI.revive(v)))}$watch(f,v,S,P){const w=this._getFsProvider(f).watch(g.URI.revive(S),P);this._watches.set(v,w)}$unwatch(f,v){const S=this._watches.get(v);S&&(S.dispose(),this._watches.delete(v))}$open(f,v,S){const P=this._getFsProvider(f);if(!P.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(P.open(g.URI.revive(v),S))}$close(f,v){const S=this._getFsProvider(f);if(!S.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(S.close(v))}$read(f,v,S,P){const w=this._getFsProvider(f);if(!w.read)throw new Error('FileSystemProvider does not implement "read"');const s=D.VSBuffer.alloc(P);return Promise.resolve(w.read(v,S,s.buffer,0,P)).then(r=>s.slice(0,r))}$write(f,v,S,P){const w=this._getFsProvider(f);if(!w.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(w.write(v,S,P.buffer,0,P.byteLength))}_getFsProvider(f){const v=this._fsProvider.get(f);if(!v){const S=new Error;throw S.name="ENOPRO",S.message="no provider",S}return v}}e.ExtHostFileSystem=c}),define(fe[69],me([0,1,5,43,7,22,4,14,45]),function(Y,e,g,L,y,C,i,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let D=class xt{constructor(I,c){const p=I.getProxy(g.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(f){return p.$stat(f).catch(xt._handleError)},readDirectory(f){return p.$readdir(f).catch(xt._handleError)},createDirectory(f){return p.$mkdir(f).catch(xt._handleError)},async readFile(f){return p.$readFile(f).then(v=>v.buffer).catch(xt._handleError)},writeFile(f,v){return p.$writeFile(f,C.VSBuffer.wrap(v)).catch(xt._handleError)},delete(f,v){return p.$delete(f,{recursive:!1,useTrash:!1,...v}).catch(xt._handleError)},rename(f,v,S){return p.$rename(f,v,{overwrite:!1,...S}).catch(xt._handleError)},copy(f,v,S){return p.$copy(f,v,{overwrite:!1,...S}).catch(xt._handleError)},isWritableFileSystem(f){const v=c.getCapabilities(f);if(typeof v=="number")return!(v&2048)}})}static _handleError(I){if(!(I instanceof Error))throw new y.FileSystemError(String(I));if(I.name==="ENOPRO")throw y.FileSystemError.Unavailable(I.message);switch(I.name){case L.FileSystemProviderErrorCode.FileExists:throw y.FileSystemError.FileExists(I.message);case L.FileSystemProviderErrorCode.FileNotFound:throw y.FileSystemError.FileNotFound(I.message);case L.FileSystemProviderErrorCode.FileNotADirectory:throw y.FileSystemError.FileNotADirectory(I.message);case L.FileSystemProviderErrorCode.FileIsADirectory:throw y.FileSystemError.FileIsADirectory(I.message);case L.FileSystemProviderErrorCode.NoPermissions:throw y.FileSystemError.NoPermissions(I.message);case L.FileSystemProviderErrorCode.Unavailable:throw y.FileSystemError.Unavailable(I.message);default:throw new y.FileSystemError(I.message,I.name)}}};D=Ve([$e(0,k.IExtHostRpcService),$e(1,_.IExtHostFileSystemInfo)],D),e.ExtHostConsumerFileSystem=D,e.IExtHostConsumerFileSystem=(0,i.createDecorator)("IExtHostConsumerFileSystem")}),define(fe[242],me([0,1,2,40]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class y{constructor(i,k,_,D){this._extHostNotebooks=k,this._textDocumentsAndEditors=_,this._commands=D;const T=new L.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new L.ApiCommandArgument("showOptions","Show Options",I=>!0,I=>I),new L.ApiCommandArgument("resource","Interactive resource Uri",I=>!0,I=>I),new L.ApiCommandArgument("controllerId","Notebook controller Id",I=>!0,I=>I),new L.ApiCommandArgument("title","Interactive editor title",I=>!0,I=>I)],new L.ApiCommandResult("Notebook and input URI",I=>{if(I.notebookEditorId!==void 0){const c=this._extHostNotebooks.getEditorById(I.notebookEditorId);return{notebookUri:g.URI.revive(I.notebookUri),inputUri:g.URI.revive(I.inputUri),notebookEditor:c.apiEditor}}return{notebookUri:g.URI.revive(I.notebookUri),inputUri:g.URI.revive(I.inputUri)}}));this._commands.registerApiCommand(T)}$willAddInteractiveDocument(i,k,_,D){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:k,lines:[""],languageId:_,uri:i,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(g.URI.revive(D))?.apiNotebook}]})}$willRemoveInteractiveDocument(i,k){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[i]})}}e.ExtHostInteractive=y}),define(fe[243],me([0,1,6,5]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class y{constructor(i){this._handlePool=0,this._proxy=i.getProxy(L.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(i){const k=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(k,i),(0,g.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(k)})}}e.ExtHostLabelService=y}),define(fe[244],me([0,1,2,25,17,7,5,8,42,15,13,145,6,111,77,88,47,18,3]),function(Y,e,g,L,y,C,i,k,_,D,T,I,c,p,f,v,S,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class s{constructor(G,ee){this._documents=G,this._provider=ee}async provideDocumentSymbols(G,ee){const ie=this._documents.getDocument(G),le=await this._provider.provideDocumentSymbols(ie,ee);if(!(0,D.isFalsyOrEmpty)(le))return le[0]instanceof C.DocumentSymbol?le.map(y.DocumentSymbol.from):s._asDocumentSymbolTree(le)}static _asDocumentSymbolTree(G){G=G.slice(0).sort((le,Z)=>{let re=le.location.range.start.compareTo(Z.location.range.start);return re===0&&(re=Z.location.range.end.compareTo(le.location.range.end)),re});const ee=[],ie=[];for(const le of G){const Z={name:le.name||"!!MISSING: name!!",kind:y.SymbolKind.from(le.kind),tags:le.tags?.map(y.SymbolTag.from)||[],detail:"",containerName:le.containerName,range:y.Range.from(le.location.range),selectionRange:y.Range.from(le.location.range),children:[]};for(;;){if(ie.length===0){ie.push(Z),ee.push(Z);break}const re=ie[ie.length-1];if(_.Range.containsRange(re.range,Z.range)&&!_.Range.equalsRange(re.range,Z.range)){re.children&&re.children.push(Z),ie.push(Z);break}ie.pop()}}return ee}}class r{constructor(G,ee,ie){this._documents=G,this._commands=ee,this._provider=ie,this._cache=new v.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(G,ee){const ie=this._documents.getDocument(G),le=await this._provider.provideCodeLenses(ie,ee);if(!le||ee.isCancellationRequested)return;const Z=this._cache.add(le),re=new c.DisposableStore;this._disposables.set(Z,re);const pe={cacheId:Z,lenses:[]};for(let Me=0;Me<le.length;Me++)pe.lenses.push({cacheId:[Z,Me],range:y.Range.from(le[Me].range),command:this._commands.toInternal(le[Me].command,re)});return pe}async resolveCodeLens(G,ee){const ie=G.cacheId&&this._cache.get(...G.cacheId);if(!ie)return;let le;if(typeof this._provider.resolveCodeLens!="function"||ie.isResolved?le=ie:le=await this._provider.resolveCodeLens(ie,ee),le||(le=ie),ee.isCancellationRequested)return;const Z=G.cacheId&&this._disposables.get(G.cacheId[0]);if(!!Z)return G.command=this._commands.toInternal(le.command??r._badCmd,Z),G}releaseCodeLenses(G){this._disposables.get(G)?.dispose(),this._disposables.delete(G),this._cache.delete(G)}}r._badCmd={command:"missing",title:"!!MISSING: command!!"};function m(He){return Array.isArray(He)?He.map(y.DefinitionLink.from):He?[y.DefinitionLink.from(He)]:[]}class a{constructor(G,ee){this._documents=G,this._provider=ee}async provideDefinition(G,ee,ie){const le=this._documents.getDocument(G),Z=y.Position.to(ee),re=await this._provider.provideDefinition(le,Z,ie);return m(re)}}class b{constructor(G,ee){this._documents=G,this._provider=ee}async provideDeclaration(G,ee,ie){const le=this._documents.getDocument(G),Z=y.Position.to(ee),re=await this._provider.provideDeclaration(le,Z,ie);return m(re)}}class n{constructor(G,ee){this._documents=G,this._provider=ee}async provideImplementation(G,ee,ie){const le=this._documents.getDocument(G),Z=y.Position.to(ee),re=await this._provider.provideImplementation(le,Z,ie);return m(re)}}class t{constructor(G,ee){this._documents=G,this._provider=ee}async provideTypeDefinition(G,ee,ie){const le=this._documents.getDocument(G),Z=y.Position.to(ee),re=await this._provider.provideTypeDefinition(le,Z,ie);return m(re)}}class l{constructor(G,ee){this._documents=G,this._provider=ee}async provideHover(G,ee,ie){const le=this._documents.getDocument(G),Z=y.Position.to(ee),re=await this._provider.provideHover(le,Z,ie);if(!(!re||(0,D.isFalsyOrEmpty)(re.contents)))return re.range||(re.range=le.getWordRangeAtPosition(Z)),re.range||(re.range=new C.Range(Z,Z)),y.Hover.from(re)}}class d{constructor(G,ee){this._documents=G,this._provider=ee}async provideEvaluatableExpression(G,ee,ie){const le=this._documents.getDocument(G),Z=y.Position.to(ee),re=await this._provider.provideEvaluatableExpression(le,Z,ie);if(re)return y.EvaluatableExpression.from(re)}}class o{constructor(G,ee){this._documents=G,this._provider=ee}async provideInlineValues(G,ee,ie,le){const Z=this._documents.getDocument(G),re=await this._provider.provideInlineValues(Z,y.Range.to(ee),y.InlineValueContext.to(ie),le);if(Array.isArray(re))return re.map(pe=>y.InlineValue.from(pe))}}class h{constructor(G,ee){this._documents=G,this._provider=ee}async provideDocumentHighlights(G,ee,ie){const le=this._documents.getDocument(G),Z=y.Position.to(ee),re=await this._provider.provideDocumentHighlights(le,Z,ie);if(Array.isArray(re))return re.map(y.DocumentHighlight.from)}}class u{constructor(G,ee){this._documents=G,this._provider=ee}async provideLinkedEditingRanges(G,ee,ie){const le=this._documents.getDocument(G),Z=y.Position.to(ee),re=await this._provider.provideLinkedEditingRanges(le,Z,ie);if(re&&Array.isArray(re.ranges))return{ranges:(0,D.coalesce)(re.ranges.map(y.Range.from)),wordPattern:re.wordPattern}}}class E{constructor(G,ee){this._documents=G,this._provider=ee}async provideReferences(G,ee,ie,le){const Z=this._documents.getDocument(G),re=y.Position.to(ee),pe=await this._provider.provideReferences(Z,re,ie,le);if(Array.isArray(pe))return pe.map(y.location.from)}}class A{constructor(G,ee,ie,le,Z,re,pe){this._documents=G,this._commands=ee,this._diagnostics=ie,this._provider=le,this._logService=Z,this._extension=re,this._apiDeprecation=pe,this._cache=new v.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(G,ee,ie,le){const Z=this._documents.getDocument(G),re=I.Selection.isISelection(ee)?y.Selection.to(ee):y.Range.to(ee),pe=[];for(const lt of this._diagnostics.getDiagnostics(G))if(re.intersection(lt.range)&&pe.push(lt)>A._maxCodeActionsPerFile)break;const Me={diagnostics:pe,only:ie.only?new C.CodeActionKind(ie.only):void 0,triggerKind:y.CodeActionTriggerKind.to(ie.trigger)},je=await this._provider.provideCodeActions(Z,re,Me,le);if(!(0,D.isNonEmptyArray)(je)||le.isCancellationRequested)return;const Ke=this._cache.add(je),Ze=new c.DisposableStore;this._disposables.set(Ke,Ze);const rt=[];for(let lt=0;lt<je.length;lt++){const ye=je[lt];!ye||(A._isCommand(ye)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),rt.push({_isSynthetic:!0,title:ye.title,command:this._commands.toInternal(ye,Ze)})):(Me.only&&(ye.kind?Me.only.contains(ye.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Me.only.value} 'requested but returned code action is of kind '${ye.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Me.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),rt.push({cacheId:[Ke,lt],title:ye.title,command:ye.command&&this._commands.toInternal(ye.command,Ze),diagnostics:ye.diagnostics&&ye.diagnostics.map(y.Diagnostic.from),edit:ye.edit&&y.WorkspaceEdit.from(ye.edit),kind:ye.kind&&ye.kind.value,isPreferred:ye.isPreferred,disabled:ye.disabled?.reason})))}return{cacheId:Ke,actions:rt}}async resolveCodeAction(G,ee){const[ie,le]=G,Z=this._cache.get(ie,le);if(!Z||A._isCommand(Z)||!this._provider.resolveCodeAction)return;const re=await this._provider.resolveCodeAction(Z,ee)??Z;return re?.edit?y.WorkspaceEdit.from(re.edit):void 0}releaseCodeActions(G){this._disposables.get(G)?.dispose(),this._disposables.delete(G),this._cache.delete(G)}static _isCommand(G){return typeof G.command=="string"&&typeof G.title=="string"}}A._maxCodeActionsPerFile=1e3;class R{constructor(G,ee){this._documents=G,this._provider=ee}async provideDocumentFormattingEdits(G,ee,ie){const le=this._documents.getDocument(G),Z=await this._provider.provideDocumentFormattingEdits(le,ee,ie);if(Array.isArray(Z))return Z.map(y.TextEdit.from)}}class B{constructor(G,ee){this._documents=G,this._provider=ee}async provideDocumentRangeFormattingEdits(G,ee,ie,le){const Z=this._documents.getDocument(G),re=y.Range.to(ee),pe=await this._provider.provideDocumentRangeFormattingEdits(Z,re,ie,le);if(Array.isArray(pe))return pe.map(y.TextEdit.from)}}class x{constructor(G,ee){this._documents=G,this._provider=ee,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(G,ee,ie,le,Z){const re=this._documents.getDocument(G),pe=y.Position.to(ee),Me=await this._provider.provideOnTypeFormattingEdits(re,pe,ie,le,Z);if(Array.isArray(Me))return Me.map(y.TextEdit.from)}}class F{constructor(G,ee){this._provider=G,this._logService=ee,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(G,ee){const ie=i.IdObject.mixin({symbols:[]}),le=await this._provider.provideWorkspaceSymbols(G,ee);if((0,D.isNonEmptyArray)(le))for(const Z of le){if(!Z)continue;if(!Z.name){this._logService.warn("INVALID SymbolInformation, lacks name",Z);continue}const re=i.IdObject.mixin(y.WorkspaceSymbol.from(Z));this._symbolCache.set(re._id,Z),ie.symbols.push(re)}return ie.symbols.length>0&&this._resultCache.set(ie._id,[ie.symbols[0]._id,ie.symbols[ie.symbols.length-1]._id]),ie}async resolveWorkspaceSymbol(G,ee){if(typeof this._provider.resolveWorkspaceSymbol!="function")return G;const ie=this._symbolCache.get(G._id);if(ie){const le=await this._provider.resolveWorkspaceSymbol(ie,ee);return le&&(0,L.mixin)(G,y.WorkspaceSymbol.from(le),!0)}}releaseWorkspaceSymbols(G){const ee=this._resultCache.get(G);if(ee){for(let[ie,le]=ee;ie<=le;ie++)this._symbolCache.delete(ie);this._resultCache.delete(G)}}}class ${constructor(G,ee,ie){this._documents=G,this._provider=ee,this._logService=ie}static supportsResolving(G){return typeof G.prepareRename=="function"}async provideRenameEdits(G,ee,ie,le){const Z=this._documents.getDocument(G),re=y.Position.to(ee);try{const pe=await this._provider.provideRenameEdits(Z,re,ie,le);return pe?y.WorkspaceEdit.from(pe):void 0}catch(pe){const Me=$._asMessage(pe);return Me?{rejectReason:Me,edits:void 0}:Promise.reject(pe)}}async resolveRenameLocation(G,ee,ie){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const le=this._documents.getDocument(G),Z=y.Position.to(ee);try{const re=await this._provider.prepareRename(le,Z,ie);let pe,Me;if(C.Range.isRange(re)?(pe=re,Me=le.getText(re)):(0,T.isObject)(re)&&(pe=re.range,Me=re.placeholder),!pe||!Me)return;if(pe.start.line>Z.line||pe.end.line<Z.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:y.Range.from(pe),text:Me}}catch(re){const pe=$._asMessage(re);return pe?{rejectReason:pe,range:void 0,text:void 0}:Promise.reject(re)}}static _asMessage(G){return typeof G=="string"?G:G instanceof Error&&typeof G.message=="string"?G.message:void 0}}class M{constructor(G,ee){this.resultId=G,this.tokens=ee}}class H{constructor(G,ee){this._documents=G,this._provider=ee,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(G,ee,ie){const le=this._documents.getDocument(G),Z=ee!==0?this._previousResults.get(ee):null;let re=typeof Z?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(le,Z.resultId,ie):await this._provider.provideDocumentSemanticTokens(le,ie);return Z&&this._previousResults.delete(ee),re?(re=H._fixProvidedSemanticTokens(re),this._send(H._convertToEdits(Z,re),re)):null}async releaseDocumentSemanticColoring(G){this._previousResults.delete(G)}static _fixProvidedSemanticTokens(G){return H._isSemanticTokens(G)?H._isCorrectSemanticTokens(G)?G:new C.SemanticTokens(new Uint32Array(G.data),G.resultId):H._isSemanticTokensEdits(G)?H._isCorrectSemanticTokensEdits(G)?G:new C.SemanticTokensEdits(G.edits.map(ee=>new C.SemanticTokensEdit(ee.start,ee.deleteCount,ee.data?new Uint32Array(ee.data):ee.data)),G.resultId):G}static _isSemanticTokens(G){return G&&!!G.data}static _isCorrectSemanticTokens(G){return G.data instanceof Uint32Array}static _isSemanticTokensEdits(G){return G&&Array.isArray(G.edits)}static _isCorrectSemanticTokensEdits(G){for(const ee of G.edits)if(!(ee.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(G,ee){if(!H._isSemanticTokens(ee)||!G||!G.tokens)return ee;const ie=G.tokens,le=ie.length,Z=ee.data,re=Z.length;let pe=0;const Me=Math.min(le,re);for(;pe<Me&&ie[pe]===Z[pe];)pe++;if(pe===le&&pe===re)return new C.SemanticTokensEdits([],ee.resultId);let je=0;const Ke=Me-pe;for(;je<Ke&&ie[le-je-1]===Z[re-je-1];)je++;return new C.SemanticTokensEdits([{start:pe,deleteCount:le-pe-je,data:Z.subarray(pe,re-je)}],ee.resultId)}_send(G,ee){if(H._isSemanticTokens(G)){const ie=this._nextResultId++;return this._previousResults.set(ie,new M(G.resultId,G.data)),(0,p.encodeSemanticTokensDto)({id:ie,type:"full",data:G.data})}if(H._isSemanticTokensEdits(G)){const ie=this._nextResultId++;return H._isSemanticTokens(ee)?this._previousResults.set(ie,new M(ee.resultId,ee.data)):this._previousResults.set(ie,new M(G.resultId)),(0,p.encodeSemanticTokensDto)({id:ie,type:"delta",deltas:(G.edits||[]).map(le=>({start:le.start,deleteCount:le.deleteCount,data:le.data}))})}return null}}e.DocumentSemanticTokensAdapter=H;class N{constructor(G,ee){this._documents=G,this._provider=ee}async provideDocumentRangeSemanticTokens(G,ee,ie){const le=this._documents.getDocument(G),Z=await this._provider.provideDocumentRangeSemanticTokens(le,y.Range.to(ee),ie);return Z?this._send(Z):null}_send(G){return(0,p.encodeSemanticTokensDto)({id:0,type:"full",data:G.data})}}e.DocumentRangeSemanticTokensAdapter=N;class U{constructor(G,ee,ie,le,Z){this._documents=G,this._commands=ee,this._provider=ie,this._apiDeprecation=le,this._extension=Z,this._cache=new v.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(G){return typeof G.resolveCompletionItem=="function"}async provideCompletionItems(G,ee,ie,le){const Z=this._documents.getDocument(G),re=y.Position.to(ee),pe=Z.getWordRangeAtPosition(re)||new C.Range(re,re),Me=pe.with({end:re}),je=new S.StopWatch(!0),Ke=await this._provider.provideCompletionItems(Z,re,le,y.CompletionContext.to(ie));if(!Ke||le.isCancellationRequested)return;const Ze=Array.isArray(Ke)?new C.CompletionList(Ke):Ke,rt=U.supportsResolving(this._provider)?this._cache.add(Ze.items):this._cache.add([]),lt=new c.DisposableStore;this._disposables.set(rt,lt);const ye=[],at={x:rt,b:ye,a:{replace:y.Range.from(pe),insert:y.Range.from(Me)},c:Ze.isIncomplete||void 0,d:je.elapsed()};for(let J=0;J<Ze.items.length;J++){const ne=Ze.items[J],_e=this._convertCompletionItem(ne,[rt,J],Me,pe);ye.push(_e)}return at}async resolveCompletionItem(G,ee){if(typeof this._provider.resolveCompletionItem!="function")return;const ie=this._cache.get(...G);if(!ie)return;const le=await this._provider.resolveCompletionItem(ie,ee);if(!!le)return this._convertCompletionItem(le,G)}releaseCompletionItems(G){this._disposables.get(G)?.dispose(),this._disposables.delete(G),this._cache.delete(G)}_convertCompletionItem(G,ee,ie,le){const Z=this._disposables.get(ee[0]);if(!Z)throw Error("DisposableStore is missing...");const re={x:ee,a:G.label,b:G.kind!==void 0?y.CompletionItemKind.from(G.kind):void 0,n:G.tags&&G.tags.map(y.CompletionItemTag.from),c:G.detail,d:typeof G.documentation=="undefined"?void 0:y.MarkdownString.fromStrict(G.documentation),e:G.sortText!==G.label?G.sortText:void 0,f:G.filterText!==G.label?G.filterText:void 0,g:G.preselect||void 0,i:G.keepWhitespace?1:0,k:G.commitCharacters,l:G.additionalTextEdits&&G.additionalTextEdits.map(y.TextEdit.from),m:this._commands.toInternal(G.command,Z)};G.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),re.h=G.textEdit.newText):typeof G.insertText=="string"?re.h=G.insertText:G.insertText instanceof C.SnippetString&&(re.h=G.insertText.value,re.i|=4);let pe;return G.textEdit?pe=G.textEdit.range:G.range&&(pe=G.range),C.Range.isRange(pe)?re.j=y.Range.from(pe):pe&&(!ie?.isEqual(pe.inserting)||!le?.isEqual(pe.replacing))&&(re.j={insert:y.Range.from(pe.inserting),replace:y.Range.from(pe.replacing)}),re}}class V{constructor(G,ee,ie){this._documents=G,this._provider=ee,this._commands=ie,this._cache=new v.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(G,ee,ie,le){const Z=this._documents.getDocument(G),re=y.Position.to(ee),pe=await this._provider.provideInlineCompletionItems(Z,re,{selectedCompletionInfo:ie.selectedSuggestionInfo?{range:y.Range.to(ie.selectedSuggestionInfo.range),text:ie.selectedSuggestionInfo.text}:void 0,triggerKind:ie.triggerKind},le);if(!pe||le.isCancellationRequested)return;const Me=(0,T.isArray)(pe)?{items:pe}:pe,je=this._cache.add(Me.items);let Ke;return{pid:je,items:Me.items.map((Ze,rt)=>{let lt;return Ze.command&&(Ke||(Ke=new c.DisposableStore,this._disposables.set(je,Ke)),lt=this._commands.toInternal(Ze.command,Ke)),{text:Ze.text,range:Ze.range?y.Range.from(Ze.range):void 0,command:lt,idx:rt}})}}disposeCompletions(G){this._cache.delete(G);const ee=this._disposables.get(G);ee&&ee.clear(),this._disposables.delete(G)}handleDidShowCompletionItem(G,ee){const ie=this._cache.get(G,ee);ie&&O.get(this._provider).fireOnDidShowCompletionItem({completionItem:ie})}}class O{constructor(){this._onDidShowCompletionItemEmitter=new w.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(G){let ee=O.map.get(G);return ee||(ee=new O,O.map.set(G,ee)),ee}fireOnDidShowCompletionItem(G){this._onDidShowCompletionItemEmitter.fire(G)}}e.InlineCompletionController=O,O.map=new WeakMap;class W{constructor(G,ee){this._documents=G,this._provider=ee,this._cache=new v.Cache("SignatureHelp")}async provideSignatureHelp(G,ee,ie,le){const Z=this._documents.getDocument(G),re=y.Position.to(ee),pe=this.reviveContext(ie),Me=await this._provider.provideSignatureHelp(Z,re,le,pe);if(Me){const je=this._cache.add([Me]);return{...y.SignatureHelp.from(Me),id:je}}}reviveContext(G){let ee;if(G.activeSignatureHelp){const ie=y.SignatureHelp.to(G.activeSignatureHelp),le=this._cache.get(G.activeSignatureHelp.id,0);le?(ee=le,ee.activeSignature=ie.activeSignature,ee.activeParameter=ie.activeParameter):ee=ie}return{...G,activeSignatureHelp:ee}}releaseSignatureHelp(G){this._cache.delete(G)}}class j{constructor(G,ee){this._documents=G,this._provider=ee}async provideInlayHints(G,ee,ie){const le=this._documents.getDocument(G),Z=await this._provider.provideInlayHints(le,y.Range.to(ee),ie);return Z?{hints:Z.map(y.InlayHint.from)}:void 0}}class X{constructor(G,ee){this._documents=G,this._provider=ee,this._cache=new v.Cache("DocumentLink")}async provideLinks(G,ee){const ie=this._documents.getDocument(G),le=await this._provider.provideDocumentLinks(ie,ee);if(!(!Array.isArray(le)||le.length===0)&&!ee.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:le.filter(X._validateLink).map(y.DocumentLink.from)};{const Z=this._cache.add(le),re={links:[],id:Z};for(let pe=0;pe<le.length;pe++){if(!X._validateLink(le[pe]))continue;const Me=y.DocumentLink.from(le[pe]);Me.cacheId=[Z,pe],re.links.push(Me)}return re}}}static _validateLink(G){return G.target&&G.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(G,ee){if(typeof this._provider.resolveDocumentLink!="function")return;const ie=this._cache.get(...G);if(!ie)return;const le=await this._provider.resolveDocumentLink(ie,ee);if(!(!le||!X._validateLink(le)))return y.DocumentLink.from(le)}releaseLinks(G){this._cache.delete(G)}}class Q{constructor(G,ee){this._documents=G,this._provider=ee}async provideColors(G,ee){const ie=this._documents.getDocument(G),le=await this._provider.provideDocumentColors(ie,ee);return Array.isArray(le)?le.map(re=>({color:y.Color.from(re.color),range:y.Range.from(re.range)})):[]}async provideColorPresentations(G,ee,ie){const le=this._documents.getDocument(G),Z=y.Range.to(ee.range),re=y.Color.to(ee.color),pe=await this._provider.provideColorPresentations(re,{document:le,range:Z},ie);if(!!Array.isArray(pe))return pe.map(y.ColorPresentation.from)}}class de{constructor(G,ee){this._documents=G,this._provider=ee}async provideFoldingRanges(G,ee,ie){const le=this._documents.getDocument(G),Z=await this._provider.provideFoldingRanges(le,ee,ie);if(!!Array.isArray(Z))return Z.map(y.FoldingRange.from)}}class Se{constructor(G,ee,ie){this._documents=G,this._provider=ee,this._logService=ie}async provideSelectionRanges(G,ee,ie){const le=this._documents.getDocument(G),Z=ee.map(y.Position.to),re=await this._provider.provideSelectionRanges(le,Z,ie);if(!(0,D.isNonEmptyArray)(re))return[];if(re.length!==Z.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const pe=[];for(let Me=0;Me<Z.length;Me++){const je=[];pe.push(je);let Ke=Z[Me],Ze=re[Me];for(;;){if(!Ze.range.contains(Ke))throw new Error("INVALID selection range, must contain the previous range");if(je.push(y.SelectionRange.from(Ze)),!Ze.parent)break;Ke=Ze.range,Ze=Ze.parent}}return pe}}class De{constructor(G,ee){this._documents=G,this._provider=ee,this._idPool=new f.IdGenerator(""),this._cache=new Map}async prepareSession(G,ee,ie){const le=this._documents.getDocument(G),Z=y.Position.to(ee),re=await this._provider.prepareCallHierarchy(le,Z,ie);if(!re)return;const pe=this._idPool.nextId();return this._cache.set(pe,new Map),Array.isArray(re)?re.map(Me=>this._cacheAndConvertItem(pe,Me)):[this._cacheAndConvertItem(pe,re)]}async provideCallsTo(G,ee,ie){const le=this._itemFromCache(G,ee);if(!le)throw new Error("missing call hierarchy item");const Z=await this._provider.provideCallHierarchyIncomingCalls(le,ie);if(!!Z)return Z.map(re=>({from:this._cacheAndConvertItem(G,re.from),fromRanges:re.fromRanges.map(pe=>y.Range.from(pe))}))}async provideCallsFrom(G,ee,ie){const le=this._itemFromCache(G,ee);if(!le)throw new Error("missing call hierarchy item");const Z=await this._provider.provideCallHierarchyOutgoingCalls(le,ie);if(!!Z)return Z.map(re=>({to:this._cacheAndConvertItem(G,re.to),fromRanges:re.fromRanges.map(pe=>y.Range.from(pe))}))}releaseSession(G){this._cache.delete(G)}_cacheAndConvertItem(G,ee){const ie=this._cache.get(G),le=y.CallHierarchyItem.from(ee,G,ie.size.toString(36));return ie.set(le._itemId,ee),le}_itemFromCache(G,ee){return this._cache.get(G)?.get(ee)}}class Pe{constructor(G,ee){this._documents=G,this._provider=ee,this._idPool=new f.IdGenerator(""),this._cache=new Map}async prepareSession(G,ee,ie){const le=this._documents.getDocument(G),Z=y.Position.to(ee),re=await this._provider.prepareTypeHierarchy(le,Z,ie);if(!re)return;const pe=this._idPool.nextId();return this._cache.set(pe,new Map),Array.isArray(re)?re.map(Me=>this._cacheAndConvertItem(pe,Me)):[this._cacheAndConvertItem(pe,re)]}async provideSupertypes(G,ee,ie){const le=this._itemFromCache(G,ee);if(!le)throw new Error("missing type hierarchy item");const Z=await this._provider.provideTypeHierarchySupertypes(le,ie);if(!!Z)return Z.map(re=>this._cacheAndConvertItem(G,re))}async provideSubtypes(G,ee,ie){const le=this._itemFromCache(G,ee);if(!le)throw new Error("missing type hierarchy item");const Z=await this._provider.provideTypeHierarchySubtypes(le,ie);if(!!Z)return Z.map(re=>this._cacheAndConvertItem(G,re))}releaseSession(G){this._cache.delete(G)}_cacheAndConvertItem(G,ee){const ie=this._cache.get(G),le=y.TypeHierarchyItem.from(ee,G,ie.size.toString(36));return ie.set(le._itemId,ee),le}_itemFromCache(G,ee){return this._cache.get(G)?.get(ee)}}class Be{constructor(G,ee){this.adapter=G,this.extension=ee}}class We{constructor(G,ee,ie,le,Z,re,pe){this._adapter=new Map,this._uriTransformer=ee,this._proxy=G.getProxy(i.MainContext.MainThreadLanguageFeatures),this._documents=ie,this._commands=le,this._diagnostics=Z,this._logService=re,this._apiDeprecation=pe}_transformDocumentSelector(G){return y.DocumentSelector.from(G,this._uriTransformer)}_createDisposable(G){return new C.Disposable(()=>{this._adapter.delete(G),this._proxy.$unregister(G)})}_nextHandle(){return We._handlePool++}_withAdapter(G,ee,ie,le,Z=!1){const re=this._adapter.get(G);if(!re)return Promise.resolve(le);if(re.adapter instanceof ee){let pe;re.extension&&(pe=Date.now(),this._logService.trace(`[${re.extension.identifier.value}] INVOKE provider '${ee.name}'`));const Me=ie(re.adapter,re.extension),je=re.extension;return je&&Promise.resolve(Me).then(()=>this._logService.trace(`[${je.identifier.value}] provider DONE after ${Date.now()-pe}ms`),Ke=>{Z&&Ke instanceof P.CancellationError||(this._logService.error(`[${je.identifier.value}] provider FAILED`),this._logService.error(Ke))}),Me}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(G,ee){const ie=this._nextHandle();return this._adapter.set(ie,new Be(G,ee)),ie}static _extLabel(G){return G.displayName||G.name}registerDocumentSymbolProvider(G,ee,ie,le){const Z=this._addNewAdapter(new s(this._documents,ie),G),re=le&&le.label||We._extLabel(G);return this._proxy.$registerDocumentSymbolProvider(Z,this._transformDocumentSelector(ee),re),this._createDisposable(Z)}$provideDocumentSymbols(G,ee,ie){return this._withAdapter(G,s,le=>le.provideDocumentSymbols(g.URI.revive(ee),ie),void 0)}registerCodeLensProvider(G,ee,ie){const le=this._nextHandle(),Z=typeof ie.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(le,new Be(new r(this._documents,this._commands.converter,ie),G)),this._proxy.$registerCodeLensSupport(le,this._transformDocumentSelector(ee),Z);let re=this._createDisposable(le);if(Z!==void 0){const pe=ie.onDidChangeCodeLenses(Me=>this._proxy.$emitCodeLensEvent(Z));re=C.Disposable.from(re,pe)}return re}$provideCodeLenses(G,ee,ie){return this._withAdapter(G,r,le=>le.provideCodeLenses(g.URI.revive(ee),ie),void 0)}$resolveCodeLens(G,ee,ie){return this._withAdapter(G,r,le=>le.resolveCodeLens(ee,ie),void 0)}$releaseCodeLenses(G,ee){this._withAdapter(G,r,ie=>Promise.resolve(ie.releaseCodeLenses(ee)),void 0)}registerDefinitionProvider(G,ee,ie){const le=this._addNewAdapter(new a(this._documents,ie),G);return this._proxy.$registerDefinitionSupport(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideDefinition(G,ee,ie,le){return this._withAdapter(G,a,Z=>Z.provideDefinition(g.URI.revive(ee),ie,le),[])}registerDeclarationProvider(G,ee,ie){const le=this._addNewAdapter(new b(this._documents,ie),G);return this._proxy.$registerDeclarationSupport(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideDeclaration(G,ee,ie,le){return this._withAdapter(G,b,Z=>Z.provideDeclaration(g.URI.revive(ee),ie,le),[])}registerImplementationProvider(G,ee,ie){const le=this._addNewAdapter(new n(this._documents,ie),G);return this._proxy.$registerImplementationSupport(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideImplementation(G,ee,ie,le){return this._withAdapter(G,n,Z=>Z.provideImplementation(g.URI.revive(ee),ie,le),[])}registerTypeDefinitionProvider(G,ee,ie){const le=this._addNewAdapter(new t(this._documents,ie),G);return this._proxy.$registerTypeDefinitionSupport(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideTypeDefinition(G,ee,ie,le){return this._withAdapter(G,t,Z=>Z.provideTypeDefinition(g.URI.revive(ee),ie,le),[])}registerHoverProvider(G,ee,ie,le){const Z=this._addNewAdapter(new l(this._documents,ie),G);return this._proxy.$registerHoverProvider(Z,this._transformDocumentSelector(ee)),this._createDisposable(Z)}$provideHover(G,ee,ie,le){return this._withAdapter(G,l,Z=>Z.provideHover(g.URI.revive(ee),ie,le),void 0)}registerEvaluatableExpressionProvider(G,ee,ie,le){const Z=this._addNewAdapter(new d(this._documents,ie),G);return this._proxy.$registerEvaluatableExpressionProvider(Z,this._transformDocumentSelector(ee)),this._createDisposable(Z)}$provideEvaluatableExpression(G,ee,ie,le){return this._withAdapter(G,d,Z=>Z.provideEvaluatableExpression(g.URI.revive(ee),ie,le),void 0)}registerInlineValuesProvider(G,ee,ie,le){const Z=typeof ie.onDidChangeInlineValues=="function"?this._nextHandle():void 0,re=this._addNewAdapter(new o(this._documents,ie),G);this._proxy.$registerInlineValuesProvider(re,this._transformDocumentSelector(ee),Z);let pe=this._createDisposable(re);if(Z!==void 0){const Me=ie.onDidChangeInlineValues(je=>this._proxy.$emitInlineValuesEvent(Z));pe=C.Disposable.from(pe,Me)}return pe}$provideInlineValues(G,ee,ie,le,Z){return this._withAdapter(G,o,re=>re.provideInlineValues(g.URI.revive(ee),ie,le,Z),void 0)}registerDocumentHighlightProvider(G,ee,ie){const le=this._addNewAdapter(new h(this._documents,ie),G);return this._proxy.$registerDocumentHighlightProvider(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideDocumentHighlights(G,ee,ie,le){return this._withAdapter(G,h,Z=>Z.provideDocumentHighlights(g.URI.revive(ee),ie,le),void 0)}registerLinkedEditingRangeProvider(G,ee,ie){const le=this._addNewAdapter(new u(this._documents,ie),G);return this._proxy.$registerLinkedEditingRangeProvider(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideLinkedEditingRanges(G,ee,ie,le){return this._withAdapter(G,u,async Z=>{const re=await Z.provideLinkedEditingRanges(g.URI.revive(ee),ie,le);if(re)return{ranges:re.ranges,wordPattern:re.wordPattern?We._serializeRegExp(re.wordPattern):void 0}},void 0)}registerReferenceProvider(G,ee,ie){const le=this._addNewAdapter(new E(this._documents,ie),G);return this._proxy.$registerReferenceSupport(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideReferences(G,ee,ie,le,Z){return this._withAdapter(G,E,re=>re.provideReferences(g.URI.revive(ee),ie,le,Z),void 0)}registerCodeActionProvider(G,ee,ie,le){const Z=new c.DisposableStore,re=this._addNewAdapter(new A(this._documents,this._commands.converter,this._diagnostics,ie,this._logService,G,this._apiDeprecation),G);return this._proxy.$registerQuickFixSupport(re,this._transformDocumentSelector(ee),{providedKinds:le?.providedCodeActionKinds?.map(pe=>pe.value),documentation:le?.documentation?.map(pe=>({kind:pe.kind.value,command:this._commands.converter.toInternal(pe.command,Z)}))},We._extLabel(G),Boolean(ie.resolveCodeAction)),Z.add(this._createDisposable(re)),Z}$provideCodeActions(G,ee,ie,le,Z){return this._withAdapter(G,A,re=>re.provideCodeActions(g.URI.revive(ee),ie,le,Z),void 0)}$resolveCodeAction(G,ee,ie){return this._withAdapter(G,A,le=>le.resolveCodeAction(ee,ie),void 0)}$releaseCodeActions(G,ee){this._withAdapter(G,A,ie=>Promise.resolve(ie.releaseCodeActions(ee)),void 0)}registerDocumentFormattingEditProvider(G,ee,ie){const le=this._addNewAdapter(new R(this._documents,ie),G);return this._proxy.$registerDocumentFormattingSupport(le,this._transformDocumentSelector(ee),G.identifier,G.displayName||G.name),this._createDisposable(le)}$provideDocumentFormattingEdits(G,ee,ie,le){return this._withAdapter(G,R,Z=>Z.provideDocumentFormattingEdits(g.URI.revive(ee),ie,le),void 0)}registerDocumentRangeFormattingEditProvider(G,ee,ie){const le=this._addNewAdapter(new B(this._documents,ie),G);return this._proxy.$registerRangeFormattingSupport(le,this._transformDocumentSelector(ee),G.identifier,G.displayName||G.name),this._createDisposable(le)}$provideDocumentRangeFormattingEdits(G,ee,ie,le,Z){return this._withAdapter(G,B,re=>re.provideDocumentRangeFormattingEdits(g.URI.revive(ee),ie,le,Z),void 0)}registerOnTypeFormattingEditProvider(G,ee,ie,le){const Z=this._addNewAdapter(new x(this._documents,ie),G);return this._proxy.$registerOnTypeFormattingSupport(Z,this._transformDocumentSelector(ee),le,G.identifier),this._createDisposable(Z)}$provideOnTypeFormattingEdits(G,ee,ie,le,Z,re){return this._withAdapter(G,x,pe=>pe.provideOnTypeFormattingEdits(g.URI.revive(ee),ie,le,Z,re),void 0)}registerWorkspaceSymbolProvider(G,ee){const ie=this._addNewAdapter(new F(ee,this._logService),G);return this._proxy.$registerNavigateTypeSupport(ie),this._createDisposable(ie)}$provideWorkspaceSymbols(G,ee,ie){return this._withAdapter(G,F,le=>le.provideWorkspaceSymbols(ee,ie),{symbols:[]})}$resolveWorkspaceSymbol(G,ee,ie){return this._withAdapter(G,F,le=>le.resolveWorkspaceSymbol(ee,ie),void 0)}$releaseWorkspaceSymbols(G,ee){this._withAdapter(G,F,ie=>ie.releaseWorkspaceSymbols(ee),void 0)}registerRenameProvider(G,ee,ie){const le=this._addNewAdapter(new $(this._documents,ie,this._logService),G);return this._proxy.$registerRenameSupport(le,this._transformDocumentSelector(ee),$.supportsResolving(ie)),this._createDisposable(le)}$provideRenameEdits(G,ee,ie,le,Z){return this._withAdapter(G,$,re=>re.provideRenameEdits(g.URI.revive(ee),ie,le,Z),void 0)}$resolveRenameLocation(G,ee,ie,le){return this._withAdapter(G,$,Z=>Z.resolveRenameLocation(g.URI.revive(ee),ie,le),void 0)}registerDocumentSemanticTokensProvider(G,ee,ie,le){const Z=this._nextHandle(),re=typeof ie.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(Z,new Be(new H(this._documents,ie),G)),this._proxy.$registerDocumentSemanticTokensProvider(Z,this._transformDocumentSelector(ee),le,re);let pe=this._createDisposable(Z);if(re){const Me=ie.onDidChangeSemanticTokens(je=>this._proxy.$emitDocumentSemanticTokensEvent(re));pe=C.Disposable.from(pe,Me)}return pe}$provideDocumentSemanticTokens(G,ee,ie,le){return this._withAdapter(G,H,Z=>Z.provideDocumentSemanticTokens(g.URI.revive(ee),ie,le),null,!0)}$releaseDocumentSemanticTokens(G,ee){this._withAdapter(G,H,ie=>ie.releaseDocumentSemanticColoring(ee),void 0)}registerDocumentRangeSemanticTokensProvider(G,ee,ie,le){const Z=this._addNewAdapter(new N(this._documents,ie),G);return this._proxy.$registerDocumentRangeSemanticTokensProvider(Z,this._transformDocumentSelector(ee),le),this._createDisposable(Z)}$provideDocumentRangeSemanticTokens(G,ee,ie,le){return this._withAdapter(G,N,Z=>Z.provideDocumentRangeSemanticTokens(g.URI.revive(ee),ie,le),null,!0)}registerCompletionItemProvider(G,ee,ie,le){const Z=this._addNewAdapter(new U(this._documents,this._commands.converter,ie,this._apiDeprecation,G),G);return this._proxy.$registerSuggestSupport(Z,this._transformDocumentSelector(ee),le,U.supportsResolving(ie),`${G.identifier.value}(${le.join("")})`),this._createDisposable(Z)}$provideCompletionItems(G,ee,ie,le,Z){return this._withAdapter(G,U,re=>re.provideCompletionItems(g.URI.revive(ee),ie,le,Z),void 0)}$resolveCompletionItem(G,ee,ie){return this._withAdapter(G,U,le=>le.resolveCompletionItem(ee,ie),void 0)}$releaseCompletionItems(G,ee){this._withAdapter(G,U,ie=>ie.releaseCompletionItems(ee),void 0)}registerInlineCompletionsProvider(G,ee,ie){const le=this._addNewAdapter(new V(this._documents,ie,this._commands.converter),G);return this._proxy.$registerInlineCompletionsSupport(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideInlineCompletions(G,ee,ie,le,Z){return this._withAdapter(G,V,re=>re.provideInlineCompletions(g.URI.revive(ee),ie,le,Z),void 0)}$handleInlineCompletionDidShow(G,ee,ie){this._withAdapter(G,V,async le=>{le.handleDidShowCompletionItem(ee,ie)},void 0)}$freeInlineCompletionsList(G,ee){this._withAdapter(G,V,async ie=>{ie.disposeCompletions(ee)},void 0)}registerSignatureHelpProvider(G,ee,ie,le){const Z=Array.isArray(le)?{triggerCharacters:le,retriggerCharacters:[]}:le,re=this._addNewAdapter(new W(this._documents,ie),G);return this._proxy.$registerSignatureHelpProvider(re,this._transformDocumentSelector(ee),Z),this._createDisposable(re)}$provideSignatureHelp(G,ee,ie,le,Z){return this._withAdapter(G,W,re=>re.provideSignatureHelp(g.URI.revive(ee),ie,le,Z),void 0)}$releaseSignatureHelp(G,ee){this._withAdapter(G,W,ie=>ie.releaseSignatureHelp(ee),void 0)}registerInlayHintsProvider(G,ee,ie){const le=typeof ie.onDidChangeInlayHints=="function"?this._nextHandle():void 0,Z=this._addNewAdapter(new j(this._documents,ie),G);this._proxy.$registerInlayHintsProvider(Z,this._transformDocumentSelector(ee),le);let re=this._createDisposable(Z);if(le!==void 0){const pe=ie.onDidChangeInlayHints(Me=>this._proxy.$emitInlayHintsEvent(le));re=C.Disposable.from(re,pe)}return re}$provideInlayHints(G,ee,ie,le){return this._withAdapter(G,j,Z=>Z.provideInlayHints(g.URI.revive(ee),ie,le),void 0)}registerDocumentLinkProvider(G,ee,ie){const le=this._addNewAdapter(new X(this._documents,ie),G);return this._proxy.$registerDocumentLinkProvider(le,this._transformDocumentSelector(ee),typeof ie.resolveDocumentLink=="function"),this._createDisposable(le)}$provideDocumentLinks(G,ee,ie){return this._withAdapter(G,X,le=>le.provideLinks(g.URI.revive(ee),ie),void 0)}$resolveDocumentLink(G,ee,ie){return this._withAdapter(G,X,le=>le.resolveLink(ee,ie),void 0)}$releaseDocumentLinks(G,ee){this._withAdapter(G,X,ie=>ie.releaseLinks(ee),void 0)}registerColorProvider(G,ee,ie){const le=this._addNewAdapter(new Q(this._documents,ie),G);return this._proxy.$registerDocumentColorProvider(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideDocumentColors(G,ee,ie){return this._withAdapter(G,Q,le=>le.provideColors(g.URI.revive(ee),ie),[])}$provideColorPresentations(G,ee,ie,le){return this._withAdapter(G,Q,Z=>Z.provideColorPresentations(g.URI.revive(ee),ie,le),void 0)}registerFoldingRangeProvider(G,ee,ie){const le=this._nextHandle(),Z=typeof ie.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(le,new Be(new de(this._documents,ie),G)),this._proxy.$registerFoldingRangeProvider(le,this._transformDocumentSelector(ee),Z);let re=this._createDisposable(le);if(Z!==void 0){const pe=ie.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(Z));re=C.Disposable.from(re,pe)}return re}$provideFoldingRanges(G,ee,ie,le){return this._withAdapter(G,de,Z=>Z.provideFoldingRanges(g.URI.revive(ee),ie,le),void 0)}registerSelectionRangeProvider(G,ee,ie){const le=this._addNewAdapter(new Se(this._documents,ie,this._logService),G);return this._proxy.$registerSelectionRangeProvider(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideSelectionRanges(G,ee,ie,le){return this._withAdapter(G,Se,Z=>Z.provideSelectionRanges(g.URI.revive(ee),ie,le),[])}registerCallHierarchyProvider(G,ee,ie){const le=this._addNewAdapter(new De(this._documents,ie),G);return this._proxy.$registerCallHierarchyProvider(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$prepareCallHierarchy(G,ee,ie,le){return this._withAdapter(G,De,Z=>Promise.resolve(Z.prepareSession(g.URI.revive(ee),ie,le)),void 0)}$provideCallHierarchyIncomingCalls(G,ee,ie,le){return this._withAdapter(G,De,Z=>Z.provideCallsTo(ee,ie,le),void 0)}$provideCallHierarchyOutgoingCalls(G,ee,ie,le){return this._withAdapter(G,De,Z=>Z.provideCallsFrom(ee,ie,le),void 0)}$releaseCallHierarchy(G,ee){this._withAdapter(G,De,ie=>Promise.resolve(ie.releaseSession(ee)),void 0)}registerTypeHierarchyProvider(G,ee,ie){const le=this._addNewAdapter(new Pe(this._documents,ie),G);return this._proxy.$registerTypeHierarchyProvider(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$prepareTypeHierarchy(G,ee,ie,le){return this._withAdapter(G,Pe,Z=>Promise.resolve(Z.prepareSession(g.URI.revive(ee),ie,le)),void 0)}$provideTypeHierarchySupertypes(G,ee,ie,le){return this._withAdapter(G,Pe,Z=>Z.provideSupertypes(ee,ie,le),void 0)}$provideTypeHierarchySubtypes(G,ee,ie,le){return this._withAdapter(G,Pe,Z=>Z.provideSubtypes(ee,ie,le),void 0)}$releaseTypeHierarchy(G,ee){this._withAdapter(G,Pe,ie=>Promise.resolve(ie.releaseSession(ee)),void 0)}static _serializeRegExp(G){return{pattern:G.source,flags:(0,k.regExpFlags)(G)}}static _serializeIndentationRule(G){return{decreaseIndentPattern:We._serializeRegExp(G.decreaseIndentPattern),increaseIndentPattern:We._serializeRegExp(G.increaseIndentPattern),indentNextLinePattern:G.indentNextLinePattern?We._serializeRegExp(G.indentNextLinePattern):void 0,unIndentedLinePattern:G.unIndentedLinePattern?We._serializeRegExp(G.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(G){return{beforeText:We._serializeRegExp(G.beforeText),afterText:G.afterText?We._serializeRegExp(G.afterText):void 0,previousLineText:G.previousLineText?We._serializeRegExp(G.previousLineText):void 0,action:G.action}}static _serializeOnEnterRules(G){return G.map(We._serializeOnEnterRule)}setLanguageConfiguration(G,ee,ie){let{wordPattern:le}=ie;if(le&&(0,k.regExpLeadsToEndlessLoop)(le))throw new Error(`Invalid language configuration: wordPattern '${le}' is not allowed to match the empty string.`);le?this._documents.setWordDefinitionFor(ee,le):this._documents.setWordDefinitionFor(ee,void 0),ie.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",G,"Do not use."),ie.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",G,"Do not use.");const Z=this._nextHandle(),re={comments:ie.comments,brackets:ie.brackets,wordPattern:ie.wordPattern?We._serializeRegExp(ie.wordPattern):void 0,indentationRules:ie.indentationRules?We._serializeIndentationRule(ie.indentationRules):void 0,onEnterRules:ie.onEnterRules?We._serializeOnEnterRules(ie.onEnterRules):void 0,__electricCharacterSupport:ie.__electricCharacterSupport,__characterPairSupport:ie.__characterPairSupport};return this._proxy.$setLanguageConfiguration(Z,ee,re),this._createDisposable(Z)}$setWordDefinitions(G){for(const ee of G)this._documents.setWordDefinitionFor(ee.languageId,new RegExp(ee.regexSource,ee.regexFlags))}}e.ExtHostLanguageFeatures=We,We._handlePool=0}),define(fe[245],me([0,1,5,17,7,50,16,6]),function(Y,e,g,L,y,C,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class _{constructor(T,I,c,p){this._documents=I,this._commands=c,this._uriTransformer=p,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=T.getProxy(g.MainContext.MainThreadLanguages)}$acceptLanguageIds(T){this._languageIds=T}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(T,I){await this._proxy.$changeLanguage(T,I);const c=this._documents.getDocumentData(T);if(!c)throw new Error(`document '${T.toString}' NOT found`);return c.document}async tokenAtPosition(T,I){const c=T.version,p=L.Position.from(I),f=await this._proxy.$tokensAtPosition(T.uri,p),v={type:y.StandardTokenType.Other,range:T.getWordRangeAtPosition(I)??new y.Range(I.line,I.character,I.line,I.character)};if(!f)return v;const S={range:L.Range.to(f.range),type:L.TokenType.to(f.type)};return!S.range.contains(I)||c!==T.version?v:S}createLanguageStatusItem(T,I,c){const p=this._handlePool++,f=this._proxy,v=this._ids,S=`${T.identifier.value}/${I}`;if(v.has(S))throw new Error(`LanguageStatusItem with id '${I}' ALREADY exists`);v.add(S);const P={selector:c,id:I,name:T.displayName??T.name,severity:y.LanguageStatusSeverity.Information,command:void 0,text:"",detail:""};let w,s=new k.DisposableStore;const r=()=>{w?.dispose(),w=(0,i.disposableTimeout)(()=>{s.clear(),this._proxy.$setLanguageStatus(p,{id:S,name:P.name??T.displayName??T.name,source:T.displayName??T.name,selector:L.DocumentSelector.from(P.selector,this._uriTransformer),label:P.text,detail:P.detail??"",severity:P.severity===y.LanguageStatusSeverity.Error?C.default.Error:P.severity===y.LanguageStatusSeverity.Warning?C.default.Warning:C.default.Info,command:P.command&&this._commands.toInternal(P.command,s),accessibilityInfo:P.accessibilityInformation})},0)},m={dispose(){s.dispose(),w?.dispose(),f.$removeLanguageStatus(p),v.delete(S)},get id(){return P.id},get name(){return P.name},set name(a){P.name=a,r()},get selector(){return P.selector},set selector(a){P.selector=a,r()},get text(){return P.text},set text(a){P.text=a,r()},get detail(){return P.detail},set detail(a){P.detail=a,r()},get severity(){return P.severity},set severity(a){P.severity=a,r()},get accessibilityInformation(){return P.accessibilityInformation},set accessibilityInformation(a){P.accessibilityInformation=a,r()},get command(){return P.command},set command(a){P.command=a,r()}};return r(),m}}e.ExtHostLanguages=_}),define(fe[132],me([0,1,11,5,26,14,3]),function(Y,e,g,L,y,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let k=class extends g.AbstractLoggerService{constructor(T,I){const c=new i.Emitter;super(I.logLevel,c.event);this._proxy=T.getProxy(L.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(c)}$setLevel(T){this._onDidChangeLogLevel.fire(T)}doCreateLogger(T,I,c){return new _(this._proxy,T,I,c)}};k=Ve([$e(0,C.IExtHostRpcService),$e(1,y.IExtHostInitDataService)],k),e.ExtHostLoggerService=k;class _ extends g.AbstractMessageLogger{constructor(T,I,c,p){super(p?.always);this.proxy=T,this.file=I,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(c),this.proxy.$createLogger(I,p).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(T,I){const c=[[T,I]];this.isLoggerCreated?this.doLog(c):this.buffer.push(...c)}doLog(T){this.proxy.$log(this.file,T)}}}),define(fe[246],me([0,1,5,11,29]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function C(k){return k&&k.title}let i=class{constructor(_,D){this._logService=D,this._proxy=_.getProxy(g.MainContext.MainThreadMessageService)}showMessage(_,D,T,I,c){const p={extension:_};let f;typeof I=="string"||C(I)?f=[I,...c]:(p.modal=I?.modal,p.useCustom=I?.useCustom,p.detail=I?.detail,f=c),p.useCustom&&(0,y.checkProposedApiEnabled)(_,"resolvers");const v=[];for(let S=0;S<f.length;S++){const P=f[S];if(typeof P=="string")v.push({title:P,handle:S,isCloseAffordance:!1});else if(typeof P=="object"){let{title:w,isCloseAffordance:s}=P;v.push({title:w,isCloseAffordance:!!s,handle:S})}else this._logService.warn("Invalid message item:",P)}return this._proxy.$showMessage(D,T,p,v).then(S=>{if(typeof S=="number")return f[S]})}};i=Ve([$e(1,L.ILogService)],i),e.ExtHostMessageService=i}),define(fe[247],me([0,1,22,3,49,6,24,8,13,2,88,5,17,7,55,222,129]),function(Y,e,g,L,y,C,i,k,_,D,T,I,c,p,f,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class P{constructor(s,r,m,a,b){this._textDocumentsAndEditors=m,this._textDocuments=a,this._extensionStoragePaths=b,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new i.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new L.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new L.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new L.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new L.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new L.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new L.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new L.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new L.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new T.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=s.getProxy(I.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=s.getProxy(I.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=s.getProxy(I.MainContext.MainThreadNotebookEditors),this._commandsConverter=r.converter,r.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===12){const t=n.notebookEditor?.notebookUri,l=n.cell.handle,o=this._documents.get(t)?.getCell(l);if(o)return o.apiCell}return n}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(s=>s.apiEditor)}getEditorById(s){const r=this._editors.get(s);if(!r)throw new Error(`unknown text editor: ${s}. known editors: ${[...this._editors.keys()]} `);return r}getIdByEditor(s){for(const[r,m]of this._editors)if(m.apiEditor===s)return r}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(s,r){const m=this._documents.get(s);if(!m&&!r)throw new Error(`NO notebook document for '${s}'`);return m}_getProviderData(s){const r=this._notebookContentProviders.get(s);if(!r)throw new Error(`NO provider for '${s}'`);return r}registerNotebookContentProvider(s,r,m,a,b){if((0,k.isFalsyOrWhitespace)(r))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(r))throw new Error(`Notebook provider for '${r}' already registered`);this._notebookContentProviders.set(r,{extension:s,provider:m});let n;return m.onDidChangeNotebookContentOptions&&(n=m.onDidChangeNotebookContentOptions(()=>{const t=c.NotebookDocumentContentOptions.from(m.options);this._notebookProxy.$updateNotebookProviderOptions(r,t)})),this._notebookProxy.$registerNotebookProvider({id:s.identifier,location:s.extensionLocation},r,c.NotebookDocumentContentOptions.from(a),P._convertNotebookRegistrationData(s,b)),new p.Disposable(()=>{n?.dispose(),this._notebookContentProviders.delete(r),this._notebookProxy.$unregisterNotebookProvider(r)})}static _convertNotebookRegistrationData(s,r){if(!r)return;const m=r.filenamePattern.map(a=>c.NotebookExclusiveDocumentPattern.from(a)).filter(a=>a!==void 0);if(r.filenamePattern&&!m){console.warn(`Notebook content provider view options file name pattern is invalid ${r.filenamePattern}`);return}return{extension:s.identifier,providerDisplayName:s.displayName||s.name,displayName:r.displayName,filenamePattern:m,exclusive:r.exclusive||!1}}registerNotebookCellStatusBarItemProvider(s,r,m){const a=P._notebookStatusBarItemProviderHandlePool++,b=typeof m.onDidChangeCellStatusBarItems=="function"?P._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(a,m),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(a,b,r);let n;return b!==void 0&&(n=m.onDidChangeCellStatusBarItems(t=>this._notebookProxy.$emitCellStatusBarEvent(b))),new p.Disposable(()=>{this._notebookStatusBarItemProviders.delete(a),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(a,b),n&&n.dispose()})}async createNotebookDocument(s){const r=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:s.viewType,content:s.content&&c.NotebookData.from(s.content)});return D.URI.revive(r)}async openNotebookDocument(s){const r=this._documents.get(s);if(r)return r.apiNotebook;const m=await this._notebookDocumentsProxy.$tryOpenNotebook(s),a=this._documents.get(D.URI.revive(m));return(0,_.assertIsDefined)(a?.apiNotebook)}async showNotebookDocument(s,r){D.URI.isUri(s)&&(s=await this.openNotebookDocument(s));let m;typeof r=="object"?m={position:c.ViewColumn.from(r.viewColumn),preserveFocus:r.preserveFocus,selections:r.selections&&r.selections.map(c.NotebookRange.from),pinned:typeof r.preview=="boolean"?!r.preview:void 0}:m={preserveFocus:!1};const a=await this._notebookEditorsProxy.$tryShowNotebookDocument(s.uri,s.notebookType,m),b=a&&this._editors.get(a)?.apiEditor;if(b)return b;throw a?new Error(`Could NOT open editor for "${s.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${s.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(s,r,m,a){const b=this._notebookStatusBarItemProviders.get(s),n=D.URI.revive(r),t=this._documents.get(n);if(!t||!b)return;const l=t.getCellFromIndex(m);if(!l)return;const d=await b.provideCellStatusBarItems(l.apiCell,a);if(!d)return;const o=new C.DisposableStore,h=this._statusBarCache.add([o]),E=(Array.isArray(d)?d:[d]).map(A=>c.NotebookStatusBarItem.from(A,this._commandsConverter,o));return{cacheId:h,items:E}}$releaseNotebookCellStatusBarItems(s){this._statusBarCache.delete(s)}registerNotebookSerializer(s,r,m,a,b){if((0,k.isFalsyOrWhitespace)(r))throw new Error("viewType cannot be empty or just whitespace");const n=this._handlePool++;return this._notebookSerializer.set(n,m),this._notebookProxy.$registerNotebookSerializer(n,{id:s.identifier,location:s.extensionLocation},r,c.NotebookDocumentContentOptions.from(a),P._convertNotebookRegistrationData(s,b)),(0,C.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(n)})}async $dataToNotebook(s,r,m){const a=this._notebookSerializer.get(s);if(!a)throw new Error("NO serializer found");const b=await a.deserializeNotebook(r.buffer,m);return new f.SerializableObjectWithBuffers(c.NotebookData.from(b))}async $notebookToData(s,r,m){const a=this._notebookSerializer.get(s);if(!a)throw new Error("NO serializer found");const b=await a.serializeNotebook(c.NotebookData.to(r.value),m);return g.VSBuffer.wrap(b)}async $openNotebook(s,r,m,a,b){const{provider:n}=this._getProviderData(s),t=await n.openNotebook(D.URI.revive(r),{backupId:m,untitledDocumentData:a?.buffer},b);return new f.SerializableObjectWithBuffers({metadata:t.metadata??Object.create(null),cells:t.cells.map(c.NotebookCellData.from)})}async $saveNotebook(s,r,m){const a=this.getNotebookDocument(D.URI.revive(r)),{provider:b}=this._getProviderData(s);return await b.saveNotebook(a.apiNotebook,m),!0}async $saveNotebookAs(s,r,m,a){const b=this.getNotebookDocument(D.URI.revive(r)),{provider:n}=this._getProviderData(s);return await n.saveNotebookAs(D.URI.revive(m),b.apiNotebook,a),!0}async $backupNotebook(s,r,m){const a=this.getNotebookDocument(D.URI.revive(r)),b=this._getProviderData(s),n=this._extensionStoragePaths.workspaceValue(b.extension)??this._extensionStoragePaths.globalValue(b.extension),t=String((0,y.hash)([a.uri.toString(),this._backupIdPool++])),l=D.URI.joinPath(n,t),d=await b.provider.backupNotebook(a.apiNotebook,{destination:l},m);return a.updateBackup(d),d.id}_createExtHostEditor(s,r,m){if(this._editors.has(r))throw new Error(`editor with id ALREADY EXSIST: ${r}`);const a=new S.ExtHostNotebookEditor(r,this._notebookEditorsProxy,s,m.visibleRanges.map(c.NotebookRange.to),m.selections.map(c.NotebookRange.to),typeof m.viewColumn=="number"?c.ViewColumn.to(m.viewColumn):void 0);this._editors.set(r,a)}$acceptDocumentAndEditorsDelta(s){if(s.value.removedDocuments)for(const m of s.value.removedDocuments){const a=D.URI.revive(m),b=this._documents.get(a);b&&(b.dispose(),this._documents.delete(a),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:b.apiNotebook.getCells().map(n=>n.document.uri)}),this._onDidCloseNotebookDocument.fire(b.apiNotebook));for(const n of this._editors.values())n.notebookData.uri.toString()===a.toString()&&this._editors.delete(n.id)}if(s.value.addedDocuments){const m=[];for(const a of s.value.addedDocuments){const b=D.URI.revive(a.uri);if(this._documents.has(b))throw new Error(`adding EXISTING notebook ${b} `);const n=this,t=new v.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(l){n._onDidChangeNotebookCells.fire(l)},emitCellOutputsChange(l){n._onDidChangeCellOutputs.fire(l)},emitCellMetadataChange(l){n._onDidChangeCellMetadata.fire(l)},emitCellExecutionStateChange(l){n._onDidChangeCellExecutionState.fire(l)}},b,a);m.push(...a.cells.map(l=>v.ExtHostCell.asModelAddData(t.apiNotebook,l))),this._documents.get(b)?.dispose(),this._documents.set(b,t),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:m}),this._onDidOpenNotebookDocument.fire(t.apiNotebook)}}if(s.value.addedEditors)for(const m of s.value.addedEditors){if(this._editors.has(m.id))return;const a=D.URI.revive(m.documentUri),b=this._documents.get(a);b&&this._createExtHostEditor(b,m.id,m)}const r=[];if(s.value.removedEditors)for(const m of s.value.removedEditors){const a=this._editors.get(m);a&&(this._editors.delete(m),this._activeNotebookEditor?.id===a.id&&(this._activeNotebookEditor=void 0),r.push(a))}if(s.value.visibleEditors){this._visibleNotebookEditors=s.value.visibleEditors.map(a=>this._editors.get(a)).filter(a=>!!a);const m=new Set;this._visibleNotebookEditors.forEach(a=>m.add(a.id));for(const a of this._editors.values()){const b=m.has(a.id);a._acceptVisibility(b)}this._visibleNotebookEditors=[...this._editors.values()].map(a=>a).filter(a=>a.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}s.value.newActiveEditor===null?this._activeNotebookEditor=void 0:s.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(s.value.newActiveEditor)),s.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=P,P._notebookStatusBarItemProviderHandlePool=0}),define(fe[248],me([0,1,3,77,11,5,14,17]),function(Y,e,g,L,y,C,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class _{constructor(I,c){const p=_._Keys.nextId();I.$registerNotebookEditorDecorationType(p,k.NotebookDecorationRenderOptions.from(c)),this.value={key:p,dispose(){I.$removeNotebookEditorDecorationType(p)}}}}_._Keys=new L.IdGenerator("NotebookEditorDecorationType");let D=class{constructor(I,c,p){this._logService=I,this._extHostRpc=c,this._notebooksAndEditors=p,this._onDidChangeNotebookEditorSelection=new g.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new g.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(I){return new _(this._extHostRpc.getProxy(C.MainContext.MainThreadNotebookEditors),I).value}$acceptEditorPropertiesChanged(I,c){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",I,c);const p=this._notebooksAndEditors.getEditorById(I);c.visibleRanges&&p._acceptVisibleRanges(c.visibleRanges.ranges.map(k.NotebookRange.to)),c.selections&&p._acceptSelections(c.selections.selections.map(k.NotebookRange.to)),c.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:p.apiEditor,visibleRanges:p.apiEditor.visibleRanges}),c.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:p.apiEditor,selections:p.apiEditor.selections}))}$acceptEditorViewColumns(I){for(const c in I)this._notebooksAndEditors.getEditorById(c)._acceptViewColumn(k.ViewColumn.to(I[c]))}};D=Ve([$e(0,y.ILogService),$e(1,i.IExtHostRpcService)],D),e.ExtHostNotebookEditors=D}),define(fe[249],me([0,1,15,16,21,3,6,24,2,27,11,5,40,17,7,89,214,29,55]),function(Y,e,g,L,y,C,i,k,_,D,T,I,c,p,f,v,S,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let s=class{constructor(n,t,l,d,o){this._initData=t,this._extHostNotebook=l,this._commands=d,this._logService=o,this._activeExecutions=new k.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=n.getProxy(I.MainContext.MainThreadNotebookKernels);const h=new c.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new c.ApiCommandArgument("options","Select kernel options",u=>!0,u=>{if(u&&"notebookEditor"in u&&"id"in u){const E=this._extHostNotebook.getIdByEditor(u.notebookEditor);return{id:u.id,extension:u.extension,notebookEditorId:E}}else if(u&&"notebookEditor"in u){const E=this._extHostNotebook.getIdByEditor(u.notebookEditor);if(E===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${u.notebookEditor.document.uri.toString()}`);return{notebookEditorId:E}}return u})],c.ApiCommandResult.Void);this._commands.registerApiCommand(h)}createNotebookController(n,t,l,d,o,h){for(let W of this._kernelData.values())if(W.controller.id===t&&D.ExtensionIdentifier.equals(n.identifier,W.extensionId))throw new Error(`notebook controller with id '${t}' ALREADY exist`);const u=this._handlePool++,E=this;this._logService.trace(`NotebookController[${u}], CREATED by ${n.identifier.value}, ${t}`);const A=()=>console.warn(`NO execute handler from notebook controller '${$.id}' of extension: '${n.identifier}'`);let R=!1;const B=new i.DisposableStore,x=new C.Emitter,F=new C.Emitter,$={id:`${n.identifier.value}/${t}`,notebookType:l,extensionId:n.identifier,extensionLocation:n.extensionLocation,label:d||n.identifier.value,preloads:h?h.map(p.NotebookRendererScript.from):[]};let M=o??A,H;this._proxy.$addKernel(u,$).catch(W=>{console.log(W),R=!0});let N=0;const U=()=>{if(R)return;const W=++N;Promise.resolve().then(()=>{W===N&&this._proxy.$updateKernel(u,$)})},V=new k.ResourceMap,O={get id(){return t},get notebookType(){return $.notebookType},onDidChangeSelectedNotebooks:x.event,get label(){return $.label},set label(W){$.label=W??n.displayName??n.name,U()},get detail(){return $.detail??""},set detail(W){$.detail=W,U()},get description(){return $.description??""},set description(W){$.description=W,U()},get kind(){return(0,P.checkProposedApiEnabled)(n,"notebookControllerKind"),$.kind??""},set kind(W){(0,P.checkProposedApiEnabled)(n,"notebookControllerKind"),$.kind=W,U()},get supportedLanguages(){return $.supportedLanguages},set supportedLanguages(W){$.supportedLanguages=W,U()},get supportsExecutionOrder(){return $.supportsExecutionOrder??!1},set supportsExecutionOrder(W){$.supportsExecutionOrder=W,U()},get rendererScripts(){return $.preloads?$.preloads.map(p.NotebookRendererScript.to):[]},get executeHandler(){return M},set executeHandler(W){M=W??A},get interruptHandler(){return H},set interruptHandler(W){H=W,$.supportsInterrupt=Boolean(W),U()},createNotebookCellExecution(W){if(R)throw new Error("notebook controller is DISPOSED");if(!V.has(W.notebook.uri))throw E._logService.trace(`NotebookController[${u}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(V.keys()).map(j=>j.toString())),new Error(`notebook controller is NOT associated to notebook: ${W.notebook.uri.toString()}`);return E._createNotebookCellExecution(W)},dispose:()=>{R||(this._logService.trace(`NotebookController[${u}], DISPOSED`),R=!0,this._kernelData.delete(u),B.dispose(),x.dispose(),F.dispose(),this._proxy.$removeKernel(u))},updateNotebookAffinity(W,j){E._proxy.$updateNotebookPriority(u,W.uri,j)},onDidReceiveMessage:F.event,postMessage(W,j){return(0,P.checkProposedApiEnabled)(n,"notebookMessaging"),E._proxy.$postMessage(u,j&&E._extHostNotebook.getIdByEditor(j),W)},asWebviewUri(W){return(0,P.checkProposedApiEnabled)(n,"notebookMessaging"),(0,v.asWebviewUri)(W,E._initData.remote)}};return this._kernelData.set(u,{extensionId:n.identifier,controller:O,onDidReceiveMessage:F,onDidChangeSelection:x,associatedNotebooks:V}),O}$acceptNotebookAssociation(n,t,l){const d=this._kernelData.get(n);if(d){const o=this._extHostNotebook.getNotebookDocument(_.URI.revive(t));l?d.associatedNotebooks.set(o.uri,!0):d.associatedNotebooks.delete(o.uri),this._logService.trace(`NotebookController[${n}] ASSOCIATE notebook`,o.uri.toString(),l),d.onDidChangeSelection.fire({selected:l,notebook:o.apiNotebook})}}async $executeCells(n,t,l){const d=this._kernelData.get(n);if(!d)return;const o=this._extHostNotebook.getNotebookDocument(_.URI.revive(t)),h=[];for(let u of l){const E=o.getCell(u);E&&h.push(E.apiCell)}try{this._logService.trace(`NotebookController[${n}] EXECUTE cells`,o.uri.toString(),h.length),await d.controller.executeHandler.call(d.controller,h,o.apiNotebook,d.controller)}catch(u){this._logService.error(`NotebookController[${n}] execute cells FAILED`,u),console.error(u)}}async $cancelCells(n,t,l){const d=this._kernelData.get(n);if(!d)return;const o=this._extHostNotebook.getNotebookDocument(_.URI.revive(t));if(d.controller.interruptHandler)await d.controller.interruptHandler.call(d.controller,o.apiNotebook);else for(let h of l){const u=o.getCell(h);u&&this._activeExecutions.get(u.uri)?.cancel()}}$acceptKernelMessageFromRenderer(n,t,l){const d=this._kernelData.get(n);if(!d)return;const o=this._extHostNotebook.getEditorById(t);d.onDidReceiveMessage.fire(Object.freeze({editor:o.apiEditor,message:l}))}_createNotebookCellExecution(n){if(n.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const l=this._extHostNotebook.getNotebookDocument(n.notebook.uri).getCellFromApiCell(n);if(!l)throw new Error("invalid cell");if(this._activeExecutions.has(l.uri))throw new Error(`duplicate execution for ${l.uri}`);const d=new m(l.notebook,l,this._proxy);this._activeExecutions.set(l.uri,d);const o=d.onDidChangeState(()=>{d.state===r.Resolved&&(d.dispose(),o.dispose(),this._activeExecutions.delete(l.uri))});return d.asApiObject()}};s=Ve([$e(4,T.ILogService)],s),e.ExtHostNotebookKernels=s;var r;(function(b){b[b.Init=0]="Init",b[b.Started=1]="Started",b[b.Resolved=2]="Resolved"})(r||(r={}));class m extends i.Disposable{constructor(n,t,l){super();this._document=n,this._cell=t,this._proxy=l,this._handle=m.HANDLE++,this._onDidChangeState=new C.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=r.Init,this._tokenSource=this._register(new y.CancellationTokenSource),this._collector=new a(10,d=>this.update(d)),this._executionOrder=t.internalMetadata.executionOrder,this._proxy.$addExecution(this._handle,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(n){await this._collector.addItem(n)}async update(n){const t=Array.isArray(n)?n:[n];return this._proxy.$updateExecutions(new w.SerializableObjectWithBuffers(t))}verifyStateForOutput(){if(this._state===r.Init)throw new Error("Must call start before modifying cell output");if(this._state===r.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(n){let t=this._cell;if(n&&(t=this._document.getCellFromApiCell(n)),!t)throw new Error("INVALID cell");return t.handle}validateAndConvertOutputs(n){return n.map(t=>{const l=f.NotebookCellOutput.ensureUniqueMimeTypes(t.items,!0);return l===t.items?p.NotebookCellOutput.from(t):p.NotebookCellOutput.from({items:l,id:t.id,metadata:t.metadata})})}async updateOutputs(n,t,l){const d=this.cellIndexToHandle(t),o=this.validateAndConvertOutputs((0,g.asArray)(n));return this.updateSoon({editType:S.CellExecutionUpdateType.Output,executionHandle:this._handle,cellHandle:d,append:l,outputs:o})}async updateOutputItems(n,t,l){return n=f.NotebookCellOutput.ensureUniqueMimeTypes((0,g.asArray)(n),!0),this.updateSoon({editType:S.CellExecutionUpdateType.OutputItems,executionHandle:this._handle,items:n.map(p.NotebookCellOutputItem.from),outputId:t.id,append:l})}asApiObject(){const n=this;return Object.freeze({get token(){return n._tokenSource.token},get cell(){return n._cell.apiCell},get executionOrder(){return n._executionOrder},set executionOrder(l){n._executionOrder=l,n.update([{editType:S.CellExecutionUpdateType.ExecutionState,executionHandle:n._handle,executionOrder:n._executionOrder}])},start(l){if(n._state===r.Resolved||n._state===r.Started)throw new Error("Cannot call start again");n._state=r.Started,n._onDidChangeState.fire(),n.update({editType:S.CellExecutionUpdateType.ExecutionState,executionHandle:n._handle,runStartTime:l})},end(l,d){if(n._state===r.Resolved)throw new Error("Cannot call resolve twice");n._state=r.Resolved,n._onDidChangeState.fire(),n.updateSoon({editType:S.CellExecutionUpdateType.Complete,executionHandle:n._handle,runEndTime:d,lastRunSuccess:l}),n._collector.flush(),n._proxy.$removeExecution(n._handle)},clearOutput(l){return n.verifyStateForOutput(),n.updateOutputs([],l,!1)},appendOutput(l,d){return n.verifyStateForOutput(),n.updateOutputs(l,d,!0)},replaceOutput(l,d){return n.verifyStateForOutput(),n.updateOutputs(l,d,!1)},appendOutputItems(l,d){return n.verifyStateForOutput(),n.updateOutputItems(l,d,!0)},replaceOutputItems(l,d){return n.verifyStateForOutput(),n.updateOutputItems(l,d,!1)}})}}m.HANDLE=0;class a{constructor(n,t){this.delay=n,this.callback=t,this.batch=[],this.startedTimer=Date.now()}addItem(n){return this.batch.push(n),this.currentDeferred||(this.currentDeferred=new L.DeferredPromise,this.startedTimer=Date.now(),(0,L.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const n=this.currentDeferred;this.currentDeferred=void 0;const t=this.batch;return this.batch=[],this.callback(t).finally(()=>n.complete())}}}),define(fe[250],me([0,1,3,5,129,29]),function(Y,e,g,L,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class i{constructor(_,D){this._extHostNotebook=D,this._rendererMessageEmitters=new Map,this.proxy=_.getProxy(L.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(_,D,T){const I=this._extHostNotebook.getEditorById(_);this._rendererMessageEmitters.get(D)?.fire({editor:I.apiEditor,message:T})}createRendererMessaging(_,D){if(!_.contributes?.notebookRenderer?.some(p=>p.id===D))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${D})`);const T=(0,C.isProposedApiEnabled)(_,"notebookEditor"),I=new WeakMap;return{onDidReceiveMessage:(p,f,v)=>{const S=T?p:P=>{const w={};I.set(w,P.editor),p({editor:w,message:P.message})};return this.getOrCreateEmitterFor(D).event(S,f,v)},postMessage:(p,f)=>{y.ExtHostNotebookEditor.apiEditorsToExtHost.has(p)&&([p,f]=[f,p]);const v=T?f:I.get(f),S=v&&y.ExtHostNotebookEditor.apiEditorsToExtHost.get(v);return this.proxy.$postMessage(S?.id,D,p)}}}getOrCreateEmitterFor(_){let D=this._rendererMessageEmitters.get(_);return D||(D=new g.Emitter({onLastListenerRemove:()=>{D?.dispose(),this._rendererMessageEmitters.delete(_)}}),this._rendererMessageEmitters.set(_,D),D)}}e.ExtHostNotebookRenderers=i}),define(fe[133],me([0,1,5,6,4,14,11,215,69,26,45,152,22]),function(Y,e,g,L,y,C,i,k,_,D,T,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class p extends L.Disposable{constructor(S,P,w,s){super();this.id=S,this.name=P,this.logger=w,this.proxy=s,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(S){this.append(S+`
`)}append(S){this.write(S),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Append))}clear(){const S=this.offset;this.logger.flush(),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Clear,S)}replace(S){const P=this.offset;this.write(S),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Replace,P),this.visible&&this.logger.flush()}show(S,P){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof S=="boolean"?S:P))}hide(){this.proxy.$close(this.id)}write(S){this.offset+=c.VSBuffer.fromString(S).byteLength,this.logger.info(S)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=p;let f=class{constructor(S,P,w,s,r){this.extHostFileSystem=w,this.extHostFileSystemInfo=s,this.loggerService=r,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=S.getProxy(g.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(P.logsLocation,`output_logging_${(0,I.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(S){this.visibleChannelId=S;for(const[P,w]of this.channels)w.visible=P===this.visibleChannelId}createOutputChannel(S,P){if(S=S.trim(),!S)throw new Error("illegal argument `name`. must not be falsy");const w=this.doCreateOutputChannel(S,P);return w.then(s=>{this.channels.set(s.id,s),s.visible=s.id===this.visibleChannelId}),this.createExtHostOutputChannel(S,w)}async doCreateOutputChannel(S,P){const w=await this.createOutputDirectory(),s=this.extHostFileSystemInfo.extUri.joinPath(w,`${this.namePool++}-${S.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),r=this.loggerService.createLogger(s,{always:!0,donotRotate:!0,donotUseFormatters:!0}),m=await this.proxy.$register(S,!1,s,P.identifier.value);return new p(m,S,r,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(S,P){let w=!1;const s=()=>{if(w)throw new Error("Channel has been closed")};return{get name(){return S},append(r){s(),P.then(m=>m.append(r))},appendLine(r){s(),P.then(m=>m.appendLine(r))},clear(){s(),P.then(r=>r.clear())},replace(r){s(),P.then(m=>m.replace(r))},show(r,m){s(),P.then(a=>a.show(r,m))},hide(){s(),P.then(r=>r.hide())},dispose(){w=!0,P.then(r=>r.dispose())}}}};f=Ve([$e(0,C.IExtHostRpcService),$e(1,D.IExtHostInitDataService),$e(2,_.IExtHostConsumerFileSystem),$e(3,T.IExtHostFileSystemInfo),$e(4,i.ILoggerService)],f),e.ExtHostOutputService=f,e.IExtHostOutputService=(0,y.createDecorator)("IExtHostOutputService")}),define(fe[251],me([0,1,16,21,3,6,5,2,7,18,15,50,65,29]),function(Y,e,g,L,y,C,i,k,_,D,T,I,c,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function f(v,S,P){const w=v.getProxy(i.MainContext.MainThreadQuickOpen);class s{constructor(o,h){this._sessions=new Map,this._instances=0,this._workspace=o,this._commands=h}showQuickPick(o,h,u=L.CancellationToken.None){this._onDidSelectItem=void 0;const E=Promise.resolve(o),A=++this._instances,R=w.$show(A,{title:h?.title,placeHolder:h?.placeHolder,matchOnDescription:h?.matchOnDescription,matchOnDetail:h?.matchOnDetail,ignoreFocusLost:h?.ignoreFocusOut,canPickMany:h?.canPickMany},u),B={},x=R.then(()=>B);return Promise.race([x,E]).then(F=>{if(F!==B)return E.then($=>{const M=[];for(let H=0;H<$.length;H++){const N=$[H];typeof N=="string"?M.push({label:N,handle:H}):N.kind===_.QuickPickItemKind.Separator?M.push({type:"separator",label:N.label}):M.push({label:N.label,description:N.description,detail:N.detail,picked:N.picked,alwaysShow:N.alwaysShow,handle:H})}return h&&typeof h.onDidSelectItem=="function"&&(this._onDidSelectItem=H=>{h.onDidSelectItem($[H])}),w.$setItems(A,M),R.then(H=>{if(typeof H=="number")return $[H];if(Array.isArray(H))return H.map(N=>$[N])})})}).then(void 0,F=>{if(!(0,D.isPromiseCanceledError)(F))return w.$setError(A,F),Promise.reject(F)})}$onItemSelected(o){this._onDidSelectItem&&this._onDidSelectItem(o)}showInput(o,h=L.CancellationToken.None){return this._validateInput=o?o.validateInput:void 0,w.$input(o,typeof this._validateInput=="function",h).then(void 0,u=>{if(!(0,D.isPromiseCanceledError)(u))return Promise.reject(u)})}$validateInput(o){return this._validateInput?(0,g.asPromise)(()=>this._validateInput(o)):Promise.resolve(void 0)}async showWorkspaceFolderPick(o,h=L.CancellationToken.None){const u=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[o]);if(!u)return;const E=await this._workspace.getWorkspaceFolders2();if(!!E)return E.find(A=>A.uri.toString()===u.uri.toString())}createQuickPick(o){const h=new t(o,()=>this._sessions.delete(h._id));return this._sessions.set(h._id,h),h}createInputBox(o){const h=new l(o,()=>this._sessions.delete(h._id));return this._sessions.set(h._id,h),h}$onDidChangeValue(o,h){const u=this._sessions.get(o);u&&u._fireDidChangeValue(h)}$onDidAccept(o){const h=this._sessions.get(o);h&&h._fireDidAccept()}$onDidChangeActive(o,h){const u=this._sessions.get(o);u instanceof t&&u._fireDidChangeActive(h)}$onDidChangeSelection(o,h){const u=this._sessions.get(o);u instanceof t&&u._fireDidChangeSelection(h)}$onDidTriggerButton(o,h){const u=this._sessions.get(o);u&&u._fireDidTriggerButton(h)}$onDidTriggerItemButton(o,h,u){const E=this._sessions.get(o);E instanceof t&&E._fireDidTriggerItemButton(h,u)}$onDidHide(o){const h=this._sessions.get(o);h&&h._fireDidHide()}}class r{constructor(o,h){this._extensionId=o,this._onDidDispose=h,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new y.Emitter,this._onDidChangeValueEmitter=new y.Emitter,this._onDidTriggerButtonEmitter=new y.Emitter,this._onDidHideEmitter=new y.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(o){this._title=o,this.update({title:o})}get step(){return this._steps}set step(o){this._steps=o,this.update({step:o})}get totalSteps(){return this._totalSteps}set totalSteps(o){this._totalSteps=o,this.update({totalSteps:o})}get enabled(){return this._enabled}set enabled(o){this._enabled=o,this.update({enabled:o})}get busy(){return this._busy}set busy(o){this._busy=o,this.update({busy:o})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(o){this._ignoreFocusOut=o,this.update({ignoreFocusOut:o})}get value(){return this._value}set value(o){this._value=o,this.update({value:o})}get placeholder(){return this._placeholder}set placeholder(o){this._placeholder=o,this.update({placeholder:o})}get buttons(){return this._buttons}set buttons(o){this._buttons=o.slice(),this._handlesToButtons.clear(),o.forEach((h,u)=>{const E=h===_.QuickInputButtons.Back?-1:u;this._handlesToButtons.set(E,h)}),this.update({buttons:o.map((h,u)=>({...n(h),tooltip:h.tooltip,handle:h===_.QuickInputButtons.Back?-1:u}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(o){this._value=o,this._onDidChangeValueEmitter.fire(o)}_fireDidTriggerButton(o){const h=this._handlesToButtons.get(o);h&&this._onDidTriggerButtonEmitter.fire(h)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,C.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),w.$dispose(this._id))}update(o){if(!this._disposed){for(const h of Object.keys(o)){const u=o[h];this._pendingUpdate[h]=u===void 0?null:u}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){w.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}r._nextId=1;function m(d){if(d instanceof _.ThemeIcon)return{id:d.id};const o=b(d),h=a(d);return{dark:typeof o=="string"?k.URI.file(o):o,light:typeof h=="string"?k.URI.file(h):h}}function a(d){return typeof d=="object"&&"light"in d?d.light:d}function b(d){return typeof d=="object"&&"dark"in d?d.dark:d}function n(d){const o=m(d.iconPath);let h,u;return"id"in o?u=c.ThemeIcon.asClassName(o):h=o,{iconPath:h,iconClass:u}}class t extends r{constructor(o,h){super(o.identifier,h);this.extension=o,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new y.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new y.Emitter,this._onDidTriggerItemButtonEmitter=new y.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(o){o.some(u=>u.kind!==void 0)&&(0,p.checkProposedApiEnabled)(this.extension,"quickPickSeparators"),this._items=o.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),o.forEach((u,E)=>{this._handlesToItems.set(E,u),this._itemsToHandles.set(u,E)});const h=[];for(let u=0;u<o.length;u++){const E=o[u];E.kind===_.QuickPickItemKind.Separator?h.push({type:"separator",label:E.label}):h.push({handle:u,label:E.label,description:E.description,detail:E.detail,picked:E.picked,alwaysShow:E.alwaysShow,buttons:E.buttons?.map((A,R)=>({...n(A),tooltip:A.tooltip,handle:R}))})}this.update({items:h})}get canSelectMany(){return this._canSelectMany}set canSelectMany(o){this._canSelectMany=o,this.update({canSelectMany:o})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(o){this._matchOnDescription=o,this.update({matchOnDescription:o})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(o){this._matchOnDetail=o,this.update({matchOnDetail:o})}get sortByLabel(){return this._sortByLabel}set sortByLabel(o){this._sortByLabel=o,this.update({sortByLabel:o})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(o){this._keepScrollPosition=o,this.update({keepScrollPosition:o})}get activeItems(){return this._activeItems}set activeItems(o){this._activeItems=o.filter(h=>this._itemsToHandles.has(h)),this.update({activeItems:this._activeItems.map(h=>this._itemsToHandles.get(h))})}get selectedItems(){return this._selectedItems}set selectedItems(o){this._selectedItems=o.filter(h=>this._itemsToHandles.has(h)),this.update({selectedItems:this._selectedItems.map(h=>this._itemsToHandles.get(h))})}_fireDidChangeActive(o){const h=(0,T.coalesce)(o.map(u=>this._handlesToItems.get(u)));this._activeItems=h,this._onDidChangeActiveEmitter.fire(h)}_fireDidChangeSelection(o){const h=(0,T.coalesce)(o.map(u=>this._handlesToItems.get(u)));this._selectedItems=h,this._onDidChangeSelectionEmitter.fire(h)}_fireDidTriggerItemButton(o,h){const u=this._handlesToItems.get(o);if(!u||!u.buttons||!u.buttons.length)return;const E=u.buttons[h];E&&this._onDidTriggerItemButtonEmitter.fire({button:E,item:u})}}class l extends r{constructor(o,h){super(o,h);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(o){this._password=o,this.update({password:o})}get prompt(){return this._prompt}set prompt(o){this._prompt=o,this.update({prompt:o})}get validationMessage(){return this._validationMessage}set validationMessage(o){this._validationMessage=o,this.update({validationMessage:o,severity:o?I.default.Error:I.default.Ignore})}}return new s(S,P)}e.createExtHostQuickOpen=f}),define(fe[252],me([0,1,2,3,60,6,16,5,15,100,11,27,65,17,29]),function(Y,e,g,L,y,C,i,k,_,D,T,I,c,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function v(d){if(d)return typeof d.iconPath=="string"?g.URI.file(d.iconPath):g.URI.isUri(d.iconPath)||c.ThemeIcon.isThemeIcon(d.iconPath)?d.iconPath:void 0}function S(d,o){if(!d.iconPath&&!o.iconPath)return 0;if(d.iconPath){if(!o.iconPath)return 1}else return-1;const h=typeof d.iconPath=="string"?d.iconPath:g.URI.isUri(d.iconPath)?d.iconPath.fsPath:d.iconPath.id,u=typeof o.iconPath=="string"?o.iconPath:g.URI.isUri(o.iconPath)?o.iconPath.fsPath:o.iconPath.id;return(0,D.comparePaths)(h,u)}function P(d,o){let h=0;if(d.strikeThrough!==o.strikeThrough)return d.strikeThrough?1:-1;if(d.faded!==o.faded)return d.faded?1:-1;if(d.tooltip!==o.tooltip)return(d.tooltip||"").localeCompare(o.tooltip||"");if(h=S(d,o),h!==0)return h;if(d.light&&o.light)h=S(d.light,o.light);else{if(d.light)return 1;if(o.light)return-1}if(h!==0)return h;if(d.dark&&o.dark)h=S(d.dark,o.dark);else{if(d.dark)return 1;if(o.dark)return-1}return h}function w(d,o){if(d.command!==o.command)return d.command<o.command?-1:1;if(d.title!==o.title)return d.title<o.title?-1:1;if(d.tooltip!==o.tooltip){if(d.tooltip!==void 0&&o.tooltip!==void 0)return d.tooltip<o.tooltip?-1:1;if(d.tooltip!==void 0)return 1;if(o.tooltip!==void 0)return-1}if(d.arguments===o.arguments)return 0;if(d.arguments)if(o.arguments){if(d.arguments.length!==o.arguments.length)return d.arguments.length-o.arguments.length}else return 1;else return-1;for(let h=0;h<d.arguments.length;h++){const u=d.arguments[h],E=o.arguments[h];if(u!==E)return u<E?-1:1}return 0}function s(d,o){let h=(0,D.comparePaths)(d.resourceUri.fsPath,o.resourceUri.fsPath,!0);if(h!==0)return h;if(d.command&&o.command)h=w(d.command,o.command);else{if(d.command)return 1;if(o.command)return-1}if(h!==0)return h;if(d.decorations&&o.decorations)h=P(d.decorations,o.decorations);else{if(d.decorations)return 1;if(o.decorations)return-1}return h}function r(d,o){for(let h=0;h<d.length;h++)if(d[h]!==o[h])return!1;return!0}function m(d,o){return d.command===o.command&&d.title===o.title&&d.tooltip===o.tooltip&&(d.arguments&&o.arguments?r(d.arguments,o.arguments):d.arguments===o.arguments)}function a(d,o){return(0,_.equals)(d,o,m)}class b{constructor(o,h,u){this._extension=o,this._proxy=h,this._sourceControlHandle=u,this._value="",this._onDidChange=new L.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(o){this._proxy.$setInputBoxValue(this._sourceControlHandle,o),this.updateValue(o)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(o){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,o),this._placeholder=o}get validateInput(){return(0,f.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(o){if((0,f.checkProposedApiEnabled)(this._extension,"scmValidation"),o&&typeof o!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=o,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!o)}get visible(){return this._visible}set visible(o){o=!!o,this._visible!==o&&(this._visible=o,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,o))}showValidationMessage(o,h){(0,f.checkProposedApiEnabled)(this._extension,"scmValidation"),this._proxy.$showValidationMessage(this._sourceControlHandle,o,h)}$onInputBoxValueChange(o){this.updateValue(o)}updateValue(o){this._value=o,this._onDidChange.fire(o)}}e.ExtHostSCMInputBox=b;class n{constructor(o,h,u,E,A){this._proxy=o,this._commands=h,this._sourceControlHandle=u,this._id=E,this._label=A,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new L.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=n._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(o){this._label=o,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,o)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(o){this._hideWhenEmpty=o,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(o){this._resourceStates=[...o],this._onDidUpdateResourceStates.fire()}getResourceState(o){return this._resourceStatesMap.get(o)}$executeResourceCommand(o,h){const u=this._resourceStatesCommandsMap.get(o);return u?(0,i.asPromise)(()=>this._commands.executeCommand(u.command,...u.arguments||[],h)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const o=[...this._resourceStates].sort(s),u=(0,_.sortedDiff)(this._resourceSnapshot,o,s).map(R=>{const B=R.toInsert.map(x=>{const F=this._resourceHandlePool++;this._resourceStatesMap.set(F,x);const $=x.resourceUri;let M;if(x.command)if(x.command.command==="vscode.open"||x.command.command==="vscode.diff"){const de=new C.DisposableStore;M=this._commands.converter.toInternal(x.command,de),this._resourceStatesDisposablesMap.set(F,de)}else this._resourceStatesCommandsMap.set(F,x.command);const H=v(x.decorations),N=x.decorations&&v(x.decorations.light)||H,U=x.decorations&&v(x.decorations.dark)||H,V=[N,U],O=x.decorations&&x.decorations.tooltip||"",W=x.decorations&&!!x.decorations.strikeThrough,j=x.decorations&&!!x.decorations.faded,X=x.contextValue||"";return{rawResource:[F,$,V,O,W,j,X,M],handle:F}});return{start:R.start,deleteCount:R.deleteCount,toInsert:B}}),E=u.map(({start:R,deleteCount:B,toInsert:x})=>[R,B,x.map(F=>F.rawResource)]),A=u.reverse();for(const{start:R,deleteCount:B,toInsert:x}of A){const F=x.map(M=>M.handle),$=this._handlesSnapshot.splice(R,B,...F);for(const M of $)this._resourceStatesMap.delete(M),this._resourceStatesCommandsMap.delete(M),this._resourceStatesDisposablesMap.get(M)?.dispose(),this._resourceStatesDisposablesMap.delete(M)}return this._resourceSnapshot=o,E}dispose(){this._disposed=!0,this._onDidDispose.fire()}}n._handlePool=0;class t{constructor(o,h,u,E,A,R){this._extension=o,this._proxy=h,this._commands=u,this._id=E,this._label=A,this._rootUri=R,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new C.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new C.MutableDisposable,this._statusBarDisposables=new C.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new L.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=t._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new b(o,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,E,A,R)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(o){this._count!==o&&(this._count=o,this._proxy.$updateSourceControl(this.handle,{count:o}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(o){this._quickDiffProvider=o,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!o})}get commitTemplate(){return this._commitTemplate}set commitTemplate(o){o!==this._commitTemplate&&(this._commitTemplate=o,this._proxy.$updateSourceControl(this.handle,{commitTemplate:o}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(o){this._acceptInputDisposables.value=new C.DisposableStore,this._acceptInputCommand=o;const h=this._commands.converter.toInternal(o,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:h})}get actionButton(){return(0,f.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(o){(0,f.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new C.DisposableStore,this._actionButton=o;const h=o!==void 0?this._commands.converter.toInternal(this._actionButton,this._actionButtonDisposables.value):void 0;this._proxy.$updateSourceControl(this.handle,{actionButton:h??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(o){if(this._statusBarCommands&&o&&a(this._statusBarCommands,o))return;this._statusBarDisposables.value=new C.DisposableStore,this._statusBarCommands=o;const h=(o||[]).map(u=>this._commands.converter.toInternal(u,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:h})}get selected(){return this._selected}createResourceGroup(o,h){const u=new n(this._proxy,this._commands,this.handle,o,h),E=L.Event.once(u.onDidDispose)(()=>this.createdResourceGroups.delete(u));return this.createdResourceGroups.set(u,E),this.eventuallyAddResourceGroups(),u}eventuallyAddResourceGroups(){const o=[],h=[];for(const[u,E]of this.createdResourceGroups){E.dispose();const A=u.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(u),this.eventuallyUpdateResourceStates()});L.Event.once(u.onDidDispose)(()=>{this.updatedResourceGroups.delete(u),A.dispose(),this._groups.delete(u.handle),this._proxy.$unregisterGroup(this.handle,u.handle)}),o.push([u.handle,u.id,u.label,u.features]);const R=u._takeResourceStateSnapshot();R.length>0&&h.push([u.handle,R]),this._groups.set(u.handle,u)}this._proxy.$registerGroups(this.handle,o,h),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const o=[];this.updatedResourceGroups.forEach(h=>{const u=h._takeResourceStateSnapshot();u.length!==0&&o.push([h.handle,u])}),o.length>0&&this._proxy.$spliceResourceStates(this.handle,o),this.updatedResourceGroups.clear()}getResourceGroup(o){return this._groups.get(o)}setSelectionState(o){this._selected=o,this._onDidChangeSelection.fire(o)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(o=>o.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}t._handlePool=0,Ve([(0,y.debounce)(100)],t.prototype,"eventuallyAddResourceGroups",null),Ve([(0,y.debounce)(100)],t.prototype,"eventuallyUpdateResourceStates",null);let l=class $i{constructor(o,h,u){this._commands=h,this.logService=u,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new L.Emitter,this._proxy=o.getProxy(k.MainContext.MainThreadSCM),this._telemetry=o.getProxy(k.MainContext.MainThreadTelemetry),h.registerArgumentProcessor({processArgument:E=>{if(E&&E.$mid===3){const A=this._sourceControls.get(E.sourceControlHandle);if(!A)return E;const R=A.getResourceGroup(E.groupHandle);return R?R.getResourceState(E.handle):E}else if(E&&E.$mid===4){const A=this._sourceControls.get(E.sourceControlHandle);return A?A.getResourceGroup(E.groupHandle):E}else if(E&&E.$mid===5){const A=this._sourceControls.get(E.handle);return A||E}return E}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(o,h,u,E){this.logService.trace("ExtHostSCM#createSourceControl",o.identifier.value,h,u,E),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:o.identifier.value});const A=$i._handlePool++,R=new t(o,this._proxy,this._commands,h,u,E);this._sourceControls.set(A,R);const B=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(o.identifier))||[];return B.push(R),this._sourceControlsByExtension.set(I.ExtensionIdentifier.toKey(o.identifier),B),R}getLastInputBox(o){this.logService.trace("ExtHostSCM#getLastInputBox",o.identifier.value);const h=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(o.identifier)),u=h&&h[h.length-1];return u&&u.inputBox}$provideOriginalResource(o,h,u){const E=g.URI.revive(h);this.logService.trace("ExtHostSCM#$provideOriginalResource",o,E.toString());const A=this._sourceControls.get(o);return!A||!A.quickDiffProvider||!A.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,i.asPromise)(()=>A.quickDiffProvider.provideOriginalResource(E,u)).then(R=>R||null)}$onInputBoxValueChange(o,h){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",o);const u=this._sourceControls.get(o);return u&&u.inputBox.$onInputBoxValueChange(h),Promise.resolve(void 0)}$executeResourceCommand(o,h,u,E){this.logService.trace("ExtHostSCM#$executeResourceCommand",o,h,u);const A=this._sourceControls.get(o);if(!A)return Promise.resolve(void 0);const R=A.getResourceGroup(h);return R?R.$executeResourceCommand(u,E):Promise.resolve(void 0)}$validateInput(o,h,u){this.logService.trace("ExtHostSCM#$validateInput",o);const E=this._sourceControls.get(o);return!E||!E.inputBox.validateInput?Promise.resolve(void 0):(0,i.asPromise)(()=>E.inputBox.validateInput(h,u)).then(A=>{if(!A)return Promise.resolve(void 0);const R=p.MarkdownString.fromStrict(A.message);return R?Promise.resolve([R,A.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(o){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",o),o!==void 0&&this._sourceControls.get(o)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=o,Promise.resolve(void 0)}};l._handlePool=0,l=Ve([$e(2,T.ILogService)],l),e.ExtHostSCM=l});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,L,y){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?y.call(Y,g):y?y.value=g:e.set(Y,g),g},Ne=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[253],me([0,1,7,5,167,6,17,13]),function(Y,e,g,L,y,C,i,k){"use strict";var _,D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class T{constructor(f,v,S,P,w=g.StatusBarAlignment.Left,s){_.set(this,void 0),D.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new C.DisposableStore,st(this,_,f,"f"),st(this,D,v,"f"),this._entryId=T.ID_GEN++,this._extension=S,this._id=P,this._alignment=w,this._priority=this.validatePriority(s)}validatePriority(f){if(!!(0,k.isNumber)(f))return f===Number.POSITIVE_INFINITY?Number.MAX_VALUE:f===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:f}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(f){this._text=f,this.update()}set name(f){this._name=f,this.update()}set tooltip(f){this._tooltip=f,this.update()}set color(f){this._color=f,this.update()}set backgroundColor(f){f&&!T.ALLOWED_BACKGROUND_COLORS.has(f.id)&&(f=void 0),this._backgroundColor=f,this.update()}set command(f){this._command?.fromApi!==f&&(this._internalCommandRegistration.clear(),typeof f=="string"?this._command={fromApi:f,internal:Ne(this,D,"f").toInternal({title:"",command:f},this._internalCommandRegistration)}:f?this._command={fromApi:f,internal:Ne(this,D,"f").toInternal(f,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(f){this._accessibilityInformation=f,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Ne(this,_,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let f;this._extension?this._id?f=`${this._extension.identifier.value}.${this._id}`:f=this._extension.identifier.value:f=this._id;let v;this._name?v=this._name:v=(0,y.localize)(0,null,this._extension.displayName||this._extension.name);let S=this._color;this._backgroundColor&&(S=T.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const P=this._tooltip?i.MarkdownString.fromStrict(this._tooltip):void 0;Ne(this,_,"f").$setEntry(this._entryId,f,v,this._text,P,this._command?.internal,S,this._backgroundColor,this._alignment===g.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=T,_=new WeakMap,D=new WeakMap,T.ID_GEN=0,T.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new g.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new g.ThemeColor("statusBarItem.warningForeground")]]);class I{constructor(f){this._messages=[],this._item=f.createStatusBarEntry(void 0,"status.extensionMessage",g.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,y.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(f){const v={message:f};return this._messages.unshift(v),this._update(),new g.Disposable(()=>{const S=this._messages.indexOf(v);S>=0&&(this._messages.splice(S,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class c{constructor(f,v){this._proxy=f.getProxy(L.MainContext.MainThreadStatusBar),this._commands=v,this._statusMessage=new I(this)}createStatusBarEntry(f,v,S,P){return new T(this._proxy,this._commands,f,v,S,P)}setStatusBarMessage(f,v){const S=this._statusMessage.setMessage(f);let P;return typeof v=="number"?P=setTimeout(()=>S.dispose(),v):typeof v!="undefined"&&v.then(()=>S.dispose(),()=>S.dispose()),new g.Disposable(()=>{S.dispose(),clearTimeout(P)})}}e.ExtHostStatusBar=c}),define(fe[92],me([0,1,5,3,4]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class C{constructor(k){this._onDidChangeStorage=new L.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=k.getProxy(g.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(k,_){this._proxy.$registerExtensionStorageKeysToSync(k,_)}getValue(k,_,D){return this._proxy.$getValue(k,_).then(T=>T||D)}setValue(k,_,D){return this._proxy.$setValue(k,_,D)}$acceptValue(k,_,D){this._onDidChangeStorage.fire({shared:k,key:_,value:D})}}e.ExtHostStorage=C,e.IExtHostStorage=(0,y.createDecorator)("IExtHostStorage")}),define(fe[70],me([0,1,4,26,11,69,2]),function(Y,e,g,L,y,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,g.createDecorator)("IExtensionStoragePaths");let k=class{constructor(D,T,I){this._logService=T,this._extHostFileSystem=I,this._workspace=D.workspace??void 0,this._environment=D.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(c=>this._value=c)}async _getWorkspaceStorageURI(D){return i.URI.joinPath(this._environment.workspaceStorageHome,D)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const D=this._workspace.id,T=await this._getWorkspaceStorageURI(D);try{return await this._extHostFileSystem.value.stat(T),this._logService.trace("[ExtHostStorage] storage dir already exists",T),T}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",T),await this._extHostFileSystem.value.createDirectory(T),await this._extHostFileSystem.value.writeFile(i.URI.joinPath(T,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:i.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),T}catch(I){this._logService.error("[ExtHostStorage]",I);return}}workspaceValue(D){if(this._value)return i.URI.joinPath(this._value,D.identifier.value)}globalValue(D){return i.URI.joinPath(this._environment.globalStorageHome,D.identifier.value.toLowerCase())}onWillDeactivateAll(){}};k=Ve([$e(0,L.IExtHostInitDataService),$e(1,y.ILogService),$e(2,C.IExtHostConsumerFileSystem)],k),e.ExtensionStoragePaths=k}),define(fe[34],me([0,1,3,5,4,2,14,6,7,168,18,217,21,32,197,65,13,16]),function(Y,e,g,L,y,C,i,k,_,D,T,I,c,p,f,v,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,y.createDecorator)("IExtHostTerminalService");class w{constructor(d,o,h,u){this._proxy=d,this._id=o,this._creationOptions=h,this._name=u,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(A=>this._pidPromiseComplete=A);const E=this;this.value={get name(){return E._name||""},get processId(){return E._pidPromise},get creationOptions(){return E._creationOptions},get exitStatus(){return E._exitStatus},get state(){return E._state},sendText(A,R=!0){E._checkDisposed(),E._proxy.$sendText(E._id,A,R)},show(A){E._checkDisposed(),E._proxy.$show(E._id,A)},hide(){E._checkDisposed(),E._proxy.$hide(E._id)},dispose(){E._disposed||(E._disposed=!0,E._proxy.$dispose(E._id))},get dimensions(){if(!(E._cols===void 0||E._rows===void 0))return{columns:E._cols,rows:E._rows}}}}async create(d,o){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:d.name,shellPath:(0,S.withNullAsUndefined)(d.shellPath),shellArgs:(0,S.withNullAsUndefined)(d.shellArgs),cwd:(0,S.withNullAsUndefined)(d.cwd),env:(0,S.withNullAsUndefined)(d.env),icon:(0,S.withNullAsUndefined)(n(d.iconPath)),color:v.ThemeColor.isThemeColor(d.color)?d.color.id:void 0,initialText:(0,S.withNullAsUndefined)(d.message),strictEnv:(0,S.withNullAsUndefined)(d.strictEnv),hideFromUser:(0,S.withNullAsUndefined)(d.hideFromUser),isFeatureTerminal:(0,S.withNullAsUndefined)(o?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,S.withNullAsUndefined)(o?.useShellEnvironment),location:o?.location||this._serializeParentTerminal(d.location,o?.resolvedExtHostIdentifier)})}async createExtensionTerminal(d,o,h,u){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:h,color:v.ThemeColor.isThemeColor(u)?u.id:void 0,location:this._serializeParentTerminal(d,o)}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(d,o){return typeof d=="object"?"parentTerminal"in d&&d.parentTerminal&&o?{parentTerminal:o}:"viewColumn"in d?{viewColumn:d.viewColumn,preserveFocus:d.preserveFocus}:void 0:d}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(d){this._name=d}setExitCode(d){this._exitStatus=Object.freeze({code:d})}setDimensions(d,o){return d===this._cols&&o===this._rows||d===0||o===0?!1:(this._cols=d,this._rows=o,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(d){this._pidPromiseComplete?(this._pidPromiseComplete(d),this._pidPromiseComplete=void 0):this._pidPromise.then(o=>{o!==d&&(this._pidPromise=Promise.resolve(d))})}}e.ExtHostTerminal=w;class s{constructor(d){this._pty=d,this.id=0,this.shouldPersist=!1,this._capabilities=[],this._onProcessData=new g.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new g.Emitter,this._onDidChangeProperty=new g.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new g.Emitter,this.onProcessExit=this._onProcessExit.event}get capabilities(){return this._capabilities}get onProcessReady(){return this._onProcessReady.event}refreshProperty(d){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${d}`)}updateProperty(d,o){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${d}, value: ${o}`)}async start(){}shutdown(){this._pty.close()}input(d){this._pty.handleInput?.(d)}resize(d,o){this._pty.setDimensions?.({columns:d,rows:o})}async processBinary(d){}acknowledgeDataEvent(d){}async setUnicodeVersion(d){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(d){this._pty.onDidWrite(o=>this._onProcessData.fire(o)),this._pty.onDidClose?.((o=void 0)=>{this._onProcessExit.fire(o===void 0?void 0:o)}),this._pty.onDidOverrideDimensions?.(o=>{o&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:o.columns,rows:o.rows}})}),this._pty.onDidChangeName?.(o=>{this._onDidChangeProperty.fire({type:"title",value:o})}),this._pty.open(d||void 0),d&&this._pty.setDimensions?.(d),this._onProcessReady.fire({pid:-1,cwd:"",capabilities:this._capabilities})}}e.ExtHostPseudoterminal=s;let r=1,m=class extends k.Disposable{constructor(d,o){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new g.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new g.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new g.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new g.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new g.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=o.getProxy(L.MainContext.MainThreadTerminalService),this._bufferer=new f.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new g.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(d),this._register({dispose:()=>{for(const[h,u]of this._terminalProcesses)u.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(d=>d.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(d){return(d?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(d){return(d?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(d,o){const h=new w(this._proxy,(0,p.generateUuid)(),d,d.name),u=new s(d.pty);return h.createExtensionTerminal(d.location,this._serializeParentTerminal(d,o).resolvedExtHostIdentifier,n(d.iconPath),t(d.color)).then(E=>{const A=this._setupExtHostProcessListeners(E,u);this._terminalProcessDisposables[E]=A}),this._terminals.push(h),h.value}_serializeParentTerminal(d,o){if(o=o||{},d.location&&typeof d.location=="object"&&"parentTerminal"in d.location){const h=d.location.parentTerminal;if(h){const u=this._terminals.find(E=>E.value===h);u&&(o.resolvedExtHostIdentifier=u._id)}}else d.location&&typeof d.location!="object"?o.location=d.location:o.location&&typeof o.location=="object"&&"splitActiveTerminal"in o.location&&(o.location={splitActiveTerminal:!0});return o}attachPtyToTerminal(d,o){if(!this._getTerminalById(d))throw new Error(`Cannot resolve terminal with id ${d} for virtual process`);const u=new s(o),E=this._setupExtHostProcessListeners(d,u);this._terminalProcessDisposables[d]=E}async $acceptActiveTerminalChanged(d){const o=this._activeTerminal;if(d===null){this._activeTerminal=void 0,o!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const h=this._getTerminalById(d);h&&(this._activeTerminal=h,o!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(d,o){const h=this._getTerminalById(d);h&&this._onDidWriteTerminalData.fire({terminal:h.value,data:o})}async $acceptTerminalDimensions(d,o,h){const u=this._getTerminalById(d);u&&u.setDimensions(o,h)&&this._onDidChangeTerminalDimensions.fire({terminal:u.value,dimensions:u.value.dimensions})}async $acceptTerminalMaximumDimensions(d,o,h){this._terminalProcesses.get(d)?.resize(o,h)}async $acceptTerminalTitleChange(d,o){const h=this._getTerminalById(d);h&&(h.name=o)}async $acceptTerminalClosed(d,o){const h=this._getTerminalObjectIndexById(this._terminals,d);if(h!==null){const u=this._terminals.splice(h,1)[0];u.setExitCode(o),this._onDidCloseTerminal.fire(u.value)}}$acceptTerminalOpened(d,o,h,u){if(o){const R=this._getTerminalObjectIndexById(this._terminals,o);if(R!==null){this._terminals[R]._id=d,this._onDidOpenTerminal.fire(this.terminals[R]),this._terminals[R].isOpen=!0;return}}const E={name:u.name,shellPath:u.executable,shellArgs:u.args,cwd:typeof u.cwd=="string"?u.cwd:C.URI.revive(u.cwd),env:u.env,hideFromUser:u.hideFromUser},A=new w(this._proxy,d,E,h);this._terminals.push(A),this._onDidOpenTerminal.fire(A.value),A.isOpen=!0}async $acceptTerminalProcessId(d,o){const h=this._getTerminalById(d);h&&h._setProcessId(o)}async $startExtensionTerminal(d,o){const h=this._getTerminalById(d);if(!h)return{message:(0,D.localize)(0,null,d)};h.isOpen||await new Promise(E=>{const A=this.onDidOpenTerminal(async R=>{R===h.value&&(A.dispose(),E())})});const u=this._terminalProcesses.get(d);u?u.startSendingEvents(o):this._extensionTerminalAwaitingStart[d]={initialDimensions:o}}_setupExtHostProcessListeners(d,o){const h=new k.DisposableStore;h.add(o.onProcessReady(E=>this._proxy.$sendProcessReady(d,E.pid,E.cwd))),h.add(o.onDidChangeProperty(E=>this._proxy.$sendProcessProperty(d,E))),this._bufferer.startBuffering(d,o.onProcessData),h.add(o.onProcessExit(E=>this._onProcessExit(d,E))),this._terminalProcesses.set(d,o);const u=this._extensionTerminalAwaitingStart[d];return u&&o instanceof s&&(o.startSendingEvents(u.initialDimensions),delete this._extensionTerminalAwaitingStart[d]),h}$acceptProcessAckDataEvent(d,o){this._terminalProcesses.get(d)?.acknowledgeDataEvent(o)}$acceptProcessInput(d,o){this._terminalProcesses.get(d)?.input(o)}$acceptTerminalInteraction(d){const o=this._getTerminalById(d);o?.setInteractedWith()&&this._onDidChangeTerminalState.fire(o.value)}$acceptProcessResize(d,o,h){try{this._terminalProcesses.get(d)?.resize(o,h)}catch(u){if(u.code!=="EPIPE"&&u.code!=="ERR_IPC_CHANNEL_CLOSED")throw u}}$acceptProcessShutdown(d,o){this._terminalProcesses.get(d)?.shutdown(o)}$acceptProcessRequestInitialCwd(d){this._terminalProcesses.get(d)?.getInitialCwd().then(o=>this._proxy.$sendProcessProperty(d,{type:"initialCwd",value:o}))}$acceptProcessRequestCwd(d){this._terminalProcesses.get(d)?.getCwd().then(o=>this._proxy.$sendProcessProperty(d,{type:"cwd",value:o}))}$acceptProcessRequestLatency(d){return d}registerLinkProvider(d){return this._linkProviders.add(d),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new _.Disposable(()=>{this._linkProviders.delete(d),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(d,o,h){if(this._profileProviders.has(o))throw new Error(`Terminal profile provider "${o}" already registered`);return this._profileProviders.set(o,h),this._proxy.$registerProfileProvider(o,d.identifier.value),new _.Disposable(()=>{this._profileProviders.delete(o),this._proxy.$unregisterProfileProvider(o)})}async $createContributedProfileTerminal(d,o){const h=new c.CancellationTokenSource().token;let u=await this._profileProviders.get(d)?.provideTerminalProfile(h);if(!h.isCancellationRequested){if(u&&!("options"in u)&&(u={options:u}),!u||!("options"in u))throw new Error(`No terminal profile options provided for id "${d}"`);if("pty"in u.options){this.createExtensionTerminal(u.options,o);return}this.createTerminalFromOptions(u.options,o)}}async $provideLinks(d,o){const h=this._getTerminalById(d);if(!h)return[];this._terminalLinkCache.delete(d);const u=this._terminalLinkCancellationSource.get(d);u&&u.dispose(!0);const E=new c.CancellationTokenSource;this._terminalLinkCancellationSource.set(d,E);const A=[],R={terminal:h.value,line:o},B=[];for(const $ of this._linkProviders)B.push(P.Promises.withAsyncBody(async M=>{E.token.onCancellationRequested(()=>M({provider:$,links:[]}));const H=await $.provideTerminalLinks(R,E.token)||[];E.token.isCancellationRequested||M({provider:$,links:H})}));const x=await Promise.all(B);if(E.token.isCancellationRequested)return[];const F=new Map;for(const $ of x)$&&$.links.length>0&&A.push(...$.links.map(M=>{const H={id:r++,startIndex:M.startIndex,length:M.length,label:M.tooltip};return F.set(H.id,{provider:$.provider,link:M}),H}));return this._terminalLinkCache.set(d,F),A}$activateLink(d,o){const h=this._terminalLinkCache.get(d)?.get(o);!h||h.provider.handleTerminalLink(h.link)}_onProcessExit(d,o){this._bufferer.stopBuffering(d),this._terminalProcesses.delete(d),delete this._extensionTerminalAwaitingStart[d];const h=this._terminalProcessDisposables[d];h&&(h.dispose(),delete this._terminalProcessDisposables[d]),this._proxy.$sendProcessExit(d,o)}_getTerminalById(d){return this._getTerminalObjectById(this._terminals,d)}_getTerminalObjectById(d,o){const h=this._getTerminalObjectIndexById(d,o);return h!==null?d[h]:null}_getTerminalObjectIndexById(d,o){let h=null;return d.some((u,E)=>u._id===o?(h=E,!0):!1),h}getEnvironmentVariableCollection(d){let o=this._environmentVariableCollections.get(d.identifier.value);return o||(o=new a,this._setEnvironmentVariableCollection(d.identifier.value,o)),o}_syncEnvironmentVariableCollection(d,o){const h=(0,I.serializeEnvironmentVariableCollection)(o.map);this._proxy.$setEnvironmentVariableCollection(d,o.persistent,h.length===0?void 0:h)}$initEnvironmentVariableCollections(d){d.forEach(o=>{const h=o[0],u=new a(o[1]);this._setEnvironmentVariableCollection(h,u)})}$acceptDefaultProfile(d,o){this._defaultProfile=d,this._defaultAutomationProfile=o}_setEnvironmentVariableCollection(d,o){this._environmentVariableCollections.set(d,o),o.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(d,o)})}};m=Ve([$e(1,i.IExtHostRpcService)],m),e.BaseExtHostTerminalService=m;class a{constructor(d){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new g.Emitter,this.map=new Map(d)}get persistent(){return this._persistent}set persistent(d){this._persistent=d,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(d,o){this._setIfDiffers(d,{value:o,type:_.EnvironmentVariableMutatorType.Replace})}append(d,o){this._setIfDiffers(d,{value:o,type:_.EnvironmentVariableMutatorType.Append})}prepend(d,o){this._setIfDiffers(d,{value:o,type:_.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(d,o){const h=this.map.get(d);(!h||h.value!==o.value||h.type!==o.type)&&(this.map.set(d,o),this._onDidChangeCollection.fire())}get(d){return this.map.get(d)}forEach(d,o){this.map.forEach((h,u)=>d.call(o,u,h,this))}delete(d){this.map.delete(d),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=a;let b=class extends m{constructor(d){super(!1,d)}createTerminal(d,o,h){throw new T.NotSupportedError}createTerminalFromOptions(d,o){throw new T.NotSupportedError}};b=Ve([$e(0,i.IExtHostRpcService)],b),e.WorkerExtHostTerminalService=b;function n(l){if(!(!l||typeof l=="string"))return"id"in l?{id:l.id,color:l.color}:l}function t(l){return v.ThemeColor.isThemeColor(l)?l:void 0}});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,L,y){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?y.call(Y,g):y?y.value=g:e.set(Y,g),g},Ne=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[254],me([0,1,15,22,21,3,76,49,6,25,13,32,5,14,66,17,7,225,127,90]),function(Y,e,g,L,y,C,i,k,_,D,T,I,c,p,f,v,S,P,w,s){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let m=class{constructor(R,B){this.resultsChangedEmitter=new C.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=R.getProxy(c.MainContext.MainThreadTesting),this.observer=new h(this.proxy),this.runTracker=new b(this.proxy),B.registerArgumentProcessor({processArgument:x=>x?.$mid===13?v.TestItem.toItemFromContext(x):x})}createTestController(R,B){if(this.controllers.has(R))throw new Error(`Attempt to insert a duplicate controller with ID "${R}"`);const x=new _.DisposableStore,F=x.add(new P.SingleUseTestCollection(R));F.root.label=B;const $=new Map,M=this.proxy,H={items:F.root.children,get label(){return B},set label(U){B=U,F.root.label=U,M.$updateControllerLabel(R,B)},get id(){return R},createRunProfile:(U,V,O,W,j)=>{let X=(0,k.hash)(U);for(;$.has(X);)X++;const Q=new u(this.proxy,R,X,U,V,O,W,j);return $.set(X,Q),Q},createTestItem(U,V,O){return new f.TestItemImpl(R,U,V,O)},createTestRun:(U,V,O=!0)=>this.runTracker.createTestRun(R,F,U,V,O),set resolveHandler(U){F.resolveHandler=U},get resolveHandler(){return F.resolveHandler},dispose:()=>{x.dispose()}};H.createRunConfiguration=H.createRunProfile,M.$registerTestController(R,B),x.add((0,_.toDisposable)(()=>M.$unregisterTestController(R)));const N={controller:H,collection:F,profiles:$};return this.controllers.set(R,N),x.add((0,_.toDisposable)(()=>this.controllers.delete(R))),x.add(F.onDidGenerateDiff(U=>M.$publishDiff(R,U))),H}createTestObserver(){return this.observer.checkout()}async runTests(R,B=y.CancellationToken.None){const x=n(R);if(!x)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const F=this.controllers.get(x.controllerId);if(!F)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:R.include?.map($=>$.id)??[F.collection.root.id],profileGroup:E[x.kind],profileId:x.profileId,controllerId:x.controllerId}],exclude:R.exclude?.map($=>$.id)},B)}$provideFileCoverage(R,B,x){return(0,g.mapFind)(this.runTracker.trackers,$=>$.id===R?$.getCoverage(B):void 0)?.provideFileCoverage(x)??Promise.resolve([])}$resolveFileCoverage(R,B,x,F){return(0,g.mapFind)(this.runTracker.trackers,M=>M.id===R?M.getCoverage(B):void 0)?.resolveFileCoverage(x,F)??Promise.resolve([])}$configureRunProfile(R,B){this.controllers.get(R)?.profiles.get(B)?.configureHandler?.()}$publishTestResults(R){this.results=Object.freeze(R.map(B=>(0,D.deepFreeze)(v.TestResults.to(B))).concat(this.results).sort((B,x)=>x.completedAt-B.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(R,B){const x=this.controllers.get(s.TestId.fromString(R).controllerId)?.collection;x&&(await x.expand(R,B<0?Infinity:B),x.flushDiff())}$acceptDiff(R){this.observer.applyDiff(R)}async $runControllerTests(R,B){const x=this.controllers.get(R.controllerId);if(!x)return;const{collection:F,profiles:$}=x,M=$.get(R.profileId);if(!M)return;const H=R.testIds.map(O=>F.tree.get(O)).filter(T.isDefined),N=R.excludeExtIds.map(O=>x.collection.tree.get(O)).filter(T.isDefined).filter(O=>H.some(W=>W.fullId.compare(O.fullId)===2));if(!H.length)return;const U=new S.TestRunRequest(H.some(O=>O.actual instanceof f.TestItemRootImpl)?void 0:H.map(O=>O.actual),N.map(O=>O.actual),M),V=this.runTracker.prepareForMainThreadTestRun(U,t.fromInternal(R,x.collection),B);try{await M.runHandler(U,B)}finally{V.isRunning&&!B.isCancellationRequested&&await C.Event.toPromise(V.onEnd),V.dispose()}}$cancelExtensionTestRun(R){R===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(R)}};m=Ve([$e(0,p.IExtHostRpcService)],m),e.ExtHostTesting=m;class a extends _.Disposable{constructor(R,B,x){super();this.dto=R,this.proxy=B,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new C.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new y.CancellationTokenSource(x)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:F}of this.tasks.values())F.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(R){return this.tasks.get(R)?.coverage}createRun(R){const B=this.dto.id,x=this.dto.controllerId,F=(0,I.generateUuid)(),$=new l(this.proxy,B,F),M=V=>(O,...W)=>{if(N){console.warn(`Setting the state of test "${O.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(O)||(this.ensureTestIsKnown(O),V(O,...W))},H=(V,O)=>{const W=O instanceof Array?O.map(v.TestMessage.from):[v.TestMessage.from(O)];if(V.uri&&V.range){const j={range:v.Range.from(V.range),uri:V.uri};for(const X of W)X.location=X.location||j}this.proxy.$appendTestMessagesInRun(B,F,s.TestId.fromExtHostTestItem(V,x).toString(),W)};let N=!1;const U={isPersisted:this.dto.isPersisted,token:this.cts.token,name:R,get coverageProvider(){return $.coverageProvider},set coverageProvider(V){$.coverageProvider=V},enqueued:M(V=>{this.proxy.$updateTestStateInRun(B,F,s.TestId.fromExtHostTestItem(V,x).toString(),1)}),skipped:M(V=>{this.proxy.$updateTestStateInRun(B,F,s.TestId.fromExtHostTestItem(V,x).toString(),5)}),started:M(V=>{this.proxy.$updateTestStateInRun(B,F,s.TestId.fromExtHostTestItem(V,x).toString(),2)}),errored:M((V,O,W)=>{H(V,O),this.proxy.$updateTestStateInRun(B,F,s.TestId.fromExtHostTestItem(V,x).toString(),6,W)}),failed:M((V,O,W)=>{H(V,O),this.proxy.$updateTestStateInRun(B,F,s.TestId.fromExtHostTestItem(V,x).toString(),4,W)}),passed:M((V,O)=>{this.proxy.$updateTestStateInRun(B,F,s.TestId.fromExtHostTestItem(V,this.dto.controllerId).toString(),3,O)}),appendOutput:(V,O,W)=>{N||(W&&(this.dto.isIncluded(W)?this.ensureTestIsKnown(W):W=void 0),this.proxy.$appendOutputToRun(B,F,L.VSBuffer.fromString(V),O&&v.location.from(O),W&&s.TestId.fromExtHostTestItem(W,x).toString()))},end:()=>{N||(N=!0,this.proxy.$finishedTestRunTask(B,F),this.tasks.delete(F),this.isRunning||this.dispose())}};return this.tasks.set(F,{run:U,coverage:$}),this.proxy.$startedTestRunTask(B,{id:F,name:R,running:!0}),U}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(R){if(!(R instanceof f.TestItemImpl))throw new f.InvalidTestItemError(R.id);if(this.sharedTestIds.has(s.TestId.fromExtHostTestItem(R,this.dto.controllerId).toString()))return;const B=[],x=this.dto.colllection.root;for(;;){const F=v.TestItem.from(R);if(B.unshift(F),this.sharedTestIds.has(F.extId)||(this.sharedTestIds.add(F.extId),R===x))break;R=R.parent||x}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,B)}}class b{constructor(R){this.proxy=R,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(R,B,x){return this.getTracker(R,B,x)}cancelRunById(R){for(const B of this.tracked.values())if(B.id===R){B.dispose();return}}cancelAllRuns(){for(const R of this.tracked.values())R.dispose()}createTestRun(R,B,x,F,$){const M=this.tracked.get(x);if(M)return M.createRun(F);const H=t.fromPublic(R,B,x,$),N=n(x);this.proxy.$startedExtensionTestRun({controllerId:R,profile:N&&{group:E[N.kind],id:N.profileId},exclude:x.exclude?.map(V=>V.id)??[],id:H.id,include:x.include?.map(V=>V.id)??[B.root.id],persist:$});const U=this.getTracker(x,H);return U.onEnd(()=>this.proxy.$finishedExtensionTestRun(H.id)),U.createRun(F)}getTracker(R,B,x){const F=new a(B,this.proxy,x);return this.tracked.set(R,F),F.onEnd(()=>this.tracked.delete(R)),F}}e.TestRunCoordinator=b;const n=A=>{if(!!A.profile){if(!(A.profile instanceof u))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return A.profile}};class t{constructor(R,B,x,F,$,M){this.controllerId=R,this.id=B,this.isPersisted=$,this.colllection=M,this.includePrefix=x.map(H=>H+"\0"),this.excludePrefix=F.map(H=>H+"\0")}static fromPublic(R,B,x,F){return new t(R,(0,I.generateUuid)(),x.include?.map($=>s.TestId.fromExtHostTestItem($,R).toString())??[R],x.exclude?.map($=>s.TestId.fromExtHostTestItem($,R).toString())??[],F,B)}static fromInternal(R,B){return new t(R.controllerId,R.runId,R.testIds,R.excludeExtIds,!0,B)}isIncluded(R){const B=s.TestId.fromExtHostTestItem(R,this.controllerId).toString()+"\0";for(const x of this.excludePrefix)if(B===x||B.startsWith(x))return!1;for(const x of this.includePrefix)if(B===x||B.startsWith(x))return!0;return!1}}e.TestRunDto=t;class l{constructor(R,B,x){this.proxy=R,this.runId=B,this.taskId=x}set coverageProvider(R){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!R||(this._coverageProvider=R,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(R){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(R))());try{return(await this.fileCoverage)?.map(v.TestCoverage.fromFile)??[]}catch(B){throw this.fileCoverage=void 0,B}}async resolveFileCoverage(R,B){const x=await this.fileCoverage;let F=x?.[R];return!this._coverageProvider||!x||!F?[]:(F.detailedCoverage||(F=x[R]=await this._coverageProvider.resolveFileCoverage?.(F,B)??F),F.detailedCoverage?.map(v.TestCoverage.fromDetailed)??[])}}class d extends w.IncrementalChangeCollector{constructor(R){super();this.emitter=R,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(R){this.added.add(R)}update(R){Object.assign(R.revived,v.TestItem.toPlain(R.item)),this.added.has(R)||this.updated.add(R)}remove(R){if(this.added.has(R)){this.added.delete(R);return}if(this.updated.delete(R),R.parent&&this.alreadyRemoved.has(R.parent)){this.alreadyRemoved.add(R.item.extId);return}this.removed.add(R)}getChangeEvent(){const{added:R,updated:B,removed:x}=this;return{get added(){return[...R].map(F=>F.revived)},get updated(){return[...B].map(F=>F.revived)},get removed(){return[...x].map(F=>F.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class o extends w.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new C.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(R){return this.items.get(R)}getMirroredTestDataByReference(R){return this.items.get(R.id)}createItem(R,B){return{...R,revived:v.TestItem.toPlain(R.item),depth:B?B.depth+1:0,children:new Set}}createChangeCollector(){return new d(this.changeEmitter)}}e.MirroredTestCollection=o;class h{constructor(R){this.proxy=R}checkout(){this.current||(this.current=this.createObserverData());const R=this.current;return R.observers++,{onDidChangeTest:R.tests.onDidChangeTests,get tests(){return[...R.tests.rootTests].map(B=>B.revived)},dispose:(0,i.once)(()=>{--R.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(R){return this.current?.tests.getMirroredTestDataByReference(R)}applyDiff(R){this.current?.tests.apply(R)}createObserverData(){const R=new o;return this.proxy.$subscribeToDiffs(),{observers:0,tests:R}}}class u{constructor(R,B,x,F,$,M,H=!1,N=void 0){this.controllerId=B,this.profileId=x,this._label=F,this.kind=$,this.runHandler=M,this._isDefault=H,this._tag=N,r.set(this,void 0),st(this,r,R,"f");const U=E[$];if(typeof U!="number")throw new Error(`Unknown TestRunProfile.group ${$}`);Ne(this,r,"f").$publishTestRunProfile({profileId:x,controllerId:B,tag:N?v.TestTag.namespace(this.controllerId,N.id):null,label:F,group:U,isDefault:H,hasConfigurationHandler:!1})}get label(){return this._label}set label(R){R!==this._label&&(this._label=R,Ne(this,r,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:R}))}get isDefault(){return this._isDefault}set isDefault(R){R!==this._isDefault&&(this._isDefault=R,Ne(this,r,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:R}))}get tag(){return this._tag}set tag(R){R?.id!==this._tag?.id&&(this._tag=R,Ne(this,r,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:R?v.TestTag.namespace(this.controllerId,R.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(R){R!==this._configureHandler&&(this._configureHandler=R,Ne(this,r,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!R}))}dispose(){Ne(this,r,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=u,r=new WeakMap;const E={[S.TestRunProfileKind.Coverage]:8,[S.TestRunProfileKind.Debug]:4,[S.TestRunProfileKind.Run]:2}}),define(fe[255],me([0,1,3,15,5,130,17,7]),function(Y,e,g,L,y,C,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class _{constructor(T,I){this._extHostDocumentsAndEditors=I,this._onDidChangeTextEditorSelection=new g.Emitter,this._onDidChangeTextEditorOptions=new g.Emitter,this._onDidChangeTextEditorVisibleRanges=new g.Emitter,this._onDidChangeTextEditorViewColumn=new g.Emitter,this._onDidChangeActiveTextEditor=new g.Emitter,this._onDidChangeVisibleTextEditors=new g.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=T.getProxy(y.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(c=>this._onDidChangeVisibleTextEditors.fire(c)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(c=>this._onDidChangeActiveTextEditor.fire(c))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(T){const I=this._extHostDocumentsAndEditors.allEditors();return T?I:I.map(c=>c.value)}async showTextDocument(T,I,c){let p;typeof I=="number"?p={position:i.ViewColumn.from(I),preserveFocus:c}:typeof I=="object"?p={position:i.ViewColumn.from(I.viewColumn),preserveFocus:I.preserveFocus,selection:typeof I.selection=="object"?i.Range.from(I.selection):void 0,pinned:typeof I.preview=="boolean"?!I.preview:void 0}:p={preserveFocus:!1};const f=await this._proxy.$tryShowTextDocument(T.uri,p),v=f&&this._extHostDocumentsAndEditors.getEditor(f);if(v)return v.value;throw f?new Error(`Could NOT open editor for "${T.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${T.uri.toString()}".`)}createTextEditorDecorationType(T,I){return new C.TextEditorDecorationType(this._proxy,T,I).value}$acceptEditorPropertiesChanged(T,I){const c=this._extHostDocumentsAndEditors.getEditor(T);if(!c)throw new Error("unknown text editor");if(I.options&&c._acceptOptions(I.options),I.selections){const p=I.selections.selections.map(i.Selection.to);c._acceptSelections(p)}if(I.visibleRanges){const p=L.coalesce(I.visibleRanges.map(i.Range.to));c._acceptVisibleRanges(p)}if(I.options&&this._onDidChangeTextEditorOptions.fire({textEditor:c.value,options:{...I.options,lineNumbers:i.TextEditorLineNumbersStyle.to(I.options.lineNumbers)}}),I.selections){const p=k.TextEditorSelectionChangeKind.fromValue(I.selections.source),f=I.selections.selections.map(i.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:c.value,selections:f,kind:p})}if(I.visibleRanges){const p=L.coalesce(I.visibleRanges.map(i.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:c.value,visibleRanges:p})}}$acceptEditorPositionData(T){for(const I in T){const c=this._extHostDocumentsAndEditors.getEditor(I);if(!c)throw new Error("Unknown text editor");const p=i.ViewColumn.to(T[I]);c.value.viewColumn!==p&&(c._acceptViewColumn(p),this._onDidChangeTextEditorViewColumn.fire({textEditor:c.value,viewColumn:p}))}}getDiffInformation(T){return Promise.resolve(this._proxy.$getDiffInformation(T))}}e.ExtHostEditors=_}),define(fe[256],me([0,1,2,4,5,6,7]),function(Y,e,g,L,y,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,L.createDecorator)("IExtHostTimeline");class k{constructor(T,I){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=T.getProxy(y.MainContext.MainThreadTimeline),I.registerArgumentProcessor({processArgument:c=>{if(c&&c.$mid===11){const p=c.uri===void 0?void 0:g.URI.revive(c.uri);return this._itemsBySourceAndUriMap.get(c.source)?.get(_(p))?.get(c.handle)}return c}})}async $getTimeline(T,I,c,p,f){return this._providers.get(T)?.provideTimeline(g.URI.revive(I),c,p,f)}registerTimelineProvider(T,I,c,p){const f=new C.DisposableStore,v=this.convertTimelineItem(I.id,p,f).bind(this);let S;I.onDidChange&&(S=I.onDidChange(w=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...w,id:I.id}),this));const P=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...I,scheme:T,onDidChange:void 0,async provideTimeline(w,s,r,m){m?.resetCache&&(f.clear(),P.get(I.id)?.clear());const a=await I.provideTimeline(w,s,r);if(a==null)return;const b=v(w,m);return{...a,source:I.id,items:a.items.map(b)}},dispose(){for(const w of P.values())w.get(I.id)?.clear();S?.dispose(),f.dispose()}})}convertTimelineItem(T,I,c){return(p,f)=>{let v;if(f?.cacheResults){let S=this._itemsBySourceAndUriMap.get(T);S===void 0&&(S=new Map,this._itemsBySourceAndUriMap.set(T,S));const P=_(p);v=S.get(P),v===void 0&&(v=new Map,S.set(P,v))}return S=>{const{iconPath:P,...w}=S,s=`${T}|${S.id??S.timestamp}`;v?.set(s,S);let r,m,a;return S.iconPath&&(P instanceof i.ThemeIcon?a={id:P.id,color:P.color}:g.URI.isUri(P)?(r=P,m=P):{light:r,dark:m}=P),{...w,id:w.id??void 0,handle:s,source:T,command:S.command?I.toInternal(S.command,c):void 0,icon:r,iconDark:m,themeIcon:a,accessibilityInformation:S.accessibilityInformation}}}}registerTimelineProviderCore(T){if(this._providers.get(T.id))throw new Error(`Timeline Provider ${T.id} already exists.`);return this._proxy.$registerTimelineProvider({id:T.id,label:T.label,scheme:T.scheme}),this._providers.set(T.id,T),(0,C.toDisposable)(()=>{for(const c of this._itemsBySourceAndUriMap.values())c.get(T.id)?.clear();this._providers.delete(T.id),this._proxy.$unregisterTimelineProvider(T.id),T.dispose()})}}e.ExtHostTimeline=k;function _(D){return D?.toString()}}),define(fe[257],me([0,1,6,10,2,5]),function(Y,e,g,L,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class i{constructor(_){this._openers=new Map,this._proxy=_.getProxy(C.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(_,D,T,I){if(this._openers.has(D))throw new Error(`Opener with id '${D}' already registered`);const c=I.schemes.find(p=>!i.supportedSchemes.has(p));if(c)throw new Error(`Scheme '${c}' is not supported. Only http and https are currently supported.`);return this._openers.set(D,T),this._proxy.$registerUriOpener(D,I.schemes,_,I.label),(0,g.toDisposable)(()=>{this._openers.delete(D),this._proxy.$unregisterUriOpener(D)})}async $canOpenUri(_,D,T){const I=this._openers.get(_);if(!I)throw new Error(`Unknown opener with id: ${_}`);const c=y.URI.revive(D);return I.canOpenExternalUri(c,T)}async $openUri(_,D,T){const I=this._openers.get(_);if(!I)throw new Error(`Unknown opener id: '${_}'`);return I.openExternalUri(y.URI.revive(D.resolvedUri),{sourceUri:y.URI.revive(D.sourceUri)},T)}}e.ExtHostUriOpeners=i,i.supportedSchemes=new Set([L.Schemas.http,L.Schemas.https])}),define(fe[258],me([0,1,5,2,6,18,27]),function(Y,e,g,L,y,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class k{constructor(D){this.handles=new Set,this.handlers=new Map,this._proxy=D.getProxy(g.MainContext.MainThreadUrls)}registerUriHandler(D,T){if(this.handles.has(i.ExtensionIdentifier.toKey(D)))throw new Error(`Protocol handler already registered for extension ${D}`);const I=k.HandlePool++;return this.handles.add(i.ExtensionIdentifier.toKey(D)),this.handlers.set(I,T),this._proxy.$registerUriHandler(I,D),(0,y.toDisposable)(()=>{this.handles.delete(i.ExtensionIdentifier.toKey(D)),this.handlers.delete(I),this._proxy.$unregisterUriHandler(I)})}$handleExternalUri(D,T){const I=this.handlers.get(D);if(!I)return Promise.resolve(void 0);try{I.handleUri(L.URI.revive(T))}catch(c){(0,C.onUnexpectedError)(c)}return Promise.resolve(void 0)}async createAppUri(D){return L.URI.revive(await this._proxy.$createAppUri(D))}}e.ExtHostUrls=k,k.HandlePool=0});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,L,y){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?y.call(Y,g):y?y.value=g:e.set(Y,g),g},Ne=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[71],me([0,1,3,10,2,181,206,89,5]),function(Y,e,g,L,y,C,i,k,_){"use strict";var D,T,I,c,p,f,v,S,P,w,s,r;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class m{constructor(h,u,E,A,R,B,x){D.set(this,void 0),T.set(this,void 0),I.set(this,void 0),c.set(this,void 0),p.set(this,void 0),f.set(this,void 0),v.set(this,""),S.set(this,void 0),P.set(this,!1),w.set(this,!1),s.set(this,!1),this._onMessageEmitter=new g.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,r.set(this,new g.Emitter),this._onDidDispose=Ne(this,r,"f").event,st(this,D,h,"f"),st(this,T,u,"f"),st(this,S,E,"f"),st(this,c,A,"f"),st(this,p,R,"f"),st(this,f,B,"f"),st(this,s,a(B),"f"),st(this,I,x,"f")}dispose(){st(this,P,!0,"f"),Ne(this,r,"f").fire(),Ne(this,r,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(h){return st(this,w,!0,"f"),(0,k.asWebviewUri)(h,Ne(this,c,"f").remote)}get cspSource(){const h=Ne(this,f,"f").extensionLocation;if(h.scheme===L.Schemas.https||h.scheme===L.Schemas.http){let u=h.toString();return u.endsWith("/")||(u+="/"),u+" "+k.webviewGenericCspSource}return k.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Ne(this,v,"f")}set html(h){this.assertNotDisposed(),Ne(this,v,"f")!==h&&(st(this,v,h,"f"),!Ne(this,w,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(h)&&(st(this,w,!0,"f"),Ne(this,I,"f").report("Webview vscode-resource: uris",Ne(this,f,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ne(this,T,"f").$setHtml(Ne(this,D,"f"),h))}get options(){return this.assertNotDisposed(),Ne(this,S,"f")}set options(h){this.assertNotDisposed(),Ne(this,T,"f").$setOptions(Ne(this,D,"f"),t(Ne(this,f,"f"),Ne(this,p,"f"),h)),st(this,S,h,"f")}async postMessage(h){if(Ne(this,P,"f"))return!1;const u=(0,i.serializeWebviewMessage)(h,{serializeBuffersForPostMessage:Ne(this,s,"f")});return Ne(this,T,"f").$postMessage(Ne(this,D,"f"),u.message,...u.buffers)}assertNotDisposed(){if(Ne(this,P,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=m,D=new WeakMap,T=new WeakMap,I=new WeakMap,c=new WeakMap,p=new WeakMap,f=new WeakMap,v=new WeakMap,S=new WeakMap,P=new WeakMap,w=new WeakMap,s=new WeakMap,r=new WeakMap;function a(o){try{const h=(0,C.normalizeVersion)((0,C.parseVersion)(o.engines.vscode));return!!h&&h.majorBase>=1&&h.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=a;class b{constructor(h,u,E,A,R){this.initData=u,this.workspace=E,this._logService=A,this._deprecationService=R,this._webviews=new Map,this._webviewProxy=h.getProxy(_.MainContext.MainThreadWebviews)}$onMessage(h,u,...E){const A=this.getWebview(h);if(A){const{message:R}=(0,i.deserializeWebviewMessage)(u,E);A._onMessageEmitter.fire(R)}}$onMissingCsp(h,u){this._logService.warn(`${u} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(h,u,E){const A=new m(h,this._webviewProxy,l(u),this.initData,this.workspace,E,this._deprecationService);return this._webviews.set(h,A),A._onDidDispose(()=>{this._webviews.delete(h)}),A}deleteWebview(h){this._webviews.delete(h)}getWebview(h){return this._webviews.get(h)}}e.ExtHostWebviews=b;function n(o){return{id:o.identifier,location:o.extensionLocation}}e.toExtensionData=n;function t(o,h,u){return{enableCommandUris:u.enableCommandUris,enableScripts:u.enableScripts,enableForms:u.enableForms,portMapping:u.portMapping,localResourceRoots:u.localResourceRoots||d(o,h)}}e.serializeWebviewOptions=t;function l(o){return{enableCommandUris:o.enableCommandUris,enableScripts:o.enableScripts,enableForms:o.enableForms,portMapping:o.portMapping,localResourceRoots:o.localResourceRoots?.map(h=>y.URI.from(h))}}e.reviveOptions=l;function d(o,h){return[...(h?.getWorkspaceFolders()||[]).map(u=>u.uri),o.extensionLocation]}}),define(fe[259],me([0,1,21,49,6,10,23,2,17,71,88,5,7]),function(Y,e,g,L,y,C,i,k,_,D,T,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class p{constructor(a,b){this.document=a,this._storagePath=b,this._backupCounter=1,this._edits=new T.Cache("custom documents")}addEdit(a){return this._edits.add([a])}async undo(a,b){await this.getEdit(a).undo(),b||this.disposeBackup()}async redo(a,b){await this.getEdit(a).redo(),b||this.disposeBackup()}disposeEdits(a){for(const b of a)this._edits.delete(b)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const a=r(this.document.uri)+this._backupCounter++;return(0,i.joinPath)(this._storagePath,a)}updateBackup(a){this._backup?.delete(),this._backup=a}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(a){const b=this._edits.get(a,0);if(!b)throw new Error("No edit found");return b}}class f{constructor(){this._documents=new Map}get(a,b){return this._documents.get(this.key(a,b))}add(a,b,n){const t=this.key(a,b.uri);if(this._documents.has(t))throw new Error(`Document already exists for viewType:${a} resource:${b.uri}`);const l=new p(b,n);return this._documents.set(t,l),l}delete(a,b){const n=this.key(a,b.uri);this._documents.delete(n)}key(a,b){return`${a}@@@${b}`}}var v;(function(m){m[m.Text=0]="Text",m[m.Custom=1]="Custom"})(v||(v={}));class S{constructor(){this._providers=new Map}addTextProvider(a,b,n){return this.add(0,a,b,n)}addCustomProvider(a,b,n){return this.add(1,a,b,n)}get(a){return this._providers.get(a)}add(a,b,n,t){if(this._providers.has(b))throw new Error(`Provider for viewType:${b} already registered`);return this._providers.set(b,{type:a,extension:n,provider:t}),new c.Disposable(()=>this._providers.delete(b))}}class P{constructor(a,b,n,t,l){this._extHostDocuments=b,this._extensionStoragePaths=n,this._extHostWebview=t,this._extHostWebviewPanels=l,this._editorProviders=new S,this._documents=new f,this._proxy=a.getProxy(I.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(a,b,n,t){const l=new y.DisposableStore;return w(n)?(l.add(this._editorProviders.addTextProvider(b,a,n)),this._proxy.$registerTextEditorProvider((0,D.toExtensionData)(a),b,t.webviewOptions||{},{supportsMove:!!n.moveCustomTextEditor},(0,D.shouldSerializeBuffersForPostMessage)(a))):(l.add(this._editorProviders.addCustomProvider(b,a,n)),this.supportEditing(n)&&l.add(n.onDidChangeCustomDocument(d=>{const o=this.getCustomDocumentEntry(b,d.document.uri);if(s(d)){const h=o.addEdit(d);this._proxy.$onDidEdit(d.document.uri,b,h,d.label)}else this._proxy.$onContentChange(d.document.uri,b)})),this._proxy.$registerCustomEditorProvider((0,D.toExtensionData)(a),b,t.webviewOptions||{},!!t.supportsMultipleEditorsPerDocument,(0,D.shouldSerializeBuffersForPostMessage)(a))),c.Disposable.from(l,new c.Disposable(()=>{this._proxy.$unregisterEditorProvider(b)}))}async $createCustomDocument(a,b,n,t,l){const d=this._editorProviders.get(b);if(!d)throw new Error(`No provider found for '${b}'`);if(d.type!==1)throw new Error(`Invalid provide type for '${b}'`);const o=k.URI.revive(a),h=await d.provider.openCustomDocument(o,{backupId:n,untitledDocumentData:t?.buffer},l);let u;return this.supportEditing(d.provider)&&this._extensionStoragePaths&&(u=this._extensionStoragePaths.workspaceValue(d.extension)??this._extensionStoragePaths.globalValue(d.extension)),this._documents.add(b,h,u),{editable:this.supportEditing(d.provider)}}async $disposeCustomDocument(a,b){const n=this._editorProviders.get(b);if(!n)throw new Error(`No provider found for '${b}'`);if(n.type!==1)throw new Error(`Invalid provider type for '${b}'`);const t=k.URI.revive(a),{document:l}=this.getCustomDocumentEntry(b,t);this._documents.delete(b,l),l.dispose()}async $resolveWebviewEditor(a,b,n,t,l,d){const o=this._editorProviders.get(n);if(!o)throw new Error(`No provider found for '${n}'`);const h=_.ViewColumn.to(l),u=this._extHostWebview.createNewWebview(b,t.webviewOptions,o.extension),E=this._extHostWebviewPanels.createNewWebviewPanel(b,n,t.title,h,t.panelOptions,u),A=k.URI.revive(a);switch(o.type){case 1:{const{document:R}=this.getCustomDocumentEntry(n,A);return o.provider.resolveCustomEditor(R,E,d)}case 0:{const R=this._extHostDocuments.getDocument(A);return o.provider.resolveCustomTextEditor(R,E,d)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(a,b,n){this.getCustomDocumentEntry(b,a).disposeEdits(n)}async $onMoveCustomEditor(a,b,n){const t=this._editorProviders.get(n);if(!t)throw new Error(`No provider found for '${n}'`);if(!t.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${n}'`);const l=this._extHostWebviewPanels.getWebviewPanel(a);if(!l)throw new Error("No webview found");const d=k.URI.revive(b),o=this._extHostDocuments.getDocument(d);await t.provider.moveCustomTextEditor(o,l,g.CancellationToken.None)}async $undo(a,b,n,t){return this.getCustomDocumentEntry(b,a).undo(n,t)}async $redo(a,b,n,t){return this.getCustomDocumentEntry(b,a).redo(n,t)}async $revert(a,b,n){const t=this.getCustomDocumentEntry(b,a);await this.getCustomEditorProvider(b).revertCustomDocument(t.document,n),t.disposeBackup()}async $onSave(a,b,n){const t=this.getCustomDocumentEntry(b,a);await this.getCustomEditorProvider(b).saveCustomDocument(t.document,n),t.disposeBackup()}async $onSaveAs(a,b,n,t){const l=this.getCustomDocumentEntry(b,a);return this.getCustomEditorProvider(b).saveCustomDocumentAs(l.document,k.URI.revive(n),t)}async $backup(a,b,n){const t=this.getCustomDocumentEntry(b,a),d=await this.getCustomEditorProvider(b).backupCustomDocument(t.document,{destination:t.getNewBackupUri()},n);return t.updateBackup(d),d.id}getCustomDocumentEntry(a,b){const n=this._documents.get(a,k.URI.revive(b));if(!n)throw new Error("No custom document found");return n}getCustomEditorProvider(a){const n=this._editorProviders.get(a)?.provider;if(!n||!this.supportEditing(n))throw new Error("Custom document is not editable");return n}supportEditing(a){return!!a.onDidChangeCustomDocument}}e.ExtHostCustomEditors=P;function w(m){return typeof m.resolveCustomTextEditor=="function"}function s(m){return typeof m.undo=="function"&&typeof m.redo=="function"}function r(m){const a=m.scheme===C.Schemas.file||m.scheme===C.Schemas.untitled?m.fsPath:m.toString();return(0,L.hash)(a)+""}});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,L,y){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?y.call(Y,g):y?y.value=g:e.set(Y,g),g},Ne=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[260],me([0,1,3,6,2,32,17,71,5,7]),function(Y,e,g,L,y,C,i,k,_,D){"use strict";var T,I,c,p,f,v,S,P,w,s,r,m,a;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class b extends L.Disposable{constructor(d,o,h,u,E,A,R){super();T.set(this,void 0),I.set(this,void 0),c.set(this,void 0),p.set(this,void 0),f.set(this,void 0),v.set(this,void 0),S.set(this,void 0),P.set(this,void 0),w.set(this,!0),s.set(this,!0),r.set(this,!1),m.set(this,this._register(new g.Emitter)),this.onDidDispose=Ne(this,m,"f").event,a.set(this,this._register(new g.Emitter)),this.onDidChangeViewState=Ne(this,a,"f").event,st(this,T,d,"f"),st(this,I,o,"f"),st(this,c,h,"f"),st(this,f,A,"f"),st(this,P,E,"f"),st(this,v,u,"f"),st(this,p,R,"f")}dispose(){Ne(this,r,"f")||(st(this,r,!0,"f"),Ne(this,m,"f").fire(),Ne(this,I,"f").$disposeWebview(Ne(this,T,"f")),Ne(this,p,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Ne(this,p,"f")}get viewType(){return this.assertNotDisposed(),Ne(this,c,"f")}get title(){return this.assertNotDisposed(),Ne(this,v,"f")}set title(d){this.assertNotDisposed(),Ne(this,v,"f")!==d&&(st(this,v,d,"f"),Ne(this,I,"f").$setTitle(Ne(this,T,"f"),d))}get iconPath(){return this.assertNotDisposed(),Ne(this,S,"f")}set iconPath(d){this.assertNotDisposed(),Ne(this,S,"f")!==d&&(st(this,S,d,"f"),Ne(this,I,"f").$setIconPath(Ne(this,T,"f"),y.URI.isUri(d)?{light:d,dark:d}:d))}get options(){return Ne(this,f,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Ne(this,P,"f")=="number"&&Ne(this,P,"f")<0))return Ne(this,P,"f")}get active(){return this.assertNotDisposed(),Ne(this,s,"f")}get visible(){return this.assertNotDisposed(),Ne(this,w,"f")}_updateViewState(d){Ne(this,r,"f")||(this.active!==d.active||this.visible!==d.visible||this.viewColumn!==d.viewColumn)&&(st(this,s,d.active,"f"),st(this,w,d.visible,"f"),st(this,P,d.viewColumn,"f"),Ne(this,a,"f").fire({webviewPanel:this}))}reveal(d,o){this.assertNotDisposed(),Ne(this,I,"f").$reveal(Ne(this,T,"f"),{viewColumn:d?i.ViewColumn.from(d):void 0,preserveFocus:!!o})}assertNotDisposed(){if(Ne(this,r,"f"))throw new Error("Webview is disposed")}}T=new WeakMap,I=new WeakMap,c=new WeakMap,p=new WeakMap,f=new WeakMap,v=new WeakMap,S=new WeakMap,P=new WeakMap,w=new WeakMap,s=new WeakMap,r=new WeakMap,m=new WeakMap,a=new WeakMap;class n{constructor(d,o,h){this.webviews=o,this.workspace=h,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=d.getProxy(_.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,C.generateUuid)()}createWebviewPanel(d,o,h,u,E={}){const A=typeof u=="object"?u.viewColumn:u,R={viewColumn:i.ViewColumn.from(A),preserveFocus:typeof u=="object"&&!!u.preserveFocus},B=(0,k.shouldSerializeBuffersForPostMessage)(d),x=n.newHandle();this._proxy.$createWebviewPanel((0,k.toExtensionData)(d),x,o,{title:h,panelOptions:t(E),webviewOptions:(0,k.serializeWebviewOptions)(d,this.workspace,E),serializeBuffersForPostMessage:B},R);const F=this.webviews.createNewWebview(x,E,d);return this.createNewWebviewPanel(x,o,h,A,E,F)}$onDidChangeWebviewPanelViewStates(d){const o=Object.keys(d);o.sort((h,u)=>{const E=d[h],A=d[u];return E.active?1:A.active?-1:+E.visible-+A.visible});for(const h of o){const u=this.getWebviewPanel(h);if(!u)continue;const E=d[h];u._updateViewState({active:E.active,visible:E.visible,viewColumn:i.ViewColumn.to(E.position)})}}async $onDidDisposeWebviewPanel(d){this.getWebviewPanel(d)?.dispose(),this._webviewPanels.delete(d),this.webviews.deleteWebview(d)}registerWebviewPanelSerializer(d,o,h){if(this._serializers.has(o))throw new Error(`Serializer for '${o}' already registered`);return this._serializers.set(o,{serializer:h,extension:d}),this._proxy.$registerSerializer(o,{serializeBuffersForPostMessage:(0,k.shouldSerializeBuffersForPostMessage)(d)}),new D.Disposable(()=>{this._serializers.delete(o),this._proxy.$unregisterSerializer(o)})}async $deserializeWebviewPanel(d,o,h,u){const E=this._serializers.get(o);if(!E)throw new Error(`No serializer found for '${o}'`);const{serializer:A,extension:R}=E,B=this.webviews.createNewWebview(d,h.webviewOptions,R),x=this.createNewWebviewPanel(d,o,h.title,u,h.panelOptions,B);await A.deserializeWebviewPanel(x,h.state)}createNewWebviewPanel(d,o,h,u,E,A){const R=new b(d,this._proxy,o,h,u,E,A);return this._webviewPanels.set(d,R),R}getWebviewPanel(d){return this._webviewPanels.get(d)}}e.ExtHostWebviewPanels=n;function t(l){return{enableFindWidget:l.enableFindWidget,retainContextWhenHidden:l.retainContextWhenHidden}}});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,L,y){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?y.call(Y,g):y?y.value=g:e.set(Y,g),g},Ne=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[261],me([0,1,3,6,71,5,7]),function(Y,e,g,L,y,C,i){"use strict";var k,_,D,T,I,c,p,f,v,S;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class P extends L.Disposable{constructor(r,m,a,b,n,t){super();k.set(this,void 0),_.set(this,void 0),D.set(this,void 0),T.set(this,void 0),I.set(this,!1),c.set(this,void 0),p.set(this,void 0),f.set(this,void 0),v.set(this,this._register(new g.Emitter)),this.onDidChangeVisibility=Ne(this,v,"f").event,S.set(this,this._register(new g.Emitter)),this.onDidDispose=Ne(this,S,"f").event,st(this,D,a,"f"),st(this,p,b,"f"),st(this,k,r,"f"),st(this,_,m,"f"),st(this,T,n,"f"),st(this,c,t,"f")}dispose(){Ne(this,I,"f")||(st(this,I,!0,"f"),Ne(this,S,"f").fire(),Ne(this,T,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Ne(this,p,"f")}set title(r){this.assertNotDisposed(),Ne(this,p,"f")!==r&&(st(this,p,r,"f"),Ne(this,_,"f").$setWebviewViewTitle(Ne(this,k,"f"),r))}get description(){return this.assertNotDisposed(),Ne(this,f,"f")}set description(r){this.assertNotDisposed(),Ne(this,f,"f")!==r&&(st(this,f,r,"f"),Ne(this,_,"f").$setWebviewViewDescription(Ne(this,k,"f"),r))}get visible(){return Ne(this,c,"f")}get webview(){return Ne(this,T,"f")}get viewType(){return Ne(this,D,"f")}_setVisible(r){r===Ne(this,c,"f")||Ne(this,I,"f")||(st(this,c,r,"f"),Ne(this,v,"f").fire())}show(r){this.assertNotDisposed(),Ne(this,_,"f").$show(Ne(this,k,"f"),!!r)}assertNotDisposed(){if(Ne(this,I,"f"))throw new Error("Webview is disposed")}}k=new WeakMap,_=new WeakMap,D=new WeakMap,T=new WeakMap,I=new WeakMap,c=new WeakMap,p=new WeakMap,f=new WeakMap,v=new WeakMap,S=new WeakMap;class w{constructor(r,m){this._extHostWebview=m,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=r.getProxy(C.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(r,m,a,b){if(this._viewProviders.has(m))throw new Error(`View provider for '${m}' already registered`);return this._viewProviders.set(m,{provider:a,extension:r}),this._proxy.$registerWebviewViewProvider((0,y.toExtensionData)(r),m,{retainContextWhenHidden:b?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new i.Disposable(()=>{this._viewProviders.delete(m),this._proxy.$unregisterWebviewViewProvider(m)})}async $resolveWebviewView(r,m,a,b,n){const t=this._viewProviders.get(m);if(!t)throw new Error(`No view provider found for '${m}'`);const{provider:l,extension:d}=t,o=this._extHostWebview.createNewWebview(r,{},d),h=new P(r,this._proxy,m,a,o,!0);this._webviewViews.set(r,h),await l.resolveWebviewView(h,{state:b},n)}async $onDidChangeWebviewViewVisibility(r,m){this.getWebviewView(r)._setVisible(m)}async $disposeWebviewView(r){const m=this.getWebviewView(r);this._webviewViews.delete(r),m.dispose(),this._extHostWebview.deleteWebview(r)}getWebviewView(r){const m=this._webviewViews.get(r);if(!m)throw new Error("No webview found");return m}}e.ExtHostWebviewViews=w}),define(fe[134],me([0,1,3,5,2,10,8,4,14]),function(Y,e,g,L,y,C,i,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let D=class Wi{constructor(I){this._onDidChangeWindowState=new g.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Wi.InitialState,this._proxy=I.getProxy(L.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(c=>this.$onDidChangeWindowFocus(c))}get state(){return this._state}$onDidChangeWindowFocus(I){I!==this._state.focused&&(this._state={...this._state,focused:I},this._onDidChangeWindowState.fire(this._state))}openUri(I,c){let p;if(typeof I=="string"){p=I;try{I=y.URI.parse(I)}catch(f){return Promise.reject(`Invalid uri - '${I}'`)}}return(0,i.isFalsyOrWhitespace)(I.scheme)?Promise.reject("Invalid scheme - cannot be empty"):I.scheme===C.Schemas.command?Promise.reject(`Invalid scheme '${I.scheme}'`):this._proxy.$openUri(I,p,c)}async asExternalUri(I,c){if((0,i.isFalsyOrWhitespace)(I.scheme))return Promise.reject("Invalid scheme - cannot be empty");const p=await this._proxy.$asExternalUri(I,c);return y.URI.from(p)}};D.InitialState={focused:!0},D=Ve([$e(0,_.IExtHostRpcService)],D),e.ExtHostWindow=D,e.IExtHostWindow=(0,k.createDecorator)("IExtHostWindow")}),define(fe[262],me([0,1,9,82,32,40,6,5,2,14]),function(Y,e,g,L,y,C,i,k,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let T=class extends i.Disposable{constructor(c,p){super();const f=c.getProxy(k.MainContext.MainThreadDownloadService);p.registerCommand(!1,"_workbench.downloadResource",async v=>{const S=_.URI.file((0,g.join)((0,L.tmpdir)(),(0,y.generateUuid)()));return await f.$download(v,S),S})}};T=Ve([$e(0,D.IExtHostRpcService),$e(1,C.IExtHostCommands)],T),e.ExtHostDownloadService=T}),define(fe[263],me([0,1,132,10,190,32]),function(Y,e,g,L,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class i extends g.ExtHostLoggerService{doCreateLogger(_,D,T){return _.scheme===L.Schemas.file?new y.SpdLogLogger(T?.name||(0,C.generateUuid)(),_.fsPath,!T?.donotRotate,!!T?.donotUseFormatters,D):super.doCreateLogger(_,D,T)}}e.ExtHostLoggerService=i}),define(fe[264],me([0,1,63,9,2,70,6,10,16,28]),function(Y,e,g,L,y,C,i,k,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class T extends C.ExtensionStoragePaths{constructor(){super(...arguments);this._workspaceStorageLock=null}async _getWorkspaceStorageURI(a){const b=await super._getWorkspaceStorageURI(a);if(b.scheme!==k.Schemas.file)return b;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${b.fsPath}.`),b;const n=b.fsPath;let t=0;do{let l;t===0?l=n:l=/[/\\]$/.test(n)?`${n.substr(0,n.length-1)}-${t}`:`${n}-${t}`,await I(l);const d=L.join(l,"vscode.lock"),o=await v(this._logService,d,!1);if(o)return this._workspaceStorageLock=o,process.on("exit",()=>{o.dispose()}),y.URI.file(l);t++}while(t<10);return b}onWillDeactivateAll(){this._workspaceStorageLock&&this._workspaceStorageLock.setWillRelease(6e3)}}e.ExtensionStoragePaths=T;async function I(m){try{await D.Promises.stat(m);return}catch{}try{await D.Promises.mkdir(m,{recursive:!0})}catch{}}const c=1e3,p=10*60*1e3;class f extends i.Disposable{constructor(a,b){super();this.logService=a,this.filename=b,this._timer=this._register(new _.IntervalTimer),this._timer.cancelAndSet(async()=>{const n=await S(a,b);(!n||n.pid!==process.pid)&&(a.info(`Lock '${b}': The lock was lost unexpectedly.`),this._timer.cancel());try{await D.Promises.utimes(b,new Date,new Date)}catch(t){a.error(t),a.info(`Lock '${b}': Could not update mtime.`)}},c)}dispose(){super.dispose();try{g.unlinkSync(this.filename)}catch(a){}}async setWillRelease(a){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${a} ms.`);try{const b={pid:process.pid,willReleaseAt:Date.now()+a};await D.Promises.writeFile(this.filename,JSON.stringify(b),{flag:"w"})}catch(b){this.logService.error(b)}}}async function v(m,a,b){try{const t={pid:process.pid,willReleaseAt:0};await D.Promises.writeFile(a,JSON.stringify(t),{flag:"wx"})}catch(t){m.error(t)}const n=await S(m,a);return!n||n.pid!==process.pid?b?(m.info(`Lock '${a}': Could not acquire lock, giving up.`),null):(m.info(`Lock '${a}': Could not acquire lock, checking if the file is stale.`),s(m,a)):(m.info(`Lock '${a}': Lock acquired.`),new f(m,a))}async function S(m,a){let b;try{b=await D.Promises.readFile(a)}catch(n){return m.error(n),null}try{return JSON.parse(String(b))}catch(n){return m.error(n),null}}async function P(m,a){let b;try{b=await D.Promises.stat(a)}catch(n){return m.error(n),0}return b.mtime.getTime()}function w(m){try{return process.kill(m,0),!0}catch(a){return!1}}async function s(m,a){const b=await S(m,a);if(!b)return m.info(`Lock '${a}': Could not read pid of lock holder.`),r(m,a);if(b.willReleaseAt){let o=b.willReleaseAt-Date.now();if(o<5e3){for(o>0?m.info(`Lock '${a}': The lockfile is scheduled to be released in ${o} ms.`):m.info(`Lock '${a}': The lockfile is scheduled to have been released.`);o>0;){if(await(0,_.timeout)(Math.min(100,o)),await P(m,a)===0)return r(m,a);o=b.willReleaseAt-Date.now()}return r(m,a)}}if(!w(b.pid))return m.info(`Lock '${a}': The pid ${b.pid} appears to be gone.`),r(m,a);const n=await P(m,a),t=Date.now()-n;if(t<=p)return m.info(`Lock '${a}': The lock does not look stale, elapsed: ${t} ms, giving up.`),null;m.info(`Lock '${a}': The lock looks stale, waiting for 2s.`),await(0,_.timeout)(2e3);const l=await P(m,a),d=Date.now()-l;return d<=p?(m.info(`Lock '${a}': The lock does not look stale, elapsed: ${d} ms, giving up.`),null):(m.info(`Lock '${a}': The lock looks stale even after waiting for 2s.`),r(m,a))}async function r(m,a){m.info(`Lock '${a}': Deleting a stale lock.`);try{await D.Promises.unlink(a)}catch(b){}return v(m,a,!0)}}),define(fe[265],me([0,1,32,14,34]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let C=class extends y.BaseExtHostTerminalService{constructor(k){super(!0,k)}createTerminal(k,_,D){return this.createTerminalFromOptions({name:k,shellPath:_,shellArgs:D})}createTerminalFromOptions(k,_){const D=new y.ExtHostTerminal(this._proxy,(0,g.generateUuid)(),k,k.name);return this._terminals.push(D),D.create(k,this._serializeParentTerminal(k,_)),D.value}};C=Ve([$e(0,L.IExtHostRpcService)],C),e.ExtHostTerminalService=C}),define(fe[266],me([0,1,5,14,172,6,26,2,39,23,28,7,12,54,3,121,79,11]),function(Y,e,g,L,y,C,i,k,_,D,T,I,c,p,f,v,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class w{constructor(h,u,E){this.remoteAddress=h,this.localAddress=u,this._dispose=E,this._onDispose=new f.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function s(o){const h=o.trim().split(`
`),u=[];return h.forEach(A=>{const R=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(A);R&&R.length>=3&&u.push({pid:parseInt(R[1],10),socket:parseInt(R[2],10)})}),u.reduce((A,R)=>(A[R.socket]=R,A),{})}e.getSockets=s;function r(...o){const h=[].concat(...o.map(a));return[...new Map(h.filter(u=>u.st==="0A").map(u=>{const E=u.local_address.split(":");return{socket:parseInt(u.inode,10),ip:m(E[0]),port:parseInt(E[1],16)}}).map(u=>[u.ip+":"+u.port,u])).values()]}e.loadListeningPorts=r;function m(o){let h="";if(o.length===8)for(let u=o.length-2;u>=0;u-=2)h+=parseInt(o.substr(u,2),16),u!==0&&(h+=".");else for(let u=o.length-4;u>=0;u-=4)h+=parseInt(o.substr(u,4),16).toString(16),u!==0&&(h+=":");return h}e.parseIpAddress=m;function a(o){const h=o.trim().split(`
`),u=h.shift().trim().split(/\s+/).filter(A=>A!=="rx_queue"&&A!=="tm->when");return h.map(A=>A.trim().split(/\s+/).reduce((R,B,x)=>(R[u[x]||x]=B,R),{}))}e.loadConnectionTable=a;function b(o){return!!o.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||o.indexOf("out/vs/server/main.js")!==-1||o.indexOf("_productName=VSCode")!==-1}function n(o){const h=o.trim().split(`
`),u=[];return h.forEach(E=>{const A=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(E);A&&A.length>=4&&u.push({pid:parseInt(A[1],10),ppid:parseInt(A[2]),cmd:A[3]})}),u}e.getRootProcesses=n;async function t(o,h,u){const E=u.reduce((R,B)=>(R[B.pid]=B,R),{}),A=[];return o.forEach(({socket:R,ip:B,port:x})=>{const F=h[R]?h[R].pid:void 0,$=F?E[F]?.cmd:void 0;F&&$&&!b($)&&A.push({host:B,port:x,detail:$,pid:F})}),A}e.findPorts=t;function l(o,h,u){const E=new Map,A=n(h);for(const R of o){const B=u.get(R.port);if(B){E.set(R.port,B);continue}const x=A.find(F=>F.cmd.includes(`${R.port}`));if(x){let F=x,$;do $=A.find(M=>M.ppid===F.pid),$&&(F=$);while($);E.set(R.port,{host:R.ip,port:R.port,pid:F.pid,detail:F.cmd,ppid:F.ppid})}else E.set(R.port,{host:R.ip,port:R.port,ppid:Number.MAX_VALUE})}return E}e.tryFindRootPorts=l;let d=class extends C.Disposable{constructor(h,u,E){super();this.logService=E,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new f.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=h.getProxy(g.MainContext.MainThreadTunnelService),c.isLinux&&u.remote.isRemote&&u.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(h,u){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${h.identifier.value} called openTunnel API for ${u.remoteAddress.host}:${u.remoteAddress.port}.`);const E=await this._proxy.$openTunnel(u,h.displayName);if(E){const A=new w(E.remoteAddress,E.localAddress,()=>this._proxy.$closeTunnel(E.remoteAddress));return this._register(A),A}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(h){return Math.max(h*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(h,u){const E=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(E,{selector:h,provider:u}),this._proxy.$registerPortsAttributesProvider(h,E),new I.Disposable(()=>{this._portAttributesProviders.delete(E),this._proxy.$unregisterPortsAttributesProvider(E)})}async $providePortAttributes(h,u,E,A,R){const B=[];for(const F of h){const $=this._portAttributesProviders.get(F);if(!$)return[];B.push(...await Promise.all(u.map(async M=>$.provider.providePortAttributes(M,E,A,R))))}const x=B.filter(F=>!!F);return x.length>0?x.map(F=>({autoForwardAction:F.autoForwardAction,port:F.port})):[]}async $registerCandidateFinder(h){if(h&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=h;let u=new S.MovingAverage,E;for(;this._candidateFindingEnabled;){const A=new Date().getTime(),R=(await this.findCandidatePorts()).filter(x=>(0,v.isLocalhost)(x.host)||(0,v.isAllInterfaces)(x.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${R.map(x=>x.port).join(", ")}`);const B=new Date().getTime()-A;u.update(B),(!E||JSON.stringify(E)!==JSON.stringify(R))&&(E=R,await this._proxy.$onFoundNewCandidates(E)),await new Promise(x=>setTimeout(()=>x(),this.calculateDelay(u.value)))}}async setTunnelExtensionFunctions(h){if(h){if(h.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(h.candidatePortSource),h.showCandidatePort&&(this._showCandidatePort=h.showCandidatePort,this._proxy.$setCandidateFilter()),h.tunnelFactory){this._forwardPortProvider=h.tunnelFactory;let u=h.tunnelFeatures?.privacyOptions??[];h.tunnelFeatures?.public&&u.length===0&&(u=[{id:"private",label:y.localize(0,null),themeIcon:"lock"},{id:"public",label:y.localize(1,null),themeIcon:"eye"}]),this._proxy.$setTunnelProvider({elevation:!!h.tunnelFeatures?.elevation,public:!!h.tunnelFeatures?.public,privacyOptions:u})}}else this._forwardPortProvider=void 0;return(0,C.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(h,u){if(this._extensionTunnels.has(h.host)){const E=this._extensionTunnels.get(h.host);E.has(h.port)&&(u&&E.get(h.port).disposeListener.dispose(),await E.get(h.port).tunnel.dispose(),E.delete(h.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(h,u){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const E=this._forwardPortProvider(h,u);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),E!==void 0){const A=await E;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(h.remoteAddress.host)||this._extensionTunnels.set(h.remoteAddress.host,new Map);const R=this._register(A.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(A.remoteAddress))));return this._extensionTunnels.get(h.remoteAddress.host).set(h.remoteAddress.port,{tunnel:A,disposeListener:R}),p.TunnelDto.fromApiTunnel(A)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(E){this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(h){const u=await Promise.all(h.map(A=>this._showCandidatePort(A.host,A.port,A.detail??""))),E=h.filter((A,R)=>u[R]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${h.map(A=>A.port).join(", ")} to ${E.map(A=>A.port).join(", ")}`),E}async findCandidatePorts(){let h="",u="";try{h=await T.Promises.readFile("/proc/net/tcp","utf8"),u=await T.Promises.readFile("/proc/net/tcp6","utf8")}catch(N){}const E=r(h,u),A=await new Promise(N=>{(0,_.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(U,V,O)=>{N(V)})}),R=s(A),B=await T.Promises.readdir("/proc"),x=[];for(let N of B)try{const U=Number(N),V=D.joinPath(k.URI.file("/proc"),N);if((await T.Promises.stat(V.fsPath)).isDirectory()&&!isNaN(U)){const W=await T.Promises.readlink(D.joinPath(V,"cwd").fsPath),j=await T.Promises.readFile(D.joinPath(V,"cmdline").fsPath,"utf8");x.push({pid:U,cwd:W,cmd:j})}}catch(U){}const F=[],$=E.filter(N=>{const U=R[N.socket];return U||F.push(N),U}),M=t($,R,x);let H;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${F.length}`),F.length>0){const N=await new Promise(U=>{(0,_.exec)("ps -F -A -l | grep root",(V,O,W)=>{U(O)})});this._foundRootPorts=l(F,N,this._foundRootPorts),H=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${H.join(", ")}`)}return M.then(N=>H?N.concat(H):N)}};d=Ve([$e(0,L.IExtHostRpcService),$e(1,i.IExtHostInitDataService),$e(2,P.ILogService)],d),e.ExtHostTunnelService=d}),define(fe[267],me([0,1,16,22,21,18,3,6,103,231,55]),function(Y,e,g,L,y,C,i,k,_,D,T){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function c(E,A){try{return JSON.stringify(E,A)}catch(R){return"null"}}const p="$$ref$$",f={[p]:-1};class v{constructor(A,R){this.jsonString=A,this.referencedBuffers=R}}function S(E,A=null,R=!1){const B=[];return{jsonString:(R?c:JSON.stringify)(E,(F,$)=>{if(typeof $=="undefined")return f;if(typeof $=="object"){if($ instanceof L.VSBuffer){const M=B.push($)-1;return{[p]:M}}if(A)return A(F,$)}return $}),referencedBuffers:B}}e.stringifyJsonWithBufferRefs=S;function P(E,A,R){return JSON.parse(E,(B,x)=>{if(x){const F=x[p];if(typeof F=="number")return A[F];if(R&&x.$mid===1)return R.transformIncoming(x)}return x})}e.parseJsonAndRestoreBufferRefs=P;function w(E,A){return JSON.stringify(E,A)}function s(E){return E?(A,R)=>R&&R.$mid===1?E.transformOutgoing(R):R:null}var r;(function(E){E[E.LocalSide=0]="LocalSide",E[E.OtherSide=1]="OtherSide"})(r=e.RequestInitiator||(e.RequestInitiator={}));var m;(function(E){E[E.Responsive=0]="Responsive",E[E.Unresponsive=1]="Unresponsive"})(m=e.ResponsiveState||(e.ResponsiveState={}));const a=()=>{},b=Symbol.for("rpcProtocol"),n=Symbol.for("rpcProxy");class t extends k.Disposable{constructor(A,R=null,B=null){super();this[I]=!0,this._onDidChangeResponsiveState=this._register(new i.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=A,this._logger=R,this._uriTransformer=B,this._uriReplacer=s(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let x=0,F=T.ProxyIdentifier.count;x<F;x++)this._locals[x]=null,this._proxies[x]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new g.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(x=>this._receiveOneMessage(x))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(A=>{this._pendingRPCReplies[A].resolveErr(C.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(A){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+t.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(A){this._unresponsiveTime=Date.now()+t.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(A){this._responsiveState!==A&&(this._responsiveState=A,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(A){return this._uriTransformer?(0,_.transformIncomingURIs)(A,this._uriTransformer):A}getProxy(A){const{nid:R,sid:B}=A;return this._proxies[R]||(this._proxies[R]=this._createProxy(R,B)),this._proxies[R]}_createProxy(A,R){let B={get:(x,F)=>(typeof F=="string"&&!x[F]&&F.charCodeAt(0)===36&&(x[F]=(...$)=>this._remoteCall(A,F,$)),F===n?R:x[F])};return new Proxy(Object.create(null),B)}set(A,R){return this._locals[A.nid]=R,R}assertRegistered(A){for(let R=0,B=A.length;R<B;R++){const x=A[R];if(!this._locals[x.nid])throw new Error(`Missing actor ${x.sid} (isMain: ${x.isMain})`)}}_receiveOneMessage(A){if(this._isDisposed)return;const R=A.byteLength,B=l.read(A,0),x=B.readUInt8(),F=B.readUInt32();switch(x){case 1:case 2:{let{rpcId:$,method:M,args:H}=o.deserializeRequestJSONArgs(B);this._uriTransformer&&(H=(0,_.transformIncomingURIs)(H,this._uriTransformer)),this._receiveRequest(R,F,$,M,H,x===2);break}case 3:case 4:{let{rpcId:$,method:M,args:H}=o.deserializeRequestMixedArgs(B);this._uriTransformer&&(H=(0,_.transformIncomingURIs)(H,this._uriTransformer)),this._receiveRequest(R,F,$,M,H,x===4);break}case 5:{this._logger&&this._logger.logIncoming(R,F,0,"ack"),this._onDidReceiveAcknowledge(F);break}case 6:{this._receiveCancel(R,F);break}case 7:{this._receiveReply(R,F,void 0);break}case 9:{let $=o.deserializeReplyOKJSON(B);this._uriTransformer&&($=(0,_.transformIncomingURIs)($,this._uriTransformer)),this._receiveReply(R,F,$);break}case 10:{const $=o.deserializeReplyOKJSONWithBuffers(B,this._uriTransformer);this._receiveReply(R,F,$);break}case 8:{let $=o.deserializeReplyOKVSBuffer(B);this._receiveReply(R,F,$);break}case 11:{let $=o.deserializeReplyErrError(B);this._uriTransformer&&($=(0,_.transformIncomingURIs)($,this._uriTransformer)),this._receiveReplyErr(R,F,$);break}case 12:{this._receiveReplyErr(R,F,void 0);break}default:console.error("received unexpected message"),console.error(A)}}_receiveRequest(A,R,B,x,F,$){this._logger&&this._logger.logIncoming(A,R,1,`receiveRequest ${(0,T.getStringIdentifierForProxy)(B)}.${x}(`,F);const M=String(R);let H,N;if($){const V=new y.CancellationTokenSource;F.push(V.token),H=this._invokeHandler(B,x,F),N=()=>V.cancel()}else H=this._invokeHandler(B,x,F),N=a;this._cancelInvokedHandlers[M]=N;const U=o.serializeAcknowledged(R);this._logger&&this._logger.logOutgoing(U.byteLength,R,1,"ack"),this._protocol.send(U),H.then(V=>{delete this._cancelInvokedHandlers[M];const O=o.serializeReplyOK(R,V,this._uriReplacer);this._logger&&this._logger.logOutgoing(O.byteLength,R,1,"reply:",V),this._protocol.send(O)},V=>{delete this._cancelInvokedHandlers[M];const O=o.serializeReplyErr(R,V);this._logger&&this._logger.logOutgoing(O.byteLength,R,1,"replyErr:",V),this._protocol.send(O)})}_receiveCancel(A,R){this._logger&&this._logger.logIncoming(A,R,1,"receiveCancel");const B=String(R);this._cancelInvokedHandlers[B]&&this._cancelInvokedHandlers[B]()}_receiveReply(A,R,B){this._logger&&this._logger.logIncoming(A,R,0,"receiveReply:",B);const x=String(R);if(!this._pendingRPCReplies.hasOwnProperty(x))return;const F=this._pendingRPCReplies[x];delete this._pendingRPCReplies[x],F.resolveOk(B)}_receiveReplyErr(A,R,B){this._logger&&this._logger.logIncoming(A,R,0,"receiveReplyErr:",B);const x=String(R);if(!this._pendingRPCReplies.hasOwnProperty(x))return;const F=this._pendingRPCReplies[x];delete this._pendingRPCReplies[x];let $;B&&(B.$isError?($=new Error,$.name=B.name,$.message=B.message,$.stack=B.stack):$=B),F.resolveErr($)}_invokeHandler(A,R,B){try{return Promise.resolve(this._doInvokeHandler(A,R,B))}catch(x){return Promise.reject(x)}}_doInvokeHandler(A,R,B){const x=this._locals[A];if(!x)throw new Error("Unknown actor "+(0,T.getStringIdentifierForProxy)(A));let F=x[R];if(typeof F!="function")throw new Error("Unknown method "+R+" on actor "+(0,T.getStringIdentifierForProxy)(A));return F.apply(x,B)}_remoteCall(A,R,B){if(this._isDisposed)return Promise.reject(C.canceled());let x=null;if(B.length>0&&y.CancellationToken.isCancellationToken(B[B.length-1])&&(x=B.pop()),x&&x.isCancellationRequested)return Promise.reject(C.canceled());const F=o.serializeRequestArguments(B,this._uriReplacer),$=++this._lastMessageId,M=String($),H=new D.LazyPromise;x&&x.onCancellationRequested(()=>{const U=o.serializeCancel($);this._logger&&this._logger.logOutgoing(U.byteLength,$,0,"cancel"),this._protocol.send(o.serializeCancel($))}),this._pendingRPCReplies[M]=H,this._onWillSendRequest($);const N=o.serializeRequest($,A,R,F,!!x);return this._logger&&this._logger.logOutgoing(N.byteLength,$,0,`request: ${(0,T.getStringIdentifierForProxy)(A)}.${R}(`,B),this._protocol.send(N),H}}e.RPCProtocol=t,I=b,t.UNRESPONSIVE_TIME=3*1e3;class l{constructor(A,R){this._buff=A,this._offset=R}static alloc(A,R,B){let x=new l(L.VSBuffer.alloc(B+1+4),0);return x.writeUInt8(A),x.writeUInt32(R),x}static read(A,R){return new l(A,R)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(A){this._buff.writeUInt8(A,this._offset),this._offset+=1}readUInt8(){const A=this._buff.readUInt8(this._offset);return this._offset+=1,A}writeUInt32(A){this._buff.writeUInt32BE(A,this._offset),this._offset+=4}readUInt32(){const A=this._buff.readUInt32BE(this._offset);return this._offset+=4,A}static sizeShortString(A){return 1+A.byteLength}writeShortString(A){this._buff.writeUInt8(A.byteLength,this._offset),this._offset+=1,this._buff.set(A,this._offset),this._offset+=A.byteLength}readShortString(){const A=this._buff.readUInt8(this._offset);this._offset+=1;const B=this._buff.slice(this._offset,this._offset+A).toString();return this._offset+=A,B}static sizeLongString(A){return 4+A.byteLength}writeLongString(A){this._buff.writeUInt32BE(A.byteLength,this._offset),this._offset+=4,this._buff.set(A,this._offset),this._offset+=A.byteLength}readLongString(){const A=this._buff.readUInt32BE(this._offset);this._offset+=4;const B=this._buff.slice(this._offset,this._offset+A).toString();return this._offset+=A,B}writeBuffer(A){this._buff.writeUInt32BE(A.byteLength,this._offset),this._offset+=4,this._buff.set(A,this._offset),this._offset+=A.byteLength}static sizeVSBuffer(A){return 4+A.byteLength}writeVSBuffer(A){this._buff.writeUInt32BE(A.byteLength,this._offset),this._offset+=4,this._buff.set(A,this._offset),this._offset+=A.byteLength}readVSBuffer(){const A=this._buff.readUInt32BE(this._offset);this._offset+=4;const R=this._buff.slice(this._offset,this._offset+A);return this._offset+=A,R}static sizeMixedArray(A){let R=0;R+=1;for(let B=0,x=A.length;B<x;B++){const F=A[B];switch(R+=1,F.type){case 1:R+=this.sizeLongString(F.value);break;case 2:R+=this.sizeVSBuffer(F.value);break;case 3:R+=this.sizeUInt32,R+=this.sizeLongString(F.value);for(let $=0;$<F.buffers.length;++$)R+=this.sizeVSBuffer(F.buffers[$]);break;case 4:break}}return R}writeMixedArray(A){this._buff.writeUInt8(A.length,this._offset),this._offset+=1;for(let R=0,B=A.length;R<B;R++){const x=A[R];switch(x.type){case 1:this.writeUInt8(1),this.writeLongString(x.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(x.value);break;case 3:this.writeUInt8(3),this.writeUInt32(x.buffers.length),this.writeLongString(x.value);for(let F=0;F<x.buffers.length;++F)this.writeBuffer(x.buffers[F]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const A=this._buff.readUInt8(this._offset);this._offset+=1;let R=new Array(A);for(let B=0;B<A;B++)switch(this.readUInt8()){case 1:R[B]=this.readLongString();break;case 2:R[B]=this.readVSBuffer();break;case 3:const F=this.readUInt32(),$=this.readLongString(),M=[];for(let H=0;H<F;++H)M.push(this.readVSBuffer());R[B]=new T.SerializableObjectWithBuffers(P($,M,null));break;case 4:R[B]=void 0;break}return R}}l.sizeUInt32=4;var d;(function(E){E[E.Simple=0]="Simple",E[E.Mixed=1]="Mixed"})(d||(d={}));class o{static _useMixedArgSerialization(A){for(let R=0,B=A.length;R<B;R++)if(A[R]instanceof L.VSBuffer||A[R]instanceof T.SerializableObjectWithBuffers||typeof A[R]=="undefined")return!0;return!1}static serializeRequestArguments(A,R){if(this._useMixedArgSerialization(A)){const B=[];for(let x=0,F=A.length;x<F;x++){const $=A[x];if($ instanceof L.VSBuffer)B[x]={type:2,value:$};else if(typeof $=="undefined")B[x]={type:4};else if($ instanceof T.SerializableObjectWithBuffers){const{jsonString:M,referencedBuffers:H}=S($.value,R);B[x]={type:3,value:L.VSBuffer.fromString(M),buffers:H}}else B[x]={type:1,value:L.VSBuffer.fromString(w($,R))}}return{type:1,args:B}}return{type:0,args:w(A,R)}}static serializeRequest(A,R,B,x,F){switch(x.type){case 0:return this._requestJSONArgs(A,R,B,x.args,F);case 1:return this._requestMixedArgs(A,R,B,x.args,F)}}static _requestJSONArgs(A,R,B,x,F){const $=L.VSBuffer.fromString(B),M=L.VSBuffer.fromString(x);let H=0;H+=l.sizeUInt8(),H+=l.sizeShortString($),H+=l.sizeLongString(M);let N=l.alloc(F?2:1,A,H);return N.writeUInt8(R),N.writeShortString($),N.writeLongString(M),N.buffer}static deserializeRequestJSONArgs(A){const R=A.readUInt8(),B=A.readShortString(),x=A.readLongString();return{rpcId:R,method:B,args:JSON.parse(x)}}static _requestMixedArgs(A,R,B,x,F){const $=L.VSBuffer.fromString(B);let M=0;M+=l.sizeUInt8(),M+=l.sizeShortString($),M+=l.sizeMixedArray(x);let H=l.alloc(F?4:3,A,M);return H.writeUInt8(R),H.writeShortString($),H.writeMixedArray(x),H.buffer}static deserializeRequestMixedArgs(A){const R=A.readUInt8(),B=A.readShortString(),x=A.readMixedArray(),F=new Array(x.length);for(let $=0,M=x.length;$<M;$++){const H=x[$];typeof H=="string"?F[$]=JSON.parse(H):F[$]=H}return{rpcId:R,method:B,args:F}}static serializeAcknowledged(A){return l.alloc(5,A,0).buffer}static serializeCancel(A){return l.alloc(6,A,0).buffer}static serializeReplyOK(A,R,B){if(typeof R=="undefined")return this._serializeReplyOKEmpty(A);if(R instanceof L.VSBuffer)return this._serializeReplyOKVSBuffer(A,R);if(R instanceof T.SerializableObjectWithBuffers){const{jsonString:x,referencedBuffers:F}=S(R.value,B,!0);return this._serializeReplyOKJSONWithBuffers(A,x,F)}else return this._serializeReplyOKJSON(A,c(R,B))}static _serializeReplyOKEmpty(A){return l.alloc(7,A,0).buffer}static _serializeReplyOKVSBuffer(A,R){let B=0;B+=l.sizeVSBuffer(R);let x=l.alloc(8,A,B);return x.writeVSBuffer(R),x.buffer}static deserializeReplyOKVSBuffer(A){return A.readVSBuffer()}static _serializeReplyOKJSON(A,R){const B=L.VSBuffer.fromString(R);let x=0;x+=l.sizeLongString(B);let F=l.alloc(9,A,x);return F.writeLongString(B),F.buffer}static _serializeReplyOKJSONWithBuffers(A,R,B){const x=L.VSBuffer.fromString(R);let F=0;F+=l.sizeUInt32,F+=l.sizeLongString(x);for(const M of B)F+=l.sizeVSBuffer(M);let $=l.alloc(10,A,F);$.writeUInt32(B.length),$.writeLongString(x);for(const M of B)$.writeBuffer(M);return $.buffer}static deserializeReplyOKJSON(A){const R=A.readLongString();return JSON.parse(R)}static deserializeReplyOKJSONWithBuffers(A,R){const B=A.readUInt32(),x=A.readLongString(),F=[];for(let $=0;$<B;++$)F.push(A.readVSBuffer());return new T.SerializableObjectWithBuffers(P(x,F,R))}static serializeReplyErr(A,R){return R?this._serializeReplyErrEror(A,R):this._serializeReplyErrEmpty(A)}static _serializeReplyErrEror(A,R){const B=L.VSBuffer.fromString(c(C.transformErrorForSerialization(R),null));let x=0;x+=l.sizeLongString(B);let F=l.alloc(11,A,x);return F.writeLongString(B),F.buffer}static deserializeReplyErrError(A){const R=A.readLongString();return JSON.parse(R)}static _serializeReplyErrEmpty(A){return l.alloc(12,A,0).buffer}}var h;(function(E){E[E.RequestJSONArgs=1]="RequestJSONArgs",E[E.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",E[E.RequestMixedArgs=3]="RequestMixedArgs",E[E.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",E[E.Acknowledged=5]="Acknowledged",E[E.Cancel=6]="Cancel",E[E.ReplyOKEmpty=7]="ReplyOKEmpty",E[E.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",E[E.ReplyOKJSON=9]="ReplyOKJSON",E[E.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",E[E.ReplyErrError=11]="ReplyErrError",E[E.ReplyErrEmpty=12]="ReplyErrEmpty"})(h||(h={}));var u;(function(E){E[E.String=1]="String",E[E.VSBuffer=2]="VSBuffer",E[E.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",E[E.Undefined=4]="Undefined"})(u||(u={}))}),define(fe[268],me([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,g.createDecorator)("remoteAgentService")}),define(fe[269],me([0,1,10,9,12,2,4,64,44,226,268]),function(Y,e,g,L,y,C,i,k,_,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,i.createDecorator)("pathService");let I=class Hi{constructor(p,f,v,S){this.localUserHome=p,this.remoteAgentService=f,this.environmentService=v,this.contextService=S,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||y.OS)(),this.resolveUserHome=(async()=>{const P=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=P?.userHome||p})()}get defaultUriScheme(){return Hi.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(p,f){if(p.remoteAuthority)return g.Schemas.vscodeRemote;const v=(0,k.getVirtualWorkspaceScheme)(f.getWorkspace());if(v)return v;const S=f.getWorkspace().folders[0];if(S)return S.uri.scheme;const P=f.getWorkspace().configuration;return P?P.scheme:g.Schemas.file}async userHome(p){return p?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(p=>p===1?L.win32:L.posix)}async fileURI(p){let f="";if(await this.resolveOS===1&&(p=p.replace(/\\/g,"/")),p[0]==="/"&&p[1]==="/"){const S=p.indexOf("/",2);S===-1?(f=p.substring(2),p="/"):(f=p.substring(2,S),p=p.substring(S)||"/")}return C.URI.from({scheme:g.Schemas.file,authority:f,path:p,query:"",fragment:""})}};I=Ve([$e(1,T.IRemoteAgentService),$e(2,D.IWorkbenchEnvironmentService),$e(3,_.IWorkspaceContextService)],I),e.AbstractPathService=I}),define(fe[72],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class g{constructor(i,k){this.line=i,this.character=k}isBefore(i){return!1}isBeforeOrEqual(i){return!1}isAfter(i){return!1}isAfterOrEqual(i){return!1}isEqual(i){return!1}compareTo(i){return 0}translate(i,k){return new g(0,0)}with(i){return new g(0,0)}}e.Position=g;class L{constructor(i,k,_,D){this.isEmpty=!1,this.isSingleLine=!1,this.start=new g(i,k),this.end=new g(_,D)}contains(i){return!1}isEqual(i){return!1}intersection(i){}union(i){return new L(0,0,0,0)}with(i){return new L(0,0,0,0)}}e.Range=L;var y;(function(C){C[C.Information=1]="Information",C[C.Warning=2]="Warning"})(y=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(fe[33],me([0,1,15,31,25,30,8,4,9,18,72,13]),function(Y,e,g,L,y,C,i,k,_,D,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return T.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const c="\u27EA ",p=" characters skipped \u27EB",f=(c.length+p.length+5)*2;e.ISearchService=(0,k.createDecorator)("searchService");var v;(function(U){U[U.file=0]="file",U[U.text=1]="text"})(v=e.SearchProviderType||(e.SearchProviderType={}));var S;(function(U){U[U.File=1]="File",U[U.Text=2]="Text"})(S=e.QueryType||(e.QueryType={}));function P(U){return!!U.preview}e.resultIsMatch=P;function w(U){return!!U.resource}e.isFileMatch=w;function s(U){return!!U.message}e.isProgressMessage=s;var r;(function(U){U[U.Normal=0]="Normal",U[U.NewSearchStarted=1]="NewSearchStarted"})(r=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class m{constructor(V){this.resource=V,this.results=[]}}e.FileMatch=m;class a{constructor(V,O,W){this.ranges=O;const j=Array.isArray(O)?O:[O];if(W&&W.matchLines===1&&b(j)){V=(0,i.getNLines)(V,W.matchLines);let X="",Q=0,de=0;const Se=Math.floor(W.charsPerLine/5),De=[];for(const Pe of j){const Be=Math.max(Pe.startColumn-Se,0),We=Pe.startColumn+W.charsPerLine;if(Be>de+Se+f){const He=c+(Be-de)+p;X+=He+V.slice(Be,We),Q+=Be-(de+He.length)}else X+=V.slice(de,We);De.push(new t(0,Pe.startColumn-Q,Pe.endColumn-Q)),de=We}this.preview={text:X,matches:Array.isArray(this.ranges)?De:De[0]}}else{const X=Array.isArray(O)?O[0].startLineNumber:O.startLineNumber;this.preview={text:V,matches:(0,g.mapArrayOrNot)(O,Q=>new n(Q.startLineNumber-X,Q.startColumn,Q.endLineNumber-X,Q.endColumn))}}}}e.TextSearchMatch=a;function b(U){const V=U[0].startLineNumber;for(const O of U)if(O.startLineNumber!==V||O.endLineNumber!==V)return!1;return!0}class n{constructor(V,O,W,j){this.startLineNumber=V,this.startColumn=O,this.endLineNumber=W,this.endColumn=j}}e.SearchRange=n;class t extends n{constructor(V,O,W){super(V,O,V,W)}}e.OneLineRange=t;var l;(function(U){U.Default="default",U.FileNames="fileNames",U.Type="type",U.Modified="modified",U.CountDescending="countDescending",U.CountAscending="countAscending"})(l=e.SearchSortOrder||(e.SearchSortOrder={}));function d(U,V=!0){const O=U&&U.files&&U.files.exclude,W=V&&U&&U.search&&U.search.exclude;if(!O&&!W)return;if(!O||!W)return O||W;let j=Object.create(null);return j=y.mixin(j,y.deepClone(O)),j=y.mixin(j,y.deepClone(W),!0),j}e.getExcludes=d;function o(U,V){return U.excludePattern&&L.match(U.excludePattern,V)?!1:U.includePattern||U.usingSearchPaths?U.includePattern&&L.match(U.includePattern,V)?!0:U.usingSearchPaths?!!U.folderQueries&&U.folderQueries.some(O=>{const W=O.folder.fsPath;if(C.isEqualOrParent(V,W)){const j=_.relative(W,V);return!O.includePattern||!!L.match(O.includePattern,j)}else return!1}):!1:!0}e.pathIncludedInQuery=o;var h;(function(U){U[U.unknownEncoding=1]="unknownEncoding",U[U.regexParseError=2]="regexParseError",U[U.globParseError=3]="globParseError",U[U.invalidLiteral=4]="invalidLiteral",U[U.rgProcessError=5]="rgProcessError",U[U.other=6]="other",U[U.canceled=7]="canceled"})(h=e.SearchErrorCode||(e.SearchErrorCode={}));class u extends Error{constructor(V,O){super(V);this.code=O}}e.SearchError=u;function E(U){const V=U.message;if((0,D.isPromiseCanceledError)(U))return new u(V,h.canceled);try{const O=JSON.parse(V);return new u(O.message,O.code)}catch(O){return new u(V,h.other)}}e.deserializeSearchError=E;function A(U){const V={message:U.message,code:U.code};return new Error(JSON.stringify(V))}e.serializeSearchError=A;function R(U){return U.type==="error"?!0:U.type==="success"}e.isSerializedSearchComplete=R;function B(U){return U.type==="success"}e.isSerializedSearchSuccess=B;function x(U){return!!U.path}e.isSerializedFileMatch=x;function F(U,V){const O=U.searchPath?U.searchPath:U.relativePath;return(0,i.fuzzyContains)(O,V)}e.isFilePatternMatch=F;class ${constructor(V){this.path=V,this.results=[]}addMatch(V){this.results.push(V)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=$;function M(U,V){const O={...U||{},...V||{}};return Object.keys(O).filter(W=>{const j=O[W];return typeof j=="boolean"&&j})}e.resolvePatternsForProvider=M;class H{constructor(V,O){this._parsedIncludeExpression=null,this._excludeExpression={...V.excludePattern||{},...O.excludePattern||{}},this._parsedExcludeExpression=L.parse(this._excludeExpression);let W=V.includePattern;O.includePattern&&(W?W={...W,...O.includePattern}:W=O.includePattern),W&&(this._parsedIncludeExpression=L.parse(W))}matchesExcludesSync(V,O,W){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(V,O,W))}includedInQuerySync(V,O,W){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(V,O,W)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(V,O,W))}includedInQuery(V,O,W){const j=this._parsedExcludeExpression(V,O,W),X=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(V,O,W):!0;return(0,I.isPromise)(j)?j.then(Q=>Q?!1:X()):X()}hasSiblingExcludeClauses(){return N(this._excludeExpression)}}e.QueryGlobTester=H;function N(U){for(const V in U)if(typeof U[V]!="boolean")return!0;return!1}}),define(fe[36],me([0,1,15,16,21,3,24,10,79,23,8,13,2,170,4,11,191,44,45,26,14,7,33,5]),function(Y,e,g,L,y,C,i,k,_,D,T,I,c,p,f,v,S,P,w,s,r,m,a,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function n(A,R,B){return new D.ExtUri(x=>o(x,B)).isEqual(A,R)}function t(A,R,B){return n(A.uri,R.uri,B)?0:(0,T.compare)(A.uri.toString(),R.uri.toString())}function l(A,R,B){return A.index!==R.index?A.index<R.index?-1:1:n(A.uri,R.uri,B)?(0,T.compare)(A.name,R.name):(0,T.compare)(A.uri.toString(),R.uri.toString())}function d(A,R,B,x){const F=A.slice(0).sort((M,H)=>B(M,H,x)),$=R.slice(0).sort((M,H)=>B(M,H,x));return(0,g.delta)(F,$,(M,H)=>B(M,H,x))}function o(A,R){const B=R.getCapabilities(A.scheme);return!(B&&B&1024)}class h extends P.Workspace{constructor(R,B,x,F,$,M,H){super(R,x.map(N=>new P.WorkspaceFolder(N)),F,$,H);this._name=B,this._isUntitled=M,this._workspaceFolders=[],this._structure=i.TernarySearchTree.forUris(H),x.forEach(N=>{this._workspaceFolders.push(N),this._structure.set(N.uri,N)})}static toExtHostWorkspace(R,B,x,F){if(!R)return{workspace:null,added:[],removed:[]};const{id:$,name:M,folders:H,configuration:N,transient:U,isUntitled:V}=R,O=[],W=B;B?H.forEach((de,Se)=>{const De=c.URI.revive(de.uri),Pe=h._findFolder(x||B,De,F);Pe?(Pe.name=de.name,Pe.index=de.index,O.push(Pe)):O.push({uri:De,name:de.name,index:Se})}):O.push(...H.map(({uri:de,name:Se,index:De})=>({uri:c.URI.revive(de),name:Se,index:De}))),O.sort((de,Se)=>de.index<Se.index?-1:1);const j=new h($,M,O,!!U,N?c.URI.revive(N):null,!!V,de=>o(de,F)),{added:X,removed:Q}=d(W?W.workspaceFolders:[],j.workspaceFolders,t,F);return{workspace:j,added:X,removed:Q}}static _findFolder(R,B,x){for(let F=0;F<R.folders.length;F++){const $=R.workspaceFolders[F];if(n($.uri,B,x))return $}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(R,B){return B&&this._structure.get(R)&&(R=(0,D.dirname)(R)),this._structure.findSubstr(R)}resolveWorkspaceFolder(R){return this._structure.get(R)}}let u=class{constructor(R,B,x,F){this._onDidChangeWorkspace=new C.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new C.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=F,this._extHostFileSystemInfo=x,this._requestIdProvider=new _.Counter,this._barrier=new L.Barrier,this._proxy=R.getProxy(b.MainContext.MainThreadWorkspace),this._messageService=R.getProxy(b.MainContext.MainThreadMessageService);const $=B.workspace;this._confirmedWorkspace=$?new h($.id,$.name,[],!!$.transient,$.configuration?c.URI.revive($.configuration):null,!!$.isUntitled,M=>o(M,x)):void 0}$initializeWorkspace(R,B){this._trusted=B,this.$acceptWorkspaceData(R),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?c.URI.from({scheme:k.Schemas.untitled,path:(0,D.basename)((0,D.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(R,B,x,...F){const $=[];if(Array.isArray(F)&&F.forEach(V=>{c.URI.isUri(V.uri)&&!$.some(O=>n(O.uri,V.uri,this._extHostFileSystemInfo))&&$.push({uri:V.uri,name:V.name||(0,D.basenameOrAuthority)(V.uri)})}),this._unconfirmedWorkspace||[B,x].some(V=>typeof V!="number"||V<0)||x===0&&$.length===0)return!1;const M=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(B+x>M.length)return!1;const H=M.slice(0);H.splice(B,x,...$.map(V=>({uri:V.uri,name:V.name||(0,D.basenameOrAuthority)(V.uri),index:void 0})));for(let V=0;V<H.length;V++){const O=H[V];if(H.some((W,j)=>j!==V&&n(O.uri,W.uri,this._extHostFileSystemInfo)))return!1}H.forEach((V,O)=>V.index=O);const{added:N,removed:U}=d(M,H,l,this._extHostFileSystemInfo);if(N.length===0&&U.length===0)return!1;if(this._proxy){const V=R.displayName||R.name;this._proxy.$updateWorkspaceFolders(V,B,x,$).then(void 0,O=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(S.Severity.Error,(0,p.localize)(0,null,V,O.toString()),{extension:R},[])})}return this.trySetWorkspaceFolders(H),!0}getWorkspaceFolder(R,B){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(R,B)}async getWorkspaceFolder2(R,B){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(R,B)}async resolveWorkspaceFolder(R){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(R)}getPath(){if(!this._actualWorkspace)return;const{folders:R}=this._actualWorkspace;if(R.length!==0)return R[0].uri.fsPath}getRelativePath(R,B){let x,F="";if(typeof R=="string"?(x=c.URI.file(R),F=R):typeof R!="undefined"&&(x=R,F=R.fsPath),!x)return F;const $=this.getWorkspaceFolder(x,!0);if(!$)return F;typeof B=="undefined"&&this._actualWorkspace&&(B=this._actualWorkspace.folders.length>1);let M=(0,D.relativePath)($.uri,x);return B&&$.name&&(M=`${$.name}/${M}`),M}trySetWorkspaceFolders(R){this._actualWorkspace&&(this._unconfirmedWorkspace=h.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:R,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(R){const{workspace:B,added:x,removed:F}=h.toExtHostWorkspace(R,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=B||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:x,removed:F}))}findFiles(R,B,x,F,$=y.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${F.value}, entryPoint: findFiles`);let M;if(B===null?M=!1:B&&(typeof B=="string"?M=B:M=B.pattern),$&&$.isCancellationRequested)return Promise.resolve([]);const{includePattern:H,folder:N}=E(R);return this._proxy.$startFileSearch((0,I.withUndefinedAsNull)(H),(0,I.withUndefinedAsNull)(N),(0,I.withUndefinedAsNull)(M),(0,I.withUndefinedAsNull)(x),$).then(U=>Array.isArray(U)?U.map(V=>c.URI.revive(V)):[])}async findTextInFiles(R,B,x,F,$=y.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${F.value}, entryPoint: findTextInFiles`);const M=this._requestIdProvider.getNext(),H=typeof B.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:B.previewOptions,{includePattern:N,folder:U}=E(B.include),V=typeof B.exclude=="string"?B.exclude:B.exclude?B.exclude.pattern:void 0,O={ignoreSymlinks:typeof B.followSymlinks=="boolean"?!B.followSymlinks:void 0,disregardIgnoreFiles:typeof B.useIgnoreFiles=="boolean"?!B.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof B.useGlobalIgnoreFiles=="boolean"?!B.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof B.useDefaultExcludes=="boolean"?!B.useDefaultExcludes:!0,fileEncoding:B.encoding,maxResults:B.maxResults,previewOptions:H,afterContext:B.afterContext,beforeContext:B.beforeContext,includePattern:N,excludePattern:V},W=!1;if(this._activeSearchCallbacks[M]=j=>{if(W)return;const X=c.URI.revive(j.resource);j.results.forEach(Q=>{(0,a.resultIsMatch)(Q)?x({uri:X,preview:{text:Q.preview.text,matches:(0,g.mapArrayOrNot)(Q.preview.matches,de=>new m.Range(de.startLineNumber,de.startColumn,de.endLineNumber,de.endColumn))},ranges:(0,g.mapArrayOrNot)(Q.ranges,de=>new m.Range(de.startLineNumber,de.startColumn,de.endLineNumber,de.endColumn))}):x({uri:X,text:Q.text,lineNumber:Q.lineNumber})})},$.isCancellationRequested)return{};try{const j=await this._proxy.$startTextSearch(R,(0,I.withUndefinedAsNull)(U),O,M,$);return delete this._activeSearchCallbacks[M],j||{}}catch(j){throw delete this._activeSearchCallbacks[M],j}}$handleTextSearchResult(R,B){this._activeSearchCallbacks[B]&&this._activeSearchCallbacks[B](R)}saveAll(R){return this._proxy.$saveAll(R)}resolveProxy(R){return this._proxy.$resolveProxy(R)}get trusted(){return this._trusted}requestWorkspaceTrust(R){return this._proxy.$requestWorkspaceTrust(R)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};u=Ve([$e(0,r.IExtHostRpcService),$e(1,s.IExtHostInitDataService),$e(2,w.IExtHostFileSystemInfo),$e(3,v.ILogService)],u),e.ExtHostWorkspace=u,e.IExtHostWorkspace=(0,f.createDecorator)("IExtHostWorkspace");function E(A){let R,B;return A&&(typeof A=="string"?R=A:(R=A.pattern,B=A.baseFolder||c.URI.file(A.base))),{includePattern:R,folder:B}}}),define(fe[37],me([0,1,25,3,36,5,7,194,87,13,16,4,14,11,2]),function(Y,e,g,L,y,C,i,k,_,D,T,I,c,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function v(b,n){if(n){const t=n.split(".");let l=b;for(let d=0;l&&d<t.length;d++)l=l[t[d]];return l}}function S(b){return b instanceof f.URI}function P(b){return b&&b.uri instanceof f.URI&&b.languageId&&typeof b.languageId=="string"}function w(b){return b&&!b.uri&&b.languageId&&typeof b.languageId=="string"}function s(b){return b&&b.uri instanceof f.URI&&(!b.name||typeof b.name=="string")&&(!b.index||typeof b.index=="number")}function r(b){if(S(b))return{resource:b};if(P(b))return{resource:b.uri,overrideIdentifier:b.languageId};if(w(b))return{overrideIdentifier:b.languageId};if(s(b))return{resource:b.uri};if(b===null)return{resource:null}}let m=class{constructor(n,t,l){this._proxy=n.getProxy(C.MainContext.MainThreadConfiguration),this._extHostWorkspace=t,this._logService=l,this._barrier=new T.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(n=>this._actual)}$initializeConfiguration(n){this._actual=new a(this._proxy,this._extHostWorkspace,n,this._logService),this._barrier.open()}$acceptConfigurationChanged(n,t){this.getConfigProvider().then(l=>l.$acceptConfigurationChanged(n,t))}};m=Ve([$e(0,c.IExtHostRpcService),$e(1,y.IExtHostWorkspace),$e(2,p.ILogService)],m),e.ExtHostConfiguration=m;class a{constructor(n,t,l,d){this._onDidChangeConfiguration=new L.Emitter,this._proxy=n,this._logService=d,this._extHostWorkspace=t,this._configuration=k.Configuration.parse(l),this._configurationScopes=this._toMap(l.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(n,t){const l={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=k.Configuration.parse(n),this._configurationScopes=this._toMap(n.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(t,l))}getConfiguration(n,t,l){const d=r(t)||{},o=this._toReadonlyValue(n?v(this._configuration.getValue(void 0,d,this._extHostWorkspace.workspace),n):this._configuration.getValue(void 0,d,this._extHostWorkspace.workspace));n&&this._validateConfigurationAccess(n,d,l?.identifier);function h(E){if(E==null)return null;if(typeof E=="boolean")return E?1:4;switch(E){case i.ConfigurationTarget.Global:return 1;case i.ConfigurationTarget.Workspace:return 4;case i.ConfigurationTarget.WorkspaceFolder:return 5}}const u={has(E){return typeof v(o,E)!="undefined"},get:(E,A)=>{this._validateConfigurationAccess(n?`${n}.${E}`:E,d,l?.identifier);let R=v(o,E);if(typeof R=="undefined")R=A;else{let B;const x=(F,$)=>{let M;const H=()=>{B=B||(0,g.deepClone)(o),M=M||v(B,$)};return(0,D.isObject)(F)?new Proxy(F,{get:(N,U)=>{if(typeof U=="string"&&U.toLowerCase()==="tojson")return H(),()=>M;if(B)return M=M||v(B,$),M[U];const V=N[U];return typeof U=="string"?x(V,`${$}.${U}`):V},set:(N,U,V)=>(H(),M&&(M[U]=V),!0),deleteProperty:(N,U)=>(H(),M&&delete M[U],!0),defineProperty:(N,U,V)=>(H(),M&&Object.defineProperty(M,U,V),!0)}):F};R=x(R,E)}return R},update:(E,A,R,B)=>{E=n?`${n}.${E}`:E;const x=h(R);return A!==void 0?this._proxy.$updateConfigurationOption(x,E,A,d,B):this._proxy.$removeConfigurationOption(x,E,d,B)},inspect:E=>{E=n?`${n}.${E}`:E;const A=(0,g.deepClone)(this._configuration.inspect(E,d,this._extHostWorkspace.workspace));if(A)return{key:E,defaultValue:A.default?.value,globalValue:A.user?.value,workspaceValue:A.workspace?.value,workspaceFolderValue:A.workspaceFolder?.value,defaultLanguageValue:A.default?.override,globalLanguageValue:A.user?.override,workspaceLanguageValue:A.workspace?.override,workspaceFolderLanguageValue:A.workspaceFolder?.override,languageIds:A.overrideIdentifiers}}};return typeof o=="object"&&(0,g.mixin)(u,o,!1),Object.freeze(u)}_toReadonlyValue(n){const t=l=>(0,D.isObject)(l)?new Proxy(l,{get:(d,o)=>t(d[o]),set:(d,o,h)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(o)}' of object`)},deleteProperty:(d,o)=>{throw new Error(`TypeError: Cannot delete read only property '${String(o)}' of object`)},defineProperty:(d,o)=>{throw new Error(`TypeError: Cannot define property '${String(o)}' for a readonly object`)},setPrototypeOf:d=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):l;return t(n)}_validateConfigurationAccess(n,t,l){const d=_.OVERRIDE_PROPERTY_PATTERN.test(n)?4:this._configurationScopes.get(n),o=l?`[${l.value}] `:"";if(d===4){typeof t?.resource=="undefined"&&this._logService.warn(`${o}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${n}', provide the URI of a resource or 'null' for any resource.`);return}if(d===3){t?.resource&&this._logService.warn(`${o}Accessing a window scoped configuration for a resource is not expected. To associate '${n}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(n,t){const l=new k.ConfigurationChangeEvent(n,t,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(d,o)=>l.affectsConfiguration(d,r(o))})}_toMap(n){return n.reduce((t,l)=>(t.set(l[0],l[1]),t),new Map)}}e.ExtHostConfigProvider=a,e.IExtHostConfiguration=(0,I.createDecorator)("IExtHostConfiguration")});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,L,y){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?y.call(Y,g):y?y.value=g:e.set(Y,g),g},Ne=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[73],me([0,1,2,16,3,5,7,36,46,37,21,34,14,26,4,10,12,11,68,216,18]),function(Y,e,g,L,y,C,i,k,_,D,T,I,c,p,f,v,S,P,w,s,r){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var a;(function($){function M(N){if(N!=null)return N}$.from=M;function H(N){if(N!=null)return N}$.to=H})(a=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var b;(function($){function M(N){if(N!=null)return N}$.from=M;function H(N){if(N!=null)return N}$.to=H})(b=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var n;(function($){function M(N){if(N!=null)return N}$.from=M;function H(N){if(N!=null)return N}$.to=H})(n=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var t;(function($){function M(U){if(U){const V=U;return V&&!!V.process}else return!1}$.is=M;function H(U){if(U==null)return;const V={process:U.process,args:U.args};return U.options&&(V.options=n.from(U.options)),V}$.from=H;function N(U){if(U!=null)return new i.ProcessExecution(U.process,U.args,U.options)}$.to=N})(t=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var l;(function($){function M(N){if(N!=null)return N}$.from=M;function H(N){if(N!=null)return N}$.to=H})(l=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var d;(function($){function M(U){if(U){const V=U;return V&&(!!V.commandLine||!!V.command)}else return!1}$.is=M;function H(U){if(U==null)return;const V={};return U.commandLine!==void 0?V.commandLine=U.commandLine:(V.command=U.command,V.args=U.args),U.options&&(V.options=l.from(U.options)),V}$.from=H;function N(U){if(!(U==null||U.command===void 0&&U.commandLine===void 0))return U.commandLine?new i.ShellExecution(U.commandLine,U.options):new i.ShellExecution(U.command,U.args?U.args:[],U.options)}$.to=N})(d=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var o;(function($){function M(U){if(U){let V=U;return V&&V.customExecution==="customExecution"}else return!1}$.is=M;function H(U){return{customExecution:"customExecution"}}$.from=H;function N(U,V){return V.get(U)}$.to=N})(o=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var h;(function($){function M(H,N){let U;return H.scope!==void 0&&typeof H.scope!="number"?U=H.scope.uri:H.scope!==void 0&&typeof H.scope=="number"&&(H.scope===i.TaskScope.Workspace&&N&&N.workspaceFile?U=N.workspaceFile:U=s.USER_TASKS_GROUP_KEY),{id:H._id,workspaceFolder:U}}$.from=M})(h=e.TaskHandleDTO||(e.TaskHandleDTO={}));var u;(function($){function M(H){if(H!=null)return{_id:H.id,isDefault:H.isDefault}}$.from=M})(u=e.TaskGroupDTO||(e.TaskGroupDTO={}));var E;(function($){function M(U,V){if(U==null)return[];const O=[];for(let W of U){const j=H(W,V);j&&O.push(j)}return O}$.fromMany=M;function H(U,V){if(U==null)return;let O;U.execution instanceof i.ProcessExecution?O=t.from(U.execution):U.execution instanceof i.ShellExecution?O=d.from(U.execution):U.execution&&U.execution instanceof i.CustomExecution&&(O=o.from(U.execution));const W=a.from(U.definition);let j;return U.scope?typeof U.scope=="number"?j=U.scope:j=U.scope.uri:j=i.TaskScope.Workspace,!W||!j?void 0:{_id:U._id,definition:W,name:U.name,source:{extensionId:V.identifier.value,label:U.source,scope:j},execution:O,isBackground:U.isBackground,group:u.from(U.group),presentationOptions:b.from(U.presentationOptions),problemMatchers:U.problemMatchers,hasDefinedMatchers:U.hasDefinedMatchers,runOptions:U.runOptions?U.runOptions:{reevaluateOnRerun:!0},detail:U.detail}}$.from=H;async function N(U,V,O){if(U==null)return;let W;t.is(U.execution)?W=t.to(U.execution):d.is(U.execution)?W=d.to(U.execution):o.is(U.execution)&&(W=o.to(U._id,O));const j=a.to(U.definition);let X;if(U.source&&(U.source.scope!==void 0?typeof U.source.scope=="number"?X=U.source.scope:X=await V.resolveWorkspaceFolder(g.URI.revive(U.source.scope)):X=i.TaskScope.Workspace),!j||!X)return;const Q=new i.Task(j,X,U.name,U.source.label,W,U.problemMatchers);return U.isBackground!==void 0&&(Q.isBackground=U.isBackground),U.group!==void 0&&(Q.group=i.TaskGroup.from(U.group._id),Q.group&&U.group.isDefault&&(Q.group=new i.TaskGroup(Q.group.id,Q.group.label),U.group.isDefault&&(Q.group.isDefault=U.group.isDefault))),U.presentationOptions&&(Q.presentationOptions=b.to(U.presentationOptions)),U._id&&(Q._id=U._id),U.detail&&(Q.detail=U.detail),Q}$.to=N})(E=e.TaskDTO||(e.TaskDTO={}));var A;(function($){function M(N){return N}$.from=M;function H(N){if(!!N)return Object.assign(Object.create(null),N)}$.to=H})(A=e.TaskFilterDTO||(e.TaskFilterDTO={}));class R{constructor(M,H,N){this._id=H,this._task=N,m.set(this,void 0),st(this,m,M,"f")}get task(){return this._task}terminate(){Ne(this,m,"f").terminateTask(this)}fireDidStartProcess(M){}fireDidEndProcess(M){}}m=new WeakMap;var B;(function($){function M(H){return{id:H._id,task:void 0}}$.from=M})(B=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let x=class{constructor(M,H,N,U,V,O,W,j){this._onDidExecuteTask=new y.Emitter,this._onDidTerminateTask=new y.Emitter,this._onDidTaskProcessStarted=new y.Emitter,this._onDidTaskProcessEnded=new y.Emitter,this._proxy=M.getProxy(C.MainContext.MainThreadTask),this._workspaceProvider=N,this._editorService=U,this._configurationService=V,this._terminalService=O,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=W,this._deprecationService=j,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(M,H,N){if(!N)return new i.Disposable(()=>{});const U=this.nextHandle();return this._handlers.set(U,{type:H,provider:N,extension:M}),this._proxy.$registerTaskProvider(U,H),new i.Disposable(()=>{this._handlers.delete(U),this._proxy.$unregisterTaskProvider(U)})}registerTaskSystem(M,H){this._proxy.$registerTaskSystem(M,H)}fetchTasks(M){return this._proxy.$fetchTasks(A.from(M)).then(async H=>{const N=[];for(let U of H){const V=await E.to(U,this._workspaceProvider,this._providedCustomExecutions2);V&&N.push(V)}return N})}get taskExecutions(){const M=[];return this._taskExecutions.forEach(H=>M.push(H)),M}terminateTask(M){if(!(M instanceof R))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(M._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(M,H,N){const U=this._providedCustomExecutions2.get(M.id);U&&(this._activeCustomExecutions2.set(M.id,U),this._terminalService.attachPtyToTerminal(H,await U.callback(N))),this._lastStartedTask=M.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(M)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(M){const H=await this.getTaskExecution(M);this._taskExecutionPromises.delete(M.id),this._taskExecutions.delete(M.id),this.customExecutionComplete(M),this._onDidTerminateTask.fire({execution:H})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(M){const H=await this.getTaskExecution(M.id);this._onDidTaskProcessStarted.fire({execution:H,processId:M.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(M){const H=await this.getTaskExecution(M.id);this._onDidTaskProcessEnded.fire({execution:H,exitCode:M.exitCode})}$provideTasks(M,H){const N=this._handlers.get(M);if(!N)return Promise.reject(new Error("no handler found"));const U=[],V=(0,L.asPromise)(()=>N.provider.provideTasks(T.CancellationToken.None)).then(O=>this.provideTasksInternal(H,U,N,O));return new Promise(O=>{V.then(W=>{Promise.all(U).then(()=>{O(W)})})})}async $resolveTask(M,H){const N=this._handlers.get(M);if(!N)return Promise.reject(new Error("no handler found"));if(H.definition.type!==N.type)throw new Error(`Unexpected: Task of type [${H.definition.type}] cannot be resolved by provider of type [${N.type}].`);const U=await E.to(H,this._workspaceProvider,this._providedCustomExecutions2);if(!U)throw new Error("Unexpected: Task cannot be resolved.");const V=await N.provider.resolveTask(U,T.CancellationToken.None);if(!V)return;this.checkDeprecation(V,N);const O=E.from(V,N.extension);if(!O)throw new Error("Unexpected: Task cannot be resolved.");if(V.definition!==U.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return o.is(O.execution)&&await this.addCustomExecution(O,V,!0),await this.resolveTaskInternal(O)}nextHandle(){return this._handleCounter++}async addCustomExecution(M,H,N){const U=await this._proxy.$createTaskId(M);!N&&!this._providedCustomExecutions2.has(U)&&(this._notProvidedCustomExecutions.add(U),this._activeCustomExecutions2.set(U,H.execution)),this._providedCustomExecutions2.set(U,H.execution)}async getTaskExecution(M,H){if(typeof M=="string"){const V=this._taskExecutionPromises.get(M);if(!V)throw new Error("Unexpected: The specified task is missing an execution");return V}let N=this._taskExecutionPromises.get(M.id);if(N)return N;const U=new Promise((V,O)=>{function W(j,X,Q){Q?V(new R(j,X.id,Q)):O("Unexpected: Task does not exist.")}H?W(this,M,H):E.to(M.task,this._workspaceProvider,this._providedCustomExecutions2).then(j=>W(this,M,j))});return this._taskExecutionPromises.set(M.id,U),U.then(V=>(this._taskExecutions.set(M.id,V),V),V=>Promise.reject(V))}checkDeprecation(M,H){M._deprecated&&this._deprecationService.report("Task.constructor",H.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(M){this._activeCustomExecutions2.get(M.id)&&this._activeCustomExecutions2.delete(M.id),this._notProvidedCustomExecutions.has(M.id)&&this._lastStartedTask!==M.id&&(this._providedCustomExecutions2.delete(M.id),this._notProvidedCustomExecutions.delete(M.id));let N=this._notProvidedCustomExecutions.values(),U=N.next();for(;!U.done;)!this._activeCustomExecutions2.has(U.value)&&this._lastStartedTask!==U.value&&(this._providedCustomExecutions2.delete(U.value),this._notProvidedCustomExecutions.delete(U.value)),U=N.next()}};x=Ve([$e(0,c.IExtHostRpcService),$e(1,p.IExtHostInitDataService),$e(2,k.IExtHostWorkspace),$e(3,_.IExtHostDocumentsAndEditors),$e(4,D.IExtHostConfiguration),$e(5,I.IExtHostTerminalService),$e(6,P.ILogService),$e(7,w.IExtHostApiDeprecationService)],x),e.ExtHostTaskBase=x;let F=class extends x{constructor(M,H,N,U,V,O,W,j){super(M,H,N,U,V,O,W,j);this.registerTaskSystem(v.Schemas.vscodeRemote,{scheme:v.Schemas.vscodeRemote,authority:"",platform:S.PlatformToString(0)})}async executeTask(M,H){if(!H.execution)throw new Error("Tasks to execute must include an execution");const N=E.from(H,M);if(N===void 0)throw new Error("Task is not valid");if(o.is(N.execution))await this.addCustomExecution(N,H,!1);else throw new r.NotSupportedError;const U=await this.getTaskExecution(await this._proxy.$getTaskExecution(N),H);return this._proxy.$executeTask(N).catch(V=>{throw new Error(V)}),U}provideTasksInternal(M,H,N,U){const V=[];if(U)for(let O of U){this.checkDeprecation(O,N),(!O.definition||!M[O.definition.type])&&this._logService.warn(`The task [${O.source}, ${O.name}] uses an undefined task type. The task will be ignored in the future.`);const W=E.from(O,N.extension);W&&o.is(W.execution)?(V.push(W),H.push(this.addCustomExecution(W,O,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:V,extension:N.extension}}async resolveTaskInternal(M){if(o.is(M.execution))return M;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(M,H){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(M,H,N){}};F=Ve([$e(0,c.IExtHostRpcService),$e(1,p.IExtHostInitDataService),$e(2,k.IExtHostWorkspace),$e(3,_.IExtHostDocumentsAndEditors),$e(4,D.IExtHostConfiguration),$e(5,I.IExtHostTerminalService),$e(6,P.ILogService),$e(7,w.IExtHostApiDeprecationService)],F),e.WorkerExtHostTask=F,e.IExtHostTask=(0,f.createDecorator)("IExtHostTask")}),define(fe[270],me([0,1,15,59,31,81,24,10,9,23,8,13,2,146,177,119,44,128,269,33]),function(Y,e,g,L,y,C,i,k,_,D,T,I,c,p,f,v,S,P,w,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let r=class{constructor(h,u,E,A){this.configurationService=h,this.workspaceContextService=u,this.editorGroupsService=E,this.pathService=A}text(h,u,E={}){h=this.getContentPattern(h,E);const A=this.configurationService.getValue(),R=u&&u.some(x=>!this.configurationService.getValue({resource:x}).search.useRipgrep);return{...this.commonQuery(u?.map(S.toWorkspaceFolder),E),type:2,contentPattern:h,previewOptions:E.previewOptions,maxFileSize:E.maxFileSize,usePCRE2:A.search.usePCRE2||R||!1,beforeContext:E.beforeContext,afterContext:E.afterContext,userDisabledExcludesAndIgnoreFiles:E.disregardExcludeSettings&&E.disregardIgnoreFiles}}getContentPattern(h,u){const E=this.configurationService.getValue();h.isRegExp&&(h.pattern=h.pattern.replace(/\r?\n/g,"\\n"));const A={...h,wordSeparators:E.editor.wordSeparators};return this.isCaseSensitive(h,u)&&(A.isCaseSensitive=!0),this.isMultiline(h)&&(A.isMultiline=!0),A}file(h,u={}){return{...this.commonQuery(h,u),type:1,filePattern:u.filePattern?u.filePattern.trim():u.filePattern,exists:u.exists,sortByScore:u.sortByScore,cacheKey:u.cacheKey}}handleIncludeExclude(h,u){return h?(h=Array.isArray(h)?h.map(t):t(h),u?this.parseSearchPaths(h):{pattern:a(...Array.isArray(h)?h:[h])}):{}}commonQuery(h=[],u={}){const E=this.handleIncludeExclude(u.includePattern,u.expandPatterns),A=this.handleIncludeExclude(u.excludePattern,u.expandPatterns),R=h.length>1,B=(E.searchPaths&&E.searchPaths.length?E.searchPaths.map($=>this.getFolderQueryForSearchPath($,u,A)):h.map($=>this.getFolderQueryForRoot($,u,A,R))).filter($=>!!$),x={_reason:u._reason,folderQueries:B,usingSearchPaths:!!(E.searchPaths&&E.searchPaths.length),extraFileResources:u.extraFileResources,excludePattern:A.pattern,includePattern:E.pattern,onlyOpenEditors:u.onlyOpenEditors,maxResults:u.maxResults};if(u.onlyOpenEditors){const M=g.coalesce(g.flatten(this.editorGroupsService.groups.map(N=>N.editors.map(U=>U.resource)))).filter(N=>(0,s.pathIncludedInQuery)(x,N.fsPath)),H=this.commonQueryFromFileList(M);return{...x,...H}}const F=u.extraFileResources&&u.extraFileResources.filter($=>(0,s.pathIncludedInQuery)(x,$.fsPath));return x.extraFileResources=F&&F.length?F:void 0,x}commonQueryFromFileList(h){const u=[],E=new i.ResourceMap,A={};let R=!1;return h.forEach(B=>{if(B.scheme===k.Schemas.walkThrough)return;if((0,D.isAbsolutePath)(B)){const F=this.workspaceContextService.getWorkspaceFolder(B)?.uri??B.with({path:_.dirname(B.fsPath)});let $=E.get(F);$||(R=!0,$={folder:F,includePattern:{}},u.push($),E.set(F,$));const M=_.relative(F.fsPath,B.fsPath);(0,I.assertIsDefined)($.includePattern)[M.replace(/\\/g,"/")]=!0}else B.fsPath&&(R=!0,A[B.fsPath]=!0)}),{folderQueries:u,includePattern:A,usingSearchPaths:!0,excludePattern:R?void 0:{"**/*":!0}}}isCaseSensitive(h,u){if(u.isSmartCase){if(h.isRegExp){if(T.containsUppercaseCharacter(h.pattern,!0))return!0}else if(T.containsUppercaseCharacter(h.pattern))return!0}return!!h.isCaseSensitive}isMultiline(h){return h.isMultiline||h.isRegExp&&(0,p.isMultilineRegexSource)(h.pattern)||h.pattern.indexOf(`
`)>=0?!0:!!h.isMultiline}parseSearchPaths(h){const u=H=>_.isAbsolute(H)||/^\.\.?([\/\\]|$)/.test(H),A=(Array.isArray(h)?h:b(h)).map(H=>{const N=this.pathService.resolvedUserHome;return N?(0,C.untildify)(H,N.scheme===k.Schemas.file?N.fsPath:N.path):H}),R=L.groupBy(A,H=>u(H)?"searchPaths":"exprSegments"),B=(R.exprSegments||[]).map(H=>T.rtrim(H,"/")).map(H=>T.rtrim(H,"\\")).map(H=>(H[0]==="."&&(H="*"+H),n(H))),x={},F=this.expandSearchPathPatterns(R.searchPaths||[]);F&&F.length&&(x.searchPaths=F);const $=g.flatten(B),M=a(...$);return M&&(x.pattern=M),x}getExcludesForFolder(h,u){return u.disregardExcludeSettings?void 0:(0,s.getExcludes)(h,!u.disregardSearchExcludeSettings)}expandSearchPathPatterns(h){if(!h||!h.length)return[];const u=g.flatten(h.map(A=>{let{pathPortion:R,globPortion:B}=m(A);B&&(B=l(B));const x=this.expandOneSearchPath(R);return g.flatten(x.map(F=>this.resolveOneSearchPathPattern(F,B)))})),E=new Map;return u.forEach(A=>{const R=A.searchPath.toString(),B=E.get(R);B?A.pattern&&(B.pattern=B.pattern||{},B.pattern[A.pattern]=!0):E.set(R,{searchPath:A.searchPath,pattern:A.pattern?a(A.pattern):void 0})}),Array.from(E.values())}expandOneSearchPath(h){if(_.isAbsolute(h)){const u=this.workspaceContextService.getWorkspace().folders;return u[0]&&u[0].uri.scheme!==k.Schemas.file?[{searchPath:u[0].uri.with({path:h})}]:[{searchPath:c.URI.file(_.normalize(h))}]}if(this.workspaceContextService.getWorkbenchState()===2){const u=this.workspaceContextService.getWorkspace().folders[0].uri;if(h=t(h),h.startsWith("../")||h===".."){const A=_.posix.resolve(u.path,h);return[{searchPath:u.with({path:A})}]}const E=l(h);return[{searchPath:u,pattern:E}]}else{if(h==="./"||h===".\\")return[];{const u=h.replace(/^\.[\/\\]/,""),A=this.workspaceContextService.getWorkspace().folders.map(R=>{const B=u.match(new RegExp(`^${T.escapeRegExpCharacters(R.name)}(?:/(.*)|$)`));return B?{match:B,folder:R}:null}).filter(I.isDefined);if(A.length)return A.map(R=>{const B=R.match[1];return{searchPath:R.folder.uri,pattern:B&&l(B)}});{const R=h.match(/\.[\/\\](.+)[\/\\]?/),B=R?R[1]:h,x=f.localize(0,null,B);throw new Error(x)}}}}resolveOneSearchPathPattern(h,u){const E=h.pattern&&u?`${h.pattern}/${u}`:h.pattern||u,A=[{searchPath:h.searchPath,pattern:E}];return E&&!E.endsWith("**")&&A.push({searchPath:h.searchPath,pattern:E+"/**"}),A}getFolderQueryForSearchPath(h,u,E){const A=this.getFolderQueryForRoot((0,S.toWorkspaceFolder)(h.searchPath),u,E,!1);return A?{...A,includePattern:h.pattern}:null}getFolderQueryForRoot(h,u,E,A){let R;const B=c.URI.isUri(h)?h:h.uri;if(E.searchPaths){const H=E.searchPaths.filter(N=>(0,D.isEqual)(N.searchPath,B))[0];if(H&&!H.pattern)return null;H&&(R=H.pattern)}const x=this.configurationService.getValue({resource:B}),$={...this.getExcludesForFolder(x,u)||{},...R||{}},M=c.URI.isUri(h)?(0,D.basename)(h):h.name;return{folder:B,folderName:A?M:void 0,excludePattern:Object.keys($).length>0?$:void 0,fileEncoding:x.files&&x.files.encoding,disregardIgnoreFiles:typeof u.disregardIgnoreFiles=="boolean"?u.disregardIgnoreFiles:!x.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof u.disregardGlobalIgnoreFiles=="boolean"?u.disregardGlobalIgnoreFiles:!x.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof u.ignoreSymlinks=="boolean"?u.ignoreSymlinks:!x.search.followSymlinks}}};r=Ve([$e(0,v.IConfigurationService),$e(1,S.IWorkspaceContextService),$e(2,P.IEditorGroupsService),$e(3,w.IPathService)],r),e.QueryBuilder=r;function m(o){const h=o.match(/[\*\{\}\(\)\[\]\?]/);if(h){const u=h.index,E=o.substr(0,u).match(/[/|\\][^/\\]*$/);if(E){let A=o.substr(0,E.index);return A.match(/[/\\]/)||(A+="/"),{pathPortion:A,globPortion:o.substr((E.index||0)+1)}}}return{pathPortion:o}}function a(...o){return o.length?o.reduce((h,u)=>(h[u]=!0,h),Object.create(null)):void 0}function b(o){return y.splitGlobAware(o,",").map(h=>h.trim()).filter(h=>!!h.length)}function n(o){return[`**/${o}/**`,`**/${o}`].map(u=>u.replace(/\*\*\/\*\*/g,"**"))}function t(o){return o.replace(/\\/g,"/")}function l(o){return t(o).replace(/^\.\//,"").replace(/\/+$/g,"")}function d(o,h){o=g.distinct(o,A=>A.toString());const u=[],E=h.getWorkspace();return o&&o.forEach(A=>{let R;if(h.getWorkbenchState()===2)R=(0,D.relativePath)(E.folders[0].uri,A),R&&R!=="."&&(R="./"+R);else{const B=h.getWorkspaceFolder(A);if(B){const x=B.name;if(E.folders.filter($=>$.name===x).length===1){const $=(0,D.relativePath)(B.uri,A);$===""?R=`./${B.name}`:R=`./${B.name}/${$}`}else R=A.fsPath}}R&&u.push(R)}),u}e.resolveResourcesForSearchIncludes=d}),define(fe[271],me([0,1,23,2,21,18,4,270,33,44]),function(Y,e,g,L,y,C,i,k,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const T=7e3;function I(v,S){const P=S.activationEvents;if(!P)return Promise.resolve(void 0);const w=[],s=[];for(const t of P)if(/^workspaceContains:/.test(t)){const l=t.substr("workspaceContains:".length);l.indexOf("*")>=0||l.indexOf("?")>=0||v.forceUsingSearch?s.push(l):w.push(l)}if(w.length===0&&s.length===0)return Promise.resolve(void 0);let r;const m=new Promise((t,l)=>{r=t}),a=t=>r({activationEvent:t}),b=Promise.all(w.map(t=>c(v,t,a))).then(()=>{}),n=p(v,S.identifier,s,a);return Promise.all([b,n]).then(()=>{r(void 0)}),m}e.checkActivateWorkspaceContainsExtension=I;async function c(v,S,P){for(const w of v.folders)if(await v.exists(g.joinPath(L.URI.revive(w),S))){P(`workspaceContains:${S}`);return}}async function p(v,S,P,w){if(P.length===0)return Promise.resolve(void 0);const s=new y.CancellationTokenSource,r=v.checkExists(v.folders,P,s.token),m=setTimeout(async()=>{s.cancel(),w(`workspaceContainsTimeout:${P.join(",")}`)},T);let a=!1;try{a=await r}catch(b){C.isPromiseCanceledError(b)||C.onUnexpectedError(b)}s.dispose(),clearTimeout(m),a&&w(`workspaceContains:${P.join(",")}`)}function f(v,S,P,w){const s=v.get(i.IInstantiationService),r=v.get(_.ISearchService),a=s.createInstance(k.QueryBuilder).file(S.map(b=>(0,D.toWorkspaceFolder)(L.URI.revive(b))),{_reason:"checkExists",includePattern:P,exists:!0});return r.fileSearch(a,w).then(b=>!!b.limitHit,b=>C.isPromiseCanceledError(b)?!1:Promise.reject(b))}e.checkGlobFileExists=f});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,L,y){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?y.call(Y,g):y?y.value=g:e.set(Y,g),g},Ne=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[41],me([0,1,165,9,74,23,16,6,24,2,11,5,37,229,92,36,29,227,18,27,22,201,7,120,4,26,70,14,86,54,34,3,271,91,203,10]),function(Y,e,g,L,y,C,i,k,_,D,T,I,c,p,f,v,S,P,w,s,r,m,a,b,n,t,l,d,o,h,u,E,A,R,B,x){"use strict";var F,$,M;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,n.createDecorator)("IHostUtils");let H=class zi extends k.Disposable{constructor(O,W,j,X,Q,de,Se,De,Pe,Be){super();this._onDidChangeRemoteConnectionData=this._register(new E.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=W,this._extHostContext=j,this._initData=Se,this._extHostWorkspace=X,this._extHostConfiguration=Q,this._logService=de,this._extHostTunnelService=Pe,this._extHostTerminalService=Be,this._disposables=new k.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(I.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(I.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(I.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new i.Barrier,this._readyToStartExtensionHost=new i.Barrier,this._readyToRunExtensions=new i.Barrier,this._eagerExtensionsActivated=new i.Barrier,this._registry=new P.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new f.ExtHostStorage(this._extHostContext),this._secretState=new R.ExtHostSecretState(this._extHostContext),this._storagePath=De,this._instaService=O.createChild(new o.ServiceCollection([f.IExtHostStorage,this._storage],[R.IExtHostSecretState,this._secretState]));const We=new Set;this._initData.hostExtensions.forEach(He=>We.add(s.ExtensionIdentifier.toKey(He))),this._activator=new p.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(He,G,ee)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(He,w.transformErrorForSerialization(G),ee)},actualActivateExtension:async(He,G)=>{if(We.has(s.ExtensionIdentifier.toKey(He)))return await this._mainThreadExtensionsProxy.$activateExtension(He,G),new p.HostExtension;const ee=this._registry.getExtensionDescription(He);return this._activateExtension(ee,G)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),y.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(O){w.onUnexpectedError(O)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let O=[];try{O=this._registry.getAllExtensionDescriptions().map(Q=>Q.identifier).filter(Q=>this.isActivated(Q)).map(Q=>this._deactivate(Q))}catch(W){}await Promise.all(O)}isActivated(O){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(O):!1}_activateByEvent(O,W){return this._activator.activateByEvent(O,W)}_activateById(O,W){return this._activator.activateById(O,W)}activateByIdWithErrors(O,W){return this._activateById(O,W).then(()=>{const j=this._activator.getActivatedExtension(O);if(j.activationFailed)return Promise.reject(j.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(O=>this._registry)}getExtensionExports(O){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(O).exports:null}async _realPathExtensionUri(O){if(O.scheme!==x.Schemas.file)return O;const W=await this._hostUtils.realpath(O.fsPath);return D.URI.file(W)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const O=_.TernarySearchTree.forUris(W=>C.extUriBiasedIgnorePathCase.ignorePathCasing(W));for(const W of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint(W)){const j=await this._realPathExtensionUri(W.extensionLocation);O.set(j,W)}return O})()),this._extensionPathIndex}_deactivate(O){let W=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(O))return W;const j=this._activator.getActivatedExtension(O);if(!j)return W;try{typeof j.module.deactivate=="function"&&(W=Promise.resolve(j.module.deactivate()).then(void 0,X=>(this._logService.error(X),Promise.resolve(void 0))))}catch(X){this._logService.error(X)}try{(0,k.dispose)(j.subscriptions)}catch(X){this._logService.error(X)}return W}async _activateExtension(O,W){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(O.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(O.identifier),this._doActivateExtension(O,W).then(j=>{const X=j.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(O.identifier,X.codeLoadingTime,X.activateCallTime,X.activateResolvedTime,W),this._logExtensionActivationTimes(O,W,"success",X),j},j=>{throw this._logExtensionActivationTimes(O,W,"failure"),j})}_logExtensionActivationTimes(O,W,j,X){const Q=N(O,W);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...Q,...X||{},outcome:j})}_doActivateExtension(O,W){const j=N(O,W);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",j);const X=this._getEntryPoint(O);if(!X)return Promise.resolve(new p.EmptyExtension(p.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${O.identifier.value}, startup: ${W.startup}, activationEvent: '${W.activationEvent}'${O.identifier.value!==W.extensionId.value?`, root cause: ${W.extensionId.value}`:""}`),this._logService.flush();const Q=new p.ExtensionActivationTimesBuilder(W.startup);return Promise.all([this._loadCommonJSModule(O.identifier,(0,C.joinPath)(O.extensionLocation,X),Q),this._loadExtensionContext(O)]).then(de=>(y.mark(`code/extHost/willActivateExtension/${O.identifier.value}`),zi._callActivate(this._logService,O.identifier,de[0],de[1],Q))).then(de=>(y.mark(`code/extHost/didActivateExtension/${O.identifier.value}`),de))}_loadExtensionContext(O){const W=new m.ExtensionGlobalMemento(O,this._storage),j=new m.ExtensionMemento(O.identifier.value,!1,this._storage),X=new B.ExtensionSecrets(O,this._secretState),Q=O.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?a.ExtensionMode.Test:a.ExtensionMode.Development:a.ExtensionMode.Production,de=this._initData.remote.isRemote?a.ExtensionKind.Workspace:a.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${O.identifier.value}`),Promise.all([W.whenReady,j.whenReady,this._storagePath.whenReady]).then(()=>{const Se=this;let De;return Object.freeze({globalState:W,workspaceState:j,secrets:X,subscriptions:[],get extensionUri(){return O.extensionLocation},get extensionPath(){return O.extensionLocation.fsPath},asAbsolutePath(Pe){return L.join(O.extensionLocation.fsPath,Pe)},get storagePath(){return Se._storagePath.workspaceValue(O)?.fsPath},get globalStoragePath(){return Se._storagePath.globalValue(O).fsPath},get logPath(){return L.join(Se._initData.logsLocation.fsPath,O.identifier.value)},get logUri(){return D.URI.joinPath(Se._initData.logsLocation,O.identifier.value)},get storageUri(){return Se._storagePath.workspaceValue(O)},get globalStorageUri(){return Se._storagePath.globalValue(O)},get extensionMode(){return Q},get extension(){return De===void 0&&(De=new U(Se,O.identifier,O,de)),De},get extensionRuntime(){return(0,S.checkProposedApiEnabled)(O,"extensionRuntime"),Se.extensionRuntime},get environmentVariableCollection(){return Se._extHostTerminalService.getEnvironmentVariableCollection(O)}})})}static _callActivate(O,W,j,X,Q){return j=j||{activate:void 0,deactivate:void 0},this._callActivateOptional(O,W,j,X,Q).then(de=>new p.ActivatedExtension(!1,null,Q.build(),j,de,X.subscriptions))}static _callActivateOptional(O,W,j,X,Q){if(typeof j.activate=="function")try{Q.activateCallStart(),O.trace(`ExtensionService#_callActivateOptional ${W.value}`);const de=typeof global=="object"?global:self,Se=j.activate.apply(de,[X]);return Q.activateCallStop(),Q.activateResolveStart(),Promise.resolve(Se).then(De=>(Q.activateResolveStop(),De))}catch(de){return Promise.reject(de)}else return Promise.resolve(j)}_activateOneStartupFinished(O,W){this._activateById(O.identifier,{startup:!1,extensionId:O.identifier,activationEvent:W}).then(void 0,j=>{this._logService.error(j)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(y.getMarks());for(const O of this._registry.getAllExtensionDescriptions())if(O.activationEvents)for(const W of O.activationEvents)W==="onStartupFinished"&&this._activateOneStartupFinished(O,W)}_handleEagerExtensions(){const O=this._activateByEvent("*",!0).then(void 0,Q=>{this._logService.error(Q)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(Q=>this._handleWorkspaceContainsEagerExtensions(Q.added)));const W=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],j=this._handleWorkspaceContainsEagerExtensions(W),X=Promise.all([O,j]).then(()=>{});return Promise.race([X,(0,i.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),X}_handleWorkspaceContainsEagerExtensions(O){return O.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(W=>this._handleWorkspaceContainsEagerExtension(O,W))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(O,W){if(this.isActivated(W.identifier))return;const j=!this._initData.remote.isRemote&&!!this._initData.remote.authority,X={folders:O.map(de=>de.uri),forceUsingSearch:j,exists:de=>this._hostUtils.exists(de.fsPath),checkExists:(de,Se,De)=>this._mainThreadWorkspaceProxy.$checkExists(de,Se,De)},Q=await(0,A.checkActivateWorkspaceContainsExtension)(X,W);if(!!Q)return this._activateById(W.identifier,{startup:!0,extensionId:W.identifier,activationEvent:Q.activationEvent}).then(void 0,de=>this._logService.error(de))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(O){throw console.error(O),O}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:O,extensionTestsLocationURI:W}=this._initData.environment;if(!O||!W)throw new Error(g.localize(0,null));const j=await this._loadCommonJSModule(null,W,new p.ExtensionActivationTimesBuilder(!1));if(!j||typeof j.run!="function")throw new Error(g.localize(1,null,W.toString()));return new Promise((X,Q)=>{const de=(Pe,Be)=>{Pe?Q(Pe):X(typeof Be=="number"&&Be>0?1:0)},Se=(0,C.originalFSPath)(W),De=j.run(Se,de);De&&De.then&&De.then(()=>{X(0)}).catch(Pe=>{Q(Pe.toString())})})}async $extensionTestsExit(O){this._logService.info(`Extension host terminating: test runner requested exit with code ${O}`),this._hostUtils.pid&&this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${O}`),this._logService.flush(),this._hostUtils.exit(O)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(O,W){return this._resolvers[O]=W,(0,k.toDisposable)(()=>{delete this._resolvers[O]})}async _activateAndGetResolver(O){const W=O.indexOf("+");if(W===-1)throw new Error("Not an authority that can be resolved!");const j=O.substr(0,W);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${j}`,!1),{authorityPrefix:j,resolver:this._resolvers[j]}}async $resolveAuthority(O,W){const{authorityPrefix:j,resolver:X}=await this._activateAndGetResolver(O);if(!X)return{type:"error",error:{code:b.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${j}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(X)),y.mark(`code/extHost/willResolveAuthority/${j}`);const Q=await X.resolve(O,{resolveAttempt:W});y.mark(`code/extHost/didResolveAuthorityOK/${j}`);const de={authority:O,host:Q.host,port:Q.port,connectionToken:Q.connectionToken},Se={extensionHostEnv:Q.extensionHostEnv,isTrusted:Q.isTrusted,authenticationSession:Q.authenticationSession?{id:Q.authenticationSession.id,providerId:Q.authenticationSession.providerId}:void 0};return{type:"ok",value:{authority:de,options:Se,tunnelInformation:{environmentTunnels:Q.environmentTunnels}}}}catch(Q){if(y.mark(`code/extHost/didResolveAuthorityError/${j}`),Q instanceof a.RemoteAuthorityResolverError)return{type:"error",error:{code:Q._code,message:Q._message,detail:Q._detail}};throw Q}}async $getCanonicalURI(O,W){const{authorityPrefix:j,resolver:X}=await this._activateAndGetResolver(O);if(!X)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${j}`);const Q=D.URI.revive(W);if(typeof X.getCanonicalURI=="undefined")return Q;const de=await(0,i.asPromise)(()=>X.getCanonicalURI(Q));return de||Q}$startExtensionHost(O){return this._registry.keepOnly(O),this._startExtensionHost()}$activateByEvent(O,W){return W===1?this._activateByEvent(O,!1):this._readyToRunExtensions.wait().then(j=>this._activateByEvent(O,!1))}async $activate(O,W){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(O)?(await this._activateById(O,W),!0):!1}async $deltaExtensions(O,W){O.forEach(X=>X.extensionLocation=D.URI.revive(X.extensionLocation));const j=await this.getExtensionPathIndex();return await Promise.all(W.map(async X=>{const Q=this._registry.getExtensionDescription(X);Q&&j.delete(await this._realPathExtensionUri(Q.extensionLocation))})),await Promise.all(O.map(async X=>{const Q=await this._realPathExtensionUri(X.extensionLocation);j.set(Q,X)})),this._registry.deltaExtensions(O,W),Promise.resolve(void 0)}async $test_latency(O){return O}async $test_up(O){return O.byteLength}async $test_down(O){let W=r.VSBuffer.alloc(O),j=Math.random()%256;for(let X=0;X<O;X++)W.writeUInt8(j,X);return W}async $updateRemoteConnectionData(O){this._remoteConnectionData=O,this._onDidChangeRemoteConnectionData.fire()}};H=Ve([$e(0,n.IInstantiationService),$e(1,e.IHostUtils),$e(2,d.IExtHostRpcService),$e(3,v.IExtHostWorkspace),$e(4,c.IExtHostConfiguration),$e(5,T.ILogService),$e(6,t.IExtHostInitDataService),$e(7,l.IExtensionStoragePaths),$e(8,h.IExtHostTunnelService),$e(9,u.IExtHostTerminalService)],H),e.AbstractExtHostExtensionService=H;function N(V,O){return{id:V.identifier.value,name:V.name,extensionVersion:V.version,publisherDisplayName:V.publisher,activationEvents:V.activationEvents?V.activationEvents.join(","):null,isBuiltin:V.isBuiltin,reason:O.activationEvent,reasonId:O.extensionId.value}}e.IExtHostExtensionService=(0,n.createDecorator)("IExtHostExtensionService");class U{constructor(O,W,j,X){F.set(this,void 0),$.set(this,void 0),M.set(this,void 0),st(this,F,O,"f"),st(this,$,W,"f"),st(this,M,j.identifier,"f"),this.id=j.identifier.value,this.extensionUri=j.extensionLocation,this.extensionPath=L.normalize((0,C.originalFSPath)(j.extensionLocation)),this.packageJSON=j,this.extensionKind=X}get isActive(){return Ne(this,F,"f").isActivated(Ne(this,M,"f"))}get exports(){if(this.packageJSON.api!=="none")return Ne(this,F,"f").getExtensionExports(Ne(this,M,"f"))}activate(){return Ne(this,F,"f").activateByIdWithErrors(Ne(this,M,"f"),{startup:!1,extensionId:Ne(this,$,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=U,F=new WeakMap,$=new WeakMap,M=new WeakMap}),define(fe[57],me([0,1,9,2,3,16,5,7,124,36,41,46,218,37,211,14,4,13,38,56]),function(Y,e,g,L,y,C,i,k,_,D,T,I,c,p,f,v,S,P,w,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,S.createDecorator)("IExtHostDebugService");let r=class{constructor(o,h,u,E,A,R){this._workspaceService=h,this._extensionService=u,this._editorsService=E,this._configurationService=A,this._editorTabs=R,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new y.Emitter,this._onDidTerminateDebugSession=new y.Emitter,this._onDidChangeActiveDebugSession=new y.Emitter,this._onDidReceiveDebugSessionCustomEvent=new y.Emitter,this._debugServiceProxy=o.getProxy(i.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new y.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new a(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(B=>{B.onDidChange(x=>{this.registerAllDebugTypes(B)}),this.registerAllDebugTypes(B)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(o,h){const u=o;if(typeof u.sourceReference=="number"&&u.sourceReference>0){let E=`debug:${encodeURIComponent(u.path||"")}`,A="?";return h&&(E+=`${A}session=${encodeURIComponent(h.id)}`,A="&"),E+=`${A}ref=${u.sourceReference}`,L.URI.parse(E)}else{if(u.path)return L.URI.file(u.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(o){const h=[];for(const u of o.getAllExtensionDescriptions())if(u.contributes){const E=u.contributes.debuggers;if(E&&E.length>0)for(const A of E)(0,f.isDebuggerMainContribution)(A)&&h.push(A.type)}this._debugServiceProxy.$registerDebugTypes(h)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const o=[];return this._breakpoints.forEach(h=>o.push(h)),o}addBreakpoints(o){this.startBreakpoints();const h=o.filter(A=>{const R=A.id;return this._breakpoints.has(R)?!1:(this._breakpoints.set(R,A),!0)});this.fireBreakpointChanges(h,[],[]);const u=[],E=new Map;for(const A of h)if(A instanceof k.SourceBreakpoint){let R=E.get(A.location.uri.toString());R||(R={type:"sourceMulti",uri:A.location.uri,lines:[]},E.set(A.location.uri.toString(),R),u.push(R)),R.lines.push({id:A.id,enabled:A.enabled,condition:A.condition,hitCondition:A.hitCondition,logMessage:A.logMessage,line:A.location.range.start.line,character:A.location.range.start.character})}else A instanceof k.FunctionBreakpoint&&u.push({type:"function",id:A.id,enabled:A.enabled,hitCondition:A.hitCondition,logMessage:A.logMessage,condition:A.condition,functionName:A.functionName});return this._debugServiceProxy.$registerBreakpoints(u)}removeBreakpoints(o){this.startBreakpoints();const h=o.filter(R=>this._breakpoints.delete(R.id));this.fireBreakpointChanges([],h,[]);const u=h.filter(R=>R instanceof k.SourceBreakpoint).map(R=>R.id),E=h.filter(R=>R instanceof k.FunctionBreakpoint).map(R=>R.id),A=h.filter(R=>R instanceof k.DataBreakpoint).map(R=>R.id);return this._debugServiceProxy.$unregisterBreakpoints(u,E,A)}startDebugging(o,h,u){return this._debugServiceProxy.$startDebugging(o?o.uri:void 0,h,{parentSessionID:u.parentSession?u.parentSession.id:void 0,lifecycleManagedByParent:u.lifecycleManagedByParent,repl:u.consoleMode===k.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:u.noDebug,compact:u.compact,debugUI:u.debugUI,suppressSaveBeforeStart:u.suppressSaveBeforeStart})}stopDebugging(o){return this._debugServiceProxy.$stopDebugging(o?o.id:void 0)}registerDebugConfigurationProvider(o,h,u){if(!h)return new k.Disposable(()=>{});const E=this._configProviderHandleCounter++;return this._configProviders.push({type:o,handle:E,provider:h}),this._debugServiceProxy.$registerDebugConfigurationProvider(o,u,!!h.provideDebugConfigurations,!!h.resolveDebugConfiguration,!!h.resolveDebugConfigurationWithSubstitutedVariables,E),new k.Disposable(()=>{this._configProviders=this._configProviders.filter(A=>A.provider!==h),this._debugServiceProxy.$unregisterDebugConfigurationProvider(E)})}registerDebugAdapterDescriptorFactory(o,h,u){if(!u)return new k.Disposable(()=>{});if(!this.definesDebugType(o,h))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${h}' debugger.`);if(this.getAdapterDescriptorFactoryByType(h))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const E=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:h,handle:E,factory:u}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(h,E),new k.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(A=>A.factory!==u),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(E)})}registerDebugAdapterTrackerFactory(o,h){if(!h)return new k.Disposable(()=>{});const u=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:o,handle:u,factory:h}),new k.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(E=>E.factory!==h)})}async $runInTerminal(o,h){return Promise.resolve(void 0)}async $substituteVariables(o,h){if(!this._variableResolver){const[A,R]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(A||[],this._editorsService,R)}let u;const E=await this.getFolder(o);return E&&(u={uri:E.uri,name:E.name,index:E.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(u,h)}createDebugAdapter(o,h){if(o.type==="implementation")return new t(o.implementation)}createSignService(){}async $startDASession(o,h){const u=this,E=await this.getSession(h);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(E.type),E).then(A=>{if(!A)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${E.type}' (extension might have failed to activate)`);const R=this.convertToDto(A),B=this.createDebugAdapter(R,E);if(!B)throw new Error(`Couldn't create a debug adapter for type '${E.type}'.`);const x=B;return this._debugAdapters.set(o,x),this.getDebugAdapterTrackers(E).then(F=>(F&&this._debugAdaptersTrackers.set(o,F),x.onMessage(async $=>{if($.type==="request"&&$.command==="handshake"){const M=$,H={type:"response",seq:0,command:M.command,request_seq:M.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const N=await this._signService.sign(M.arguments.value);H.body={signature:N},x.sendResponse(H)}else throw new Error("no signer")}catch(N){H.success=!1,H.message=N.message,x.sendResponse(H)}}else F&&F.onDidSendMessage&&F.onDidSendMessage($),$=(0,f.convertToVSCPaths)($,!0),u._debugServiceProxy.$acceptDAMessage(o,$)}),x.onError($=>{F&&F.onError&&F.onError($),this._debugServiceProxy.$acceptDAError(o,$.name,$.message,$.stack)}),x.onExit($=>{F&&F.onExit&&F.onExit((0,P.withNullAsUndefined)($),void 0),this._debugServiceProxy.$acceptDAExit(o,(0,P.withNullAsUndefined)($),void 0)}),F&&F.onWillStartSession&&F.onWillStartSession(),x.startSession()))})}$sendDAMessage(o,h){h=(0,f.convertToDAPaths)(h,!1);const u=this._debugAdaptersTrackers.get(o);u&&u.onWillReceiveMessage&&u.onWillReceiveMessage(h);const E=this._debugAdapters.get(o);E&&E.sendMessage(h)}$stopDASession(o){const h=this._debugAdaptersTrackers.get(o);this._debugAdaptersTrackers.delete(o),h&&h.onWillStopSession&&h.onWillStopSession();const u=this._debugAdapters.get(o);return this._debugAdapters.delete(o),u?u.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(o){const h=[],u=[],E=[];if(o.added)for(const A of o.added){const R=A.id;if(R&&!this._breakpoints.has(R)){let B;if(A.type==="function")B=new k.FunctionBreakpoint(A.functionName,A.enabled,A.condition,A.hitCondition,A.logMessage);else if(A.type==="data")B=new k.DataBreakpoint(A.label,A.dataId,A.canPersist,A.enabled,A.hitCondition,A.condition,A.logMessage);else{const x=L.URI.revive(A.uri);B=new k.SourceBreakpoint(new k.Location(x,new k.Position(A.line,A.character)),A.enabled,A.condition,A.hitCondition,A.logMessage)}B._id=R,this._breakpoints.set(R,B),h.push(B)}}if(o.removed)for(const A of o.removed){const R=this._breakpoints.get(A);R&&(this._breakpoints.delete(A),u.push(R))}if(o.changed){for(const A of o.changed)if(A.id){const R=this._breakpoints.get(A.id);if(R){if(R instanceof k.FunctionBreakpoint&&A.type==="function"){const B=R;B.enabled=A.enabled,B.condition=A.condition,B.hitCondition=A.hitCondition,B.logMessage=A.logMessage,B.functionName=A.functionName}else if(R instanceof k.SourceBreakpoint&&A.type==="source"){const B=R;B.enabled=A.enabled,B.condition=A.condition,B.hitCondition=A.hitCondition,B.logMessage=A.logMessage,B.location=new k.Location(L.URI.revive(A.uri),new k.Position(A.line,A.character))}E.push(R)}}}this.fireBreakpointChanges(h,u,E)}$provideDebugConfigurations(o,h,u){return(0,C.asPromise)(async()=>{const E=this.getConfigProviderByHandle(o);if(!E)throw new Error("no DebugConfigurationProvider found");if(!E.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const A=await this.getFolder(h);return E.provideDebugConfigurations(A,u)}).then(E=>{if(!E)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return E})}$resolveDebugConfiguration(o,h,u,E){return(0,C.asPromise)(async()=>{const A=this.getConfigProviderByHandle(o);if(!A)throw new Error("no DebugConfigurationProvider found");if(!A.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const R=await this.getFolder(h);return A.resolveDebugConfiguration(R,u,E)})}$resolveDebugConfigurationWithSubstitutedVariables(o,h,u,E){return(0,C.asPromise)(async()=>{const A=this.getConfigProviderByHandle(o);if(!A)throw new Error("no DebugConfigurationProvider found");if(!A.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const R=await this.getFolder(h);return A.resolveDebugConfigurationWithSubstitutedVariables(R,u,E)})}async $provideDebugAdapter(o,h){const u=this.getAdapterDescriptorFactoryByHandle(o);if(!u)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const E=await this.getSession(h);return this.getAdapterDescriptor(u,E).then(A=>{if(!A)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${E.type}'`);return this.convertToDto(A)})}async $acceptDebugSessionStarted(o){const h=await this.getSession(o);this._onDidStartDebugSession.fire(h)}async $acceptDebugSessionTerminated(o){const h=await this.getSession(o);h&&(this._onDidTerminateDebugSession.fire(h),this._debugSessions.delete(h.id))}async $acceptDebugSessionActiveChanged(o){this._activeDebugSession=o?await this.getSession(o):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(o,h){const u=await this.getSession(o);u&&u._acceptNameChanged(h)}async $acceptDebugSessionCustomEvent(o,h){const E={session:await this.getSession(o),event:h.event,body:h.body};this._onDidReceiveDebugSessionCustomEvent.fire(E)}convertToDto(o){if(o instanceof k.DebugAdapterExecutable)return{type:"executable",command:o.command,args:o.args,options:o.options};if(o instanceof k.DebugAdapterServer)return{type:"server",port:o.port,host:o.host};if(o instanceof k.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:o.path};if(o instanceof k.DebugAdapterInlineImplementation)return{type:"implementation",implementation:o.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(o){const h=this._adapterFactories.filter(u=>u.type===o);if(h.length>0)return h[0].factory}getAdapterDescriptorFactoryByHandle(o){const h=this._adapterFactories.filter(u=>u.handle===o);if(h.length>0)return h[0].factory}getConfigProviderByHandle(o){const h=this._configProviders.filter(u=>u.handle===o);if(h.length>0)return h[0].provider}definesDebugType(o,h){if(o.contributes){const u=o.contributes.debuggers;if(u&&u.length>0){for(const E of u)if(E.label&&E.type&&E.type===h)return!0}}return!1}getDebugAdapterTrackers(o){const u=o.configuration.type,E=this._trackerFactories.filter(A=>A.type===u||A.type==="*").map(A=>(0,C.asPromise)(()=>A.factory.createDebugAdapterTracker(o)).then(R=>R,R=>null));return Promise.race([Promise.all(E).then(A=>{const R=A.filter(B=>!!B);if(R.length>0)return new n(R)}),new Promise((A,R)=>{const B=setTimeout(()=>{clearTimeout(B),R(new Error("timeout"))},1e3)})]).catch(A=>{})}async getAdapterDescriptor(o,h){const u=h.configuration.debugServer;if(typeof u=="number")return Promise.resolve(new k.DebugAdapterServer(u));if(o){const A=await this._extensionService.getExtensionRegistry();return(0,C.asPromise)(()=>o.createDebugAdapterDescriptor(h,this.daExecutableFromPackage(h,A))).then(R=>{if(R)return R})}const E=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(h,E))}daExecutableFromPackage(o,h){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(o,h,u){(o.length>0||h.length>0||u.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:o,removed:h,changed:u}))}async getSession(o){if(o)if(typeof o=="string"){const h=this._debugSessions.get(o);if(h)return h}else{let h=this._debugSessions.get(o.id);if(!h){const u=await this.getFolder(o.folderUri),E=o.parent?this._debugSessions.get(o.parent):void 0;h=new m(this._debugServiceProxy,o.id,o.type,o.name,u,o.configuration,E),this._debugSessions.set(h.id,h),this._debugServiceProxy.$sessionCached(h.id)}return h}throw new Error("cannot find session")}getFolder(o){if(o){const h=L.URI.revive(o);return this._workspaceService.resolveWorkspaceFolder(h)}return Promise.resolve(void 0)}};r=Ve([$e(0,v.IExtHostRpcService),$e(1,D.IExtHostWorkspace),$e(2,T.IExtHostExtensionService),$e(3,I.IExtHostDocumentsAndEditors),$e(4,p.IExtHostConfiguration),$e(5,s.IExtHostEditorTabs)],r),e.ExtHostDebugServiceBase=r;class m{constructor(o,h,u,E,A,R,B){this._debugServiceProxy=o,this._id=h,this._type=u,this._name=E,this._workspaceFolder=A,this._configuration=R,this._parentSession=B}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(o){this._name=o,this._debugServiceProxy.$setDebugSessionName(this._id,o)}get parentSession(){return this._parentSession}_acceptNameChanged(o){this._name=o}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(o,h){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,o,h)}getDebugProtocolBreakpoint(o){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,o.id)}}e.ExtHostDebugSession=m;class a{constructor(o){this.value=Object.freeze({append(h){o.$appendDebugConsole(h)},appendLine(h){this.append(h+`
`)}})}}e.ExtHostDebugConsole=a;class b extends c.AbstractVariableResolverService{constructor(o,h,u,E,A){function R(){if(h){const B=h.activeEditor();if(B)return B.document.uri;const x=E.tabs.filter(F=>F.isActive);if(x.length>0){const F=x[0].resource;return F&&(F.primary||F.secondary)?F.primary??F.secondary:x[0].resource}}}super({getFolderUri:B=>{const x=o.filter(F=>F.name===B);if(x&&x.length>0)return x[0].uri},getWorkspaceFolderCount:()=>o.length,getConfigurationValue:(B,x)=>u.getConfiguration(void 0,B).get(x),getAppRoot:()=>w.cwd(),getExecPath:()=>w.env.VSCODE_EXEC_PATH,getFilePath:()=>{const B=R();if(B)return g.normalize(B.fsPath)},getWorkspaceFolderPathForFile:()=>{if(A){const B=R();if(B){const x=A.getWorkspaceFolder(B);if(x)return g.normalize(x.uri.fsPath)}}},getSelectedText:()=>{if(h){const B=h.activeEditor();if(B&&!B.selection.isEmpty)return B.document.getText(B.selection)}},getLineNumber:()=>{if(h){const B=h.activeEditor();if(B)return String(B.selection.end.line+1)}}},void 0,Promise.resolve(w.env))}}e.ExtHostVariableResolverService=b;class n{constructor(o){this.trackers=o}onWillStartSession(){this.trackers.forEach(o=>o.onWillStartSession?o.onWillStartSession():void 0)}onWillReceiveMessage(o){this.trackers.forEach(h=>h.onWillReceiveMessage?h.onWillReceiveMessage(o):void 0)}onDidSendMessage(o){this.trackers.forEach(h=>h.onDidSendMessage?h.onDidSendMessage(o):void 0)}onWillStopSession(){this.trackers.forEach(o=>o.onWillStopSession?o.onWillStopSession():void 0)}onError(o){this.trackers.forEach(h=>h.onError?h.onError(o):void 0)}onExit(o,h){this.trackers.forEach(u=>u.onExit?u.onExit(o,h):void 0)}}class t extends _.AbstractDebugAdapter{constructor(o){super();this.implementation=o,o.onDidSendMessage(h=>{this.acceptMessage(h)})}startSession(){return Promise.resolve(void 0)}sendMessage(o){this.implementation.handleMessage(o)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let l=class extends r{constructor(o,h,u,E,A,R){super(o,h,u,E,A,R)}createVariableResolver(o,h,u){return new b(o,h,u,this._editorTabs)}};l=Ve([$e(0,v.IExtHostRpcService),$e(1,D.IExtHostWorkspace),$e(2,T.IExtHostExtensionService),$e(3,I.IExtHostDocumentsAndEditors),$e(4,p.IExtHostConfiguration),$e(5,s.IExtHostEditorTabs)],l),e.WorkerExtHostDebugService=l}),define(fe[272],me([0,1,74,2,5,37,29,27,14,26,4,41,38,11]),function(Y,e,g,L,y,C,i,k,_,D,T,I,c,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let f=class{constructor(s,r,m,a,b,n,t){this._apiFactory=s,this._extensionRegistry=r,this._instaService=m,this._extHostConfiguration=a,this._extHostExtensionService=b,this._initData=n,this._logService=t,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),g.mark("code/extHost/willWaitForConfig");const s=await this._extHostConfiguration.getConfigProvider();g.mark("code/extHost/didWaitForConfig");const r=await this._extHostExtensionService.getExtensionPathIndex();this.register(new v(this._apiFactory,r,this._extensionRegistry,s,this._logService)),this.register(this._instaService.createInstance(S,r)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(P,r,this._initData.environment.appUriScheme))}register(s){if(Array.isArray(s.nodeModuleName))for(let r of s.nodeModuleName)this._factories.set(r,s);else this._factories.set(s.nodeModuleName,s);typeof s.alternativeModuleName=="function"&&this._alternatives.push(r=>s.alternativeModuleName(r))}};f=Ve([$e(2,T.IInstantiationService),$e(3,C.IExtHostConfiguration),$e(4,I.IExtHostExtensionService),$e(5,D.IExtHostInitDataService),$e(6,p.ILogService)],f),e.RequireInterceptor=f;class v{constructor(s,r,m,a,b){this._apiFactory=s,this._extensionPaths=r,this._extensionRegistry=m,this._configProvider=a,this._logService=b,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(s,r){const m=this._extensionPaths.findSubstr(r);if(m){let a=this._extApiImpl.get(k.ExtensionIdentifier.toKey(m.identifier));return a||(a=this._apiFactory(m,this._extensionRegistry,this._configProvider),this._extApiImpl.set(k.ExtensionIdentifier.toKey(m.identifier),a)),a}if(!this._defaultApiImpl){let a="";this._extensionPaths.forEach((b,n)=>a+=`	${n} -> ${b.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${r}. These are the extension path mappings: 
${a}`),this._defaultApiImpl=this._apiFactory(i.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let S=class{constructor(s,r,m){this._extensionPaths=s,this.nodeModuleName="keytar",this._mainThreadTelemetry=r.getProxy(y.MainContext.MainThreadTelemetry);const{environment:a}=m,b=r.getProxy(y.MainContext.MainThreadKeytar);if(a.appRoot){let n=a.appRoot.fsPath;c.platform==="win32"&&(n=n.replace(/\\/g,"/")),n[n.length-1]==="/"&&(n=n.substr(0,n.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${n}/node_modules.asar/keytar`),this.alternativeNames.add(`${n}/node_modules/keytar`)}this._impl={getPassword:(n,t)=>b.$getPassword(n,t),setPassword:(n,t,l)=>b.$setPassword(n,t,l),deletePassword:(n,t)=>b.$deletePassword(n,t),findPassword:n=>b.$findPassword(n),findCredentials(n){return b.$findCredentials(n)}}}load(s,r){const m=this._extensionPaths.findSubstr(r);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:m?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(s){const r=s.length;if(r<=7||!this.alternativeNames)return;const m=r-7;if((s.charAt(m)==="/"||s.charAt(m)==="\\")&&s.endsWith("keytar")&&(s=s.replace(/\\/g,"/"),this.alternativeNames.has(s)))return"keytar"}};S=Ve([$e(1,_.IExtHostRpcService),$e(2,D.IExtHostInitDataService)],S);let P=class{constructor(s,r,m){this._extensionPaths=s,this._appUriScheme=r,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=m.getProxy(y.MainContext.MainThreadTelemetry);const a=m.getProxy(y.MainContext.MainThreadWindow);this._impl=(b,n)=>{const t=L.URI.parse(b);return n?this.callOriginal(b,n):t.scheme==="http"||t.scheme==="https"?a.$openUri(t,b,{allowTunneling:!0}):t.scheme==="mailto"||t.scheme===this._appUriScheme?a.$openUri(t,b,{}):this.callOriginal(b,n)}}load(s,r,m){const a=this._extensionPaths.findSubstr(r);return a&&(this._extensionId=a.identifier.value,this.sendShimmingTelemetry()),this._original=m(s),this._impl}callOriginal(s,r){return this.sendNoForwardTelemetry(),this._original(s,r)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};P=Ve([$e(2,_.IExtHostRpcService)],P)}),define(fe[273],me([0,1,171,12,7,212,36,41,46,37,34,14,57,196,16,213,56]),function(Y,e,g,L,y,C,i,k,_,D,T,I,c,p,f,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let P=class extends c.ExtHostDebugServiceBase{constructor(r,m,a,b,n,t,l){super(r,m,a,b,n,l);this._terminalService=t,this._integratedTerminalInstances=new w}createDebugAdapter(r,m){switch(r.type){case"server":return new C.SocketDebugAdapter(r);case"pipeServer":return new C.NamedPipeDebugAdapter(r);case"executable":return new C.ExecutableDebugAdapter(r,m.type)}return super.createDebugAdapter(r,m)}daExecutableFromPackage(r,m){const a=C.ExecutableDebugAdapter.platformAdapterExecutable(m.getAllExtensionDescriptions(),r.type);if(a)return new y.DebugAdapterExecutable(a.command,a.args,a.options)}createSignService(){return new p.SignService}async $runInTerminal(r,m){if(r.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(R=>{this._integratedTerminalInstances.onTerminalClosed(R)}));const a=await this._configurationService.getConfigProvider(),b=this._terminalService.getDefaultShell(!0),n=this._terminalService.getDefaultShellArgs(!0),t=r.title||g.localize(0,null),l=JSON.stringify({shell:b,shellArgs:n});let d=await this._integratedTerminalInstances.checkout(l,t),o,h=!1;if(d)o=r.cwd;else{const R={shellPath:b,shellArgs:n,cwd:r.cwd,name:t,iconPath:new y.ThemeIcon("debug")};h=!0,d=this._terminalService.createTerminalFromOptions(R,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(d,l)}d.show(!0);const u=await d.processId;h?await new Promise(R=>setTimeout(R,1e3)):a.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(b.indexOf("powershell")>=0||b.indexOf("pwsh")>=0||b.indexOf("cmd.exe")>=0?d.sendText("cls"):b.indexOf("bash")>=0?d.sendText("clear"):L.isWindows?d.sendText("cls"):d.sendText("clear"));const E=(0,v.prepareCommand)(b,r.args,o,r.env);d.sendText(E);const A=this.onDidTerminateDebugSession(R=>{R.id===m&&(this._integratedTerminalInstances.free(d),A.dispose())});return u}else if(r.kind==="external")return(0,v.runInExternalTerminal)(r,await this._configurationService.getConfigProvider());return super.$runInTerminal(r,m)}createVariableResolver(r,m,a){return new c.ExtHostVariableResolverService(r,m,a,this._editorTabs,this._workspaceService)}};P=Ve([$e(0,I.IExtHostRpcService),$e(1,i.IExtHostWorkspace),$e(2,k.IExtHostExtensionService),$e(3,_.IExtHostDocumentsAndEditors),$e(4,D.IExtHostConfiguration),$e(5,T.IExtHostTerminalService),$e(6,S.IExtHostEditorTabs)],P),e.ExtHostDebugService=P;class w{constructor(){this._terminalInstances=new Map}async checkout(r,m){const b=[...this._terminalInstances.entries()].map(([n,t])=>(0,f.createCancelablePromise)(async l=>{if(n.name!==m||t.lastUsedAt!==-1&&await(0,v.hasChildProcesses)(await n.processId))return null;const d=Date.now();return t.lastUsedAt+w.minUseDelay>d||l.isCancellationRequested||t.config!==r?null:(t.lastUsedAt=d,n)}));return await(0,f.firstParallel)(b,n=>!!n)}insert(r,m){this._terminalInstances.set(r,{lastUsedAt:Date.now(),config:m})}free(r){const m=this._terminalInstances.get(r);m&&(m.lastUsedAt=-1)}onTerminalClosed(r){this._terminalInstances.delete(r)}}w.minUseDelay=1e3}),define(fe[274],me([0,1,9,2,113,36,57,46,37,44,34,14,26,73,10,11,68,56,23,82]),function(Y,e,g,L,y,C,i,k,_,D,T,I,c,p,f,v,S,P,w,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let r=class extends p.ExtHostTaskBase{constructor(a,b,n,t,l,d,o,h,u){super(a,b,n,t,l,d,o,h);this.workspaceService=n,this.editorTabs=u,b.remote.isRemote&&b.remote.authority?this.registerTaskSystem(f.Schemas.vscodeRemote,{scheme:f.Schemas.vscodeRemote,authority:b.remote.authority,platform:process.platform}):this.registerTaskSystem(f.Schemas.file,{scheme:f.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(a,b){const n=b;if(!b.execution&&n._id===void 0)throw new Error("Tasks to execute must include an execution");if(n._id!==void 0){const t=p.TaskHandleDTO.from(n,this.workspaceService),l=await this._proxy.$getTaskExecution(t);if(l.task===void 0)throw new Error("Task from execution DTO is undefined");const d=await this.getTaskExecution(l,b);return this._proxy.$executeTask(t).catch(()=>{}),d}else{const t=p.TaskDTO.from(b,a);if(t===void 0)return Promise.reject(new Error("Task is not valid"));p.CustomExecutionDTO.is(t.execution)&&await this.addCustomExecution(t,b,!1);const l=await this.getTaskExecution(await this._proxy.$getTaskExecution(t),b);return this._proxy.$executeTask(t).catch(()=>{}),l}}provideTasksInternal(a,b,n,t){const l=[];if(t)for(let d of t){this.checkDeprecation(d,n),(!d.definition||!a[d.definition.type])&&this._logService.warn(`The task [${d.source}, ${d.name}] uses an undefined task type. The task will be ignored in the future.`);const o=p.TaskDTO.from(d,n.extension);o&&(l.push(o),p.CustomExecutionDTO.is(o.execution)&&b.push(this.addCustomExecution(o,d,!0)))}return{tasks:l,extension:n.extension}}async resolveTaskInternal(a){return a}async getVariableResolver(a){if(this._variableResolver===void 0){const b=await this._configurationService.getConfigProvider();this._variableResolver=new i.ExtHostVariableResolverService(a,this._editorService,b,this.editorTabs,this.workspaceService)}return this._variableResolver}async getAFolder(a){let b=a&&a.length>0?a[0]:void 0;if(!b){const n=L.URI.file((0,s.homedir)());b=new D.WorkspaceFolder({uri:n,name:w.basename(n),index:0})}return{uri:b.uri,name:b.name,index:b.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(a,b){const n=L.URI.revive(a),t={process:void 0,variables:Object.create(null)},l=await this._workspaceProvider.resolveWorkspaceFolder(n),d=await this._workspaceProvider.getWorkspaceFolders2()??[],o=await this.getVariableResolver(d),h=l?{uri:l.uri,name:l.name,index:l.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(d);for(let u of b.variables)t.variables[u]=await o.resolveAsync(h,u);if(b.process!==void 0){let u;if(b.process.path!==void 0){u=b.process.path.split(g.delimiter);for(let E=0;E<u.length;E++)u[E]=await o.resolveAsync(h,u[E])}t.process=await y.win32.findExecutable(await o.resolveAsync(h,b.process.name),b.process.cwd!==void 0?await o.resolveAsync(h,b.process.cwd):void 0,u)}return t}async $jsonTasksSupported(){return!0}async $findExecutable(a,b,n){return y.win32.findExecutable(a,b,n)}};r=Ve([$e(0,I.IExtHostRpcService),$e(1,c.IExtHostInitDataService),$e(2,C.IExtHostWorkspace),$e(3,k.IExtHostDocumentsAndEditors),$e(4,_.IExtHostConfiguration),$e(5,T.IExtHostTerminalService),$e(6,v.ILogService),$e(7,S.IExtHostApiDeprecationService),$e(8,P.IExtHostEditorTabs)],r),e.ExtHostTask=r}),define(fe[275],me([0,1,16,18,74,6,2,5,267,11,84,86,26,189,14,67,41,34]),function(Y,e,g,L,y,C,i,k,_,D,T,I,c,p,f,v,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class w{constructor(r,m,a,b){this._disposables=new C.DisposableStore,this._isTerminating=!1,this._hostUtils=a,this._rpcProtocol=new _.RPCProtocol(r,null,b),m=w._transform(m,this._rpcProtocol);const n=new I.ServiceCollection(...(0,T.getSingletonServiceDescriptors)());n.set(c.IExtHostInitDataService,{_serviceBrand:void 0,...m}),n.set(f.IExtHostRpcService,new f.ExtHostRpcService(this._rpcProtocol)),n.set(v.IURITransformerService,new v.URITransformerService(b)),n.set(S.IHostUtils,a);const t=new p.InstantiationService(n,!0),l=t.invokeFunction(u=>u.get(P.IExtHostTerminalService));this._disposables.add(l),this._logService=t.invokeFunction(u=>u.get(D.ILogService)),y.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",m),this._extensionService=t.invokeFunction(u=>u.get(S.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const d=new WeakMap;this._extensionService.getExtensionPathIndex().then(u=>{Error.prepareStackTrace=(E,A)=>{let R="",B,x;for(const F of A)R+=`
	at ${F.toString()}`,x=F.getFileName(),!B&&x&&(B=u.findSubstr(i.URI.file(x)));return d.set(E,B),`${E.name||"Error"}: ${E.message||""}${R}`}});const o=this._rpcProtocol.getProxy(k.MainContext.MainThreadExtensionService),h=this._rpcProtocol.getProxy(k.MainContext.MainThreadErrors);L.setUnexpectedErrorHandler(u=>{const E=L.transformErrorForSerialization(u),A=d.get(u);A?o.$onExtensionRuntimeError(A.identifier,E):h.$onUnexpectedError(E)})}terminate(r){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${r}`),this._logService.flush(),this._disposables.dispose(),L.setUnexpectedErrorHandler(a=>{this._logService.error(a)}),this._rpcProtocol.dispose();const m=this._extensionService.deactivateAll();Promise.race([(0,g.timeout)(5e3),m]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code 0`):this._logService.info("Extension host exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})}static _transform(r,m){r.extensions.forEach(b=>b.extensionLocation=i.URI.revive(m.transformIncomingURIs(b.extensionLocation))),r.environment.appRoot=i.URI.revive(m.transformIncomingURIs(r.environment.appRoot));const a=r.environment.extensionDevelopmentLocationURI;return a&&(r.environment.extensionDevelopmentLocationURI=a.map(b=>i.URI.revive(m.transformIncomingURIs(b)))),r.environment.extensionTestsLocationURI=i.URI.revive(m.transformIncomingURIs(r.environment.extensionTestsLocationURI)),r.environment.globalStorageHome=i.URI.revive(m.transformIncomingURIs(r.environment.globalStorageHome)),r.environment.workspaceStorageHome=i.URI.revive(m.transformIncomingURIs(r.environment.workspaceStorageHome)),r.logsLocation=i.URI.revive(m.transformIncomingURIs(r.logsLocation)),r.logFile=i.URI.revive(m.transformIncomingURIs(r.logFile)),r.workspace=m.transformIncomingURIs(r.workspace),r}}e.ExtensionHostMain=w}),define(fe[276],me([0,1,9,21,52,31,23,47,33]),function(Y,e,g,L,y,C,i,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class D{constructor(c,p,f){this.config=c,this.provider=p,this.sessionToken=f,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=c.filePattern,this.includePattern=c.includePattern&&C.parse(c.includePattern),this.maxResults=c.maxResults||void 0,this.exists=c.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=c.excludePattern&&C.parse(c.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(c=>c.cancel()),this.activeCancellationTokens=new Set}search(c){const p=this.config.folderQueries||[];return new Promise((f,v)=>{const S=P=>{this.resultCount++,c(P)};if(this.isCanceled)return f({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(P=>{const w=P.toString(),s=g.basename(w);this.globalExcludePattern&&this.globalExcludePattern(w,s)||this.matchFile(S,{base:P,basename:s})}),Promise.all(p.map(P=>this.searchInFolder(P,S))).then(P=>{f({limitHit:this.isLimitHit,stats:P[0]||void 0})},P=>{v(new Error((0,y.toErrorMessage)(P)))})})}async searchInFolder(c,p){const f=new L.CancellationTokenSource,v=this.getSearchOptionsForFolder(c),S=this.initDirectoryTree(),P=new _.QueryGlobTester(this.config,c),w=!P.hasSiblingExcludeClauses();let s;try{this.activeCancellationTokens.add(f),s=k.StopWatch.create();const r=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},v,f.token),m=s.elapsed(),a=k.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(r&&r.forEach(b=>{const n=g.posix.relative(c.folder.path,b.path);if(w){const t=g.basename(b.path);this.matchFile(p,{base:c.folder,relativePath:n,basename:t});return}this.addDirectoryEntries(S,c.folder,n,p)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(S,P,p),{providerTime:m,postProcessTime:a.elapsed()})}finally{f.dispose(),this.activeCancellationTokens.delete(f)}}getSearchOptionsForFolder(c){const p=(0,_.resolvePatternsForProvider)(this.config.includePattern,c.includePattern),f=(0,_.resolvePatternsForProvider)(this.config.excludePattern,c.excludePattern);return{folder:c.folder,excludes:f,includes:p,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,followSymlinks:!c.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const c={rootEntries:[],pathToEntries:Object.create(null)};return c.pathToEntries["."]=c.rootEntries,c}addDirectoryEntries({pathToEntries:c},p,f,v){if(f===this.filePattern){const P=g.basename(this.filePattern);this.matchFile(v,{base:p,relativePath:this.filePattern,basename:P})}function S(P){const w=g.basename(P),s=g.dirname(P);let r=c[s];r||(r=c[s]=[],S(s)),r.push({base:p,relativePath:P,basename:w})}S(f)}matchDirectoryTree({rootEntries:c,pathToEntries:p},f,v){const S=this,P=this.filePattern;function w(s){const r=C.hasSiblingFn(()=>s.map(m=>m.basename));for(let m=0,a=s.length;m<a;m++){const b=s[m],{relativePath:n,basename:t}=b;if(f.matchesExcludesSync(n,t,P!==t?r:void 0))continue;const l=p[n];if(l)w(l);else{if(n===P)continue;S.matchFile(v,b)}if(S.isLimitHit)break}}w(c)}matchFile(c,p){(!this.includePattern||p.relativePath&&this.includePattern(p.relativePath,p.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||c(p))}}class T{constructor(){this.sessions=new Map}fileSearch(c,p,f,v){const S=this.getSessionTokenSource(c.cacheKey),P=new D(c,p,S&&S.token);let w=0;const s=r=>{w+=r.length,f(r.map(m=>this.rawMatchToSearchItem(m)))};return this.doSearch(P,T.BATCH_SIZE,s,v).then(r=>({limitHit:r.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:w,detailStats:r.stats}}))}clearCache(c){const p=this.getSessionTokenSource(c);p&&p.cancel()}getSessionTokenSource(c){if(!!c)return this.sessions.has(c)||this.sessions.set(c,new L.CancellationTokenSource),this.sessions.get(c)}rawMatchToSearchItem(c){return c.relativePath?{resource:i.joinPath(c.base,c.relativePath)}:{resource:c.base}}doSearch(c,p,f,v){v.onCancellationRequested(()=>{c.cancel()});const S=w=>{w&&(P.push(w),p>0&&P.length>=p&&(f(P),P=[]))};let P=[];return c.search(S).then(w=>(P.length&&f(P),w),w=>(P.length&&f(P),Promise.reject(w)))}}e.FileSearchManager=T,T.BATCH_SIZE=512}),define(fe[135],me([0,1,15,21,52,31,10,9,23,13,2,33]),function(Y,e,g,L,y,C,i,k,_,D,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class c{constructor(s,r,m,a){this.query=s,this.provider=r,this.fileUtils=m,this.processType=a,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(s,r){const m=this.query.folderQueries||[],a=new L.CancellationTokenSource;return r.onCancellationRequested(()=>a.cancel()),new Promise((b,n)=>{this.collector=new f(s);let t=!1;const l=(d,o)=>{if(!t&&!this.isLimitHit){const h=this.resultSize(d);S(d)&&typeof this.query.maxResults=="number"&&this.resultCount+h>this.query.maxResults&&(this.isLimitHit=!0,t=!0,a.cancel(),d=this.trimResultToSize(d,this.query.maxResults-this.resultCount));const u=this.resultSize(d);this.resultCount+=u,(u>0||!S(d))&&this.collector.add(d,o)}};Promise.all(m.map((d,o)=>this.searchInFolder(d,h=>l(h,o),a.token))).then(d=>{a.dispose(),this.collector.flush();const o=d.some(h=>!!h&&!!h.limitHit);b({limitHit:this.isLimitHit||o,messages:(0,g.flatten)(d.map(h=>h?.message?(0,D.isArray)(h.message)?h.message:[h.message]:[])),stats:{type:this.processType}})},d=>{a.dispose();const o=(0,y.toErrorMessage)(d);n(new Error(o))})})}resultSize(s){return S(s)?Array.isArray(s.ranges)?s.ranges.length:1:0}trimResultToSize(s,r){const m=Array.isArray(s.ranges)?s.ranges:[s.ranges],a=Array.isArray(s.preview.matches)?s.preview.matches:[s.preview.matches];return{ranges:m.slice(0,r),preview:{matches:a.slice(0,r),text:s.preview.text},uri:s.uri}}async searchInFolder(s,r,m){const a=new I.QueryGlobTester(this.query,s),b=[],n={report:d=>{if(!this.validateProviderResult(d))return;const o=s.folder.scheme===i.Schemas.file?C.hasSiblingPromiseFn(()=>this.fileUtils.readdir(_.dirname(d.uri))):void 0,h=_.relativePath(s.folder,d.uri);if(h){const u=a.includedInQuery(h,k.basename(h),o);(0,D.isPromise)(u)?b.push(u.then(E=>{E&&r(d)})):u&&r(d)}}},t=this.getSearchOptionsForFolder(s),l=await this.provider.provideTextSearchResults(p(this.query.contentPattern),t,n,m);return b.length&&await Promise.all(b),l}validateProviderResult(s){if(S(s)){if(Array.isArray(s.ranges)){if(!Array.isArray(s.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(s.preview.matches.length!==s.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(s.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(s){const r=(0,I.resolvePatternsForProvider)(this.query.includePattern,s.includePattern),m=(0,I.resolvePatternsForProvider)(this.query.excludePattern,s.excludePattern),a={folder:T.URI.from(s.folder),excludes:m,includes:r,useIgnoreFiles:!s.disregardIgnoreFiles,useGlobalIgnoreFiles:!s.disregardGlobalIgnoreFiles,followSymlinks:!s.ignoreSymlinks,encoding:s.fileEncoding&&this.fileUtils.toCanonicalName(s.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return a.usePCRE2=this.query.usePCRE2,a}}e.TextSearchManager=c;function p(w){return{isCaseSensitive:w.isCaseSensitive||!1,isRegExp:w.isRegExp||!1,isWordMatch:w.isWordMatch||!1,isMultiline:w.isMultiline||!1,pattern:w.pattern}}class f{constructor(s){this._onResult=s,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new P(512,r=>this.sendItems(r))}add(s,r){this._currentFileMatch&&(this._currentFolderIdx!==r||!_.isEqual(this._currentUri,s.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=r,this._currentFileMatch={resource:s.uri,results:[]}),this._currentFileMatch.results.push(v(s))}pushToCollector(){const s=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,s)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(s){this._onResult(s)}}e.TextSearchResultsCollector=f;function v(w){return S(w)?{preview:{matches:(0,g.mapArrayOrNot)(w.preview.matches,s=>({startLineNumber:s.start.line,startColumn:s.start.character,endLineNumber:s.end.line,endColumn:s.end.character})),text:w.preview.text},ranges:(0,g.mapArrayOrNot)(w.ranges,s=>({startLineNumber:s.start.line,startColumn:s.start.character,endLineNumber:s.end.line,endColumn:s.end.character}))}:{text:w.text,lineNumber:w.lineNumber}}function S(w){return!!w.preview}e.extensionResultIsMatch=S;class P{constructor(s,r){this.maxBatchSize=s,this.cb=r,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(s,r){!s||this.addItemToBatch(s,r)}addItems(s,r){!s||this.addItemsToBatch(s,r)}addItemToBatch(s,r){this.batch.push(s),this.batchSize+=r,this.onUpdate()}addItemsToBatch(s,r){this.batch=this.batch.concat(s),this.batchSize+=r,this.onUpdate()}onUpdate(){this.totalNumberCompleted<P.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},P.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=P,P.TIMEOUT=4e3,P.START_BATCH_AFTER_COUNT=50}),define(fe[75],me([0,1,6,5,4,276,14,67,11,2,135]),function(Y,e,g,L,y,C,i,k,_,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,y.createDecorator)("IExtHostSearch");let I=class{constructor(v,S,P){this.extHostRpc=v,this._uriTransformer=S,this._logService=P,this._proxy=this.extHostRpc.getProxy(L.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new C.FileSearchManager}_transformScheme(v){return this._uriTransformer.transformOutgoingScheme(v)}registerTextSearchProvider(v,S){if(this._textSearchUsedSchemes.has(v))throw new Error(`a text search provider for the scheme '${v}' is already registered`);this._textSearchUsedSchemes.add(v);const P=this._handlePool++;return this._textSearchProvider.set(P,S),this._proxy.$registerTextSearchProvider(P,this._transformScheme(v)),(0,g.toDisposable)(()=>{this._textSearchUsedSchemes.delete(v),this._textSearchProvider.delete(P),this._proxy.$unregisterProvider(P)})}registerFileSearchProvider(v,S){if(this._fileSearchUsedSchemes.has(v))throw new Error(`a file search provider for the scheme '${v}' is already registered`);this._fileSearchUsedSchemes.add(v);const P=this._handlePool++;return this._fileSearchProvider.set(P,S),this._proxy.$registerFileSearchProvider(P,this._transformScheme(v)),(0,g.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(v),this._fileSearchProvider.delete(P),this._proxy.$unregisterProvider(P)})}$provideFileSearchResults(v,S,P,w){const s=c(P),r=this._fileSearchProvider.get(v);if(r)return this._fileSearchManager.fileSearch(s,r,m=>{this._proxy.$handleFileMatch(v,S,m.map(a=>a.resource))},w);throw new Error("unknown provider: "+v)}$clearCache(v){return this._fileSearchManager.clearCache(v),Promise.resolve(void 0)}$provideTextSearchResults(v,S,P,w){const s=this._textSearchProvider.get(v);if(!s||!s.provideTextSearchResults)throw new Error(`Unknown provider ${v}`);const r=c(P);return this.createTextSearchManager(r,s).search(a=>this._proxy.$handleTextMatch(v,S,a),w)}$enableExtensionHostSearch(){}createTextSearchManager(v,S){return new T.TextSearchManager(v,S,{readdir:P=>Promise.resolve([]),toCanonicalName:P=>P},"textSearchProvider")}};I=Ve([$e(0,i.IExtHostRpcService),$e(1,k.IURITransformerService),$e(2,_.ILogService)],I),e.ExtHostSearch=I;function c(f){return{...f,folderQueries:f.folderQueries&&f.folderQueries.map(p),extraFileResources:f.extraFileResources&&f.extraFileResources.map(v=>D.URI.revive(v))}}e.reviveQuery=c;function p(f){return{...f,folder:D.URI.revive(f.folder)}}}),define(fe[277],me([0,1,21,18,3,50,2,114,109,147,83,43,5,235,234,40,236,37,237,238,239,220,240,46,41,241,221,244,245,246,133,223,251,252,253,92,34,255,224,17,7,258,71,134,36,59,208,243,64,131,73,57,75,11,67,14,26,247,205,54,68,232,256,204,70,69,261,259,260,233,45,254,257,91,56,122,249,72,250,10,192,248,202,242,29]),function(Y,e,g,L,y,C,i,k,_,D,T,I,c,p,f,v,S,P,w,s,r,m,a,b,n,t,l,d,o,h,u,E,A,R,B,x,F,$,M,H,N,U,V,O,W,j,X,Q,de,Se,De,Pe,Be,We,He,G,ee,ie,le,Z,re,pe,Me,je,Ke,Ze,rt,lt,ye,at,J,ne,_e,Qe,et,ce,Ie,Ue,Xe,nt,ft,tt,ut,Re,ve){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Te(se){const ue=se.get(ee.IExtHostInitDataService),be=se.get(J.IExtHostFileSystemInfo),we=se.get(Ze.IExtHostConsumerFileSystem),Fe=se.get(n.IExtHostExtensionService),qe=se.get(W.IExtHostWorkspace),ze=se.get(ce.IExtHostTelemetry),Ye=se.get(P.IExtHostConfiguration),ct=se.get(He.IURITransformerService),xe=se.get(G.IExtHostRpcService),ge=se.get(x.IExtHostStorage),Ee=se.get(Ke.IExtensionStoragePaths),ae=se.get(We.ILoggerService),K=se.get(We.ILogService),Ce=se.get(Z.IExtHostTunnelService),Le=se.get(re.IExtHostApiDeprecationService),it=se.get(O.IExtHostWindow),Ge=se.get(Qe.IExtHostSecretState),mt=se.get(et.IExtHostEditorTabs);xe.set(c.ExtHostContext.ExtHostFileSystemInfo,be),xe.set(c.ExtHostContext.ExtHostLogLevelServiceShape,ae),xe.set(c.ExtHostContext.ExtHostWorkspace,qe),xe.set(c.ExtHostContext.ExtHostConfiguration,Ye),xe.set(c.ExtHostContext.ExtHostExtensionService,Fe),xe.set(c.ExtHostContext.ExtHostStorage,ge),xe.set(c.ExtHostContext.ExtHostTunnelService,Ce),xe.set(c.ExtHostContext.ExtHostWindow,it),xe.set(c.ExtHostContext.ExtHostSecretState,Ge),xe.set(c.ExtHostContext.ExtHostTelemetry,ze),xe.set(c.ExtHostContext.ExtHostEditorTabs,mt);const yt=xe.set(c.ExtHostContext.ExtHostDecorations,se.get(Se.IExtHostDecorations)),_t=xe.set(c.ExtHostContext.ExtHostDocumentsAndEditors,se.get(b.IExtHostDocumentsAndEditors)),gt=xe.set(c.ExtHostContext.ExtHostCommands,se.get(v.IExtHostCommands)),bt=xe.set(c.ExtHostContext.ExtHostTerminalService,se.get(F.IExtHostTerminalService)),vt=xe.set(c.ExtHostContext.ExtHostDebugService,se.get(Pe.IExtHostDebugService)),Tt=xe.set(c.ExtHostContext.ExtHostSearch,se.get(Be.IExtHostSearch)),Dt=xe.set(c.ExtHostContext.ExtHostTask,se.get(De.IExtHostTask)),Bt=xe.set(c.ExtHostContext.ExtHostOutputService,se.get(u.IExtHostOutputService)),Vt=xe.set(c.ExtHostContext.ExtHostUrls,new U.ExtHostUrls(xe)),kt=xe.set(c.ExtHostContext.ExtHostDocuments,new a.ExtHostDocuments(xe,_t)),$t=xe.set(c.ExtHostContext.ExtHostDocumentContentProviders,new r.ExtHostDocumentContentProvider(xe,_t,K)),ti=xe.set(c.ExtHostContext.ExtHostDocumentSaveParticipant,new m.ExtHostDocumentSaveParticipant(K,kt,xe.getProxy(c.MainContext.MainThreadBulkEdits))),St=xe.set(c.ExtHostContext.ExtHostNotebook,new ie.ExtHostNotebookController(xe,gt,_t,kt,Ee)),Qt=xe.set(c.ExtHostContext.ExtHostNotebookDocuments,new ut.ExtHostNotebookDocuments(K,St)),jt=xe.set(c.ExtHostContext.ExtHostNotebookEditors,new tt.ExtHostNotebookEditors(K,xe,St)),ii=xe.set(c.ExtHostContext.ExtHostNotebookKernels,new Ie.ExtHostNotebookKernels(xe,ue,St,gt,K)),ni=xe.set(c.ExtHostContext.ExtHostNotebookRenderers,new Xe.ExtHostNotebookRenderers(xe,St)),At=xe.set(c.ExtHostContext.ExtHostEditors,new $.ExtHostEditors(xe,_t)),Xt=xe.set(c.ExtHostContext.ExtHostTreeViews,new M.ExtHostTreeViews(xe.getProxy(c.MainContext.MainThreadTreeViews),gt,K)),wi=xe.set(c.ExtHostContext.ExtHostEditorInsets,new X.ExtHostEditorInsets(xe.getProxy(c.MainContext.MainThreadEditorInsets),At,ue)),Wt=xe.set(c.ExtHostContext.ExtHostDiagnostics,new w.ExtHostDiagnostics(xe,K,be)),Ht=xe.set(c.ExtHostContext.ExtHostLanguages,new o.ExtHostLanguages(xe,kt,gt.converter,ct)),wt=xe.set(c.ExtHostContext.ExtHostLanguageFeatures,new d.ExtHostLanguageFeatures(xe,ct,kt,gt,Wt,K,Le)),ri=xe.set(c.ExtHostContext.ExtHostFileSystem,new t.ExtHostFileSystem(xe,wt)),Ot=xe.set(c.ExtHostContext.ExtHostFileSystemEventService,new l.ExtHostFileSystemEventService(xe,K,_t)),Nt=xe.set(c.ExtHostContext.ExtHostQuickOpen,(0,A.createExtHostQuickOpen)(xe,qe,gt)),Yt=xe.set(c.ExtHostContext.ExtHostSCM,new R.ExtHostSCM(xe,gt,K)),bi=xe.set(c.ExtHostContext.ExtHostComments,(0,S.createExtHostComments)(xe,gt,kt)),di=xe.set(c.ExtHostContext.ExtHostProgress,new E.ExtHostProgress(xe.getProxy(c.MainContext.MainThreadProgress))),Ei=xe.set(c.ExtHostContext.ExtHosLabelService,new Q.ExtHostLabelService(xe)),hi=xe.set(c.ExtHostContext.ExtHostTheming,new le.ExtHostTheming(xe)),Jt=xe.set(c.ExtHostContext.ExtHostAuthentication,new pe.ExtHostAuthentication(xe)),si=xe.set(c.ExtHostContext.ExtHostTimeline,new Me.ExtHostTimeline(xe,gt)),qt=xe.set(c.ExtHostContext.ExtHostWebviews,new V.ExtHostWebviews(xe,{remote:ue.remote},qe,K,Le)),oi=xe.set(c.ExtHostContext.ExtHostWebviewPanels,new ye.ExtHostWebviewPanels(xe,qt,qe)),_i=xe.set(c.ExtHostContext.ExtHostCustomEditors,new lt.ExtHostCustomEditors(xe,kt,Ee,qt,oi)),Si=xe.set(c.ExtHostContext.ExtHostWebviewViews,new rt.ExtHostWebviewViews(xe,qt)),Gt=xe.set(c.ExtHostContext.ExtHostTesting,new ne.ExtHostTesting(xe,gt)),Zt=xe.set(c.ExtHostContext.ExtHostUriOpeners,new _e.ExtHostUriOpeners(xe));xe.set(c.ExtHostContext.ExtHostInteractive,new Re.ExtHostInteractive(xe,St,_t,gt));const Ci=(0,j.values)(c.ExtHostContext);xe.assertRegistered(Ci);const yi=new at.ExtHostBulkEdits(xe,_t),Di=new f.ExtHostClipboard(xe),Kt=new h.ExtHostMessageService(xe,K),fi=new s.ExtHostDialogs(xe),zt=new B.ExtHostStatusBar(xe,gt.converter);return p.ExtHostApiCommands.register(gt),function(Oe,ai,Lt){const Et=function(){let te=!Oe.isUnderDevelopment;function he(){te||(K.info(`Extension '${Oe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),te=!0)}return function Ae(ht){if(Array.isArray(ht))ht.forEach(Ae);else if(typeof ht=="string")he();else{const Ct=ht;typeof Ct.scheme=="undefined"&&he(),typeof Ct.exclusive=="boolean"&&(0,ve.checkProposedApiEnabled)(Oe,"documentFiltersExclusive")}return ht}}(),ki={getSession(te,he,Ae){return Ae?.forceNewSession&&(0,ve.checkProposedApiEnabled)(Oe,"authSession"),Jt.getSession(Oe,te,he,Ae)},async hasSession(te,he){return(0,ve.checkProposedApiEnabled)(Oe,"authSession"),!!await Jt.getSession(Oe,te,he,{silent:!0})},get onDidChangeSessions(){return Jt.onDidChangeSessions},registerAuthenticationProvider(te,he,Ae,ht){return Jt.registerAuthenticationProvider(te,he,Ae,ht)}},Ii={registerCommand(te,he,Ae){return gt.registerCommand(!0,te,he,Ae,void 0,Oe)},registerTextEditorCommand(te,he,Ae){return gt.registerCommand(!0,te,(...ht)=>{const Ct=At.getActiveTextEditor();if(!Ct){K.warn("Cannot execute "+te+" because there is no active text editor.");return}return Ct.edit(Pt=>{he.apply(Ae,[Ct,Pt,...ht])}).then(Pt=>{Pt||K.warn("Edits from command "+te+" were not applied.")},Pt=>{K.warn("An error occurred while running command "+te,Pt)})},void 0,void 0,Oe)},registerDiffInformationCommand:(te,he,Ae)=>((0,ve.checkProposedApiEnabled)(Oe,"diffCommand"),gt.registerCommand(!0,te,async(...ht)=>{const Ct=_t.activeEditor(!0);if(!Ct){K.warn("Cannot execute "+te+" because there is no active text editor.");return}const Pt=await At.getDiffInformation(Ct.id);he.apply(Ae,[Pt,...ht])},void 0,void 0,Oe)),executeCommand(te,...he){return gt.executeCommand(te,...he)},getCommands(te=!1){return gt.getCommands(te)}},mi={get machineId(){return ue.telemetryInfo.machineId},get sessionId(){return ue.telemetryInfo.sessionId},get language(){return ue.environment.appLanguage},get appName(){return ue.environment.appName},get appRoot(){return ue.environment.appRoot?.fsPath??""},get appHost(){return ue.environment.appHost},get uriScheme(){return ue.environment.appUriScheme},get clipboard(){return Di.value},get shell(){return bt.getDefaultShell(!1)},get isTelemetryEnabled(){return ze.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return ze.onDidChangeTelemetryEnabled},get isNewAppInstall(){const te=Date.now()-new Date(ue.telemetryInfo.firstSessionDate).getTime();return isNaN(te)?!1:te<1e3*60*60*24},openExternal(te,he){return it.openUri(te,{allowTunneling:!!ue.remote.authority,allowContributedOpeners:he?.allowContributedOpeners})},async asExternalUri(te){if(te.scheme===ue.environment.appUriScheme)return Vt.createAppUri(te);try{return await it.asExternalUri(te,{allowTunneling:!!ue.remote.authority})}catch(he){if((0,ft.matchesScheme)(te,nt.Schemas.http)||(0,ft.matchesScheme)(te,nt.Schemas.https))return te;throw he}},get remoteName(){return(0,de.getRemoteName)(ue.remote.authority)},get remoteAuthority(){return(0,ve.checkProposedApiEnabled)(Oe,"resolvers"),ue.remote.authority},get uiKind(){return ue.uiKind}};ue.environment.extensionTestsLocationURI||Object.freeze(mi);const gi=ue.remote.isRemote?N.ExtensionKind.Workspace:N.ExtensionKind.UI,Pi={createTestController(te,he){return Gt.createTestController(te,he)},createTestObserver(){return(0,ve.checkProposedApiEnabled)(Oe,"testObserver"),Gt.createTestObserver()},runTests(te){return(0,ve.checkProposedApiEnabled)(Oe,"testObserver"),Gt.runTests(te)},get onDidChangeTestResults(){return(0,ve.checkProposedApiEnabled)(Oe,"testObserver"),Gt.onResultsChanged},get testResults(){return(0,ve.checkProposedApiEnabled)(Oe,"testObserver"),Gt.results}},Ti={getExtension(te){const he=ai.getExtensionDescription(te);if(he)return new n.Extension(Fe,Oe.identifier,he,gi)},get all(){return ai.getAllExtensionDescriptions().map(te=>new n.Extension(Fe,Oe.identifier,te,gi))},get onDidChange(){return ai.onDidChange}},Ai={createDiagnosticCollection(te){return Wt.createDiagnosticCollection(Oe.identifier,te)},get onDidChangeDiagnostics(){return Wt.onDidChangeDiagnostics},getDiagnostics:te=>Wt.getDiagnostics(te),getLanguages(){return Ht.getLanguages()},setTextDocumentLanguage(te,he){return Ht.changeLanguage(te.uri,he)},match(te,he){return(0,T.score)(H.LanguageSelector.from(te),he.uri,he.languageId,!0)},registerCodeActionsProvider(te,he,Ae){return wt.registerCodeActionProvider(Oe,Et(te),he,Ae)},registerCodeLensProvider(te,he){return wt.registerCodeLensProvider(Oe,Et(te),he)},registerDefinitionProvider(te,he){return wt.registerDefinitionProvider(Oe,Et(te),he)},registerDeclarationProvider(te,he){return wt.registerDeclarationProvider(Oe,Et(te),he)},registerImplementationProvider(te,he){return wt.registerImplementationProvider(Oe,Et(te),he)},registerTypeDefinitionProvider(te,he){return wt.registerTypeDefinitionProvider(Oe,Et(te),he)},registerHoverProvider(te,he){return wt.registerHoverProvider(Oe,Et(te),he,Oe.identifier)},registerEvaluatableExpressionProvider(te,he){return wt.registerEvaluatableExpressionProvider(Oe,Et(te),he,Oe.identifier)},registerInlineValuesProvider(te,he){return wt.registerInlineValuesProvider(Oe,Et(te),he,Oe.identifier)},registerDocumentHighlightProvider(te,he){return wt.registerDocumentHighlightProvider(Oe,Et(te),he)},registerLinkedEditingRangeProvider(te,he){return wt.registerLinkedEditingRangeProvider(Oe,Et(te),he)},registerReferenceProvider(te,he){return wt.registerReferenceProvider(Oe,Et(te),he)},registerRenameProvider(te,he){return wt.registerRenameProvider(Oe,Et(te),he)},registerDocumentSymbolProvider(te,he,Ae){return wt.registerDocumentSymbolProvider(Oe,Et(te),he,Ae)},registerWorkspaceSymbolProvider(te){return wt.registerWorkspaceSymbolProvider(Oe,te)},registerDocumentFormattingEditProvider(te,he){return wt.registerDocumentFormattingEditProvider(Oe,Et(te),he)},registerDocumentRangeFormattingEditProvider(te,he){return wt.registerDocumentRangeFormattingEditProvider(Oe,Et(te),he)},registerOnTypeFormattingEditProvider(te,he,Ae,...ht){return wt.registerOnTypeFormattingEditProvider(Oe,Et(te),he,[Ae].concat(ht))},registerDocumentSemanticTokensProvider(te,he,Ae){return wt.registerDocumentSemanticTokensProvider(Oe,Et(te),he,Ae)},registerDocumentRangeSemanticTokensProvider(te,he,Ae){return wt.registerDocumentRangeSemanticTokensProvider(Oe,Et(te),he,Ae)},registerSignatureHelpProvider(te,he,Ae,...ht){return typeof Ae=="object"?wt.registerSignatureHelpProvider(Oe,Et(te),he,Ae):wt.registerSignatureHelpProvider(Oe,Et(te),he,typeof Ae=="undefined"?[]:[Ae,...ht])},registerCompletionItemProvider(te,he,...Ae){return wt.registerCompletionItemProvider(Oe,Et(te),he,Ae)},registerInlineCompletionItemProvider(te,he){return(0,ve.checkProposedApiEnabled)(Oe,"inlineCompletions"),wt.registerInlineCompletionsProvider(Oe,Et(te),he)},registerDocumentLinkProvider(te,he){return wt.registerDocumentLinkProvider(Oe,Et(te),he)},registerColorProvider(te,he){return wt.registerColorProvider(Oe,Et(te),he)},registerFoldingRangeProvider(te,he){return wt.registerFoldingRangeProvider(Oe,Et(te),he)},registerSelectionRangeProvider(te,he){return wt.registerSelectionRangeProvider(Oe,te,he)},registerCallHierarchyProvider(te,he){return wt.registerCallHierarchyProvider(Oe,te,he)},registerTypeHierarchyProvider(te,he){return wt.registerTypeHierarchyProvider(Oe,te,he)},setLanguageConfiguration:(te,he)=>wt.setLanguageConfiguration(Oe,te,he),getTokenInformationAtPosition(te,he){return(0,ve.checkProposedApiEnabled)(Oe,"tokenInformation"),Ht.tokenAtPosition(te,he)},registerInlayHintsProvider(te,he){return(0,ve.checkProposedApiEnabled)(Oe,"inlayHints"),wt.registerInlayHintsProvider(Oe,te,he)},createLanguageStatusItem(te,he){return(0,ve.checkProposedApiEnabled)(Oe,"languageStatus"),Ht.createLanguageStatusItem(Oe,te,he)}},ci={get activeTextEditor(){return At.getActiveTextEditor()},get visibleTextEditors(){return At.getVisibleTextEditors()},get activeTerminal(){return bt.activeTerminal},get terminals(){return bt.terminals},async showTextDocument(te,he,Ae){const ht=await(i.URI.isUri(te)?Promise.resolve(pi.openTextDocument(te)):Promise.resolve(te));return At.showTextDocument(ht,he,Ae)},createTextEditorDecorationType(te){return At.createTextEditorDecorationType(Oe,te)},onDidChangeActiveTextEditor(te,he,Ae){return At.onDidChangeActiveTextEditor(te,he,Ae)},onDidChangeVisibleTextEditors(te,he,Ae){return At.onDidChangeVisibleTextEditors(te,he,Ae)},onDidChangeTextEditorSelection(te,he,Ae){return At.onDidChangeTextEditorSelection(te,he,Ae)},onDidChangeTextEditorOptions(te,he,Ae){return At.onDidChangeTextEditorOptions(te,he,Ae)},onDidChangeTextEditorVisibleRanges(te,he,Ae){return At.onDidChangeTextEditorVisibleRanges(te,he,Ae)},onDidChangeTextEditorViewColumn(te,he,Ae){return At.onDidChangeTextEditorViewColumn(te,he,Ae)},onDidCloseTerminal(te,he,Ae){return bt.onDidCloseTerminal(te,he,Ae)},onDidOpenTerminal(te,he,Ae){return bt.onDidOpenTerminal(te,he,Ae)},onDidChangeActiveTerminal(te,he,Ae){return bt.onDidChangeActiveTerminal(te,he,Ae)},onDidChangeTerminalDimensions(te,he,Ae){return(0,ve.checkProposedApiEnabled)(Oe,"terminalDimensions"),bt.onDidChangeTerminalDimensions(te,he,Ae)},onDidChangeTerminalState(te,he,Ae){return bt.onDidChangeTerminalState(te,he,Ae)},onDidWriteTerminalData(te,he,Ae){return(0,ve.checkProposedApiEnabled)(Oe,"terminalDataWriteEvent"),bt.onDidWriteTerminalData(te,he,Ae)},get state(){return it.state},onDidChangeWindowState(te,he,Ae){return it.onDidChangeWindowState(te,he,Ae)},showInformationMessage(te,...he){return Kt.showMessage(Oe,C.default.Info,te,he[0],he.slice(1))},showWarningMessage(te,...he){return Kt.showMessage(Oe,C.default.Warning,te,he[0],he.slice(1))},showErrorMessage(te,...he){return Kt.showMessage(Oe,C.default.Error,te,he[0],he.slice(1))},showQuickPick(te,he,Ae){return Array.isArray(te)&&te.some(ht=>ht.kind!==void 0)&&(0,ve.checkProposedApiEnabled)(Oe,"quickPickSeparators"),Nt.showQuickPick(te,he,Ae)},showWorkspaceFolderPick(te){return Nt.showWorkspaceFolderPick(te)},showInputBox(te,he){return Nt.showInput(te,he)},showOpenDialog(te){return fi.showOpenDialog(te)},showSaveDialog(te){return fi.showSaveDialog(te)},createStatusBarItem(te,he,Ae){let ht,Ct,Pt;return typeof te=="string"?(ht=te,Ct=he,Pt=Ae):(Ct=te,Pt=he),zt.createStatusBarEntry(Oe,ht,Ct,Pt)},setStatusBarMessage(te,he){return zt.setStatusBarMessage(te,he)},withScmProgress(te){return Le.report("window.withScmProgress",Oe,"Use 'withProgress' instead."),di.withProgress(Oe,{location:N.ProgressLocation.SourceControl},(he,Ae)=>te({report(ht){}}))},withProgress(te,he){return di.withProgress(Oe,te,he)},createOutputChannel(te){return Bt.createOutputChannel(te,Oe)},createWebviewPanel(te,he,Ae,ht){return oi.createWebviewPanel(Oe,te,he,Ae,ht)},createWebviewTextEditorInset(te,he,Ae,ht){return(0,ve.checkProposedApiEnabled)(Oe,"editorInsets"),wi.createWebviewEditorInset(te,he,Ae,ht,Oe)},createTerminal(te,he,Ae){return typeof te=="object"?("location"in te&&(0,ve.checkProposedApiEnabled)(Oe,"terminalLocation"),"pty"in te?bt.createExtensionTerminal(te):bt.createTerminalFromOptions(te)):bt.createTerminal(te,he,Ae)},registerTerminalLinkProvider(te){return bt.registerLinkProvider(te)},registerTerminalProfileProvider(te,he){return bt.registerProfileProvider(Oe,te,he)},registerTreeDataProvider(te,he){return Xt.registerTreeDataProvider(te,he,Oe)},createTreeView(te,he){return Xt.createTreeView(te,he,Oe)},registerWebviewPanelSerializer:(te,he)=>oi.registerWebviewPanelSerializer(Oe,te,he),registerCustomEditorProvider:(te,he,Ae={})=>_i.registerCustomEditorProvider(Oe,te,he,Ae),registerFileDecorationProvider(te){return yt.registerFileDecorationProvider(te,Oe.identifier)},registerUriHandler(te){return Vt.registerUriHandler(Oe.identifier,te)},createQuickPick(){return Nt.createQuickPick(Oe)},createInputBox(){return Nt.createInputBox(Oe.identifier)},get activeColorTheme(){return hi.activeColorTheme},onDidChangeActiveColorTheme(te,he,Ae){return hi.onDidChangeActiveColorTheme(te,he,Ae)},registerWebviewViewProvider(te,he,Ae){return Si.registerWebviewViewProvider(Oe,te,he,Ae?.webviewOptions)},get activeNotebookEditor(){return(0,ve.checkProposedApiEnabled)(Oe,"notebookEditor"),St.activeNotebookEditor},onDidChangeActiveNotebookEditor(te,he,Ae){return(0,ve.checkProposedApiEnabled)(Oe,"notebookEditor"),St.onDidChangeActiveNotebookEditor(te,he,Ae)},get visibleNotebookEditors(){return(0,ve.checkProposedApiEnabled)(Oe,"notebookEditor"),St.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,ve.checkProposedApiEnabled)(Oe,"notebookEditor"),St.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(te,he,Ae){return(0,ve.checkProposedApiEnabled)(Oe,"notebookEditor"),jt.onDidChangeNotebookEditorSelection(te,he,Ae)},onDidChangeNotebookEditorVisibleRanges(te,he,Ae){return(0,ve.checkProposedApiEnabled)(Oe,"notebookEditor"),jt.onDidChangeNotebookEditorVisibleRanges(te,he,Ae)},showNotebookDocument(te,he){return(0,ve.checkProposedApiEnabled)(Oe,"notebookEditor"),St.showNotebookDocument(te,he)},registerExternalUriOpener(te,he,Ae){return(0,ve.checkProposedApiEnabled)(Oe,"externalUriOpener"),Zt.registerExternalUriOpener(Oe.identifier,te,he,Ae)},get tabs(){return(0,ve.checkProposedApiEnabled)(Oe,"tabs"),mt.tabs},get activeTab(){return(0,ve.checkProposedApiEnabled)(Oe,"tabs"),mt.activeTab},get onDidChangeTabs(){return(0,ve.checkProposedApiEnabled)(Oe,"tabs"),mt.onDidChangeTabs},get onDidChangeActiveTab(){return(0,ve.checkProposedApiEnabled)(Oe,"tabs"),mt.onDidChangeActiveTab},getInlineCompletionItemController(te){return(0,ve.checkProposedApiEnabled)(Oe,"inlineCompletions"),d.InlineCompletionController.get(te)}},pi={get rootPath(){return Le.report("workspace.rootPath",Oe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),qe.getPath()},set rootPath(te){throw L.readonly()},getWorkspaceFolder(te){return qe.getWorkspaceFolder(te)},get workspaceFolders(){return qe.getWorkspaceFolders()},get name(){return qe.name},set name(te){throw L.readonly()},get workspaceFile(){return qe.workspaceFile},set workspaceFile(te){throw L.readonly()},updateWorkspaceFolders:(te,he,...Ae)=>qe.updateWorkspaceFolders(Oe,te,he||0,...Ae),onDidChangeWorkspaceFolders:function(te,he,Ae){return qe.onDidChangeWorkspace(te,he,Ae)},asRelativePath:(te,he)=>qe.getRelativePath(te,he),findFiles:(te,he,Ae,ht)=>qe.findFiles(H.GlobPattern.from(te),H.GlobPattern.from(he),Ae,Oe.identifier,ht),findTextInFiles:(te,he,Ae,ht)=>{(0,ve.checkProposedApiEnabled)(Oe,"findTextInFiles");let Ct,Pt;return typeof he=="object"?(Ct=he,Pt=Ae):(Ct={},Pt=he,ht=Ae),qe.findTextInFiles(te,Ct||{},Pt,Oe.identifier,ht)},saveAll:te=>qe.saveAll(te),applyEdit(te){return yi.applyWorkspaceEdit(te)},createFileSystemWatcher:(te,he,Ae,ht)=>Ot.createFileSystemWatcher(H.GlobPattern.from(te),he,Ae,ht),get textDocuments(){return kt.getAllDocumentData().map(te=>te.document)},set textDocuments(te){throw L.readonly()},openTextDocument(te){let he;const Ae=te;if(typeof te=="string")he=Promise.resolve(i.URI.file(te));else if(i.URI.isUri(te))he=Promise.resolve(te);else if(!Ae||typeof Ae=="object")he=kt.createDocumentData(Ae);else throw new Error("illegal argument - uriOrFileNameOrOptions");return he.then(ht=>kt.ensureDocumentData(ht).then(Ct=>Ct.document))},onDidOpenTextDocument:(te,he,Ae)=>kt.onDidAddDocument(te,he,Ae),onDidCloseTextDocument:(te,he,Ae)=>kt.onDidRemoveDocument(te,he,Ae),onDidChangeTextDocument:(te,he,Ae)=>kt.onDidChangeDocument(te,he,Ae),onDidSaveTextDocument:(te,he,Ae)=>kt.onDidSaveDocument(te,he,Ae),onWillSaveTextDocument:(te,he,Ae)=>ti.getOnWillSaveTextDocumentEvent(Oe)(te,he,Ae),get notebookDocuments(){return St.notebookDocuments.map(te=>te.apiNotebook)},async openNotebookDocument(te,he){let Ae;if(i.URI.isUri(te))Ae=te,await St.openNotebookDocument(te);else if(typeof te=="string")Ae=i.URI.revive(await St.createNotebookDocument({viewType:te,content:he}));else throw new Error("Invalid arguments");return St.getNotebookDocument(Ae).apiNotebook},get onDidOpenNotebookDocument(){return St.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return St.onDidCloseNotebookDocument},registerNotebookSerializer(te,he,Ae,ht){return St.registerNotebookSerializer(Oe,te,he,Ae,(0,ve.isProposedApiEnabled)(Oe,"notebookLiveShare")?ht:void 0)},registerNotebookContentProvider:(te,he,Ae,ht)=>((0,ve.checkProposedApiEnabled)(Oe,"notebookContentProvider"),St.registerNotebookContentProvider(Oe,te,he,Ae,(0,ve.isProposedApiEnabled)(Oe,"notebookLiveShare")?ht:void 0)),onDidChangeConfiguration:(te,he,Ae)=>Lt.onDidChangeConfiguration(te,he,Ae),getConfiguration(te,he){return he=arguments.length===1?void 0:he,Lt.getConfiguration(te,he,Oe)},registerTextDocumentContentProvider(te,he){return $t.registerTextDocumentContentProvider(te,he)},registerTaskProvider:(te,he)=>(Le.report("window.registerTaskProvider",Oe,"Use the corresponding function on the 'tasks' namespace instead"),Dt.registerTaskProvider(Oe,te,he)),registerFileSystemProvider(te,he,Ae){return ri.registerFileSystemProvider(Oe,te,he,Ae)},get fs(){return we.value},registerFileSearchProvider:(te,he)=>((0,ve.checkProposedApiEnabled)(Oe,"fileSearchProvider"),Tt.registerFileSearchProvider(te,he)),registerTextSearchProvider:(te,he)=>((0,ve.checkProposedApiEnabled)(Oe,"textSearchProvider"),Tt.registerTextSearchProvider(te,he)),registerRemoteAuthorityResolver:(te,he)=>((0,ve.checkProposedApiEnabled)(Oe,"resolvers"),Fe.registerRemoteAuthorityResolver(te,he)),registerResourceLabelFormatter:te=>((0,ve.checkProposedApiEnabled)(Oe,"resolvers"),Ei.$registerResourceLabelFormatter(te)),onDidCreateFiles:(te,he,Ae)=>Ot.onDidCreateFile(te,he,Ae),onDidDeleteFiles:(te,he,Ae)=>Ot.onDidDeleteFile(te,he,Ae),onDidRenameFiles:(te,he,Ae)=>Ot.onDidRenameFile(te,he,Ae),onWillCreateFiles:(te,he,Ae)=>Ot.getOnWillCreateFileEvent(Oe)(te,he,Ae),onWillDeleteFiles:(te,he,Ae)=>Ot.getOnWillDeleteFileEvent(Oe)(te,he,Ae),onWillRenameFiles:(te,he,Ae)=>Ot.getOnWillRenameFileEvent(Oe)(te,he,Ae),openTunnel:te=>((0,ve.checkProposedApiEnabled)(Oe,"resolvers"),Ce.openTunnel(Oe,te).then(he=>{if(!he)throw new Error("cannot open tunnel");return he})),get tunnels(){return(0,ve.checkProposedApiEnabled)(Oe,"resolvers"),Ce.getTunnels()},onDidChangeTunnels:(te,he,Ae)=>((0,ve.checkProposedApiEnabled)(Oe,"resolvers"),Ce.onDidChangeTunnels(te,he,Ae)),registerPortAttributesProvider:(te,he)=>((0,ve.checkProposedApiEnabled)(Oe,"portsAttributes"),Ce.registerPortsAttributesProvider(te,he)),registerTimelineProvider:(te,he)=>((0,ve.checkProposedApiEnabled)(Oe,"timeline"),si.registerTimelineProvider(te,he,Oe.identifier,gt.converter)),get isTrusted(){return qe.trusted},requestWorkspaceTrust:te=>((0,ve.checkProposedApiEnabled)(Oe,"workspaceTrust"),qe.requestWorkspaceTrust(te)),onDidGrantWorkspaceTrust:(te,he,Ae)=>qe.onDidGrantWorkspaceTrust(te,he,Ae)},Ri={get inputBox(){return Le.report("scm.inputBox",Oe,"Use 'SourceControl.inputBox' instead"),Yt.getLastInputBox(Oe)},createSourceControl(te,he,Ae){return Yt.createSourceControl(Oe,te,he,Ae)}},Li={createCommentController(te,he){return bi.createCommentController(Oe,te,he)}},Fi={get activeDebugSession(){return vt.activeDebugSession},get activeDebugConsole(){return vt.activeDebugConsole},get breakpoints(){return vt.breakpoints},onDidStartDebugSession(te,he,Ae){return vt.onDidStartDebugSession(te,he,Ae)},onDidTerminateDebugSession(te,he,Ae){return vt.onDidTerminateDebugSession(te,he,Ae)},onDidChangeActiveDebugSession(te,he,Ae){return vt.onDidChangeActiveDebugSession(te,he,Ae)},onDidReceiveDebugSessionCustomEvent(te,he,Ae){return vt.onDidReceiveDebugSessionCustomEvent(te,he,Ae)},onDidChangeBreakpoints(te,he,Ae){return vt.onDidChangeBreakpoints(te,he,Ae)},registerDebugConfigurationProvider(te,he,Ae){return vt.registerDebugConfigurationProvider(te,he,Ae||N.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(te,he){return vt.registerDebugAdapterDescriptorFactory(Oe,te,he)},registerDebugAdapterTrackerFactory(te,he){return vt.registerDebugAdapterTrackerFactory(te,he)},startDebugging(te,he,Ae){return!Ae||typeof Ae=="object"&&"configuration"in Ae?vt.startDebugging(te,he,{parentSession:Ae}):vt.startDebugging(te,he,Ae||{})},stopDebugging(te){return vt.stopDebugging(te)},addBreakpoints(te){return vt.addBreakpoints(te)},removeBreakpoints(te){return vt.removeBreakpoints(te)},asDebugSourceUri(te,he){return vt.asDebugSourceUri(te,he)}},Mi={registerTaskProvider:(te,he)=>Dt.registerTaskProvider(Oe,te,he),fetchTasks:te=>Dt.fetchTasks(te),executeTask:te=>Dt.executeTask(Oe,te),get taskExecutions(){return Dt.taskExecutions},onDidStartTask:(te,he,Ae)=>Dt.onDidStartTask(te,he,Ae),onDidEndTask:(te,he,Ae)=>Dt.onDidEndTask(te,he,Ae),onDidStartTaskProcess:(te,he,Ae)=>Dt.onDidStartTaskProcess(te,he,Ae),onDidEndTaskProcess:(te,he,Ae)=>Dt.onDidEndTaskProcess(te,he,Ae)},Oi={createNotebookController(te,he,Ae,ht,Ct){return ii.createNotebookController(Oe,te,he,Ae,ht,(0,ve.isProposedApiEnabled)(Oe,"notebookMessaging")?Ct:void 0)},registerNotebookCellStatusBarItemProvider:(te,he)=>St.registerNotebookCellStatusBarItemProvider(Oe,te,he),get onDidSaveNotebookDocument(){return(0,ve.checkProposedApiEnabled)(Oe,"notebookEditor"),Qt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(te){return(0,ve.checkProposedApiEnabled)(Oe,"notebookEditorDecorationType"),jt.createNotebookEditorDecorationType(te)},createRendererMessaging(te){return ni.createRendererMessaging(Oe,te)},onDidChangeNotebookDocumentMetadata(te,he,Ae){return(0,ve.checkProposedApiEnabled)(Oe,"notebookEditor"),Qt.onDidChangeNotebookDocumentMetadata(te,he,Ae)},onDidChangeNotebookCells(te,he,Ae){return(0,ve.checkProposedApiEnabled)(Oe,"notebookEditor"),St.onDidChangeNotebookCells(te,he,Ae)},onDidChangeNotebookCellExecutionState(te,he,Ae){return(0,ve.checkProposedApiEnabled)(Oe,"notebookCellExecutionState"),St.onDidChangeNotebookCellExecutionState(te,he,Ae)},onDidChangeCellOutputs(te,he,Ae){return(0,ve.checkProposedApiEnabled)(Oe,"notebookEditor"),St.onDidChangeCellOutputs(te,he,Ae)},onDidChangeCellMetadata(te,he,Ae){return(0,ve.checkProposedApiEnabled)(Oe,"notebookEditor"),St.onDidChangeCellMetadata(te,he,Ae)},createConcatTextDocument(te,he){return(0,ve.checkProposedApiEnabled)(Oe,"notebookConcatTextDocument"),new je.ExtHostNotebookConcatDocument(St,kt,te,he)}};return{version:ue.version,authentication:ki,commands:Ii,comments:Li,debug:Fi,env:mi,extensions:Ti,languages:Ai,notebooks:Oi,scm:Ri,tasks:Mi,tests:Pi,window:ci,workspace:pi,Breakpoint:N.Breakpoint,CallHierarchyIncomingCall:N.CallHierarchyIncomingCall,CallHierarchyItem:N.CallHierarchyItem,CallHierarchyOutgoingCall:N.CallHierarchyOutgoingCall,CancellationError:L.CancellationError,CancellationTokenSource:g.CancellationTokenSource,CandidatePortSource:c.CandidatePortSource,CodeAction:N.CodeAction,CodeActionKind:N.CodeActionKind,CodeActionTriggerKind:N.CodeActionTriggerKind,CodeLens:N.CodeLens,Color:N.Color,ColorInformation:N.ColorInformation,ColorPresentation:N.ColorPresentation,ColorThemeKind:N.ColorThemeKind,CommentMode:N.CommentMode,CommentThreadCollapsibleState:N.CommentThreadCollapsibleState,CompletionItem:N.CompletionItem,CompletionItemKind:N.CompletionItemKind,CompletionItemTag:N.CompletionItemTag,CompletionList:N.CompletionList,CompletionTriggerKind:N.CompletionTriggerKind,ConfigurationTarget:N.ConfigurationTarget,CustomExecution:N.CustomExecution,DebugAdapterExecutable:N.DebugAdapterExecutable,DebugAdapterInlineImplementation:N.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:N.DebugAdapterNamedPipeServer,DebugAdapterServer:N.DebugAdapterServer,DebugConfigurationProviderTriggerKind:N.DebugConfigurationProviderTriggerKind,DebugConsoleMode:N.DebugConsoleMode,DecorationRangeBehavior:N.DecorationRangeBehavior,Diagnostic:N.Diagnostic,DiagnosticRelatedInformation:N.DiagnosticRelatedInformation,DiagnosticSeverity:N.DiagnosticSeverity,DiagnosticTag:N.DiagnosticTag,Disposable:N.Disposable,DocumentHighlight:N.DocumentHighlight,DocumentHighlightKind:N.DocumentHighlightKind,DocumentLink:N.DocumentLink,DocumentSymbol:N.DocumentSymbol,EndOfLine:N.EndOfLine,EnvironmentVariableMutatorType:N.EnvironmentVariableMutatorType,EvaluatableExpression:N.EvaluatableExpression,InlineValueText:N.InlineValueText,InlineValueVariableLookup:N.InlineValueVariableLookup,InlineValueEvaluatableExpression:N.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:N.InlineCompletionTriggerKind,EventEmitter:y.Emitter,ExtensionKind:N.ExtensionKind,ExtensionMode:N.ExtensionMode,ExternalUriOpenerPriority:N.ExternalUriOpenerPriority,FileChangeType:N.FileChangeType,FileDecoration:N.FileDecoration,FileSystemError:N.FileSystemError,FileType:I.FileType,FilePermission:I.FilePermission,FoldingRange:N.FoldingRange,FoldingRangeKind:N.FoldingRangeKind,FunctionBreakpoint:N.FunctionBreakpoint,InlineCompletionItem:N.InlineSuggestion,InlineCompletionList:N.InlineSuggestions,Hover:N.Hover,IndentAction:D.IndentAction,Location:N.Location,MarkdownString:N.MarkdownString,OverviewRulerLane:_.OverviewRulerLane,ParameterInformation:N.ParameterInformation,PortAutoForwardAction:N.PortAutoForwardAction,Position:N.Position,ProcessExecution:N.ProcessExecution,ProgressLocation:N.ProgressLocation,QuickInputButtons:N.QuickInputButtons,Range:N.Range,RelativePattern:N.RelativePattern,Selection:N.Selection,SelectionRange:N.SelectionRange,SemanticTokens:N.SemanticTokens,SemanticTokensBuilder:N.SemanticTokensBuilder,SemanticTokensEdit:N.SemanticTokensEdit,SemanticTokensEdits:N.SemanticTokensEdits,SemanticTokensLegend:N.SemanticTokensLegend,ShellExecution:N.ShellExecution,ShellQuoting:N.ShellQuoting,SignatureHelp:N.SignatureHelp,SignatureHelpTriggerKind:N.SignatureHelpTriggerKind,SignatureInformation:N.SignatureInformation,SnippetString:N.SnippetString,SourceBreakpoint:N.SourceBreakpoint,StandardTokenType:N.StandardTokenType,StatusBarAlignment:N.StatusBarAlignment,SymbolInformation:N.SymbolInformation,SymbolKind:N.SymbolKind,SymbolTag:N.SymbolTag,Task:N.Task,TaskGroup:N.TaskGroup,TaskPanelKind:N.TaskPanelKind,TaskRevealKind:N.TaskRevealKind,TaskScope:N.TaskScope,TerminalLink:N.TerminalLink,TerminalLocation:N.TerminalLocation,TerminalProfile:N.TerminalProfile,TextDocumentSaveReason:N.TextDocumentSaveReason,TextEdit:N.TextEdit,TextEditorCursorStyle:k.TextEditorCursorStyle,TextEditorLineNumbersStyle:N.TextEditorLineNumbersStyle,TextEditorRevealType:N.TextEditorRevealType,TextEditorSelectionChangeKind:N.TextEditorSelectionChangeKind,TextDocumentChangeReason:N.TextDocumentChangeReason,ThemeColor:N.ThemeColor,ThemeIcon:N.ThemeIcon,TreeItem:N.TreeItem,TreeItemCollapsibleState:N.TreeItemCollapsibleState,TypeHierarchyItem:N.TypeHierarchyItem,UIKind:c.UIKind,Uri:i.URI,ViewColumn:N.ViewColumn,WorkspaceEdit:N.WorkspaceEdit,InlayHint:N.InlayHint,InlayHintKind:N.InlayHintKind,RemoteAuthorityResolverError:N.RemoteAuthorityResolverError,ResolvedAuthority:N.ResolvedAuthority,SourceControlInputBoxValidationType:N.SourceControlInputBoxValidationType,ExtensionRuntime:N.ExtensionRuntime,TimelineItem:N.TimelineItem,NotebookRange:N.NotebookRange,NotebookCellKind:N.NotebookCellKind,NotebookCellExecutionState:N.NotebookCellExecutionState,NotebookCellData:N.NotebookCellData,NotebookData:N.NotebookData,NotebookRendererScript:N.NotebookRendererScript,NotebookCellStatusBarAlignment:N.NotebookCellStatusBarAlignment,NotebookEditorRevealType:N.NotebookEditorRevealType,NotebookCellOutput:N.NotebookCellOutput,NotebookCellOutputItem:N.NotebookCellOutputItem,NotebookCellStatusBarItem:N.NotebookCellStatusBarItem,NotebookControllerAffinity:N.NotebookControllerAffinity,PortAttributes:N.PortAttributes,LinkedEditingRanges:N.LinkedEditingRanges,TestResultState:N.TestResultState,TestRunRequest:N.TestRunRequest,TestMessage:N.TestMessage,TestTag:N.TestTag,TestRunProfileKind:N.TestRunProfileKind,TextSearchCompleteMessageType:Ue.TextSearchCompleteMessageType,CoveredCount:N.CoveredCount,FileCoverage:N.FileCoverage,StatementCoverage:N.StatementCoverage,BranchCoverage:N.BranchCoverage,FunctionCoverage:N.FunctionCoverage,WorkspaceTrustState:N.WorkspaceTrustState,LanguageStatusSeverity:N.LanguageStatusSeverity,QuickPickItemKind:N.QuickPickItemKind}}}e.createApiFactoryAndRegisterActors=Te}),define(fe[278],me([0,1,84,133,36,131,37,40,46,34,73,57,75,92,54,68,134,69,45,91,122,56,132,11,230]),function(Y,e,g,L,y,C,i,k,_,D,T,I,c,p,f,v,S,P,w,s,r,m,a,b,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,g.registerSingleton)(b.ILoggerService,a.ExtHostLoggerService),(0,g.registerSingleton)(b.ILogService,n.ExtHostLogService),(0,g.registerSingleton)(v.IExtHostApiDeprecationService,v.ExtHostApiDeprecationService),(0,g.registerSingleton)(k.IExtHostCommands,k.ExtHostCommands),(0,g.registerSingleton)(i.IExtHostConfiguration,i.ExtHostConfiguration),(0,g.registerSingleton)(P.IExtHostConsumerFileSystem,P.ExtHostConsumerFileSystem),(0,g.registerSingleton)(I.IExtHostDebugService,I.WorkerExtHostDebugService),(0,g.registerSingleton)(C.IExtHostDecorations,C.ExtHostDecorations),(0,g.registerSingleton)(_.IExtHostDocumentsAndEditors,_.ExtHostDocumentsAndEditors),(0,g.registerSingleton)(w.IExtHostFileSystemInfo,w.ExtHostFileSystemInfo),(0,g.registerSingleton)(L.IExtHostOutputService,L.ExtHostOutputService),(0,g.registerSingleton)(c.IExtHostSearch,c.ExtHostSearch),(0,g.registerSingleton)(p.IExtHostStorage,p.ExtHostStorage),(0,g.registerSingleton)(T.IExtHostTask,T.WorkerExtHostTask),(0,g.registerSingleton)(D.IExtHostTerminalService,D.WorkerExtHostTerminalService),(0,g.registerSingleton)(f.IExtHostTunnelService,f.ExtHostTunnelService),(0,g.registerSingleton)(S.IExtHostWindow,S.ExtHostWindow),(0,g.registerSingleton)(y.IExtHostWorkspace,y.ExtHostWorkspace),(0,g.registerSingleton)(s.IExtHostSecretState,s.ExtHostSecretState),(0,g.registerSingleton)(r.IExtHostTelemetry,r.ExtHostTelemetry),(0,g.registerSingleton)(m.IExtHostEditorTabs,m.ExtHostEditorTabs)}),define(fe[93],me([0,1,15,11,33,72]),function(Y,e,g,L,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function i(I){return I.startsWith("**")||I.startsWith("/")?I:`/${I}`}e.anchorGlob=i;function k(I,c,p,f){const v=(0,g.mapArrayOrNot)(p,_),S=new y.TextSearchMatch(c,v,f),P=S.preview.matches;return{ranges:(0,g.mapArrayOrNot)(v,D),uri:I,preview:{text:S.preview.text,matches:(0,g.mapArrayOrNot)(P,D)}}}e.createTextSearchResult=k;function _(I){return new y.SearchRange(I.start.line,I.start.character,I.end.line,I.end.character)}function D(I){return new C.Range(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn)}let T=class{constructor(c,p){this.prefix=c,this.logService=p}appendLine(c){this.logService.debug(`${this.prefix}#search`,c)}};T=Ve([$e(1,L.ILogService)],T),e.OutputChannel=T}),define(fe[279],me([0,1,96,22]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function y(a){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(b=>b===a)}e.isUTFEncoding=y,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const C=512,i=512,k=512*8,_=512*128;class D{constructor(b){this.iconvLiteDecoder=b}static async create(b){let n;if(b!==e.UTF8)n=(await new Promise((l,d)=>{Y(["iconv-lite-umd"],l,d)})).getDecoder(p(b));else{const t=new TextDecoder;n={write(l){return t.decode(l,{stream:!0})},end(){return t.decode()}}}return new D(n)}write(b){return this.iconvLiteDecoder.write(b)}end(){return this.iconvLiteDecoder.end()}}function T(a,b){const n=b.minBytesRequiredForDetection??b.guessEncoding?k:i;return new Promise((t,l)=>{const d=(0,g.newWriteableStream)(A=>A.join("")),o=[];let h=0,u;const E=async()=>{try{const A=await m({buffer:L.VSBuffer.concat(o),bytesRead:h},b.guessEncoding);A.encoding=await b.overwriteEncoding(A.encoding),u=await D.create(A.encoding);const R=u.write(L.VSBuffer.concat(o).buffer);d.write(R),o.length=0,h=0,t({stream:d,detected:A})}catch(A){l(A)}};(0,g.listenStream)(a,{onData:async A=>{u?d.write(u.write(A.buffer)):(o.push(A),h+=A.byteLength,h>=n&&(a.pause(),await E(),setTimeout(()=>a.resume())))},onError:A=>d.error(A),onEnd:async()=>{u||await E(),d.end(u?.end())}})})}e.toDecodeStream=T;async function I(a,b,n){const l=(await new Promise((h,u)=>{Y(["iconv-lite-umd"],h,u)})).getEncoder(p(b),n);let d=!1,o=!1;return{read(){if(o)return null;const h=a.read();if(typeof h!="string"){if(o=!0,!d&&n?.addBOM)switch(b){case e.UTF8:case e.UTF8_with_bom:return L.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return L.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return L.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const u=l.end();return u&&u.length>0?(d=!0,L.VSBuffer.wrap(u)):null}return d=!0,L.VSBuffer.wrap(l.write(h))}}}e.toEncodeReadable=I;async function c(a){return(await new Promise((n,t)=>{Y(["iconv-lite-umd"],n,t)})).encodingExists(p(a))}e.encodingExists=c;function p(a){return a===e.UTF8_with_bom||a===null?e.UTF8:a}e.toNodeEncoding=p;function f(a,b){if(!a||b<e.UTF16be_BOM.length)return null;const n=a.readUInt8(0),t=a.readUInt8(1);if(n===e.UTF16be_BOM[0]&&t===e.UTF16be_BOM[1])return e.UTF16be;if(n===e.UTF16le_BOM[0]&&t===e.UTF16le_BOM[1])return e.UTF16le;if(b<e.UTF8_BOM.length)return null;const l=a.readUInt8(2);return n===e.UTF8_BOM[0]&&t===e.UTF8_BOM[1]&&l===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=f;const v=["ascii","utf-16","utf-32"];async function S(a){const b=await new Promise((o,h)=>{Y(["jschardet"],o,h)}),n=a.slice(0,_),t=s(n.buffer),l=b.detect(t);if(!l||!l.encoding)return null;const d=l.encoding.toLowerCase();return 0<=v.indexOf(d)?null:w(l.encoding)}const P={ibm866:"cp866",big5:"cp950"};function w(a){const b=a.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return P[b]||b}function s(a){let b="";for(let n=0;n<a.length;n++)b+=String.fromCharCode(a[n]);return b}function r(a){switch(a){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const b=a.match(/windows(\d+)/);return b?"windows-"+b[1]:a}}e.toCanonicalName=r;function m({buffer:a,bytesRead:b},n){let t=f(a,b),l=!1;if(t!==e.UTF16be&&t!==e.UTF16le&&a){let d=!0,o=!0,h=!1;for(let u=0;u<b&&u<C;u++){const E=u%2==1,A=a.readUInt8(u)===0;if(A&&(h=!0),d&&(E&&!A||!E&&A)&&(d=!1),o&&(E&&A||!E&&!A)&&(o=!1),A&&!d&&!o)break}h&&(d?t=e.UTF16le:o?t=e.UTF16be:l=!0)}return n&&!l&&!t&&a?S(a.slice(0,b)).then(d=>({seemsBinary:!1,encoding:d})):{seemsBinary:l,encoding:t}}e.detectEncodingFromBuffer=m,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(fe[136],me([0,1,279,28,135]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class C extends y.TextSearchManager{constructor(k,_,D=L,T="searchProcess"){super(k,_,{readdir:I=>D.Promises.readdir(I.fsPath),toCanonicalName:I=>(0,g.toCanonicalName)(I)},T)}}e.NativeTextSearchManager=C}),define(fe[280],me([0,1,281,295,296,2,297]),function(Y,e,g,L,y,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function k(I,c,p,f,v,S){const P=S.environment.useHostProxy,w=typeof P=="boolean"?P:!S.remote.isRemote,s=(0,i.createProxyResolver)({resolveProxy:m=>I.resolveProxy(m),getHttpProxySetting:()=>c.getConfiguration("http").get("proxy"),log:(m,a,...b)=>{switch(m){case i.LogLevel.Trace:f.trace(a,...b);break;case i.LogLevel.Debug:f.debug(a,...b);break;case i.LogLevel.Info:f.info(a,...b);break;case i.LogLevel.Warning:f.warn(a,...b);break;case i.LogLevel.Error:f.error(a,...b);break;case i.LogLevel.Critical:f.critical(a,...b);break;case i.LogLevel.Off:break;default:n(m,a,b);break}function n(t,l,...d){f.error("Unknown log level",t),f.error(l,...d)}},getLogLevel:()=>f.getLevel(),proxyResolveTelemetry:m=>{v.$publicLog2("resolveProxy",m)},useHostProxy:w,env:process.env}),r=_(c,s);return T(p,r)}e.connectProxyResolver=k;function _(I,c){const p={config:I.getConfiguration("http").get("proxySupport")||"off"};I.onDidChangeConfiguration(v=>{p.config=I.getConfiguration("http").get("proxySupport")||"off"});const f={config:!!I.getConfiguration("http").get("systemCertificates")};return I.onDidChangeConfiguration(v=>{f.config=!!I.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},g,(0,i.createHttpPatch)(g,c,{config:"off"},f,!0)),on:Object.assign({},g,(0,i.createHttpPatch)(g,c,{config:"on"},f,!0)),override:Object.assign({},g,(0,i.createHttpPatch)(g,c,{config:"override"},f,!0)),onRequest:Object.assign({},g,(0,i.createHttpPatch)(g,c,p,f,!0)),default:Object.assign(g,(0,i.createHttpPatch)(g,c,p,f,!1))},https:{off:Object.assign({},L,(0,i.createHttpPatch)(L,c,{config:"off"},f,!0)),on:Object.assign({},L,(0,i.createHttpPatch)(L,c,{config:"on"},f,!0)),override:Object.assign({},L,(0,i.createHttpPatch)(L,c,{config:"override"},f,!0)),onRequest:Object.assign({},L,(0,i.createHttpPatch)(L,c,p,f,!0)),default:Object.assign(L,(0,i.createHttpPatch)(L,c,p,f,!1))},tls:Object.assign(y,(0,i.createTlsPatch)(y))}}const D=new Map;function T(I,c){return I.getExtensionPathIndex().then(p=>{const f=Y.__$__nodeRequire("module"),v=f._load;f._load=function(P,w,s){if(P==="tls")return c.tls;if(P!=="http"&&P!=="https")return v.apply(this,arguments);const r=c[P],m=p.findSubstr(C.URI.file(w.filename));let a=D.get(m);if(a||D.set(m,a={}),!a[P]){let b=r.default;a[P]={...b}}return a[P]}})}}),define(fe[282],me([0,1,39,9,80,30,12,8,93,283]),function(Y,e,g,L,y,C,i,k,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const T=D.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function I(s,r,m,a){const b=c(s,r,m,a),n=r.folder.fsPath;return{cmd:g.spawn(T,b.args,{cwd:n}),rgDiskPath:T,siblingClauses:b.siblingClauses,rgArgs:b,cwd:n}}e.spawnRipgrepCmd=I;function c(s,r,m,a){const b=["--files","--hidden","--case-sensitive"];f([r],m,!1).forEach(t=>{const l=(0,_.anchorGlob)(t);if(b.push("-g",l),i.isMacintosh){const d=(0,y.normalizeNFD)(l);d!==l&&b.push("-g",d)}});const n=p([r],a,void 0,!1);return n.globArgs.forEach(t=>{const l=`!${(0,_.anchorGlob)(t)}`;if(b.push("-g",l),i.isMacintosh){const d=(0,y.normalizeNFD)(l);d!==l&&b.push("-g",d)}}),r.disregardIgnoreFiles!==!1?b.push("--no-ignore"):b.push("--no-ignore-parent"),r.ignoreSymlinks||b.push("--follow"),s.exists&&b.push("--quiet"),b.push("--no-config"),r.disregardGlobalIgnoreFiles&&b.push("--no-ignore-global"),{args:b,siblingClauses:n.siblingClauses}}function p(s,r,m,a=!0){const b=[];let n={};return s.forEach(t=>{const l=Object.assign({},t.excludePattern||{},r||{}),d=v(l,a?t.folder.fsPath:void 0,m);b.push(...d.globArgs),d.siblingClauses&&(n=Object.assign(n,d.siblingClauses))}),{globArgs:b,siblingClauses:n}}e.foldersToRgExcludeGlobs=p;function f(s,r,m=!0){const a=[];return s.forEach(b=>{const n=Object.assign({},r||{},b.includePattern||{}),t=v(n,m?b.folder.fsPath:void 0);a.push(...t.globArgs)}),a}e.foldersToIncludeGlobs=f;function v(s,r,m){const a=[],b={};return Object.keys(s).forEach(n=>{if(m&&m.has(n)||!n)return;const t=s[n];n=P(r?S(r,n):n),n.startsWith("\\\\")?n="\\\\"+n.substr(2).replace(/\\/g,"/"):n=n.replace(/\\/g,"/"),typeof t=="boolean"&&t?(n.startsWith("\\\\")&&(n+="**"),a.push(w(n))):t&&t.when&&(b[n]=t)}),{globArgs:a,siblingClauses:b}}function S(s,r){return L.isAbsolute(r)?r:L.join(s,r)}e.getAbsoluteGlob=S;function P(s){return s=k.rtrim(s,"\\"),k.rtrim(s,"/")}function w(s){return C.getRoot(s).toLowerCase()==="c:/"?s.replace(/^c:[/\\]/i,"/"):s}e.fixDriveC=w}),define(fe[284],me([0,1,39,63,9,104,15,52,31,80,30,12,47,8,13,28,33,282,101]),function(Y,e,g,L,y,C,i,k,_,D,T,I,c,p,f,v,S,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const s=new Set;process.on("exit",()=>{s.forEach(n=>n())});class r{constructor(t){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=t,this.filePattern=t.filePattern||"",this.includePattern=t.includePattern&&_.parse(t.includePattern),this.maxResults=t.maxResults||null,this.exists=!!t.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,w.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=t.excludePattern&&_.parse(t.excludePattern),this.folderExcludePatterns=new Map,t.folderQueries.forEach(l=>{const d=Object.assign({},l.excludePattern||{},this.config.excludePattern||{}),o=l.folder.fsPath;t.folderQueries.map(h=>h.folder.fsPath).filter(h=>h!==o).forEach(h=>{(0,T.isEqualOrParent)(h,o)&&(d[y.relative(o,h)]=!0)}),this.folderExcludePatterns.set(o,new a(d,o))})}cancel(){this.isCanceled=!0,s.forEach(t=>t())}walk(t,l,d,o,h){if(this.fileWalkSW=c.StopWatch.create(!1),this.isCanceled)return h(null,this.isLimitHit);l.forEach(u=>{const E=y.basename(u.fsPath);this.globalExcludePattern&&this.globalExcludePattern(u.fsPath,E)||this.matchFile(d,{relativePath:u.fsPath,searchPath:void 0})}),this.cmdSW=c.StopWatch.create(!1),this.parallel(t,(u,E)=>{this.call(this.cmdTraversal,this,u,d,o,A=>{if(A){const R=(0,k.toErrorMessage)(A);console.error(R),this.errors.push(R),E(A,void 0)}else E(null,void 0)})},(u,E)=>{this.fileWalkSW.stop();const A=u?i.coalesce(u)[0]:null;h(A,this.isLimitHit)})}parallel(t,l,d){const o=new Array(t.length),h=new Array(t.length);let u=!1,E=0;if(t.length===0)return d(null,[]);t.forEach((A,R)=>{l(A,(B,x)=>{if(B?(u=!0,o[R]=null,h[R]=B):(o[R]=x,h[R]=null),++E===t.length)return d(u?h:null,o)})})}call(t,l,...d){try{t.apply(l,d)}catch(o){d[d.length-1](o)}}cmdTraversal(t,l,d,o){const h=t.folder.fsPath,u=I.isMacintosh;let E;const A=()=>E&&E.kill();s.add(A);let R=N=>{s.delete(A),R=()=>{},o(N)},B="";const x=this.initDirectoryTree();let F;const $=(0,P.spawnRipgrepCmd)(this.config,t,this.config.includePattern,this.folderExcludePatterns.get(t.folder.fsPath).expression);E=$.cmd,F=!Object.keys($.siblingClauses).length;const M=$.rgArgs.args.map(N=>N.match(/^-/)?N:`'${N}'`).join(" ");let H=`${$.rgDiskPath} ${M}
 - cwd: ${$.cwd}`;$.rgArgs.siblingClauses&&(H+=`
 - Sibling clauses: ${JSON.stringify($.rgArgs.siblingClauses)}`),d({message:H}),this.cmdResultCount=0,this.collectStdout(E,"utf8",d,(N,U,V)=>{if(N){R(N);return}if(this.isLimitHit){R();return}const W=(B+(u?D.normalizeNFC(U||""):U)).split(`
`);if(V){const j=W.length;W[j-1]=W[j-1].trim(),W[j-1]||W.pop()}else B=W.pop()||"";if(W.length&&W[0].indexOf(`
`)!==-1){R(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=W.length,F){for(const j of W)if(this.matchFile(l,{base:h,relativePath:j,searchPath:this.getSearchPath(t,j)}),this.isLimitHit){A();break}(V||this.isLimitHit)&&R();return}this.addDirectoryEntries(t,x,h,W,l),V&&(this.matchDirectoryTree(x,h,l),R())})}spawnFindCmd(t){const l=this.folderExcludePatterns.get(t.folder.fsPath),d=l.getBasenameTerms(),o=l.getPathTerms(),h=["-L","."];if(d.length||o.length){h.push("-not","(","(");for(const u of d)h.push("-name",u),h.push("-o");for(const u of o)h.push("-path",u),h.push("-o");h.pop(),h.push(")","-prune",")")}return h.push("-type","f"),g.spawn("find",h,{cwd:t.folder.fsPath})}readStdout(t,l,d){let o="";this.collectStdout(t,l,()=>{},(h,u,E)=>{if(h){d(h);return}o+=u,E&&d(null,o)})}collectStdout(t,l,d,o){let h=(A,R,B)=>{(A||B)&&(h=()=>{},this.cmdSW&&this.cmdSW.stop()),o(A,R,B)},u=!1;t.stdout?(this.forwardData(t.stdout,l,h),t.stdout.once("data",()=>u=!0)):d({message:"stdout is null"});let E;t.stderr?E=this.collectData(t.stderr):d({message:"stderr is null"}),t.on("error",A=>{h(A)}),t.on("close",A=>{let R;!u&&(R=this.decodeData(E,l))&&b(R)?h(new Error(`command failed with error code ${A}: ${this.decodeData(E,l)}`)):(this.exists&&A===0&&(this.isLimitHit=!0),h(null,"",!0))})}forwardData(t,l,d){const o=new C.StringDecoder(l);return t.on("data",h=>{d(null,o.write(h))}),o}collectData(t){const l=[];return t.on("data",d=>{l.push(d)}),l}decodeData(t,l){const d=new C.StringDecoder(l);return t.map(o=>d.write(o)).join("")}initDirectoryTree(){const t={rootEntries:[],pathToEntries:Object.create(null)};return t.pathToEntries["."]=t.rootEntries,t}addDirectoryEntries(t,{pathToEntries:l},d,o,h){o.indexOf(this.filePattern)!==-1&&this.matchFile(h,{base:d,relativePath:this.filePattern,searchPath:this.getSearchPath(t,this.filePattern)});const u=E=>{const A=y.basename(E),R=y.dirname(E);let B=l[R];B||(B=l[R]=[],u(R)),B.push({base:d,relativePath:E,basename:A,searchPath:this.getSearchPath(t,E)})};o.forEach(u)}matchDirectoryTree({rootEntries:t,pathToEntries:l},d,o){const h=this,u=this.folderExcludePatterns.get(d),E=this.filePattern;function A(R){h.directoriesWalked++;const B=_.hasSiblingFn(()=>R.map(x=>x.basename));for(let x=0,F=R.length;x<F;x++){const $=R[x],{relativePath:M,basename:H}=$;if(u.test(M,H,E!==H?B:void 0))continue;const N=l[M];if(N)A(N);else{if(h.filesWalked++,M===E)continue;h.matchFile(o,$)}if(h.isLimitHit)break}}A(t)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(t,l,d,o,h){const u=t.folder,E=_.hasSiblingFn(()=>d);this.parallel(d,(A,R)=>{if(this.isCanceled||this.isLimitHit)return R(null);const B=l?[l,A].join(y.sep):A;if(this.folderExcludePatterns.get(t.folder.fsPath).test(B,A,this.config.filePattern!==A?E:void 0))return R(null);const x=[u.fsPath,B].join(y.sep);L.lstat(x,(F,$)=>{if(F||this.isCanceled||this.isLimitHit)return R(null);this.statLinkIfNeeded(x,$,(M,H)=>M||this.isCanceled||this.isLimitHit?R(null):H.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(x,$,(N,U)=>N||this.isCanceled||this.isLimitHit||(U=U||"",this.walkedPaths[U])?R(null):(this.walkedPaths[U]=!0,v.Promises.readdir(x).then(V=>{if(this.isCanceled||this.isLimitHit)return R(null);this.doWalk(t,B,V,o,O=>R(O||null))},V=>{R(null)})))):(this.filesWalked++,B===this.filePattern||this.maxFilesize&&f.isNumber(H.size)&&H.size>this.maxFilesize||this.matchFile(o,{base:u.fsPath,relativePath:B,searchPath:this.getSearchPath(t,B)}),R(null,void 0)))})},A=>{const R=A&&i.coalesce(A);return h(R&&R.length>0?R[0]:void 0)})}matchFile(t,l){this.isFileMatch(l)&&(!this.includePattern||this.includePattern(l.relativePath,y.basename(l.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||t(l))}isFileMatch(t){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,S.isFilePatternMatch)(t,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(t,l,d){return l.isSymbolicLink()?L.stat(t,d):d(null,l)}realPathIfNeeded(t,l,d){return l.isSymbolicLink()?L.realpath(t,(o,h)=>o?d(o):d(null,h)):d(null,t)}getSearchPath(t,l){return t.folderName?y.join(t.folderName,l):l}}e.FileWalker=r;class m{constructor(t){this.folderQueries=t.folderQueries,this.extraFiles=t.extraFileResources||[],this.walker=new r(t)}search(t,l,d){this.walker.walk(this.folderQueries,this.extraFiles,t,l,(o,h)=>{d(o,{limitHit:h,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=m;class a{constructor(t,l){this.expression=t,this.root=l,this.init(t)}init(t){let l,d;Object.keys(t).filter(o=>t[o]).forEach(o=>{y.isAbsolute(o)?(l=l||_.getEmptyExpression(),l[o]=t[o]):(d=d||_.getEmptyExpression(),d[o]=t[o])}),this.absoluteParsedExpr=l&&_.parse(l,{trimForExclusions:!0}),this.relativeParsedExpr=d&&_.parse(d,{trimForExclusions:!0})}test(t,l,d){return this.relativeParsedExpr&&this.relativeParsedExpr(t,l,d)||this.absoluteParsedExpr&&this.absoluteParsedExpr(y.join(this.root,t),l,d)}getBasenameTerms(){const t=[];return this.absoluteParsedExpr&&t.push(..._.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&t.push(..._.getBasenameTerms(this.relativeParsedExpr)),t}getPathTerms(){const t=[];return this.absoluteParsedExpr&&t.push(..._.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&t.push(..._.getPathTerms(this.relativeParsedExpr)),t}}function b(n){const t=n.trim().split(`
`),l=t[0].trim();if(l.startsWith("Error parsing regex"))return l;if(l.startsWith("regex parse error"))return p.uppercaseFirstLetter(t[t.length-1].trim());if(l.startsWith("error parsing glob")||l.startsWith("unsupported encoding"))return l.charAt(0).toUpperCase()+l.substr(1);if(l==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(l.startsWith("Literal "))return l}e.rgErrorMsgForDisplay=b}),define(fe[137],me([0,1,39,298,104,15,59,31,9,8,2,33,72,299,283,93]),function(Y,e,g,L,y,C,i,k,_,D,T,I,c,p,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const S=f.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class P{constructor(u){this.outputChannel=u}provideTextSearchResults(u,E,A,R){return this.outputChannel.appendLine(`provideTextSearchResults ${u.pattern}, ${JSON.stringify({...E,folder:E.folder.toString()})}`),new Promise((B,x)=>{R.onCancellationRequested(()=>O());const F=b(u,E),$=E.folder.fsPath,M=F.map(de=>de.match(/^-/)?de:`'${de}'`).join(" ");this.outputChannel.appendLine(`${S} ${M}
 - cwd: ${$}`);let H=g.spawn(S,F,{cwd:$});H.on("error",de=>{console.error(de),this.outputChannel.appendLine("Error: "+(de&&de.message)),x((0,I.serializeSearchError)(new I.SearchError(de&&de.message,I.SearchErrorCode.rgProcessError)))});let N=!1;const U=new r(E.maxResults,$,E.previewOptions);U.on("result",de=>{N=!0,j="",A.report(de)});let V=!1;const O=()=>{V=!0,H&&H.kill(),U&&U.cancel()};let W=!1;U.on("hitLimit",()=>{W=!0,O()});let j="";H.stdout.on("data",de=>{U.handleData(de),N||(j+=de)});let X=!1;H.stdout.once("data",()=>X=!0);let Q="";H.stderr.on("data",de=>{const Se=de.toString();this.outputChannel.appendLine(Se),Q+=Se}),H.on("close",()=>{if(this.outputChannel.appendLine(X?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(N?"Got result from parser":"No result from parser"),j&&this.outputChannel.appendLine(`Got data without result: ${j}`),this.outputChannel.appendLine(""),V)B({limitHit:W});else{U.flush(),H=null;let de;Q&&!X&&(de=w(Q))?x((0,I.serializeSearchError)(new I.SearchError(de.message,de.code))):B({limitHit:W})}})})}}e.RipgrepTextSearchEngine=P;function w(h){const u=h.split(`
`),E=u[0].trim();if(u.some(R=>R.startsWith("regex parse error")))return new I.SearchError(s(u),I.SearchErrorCode.regexParseError);const A=E.match(/grep config error: unknown encoding: (.*)/);if(A)return new I.SearchError(`Unknown encoding: ${A[1]}`,I.SearchErrorCode.unknownEncoding);if(E.startsWith("error parsing glob"))return new I.SearchError(E.charAt(0).toUpperCase()+E.substr(1),I.SearchErrorCode.globParseError);if(E.startsWith("the literal"))return new I.SearchError(E.charAt(0).toUpperCase()+E.substr(1),I.SearchErrorCode.invalidLiteral);if(E.startsWith("PCRE2: error compiling pattern"))return new I.SearchError(E,I.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=w;function s(h){const u=["Regex parse error"],E=h.filter(A=>A.startsWith("PCRE2:"));if(E.length>=1){const A=E[0].replace("PCRE2:","");if(A.indexOf(":")!==-1&&A.split(":").length>=2){const R=A.split(":")[1];u.push(":"+R)}}return u.join("")}e.buildRegexParseError=s;class r extends L.EventEmitter{constructor(u,E,A){super();this.maxResults=u,this.rootFolder=E,this.previewOptions=A,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new y.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(u,E){return super.on(u,E),this}handleData(u){if(this.isDone)return;const E=typeof u=="string"?u:this.stringDecoder.write(u);this.handleDecodedData(E)}handleDecodedData(u){let E=u.indexOf(`
`);const A=this.remainder+u;if(E>=0)E+=this.remainder.length;else{this.remainder=A;return}let R=0;for(;E>=0;)this.handleLine(A.substring(R,E).trim()),R=E+1,E=A.indexOf(`
`,R);this.remainder=A.substring(R)}handleLine(u){if(this.isDone||!u)return;let E;try{E=JSON.parse(u)}catch(A){throw new Error(`malformed line from rg: ${u}`)}if(E.type==="match"){const A=m(E.data.path),R=T.URI.file(_.join(this.rootFolder,A)),B=this.createTextSearchMatch(E.data,R);this.onResult(B),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(E.type==="context"){const A=m(E.data.path),R=T.URI.file(_.join(this.rootFolder,A));this.createTextSearchContext(E.data,R).forEach(x=>this.onResult(x))}}createTextSearchMatch(u,E){const A=u.line_number-1,R=m(u.lines),B=Buffer.from(R);let x=0,F=0,$=A;u.submatches.length===0&&u.submatches.push(R.length?{start:0,end:1,match:{text:R[0]}}:{start:0,end:0,match:{text:""}});const M=(0,C.coalesce)(u.submatches.map((H,N)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const U=m(H.match),V=B.slice(x,H.start).toString().length,O=F+V,W=a(U),j=$,X=W.numLines+j,Q=W.numLines>0?W.lastLineLength:W.lastLineLength+O;return x=H.end,F=Q,$=X,new c.Range(j,O,X,Q)}));return(0,v.createTextSearchResult)(E,R,M,this.previewOptions)}createTextSearchContext(u,E){const A=m(u.lines),R=u.line_number;return A.replace(/\r?\n$/,"").split(`
`).map((B,x)=>({text:B,uri:E,lineNumber:R+x}))}onResult(u){this.emit("result",u)}}e.RipgrepParser=r;function m(h){return h.bytes?Buffer.from(h.bytes,"base64").toString():h.text}function a(h){const u=/\n/g;let E=0,A=-1,R;for(;R=u.exec(h);)E++,A=R.index;const B=A>=0?h.length-A-1:h.length;return{numLines:E,lastLineLength:B}}function b(h,u){const E=["--hidden"];E.push(h.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:A,otherIncludes:R}=(0,i.groupBy)(u.includes,x=>x.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(R&&R.length){const x=new Set;R.forEach(F=>{x.add(F)}),E.push("-g","!*"),x.forEach(F=>{n(F).map(v.anchorGlob).forEach($=>{E.push("-g",$)})})}A&&A.length&&A.forEach(x=>{E.push("-g",x)}),u.excludes.map(v.anchorGlob).forEach(x=>E.push("-g",`!${x}`)),u.maxFileSize&&E.push("--max-filesize",u.maxFileSize+""),u.useIgnoreFiles?E.push("--no-ignore-parent"):E.push("--no-ignore"),u.followSymlinks&&E.push("--follow"),u.encoding&&u.encoding!=="utf8"&&E.push("--encoding",u.encoding),h.pattern==="--"&&(h.isRegExp=!0,h.pattern="\\-\\-"),h.isMultiline&&!h.isRegExp&&(h.pattern=(0,D.escapeRegExpCharacters)(h.pattern),h.isRegExp=!0),u.usePCRE2&&E.push("--pcre2"),E.push("--crlf"),h.isRegExp&&(h.pattern=t(h.pattern),E.push("--auto-hybrid-regex"));let B;if(h.isWordMatch){const F=(0,D.createRegExp)(h.pattern,!!h.isRegExp,{wholeWord:h.isWordMatch}).source.replace(/\\\//g,"/");E.push("--regexp",F)}else if(h.isRegExp){let x=d(h.pattern);x=o(x),E.push("--regexp",x)}else B=h.pattern,E.push("--fixed-strings");return E.push("--no-config"),u.useGlobalIgnoreFiles||E.push("--no-ignore-global"),E.push("--json"),h.isMultiline&&E.push("--multiline"),u.beforeContext&&E.push("--before-context",u.beforeContext+""),u.afterContext&&E.push("--after-context",u.afterContext+""),E.push("--"),B&&E.push(B),E.push("."),E}function n(h){const u=(0,k.splitGlobAware)(h,"/");return u.map((E,A)=>u.slice(0,A+1).join("/"))}e.spreadGlobComponents=n;function t(h){const u=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;h.match(u);)h=h.replace(u,"$1\\x{$2}");const E=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;h.match(E);)h=h.replace(E,"$1\\x{$2}");return h}e.unicodeEscapesToPCRE2=t;const l=h=>h.type==="Assertion"&&h.kind==="lookbehind";function d(h){let u;try{u=new p.RegExpParser().parsePattern(h)}catch{return h}let E="",A=0;const R=(F,$,M)=>{E+=h.slice(A,F)+M,A=$},B=[];return new p.RegExpVisitor({onCharacterEnter(F){if(F.raw!=="\\n")return;const $=B[0];if(!$)R(F.start,F.end,"\\r?\\n");else if(!B.some(l))if($.type==="CharacterClass")if($.negate){const M=h.slice($.start+2,F.start)+h.slice(F.end,$.end-1);if($.parent?.type==="Quantifier"){const H=$.parent;R(H.start,H.end,(M?`[^${M}]`:".")+(H.greedy?"+":"*"))}else R($.start,$.end,"(?!\\r?\\n"+(M?`|[${M}]`:"")+")")}else{const M=h.slice($.start+1,F.start)+h.slice(F.end,$.end-1);R($.start,$.end,M===""?"\\r?\\n":`(?:[${M}]|\\r?\\n)`)}else $.type==="Quantifier"&&R(F.start,F.end,"(?:\\r?\\n)")},onQuantifierEnter(F){B.unshift(F)},onQuantifierLeave(){B.shift()},onCharacterClassRangeEnter(F){B.unshift(F)},onCharacterClassRangeLeave(){B.shift()},onCharacterClassEnter(F){B.unshift(F)},onCharacterClassLeave(){B.shift()},onAssertionEnter(F){l(F)&&B.push(F)},onAssertionLeave(F){B[0]===F&&B.shift()}}).visit(u),E+=h.slice(A),E}e.fixRegexNewline=d;function o(h){return h.replace(/\n/g,"\\r?\\n")}e.fixNewline=o}),define(fe[285],me([0,1,21,137,117,10]),function(Y,e,g,L,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class i{constructor(D){this.outputChannel=D,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(D,T,I,c){const p=new L.RipgrepTextSearchEngine(this.outputChannel);if(T.folder.scheme===C.Schemas.userData){const f={...T,folder:T.folder.with({scheme:C.Schemas.file})},v=new y.Progress(S=>I.report({...S,uri:S.uri.with({scheme:T.folder.scheme})}));return this.withToken(c,S=>p.provideTextSearchResults(D,f,v,S))}else return this.withToken(c,f=>p.provideTextSearchResults(D,T,I,f))}async withToken(D,T){const I=k(D);this.inProgress.add(I);const c=await T(I.token);return this.inProgress.delete(I),c}dispose(){this.inProgress.forEach(D=>D.cancel())}}e.RipgrepSearchProvider=i;function k(_){const D=new g.CancellationTokenSource;return _.onCancellationRequested(()=>D.cancel()),D}}),define(fe[286],me([0,1,28,137,136]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class C{constructor(_){this.query=_}search(_,D,T){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const I={appendLine(p){T({message:p})}},c=new y.NativeTextSearchManager(this.query,new L.RipgrepTextSearchEngine(I),g);return new Promise((p,f)=>c.search(v=>{D(v.map(i))},_).then(v=>p({limitHit:v.limitHit,type:"success",stats:v.stats}),f))}}e.TextSearchEngineAdapter=C;function i(k){return{path:k.resource&&k.resource.fsPath,results:k.results,numMatches:(k.results||[]).reduce((_,D)=>{if(D.ranges){const T=D;return _+(Array.isArray(T.ranges)?T.ranges.length:1)}else return _+1},0)}}}),define(fe[287],me([0,1,15,16,18,3,101,9,47,2,43,33,284,286]),function(Y,e,g,L,y,C,i,k,_,D,T,I,c,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class f{constructor(r="searchProcess"){this.processType=r,this.caches=Object.create(null)}fileSearch(r){let m;const a=P(r),b=new C.Emitter({onFirstListenerDidAdd:()=>{m=(0,L.createCancelablePromise)(n=>this.doFileSearchWithEngine(c.Engine,a,t=>b.fire(t),n)),m.then(n=>b.fire(n),n=>b.fire({type:"error",error:{message:n.message,stack:n.stack}}))},onLastListenerRemove:()=>{m.cancel()}});return b.event}textSearch(r){let m;const a=P(r),b=new C.Emitter({onFirstListenerDidAdd:()=>{m=(0,L.createCancelablePromise)(n=>this.ripgrepTextSearch(a,t=>b.fire(t),n)),m.then(n=>b.fire(n),n=>b.fire({type:"error",error:{message:n.message,stack:n.stack}}))},onLastListenerRemove:()=>{m.cancel()}});return b.event}ripgrepTextSearch(r,m,a){return r.maxFileSize=(0,T.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new p.TextSearchEngineAdapter(r).search(a,m,m)}doFileSearch(r,m,a){return this.doFileSearchWithEngine(c.Engine,r,m,a)}doFileSearchWithEngine(r,m,a,b,n=f.BATCH_SIZE){let t=0;const l=o=>{Array.isArray(o)?(t+=o.length,a(o.map(h=>this.rawMatchToSearchItem(h)))):o.relativePath?(t++,a(this.rawMatchToSearchItem(o))):a(o)};if(m.sortByScore){let o=this.trySortedSearchFromCache(m,l,b);if(!o){const h=m.maxResults?Object.assign({},m,{maxResults:null}):m,u=new r(h);o=this.doSortedSearch(u,m,a,l,b)}return new Promise((h,u)=>{o.then(([E,A])=>{const R=A.map(B=>this.rawMatchToSearchItem(B));this.sendProgress(R,a,n),h(E)},u)})}const d=new r(m);return this.doSearch(d,l,n,b).then(o=>({limitHit:o.limitHit,type:"success",stats:{detailStats:o.stats,type:this.processType,fromCache:!1,resultCount:t,sortingTime:void 0}}))}rawMatchToSearchItem(r){return{path:r.base?(0,k.join)(r.base,r.relativePath):r.relativePath}}doSortedSearch(r,m,a,b,n){const t=new C.Emitter;let l=(0,L.createCancelablePromise)(o=>{let h=[];const u=E=>{Array.isArray(E)?h=E:(b(E),t.fire(E))};return this.doSearch(r,u,-1,o).then(E=>[E,h])}),d;if(m.cacheKey){d=this.getOrCreateCache(m.cacheKey);const o={promise:l,event:t.event,resolved:!1};d.resultsToSearchCache[m.filePattern||""]=o,l.then(()=>{o.resolved=!0},h=>{delete d.resultsToSearchCache[m.filePattern||""]}),l=this.preventCancellation(l)}return l.then(([o,h])=>{const u=d?d.scorerCache:Object.create(null),E=(typeof m.maxResults!="number"||m.maxResults>0)&&_.StopWatch.create(!1);return this.sortResults(m,h,u,n).then(A=>{const R=E?E.elapsed():-1;return[{type:"success",stats:{detailStats:o.stats,sortingTime:R,fromCache:!1,type:this.processType,workspaceFolderCount:m.folderQueries.length,resultCount:A.length},messages:o.messages,limitHit:o.limitHit||typeof m.maxResults=="number"&&h.length>m.maxResults},A]})})}getOrCreateCache(r){const m=this.caches[r];return m||(this.caches[r]=new v)}trySortedSearchFromCache(r,m,a){const b=r.cacheKey&&this.caches[r.cacheKey];if(!b)return;const n=this.getResultsFromCache(b,r.filePattern||"",m,a);if(n)return n.then(([t,l,d])=>{const o=_.StopWatch.create(!1);return this.sortResults(r,l,b.scorerCache,a).then(h=>{const u=o.elapsed(),E={fromCache:!0,detailStats:d,type:this.processType,resultCount:l.length,sortingTime:u};return[{type:"success",limitHit:t.limitHit||typeof r.maxResults=="number"&&l.length>r.maxResults,stats:E},h]})})}sortResults(r,m,a,b){const n=(0,i.prepareQuery)(r.filePattern||""),t=(d,o)=>(0,i.compareItemsByFuzzyScore)(d,o,n,!0,S,a),l=typeof r.maxResults=="number"?r.maxResults:Number.MAX_VALUE;return g.topAsync(m,t,l,1e4,b)}sendProgress(r,m,a){if(a&&a>0)for(let b=0;b<r.length;b+=a)m(r.slice(b,b+a));else m(r)}getResultsFromCache(r,m,a,b){const n=_.StopWatch.create(!1),t=m.indexOf(k.sep)>=0;let l;for(const u in r.resultsToSearchCache)if(m.startsWith(u)){if(t&&u.indexOf(k.sep)<0&&u!=="")continue;const E=r.resultsToSearchCache[u];l={promise:this.preventCancellation(E.promise),event:E.event,resolved:E.resolved};break}if(!l)return null;const d=n.elapsed(),o=_.StopWatch.create(!1),h=l.event(a);return b&&b.onCancellationRequested(()=>{h.dispose()}),l.promise.then(([u,E])=>{if(b&&b.isCancellationRequested)throw(0,y.canceled)();const A=[],R=(0,i.prepareQuery)(m).normalizedLowercase;for(const B of E)!(0,I.isFilePatternMatch)(B,R)||A.push(B);return[u,A,{cacheWasResolved:l.resolved,cacheLookupTime:d,cacheFilterTime:o.elapsed(),cacheEntryCount:E.length}]})}doSearch(r,m,a,b){return new Promise((n,t)=>{let l=[];b&&b.onCancellationRequested(()=>r.cancel()),r.search(d=>{d&&(a?(l.push(d),a>0&&l.length>=a&&(m(l),l=[])):m(d))},d=>{m(d)},(d,o)=>{l.length&&m(l),d?t(d):n(o)})})}clearCache(r){return delete this.caches[r],Promise.resolve(void 0)}preventCancellation(r){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(m,a){return r.then(m,a)}catch(m){return this.then(void 0,m)}finally(m){return r.finally(m)}}}}e.SearchService=f,f.BATCH_SIZE=512;class v{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const S=new class{getItemLabel(s){return(0,k.basename)(s.relativePath)}getItemDescription(s){return(0,k.dirname)(s.relativePath)}getItemPath(s){return s.relativePath}};function P(s){return{...s,folderQueries:s.folderQueries&&s.folderQueries.map(w),extraFileResources:s.extraFileResources&&s.extraFileResources.map(r=>D.URI.revive(r))}}function w(s){return{...s,folder:D.URI.revive(s.folder)}}}),define(fe[288],me([0,1,6,10,2,28,11,26,14,75,67,33,287,285,93,136]),function(Y,e,g,L,y,C,i,k,_,D,T,I,c,p,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let S=class extends D.ExtHostSearch{constructor(w,s,r,m){super(w,r,m);this._pfs=C,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1;const a=new f.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(L.Schemas.userData,new p.RipgrepSearchProvider(a)),s.remote.isRemote&&s.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const w=new f.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(L.Schemas.file,new p.RipgrepSearchProvider(w)),this.registerInternalFileSearchProvider(L.Schemas.file,new c.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(w,s){const r=this._handlePool++;return this._internalFileSearchProvider=s,this._internalFileSearchHandle=r,this._proxy.$registerFileSearchProvider(r,this._transformScheme(w)),(0,g.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(r)})}$provideFileSearchResults(w,s,r,m){const a=(0,D.reviveQuery)(r);return w===this._internalFileSearchHandle?this.doInternalFileSearch(w,s,a,m):super.$provideFileSearchResults(w,s,r,m)}doInternalFileSearch(w,s,r,m){const a=b=>{if((0,I.isSerializedFileMatch)(b)&&(b=[b]),Array.isArray(b)){this._proxy.$handleFileMatch(w,s,b.map(n=>y.URI.file(n.path)));return}b.message&&this._logService.debug("ExtHostSearch",b.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(r,a,m)}$clearCache(w){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(w),super.$clearCache(w)}createTextSearchManager(w,s){return new v.NativeTextSearchManager(w,s,void 0,"textSearchProvider")}};S=Ve([$e(0,_.IExtHostRpcService),$e(1,k.IExtHostInitDataService),$e(2,T.IURITransformerService),$e(3,i.ILogService)],S),e.NativeExtHostSearch=S}),define(fe[138],me([0,1,300,125,82,22,18,3,6,9,12,32,106,107,301]),function(Y,e,g,L,y,C,i,k,_,D,T,I,c,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class v{constructor(o){this.socket=o,this._errorListener=h=>{if(h){if(h.code==="EPIPE")return;(0,i.onUnexpectedError)(h)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(o){const h=u=>o(C.VSBuffer.wrap(u));return this.socket.on("data",h),{dispose:()=>this.socket.off("data",h)}}onClose(o){const h=u=>{o({type:0,hadError:u,error:void 0})};return this.socket.on("close",h),{dispose:()=>this.socket.off("close",h)}}onEnd(o){return this.socket.on("end",o),{dispose:()=>this.socket.off("end",o)}}write(o){if(!this.socket.destroyed)try{this.socket.write(o.buffer,h=>{if(h){if(h.code==="EPIPE")return;(0,i.onUnexpectedError)(h)}})}catch(h){if(h.code==="EPIPE")return;(0,i.onUnexpectedError)(h)}}end(){this.socket.end()}drain(){return new Promise((o,h)=>{if(this.socket.bufferSize===0){o();return}const u=()=>{this.socket.off("close",u),this.socket.off("end",u),this.socket.off("error",u),this.socket.off("timeout",u),this.socket.off("drain",u),o()};this.socket.on("close",u),this.socket.on("end",u),this.socket.on("error",u),this.socket.on("timeout",u),this.socket.on("drain",u)})}}e.NodeSocket=v;var S;(function(d){d[d.MinHeaderByteSize=2]="MinHeaderByteSize"})(S||(S={}));var P;(function(d){d[d.PeekHeader=1]="PeekHeader",d[d.ReadHeader=2]="ReadHeader",d[d.ReadBody=3]="ReadBody",d[d.Fin=4]="Fin"})(P||(P={}));class w extends _.Disposable{constructor(o,h,u,E){super();this._onDidZlibFlush=this._register(new k.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new k.Emitter),this._onClose=this._register(new k.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=o,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=h,this._recordInflateBytes=E,h?(this._zlibInflate=f.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",A=>{console.error(A),(0,i.onUnexpectedError)(A),this._onClose.fire({type:0,hadError:!0,error:A})}),this._zlibInflate.on("data",A=>{this._pendingInflateData.push(A)}),u&&(this._zlibInflate.write(u.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=f.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",A=>{console.error(A),(0,i.onUnexpectedError)(A),this._onClose.fire({type:0,hadError:!0,error:A})}),this._zlibDeflate.on("data",A=>{this._pendingDeflateData.push(A)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new p.ChunkStream,this._register(this.socket.onData(A=>this._acceptChunk(A))),this._register(this.socket.onClose(A=>this._onClose.fire(A)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?C.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):C.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(o){return this._onData.event(o)}onClose(o){return this._onClose.event(o)}onEnd(o){return this.socket.onEnd(o)}write(o){this._totalOutgoingDataBytes+=o.byteLength,this._zlibDeflate?(this._zlibDeflate.write(o.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let h=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,h=h.slice(0,h.length-4),this._isEnded||this._write(C.VSBuffer.wrap(h),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(o,!1)}_write(o,h){let u=2;o.byteLength<126?u+=0:o.byteLength<2**16?u+=2:u+=8;const E=C.VSBuffer.alloc(u);if(h?E.writeUInt8(194,0):E.writeUInt8(130,0),o.byteLength<126)E.writeUInt8(o.byteLength,1);else if(o.byteLength<2**16){E.writeUInt8(126,1);let A=1;E.writeUInt8(o.byteLength>>>8&255,++A),E.writeUInt8(o.byteLength>>>0&255,++A)}else{E.writeUInt8(127,1);let A=1;E.writeUInt8(0,++A),E.writeUInt8(0,++A),E.writeUInt8(0,++A),E.writeUInt8(0,++A),E.writeUInt8(o.byteLength>>>24&255,++A),E.writeUInt8(o.byteLength>>>16&255,++A),E.writeUInt8(o.byteLength>>>8&255,++A),E.writeUInt8(o.byteLength>>>0&255,++A)}this._totalOutgoingWireBytes+=E.byteLength+o.byteLength,this.socket.write(C.VSBuffer.concat([E,o]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(o){if(o.byteLength!==0){for(this._totalIncomingWireBytes+=o.byteLength,this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const h=this._incomingData.peek(this._state.readLen),u=h.readUInt8(0),E=(u&128)>>>7,A=(u&64)>>>6,R=h.readUInt8(1),B=(R&128)>>>7,x=R&127;this._state.state=2,this._state.readLen=2+(B?4:0)+(x===126?2:0)+(x===127?8:0),this._state.fin=E,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(A)),this._state.firstFrameOfMessage=Boolean(E),this._state.mask=0}else if(this._state.state===2){const h=this._incomingData.read(this._state.readLen),u=h.readUInt8(1),E=(u&128)>>>7;let A=u&127,R=1;A===126?A=h.readUInt8(++R)*2**8+h.readUInt8(++R):A===127&&(A=h.readUInt8(++R)*0+h.readUInt8(++R)*0+h.readUInt8(++R)*0+h.readUInt8(++R)*0+h.readUInt8(++R)*2**24+h.readUInt8(++R)*2**16+h.readUInt8(++R)*2**8+h.readUInt8(++R));let B=0;E&&(B=h.readUInt8(++R)*2**24+h.readUInt8(++R)*2**16+h.readUInt8(++R)*2**8+h.readUInt8(++R)),this._state.state=3,this._state.readLen=A,this._state.mask=B}else if(this._state.state===3){const h=this._incomingData.read(this._state.readLen);s(h,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate&&this._state.compressed?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(h.buffer)),this._zlibInflate.write(h.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const u=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=u.length,this._onData.fire(C.VSBuffer.wrap(u))})):(this._totalIncomingDataBytes+=h.byteLength,this._onData.fire(h))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await k.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=w;function s(d,o){if(o===0)return;let h=d.byteLength>>>2;for(let x=0;x<h;x++){const F=d.readUInt32BE(x*4);d.writeUInt32BE(F^o,x*4)}let u=h*4,E=d.byteLength-u;const A=o>>>24&255,R=o>>>16&255,B=o>>>8&255;E>=1&&d.writeUInt8(d.readUInt8(u)^A,u),E>=2&&d.writeUInt8(d.readUInt8(u+1)^R,u+1),E>=3&&d.writeUInt8(d.readUInt8(u+2)^B,u+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const r={[2]:107,[1]:103};function m(){const d=(0,I.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${d}-sock`;let o;return e.XDG_RUNTIME_DIR?o=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${d}.sock`):o=(0,D.join)((0,y.tmpdir)(),`vscode-ipc-${d}.sock`),b(o),o}e.createRandomIPCHandle=m;function a(d,o,h){const u=(0,g.createHash)("md5").update(d).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${u}-${h}-${o}-sock`;let E;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?E=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-${u.substr(0,8)}-${h}-${o}.sock`):E=(0,D.join)(d,`${h}-${o}.sock`),b(E),E}e.createStaticIPCHandle=a;function b(d){const o=r[T.platform];typeof o=="number"&&d.length>=o&&console.warn(`WARNING: IPC handle "${d}" is longer than ${o} chars, try a shorter --user-data-dir`)}class n extends c.IPCServer{constructor(o){super(n.toClientConnectionEvent(o));this.server=o}static toClientConnectionEvent(o){const h=k.Event.fromNodeEventEmitter(o,"connection");return k.Event.map(h,u=>({protocol:new p.Protocol(new v(u)),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(u,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=n;function t(d){return new Promise((o,h)=>{const u=(0,L.createServer)();u.on("error",h),u.listen(d,()=>{u.removeListener("error",h),o(new n(u))})})}e.serve=t;function l(d,o){return new Promise((h,u)=>{const E=(0,L.createConnection)(d,()=>{E.removeListener("error",u),h(p.Client.fromSocket(new v(E),o))});E.once("error",u)})}e.connect=l}),define(fe[289],me([0,1,138,281,63,40,2,200,11]),function(Y,e,g,L,y,C,i,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class D{constructor(c,p,f){this._commands=c,this.logService=p,this._ipcHandlePath=f,this._server=L.createServer((v,S)=>this.onRequest(v,S)),this.setup().catch(v=>(p.error(v),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",c=>this.logService.error(c))}catch(c){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(c,p){const f=[];c.setEncoding("utf8"),c.on("data",v=>f.push(v)),c.on("end",()=>{const v=JSON.parse(f.join(""));switch(v.type){case"open":this.open(v,p);break;case"openExternal":this.openExternal(v,p);break;case"status":this.getStatus(v,p);break;case"extensionManagement":this.manageExtensions(v,p).catch(this.logService.error);break;default:p.writeHead(404),p.write(`Unknown message type: ${v.type}`,S=>{S&&this.logService.error(S)}),p.end();break}})}open(c,p){let{fileURIs:f,folderURIs:v,forceNewWindow:S,diffMode:P,addMode:w,forceReuseWindow:s,gotoLineMode:r,waitMarkerFilePath:m}=c;const a=[];if(Array.isArray(v))for(const b of v)try{a.push({folderUri:i.URI.parse(b)})}catch(n){}if(Array.isArray(f))for(const b of f)try{(0,k.hasWorkspaceFileExtension)(b)?a.push({workspaceUri:i.URI.parse(b)}):a.push({fileUri:i.URI.parse(b)})}catch(n){}if(a.length){const b=m?i.URI.file(m):void 0,t={forceNewWindow:S,diffMode:P,addMode:w,gotoLineMode:r,forceReuseWindow:s,preferNewWindow:!s&&!b&&!w,waitMarkerFileURI:b};this._commands.executeCommand("_remoteCLI.windowOpen",a,t)}p.writeHead(200),p.end()}async openExternal(c,p){for(const f of c.uris){const v=i.URI.parse(f),S=v.scheme==="file"?v:f;await this._commands.executeCommand("_remoteCLI.openExternal",S)}p.writeHead(200),p.end()}async manageExtensions(c,p){try{const f=P=>P?.map(w=>/\.vsix$/i.test(w)?i.URI.parse(w):w),v={list:c.list,install:f(c.install),uninstall:f(c.uninstall),force:c.force},S=await this._commands.executeCommand("_remoteCLI.manageExtensions",v);p.writeHead(200),p.write(S)}catch(f){p.writeHead(500),p.write(String(f),v=>{v&&this.logService.error(v)})}p.end()}async getStatus(c,p){try{const f=await this._commands.executeCommand("_remoteCLI.getSystemStatus");p.writeHead(200),p.write(f),p.end()}catch(f){p.writeHead(500),p.write(String(f),v=>{v&&this.logService.error(v)}),p.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&y.existsSync(this._ipcHandlePath)&&y.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=D;let T=class extends D{constructor(c,p){super(c,p,(0,g.createRandomIPCHandle)())}};T=Ve([$e(0,C.IExtHostCommands),$e(1,_.ILogService)],T),e.CLIServer=T}),define(fe[290],me([0,1,74,277,272,5,280,41,262,2,10,7,289,105]),function(Y,e,g,L,y,C,i,k,_,D,T,I,c,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class f extends y.RequireInterceptor{_installInterceptor(){const P=this,w=Y.__$__nodeRequire("module"),s=w._load;w._load=function(m,a,b){for(let n of P._alternatives){let t=n(m);if(t){m=t;break}}return P._factories.has(m)?P._factories.get(m).load(m,D.URI.file((0,p.realpathSync)(a.filename)),n=>s.apply(this,[n,a,b])):s.apply(this,arguments)}}}class v extends k.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=I.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const P=this._instaService.invokeFunction(L.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(_.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const a=this._instaService.createInstance(c.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=a.ipcHandlePath}await this._instaService.createInstance(f,P,this._registry).install(),g.mark("code/extHost/didInitAPI");const s=await this._extHostConfiguration.getConfigProvider();await(0,i.connectProxyResolver)(this._extHostWorkspace,s,this,this._logService,this._mainThreadTelemetryProxy,this._initData),g.mark("code/extHost/didInitProxyResolver");const r=process.send,m=this._extHostContext.getProxy(C.MainContext.MainThreadConsole);process.send=(...a)=>a.length===0||!a[0]||a[0].type!=="__$console"?r.apply(process,a):(m.$logExtensionHostMessage(a[0]),!1)}_getEntryPoint(P){return P.main}_loadCommonJSModule(P,w,s){if(w.scheme!==T.Schemas.file)throw new Error(`Cannot load URI: '${w}', must be of file-scheme`);let r=null;s.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${w.toString(!0)}`),this._logService.flush();try{P&&g.mark(`code/extHost/willLoadExtensionCode/${P.value}`),r=Y.__$__nodeRequire(w.fsPath)}catch(m){return Promise.reject(m)}finally{P&&g.mark(`code/extHost/didLoadExtensionCode/${P.value}`),s.codeLoadingStop()}return Promise.resolve(r)}async $setRemoteEnvironment(P){if(!!this._initData.remote.isRemote)for(const w in P){const s=P[w];s===null?delete process.env[w]:process.env[w]=s}}}e.ExtHostExtensionService=v}),define(fe[291],me([0,1,84,265,274,273,288,290,266,57,41,75,73,34,54,70,264,263,11]),function(Y,e,g,L,y,C,i,k,_,D,T,I,c,p,f,v,S,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,g.registerSingleton)(T.IExtHostExtensionService,k.ExtHostExtensionService),(0,g.registerSingleton)(w.ILoggerService,P.ExtHostLoggerService),(0,g.registerSingleton)(v.IExtensionStoragePaths,S.ExtensionStoragePaths),(0,g.registerSingleton)(D.IExtHostDebugService,C.ExtHostDebugService),(0,g.registerSingleton)(I.IExtHostSearch,i.NativeExtHostSearch),(0,g.registerSingleton)(c.IExtHostTask,y.ExtHostTask),(0,g.registerSingleton)(p.IExtHostTerminalService,L.ExtHostTerminalService),(0,g.registerSingleton)(f.IExtHostTunnelService,_.ExtHostTunnelService)}),define(fe[292],me([0,1,125,302,74,18,107,138,193,228,275,22,103,28,105,16,114,278,291]),function(Y,e,g,L,y,C,i,k,_,D,T,I,c,p,f,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let l=0;l<process.execArgv.length;l++)process.execArgv[l]==="--inspect-port=0"&&(process.execArgv.splice(l,1),l--)}();const P=L(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"],boolean:["skipWorkspaceStorageLock"]});(function(){const t=Y.__$__nodeRequire("module"),l=t._load;t._load=function(d){if(d==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return l.apply(this,arguments)}})();const w=process.exit.bind(process);function s(t){process.exit=function(l){if(t)w(l);else{const d=new Error("An extension called process.exit() and this was prevented.");console.warn(d.stack)}},process.crash=function(){const l=new Error("An extension called process.crash() and this was prevented.");console.warn(l.stack)}}let r=function(t){w()};function m(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((t,l)=>{let d=null,o=setTimeout(()=>{r("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const h=108e5,u=3e5,E=new v.ProcessTimeRunOnceScheduler(()=>r("renderer disconnected for too long (1)"),h),A=new v.ProcessTimeRunOnceScheduler(()=>r("renderer disconnected for too long (2)"),u);process.on("message",(B,x)=>{if(B&&B.type==="VSCODE_EXTHOST_IPC_SOCKET"){const F=I.VSBuffer.wrap(Buffer.from(B.initialDataChunk,"base64"));let $;if(B.skipWebSocketFrames)$=new k.NodeSocket(x);else{const M=I.VSBuffer.wrap(Buffer.from(B.inflateBytes,"base64"));$=new k.WebSocketNodeSocket(new k.NodeSocket(x),B.permessageDeflate,M,!1)}d?(E.cancel(),A.cancel(),d.beginAcceptReconnection($,F),d.endAcceptReconnection()):(clearTimeout(o),d=new i.PersistentProtocol($,F),d.onDidDispose(()=>r("renderer disconnected")),t(d),d.onSocketClose(()=>{E.schedule()}))}if(B&&B.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(A.isScheduled())return;E.isScheduled()&&A.schedule()}});const R={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(R)});{const t=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((l,d)=>{const o=g.createConnection(t,()=>{o.removeListener("error",d),l(new i.PersistentProtocol(new k.NodeSocket(o)))});o.once("error",d),o.on("close",()=>{r("renderer closed the socket")})})}}async function a(){const t=await m();return new class{constructor(){this._onMessage=new i.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,t.onMessage(l=>{(0,D.isMessageOfType)(l,2)?(this._terminating=!0,r("received terminate message from renderer")):this._onMessage.fire(l)})}send(l){this._terminating||t.send(l)}drain(){return t.drain()}}}function b(t){return new Promise(l=>{const d=t.onMessage(o=>{d.dispose();const h=JSON.parse(o.toString()),u=h.commit,E=_.default.commit;u&&E&&u!==E&&w(55);let A=0;setInterval(function(){try{process.kill(h.parentPid,0),A=0}catch(B){B&&B.code==="EPERM"?(A++,A>=3&&r(`parent process ${h.parentPid} does not exist anymore (3 x EPERM): ${B.message} (code: ${B.code}) (errno: ${B.errno})`)):r(`parent process ${h.parentPid} does not exist anymore: ${B.message} (code: ${B.code}) (errno: ${B.errno})`)}},1e3);let R;try{R=Y.__$__nodeRequire("native-watchdog"),R.start(h.parentPid)}catch(B){(0,C.onUnexpectedError)(B)}t.send((0,D.createMessageOfType)(0)),l({protocol:t,initData:h})});t.send((0,D.createMessageOfType)(1))})}async function n(){const t=[];process.on("unhandledRejection",(A,R)=>{t.push(R),setTimeout(()=>{const B=t.indexOf(R);B>=0&&R.catch(x=>{t.splice(B,1),(0,C.isPromiseCanceledError)(x)||(console.warn(`rejected promise not handled within 1 second: ${x}`),x&&x.stack&&console.warn(`stack trace: ${x.stack}`),A&&(0,C.onUnexpectedError)(A))})},1e3)}),process.on("rejectionHandled",A=>{const R=t.indexOf(A);R>=0&&t.splice(R,1)}),process.on("uncaughtException",function(A){(0,C.onUnexpectedError)(A)}),y.mark("code/extHost/willConnectToRenderer");const l=await a();y.mark("code/extHost/didConnectToRenderer");const d=await b(l);y.mark("code/extHost/didWaitForInitData");const{initData:o}=d;s(!!o.environment.extensionTestsLocationURI),o.environment.useHostProxy=P.useHostProxy!==void 0?P.useHostProxy!=="false":void 0,o.environment.skipWorkspaceStorageLock=(0,S.boolean)(P.skipWorkspaceStorageLock,!1);const h=new class{constructor(){this.pid=process.pid}exit(R){w(R)}exists(R){return p.Promises.exists(R)}realpath(R){return(0,f.realpath)(R)}};let u=null;if(o.remote.authority&&P.uriTransformerPath)try{const R=Y.__$__nodeRequire(P.uriTransformerPath)(o.remote.authority);u=new c.URITransformer(R)}catch(A){console.error(A)}const E=new T.ExtensionHostMain(d.protocol,o,h,u);r=A=>E.terminate(A)}e.startExtensionHostProcess=n}),define(fe[303],me([0,1,292]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,g.startExtensionHostProcess)().catch(L=>console.log(L))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/6a25ae3a24929f35aabf8a051531c0716032e0a0/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
