/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var be=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/strings","vs/base/common/types","vs/base/common/network","vs/platform/log/common/log","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/errors","vs/base/common/path","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/map","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/base/common/platform","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/codicons","vs/base/common/severity","vs/base/common/uuid","vs/platform/contextkey/common/contextkey","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/extpath","vs/editor/common/core/range","vs/base/common/errorMessage","vs/platform/files/common/files","vs/platform/theme/common/themeService","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/idGenerator","vs/base/common/marshalling","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/base/common/hash","vs/editor/common/modes","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/numbers","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/mime","vs/editor/common/model","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/base/common/process","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/lazy","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/model/textModelSearch","vs/editor/common/core/position","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/tokenizationRegistry","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/model/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/remote/common/tunnel","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/output/common/output","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/editor/common/core/characterClassifier","vs/editor/common/model/mirrorTextModel","vs/editor/common/viewModel/prefixSumComputer","vs/base/common/marked/marked","vs/base/common/linkedList","vs/editor/common/modes/linkComputer","vs/editor/common/core/selection","vs/base/common/functional","vs/workbench/services/extensions/worker/extensionHostWorker"],Ee=function(re){for(var e=[],u=0,M=re.length;u<M;u++)e[u]=be[re[u]];return e};define(be[43],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function u(M,b){if(!M)throw new Error(b?`Assertion failed (${b})`:"Assertion Failed")}e.ok=u}),define(be[54],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const u=Object.prototype.hasOwnProperty;function M(F){const y=[];for(let r in F)u.call(F,r)&&y.push(F[r]);return y}e.values=M;function b(F,y){for(let r in F)if(u.call(F,r)&&y({key:r,value:F[r]},function(){delete F[r]})===!1)return}e.forEach=b;function P(F,y){const r=Object.create(null);for(const m of F){const a=y(m);let h=r[a];h||(h=r[a]=[]),h.push(m)}return r}e.groupBy=P;function t(F){const y=Object.create(null);return F&&F.forEach((r,m)=>{y[m]=r}),y}e.fromMap=t;function A(F,y){const r=[],m=[];for(let a of F)y.has(a)||r.push(a);for(let a of y)F.has(a)||m.push(a);return{removed:r,added:m}}e.diffSets=A;function C(F,y){const r=[],m=[];for(let[a,h]of F)y.has(a)||r.push(h);for(let[a,h]of y)F.has(a)||m.push(h);return{removed:r,added:m}}e.diffMaps=C;class k{constructor(){this.map=new Map}add(y,r){let m=this.map.get(y);m||(m=new Set,this.map.set(y,m)),m.add(r)}delete(y,r){const m=this.map.get(y);!m||(m.delete(r),m.size===0&&this.map.delete(y))}forEach(y,r){const m=this.map.get(y);!m||m.forEach(r)}}e.SetMap=k}),define(be[55],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function u(t){return(A,C,k)=>{let F=null,y=null;if(typeof k.value=="function"?(F="value",y=k.value):typeof k.get=="function"&&(F="get",y=k.get),!y)throw new Error("not supported");k[F]=t(y,C)}}e.createDecorator=u;function M(t,A,C){let k=null,F=null;if(typeof C.value=="function"?(k="value",F=C.value,F.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof C.get=="function"&&(k="get",F=C.get),!F)throw new Error("not supported");const y=`$memoize$${A}`;C[k]=function(...r){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:F.apply(this,r)}),this[y]}}e.memoize=M;function b(t,A,C){return u((k,F)=>{const y=`$debounce$${F}`,r=`$debounce$result$${F}`;return function(...m){this[r]||(this[r]=C?C():void 0),clearTimeout(this[y]),A&&(this[r]=A(this[r],...m),m=[this[r]]),this[y]=setTimeout(()=>{k.apply(this,m),this[r]=C?C():void 0},t)}})}e.debounce=b;function P(t,A,C){return u((k,F)=>{const y=`$throttle$timer$${F}`,r=`$throttle$result$${F}`,m=`$throttle$lastRun$${F}`,a=`$throttle$pending$${F}`;return function(...h){if(this[r]||(this[r]=C?C():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),A&&(this[r]=A(this[r],...h)),this[a])return;const p=this[m]+t;p<=Date.now()?(this[m]=Date.now(),k.apply(this,[this[r]]),this[r]=C?C():void 0):(this[a]=!0,this[y]=setTimeout(()=>{this[a]=!1,this[m]=Date.now(),k.apply(this,[this[r]]),this[r]=C?C():void 0},p-Date.now()))}})}e.throttle=P}),define(be[56],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class u{constructor(b){this._prefix=b,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=u,e.defaultGenerator=new u("id#")}),define(be[102],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var u;(function(c){c[c.None=0]="None",c[c.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",c[c.UnexpectedEndOfString=2]="UnexpectedEndOfString",c[c.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",c[c.InvalidUnicode=4]="InvalidUnicode",c[c.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",c[c.InvalidCharacter=6]="InvalidCharacter"})(u=e.ScanError||(e.ScanError={}));var M;(function(c){c[c.OpenBraceToken=1]="OpenBraceToken",c[c.CloseBraceToken=2]="CloseBraceToken",c[c.OpenBracketToken=3]="OpenBracketToken",c[c.CloseBracketToken=4]="CloseBracketToken",c[c.CommaToken=5]="CommaToken",c[c.ColonToken=6]="ColonToken",c[c.NullKeyword=7]="NullKeyword",c[c.TrueKeyword=8]="TrueKeyword",c[c.FalseKeyword=9]="FalseKeyword",c[c.StringLiteral=10]="StringLiteral",c[c.NumericLiteral=11]="NumericLiteral",c[c.LineCommentTrivia=12]="LineCommentTrivia",c[c.BlockCommentTrivia=13]="BlockCommentTrivia",c[c.LineBreakTrivia=14]="LineBreakTrivia",c[c.Trivia=15]="Trivia",c[c.Unknown=16]="Unknown",c[c.EOF=17]="EOF"})(M=e.SyntaxKind||(e.SyntaxKind={}));var b;(function(c){c[c.InvalidSymbol=1]="InvalidSymbol",c[c.InvalidNumberFormat=2]="InvalidNumberFormat",c[c.PropertyNameExpected=3]="PropertyNameExpected",c[c.ValueExpected=4]="ValueExpected",c[c.ColonExpected=5]="ColonExpected",c[c.CommaExpected=6]="CommaExpected",c[c.CloseBraceExpected=7]="CloseBraceExpected",c[c.CloseBracketExpected=8]="CloseBracketExpected",c[c.EndOfFileExpected=9]="EndOfFileExpected",c[c.InvalidCommentToken=10]="InvalidCommentToken",c[c.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",c[c.UnexpectedEndOfString=12]="UnexpectedEndOfString",c[c.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",c[c.InvalidUnicode=14]="InvalidUnicode",c[c.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",c[c.InvalidCharacter=16]="InvalidCharacter"})(b=e.ParseErrorCode||(e.ParseErrorCode={}));var P;(function(c){c.DEFAULT={allowTrailingComma:!0}})(P=e.ParseOptions||(e.ParseOptions={}));function t(c,R=!1){let n=0,i=c.length,g="",f=0,s=16,v=0;function l(x){let N=0,V=0;for(;N<x;){const $=c.charCodeAt(n);if($>=48&&$<=57)V=V*16+$-48;else if($>=65&&$<=70)V=V*16+$-65+10;else if($>=97&&$<=102)V=V*16+$-97+10;else break;n++,N++}return N<x&&(V=-1),V}function E(x){n=x,g="",f=0,s=16,v=0}function T(){const x=n;if(c.charCodeAt(n)===48)n++;else for(n++;n<c.length&&k(c.charCodeAt(n));)n++;if(n<c.length&&c.charCodeAt(n)===46)if(n++,n<c.length&&k(c.charCodeAt(n)))for(n++;n<c.length&&k(c.charCodeAt(n));)n++;else return v=3,c.substring(x,n);let N=n;if(n<c.length&&(c.charCodeAt(n)===69||c.charCodeAt(n)===101))if(n++,(n<c.length&&c.charCodeAt(n)===43||c.charCodeAt(n)===45)&&n++,n<c.length&&k(c.charCodeAt(n))){for(n++;n<c.length&&k(c.charCodeAt(n));)n++;N=n}else v=3;return c.substring(x,N)}function I(){let x="",N=n;for(;;){if(n>=i){x+=c.substring(N,n),v=2;break}const V=c.charCodeAt(n);if(V===34){x+=c.substring(N,n),n++;break}if(V===92){if(x+=c.substring(N,n),n++,n>=i){v=2;break}switch(c.charCodeAt(n++)){case 34:x+='"';break;case 92:x+="\\";break;case 47:x+="/";break;case 98:x+="\b";break;case 102:x+="\f";break;case 110:x+=`
`;break;case 114:x+="\r";break;case 116:x+="	";break;case 117:const z=l(4);z>=0?x+=String.fromCharCode(z):v=4;break;default:v=5}N=n;continue}if(V>=0&&V<=31)if(C(V)){x+=c.substring(N,n),v=2;break}else v=6;n++}return x}function B(){if(g="",v=0,f=n,n>=i)return f=i,s=17;let x=c.charCodeAt(n);if(A(x)){do n++,g+=String.fromCharCode(x),x=c.charCodeAt(n);while(A(x));return s=15}if(C(x))return n++,g+=String.fromCharCode(x),x===13&&c.charCodeAt(n)===10&&(n++,g+=`
`),s=14;switch(x){case 123:return n++,s=1;case 125:return n++,s=2;case 91:return n++,s=3;case 93:return n++,s=4;case 58:return n++,s=6;case 44:return n++,s=5;case 34:return n++,g=I(),s=10;case 47:const N=n-1;if(c.charCodeAt(n+1)===47){for(n+=2;n<i&&!C(c.charCodeAt(n));)n++;return g=c.substring(N,n),s=12}if(c.charCodeAt(n+1)===42){n+=2;const V=i-1;let $=!1;for(;n<V;){if(c.charCodeAt(n)===42&&c.charCodeAt(n+1)===47){n+=2,$=!0;break}n++}return $||(n++,v=1),g=c.substring(N,n),s=13}return g+=String.fromCharCode(x),n++,s=16;case 45:if(g+=String.fromCharCode(x),n++,n===i||!k(c.charCodeAt(n)))return s=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return g+=T(),s=11;default:for(;n<i&&O(x);)n++,x=c.charCodeAt(n);if(f!==n){switch(g=c.substring(f,n),g){case"true":return s=8;case"false":return s=9;case"null":return s=7}return s=16}return g+=String.fromCharCode(x),n++,s=16}}function O(x){if(A(x)||C(x))return!1;switch(x){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function D(){let x;do x=B();while(x>=12&&x<=15);return x}return{setPosition:E,getPosition:()=>n,scan:R?D:B,getToken:()=>s,getTokenValue:()=>g,getTokenOffset:()=>f,getTokenLength:()=>n-f,getTokenError:()=>v}}e.createScanner=t;function A(c){return c===32||c===9||c===11||c===12||c===160||c===5760||c>=8192&&c<=8203||c===8239||c===8287||c===12288||c===65279}function C(c){return c===10||c===13||c===8232||c===8233}function k(c){return c>=48&&c<=57}var F;(function(c){c[c.nullCharacter=0]="nullCharacter",c[c.maxAsciiCharacter=127]="maxAsciiCharacter",c[c.lineFeed=10]="lineFeed",c[c.carriageReturn=13]="carriageReturn",c[c.lineSeparator=8232]="lineSeparator",c[c.paragraphSeparator=8233]="paragraphSeparator",c[c.nextLine=133]="nextLine",c[c.space=32]="space",c[c.nonBreakingSpace=160]="nonBreakingSpace",c[c.enQuad=8192]="enQuad",c[c.emQuad=8193]="emQuad",c[c.enSpace=8194]="enSpace",c[c.emSpace=8195]="emSpace",c[c.threePerEmSpace=8196]="threePerEmSpace",c[c.fourPerEmSpace=8197]="fourPerEmSpace",c[c.sixPerEmSpace=8198]="sixPerEmSpace",c[c.figureSpace=8199]="figureSpace",c[c.punctuationSpace=8200]="punctuationSpace",c[c.thinSpace=8201]="thinSpace",c[c.hairSpace=8202]="hairSpace",c[c.zeroWidthSpace=8203]="zeroWidthSpace",c[c.narrowNoBreakSpace=8239]="narrowNoBreakSpace",c[c.ideographicSpace=12288]="ideographicSpace",c[c.mathematicalSpace=8287]="mathematicalSpace",c[c.ogham=5760]="ogham",c[c._=95]="_",c[c.$=36]="$",c[c._0=48]="_0",c[c._1=49]="_1",c[c._2=50]="_2",c[c._3=51]="_3",c[c._4=52]="_4",c[c._5=53]="_5",c[c._6=54]="_6",c[c._7=55]="_7",c[c._8=56]="_8",c[c._9=57]="_9",c[c.a=97]="a",c[c.b=98]="b",c[c.c=99]="c",c[c.d=100]="d",c[c.e=101]="e",c[c.f=102]="f",c[c.g=103]="g",c[c.h=104]="h",c[c.i=105]="i",c[c.j=106]="j",c[c.k=107]="k",c[c.l=108]="l",c[c.m=109]="m",c[c.n=110]="n",c[c.o=111]="o",c[c.p=112]="p",c[c.q=113]="q",c[c.r=114]="r",c[c.s=115]="s",c[c.t=116]="t",c[c.u=117]="u",c[c.v=118]="v",c[c.w=119]="w",c[c.x=120]="x",c[c.y=121]="y",c[c.z=122]="z",c[c.A=65]="A",c[c.B=66]="B",c[c.C=67]="C",c[c.D=68]="D",c[c.E=69]="E",c[c.F=70]="F",c[c.G=71]="G",c[c.H=72]="H",c[c.I=73]="I",c[c.J=74]="J",c[c.K=75]="K",c[c.L=76]="L",c[c.M=77]="M",c[c.N=78]="N",c[c.O=79]="O",c[c.P=80]="P",c[c.Q=81]="Q",c[c.R=82]="R",c[c.S=83]="S",c[c.T=84]="T",c[c.U=85]="U",c[c.V=86]="V",c[c.W=87]="W",c[c.X=88]="X",c[c.Y=89]="Y",c[c.Z=90]="Z",c[c.ampersand=38]="ampersand",c[c.asterisk=42]="asterisk",c[c.at=64]="at",c[c.backslash=92]="backslash",c[c.bar=124]="bar",c[c.caret=94]="caret",c[c.closeBrace=125]="closeBrace",c[c.closeBracket=93]="closeBracket",c[c.closeParen=41]="closeParen",c[c.colon=58]="colon",c[c.comma=44]="comma",c[c.dot=46]="dot",c[c.doubleQuote=34]="doubleQuote",c[c.equals=61]="equals",c[c.exclamation=33]="exclamation",c[c.greaterThan=62]="greaterThan",c[c.lessThan=60]="lessThan",c[c.minus=45]="minus",c[c.openBrace=123]="openBrace",c[c.openBracket=91]="openBracket",c[c.openParen=40]="openParen",c[c.percent=37]="percent",c[c.plus=43]="plus",c[c.question=63]="question",c[c.semicolon=59]="semicolon",c[c.singleQuote=39]="singleQuote",c[c.slash=47]="slash",c[c.tilde=126]="tilde",c[c.backspace=8]="backspace",c[c.formFeed=12]="formFeed",c[c.byteOrderMark=65279]="byteOrderMark",c[c.tab=9]="tab",c[c.verticalTab=11]="verticalTab"})(F||(F={}));function y(c,R){const n=[],i=new Object;let g;const f={value:{},offset:0,length:0,type:"object",parent:void 0};let s=!1;function v(l,E,T,I){f.value=l,f.offset=E,f.length=T,f.type=I,f.colonOffset=void 0,g=f}try{o(c,{onObjectBegin:(l,E)=>{if(R<=l)throw i;g=void 0,s=R>l,n.push("")},onObjectProperty:(l,E,T)=>{if(R<E||(v(l,E,T,"property"),n[n.length-1]=l,R<=E+T))throw i},onObjectEnd:(l,E)=>{if(R<=l)throw i;g=void 0,n.pop()},onArrayBegin:(l,E)=>{if(R<=l)throw i;g=void 0,n.push(0)},onArrayEnd:(l,E)=>{if(R<=l)throw i;g=void 0,n.pop()},onLiteralValue:(l,E,T)=>{if(R<E||(v(l,E,T,_(l)),R<=E+T))throw i},onSeparator:(l,E,T)=>{if(R<=E)throw i;if(l===":"&&g&&g.type==="property")g.colonOffset=E,s=!1,g=void 0;else if(l===","){const I=n[n.length-1];typeof I=="number"?n[n.length-1]=I+1:(s=!0,n[n.length-1]=""),g=void 0}}})}catch(l){if(l!==i)throw l}return{path:n,previousNode:g,isAtPropertyKey:s,matches:l=>{let E=0;for(let T=0;E<l.length&&T<n.length;T++)if(l[E]===n[T]||l[E]==="*")E++;else if(l[E]!=="**")return!1;return E===l.length}}}e.getLocation=y;function r(c,R=[],n=P.DEFAULT){let i=null,g=[];const f=[];function s(l){Array.isArray(g)?g.push(l):i!==null&&(g[i]=l)}return o(c,{onObjectBegin:()=>{const l={};s(l),f.push(g),g=l,i=null},onObjectProperty:l=>{i=l},onObjectEnd:()=>{g=f.pop()},onArrayBegin:()=>{const l=[];s(l),f.push(g),g=l,i=null},onArrayEnd:()=>{g=f.pop()},onLiteralValue:s,onError:(l,E,T)=>{R.push({error:l,offset:E,length:T})}},n),g[0]}e.parse=r;function m(c,R=[],n=P.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function g(l){i.type==="property"&&(i.length=l-i.offset,i=i.parent)}function f(l){return i.children.push(l),l}o(c,{onObjectBegin:l=>{i=f({type:"object",offset:l,length:-1,parent:i,children:[]})},onObjectProperty:(l,E,T)=>{i=f({type:"property",offset:E,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:l,offset:E,length:T,parent:i})},onObjectEnd:(l,E)=>{i.length=l+E-i.offset,i=i.parent,g(l+E)},onArrayBegin:(l,E)=>{i=f({type:"array",offset:l,length:-1,parent:i,children:[]})},onArrayEnd:(l,E)=>{i.length=l+E-i.offset,i=i.parent,g(l+E)},onLiteralValue:(l,E,T)=>{f({type:_(l),offset:E,length:T,parent:i,value:l}),g(E+T)},onSeparator:(l,E,T)=>{i.type==="property"&&(l===":"?i.colonOffset=E:l===","&&g(E))},onError:(l,E,T)=>{R.push({error:l,offset:E,length:T})}},n);const v=i.children[0];return v&&delete v.parent,v}e.parseTree=m;function a(c,R){if(!c)return;let n=c;for(let i of R)if(typeof i=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let g=!1;for(const f of n.children)if(Array.isArray(f.children)&&f.children[0].value===i){n=f.children[1],g=!0;break}if(!g)return}else{const g=i;if(n.type!=="array"||g<0||!Array.isArray(n.children)||g>=n.children.length)return;n=n.children[g]}return n}e.findNodeAtLocation=a;function h(c){if(!c.parent||!c.parent.children)return[];const R=h(c.parent);if(c.parent.type==="property"){const n=c.parent.children[0].value;R.push(n)}else if(c.parent.type==="array"){const n=c.parent.children.indexOf(c);n!==-1&&R.push(n)}return R}e.getNodePath=h;function p(c){switch(c.type){case"array":return c.children.map(p);case"object":const R=Object.create(null);for(let n of c.children){const i=n.children[1];i&&(R[n.children[0].value]=p(i))}return R;case"null":case"string":case"number":case"boolean":return c.value;default:return}}e.getNodeValue=p;function S(c,R,n=!1){return R>=c.offset&&R<c.offset+c.length||n&&R===c.offset+c.length}e.contains=S;function w(c,R,n=!1){if(S(c,R,n)){const i=c.children;if(Array.isArray(i))for(let g=0;g<i.length&&i[g].offset<=R;g++){const f=w(i[g],R,n);if(f)return f}return c}}e.findNodeAtOffset=w;function o(c,R,n=P.DEFAULT){const i=t(c,!1);function g(ue){return ue?()=>ue(i.getTokenOffset(),i.getTokenLength()):()=>!0}function f(ue){return ue?Fe=>ue(Fe,i.getTokenOffset(),i.getTokenLength()):()=>!0}const s=g(R.onObjectBegin),v=f(R.onObjectProperty),l=g(R.onObjectEnd),E=g(R.onArrayBegin),T=g(R.onArrayEnd),I=f(R.onLiteralValue),B=f(R.onSeparator),O=g(R.onComment),D=f(R.onError),x=n&&n.disallowComments,N=n&&n.allowTrailingComma;function V(){for(;;){const ue=i.scan();switch(i.getTokenError()){case 4:$(14);break;case 5:$(15);break;case 3:$(13);break;case 1:x||$(11);break;case 2:$(12);break;case 6:$(16);break}switch(ue){case 12:case 13:x?$(10):O();break;case 16:$(1);break;case 15:case 14:break;default:return ue}}}function $(ue,Fe=[],Ke=[]){if(D(ue),Fe.length+Ke.length>0){let Oe=i.getToken();for(;Oe!==17;){if(Fe.indexOf(Oe)!==-1){V();break}else if(Ke.indexOf(Oe)!==-1)break;Oe=V()}}}function z(ue){const Fe=i.getTokenValue();return ue?I(Fe):v(Fe),V(),!0}function ee(){switch(i.getToken()){case 11:let ue=0;try{ue=JSON.parse(i.getTokenValue()),typeof ue!="number"&&($(2),ue=0)}catch(Fe){$(2)}I(ue);break;case 7:I(null);break;case 8:I(!0);break;case 9:I(!1);break;default:return!1}return V(),!0}function j(){return i.getToken()!==10?($(3,[],[2,5]),!1):(z(!1),i.getToken()===6?(B(":"),V(),ve()||$(4,[],[2,5])):$(5,[],[2,5]),!0)}function Q(){s(),V();let ue=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(ue||$(4,[],[]),B(","),V(),i.getToken()===2&&N)break}else ue&&$(6,[],[]);j()||$(4,[],[2,5]),ue=!0}return l(),i.getToken()!==2?$(7,[2],[]):V(),!0}function le(){E(),V();let ue=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(ue||$(4,[],[]),B(","),V(),i.getToken()===4&&N)break}else ue&&$(6,[],[]);ve()||$(4,[],[4,5]),ue=!0}return T(),i.getToken()!==4?$(8,[4],[]):V(),!0}function ve(){switch(i.getToken()){case 3:return le();case 1:return Q();case 10:return z(!0);default:return ee()}}return V(),i.getToken()===17?n.allowEmptyContent?!0:($(4,[],[]),!1):ve()?(i.getToken()!==17&&$(9,[],[]),!0):($(4,[],[]),!1)}e.visit=o;function d(c,R){let n=t(c),i=[],g,f=0,s;do switch(s=n.getPosition(),g=n.scan(),g){case 12:case 13:case 17:f!==s&&i.push(c.substring(f,s)),R!==void 0&&i.push(n.getTokenValue().replace(/[^\r\n]/g,R)),f=n.getPosition();break}while(g!==17);return i.join("")}e.stripComments=d;function _(c){switch(typeof c){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(c){if(Array.isArray(c))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=_}),define(be[103],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class u{constructor(b){this.executor=b,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(b){this._error=b}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(b){return new u(()=>b(this.getValue()))}}e.Lazy=u}),function(re,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(re=typeof globalThis!="undefined"?globalThis:re||self,re.marked=e())}(this,function(){"use strict";function re(Ie,ge){for(var Ce=0;Ce<ge.length;Ce++){var Z=ge[Ce];Z.enumerable=Z.enumerable||!1,Z.configurable=!0,"value"in Z&&(Z.writable=!0),Object.defineProperty(Ie,Z.key,Z)}}function e(Ie,ge,Ce){return ge&&re(Ie.prototype,ge),Ce&&re(Ie,Ce),Ie}function u(Ie,ge){if(!!Ie){if(typeof Ie=="string")return M(Ie,ge);var Ce=Object.prototype.toString.call(Ie).slice(8,-1);if(Ce==="Object"&&Ie.constructor&&(Ce=Ie.constructor.name),Ce==="Map"||Ce==="Set")return Array.from(Ie);if(Ce==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ce))return M(Ie,ge)}}function M(Ie,ge){(ge==null||ge>Ie.length)&&(ge=Ie.length);for(var Ce=0,Z=new Array(ge);Ce<ge;Ce++)Z[Ce]=Ie[Ce];return Z}function b(Ie,ge){var Ce=typeof Symbol!="undefined"&&Ie[Symbol.iterator]||Ie["@@iterator"];if(Ce)return(Ce=Ce.call(Ie)).next.bind(Ce);if(Array.isArray(Ie)||(Ce=u(Ie))||ge&&Ie&&typeof Ie.length=="number"){Ce&&(Ie=Ce);var Z=0;return function(){return Z>=Ie.length?{done:!0}:{done:!1,value:Ie[Z++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var P={exports:{}};function t(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function A(Ie){P.exports.defaults=Ie}P.exports={defaults:t(),getDefaults:t,changeDefaults:A};var C=/[&<>"']/,k=/[&<>"']/g,F=/[<>"']|&(?!#?\w+;)/,y=/[<>"']|&(?!#?\w+;)/g,r={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},m=function(ge){return r[ge]};function a(Ie,ge){if(ge){if(C.test(Ie))return Ie.replace(k,m)}else if(F.test(Ie))return Ie.replace(y,m);return Ie}var h=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function p(Ie){return Ie.replace(h,function(ge,Ce){return Ce=Ce.toLowerCase(),Ce==="colon"?":":Ce.charAt(0)==="#"?Ce.charAt(1)==="x"?String.fromCharCode(parseInt(Ce.substring(2),16)):String.fromCharCode(+Ce.substring(1)):""})}var S=/(^|[^\[])\^/g;function w(Ie,ge){Ie=Ie.source||Ie,ge=ge||"";var Ce={replace:function(se,fe){return fe=fe.source||fe,fe=fe.replace(S,"$1"),Ie=Ie.replace(se,fe),Ce},getRegex:function(){return new RegExp(Ie,ge)}};return Ce}var o=/[^\w:]/g,d=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function _(Ie,ge,Ce){if(Ie){var Z;try{Z=decodeURIComponent(p(Ce)).replace(o,"").toLowerCase()}catch(se){return null}if(Z.indexOf("javascript:")===0||Z.indexOf("vbscript:")===0||Z.indexOf("data:")===0)return null}ge&&!d.test(Ce)&&(Ce=g(ge,Ce));try{Ce=encodeURI(Ce).replace(/%25/g,"%")}catch(se){return null}return Ce}var c={},R=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function g(Ie,ge){c[" "+Ie]||(R.test(Ie)?c[" "+Ie]=Ie+"/":c[" "+Ie]=l(Ie,"/",!0)),Ie=c[" "+Ie];var Ce=Ie.indexOf(":")===-1;return ge.substring(0,2)==="//"?Ce?ge:Ie.replace(n,"$1")+ge:ge.charAt(0)==="/"?Ce?ge:Ie.replace(i,"$1")+ge:Ie+ge}var f={exec:function(){}};function s(Ie){for(var ge=1,Ce,Z;ge<arguments.length;ge++){Ce=arguments[ge];for(Z in Ce)Object.prototype.hasOwnProperty.call(Ce,Z)&&(Ie[Z]=Ce[Z])}return Ie}function v(Ie,ge){var Ce=Ie.replace(/\|/g,function(fe,he,ke){for(var Le=!1,Me=he;--Me>=0&&ke[Me]==="\\";)Le=!Le;return Le?"|":" |"}),Z=Ce.split(/ \|/),se=0;if(Z[0].trim()||Z.shift(),Z[Z.length-1].trim()||Z.pop(),Z.length>ge)Z.splice(ge);else for(;Z.length<ge;)Z.push("");for(;se<Z.length;se++)Z[se]=Z[se].trim().replace(/\\\|/g,"|");return Z}function l(Ie,ge,Ce){var Z=Ie.length;if(Z===0)return"";for(var se=0;se<Z;){var fe=Ie.charAt(Z-se-1);if(fe===ge&&!Ce)se++;else if(fe!==ge&&Ce)se++;else break}return Ie.substr(0,Z-se)}function E(Ie,ge){if(Ie.indexOf(ge[1])===-1)return-1;for(var Ce=Ie.length,Z=0,se=0;se<Ce;se++)if(Ie[se]==="\\")se++;else if(Ie[se]===ge[0])Z++;else if(Ie[se]===ge[1]&&(Z--,Z<0))return se;return-1}function T(Ie){Ie&&Ie.sanitize&&!Ie.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function I(Ie,ge){if(ge<1)return"";for(var Ce="";ge>1;)ge&1&&(Ce+=Ie),ge>>=1,Ie+=Ie;return Ce+Ie}var B={escape:a,unescape:p,edit:w,cleanUrl:_,resolveUrl:g,noopTest:f,merge:s,splitCells:v,rtrim:l,findClosingBracket:E,checkSanitizeDeprecation:T,repeatString:I},O=P.exports.defaults,D=B.rtrim,x=B.splitCells,N=B.escape,V=B.findClosingBracket;function $(Ie,ge,Ce,Z){var se=ge.href,fe=ge.title?N(ge.title):null,he=Ie[1].replace(/\\([\[\]])/g,"$1");if(Ie[0].charAt(0)!=="!"){Z.state.inLink=!0;var ke={type:"link",raw:Ce,href:se,title:fe,text:he,tokens:Z.inlineTokens(he,[])};return Z.state.inLink=!1,ke}else return{type:"image",raw:Ce,href:se,title:fe,text:N(he)}}function z(Ie,ge){var Ce=Ie.match(/^(\s+)(?:```)/);if(Ce===null)return ge;var Z=Ce[1];return ge.split(`
`).map(function(se){var fe=se.match(/^\s+/);if(fe===null)return se;var he=fe[0];return he.length>=Z.length?se.slice(Z.length):se}).join(`
`)}var ee=function(){function Ie(Ce){this.options=Ce||O}var ge=Ie.prototype;return ge.space=function(Z){var se=this.rules.block.newline.exec(Z);if(se)return se[0].length>1?{type:"space",raw:se[0]}:{raw:`
`}},ge.code=function(Z){var se=this.rules.block.code.exec(Z);if(se){var fe=se[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:se[0],codeBlockStyle:"indented",text:this.options.pedantic?fe:D(fe,`
`)}}},ge.fences=function(Z){var se=this.rules.block.fences.exec(Z);if(se){var fe=se[0],he=z(fe,se[3]||"");return{type:"code",raw:fe,lang:se[2]?se[2].trim():se[2],text:he}}},ge.heading=function(Z){var se=this.rules.block.heading.exec(Z);if(se){var fe=se[2].trim();if(/#$/.test(fe)){var he=D(fe,"#");(this.options.pedantic||!he||/ $/.test(he))&&(fe=he.trim())}var ke={type:"heading",raw:se[0],depth:se[1].length,text:fe,tokens:[]};return this.lexer.inline(ke.text,ke.tokens),ke}},ge.hr=function(Z){var se=this.rules.block.hr.exec(Z);if(se)return{type:"hr",raw:se[0]}},ge.blockquote=function(Z){var se=this.rules.block.blockquote.exec(Z);if(se){var fe=se[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:se[0],tokens:this.lexer.blockTokens(fe,[]),text:fe}}},ge.list=function(Z){var se=this.rules.block.list.exec(Z);if(se){var fe,he,ke,Le,Me,We,it,Re,ce,me,ne=se[1].trim(),H=ne.length>1,we={type:"list",raw:"",ordered:H,start:H?+ne.slice(0,-1):"",loose:!1,items:[]};ne=H?"\\d{1,9}\\"+ne.slice(-1):"\\"+ne,this.options.pedantic&&(ne=H?ne:"[*+-]");for(var De=new RegExp("^( {0,3}"+ne+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");Z&&!(this.rules.block.hr.test(Z)||!(se=De.exec(Z)));){ce=se[2].split(`
`),this.options.pedantic?(Le=2,me=ce[0].trimLeft()):(Le=se[2].search(/[^ ]/),Le=se[1].length+(Le>4?1:Le),me=ce[0].slice(Le-se[1].length)),We=!1,fe=se[0],!ce[0]&&/^ *$/.test(ce[1])&&(fe=se[1]+ce.slice(0,2).join(`
`)+`
`,we.loose=!0,ce=[]);var Ge=new RegExp("^ {0,"+Math.min(3,Le-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(Me=1;Me<ce.length;Me++){if(Re=ce[Me],this.options.pedantic&&(Re=Re.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),Ge.test(Re)){fe=se[1]+ce.slice(0,Me).join(`
`)+`
`;break}if(!We){Re.trim()||(We=!0),Re.search(/[^ ]/)>=Le?me+=`
`+Re.slice(Le):me+=`
`+Re;continue}if(Re.search(/[^ ]/)>=Le||!Re.trim()){me+=`
`+Re.slice(Le);continue}else{fe=se[1]+ce.slice(0,Me).join(`
`)+`
`;break}}we.loose||(it?we.loose=!0:/\n *\n *$/.test(fe)&&(it=!0)),this.options.gfm&&(he=/^\[[ xX]\] /.exec(me),he&&(ke=he[0]!=="[ ] ",me=me.replace(/^\[[ xX]\] +/,""))),we.items.push({type:"list_item",raw:fe,task:!!he,checked:ke,loose:!1,text:me}),we.raw+=fe,Z=Z.slice(fe.length)}we.items[we.items.length-1].raw=fe.trimRight(),we.items[we.items.length-1].text=me.trimRight(),we.raw=we.raw.trimRight();var xe=we.items.length;for(Me=0;Me<xe;Me++)this.lexer.state.top=!1,we.items[Me].tokens=this.lexer.blockTokens(we.items[Me].text,[]),we.items[Me].tokens.some(function(ct){return ct.type==="space"})&&(we.loose=!0,we.items[Me].loose=!0);return we}},ge.html=function(Z){var se=this.rules.block.html.exec(Z);if(se){var fe={type:"html",raw:se[0],pre:!this.options.sanitizer&&(se[1]==="pre"||se[1]==="script"||se[1]==="style"),text:se[0]};return this.options.sanitize&&(fe.type="paragraph",fe.text=this.options.sanitizer?this.options.sanitizer(se[0]):N(se[0]),fe.tokens=[],this.lexer.inline(fe.text,fe.tokens)),fe}},ge.def=function(Z){var se=this.rules.block.def.exec(Z);if(se){se[3]&&(se[3]=se[3].substring(1,se[3].length-1));var fe=se[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:fe,raw:se[0],href:se[2],title:se[3]}}},ge.table=function(Z){var se=this.rules.block.table.exec(Z);if(se){var fe={type:"table",header:x(se[1]).map(function(it){return{text:it}}),align:se[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:se[3]?se[3].replace(/\n$/,"").split(`
`):[]};if(fe.header.length===fe.align.length){fe.raw=se[0];var he=fe.align.length,ke,Le,Me,We;for(ke=0;ke<he;ke++)/^ *-+: *$/.test(fe.align[ke])?fe.align[ke]="right":/^ *:-+: *$/.test(fe.align[ke])?fe.align[ke]="center":/^ *:-+ *$/.test(fe.align[ke])?fe.align[ke]="left":fe.align[ke]=null;for(he=fe.rows.length,ke=0;ke<he;ke++)fe.rows[ke]=x(fe.rows[ke],fe.header.length).map(function(it){return{text:it}});for(he=fe.header.length,Le=0;Le<he;Le++)fe.header[Le].tokens=[],this.lexer.inlineTokens(fe.header[Le].text,fe.header[Le].tokens);for(he=fe.rows.length,Le=0;Le<he;Le++)for(We=fe.rows[Le],Me=0;Me<We.length;Me++)We[Me].tokens=[],this.lexer.inlineTokens(We[Me].text,We[Me].tokens);return fe}}},ge.lheading=function(Z){var se=this.rules.block.lheading.exec(Z);if(se){var fe={type:"heading",raw:se[0],depth:se[2].charAt(0)==="="?1:2,text:se[1],tokens:[]};return this.lexer.inline(fe.text,fe.tokens),fe}},ge.paragraph=function(Z){var se=this.rules.block.paragraph.exec(Z);if(se){var fe={type:"paragraph",raw:se[0],text:se[1].charAt(se[1].length-1)===`
`?se[1].slice(0,-1):se[1],tokens:[]};return this.lexer.inline(fe.text,fe.tokens),fe}},ge.text=function(Z){var se=this.rules.block.text.exec(Z);if(se){var fe={type:"text",raw:se[0],text:se[0],tokens:[]};return this.lexer.inline(fe.text,fe.tokens),fe}},ge.escape=function(Z){var se=this.rules.inline.escape.exec(Z);if(se)return{type:"escape",raw:se[0],text:N(se[1])}},ge.tag=function(Z){var se=this.rules.inline.tag.exec(Z);if(se)return!this.lexer.state.inLink&&/^<a /i.test(se[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(se[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(se[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(se[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:se[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(se[0]):N(se[0]):se[0]}},ge.link=function(Z){var se=this.rules.inline.link.exec(Z);if(se){var fe=se[2].trim();if(!this.options.pedantic&&/^</.test(fe)){if(!/>$/.test(fe))return;var he=D(fe.slice(0,-1),"\\");if((fe.length-he.length)%2==0)return}else{var ke=V(se[2],"()");if(ke>-1){var Le=se[0].indexOf("!")===0?5:4,Me=Le+se[1].length+ke;se[2]=se[2].substring(0,ke),se[0]=se[0].substring(0,Me).trim(),se[3]=""}}var We=se[2],it="";if(this.options.pedantic){var Re=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(We);Re&&(We=Re[1],it=Re[3])}else it=se[3]?se[3].slice(1,-1):"";return We=We.trim(),/^</.test(We)&&(this.options.pedantic&&!/>$/.test(fe)?We=We.slice(1):We=We.slice(1,-1)),$(se,{href:We&&We.replace(this.rules.inline._escapes,"$1"),title:it&&it.replace(this.rules.inline._escapes,"$1")},se[0],this.lexer)}},ge.reflink=function(Z,se){var fe;if((fe=this.rules.inline.reflink.exec(Z))||(fe=this.rules.inline.nolink.exec(Z))){var he=(fe[2]||fe[1]).replace(/\s+/g," ");if(he=se[he.toLowerCase()],!he||!he.href){var ke=fe[0].charAt(0);return{type:"text",raw:ke,text:ke}}return $(fe,he,fe[0],this.lexer)}},ge.emStrong=function(Z,se,fe){fe===void 0&&(fe="");var he=this.rules.inline.emStrong.lDelim.exec(Z);if(!!he&&!(he[3]&&fe.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ke=he[1]||he[2]||"";if(!ke||ke&&(fe===""||this.rules.inline.punctuation.exec(fe))){var Le=he[0].length-1,Me,We,it=Le,Re=0,ce=he[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ce.lastIndex=0,se=se.slice(-1*Z.length+Le);(he=ce.exec(se))!=null;)if(Me=he[1]||he[2]||he[3]||he[4]||he[5]||he[6],!!Me){if(We=Me.length,he[3]||he[4]){it+=We;continue}else if((he[5]||he[6])&&Le%3&&!((Le+We)%3)){Re+=We;continue}if(it-=We,!(it>0)){if(We=Math.min(We,We+it+Re),Math.min(Le,We)%2){var me=Z.slice(1,Le+he.index+We);return{type:"em",raw:Z.slice(0,Le+he.index+We+1),text:me,tokens:this.lexer.inlineTokens(me,[])}}var ne=Z.slice(2,Le+he.index+We-1);return{type:"strong",raw:Z.slice(0,Le+he.index+We+1),text:ne,tokens:this.lexer.inlineTokens(ne,[])}}}}}},ge.codespan=function(Z){var se=this.rules.inline.code.exec(Z);if(se){var fe=se[2].replace(/\n/g," "),he=/[^ ]/.test(fe),ke=/^ /.test(fe)&&/ $/.test(fe);return he&&ke&&(fe=fe.substring(1,fe.length-1)),fe=N(fe,!0),{type:"codespan",raw:se[0],text:fe}}},ge.br=function(Z){var se=this.rules.inline.br.exec(Z);if(se)return{type:"br",raw:se[0]}},ge.del=function(Z){var se=this.rules.inline.del.exec(Z);if(se)return{type:"del",raw:se[0],text:se[2],tokens:this.lexer.inlineTokens(se[2],[])}},ge.autolink=function(Z,se){var fe=this.rules.inline.autolink.exec(Z);if(fe){var he,ke;return fe[2]==="@"?(he=N(this.options.mangle?se(fe[1]):fe[1]),ke="mailto:"+he):(he=N(fe[1]),ke=he),{type:"link",raw:fe[0],text:he,href:ke,tokens:[{type:"text",raw:he,text:he}]}}},ge.url=function(Z,se){var fe;if(fe=this.rules.inline.url.exec(Z)){var he,ke;if(fe[2]==="@")he=N(this.options.mangle?se(fe[0]):fe[0]),ke="mailto:"+he;else{var Le;do Le=fe[0],fe[0]=this.rules.inline._backpedal.exec(fe[0])[0];while(Le!==fe[0]);he=N(fe[0]),fe[1]==="www."?ke="http://"+he:ke=he}return{type:"link",raw:fe[0],text:he,href:ke,tokens:[{type:"text",raw:he,text:he}]}}},ge.inlineText=function(Z,se){var fe=this.rules.inline.text.exec(Z);if(fe){var he;return this.lexer.state.inRawBlock?he=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(fe[0]):N(fe[0]):fe[0]:he=N(this.options.smartypants?se(fe[0]):fe[0]),{type:"text",raw:fe[0],text:he}}},Ie}(),j=B.noopTest,Q=B.edit,le=B.merge,ve={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:j,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};ve._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,ve._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,ve.def=Q(ve.def).replace("label",ve._label).replace("title",ve._title).getRegex(),ve.bullet=/(?:[*+-]|\d{1,9}[.)])/,ve.listItemStart=Q(/^( *)(bull) */).replace("bull",ve.bullet).getRegex(),ve.list=Q(ve.list).replace(/bull/g,ve.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+ve.def.source+")").getRegex(),ve._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",ve._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,ve.html=Q(ve.html,"i").replace("comment",ve._comment).replace("tag",ve._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),ve.paragraph=Q(ve._paragraph).replace("hr",ve.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ve._tag).getRegex(),ve.blockquote=Q(ve.blockquote).replace("paragraph",ve.paragraph).getRegex(),ve.normal=le({},ve),ve.gfm=le({},ve.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),ve.gfm.table=Q(ve.gfm.table).replace("hr",ve.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ve._tag).getRegex(),ve.pedantic=le({},ve.normal,{html:Q(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",ve._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:j,paragraph:Q(ve.normal._paragraph).replace("hr",ve.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",ve.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ue={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:j,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:j,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ue._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ue.punctuation=Q(ue.punctuation).replace(/punctuation/g,ue._punctuation).getRegex(),ue.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ue.escapedEmSt=/\\\*|\\_/g,ue._comment=Q(ve._comment).replace("(?:-->|$)","-->").getRegex(),ue.emStrong.lDelim=Q(ue.emStrong.lDelim).replace(/punct/g,ue._punctuation).getRegex(),ue.emStrong.rDelimAst=Q(ue.emStrong.rDelimAst,"g").replace(/punct/g,ue._punctuation).getRegex(),ue.emStrong.rDelimUnd=Q(ue.emStrong.rDelimUnd,"g").replace(/punct/g,ue._punctuation).getRegex(),ue._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ue._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ue._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ue.autolink=Q(ue.autolink).replace("scheme",ue._scheme).replace("email",ue._email).getRegex(),ue._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ue.tag=Q(ue.tag).replace("comment",ue._comment).replace("attribute",ue._attribute).getRegex(),ue._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ue._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ue._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ue.link=Q(ue.link).replace("label",ue._label).replace("href",ue._href).replace("title",ue._title).getRegex(),ue.reflink=Q(ue.reflink).replace("label",ue._label).getRegex(),ue.reflinkSearch=Q(ue.reflinkSearch,"g").replace("reflink",ue.reflink).replace("nolink",ue.nolink).getRegex(),ue.normal=le({},ue),ue.pedantic=le({},ue.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:Q(/^!?\[(label)\]\((.*?)\)/).replace("label",ue._label).getRegex(),reflink:Q(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ue._label).getRegex()}),ue.gfm=le({},ue.normal,{escape:Q(ue.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),ue.gfm.url=Q(ue.gfm.url,"i").replace("email",ue.gfm._extended_email).getRegex(),ue.breaks=le({},ue.gfm,{br:Q(ue.br).replace("{2,}","*").getRegex(),text:Q(ue.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var Fe={block:ve,inline:ue},Ke=ee,Oe=P.exports.defaults,He=Fe.block,Je=Fe.inline,Ye=B.repeatString;function Qe(Ie){return Ie.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function W(Ie){var ge="",Ce,Z,se=Ie.length;for(Ce=0;Ce<se;Ce++)Z=Ie.charCodeAt(Ce),Math.random()>.5&&(Z="x"+Z.toString(16)),ge+="&#"+Z+";";return ge}var K=function(){function Ie(Ce){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ce||Oe,this.options.tokenizer=this.options.tokenizer||new Ke,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Z={block:He.normal,inline:Je.normal};this.options.pedantic?(Z.block=He.pedantic,Z.inline=Je.pedantic):this.options.gfm&&(Z.block=He.gfm,this.options.breaks?Z.inline=Je.breaks:Z.inline=Je.gfm),this.tokenizer.rules=Z}Ie.lex=function(Z,se){var fe=new Ie(se);return fe.lex(Z)},Ie.lexInline=function(Z,se){var fe=new Ie(se);return fe.inlineTokens(Z)};var ge=Ie.prototype;return ge.lex=function(Z){Z=Z.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(Z,this.tokens);for(var se;se=this.inlineQueue.shift();)this.inlineTokens(se.src,se.tokens);return this.tokens},ge.blockTokens=function(Z,se){var fe=this;se===void 0&&(se=[]),this.options.pedantic&&(Z=Z.replace(/^ +$/gm,""));for(var he,ke,Le,Me;Z;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(it){return(he=it.call({lexer:fe},Z,se))?(Z=Z.substring(he.raw.length),se.push(he),!0):!1}))){if(he=this.tokenizer.space(Z)){Z=Z.substring(he.raw.length),he.type&&se.push(he);continue}if(he=this.tokenizer.code(Z)){Z=Z.substring(he.raw.length),ke=se[se.length-1],ke&&(ke.type==="paragraph"||ke.type==="text")?(ke.raw+=`
`+he.raw,ke.text+=`
`+he.text,this.inlineQueue[this.inlineQueue.length-1].src=ke.text):se.push(he);continue}if(he=this.tokenizer.fences(Z)){Z=Z.substring(he.raw.length),se.push(he);continue}if(he=this.tokenizer.heading(Z)){Z=Z.substring(he.raw.length),se.push(he);continue}if(he=this.tokenizer.hr(Z)){Z=Z.substring(he.raw.length),se.push(he);continue}if(he=this.tokenizer.blockquote(Z)){Z=Z.substring(he.raw.length),se.push(he);continue}if(he=this.tokenizer.list(Z)){Z=Z.substring(he.raw.length),se.push(he);continue}if(he=this.tokenizer.html(Z)){Z=Z.substring(he.raw.length),se.push(he);continue}if(he=this.tokenizer.def(Z)){Z=Z.substring(he.raw.length),ke=se[se.length-1],ke&&(ke.type==="paragraph"||ke.type==="text")?(ke.raw+=`
`+he.raw,ke.text+=`
`+he.raw,this.inlineQueue[this.inlineQueue.length-1].src=ke.text):this.tokens.links[he.tag]||(this.tokens.links[he.tag]={href:he.href,title:he.title});continue}if(he=this.tokenizer.table(Z)){Z=Z.substring(he.raw.length),se.push(he);continue}if(he=this.tokenizer.lheading(Z)){Z=Z.substring(he.raw.length),se.push(he);continue}if(Le=Z,this.options.extensions&&this.options.extensions.startBlock&&function(){var it=Infinity,Re=Z.slice(1),ce=void 0;fe.options.extensions.startBlock.forEach(function(me){ce=me.call({lexer:this},Re),typeof ce=="number"&&ce>=0&&(it=Math.min(it,ce))}),it<Infinity&&it>=0&&(Le=Z.substring(0,it+1))}(),this.state.top&&(he=this.tokenizer.paragraph(Le))){ke=se[se.length-1],Me&&ke.type==="paragraph"?(ke.raw+=`
`+he.raw,ke.text+=`
`+he.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ke.text):se.push(he),Me=Le.length!==Z.length,Z=Z.substring(he.raw.length);continue}if(he=this.tokenizer.text(Z)){Z=Z.substring(he.raw.length),ke=se[se.length-1],ke&&ke.type==="text"?(ke.raw+=`
`+he.raw,ke.text+=`
`+he.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ke.text):se.push(he);continue}if(Z){var We="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(We);break}else throw new Error(We)}}return this.state.top=!0,se},ge.inline=function(Z,se){this.inlineQueue.push({src:Z,tokens:se})},ge.inlineTokens=function(Z,se){var fe=this;se===void 0&&(se=[]);var he,ke,Le,Me=Z,We,it,Re;if(this.tokens.links){var ce=Object.keys(this.tokens.links);if(ce.length>0)for(;(We=this.tokenizer.rules.inline.reflinkSearch.exec(Me))!=null;)ce.includes(We[0].slice(We[0].lastIndexOf("[")+1,-1))&&(Me=Me.slice(0,We.index)+"["+Ye("a",We[0].length-2)+"]"+Me.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(We=this.tokenizer.rules.inline.blockSkip.exec(Me))!=null;)Me=Me.slice(0,We.index)+"["+Ye("a",We[0].length-2)+"]"+Me.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(We=this.tokenizer.rules.inline.escapedEmSt.exec(Me))!=null;)Me=Me.slice(0,We.index)+"++"+Me.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Z;)if(it||(Re=""),it=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ne){return(he=ne.call({lexer:fe},Z,se))?(Z=Z.substring(he.raw.length),se.push(he),!0):!1}))){if(he=this.tokenizer.escape(Z)){Z=Z.substring(he.raw.length),se.push(he);continue}if(he=this.tokenizer.tag(Z)){Z=Z.substring(he.raw.length),ke=se[se.length-1],ke&&he.type==="text"&&ke.type==="text"?(ke.raw+=he.raw,ke.text+=he.text):se.push(he);continue}if(he=this.tokenizer.link(Z)){Z=Z.substring(he.raw.length),se.push(he);continue}if(he=this.tokenizer.reflink(Z,this.tokens.links)){Z=Z.substring(he.raw.length),ke=se[se.length-1],ke&&he.type==="text"&&ke.type==="text"?(ke.raw+=he.raw,ke.text+=he.text):se.push(he);continue}if(he=this.tokenizer.emStrong(Z,Me,Re)){Z=Z.substring(he.raw.length),se.push(he);continue}if(he=this.tokenizer.codespan(Z)){Z=Z.substring(he.raw.length),se.push(he);continue}if(he=this.tokenizer.br(Z)){Z=Z.substring(he.raw.length),se.push(he);continue}if(he=this.tokenizer.del(Z)){Z=Z.substring(he.raw.length),se.push(he);continue}if(he=this.tokenizer.autolink(Z,W)){Z=Z.substring(he.raw.length),se.push(he);continue}if(!this.state.inLink&&(he=this.tokenizer.url(Z,W))){Z=Z.substring(he.raw.length),se.push(he);continue}if(Le=Z,this.options.extensions&&this.options.extensions.startInline&&function(){var ne=Infinity,H=Z.slice(1),we=void 0;fe.options.extensions.startInline.forEach(function(De){we=De.call({lexer:this},H),typeof we=="number"&&we>=0&&(ne=Math.min(ne,we))}),ne<Infinity&&ne>=0&&(Le=Z.substring(0,ne+1))}(),he=this.tokenizer.inlineText(Le,Qe)){Z=Z.substring(he.raw.length),he.raw.slice(-1)!=="_"&&(Re=he.raw.slice(-1)),it=!0,ke=se[se.length-1],ke&&ke.type==="text"?(ke.raw+=he.raw,ke.text+=he.text):se.push(he);continue}if(Z){var me="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(me);break}else throw new Error(me)}}return se},e(Ie,null,[{key:"rules",get:function(){return{block:He,inline:Je}}}]),Ie}(),X=P.exports.defaults,oe=B.cleanUrl,G=B.escape,ie=function(){function Ie(Ce){this.options=Ce||X}var ge=Ie.prototype;return ge.code=function(Z,se,fe){var he=(se||"").match(/\S*/)[0];if(this.options.highlight){var ke=this.options.highlight(Z,he);ke!=null&&ke!==Z&&(fe=!0,Z=ke)}return Z=Z.replace(/\n$/,"")+`
`,he?'<pre><code class="'+this.options.langPrefix+G(he,!0)+'">'+(fe?Z:G(Z,!0))+`</code></pre>
`:"<pre><code>"+(fe?Z:G(Z,!0))+`</code></pre>
`},ge.blockquote=function(Z){return`<blockquote>
`+Z+`</blockquote>
`},ge.html=function(Z){return Z},ge.heading=function(Z,se,fe,he){return this.options.headerIds?"<h"+se+' id="'+this.options.headerPrefix+he.slug(fe)+'">'+Z+"</h"+se+`>
`:"<h"+se+">"+Z+"</h"+se+`>
`},ge.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ge.list=function(Z,se,fe){var he=se?"ol":"ul",ke=se&&fe!==1?' start="'+fe+'"':"";return"<"+he+ke+`>
`+Z+"</"+he+`>
`},ge.listitem=function(Z){return"<li>"+Z+`</li>
`},ge.checkbox=function(Z){return"<input "+(Z?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ge.paragraph=function(Z){return"<p>"+Z+`</p>
`},ge.table=function(Z,se){return se&&(se="<tbody>"+se+"</tbody>"),`<table>
<thead>
`+Z+`</thead>
`+se+`</table>
`},ge.tablerow=function(Z){return`<tr>
`+Z+`</tr>
`},ge.tablecell=function(Z,se){var fe=se.header?"th":"td",he=se.align?"<"+fe+' align="'+se.align+'">':"<"+fe+">";return he+Z+"</"+fe+`>
`},ge.strong=function(Z){return"<strong>"+Z+"</strong>"},ge.em=function(Z){return"<em>"+Z+"</em>"},ge.codespan=function(Z){return"<code>"+Z+"</code>"},ge.br=function(){return this.options.xhtml?"<br/>":"<br>"},ge.del=function(Z){return"<del>"+Z+"</del>"},ge.link=function(Z,se,fe){if(Z=oe(this.options.sanitize,this.options.baseUrl,Z),Z===null)return fe;var he='<a href="'+G(Z)+'"';return se&&(he+=' title="'+se+'"'),he+=">"+fe+"</a>",he},ge.image=function(Z,se,fe){if(Z=oe(this.options.sanitize,this.options.baseUrl,Z),Z===null)return fe;var he='<img src="'+Z+'" alt="'+fe+'"';return se&&(he+=' title="'+se+'"'),he+=this.options.xhtml?"/>":">",he},ge.text=function(Z){return Z},Ie}(),de=function(){function Ie(){}var ge=Ie.prototype;return ge.strong=function(Z){return Z},ge.em=function(Z){return Z},ge.codespan=function(Z){return Z},ge.del=function(Z){return Z},ge.html=function(Z){return Z},ge.text=function(Z){return Z},ge.link=function(Z,se,fe){return""+fe},ge.image=function(Z,se,fe){return""+fe},ge.br=function(){return""},Ie}(),Te=function(){function Ie(){this.seen={}}var ge=Ie.prototype;return ge.serialize=function(Z){return Z.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ge.getNextSafeSlug=function(Z,se){var fe=Z,he=0;if(this.seen.hasOwnProperty(fe)){he=this.seen[Z];do he++,fe=Z+"-"+he;while(this.seen.hasOwnProperty(fe))}return se||(this.seen[Z]=he,this.seen[fe]=0),fe},ge.slug=function(Z,se){se===void 0&&(se={});var fe=this.serialize(Z);return this.getNextSafeSlug(fe,se.dryrun)},Ie}(),Ne=ie,ze=de,je=Te,et=P.exports.defaults,ot=B.unescape,ye=function(){function Ie(Ce){this.options=Ce||et,this.options.renderer=this.options.renderer||new Ne,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ze,this.slugger=new je}Ie.parse=function(Z,se){var fe=new Ie(se);return fe.parse(Z)},Ie.parseInline=function(Z,se){var fe=new Ie(se);return fe.parseInline(Z)};var ge=Ie.prototype;return ge.parse=function(Z,se){se===void 0&&(se=!0);var fe="",he,ke,Le,Me,We,it,Re,ce,me,ne,H,we,De,Ge,xe,ct,_t,wt,lt,gt=Z.length;for(he=0;he<gt;he++){if(ne=Z[he],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ne.type]&&(lt=this.options.extensions.renderers[ne.type].call({parser:this},ne),lt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ne.type))){fe+=lt||"";continue}switch(ne.type){case"space":continue;case"hr":{fe+=this.renderer.hr();continue}case"heading":{fe+=this.renderer.heading(this.parseInline(ne.tokens),ne.depth,ot(this.parseInline(ne.tokens,this.textRenderer)),this.slugger);continue}case"code":{fe+=this.renderer.code(ne.text,ne.lang,ne.escaped);continue}case"table":{for(ce="",Re="",Me=ne.header.length,ke=0;ke<Me;ke++)Re+=this.renderer.tablecell(this.parseInline(ne.header[ke].tokens),{header:!0,align:ne.align[ke]});for(ce+=this.renderer.tablerow(Re),me="",Me=ne.rows.length,ke=0;ke<Me;ke++){for(it=ne.rows[ke],Re="",We=it.length,Le=0;Le<We;Le++)Re+=this.renderer.tablecell(this.parseInline(it[Le].tokens),{header:!1,align:ne.align[Le]});me+=this.renderer.tablerow(Re)}fe+=this.renderer.table(ce,me);continue}case"blockquote":{me=this.parse(ne.tokens),fe+=this.renderer.blockquote(me);continue}case"list":{for(H=ne.ordered,we=ne.start,De=ne.loose,Me=ne.items.length,me="",ke=0;ke<Me;ke++)xe=ne.items[ke],ct=xe.checked,_t=xe.task,Ge="",xe.task&&(wt=this.renderer.checkbox(ct),De?xe.tokens.length>0&&xe.tokens[0].type==="paragraph"?(xe.tokens[0].text=wt+" "+xe.tokens[0].text,xe.tokens[0].tokens&&xe.tokens[0].tokens.length>0&&xe.tokens[0].tokens[0].type==="text"&&(xe.tokens[0].tokens[0].text=wt+" "+xe.tokens[0].tokens[0].text)):xe.tokens.unshift({type:"text",text:wt}):Ge+=wt),Ge+=this.parse(xe.tokens,De),me+=this.renderer.listitem(Ge,_t,ct);fe+=this.renderer.list(me,H,we);continue}case"html":{fe+=this.renderer.html(ne.text);continue}case"paragraph":{fe+=this.renderer.paragraph(this.parseInline(ne.tokens));continue}case"text":{for(me=ne.tokens?this.parseInline(ne.tokens):ne.text;he+1<gt&&Z[he+1].type==="text";)ne=Z[++he],me+=`
`+(ne.tokens?this.parseInline(ne.tokens):ne.text);fe+=se?this.renderer.paragraph(me):me;continue}default:{var dt='Token with "'+ne.type+'" type was not found.';if(this.options.silent){console.error(dt);return}else throw new Error(dt)}}}return fe},ge.parseInline=function(Z,se){se=se||this.renderer;var fe="",he,ke,Le,Me=Z.length;for(he=0;he<Me;he++){if(ke=Z[he],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ke.type]&&(Le=this.options.extensions.renderers[ke.type].call({parser:this},ke),Le!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(ke.type))){fe+=Le||"";continue}switch(ke.type){case"escape":{fe+=se.text(ke.text);break}case"html":{fe+=se.html(ke.text);break}case"link":{fe+=se.link(ke.href,ke.title,this.parseInline(ke.tokens,se));break}case"image":{fe+=se.image(ke.href,ke.title,ke.text);break}case"strong":{fe+=se.strong(this.parseInline(ke.tokens,se));break}case"em":{fe+=se.em(this.parseInline(ke.tokens,se));break}case"codespan":{fe+=se.codespan(ke.text);break}case"br":{fe+=se.br();break}case"del":{fe+=se.del(this.parseInline(ke.tokens,se));break}case"text":{fe+=se.text(ke.text);break}default:{var We='Token with "'+ke.type+'" type was not found.';if(this.options.silent){console.error(We);return}else throw new Error(We)}}}return fe},Ie}(),nt=K,q=ye,J=ee,pe=ie,$e=de,qe=Te,rt=B.merge,ft=B.checkSanitizeDeprecation,ht=B.escape,Ct=P.exports.getDefaults,It=P.exports.changeDefaults,Pt=P.exports.defaults;function Ze(Ie,ge,Ce){if(typeof Ie=="undefined"||Ie===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ie!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ie)+", string expected");if(typeof ge=="function"&&(Ce=ge,ge=null),ge=rt({},Ze.defaults,ge||{}),ft(ge),Ce){var Z=ge.highlight,se;try{se=nt.lex(Ie,ge)}catch(Le){return Ce(Le)}var fe=function(Me){var We;if(!Me)try{ge.walkTokens&&Ze.walkTokens(se,ge.walkTokens),We=q.parse(se,ge)}catch(it){Me=it}return ge.highlight=Z,Me?Ce(Me):Ce(null,We)};if(!Z||Z.length<3||(delete ge.highlight,!se.length))return fe();var he=0;Ze.walkTokens(se,function(Le){Le.type==="code"&&(he++,setTimeout(function(){Z(Le.text,Le.lang,function(Me,We){if(Me)return fe(Me);We!=null&&We!==Le.text&&(Le.text=We,Le.escaped=!0),he--,he===0&&fe()})},0))}),he===0&&fe();return}try{var ke=nt.lex(Ie,ge);return ge.walkTokens&&Ze.walkTokens(ke,ge.walkTokens),q.parse(ke,ge)}catch(Le){if(Le.message+=`
Please report this to https://github.com/markedjs/marked.`,ge.silent)return"<p>An error occurred:</p><pre>"+ht(Le.message+"",!0)+"</pre>";throw Le}}Ze.options=Ze.setOptions=function(Ie){return rt(Ze.defaults,Ie),It(Ze.defaults),Ze},Ze.getDefaults=Ct,Ze.defaults=Pt,Ze.use=function(){for(var Ie=this,ge=arguments.length,Ce=new Array(ge),Z=0;Z<ge;Z++)Ce[Z]=arguments[Z];var se=rt.apply(void 0,[{}].concat(Ce)),fe=Ze.defaults.extensions||{renderers:{},childTokens:{}},he;Ce.forEach(function(ke){if(ke.extensions&&(he=!0,ke.extensions.forEach(function(Me){if(!Me.name)throw new Error("extension name required");if(Me.renderer){var We=fe.renderers?fe.renderers[Me.name]:null;We?fe.renderers[Me.name]=function(){for(var it=arguments.length,Re=new Array(it),ce=0;ce<it;ce++)Re[ce]=arguments[ce];var me=Me.renderer.apply(this,Re);return me===!1&&(me=We.apply(this,Re)),me}:fe.renderers[Me.name]=Me.renderer}if(Me.tokenizer){if(!Me.level||Me.level!=="block"&&Me.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");fe[Me.level]?fe[Me.level].unshift(Me.tokenizer):fe[Me.level]=[Me.tokenizer],Me.start&&(Me.level==="block"?fe.startBlock?fe.startBlock.push(Me.start):fe.startBlock=[Me.start]:Me.level==="inline"&&(fe.startInline?fe.startInline.push(Me.start):fe.startInline=[Me.start]))}Me.childTokens&&(fe.childTokens[Me.name]=Me.childTokens)})),ke.renderer&&function(){var Me=Ze.defaults.renderer||new pe,We=function(ce){var me=Me[ce];Me[ce]=function(){for(var ne=arguments.length,H=new Array(ne),we=0;we<ne;we++)H[we]=arguments[we];var De=ke.renderer[ce].apply(Me,H);return De===!1&&(De=me.apply(Me,H)),De}};for(var it in ke.renderer)We(it);se.renderer=Me}(),ke.tokenizer&&function(){var Me=Ze.defaults.tokenizer||new J,We=function(ce){var me=Me[ce];Me[ce]=function(){for(var ne=arguments.length,H=new Array(ne),we=0;we<ne;we++)H[we]=arguments[we];var De=ke.tokenizer[ce].apply(Me,H);return De===!1&&(De=me.apply(Me,H)),De}};for(var it in ke.tokenizer)We(it);se.tokenizer=Me}(),ke.walkTokens){var Le=Ze.defaults.walkTokens;se.walkTokens=function(Me){ke.walkTokens.call(Ie,Me),Le&&Le(Me)}}he&&(se.extensions=fe),Ze.setOptions(se)})},Ze.walkTokens=function(Ie,ge){for(var Ce=function(){var he=se.value;switch(ge(he),he.type){case"table":{for(var ke=b(he.header),Le;!(Le=ke()).done;){var Me=Le.value;Ze.walkTokens(Me.tokens,ge)}for(var We=b(he.rows),it;!(it=We()).done;)for(var Re=it.value,ce=b(Re),me;!(me=ce()).done;){var ne=me.value;Ze.walkTokens(ne.tokens,ge)}break}case"list":{Ze.walkTokens(he.items,ge);break}default:Ze.defaults.extensions&&Ze.defaults.extensions.childTokens&&Ze.defaults.extensions.childTokens[he.type]?Ze.defaults.extensions.childTokens[he.type].forEach(function(H){Ze.walkTokens(he[H],ge)}):he.tokens&&Ze.walkTokens(he.tokens,ge)}},Z=b(Ie),se;!(se=Z()).done;)Ce()},Ze.parseInline=function(Ie,ge){if(typeof Ie=="undefined"||Ie===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ie!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ie)+", string expected");ge=rt({},Ze.defaults,ge||{}),ft(ge);try{var Ce=nt.lexInline(Ie,ge);return ge.walkTokens&&Ze.walkTokens(Ce,ge.walkTokens),q.parseInline(Ce,ge)}catch(Z){if(Z.message+=`
Please report this to https://github.com/markedjs/marked.`,ge.silent)return"<p>An error occurred:</p><pre>"+ht(Z.message+"",!0)+"</pre>";throw Z}},Ze.Parser=q,Ze.parser=q.parse,Ze.Renderer=pe,Ze.TextRenderer=$e,Ze.Lexer=nt,Ze.lexer=nt.lex,Ze.Tokenizer=J,Ze.Slugger=qe,Ze.parse=Ze;var pt=Ze;return pt}),define(be[76],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function u(t,A,C){return Math.min(Math.max(t,A),C)}e.clamp=u;function M(t,A){return(A+t%A)%A}e.rot=M;class b{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=b;class P{constructor(){this._n=1,this._val=0}update(A){return this._val=this._val+(A-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=P}),function(){function re(b){const P=[];typeof b=="number"&&P.push("code/timeOrigin",b);function t(C){P.push(C,Date.now())}function A(){const C=[];for(let k=0;k<P.length;k+=2)C.push({name:P[k],startTime:P[k+1]});return C}return{mark:t,getMarks:A}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?re():{mark(b){performance.mark(b)},getMarks(){let b=performance.timeOrigin;typeof b!="number"&&(b=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const P=[{name:"code/timeOrigin",startTime:Math.round(b)}];for(const t of performance.getEntriesByType("mark"))P.push({name:t.name,startTime:Math.round(b+t.startTime)});return P}};if(typeof process=="object"){const b=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return re(b)}else return console.trace("perf-util loaded in UNKNOWN environment"),re()}function u(b){return b.MonacoPerformanceMarks||(b.MonacoPerformanceMarks=e()),b.MonacoPerformanceMarks}var M;typeof global=="object"?M=global:typeof self=="object"?M=self:M={},typeof define=="function"?define("vs/base/common/performance",[],function(){return u(M)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=u(M):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),M.perf=u(M))}(),define(be[35],Ee([0,1,3]),function(re,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.iconRegistry=void 0;class M{constructor(){this._icons=new Map,this._onDidRegister=new u.Emitter}add(F){const y=this._icons.get(F.id);y?F.description?y.description=F.description:console.error(`Duplicate registration of codicon ${F.id}`):(this._icons.set(F.id,F),this._onDidRegister.fire(F))}get(F){return this._icons.get(F)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const b=new M;e.iconRegistry=b;function P(k){return k?k.replace(/\$\((.*?)\)/g,(F,y)=>` ${y} `).trim():""}e.getCodiconAriaLabel=P;class t{constructor(F,y,r){this.id=F,this.definition=y,this.description=r,b.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=t,t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function A(k,F){const y=["codicon","codicon-"+k];return F&&y.push("codicon-modifier-"+F),y}e.getClassNamesArray=A;var C;(function(k){k.iconNameSegment="[A-Za-z0-9]+",k.iconNameExpression="[A-Za-z0-9-]+",k.iconModifierExpression="~[A-Za-z]+",k.iconNameCharacter="[A-Za-z0-9~-]";const F=new RegExp(`^(${k.iconNameExpression})(${k.iconModifierExpression})?$`);function y(a){if(a instanceof t)return["codicon","codicon-"+a.id];const h=F.exec(a.id);if(!h)return y(t.error);let[,p,S]=h;const w=["codicon","codicon-"+p];return S&&w.push("codicon-modifier-"+S.substr(1)),w}k.asClassNameArray=y;function r(a){return y(a).join(" ")}k.asClassName=r;function m(a){return"."+y(a).join(".")}k.asCSSSelector=m})(C=e.CSSIcon||(e.CSSIcon={}))}),define(be[104],Ee([0,1,16,6]),function(re,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function b(o){const d=o;return d?[d.on,d.pause,d.resume,d.destroy].every(_=>typeof _=="function"):!1}e.isReadableStream=b;function P(o){const d=o;return d?b(d.stream)&&Array.isArray(d.buffer)&&typeof d.ended=="boolean":!1}e.isReadableBufferedStream=P;function t(o,d){return new A(o,d)}e.newWriteableStream=t;class A{constructor(d,_){this.reducer=d,this.options=_,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(d){if(!this.state.destroyed){if(this.state.flowing)this.emitData(d);else if(this.buffer.data.push(d),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(_=>this.pendingWritePromises.push(_))}}error(d){this.state.destroyed||(this.state.flowing?this.emitError(d):this.buffer.error.push(d))}end(d){this.state.destroyed||(typeof d!="undefined"&&this.write(d),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(d){this.listeners.data.slice(0).forEach(_=>_(d))}emitError(d){this.listeners.error.length===0?(0,u.onUnexpectedError)(d):this.listeners.error.slice(0).forEach(_=>_(d))}emitEnd(){this.listeners.end.slice(0).forEach(d=>d())}on(d,_){if(!this.state.destroyed)switch(d){case"data":this.listeners.data.push(_),this.resume();break;case"end":this.listeners.end.push(_),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(_),this.state.flowing&&this.flowErrors();break}}removeListener(d,_){if(this.state.destroyed)return;let c;switch(d){case"data":c=this.listeners.data;break;case"end":c=this.listeners.end;break;case"error":c=this.listeners.error;break}if(c){const R=c.indexOf(_);R>=0&&c.splice(R,1)}}flowData(){if(this.buffer.data.length>0){const d=this.reducer(this.buffer.data);this.emitData(d),this.buffer.data.length=0;const _=[...this.pendingWritePromises];this.pendingWritePromises.length=0,_.forEach(c=>c())}}flowErrors(){if(this.listeners.error.length>0){for(const d of this.buffer.error)this.emitError(d);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function C(o,d){const _=[];let c;for(;(c=o.read())!==null;)_.push(c);return d(_)}e.consumeReadable=C;function k(o,d,_){const c=[];let R;for(;(R=o.read())!==null&&c.length<_;)c.push(R);return R===null&&c.length>0?d(c):{read:()=>{if(c.length>0)return c.shift();if(typeof R!="undefined"){const n=R;return R=void 0,n}return o.read()}}}e.peekReadable=k;function F(o,d){return new Promise((_,c)=>{const R=[];y(o,{onData:n=>{d&&R.push(n)},onError:n=>{d?c(n):_(void 0)},onEnd:()=>{_(d?d(R):void 0)}})})}e.consumeStream=F;function y(o,d){o.on("error",_=>d.onError(_)),o.on("end",()=>d.onEnd()),o.on("data",_=>d.onData(_))}e.listenStream=y;function r(o,d){return new Promise((_,c)=>{const R=new M.DisposableStore,n=[],i=s=>{if(n.push(s),n.length>d)return R.dispose(),o.pause(),_({stream:o,buffer:n,ended:!1})},g=s=>c(s),f=()=>_({stream:o,buffer:n,ended:!0});R.add((0,M.toDisposable)(()=>o.removeListener("error",g))),o.on("error",g),R.add((0,M.toDisposable)(()=>o.removeListener("end",f))),o.on("end",f),R.add((0,M.toDisposable)(()=>o.removeListener("data",i))),o.on("data",i)})}e.peekStream=r;function m(o,d){const _=t(d);return _.end(o),_}e.toStream=m;function a(){const o=t(()=>{throw new Error("not supported")});return o.end(),o}e.emptyStream=a;function h(o){let d=!1;return{read:()=>d?null:(d=!0,o)}}e.toReadable=h;function p(o,d,_){const c=t(_);return y(o,{onData:R=>c.write(d.data(R)),onError:R=>c.error(d.error?d.error(R):R),onEnd:()=>c.end()}),c}e.transform=p;function S(o,d,_){let c=!1;return{read:()=>{const R=d.read();return c?R:(c=!0,R!==null?_([o,R]):o)}}}e.prefixedReadable=S;function w(o,d,_){let c=!1;const R=t(_);return y(d,{onData:n=>c?R.write(n):(c=!0,R.write(_([o,n]))),onError:n=>R.error(n),onEnd:()=>{c||(c=!0,R.write(o)),R.end()}}),R}e.prefixedStream=w}),define(be[22],Ee([0,1,104]),function(re,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const M=typeof Buffer!="undefined";let b,P;class t{constructor(i){this.buffer=i,this.byteLength=this.buffer.byteLength}static alloc(i){return M?new t(Buffer.allocUnsafe(i)):new t(new Uint8Array(i))}static wrap(i){return M&&!Buffer.isBuffer(i)&&(i=Buffer.from(i.buffer,i.byteOffset,i.byteLength)),new t(i)}static fromString(i,g){return!(g?.dontUseNodeBuffer||!1)&&M?new t(Buffer.from(i)):(b||(b=new TextEncoder),new t(b.encode(i)))}static concat(i,g){if(typeof g=="undefined"){g=0;for(let v=0,l=i.length;v<l;v++)g+=i[v].byteLength}const f=t.alloc(g);let s=0;for(let v=0,l=i.length;v<l;v++){const E=i[v];f.set(E,s),s+=E.byteLength}return f}toString(){return M?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(i,g){return new t(this.buffer.subarray(i,g))}set(i,g){i instanceof t?this.buffer.set(i.buffer,g):this.buffer.set(i,g)}readUInt32BE(i){return k(this.buffer,i)}writeUInt32BE(i,g){F(this.buffer,i,g)}readUInt32LE(i){return y(this.buffer,i)}writeUInt32LE(i,g){r(this.buffer,i,g)}readUInt8(i){return m(this.buffer,i)}writeUInt8(i,g){a(this.buffer,i,g)}}e.VSBuffer=t;function A(n,i){return n[i+0]<<0>>>0|n[i+1]<<8>>>0}e.readUInt16LE=A;function C(n,i,g){n[g+0]=i&255,i=i>>>8,n[g+1]=i&255}e.writeUInt16LE=C;function k(n,i){return n[i]*2**24+n[i+1]*2**16+n[i+2]*2**8+n[i+3]}e.readUInt32BE=k;function F(n,i,g){n[g+3]=i,i=i>>>8,n[g+2]=i,i=i>>>8,n[g+1]=i,i=i>>>8,n[g]=i}e.writeUInt32BE=F;function y(n,i){return n[i+0]<<0>>>0|n[i+1]<<8>>>0|n[i+2]<<16>>>0|n[i+3]<<24>>>0}e.readUInt32LE=y;function r(n,i,g){n[g+0]=i&255,i=i>>>8,n[g+1]=i&255,i=i>>>8,n[g+2]=i&255,i=i>>>8,n[g+3]=i&255}e.writeUInt32LE=r;function m(n,i){return n[i]}e.readUInt8=m;function a(n,i,g){n[g]=i}e.writeUInt8=a;function h(n){return u.consumeReadable(n,i=>t.concat(i))}e.readableToBuffer=h;function p(n){return u.toReadable(n)}e.bufferToReadable=p;function S(n){return u.consumeStream(n,i=>t.concat(i))}e.streamToBuffer=S;async function w(n){return n.ended?t.concat(n.buffer):t.concat([...n.buffer,await S(n.stream)])}e.bufferedStreamToBuffer=w;function o(n){return u.toStream(n,i=>t.concat(i))}e.bufferToStream=o;function d(n){return u.transform(n,{data:i=>typeof i=="string"?t.fromString(i):t.wrap(i)},i=>t.concat(i))}e.streamToBufferReadableStream=d;function _(n){return u.newWriteableStream(i=>t.concat(i),n)}e.newWriteableBufferStream=_;function c(n,i){return u.prefixedReadable(n,i,g=>t.concat(g))}e.prefixedBufferReadable=c;function R(n,i){return u.prefixedStream(n,i,g=>t.concat(g))}e.prefixedBufferStream=R});var Xe=this&&this.__classPrivateFieldSet||function(re,e,u,M,b){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!b:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?b.call(re,u):b?b.value=u:e.set(re,u),u},Ae=this&&this.__classPrivateFieldGet||function(re,e,u,M){if(u==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?M:u==="a"?M.call(re):M?M.value:e.get(re)};define(be[20],Ee([0,1,15,9]),function(re,e,u,M){"use strict";var b,P,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function A(n,i,g){let f=n.get(i);return f===void 0&&(f=g,n.set(i,f)),f}e.getOrSet=A;function C(n){const i=[];return n.forEach((g,f)=>{i.push(`${f} => ${g}`)}),`Map(${n.size}) {${i.join(", ")}}`}e.mapToString=C;function k(n){const i=[];return n.forEach(g=>{i.push(g)}),`Set(${n.size}) {${i.join(", ")}}`}e.setToString=k;class F{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const g=i.charCodeAt(0),f=this._value.charCodeAt(this._pos);return g-f}value(){return this._value[this._pos]}}e.StringIterator=F;class y{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,M.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,M.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=y;class r{constructor(i=!0,g=!0){this._splitOnBackslash=i,this._caseSensitive=g}reset(i){return this._value=i.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++){const g=this._value.charCodeAt(this._to);if(g===47||this._splitOnBackslash&&g===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,M.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,M.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=r;var m;(function(n){n[n.Scheme=1]="Scheme",n[n.Authority=2]="Authority",n[n.Path=3]="Path",n[n.Query=4]="Query",n[n.Fragment=5]="Fragment"})(m||(m={}));class a{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new r(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,M.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,M.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,M.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,M.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=a;class h{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var p;(function(n){n[n.Left=-1]="Left",n[n.Mid=0]="Mid",n[n.Right=1]="Right"})(p||(p={}));class S{constructor(i){this._iter=i}static forUris(i=()=>!1){return new S(new a(i))}static forPaths(){return new S(new r)}static forStrings(){return new S(new F)}static forConfigKeys(){return new S(new y)}clear(){this._root=void 0}fill(i,g){if(g){const f=g.slice(0);(0,u.shuffle)(f);for(let s of f)this.set(s,i)}else{const f=i.slice(0);(0,u.shuffle)(f);for(let s of f)this.set(s[0],s[1])}}set(i,g){const f=this._iter.reset(i);let s;this._root||(this._root=new h,this._root.segment=f.value());const v=[];for(s=this._root;;){const E=f.cmp(s.segment);if(E>0)s.left||(s.left=new h,s.left.segment=f.value()),v.push([-1,s]),s=s.left;else if(E<0)s.right||(s.right=new h,s.right.segment=f.value()),v.push([1,s]),s=s.right;else if(f.hasNext())f.next(),s.mid||(s.mid=new h,s.mid.segment=f.value()),v.push([0,s]),s=s.mid;else break}const l=s.value;s.value=g,s.key=i;for(let E=v.length-1;E>=0;E--){const T=v[E][1];T.updateHeight();const I=T.balanceFactor();if(I<-1||I>1){const B=v[E][0],O=v[E+1][0];if(B===1&&O===1)v[E][1]=T.rotateLeft();else if(B===-1&&O===-1)v[E][1]=T.rotateRight();else if(B===1&&O===-1)T.right=v[E+1][1]=v[E+1][1].rotateRight(),v[E][1]=T.rotateLeft();else if(B===-1&&O===1)T.left=v[E+1][1]=v[E+1][1].rotateLeft(),v[E][1]=T.rotateRight();else throw new Error;if(E>0)switch(v[E-1][0]){case-1:v[E-1][1].left=v[E][1];break;case 1:v[E-1][1].right=v[E][1];break;case 0:v[E-1][1].mid=v[E][1];break}else this._root=v[0][1]}}return l}get(i){return this._getNode(i)?.value}_getNode(i){const g=this._iter.reset(i);let f=this._root;for(;f;){const s=g.cmp(f.segment);if(s>0)f=f.left;else if(s<0)f=f.right;else if(g.hasNext())g.next(),f=f.mid;else break}return f}has(i){const g=this._getNode(i);return!(g?.value===void 0&&g?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,g){const f=this._iter.reset(i),s=[];let v=this._root;for(;v;){const l=f.cmp(v.segment);if(l>0)s.push([-1,v]),v=v.left;else if(l<0)s.push([1,v]),v=v.right;else if(f.hasNext())f.next(),s.push([0,v]),v=v.mid;else break}if(!!v){if(g?(v.left=void 0,v.mid=void 0,v.right=void 0,v.height=1):(v.key=void 0,v.value=void 0),!v.mid&&!v.value)if(v.left&&v.right){const l=this._min(v.right),{key:E,value:T,segment:I}=l;this._delete(l.key,!1),v.key=E,v.value=T,v.segment=I}else{const l=v.left??v.right;if(s.length>0){const[E,T]=s[s.length-1];switch(E){case-1:T.left=l;break;case 0:T.mid=l;break;case 1:T.right=l;break}}else this._root=l}for(let l=s.length-1;l>=0;l--){const E=s[l][1];E.updateHeight();const T=E.balanceFactor();if(T>1?(E.right.balanceFactor()>=0||(E.right=s[l+1][1]=s[l+1][1].rotateRight()),s[l][1]=E.rotateLeft()):T<-1&&(E.left.balanceFactor()<=0||(E.left=s[l+1][1]=s[l+1][1].rotateLeft()),s[l][1]=E.rotateRight()),l>0)switch(s[l-1][0]){case-1:s[l-1][1].left=s[l][1];break;case 1:s[l-1][1].right=s[l][1];break;case 0:s[l-1][1].mid=s[l][1];break}else this._root=s[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const g=this._iter.reset(i);let f=this._root,s;for(;f;){const v=g.cmp(f.segment);if(v>0)f=f.left;else if(v<0)f=f.right;else if(g.hasNext())g.next(),s=f.value||s,f=f.mid;else break}return f&&f.value||s}findSuperstr(i){const g=this._iter.reset(i);let f=this._root;for(;f;){const s=g.cmp(f.segment);if(s>0)f=f.left;else if(s<0)f=f.right;else if(g.hasNext())g.next(),f=f.mid;else return f.mid?this._entries(f.mid):void 0}}forEach(i){for(const[g,f]of this)i(f,g)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){!i||(i.left&&(yield*this._entries(i.left)),i.value&&(yield[i.key,i.value]),i.mid&&(yield*this._entries(i.mid)),i.right&&(yield*this._entries(i.right)))}_isBalanced(){const i=g=>{if(!g)return!0;const f=g.balanceFactor();return f<-1||f>1?!1:i(g.left)&&i(g.right)};return i(this._root)}}e.TernarySearchTree=S;class w{constructor(i,g){this.uri=i,this.value=g}}class o{constructor(i,g){this[b]="ResourceMap",i instanceof o?(this.map=new Map(i.map),this.toKey=g??o.defaultToKey):(this.map=new Map,this.toKey=i??o.defaultToKey)}set(i,g){return this.map.set(this.toKey(i),new w(i,g)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,g){typeof g!="undefined"&&(i=i.bind(g));for(let[f,s]of this.map)i(s.value,s.uri,this)}*values(){for(let i of this.map.values())yield i.value}*keys(){for(let i of this.map.values())yield i.uri}*entries(){for(let i of this.map.values())yield[i.uri,i.value]}*[(b=Symbol.toStringTag,Symbol.iterator)](){for(let[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=o,o.defaultToKey=n=>n.toString();var d;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})(d=e.Touch||(e.Touch={}));class _{constructor(){this[P]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,g=0){const f=this._map.get(i);if(!!f)return g!==0&&this.touch(f,g),f.value}set(i,g,f=0){let s=this._map.get(i);if(s)s.value=g,f!==0&&this.touch(s,f);else{switch(s={key:i,value:g,next:void 0,previous:void 0},f){case 0:this.addItemLast(s);break;case 1:this.addItemFirst(s);break;case 2:this.addItemLast(s);break;default:this.addItemLast(s);break}this._map.set(i,s),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const g=this._map.get(i);if(!!g)return this._map.delete(i),this.removeItem(g),this._size--,g.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,g){const f=this._state;let s=this._head;for(;s;){if(g?i.bind(g)(s.value,s.key,this):i(s.value,s.key,this),this._state!==f)throw new Error("LinkedMap got modified during iteration.");s=s.next}}keys(){const i=this,g=this._state;let f=this._head;const s={[Symbol.iterator](){return s},next(){if(i._state!==g)throw new Error("LinkedMap got modified during iteration.");if(f){const v={value:f.key,done:!1};return f=f.next,v}else return{value:void 0,done:!0}}};return s}values(){const i=this,g=this._state;let f=this._head;const s={[Symbol.iterator](){return s},next(){if(i._state!==g)throw new Error("LinkedMap got modified during iteration.");if(f){const v={value:f.value,done:!1};return f=f.next,v}else return{value:void 0,done:!0}}};return s}entries(){const i=this,g=this._state;let f=this._head;const s={[Symbol.iterator](){return s},next(){if(i._state!==g)throw new Error("LinkedMap got modified during iteration.");if(f){const v={value:[f.key,f.value],done:!1};return f=f.next,v}else return{value:void 0,done:!0}}};return s}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let g=this._head,f=this.size;for(;g&&f>i;)this._map.delete(g.key),g=g.next,f--;this._head=g,this._size=f,g&&(g.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const g=i.next,f=i.previous;if(!g||!f)throw new Error("Invalid list");g.previous=f,f.next=g}i.next=void 0,i.previous=void 0,this._state++}touch(i,g){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(g!==1&&g!==2)){if(g===1){if(i===this._head)return;const f=i.next,s=i.previous;i===this._tail?(s.next=void 0,this._tail=s):(f.previous=s,s.next=f),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(g===2){if(i===this._tail)return;const f=i.next,s=i.previous;i===this._head?(f.previous=void 0,this._head=f):(f.previous=s,s.next=f),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((g,f)=>{i.push([f,g])}),i}fromJSON(i){this.clear();for(const[g,f]of i)this.set(g,f)}}e.LinkedMap=_;class c extends _{constructor(i,g=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,g),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,g=2){return super.get(i,g)}peek(i){return super.get(i,0)}set(i,g){return super.set(i,g,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=c;class R{constructor(i){t.set(this,void 0),Xe(this,t,i,"f")}get size(){return Ae(this,t,"f").size}forEach(i,g){Ae(this,t,"f").forEach(i,g)}get(i){return Ae(this,t,"f").get(i)}has(i){return Ae(this,t,"f").has(i)}entries(){return Ae(this,t,"f").entries()}keys(){return Ae(this,t,"f").keys()}values(){return Ae(this,t,"f").values()}[(t=new WeakMap,Symbol.iterator)](){return Ae(this,t,"f").entries()}}e.ReadonlyMapView=R}),define(be[105],Ee([0,1,20,9]),function(re,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function b(...G){return function(ie,de){for(let Te=0,Ne=G.length;Te<Ne;Te++){const ze=G[Te](ie,de);if(ze)return ze}return null}}e.or=b,e.matchesStrictPrefix=P.bind(void 0,!1),e.matchesPrefix=P.bind(void 0,!0);function P(G,ie,de){if(!de||de.length<ie.length)return null;let Te;return G?Te=M.startsWithIgnoreCase(de,ie):Te=de.indexOf(ie)===0,Te?ie.length>0?[{start:0,end:ie.length}]:[]:null}function t(G,ie){const de=ie.toLowerCase().indexOf(G.toLowerCase());return de===-1?null:[{start:de,end:de+G.length}]}e.matchesContiguousSubString=t;function A(G,ie){return C(G.toLowerCase(),ie.toLowerCase(),0,0)}e.matchesSubString=A;function C(G,ie,de,Te){if(de===G.length)return[];if(Te===ie.length)return null;if(G[de]===ie[Te]){let Ne=null;return(Ne=C(G,ie,de+1,Te+1))?S({start:Te,end:Te+1},Ne):null}return C(G,ie,de,Te+1)}function k(G){return 97<=G&&G<=122}function F(G){return 65<=G&&G<=90}e.isUpper=F;function y(G){return 48<=G&&G<=57}function r(G){return G===32||G===9||G===10||G===13}const m=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(G=>m.add(G.charCodeAt(0)));function a(G){return r(G)||m.has(G)}function h(G,ie){return G===ie||a(G)&&a(ie)}function p(G){return k(G)||F(G)||y(G)}function S(G,ie){return ie.length===0?ie=[G]:G.end===ie[0].start?ie[0].start=G.start:ie.unshift(G),ie}function w(G,ie){for(let de=ie;de<G.length;de++){const Te=G.charCodeAt(de);if(F(Te)||y(Te)||de>0&&!p(G.charCodeAt(de-1)))return de}return G.length}function o(G,ie,de,Te){if(de===G.length)return[];if(Te===ie.length)return null;if(G[de]!==ie[Te].toLowerCase())return null;{let Ne=null,ze=Te+1;for(Ne=o(G,ie,de+1,Te+1);!Ne&&(ze=w(ie,ze))<ie.length;)Ne=o(G,ie,de+1,ze),ze++;return Ne===null?null:S({start:Te,end:Te+1},Ne)}}function d(G){let ie=0,de=0,Te=0,Ne=0,ze=0;for(let nt=0;nt<G.length;nt++)ze=G.charCodeAt(nt),F(ze)&&ie++,k(ze)&&de++,p(ze)&&Te++,y(ze)&&Ne++;const je=ie/G.length,et=de/G.length,ot=Te/G.length,ye=Ne/G.length;return{upperPercent:je,lowerPercent:et,alphaPercent:ot,numericPercent:ye}}function _(G){const{upperPercent:ie,lowerPercent:de}=G;return de===0&&ie>.6}function c(G){const{upperPercent:ie,lowerPercent:de,alphaPercent:Te,numericPercent:Ne}=G;return de>.2&&ie<.8&&Te>.6&&Ne<.2}function R(G){let ie=0,de=0,Te=0,Ne=0;for(let ze=0;ze<G.length;ze++)Te=G.charCodeAt(ze),F(Te)&&ie++,k(Te)&&de++,r(Te)&&Ne++;return(ie===0||de===0)&&Ne===0?G.length<=30:ie<=5}function n(G,ie){if(!ie||(ie=ie.trim(),ie.length===0)||!R(G)||ie.length>60)return null;const de=d(ie);if(!c(de)){if(!_(de))return null;ie=ie.toLowerCase()}let Te=null,Ne=0;for(G=G.toLowerCase();Ne<ie.length&&(Te=o(G,ie,0,Ne))===null;)Ne=w(ie,Ne+1);return Te}e.matchesCamelCase=n;function i(G,ie,de=!1){if(!ie||ie.length===0)return null;let Te=null,Ne=0;for(G=G.toLowerCase(),ie=ie.toLowerCase();Ne<ie.length&&(Te=g(G,ie,0,Ne,de))===null;)Ne=f(ie,Ne+1);return Te}e.matchesWords=i;function g(G,ie,de,Te,Ne){if(de===G.length)return[];if(Te===ie.length)return null;if(h(G.charCodeAt(de),ie.charCodeAt(Te))){let ze=null,je=Te+1;if(ze=g(G,ie,de+1,Te+1,Ne),!Ne)for(;!ze&&(je=f(ie,je))<ie.length;)ze=g(G,ie,de+1,je,Ne),je++;return ze===null?null:S({start:Te,end:Te+1},ze)}else return null}function f(G,ie){for(let de=ie;de<G.length;de++)if(a(G.charCodeAt(de))||de>0&&a(G.charCodeAt(de-1)))return de;return G.length}const s=b(e.matchesPrefix,n,t),v=b(e.matchesPrefix,n,A),l=new u.LRUCache(1e4);function E(G,ie,de=!1){if(typeof G!="string"||typeof ie!="string")return null;let Te=l.get(G);Te||(Te=new RegExp(M.convertSimple2RegExpPattern(G),"i"),l.set(G,Te));const Ne=Te.exec(ie);return Ne?[{start:Ne.index,end:Ne.index+Ne[0].length}]:de?v(G,ie):s(G,ie)}e.matchesFuzzy=E;function T(G,ie){const de=Je(G,G.toLowerCase(),0,ie,ie.toLowerCase(),0,!0);return de?B(de):null}e.matchesFuzzy2=T;function I(G,ie,de,Te,Ne,ze){const je=Math.min(13,G.length);for(;de<je;de++){const et=Je(G,ie,de,Te,Ne,ze,!1);if(et)return et}return[0,ze]}e.anyScore=I;function B(G){if(typeof G=="undefined")return[];const ie=[],de=G[1];for(let Te=G.length-1;Te>1;Te--){const Ne=G[Te]+de,ze=ie[ie.length-1];ze&&ze.end===Ne?ze.end=Ne+1:ie.push({start:Ne,end:Ne+1})}return ie}e.createMatches=B;const O=128;function D(){const G=[],ie=[];for(let de=0;de<=O;de++)ie[de]=0;for(let de=0;de<=O;de++)G.push(ie.slice(0));return G}function x(G){const ie=[];for(let de=0;de<=G;de++)ie[de]=0;return ie}const N=x(2*O),V=x(2*O),$=D(),z=D(),ee=D(),j=!1;function Q(G,ie,de,Te,Ne){function ze(et,ot,ye=" "){for(;et.length<ot;)et=ye+et;return et}let je=` |   |${Te.split("").map(et=>ze(et,3)).join("|")}
`;for(let et=0;et<=de;et++)et===0?je+=" |":je+=`${ie[et-1]}|`,je+=G[et].slice(0,Ne+1).map(ot=>ze(ot.toString(),3)).join("|")+`
`;return je}function le(G,ie,de,Te){G=G.substr(ie),de=de.substr(Te),console.log(Q(z,G,G.length,de,de.length)),console.log(Q(ee,G,G.length,de,de.length)),console.log(Q($,G,G.length,de,de.length))}function ve(G,ie){if(ie<0||ie>=G.length)return!1;const de=G.codePointAt(ie);switch(de){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!M.isEmojiImprecise(de)}}function ue(G,ie){if(ie<0||ie>=G.length)return!1;switch(G.charCodeAt(ie)){case 32:case 9:return!0;default:return!1}}function Fe(G,ie,de){return ie[G]!==de[G]}function Ke(G,ie,de,Te,Ne,ze,je=!1){for(;ie<de&&Ne<ze;)G[ie]===Te[Ne]&&(je&&(N[ie]=Ne),ie+=1),Ne+=1;return ie===de}e.isPatternInWord=Ke;var Oe;(function(G){G[G.Diag=1]="Diag",G[G.Left=2]="Left",G[G.LeftLeft=3]="LeftLeft"})(Oe||(Oe={}));var He;(function(G){G.Default=[-100,0];function ie(de){return!de||de.length===2&&de[0]===-100&&de[1]===0}G.isDefault=ie})(He=e.FuzzyScore||(e.FuzzyScore={}));function Je(G,ie,de,Te,Ne,ze,je){const et=G.length>O?O:G.length,ot=Te.length>O?O:Te.length;if(de>=et||ze>=ot||et-de>ot-ze||!Ke(ie,de,et,Ne,ze,ot,!0))return;Ye(et,ot,de,ze,ie,Ne);let ye=1,nt=1,q=de,J=ze;const pe=[!1];for(ye=1,q=de;q<et;ye++,q++){const ht=N[q],Ct=V[q],It=q+1<et?V[q+1]:ot;for(nt=ht-ze+1,J=ht;J<It;nt++,J++){let Pt=Number.MIN_SAFE_INTEGER,Ze=!1;J<=Ct&&(Pt=Qe(G,ie,q,de,Te,Ne,J,ot,ze,$[ye-1][nt-1]===0,pe));let pt=0;Pt!==Number.MAX_SAFE_INTEGER&&(Ze=!0,pt=Pt+z[ye-1][nt-1]);const Ie=J>ht,ge=Ie?z[ye][nt-1]+($[ye][nt-1]>0?-5:0):0,Ce=J>ht+1&&$[ye][nt-1]>0,Z=Ce?z[ye][nt-2]+($[ye][nt-2]>0?-5:0):0;if(Ce&&(!Ie||Z>=ge)&&(!Ze||Z>=pt))z[ye][nt]=Z,ee[ye][nt]=3,$[ye][nt]=0;else if(Ie&&(!Ze||ge>=pt))z[ye][nt]=ge,ee[ye][nt]=2,$[ye][nt]=0;else if(Ze)z[ye][nt]=pt,ee[ye][nt]=1,$[ye][nt]=$[ye-1][nt-1]+1;else throw new Error("not possible")}}if(j&&le(G,de,Te,ze),!pe[0]&&!je)return;ye--,nt--;const $e=[z[ye][nt],ze];let qe=0,rt=0;for(;ye>=1;){let ht=nt;do{const Ct=ee[ye][ht];if(Ct===3)ht=ht-2;else if(Ct===2)ht=ht-1;else break}while(ht>=1);qe>1&&ie[de+ye-1]===Ne[ze+nt-1]&&!Fe(ht+ze-1,Te,Ne)&&qe+1>$[ye][ht]&&(ht=nt),ht===nt?qe++:qe=1,rt||(rt=ht),ye--,nt=ht-1,$e.push(nt)}ot===et&&($e[0]+=2);const ft=rt-et;return $e[0]-=ft,$e}e.fuzzyScore=Je;function Ye(G,ie,de,Te,Ne,ze){let je=G-1,et=ie-1;for(;je>=de&&et>=Te;)Ne[je]===ze[et]&&(V[je]=et,je--),et--}function Qe(G,ie,de,Te,Ne,ze,je,et,ot,ye,nt){if(ie[de]!==ze[je])return Number.MIN_SAFE_INTEGER;let q=1,J=!1;return je===de-Te?q=G[de]===Ne[je]?7:5:Fe(je,Ne,ze)&&(je===0||!Fe(je-1,Ne,ze))?(q=G[de]===Ne[je]?7:5,J=!0):ve(ze,je)&&(je===0||!ve(ze,je-1))?q=5:(ve(ze,je-1)||ue(ze,je-1))&&(q=5,J=!0),q>1&&de===Te&&(nt[0]=!0),J||(J=Fe(je,Ne,ze)||ve(ze,je-1)||ue(ze,je-1)),de===Te?je>ot&&(q-=J?3:5):ye?q+=J?2:0:q+=J?0:1,je+1===et&&(q-=J?3:5),q}function W(G,ie,de,Te,Ne,ze,je){return X(G,ie,de,Te,Ne,ze,!0,je)}e.fuzzyScoreGracefulAggressive=W;function K(G,ie,de,Te,Ne,ze,je){return X(G,ie,de,Te,Ne,ze,!1,je)}e.fuzzyScoreGraceful=K;function X(G,ie,de,Te,Ne,ze,je,et){let ot=Je(G,ie,de,Te,Ne,ze,et);if(ot&&!je)return ot;if(G.length>=3){const ye=Math.min(7,G.length-1);for(let nt=de+1;nt<ye;nt++){const q=oe(G,nt);if(q){const J=Je(q,q.toLowerCase(),de,Te,Ne,ze,et);J&&(J[0]-=3,(!ot||J[0]>ot[0])&&(ot=J))}}}return ot}function oe(G,ie){if(ie+1>=G.length)return;const de=G[ie],Te=G[ie+1];if(de!==Te)return G.slice(0,ie)+Te+de+G.slice(ie+2)}}),define(be[106],Ee([0,1,35,105,9]),function(re,e,u,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const P=new RegExp(`\\$\\(${u.CSSIcon.iconNameExpression}(?:${u.CSSIcon.iconModifierExpression})?\\)`,"g"),t=new RegExp(u.CSSIcon.iconNameCharacter),A=new RegExp(`(\\\\)?${P.source}`,"g");function C(p){return p.replace(A,(S,w)=>w?S:`\\${S}`)}e.escapeIcons=C;const k=new RegExp(`\\\\${P.source}`,"g");function F(p){return p.replace(k,S=>`\\${S}`)}e.markdownEscapeEscapedIcons=F;const y=new RegExp(`(\\s)?(\\\\)?${P.source}(\\s)?`,"g");function r(p){return p.indexOf(e.iconStartMarker)===-1?p:p.replace(y,(S,w,o,d)=>o?S:w||d||"")}e.stripIcons=r;function m(p){const S=p.indexOf(e.iconStartMarker);return S===-1?{text:p}:a(p,S)}e.parseLabelWithIcons=m;function a(p,S){const w=[];let o="";function d(s){if(s){o+=s;for(const v of s)w.push(R)}}let _=-1,c="",R=0,n,i,g=S;const f=p.length;for(d(p.substr(0,S));g<f;)n=p[g],i=p[g+1],n===e.iconStartMarker[0]&&i===e.iconStartMarker[1]?(_=g,d(c),c=e.iconStartMarker,g++):n===")"&&_!==-1?(R+=g-_+1,_=-1,c=""):_!==-1?t.test(n)?c+=n:(d(c),_=-1,c=""):d(n),g++;return d(c),{text:o,iconOffsets:w}}function h(p,S,w=!1){const{text:o,iconOffsets:d}=S;if(!d||d.length===0)return(0,M.matchesFuzzy)(p,o,w);const _=(0,b.ltrim)(o," "),c=o.length-_.length,R=(0,M.matchesFuzzy)(p,_,w);if(R)for(const n of R){const i=d[n.start+c]+c;n.start+=i,n.end+=i}return R}e.matchesFuzzyIconAware=h}),define(be[77],Ee([0,1,16,106]),function(re,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var b;(function(r){r[r.Paragraph=0]="Paragraph",r[r.Break=1]="Break"})(b=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class P{constructor(m="",a=!1){if(this.value=m,typeof this.value!="string")throw(0,u.illegalArgument)("value");typeof a=="boolean"?(this.isTrusted=a,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=a.isTrusted??void 0,this.supportThemeIcons=a.supportThemeIcons??!1,this.supportHtml=a.supportHtml??!1)}appendText(m,a=0){return this.value+=k(this.supportThemeIcons?(0,M.escapeIcons)(m):m).replace(/([ \t]+)/g,(h,p)=>"&nbsp;".repeat(p.length)).replace(/\>/gm,"\\>").replace(/\n/g,a===1?`\\
`:`

`),this}appendMarkdown(m){return this.value+=m,this}appendCodeblock(m,a){return this.value+="\n```",this.value+=m,this.value+=`
`,this.value+=a,this.value+="\n```\n",this}}e.MarkdownString=P;function t(r){return A(r)?!r.value:Array.isArray(r)?r.every(t):!0}e.isEmptyMarkdownString=t;function A(r){return r instanceof P?!0:r&&typeof r=="object"?typeof r.value=="string"&&(typeof r.isTrusted=="boolean"||r.isTrusted===void 0)&&(typeof r.supportThemeIcons=="boolean"||r.supportThemeIcons===void 0):!1}e.isMarkdownString=A;function C(r,m){return r===m?!0:!r||!m?!1:r.value===m.value&&r.isTrusted===m.isTrusted&&r.supportThemeIcons===m.supportThemeIcons}e.markdownStringEqual=C;function k(r){return r.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=k;function F(r){return r&&r.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=F;function y(r){const m=[],a=r.split("|").map(p=>p.trim());r=a[0];const h=a[1];if(h){const p=/height=(\d+)/.exec(h),S=/width=(\d+)/.exec(h),w=p?p[1]:"",o=S?S[1]:"",d=isFinite(parseInt(o)),_=isFinite(parseInt(w));d&&m.push(`width="${o}"`),_&&m.push(`height="${w}"`)}return{href:r,dimensions:m}}e.parseHrefAndDimensions=y}),define(be[36],Ee([0,1,9]),function(re,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var M;(function(b){b[b.Ignore=0]="Ignore",b[b.Info=1]="Info",b[b.Warning=2]="Warning",b[b.Error=3]="Error"})(M||(M={})),function(b){const P="error",t="warning",A="warn",C="info",k="ignore";function F(r){return r?u.equalsIgnoreCase(P,r)?b.Error:u.equalsIgnoreCase(t,r)||u.equalsIgnoreCase(A,r)?b.Warning:u.equalsIgnoreCase(C,r)?b.Info:b.Ignore:b.Ignore}b.fromValue=F;function y(r){switch(r){case b.Error:return P;case b.Warning:return t;case b.Info:return C;default:return k}}b.toString=y}(M||(M={})),e.default=M}),define(be[44],Ee([0,1,17,25,9,10]),function(re,e,u,M,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function t(n){return n===47||n===92}e.isPathSeparator=t;function A(n){return n.replace(/[\\/]/g,u.posix.sep)}e.toSlashes=A;function C(n){return n.indexOf("/")===-1&&(n=A(n)),/^[a-zA-Z]:(\/|$)/.test(n)&&(n="/"+n),n}e.toPosixPath=C;function k(n,i=u.posix.sep){if(!n)return"";const g=n.length,f=n.charCodeAt(0);if(t(f)){if(t(n.charCodeAt(1))&&!t(n.charCodeAt(2))){let v=3;const l=v;for(;v<g&&!t(n.charCodeAt(v));v++);if(l!==v&&!t(n.charCodeAt(v+1))){for(v+=1;v<g;v++)if(t(n.charCodeAt(v)))return n.slice(0,v+1).replace(/[\\/]/g,i)}}return i}else if(S(f)&&n.charCodeAt(1)===58)return t(n.charCodeAt(2))?n.slice(0,2)+i:n.slice(0,2);let s=n.indexOf("://");if(s!==-1){for(s+=3;s<g;s++)if(t(n.charCodeAt(s)))return n.slice(0,s+1)}return""}e.getRoot=k;function F(n){if(!M.isWindows||!n||n.length<5)return!1;let i=n.charCodeAt(0);if(i!==92||(i=n.charCodeAt(1),i!==92))return!1;let g=2;const f=g;for(;g<n.length&&(i=n.charCodeAt(g),i!==92);g++);return!(f===g||(i=n.charCodeAt(g+1),isNaN(i)||i===92))}e.isUNC=F;const y=/[\\/:\*\?"<>\|]/g,r=/[\\/]/g,m=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function a(n,i=M.isWindows){const g=i?y:r;return!(!n||n.length===0||/^\s+$/.test(n)||(g.lastIndex=0,g.test(n))||i&&m.test(n)||n==="."||n===".."||i&&n[n.length-1]==="."||i&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=a;function h(n,i,g){const f=n===i;return!g||f?f:!n||!i?!1:(0,b.equalsIgnoreCase)(n,i)}e.isEqual=h;function p(n,i,g,f=u.sep){if(n===i)return!0;if(!n||!i||i.length>n.length)return!1;if(g){if(!(0,b.startsWithIgnoreCase)(n,i))return!1;if(i.length===n.length)return!0;let v=i.length;return i.charAt(i.length-1)===f&&v--,n.charAt(v)===f}return i.charAt(i.length-1)!==f&&(i+=f),n.indexOf(i)===0}e.isEqualOrParent=p;function S(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=S;function w(n,i){return M.isWindows&&n.endsWith(":")&&(n+=u.sep),(0,u.isAbsolute)(n)||(n=(0,u.join)(i,n)),n=(0,u.normalize)(n),M.isWindows?(n=(0,b.rtrim)(n,u.sep),n.endsWith(":")&&(n+=u.sep)):(n=(0,b.rtrim)(n,u.sep),n||(n=u.sep)),n}e.sanitizeFilePath=w;function o(n){const i=(0,u.normalize)(n);return M.isWindows?n.length>3?!1:d(i)&&(n.length===2||i.charCodeAt(2)===92):i===u.posix.sep}e.isRootOrDriveLetter=o;function d(n,i){return(i!==void 0?i:M.isWindows)?S(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=d;function _(n){return d(n)?n[0]:void 0}e.getDriveLetter=_;function c(n,i,g){return i.length>n.length?-1:n===i?0:(g&&(n=n.toLowerCase(),i=i.toLowerCase()),n.indexOf(i))}e.indexOfPath=c;function R(n){const i=n.split(":");let g,f,s;if(i.forEach(v=>{const l=Number(v);(0,P.isNumber)(l)?f===void 0?f=l:s===void 0&&(s=l):g=g?[g,v].join(":"):v}),!g)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:g,line:f!==void 0?f:void 0,column:s!==void 0?s:f!==void 0?1:void 0}}e.parseLineAndColumnAware=R}),define(be[23],Ee([0,1,10]),function(re,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function M(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const p=Array.isArray(h)?[]:{};return Object.keys(h).forEach(S=>{h[S]&&typeof h[S]=="object"?p[S]=M(h[S]):p[S]=h[S]}),p}e.deepClone=M;function b(h){if(!h||typeof h!="object")return h;const p=[h];for(;p.length>0;){const S=p.shift();Object.freeze(S);for(const w in S)if(P.call(S,w)){const o=S[w];typeof o=="object"&&!Object.isFrozen(o)&&p.push(o)}}return h}e.deepFreeze=b;const P=Object.prototype.hasOwnProperty;function t(h,p){return A(h,p,new Set)}e.cloneAndChange=t;function A(h,p,S){if((0,u.isUndefinedOrNull)(h))return h;const w=p(h);if(typeof w!="undefined")return w;if((0,u.isArray)(h)){const o=[];for(const d of h)o.push(A(d,p,S));return o}if((0,u.isObject)(h)){if(S.has(h))throw new Error("Cannot clone recursive data-structure");S.add(h);const o={};for(let d in h)P.call(h,d)&&(o[d]=A(h[d],p,S));return S.delete(h),o}return h}function C(h,p,S=!0){return(0,u.isObject)(h)?((0,u.isObject)(p)&&Object.keys(p).forEach(w=>{w in h?S&&((0,u.isObject)(h[w])&&(0,u.isObject)(p[w])?C(h[w],p[w],S):h[w]=p[w]):h[w]=p[w]}),h):p}e.mixin=C;function k(h,p){if(h===p)return!0;if(h==null||p===null||p===void 0||typeof h!=typeof p||typeof h!="object"||Array.isArray(h)!==Array.isArray(p))return!1;let S,w;if(Array.isArray(h)){if(h.length!==p.length)return!1;for(S=0;S<h.length;S++)if(!k(h[S],p[S]))return!1}else{const o=[];for(w in h)o.push(w);o.sort();const d=[];for(w in p)d.push(w);if(d.sort(),!k(o,d))return!1;for(S=0;S<o.length;S++)if(!k(h[o[S]],p[o[S]]))return!1}return!0}e.equals=k;function F(h){const p=new Set;return JSON.stringify(h,(S,w)=>{if((0,u.isObject)(w)||Array.isArray(w)){if(p.has(w))return"[Circular]";p.add(w)}return w})}e.safeStringify=F;function y(h,p,S){const w=p(h);return typeof w=="undefined"?S:w}e.getOrDefault=y;function r(h,p){const S=Object.create(null);return!h||!p||Object.keys(p).forEach(o=>{const d=h[o],_=p[o];k(d,_)||(S[o]=_)}),S}e.distinct=r;function m(h,p){const S=p.toLowerCase(),w=Object.keys(h).find(o=>o.toLowerCase()===S);return w?h[w]:h[p]}e.getCaseInsensitive=m;function a(h,p){const S=Object.create(null);for(const[w,o]of Object.entries(h))p(w,o)&&(S[w]=o);return S}e.filter=a}),define(be[57],Ee([0,1,22,9,2]),function(re,e,u,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function P(F){return JSON.stringify(F,C)}e.stringify=P;function t(F){let y=JSON.parse(F);return y=k(y),y}e.parse=t;var A;(function(F){F[F.Uri=1]="Uri",F[F.Regexp=2]="Regexp",F[F.ScmResource=3]="ScmResource",F[F.ScmResourceGroup=4]="ScmResourceGroup",F[F.ScmProvider=5]="ScmProvider",F[F.CommentController=6]="CommentController",F[F.CommentThread=7]="CommentThread",F[F.CommentThreadReply=8]="CommentThreadReply",F[F.CommentNode=9]="CommentNode",F[F.CommentThreadNode=10]="CommentThreadNode",F[F.TimelineActionContext=11]="TimelineActionContext",F[F.NotebookCellActionContext=12]="NotebookCellActionContext",F[F.TestItemContext=13]="TestItemContext"})(A=e.MarshalledId||(e.MarshalledId={}));function C(F,y){return y instanceof RegExp?{$mid:2,source:y.source,flags:(0,M.regExpFlags)(y)}:y}function k(F,y=0){if(!F||y>200)return F;if(typeof F=="object"){switch(F.$mid){case 1:return b.URI.revive(F);case 2:return new RegExp(F.source,F.flags)}if(F instanceof u.VSBuffer||F instanceof Uint8Array)return F;if(Array.isArray(F))for(let r=0;r<F.length;++r)F[r]=k(F[r],y+1);else for(const r in F)Object.hasOwnProperty.call(F,r)&&(F[r]=k(F[r],y+1))}return F}e.revive=k}),define(be[11],Ee([0,1,25,2]),function(re,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var b;(function(A){A.inMemory="inmemory",A.vscode="vscode",A.internal="private",A.walkThrough="walkThrough",A.walkThroughSnippet="walkThroughSnippet",A.http="http",A.https="https",A.file="file",A.mailto="mailto",A.untitled="untitled",A.data="data",A.command="command",A.vscodeRemote="vscode-remote",A.vscodeRemoteResource="vscode-remote-resource",A.userData="vscode-userdata",A.vscodeCustomEditor="vscode-custom-editor",A.vscodeNotebook="vscode-notebook",A.vscodeNotebookCell="vscode-notebook-cell",A.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",A.vscodeNotebookCellOutput="vscode-notebook-cell-output",A.vscodeInteractive="vscode-interactive",A.vscodeInteractiveInput="vscode-interactive-input",A.vscodeSettings="vscode-settings",A.vscodeWorkspaceTrust="vscode-workspace-trust",A.vscodeTerminal="vscode-terminal",A.webviewPanel="webview-panel",A.vscodeWebview="vscode-webview",A.extension="extension",A.vscodeFileResource="vscode-file",A.tmp="tmp",A.vsls="vsls"})(b=e.Schemas||(e.Schemas={}));class P{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(C){this._preferredWebSchema=C}setDelegate(C){this._delegate=C}set(C,k,F){this._hosts[C]=k,this._ports[C]=F}setConnectionToken(C,k){this._connectionTokens[C]=k}rewrite(C){if(this._delegate)return this._delegate(C);const k=C.authority;let F=this._hosts[k];F&&F.indexOf(":")!==-1&&(F=`[${F}]`);const y=this._ports[k],r=this._connectionTokens[k];let m=`path=${encodeURIComponent(C.path)}`;return typeof r=="string"&&(m+=`&tkn=${encodeURIComponent(r)}`),M.URI.from({scheme:u.isWeb?this._preferredWebSchema:b.vscodeRemoteResource,authority:`${F}:${y}`,path:"/vscode-remote-resource",query:m})}}e.RemoteAuthorities=new P;class t{asBrowserUri(C,k){const F=this.toUri(C,k);return F.scheme===b.vscodeRemote?e.RemoteAuthorities.rewrite(F):F.scheme===b.file&&(u.isNative||typeof u.globals.importScripts=="function"&&u.globals.origin===`${b.vscodeFileResource}://${t.FALLBACK_AUTHORITY}`)?F.with({scheme:b.vscodeFileResource,authority:F.authority||t.FALLBACK_AUTHORITY,query:null,fragment:null}):F}asFileUri(C,k){const F=this.toUri(C,k);return F.scheme===b.vscodeFileResource?F.with({scheme:b.file,authority:F.authority!==t.FALLBACK_AUTHORITY?F.authority:null,query:null,fragment:null}):F}toUri(C,k){return M.URI.isUri(C)?C:M.URI.parse(k.toUrl(C))}}t.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new t}),define(be[24],Ee([0,1,44,11,17,25,9,2]),function(re,e,u,M,b,P,t,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function C(m){return(0,A.uriToFsPath)(m,!0)}e.originalFSPath=C;class k{constructor(a){this._ignorePathCasing=a}compare(a,h,p=!1){return a===h?0:(0,t.compare)(this.getComparisonKey(a,p),this.getComparisonKey(h,p))}isEqual(a,h,p=!1){return a===h?!0:!a||!h?!1:this.getComparisonKey(a,p)===this.getComparisonKey(h,p)}getComparisonKey(a,h=!1){return a.with({path:this._ignorePathCasing(a)?a.path.toLowerCase():void 0,fragment:h?null:void 0}).toString()}ignorePathCasing(a){return this._ignorePathCasing(a)}isEqualOrParent(a,h,p=!1){if(a.scheme===h.scheme){if(a.scheme===M.Schemas.file)return u.isEqualOrParent(C(a),C(h),this._ignorePathCasing(a))&&a.query===h.query&&(p||a.fragment===h.fragment);if((0,e.isEqualAuthority)(a.authority,h.authority))return u.isEqualOrParent(a.path,h.path,this._ignorePathCasing(a),"/")&&a.query===h.query&&(p||a.fragment===h.fragment)}return!1}joinPath(a,...h){return A.URI.joinPath(a,...h)}basenameOrAuthority(a){return(0,e.basename)(a)||a.authority}basename(a){return b.posix.basename(a.path)}extname(a){return b.posix.extname(a.path)}dirname(a){if(a.path.length===0)return a;let h;return a.scheme===M.Schemas.file?h=A.URI.file(b.dirname(C(a))).path:(h=b.posix.dirname(a.path),a.authority&&h.length&&h.charCodeAt(0)!==47&&(console.error(`dirname("${a.toString})) resulted in a relative path`),h="/")),a.with({path:h})}normalizePath(a){if(!a.path.length)return a;let h;return a.scheme===M.Schemas.file?h=A.URI.file(b.normalize(C(a))).path:h=b.posix.normalize(a.path),a.with({path:h})}relativePath(a,h){if(a.scheme!==h.scheme||!(0,e.isEqualAuthority)(a.authority,h.authority))return;if(a.scheme===M.Schemas.file){const w=b.relative(C(a),C(h));return P.isWindows?u.toSlashes(w):w}let p=a.path||"/",S=h.path||"/";if(this._ignorePathCasing(a)){let w=0;for(const o=Math.min(p.length,S.length);w<o&&!(p.charCodeAt(w)!==S.charCodeAt(w)&&p.charAt(w).toLowerCase()!==S.charAt(w).toLowerCase());w++);p=S.substr(0,w)+p.substr(w)}return b.posix.relative(p,S)}resolvePath(a,h){if(a.scheme===M.Schemas.file){const p=A.URI.file(b.resolve(C(a),h));return a.with({authority:p.authority,path:p.path})}return h=u.toPosixPath(h),a.with({path:b.posix.resolve(a.path,h)})}isAbsolutePath(a){return!!a.path&&a.path[0]==="/"}isEqualAuthority(a,h){return a===h||a!==void 0&&h!==void 0&&(0,t.equalsIgnoreCase)(a,h)}hasTrailingPathSeparator(a,h=b.sep){if(a.scheme===M.Schemas.file){const p=C(a);return p.length>u.getRoot(p).length&&p[p.length-1]===h}else{const p=a.path;return p.length>1&&p.charCodeAt(p.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(a.fsPath)}}removeTrailingPathSeparator(a,h=b.sep){return(0,e.hasTrailingPathSeparator)(a,h)?a.with({path:a.path.substr(0,a.path.length-1)}):a}addTrailingPathSeparator(a,h=b.sep){let p=!1;if(a.scheme===M.Schemas.file){const S=C(a);p=S!==void 0&&S.length===u.getRoot(S).length&&S[S.length-1]===h}else{h="/";const S=a.path;p=S.length===1&&S.charCodeAt(S.length-1)===47}return!p&&!(0,e.hasTrailingPathSeparator)(a,h)?a.with({path:a.path+"/"}):a}}e.ExtUri=k,e.extUri=new k(()=>!1),e.extUriBiasedIgnorePathCase=new k(m=>m.scheme===M.Schemas.file?!P.isLinux:!0),e.extUriIgnorePathCase=new k(m=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function F(m,a){const h=[];for(let p=0;p<m.length;p++){const S=a(m[p]);m.some((w,o)=>o===p?!1:(0,e.isEqualOrParent)(S,a(w)))||h.push(m[p])}return h}e.distinctParents=F;var y;(function(m){m.META_DATA_LABEL="label",m.META_DATA_DESCRIPTION="description",m.META_DATA_SIZE="size",m.META_DATA_MIME="mime";function a(h){const p=new Map;h.path.substring(h.path.indexOf(";")+1,h.path.lastIndexOf(";")).split(";").forEach(o=>{const[d,_]=o.split(":");d&&_&&p.set(d,_)});const w=h.path.substring(0,h.path.indexOf(";"));return w&&p.set(m.META_DATA_MIME,w),p}m.parseMetaData=a})(y=e.DataUri||(e.DataUri={}));function r(m,a,h){if(a){let p=m.path;return p&&p[0]!==b.posix.sep&&(p=b.posix.sep+p),m.with({scheme:h,authority:a,path:p})}return m.with({scheme:h})}e.toLocalResource=r}),define(be[13],Ee([0,1,21,16,3,6,24]),function(re,e,u,M,b,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function A($){return!!$&&typeof $.then=="function"}e.isThenable=A;function C($){const z=new u.CancellationTokenSource,ee=$(z.token),j=new Promise((Q,le)=>{const ve=z.token.onCancellationRequested(()=>{ve.dispose(),z.dispose(),le((0,M.canceled)())});Promise.resolve(ee).then(ue=>{ve.dispose(),z.dispose(),Q(ue)},ue=>{ve.dispose(),z.dispose(),le(ue)})});return new class{cancel(){z.cancel()}then(Q,le){return j.then(Q,le)}catch(Q){return this.then(void 0,Q)}finally(Q){return j.finally(Q)}}}e.createCancelablePromise=C;function k($,z,ee){return Promise.race([$,new Promise(j=>z.onCancellationRequested(()=>j(ee)))])}e.raceCancellation=k;async function F($){let z=-1;const ee=$.map((Q,le)=>Q.then(ve=>(z=le,ve))),j=await Promise.race(ee);return $.forEach((Q,le)=>{le!==z&&Q.cancel()}),j}e.raceCancellablePromises=F;function y($,z,ee){let j;const Q=setTimeout(()=>{j?.(void 0),ee?.()},z);return Promise.race([$.finally(()=>clearTimeout(Q)),new Promise(le=>j=le)])}e.raceTimeout=y;function r($){return new Promise((z,ee)=>{const j=$();A(j)?j.then(z,ee):z(j)})}e.asPromise=r;class m{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(z){if(this.activePromise){if(this.queuedPromiseFactory=z,!this.queuedPromise){const ee=()=>{this.queuedPromise=null;const j=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,j};this.queuedPromise=new Promise(j=>{this.activePromise.then(ee,ee).then(j)})}return new Promise((ee,j)=>{this.queuedPromise.then(ee,j)})}return this.activePromise=z(),new Promise((ee,j)=>{this.activePromise.then(Q=>{this.activePromise=null,ee(Q)},Q=>{this.activePromise=null,j(Q)})})}}e.Throttler=m;class a{constructor(){this.current=Promise.resolve(null)}queue(z){return this.current=this.current.then(()=>z(),()=>z())}}e.Sequencer=a;class h{constructor(){this.promiseMap=new Map}queue(z,ee){const Q=(this.promiseMap.get(z)??Promise.resolve()).catch(()=>{}).then(ee).finally(()=>{this.promiseMap.get(z)===Q&&this.promiseMap.delete(z)});return this.promiseMap.set(z,Q),Q}}e.SequencerByKey=h;class p{constructor(z){this.defaultDelay=z,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(z,ee=this.defaultDelay){return this.task=z,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((j,Q)=>{this.doResolve=j,this.doReject=Q}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const j=this.task;return this.task=null,j()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},ee),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,M.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=p;class S{constructor(z){this.delayer=new p(z),this.throttler=new m}trigger(z,ee){return this.delayer.trigger(()=>this.throttler.queue(z),ee)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=S;class w{constructor(){this._isOpen=!1,this._promise=new Promise((z,ee)=>{this._completePromise=z})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=w;class o extends w{constructor(z){super();this._timeout=setTimeout(()=>this.open(),z)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=o;function d($,z){return z?new Promise((ee,j)=>{const Q=setTimeout(()=>{le.dispose(),ee()},$),le=z.onCancellationRequested(()=>{clearTimeout(Q),le.dispose(),j((0,M.canceled)())})}):C(ee=>d($,ee))}e.timeout=d;function _($,z=0){const ee=setTimeout($,z);return(0,P.toDisposable)(()=>clearTimeout(ee))}e.disposableTimeout=_;function c($){const z=[];let ee=0;const j=$.length;function Q(){return ee<j?$[ee++]():null}function le(ve){ve!=null&&z.push(ve);const ue=Q();return ue?ue.then(le):Promise.resolve(z)}return Promise.resolve(null).then(le)}e.sequence=c;function R($,z=j=>!!j,ee=null){let j=0;const Q=$.length,le=()=>{if(j>=Q)return Promise.resolve(ee);const ve=$[j++];return Promise.resolve(ve()).then(Fe=>z(Fe)?Promise.resolve(Fe):le())};return le()}e.first=R;function n($,z=j=>!!j,ee=null){if($.length===0)return Promise.resolve(ee);let j=$.length;const Q=()=>{j=-1;for(const le of $)le.cancel?.()};return new Promise((le,ve)=>{for(const ue of $)ue.then(Fe=>{--j>=0&&z(Fe)?(Q(),le(Fe)):j===0&&le(ee)}).catch(Fe=>{--j>=0&&(Q(),ve(Fe))})})}e.firstParallel=n;class i{constructor(z){this._size=0,this.maxDegreeOfParalellism=z,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new b.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(z){return this._size++,new Promise((ee,j)=>{this.outstandingPromises.push({factory:z,c:ee,e:j}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const z=this.outstandingPromises.shift();this.runningPromises++;const ee=z.factory();ee.then(z.c,z.e),ee.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=i;class g extends i{constructor(){super(1)}}e.Queue=g;class f{constructor(){this.queues=new Map}queueFor(z,ee=t.extUri){const j=ee.getComparisonKey(z);let Q=this.queues.get(j);return Q||(Q=new g,b.Event.once(Q.onFinished)(()=>{Q?.dispose(),this.queues.delete(j)}),this.queues.set(j,Q)),Q}dispose(){this.queues.forEach(z=>z.dispose()),this.queues.clear()}}e.ResourceQueue=f;class s{constructor(z,ee){this._token=-1,typeof z=="function"&&typeof ee=="number"&&this.setIfNotSet(z,ee)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(z,ee){this.cancel(),this._token=setTimeout(()=>{this._token=-1,z()},ee)}setIfNotSet(z,ee){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,z()},ee))}}e.TimeoutTimer=s;class v{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(z,ee){this.cancel(),this._token=setInterval(()=>{z()},ee)}}e.IntervalTimer=v;class l{constructor(z,ee){this.timeoutToken=-1,this.runner=z,this.timeout=ee,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(z=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,z)}get delay(){return this.timeout}set delay(z){this.timeout=z}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=l;class E{constructor(z,ee){ee%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ee}ms is not a multiple of 1000ms.`),this.runner=z,this.timeout=ee,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(z=this.timeout){z%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${z}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(z/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=E;class T extends l{constructor(z,ee){super(z,ee);this.units=[]}work(z){this.units.push(z),this.isScheduled()||this.schedule()}doRun(){const z=this.units;this.units=[],this.runner&&this.runner(z)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=T;class I extends P.Disposable{constructor(z,ee,j,Q){super();this.maxWorkChunkSize=z,this.maxPendingWork=ee,this.throttleDelay=j,this.handler=Q,this.pendingWork=[],this.throttler=this._register(new P.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(z){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+z.length>this.maxPendingWork)return!1}else if(this.pending+z.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...z),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new l(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=I,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=$=>{const z=setTimeout(()=>{const j=Date.now()+15;$(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,j-Date.now())}}))});let ee=!1;return{dispose(){ee||(ee=!0,clearTimeout(z))}}}:e.runWhenIdle=($,z)=>{const ee=requestIdleCallback($,typeof z=="number"?{timeout:z}:void 0);let j=!1;return{dispose(){j||(j=!0,cancelIdleCallback(ee))}}}}();class B{constructor(z){this._didRun=!1,this._executor=()=>{try{this._value=z()}catch(ee){this._error=ee}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=B;async function O($,z,ee){let j;for(let Q=0;Q<ee;Q++)try{return await $()}catch(le){j=le,await d(z)}throw j}e.retry=O;class D{hasPending(z){return this._pending?typeof z=="number"?this._pending.taskId===z:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(z,ee,j){return this._pending={taskId:z,cancel:()=>j?.(),promise:ee},ee.then(()=>this.donePending(z),()=>this.donePending(z)),ee}donePending(z){this._pending&&z===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const z=this._next;this._next=void 0,z.run().then(z.promiseResolve,z.promiseReject)}}setNext(z){if(this._next)this._next.run=z;else{let ee,j;const Q=new Promise((le,ve)=>{ee=le,j=ve});this._next={run:z,promise:Q,promiseResolve:ee,promiseReject:j}}return this._next.promise}}e.TaskSequentializer=D;class x{constructor(z){this.interval=z,this.lastIncrementTime=0,this.value=0}increment(){const z=Date.now();return z-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=z,this.value=0),this.value++,this.value}}e.IntervalCounter=x;class N{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((z,ee)=>{this.completeCallback=z,this.errorCallback=ee})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(z){return new Promise(ee=>{this.completeCallback(z),this.resolved=!0,ee()})}error(z){return new Promise(ee=>{this.errorCallback(z),this.rejected=!0,ee()})}cancel(){new Promise(z=>{this.errorCallback((0,M.canceled)()),this.rejected=!0,z()})}}e.DeferredPromise=N;var V;(function($){async function z(j){let Q;const le=await Promise.all(j.map(ve=>ve.then(ue=>ue,ue=>{Q||(Q=ue)})));if(typeof Q!="undefined")throw Q;return le}$.settled=z;function ee(j){return new Promise(async(Q,le)=>{try{await j(Q,le)}catch(ve){le(ve)}})}$.withAsyncBody=ee})(V=e.Promises||(e.Promises={}))}),define(be[107],Ee([0,1,13,17]),function(re,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const b=new u.IdleValue(()=>{const l=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:l,collatorIsNumeric:l.resolvedOptions().numeric}}),P=new u.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),t=new u.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function A(l,E,T=!1){const I=l||"",B=E||"",O=b.value.collator.compare(I,B);return b.value.collatorIsNumeric&&O===0&&I!==B?I<B?-1:1:O}e.compareFileNames=A;function C(l,E){const T=P.value.collator;return l=l||"",E=E||"",_(T,l,E)}e.compareFileNamesDefault=C;function k(l,E){const T=P.value.collator;return l=l||"",E=E||"",i(l,E)||_(T,l,E)}e.compareFileNamesUpper=k;function F(l,E){const T=P.value.collator;return l=l||"",E=E||"",n(l,E)||_(T,l,E)}e.compareFileNamesLower=F;function y(l,E){return l=l||"",E=E||"",l===E?0:l<E?-1:1}e.compareFileNamesUnicode=y;function r(l,E,T=!1){T||(l=l&&l.toLowerCase(),E=E&&E.toLowerCase());const[I,B]=o(l),[O,D]=o(E);return I!==O?I<O?-1:1:B===D?0:B<D?-1:1}e.noIntlCompareFileNames=r;function m(l,E){const[T,I]=o(l),[B,O]=o(E);let D=b.value.collator.compare(I,O);if(D===0){if(b.value.collatorIsNumeric&&I!==O)return I<O?-1:1;if(D=b.value.collator.compare(T,B),b.value.collatorIsNumeric&&D===0&&T!==B)return T<B?-1:1}return D}e.compareFileExtensions=m;function a(l,E){l=l||"",E=E||"";const T=d(l),I=d(E),B=P.value.collator,O=t.value.collator;return _(O,T,I)||_(B,l,E)}e.compareFileExtensionsDefault=a;function h(l,E){l=l||"",E=E||"";const T=d(l),I=d(E),B=P.value.collator,O=t.value.collator;return _(O,T,I)||i(l,E)||_(B,l,E)}e.compareFileExtensionsUpper=h;function p(l,E){l=l||"",E=E||"";const T=d(l),I=d(E),B=P.value.collator,O=t.value.collator;return _(O,T,I)||n(l,E)||_(B,l,E)}e.compareFileExtensionsLower=p;function S(l,E){l=l||"",E=E||"";const T=d(l).toLowerCase(),I=d(E).toLowerCase();return T!==I?T<I?-1:1:l!==E?l<E?-1:1:0}e.compareFileExtensionsUnicode=S;const w=/^(.*?)(\.([^.]*))?$/;function o(l,E=!1){const T=l?w.exec(l):[];let I=[T&&T[1]||"",T&&T[3]||""];return E&&(!I[0]&&I[1]||I[0]&&I[0].charAt(0)===".")&&(I=[I[0]+"."+I[1],""]),I}function d(l){const E=l?w.exec(l):[];return E&&E[1]&&E[1].charAt(0)!=="."&&E[3]||""}function _(l,E,T){let I=l.compare(E,T);return I!==0?I:E.length!==T.length?E.length<T.length?-1:1:0}function c(l){const E=l.charAt(0);return E.toLocaleUpperCase()!==E}function R(l){const E=l.charAt(0);return E.toLocaleLowerCase()!==E}function n(l,E){return c(l)&&R(E)?-1:R(l)&&c(E)?1:0}function i(l,E){return R(l)&&c(E)?-1:c(l)&&R(E)?1:0}function g(l,E,T=!1){return T||(l=l&&l.toLowerCase(),E=E&&E.toLowerCase()),l===E?0:l<E?-1:1}function f(l,E,T=!1){const I=l.split(M.sep),B=E.split(M.sep),O=I.length-1,D=B.length-1;let x,N;for(let V=0;;V++){if(x=O===V,N=D===V,x&&N)return A(I[V],B[V],T);if(x)return-1;if(N)return 1;const $=g(I[V],B[V],T);if($!==0)return $}}e.comparePaths=f;function s(l,E,T){const I=l.toLowerCase(),B=E.toLowerCase(),O=v(l,E,T);if(O)return O;const D=I.endsWith(T),x=B.endsWith(T);if(D!==x)return D?-1:1;const N=A(I,B);return N!==0?N:I.localeCompare(B)}e.compareAnything=s;function v(l,E,T){const I=l.toLowerCase(),B=E.toLowerCase(),O=I.startsWith(T),D=B.startsWith(T);if(O!==D)return O?-1:1;if(O&&D){if(I.length<B.length)return-1;if(I.length>B.length)return 1}return 0}e.compareByPrefix=v}),define(be[29],Ee([0,1,13,44,20,17,9]),function(re,e,u,M,b,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function A(){return Object.create(null)}e.getEmptyExpression=A;const C="**",k="/",F="[/\\\\]",y="[^/\\\\]",r=/\//g;function m(j){switch(j){case 0:return"";case 1:return`${y}*?`;default:return`(?:${F}|${y}+${F}|${F}${y}+)*?`}}function a(j,Q){if(!j)return[];const le=[];let ve=!1,ue=!1,Fe="";for(const Ke of j){switch(Ke){case Q:if(!ve&&!ue){le.push(Fe),Fe="";continue}break;case"{":ve=!0;break;case"}":ve=!1;break;case"[":ue=!0;break;case"]":ue=!1;break}Fe+=Ke}return Fe&&le.push(Fe),le}e.splitGlobAware=a;function h(j){if(!j)return"";let Q="";const le=a(j,k);if(le.every(ve=>ve===C))Q=".*";else{let ve=!1;le.forEach((ue,Fe)=>{if(ue===C){ve||(Q+=m(2),ve=!0);return}let Ke=!1,Oe="",He=!1,Je="";for(const Ye of ue){if(Ye!=="}"&&Ke){Oe+=Ye;continue}if(He&&(Ye!=="]"||!Je)){let Qe;Ye==="-"?Qe=Ye:(Ye==="^"||Ye==="!")&&!Je?Qe="^":Ye===k?Qe="":Qe=t.escapeRegExpCharacters(Ye),Je+=Qe;continue}switch(Ye){case"{":Ke=!0;continue;case"[":He=!0;continue;case"}":Q+=`(?:${a(Oe,",").map(K=>h(K)).join("|")})`,Ke=!1,Oe="";break;case"]":Q+="["+Je+"]",He=!1,Je="";break;case"?":Q+=y;continue;case"*":Q+=m(1);continue;default:Q+=t.escapeRegExpCharacters(Ye)}}Fe<le.length-1&&(le[Fe+1]!==C||Fe+2<le.length)&&(Q+=F),ve=!1})}return Q}const p=/^\*\*\/\*\.[\w\.-]+$/,S=/^\*\*\/([\w\.-]+)\/?$/,w=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,o=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,d=/^\*\*((\/[\w\.-]+)+)\/?$/,_=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,c=new b.LRUCache(1e4),R=function(){return!1},n=function(){return null};function i(j,Q){if(!j)return n;let le;typeof j!="string"?le=j.pattern:le=j,le=le.trim();const ve=`${le}_${!!Q.trimForExclusions}`;let ue=c.get(ve);if(ue)return g(ue,j);let Fe;if(p.test(le)){const Ke=le.substr(4);ue=function(Oe,He){return typeof Oe=="string"&&Oe.endsWith(Ke)?le:null}}else(Fe=S.exec(f(le,Q)))?ue=s(Fe[1],le):(Q.trimForExclusions?o:w).test(le)?ue=v(le,Q):(Fe=d.exec(f(le,Q)))?ue=l(Fe[1].substr(1),le,!0):(Fe=_.exec(f(le,Q)))?ue=l(Fe[1],le,!1):ue=E(le);return c.set(ve,ue),g(ue,j)}function g(j,Q){return typeof Q=="string"?j:function(le,ve){return M.isEqualOrParent(le,Q.base)?j(P.relative(Q.base,le),ve):null}}function f(j,Q){return Q.trimForExclusions&&j.endsWith("/**")?j.substr(0,j.length-2):j}function s(j,Q){const le=`/${j}`,ve=`\\${j}`,ue=function(Ke,Oe){return typeof Ke!="string"?null:Oe?Oe===j?Q:null:Ke===j||Ke.endsWith(le)||Ke.endsWith(ve)?Q:null},Fe=[j];return ue.basenames=Fe,ue.patterns=[Q],ue.allBasenames=Fe,ue}function v(j,Q){const le=ee(j.slice(1,-1).split(",").map(Oe=>i(Oe,Q)).filter(Oe=>Oe!==n),j),ve=le.length;if(!ve)return n;if(ve===1)return le[0];const ue=function(Oe,He){for(let Je=0,Ye=le.length;Je<Ye;Je++)if(le[Je](Oe,He))return j;return null},Fe=le.find(Oe=>!!Oe.allBasenames);Fe&&(ue.allBasenames=Fe.allBasenames);const Ke=le.reduce((Oe,He)=>He.allPaths?Oe.concat(He.allPaths):Oe,[]);return Ke.length&&(ue.allPaths=Ke),ue}function l(j,Q,le){const ve=P.sep===P.posix.sep,ue=ve?j:j.replace(r,P.sep),Fe=P.sep+ue,Ke=P.posix.sep+j,Oe=le?function(He,Je){return typeof He=="string"&&(He===ue||He.endsWith(Fe)||!ve&&(He===j||He.endsWith(Ke)))?Q:null}:function(He,Je){return typeof He=="string"&&(He===ue||!ve&&He===j)?Q:null};return Oe.allPaths=[(le?"*/":"./")+j],Oe}function E(j){try{const Q=new RegExp(`^${h(j)}$`);return function(le){return Q.lastIndex=0,typeof le=="string"&&Q.test(le)?j:null}}catch(Q){return n}}function T(j,Q,le){return!j||typeof Q!="string"?!1:I(j)(Q,void 0,le)}e.match=T;function I(j,Q={}){if(!j)return R;if(typeof j=="string"||x(j)){const le=i(j,Q);if(le===n)return R;const ve=function(ue,Fe){return!!le(ue,Fe)};return le.allBasenames&&(ve.allBasenames=le.allBasenames),le.allPaths&&(ve.allPaths=le.allPaths),ve}return $(j,Q)}e.parse=I;function B(j){if(!j)return;let Q;return le=>(Q||(Q=(j()||Promise.resolve([])).then(ve=>ve?D(ve):{})),Q.then(ve=>!!ve[le]))}e.hasSiblingPromiseFn=B;function O(j){if(!j)return;let Q;return le=>{if(!Q){const ve=j();Q=ve?D(ve):{}}return!!Q[le]}}e.hasSiblingFn=O;function D(j){const Q={};for(const le of j)Q[le]=!0;return Q}function x(j){const Q=j;return Q&&typeof Q.base=="string"&&typeof Q.pattern=="string"}e.isRelativePattern=x;function N(j){return j.allBasenames||[]}e.getBasenameTerms=N;function V(j){return j.allPaths||[]}e.getPathTerms=V;function $(j,Q){const le=ee(Object.getOwnPropertyNames(j).map(Oe=>z(Oe,j[Oe],Q)).filter(Oe=>Oe!==n)),ve=le.length;if(!ve)return n;if(!le.some(Oe=>!!Oe.requiresSiblings)){if(ve===1)return le[0];const Oe=function(Ye,Qe){for(let W=0,K=le.length;W<K;W++){const X=le[W](Ye,Qe);if(X)return X}return null},He=le.find(Ye=>!!Ye.allBasenames);He&&(Oe.allBasenames=He.allBasenames);const Je=le.reduce((Ye,Qe)=>Qe.allPaths?Ye.concat(Qe.allPaths):Ye,[]);return Je.length&&(Oe.allPaths=Je),Oe}const ue=function(Oe,He,Je){let Ye;for(let Qe=0,W=le.length;Qe<W;Qe++){const K=le[Qe];K.requiresSiblings&&Je&&(He||(He=P.basename(Oe)),Ye||(Ye=He.substr(0,He.length-P.extname(Oe).length)));const X=K(Oe,He,Ye,Je);if(X)return X}return null},Fe=le.find(Oe=>!!Oe.allBasenames);Fe&&(ue.allBasenames=Fe.allBasenames);const Ke=le.reduce((Oe,He)=>He.allPaths?Oe.concat(He.allPaths):Oe,[]);return Ke.length&&(ue.allPaths=Ke),ue}function z(j,Q,le){if(Q===!1)return n;const ve=i(j,le);if(ve===n)return n;if(typeof Q=="boolean")return ve;if(Q){const ue=Q.when;if(typeof ue=="string"){const Fe=(Ke,Oe,He,Je)=>{if(!Je||!ve(Ke,Oe))return null;const Ye=ue.replace("$(basename)",He),Qe=Je(Ye);return(0,u.isThenable)(Qe)?Qe.then(W=>W?j:null):Qe?j:null};return Fe.requiresSiblings=!0,Fe}}return ve}function ee(j,Q){const le=j.filter(Oe=>!!Oe.basenames);if(le.length<2)return j;const ve=le.reduce((Oe,He)=>{const Je=He.basenames;return Je?Oe.concat(Je):Oe},[]);let ue;if(Q){ue=[];for(let Oe=0,He=ve.length;Oe<He;Oe++)ue.push(Q)}else ue=le.reduce((Oe,He)=>{const Je=He.patterns;return Je?Oe.concat(Je):Oe},[]);const Fe=function(Oe,He){if(typeof Oe!="string")return null;if(!He){let Ye;for(Ye=Oe.length;Ye>0;Ye--){const Qe=Oe.charCodeAt(Ye-1);if(Qe===47||Qe===92)break}He=Oe.substr(Ye)}const Je=ve.indexOf(He);return Je!==-1?ue[Je]:null};Fe.basenames=ve,Fe.patterns=ue,Fe.allBasenames=ve;const Ke=j.filter(Oe=>!Oe.basenames);return Ke.push(Fe),Ke}}),define(be[78],Ee([0,1,44,11,17,25,24,9,2]),function(re,e,u,M,b,P,t,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function k(i,g,f){if(typeof i=="string"&&(i=C.URI.file(i)),f){const v=f.getWorkspaceFolder(i);if(v){const l=f.getWorkspace().folders.length>1;let E;if((0,t.isEqual)(v.uri,i)?E="":E=(0,t.relativePath)(v.uri,i),l){const T=v.name?v.name:(0,t.basename)(v.uri);E=E?T+" \u2022 "+E:T}return E}}if(i.scheme!==M.Schemas.file&&i.scheme!==M.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,u.hasDriveLetter)(i.fsPath))return(0,b.normalize)(y(i.fsPath));let s=(0,b.normalize)(i.fsPath);return!P.isWindows&&g?.userHome&&(s=m(s,g.userHome.fsPath)),s}e.getPathLabel=k;function F(i){if(!i)return;typeof i=="string"&&(i=C.URI.file(i));const g=(0,t.basename)(i)||(i.scheme===M.Schemas.file?i.fsPath:i.path);return P.isWindows&&(0,u.isRootOrDriveLetter)(g)?y(g):g}e.getBaseLabel=F;function y(i,g){return(0,u.hasDriveLetter)(i,g)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=y;let r=Object.create(null);function m(i,g){if(P.isWindows||!i||!g)return i;let f=r.original===g?r.normalized:void 0;return f||(f=`${(0,A.rtrim)(g,b.posix.sep)}${b.posix.sep}`,r={original:g,normalized:f}),(P.isLinux?i.startsWith(f):(0,A.startsWithIgnoreCase)(i,f))&&(i=`~/${i.substr(f.length)}`),i}e.tildify=m;function a(i,g){return i.replace(/^~($|\/|\\)/,`${g}$1`)}e.untildify=a;const h="\u2026",p="\\\\",S="~";function w(i,g=b.sep){const f=new Array(i.length);let s=!1;for(let v=0;v<i.length;v++){let l=i[v];if(l===""){f[v]=`.${g}`;continue}if(!l){f[v]=l;continue}s=!0;let E="";l.indexOf(p)===0?(E=l.substr(0,l.indexOf(p)+p.length),l=l.substr(l.indexOf(p)+p.length)):l.indexOf(g)===0?(E=l.substr(0,l.indexOf(g)+g.length),l=l.substr(l.indexOf(g)+g.length)):l.indexOf(S)===0&&(E=l.substr(0,l.indexOf(S)+S.length),l=l.substr(l.indexOf(S)+S.length));const T=l.split(g);for(let I=1;s&&I<=T.length;I++)for(let B=T.length-I;s&&B>=0;B--){s=!1;let O=T.slice(B,B+I).join(g);for(let D=0;!s&&D<i.length;D++)if(D!==v&&i[D]&&i[D].indexOf(O)>-1){const x=B+I===T.length,N=B>0&&i[D].indexOf(g)>-1?g+O:O,V=i[D].endsWith(N);s=!x||V}if(!s){let D="";(T[0].endsWith(":")||E!=="")&&(B===1&&(B=0,I++,O=T[0]+g+O),B>0&&(D=T[0]+g),D=E+D),B>0&&(D=D+h+g),D=D+O,B+I<T.length&&(D=D+g+h),f[v]=D}}s&&(f[v]=l)}return f}e.shorten=w;var o;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(o||(o={}));function d(i,g=Object.create(null)){const f=[];let s=!1,v="";for(const l of i)if(l==="$"||s&&l==="{")v&&f.push({value:v,type:o.TEXT}),v="",s=!0;else if(l==="}"&&s){const E=g[v];if(typeof E=="string")E.length&&f.push({value:E,type:o.VARIABLE});else if(E){const T=f[f.length-1];(!T||T.type!==o.SEPARATOR)&&f.push({value:E.label,type:o.SEPARATOR})}v="",s=!1}else v+=l;return v&&!s&&f.push({value:v,type:o.TEXT}),f.filter((l,E)=>{if(l.type===o.SEPARATOR){const T=f[E-1],I=f[E+1];return[T,I].every(B=>B&&(B.type===o.VARIABLE||B.type===o.TEXT)&&B.value.length>0)}return!0}).map(l=>l.value).join("")}e.template=d;function _(i,g){return P.isMacintosh||g?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,P.isMacintosh?"&":"&&"):i.replace(/&&|&/g,f=>f==="&"?"&&":"&")}e.mnemonicMenuLabel=_;function c(i,g){return P.isMacintosh||g?i.replace(/\(&&\w\)|&&/g,""):P.isWindows?i.replace(/&&|&/g,f=>f==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=c;function R(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=R;function n(i){const g=i.indexOf("/")!==-1?b.posix:b.win32,f=g.basename(i),s=g.dirname(i);return f.length?{name:f,parentPath:s}:{name:s,parentPath:""}}e.splitName=n}),define(be[79],Ee([0,1,29,11,17,24,9]),function(re,e,u,M,b,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var A;(function(i){i.text="text/plain",i.binary="application/octet-stream",i.unknown="application/unknown",i.markdown="text/markdown",i.latex="text/latex"})(A=e.Mimes||(e.Mimes={}));let C=[],k=[],F=[];function y(i,g=!1){const f=r(i);C.push(f),f.userConfigured?F.push(f):k.push(f),g&&!f.userConfigured&&C.forEach(s=>{s.mime===f.mime||s.userConfigured||(f.extension&&s.extension===f.extension&&console.warn(`Overwriting extension <<${f.extension}>> to now point to mime <<${f.mime}>>`),f.filename&&s.filename===f.filename&&console.warn(`Overwriting filename <<${f.filename}>> to now point to mime <<${f.mime}>>`),f.filepattern&&s.filepattern===f.filepattern&&console.warn(`Overwriting filepattern <<${f.filepattern}>> to now point to mime <<${f.mime}>>`),f.firstline&&s.firstline===f.firstline&&console.warn(`Overwriting firstline <<${f.firstline}>> to now point to mime <<${f.mime}>>`))})}e.registerTextMime=y;function r(i){return{id:i.id,mime:i.mime,filename:i.filename,extension:i.extension,filepattern:i.filepattern,firstline:i.firstline,userConfigured:i.userConfigured,filenameLowercase:i.filename?i.filename.toLowerCase():void 0,extensionLowercase:i.extension?i.extension.toLowerCase():void 0,filepatternLowercase:i.filepattern?(0,u.parse)(i.filepattern.toLowerCase()):void 0,filepatternOnPath:i.filepattern?i.filepattern.indexOf(b.posix.sep)>=0:!1}}function m(i){i?(C=C.filter(g=>!g.userConfigured),F=[]):(C=[],k=[],F=[])}e.clearTextMimes=m;function a(i,g){let f;if(i)switch(i.scheme){case M.Schemas.file:f=i.fsPath;break;case M.Schemas.data:f=P.DataUri.parseMetaData(i).get(P.DataUri.META_DATA_LABEL);break;default:f=i.path}if(!f)return[A.unknown];f=f.toLowerCase();const s=(0,b.basename)(f),v=h(f,s,F);if(v)return[v,A.text];const l=h(f,s,k);if(l)return[l,A.text];if(g){const E=p(g);if(E)return[E,A.text]}return[A.unknown]}e.guessMimeTypes=a;function h(i,g,f){let s=null,v=null,l=null;for(let E=f.length-1;E>=0;E--){const T=f[E];if(g===T.filenameLowercase){s=T;break}if(T.filepattern&&(!v||T.filepattern.length>v.filepattern.length)){const I=T.filepatternOnPath?i:g;T.filepatternLowercase?.(I)&&(v=T)}T.extension&&(!l||T.extension.length>l.extension.length)&&g.endsWith(T.extensionLowercase)&&(l=T)}return s?s.mime:v?v.mime:l?l.mime:null}function p(i){if((0,t.startsWithUTF8BOM)(i)&&(i=i.substr(1)),i.length>0)for(let g=C.length-1;g>=0;g--){const f=C[g];if(!f.firstline)continue;const s=i.match(f.firstline);if(s&&s.length>0)return f.mime}return null}function S(i){return i?typeof i=="string"?i===A.binary||i===A.text||i===A.unknown:i.length===1&&S(i[0]):!0}e.isUnspecific=S;const w={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},o={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function d(i){const g=(0,b.extname)(i),f=w[g.toLowerCase()];return f!==void 0?f:_(i)}e.getMediaOrTextMime=d;function _(i){const g=(0,b.extname)(i);return o[g.toLowerCase()]}e.getMediaMime=_;function c(i){for(const g in o)if(o[g]===i)return g}e.getExtensionForMimeType=c;const R=/^(.+)\/(.+?)(;.+)?$/;function n(i,g){const f=R.exec(i);return f?`${f[1].toLowerCase()}/${f[2].toLowerCase()}${f[3]??""}`:g?void 0:i}e.normalizeMimeType=n}),define(be[108],Ee([0,1,2]),function(re,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function M(F){return F.toJSON()}class b{constructor(y){this._uriTransformer=y}transformIncoming(y){const r=this._uriTransformer.transformIncoming(y);return r===y?y:M(u.URI.from(r))}transformOutgoing(y){const r=this._uriTransformer.transformOutgoing(y);return r===y?y:M(u.URI.from(r))}transformOutgoingURI(y){const r=this._uriTransformer.transformOutgoing(y);return r===y?y:u.URI.from(r)}transformOutgoingScheme(y){return this._uriTransformer.transformOutgoingScheme(y)}}e.URITransformer=b,e.DefaultURITransformer=new class{transformIncoming(F){return F}transformOutgoing(F){return F}transformOutgoingURI(F){return F}transformOutgoingScheme(F){return F}};function P(F,y,r){if(!F||r>200)return null;if(typeof F=="object"){if(F instanceof u.URI)return y.transformOutgoing(F);for(let m in F)if(Object.hasOwnProperty.call(F,m)){const a=P(F[m],y,r+1);a!==null&&(F[m]=a)}}return null}function t(F,y){const r=P(F,y,0);return r===null?F:r}e.transformOutgoingURIs=t;function A(F,y,r,m){if(!F||m>200)return null;if(typeof F=="object"){if(F.$mid===1)return r?u.URI.revive(y.transformIncoming(F)):y.transformIncoming(F);for(let a in F)if(Object.hasOwnProperty.call(F,a)){const h=A(F[a],y,r,m+1);h!==null&&(F[a]=h)}}return null}function C(F,y){const r=A(F,y,!1,0);return r===null?F:r}e.transformIncomingURIs=C;function k(F,y){const r=A(F,y,!0,0);return r===null?F:r}e.transformAndReviveIncomingURIs=k}),define(be[37],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const u=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function M(C){return u.test(C)}e.isUUID=M;const b=new Uint8Array(16),P=[];for(let C=0;C<256;C++)P.push(C.toString(16).padStart(2,"0"));let t;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?t=crypto.getRandomValues.bind(crypto):t=function(C){for(let k=0;k<C.length;k++)C[k]=Math.floor(Math.random()*256);return C};function A(){t(b),b[6]=b[6]&15|64,b[8]=b[8]&63|128;let C=0,k="";return k+=P[b[C++]],k+=P[b[C++]],k+=P[b[C++]],k+=P[b[C++]],k+="-",k+=P[b[C++]],k+=P[b[C++]],k+="-",k+=P[b[C++]],k+=P[b[C++]],k+="-",k+=P[b[C++]],k+=P[b[C++]],k+="-",k+=P[b[C++]],k+=P[b[C++]],k+=P[b[C++]],k+=P[b[C++]],k+=P[b[C++]],k+=P[b[C++]],k}e.generateUuid=A}),define(be[109],Ee([0,1,231]),function(re,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var M;(function(t){t[t.Regular=0]="Regular",t[t.Whitespace=1]="Whitespace",t[t.WordSeparator=2]="WordSeparator"})(M=e.WordCharacterClass||(e.WordCharacterClass={}));class b extends u.CharacterClassifier{constructor(A){super(0);for(let C=0,k=A.length;C<k;C++)this.set(A.charCodeAt(C),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=b;function P(t){let A={};return C=>(A.hasOwnProperty(C)||(A[C]=t(C)),A[C])}e.getMapForWordSeparators=P(t=>new b(t))}),define(be[80],Ee([0,1,23]),function(re,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.IndentGuideHorizontalLine=e.IndentGuide=e.HorizontalGuidesState=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var M;(function(w){w[w.Left=1]="Left",w[w.Center=2]="Center",w[w.Right=4]="Right",w[w.Full=7]="Full"})(M=e.OverviewRulerLane||(e.OverviewRulerLane={}));var b;(function(w){w[w.Inline=1]="Inline",w[w.Gutter=2]="Gutter"})(b=e.MinimapPosition||(e.MinimapPosition={}));var P;(function(w){w[w.TextDefined=0]="TextDefined",w[w.LF=1]="LF",w[w.CRLF=2]="CRLF"})(P=e.EndOfLinePreference||(e.EndOfLinePreference={}));var t;(function(w){w[w.LF=1]="LF",w[w.CRLF=2]="CRLF"})(t=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var A;(function(w){w[w.LF=0]="LF",w[w.CRLF=1]="CRLF"})(A=e.EndOfLineSequence||(e.EndOfLineSequence={}));class C{constructor(o){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,o.tabSize|0),this.indentSize=o.tabSize|0,this.insertSpaces=Boolean(o.insertSpaces),this.defaultEOL=o.defaultEOL|0,this.trimAutoWhitespace=Boolean(o.trimAutoWhitespace),this.bracketPairColorizationOptions=o.bracketPairColorizationOptions}equals(o){return this.tabSize===o.tabSize&&this.indentSize===o.indentSize&&this.insertSpaces===o.insertSpaces&&this.defaultEOL===o.defaultEOL&&this.trimAutoWhitespace===o.trimAutoWhitespace&&(0,u.equals)(this.bracketPairColorizationOptions,o.bracketPairColorizationOptions)}createChangeEvent(o){return{tabSize:this.tabSize!==o.tabSize,indentSize:this.indentSize!==o.indentSize,insertSpaces:this.insertSpaces!==o.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==o.trimAutoWhitespace}}}e.TextModelResolvedOptions=C;class k{constructor(o,d){this._findMatchBrand=void 0,this.range=o,this.matches=d}}e.FindMatch=k;var F;(function(w){w[w.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",w[w.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",w[w.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",w[w.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(F=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var y;(function(w){w[w.Disabled=0]="Disabled",w[w.EnabledForActive=1]="EnabledForActive",w[w.Enabled=2]="Enabled"})(y=e.HorizontalGuidesState||(e.HorizontalGuidesState={}));class r{constructor(o,d,_){this.visibleColumn=o,this.className=d,this.horizontalLine=_}}e.IndentGuide=r;class m{constructor(o,d){this.top=o,this.endColumn=d}}e.IndentGuideHorizontalLine=m;var a;(function(w){w[w.Left=0]="Left",w[w.Right=1]="Right",w[w.None=2]="None"})(a=e.PositionAffinity||(e.PositionAffinity={}));var h;(function(w){w[w.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(h=e.ModelConstants||(e.ModelConstants={}));class p{constructor(o,d,_,c,R,n){this.identifier=o,this.range=d,this.text=_,this.forceMoveMarkers=c,this.isAutoWhitespaceEdit=R,this._isTracked=n}}e.ValidAnnotatedEditOperation=p;class S{constructor(o,d,_){this.reverseEdits=o,this.changes=d,this.trimAutoWhitespaceLineNumbers=_}}e.ApplyEditsResult=S}),define(be[110],Ee([0,1,9,109,111,45,80]),function(re,e,u,M,b,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const A=999;class C{constructor(o,d,_,c){this.searchString=o,this.isRegex=d,this.matchCase=_,this.wordSeparators=c}parseSearchRequest(){if(this.searchString==="")return null;let o;this.isRegex?o=k(this.searchString):o=this.searchString.indexOf(`
`)>=0;let d=null;try{d=u.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:o,global:!0,unicode:!0})}catch(c){return null}if(!d)return null;let _=!this.isRegex&&!o;return _&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(_=this.matchCase),new F(d,this.wordSeparators?(0,M.getMapForWordSeparators)(this.wordSeparators):null,_?this.searchString:null)}}e.SearchParams=C;function k(w){if(!w||w.length===0)return!1;for(let o=0,d=w.length;o<d;o++)if(w.charCodeAt(o)===92){if(o++,o>=d)break;const c=w.charCodeAt(o);if(c===110||c===114||c===87)return!0}return!1}e.isMultilineRegexSource=k;class F{constructor(o,d,_){this.regex=o,this.wordSeparators=d,this.simpleSearch=_}}e.SearchData=F;function y(w,o,d){if(!d)return new t.FindMatch(w,null);let _=[];for(let c=0,R=o.length;c<R;c++)_[c]=o[c];return new t.FindMatch(w,_)}e.createFindMatch=y;class r{constructor(o){let d=[],_=0;for(let c=0,R=o.length;c<R;c++)o.charCodeAt(c)===10&&(d[_++]=c);this._lineFeedsOffsets=d}findLineFeedCountBeforeOffset(o){const d=this._lineFeedsOffsets;let _=0,c=d.length-1;if(c===-1||o<=d[0])return 0;for(;_<c;){const R=_+((c-_)/2>>0);d[R]>=o?c=R-1:d[R+1]>=o?(_=R,c=R):_=R+1}return _+1}}class m{static findMatches(o,d,_,c,R){const n=d.parseSearchRequest();return n?n.regex.multiline?this._doFindMatchesMultiline(o,_,new S(n.wordSeparators,n.regex),c,R):this._doFindMatchesLineByLine(o,_,n,c,R):[]}static _getMultilineMatchRange(o,d,_,c,R,n){let i,g=0;c?(g=c.findLineFeedCountBeforeOffset(R),i=d+R+g):i=d+R;let f;if(c){let E=c.findLineFeedCountBeforeOffset(R+n.length)-g;f=i+n.length+E}else f=i+n.length;const s=o.getPositionAt(i),v=o.getPositionAt(f);return new P.Range(s.lineNumber,s.column,v.lineNumber,v.column)}static _doFindMatchesMultiline(o,d,_,c,R){const n=o.getOffsetAt(d.getStartPosition()),i=o.getValueInRange(d,1),g=o.getEOL()===`\r
`?new r(i):null,f=[];let s=0,v;for(_.reset(0);v=_.next(i);)if(f[s++]=y(this._getMultilineMatchRange(o,n,i,g,v.index,v[0]),v,c),s>=R)return f;return f}static _doFindMatchesLineByLine(o,d,_,c,R){const n=[];let i=0;if(d.startLineNumber===d.endLineNumber){const f=o.getLineContent(d.startLineNumber).substring(d.startColumn-1,d.endColumn-1);return i=this._findMatchesInLine(_,f,d.startLineNumber,d.startColumn-1,i,n,c,R),n}const g=o.getLineContent(d.startLineNumber).substring(d.startColumn-1);i=this._findMatchesInLine(_,g,d.startLineNumber,d.startColumn-1,i,n,c,R);for(let f=d.startLineNumber+1;f<d.endLineNumber&&i<R;f++)i=this._findMatchesInLine(_,o.getLineContent(f),f,0,i,n,c,R);if(i<R){const f=o.getLineContent(d.endLineNumber).substring(0,d.endColumn-1);i=this._findMatchesInLine(_,f,d.endLineNumber,0,i,n,c,R)}return n}static _findMatchesInLine(o,d,_,c,R,n,i,g){const f=o.wordSeparators;if(!i&&o.simpleSearch){const l=o.simpleSearch,E=l.length,T=d.length;let I=-E;for(;(I=d.indexOf(l,I+E))!==-1;)if((!f||p(f,d,T,I,E))&&(n[R++]=new t.FindMatch(new P.Range(_,I+1+c,_,I+1+E+c),null),R>=g))return R;return R}const s=new S(o.wordSeparators,o.regex);let v;s.reset(0);do if(v=s.next(d),v&&(n[R++]=y(new P.Range(_,v.index+1+c,_,v.index+1+v[0].length+c),v,i),R>=g))return R;while(v);return R}static findNextMatch(o,d,_,c){const R=d.parseSearchRequest();if(!R)return null;const n=new S(R.wordSeparators,R.regex);return R.regex.multiline?this._doFindNextMatchMultiline(o,_,n,c):this._doFindNextMatchLineByLine(o,_,n,c)}static _doFindNextMatchMultiline(o,d,_,c){const R=new b.Position(d.lineNumber,1),n=o.getOffsetAt(R),i=o.getLineCount(),g=o.getValueInRange(new P.Range(R.lineNumber,R.column,i,o.getLineMaxColumn(i)),1),f=o.getEOL()===`\r
`?new r(g):null;_.reset(d.column-1);let s=_.next(g);return s?y(this._getMultilineMatchRange(o,n,g,f,s.index,s[0]),s,c):d.lineNumber!==1||d.column!==1?this._doFindNextMatchMultiline(o,new b.Position(1,1),_,c):null}static _doFindNextMatchLineByLine(o,d,_,c){const R=o.getLineCount(),n=d.lineNumber,i=o.getLineContent(n),g=this._findFirstMatchInLine(_,i,n,d.column,c);if(g)return g;for(let f=1;f<=R;f++){const s=(n+f-1)%R,v=o.getLineContent(s+1),l=this._findFirstMatchInLine(_,v,s+1,1,c);if(l)return l}return null}static _findFirstMatchInLine(o,d,_,c,R){o.reset(c-1);const n=o.next(d);return n?y(new P.Range(_,n.index+1,_,n.index+1+n[0].length),n,R):null}static findPreviousMatch(o,d,_,c){const R=d.parseSearchRequest();if(!R)return null;const n=new S(R.wordSeparators,R.regex);return R.regex.multiline?this._doFindPreviousMatchMultiline(o,_,n,c):this._doFindPreviousMatchLineByLine(o,_,n,c)}static _doFindPreviousMatchMultiline(o,d,_,c){const R=this._doFindMatchesMultiline(o,new P.Range(1,1,d.lineNumber,d.column),_,c,10*A);if(R.length>0)return R[R.length-1];const n=o.getLineCount();return d.lineNumber!==n||d.column!==o.getLineMaxColumn(n)?this._doFindPreviousMatchMultiline(o,new b.Position(n,o.getLineMaxColumn(n)),_,c):null}static _doFindPreviousMatchLineByLine(o,d,_,c){const R=o.getLineCount(),n=d.lineNumber,i=o.getLineContent(n).substring(0,d.column-1),g=this._findLastMatchInLine(_,i,n,c);if(g)return g;for(let f=1;f<=R;f++){const s=(R+n-f-1)%R,v=o.getLineContent(s+1),l=this._findLastMatchInLine(_,v,s+1,c);if(l)return l}return null}static _findLastMatchInLine(o,d,_,c){let R=null,n;for(o.reset(0);n=o.next(d);)R=y(new P.Range(_,n.index+1,_,n.index+1+n[0].length),n,c);return R}}e.TextModelSearch=m;function a(w,o,d,_,c){if(_===0)return!0;const R=o.charCodeAt(_-1);if(w.get(R)!==0||R===13||R===10)return!0;if(c>0){const n=o.charCodeAt(_);if(w.get(n)!==0)return!0}return!1}function h(w,o,d,_,c){if(_+c===d)return!0;const R=o.charCodeAt(_+c);if(w.get(R)!==0||R===13||R===10)return!0;if(c>0){const n=o.charCodeAt(_+c-1);if(w.get(n)!==0)return!0}return!1}function p(w,o,d,_,c){return a(w,o,d,_,c)&&h(w,o,d,_,c)}e.isValidMatch=p;class S{constructor(o,d){this._wordSeparators=o,this._searchRegex=d,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(o){this._searchRegex.lastIndex=o,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(o){const d=o.length;let _;do{if(this._prevMatchStartIndex+this._prevMatchLength===d||(_=this._searchRegex.exec(o),!_))return null;const c=_.index,R=_[0].length;if(c===this._prevMatchStartIndex&&R===this._prevMatchLength){if(R===0){u.getNextCodePoint(o,d,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=c,this._prevMatchLength=R,!this._wordSeparators||p(this._wordSeparators,o,d,c,R))return _}while(_);return null}}e.Searcher=S}),define(be[112],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var u;(function(t){t[t.None=0]="None",t[t.Indent=1]="Indent",t[t.IndentOutdent=2]="IndentOutdent",t[t.Outdent=3]="Outdent"})(u=e.IndentAction||(e.IndentAction={}));class M{constructor(A){if(this._standardAutoClosingPairConditionalBrand=void 0,this.open=A.open,this.close=A.close,this._standardTokenMask=0,Array.isArray(A.notIn))for(let C=0,k=A.notIn.length;C<k;C++)switch(A.notIn[C]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(A){return(this._standardTokenMask&A)==0}}e.StandardAutoClosingPairConditional=M;class b{constructor(A){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const C of A)P(this.autoClosingPairsOpenByStart,C.open.charAt(0),C),P(this.autoClosingPairsOpenByEnd,C.open.charAt(C.open.length-1),C),P(this.autoClosingPairsCloseByStart,C.close.charAt(0),C),P(this.autoClosingPairsCloseByEnd,C.close.charAt(C.close.length-1),C),C.close.length===1&&C.open.length===1&&P(this.autoClosingPairsCloseSingleChar,C.close,C)}}e.AutoClosingPairs=b;function P(t,A,C){t.has(A)?t.get(A).push(C):t.set(A,[C])}}),define(be[58],Ee([0,1,29,17]),function(re,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function b(P,t,A,C){if(Array.isArray(P)){let k=0;for(const F of P){const y=b(F,t,A,C);if(y===10)return y;y>k&&(k=y)}return k}else{if(typeof P=="string")return C?P==="*"?5:P===A?10:0:0;if(P){const{language:k,pattern:F,scheme:y,hasAccessToAllModels:r}=P;if(!C&&!r)return 0;let m=0;if(y)if(y===t.scheme)m=10;else if(y==="*")m=5;else return 0;if(k)if(k===A)m=10;else if(k==="*")m=Math.max(m,5);else return 0;if(F){let a;if(typeof F=="string"?a=F:a={...F,base:(0,M.normalize)(F.base)},a===t.fsPath||(0,u.match)(a,t.fsPath))m=10;else return 0}return m}else return 0}}e.score=b}),define(be[113],Ee([0,1,3,6]),function(re,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class b{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new u.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(t){this._onDidChange.fire({changedLanguages:t,changedColorMap:!1})}register(t,A){return this._map.set(t,A),this.fire([t]),(0,M.toDisposable)(()=>{this._map.get(t)===A&&(this._map.delete(t),this.fire([t]))})}registerPromise(t,A){let C=null,k=!1;return this._promises.set(t,A.then(F=>{this._promises.delete(t),!(k||!F)&&(C=this.register(t,F))})),(0,M.toDisposable)(()=>{k=!0,C&&C.dispose()})}getPromise(t){const A=this.get(t);if(A)return Promise.resolve(A);const C=this._promises.get(t);return C?C.then(k=>this.get(t)):null}get(t){return this._map.get(t)||null}setColorMap(t){this._colorMap=t,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=b}),define(be[81],Ee([0,1,22,25]),function(re,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var b;(function(y){y[y.Full=1]="Full",y[y.Delta=2]="Delta"})(b||(b={}));function P(y){for(let r=0,m=y.length;r<m;r+=4){const a=y[r+0],h=y[r+1],p=y[r+2],S=y[r+3];y[r+0]=S,y[r+1]=p,y[r+2]=h,y[r+3]=a}}function t(y){const r=new Uint8Array(y.buffer,y.byteOffset,y.length*4);return M.isLittleEndian()||P(r),u.VSBuffer.wrap(r)}function A(y){const r=y.buffer;if(M.isLittleEndian()||P(r),r.byteOffset%4==0)return new Uint32Array(r.buffer,r.byteOffset,r.length/4);{const m=new Uint8Array(r.byteLength);return m.set(r),new Uint32Array(m.buffer,m.byteOffset,m.length/4)}}function C(y){const r=new Uint32Array(k(y));let m=0;if(r[m++]=y.id,y.type==="full")r[m++]=1,r[m++]=y.data.length,r.set(y.data,m),m+=y.data.length;else{r[m++]=2,r[m++]=y.deltas.length;for(const a of y.deltas)r[m++]=a.start,r[m++]=a.deleteCount,a.data?(r[m++]=a.data.length,r.set(a.data,m),m+=a.data.length):r[m++]=0}return t(r)}e.encodeSemanticTokensDto=C;function k(y){let r=0;if(r+=1+1,y.type==="full")r+=1+y.data.length;else{r+=1,r+=(1+1+1)*y.deltas.length;for(const m of y.deltas)m.data&&(r+=m.data.length)}return r}function F(y){const r=A(y);let m=0;const a=r[m++];if(r[m++]===1){const w=r[m++],o=r.subarray(m,m+w);return m+=w,{id:a,type:"full",data:o}}const p=r[m++];let S=[];for(let w=0;w<p;w++){const o=r[m++],d=r[m++],_=r[m++];let c;_>0&&(c=r.subarray(m,m+_),m+=_),S[w]={start:o,deleteCount:d,data:c}}return{id:a,type:"delta",deltas:S}}e.decodeSemanticTokensDto=F}),define(be[114],Ee([18,19]),function(re,e){return re.create("vs/base/common/date",e)}),define(be[115],Ee([0,1,114]),function(re,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const M=60,b=M*60,P=b*24,t=P*7,A=P*30,C=P*365;function k(y,r){typeof y!="number"&&(y=y.getTime());const m=Math.round((new Date().getTime()-y)/1e3);if(m<-30)return(0,u.localize)(0,null,k(new Date().getTime()+m*1e3,!1));if(m<30)return(0,u.localize)(1,null);let a;return m<M?(a=m,r?a===1?(0,u.localize)(2,null,a):(0,u.localize)(3,null,a):a===1?(0,u.localize)(4,null,a):(0,u.localize)(5,null,a)):m<b?(a=Math.floor(m/M),r?a===1?(0,u.localize)(6,null,a):(0,u.localize)(7,null,a):a===1?(0,u.localize)(8,null,a):(0,u.localize)(9,null,a)):m<P?(a=Math.floor(m/b),r?a===1?(0,u.localize)(10,null,a):(0,u.localize)(11,null,a):a===1?(0,u.localize)(12,null,a):(0,u.localize)(13,null,a)):m<t?(a=Math.floor(m/P),r?a===1?(0,u.localize)(14,null,a):(0,u.localize)(15,null,a):a===1?(0,u.localize)(16,null,a):(0,u.localize)(17,null,a)):m<A?(a=Math.floor(m/t),r?a===1?(0,u.localize)(18,null,a):(0,u.localize)(19,null,a):a===1?(0,u.localize)(20,null,a):(0,u.localize)(21,null,a)):m<C?(a=Math.floor(m/A),r?a===1?(0,u.localize)(22,null,a):(0,u.localize)(23,null,a):a===1?(0,u.localize)(24,null,a):(0,u.localize)(25,null,a)):(a=Math.floor(m/C),r?a===1?(0,u.localize)(26,null,a):(0,u.localize)(27,null,a):a===1?(0,u.localize)(28,null,a):(0,u.localize)(29,null,a))}e.fromNow=k;function F(y){return y.getFullYear()+"-"+String(y.getMonth()+1).padStart(2,"0")+"-"+String(y.getDate()).padStart(2,"0")+"T"+String(y.getHours()).padStart(2,"0")+":"+String(y.getMinutes()).padStart(2,"0")+":"+String(y.getSeconds()).padStart(2,"0")+"."+(y.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=F}),define(be[116],Ee([18,19]),function(re,e){return re.create("vs/base/common/errorMessage",e)}),define(be[46],Ee([0,1,15,10,116]),function(re,e,u,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function P(k,F){return F&&(k.stack||k.stacktrace)?b.localize(0,null,A(k),t(k.stack)||t(k.stacktrace)):A(k)}function t(k){return Array.isArray(k)?k.join(`
`):k}function A(k){return typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?b.localize(1,null,k.message):k.message||b.localize(2,null)}function C(k=null,F=!1){if(!k)return b.localize(3,null);if(Array.isArray(k)){const y=u.coalesce(k),r=C(y[0],F);return y.length>1?b.localize(4,null,r,y.length):r}if(M.isString(k))return k;if(k.detail){const y=k.detail;if(y.error)return P(y.error,F);if(y.exception)return P(y.exception,F)}return k.stack?P(k,F):k.message?k.message:b.localize(5,null)}e.toErrorMessage=C}),define(be[117],Ee([18,19]),function(re,e){return re.create("vs/editor/common/config/editorOptions",e)}),define(be[118],Ee([0,1,117,25,119]),function(re,e,u,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var P;(function(q){q[q.None=0]="None",q[q.Keep=1]="Keep",q[q.Brackets=2]="Brackets",q[q.Advanced=3]="Advanced",q[q.Full=4]="Full"})(P=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class t{constructor(J){this._values=J}hasChanged(J){return this._values[J]}}e.ConfigurationChangedEvent=t;class A{constructor(){this._values=[]}_read(J){return this._values[J]}get(J){return this._values[J]}_write(J,pe){this._values[J]=pe}}e.ValidatedEditorOptions=A;class C{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=C;class k{constructor(J,pe,$e,qe){this.id=J,this.name=pe,this.defaultValue=$e,this.schema=qe}compute(J,pe,$e){return $e}}class F{constructor(J,pe=null){this.schema=void 0,this.id=J,this.name="_never_",this.defaultValue=void 0,this.deps=pe}validate(J){return this.defaultValue}}class y{constructor(J,pe,$e,qe){this.id=J,this.name=pe,this.defaultValue=$e,this.schema=qe}validate(J){return typeof J=="undefined"?this.defaultValue:J}compute(J,pe,$e){return $e}}function r(q,J){return typeof q=="undefined"?J:q==="false"?!1:Boolean(q)}e.boolean=r;class m extends y{constructor(J,pe,$e,qe=void 0){typeof qe!="undefined"&&(qe.type="boolean",qe.default=$e),super(J,pe,$e,qe)}validate(J){return r(J,this.defaultValue)}}function a(q,J,pe,$e){if(typeof q=="undefined")return J;let qe=parseInt(q,10);return isNaN(qe)?J:(qe=Math.max(pe,qe),qe=Math.min($e,qe),qe|0)}e.clampedInt=a;class h extends y{constructor(J,pe,$e,qe,rt,ft=void 0){typeof ft!="undefined"&&(ft.type="integer",ft.default=$e,ft.minimum=qe,ft.maximum=rt),super(J,pe,$e,ft),this.minimum=qe,this.maximum=rt}static clampedInt(J,pe,$e,qe){return a(J,pe,$e,qe)}validate(J){return h.clampedInt(J,this.defaultValue,this.minimum,this.maximum)}}class p extends y{constructor(J,pe,$e,qe,rt){typeof rt!="undefined"&&(rt.type="number",rt.default=$e),super(J,pe,$e,rt),this.validationFn=qe}static clamp(J,pe,$e){return J<pe?pe:J>$e?$e:J}static float(J,pe){if(typeof J=="number")return J;if(typeof J=="undefined")return pe;const $e=parseFloat(J);return isNaN($e)?pe:$e}validate(J){return this.validationFn(p.float(J,this.defaultValue))}}class S extends y{static string(J,pe){return typeof J!="string"?pe:J}constructor(J,pe,$e,qe=void 0){typeof qe!="undefined"&&(qe.type="string",qe.default=$e),super(J,pe,$e,qe)}validate(J){return S.string(J,this.defaultValue)}}function w(q,J,pe){return typeof q!="string"||pe.indexOf(q)===-1?J:q}e.stringSet=w;class o extends y{constructor(J,pe,$e,qe,rt=void 0){typeof rt!="undefined"&&(rt.type="string",rt.enum=qe,rt.default=$e),super(J,pe,$e,rt),this._allowedValues=qe}validate(J){return w(J,this.defaultValue,this._allowedValues)}}class d extends k{constructor(J,pe,$e,qe,rt,ft,ht=void 0){typeof ht!="undefined"&&(ht.type="string",ht.enum=rt,ht.default=qe),super(J,pe,$e,ht),this._allowedValues=rt,this._convert=ft}validate(J){return typeof J!="string"?this.defaultValue:this._allowedValues.indexOf(J)===-1?this.defaultValue:this._convert(J)}}function _(q){switch(q){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class c extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[u.localize(0,null),u.localize(1,null),u.localize(2,null)],default:"auto",description:u.localize(3,null)})}validate(J){switch(J){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(J,pe,$e){return $e===0?J.accessibilitySupport:$e}}class R extends k{constructor(){const J={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",J,{"editor.comments.insertSpace":{type:"boolean",default:J.insertSpace,description:u.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:J.ignoreEmptyLines,description:u.localize(5,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const pe=J;return{insertSpace:r(pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:r(pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var n;(function(q){q[q.Hidden=0]="Hidden",q[q.Blink=1]="Blink",q[q.Smooth=2]="Smooth",q[q.Phase=3]="Phase",q[q.Expand=4]="Expand",q[q.Solid=5]="Solid"})(n=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function i(q){switch(q){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var g;(function(q){q[q.Line=1]="Line",q[q.Block=2]="Block",q[q.Underline=3]="Underline",q[q.LineThin=4]="LineThin",q[q.BlockOutline=5]="BlockOutline",q[q.UnderlineThin=6]="UnderlineThin"})(g=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function f(q){switch(q){case g.Line:return"line";case g.Block:return"block";case g.Underline:return"underline";case g.LineThin:return"line-thin";case g.BlockOutline:return"block-outline";case g.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=f;function s(q){switch(q){case"line":return g.Line;case"block":return g.Block;case"underline":return g.Underline;case"line-thin":return g.LineThin;case"block-outline":return g.BlockOutline;case"underline-thin":return g.UnderlineThin}}class v extends F{constructor(){super(126,[65,33])}compute(J,pe,$e){const qe=["monaco-editor"];return pe.get(33)&&qe.push(pe.get(33)),J.extraEditorClassName&&qe.push(J.extraEditorClassName),pe.get(65)==="default"?qe.push("mouse-default"):pe.get(65)==="copy"&&qe.push("mouse-copy"),pe.get(99)&&qe.push("showUnused"),pe.get(124)&&qe.push("showDeprecated"),qe.join(" ")}}class l extends m{constructor(){super(32,"emptySelectionClipboard",!0,{description:u.localize(6,null)})}compute(J,pe,$e){return $e&&J.emptySelectionClipboard}}class E extends k{constructor(){const J={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",J,{"editor.find.cursorMoveOnType":{type:"boolean",default:J.cursorMoveOnType,description:u.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:J.seedSearchStringFromSelection,enumDescriptions:[u.localize(8,null),u.localize(9,null),u.localize(10,null)],description:u.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:J.autoFindInSelection,enumDescriptions:[u.localize(12,null),u.localize(13,null),u.localize(14,null)],description:u.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:J.globalFindClipboard,description:u.localize(16,null),included:M.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:J.addExtraSpaceOnTop,description:u.localize(17,null)},"editor.find.loop":{type:"boolean",default:J.loop,description:u.localize(18,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const pe=J;return{cursorMoveOnType:r(pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof J.seedSearchStringFromSelection=="boolean"?J.seedSearchStringFromSelection?"always":"never":w(pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof J.autoFindInSelection=="boolean"?J.autoFindInSelection?"always":"never":w(pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:r(pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:r(pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:r(pe.loop,this.defaultValue.loop)}}}class T extends k{constructor(){super(44,"fontLigatures",T.OFF,{anyOf:[{type:"boolean",description:u.localize(19,null)},{type:"string",description:u.localize(20,null)}],description:u.localize(21,null),default:!1})}validate(J){return typeof J=="undefined"?this.defaultValue:typeof J=="string"?J==="false"?T.OFF:J==="true"?T.ON:J:Boolean(J)?T.ON:T.OFF}}e.EditorFontLigatures=T,T.OFF='"liga" off, "calt" off',T.ON='"liga" on, "calt" on';class I extends F{constructor(){super(43)}compute(J,pe,$e){return J.fontInfo}}class B extends y{constructor(){super(45,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:u.localize(22,null)})}validate(J){let pe=p.float(J,this.defaultValue);return pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:p.clamp(pe,6,100)}compute(J,pe,$e){return J.fontInfo.fontSize}}class O extends k{constructor(){super(46,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:O.MINIMUM_VALUE,maximum:O.MAXIMUM_VALUE,errorMessage:u.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:O.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:u.localize(24,null)})}validate(J){return J==="normal"||J==="bold"?J:String(h.clampedInt(J,e.EDITOR_FONT_DEFAULTS.fontWeight,O.MINIMUM_VALUE,O.MAXIMUM_VALUE))}}O.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],O.MINIMUM_VALUE=1,O.MAXIMUM_VALUE=1e3;class D extends k{constructor(){const J={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:J.multiple,enumDescriptions:[u.localize(25,null),u.localize(26,null),u.localize(27,null)]},$e=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(50,"gotoLocation",J,{"editor.gotoLocation.multiple":{deprecationMessage:u.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:u.localize(29,null),...pe},"editor.gotoLocation.multipleTypeDefinitions":{description:u.localize(30,null),...pe},"editor.gotoLocation.multipleDeclarations":{description:u.localize(31,null),...pe},"editor.gotoLocation.multipleImplementations":{description:u.localize(32,null),...pe},"editor.gotoLocation.multipleReferences":{description:u.localize(33,null),...pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:J.alternativeDefinitionCommand,enum:$e,description:u.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:J.alternativeTypeDefinitionCommand,enum:$e,description:u.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:J.alternativeDeclarationCommand,enum:$e,description:u.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:J.alternativeImplementationCommand,enum:$e,description:u.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:J.alternativeReferenceCommand,enum:$e,description:u.localize(38,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const pe=J;return{multiple:w(pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:pe.multipleDefinitions??w(pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:pe.multipleTypeDefinitions??w(pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:pe.multipleDeclarations??w(pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:pe.multipleImplementations??w(pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:pe.multipleReferences??w(pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:S.string(pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:S.string(pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:S.string(pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:S.string(pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:S.string(pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class x extends k{constructor(){const J={enabled:!0,delay:300,sticky:!0,above:!0};super(52,"hover",J,{"editor.hover.enabled":{type:"boolean",default:J.enabled,description:u.localize(39,null)},"editor.hover.delay":{type:"number",default:J.delay,description:u.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:J.sticky,description:u.localize(41,null)},"editor.hover.above":{type:"boolean",default:J.above,description:u.localize(42,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const pe=J;return{enabled:r(pe.enabled,this.defaultValue.enabled),delay:h.clampedInt(pe.delay,this.defaultValue.delay,0,1e4),sticky:r(pe.sticky,this.defaultValue.sticky),above:r(pe.above,this.defaultValue.above)}}}var N;(function(q){q[q.None=0]="None",q[q.Text=1]="Text",q[q.Blocks=2]="Blocks"})(N=e.RenderMinimap||(e.RenderMinimap={}));class V extends F{constructor(){super(129,[49,57,37,64,91,59,60,93,116,119,120,121,2])}compute(J,pe,$e){return V.computeLayout(pe,{memory:J.memory,outerWidth:J.outerWidth,outerHeight:J.outerHeight,isDominatedByLongLines:J.isDominatedByLongLines,lineHeight:J.fontInfo.lineHeight,viewLineCount:J.viewLineCount,lineNumbersDigitCount:J.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:J.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:J.fontInfo.maxDigitWidth,pixelRatio:J.pixelRatio})}static computeContainedMinimapLineCount(J){const pe=J.height/J.lineHeight,$e=J.scrollBeyondLastLine?pe-1:0,qe=(J.viewLineCount+$e)/(J.pixelRatio*J.height),rt=Math.floor(J.viewLineCount/qe);return{typicalViewportLineCount:pe,extraLinesBeyondLastLine:$e,desiredRatio:qe,minimapLineCount:rt}}static _computeMinimapLayout(J,pe){const $e=J.outerWidth,qe=J.outerHeight,rt=J.pixelRatio;if(!J.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(rt*qe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:qe};const ft=pe.stableMinimapLayoutInput,ht=ft&&J.outerHeight===ft.outerHeight&&J.lineHeight===ft.lineHeight&&J.typicalHalfwidthCharacterWidth===ft.typicalHalfwidthCharacterWidth&&J.pixelRatio===ft.pixelRatio&&J.scrollBeyondLastLine===ft.scrollBeyondLastLine&&J.minimap.enabled===ft.minimap.enabled&&J.minimap.side===ft.minimap.side&&J.minimap.size===ft.minimap.size&&J.minimap.showSlider===ft.minimap.showSlider&&J.minimap.renderCharacters===ft.minimap.renderCharacters&&J.minimap.maxColumn===ft.minimap.maxColumn&&J.minimap.scale===ft.minimap.scale&&J.verticalScrollbarWidth===ft.verticalScrollbarWidth&&J.isViewportWrapping===ft.isViewportWrapping,Ct=J.lineHeight,It=J.typicalHalfwidthCharacterWidth,Pt=J.scrollBeyondLastLine,Ze=J.minimap.renderCharacters;let pt=rt>=2?Math.round(J.minimap.scale*2):J.minimap.scale;const Ie=J.minimap.maxColumn,ge=J.minimap.size,Ce=J.minimap.side,Z=J.verticalScrollbarWidth,se=J.viewLineCount,fe=J.remainingWidth,he=J.isViewportWrapping,ke=Ze?2:3;let Le=Math.floor(rt*qe);const Me=Le/rt;let We=!1,it=!1,Re=ke*pt,ce=pt/rt,me=1;if(ge==="fill"||ge==="fit"){const{typicalViewportLineCount:ct,extraLinesBeyondLastLine:_t,desiredRatio:wt,minimapLineCount:lt}=V.computeContainedMinimapLineCount({viewLineCount:se,scrollBeyondLastLine:Pt,height:qe,lineHeight:Ct,pixelRatio:rt});if(se/lt>1)We=!0,it=!0,pt=1,Re=1,ce=pt/rt;else{let dt=!1,Tt=pt+1;if(ge==="fit"){const yt=Math.ceil((se+_t)*Re);he&&ht&&fe<=pe.stableFitRemainingWidth?(dt=!0,Tt=pe.stableFitMaxMinimapScale):dt=yt>Le}if(ge==="fill"||dt){We=!0;const yt=pt;Re=Math.min(Ct*rt,Math.max(1,Math.floor(1/wt))),he&&ht&&fe<=pe.stableFitRemainingWidth&&(Tt=pe.stableFitMaxMinimapScale),pt=Math.min(Tt,Math.max(1,Math.floor(Re/ke))),pt>yt&&(me=Math.min(2,pt/yt)),ce=pt/rt/me,Le=Math.ceil(Math.max(ct,se+_t)*Re),he?(pe.stableMinimapLayoutInput=J,pe.stableFitRemainingWidth=fe,pe.stableFitMaxMinimapScale=pt):(pe.stableMinimapLayoutInput=null,pe.stableFitRemainingWidth=0)}}}const ne=Math.floor(Ie*ce),H=Math.min(ne,Math.max(0,Math.floor((fe-Z-2)*ce/(It+ce)))+e.MINIMAP_GUTTER_WIDTH);let we=Math.floor(rt*H);const De=we/rt;we=Math.floor(we*me);const Ge=Ze?1:2,xe=Ce==="left"?0:$e-H-Z;return{renderMinimap:Ge,minimapLeft:xe,minimapWidth:H,minimapHeightIsEditorHeight:We,minimapIsSampling:it,minimapScale:pt,minimapLineHeight:Re,minimapCanvasInnerWidth:we,minimapCanvasInnerHeight:Le,minimapCanvasOuterWidth:De,minimapCanvasOuterHeight:Me}}static computeLayout(J,pe){const $e=pe.outerWidth|0,qe=pe.outerHeight|0,rt=pe.lineHeight|0,ft=pe.lineNumbersDigitCount|0,ht=pe.typicalHalfwidthCharacterWidth,Ct=pe.maxDigitWidth,It=pe.pixelRatio,Pt=pe.viewLineCount,Ze=J.get(121),pt=Ze==="inherit"?J.get(120):Ze,Ie=pt==="inherit"?J.get(116):pt,ge=J.get(119),Ce=J.get(2),Z=pe.isDominatedByLongLines,se=J.get(49),fe=J.get(59).renderType!==0,he=J.get(60),ke=J.get(93),Le=J.get(64),Me=J.get(91),We=Me.verticalScrollbarSize,it=Me.verticalHasArrows,Re=Me.arrowSize,ce=Me.horizontalScrollbarSize,me=J.get(57),ne=J.get(37);let H;if(typeof me=="string"&&/^\d+(\.\d+)?ch$/.test(me)){const St=parseFloat(me.substr(0,me.length-2));H=h.clampedInt(St*ht,0,0,1e3)}else H=h.clampedInt(me,0,0,1e3);ne&&(H+=16);let we=0;if(fe){const St=Math.max(ft,he);we=Math.round(St*Ct)}let De=0;se&&(De=rt);let Ge=0,xe=Ge+De,ct=xe+we,_t=ct+H;const wt=$e-De-we-H;let lt=!1,gt=!1,dt=-1;Ce!==2&&(pt==="inherit"&&Z?(lt=!0,gt=!0):Ie==="on"||Ie==="bounded"?gt=!0:Ie==="wordWrapColumn"&&(dt=ge));const Tt=V._computeMinimapLayout({outerWidth:$e,outerHeight:qe,lineHeight:rt,typicalHalfwidthCharacterWidth:ht,pixelRatio:It,scrollBeyondLastLine:ke,minimap:Le,verticalScrollbarWidth:We,viewLineCount:Pt,remainingWidth:wt,isViewportWrapping:gt},pe.memory||new C);Tt.renderMinimap!==0&&Tt.minimapLeft===0&&(Ge+=Tt.minimapWidth,xe+=Tt.minimapWidth,ct+=Tt.minimapWidth,_t+=Tt.minimapWidth);const yt=wt-Tt.minimapWidth,Bt=Math.max(1,Math.floor((yt-We-2)/ht)),Vt=it?Re:0;return gt&&(dt=Math.max(1,Bt),Ie==="bounded"&&(dt=Math.min(dt,ge))),{width:$e,height:qe,glyphMarginLeft:Ge,glyphMarginWidth:De,lineNumbersLeft:xe,lineNumbersWidth:we,decorationsLeft:ct,decorationsWidth:H,contentLeft:_t,contentWidth:yt,minimap:Tt,viewportColumn:Bt,isWordWrapMinified:lt,isViewportWrapping:gt,wrappingColumn:dt,verticalScrollbarWidth:We,horizontalScrollbarHeight:ce,overviewRuler:{top:Vt,width:We,height:qe-2*Vt,right:0}}}}e.EditorLayoutInfoComputer=V;class $ extends k{constructor(){const J={enabled:!0};super(56,"lightbulb",J,{"editor.lightbulb.enabled":{type:"boolean",default:J.enabled,description:u.localize(43,null)}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{enabled:r(J.enabled,this.defaultValue.enabled)}}}class z extends k{constructor(){const J={enabled:!0,fontSize:0,fontFamily:""};super(125,"inlayHints",J,{"editor.inlayHints.enabled":{type:"boolean",default:J.enabled,description:u.localize(44,null)},"editor.inlayHints.fontSize":{type:"number",default:J.fontSize,markdownDescription:u.localize(45,null)},"editor.inlayHints.fontFamily":{type:"string",default:J.fontFamily,markdownDescription:u.localize(46,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const pe=J;return{enabled:r(pe.enabled,this.defaultValue.enabled),fontSize:h.clampedInt(pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:S.string(pe.fontFamily,this.defaultValue.fontFamily)}}}class ee extends p{constructor(){super(58,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,J=>p.clamp(J,0,150),{markdownDescription:u.localize(47,null)})}compute(J,pe,$e){return J.fontInfo.lineHeight}}class j extends k{constructor(){const J={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(64,"minimap",J,{"editor.minimap.enabled":{type:"boolean",default:J.enabled,description:u.localize(48,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[u.localize(49,null),u.localize(50,null),u.localize(51,null)],default:J.size,description:u.localize(52,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:J.side,description:u.localize(53,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:J.showSlider,description:u.localize(54,null)},"editor.minimap.scale":{type:"number",default:J.scale,minimum:1,maximum:3,enum:[1,2,3],description:u.localize(55,null)},"editor.minimap.renderCharacters":{type:"boolean",default:J.renderCharacters,description:u.localize(56,null)},"editor.minimap.maxColumn":{type:"number",default:J.maxColumn,description:u.localize(57,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const pe=J;return{enabled:r(pe.enabled,this.defaultValue.enabled),size:w(pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:w(pe.side,this.defaultValue.side,["right","left"]),showSlider:w(pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:r(pe.renderCharacters,this.defaultValue.renderCharacters),scale:h.clampedInt(pe.scale,1,1,3),maxColumn:h.clampedInt(pe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Q(q){return q==="ctrlCmd"?M.isMacintosh?"metaKey":"ctrlKey":"altKey"}class le extends k{constructor(){super(74,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:u.localize(58,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:u.localize(59,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const pe=J;return{top:h.clampedInt(pe.top,0,0,1e3),bottom:h.clampedInt(pe.bottom,0,0,1e3)}}}class ve extends k{constructor(){const J={enabled:!0,cycle:!1};super(75,"parameterHints",J,{"editor.parameterHints.enabled":{type:"boolean",default:J.enabled,description:u.localize(60,null)},"editor.parameterHints.cycle":{type:"boolean",default:J.cycle,description:u.localize(61,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const pe=J;return{enabled:r(pe.enabled,this.defaultValue.enabled),cycle:r(pe.cycle,this.defaultValue.cycle)}}}class ue extends F{constructor(){super(127)}compute(J,pe,$e){return J.pixelRatio}}class Fe extends k{constructor(){const J={other:!0,comments:!1,strings:!1};super(78,"quickSuggestions",J,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:J.strings,description:u.localize(62,null)},comments:{type:"boolean",default:J.comments,description:u.localize(63,null)},other:{type:"boolean",default:J.other,description:u.localize(64,null)}}}],default:J,description:u.localize(65,null)});this.defaultValue=J}validate(J){if(typeof J=="boolean")return J;if(J&&typeof J=="object"){const pe=J,$e={other:r(pe.other,this.defaultValue.other),comments:r(pe.comments,this.defaultValue.comments),strings:r(pe.strings,this.defaultValue.strings)};return $e.other&&$e.comments&&$e.strings?!0:!$e.other&&!$e.comments&&!$e.strings?!1:$e}return this.defaultValue}}var Ke;(function(q){q[q.Off=0]="Off",q[q.On=1]="On",q[q.Relative=2]="Relative",q[q.Interval=3]="Interval",q[q.Custom=4]="Custom"})(Ke=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Oe extends k{constructor(){super(59,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[u.localize(66,null),u.localize(67,null),u.localize(68,null),u.localize(69,null)],default:"on",description:u.localize(70,null)})}validate(J){let pe=this.defaultValue.renderType,$e=this.defaultValue.renderFn;return typeof J!="undefined"&&(typeof J=="function"?(pe=4,$e=J):J==="interval"?pe=3:J==="relative"?pe=2:J==="on"?pe=1:pe=0),{renderType:pe,renderFn:$e}}}function He(q){const J=q.get(86);return J==="editable"?q.get(80):J!=="on"}e.filterValidationDecorations=He;class Je extends k{constructor(){const J=[],pe={type:"number",description:u.localize(71,null)};super(90,"rulers",J,{type:"array",items:{anyOf:[pe,{type:["object"],properties:{column:pe,color:{type:"string",description:u.localize(72,null),format:"color-hex"}}}]},default:J,description:u.localize(73,null)})}validate(J){if(Array.isArray(J)){let pe=[];for(let $e of J)if(typeof $e=="number")pe.push({column:h.clampedInt($e,0,0,1e4),color:null});else if($e&&typeof $e=="object"){const qe=$e;pe.push({column:h.clampedInt(qe.column,0,0,1e4),color:qe.color})}return pe.sort(($e,qe)=>$e.column-qe.column),pe}return this.defaultValue}}function Ye(q,J){if(typeof q!="string")return J;switch(q){case"hidden":return 2;case"visible":return 3;default:return 1}}class Qe extends k{constructor(){const J={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(91,"scrollbar",J,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[u.localize(74,null),u.localize(75,null),u.localize(76,null)],default:"auto",description:u.localize(77,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[u.localize(78,null),u.localize(79,null),u.localize(80,null)],default:"auto",description:u.localize(81,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:J.verticalScrollbarSize,description:u.localize(82,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:J.horizontalScrollbarSize,description:u.localize(83,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:J.scrollByPage,description:u.localize(84,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const pe=J,$e=h.clampedInt(pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),qe=h.clampedInt(pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:h.clampedInt(pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ye(pe.vertical,this.defaultValue.vertical),horizontal:Ye(pe.horizontal,this.defaultValue.horizontal),useShadows:r(pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:r(pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:r(pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:r(pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:r(pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:$e,horizontalSliderSize:h.clampedInt(pe.horizontalSliderSize,$e,0,1e3),verticalScrollbarSize:qe,verticalSliderSize:h.clampedInt(pe.verticalSliderSize,qe,0,1e3),scrollByPage:r(pe.scrollByPage,this.defaultValue.scrollByPage)}}}class W extends k{constructor(){const J={enabled:!0,mode:"subwordSmart"};super(54,"inlineSuggest",J,{"editor.inlineSuggest.enabled":{type:"boolean",default:J.enabled,description:u.localize(85,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const pe=J;return{enabled:r(pe.enabled,this.defaultValue.enabled),mode:w(pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class K extends k{constructor(){const J={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",J,{"editor.bracketPairColorization.enabled":{type:"boolean",default:J.enabled,description:u.localize(86,null)}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{enabled:r(J.enabled,this.defaultValue.enabled)}}}class X extends k{constructor(){const J={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",J,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[u.localize(87,null),u.localize(88,null),u.localize(89,null)],default:J.bracketPairs,description:u.localize(90,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[u.localize(91,null),u.localize(92,null),u.localize(93,null)],default:J.bracketPairsHorizontal,description:u.localize(94,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:J.highlightActiveBracketPair,description:u.localize(95,null)},"editor.guides.indentation":{type:"boolean",default:J.indentation,description:u.localize(96,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:J.highlightActiveIndentation,description:u.localize(97,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const pe=J;return{bracketPairs:oe(pe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:oe(pe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:r(pe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:r(pe.indentation,this.defaultValue.indentation),highlightActiveIndentation:r(pe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}function oe(q,J,pe){const $e=pe.indexOf(q);return $e===-1?J:pe[$e]}class G extends k{constructor(){const J={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(105,"suggest",J,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[u.localize(98,null),u.localize(99,null)],default:J.insertMode,description:u.localize(100,null)},"editor.suggest.filterGraceful":{type:"boolean",default:J.filterGraceful,description:u.localize(101,null)},"editor.suggest.localityBonus":{type:"boolean",default:J.localityBonus,description:u.localize(102,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:J.shareSuggestSelections,markdownDescription:u.localize(103,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:J.snippetsPreventQuickSuggestions,description:u.localize(104,null)},"editor.suggest.showIcons":{type:"boolean",default:J.showIcons,description:u.localize(105,null)},"editor.suggest.showStatusBar":{type:"boolean",default:J.showStatusBar,description:u.localize(106,null)},"editor.suggest.preview":{type:"boolean",default:J.preview,description:u.localize(107,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:J.showInlineDetails,description:u.localize(108,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:u.localize(109,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:u.localize(110,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:u.localize(111,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:u.localize(112,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:u.localize(113,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:u.localize(114,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:u.localize(115,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:u.localize(116,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:u.localize(117,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:u.localize(118,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:u.localize(119,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:u.localize(120,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:u.localize(121,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:u.localize(122,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:u.localize(123,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:u.localize(124,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:u.localize(125,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:u.localize(126,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:u.localize(127,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:u.localize(128,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:u.localize(129,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:u.localize(130,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:u.localize(131,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:u.localize(132,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:u.localize(133,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:u.localize(134,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:u.localize(135,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:u.localize(136,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:u.localize(137,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:u.localize(138,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:u.localize(139,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const pe=J;return{insertMode:w(pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:r(pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:r(pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:r(pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:r(pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:r(pe.showIcons,this.defaultValue.showIcons),showStatusBar:r(pe.showStatusBar,this.defaultValue.showStatusBar),preview:r(pe.preview,this.defaultValue.preview),previewMode:w(pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:r(pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:r(pe.showMethods,this.defaultValue.showMethods),showFunctions:r(pe.showFunctions,this.defaultValue.showFunctions),showConstructors:r(pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:r(pe.showDeprecated,this.defaultValue.showDeprecated),showFields:r(pe.showFields,this.defaultValue.showFields),showVariables:r(pe.showVariables,this.defaultValue.showVariables),showClasses:r(pe.showClasses,this.defaultValue.showClasses),showStructs:r(pe.showStructs,this.defaultValue.showStructs),showInterfaces:r(pe.showInterfaces,this.defaultValue.showInterfaces),showModules:r(pe.showModules,this.defaultValue.showModules),showProperties:r(pe.showProperties,this.defaultValue.showProperties),showEvents:r(pe.showEvents,this.defaultValue.showEvents),showOperators:r(pe.showOperators,this.defaultValue.showOperators),showUnits:r(pe.showUnits,this.defaultValue.showUnits),showValues:r(pe.showValues,this.defaultValue.showValues),showConstants:r(pe.showConstants,this.defaultValue.showConstants),showEnums:r(pe.showEnums,this.defaultValue.showEnums),showEnumMembers:r(pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:r(pe.showKeywords,this.defaultValue.showKeywords),showWords:r(pe.showWords,this.defaultValue.showWords),showColors:r(pe.showColors,this.defaultValue.showColors),showFiles:r(pe.showFiles,this.defaultValue.showFiles),showReferences:r(pe.showReferences,this.defaultValue.showReferences),showFolders:r(pe.showFolders,this.defaultValue.showFolders),showTypeParameters:r(pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:r(pe.showSnippets,this.defaultValue.showSnippets),showUsers:r(pe.showUsers,this.defaultValue.showUsers),showIssues:r(pe.showIssues,this.defaultValue.showIssues)}}}class ie extends k{constructor(){super(101,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:u.localize(140,null),default:!0,type:"boolean"}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:r(J.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class de extends F{constructor(){super(128,[80])}compute(J,pe,$e){return pe.get(80)?!0:J.tabFocusMode}}var Te;(function(q){q[q.None=0]="None",q[q.Same=1]="Same",q[q.Indent=2]="Indent",q[q.DeepIndent=3]="DeepIndent"})(Te=e.WrappingIndent||(e.WrappingIndent={}));function Ne(q){switch(q){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ze extends F{constructor(){super(130,[129])}compute(J,pe,$e){const qe=pe.get(129);return{isDominatedByLongLines:J.isDominatedByLongLines,isWordWrapMinified:qe.isWordWrapMinified,isViewportWrapping:qe.isViewportWrapping,wrappingColumn:qe.wrappingColumn}}}const je="Consolas, 'Courier New', monospace",et="Menlo, Monaco, 'Courier New', monospace",ot="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:M.isMacintosh?et:M.isLinux?ot:je,fontWeight:"normal",fontSize:M.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function ye(q){return e.editorOptionsRegistry[q.id]=q,q}var nt;(function(q){q[q.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",q[q.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",q[q.accessibilitySupport=2]="accessibilitySupport",q[q.accessibilityPageSize=3]="accessibilityPageSize",q[q.ariaLabel=4]="ariaLabel",q[q.autoClosingBrackets=5]="autoClosingBrackets",q[q.autoClosingDelete=6]="autoClosingDelete",q[q.autoClosingOvertype=7]="autoClosingOvertype",q[q.autoClosingQuotes=8]="autoClosingQuotes",q[q.autoIndent=9]="autoIndent",q[q.automaticLayout=10]="automaticLayout",q[q.autoSurround=11]="autoSurround",q[q.bracketPairColorization=12]="bracketPairColorization",q[q.guides=13]="guides",q[q.codeLens=14]="codeLens",q[q.codeLensFontFamily=15]="codeLensFontFamily",q[q.codeLensFontSize=16]="codeLensFontSize",q[q.colorDecorators=17]="colorDecorators",q[q.columnSelection=18]="columnSelection",q[q.comments=19]="comments",q[q.contextmenu=20]="contextmenu",q[q.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",q[q.cursorBlinking=22]="cursorBlinking",q[q.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",q[q.cursorStyle=24]="cursorStyle",q[q.cursorSurroundingLines=25]="cursorSurroundingLines",q[q.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",q[q.cursorWidth=27]="cursorWidth",q[q.disableLayerHinting=28]="disableLayerHinting",q[q.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",q[q.domReadOnly=30]="domReadOnly",q[q.dragAndDrop=31]="dragAndDrop",q[q.emptySelectionClipboard=32]="emptySelectionClipboard",q[q.extraEditorClassName=33]="extraEditorClassName",q[q.fastScrollSensitivity=34]="fastScrollSensitivity",q[q.find=35]="find",q[q.fixedOverflowWidgets=36]="fixedOverflowWidgets",q[q.folding=37]="folding",q[q.foldingStrategy=38]="foldingStrategy",q[q.foldingHighlight=39]="foldingHighlight",q[q.foldingImportsByDefault=40]="foldingImportsByDefault",q[q.unfoldOnClickAfterEndOfLine=41]="unfoldOnClickAfterEndOfLine",q[q.fontFamily=42]="fontFamily",q[q.fontInfo=43]="fontInfo",q[q.fontLigatures=44]="fontLigatures",q[q.fontSize=45]="fontSize",q[q.fontWeight=46]="fontWeight",q[q.formatOnPaste=47]="formatOnPaste",q[q.formatOnType=48]="formatOnType",q[q.glyphMargin=49]="glyphMargin",q[q.gotoLocation=50]="gotoLocation",q[q.hideCursorInOverviewRuler=51]="hideCursorInOverviewRuler",q[q.hover=52]="hover",q[q.inDiffEditor=53]="inDiffEditor",q[q.inlineSuggest=54]="inlineSuggest",q[q.letterSpacing=55]="letterSpacing",q[q.lightbulb=56]="lightbulb",q[q.lineDecorationsWidth=57]="lineDecorationsWidth",q[q.lineHeight=58]="lineHeight",q[q.lineNumbers=59]="lineNumbers",q[q.lineNumbersMinChars=60]="lineNumbersMinChars",q[q.linkedEditing=61]="linkedEditing",q[q.links=62]="links",q[q.matchBrackets=63]="matchBrackets",q[q.minimap=64]="minimap",q[q.mouseStyle=65]="mouseStyle",q[q.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",q[q.mouseWheelZoom=67]="mouseWheelZoom",q[q.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",q[q.multiCursorModifier=69]="multiCursorModifier",q[q.multiCursorPaste=70]="multiCursorPaste",q[q.occurrencesHighlight=71]="occurrencesHighlight",q[q.overviewRulerBorder=72]="overviewRulerBorder",q[q.overviewRulerLanes=73]="overviewRulerLanes",q[q.padding=74]="padding",q[q.parameterHints=75]="parameterHints",q[q.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",q[q.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",q[q.quickSuggestions=78]="quickSuggestions",q[q.quickSuggestionsDelay=79]="quickSuggestionsDelay",q[q.readOnly=80]="readOnly",q[q.renameOnType=81]="renameOnType",q[q.renderControlCharacters=82]="renderControlCharacters",q[q.renderFinalNewline=83]="renderFinalNewline",q[q.renderLineHighlight=84]="renderLineHighlight",q[q.renderLineHighlightOnlyWhenFocus=85]="renderLineHighlightOnlyWhenFocus",q[q.renderValidationDecorations=86]="renderValidationDecorations",q[q.renderWhitespace=87]="renderWhitespace",q[q.revealHorizontalRightPadding=88]="revealHorizontalRightPadding",q[q.roundedSelection=89]="roundedSelection",q[q.rulers=90]="rulers",q[q.scrollbar=91]="scrollbar",q[q.scrollBeyondLastColumn=92]="scrollBeyondLastColumn",q[q.scrollBeyondLastLine=93]="scrollBeyondLastLine",q[q.scrollPredominantAxis=94]="scrollPredominantAxis",q[q.selectionClipboard=95]="selectionClipboard",q[q.selectionHighlight=96]="selectionHighlight",q[q.selectOnLineNumbers=97]="selectOnLineNumbers",q[q.showFoldingControls=98]="showFoldingControls",q[q.showUnused=99]="showUnused",q[q.snippetSuggestions=100]="snippetSuggestions",q[q.smartSelect=101]="smartSelect",q[q.smoothScrolling=102]="smoothScrolling",q[q.stickyTabStops=103]="stickyTabStops",q[q.stopRenderingLineAfter=104]="stopRenderingLineAfter",q[q.suggest=105]="suggest",q[q.suggestFontSize=106]="suggestFontSize",q[q.suggestLineHeight=107]="suggestLineHeight",q[q.suggestOnTriggerCharacters=108]="suggestOnTriggerCharacters",q[q.suggestSelection=109]="suggestSelection",q[q.tabCompletion=110]="tabCompletion",q[q.tabIndex=111]="tabIndex",q[q.unusualLineTerminators=112]="unusualLineTerminators",q[q.useShadowDOM=113]="useShadowDOM",q[q.useTabStops=114]="useTabStops",q[q.wordSeparators=115]="wordSeparators",q[q.wordWrap=116]="wordWrap",q[q.wordWrapBreakAfterCharacters=117]="wordWrapBreakAfterCharacters",q[q.wordWrapBreakBeforeCharacters=118]="wordWrapBreakBeforeCharacters",q[q.wordWrapColumn=119]="wordWrapColumn",q[q.wordWrapOverride1=120]="wordWrapOverride1",q[q.wordWrapOverride2=121]="wordWrapOverride2",q[q.wrappingIndent=122]="wrappingIndent",q[q.wrappingStrategy=123]="wrappingStrategy",q[q.showDeprecated=124]="showDeprecated",q[q.inlayHints=125]="inlayHints",q[q.editorClassName=126]="editorClassName",q[q.pixelRatio=127]="pixelRatio",q[q.tabFocusMode=128]="tabFocusMode",q[q.layoutInfo=129]="layoutInfo",q[q.wrappingInfo=130]="wrappingInfo"})(nt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ye(new m(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:u.localize(141,null)})),acceptSuggestionOnEnter:ye(new o(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",u.localize(142,null),""],markdownDescription:u.localize(143,null)})),accessibilitySupport:ye(new c),accessibilityPageSize:ye(new h(3,"accessibilityPageSize",10,1,1073741824,{description:u.localize(144,null)})),ariaLabel:ye(new S(4,"ariaLabel",u.localize(145,null))),autoClosingBrackets:ye(new o(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",u.localize(146,null),u.localize(147,null),""],description:u.localize(148,null)})),autoClosingDelete:ye(new o(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",u.localize(149,null),""],description:u.localize(150,null)})),autoClosingOvertype:ye(new o(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",u.localize(151,null),""],description:u.localize(152,null)})),autoClosingQuotes:ye(new o(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",u.localize(153,null),u.localize(154,null),""],description:u.localize(155,null)})),autoIndent:ye(new d(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],_,{enumDescriptions:[u.localize(156,null),u.localize(157,null),u.localize(158,null),u.localize(159,null),u.localize(160,null)],description:u.localize(161,null)})),automaticLayout:ye(new m(10,"automaticLayout",!1)),autoSurround:ye(new o(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[u.localize(162,null),u.localize(163,null),u.localize(164,null),""],description:u.localize(165,null)})),bracketPairColorization:ye(new K),bracketPairGuides:ye(new X),stickyTabStops:ye(new m(103,"stickyTabStops",!1,{description:u.localize(166,null)})),codeLens:ye(new m(14,"codeLens",!0,{description:u.localize(167,null)})),codeLensFontFamily:ye(new S(15,"codeLensFontFamily","",{description:u.localize(168,null)})),codeLensFontSize:ye(new h(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:u.localize(169,null)})),colorDecorators:ye(new m(17,"colorDecorators",!0,{description:u.localize(170,null)})),columnSelection:ye(new m(18,"columnSelection",!1,{description:u.localize(171,null)})),comments:ye(new R),contextmenu:ye(new m(20,"contextmenu",!0)),copyWithSyntaxHighlighting:ye(new m(21,"copyWithSyntaxHighlighting",!0,{description:u.localize(172,null)})),cursorBlinking:ye(new d(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],i,{description:u.localize(173,null)})),cursorSmoothCaretAnimation:ye(new m(23,"cursorSmoothCaretAnimation",!1,{description:u.localize(174,null)})),cursorStyle:ye(new d(24,"cursorStyle",g.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],s,{description:u.localize(175,null)})),cursorSurroundingLines:ye(new h(25,"cursorSurroundingLines",0,0,1073741824,{description:u.localize(176,null)})),cursorSurroundingLinesStyle:ye(new o(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[u.localize(177,null),u.localize(178,null)],description:u.localize(179,null)})),cursorWidth:ye(new h(27,"cursorWidth",0,0,1073741824,{markdownDescription:u.localize(180,null)})),disableLayerHinting:ye(new m(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:ye(new m(29,"disableMonospaceOptimizations",!1)),domReadOnly:ye(new m(30,"domReadOnly",!1)),dragAndDrop:ye(new m(31,"dragAndDrop",!0,{description:u.localize(181,null)})),emptySelectionClipboard:ye(new l),extraEditorClassName:ye(new S(33,"extraEditorClassName","")),fastScrollSensitivity:ye(new p(34,"fastScrollSensitivity",5,q=>q<=0?5:q,{markdownDescription:u.localize(182,null)})),find:ye(new E),fixedOverflowWidgets:ye(new m(36,"fixedOverflowWidgets",!1)),folding:ye(new m(37,"folding",!0,{description:u.localize(183,null)})),foldingStrategy:ye(new o(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[u.localize(184,null),u.localize(185,null)],description:u.localize(186,null)})),foldingHighlight:ye(new m(39,"foldingHighlight",!0,{description:u.localize(187,null)})),foldingImportsByDefault:ye(new m(40,"foldingImportsByDefault",!1,{description:u.localize(188,null)})),unfoldOnClickAfterEndOfLine:ye(new m(41,"unfoldOnClickAfterEndOfLine",!1,{description:u.localize(189,null)})),fontFamily:ye(new S(42,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:u.localize(190,null)})),fontInfo:ye(new I),fontLigatures2:ye(new T),fontSize:ye(new B),fontWeight:ye(new O),formatOnPaste:ye(new m(47,"formatOnPaste",!1,{description:u.localize(191,null)})),formatOnType:ye(new m(48,"formatOnType",!1,{description:u.localize(192,null)})),glyphMargin:ye(new m(49,"glyphMargin",!0,{description:u.localize(193,null)})),gotoLocation:ye(new D),hideCursorInOverviewRuler:ye(new m(51,"hideCursorInOverviewRuler",!1,{description:u.localize(194,null)})),hover:ye(new x),inDiffEditor:ye(new m(53,"inDiffEditor",!1)),letterSpacing:ye(new p(55,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,q=>p.clamp(q,-5,20),{description:u.localize(195,null)})),lightbulb:ye(new $),lineDecorationsWidth:ye(new y(57,"lineDecorationsWidth",10)),lineHeight:ye(new ee),lineNumbers:ye(new Oe),lineNumbersMinChars:ye(new h(60,"lineNumbersMinChars",5,1,300)),linkedEditing:ye(new m(61,"linkedEditing",!1,{description:u.localize(196,null)})),links:ye(new m(62,"links",!0,{description:u.localize(197,null)})),matchBrackets:ye(new o(63,"matchBrackets","always",["always","near","never"],{description:u.localize(198,null)})),minimap:ye(new j),mouseStyle:ye(new o(65,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ye(new p(66,"mouseWheelScrollSensitivity",1,q=>q===0?1:q,{markdownDescription:u.localize(199,null)})),mouseWheelZoom:ye(new m(67,"mouseWheelZoom",!1,{markdownDescription:u.localize(200,null)})),multiCursorMergeOverlapping:ye(new m(68,"multiCursorMergeOverlapping",!0,{description:u.localize(201,null)})),multiCursorModifier:ye(new d(69,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Q,{markdownEnumDescriptions:[u.localize(202,null),u.localize(203,null)],markdownDescription:u.localize(204,null)})),multiCursorPaste:ye(new o(70,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[u.localize(205,null),u.localize(206,null)],markdownDescription:u.localize(207,null)})),occurrencesHighlight:ye(new m(71,"occurrencesHighlight",!0,{description:u.localize(208,null)})),overviewRulerBorder:ye(new m(72,"overviewRulerBorder",!0,{description:u.localize(209,null)})),overviewRulerLanes:ye(new h(73,"overviewRulerLanes",3,0,3)),padding:ye(new le),parameterHints:ye(new ve),peekWidgetDefaultFocus:ye(new o(76,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[u.localize(210,null),u.localize(211,null)],description:u.localize(212,null)})),definitionLinkOpensInPeek:ye(new m(77,"definitionLinkOpensInPeek",!1,{description:u.localize(213,null)})),quickSuggestions:ye(new Fe),quickSuggestionsDelay:ye(new h(79,"quickSuggestionsDelay",10,0,1073741824,{description:u.localize(214,null)})),readOnly:ye(new m(80,"readOnly",!1)),renameOnType:ye(new m(81,"renameOnType",!1,{description:u.localize(215,null),markdownDeprecationMessage:u.localize(216,null)})),renderControlCharacters:ye(new m(82,"renderControlCharacters",!0,{description:u.localize(217,null),restricted:!0})),renderFinalNewline:ye(new m(83,"renderFinalNewline",!0,{description:u.localize(218,null)})),renderLineHighlight:ye(new o(84,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",u.localize(219,null)],description:u.localize(220,null)})),renderLineHighlightOnlyWhenFocus:ye(new m(85,"renderLineHighlightOnlyWhenFocus",!1,{description:u.localize(221,null)})),renderValidationDecorations:ye(new o(86,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ye(new o(87,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",u.localize(222,null),u.localize(223,null),u.localize(224,null),""],description:u.localize(225,null)})),revealHorizontalRightPadding:ye(new h(88,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:ye(new m(89,"roundedSelection",!0,{description:u.localize(226,null)})),rulers:ye(new Je),scrollbar:ye(new Qe),scrollBeyondLastColumn:ye(new h(92,"scrollBeyondLastColumn",5,0,1073741824,{description:u.localize(227,null)})),scrollBeyondLastLine:ye(new m(93,"scrollBeyondLastLine",!0,{description:u.localize(228,null)})),scrollPredominantAxis:ye(new m(94,"scrollPredominantAxis",!0,{description:u.localize(229,null)})),selectionClipboard:ye(new m(95,"selectionClipboard",!0,{description:u.localize(230,null),included:M.isLinux})),selectionHighlight:ye(new m(96,"selectionHighlight",!0,{description:u.localize(231,null)})),selectOnLineNumbers:ye(new m(97,"selectOnLineNumbers",!0)),showFoldingControls:ye(new o(98,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[u.localize(232,null),u.localize(233,null)],description:u.localize(234,null)})),showUnused:ye(new m(99,"showUnused",!0,{description:u.localize(235,null)})),showDeprecated:ye(new m(124,"showDeprecated",!0,{description:u.localize(236,null)})),inlayHints:ye(new z),snippetSuggestions:ye(new o(100,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[u.localize(237,null),u.localize(238,null),u.localize(239,null),u.localize(240,null)],description:u.localize(241,null)})),smartSelect:ye(new ie),smoothScrolling:ye(new m(102,"smoothScrolling",!1,{description:u.localize(242,null)})),stopRenderingLineAfter:ye(new h(104,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ye(new G),inlineSuggest:ye(new W),suggestFontSize:ye(new h(106,"suggestFontSize",0,0,1e3,{markdownDescription:u.localize(243,null)})),suggestLineHeight:ye(new h(107,"suggestLineHeight",0,0,1e3,{markdownDescription:u.localize(244,null)})),suggestOnTriggerCharacters:ye(new m(108,"suggestOnTriggerCharacters",!0,{description:u.localize(245,null)})),suggestSelection:ye(new o(109,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[u.localize(246,null),u.localize(247,null),u.localize(248,null)],description:u.localize(249,null)})),tabCompletion:ye(new o(110,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[u.localize(250,null),u.localize(251,null),u.localize(252,null)],description:u.localize(253,null)})),tabIndex:ye(new h(111,"tabIndex",0,-1,1073741824)),unusualLineTerminators:ye(new o(112,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[u.localize(254,null),u.localize(255,null),u.localize(256,null)],description:u.localize(257,null)})),useShadowDOM:ye(new m(113,"useShadowDOM",!0)),useTabStops:ye(new m(114,"useTabStops",!0,{description:u.localize(258,null)})),wordSeparators:ye(new S(115,"wordSeparators",b.USUAL_WORD_SEPARATORS,{description:u.localize(259,null)})),wordWrap:ye(new o(116,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[u.localize(260,null),u.localize(261,null),u.localize(262,null),u.localize(263,null)],description:u.localize(264,null)})),wordWrapBreakAfterCharacters:ye(new S(117,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ye(new S(118,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ye(new h(119,"wordWrapColumn",80,1,1073741824,{markdownDescription:u.localize(265,null)})),wordWrapOverride1:ye(new o(120,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ye(new o(121,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:ye(new d(122,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Ne,{enumDescriptions:[u.localize(266,null),u.localize(267,null),u.localize(268,null),u.localize(269,null)],description:u.localize(270,null)})),wrappingStrategy:ye(new o(123,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[u.localize(271,null),u.localize(272,null)],description:u.localize(273,null)})),editorClassName:ye(new v),pixelRatio:ye(new ue),tabFocusMode:ye(new de),layoutInfo:ye(new V),wrappingInfo:ye(new ze)}}),define(be[120],Ee([18,19]),function(re,e){return re.create("vs/platform/configuration/common/configurationRegistry",e)}),define(be[121],Ee([18,19]),function(re,e){return re.create("vs/platform/extensions/common/extensionValidator",e)}),define(be[122],Ee([18,19]),function(re,e){return re.create("vs/platform/files/common/files",e)}),define(be[123],Ee([18,19]),function(re,e){return re.create("vs/platform/markers/common/markers",e)}),define(be[124],Ee([18,19]),function(re,e){return re.create("vs/platform/theme/common/iconRegistry",e)}),define(be[125],Ee([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(be[126],Ee([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostExtensionService",e)}),define(be[127],Ee([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostProgress",e)}),define(be[128],Ee([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostStatusBar",e)}),define(be[129],Ee([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostTerminalService",e)}),define(be[130],Ee([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostTreeViews",e)}),define(be[131],Ee([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostWorkspace",e)}),define(be[132],Ee([18,19]),function(re,e){return re.create("vs/workbench/common/editor",e)}),define(be[133],Ee([18,19]),function(re,e){return re.create("vs/workbench/common/views",e)}),define(be[134],Ee([18,19]),function(re,e){return re.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(be[135],Ee([18,19]),function(re,e){return re.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(be[136],Ee([18,19]),function(re,e){return re.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(be[137],Ee([18,19]),function(re,e){return re.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(be[138],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var u;(function(t){t[t.ACTIVATE=1]="ACTIVATE",t[t.RESTORE=2]="RESTORE",t[t.PRESERVE=3]="PRESERVE"})(u=e.EditorActivation||(e.EditorActivation={}));var M;(function(t){t[t.PICK=0]="PICK",t[t.DISABLED=1]="DISABLED",t[t.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(M=e.EditorResolution||(e.EditorResolution={}));var b;(function(t){t[t.API=0]="API",t[t.USER=1]="USER"})(b=e.EditorOpenContext||(e.EditorOpenContext={}));var P;(function(t){t[t.Center=0]="Center",t[t.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",t[t.NearTop=2]="NearTop",t[t.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(P=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(be[139],Ee([0,1,121]),function(re,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const M=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function P(r){return r=r.trim(),r==="*"||M.test(r)}e.isValidVersionStr=P;function t(r){if(!P(r))return null;if(r=r.trim(),r==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let m=r.match(M);return m?{hasCaret:m[1]==="^",hasGreaterEquals:m[1]===">=",majorBase:m[2]==="x"?0:parseInt(m[2],10),majorMustEqual:m[2]!=="x",minorBase:m[4]==="x"?0:parseInt(m[4],10),minorMustEqual:m[4]!=="x",patchBase:m[6]==="x"?0:parseInt(m[6],10),patchMustEqual:m[6]!=="x",preRelease:m[8]||null}:null}e.parseVersion=t;function A(r){if(!r)return null;let m=r.majorBase,a=r.majorMustEqual,h=r.minorBase,p=r.minorMustEqual,S=r.patchBase,w=r.patchMustEqual;r.hasCaret&&(m===0||(p=!1),w=!1);let o=0;if(r.preRelease){const d=b.exec(r.preRelease);if(d){const[,_,c,R]=d;o=Date.UTC(Number(_),Number(c)-1,Number(R))}}return{majorBase:m,majorMustEqual:a,minorBase:h,minorMustEqual:p,patchBase:S,patchMustEqual:w,isMinimum:r.hasGreaterEquals,notBefore:o}}e.normalizeVersion=A;function C(r,m,a){let h;typeof r=="string"?h=A(t(r)):h=r;let p;m instanceof Date?p=m.getTime():typeof m=="string"&&(p=new Date(m).getTime());let S;if(typeof a=="string"?S=A(t(a)):S=a,!h||!S)return!1;let w=h.majorBase,o=h.minorBase,d=h.patchBase,_=S.majorBase,c=S.minorBase,R=S.patchBase,n=S.notBefore,i=S.majorMustEqual,g=S.minorMustEqual,f=S.patchMustEqual;return S.isMinimum?w>_?!0:w<_?!1:o>c?!0:o<c||p&&p<n?!1:d>=R:(w===1&&_===0&&(!i||!g||!f)&&(_=1,c=0,R=0,i=!0,g=!1,f=!1),w<_?!1:w>_?!i:o<c?!1:o>c?!g:d<R?!1:d>R?!f:!(p&&p<n))}e.isValidVersion=C;function k(r,m,a,h){return a.isBuiltin||typeof a.main=="undefined"?!0:y(r,m,a.engines.vscode,h)}e.isValidExtensionVersion=k;function F(r,m,a){return r==="*"||y(m,a,r)}e.isEngineValid=F;function y(r,m,a,h=[]){let p=A(t(a));if(!p)return h.push(u.localize(0,null,a)),!1;if(p.majorBase===0){if(!p.majorMustEqual||!p.minorMustEqual)return h.push(u.localize(1,null,a)),!1}else if(!p.majorMustEqual)return h.push(u.localize(2,null,a)),!1;return C(r,m,p)?!0:(h.push(u.localize(3,null,r,a)),!1)}}),define(be[82],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class u{constructor(b,P=[],t=!1){this.ctor=b,this.staticArguments=P,this.supportsDelayedInstantiation=t}}e.SyncDescriptor=u}),define(be[59],Ee([0,1,82]),function(re,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const M=[];function b(t,A,C){A instanceof u.SyncDescriptor||(A=new u.SyncDescriptor(A,[],C)),M.push([t,A])}e.registerSingleton=b;function P(){return M}e.getSingletonServiceDescriptors=P}),define(be[140],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class u{constructor(P){this.incoming=new Map,this.outgoing=new Map,this.data=P}}e.Node=u;class M{constructor(P){this._hashFn=P,this._nodes=new Map}roots(){const P=[];for(let t of this._nodes.values())t.outgoing.size===0&&P.push(t);return P}insertEdge(P,t){const A=this.lookupOrInsertNode(P),C=this.lookupOrInsertNode(t);A.outgoing.set(this._hashFn(t),C),C.incoming.set(this._hashFn(P),A)}removeNode(P){const t=this._hashFn(P);this._nodes.delete(t);for(let A of this._nodes.values())A.outgoing.delete(t),A.incoming.delete(t)}lookupOrInsertNode(P){const t=this._hashFn(P);let A=this._nodes.get(t);return A||(A=new u(P),this._nodes.set(t,A)),A}lookup(P){return this._nodes.get(this._hashFn(P))}isEmpty(){return this._nodes.size===0}toString(){let P=[];for(let[t,A]of this._nodes)P.push(`${t}, (incoming)[${[...A.incoming.keys()].join(", ")}], (outgoing)[${[...A.outgoing.keys()].join(",")}]`);return P.join(`
`)}findCycleSlow(){for(let[P,t]of this._nodes){const A=new Set([P]),C=this._findCycle(t,A);if(C)return C}}_findCycle(P,t){for(let[A,C]of P.outgoing){if(t.has(A))return[...t,A].join(" -> ");t.add(A);const k=this._findCycle(C,t);if(k)return k;t.delete(A)}}}e.Graph=M}),define(be[4],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var u;(function(t){t.serviceIds=new Map,t.DI_TARGET="$di$target",t.DI_DEPENDENCIES="$di$dependencies";function A(C){return C[t.DI_DEPENDENCIES]||[]}t.getServiceDependencies=A})(u=e._util||(e._util={})),e.IInstantiationService=b("instantiationService");function M(t,A,C,k){A[u.DI_TARGET]===A?A[u.DI_DEPENDENCIES].push({id:t,index:C,optional:k}):(A[u.DI_DEPENDENCIES]=[{id:t,index:C,optional:k}],A[u.DI_TARGET]=A)}function b(t){if(u.serviceIds.has(t))return u.serviceIds.get(t);const A=function(C,k,F){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");M(A,C,F,!1)};return A.toString=()=>t,u.serviceIds.set(t,A),A}e.createDecorator=b;function P(t){return t}e.refineServiceDecorator=P}),define(be[141],Ee([0,1,4]),function(re,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,u.createDecorator)("modelService");function M(b){return!b.isTooLargeForSyncing()&&!b.isForSimpleWidget}e.shouldSynchronizeModel=M}),define(be[142],Ee([0,1,3,60,6,20,76,58,141]),function(re,e,u,M,b,P,t,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function k(h){return typeof h=="string"?!1:Array.isArray(h)?h.every(k):!!h.exclusive}class F{constructor(){this._clock=0,this._entries=[],this._onDidChange=new u.Emitter}get onDidChange(){return this._onDidChange.event}register(p,S){let w={selector:p,provider:S,_score:-1,_time:this._clock++};return this._entries.push(w),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,b.toDisposable)(()=>{if(w){let o=this._entries.indexOf(w);o>=0&&(this._entries.splice(o,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),w=void 0)}})}has(p){return this.all(p).length>0}all(p){if(!p)return[];this._updateScores(p);const S=[];for(let w of this._entries)w._score>0&&S.push(w.provider);return S}ordered(p){const S=[];return this._orderedForEach(p,w=>S.push(w.provider)),S}orderedGroups(p){const S=[];let w,o;return this._orderedForEach(p,d=>{w&&o===d._score?w.push(d.provider):(o=d._score,w=[d.provider],S.push(w))}),S}_orderedForEach(p,S){if(!!p){this._updateScores(p);for(const w of this._entries)w._score>0&&S(w)}}_updateScores(p){let S={uri:p.uri.toString(),language:p.getLanguageId()};if(!(this._lastCandidate&&this._lastCandidate.language===S.language&&this._lastCandidate.uri===S.uri)){this._lastCandidate=S;for(let w of this._entries)if(w._score=(0,A.score)(w.selector,p.uri,p.getLanguageId(),(0,C.shouldSynchronizeModel)(p)),k(w.selector)&&w._score>0){for(let o of this._entries)o._score=0;w._score=1e3;break}this._entries.sort(F._compareByScoreAndTime)}}static _compareByScoreAndTime(p,S){return p._score<S._score?1:p._score>S._score?-1:p._time<S._time?1:p._time>S._time?-1:0}}e.LanguageFeatureRegistry=F;const y=new WeakMap;let r=0;function m(h){let p=y.get(h);return p===void 0&&(p=++r,y.set(h,p)),p}class a{constructor(p,S,w=Number.MAX_SAFE_INTEGER){this._registry=p,this.min=S,this.max=w,this._cache=new P.LRUCache(50,.7)}_key(p){return p.id+this._registry.all(p).reduce((S,w)=>(0,M.doHash)(m(w),S),0)}_clamp(p){return p===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(p*1.3)))}get(p){const S=this._key(p),w=this._cache.get(S);return this._clamp(w?.value)}update(p,S){const w=this._key(p);let o=this._cache.get(w);return o||(o=new t.MovingAverage,this._cache.set(w,o)),o.update(S),this.get(p)}}e.LanguageFeatureRequestDelays=a}),define(be[61],Ee([0,1,2,45,142,113,35]),function(re,e,u,M,b,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var A;(function(l){l[l.Null=0]="Null",l[l.PlainText=1]="PlainText"})(A=e.LanguageId||(e.LanguageId={}));var C;(function(l){l[l.NotSet=-1]="NotSet",l[l.None=0]="None",l[l.Italic=1]="Italic",l[l.Bold=2]="Bold",l[l.Underline=4]="Underline"})(C=e.FontStyle||(e.FontStyle={}));var k;(function(l){l[l.None=0]="None",l[l.DefaultForeground=1]="DefaultForeground",l[l.DefaultBackground=2]="DefaultBackground"})(k=e.ColorId||(e.ColorId={}));var F;(function(l){l[l.Other=0]="Other",l[l.Comment=1]="Comment",l[l.String=2]="String",l[l.RegEx=4]="RegEx"})(F=e.StandardTokenType||(e.StandardTokenType={}));var y;(function(l){l[l.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",l[l.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",l[l.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",l[l.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",l[l.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",l[l.ITALIC_MASK=2048]="ITALIC_MASK",l[l.BOLD_MASK=4096]="BOLD_MASK",l[l.UNDERLINE_MASK=8192]="UNDERLINE_MASK",l[l.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",l[l.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",l[l.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",l[l.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",l[l.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",l[l.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",l[l.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",l[l.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",l[l.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",l[l.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(y=e.MetadataConsts||(e.MetadataConsts={}));class r{static getLanguageId(E){return(E&255)>>>0}static getTokenType(E){return(E&1792)>>>8}static getFontStyle(E){return(E&14336)>>>11}static getForeground(E){return(E&8372224)>>>14}static getBackground(E){return(E&4286578688)>>>23}static getClassNameFromMetadata(E){let T=this.getForeground(E),I="mtk"+T,B=this.getFontStyle(E);return B&1&&(I+=" mtki"),B&2&&(I+=" mtkb"),B&4&&(I+=" mtku"),I}static getInlineStyleFromMetadata(E,T){const I=this.getForeground(E),B=this.getFontStyle(E);let O=`color: ${T[I]};`;return B&1&&(O+="font-style: italic;"),B&2&&(O+="font-weight: bold;"),B&4&&(O+="text-decoration: underline;"),O}}e.TokenMetadata=r;var m;(function(l){l[l.Method=0]="Method",l[l.Function=1]="Function",l[l.Constructor=2]="Constructor",l[l.Field=3]="Field",l[l.Variable=4]="Variable",l[l.Class=5]="Class",l[l.Struct=6]="Struct",l[l.Interface=7]="Interface",l[l.Module=8]="Module",l[l.Property=9]="Property",l[l.Event=10]="Event",l[l.Operator=11]="Operator",l[l.Unit=12]="Unit",l[l.Value=13]="Value",l[l.Constant=14]="Constant",l[l.Enum=15]="Enum",l[l.EnumMember=16]="EnumMember",l[l.Keyword=17]="Keyword",l[l.Text=18]="Text",l[l.Color=19]="Color",l[l.File=20]="File",l[l.Reference=21]="Reference",l[l.Customcolor=22]="Customcolor",l[l.Folder=23]="Folder",l[l.TypeParameter=24]="TypeParameter",l[l.User=25]="User",l[l.Issue=26]="Issue",l[l.Snippet=27]="Snippet"})(m=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let l=Object.create(null);return l[0]="symbol-method",l[1]="symbol-function",l[2]="symbol-constructor",l[3]="symbol-field",l[4]="symbol-variable",l[5]="symbol-class",l[6]="symbol-struct",l[7]="symbol-interface",l[8]="symbol-module",l[9]="symbol-property",l[10]="symbol-event",l[11]="symbol-operator",l[12]="symbol-unit",l[13]="symbol-value",l[14]="symbol-constant",l[15]="symbol-enum",l[16]="symbol-enum-member",l[17]="symbol-keyword",l[27]="symbol-snippet",l[18]="symbol-text",l[19]="symbol-color",l[20]="symbol-file",l[21]="symbol-reference",l[22]="symbol-customcolor",l[23]="symbol-folder",l[24]="symbol-type-parameter",l[25]="account",l[26]="issues",function(E){const T=l[E];let I=T&&t.iconRegistry.get(T);return I||(console.info("No codicon found for CompletionItemKind "+E),I=t.Codicon.symbolProperty),I.classNames}}(),e.completionKindFromString=function(){let l=Object.create(null);return l.method=0,l.function=1,l.constructor=2,l.field=3,l.variable=4,l.class=5,l.struct=6,l.interface=7,l.module=8,l.property=9,l.event=10,l.operator=11,l.unit=12,l.value=13,l.constant=14,l.enum=15,l["enum-member"]=16,l.enumMember=16,l.keyword=17,l.snippet=27,l.text=18,l.color=19,l.file=20,l.reference=21,l.customcolor=22,l.folder=23,l["type-parameter"]=24,l.typeParameter=24,l.account=25,l.issue=26,function(E,T){let I=l[E];return typeof I=="undefined"&&!T&&(I=9),I}}();var a;(function(l){l[l.Deprecated=1]="Deprecated"})(a=e.CompletionItemTag||(e.CompletionItemTag={}));var h;(function(l){l[l.KeepWhitespace=1]="KeepWhitespace",l[l.InsertAsSnippet=4]="InsertAsSnippet"})(h=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var p;(function(l){l[l.Invoke=0]="Invoke",l[l.TriggerCharacter=1]="TriggerCharacter",l[l.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(p=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var S;(function(l){l[l.Automatic=0]="Automatic",l[l.Explicit=1]="Explicit"})(S=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var w;(function(l){l[l.Invoke=1]="Invoke",l[l.Auto=2]="Auto"})(w=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var o;(function(l){l[l.Invoke=1]="Invoke",l[l.TriggerCharacter=2]="TriggerCharacter",l[l.ContentChange=3]="ContentChange"})(o=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var d;(function(l){l[l.Text=0]="Text",l[l.Read=1]="Read",l[l.Write=2]="Write"})(d=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function _(l){return l&&u.URI.isUri(l.uri)&&M.Range.isIRange(l.range)&&(M.Range.isIRange(l.originSelectionRange)||M.Range.isIRange(l.targetSelectionRange))}e.isLocationLink=_;var c;(function(l){l[l.File=0]="File",l[l.Module=1]="Module",l[l.Namespace=2]="Namespace",l[l.Package=3]="Package",l[l.Class=4]="Class",l[l.Method=5]="Method",l[l.Property=6]="Property",l[l.Field=7]="Field",l[l.Constructor=8]="Constructor",l[l.Enum=9]="Enum",l[l.Interface=10]="Interface",l[l.Function=11]="Function",l[l.Variable=12]="Variable",l[l.Constant=13]="Constant",l[l.String=14]="String",l[l.Number=15]="Number",l[l.Boolean=16]="Boolean",l[l.Array=17]="Array",l[l.Object=18]="Object",l[l.Key=19]="Key",l[l.Null=20]="Null",l[l.EnumMember=21]="EnumMember",l[l.Struct=22]="Struct",l[l.Event=23]="Event",l[l.Operator=24]="Operator",l[l.TypeParameter=25]="TypeParameter"})(c=e.SymbolKind||(e.SymbolKind={}));var R;(function(l){l[l.Deprecated=1]="Deprecated"})(R=e.SymbolTag||(e.SymbolTag={}));var n;(function(l){const E=new Map;E.set("file",0),E.set("module",1),E.set("namespace",2),E.set("package",3),E.set("class",4),E.set("method",5),E.set("property",6),E.set("field",7),E.set("constructor",8),E.set("enum",9),E.set("interface",10),E.set("function",11),E.set("variable",12),E.set("constant",13),E.set("string",14),E.set("number",15),E.set("boolean",16),E.set("array",17),E.set("object",18),E.set("key",19),E.set("null",20),E.set("enum-member",21),E.set("struct",22),E.set("event",23),E.set("operator",24),E.set("type-parameter",25);const T=new Map;T.set(0,"file"),T.set(1,"module"),T.set(2,"namespace"),T.set(3,"package"),T.set(4,"class"),T.set(5,"method"),T.set(6,"property"),T.set(7,"field"),T.set(8,"constructor"),T.set(9,"enum"),T.set(10,"interface"),T.set(11,"function"),T.set(12,"variable"),T.set(13,"constant"),T.set(14,"string"),T.set(15,"number"),T.set(16,"boolean"),T.set(17,"array"),T.set(18,"object"),T.set(19,"key"),T.set(20,"null"),T.set(21,"enum-member"),T.set(22,"struct"),T.set(23,"event"),T.set(24,"operator"),T.set(25,"type-parameter");function I(D){return E.get(D)}l.fromString=I;function B(D){return T.get(D)}l.toString=B;function O(D,x){const N=T.get(D);let V=N&&t.iconRegistry.get("symbol-"+N);return V||(console.info("No codicon found for SymbolKind "+D),V=t.Codicon.symbolProperty),`${x?"inline":"block"} ${V.classNames}`}l.toCssClassName=O})(n=e.SymbolKinds||(e.SymbolKinds={}));class i{constructor(E){this.value=E}}e.FoldingRangeKind=i,i.Comment=new i("comment"),i.Imports=new i("imports"),i.Region=new i("region");var g;(function(l){l[l.Collapsed=0]="Collapsed",l[l.Expanded=1]="Expanded"})(g=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var f;(function(l){l[l.Editing=0]="Editing",l[l.Preview=1]="Preview"})(f=e.CommentMode||(e.CommentMode={}));var s;(function(l){l[l.Other=0]="Other",l[l.Type=1]="Type",l[l.Parameter=2]="Parameter"})(s=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new b.LanguageFeatureRegistry,e.RenameProviderRegistry=new b.LanguageFeatureRegistry,e.CompletionProviderRegistry=new b.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new b.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new b.LanguageFeatureRegistry,e.HoverProviderRegistry=new b.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new b.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new b.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new b.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new b.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new b.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new b.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new b.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new b.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new b.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new b.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new b.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new b.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new b.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new b.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new b.LanguageFeatureRegistry,e.LinkProviderRegistry=new b.LanguageFeatureRegistry,e.ColorProviderRegistry=new b.LanguageFeatureRegistry,e.SelectionRangeRegistry=new b.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new b.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new b.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new b.LanguageFeatureRegistry,e.TokenizationRegistry=new P.TokenizationRegistryImpl;var v;(function(l){l[l.None=0]="None",l[l.Option=1]="Option",l[l.Default=2]="Default",l[l.Preferred=3]="Preferred"})(v=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(be[38],Ee([0,1,25,9,4]),function(re,e,u,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let P=u.userAgent||"";const t=new Map;t.set("false",!1),t.set("true",!0),t.set("isMac",u.isMacintosh),t.set("isLinux",u.isLinux),t.set("isWindows",u.isWindows),t.set("isWeb",u.isWeb),t.set("isMacNative",u.isMacintosh&&!u.isWeb),t.set("isEdge",P.indexOf("Edg/")>=0),t.set("isFirefox",P.indexOf("Firefox")>=0),t.set("isChrome",P.indexOf("Chrome")>=0),t.set("isSafari",P.indexOf("Safari")>=0);const A=Object.prototype.hasOwnProperty;var C;(function(O){O[O.False=0]="False",O[O.True=1]="True",O[O.Defined=2]="Defined",O[O.Not=3]="Not",O[O.Equals=4]="Equals",O[O.NotEquals=5]="NotEquals",O[O.And=6]="And",O[O.Regex=7]="Regex",O[O.NotRegex=8]="NotRegex",O[O.Or=9]="Or",O[O.In=10]="In",O[O.NotIn=11]="NotIn",O[O.Greater=12]="Greater",O[O.GreaterEquals=13]="GreaterEquals",O[O.Smaller=14]="Smaller",O[O.SmallerEquals=15]="SmallerEquals"})(C=e.ContextKeyExprType||(e.ContextKeyExprType={}));class k{static false(){return r.INSTANCE}static true(){return m.INSTANCE}static has(D){return a.create(D)}static equals(D,x){return h.create(D,x)}static notEquals(D,x){return w.create(D,x)}static regex(D,x){return i.create(D,x)}static in(D,x){return p.create(D,x)}static not(D){return o.create(D)}static and(...D){return s.create(D,null)}static or(...D){return v.create(D,null,!0)}static greater(D,x){return _.create(D,x)}static greaterEquals(D,x){return c.create(D,x)}static smaller(D,x){return R.create(D,x)}static smallerEquals(D,x){return n.create(D,x)}static deserialize(D,x=!1){if(!!D)return this._deserializeOrExpression(D,x)}static _deserializeOrExpression(D,x){let N=D.split("||");return v.create(N.map(V=>this._deserializeAndExpression(V,x)),null,!0)}static _deserializeAndExpression(D,x){let N=D.split("&&");return s.create(N.map(V=>this._deserializeOne(V,x)),null)}static _deserializeOne(D,x){if(D=D.trim(),D.indexOf("!=")>=0){let N=D.split("!=");return w.create(N[0].trim(),this._deserializeValue(N[1],x))}if(D.indexOf("==")>=0){let N=D.split("==");return h.create(N[0].trim(),this._deserializeValue(N[1],x))}if(D.indexOf("=~")>=0){let N=D.split("=~");return i.create(N[0].trim(),this._deserializeRegexValue(N[1],x))}if(D.indexOf(" in ")>=0){let N=D.split(" in ");return p.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(D)){const N=D.split(">=");return c.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(D)){const N=D.split(">");return _.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(D)){const N=D.split("<=");return n.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(D)){const N=D.split("<");return R.create(N[0].trim(),N[1].trim())}return/^\!\s*/.test(D)?o.create(D.substr(1).trim()):a.create(D)}static _deserializeValue(D,x){if(D=D.trim(),D==="true")return!0;if(D==="false")return!1;let N=/^'([^']*)'$/.exec(D);return N?N[1].trim():D}static _deserializeRegexValue(D,x){if((0,M.isFalsyOrWhitespace)(D)){if(x)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let N=D.indexOf("/"),V=D.lastIndexOf("/");if(N===V||N<0){if(x)throw new Error(`bad regexp-value '${D}', missing /-enclosure`);return console.warn(`bad regexp-value '${D}', missing /-enclosure`),null}let $=D.slice(N+1,V),z=D[V+1]==="i"?"i":"";try{return new RegExp($,z)}catch(ee){if(x)throw new Error(`bad regexp-value '${D}', parse error: ${ee}`);return console.warn(`bad regexp-value '${D}', parse error: ${ee}`),null}}}e.ContextKeyExpr=k;function F(O,D){const x=O?O.substituteConstants():void 0,N=D?D.substituteConstants():void 0;return!x&&!N?!0:!x||!N?!1:x.equals(N)}e.expressionsAreEqualWithConstantSubstitution=F;function y(O,D){return O.cmp(D)}class r{constructor(){this.type=0}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!1}serialize(){return"false"}keys(){return[]}map(D){return this}negate(){return m.INSTANCE}}e.ContextKeyFalseExpr=r,r.INSTANCE=new r;class m{constructor(){this.type=1}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!0}serialize(){return"true"}keys(){return[]}map(D){return this}negate(){return r.INSTANCE}}e.ContextKeyTrueExpr=m,m.INSTANCE=new m;class a{constructor(D,x){this.key=D,this.negated=x,this.type=2}static create(D,x=null){const N=t.get(D);return typeof N=="boolean"?N?m.INSTANCE:r.INSTANCE:new a(D,x)}cmp(D){return D.type!==this.type?this.type-D.type:E(this.key,D.key)}equals(D){return D.type===this.type?this.key===D.key:!1}substituteConstants(){const D=t.get(this.key);return typeof D=="boolean"?D?m.INSTANCE:r.INSTANCE:this}evaluate(D){return!!D.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(D){return D.mapDefined(this.key)}negate(){return this.negated||(this.negated=o.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=a;class h{constructor(D,x,N){this.key=D,this.value=x,this.negated=N,this.type=4}static create(D,x,N=null){if(typeof x=="boolean")return x?a.create(D,N):o.create(D,N);const V=t.get(D);return typeof V=="boolean"?x===(V?"true":"false")?m.INSTANCE:r.INSTANCE:new h(D,x,N)}cmp(D){return D.type!==this.type?this.type-D.type:T(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){const D=t.get(this.key);if(typeof D=="boolean"){const x=D?"true":"false";return this.value===x?m.INSTANCE:r.INSTANCE}return this}evaluate(D){return D.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(D){return D.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=w.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=h;class p{constructor(D,x){this.key=D,this.valueKey=x,this.type=10,this.negated=null}static create(D,x){return new p(D,x)}cmp(D){return D.type!==this.type?this.type-D.type:T(this.key,this.valueKey,D.key,D.valueKey)}equals(D){return D.type===this.type?this.key===D.key&&this.valueKey===D.valueKey:!1}substituteConstants(){return this}evaluate(D){const x=D.getValue(this.valueKey),N=D.getValue(this.key);return Array.isArray(x)?x.indexOf(N)>=0:typeof N=="string"&&typeof x=="object"&&x!==null?A.call(x,N):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(D){return D.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=S.create(this)),this.negated}}e.ContextKeyInExpr=p;class S{constructor(D){this._actual=D,this.type=11}static create(D){return new S(D)}cmp(D){return D.type!==this.type?this.type-D.type:this._actual.cmp(D._actual)}equals(D){return D.type===this.type?this._actual.equals(D._actual):!1}substituteConstants(){return this}evaluate(D){return!this._actual.evaluate(D)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(D){return new S(this._actual.map(D))}negate(){return this._actual}}e.ContextKeyNotInExpr=S;class w{constructor(D,x,N){this.key=D,this.value=x,this.negated=N,this.type=5}static create(D,x,N=null){if(typeof x=="boolean")return x?o.create(D,N):a.create(D,N);const V=t.get(D);return typeof V=="boolean"?x===(V?"true":"false")?r.INSTANCE:m.INSTANCE:new w(D,x,N)}cmp(D){return D.type!==this.type?this.type-D.type:T(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){const D=t.get(this.key);if(typeof D=="boolean"){const x=D?"true":"false";return this.value===x?r.INSTANCE:m.INSTANCE}return this}evaluate(D){return D.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(D){return D.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=h.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=w;class o{constructor(D,x){this.key=D,this.negated=x,this.type=3}static create(D,x=null){const N=t.get(D);return typeof N=="boolean"?N?r.INSTANCE:m.INSTANCE:new o(D,x)}cmp(D){return D.type!==this.type?this.type-D.type:E(this.key,D.key)}equals(D){return D.type===this.type?this.key===D.key:!1}substituteConstants(){const D=t.get(this.key);return typeof D=="boolean"?D?r.INSTANCE:m.INSTANCE:this}evaluate(D){return!D.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(D){return D.mapNot(this.key)}negate(){return this.negated||(this.negated=a.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=o;function d(O,D){if(typeof O=="string"){const x=parseFloat(O);isNaN(x)||(O=x)}return typeof O=="string"||typeof O=="number"?D(O):r.INSTANCE}class _{constructor(D,x,N){this.key=D,this.value=x,this.negated=N,this.type=12}static create(D,x,N=null){return d(x,V=>new _(D,V,N))}cmp(D){return D.type!==this.type?this.type-D.type:T(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(D){return D.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=n.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=_;class c{constructor(D,x,N){this.key=D,this.value=x,this.negated=N,this.type=13}static create(D,x,N=null){return d(x,V=>new c(D,V,N))}cmp(D){return D.type!==this.type?this.type-D.type:T(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(D){return D.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=R.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=c;class R{constructor(D,x,N){this.key=D,this.value=x,this.negated=N,this.type=14}static create(D,x,N=null){return d(x,V=>new R(D,V,N))}cmp(D){return D.type!==this.type?this.type-D.type:T(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(D){return D.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=R;class n{constructor(D,x,N){this.key=D,this.value=x,this.negated=N,this.type=15}static create(D,x,N=null){return d(x,V=>new n(D,V,N))}cmp(D){return D.type!==this.type?this.type-D.type:T(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(D){return D.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=_.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=n;class i{constructor(D,x){this.key=D,this.regexp=x,this.type=7,this.negated=null}static create(D,x){return new i(D,x)}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.key<D.key)return-1;if(this.key>D.key)return 1;const x=this.regexp?this.regexp.source:"",N=D.regexp?D.regexp.source:"";return x<N?-1:x>N?1:0}equals(D){if(D.type===this.type){const x=this.regexp?this.regexp.source:"",N=D.regexp?D.regexp.source:"";return this.key===D.key&&x===N}return!1}substituteConstants(){return this}evaluate(D){let x=D.getValue(this.key);return this.regexp?this.regexp.test(x):!1}serialize(){const D=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${D}`}keys(){return[this.key]}map(D){return D.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=g.create(this)),this.negated}}e.ContextKeyRegexExpr=i;class g{constructor(D){this._actual=D,this.type=8}static create(D){return new g(D)}cmp(D){return D.type!==this.type?this.type-D.type:this._actual.cmp(D._actual)}equals(D){return D.type===this.type?this._actual.equals(D._actual):!1}substituteConstants(){return this}evaluate(D){return!this._actual.evaluate(D)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(D){return new g(this._actual.map(D))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=g;function f(O){let D=null;for(let x=0,N=O.length;x<N;x++){const V=O[x].substituteConstants();if(O[x]!==V&&D===null){D=[];for(let $=0;$<x;$++)D[$]=O[$]}D!==null&&(D[x]=V)}return D===null?O:D}class s{constructor(D,x){this.expr=D,this.negated=x,this.type=6}static create(D,x){return s._normalizeArr(D,x)}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let x=0,N=this.expr.length;x<N;x++){const V=y(this.expr[x],D.expr[x]);if(V!==0)return V}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let x=0,N=this.expr.length;x<N;x++)if(!this.expr[x].equals(D.expr[x]))return!1;return!0}return!1}substituteConstants(){const D=f(this.expr);return D===this.expr?this:s.create(D,this.negated)}evaluate(D){for(let x=0,N=this.expr.length;x<N;x++)if(!this.expr[x].evaluate(D))return!1;return!0}static _normalizeArr(D,x){const N=[];let V=!1;for(const $ of D)if(!!$){if($.type===1){V=!0;continue}if($.type===0)return r.INSTANCE;if($.type===6){N.push(...$.expr);continue}N.push($)}if(N.length===0&&V)return m.INSTANCE;if(N.length!==0){if(N.length===1)return N[0];N.sort(y);for(let $=1;$<N.length;$++)N[$-1].equals(N[$])&&(N.splice($,1),$--);if(N.length===1)return N[0];for(;N.length>1;){const $=N[N.length-1];if($.type!==9)break;N.pop();const z=N.pop(),ee=N.length===0,j=v.create($.expr.map(Q=>s.create([Q,z],null)),null,ee);j&&(N.push(j),N.sort(y))}return N.length===1?N[0]:new s(N,x)}}serialize(){return this.expr.map(D=>D.serialize()).join(" && ")}keys(){const D=[];for(let x of this.expr)D.push(...x.keys());return D}map(D){return new s(this.expr.map(x=>x.map(D)),null)}negate(){if(!this.negated){const D=[];for(let x of this.expr)D.push(x.negate());this.negated=v.create(D,this,!0)}return this.negated}}class v{constructor(D,x){this.expr=D,this.negated=x,this.type=9}static create(D,x,N){return v._normalizeArr(D,x,N)}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let x=0,N=this.expr.length;x<N;x++){const V=y(this.expr[x],D.expr[x]);if(V!==0)return V}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let x=0,N=this.expr.length;x<N;x++)if(!this.expr[x].equals(D.expr[x]))return!1;return!0}return!1}substituteConstants(){const D=f(this.expr);return D===this.expr?this:v.create(D,this.negated,!1)}evaluate(D){for(let x=0,N=this.expr.length;x<N;x++)if(this.expr[x].evaluate(D))return!0;return!1}static _normalizeArr(D,x,N){let V=[],$=!1;if(D){for(let z=0,ee=D.length;z<ee;z++){const j=D[z];if(!!j){if(j.type===0){$=!0;continue}if(j.type===1)return m.INSTANCE;if(j.type===9){V=V.concat(j.expr);continue}V.push(j)}}if(V.length===0&&$)return r.INSTANCE;V.sort(y)}if(V.length!==0){if(V.length===1)return V[0];for(let z=1;z<V.length;z++)V[z-1].equals(V[z])&&(V.splice(z,1),z--);if(V.length===1)return V[0];if(N){for(let z=0;z<V.length;z++)for(let ee=z+1;ee<V.length;ee++)I(V[z],V[ee])&&(V.splice(ee,1),ee--);if(V.length===1)return V[0]}return new v(V,x)}}serialize(){return this.expr.map(D=>D.serialize()).join(" || ")}keys(){const D=[];for(let x of this.expr)D.push(...x.keys());return D}map(D){return new v(this.expr.map(x=>x.map(D)),null)}negate(){if(!this.negated){let D=[];for(let x of this.expr)D.push(x.negate());for(;D.length>1;){const x=D.shift(),N=D.shift(),V=[];for(const z of B(x))for(const ee of B(N))V.push(s.create([z,ee],null));const $=D.length===0;D.unshift(v.create(V,null,$))}this.negated=D[0]}return this.negated}}class l extends a{constructor(D,x,N){super(D,null);this._defaultValue=x,typeof N=="object"?l._info.push({...N,key:D}):N!==!0&&l._info.push({key:D,description:N,type:x!=null?typeof x:void 0})}static all(){return l._info.values()}bindTo(D){return D.createKey(this.key,this._defaultValue)}getValue(D){return D.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(D){return h.create(this.key,D)}notEqualsTo(D){return w.create(this.key,D)}}e.RawContextKey=l,l._info=[],e.IContextKeyService=(0,b.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function E(O,D){return O<D?-1:O>D?1:0}function T(O,D,x,N){return O<x?-1:O>x?1:D<N?-1:D>N?1:0}function I(O,D){if(D.type===6&&O.type!==9&&O.type!==6){for(const V of D.expr)if(O.equals(V))return!0}const x=O.negate(),N=B(x).concat(B(D));N.sort(y);for(let V=0;V<N.length;V++){const z=N[V].negate();for(let ee=V+1;ee<N.length;ee++){const j=N[ee];if(z.equals(j))return!0}}return!1}e.implies=I;function B(O){return O.type===9?O.expr:[O]}}),define(be[143],Ee([0,1,4]),function(re,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,u.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,u.refineServiceDecorator)(e.IEnvironmentService)}),define(be[47],Ee([0,1,20,17,9,10,2,122,4]),function(re,e,u,M,b,P,t,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,C.createDecorator)("fileService");function k(N){return N.create===!0}e.isFileOpenForWriteOptions=k;var F;(function(N){N[N.Unknown=0]="Unknown",N[N.File=1]="File",N[N.Directory=2]="Directory",N[N.SymbolicLink=64]="SymbolicLink"})(F=e.FileType||(e.FileType={}));var y;(function(N){N[N.Readonly=1]="Readonly"})(y=e.FilePermission||(e.FilePermission={}));var r;(function(N){N[N.FileReadWrite=2]="FileReadWrite",N[N.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",N[N.FileReadStream=16]="FileReadStream",N[N.FileFolderCopy=8]="FileFolderCopy",N[N.PathCaseSensitive=1024]="PathCaseSensitive",N[N.Readonly=2048]="Readonly",N[N.Trash=4096]="Trash",N[N.FileWriteUnlock=8192]="FileWriteUnlock"})(r=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function m(N){return!!(N.capabilities&2)}e.hasReadWriteCapability=m;function a(N){return!!(N.capabilities&8)}e.hasFileFolderCopyCapability=a;function h(N){return!!(N.capabilities&4)}e.hasOpenReadWriteCloseCapability=h;function p(N){return!!(N.capabilities&16)}e.hasFileReadStreamCapability=p;var S;(function(N){N.FileExists="EntryExists",N.FileNotFound="EntryNotFound",N.FileNotADirectory="EntryNotADirectory",N.FileIsADirectory="EntryIsADirectory",N.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",N.FileTooLarge="EntryTooLarge",N.FileWriteLocked="EntryWriteLocked",N.NoPermissions="NoPermissions",N.Unavailable="Unavailable",N.Unknown="Unknown"})(S=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class w extends Error{constructor(V,$){super(V);this.code=$}}e.FileSystemProviderError=w;function o(N,V){const $=new w(N.toString(),V);return _($,V),$}e.createFileSystemProviderError=o;function d(N){return N||o((0,A.localize)(0,null),S.Unknown)}e.ensureFileSystemProviderError=d;function _(N,V){return N.name=V?`${V} (FileSystemError)`:"FileSystemError",N}e.markAsFileSystemProviderError=_;function c(N){if(!N)return S.Unknown;if(N instanceof w)return N.code;const V=/^(.+) \(FileSystemError\)$/.exec(N.name);if(!V)return S.Unknown;switch(V[1]){case S.FileExists:return S.FileExists;case S.FileIsADirectory:return S.FileIsADirectory;case S.FileNotADirectory:return S.FileNotADirectory;case S.FileNotFound:return S.FileNotFound;case S.FileExceedsMemoryLimit:return S.FileExceedsMemoryLimit;case S.FileTooLarge:return S.FileTooLarge;case S.FileWriteLocked:return S.FileWriteLocked;case S.NoPermissions:return S.NoPermissions;case S.Unavailable:return S.Unavailable}return S.Unknown}e.toFileSystemProviderErrorCode=c;function R(N){if(N instanceof v)return N.fileOperationResult;switch(c(N)){case S.FileNotFound:return 1;case S.FileIsADirectory:return 0;case S.FileNotADirectory:return 10;case S.FileWriteLocked:return 5;case S.NoPermissions:return 6;case S.FileExists:return 4;case S.FileExceedsMemoryLimit:return 9;case S.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=R;var n;(function(N){N[N.CREATE=0]="CREATE",N[N.DELETE=1]="DELETE",N[N.MOVE=2]="MOVE",N[N.COPY=3]="COPY"})(n=e.FileOperation||(e.FileOperation={}));class i{constructor(V,$,z){this.resource=V,this.operation=$,this.target=z}isOperation(V){return this.operation===V}}e.FileOperationEvent=i;var g;(function(N){N[N.UPDATED=0]="UPDATED",N[N.ADDED=1]="ADDED",N[N.DELETED=2]="DELETED"})(g=e.FileChangeType||(e.FileChangeType={}));class f{constructor(V,$){this.added=void 0,this.updated=void 0,this.deleted=void 0;const z=new Map;for(const ee of V){const j=z.get(ee.type);j?j.push([ee.resource,ee]):z.set(ee.type,[[ee.resource,ee]])}for(const[ee,j]of z)switch(ee){case 1:this.added=u.TernarySearchTree.forUris(()=>$),this.added.fill(j);break;case 0:this.updated=u.TernarySearchTree.forUris(()=>$),this.updated.fill(j);break;case 2:this.deleted=u.TernarySearchTree.forUris(()=>$),this.deleted.fill(j);break}}contains(V,...$){return this.doContains(V,{includeChildren:!1},...$)}affects(V,...$){return this.doContains(V,{includeChildren:!0},...$)}doContains(V,$,...z){if(!V)return!1;const ee=z.length>0;return!!((!ee||z.includes(1))&&(this.added?.get(V)||$.includeChildren&&this.added?.findSuperstr(V))||(!ee||z.includes(0))&&(this.updated?.get(V)||$.includeChildren&&this.updated?.findSuperstr(V))||(!ee||z.includes(2))&&(this.deleted?.findSubstr(V)||$.includeChildren&&this.deleted?.findSuperstr(V)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=f;function s(N,V,$){return!N||!V||N===V||V.length>N.length?!1:(V.charAt(V.length-1)!==M.sep&&(V+=M.sep),$?(0,b.startsWithIgnoreCase)(N,V):N.indexOf(V)===0)}e.isParent=s;class v extends Error{constructor(V,$,z){super(V);this.fileOperationResult=$,this.options=z}}e.FileOperationError=v;class l extends v{constructor(V,$,z){super(V,2,z);this.stat=$}}e.NotModifiedSinceFileOperationError=l;var E;(function(N){N[N.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",N[N.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",N[N.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",N[N.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",N[N.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",N[N.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",N[N.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",N[N.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",N[N.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",N[N.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",N[N.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",N[N.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(E=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var T;(function(N){N[N.FILE=0]="FILE",N[N.FOLDER=1]="FOLDER",N[N.ROOT_FOLDER=2]="ROOT_FOLDER"})(T=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function I(N){if(!(typeof N.size!="number"||typeof N.mtime!="number"))return N.mtime.toString(29)+N.size.toString(31)}e.etag=I;async function B(N,V){if(!V.hasProvider(t.URI.from({scheme:N.scheme})))return new Promise($=>{const z=V.onDidChangeFileSystemProviderRegistrations(ee=>{ee.scheme===N.scheme&&ee.added&&(z.dispose(),$())})})}e.whenProviderRegistered=B,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class O{static formatSize(V){return(0,P.isNumber)(V)||(V=0),V<O.KB?(0,A.localize)(1,null,V.toFixed(0)):V<O.MB?(0,A.localize)(2,null,(V/O.KB).toFixed(2)):V<O.GB?(0,A.localize)(3,null,(V/O.MB).toFixed(2)):V<O.TB?(0,A.localize)(4,null,(V/O.GB).toFixed(2)):(0,A.localize)(5,null,(V/O.TB).toFixed(2))}}e.ByteSize=O,O.KB=1024,O.MB=O.KB*O.KB,O.GB=O.MB*O.KB,O.TB=O.GB*O.KB;var D;(function(N){N[N.IA32=0]="IA32",N[N.OTHER=1]="OTHER"})(D=e.Arch||(e.Arch={}));function x(N){return{maxFileSize:N===0?300*O.MB:16*O.GB,maxHeapSize:N===0?700*O.MB:2*700*O.MB}}e.getPlatformLimits=x}),define(be[62],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class u{constructor(...b){this._entries=new Map;for(let[P,t]of b)this.set(P,t)}set(b,P){const t=this._entries.get(b);return this._entries.set(b,P),t}has(b){return this._entries.has(b)}get(b){return this._entries.get(b)}}e.ServiceCollection=u}),define(be[144],Ee([0,1,13,16,82,140,4,62]),function(re,e,u,M,b,P,t,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const C=!1;class k extends Error{constructor(a){super("cyclic dependency between services");this.message=a.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${a.toString()}`}}class F{constructor(a=new A.ServiceCollection,h=!1,p){this._activeInstantiations=new Set,this._services=a,this._strict=h,this._parent=p,this._services.set(t.IInstantiationService,this)}createChild(a){return new F(a,this._strict,this)}invokeFunction(a,...h){let p=r.traceInvocation(a),S=!1;try{return a({get:o=>{if(S)throw(0,M.illegalState)("service accessor is only valid during the invocation of its target method");const d=this._getOrCreateServiceInstance(o,p);if(!d)throw new Error(`[invokeFunction] unknown service '${o}'`);return d}},...h)}finally{S=!0,p.stop()}}createInstance(a,...h){let p,S;return a instanceof b.SyncDescriptor?(p=r.traceCreation(a.ctor),S=this._createInstance(a.ctor,a.staticArguments.concat(h),p)):(p=r.traceCreation(a),S=this._createInstance(a,h,p)),p.stop(),S}_createInstance(a,h=[],p){let S=t._util.getServiceDependencies(a).sort((d,_)=>d.index-_.index),w=[];for(const d of S){let _=this._getOrCreateServiceInstance(d.id,p);if(!_&&this._strict&&!d.optional)throw new Error(`[createInstance] ${a.name} depends on UNKNOWN service ${d.id}.`);w.push(_)}let o=S.length>0?S[0].index:h.length;if(h.length!==o){console.warn(`[createInstance] First service dependency of ${a.name} at position ${o+1} conflicts with ${h.length} static arguments`);let d=o-h.length;d>0?h=h.concat(new Array(d)):h=h.slice(0,o)}return new a(...[...h,...w])}_setServiceInstance(a,h){if(this._services.get(a)instanceof b.SyncDescriptor)this._services.set(a,h);else if(this._parent)this._parent._setServiceInstance(a,h);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(a){let h=this._services.get(a);return!h&&this._parent?this._parent._getServiceInstanceOrDescriptor(a):h}_getOrCreateServiceInstance(a,h){let p=this._getServiceInstanceOrDescriptor(a);return p instanceof b.SyncDescriptor?this._safeCreateAndCacheServiceInstance(a,p,h.branch(a,!0)):(h.branch(a,!1),p)}_safeCreateAndCacheServiceInstance(a,h,p){if(this._activeInstantiations.has(a))throw new Error(`illegal state - RECURSIVELY instantiating service '${a}'`);this._activeInstantiations.add(a);try{return this._createAndCacheServiceInstance(a,h,p)}finally{this._activeInstantiations.delete(a)}}_createAndCacheServiceInstance(a,h,p){const S=new P.Graph(d=>d.id.toString());let w=0;const o=[{id:a,desc:h,_trace:p}];for(;o.length;){const d=o.pop();if(S.lookupOrInsertNode(d),w++>1e3)throw new k(S);for(let _ of t._util.getServiceDependencies(d.desc.ctor)){let c=this._getServiceInstanceOrDescriptor(_.id);if(!c&&!_.optional&&console.warn(`[createInstance] ${a} depends on ${_.id} which is NOT registered.`),c instanceof b.SyncDescriptor){const R={id:_.id,desc:c,_trace:d._trace.branch(_.id,!0)};S.insertEdge(d,R),o.push(R)}}}for(;;){const d=S.roots();if(d.length===0){if(!S.isEmpty())throw new k(S);break}for(const{data:_}of d){if(this._getServiceInstanceOrDescriptor(_.id)instanceof b.SyncDescriptor){const R=this._createServiceInstanceWithOwner(_.id,_.desc.ctor,_.desc.staticArguments,_.desc.supportsDelayedInstantiation,_._trace);this._setServiceInstance(_.id,R)}S.removeNode(_)}}return this._getServiceInstanceOrDescriptor(a)}_createServiceInstanceWithOwner(a,h,p=[],S,w){if(this._services.get(a)instanceof b.SyncDescriptor)return this._createServiceInstance(h,p,S,w);if(this._parent)return this._parent._createServiceInstanceWithOwner(a,h,p,S,w);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}_createServiceInstance(a,h=[],p,S){if(p){const w=new u.IdleValue(()=>this._createInstance(a,h,S));return new Proxy(Object.create(null),{get(o,d){if(d in o)return o[d];let _=w.value,c=_[d];return typeof c!="function"||(c=c.bind(_),o[d]=c),c},set(o,d,_){return w.value[d]=_,!0}})}else return this._createInstance(a,h,S)}}e.InstantiationService=F;var y;(function(m){m[m.Creation=0]="Creation",m[m.Invocation=1]="Invocation",m[m.Branch=2]="Branch"})(y||(y={}));class r{constructor(a,h){this.type=a,this.name=h,this._start=Date.now(),this._dep=[]}static traceInvocation(a){return C?new r(1,a.name||a.toString().substring(0,42).replace(/\n/g,"")):r._None}static traceCreation(a){return C?new r(0,a.name):r._None}branch(a,h){let p=new r(2,a.toString());return this._dep.push([a,h,p]),p}stop(){let a=Date.now()-this._start;r._totals+=a;let h=!1;function p(w,o){let d=[],_=new Array(w+1).join("	");for(const[c,R,n]of o._dep)if(R&&n){h=!0,d.push(`${_}CREATES -> ${c}`);let i=p(w+1,n);i&&d.push(i)}else d.push(`${_}uses -> ${c}`);return d.join(`
`)}let S=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${a.toFixed(2)}ms (grand total ${r._totals.toFixed(2)}ms)`];(a>2||h)&&console.log(S.join(`
`))}}r._None=new class extends r{constructor(){super(-1,null)}stop(){}branch(){return this}},r._totals=0}),define(be[12],Ee([0,1,46,3,6,25,4]),function(re,e,u,M,b,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,t.createDecorator)("logService"),e.ILoggerService=(0,t.createDecorator)("loggerService");function A(){return new Date().toISOString()}var C;(function(R){R[R.Trace=0]="Trace",R[R.Debug=1]="Debug",R[R.Info=2]="Info",R[R.Warning=3]="Warning",R[R.Error=4]="Error",R[R.Critical=5]="Critical",R[R.Off=6]="Off"})(C=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=C.Info;function k(R,n,i){switch(n){case C.Trace:R.trace(i);break;case C.Debug:R.debug(i);break;case C.Info:R.info(i);break;case C.Warning:R.warn(i);break;case C.Error:R.error(i);break;case C.Critical:R.critical(i);break;default:throw new Error("Invalid log level")}}e.log=k;function F(R){let n="";for(let i=0;i<R.length;i++){let g=R[i];if(typeof g=="object")try{g=JSON.stringify(g)}catch(f){}n+=(i>0?" ":"")+g}return n}e.format=F;class y extends b.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new M.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(n){this.level!==n&&(this.level=n,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=y;class r extends y{constructor(n){super();this.logAlways=n}checkLogLevel(n){return this.logAlways||this.getLevel()<=n}trace(n,...i){this.checkLogLevel(C.Trace)&&this.log(C.Trace,F([n,...i]))}debug(n,...i){this.checkLogLevel(C.Debug)&&this.log(C.Debug,F([n,...i]))}info(n,...i){this.checkLogLevel(C.Info)&&this.log(C.Info,F([n,...i]))}warn(n,...i){this.checkLogLevel(C.Warning)&&this.log(C.Warning,F([n,...i]))}error(n,...i){if(this.checkLogLevel(C.Error))if(n instanceof Error){const g=Array.prototype.slice.call(arguments);g[0]=n.stack,this.log(C.Error,F(g))}else this.log(C.Error,F([n,...i]))}critical(n,...i){this.checkLogLevel(C.Critical)&&this.log(C.Critical,F([n,...i]))}flush(){}}e.AbstractMessageLogger=r;class m extends y{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n),this.useColors=!P.isWindows}trace(n,...i){this.getLevel()<=C.Trace&&(this.useColors?console.log(`[90m[main ${A()}][0m`,n,...i):console.log(`[main ${A()}]`,n,...i))}debug(n,...i){this.getLevel()<=C.Debug&&(this.useColors?console.log(`[90m[main ${A()}][0m`,n,...i):console.log(`[main ${A()}]`,n,...i))}info(n,...i){this.getLevel()<=C.Info&&(this.useColors?console.log(`[90m[main ${A()}][0m`,n,...i):console.log(`[main ${A()}]`,n,...i))}warn(n,...i){this.getLevel()<=C.Warning&&(this.useColors?console.warn(`[93m[main ${A()}][0m`,n,...i):console.warn(`[main ${A()}]`,n,...i))}error(n,...i){this.getLevel()<=C.Error&&(this.useColors?console.error(`[91m[main ${A()}][0m`,n,...i):console.error(`[main ${A()}]`,n,...i))}critical(n,...i){this.getLevel()<=C.Critical&&(this.useColors?console.error(`[90m[main ${A()}][0m`,n,...i):console.error(`[main ${A()}]`,n,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=m;class a extends y{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n)}trace(n,...i){this.getLevel()<=C.Trace&&console.log("%cTRACE","color: #888",n,...i)}debug(n,...i){this.getLevel()<=C.Debug&&console.log("%cDEBUG","background: #eee; color: #888",n,...i)}info(n,...i){this.getLevel()<=C.Info&&console.log("%c INFO","color: #33f",n,...i)}warn(n,...i){this.getLevel()<=C.Warning&&console.log("%c WARN","color: #993",n,...i)}error(n,...i){this.getLevel()<=C.Error&&console.log("%c  ERR","color: #f33",n,...i)}critical(n,...i){this.getLevel()<=C.Critical&&console.log("%cCRITI","background: #f33; color: white",n,...i)}dispose(){}flush(){}}e.ConsoleLogger=a;class h extends y{constructor(n,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=n,this.setLevel(i)}trace(n,...i){this.getLevel()<=C.Trace&&this.adapter.log(C.Trace,[this.extractMessage(n),...i])}debug(n,...i){this.getLevel()<=C.Debug&&this.adapter.log(C.Debug,[this.extractMessage(n),...i])}info(n,...i){this.getLevel()<=C.Info&&this.adapter.log(C.Info,[this.extractMessage(n),...i])}warn(n,...i){this.getLevel()<=C.Warning&&this.adapter.log(C.Warning,[this.extractMessage(n),...i])}error(n,...i){this.getLevel()<=C.Error&&this.adapter.log(C.Error,[this.extractMessage(n),...i])}critical(n,...i){this.getLevel()<=C.Critical&&this.adapter.log(C.Critical,[this.extractMessage(n),...i])}extractMessage(n){return typeof n=="string"?n:(0,u.toErrorMessage)(n,this.getLevel()<=C.Trace)}dispose(){}flush(){}}e.AdapterLogger=h;class p extends y{constructor(n){super();this.logServices=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const i of this.logServices)i.setLevel(n);super.setLevel(n)}trace(n,...i){for(const g of this.logServices)g.trace(n,...i)}debug(n,...i){for(const g of this.logServices)g.debug(n,...i)}info(n,...i){for(const g of this.logServices)g.info(n,...i)}warn(n,...i){for(const g of this.logServices)g.warn(n,...i)}error(n,...i){for(const g of this.logServices)g.error(n,...i)}critical(n,...i){for(const g of this.logServices)g.critical(n,...i)}flush(){for(const n of this.logServices)n.flush()}dispose(){for(const n of this.logServices)n.dispose()}}e.MultiplexLogService=p;class S extends b.Disposable{constructor(n){super();this.logger=n,this._register(n)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(n){this.logger.setLevel(n)}getLevel(){return this.logger.getLevel()}trace(n,...i){this.logger.trace(n,...i)}debug(n,...i){this.logger.debug(n,...i)}info(n,...i){this.logger.info(n,...i)}warn(n,...i){this.logger.warn(n,...i)}error(n,...i){this.logger.error(n,...i)}critical(n,...i){this.logger.critical(n,...i)}flush(){this.logger.flush()}}e.LogService=S;class w extends b.Disposable{constructor(n,i){super();this.logLevel=n,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(g=>{this.logLevel=g,this.logLevelChangeableLoggers.forEach(f=>f.setLevel(g))}))}getLogger(n){return this.loggers.get(n.toString())}createLogger(n,i){let g=this.loggers.get(n.toString());return g||(g=this.doCreateLogger(n,i?.always?C.Trace:this.logLevel,i),this.loggers.set(n.toString(),g),i?.always||this.logLevelChangeableLoggers.push(g)),g}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(n=>n.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=w;class o{constructor(){this.onDidChangeLogLevel=new M.Emitter().event}setLevel(n){}getLevel(){return C.Info}trace(n,...i){}debug(n,...i){}info(n,...i){}warn(n,...i){}error(n,...i){}critical(n,...i){}dispose(){}flush(){}}e.NullLogService=o;function d(R){if(R.verbose)return C.Trace;if(typeof R.logLevel=="string"){const n=_(R.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=d;function _(R){switch(R){case"trace":return C.Trace;case"debug":return C.Debug;case"info":return C.Info;case"warn":return C.Warning;case"error":return C.Error;case"critical":return C.Critical;case"off":return C.Off}}e.parseLogLevel=_;function c(R){switch(R){case C.Trace:return"trace";case C.Debug:return"debug";case C.Info:return"info";case C.Warning:return"warn";case C.Error:return"error";case C.Critical:return"critical";case C.Off:return"off"}}e.LogLevelToString=c}),define(be[83],Ee([0,1,36,123,4]),function(re,e,u,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var P;(function(C){C[C.Unnecessary=1]="Unnecessary",C[C.Deprecated=2]="Deprecated"})(P=e.MarkerTag||(e.MarkerTag={}));var t;(function(C){C[C.Hint=1]="Hint",C[C.Info=2]="Info",C[C.Warning=4]="Warning",C[C.Error=8]="Error"})(t=e.MarkerSeverity||(e.MarkerSeverity={})),function(C){function k(a,h){return h-a}C.compare=k;const F=Object.create(null);F[C.Error]=(0,M.localize)(0,null),F[C.Warning]=(0,M.localize)(1,null),F[C.Info]=(0,M.localize)(2,null);function y(a){return F[a]||""}C.toString=y;function r(a){switch(a){case u.default.Error:return C.Error;case u.default.Warning:return C.Warning;case u.default.Info:return C.Info;case u.default.Ignore:return C.Hint}}C.fromSeverity=r;function m(a){switch(a){case C.Error:return u.default.Error;case C.Warning:return u.default.Warning;case C.Info:return u.default.Info;case C.Hint:return u.default.Ignore}}C.toSeverity=m}(t=e.MarkerSeverity||(e.MarkerSeverity={}));var A;(function(C){const k="";function F(r){return y(r,!0)}C.makeKey=F;function y(r,m){let a=[k];return r.source?a.push(r.source.replace("\xA6","\\\xA6")):a.push(k),r.code?typeof r.code=="string"?a.push(r.code.replace("\xA6","\\\xA6")):a.push(r.code.value.replace("\xA6","\\\xA6")):a.push(k),r.severity!==void 0&&r.severity!==null?a.push(t.toString(r.severity)):a.push(k),r.message&&m?a.push(r.message.replace("\xA6","\\\xA6")):a.push(k),r.startLineNumber!==void 0&&r.startLineNumber!==null?a.push(r.startLineNumber.toString()):a.push(k),r.startColumn!==void 0&&r.startColumn!==null?a.push(r.startColumn.toString()):a.push(k),r.endLineNumber!==void 0&&r.endLineNumber!==null?a.push(r.endLineNumber.toString()):a.push(k),r.endColumn!==void 0&&r.endColumn!==null?a.push(r.endColumn.toString()):a.push(k),a.push(k),a.join("\xA6")}C.makeKeyOptionalMessage=y})(A=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,b.createDecorator)("markerService")}),define(be[145],Ee([0,1,3,36,4]),function(re,e,u,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=M.default,e.INotificationService=(0,b.createDecorator)("notificationService");var P;(function(k){k[k.WORKSPACE=0]="WORKSPACE",k[k.GLOBAL=1]="GLOBAL"})(P=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var t;(function(k){k[k.OFF=0]="OFF",k[k.SILENT=1]="SILENT",k[k.ERROR=2]="ERROR"})(t=e.NotificationsFilter||(e.NotificationsFilter={}));class A{constructor(){this.progress=new C,this.onDidClose=u.Event.None,this.onDidChangeVisibility=u.Event.None}updateSeverity(F){}updateMessage(F){}updateActions(F){}close(){}}e.NoOpNotification=A;class C{infinite(){}done(){}total(F){}worked(F){}}e.NoOpProgress=C}),define(be[146],Ee([0,1,6,9,2,4]),function(re,e,u,M,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,P.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return u.Disposable.None},registerValidator(){return u.Disposable.None},registerExternalUriResolver(){return u.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return u.Disposable.None},async open(){return!1},async resolveExternalUri(C){return{resolved:C,dispose(){}}}});function t(C,k){return b.URI.isUri(C)?(0,M.equalsIgnoreCase)(C.scheme,k):(0,M.startsWithIgnoreCase)(C,k+":")}e.matchesScheme=t;function A(C,...k){return k.some(F=>t(C,F))}e.matchesSomeScheme=A});var Ue=this&&this.__decorate||function(re,e,u,M){var b=arguments.length,P=b<3?e:M===null?M=Object.getOwnPropertyDescriptor(e,u):M,t;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")P=Reflect.decorate(re,e,u,M);else for(var A=re.length-1;A>=0;A--)(t=re[A])&&(P=(b<3?t(P):b>3?t(e,u,P):t(e,u))||P);return b>3&&P&&Object.defineProperty(e,u,P),P},Be=this&&this.__param||function(re,e){return function(u,M){e(u,M,re)}};define(be[147],Ee([0,1,13,21,6,4]),function(re,e,u,M,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,P.createDecorator)("progressService");var t;(function(F){F[F.Explorer=1]="Explorer",F[F.Scm=3]="Scm",F[F.Extensions=5]="Extensions",F[F.Window=10]="Window",F[F.Notification=15]="Notification",F[F.Dialog=20]="Dialog"})(t=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class A{constructor(y){this.callback=y}get value(){return this._value}report(y){this._value=y,this.callback(this._value)}}e.Progress=A,A.None=Object.freeze({report(){}});let C=class extends b.Disposable{constructor(y,r){super();this.deferred=new u.DeferredPromise,r.withProgress(y,m=>(this.reporter=m,this.lastStep&&m.report(this.lastStep),this.deferred.p)),this._register((0,b.toDisposable)(()=>this.deferred.complete()))}report(y){this.reporter?this.reporter.report(y):this.lastStep=y}};C=Ue([Be(1,e.IProgressService)],C),e.UnmanagedProgress=C;class k extends b.Disposable{constructor(y){super();this.progressIndicator=y,this.currentOperationId=0,this.currentOperationDisposables=this._register(new b.DisposableStore)}start(y){this.stop();const r=++this.currentOperationId,m=new M.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{r===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},y),this.currentOperationDisposables.add((0,b.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,b.toDisposable)(()=>m.cancel())),this.currentOperationDisposables.add((0,b.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:r,token:m.token,stop:()=>this.doStop(r),isCurrent:()=>this.currentOperationId===r}}stop(){this.doStop(this.currentOperationId)}doStop(y){this.currentOperationId===y&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=k,e.IEditorProgressService=(0,P.createDecorator)("editorProgressService")}),define(be[30],Ee([0,1,43,10]),function(re,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class b{constructor(){this.data=new Map}add(t,A){u.ok(M.isString(t)),u.ok(M.isObject(A)),u.ok(!this.data.has(t),"There is already an extension with this id"),this.data.set(t,A)}knows(t){return this.data.has(t)}as(t){return this.data.get(t)||null}}e.Registry=new b}),define(be[84],Ee([0,1,3,30]),function(re,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function b(A){return A.length>0&&A.charAt(A.length-1)==="#"?A.substring(0,A.length-1):A}class P{constructor(){this._onDidChangeSchema=new u.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(C,k){this.schemasById[b(C)]=k,this._onDidChangeSchema.fire(C)}notifySchemaChanged(C){this._onDidChangeSchema.fire(C)}getSchemaContributions(){return{schemas:this.schemasById}}}const t=new P;M.Registry.add(e.Extensions.JSONContribution,t)}),define(be[63],Ee([0,1,15,3,10,120,84,30]),function(re,e,u,M,b,P,t,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var C;(function(w){w.Multiline="multilineText",w.Singleline="singlelineText"})(C=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var k;(function(w){w[w.APPLICATION=1]="APPLICATION",w[w.MACHINE=2]="MACHINE",w[w.WINDOW=3]="WINDOW",w[w.RESOURCE=4]="RESOURCE",w[w.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",w[w.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(k=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const F=A.Registry.as(t.Extensions.JSONContribution);class y{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new M.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new M.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:P.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},F.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(o,d=!0){this.registerConfigurations([o],d)}registerConfigurations(o,d=!0){const _=this.doRegisterConfigurations(o,d);F.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(_)}deregisterConfigurations(o){const d=this.doDeregisterConfigurations(o);F.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(d)}updateConfigurations({add:o,remove:d}){const _=[];_.push(...this.doDeregisterConfigurations(d)),_.push(...this.doRegisterConfigurations(o,!1)),F.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,u.distinct)(_))}registerDefaultConfigurations(o){const d=[],_=[];for(const c of o)for(const R in c)if(d.push(R),e.OVERRIDE_PROPERTY_PATTERN.test(R)){this.defaultValues[R]={...this.defaultValues[R]||{},...c[R]};const n={type:"object",default:this.defaultValues[R],description:P.localize(1,null,R),$ref:e.resourceLanguageSettingsSchemaId};_.push(m(R)),this.configurationProperties[R]=n,this.defaultLanguageConfigurationOverridesNode.properties[R]=n}else{this.defaultValues[R]=c[R];const n=this.configurationProperties[R];n&&(this.updatePropertyDefaultValue(R,n),this.updateSchema(R,n))}this.registerOverrideIdentifiers(_),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(d)}deregisterDefaultConfigurations(o){const d=[];for(const _ of o)for(const c in _)if(d.push(c),delete this.defaultValues[c],e.OVERRIDE_PROPERTY_PATTERN.test(c))delete this.configurationProperties[c],delete this.defaultLanguageConfigurationOverridesNode.properties[c];else{const R=this.configurationProperties[c];R&&(this.updatePropertyDefaultValue(c,R),this.updateSchema(c,R))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(d)}notifyConfigurationSchemaUpdated(...o){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(o){for(const d of o)this.overrideIdentifiers.add(d);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(o,d){const _=[];return o.forEach(c=>{_.push(...this.validateAndRegisterProperties(c,d,c.extensionInfo)),this.configurationContributors.push(c),this.registerJSONConfiguration(c)}),_}doDeregisterConfigurations(o){const d=[],_=c=>{if(c.properties)for(const R in c.properties)d.push(R),delete this.configurationProperties[R],this.removeFromSchema(R,c.properties[R]);c.allOf&&c.allOf.forEach(R=>_(R))};for(const c of o){_(c);const R=this.configurationContributors.indexOf(c);R!==-1&&this.configurationContributors.splice(R,1)}return d}validateAndRegisterProperties(o,d=!0,_,c=3){c=b.isUndefinedOrNull(o.scope)?c:o.scope;let R=[],n=o.properties;if(n)for(let g in n){if(d&&p(g)){delete n[g];continue}const f=n[g];if(this.updatePropertyDefaultValue(g,f),e.OVERRIDE_PROPERTY_PATTERN.test(g)?f.scope=void 0:(f.scope=b.isUndefinedOrNull(f.scope)?c:f.scope,f.restricted=b.isUndefinedOrNull(f.restricted)?!!_?.restrictedConfigurations?.includes(g):f.restricted),n[g].hasOwnProperty("included")&&!n[g].included){this.excludedConfigurationProperties[g]=n[g],delete n[g];continue}else this.configurationProperties[g]=n[g];!n[g].deprecationMessage&&n[g].markdownDeprecationMessage&&(n[g].deprecationMessage=n[g].markdownDeprecationMessage),R.push(g)}let i=o.allOf;if(i)for(let g of i)R.push(...this.validateAndRegisterProperties(g,d,_,c));return R}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(o){const d=_=>{let c=_.properties;if(c)for(const n in c)this.updateSchema(n,c[n]);let R=_.allOf;R&&R.forEach(d)};d(o)}updateSchema(o,d){switch(e.allSettings.properties[o]=d,d.scope){case 1:e.applicationSettings.properties[o]=d;break;case 2:e.machineSettings.properties[o]=d;break;case 6:e.machineOverridableSettings.properties[o]=d;break;case 3:e.windowSettings.properties[o]=d;break;case 4:e.resourceSettings.properties[o]=d;break;case 5:e.resourceSettings.properties[o]=d,this.resourceLanguageSettingsSchema.properties[o]=d;break}}removeFromSchema(o,d){switch(delete e.allSettings.properties[o],d.scope){case 1:delete e.applicationSettings.properties[o];break;case 2:delete e.machineSettings.properties[o];break;case 6:delete e.machineOverridableSettings.properties[o];break;case 3:delete e.windowSettings.properties[o];break;case 4:case 5:delete e.resourceSettings.properties[o];break}}updateOverridePropertyPatternKey(){for(const o of this.overrideIdentifiers.values()){const d=`[${o}]`,_={type:"object",description:P.localize(2,null),errorMessage:P.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(d,_),e.allSettings.properties[d]=_,e.applicationSettings.properties[d]=_,e.machineSettings.properties[d]=_,e.machineOverridableSettings.properties[d]=_,e.windowSettings.properties[d]=_,e.resourceSettings.properties[d]=_}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(o,d){let _=this.defaultValues[o];b.isUndefined(_)&&(_=d.default),b.isUndefined(_)&&(_=a(d.type)),d.default=_}}const r="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(r);function m(w){return w.substring(1,w.length-1)}e.overrideIdentifierFromKey=m;function a(w){switch(Array.isArray(w)?w[0]:w){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=a;const h=new y;A.Registry.add(e.Extensions.Configuration,h);function p(w){return w.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(w)?P.localize(5,null,w):h.getConfigurationProperties()[w]!==void 0?P.localize(6,null,w):null:P.localize(4,null)}e.validateProperty=p;function S(){const w=[],o=h.getConfigurationProperties();for(const d of Object.keys(o))w.push([d,o[d].scope]);return w.push(["launch",4]),w.push(["task",4]),w}e.getScopes=S}),define(be[85],Ee([0,1,10,2,63,4,30]),function(re,e,u,M,b,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,P.createDecorator)("configurationService");function A(_){return _&&typeof _=="object"&&(!_.overrideIdentifier||typeof _.overrideIdentifier=="string")&&(!_.resource||_.resource instanceof M.URI)}e.isConfigurationOverrides=A;var C;(function(_){_[_.USER=1]="USER",_[_.USER_LOCAL=2]="USER_LOCAL",_[_.USER_REMOTE=3]="USER_REMOTE",_[_.WORKSPACE=4]="WORKSPACE",_[_.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",_[_.DEFAULT=6]="DEFAULT",_[_.MEMORY=7]="MEMORY"})(C=e.ConfigurationTarget||(e.ConfigurationTarget={}));function k(_){switch(_){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=k;function F(_,c){const R=[];for(const n of Object.keys(_))if(b.OVERRIDE_PROPERTY_PATTERN.test(n)){const i={};for(const g in _[n])i[g]=_[n][g];R.push({identifiers:[(0,b.overrideIdentifierFromKey)(n).trim()],keys:Object.keys(i),contents:y(i,c)})}return R}e.toOverrides=F;function y(_,c){const R=Object.create(null);for(let n in _)r(R,n,_[n],c);return R}e.toValuesTree=y;function r(_,c,R,n){const i=c.split("."),g=i.pop();let f=_;for(let s=0;s<i.length;s++){let v=i[s],l=f[v];switch(typeof l){case"undefined":l=f[v]=Object.create(null);break;case"object":break;default:n(`Ignoring ${c} as ${i.slice(0,s+1).join(".")} is ${JSON.stringify(l)}`);return}f=l}if(typeof f=="object"&&f!==null)try{f[g]=R}catch(s){n(`Ignoring ${c} as ${i.join(".")} is ${JSON.stringify(f)}`)}else n(`Ignoring ${c} as ${i.join(".")} is ${JSON.stringify(f)}`)}e.addToValueTree=r;function m(_,c){const R=c.split(".");a(_,R)}e.removeFromValueTree=m;function a(_,c){const R=c.shift();if(c.length===0){delete _[R];return}if(Object.keys(_).indexOf(R)!==-1){const n=_[R];typeof n=="object"&&!Array.isArray(n)&&(a(n,c),Object.keys(n).length===0&&delete _[R])}}function h(_,c,R){function n(f,s){let v=f;for(const l of s){if(typeof v!="object"||v===null)return;v=v[l]}return v}const i=c.split("."),g=n(_,i);return typeof g=="undefined"?R:g}e.getConfigurationValue=h;function p(_,c,R){Object.keys(c).forEach(n=>{n!=="__proto__"&&(n in _?u.isObject(_[n])&&u.isObject(c[n])?p(_[n],c[n],R):R&&(_[n]=c[n]):_[n]=c[n])})}e.merge=p;function S(){const _=t.Registry.as(b.Extensions.Configuration).getConfigurationProperties();return Object.keys(_)}e.getConfigurationKeys=S;function w(){const _=Object.create(null),c=t.Registry.as(b.Extensions.Configuration).getConfigurationProperties();for(let R in c){let n=c[R].default;r(_,R,n,i=>console.error(`Conflict in default settings: ${i}`))}return _}e.getDefaultValues=w;function o(_){return`[${_}]`}e.keyFromOverrideIdentifier=o;function d(_,c,R){const n=_.inspect(c),i=_.inspect(R);return typeof n.userValue!="undefined"||typeof n.workspaceValue!="undefined"||typeof n.workspaceFolderValue!="undefined"?n.value:typeof i.userValue!="undefined"||typeof i.workspaceValue!="undefined"||typeof i.workspaceFolderValue!="undefined"?i.value:n.defaultValue}e.getMigratedSettingValue=d}),define(be[148],Ee([0,1,15,3,102,6,20,23,10,2,85,63,30]),function(re,e,u,M,b,P,t,A,C,k,F,y,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class m{constructor(n={},i=[],g=[]){this._contents=n,this._keys=i,this._overrides=g,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(n){return n?(0,F.getConfigurationValue)(this.contents,n):this.contents}getOverrideValue(n,i){const g=this.getContentsForOverrideIdentifer(i);return g?n?(0,F.getConfigurationValue)(g,n):g:void 0}getKeysForOverrideIdentifier(n){const i=[];for(const g of this.overrides)g.identifiers.includes(n)&&i.push(...g.keys);return u.distinct(i)}getAllOverrideIdentifiers(){const n=[];for(const i of this.overrides)n.push(...i.identifiers);return u.distinct(n)}override(n){let i=this.overrideConfigurations.get(n);return i||(i=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,i)),i}merge(...n){const i=A.deepClone(this.contents),g=A.deepClone(this.overrides),f=[...this.keys];for(const s of n){this.mergeContents(i,s.contents);for(const v of s.overrides){const[l]=g.filter(E=>u.equals(E.identifiers,v.identifiers));l?(this.mergeContents(l.contents,v.contents),l.keys.push(...v.keys),l.keys=u.distinct(l.keys)):g.push(A.deepClone(v))}for(const v of s.keys)f.indexOf(v)===-1&&f.push(v)}return new m(i,f,g)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(n){const i=this.getContentsForOverrideIdentifer(n);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let g={};for(const f of u.distinct([...Object.keys(this.contents),...Object.keys(i)])){let s=this.contents[f],v=i[f];v&&(typeof s=="object"&&typeof v=="object"?(s=A.deepClone(s),this.mergeContents(s,v)):s=v),g[f]=s}return new m(g,this.keys,this.overrides)}mergeContents(n,i){for(const g of Object.keys(i)){if(g in n&&C.isObject(n[g])&&C.isObject(i[g])){this.mergeContents(n[g],i[g]);continue}n[g]=A.deepClone(i[g])}}checkAndFreeze(n){return this.isFrozen&&!Object.isFrozen(n)?A.deepFreeze(n):n}getContentsForOverrideIdentifer(n){let i=null,g=null;const f=s=>{s&&(g?this.mergeContents(g,s):g=s)};for(const s of this.overrides)u.equals(s.identifiers,[n])?i=s.contents:s.identifiers.includes(n)&&f(s.contents);return f(i),g}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(n,i){this.addKey(n),(0,F.addToValueTree)(this.contents,n,i,g=>{throw new Error(g)})}removeValue(n){this.removeKey(n)&&(0,F.removeFromValueTree)(this.contents,n)}addKey(n){let i=this.keys.length;for(let g=0;g<i;g++)n.indexOf(this.keys[g])===0&&(i=g);this.keys.splice(i,1,n)}removeKey(n){let i=this.keys.indexOf(n);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=m;class a extends m{constructor(){const n=(0,F.getDefaultValues)(),i=(0,F.getConfigurationKeys)(),g=[];for(const f of Object.keys(n))y.OVERRIDE_PROPERTY_PATTERN.test(f)&&g.push({identifiers:[(0,y.overrideIdentifierFromKey)(f).trim()],keys:Object.keys(n[f]),contents:(0,F.toValuesTree)(n[f],s=>console.error(`Conflict in default settings file: ${s}`))});super(n,i,g)}}e.DefaultConfigurationModel=a;class h{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new m}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,i){if(!C.isUndefinedOrNull(n)){const g=this.doParseContent(n);this.parseRaw(g,i)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,i){this._raw=n;const{contents:g,keys:f,overrides:s,restricted:v}=this.doParseRaw(n,i);this._configurationModel=new m(g,f,s),this._restrictedConfigurations=v||[]}doParseContent(n){let i={},g=null,f=[],s=[],v=[];function l(T){Array.isArray(f)?f.push(T):g!==null&&(f[g]=T)}let E={onObjectBegin:()=>{let T={};l(T),s.push(f),f=T,g=null},onObjectProperty:T=>{g=T},onObjectEnd:()=>{f=s.pop()},onArrayBegin:()=>{let T=[];l(T),s.push(f),f=T,g=null},onArrayEnd:()=>{f=s.pop()},onLiteralValue:l,onError:(T,I,B)=>{v.push({error:T,offset:I,length:B})}};if(n)try{b.visit(n,E),i=f[0]||{}}catch(T){console.error(`Error while parsing settings file ${this._name}: ${T}`),this._parseErrors=[T]}return i}doParseRaw(n,i){const g=r.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),f=this.filter(n,g,!0,i);n=f.raw;const s=(0,F.toValuesTree)(n,E=>console.error(`Conflict in settings file ${this._name}: ${E}`)),v=Object.keys(n),l=(0,F.toOverrides)(n,E=>console.error(`Conflict in settings file ${this._name}: ${E}`));return{contents:s,keys:v,overrides:l,restricted:f.restricted}}filter(n,i,g,f){if(!f?.scopes&&!f?.skipRestricted)return{raw:n,restricted:[]};const s={},v=[];for(let l in n)if(y.OVERRIDE_PROPERTY_PATTERN.test(l)&&g){const E=this.filter(n[l],i,!1,f);s[l]=E.raw,v.push(...E.restricted)}else{const E=i[l],T=E?typeof E.scope!="undefined"?E.scope:3:void 0;E?.restricted&&v.push(l),(T===void 0||f.scopes===void 0||f.scopes.includes(T))&&(f.skipRestricted&&E?.restricted||(s[l]=n[l]))}return{raw:s,restricted:v}}}e.ConfigurationModelParser=h;class p extends P.Disposable{constructor(n,i,g,f){super();this.userSettingsResource=n,this.scopes=i,this.fileService=f,this._onDidChange=this._register(new M.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new h(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(g.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(M.Event.filter(this.fileService.onDidFilesChange,s=>s.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(n){return new m}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=p;class S{constructor(n,i,g=new m,f=new m,s=new t.ResourceMap,v=new m,l=new t.ResourceMap,E=!0){this._defaultConfiguration=n,this._localUserConfiguration=i,this._remoteUserConfiguration=g,this._workspaceConfiguration=f,this._folderConfigurations=s,this._memoryConfiguration=v,this._memoryConfigurationByResource=l,this._freeze=E,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new t.ResourceMap,this._userConfiguration=null}getValue(n,i,g){return this.getConsolidateConfigurationModel(i,g).getValue(n)}updateValue(n,i,g={}){let f;g.resource?(f=this._memoryConfigurationByResource.get(g.resource),f||(f=new m,this._memoryConfigurationByResource.set(g.resource,f))):f=this._memoryConfiguration,i===void 0?f.removeValue(n):f.setValue(n,i),g.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,i,g){const f=this.getConsolidateConfigurationModel(i,g),s=this.getFolderConfigurationModelForResource(i.resource,g),v=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,l=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(n):this._defaultConfiguration.freeze().getValue(n),E=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(n):this.userConfiguration.freeze().getValue(n),T=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(n):this.localUserConfiguration.freeze().getValue(n),I=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(n):this.remoteUserConfiguration.freeze().getValue(n),B=g?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(n):this._workspaceConfiguration.freeze().getValue(n):void 0,O=s?i.overrideIdentifier?s.freeze().override(i.overrideIdentifier).getValue(n):s.freeze().getValue(n):void 0,D=i.overrideIdentifier?v.override(i.overrideIdentifier).getValue(n):v.getValue(n),x=f.getValue(n),N=u.distinct(u.flatten(f.overrides.map(V=>V.identifiers))).filter(V=>f.getOverrideValue(n,V)!==void 0);return{defaultValue:l,userValue:E,userLocalValue:T,userRemoteValue:I,workspaceValue:B,workspaceFolderValue:O,memoryValue:D,value:x,default:l!==void 0?{value:this._defaultConfiguration.freeze().getValue(n),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(n,i.overrideIdentifier):void 0}:void 0,user:E!==void 0?{value:this.userConfiguration.freeze().getValue(n),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(n,i.overrideIdentifier):void 0}:void 0,userLocal:T!==void 0?{value:this.localUserConfiguration.freeze().getValue(n),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(n,i.overrideIdentifier):void 0}:void 0,userRemote:I!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(n),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(n,i.overrideIdentifier):void 0}:void 0,workspace:B!==void 0?{value:this._workspaceConfiguration.freeze().getValue(n),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(n,i.overrideIdentifier):void 0}:void 0,workspaceFolder:O!==void 0?{value:s?.freeze().getValue(n),override:i.overrideIdentifier?s?.freeze().getOverrideValue(n,i.overrideIdentifier):void 0}:void 0,memory:D!==void 0?{value:v.getValue(n),override:i.overrideIdentifier?v.getOverrideValue(n,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:N.length?N:void 0}}keys(n){const i=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,i){this._folderConfigurations.set(n,i),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,i){const g=[];for(const f of i)if(y.OVERRIDE_PROPERTY_PATTERN.test(f)){const s=(0,y.overrideIdentifierFromKey)(f),v=this._defaultConfiguration.getKeysForOverrideIdentifier(s),l=n.getKeysForOverrideIdentifier(s),E=[...l.filter(T=>v.indexOf(T)===-1),...v.filter(T=>l.indexOf(T)===-1),...v.filter(T=>!A.equals(this._defaultConfiguration.override(s).getValue(T),n.override(s).getValue(T)))];g.push([s,E])}return this.updateDefaultConfiguration(n),{keys:i,overrides:g}}compareAndUpdateLocalUserConfiguration(n){const{added:i,updated:g,removed:f,overrides:s}=_(this.localUserConfiguration,n),v=[...i,...g,...f];return v.length&&this.updateLocalUserConfiguration(n),{keys:v,overrides:s}}compareAndUpdateRemoteUserConfiguration(n){const{added:i,updated:g,removed:f,overrides:s}=_(this.remoteUserConfiguration,n);let v=[...i,...g,...f];return v.length&&this.updateRemoteUserConfiguration(n),{keys:v,overrides:s}}compareAndUpdateWorkspaceConfiguration(n){const{added:i,updated:g,removed:f,overrides:s}=_(this.workspaceConfiguration,n);let v=[...i,...g,...f];return v.length&&this.updateWorkspaceConfiguration(n),{keys:v,overrides:s}}compareAndUpdateFolderConfiguration(n,i){const g=this.folderConfigurations.get(n),{added:f,updated:s,removed:v,overrides:l}=_(g,i);let E=[...f,...s,...v];return(E.length||!g)&&this.updateFolderConfiguration(n,i),{keys:E,overrides:l}}compareAndDeleteFolderConfiguration(n){const i=this.folderConfigurations.get(n);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:g,updated:f,removed:s,overrides:v}=_(i,void 0);return{keys:[...g,...f,...s],overrides:v}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(n,i){let g=this.getConsolidatedConfigurationModelForResource(n,i);return n.overrideIdentifier?g.override(n.overrideIdentifier):g}getConsolidatedConfigurationModelForResource({resource:n},i){let g=this.getWorkspaceConsolidatedConfiguration();if(i&&n){const f=i.getFolder(n);f&&(g=this.getFolderConsolidatedConfiguration(f.uri)||g);const s=this._memoryConfigurationByResource.get(n);s&&(g=g.merge(s))}return g}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let i=this._foldersConsolidatedConfigurations.get(n);if(!i){const g=this.getWorkspaceConsolidatedConfiguration(),f=this._folderConfigurations.get(n);f?(i=g.merge(f),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(n,i)):i=g}return i}getFolderConfigurationModelForResource(n,i){if(i&&n){const g=i.getFolder(n);if(g)return this._folderConfigurations.get(g.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,i)=>{const{contents:g,overrides:f,keys:s}=this._folderConfigurations.get(i);return n.push([i,{contents:g,overrides:f,keys:s}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>n.add(i)),this.userConfiguration.freeze().keys.forEach(i=>n.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>n.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(g=>n.add(g))),[...n.values()]}allOverrideIdentifiers(){const n=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>n.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>n.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(g=>n.add(g))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(g=>i.add(g)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(g=>i.add(g)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(g=>i.add(g)),this._folderConfigurations.forEach(g=>g.getKeysForOverrideIdentifier(n).forEach(f=>i.add(f))),[...i.values()]}static parse(n){const i=this.parseConfigurationModel(n.defaults),g=this.parseConfigurationModel(n.user),f=this.parseConfigurationModel(n.workspace),s=n.folders.reduce((v,l)=>(v.set(k.URI.revive(l[0]),this.parseConfigurationModel(l[1])),v),new t.ResourceMap);return new S(i,g,new m,f,s,new m,new t.ResourceMap,!1)}static parseConfigurationModel(n){return new m(n.contents,n.keys,n.overrides).freeze()}}e.Configuration=S;function w(...R){if(R.length===0)return{keys:[],overrides:[]};if(R.length===1)return R[0];const n=new Set,i=new Map;for(const f of R)f.keys.forEach(s=>n.add(s)),f.overrides.forEach(([s,v])=>{const l=(0,t.getOrSet)(i,s,new Set);v.forEach(E=>l.add(E))});const g=[];return i.forEach((f,s)=>g.push([s,[...f.values()]])),{keys:[...n.values()],overrides:g}}e.mergeChanges=w;class o{constructor(n,i,g,f){this.change=n,this.previous=i,this.currentConfiguraiton=g,this.currentWorkspace=f,this._previousConfiguration=void 0;const s=new Set;n.keys.forEach(l=>s.add(l)),n.overrides.forEach(([,l])=>l.forEach(E=>s.add(E))),this.affectedKeys=[...s.values()];const v=new m;this.affectedKeys.forEach(l=>v.setValue(l,{})),this.affectedKeysTree=v.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=S.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,n)){if(i){const g=this.previousConfiguration?this.previousConfiguration.getValue(n,i,this.previous?.workspace):void 0,f=this.currentConfiguraiton.getValue(n,i,this.currentWorkspace);return!A.equals(g,f)}return!0}return!1}doesAffectedKeysTreeContains(n,i){let g=(0,F.toValuesTree)({[i]:!0},()=>{}),f;for(;typeof g=="object"&&(f=Object.keys(g)[0]);){if(n=n[f],!n)return!1;g=g[f]}return!0}}e.ConfigurationChangeEvent=o;class d extends o{constructor(n,i,g,f){super({keys:n.allKeys(),overrides:[]},void 0,n,i);this.source=g,this.sourceConfig=f}}e.AllKeysConfigurationChangeEvent=d;function _(R,n){const{added:i,removed:g,updated:f}=c(n,R),s=[],v=R?.getAllOverrideIdentifiers()||[],l=n?.getAllOverrideIdentifiers()||[];if(n){const E=l.filter(T=>!v.includes(T));for(const T of E)s.push([T,n.getKeysForOverrideIdentifier(T)])}if(R){const E=v.filter(T=>!l.includes(T));for(const T of E)s.push([T,R.getKeysForOverrideIdentifier(T)])}if(n&&R){for(const E of v)if(l.includes(E)){const T=c({contents:R.getOverrideValue(void 0,E)||{},keys:R.getKeysForOverrideIdentifier(E)},{contents:n.getOverrideValue(void 0,E)||{},keys:n.getKeysForOverrideIdentifier(E)});s.push([E,[...T.added,...T.removed,...T.updated]])}}return{added:i,removed:g,updated:f,overrides:s}}function c(R,n){const i=R?n?R.keys.filter(s=>n.keys.indexOf(s)===-1):[...R.keys]:[],g=n?R?n.keys.filter(s=>R.keys.indexOf(s)===-1):[...n.keys]:[],f=[];if(R&&n){for(const s of n.keys)if(R.keys.indexOf(s)!==-1){const v=(0,F.getConfigurationValue)(n.contents,s),l=(0,F.getConfigurationValue)(R.contents,s);A.equals(v,l)||f.push(s)}}return{added:i,removed:g,updated:f}}}),define(be[86],Ee([0,1,4]),function(re,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,u.createDecorator)("remoteAuthorityResolverService");var M;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound"})(M=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class b extends Error{constructor(t,A=M.Unknown,C){super(t);this._message=t,this._code=A,this._detail=C,this.isHandled=A===M.NotAvailable&&C===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,b.prototype)}static isTemporarilyNotAvailable(t){return t instanceof b&&t._code===M.TemporarilyNotAvailable}static isNoResolverFound(t){return t instanceof b&&t._code===M.NoResolverFound}static isHandled(t){return t instanceof b&&t.isHandled}}e.RemoteAuthorityResolverError=b}),define(be[64],Ee([0,1,11]),function(re,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function M(k){return k.scheme===u.Schemas.vscodeRemote?k.authority:void 0}e.getRemoteAuthority=M;function b(k){if(!k)return;const F=k.indexOf("+");return F<0?k:k.substr(0,F)}e.getRemoteName=b;function P(k){return k.scheme!==u.Schemas.file&&k.scheme!==u.Schemas.vscodeRemote}e.isVirtualResource=P;function t(k){if(k.folders.length)return k.folders.every(F=>P(F.uri))?k.folders[0].uri:void 0;if(k.configuration&&P(k.configuration))return k.configuration}e.getVirtualWorkspaceLocation=t;function A(k){return t(k)?.scheme}e.getVirtualWorkspaceScheme=A;function C(k){return t(k)!==void 0}e.isVirtualWorkspace=C}),define(be[26],Ee([0,1,9,4,64]),function(re,e,u,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function P(r){if(typeof r=="object"&&r!==null&&r.supported!==!0)return r.description}e.getWorkspaceSupportTypeMessage=P;function t(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(!r.uuid||typeof r.uuid=="string")}e.isIExtensionIdentifier=t,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(r){r[r.System=0]="System",r[r.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));class C{constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,a){if(typeof m=="undefined"||m===null)return typeof a=="undefined"||a===null;if(typeof a=="undefined"||a===null)return!1;if(typeof m=="string"||typeof a=="string"){let h=typeof m=="string"?m:m.value,p=typeof a=="string"?a:a.value;return u.equalsIgnoreCase(h,p)}return m._lower===a._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}e.ExtensionIdentifier=C;function k(r){return r.contributes&&r.contributes.localizations?r.contributes.localizations.length>0:!1}e.isLanguagePackExtension=k;function F(r){return r.contributes&&r.contributes.authentication?r.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=F;function y(r,m){if(m){const a=`onResolveRemoteAuthority:${(0,b.getRemoteName)(m)}`;return r.activationEvents?.indexOf(a)!==-1}return!1}e.isResolverExtension=y,e.IBuiltinExtensionsScannerService=(0,M.createDecorator)("IBuiltinExtensionsScannerService")}),define(be[149],Ee([0,1,9,26]),function(re,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function b(a,h){return a.uuid&&h.uuid?a.uuid===h.uuid:a.id===h.id?!0:(0,u.compareIgnoreCase)(a.id,h.id)===0}e.areSameExtensions=b;class P{constructor(h,p){this.version=p,this.id=h.id,this.uuid=h.uuid}key(){return`${this.id}-${this.version}`}equals(h){return h instanceof P?b(this,h)&&this.version===h.version:!1}}e.ExtensionIdentifierWithVersion=P;function t(a,h){return`${a}.${h}`}e.getExtensionId=t;function A(a){return a.toLocaleLowerCase()}e.adoptToGalleryExtensionId=A;function C(a,h){return A(t(a,h))}e.getGalleryExtensionId=C;function k(a,h){const p=[],S=w=>{for(const o of p)if(o.some(d=>b(h(d),h(w))))return o;return null};for(const w of a){const o=S(w);o?o.push(w):p.push([w])}return p}e.groupByExtension=k;function F(a){return{id:a.identifier.id,name:a.manifest.name,galleryId:null,publisherId:a.publisherId,publisherName:a.manifest.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:a.manifest.extensionDependencies&&a.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=F;function y(a){return{id:a.identifier.id,name:a.name,galleryId:a.identifier.uuid,publisherId:a.publisherId,publisherName:a.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:!!(a.properties.dependencies&&a.properties.dependencies.length>0),...a.telemetryData}}e.getGalleryExtensionTelemetryData=y,e.BetterMergeId=new M.ExtensionIdentifier("pprice.better-merge");function r(a){const h=new Set;for(const p of a)p.malicious&&h.add(p.id.id);return h}e.getMaliciousExtensionsSet=r;function m(a,h){const p=[],S=h.manifest.extensionDependencies?.slice(0)??[];for(;S.length;){const w=S.shift();if(w&&p.every(o=>!b(o.identifier,{id:w}))){const o=a.filter(d=>b(d.identifier,{id:w}));o.length===1&&(p.push(o[0]),S.push(...o[0].manifest.extensionDependencies?.slice(0)??[]))}}return p}e.getExtensionDependencies=m}),define(be[150],Ee([0,1,3,25,4,12]),function(re,e,u,M,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,b.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,b.createDecorator)("sharedTunnelsService");var t;(function(a){a.Http="http",a.Https="https"})(t=e.TunnelProtocol||(e.TunnelProtocol={}));var A;(function(a){a.ConstantPrivate="constantPrivate",a.Private="private",a.Public="public"})(A=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var C;(function(a){a[a.Notify=1]="Notify",a[a.OpenBrowser=2]="OpenBrowser",a[a.OpenPreview=3]="OpenPreview",a[a.Silent=4]="Silent",a[a.Ignore=5]="Ignore",a[a.OpenBrowserOnce=6]="OpenBrowserOnce"})(C=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function k(a){if(a.scheme!=="http"&&a.scheme!=="https")return;const h=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(a.authority);if(!!h)return{address:h[1],port:+h[2]}}e.extractLocalHostUriMetaDataForPortMapping=k,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function F(a){return e.LOCALHOST_ADDRESSES.indexOf(a)>=0}e.isLocalhost=F,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function y(a){return e.ALL_INTERFACES_ADDRESSES.indexOf(a)>=0}e.isAllInterfaces=y;function r(a,h){return h?h!==1&&a<1024:!M.isWindows&&a<1024}e.isPortPrivileged=r;let m=class{constructor(h){this.logService=h,this._onTunnelOpened=new u.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new u.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new u.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(h,p){return this._tunnelProvider=h,h?(this._canElevate=p.elevation,this._privacyOptions=p.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const h=[],p=Array.from(this._tunnels.values());for(let S of p){const w=Array.from(S.values());for(let o of w){const d=await o.value;d&&h.push(d)}}return h}async dispose(){for(const h of this._tunnels.values()){for(const{value:p}of h.values())await p.then(S=>S?.dispose());h.clear()}this._tunnels.clear()}openTunnel(h,p,S,w,o=!1,d=A.Private,_){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${p}:${S} on local port ${w}.`),!h)return;p||(p="localhost");const c=this.retainOrCreateTunnel(h,p,S,w,o,d,_);return c?c.then(R=>{if(!R){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(p,S);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const n=this.makeTunnel(R);return(R.tunnelRemoteHost!==p||R.tunnelRemotePort!==S)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(n),n}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),c)}makeTunnel(h){return{tunnelRemotePort:h.tunnelRemotePort,tunnelRemoteHost:h.tunnelRemoteHost,tunnelLocalPort:h.tunnelLocalPort,localAddress:h.localAddress,privacy:h.privacy,protocol:h.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${h.tunnelRemoteHost}:${h.tunnelRemotePort} `);const p=this._tunnels.get(h.tunnelRemoteHost);if(p){const S=p.get(h.tunnelRemotePort);S&&(S.refcount--,await this.tryDisposeTunnel(h.tunnelRemoteHost,h.tunnelRemotePort,S))}}}}async tryDisposeTunnel(h,p,S){if(S.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${h}:${p}.`);const w=S.value.then(async o=>{o&&(await o.dispose(!0),this._onTunnelClosed.fire({host:o.tunnelRemoteHost,port:o.tunnelRemotePort}))});return this._tunnels.has(h)&&this._tunnels.get(h).delete(p),w}}async closeTunnel(h,p){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${h}:${p} `);const S=this._tunnels.get(h);if(S&&S.has(p)){const w=S.get(p);w.refcount=0,await this.tryDisposeTunnel(h,p,w)}}addTunnelToMap(h,p,S){this._tunnels.has(h)||this._tunnels.set(h,new Map),this._tunnels.get(h).set(p,{refcount:1,value:S})}async removeEmptyTunnelFromMap(h,p){const S=this._tunnels.get(h);S&&(await S.get(p)||S.delete(p),S.size===0&&this._tunnels.delete(h))}getTunnelFromMap(h,p){let S=[h];F(h)?(S.push(...e.LOCALHOST_ADDRESSES),S.push(...e.ALL_INTERFACES_ADDRESSES)):y(h)&&S.push(...e.ALL_INTERFACES_ADDRESSES);const w=S.map(o=>this._tunnels.get(o));for(const o of w){const d=o?.get(p);if(d)return d}}canTunnel(h){return!!k(h)}createWithProvider(h,p,S,w,o,d,_){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${p}:${S} on local port ${w}.`);const R={elevationRequired:o?r(w===void 0?S:w):!1},n={remoteAddress:{host:p,port:S},localAddressPort:w,privacy:d,public:d!==A.Private,protocol:_},i=h.forwardPort(n,R);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),i&&this.addTunnelToMap(p,S,i),i}};m=Ue([Be(0,P.ILogService)],m),e.AbstractTunnelService=m}),define(be[151],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class u{constructor(b){this._callback=b,this._terminalBufferMap=new Map}dispose(){for(const b of this._terminalBufferMap.values())b.dispose()}startBuffering(b,P,t=5){let A;return A=P(C=>{const k=typeof C=="string"?C:C.data;let F=this._terminalBufferMap.get(b);if(F){F.data.push(k);return}const y=setTimeout(()=>this.flushBuffer(b),t);F={data:[k],timeoutId:y,dispose:()=>{clearTimeout(y),this.flushBuffer(b),A.dispose()}},this._terminalBufferMap.set(b,F)}),A}stopBuffering(b){const P=this._terminalBufferMap.get(b);P&&P.dispose()}flushBuffer(b){const P=this._terminalBufferMap.get(b);P&&(this._terminalBufferMap.delete(b),this._callback(b,P.data.join("")))}}e.TerminalDataBufferer=u}),define(be[152],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var u;(function(M){M.DARK="dark",M.LIGHT="light",M.HIGH_CONTRAST="hc"})(u=e.ColorScheme||(e.ColorScheme={}))}),define(be[48],Ee([0,1,35,3,6,4,30,152]),function(re,e,u,M,b,P,t,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,P.createDecorator)("themeService");var C;(function(p){function S(w){return w&&typeof w=="object"&&typeof w.id=="string"}p.isThemeColor=S})(C=e.ThemeColor||(e.ThemeColor={}));function k(p){return{id:p}}e.themeColorFromId=k;var F;(function(p){function S(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color=="undefined"||C.isThemeColor(n.color))}p.isThemeIcon=S;const w=new RegExp(`^\\$\\((${u.CSSIcon.iconNameExpression}(?:${u.CSSIcon.iconModifierExpression})?)\\)$`);function o(n){const i=w.exec(n);if(!i)return;let[,g]=i;return{id:g}}p.fromString=o;function d(n,i){let g=n.id;const f=g.lastIndexOf("~");return f!==-1&&(g=g.substring(0,f)),i&&(g=`${g}~${i}`),{id:g}}p.modify=d;function _(n){const i=n.id.lastIndexOf("~");if(i!==-1)return n.id.substring(i+1)}p.getModifier=_;function c(n,i){return n.id===i.id&&n.color?.id===i.color?.id}p.isEqual=c;function R(n,i){return{id:n.id,color:i?k(i):void 0}}p.asThemeIcon=R,p.asClassNameArray=u.CSSIcon.asClassNameArray,p.asClassName=u.CSSIcon.asClassName,p.asCSSSelector=u.CSSIcon.asCSSSelector})(F=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=u.Codicon.file,e.FolderThemeIcon=u.Codicon.folder;function y(p){switch(p){case A.ColorScheme.DARK:return"vs-dark";case A.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=y,e.Extensions={ThemingContribution:"base.contributions.theming"};class r{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new M.Emitter}onColorThemeChange(S){return this.themingParticipants.push(S),this.onThemingParticipantAddedEmitter.fire(S),(0,b.toDisposable)(()=>{const w=this.themingParticipants.indexOf(S);this.themingParticipants.splice(w,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let m=new r;t.Registry.add(e.Extensions.ThemingContribution,m);function a(p){return m.onColorThemeChange(p)}e.registerThemingParticipant=a;class h extends b.Disposable{constructor(S){super();this.themeService=S,this.theme=S.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(w=>this.onThemeChange(w)))}onThemeChange(S){this.theme=S,this.updateStyles()}updateStyles(){}getColor(S,w){let o=this.theme.getColor(S);return o&&w&&(o=w(o,this.theme)),o?o.toString():null}}e.Themable=h}),define(be[153],Ee([0,1,13,35,3,124,84,30,48]),function(re,e,u,M,b,P,t,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class k{constructor(){this._onDidChange=new b.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,P.localize)(0,null)},fontCharacter:{type:"string",description:(0,P.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${M.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(S,w,o,d){const _=this.iconsById[S];if(_){if(o&&!_.description){_.description=o,this.iconSchema.properties[S].markdownDescription=`${o} $(${S})`;const n=this.iconReferenceSchema.enum.indexOf(S);n!==-1&&(this.iconReferenceSchema.enumDescriptions[n]=o),this._onDidChange.fire()}return _}let c={id:S,description:o,defaults:w,deprecationMessage:d};this.iconsById[S]=c;let R={$ref:"#/definitions/icons"};return d&&(R.deprecationMessage=d),o&&(R.markdownDescription=`${o}: $(${S})`),this.iconSchema.properties[S]=R,this.iconReferenceSchema.enum.push(S),this.iconReferenceSchema.enumDescriptions.push(o||""),this._onDidChange.fire(),{id:S}}deregisterIcon(S){delete this.iconsById[S],delete this.iconSchema.properties[S];const w=this.iconReferenceSchema.enum.indexOf(S);w!==-1&&(this.iconReferenceSchema.enum.splice(w,1),this.iconReferenceSchema.enumDescriptions.splice(w,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(S=>this.iconsById[S])}getIcon(S){return this.iconsById[S]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(S,w){const o=this.iconFontsById[S];if(o)return o;let d={id:S,definition:w};return this.iconFontsById[S]=d,this._onDidChange.fire(),d}deregisterIconFont(S){delete this.iconFontsById[S]}getIconFonts(){return Object.keys(this.iconFontsById).map(S=>this.iconFontsById[S])}getIconFont(S){return this.iconFontsById[S]}toString(){const S=(_,c)=>_.id.localeCompare(c.id),w=_=>{for(;C.ThemeIcon.isThemeIcon(_.defaults);)_=this.iconsById[_.defaults.id];return`codicon codicon-${_?_.id:""}`};let o=[];o.push("| preview     | identifier                        | default codicon ID                | description"),o.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const d=Object.keys(this.iconsById).map(_=>this.iconsById[_]);for(const _ of d.filter(c=>!!c.description).sort(S))o.push(`|<i class="${w(_)}"></i>|${_.id}|${C.ThemeIcon.isThemeIcon(_.defaults)?_.defaults.id:_.id}|${_.description||""}|`);o.push("| preview     | identifier                        "),o.push("| ----------- | --------------------------------- |");for(const _ of d.filter(c=>!C.ThemeIcon.isThemeIcon(c.defaults)).sort(S))o.push(`|<i class="${w(_)}"></i>|${_.id}|`);return o.join(`
`)}}const F=new k;A.Registry.add(e.Extensions.IconContribution,F);function y(p,S,w,o){return F.registerIcon(p,S,w,o)}e.registerIcon=y;function r(){return F}e.getIconRegistry=r;function m(){for(const p of M.iconRegistry.all)F.registerIcon(p.id,p.definition,p.description);M.iconRegistry.onDidRegister(p=>F.registerIcon(p.id,p.definition,p.description))}m(),e.iconsSchemaId="vscode://schemas/icons";let a=A.Registry.as(t.Extensions.JSONContribution);a.registerSchema(e.iconsSchemaId,F.getIconSchema());const h=new u.RunOnceScheduler(()=>a.notifySchemaChanged(e.iconsSchemaId),200);F.onDidChange(()=>{h.isScheduled()||h.schedule()}),e.widgetClose=y("widget-close",M.Codicon.close,(0,P.localize)(2,null)),e.gotoPreviousLocation=y("goto-previous-location",M.Codicon.arrowUp,(0,P.localize)(3,null)),e.gotoNextLocation=y("goto-next-location",M.Codicon.arrowDown,(0,P.localize)(4,null)),e.syncing=C.ThemeIcon.modify(M.Codicon.sync,"spin"),e.spinningLoading=C.ThemeIcon.modify(M.Codicon.loading,"spin")}),define(be[49],Ee([0,1,20,24,2,4]),function(re,e,u,M,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");var t;(function(r){r[r.EMPTY=1]="EMPTY",r[r.FOLDER=2]="FOLDER",r[r.WORKSPACE=3]="WORKSPACE"})(t=e.WorkbenchState||(e.WorkbenchState={}));function A(r){const m=r;return!!(m&&typeof m=="object"&&typeof m.id=="string"&&Array.isArray(m.folders))}e.isWorkspace=A;function C(r){const m=r;return!!(m&&typeof m=="object"&&b.URI.isUri(m.uri)&&typeof m.name=="string"&&typeof m.toResource=="function")}e.isWorkspaceFolder=C;class k{constructor(m,a,h,p,S){this._id=m,this._transient=h,this._configuration=p,this._ignorePathCasing=S,this._foldersMap=u.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=a}update(m){this._id=m.id,this._configuration=m.configuration,this._transient=m.transient,this._ignorePathCasing=m._ignorePathCasing,this.folders=m.folders}get folders(){return this._folders}set folders(m){this._folders=m,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(m){this._configuration=m}getFolder(m){return m&&this._foldersMap.findSubstr(m.with({scheme:m.scheme,authority:m.authority,path:m.path}))||null}updateFoldersMap(){this._foldersMap=u.TernarySearchTree.forUris(this._ignorePathCasing);for(const m of this.folders)this._foldersMap.set(m.uri,m)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=k;class F{constructor(m,a){this.raw=a,this.uri=m.uri,this.index=m.index,this.name=m.name}toResource(m){return(0,M.joinPath)(this.uri,m)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=F;function y(r){return new F({uri:r,index:0,name:(0,M.basenameOrAuthority)(r)},{uri:r.toString()})}e.toWorkspaceFolder=y}),define(be[65],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class u{constructor(b){this.id=b,this._data=new Map,this._idPool=1}add(b){const P=this._idPool++;return this._data.set(P,b),this.logDebugInfo(),P}get(b,P){return this._data.has(b)?this._data.get(b)[P]:void 0}delete(b){this._data.delete(b),this.logDebugInfo()}logDebugInfo(){!u.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=u,u.enableDebugLogging=!1}),define(be[31],Ee([0,1,11,24,4]),function(re,e,u,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class P{constructor(){this._systemSchemes=new Set(Object.keys(u.Schemas)),this._providerInfo=new Map,this.extUri=new M.ExtUri(A=>{const C=this._providerInfo.get(A.scheme);return!(C===void 0||C&1024)})}$acceptProviderInfos(A,C){C===null?this._providerInfo.delete(A):this._providerInfo.set(A,C)}isFreeScheme(A){return!this._providerInfo.has(A)&&!this._systemSchemes.has(A)}getCapabilities(A){return this._providerInfo.get(A)}}e.ExtHostFileSystemInfo=P,e.IExtHostFileSystemInfo=(0,b.createDecorator)("IExtHostFileSystemInfo")}),define(be[28],Ee([0,1,4]),function(re,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,u.createDecorator)("IExtHostInitDataService")}),define(be[154],Ee([0,1,13]),function(re,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class M{constructor(t,A,C){this._deferredPromises=new Map,this._id=t,this._shared=A,this._storage=C,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(k=>(this._value=k,this)),this._storageListener=this._storage.onDidChangeStorage(k=>{k.shared===this._shared&&k.key===this._id&&(this._value=k.value)}),this._scheduler=new u.RunOnceScheduler(()=>{const k=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const F of k.values())F.complete()}catch(F){for(const y of k.values())y.error(F)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,t])=>t!==void 0).map(([t])=>t)}get whenReady(){return this._init}get(t,A){let C=this._value[t];return typeof C=="undefined"&&(C=A),C}update(t,A){this._value[t]=A;let C=this._deferredPromises.get(t);if(C!==void 0)return C.p;const k=new u.DeferredPromise;return this._deferredPromises.set(t,k),this._scheduler.isScheduled()||this._scheduler.schedule(),k.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=M;class b extends M{constructor(t,A){super(t.identifier.value,!0,A);this._extension=t}setKeysForSync(t){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},t)}}e.ExtensionGlobalMemento=b}),define(be[155],Ee([0,1,3,2,12]),function(re,e,u,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let P=class{constructor(A,C){this._logService=A,this._notebooksAndEditors=C,this._onDidChangeNotebookDocumentMetadata=new u.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new u.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(A,C,k){this._notebooksAndEditors.getNotebookDocument(M.URI.revive(A)).acceptModelChanged(C.value,k)}$acceptDirtyStateChanged(A,C){this._notebooksAndEditors.getNotebookDocument(M.URI.revive(A)).acceptDirty(C)}$acceptModelSaved(A){const C=this._notebooksAndEditors.getNotebookDocument(M.URI.revive(A));this._onDidSaveNotebookDocument.fire(C.apiNotebook)}$acceptDocumentPropertiesChanged(A,C){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",A.path,C);const k=this._notebooksAndEditors.getNotebookDocument(M.URI.revive(A));k.acceptDocumentPropertiesChanged(C),C.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:k.apiNotebook})}};P=Ue([Be(0,b.ILogService)],P),e.ExtHostNotebookDocuments=P}),define(be[14],Ee([0,1,4]),function(re,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,u.createDecorator)("IExtHostRpcService");class M{constructor(P){this.getProxy=P.getProxy.bind(P),this.set=P.set.bind(P),this.assertRegistered=P.assertRegistered.bind(P),this.drain=P.drain.bind(P)}}e.ExtHostRpcService=M});var Xe=this&&this.__classPrivateFieldSet||function(re,e,u,M,b){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!b:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?b.call(re,u):b?b.value=u:e.set(re,u),u},Ae=this&&this.__classPrivateFieldGet||function(re,e,u,M){if(u==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?M:u==="a"?M.call(re):M?M.value:e.get(re)};define(be[156],Ee([0,1,26,3]),function(re,e,u,M){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class P{constructor(A,C){b.set(this,void 0),this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this._id=u.ExtensionIdentifier.toKey(A.identifier),Xe(this,b,C,"f"),Ae(this,b,"f").onDidChangePassword(k=>{k.extensionId===this._id&&this._onDidChange.fire({key:k.key})})}get(A){return Ae(this,b,"f").get(this._id,A)}store(A,C){return Ae(this,b,"f").store(this._id,A,C)}delete(A){return Ae(this,b,"f").delete(this._id,A)}}e.ExtensionSecrets=P,b=new WeakMap}),define(be[87],Ee([0,1,4,3]),function(re,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class b{constructor(){this._onDidChangeTelemetryEnabled=new M.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(t){this._enabled=t}$onDidChangeTelemetryEnabled(t){this._enabled=t,this._onDidChangeTelemetryEnabled.fire(t)}}e.ExtHostTelemetry=b,e.IExtHostTelemetry=(0,u.createDecorator)("IExtHostTelemetry")}),define(be[50],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var u;(function(w){w[w.Upsert=0]="Upsert",w[w.RemoveChild=1]="RemoveChild",w[w.Invalidated=2]="Invalidated",w[w.SetProp=3]="SetProp",w[w.Bulk=4]="Bulk"})(u=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const M=new WeakMap,b=(w,o)=>{const d={controllerId:o};return M.set(w,d),d};e.createPrivateApiFor=b;const P=w=>M.get(w);e.getPrivateApiFor=P;const t=(w,o,d,_)=>{let c=d;return{enumerable:!0,configurable:!1,get(){return c},set(R){if(!_(c,R)){const n=c;c=R,w.listener?.({op:3,key:o,value:R,previous:n})}}}},A=(w,o)=>w===o,C={range:(w,o)=>w===o?!0:!w||!o?!1:w.isEqual(o),label:A,description:A,busy:A,error:A,canResolveChildren:A,tags:(w,o)=>!(w.length!==o.length||w.some(d=>!o.find(_=>d.id===_.id)))},k=Object.keys(C),F=(w,o)=>({range:t(w,"range",void 0,C.range),label:t(w,"label",o,C.label),description:t(w,"description",void 0,C.description),canResolveChildren:t(w,"canResolveChildren",!1,C.canResolveChildren),busy:t(w,"busy",!1,C.busy),error:t(w,"error",void 0,C.error),tags:t(w,"tags",[],C.tags)}),y=(w,o)=>{const d=new Map;for(const _ of k)C[_](w[_],o[_])||d.set(_,o[_]);return d};e.diffTestItems=y;class r extends Error{constructor(o){super(`Attempted to insert a duplicate test item ID ${o}`)}}e.DuplicateTestItemError=r;class m extends Error{constructor(o){super(`TestItem with ID "${o}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=m;class a extends Error{constructor(o,d,_){super(`TestItem with ID "${o}" is from controller "${d}" and cannot be added as a child of an item from controller "${_}".`)}}e.MixedTestItemController=a;const h=w=>{const o=(0,e.getPrivateApiFor)(w);let d=new Map;return{get size(){return d.size},forEach(_,c){for(const R of d.values())_.call(c,R,this)},replace(_){const c=new Map,R=new Set(d.keys()),n={op:4,ops:[]};for(const i of _){if(!(i instanceof p))throw new m(i.id);const g=(0,e.getPrivateApiFor)(i).controllerId;if(g!==o.controllerId)throw new a(i.id,g,o.controllerId);if(c.has(i.id))throw new r(i.id);c.set(i.id,i),R.delete(i.id),n.ops.push({op:0,item:i})}for(const i of R.keys())n.ops.push({op:1,id:i});o.listener?.(n),d=c},add(_){if(!(_ instanceof p))throw new m(_.id);d.set(_.id,_),o.listener?.({op:0,item:_})},delete(_){d.delete(_)&&o.listener?.({op:1,id:_})},get(_){return d.get(_)},toJSON(){return Array.from(d.values())},[Symbol.iterator](){return d.values()}}};class p{constructor(o,d,_,c){if(d.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(d)} symbol`);const R=(0,e.createPrivateApiFor)(this,o);Object.defineProperties(this,{id:{value:d,enumerable:!0,writable:!1},uri:{value:c,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return R.parent instanceof S?void 0:R.parent}},children:{value:h(this),enumerable:!0,writable:!1},...F(R,_)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=p;class S extends p{constructor(o,d){super(o,o,d,void 0)}}e.TestItemRootImpl=S}),define(be[66],Ee([0,1,4,150,3,14]),function(re,e,u,M,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var t;(function(C){function k(y){return{remoteAddress:y.remoteAddress,localAddress:y.localAddress,public:!!y.public,privacy:y.privacy??(y.public?M.TunnelPrivacyId.Public:M.TunnelPrivacyId.Private),protocol:y.protocol}}C.fromApiTunnel=k;function F(y){return{remoteAddress:{host:y.tunnelRemoteHost,port:y.tunnelRemotePort},localAddress:y.localAddress,public:y.privacy!==M.TunnelPrivacyId.ConstantPrivate&&y.privacy!==M.TunnelPrivacyId.ConstantPrivate,privacy:y.privacy,protocol:y.protocol}}C.fromServiceTunnel=F})(t=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,u.createDecorator)("IExtHostTunnelService");let A=class{constructor(k){this.onDidChangeTunnels=new b.Emitter().event}async $applyCandidateFilter(k){return k}async openTunnel(k,F){}async getTunnels(){return[]}async setTunnelExtensionFunctions(k){return{dispose:()=>{}}}registerPortsAttributesProvider(k,F){return{dispose:()=>{}}}async $providePortAttributes(k,F,y,r,m){return[]}async $forwardPort(k,F){}async $closeTunnel(k){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};A=Ue([Be(0,P.IExtHostRpcService)],A),e.ExtHostTunnelService=A});var Xe=this&&this.__classPrivateFieldSet||function(re,e,u,M,b){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!b:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?b.call(re,u):b?b.value=u:e.set(re,u),u},Ae=this&&this.__classPrivateFieldGet||function(re,e,u,M){if(u==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?M:u==="a"?M.call(re):M?M.value:e.get(re)};define(be[7],Ee([0,1,15,16,77,20,79,9,10,2,37,47,86]),function(re,e,u,M,b,P,t,A,C,k,F,y,r){"use strict";var m,a,h,p,S,w,o,d,_,c,R,n,i,g,f,s,v,l,E,T;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function I(U){function L(){return Reflect.construct(U,arguments,this.constructor)}return Object.defineProperty(L,"name",Object.getOwnPropertyDescriptor(U,"name")),Object.setPrototypeOf(L,U),Object.setPrototypeOf(L.prototype,U.prototype),L}let B=S=class{constructor(L){m.set(this,void 0),Xe(this,m,L,"f")}static from(...L){let te=L;return new S(function(){if(te){for(const _e of te)_e&&typeof _e.dispose=="function"&&_e.dispose();te=void 0}})}dispose(){typeof Ae(this,m,"f")=="function"&&(Ae(this,m,"f").call(this),Xe(this,m,void 0,"f"))}};m=new WeakMap,B=S=Ue([I],B),e.Disposable=B;let O=w=class{constructor(L,te){if(L<0)throw(0,M.illegalArgument)("line must be non-negative");if(te<0)throw(0,M.illegalArgument)("character must be non-negative");this._line=L,this._character=te}static Min(...L){if(L.length===0)throw new TypeError;let te=L[0];for(let _e=1;_e<L.length;_e++){const Ve=L[_e];Ve.isBefore(te)&&(te=Ve)}return te}static Max(...L){if(L.length===0)throw new TypeError;let te=L[0];for(let _e=1;_e<L.length;_e++){const Ve=L[_e];Ve.isAfter(te)&&(te=Ve)}return te}static isPosition(L){if(!L)return!1;if(L instanceof w)return!0;let{line:te,character:_e}=L;return typeof te=="number"&&typeof _e=="number"}get line(){return this._line}get character(){return this._character}isBefore(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<L._character}isBeforeOrEqual(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<=L._character}isAfter(L){return!this.isBeforeOrEqual(L)}isAfterOrEqual(L){return!this.isBefore(L)}isEqual(L){return this._line===L._line&&this._character===L._character}compareTo(L){return this._line<L._line?-1:this._line>L.line?1:this._character<L._character?-1:this._character>L._character?1:0}translate(L,te=0){if(L===null||te===null)throw(0,M.illegalArgument)();let _e;return typeof L=="undefined"?_e=0:typeof L=="number"?_e=L:(_e=typeof L.lineDelta=="number"?L.lineDelta:0,te=typeof L.characterDelta=="number"?L.characterDelta:0),_e===0&&te===0?this:new w(this.line+_e,this.character+te)}with(L,te=this.character){if(L===null||te===null)throw(0,M.illegalArgument)();let _e;return typeof L=="undefined"?_e=this.line:typeof L=="number"?_e=L:(_e=typeof L.line=="number"?L.line:this.line,te=typeof L.character=="number"?L.character:this.character),_e===this.line&&te===this.character?this:new w(_e,te)}toJSON(){return{line:this.line,character:this.character}}};O=w=Ue([I],O),e.Position=O;let D=o=class{constructor(L,te,_e,Ve){let tt,st;if(typeof L=="number"&&typeof te=="number"&&typeof _e=="number"&&typeof Ve=="number"?(tt=new O(L,te),st=new O(_e,Ve)):L instanceof O&&te instanceof O&&(tt=L,st=te),!tt||!st)throw new Error("Invalid arguments");tt.isBefore(st)?(this._start=tt,this._end=st):(this._start=st,this._end=tt)}static isRange(L){return L instanceof o?!0:L?O.isPosition(L.start)&&O.isPosition(L.end):!1}get start(){return this._start}get end(){return this._end}contains(L){return L instanceof o?this.contains(L._start)&&this.contains(L._end):L instanceof O?!(L.isBefore(this._start)||this._end.isBefore(L)):!1}isEqual(L){return this._start.isEqual(L._start)&&this._end.isEqual(L._end)}intersection(L){const te=O.Max(L.start,this._start),_e=O.Min(L.end,this._end);if(!te.isAfter(_e))return new o(te,_e)}union(L){if(this.contains(L))return this;if(L.contains(this))return L;const te=O.Min(L.start,this._start),_e=O.Max(L.end,this.end);return new o(te,_e)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(L,te=this.end){if(L===null||te===null)throw(0,M.illegalArgument)();let _e;return L?O.isPosition(L)?_e=L:(_e=L.start||this.start,te=L.end||this.end):_e=this.start,_e.isEqual(this._start)&&te.isEqual(this.end)?this:new o(_e,te)}toJSON(){return[this.start,this.end]}};D=o=Ue([I],D),e.Range=D;let x=d=class extends D{constructor(L,te,_e,Ve){let tt,st;if(typeof L=="number"&&typeof te=="number"&&typeof _e=="number"&&typeof Ve=="number"?(tt=new O(L,te),st=new O(_e,Ve)):L instanceof O&&te instanceof O&&(tt=L,st=te),!tt||!st)throw new Error("Invalid arguments");super(tt,st);this._anchor=tt,this._active=st}static isSelection(L){return L instanceof d?!0:L?D.isRange(L)&&O.isPosition(L.anchor)&&O.isPosition(L.active)&&typeof L.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};x=d=Ue([I],x),e.Selection=x;class N{constructor(L,te,_e){if(typeof L!="string"||L.length===0)throw(0,M.illegalArgument)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,M.illegalArgument)("port");if(typeof _e!="undefined"&&(typeof _e!="string"||_e.length===0||!/^[0-9A-Za-z\-]+$/.test(_e)))throw(0,M.illegalArgument)("connectionToken");this.host=L,this.port=Math.round(te),this.connectionToken=_e}}e.ResolvedAuthority=N;class V extends Error{constructor(L,te=r.RemoteAuthorityResolverErrorCode.Unknown,_e){super(L);this._message=L,this._code=te,this._detail=_e,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,V.prototype)}static NotAvailable(L,te){return new V(L,r.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(L){return new V(L,r.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=V;var $;(function(U){U[U.LF=1]="LF",U[U.CRLF=2]="CRLF"})($=e.EndOfLine||(e.EndOfLine={}));var z;(function(U){U[U.Replace=1]="Replace",U[U.Append=2]="Append",U[U.Prepend=3]="Prepend"})(z=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let ee=_=class{constructor(L,te){this._range=L,this._newText=te}static isTextEdit(L){return L instanceof _?!0:L?D.isRange(L)&&typeof L.newText=="string":!1}static replace(L,te){return new _(L,te)}static insert(L,te){return _.replace(new D(L,L),te)}static delete(L){return _.replace(L,"")}static setEndOfLine(L){const te=new _(new D(new O(0,0),new O(0,0)),"");return te.newEol=L,te}get range(){return this._range}set range(L){if(L&&!D.isRange(L))throw(0,M.illegalArgument)("range");this._range=L}get newText(){return this._newText||""}set newText(L){if(L&&typeof L!="string")throw(0,M.illegalArgument)("newText");this._newText=L}get newEol(){return this._newEol}set newEol(L){if(L&&typeof L!="number")throw(0,M.illegalArgument)("newEol");this._newEol=L}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};ee=_=Ue([I],ee),e.TextEdit=ee;var j;(function(U){U[U.File=1]="File",U[U.Text=2]="Text",U[U.Cell=3]="Cell",U[U.CellReplace=5]="CellReplace"})(j=e.FileEditType||(e.FileEditType={}));let Q=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(L,te,_e,Ve){this._edits.push({_type:1,from:L,to:te,options:_e,metadata:Ve})}createFile(L,te,_e){this._edits.push({_type:1,from:void 0,to:L,options:te,metadata:_e})}deleteFile(L,te,_e){this._edits.push({_type:1,from:L,to:void 0,options:te,metadata:_e})}replaceNotebookMetadata(L,te,_e){this._edits.push({_type:3,metadata:_e,uri:L,edit:{editType:5,metadata:te},notebookMetadata:te})}replaceNotebookCells(L,te,_e,Ve,tt){let st,ut,Dt=[],Rt;if(Ht.isNotebookRange(te)&&Pe.isNotebookCellDataArray(_e)&&!Pe.isNotebookCellDataArray(Ve)?(st=te.start,ut=te.end,Dt=_e,Rt=Ve):typeof te=="number"&&typeof _e=="number"&&Pe.isNotebookCellDataArray(Ve)&&(st=te,ut=_e,Dt=Ve,Rt=tt),st===void 0||ut===void 0)throw new Error("Invalid arguments");(st!==ut||Dt.length>0)&&this._edits.push({_type:5,uri:L,index:st,count:ut-st,cells:Dt,metadata:Rt})}replaceNotebookCellMetadata(L,te,_e,Ve){this._edits.push({_type:3,metadata:Ve,uri:L,edit:{editType:8,index:te,metadata:_e}})}replace(L,te,_e,Ve){this._edits.push({_type:2,uri:L,edit:new ee(te,_e),metadata:Ve})}insert(L,te,_e,Ve){this.replace(L,new D(te,te),_e,Ve)}delete(L,te,_e){this.replace(L,te,"",_e)}has(L){return this._edits.some(te=>te._type===2&&te.uri.toString()===L.toString())}set(L,te){if(te)for(const _e of te)_e&&this._edits.push({_type:2,uri:L,edit:_e});else{for(let _e=0;_e<this._edits.length;_e++){const Ve=this._edits[_e];Ve._type===2&&Ve.uri.toString()===L.toString()&&(this._edits[_e]=void 0)}(0,u.coalesceInPlace)(this._edits)}}get(L){const te=[];for(let _e of this._edits)_e._type===2&&_e.uri.toString()===L.toString()&&te.push(_e.edit);return te}entries(){const L=new P.ResourceMap;for(let te of this._edits)if(te._type===2){let _e=L.get(te.uri);_e||(_e=[te.uri,[]],L.set(te.uri,_e)),_e[1].push(te.edit)}return[...L.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Q=Ue([I],Q),e.WorkspaceEdit=Q;let le=c=class{constructor(L){this._tabstop=1,this.value=L||""}static isSnippetString(L){return L instanceof c?!0:L?typeof L.value=="string":!1}static _escape(L){return L.replace(/\$|}|\\/g,"\\$&")}appendText(L){return this.value+=c._escape(L),this}appendTabstop(L=this._tabstop++){return this.value+="$",this.value+=L,this}appendPlaceholder(L,te=this._tabstop++){if(typeof L=="function"){const _e=new c;_e._tabstop=this._tabstop,L(_e),this._tabstop=_e._tabstop,L=_e.value}else L=c._escape(L);return this.value+="${",this.value+=te,this.value+=":",this.value+=L,this.value+="}",this}appendChoice(L,te=this._tabstop++){const _e=L.map(Ve=>Ve.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=_e,this.value+="|}",this}appendVariable(L,te){if(typeof te=="function"){const _e=new c;_e._tabstop=this._tabstop,te(_e),this._tabstop=_e._tabstop,te=_e.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=L,te&&(this.value+=":",this.value+=te),this.value+="}",this}};le=c=Ue([I],le),e.SnippetString=le;var ve;(function(U){U[U.Unnecessary=1]="Unnecessary",U[U.Deprecated=2]="Deprecated"})(ve=e.DiagnosticTag||(e.DiagnosticTag={}));var ue;(function(U){U[U.Hint=3]="Hint",U[U.Information=2]="Information",U[U.Warning=1]="Warning",U[U.Error=0]="Error"})(ue=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let Fe=R=class{constructor(L,te){if(this.uri=L,te)if(te instanceof D)this.range=te;else if(te instanceof O)this.range=new D(te,te);else throw new Error("Illegal argument")}static isLocation(L){return L instanceof R?!0:L?D.isRange(L.range)&&k.URI.isUri(L.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};Fe=R=Ue([I],Fe),e.Location=Fe;let Ke=class{constructor(L,te){this.location=L,this.message=te}static is(L){return L?typeof L.message=="string"&&L.location&&D.isRange(L.location.range)&&k.URI.isUri(L.location.uri):!1}static isEqual(L,te){return L===te?!0:!L||!te?!1:L.message===te.message&&L.location.range.isEqual(te.location.range)&&L.location.uri.toString()===te.location.uri.toString()}};Ke=Ue([I],Ke),e.DiagnosticRelatedInformation=Ke;let Oe=class{constructor(L,te,_e=ue.Error){if(!D.isRange(L))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=L,this.message=te,this.severity=_e}toJSON(){return{severity:ue[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(L,te){return L===te?!0:!L||!te?!1:L.message===te.message&&L.severity===te.severity&&L.code===te.code&&L.severity===te.severity&&L.source===te.source&&L.range.isEqual(te.range)&&(0,u.equals)(L.tags,te.tags)&&(0,u.equals)(L.relatedInformation,te.relatedInformation,Ke.isEqual)}};Oe=Ue([I],Oe),e.Diagnostic=Oe;let He=class{constructor(L,te){if(!L)throw new Error("Illegal argument, contents must be defined");Array.isArray(L)?this.contents=L:this.contents=[L],this.range=te}};He=Ue([I],He),e.Hover=He;var Je;(function(U){U[U.Text=0]="Text",U[U.Read=1]="Read",U[U.Write=2]="Write"})(Je=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Ye=class{constructor(L,te=Je.Text){this.range=L,this.kind=te}toJSON(){return{range:this.range,kind:Je[this.kind]}}};Ye=Ue([I],Ye),e.DocumentHighlight=Ye;var Qe;(function(U){U[U.File=0]="File",U[U.Module=1]="Module",U[U.Namespace=2]="Namespace",U[U.Package=3]="Package",U[U.Class=4]="Class",U[U.Method=5]="Method",U[U.Property=6]="Property",U[U.Field=7]="Field",U[U.Constructor=8]="Constructor",U[U.Enum=9]="Enum",U[U.Interface=10]="Interface",U[U.Function=11]="Function",U[U.Variable=12]="Variable",U[U.Constant=13]="Constant",U[U.String=14]="String",U[U.Number=15]="Number",U[U.Boolean=16]="Boolean",U[U.Array=17]="Array",U[U.Object=18]="Object",U[U.Key=19]="Key",U[U.Null=20]="Null",U[U.EnumMember=21]="EnumMember",U[U.Struct=22]="Struct",U[U.Event=23]="Event",U[U.Operator=24]="Operator",U[U.TypeParameter=25]="TypeParameter"})(Qe=e.SymbolKind||(e.SymbolKind={}));var W;(function(U){U[U.Deprecated=1]="Deprecated"})(W=e.SymbolTag||(e.SymbolTag={}));let K=n=class{constructor(L,te,_e,Ve,tt){this.name=L,this.kind=te,this.containerName=tt,typeof _e=="string"&&(this.containerName=_e),Ve instanceof Fe?this.location=Ve:_e instanceof D&&(this.location=new Fe(Ve,_e)),n.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Qe[this.kind],location:this.location,containerName:this.containerName}}};K=n=Ue([I],K),e.SymbolInformation=K;let X=i=class{constructor(L,te,_e,Ve,tt){this.name=L,this.detail=te,this.kind=_e,this.range=Ve,this.selectionRange=tt,this.children=[],i.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy");if(!L.range.contains(L.selectionRange))throw new Error("selectionRange must be contained in fullRange");L.children&&L.children.forEach(i.validate)}};X=i=Ue([I],X),e.DocumentSymbol=X;var oe;(function(U){U[U.Invoke=1]="Invoke",U[U.Automatic=2]="Automatic"})(oe=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let G=class{constructor(L,te){this.title=L,this.kind=te}};G=Ue([I],G),e.CodeAction=G;let ie=g=class{constructor(L){this.value=L}append(L){return new g(this.value?this.value+g.sep+L:L)}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+g.sep)}};ie.sep=".",ie=g=Ue([I],ie),e.CodeActionKind=ie,ie.Empty=new ie(""),ie.QuickFix=ie.Empty.append("quickfix"),ie.Refactor=ie.Empty.append("refactor"),ie.RefactorExtract=ie.Refactor.append("extract"),ie.RefactorInline=ie.Refactor.append("inline"),ie.RefactorRewrite=ie.Refactor.append("rewrite"),ie.Source=ie.Empty.append("source"),ie.SourceOrganizeImports=ie.Source.append("organizeImports"),ie.SourceFixAll=ie.Source.append("fixAll");let de=class{constructor(L,te){if(this.range=L,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};de=Ue([I],de),e.SelectionRange=de;class Te{constructor(L,te,_e,Ve,tt,st){this.kind=L,this.name=te,this.detail=_e,this.uri=Ve,this.range=tt,this.selectionRange=st}}e.CallHierarchyItem=Te;class Ne{constructor(L,te){this.fromRanges=te,this.from=L}}e.CallHierarchyIncomingCall=Ne;class ze{constructor(L,te){this.fromRanges=te,this.to=L}}e.CallHierarchyOutgoingCall=ze;var je;(function(U){U[U.Information=0]="Information",U[U.Warning=1]="Warning",U[U.Error=2]="Error"})(je=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let et=class{constructor(L,te){this.range=L,this.command=te}get isResolved(){return!!this.command}};et=Ue([I],et),e.CodeLens=et;let ot=f=class{constructor(L,te=!1){a.set(this,void 0),Xe(this,a,new b.MarkdownString(L,{supportThemeIcons:te}),"f")}static isMarkdownString(L){return L instanceof f?!0:L&&L.appendCodeblock&&L.appendMarkdown&&L.appendText&&L.value!==void 0}get value(){return Ae(this,a,"f").value}set value(L){Ae(this,a,"f").value=L}get isTrusted(){return Ae(this,a,"f").isTrusted}set isTrusted(L){Ae(this,a,"f").isTrusted=L}get supportThemeIcons(){return Ae(this,a,"f").supportThemeIcons}set supportThemeIcons(L){Ae(this,a,"f").supportThemeIcons=L}get supportHtml(){return Ae(this,a,"f").supportHtml}set supportHtml(L){Ae(this,a,"f").supportHtml=L}appendText(L){return Ae(this,a,"f").appendText(L),this}appendMarkdown(L){return Ae(this,a,"f").appendMarkdown(L),this}appendCodeblock(L,te){return Ae(this,a,"f").appendCodeblock(te??"",L),this}};a=new WeakMap,ot=f=Ue([I],ot),e.MarkdownString=ot;let ye=class{constructor(L,te){this.label=L,this.documentation=te}};ye=Ue([I],ye),e.ParameterInformation=ye;let nt=class{constructor(L,te){this.label=L,this.documentation=te,this.parameters=[]}};nt=Ue([I],nt),e.SignatureInformation=nt;let q=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};q=Ue([I],q),e.SignatureHelp=q;var J;(function(U){U[U.Invoke=1]="Invoke",U[U.TriggerCharacter=2]="TriggerCharacter",U[U.ContentChange=3]="ContentChange"})(J=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var pe;(function(U){U[U.Other=0]="Other",U[U.Type=1]="Type",U[U.Parameter=2]="Parameter"})(pe=e.InlayHintKind||(e.InlayHintKind={}));let $e=class{constructor(L,te,_e){this.text=L,this.position=te,this.kind=_e}};$e=Ue([I],$e),e.InlayHint=$e;var qe;(function(U){U[U.Invoke=0]="Invoke",U[U.TriggerCharacter=1]="TriggerCharacter",U[U.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(qe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var rt;(function(U){U[U.Text=0]="Text",U[U.Method=1]="Method",U[U.Function=2]="Function",U[U.Constructor=3]="Constructor",U[U.Field=4]="Field",U[U.Variable=5]="Variable",U[U.Class=6]="Class",U[U.Interface=7]="Interface",U[U.Module=8]="Module",U[U.Property=9]="Property",U[U.Unit=10]="Unit",U[U.Value=11]="Value",U[U.Enum=12]="Enum",U[U.Keyword=13]="Keyword",U[U.Snippet=14]="Snippet",U[U.Color=15]="Color",U[U.File=16]="File",U[U.Reference=17]="Reference",U[U.Folder=18]="Folder",U[U.EnumMember=19]="EnumMember",U[U.Constant=20]="Constant",U[U.Struct=21]="Struct",U[U.Event=22]="Event",U[U.Operator=23]="Operator",U[U.TypeParameter=24]="TypeParameter",U[U.User=25]="User",U[U.Issue=26]="Issue"})(rt=e.CompletionItemKind||(e.CompletionItemKind={}));var ft;(function(U){U[U.Deprecated=1]="Deprecated"})(ft=e.CompletionItemTag||(e.CompletionItemTag={}));let ht=class{constructor(L,te){this.label=L,this.kind=te}toJSON(){return{label:this.label,kind:this.kind&&rt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};ht=Ue([I],ht),e.CompletionItem=ht;let Ct=class{constructor(L=[],te=!1){this.items=L,this.isIncomplete=te}};Ct=Ue([I],Ct),e.CompletionList=Ct;let It=class{constructor(L,te,_e){this.text=L,this.range=te,this.command=_e}};It=Ue([I],It),e.InlineSuggestion=It;let Pt=class{constructor(L){this.items=L}};Pt=Ue([I],Pt),e.InlineSuggestions=Pt;var Ze;(function(U){U[U.Active=-1]="Active",U[U.Beside=-2]="Beside",U[U.One=1]="One",U[U.Two=2]="Two",U[U.Three=3]="Three",U[U.Four=4]="Four",U[U.Five=5]="Five",U[U.Six=6]="Six",U[U.Seven=7]="Seven",U[U.Eight=8]="Eight",U[U.Nine=9]="Nine"})(Ze=e.ViewColumn||(e.ViewColumn={}));var pt;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(pt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Ie;(function(U){U[U.Off=0]="Off",U[U.On=1]="On",U[U.Relative=2]="Relative"})(Ie=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ge;(function(U){U[U.Manual=1]="Manual",U[U.AfterDelay=2]="AfterDelay",U[U.FocusOut=3]="FocusOut"})(ge=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ce;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(Ce=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Z;(function(U){U[U.Keyboard=1]="Keyboard",U[U.Mouse=2]="Mouse",U[U.Command=3]="Command"})(Z=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var se;(function(U){U[U.Undo=1]="Undo",U[U.Redo=2]="Redo"})(se=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var fe;(function(U){U[U.OpenOpen=0]="OpenOpen",U[U.ClosedClosed=1]="ClosedClosed",U[U.OpenClosed=2]="OpenClosed",U[U.ClosedOpen=3]="ClosedOpen"})(fe=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(U){function L(te){switch(te){case"keyboard":return U.Keyboard;case"mouse":return U.Mouse;case"api":return U.Command}}U.fromValue=L}(Z=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let he=class{constructor(L,te){if(te&&!k.URI.isUri(te))throw(0,M.illegalArgument)("target");if(!D.isRange(L)||L.isEmpty)throw(0,M.illegalArgument)("range");this.range=L,this.target=te}};he=Ue([I],he),e.DocumentLink=he;let ke=class{constructor(L,te,_e,Ve){this.red=L,this.green=te,this.blue=_e,this.alpha=Ve}};ke=Ue([I],ke),e.Color=ke;let Le=class{constructor(L,te){if(te&&!(te instanceof ke))throw(0,M.illegalArgument)("color");if(!D.isRange(L)||L.isEmpty)throw(0,M.illegalArgument)("range");this.range=L,this.color=te}};Le=Ue([I],Le),e.ColorInformation=Le;let Me=class{constructor(L){if(!L||typeof L!="string")throw(0,M.illegalArgument)("label");this.label=L}};Me=Ue([I],Me),e.ColorPresentation=Me;var We;(function(U){U[U.RGB=0]="RGB",U[U.HEX=1]="HEX",U[U.HSL=2]="HSL"})(We=e.ColorFormat||(e.ColorFormat={}));var it;(function(U){U[U.Error=0]="Error",U[U.Warning=1]="Warning",U[U.Information=2]="Information"})(it=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class Re{constructor(L,te,_e){if(this.startIndex=L,this.length=te,this.tooltip=_e,typeof L!="number"||L<0)throw(0,M.illegalArgument)("startIndex");if(typeof te!="number"||te<1)throw(0,M.illegalArgument)("length");if(_e!==void 0&&typeof _e!="string")throw(0,M.illegalArgument)("tooltip")}}e.TerminalLink=Re;var ce;(function(U){U[U.Panel=1]="Panel",U[U.Editor=2]="Editor"})(ce=e.TerminalLocation||(e.TerminalLocation={}));class me{constructor(L){this.options=L,typeof L!="object"&&(0,M.illegalArgument)("options")}}e.TerminalProfile=me;var ne;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(ne=e.TaskRevealKind||(e.TaskRevealKind={}));var H;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})(H=e.TaskPanelKind||(e.TaskPanelKind={}));let we=s=class{constructor(L,te){if(this.label=te,typeof L!="string"||typeof te!="string")throw(0,M.illegalArgument)("name");this._id=L}static from(L){switch(L){case"clean":return s.Clean;case"build":return s.Build;case"rebuild":return s.Rebuild;case"test":return s.Test;default:return}}get id(){return this._id}};we.Clean=new s("clean","Clean"),we.Build=new s("build","Build"),we.Rebuild=new s("rebuild","Rebuild"),we.Test=new s("test","Test"),we=s=Ue([I],we),e.TaskGroup=we;function De(U){let L="";for(let te=0;te<U.length;te++)L+=U[te].replace(/,/g,",,")+",";return L}let Ge=class{constructor(L,te,_e){if(typeof L!="string")throw(0,M.illegalArgument)("process");this._args=[],this._process=L,te!==void 0&&(Array.isArray(te)?(this._args=te,this._options=_e):this._options=te)}get process(){return this._process}set process(L){if(typeof L!="string")throw(0,M.illegalArgument)("process");this._process=L}get args(){return this._args}set args(L){Array.isArray(L)||(L=[]),this._args=L}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("process"),this._process!==void 0&&L.push(this._process),this._args&&this._args.length>0)for(let te of this._args)L.push(te);return De(L)}};Ge=Ue([I],Ge),e.ProcessExecution=Ge;let xe=class{constructor(L,te,_e){if(this._args=[],Array.isArray(te)){if(!L)throw(0,M.illegalArgument)("command can't be undefined or null");if(typeof L!="string"&&typeof L.value!="string")throw(0,M.illegalArgument)("command");this._command=L,this._args=te,this._options=_e}else{if(typeof L!="string")throw(0,M.illegalArgument)("commandLine");this._commandLine=L,this._options=te}}get commandLine(){return this._commandLine}set commandLine(L){if(typeof L!="string")throw(0,M.illegalArgument)("commandLine");this._commandLine=L}get command(){return this._command?this._command:""}set command(L){if(typeof L!="string"&&typeof L.value!="string")throw(0,M.illegalArgument)("command");this._command=L}get args(){return this._args}set args(L){this._args=L||[]}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("shell"),this._commandLine!==void 0&&L.push(this._commandLine),this._command!==void 0&&L.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let te of this._args)L.push(typeof te=="string"?te:te.value);return De(L)}};xe=Ue([I],xe),e.ShellExecution=xe;var ct;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(ct=e.ShellQuoting||(e.ShellQuoting={}));var _t;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace"})(_t=e.TaskScope||(e.TaskScope={}));class wt{constructor(L){this._callback=L}computeId(){return"customExecution"+(0,F.generateUuid)()}set callback(L){this._callback=L}get callback(){return this._callback}}e.CustomExecution=wt;let lt=v=class{constructor(L,te,_e,Ve,tt,st){this.__deprecated=!1,this._definition=this.definition=L;let ut;typeof te=="string"?(this._name=this.name=te,this._source=this.source=_e,this.execution=Ve,ut=tt,this.__deprecated=!0):te===_t.Global||te===_t.Workspace?(this.target=te,this._name=this.name=_e,this._source=this.source=Ve,this.execution=tt,ut=st):(this.target=te,this._name=this.name=_e,this._source=this.source=Ve,this.execution=tt,ut=st),typeof ut=="string"?(this._problemMatchers=[ut],this._hasDefinedMatchers=!0):Array.isArray(ut)?(this._problemMatchers=ut,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(L){this.__id=L}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ge?this._definition={type:v.ProcessType,id:this._execution.computeId()}:this._execution instanceof xe?this._definition={type:v.ShellType,id:this._execution.computeId()}:this._execution instanceof wt?this._definition={type:v.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:v.EmptyType,id:(0,F.generateUuid)()}}get definition(){return this._definition}set definition(L){if(L==null)throw(0,M.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=L}get scope(){return this._scope}set target(L){this.clear(),this._scope=L}get name(){return this._name}set name(L){if(typeof L!="string")throw(0,M.illegalArgument)("name");this.clear(),this._name=L}get execution(){return this._execution}set execution(L){L===null&&(L=void 0),this.clear(),this._execution=L;const te=this._definition.type;(v.EmptyType===te||v.ProcessType===te||v.ShellType===te||v.ExtensionCallbackType===te)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(L){if(Array.isArray(L))this.clear(),this._problemMatchers=L,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(L){L!==!0&&L!==!1&&(L=!1),this.clear(),this._isBackground=L}get source(){return this._source}set source(L){if(typeof L!="string"||L.length===0)throw(0,M.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=L}get group(){return this._group}set group(L){L===null&&(L=void 0),this.clear(),this._group=L}get detail(){return this._detail}set detail(L){L===null&&(L=void 0),this._detail=L}get presentationOptions(){return this._presentationOptions}set presentationOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._presentationOptions=L}get runOptions(){return this._runOptions}set runOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._runOptions=L}};lt.ExtensionCallbackType="customExecution",lt.ProcessType="process",lt.ShellType="shell",lt.EmptyType="$empty",lt=v=Ue([I],lt),e.Task=lt;var gt;(function(U){U[U.SourceControl=1]="SourceControl",U[U.Window=10]="Window",U[U.Notification=15]="Notification"})(gt=e.ProgressLocation||(e.ProgressLocation={}));let dt=class{constructor(L,te=Tt.None){this.collapsibleState=te,k.URI.isUri(L)?this.resourceUri=L:this.label=L}};dt=Ue([I],dt),e.TreeItem=dt;var Tt;(function(U){U[U.None=0]="None",U[U.Collapsed=1]="Collapsed",U[U.Expanded=2]="Expanded"})(Tt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let yt=class{constructor(L,te){this.id=L,this.color=te}};yt=Ue([I],yt),e.ThemeIcon=yt,yt.File=new yt("file"),yt.Folder=new yt("folder");let Bt=class{constructor(L){this.id=L}};Bt=Ue([I],Bt),e.ThemeColor=Bt;var Vt;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.WorkspaceFolder=3]="WorkspaceFolder"})(Vt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let St=class{constructor(L,te){if(typeof L!="string"&&(!L||!k.URI.isUri(L)&&!k.URI.isUri(L.uri)))throw(0,M.illegalArgument)("base");if(typeof te!="string")throw(0,M.illegalArgument)("pattern");typeof L=="string"?(this.baseFolder=k.URI.file(L),this.base=L):k.URI.isUri(L)?(this.baseFolder=L,this.base=L.fsPath):(this.baseFolder=L.uri,this.base=L.uri.fsPath),this.pattern=te}};St=Ue([I],St),e.RelativePattern=St;let $t=class{constructor(L,te,_e,Ve){this.enabled=typeof L=="boolean"?L:!0,typeof te=="string"&&(this.condition=te),typeof _e=="string"&&(this.hitCondition=_e),typeof Ve=="string"&&(this.logMessage=Ve)}get id(){return this._id||(this._id=(0,F.generateUuid)()),this._id}};$t=Ue([I],$t),e.Breakpoint=$t;let ti=class extends $t{constructor(L,te,_e,Ve,tt){super(te,_e,Ve,tt);if(L===null)throw(0,M.illegalArgument)("location");this.location=L}};ti=Ue([I],ti),e.SourceBreakpoint=ti;let bt=class extends $t{constructor(L,te,_e,Ve,tt){super(te,_e,Ve,tt);this.functionName=L}};bt=Ue([I],bt),e.FunctionBreakpoint=bt;let Qt=class extends $t{constructor(L,te,_e,Ve,tt,st,ut){super(Ve,tt,st,ut);if(!te)throw(0,M.illegalArgument)("dataId");this.label=L,this.dataId=te,this.canPersist=_e}};Qt=Ue([I],Qt),e.DataBreakpoint=Qt;let jt=class{constructor(L,te,_e){this.command=L,this.args=te||[],this.options=_e}};jt=Ue([I],jt),e.DebugAdapterExecutable=jt;let ii=class{constructor(L,te){this.port=L,this.host=te}};ii=Ue([I],ii),e.DebugAdapterServer=ii;let ni=class{constructor(L){this.path=L}};ni=Ue([I],ni),e.DebugAdapterNamedPipeServer=ni;let At=class{constructor(L){this.implementation=L}};At=Ue([I],At),e.DebugAdapterInlineImplementation=At;let Yt=class{constructor(L,te){this.range=L,this.expression=te}};Yt=Ue([I],Yt),e.EvaluatableExpression=Yt;var wi;(function(U){U[U.Automatic=0]="Automatic",U[U.Explicit=1]="Explicit"})(wi=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let zt=class{constructor(L,te){this.range=L,this.text=te}};zt=Ue([I],zt),e.InlineValueText=zt;let Wt=class{constructor(L,te,_e=!0){this.range=L,this.variableName=te,this.caseSensitiveLookup=_e}};Wt=Ue([I],Wt),e.InlineValueVariableLookup=Wt;let mt=class{constructor(L,te){this.range=L,this.expression=te}};mt=Ue([I],mt),e.InlineValueEvaluatableExpression=mt;let ri=class{constructor(L,te){this.frameId=L,this.stoppedLocation=te}};ri=Ue([I],ri),e.InlineValueContext=ri;var Ot;(function(U){U[U.Changed=1]="Changed",U[U.Created=2]="Created",U[U.Deleted=3]="Deleted"})(Ot=e.FileChangeType||(e.FileChangeType={}));let Nt=l=class extends Error{constructor(L,te=y.FileSystemProviderErrorCode.Unknown,_e){super(k.URI.isUri(L)?L.toString(!0):L);this.code=_e?.name??"Unknown",(0,y.markAsFileSystemProviderError)(this,te),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,l.prototype),typeof Error.captureStackTrace=="function"&&typeof _e=="function"&&Error.captureStackTrace(this,_e)}static FileExists(L){return new l(L,y.FileSystemProviderErrorCode.FileExists,l.FileExists)}static FileNotFound(L){return new l(L,y.FileSystemProviderErrorCode.FileNotFound,l.FileNotFound)}static FileNotADirectory(L){return new l(L,y.FileSystemProviderErrorCode.FileNotADirectory,l.FileNotADirectory)}static FileIsADirectory(L){return new l(L,y.FileSystemProviderErrorCode.FileIsADirectory,l.FileIsADirectory)}static NoPermissions(L){return new l(L,y.FileSystemProviderErrorCode.NoPermissions,l.NoPermissions)}static Unavailable(L){return new l(L,y.FileSystemProviderErrorCode.Unavailable,l.Unavailable)}};Nt=l=Ue([I],Nt),e.FileSystemError=Nt;let Jt=class{constructor(L,te,_e){this.start=L,this.end=te,this.kind=_e}};Jt=Ue([I],Jt),e.FoldingRange=Jt;var bi;(function(U){U[U.Comment=1]="Comment",U[U.Imports=2]="Imports",U[U.Region=3]="Region"})(bi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var di;(function(U){U[U.Collapsed=0]="Collapsed",U[U.Expanded=1]="Expanded"})(di=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Ei;(function(U){U[U.Editing=0]="Editing",U[U.Preview=1]="Preview"})(Ei=e.CommentMode||(e.CommentMode={}));class hi{constructor(L,te=[]){this.tokenTypes=L,this.tokenModifiers=te}}e.SemanticTokensLegend=hi;function Xt(U){return typeof U=="undefined"||(0,C.isStringArray)(U)}class oi{constructor(L){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,L){this._hasLegend=!0;for(let te=0,_e=L.tokenTypes.length;te<_e;te++)this._tokenTypeStrToInt.set(L.tokenTypes[te],te);for(let te=0,_e=L.tokenModifiers.length;te<_e;te++)this._tokenModifierStrToInt.set(L.tokenModifiers[te],te)}}push(L,te,_e,Ve,tt){if(typeof L=="number"&&typeof te=="number"&&typeof _e=="number"&&typeof Ve=="number"&&(typeof tt=="number"||typeof tt=="undefined"))return typeof tt=="undefined"&&(tt=0),this._pushEncoded(L,te,_e,Ve,tt);if(D.isRange(L)&&typeof te=="string"&&Xt(_e))return this._push(L,te,_e);throw(0,M.illegalArgument)()}_push(L,te,_e){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(L.start.line!==L.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(te))throw new Error("`tokenType` is not in the provided legend");const Ve=L.start.line,tt=L.start.character,st=L.end.character-L.start.character,ut=this._tokenTypeStrToInt.get(te);let Dt=0;if(_e)for(const Rt of _e){if(!this._tokenModifierStrToInt.has(Rt))throw new Error("`tokenModifier` is not in the provided legend");const Mt=this._tokenModifierStrToInt.get(Rt);Dt|=1<<Mt>>>0}this._pushEncoded(Ve,tt,st,ut,Dt)}_pushEncoded(L,te,_e,Ve,tt){if(this._dataIsSortedAndDeltaEncoded&&(L<this._prevLine||L===this._prevLine&&te<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Dt=this._data.length/5|0;let Rt=0,Mt=0;for(let Lt=0;Lt<Dt;Lt++){let xt=this._data[5*Lt],li=this._data[5*Lt+1];xt===0?(xt=Rt,li+=Mt):xt+=Rt,this._data[5*Lt]=xt,this._data[5*Lt+1]=li,Rt=xt,Mt=li}}let st=L,ut=te;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(st-=this._prevLine,st===0&&(ut-=this._prevChar)),this._data[this._dataLen++]=st,this._data[this._dataLen++]=ut,this._data[this._dataLen++]=_e,this._data[this._dataLen++]=Ve,this._data[this._dataLen++]=tt,this._prevLine=L,this._prevChar=te}static _sortAndDeltaEncode(L){let te=[];const _e=L.length/5|0;for(let ut=0;ut<_e;ut++)te[ut]=ut;te.sort((ut,Dt)=>{const Rt=L[5*ut],Mt=L[5*Dt];if(Rt===Mt){const Lt=L[5*ut+1],xt=L[5*Dt+1];return Lt-xt}return Rt-Mt});const Ve=new Uint32Array(L.length);let tt=0,st=0;for(let ut=0;ut<_e;ut++){const Dt=5*te[ut],Rt=L[Dt+0],Mt=L[Dt+1],Lt=L[Dt+2],xt=L[Dt+3],li=L[Dt+4],Bi=Rt-tt,Ki=Bi===0?Mt-st:Mt,ui=5*ut;Ve[ui+0]=Bi,Ve[ui+1]=Ki,Ve[ui+2]=Lt,Ve[ui+3]=xt,Ve[ui+4]=li,tt=Rt,st=Mt}return Ve}build(L){return this._dataIsSortedAndDeltaEncoded?new qt(new Uint32Array(this._data),L):new qt(oi._sortAndDeltaEncode(this._data),L)}}e.SemanticTokensBuilder=oi;class qt{constructor(L,te){this.resultId=te,this.data=L}}e.SemanticTokens=qt;class si{constructor(L,te,_e){this.start=L,this.deleteCount=te,this.data=_e}}e.SemanticTokensEdit=si;class _i{constructor(L,te){this.resultId=te,this.edits=L}}e.SemanticTokensEdits=_i;var yi;(function(U){U[U.Separate=0]="Separate",U[U.MergeWithParent=1]="MergeWithParent"})(yi=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Gt;(function(U){U[U.Initial=1]="Initial",U[U.Dynamic=2]="Dynamic"})(Gt=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Zt=class{constructor(){}};Zt.Back={iconPath:new yt("arrow-left")},Zt=Ue([I],Zt),e.QuickInputButtons=Zt;var Si;(function(U){U[U.Default=1]="Default",U[U.Separator=2]="Separator"})(Si=e.QuickPickItemKind||(e.QuickPickItemKind={}));var Ci;(function(U){U[U.UI=1]="UI",U[U.Workspace=2]="Workspace"})(Ci=e.ExtensionKind||(e.ExtensionKind={}));class Di{constructor(L,te,_e){this.badge=L,this.tooltip=te,this.color=_e}static validate(L){if(L.badge){let te=(0,A.nextCharLength)(L.badge,0);if(te<L.badge.length&&(te+=(0,A.nextCharLength)(L.badge,te)),L.badge.length>te)throw new Error("The 'badge'-property must be undefined or a short character")}if(!L.color&&!L.badge&&!L.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=Di;let Kt=class{constructor(L){this.kind=L}};Kt=Ue([I],Kt),e.ColorTheme=Kt;var fi;(function(U){U[U.Light=1]="Light",U[U.Dark=2]="Dark",U[U.HighContrast=3]="HighContrast"})(fi=e.ColorThemeKind||(e.ColorThemeKind={}));class Ht{constructor(L,te){if(L<0)throw(0,M.illegalArgument)("start must be positive");if(te<0)throw(0,M.illegalArgument)("end must be positive");L<=te?(this._start=L,this._end=te):(this._start=te,this._end=L)}static isNotebookRange(L){return L instanceof Ht?!0:L?typeof L.start=="number"&&typeof L.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(L){let te=this._start,_e=this._end;return L.start!==void 0&&(te=L.start),L.end!==void 0&&(_e=L.end),te===this._start&&_e===this._end?this:new Ht(te,_e)}}e.NotebookRange=Ht;class Pe{constructor(L,te,_e,Ve,tt,st,ut){this.kind=L,this.value=te,this.languageId=_e,this.mime=Ve,this.outputs=tt??[],this.metadata=st,this.executionSummary=ut,Pe.validate(this)}static validate(L){if(typeof L.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof L.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof L.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(L){return Array.isArray(L)&&L.every(te=>Pe.isNotebookCellData(te))}static isNotebookCellData(L){return!0}}e.NotebookCellData=Pe;class ai{constructor(L){this.cells=L}}e.NotebookData=ai;class Ft{constructor(L,te){this.data=L,this.mime=te;const _e=(0,t.normalizeMimeType)(te,!0);if(!_e)throw new Error(`INVALID mime type: ${te}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=_e}static isNotebookCellOutputItem(L){return L instanceof Ft?!0:L?typeof L.mime=="string"&&L.data instanceof Uint8Array:!1}static error(L){const te={name:L.name,message:L.message,stack:L.stack};return Ft.json(te,"application/vnd.code.notebook.error")}static stdout(L){return Ft.text(L,"application/vnd.code.notebook.stdout")}static stderr(L){return Ft.text(L,"application/vnd.code.notebook.stderr")}static bytes(L,te="application/octet-stream"){return new Ft(L,te)}static text(L,te=t.Mimes.text){const _e=Ae(Ft,h,"f",p).encode(String(L));return new Ft(_e,te)}static json(L,te="application/json"){const _e=JSON.stringify(L,void 0,"	");return Ft.text(_e,te)}}e.NotebookCellOutputItem=Ft,h=Ft,p={value:new TextEncoder};class vt{constructor(L,te,_e){this.items=vt.ensureUniqueMimeTypes(L,!0),typeof te=="string"?(this.id=te,this.metadata=_e):(this.id=(0,F.generateUuid)(),this.metadata=te??_e)}static isNotebookCellOutput(L){return L instanceof vt?!0:!L||typeof L!="object"?!1:typeof L.id=="string"&&(0,C.isArray)(L.items)}static ensureUniqueMimeTypes(L,te=!1){const _e=new Set,Ve=new Set;for(let tt=0;tt<L.length;tt++){const st=L[tt],ut=(0,t.normalizeMimeType)(st.mime);if(!_e.has(ut)){_e.add(ut);continue}Ve.add(tt),te&&console.warn(`DUPLICATED mime type '${st.mime}' will be dropped`)}return Ve.size===0?L:L.filter((tt,st)=>!Ve.has(st))}}e.NotebookCellOutput=vt;var ki;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(ki=e.NotebookCellKind||(e.NotebookCellKind={}));var Ii;(function(U){U[U.Idle=1]="Idle",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(Ii=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var mi;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(mi=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var gi;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(gi=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Pi{constructor(L,te){this.text=L,this.alignment=te}}e.NotebookCellStatusBarItem=Pi;var Ti;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred"})(Ti=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Ai{constructor(L,te=[]){this.uri=L,this.provides=(0,u.asArray)(te)}}e.NotebookRendererScript=Ai;let ci=class{constructor(L,te){this.label=L,this.timestamp=te}};ci=Ue([I],ci),e.TimelineItem=ci;var pi;(function(U){U[U.Production=1]="Production",U[U.Development=2]="Development",U[U.Test=3]="Test"})(pi=e.ExtensionMode||(e.ExtensionMode={}));var Ri;(function(U){U[U.Node=1]="Node",U[U.Webworker=2]="Webworker"})(Ri=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Fi;(function(U){U[U.Other=0]="Other",U[U.Comment=1]="Comment",U[U.String=2]="String",U[U.RegEx=4]="RegEx"})(Fi=e.StandardTokenType||(e.StandardTokenType={}));class Mi{constructor(L,te){this.ranges=L,this.wordPattern=te}}e.LinkedEditingRanges=Mi;class Li{constructor(L,te){this._port=L,this._autoForwardAction=te}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Li;var Oi;(function(U){U[U.Queued=1]="Queued",U[U.Running=2]="Running",U[U.Passed=3]="Passed",U[U.Failed=4]="Failed",U[U.Skipped=5]="Skipped",U[U.Errored=6]="Errored"})(Oi=e.TestResultState||(e.TestResultState={}));var Y;(function(U){U[U.Run=1]="Run",U[U.Debug=2]="Debug",U[U.Coverage=3]="Coverage"})(Y=e.TestRunProfileKind||(e.TestRunProfileKind={}));let ae=class{constructor(L=void 0,te=void 0,_e=void 0){this.include=L,this.exclude=te,this.profile=_e}};ae=Ue([I],ae),e.TestRunRequest=ae;let Se=E=class{constructor(L){this.message=L}static diff(L,te,_e){const Ve=new E(L);return Ve.expectedOutput=te,Ve.actualOutput=_e,Ve}};Se=E=Ue([I],Se),e.TestMessage=Se;let at=class{constructor(L){this.id=L}};at=Ue([I],at),e.TestTag=at;let Et=class{constructor(L,te){this.covered=L,this.total=te}};Et=Ue([I],Et),e.CoveredCount=Et;let kt=T=class{constructor(L,te,_e,Ve){this.uri=L,this.statementCoverage=te,this.branchCoverage=_e,this.functionCoverage=Ve}static fromDetails(L,te){const _e=new Et(0,0),Ve=new Et(0,0),tt=new Et(0,0);for(const ut of te)if("branches"in ut){_e.total+=1,_e.covered+=ut.executionCount>0?1:0;for(const Dt of ut.branches)Ve.total+=1,Ve.covered+=Dt.executionCount>0?1:0}else tt.total+=1,tt.covered+=ut.executionCount>0?1:0;const st=new T(L,_e,Ve.total>0?Ve:void 0,tt.total>0?tt:void 0);return st.detailedCoverage=te,st}};kt=T=Ue([I],kt),e.FileCoverage=kt;let Ni=class{constructor(L,te,_e=[]){this.executionCount=L,this.location=te,this.branches=_e}};Ni=Ue([I],Ni),e.StatementCoverage=Ni;let xi=class{constructor(L,te){this.executionCount=L,this.location=te}};xi=Ue([I],xi),e.BranchCoverage=xi;let Ui=class{constructor(L,te){this.executionCount=L,this.location=te}};Ui=Ue([I],Ui),e.FunctionCoverage=Ui;var Vi;(function(U){U[U.None=0]="None",U[U.Option=1]="Option",U[U.Default=2]="Default",U[U.Preferred=3]="Preferred"})(Vi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var ji;(function(U){U[U.Untrusted=0]="Untrusted",U[U.Trusted=1]="Trusted",U[U.Unspecified=2]="Unspecified"})(ji=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var qi;(function(U){U[U.Notify=1]="Notify",U[U.OpenBrowser=2]="OpenBrowser",U[U.OpenPreview=3]="OpenPreview",U[U.Silent=4]="Silent",U[U.Ignore=5]="Ignore",U[U.OpenBrowserOnce=6]="OpenBrowserOnce"})(qi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Gi{constructor(L,te,_e,Ve,tt,st){this.kind=L,this.name=te,this.detail=_e,this.uri=Ve,this.range=tt,this.selectionRange=st}}e.TypeHierarchyItem=Gi}),define(be[88],Ee([0,1,43,11,9,232,119,7,15]),function(re,e,u,M,b,P,t,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const k=new Map;function F(a,h){h?k.set(a,h):k.delete(a)}e.setWordDefinitionFor=F;function y(a){return k.get(a)}e.getWordDefinitionFor=y;class r extends P.MirrorTextModel{constructor(h,p,S,w,o,d,_,c){super(p,S,w,o);this._proxy=h,this._languageId=d,this._isDirty=_,this._notebook=c,this._isDisposed=!1}dispose(){(0,u.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(h){return(0,C.equals)(this._lines,h)}get document(){if(!this._document){const h=this;this._document={get uri(){return h._uri},get fileName(){return h._uri.fsPath},get isUntitled(){return h._uri.scheme===M.Schemas.untitled},get languageId(){return h._languageId},get version(){return h._versionId},get isClosed(){return h._isDisposed},get isDirty(){return h._isDirty},get notebook(){return h._notebook},save(){return h._save()},getText(p){return p?h._getTextInRange(p):h.getText()},get eol(){return h._eol===`
`?A.EndOfLine.LF:A.EndOfLine.CRLF},get lineCount(){return h._lines.length},lineAt(p){return h._lineAt(p)},offsetAt(p){return h._offsetAt(p)},positionAt(p){return h._positionAt(p)},validateRange(p){return h._validateRange(p)},validatePosition(p){return h._validatePosition(p)},getWordRangeAtPosition(p,S){return h._getWordRangeAtPosition(p,S)}}}return Object.freeze(this._document)}_acceptLanguageId(h){(0,u.ok)(!this._isDisposed),this._languageId=h}_acceptIsDirty(h){(0,u.ok)(!this._isDisposed),this._isDirty=h}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(h){const p=this._validateRange(h);if(p.isEmpty)return"";if(p.isSingleLine)return this._lines[p.start.line].substring(p.start.character,p.end.character);const S=this._eol,w=p.start.line,o=p.end.line,d=[];d.push(this._lines[w].substring(p.start.character));for(let _=w+1;_<o;_++)d.push(this._lines[_]);return d.push(this._lines[o].substring(0,p.end.character)),d.join(S)}_lineAt(h){let p;if(h instanceof A.Position?p=h.line:typeof h=="number"&&(p=h),typeof p!="number"||p<0||p>=this._lines.length||Math.floor(p)!==p)throw new Error("Illegal value for `line`");return new m(p,this._lines[p],p===this._lines.length-1)}_offsetAt(h){return h=this._validatePosition(h),this._ensureLineStarts(),this._lineStarts.getPrefixSum(h.line-1)+h.character}_positionAt(h){h=Math.floor(h),h=Math.max(0,h),this._ensureLineStarts();const p=this._lineStarts.getIndexOf(h),S=this._lines[p.index].length;return new A.Position(p.index,Math.min(p.remainder,S))}_validateRange(h){if(!(h instanceof A.Range))throw new Error("Invalid argument");const p=this._validatePosition(h.start),S=this._validatePosition(h.end);return p===h.start&&S===h.end?h:new A.Range(p.line,p.character,S.line,S.character)}_validatePosition(h){if(!(h instanceof A.Position))throw new Error("Invalid argument");if(this._lines.length===0)return h.with(0,0);let{line:p,character:S}=h,w=!1;if(p<0)p=0,S=0,w=!0;else if(p>=this._lines.length)p=this._lines.length-1,S=this._lines[p].length,w=!0;else{const o=this._lines[p].length;S<0?(S=0,w=!0):S>o&&(S=o,w=!0)}return w?new A.Position(p,S):h}_getWordRangeAtPosition(h,p){const S=this._validatePosition(h);if(!p)p=y(this._languageId);else if((0,b.regExpLeadsToEndlessLoop)(p))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${p.source}' because it matches the empty string.`);const w=(0,t.getWordAtText)(S.character+1,(0,t.ensureValidWordDefinition)(p),this._lines[S.line],0);if(w)return new A.Range(S.line,w.startColumn-1,S.line,w.endColumn-1)}}e.ExtHostDocumentData=r;class m{constructor(h,p,S){this._line=h,this._text=p,this._isLastLine=S}get lineNumber(){return this._line}get text(){return this._text}get range(){return new A.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new A.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=m}),define(be[157],Ee([0,1,7,3,233,6,58,20,2,37]),function(re,e,u,M,b,P,t,A,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class F{constructor(r,m,a,h){this._notebook=a,this._selector=h,this._disposables=new P.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this.uri=C.URI.from({scheme:"vscode-concat-doc",path:(0,k.generateUuid)()}),this._init(),this._disposables.add(m.onDidChangeDocument(S=>{const w=this._cellUris.get(S.document.uri);w!==void 0&&(this._cellLengths.setValue(w,this._cells[w].document.getText().length+1),this._cellLines.setValue(w,this._cells[w].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const p=S=>{S===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(r.onDidChangeNotebookCells(S=>p(S.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new A.ResourceMap;const r=[],m=[];for(const a of this._notebook.getCells())a.kind===u.NotebookCellKind.Code&&(!this._selector||(0,t.score)(this._selector,a.document.uri,a.document.languageId,!0))&&(this._cellUris.set(a.document.uri,this._cells.length),this._cells.push(a),r.push(a.document.getText().length+1),m.push(a.document.lineCount));this._cellLengths=new b.PrefixSumComputer(new Uint32Array(r)),this._cellLines=new b.PrefixSumComputer(new Uint32Array(m))}get version(){return this._versionId}getText(r){if(!r){let w="";for(const o of this._cells)w+=o.document.getText()+`
`;return w=w.slice(0,-1),w}if(r.isEmpty)return"";const m=this.locationAt(r.start),a=this.locationAt(r.end),h=this._cellUris.get(m.uri),p=this._cellUris.get(a.uri);if(h===void 0||p===void 0)return"";if(h===p)return this._cells[h].document.getText(new u.Range(m.range.start,a.range.end));const S=[this._cells[h].document.getText(new u.Range(m.range.start,new u.Position(this._cells[h].document.lineCount,0)))];for(let w=h+1;w<p;w++)S.push(this._cells[w].document.getText());return S.push(this._cells[p].document.getText(new u.Range(new u.Position(0,0),a.range.end))),S.join(`
`)}offsetAt(r){const m=this._cellLines.getIndexOf(r.line),a=this._cellLengths.getPrefixSum(m.index-1),h=this._cells[m.index].document.offsetAt(r.with(m.remainder));return a+h}positionAt(r){if(typeof r=="number"){const a=this._cellLengths.getIndexOf(r),h=this._cellLines.getPrefixSum(a.index-1);return this._cells[a.index].document.positionAt(a.remainder).translate(h)}const m=this._cellUris.get(r.uri);if(m!==void 0){const a=this._cellLines.getPrefixSum(m-1);return new u.Position(a+r.range.start.line,r.range.start.character)}return new u.Position(0,0)}locationAt(r){u.Range.isRange(r)||(r=new u.Range(r,r));const m=this._cellLines.getIndexOf(r.start.line);let a=m;r.isEmpty||(a=this._cellLines.getIndexOf(r.end.line));const h=new u.Position(m.remainder,r.start.character),p=new u.Position(a.remainder,r.end.character),S=new u.Range(h,p),w=this._cells[m.index];return new u.Location(w.document.uri,w.document.validateRange(S))}contains(r){return this._cellUris.has(r)}validateRange(r){const m=this.validatePosition(r.start),a=this.validatePosition(r.end);return r.with(m,a)}validatePosition(r){const m=this._cellLines.getIndexOf(r.line),a=new u.Position(m.remainder,r.character),h=this._cells[m.index].document.validatePosition(a),p=this._cellLines.getPrefixSum(m.index-1);return new u.Position(p+h.line,h.character)}}e.ExtHostNotebookConcatDocument=F}),define(be[158],Ee([0,1,7,14,3]),function(re,e,u,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let P=class{constructor(A){this._actual=new u.ColorTheme(u.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new b.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(A){let C=A==="light"?u.ColorThemeKind.Light:A==="dark"?u.ColorThemeKind.Dark:u.ColorThemeKind.HighContrast;this._actual=new u.ColorTheme(C),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};P=Ue([Be(0,M.IExtHostRpcService)],P),e.ExtHostTheming=P}),define(be[67],Ee([0,1,4]),function(re,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,u.createDecorator)("IURITransformerService");class M{constructor(P){P?(this.transformIncoming=P.transformIncoming.bind(P),this.transformOutgoing=P.transformOutgoing.bind(P),this.transformOutgoingURI=P.transformOutgoingURI.bind(P),this.transformOutgoingScheme=P.transformOutgoingScheme.bind(P)):(this.transformIncoming=t=>t,this.transformOutgoing=t=>t,this.transformOutgoingURI=t=>t,this.transformOutgoingScheme=t=>t)}}e.URITransformerService=M}),define(be[159],Ee([0,1,22]),function(re,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class M{constructor(){this.buffers=[]}add(C){let k=this.buffers.indexOf(C);return k<0&&(k=this.buffers.length,this.buffers.push(C)),k}}function b(A,C){if(C.serializeBuffersForPostMessage){const k=new M,F=(m,a)=>{if(a instanceof ArrayBuffer){const h=k.add(a);return{$$vscode_array_buffer_reference$$:!0,index:h}}else if(ArrayBuffer.isView(a)){const h=P(a);if(h){const p=k.add(a.buffer);return{$$vscode_array_buffer_reference$$:!0,index:p,view:{type:h,byteLength:a.byteLength,byteOffset:a.byteOffset}}}}return a},y=JSON.stringify(A,F),r=k.buffers.map(m=>{const a=new Uint8Array(m);return u.VSBuffer.wrap(a)});return{message:y,buffers:r}}else return{message:JSON.stringify(A),buffers:[]}}e.serializeWebviewMessage=b;function P(A){switch(A.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function t(A,C){const k=C.map(r=>{const m=new ArrayBuffer(r.byteLength);return new Uint8Array(m).set(r.buffer),m}),F=C.length?(r,m)=>{if(typeof m=="object"&&m.$$vscode_array_buffer_reference$$){const a=m,{index:h}=a,p=k[h];if(a.view)switch(a.view.type){case 1:return new Int8Array(p,a.view.byteOffset,a.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(p,a.view.byteOffset,a.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(p,a.view.byteOffset,a.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(p,a.view.byteOffset,a.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(p,a.view.byteOffset,a.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(p,a.view.byteOffset,a.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(p,a.view.byteOffset,a.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(p,a.view.byteOffset,a.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(p,a.view.byteOffset,a.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(p,a.view.byteOffset,a.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(p,a.view.byteOffset,a.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return p}return m}:void 0;return{message:JSON.parse(A,F),arrayBuffers:k}}e.deserializeWebviewMessage=t}),define(be[160],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var u;(function(M){function b(t){const A={items:new Map};return t.types.forEach((C,k)=>{A.items.set(C,{asString:async()=>t.items[k].asString})}),A}M.toITreeDataTransfer=b;async function P(t){const A={types:[],items:[]},C=Array.from(t.items.entries());for(const k of C)A.types.push(k[0]),A.items.push({asString:await k[1].asString()});return A}M.toTreeDataTransferDTO=P})(u=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(be[68],Ee([0,1,11,2]),function(re,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function b(A,C){return A.scheme===u.Schemas.http||A.scheme===u.Schemas.https?A:(C&&C.authority&&C.isRemote&&A.scheme===u.Schemas.file&&(A=M.URI.from({scheme:u.Schemas.vscodeRemote,authority:C.authority,path:A.path})),M.URI.from({scheme:u.Schemas.https,authority:`${A.scheme}+${P(A.authority)}.${e.webviewRootResourceAuthority}`,path:A.path,fragment:A.fragment,query:A.query}))}e.asWebviewUri=b;function P(A){return A.replace(/./g,C=>{const k=C.charCodeAt(0);return k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57?C:"-"+k.toString(16).padStart(4,"0")})}function t(A){return A.replace(/-([0-9a-f]{4})/g,(C,k)=>String.fromCharCode(parseInt(k,16)))}e.decodeAuthority=t}),define(be[161],Ee([0,1,3,6,68]),function(re,e,u,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class P{constructor(A,C,k){this._proxy=A,this._editors=C,this._initData=k,this._handlePool=0,this._disposables=new M.DisposableStore,this._insets=new Map,this._disposables.add(C.onDidChangeVisibleTextEditors(()=>{const F=C.getVisibleTextEditors();for(const y of this._insets.values())F.indexOf(y.editor)<0&&y.inset.dispose()}))}dispose(){this._insets.forEach(A=>A.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(A,C,k,F,y){let r;for(const o of this._editors.getVisibleTextEditors(!0))if(o.value===A){r=o;break}if(!r)throw new Error("not a visible editor");const m=this,a=this._handlePool++,h=new u.Emitter,p=new u.Emitter,S=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(o){return(0,b.asWebviewUri)(o,m._initData.remote)}get cspSource(){return b.webviewGenericCspSource}set options(o){this._options=o,m._proxy.$setOptions(a,o)}get options(){return this._options}set html(o){this._html=o,m._proxy.$setHtml(a,o)}get html(){return this._html}get onDidReceiveMessage(){return h.event}postMessage(o){return m._proxy.$postMessage(a,o)}},w=new class{constructor(){this.editor=A,this.line=C,this.height=k,this.webview=S,this.onDidDispose=p.event}dispose(){m._insets.has(a)&&(m._insets.delete(a),m._proxy.$disposeEditorInset(a),p.fire(),p.dispose(),h.dispose())}};return this._proxy.$createEditorInset(a,r.id,r.value.document.uri,C+1,k,F||{},y.identifier,y.extensionLocation),this._insets.set(a,{editor:A,inset:w,onDidReceiveMessage:h}),w}$onDidDispose(A){const C=this._insets.get(A);C&&C.inset.dispose()}$onDidReceiveMessage(A,C){const k=this._insets.get(A);k&&k.onDidReceiveMessage.fire(C)}}e.ExtHostEditorInsets=P}),define(be[162],Ee([0,1,132,10,2,6,4,38,30,47,15,11]),function(re,e,u,M,b,P,t,A,C,k,F,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.SideBySideEditorActiveContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,u.localize)(0,null),providerDisplayName:(0,u.localize)(1,null)},e.ActiveEditorDirtyContext=new A.RawContextKey("activeEditorIsDirty",!1,(0,u.localize)(2,null)),e.ActiveEditorPinnedContext=new A.RawContextKey("activeEditorIsNotPreview",!1,(0,u.localize)(3,null)),e.ActiveEditorStickyContext=new A.RawContextKey("activeEditorIsPinned",!1,(0,u.localize)(4,null)),e.ActiveEditorReadonlyContext=new A.RawContextKey("activeEditorIsReadonly",!1,(0,u.localize)(5,null)),e.ActiveEditorCanRevertContext=new A.RawContextKey("activeEditorCanRevert",!1,(0,u.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new A.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new A.RawContextKey("activeEditor",null,{type:"string",description:(0,u.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new A.RawContextKey("activeEditorAvailableEditorIds","",(0,u.localize)(8,null)),e.TextCompareEditorVisibleContext=new A.RawContextKey("textCompareEditorVisible",!1,(0,u.localize)(9,null)),e.TextCompareEditorActiveContext=new A.RawContextKey("textCompareEditorActive",!1,(0,u.localize)(10,null)),e.SideBySideEditorActiveContext=new A.RawContextKey("sideBySideEditorActive",!1,(0,u.localize)(11,null)),e.EditorGroupEditorsCountContext=new A.RawContextKey("groupEditorsCount",0,(0,u.localize)(12,null)),e.ActiveEditorGroupEmptyContext=new A.RawContextKey("activeEditorGroupEmpty",!1,(0,u.localize)(13,null)),e.ActiveEditorGroupIndexContext=new A.RawContextKey("activeEditorGroupIndex",0,(0,u.localize)(14,null)),e.ActiveEditorGroupLastContext=new A.RawContextKey("activeEditorGroupLast",!1,(0,u.localize)(15,null)),e.ActiveEditorGroupLockedContext=new A.RawContextKey("activeEditorGroupLocked",!1,(0,u.localize)(16,null)),e.MultipleEditorGroupsContext=new A.RawContextKey("multipleEditorGroups",!1,(0,u.localize)(17,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new A.RawContextKey("editorIsOpen",!1,(0,u.localize)(18,null)),e.InEditorZenModeContext=new A.RawContextKey("inZenMode",!1,(0,u.localize)(19,null)),e.IsCenteredLayoutContext=new A.RawContextKey("isCenteredLayout",!1,(0,u.localize)(20,null)),e.SplitEditorsVertically=new A.RawContextKey("splitEditorsVertically",!1,(0,u.localize)(21,null)),e.EditorAreaVisibleContext=new A.RawContextKey("editorAreaVisible",!0,(0,u.localize)(22,null)),e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function r(O,D,x){for(const N of x.visibleEditorPanes)if(N.group.id===D&&O.matches(N.input))return N.getViewState()}e.findViewStateForEditor=r;function m(O){if(_(O))return!1;const D=O;return b.URI.isUri(D?.resource)}e.isResourceEditorInput=m;function a(O){if(_(O))return!1;const D=O;return D?.original!==void 0&&D.modified!==void 0}e.isResourceDiffEditorInput=a;function h(O){if(_(O)||a(O))return!1;const D=O;return D?.primary!==void 0&&D.secondary!==void 0}e.isResourceSideBySideEditorInput=h;function p(O){if(_(O))return!1;const D=O;return D?D.resource===void 0||D.resource.scheme===y.Schemas.untitled||D.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=p;var S;(function(O){O[O.SHORT=0]="SHORT",O[O.MEDIUM=1]="MEDIUM",O[O.LONG=2]="LONG"})(S=e.Verbosity||(e.Verbosity={}));var w;(function(O){O[O.EXPLICIT=1]="EXPLICIT",O[O.AUTO=2]="AUTO",O[O.FOCUS_CHANGE=3]="FOCUS_CHANGE",O[O.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(w=e.SaveReason||(e.SaveReason={}));var o;(function(O){O[O.None=0]="None",O[O.Readonly=2]="Readonly",O[O.Untitled=4]="Untitled",O[O.Singleton=8]="Singleton",O[O.RequiresTrust=16]="RequiresTrust",O[O.CanSplitInGroup=32]="CanSplitInGroup",O[O.ForceDescription=64]="ForceDescription"})(o=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class d extends P.Disposable{}e.AbstractEditorInput=d;function _(O){return O instanceof d}e.isEditorInput=_;function c(O){const D=O;return b.URI.isUri(D?.preferredResource)}function R(O){const D=O;return _(D?.primary)&&_(D?.secondary)}e.isSideBySideEditorInput=R;function n(O){const D=O;return _(D?.modified)&&_(D?.original)}e.isDiffEditorInput=n;function i(O){return _(O?.editor)}e.isEditorInputWithOptions=i;function g(O){const D=O;return i(O)&&D?.group!==void 0}e.isEditorInputWithOptionsAndGroup=g;function f(O){const D=O;return typeof D?.groupId=="number"&&_(D.editor)}e.isEditorIdentifier=f;var s;(function(O){O[O.UNKNOWN=0]="UNKNOWN",O[O.REPLACE=1]="REPLACE",O[O.MOVE=2]="MOVE",O[O.UNPIN=3]="UNPIN"})(s=e.EditorCloseContext||(e.EditorCloseContext={}));var v;(function(O){O[O.PRIMARY=1]="PRIMARY",O[O.SECONDARY=2]="SECONDARY",O[O.BOTH=3]="BOTH",O[O.ANY=4]="ANY"})(v=e.SideBySideEditor||(e.SideBySideEditor={}));class l{getOriginalUri(D,x){if(!D)return;if(x?.supportSideBySide){const{primary:V,secondary:$}=this.getSideEditors(D);if(V&&$){if(x?.supportSideBySide===v.BOTH)return{primary:this.getOriginalUri(V,{filterByScheme:x.filterByScheme}),secondary:this.getOriginalUri($,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===v.ANY)return this.getOriginalUri(V,{filterByScheme:x.filterByScheme})??this.getOriginalUri($,{filterByScheme:x.filterByScheme});D=x.supportSideBySide===v.PRIMARY?V:$}}if(a(D)||h(D))return;const N=c(D)?D.preferredResource:D.resource;return!N||!x||!x.filterByScheme?N:this.filterUri(N,x.filterByScheme)}getSideEditors(D){return R(D)||h(D)?{primary:D.primary,secondary:D.secondary}:n(D)||a(D)?{primary:D.modified,secondary:D.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(D,x){if(!D)return;if(x?.supportSideBySide){const{primary:V,secondary:$}=this.getSideEditors(D);if(V&&$){if(x?.supportSideBySide===v.BOTH)return{primary:this.getCanonicalUri(V,{filterByScheme:x.filterByScheme}),secondary:this.getCanonicalUri($,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===v.ANY)return this.getCanonicalUri(V,{filterByScheme:x.filterByScheme})??this.getCanonicalUri($,{filterByScheme:x.filterByScheme});D=x.supportSideBySide===v.PRIMARY?V:$}}if(a(D)||h(D))return;const N=D.resource;return!N||!x||!x.filterByScheme?N:this.filterUri(N,x.filterByScheme)}filterUri(D,x){if(Array.isArray(x)){if(x.some(N=>D.scheme===N))return D}else if(x===D.scheme)return D}}e.EditorResourceAccessor=new l;var E;(function(O){O[O.LEFT=0]="LEFT",O[O.RIGHT=1]="RIGHT"})(E=e.CloseDirection||(e.CloseDirection={}));class T{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(D){const x=this.instantiationService=D.get(t.IInstantiationService);for(const[N,V]of this.editorSerializerConstructors)this.createEditorSerializer(N,V,x);this.editorSerializerConstructors.clear()}createEditorSerializer(D,x,N){const V=N.createInstance(x);this.editorSerializerInstances.set(D,V)}registerFileEditorFactory(D){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=D}getFileEditorFactory(){return(0,M.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(D,x){if(this.editorSerializerConstructors.has(D)||this.editorSerializerInstances.has(D))throw new Error(`A editor serializer with type ID '${D}' was already registered.`);return this.instantiationService?this.createEditorSerializer(D,x,this.instantiationService):this.editorSerializerConstructors.set(D,x),(0,P.toDisposable)(()=>{this.editorSerializerConstructors.delete(D),this.editorSerializerInstances.delete(D)})}getEditorSerializer(D){return this.editorSerializerInstances.get(typeof D=="string"?D:D.typeId)}}C.Registry.add(e.EditorExtensions.EditorFactory,new T);async function I(O,D){if(!O||!O.length)return[];const x=await Promise.all(O.map(async N=>{const V=b.URI.revive(N.fileUri);if(!V||!await D.canHandleResource(V))return;let z=N.exists,ee=N.type;if(typeof z!="boolean"||typeof ee!="number")try{ee=(await D.resolve(V)).isFile?k.FileType.File:k.FileType.Unknown,z=!0}catch{z=!1}if(!z&&N.openOnlyIfExists||ee!==k.FileType.File)return;const j={selection:z?N.selection:void 0,pinned:!0,override:N.editorOverrideId};let Q;return z?Q={resource:V,options:j}:Q={resource:V,options:j,forceUntitled:!0},Q}));return(0,F.coalesce)(x)}e.pathsToEditors=I;var B;(function(O){O[O.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",O[O.SEQUENTIAL=1]="SEQUENTIAL"})(B=e.EditorsOrder||(e.EditorsOrder={}))}),define(be[163],Ee([0,1,3,38,133,4,6,20,30,15,54,23,35,153]),function(re,e,u,M,b,P,t,A,C,k,F,y,r,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TREE_ITEM_DATA_TRANSFER_TYPE=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,m.registerIcon)("default-view-icon",r.Codicon.window,(0,b.localize)(0,null));var a;(function(g){g.ViewContainersRegistry="workbench.registry.view.containers",g.ViewsRegistry="workbench.registry.view"})(a=e.Extensions||(e.Extensions={}));var h;(function(g){g[g.Sidebar=0]="Sidebar",g[g.Panel=1]="Panel",g[g.AuxiliaryBar=2]="AuxiliaryBar"})(h=e.ViewContainerLocation||(e.ViewContainerLocation={})),e.ViewContainerLocations=[0,1,2];function p(g){switch(g){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=p;function S(g){return`viewContainer.${g}.enabled`}e.getEnabledViewContainerContextKey=S;class w extends t.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new u.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new u.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,k.flatten)([...this.viewContainers.values()])}registerViewContainer(f,s,v){const l=this.get(f.id);if(l)return l;const E=f;return E.openCommandActionDescriptor=v?.donotRegisterOpenCommand?void 0:E.openCommandActionDescriptor??{id:E.id},(0,A.getOrSet)(this.viewContainers,s,[]).push(E),v?.isDefault&&this.defaultViewContainers.push(E),this._onDidRegister.fire({viewContainer:E,viewContainerLocation:s}),E}deregisterViewContainer(f){for(const s of this.viewContainers.keys()){const v=this.viewContainers.get(s),l=v?.indexOf(f);if(l!==-1){v?.splice(l,1),v.length===0&&this.viewContainers.delete(s),this._onDidDeregister.fire({viewContainer:f,viewContainerLocation:s});return}}}get(f){return this.all.filter(s=>s.id===f)[0]}getViewContainers(f){return[...this.viewContainers.get(f)||[]]}getViewContainerLocation(f){return[...this.viewContainers.keys()].filter(s=>this.getViewContainers(s).filter(v=>v?.id===f.id).length>0)[0]}getDefaultViewContainer(f){return this.defaultViewContainers.find(s=>this.getViewContainerLocation(s)===f)}}C.Registry.add(a.ViewContainersRegistry,new w);var o;(function(g){g.Open="2_open",g.Debug="4_debug",g.SCM="5_scm",g.More="9_more"})(o=e.ViewContentGroups||(e.ViewContentGroups={}));function d(g,f){const s=g.group??o.More,v=f.group??o.More;return s!==v?s.localeCompare(v):(g.order??5)-(f.order??5)}class _ extends t.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new u.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new u.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new u.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new u.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new F.SetMap}registerViews(f,s){this.registerViews2([{views:f,viewContainer:s}])}registerViews2(f){f.forEach(({views:s,viewContainer:v})=>this.addViews(s,v)),this._onViewsRegistered.fire(f)}deregisterViews(f,s){const v=this.removeViews(f,s);v.length&&this._onViewsDeregistered.fire({views:v,viewContainer:s})}moveViews(f,s){for(const v of this._views.keys())if(v!==s){const l=this.removeViews(f,v);l.length&&(this.addViews(l,s),this._onDidChangeContainer.fire({views:l,from:v,to:s}))}}getViews(f){return this._views.get(f)||[]}getView(f){for(const s of this._viewContainers){const v=(this._views.get(s)||[]).filter(l=>l.id===f)[0];if(v)return v}return null}getViewContainer(f){for(const s of this._viewContainers)if((this._views.get(s)||[]).filter(l=>l.id===f)[0])return s;return null}registerViewWelcomeContent(f,s){return this._viewWelcomeContents.add(f,s),this._onDidChangeViewWelcomeContent.fire(f),(0,t.toDisposable)(()=>{this._viewWelcomeContents.delete(f,s),this._onDidChangeViewWelcomeContent.fire(f)})}registerViewWelcomeContent2(f,s){const v=new Map;for(const[l,E]of s)this._viewWelcomeContents.add(f,E),v.set(l,(0,t.toDisposable)(()=>{this._viewWelcomeContents.delete(f,E),this._onDidChangeViewWelcomeContent.fire(f)}));return this._onDidChangeViewWelcomeContent.fire(f),v}getViewWelcomeContent(f){const s=[];return this._viewWelcomeContents.forEach(f,v=>s.push(v)),s.sort(d)}addViews(f,s){let v=this._views.get(s);v||(v=[],this._views.set(s,v),this._viewContainers.push(s));for(const l of f){if(this.getView(l.id)!==null)throw new Error((0,b.localize)(1,null,l.id));v.push(l)}}removeViews(f,s){const v=this._views.get(s);if(!v)return[];const l=[],E=[];for(const T of v)f.includes(T)?l.push(T):E.push(T);return l.length&&(E.length?this._views.set(s,E):(this._views.delete(s),this._viewContainers.splice(this._viewContainers.indexOf(s),1))),l}}C.Registry.add(a.ViewsRegistry,new _),e.IViewsService=(0,P.createDecorator)("viewsService"),e.FocusedViewContext=new M.RawContextKey("focusedView","",(0,b.localize)(2,null));function c(g){return`view.${g}.visible`}e.getVisbileViewContextKey=c,e.IViewDescriptorService=(0,P.createDecorator)("viewDescriptorService");var R;(function(g){g[g.Default=0]="Default",g[g.Expand=1]="Expand"})(R=e.ViewVisibilityState||(e.ViewVisibilityState={}));var n;(function(g){g[g.None=0]="None",g[g.Collapsed=1]="Collapsed",g[g.Expanded=2]="Expanded"})(n=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class i{constructor(f,s){this.resolved=!1,this._hasResolve=!1,(0,y.mixin)(this,f),this._hasResolve=!!s,this.resolve=async v=>{if(s&&!this.resolved){const l=await s(v);l&&(this.tooltip=this.tooltip??l.tooltip,this.command=this.command??l.command)}v.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=i,e.TREE_ITEM_DATA_TRANSFER_TYPE="text/treeitems"}),define(be[164],Ee([0,1,3,13,134]),function(re,e,u,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class P{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new u.Emitter,this._onExit=new u.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(A){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=A}onEvent(A){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=A}onRequest(A){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=A}sendResponse(A){A.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${A.command}`)):this.internalSend("response",A)}sendRequest(A,C,k,F){const y={command:A};if(C&&Object.keys(C).length>0&&(y.arguments=C),this.internalSend("request",y),typeof F=="number"){const r=setTimeout(()=>{clearTimeout(r);const m=this.pendingRequests.get(y.seq);if(m){this.pendingRequests.delete(y.seq);const a={type:"response",seq:0,request_seq:y.seq,success:!1,command:A,message:(0,b.localize)(0,null,F,A)};m(a)}},F)}return k&&this.pendingRequests.set(y.seq,k),y.seq}acceptMessage(A){this.messageCallback?this.messageCallback(A):(this.queue.push(A),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(A,C){return A.type!=="event"||C.type!=="event"}async processQueue(){let A;for(;this.queue.length;){if((!A||this.needsTaskBoundaryBetween(this.queue[0],A))&&await(0,M.timeout)(0),A=this.queue.shift(),!A)return;switch(A.type){case"event":this.eventCallback&&this.eventCallback(A);break;case"request":this.requestCallback&&this.requestCallback(A);break;case"response":const C=A,k=this.pendingRequests.get(C.request_seq);k&&(this.pendingRequests.delete(C.request_seq),k(C));break}}}internalSend(A,C){C.type=A,C.seq=this.sequence++,this.sendMessage(C)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const A=new Map;this.pendingRequests.forEach((C,k)=>A.set(k,C)),await(0,M.timeout)(500),A.forEach((C,k)=>{C({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(k)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=P}),define(be[165],Ee([0,1,9,2,17,23,11]),function(re,e,u,M,b,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const A=/{([^}]+)}/g;function C(n,i,g){return n.replace(A,function(f,s){return i&&s.length>0&&s[0]!=="_"?f:g&&g.hasOwnProperty(s)?g[s]:f})}e.formatPII=C;function k(n){const i={};for(const g of Object.keys(n))g.startsWith("!")||(i[g]=n[g]);return i}e.filterExceptionsFromTelemetry=k;function F(n){return n.configuration.request==="attach"&&!y(n)&&(!n.parentSession||F(n.parentSession))}e.isSessionAttach=F;function y(n){let i=n.configuration.type;if(!!i)return i==="vslsShare"&&(i=n.configuration.adapterProxy.configuration.type),(0,u.equalsIgnoreCase)(i,"extensionhost")||(0,u.equalsIgnoreCase)(i,"pwa-extensionhost")?n:n.parentSession?y(n.parentSession):void 0}e.getExtensionHostDebugSession=y;function r(n){return n.type&&(n.label||n.program||n.runtime)}e.isDebuggerMainContribution=r;function m(n,i,g){let f,s=0,v=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,l=null;for(;l=v.exec(n);){let E=l.index+1,T=E+l[0].length;if(E<=i&&T>=g){f=l[0],s=E;break}}if(f){let E=/\w+/g,T=null;for(;(T=E.exec(f))&&!(T.index+1+s+T[0].length>=g););T&&(f=f.substring(0,E.lastIndex))}return f?{start:s,end:s+f.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=m;const a=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function h(n){return!!(n&&n.match(a))}e.isUri=h;function p(n){if(typeof n.path=="string"&&!(typeof n.sourceReference=="number"&&n.sourceReference>0)){if(h(n.path))return M.URI.parse(n.path);if((0,b.isAbsolute)(n.path))return M.URI.file(n.path)}return n.path}function S(n){if(typeof n.path=="object"){const i=M.URI.revive(n.path);if(i)return i.scheme===t.Schemas.file?i.fsPath:i.toString()}return n.path}function w(n,i){const g=i?p:S,f=(0,P.deepClone)(n);return d(f,(s,v)=>{s&&v&&(v.path=g(v))}),f}e.convertToDAPaths=w;function o(n,i){const g=i?p:S,f=(0,P.deepClone)(n);return d(f,(s,v)=>{!s&&v&&(v.path=g(v))}),f}e.convertToVSCPaths=o;function d(n,i){switch(n.type){case"event":const g=n;switch(g.event){case"output":i(!1,g.body.source);break;case"loadedSource":i(!1,g.body.source);break;case"breakpoint":i(!1,g.body.breakpoint.source);break;default:break}break;case"request":const f=n;switch(f.command){case"setBreakpoints":i(!0,f.arguments.source);break;case"breakpointLocations":i(!0,f.arguments.source);break;case"source":i(!0,f.arguments.source);break;case"gotoTargets":i(!0,f.arguments.source);break;case"launchVSCode":f.arguments.args.forEach(v=>i(!1,v));break;default:break}break;case"response":const s=n;if(s.success&&s.body)switch(s.command){case"stackTrace":s.body.stackFrames.forEach(v=>i(!1,v.source));break;case"loadedSources":s.body.sources.forEach(v=>i(!1,v));break;case"scopes":s.body.scopes.forEach(v=>i(!1,v.source));break;case"setFunctionBreakpoints":s.body.breakpoints.forEach(v=>i(!1,v.source));break;case"setBreakpoints":s.body.breakpoints.forEach(v=>i(!1,v.source));break;default:break}break}}function _(n){return n.filter(i=>!i.presentation?.hidden).sort((i,g)=>i.presentation?g.presentation?i.presentation.group?g.presentation.group?i.presentation.group!==g.presentation.group?i.presentation.group.localeCompare(g.presentation.group):c(i.presentation.order,g.presentation.order):-1:g.presentation.group?1:c(i.presentation.order,g.presentation.order):-1:g.presentation?1:0)}e.getVisibleAndSorted=_;function c(n,i){return typeof n!="number"?typeof i!="number"?0:1:typeof i!="number"?-1:n-i}async function R(n,i){const g=n.getValue("debug.saveBeforeStart",{overrideIdentifier:i.activeTextEditorMode});if(g!=="none"&&(await i.saveAll(),g==="allEditorsInActiveGroup")){const f=i.activeEditorPane;f&&await i.save({editor:f.input,groupId:f.group.id})}await n.reloadConfiguration()}e.saveAllBeforeDebugStart=R}),define(be[89],Ee([0,1,29,166,79,11,17,25,38]),function(re,e,u,M,b,P,t,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var k;(function(E){E[E.Markup=1]="Markup",E[E.Code=2]="Code"})(k=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",b.Mimes.latex,b.Mimes.markdown,"image/png","image/jpeg",b.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[b.Mimes.latex,b.Mimes.markdown,"application/json",b.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["vscode.ipynb"])],["ms-toolsai.jupyter-renderers",new Set(["vscode.ipynb"])]]),e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var F;(function(E){E[E.Running=1]="Running",E[E.Idle=2]="Idle"})(F=e.NotebookRunState||(e.NotebookRunState={}));var y;(function(E){E[E.Pending=2]="Pending",E[E.Executing=3]="Executing"})(y=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var r;(function(E){E[E.WithHardKernelDependency=0]="WithHardKernelDependency",E[E.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",E[E.Pure=2]="Pure",E[E.Never=3]="Never"})(r=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var m;(function(E){E.Always="always",E.Never="never",E.Optional="optional"})(m=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var a;(function(E){E[E.ModelChange=1]="ModelChange",E[E.Move=2]="Move",E[E.ChangeLanguage=5]="ChangeLanguage",E[E.Initialize=6]="Initialize",E[E.ChangeCellMetadata=7]="ChangeCellMetadata",E[E.Output=8]="Output",E[E.OutputItem=9]="OutputItem",E[E.ChangeCellContent=10]="ChangeCellContent",E[E.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",E[E.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",E[E.ChangeCellMime=13]="ChangeCellMime",E[E.Unknown=100]="Unknown"})(a=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var h;(function(E){E[E.Handle=0]="Handle",E[E.Index=1]="Index"})(h=e.SelectionStateType||(e.SelectionStateType={}));var p;(function(E){E[E.Replace=1]="Replace",E[E.Output=2]="Output",E[E.Metadata=3]="Metadata",E[E.CellLanguage=4]="CellLanguage",E[E.DocumentMetadata=5]="DocumentMetadata",E[E.Move=6]="Move",E[E.OutputItems=7]="OutputItems",E[E.PartialMetadata=8]="PartialMetadata",E[E.PartialInternalMetadata=9]="PartialInternalMetadata"})(p=e.CellEditType||(e.CellEditType={}));var S;(function(E){E.scheme=P.Schemas.vscodeNotebookCell;const T=/^ch(\d{7,})/;function I(N,V){return N.with({scheme:E.scheme,fragment:`ch${V.toString().padStart(7,"0")}${N.scheme!==P.Schemas.file?N.scheme:""}`})}E.generate=I;function B(N){if(N.scheme!==E.scheme)return;const V=T.exec(N.fragment);return V?{handle:Number(V[1]),notebook:N.with({scheme:N.fragment.substr(V[0].length)||P.Schemas.file,fragment:null})}:void 0}E.parse=B;function O(N){if(N.scheme!==P.Schemas.vscodeNotebookCellMetadata)return;const V=T.exec(N.fragment);return V?{handle:Number(V[1]),notebook:N.with({scheme:N.fragment.substr(V[0].length)||P.Schemas.file,fragment:null})}:void 0}E.parseCellMetadataUri=O;function D(N,V,$){return N.with({scheme:$,fragment:`ch${V.toString().padStart(7,"0")}${N.scheme!==P.Schemas.file?N.scheme:""}`})}E.generateCellUri=D;function x(N,V){if(N.scheme!==V)return;const $=T.exec(N.fragment);return $?{handle:Number($[1]),notebook:N.with({scheme:N.fragment.substr($[0].length)||P.Schemas.file,fragment:null})}:void 0}E.parseCellUri=x})(S=e.CellUri||(e.CellUri={}));const w=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[b.Mimes.latex,{alwaysSecure:!0,supportedByCore:!0}],[b.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function o(E){return w.get(E)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=o;function d(E){return w.get(E)?.supportedByCore??!1}e.mimeTypeSupportedByCore=d;function _(E){return w.get(E)?.mergeable??!1}e.mimeTypeIsMergeable=_;const c=E=>A.isWindows?E.replace(/\//g,"\\"):E;class R{constructor(T=[],I=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=I,this.order=[...new Set(T)].map(B=>({pattern:B,matches:u.parse(c(B))}))}sort(T){const I=new Map(M.Iterable.map(T,O=>[O,c(O)]));let B=[];for(const{matches:O}of this.order)for(const[D,x]of I)if(O(x)){B.push(D),I.delete(D);break}return I.size&&(B=B.concat([...I.keys()].sort((O,D)=>this.defaultOrder.indexOf(O)-this.defaultOrder.indexOf(D)))),B}prioritize(T,I){const B=this.findIndex(T);if(B===-1){this.order.unshift({pattern:T,matches:u.parse(c(T))});return}const O=new Set(I.map(x=>this.findIndex(x,B)));O.delete(-1);const D=Array.from(O).sort();this.order.splice(B+1,0,...D.map(x=>this.order[x]));for(let x=D.length-1;x>=0;x--)this.order.splice(D[x],1)}toArray(){return this.order.map(T=>T.pattern)}findIndex(T,I=this.order.length){const B=c(T);for(let O=0;O<I;O++)if(this.order[O].matches(B))return O;return-1}}e.MimeTypeDisplayOrder=R;function n(E,T,I,B=(O,D)=>O===D){const O=[];function D(V,$,z){if($===0&&z.length===0)return;const ee=O[O.length-1];ee&&ee.start+ee.deleteCount===V?(ee.deleteCount+=$,ee.toInsert.push(...z)):O.push({start:V,deleteCount:$,toInsert:z})}let x=0,N=0;for(;;){if(x===E.length){D(x,0,T.slice(N));break}if(N===T.length){D(x,E.length-x,[]);break}const V=E[x],$=T[N];if(B(V,$)){x+=1,N+=1;continue}I($)?(D(x,1,[]),x+=1):(D(x,0,[$]),N+=1)}return O}e.diff=n,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new C.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(E){E.default="default",E.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function g(E){const T=E;return!!((typeof T.include=="string"||u.isRelativePattern(T.include))&&(typeof T.exclude=="string"||u.isRelativePattern(T.exclude)))}e.isDocumentExcludePattern=g;function f(E,T,I){if(Array.isArray(E.viewType)&&E.viewType.indexOf(T)>=0||E.viewType===T)return!0;if(E.filenamePattern){let B=g(E.filenamePattern)?E.filenamePattern.include:E.filenamePattern,O=g(E.filenamePattern)?E.filenamePattern.exclude:void 0;if(u.match(B,(0,t.basename)(I.fsPath).toLowerCase()))return!(O&&u.match(O,(0,t.basename)(I.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=f;class s{constructor(T){this.textModel=T}getElements(){const T=new Int32Array(this.textModel.cells.length);for(let I=0;I<this.textModel.cells.length;I++)T[I]=this.textModel.cells[I].getHashValue();return T}}e.CellSequence=s,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize"};var v;(function(E){E[E.Left=1]="Left",E[E.Right=2]="Right"})(v=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class l{static create(T){return`${l._prefix}${T}`}static parse(T){if(T.startsWith(l._prefix))return T.substr(l._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=l,l._prefix="notebook/"}),define(be[167],Ee([0,1,4]),function(re,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var M;(function(b){b[b.Output=1]="Output",b[b.OutputItems=2]="OutputItems",b[b.ExecutionState=3]="ExecutionState",b[b.Complete=4]="Complete"})(M=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,u.createDecorator)("INotebookExecutionService")}),define(be[168],Ee([0,1,4,38]),function(re,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new M.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new M.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new M.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,u.createDecorator)(e.OUTPUT_SERVICE_ID);var b;(function(P){P[P.Append=1]="Append",P[P.Replace=2]="Replace",P[P.Clear=3]="Clear"})(b=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={}))}),define(be[169],Ee([0,1,136,4,38]),function(re,e,u,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new b.RawContextKey("customExecutionSupported",!0,u.localize(0,null)),e.ShellExecutionSupportedContext=new b.RawContextKey("shellExecutionSupported",!1,u.localize(1,null)),e.ProcessExecutionSupportedContext=new b.RawContextKey("processExecutionSupported",!1,u.localize(2,null)),e.ITaskService=(0,M.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(be[170],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function u(b){return[...b.entries()]}e.serializeEnvironmentVariableCollection=u;function M(b){return new Map(b)}e.deserializeEnvironmentVariableCollection=M}),define(be[90],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var u;(function(y){y[y.Unset=0]="Unset",y[y.Queued=1]="Queued",y[y.Running=2]="Running",y[y.Passed=3]="Passed",y[y.Failed=4]="Failed",y[y.Skipped=5]="Skipped",y[y.Errored=6]="Errored"})(u=e.TestResultState||(e.TestResultState={}));var M;(function(y){y[y.Run=2]="Run",y[y.Debug=4]="Debug",y[y.Coverage=8]="Coverage",y[y.HasNonDefaultProfile=16]="HasNonDefaultProfile",y[y.HasConfigurable=32]="HasConfigurable"})(M=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var b;(function(y){y[y.Error=0]="Error",y[y.Info=1]="Info"})(b=e.TestMessageType||(e.TestMessageType={}));var P;(function(y){y[y.NotExpandable=0]="NotExpandable",y[y.Expandable=1]="Expandable",y[y.BusyExpanding=2]="BusyExpanding",y[y.Expanded=3]="Expanded"})(P=e.TestItemExpandState||(e.TestItemExpandState={}));const t=(y,r)=>{r.expand!==void 0&&(y.expand=r.expand),r.item!==void 0&&(y.item=y.item?Object.assign(y.item,r.item):r.item)};e.applyTestItemUpdate=t;var A;(function(y){y[y.Function=0]="Function",y[y.Statement=1]="Statement"})(A=e.DetailType||(e.DetailType={}));var C;(function(y){y[y.Add=0]="Add",y[y.Update=1]="Update",y[y.Remove=2]="Remove",y[y.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",y[y.Retire=4]="Retire",y[y.AddTag=5]="AddTag",y[y.RemoveTag=6]="RemoveTag"})(C=e.TestDiffOpType||(e.TestDiffOpType={}));class k{add(r){}update(r){}remove(r,m){}complete(){}}e.IncrementalChangeCollector=k;class F{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(r){const m=this.createChangeCollector();for(const a of r)switch(a[0]){case 0:{const h=a[1];if(h.parent){if(this.items.has(h.parent)){const p=this.items.get(h.parent);p.children.add(h.item.extId);const S=this.createItem(h,p);this.items.set(h.item.extId,S),m.add(S)}}else{const p=this.createItem(h);this.roots.add(p),this.items.set(h.item.extId,p),m.add(p)}h.expand===2&&this.busyControllerCount++;break}case 1:{const h=a[1],p=this.items.get(h.extId);if(!p)break;h.expand!==void 0&&(p.expand===2&&this.busyControllerCount--,h.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(p,h),m.update(p);break}case 2:{const h=this.items.get(a[1]);if(!h)break;h.parent?this.items.get(h.parent).children.delete(h.item.extId):this.roots.delete(h);const p=[[a[1]]];for(;p.length;)for(const S of p.pop()){const w=this.items.get(S);w&&(p.push(w.children),this.items.delete(S),m.remove(w,w!==h),w.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(a[1]);break;case 3:this.updatePendingRoots(a[1]);break;case 5:this._tags.set(a[1].id,a[1]);break;case 6:this._tags.delete(a[1]);break}m.complete()}retireTest(r){}updatePendingRoots(r){this.pendingRootCount+=r}createChangeCollector(){return new k}}e.AbstractIncrementalTestCollection=F}),define(be[69],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var u;(function(P){P.Delimiter="\0"})(u=e.TestIdPathParts||(e.TestIdPathParts={}));var M;(function(P){P[P.IsSame=0]="IsSame",P[P.Disconnected=1]="Disconnected",P[P.IsChild=2]="IsChild",P[P.IsParent=3]="IsParent"})(M=e.TestPosition||(e.TestPosition={}));class b{constructor(t,A=t.length){if(this.path=t,this.viewEnd=A,t.length===0||A<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(t,A,C=t.parent){if(t.id===A)return new b([A]);let k=[t.id];for(let F=C;F&&F.id!==A;F=F.parent)k.push(F.id);return k.push(A),new b(k.reverse())}static isRoot(t){return!t.includes("\0")}static fromString(t){return new b(t.split("\0"))}static join(t,A){return new b([...t.path,A])}static joinToString(t,A){return t.toString()+"\0"+A}static compare(t,A){return t===A?0:A.startsWith(t+"\0")?2:t.startsWith(A+"\0")?3:1}get parentId(){return this.viewEnd>1?new b(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let t=1;t<=this.viewEnd;t++)yield new b(this.path,t)}compare(t){if(typeof t=="string")return b.compare(this.toString(),t);for(let A=0;A<t.viewEnd&&A<this.viewEnd;A++)if(t.path[A]!==this.path[A])return 1;return t.viewEnd>this.viewEnd?2:t.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let t=1;t<this.viewEnd;t++)this.stringifed+="\0",this.stringifed+=this.path[t]}return this.stringifed}}e.TestId=b}),define(be[171],Ee([0,1,17,91,10,23,25,78,137]),function(re,e,u,M,b,P,t,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class k{constructor(y,r,m){this._contributedVariables=new Map,this._context=y,this._labelService=r,m&&(this._envVariablesPromise=m.then(a=>this.prepareEnv(a)))}prepareEnv(y){if(t.isWindows){const r=Object.create(null);return Object.keys(y).forEach(m=>{r[m.toLowerCase()]=y[m]}),r}return y}resolveWithEnvironment(y,r,m){return this.recursiveResolve(this.prepareEnv(y),r?r.uri:void 0,m)}async resolveAsync(y,r){return this.recursiveResolve(await this._envVariablesPromise,y?y.uri:void 0,r)}async resolveAnyBase(y,r,m,a){const h=P.deepClone(r);return t.isWindows&&h.windows?Object.keys(h.windows).forEach(p=>h[p]=h.windows[p]):t.isMacintosh&&h.osx?Object.keys(h.osx).forEach(p=>h[p]=h.osx[p]):t.isLinux&&h.linux&&Object.keys(h.linux).forEach(p=>h[p]=h.linux[p]),delete h.windows,delete h.osx,delete h.linux,this.recursiveResolve(await this._envVariablesPromise,y?y.uri:void 0,h,m,a)}async resolveAnyAsync(y,r,m){return this.resolveAnyBase(y,r,m)}async resolveAnyMap(y,r,m){const a=new Map;return{newConfig:await this.resolveAnyBase(y,r,m,a),resolvedVariables:a}}resolveWithInteractionReplace(y,r,m,a){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(y,r,m,a){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(y,r){if(this._contributedVariables.has(y))throw new Error("Variable "+y+" is contributed twice.");this._contributedVariables.set(y,r)}recursiveResolve(y,r,m,a,h){if(b.isString(m))return this.resolveString(y,r,m,a,h);if(b.isArray(m))return m.map(p=>this.recursiveResolve(y,r,p,a,h));if(b.isObject(m)){let p=Object.create(null);return Object.keys(m).forEach(S=>{const w=this.resolveString(y,r,S,a,h);p[w]=this.recursiveResolve(y,r,m[S],a,h)}),p}return m}resolveString(y,r,m,a,h){return m.replace(k.VARIABLE_REGEXP,(S,w)=>{if(w.includes(k.VARIABLE_LHS))return S;let o=this.evaluateSingleVariable(y,S,w,r,a);return h&&h.set(w,o),o!==S&&b.isString(o)&&o.match(k.VARIABLE_REGEXP)&&(o=this.resolveString(y,r,o,a,h)),o})}fsPath(y){return this._labelService?this._labelService.getUriLabel(y,{noPrefix:!0}):y.fsPath}evaluateSingleVariable(y,r,m,a,h){let p;const S=m.split(":");S.length>1&&(m=S[0],p=S[1]);const w=()=>{const _=this._context.getFilePath();if(_)return _;throw new Error((0,C.localize)(0,null,r))},o=()=>{const _=w();if(this._context.getWorkspaceFolderPathForFile){const c=this._context.getWorkspaceFolderPathForFile();if(c)return c}throw new Error((0,C.localize)(1,null,r,u.basename(_)))},d=()=>{if(p){const _=this._context.getFolderUri(p);if(_)return _;throw new Error((0,C.localize)(2,null,r,p))}if(a)return a;throw this._context.getWorkspaceFolderCount()>1?new Error((0,C.localize)(3,null,r)):new Error((0,C.localize)(4,null,r))};switch(m){case"env":if(p){if(y){const _=y[t.isWindows?p.toLowerCase():p];if(b.isString(_))return _}return""}throw new Error((0,C.localize)(5,null,r));case"config":if(p){const _=this._context.getConfigurationValue(a,p);if(b.isUndefinedOrNull(_))throw new Error((0,C.localize)(6,null,r,p));if(b.isObject(_))throw new Error((0,C.localize)(7,null,r,p));return _}throw new Error((0,C.localize)(8,null,r));case"command":return this.resolveFromMap(r,p,h,"command");case"input":return this.resolveFromMap(r,p,h,"input");default:switch(m){case"workspaceRoot":case"workspaceFolder":return(0,A.normalizeDriveLetter)(this.fsPath(d()));case"cwd":return a||p?(0,A.normalizeDriveLetter)(this.fsPath(d())):M.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return u.basename(this.fsPath(d()));case"lineNumber":const _=this._context.getLineNumber();if(_)return _;throw new Error((0,C.localize)(9,null,r));case"selectedText":const c=this._context.getSelectedText();if(c)return c;throw new Error((0,C.localize)(10,null,r));case"file":return w();case"fileWorkspaceFolder":return o();case"relativeFile":return a||p?u.relative(this.fsPath(d()),w()):w();case"relativeFileDirname":const R=u.dirname(w());if(a||p){const f=u.relative(this.fsPath(d()),R);return f.length===0?".":f}return R;case"fileDirname":return u.dirname(w());case"fileExtname":return u.extname(w());case"fileBasename":return u.basename(w());case"fileBasenameNoExtension":const n=u.basename(w());return n.slice(0,n.length-u.extname(n).length);case"fileDirnameBasename":return u.basename(u.dirname(w()));case"execPath":const i=this._context.getExecPath();return i||r;case"execInstallFolder":const g=this._context.getAppRoot();return g||r;case"pathSeparator":return u.sep;default:try{const f=p?`${m}:${p}`:m;return this.resolveFromMap(r,f,h,void 0)}catch(f){return r}}}}resolveFromMap(y,r,m,a){if(r&&m){const h=a===void 0?m[r]:m[a+":"+r];if(typeof h=="string")return h;throw new Error((0,C.localize)(11,null,y))}return y}}e.AbstractVariableResolverService=k,k.VARIABLE_LHS="${",k.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(be[92],Ee([0,1,4,162]),function(re,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,u.createDecorator)("editorGroupsService");var b;(function(h){h[h.UP=0]="UP",h[h.DOWN=1]="DOWN",h[h.LEFT=2]="LEFT",h[h.RIGHT=3]="RIGHT"})(b=e.GroupDirection||(e.GroupDirection={}));var P;(function(h){h[h.HORIZONTAL=0]="HORIZONTAL",h[h.VERTICAL=1]="VERTICAL"})(P=e.GroupOrientation||(e.GroupOrientation={}));var t;(function(h){h[h.FIRST=0]="FIRST",h[h.LAST=1]="LAST",h[h.NEXT=2]="NEXT",h[h.PREVIOUS=3]="PREVIOUS"})(t=e.GroupLocation||(e.GroupLocation={}));var A;(function(h){h[h.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",h[h.EVEN=1]="EVEN",h[h.TOGGLE=2]="TOGGLE"})(A=e.GroupsArrangement||(e.GroupsArrangement={}));var C;(function(h){h[h.COPY_EDITORS=0]="COPY_EDITORS",h[h.MOVE_EDITORS=1]="MOVE_EDITORS"})(C=e.MergeGroupMode||(e.MergeGroupMode={}));function k(h){const p=h;return(0,M.isEditorInput)(p?.editor)&&(0,M.isEditorInput)(p?.replacement)}e.isEditorReplacement=k;var F;(function(h){h[h.CREATION_TIME=0]="CREATION_TIME",h[h.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",h[h.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(F=e.GroupsOrder||(e.GroupsOrder={}));var y;(function(h){h[h.GROUP_ACTIVE=0]="GROUP_ACTIVE",h[h.GROUP_INDEX=1]="GROUP_INDEX",h[h.GROUP_LOCKED=2]="GROUP_LOCKED",h[h.EDITOR_OPEN=3]="EDITOR_OPEN",h[h.EDITOR_CLOSE=4]="EDITOR_CLOSE",h[h.EDITOR_MOVE=5]="EDITOR_MOVE",h[h.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",h[h.EDITOR_LABEL=7]="EDITOR_LABEL",h[h.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",h[h.EDITOR_PIN=9]="EDITOR_PIN",h[h.EDITOR_STICKY=10]="EDITOR_STICKY",h[h.EDITOR_DIRTY=11]="EDITOR_DIRTY"})(y=e.GroupChangeKind||(e.GroupChangeKind={}));var r;(function(h){h[h.NEW_EDITOR=1]="NEW_EDITOR",h[h.MOVE_EDITOR=2]="MOVE_EDITOR",h[h.COPY_EDITOR=3]="COPY_EDITOR"})(r=e.OpenEditorContext||(e.OpenEditorContext={}));function m(h){const p=h;return!!p&&typeof p.id=="number"&&Array.isArray(p.editors)}e.isEditorGroup=m;function a(h){return h.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=a}),define(be[172],Ee([0,1,4,92]),function(re,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,u.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function b(P){const t=P;return typeof P=="number"||(0,M.isEditorGroup)(t)}e.isPreferredGroup=b}),define(be[8],Ee([0,1,15,22,77,234,57,23,10,2,45,61,138,83,50,89,69,172,7]),function(re,e,u,M,b,P,t,A,C,k,F,y,r,m,a,h,p,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var o;(function(ce){function me(H){const{selectionStartLineNumber:we,selectionStartColumn:De,positionLineNumber:Ge,positionColumn:xe}=H,ct=new w.Position(we-1,De-1),_t=new w.Position(Ge-1,xe-1);return new w.Selection(ct,_t)}ce.to=me;function ne(H){const{anchor:we,active:De}=H;return{selectionStartLineNumber:we.line+1,selectionStartColumn:we.character+1,positionLineNumber:De.line+1,positionColumn:De.character+1}}ce.from=ne})(o=e.Selection||(e.Selection={}));var d;(function(ce){function me(H){if(!H)return;const{start:we,end:De}=H;return{startLineNumber:we.line+1,startColumn:we.character+1,endLineNumber:De.line+1,endColumn:De.character+1}}ce.from=me;function ne(H){if(!H)return;const{startLineNumber:we,startColumn:De,endLineNumber:Ge,endColumn:xe}=H;return new w.Range(we-1,De-1,Ge-1,xe-1)}ce.to=ne})(d=e.Range||(e.Range={}));var _;(function(ce){function me(ne){switch(ne){case 1:return w.StandardTokenType.Comment;case 0:return w.StandardTokenType.Other;case 4:return w.StandardTokenType.RegEx;case 2:return w.StandardTokenType.String}}ce.to=me})(_=e.TokenType||(e.TokenType={}));var c;(function(ce){function me(H){return new w.Position(H.lineNumber-1,H.column-1)}ce.to=me;function ne(H){return{lineNumber:H.line+1,column:H.character+1}}ce.from=ne})(c=e.Position||(e.Position={}));var R;(function(ce){function me(we,De){return(0,u.coalesce)((0,u.asArray)(we).map(Ge=>ne(Ge,De)))}ce.from=me;function ne(we,De){if(typeof we=="string")return{$serialized:!0,language:we};if(we)return{$serialized:!0,language:we.language,scheme:H(we.scheme,De),pattern:typeof we.pattern=="undefined"?void 0:rt.from(we.pattern),exclusive:we.exclusive}}function H(we,De){return De&&typeof we=="string"?De.transformOutgoingScheme(we):we}})(R=e.DocumentSelector||(e.DocumentSelector={}));var n;(function(ce){function me(H){switch(H){case w.DiagnosticTag.Unnecessary:return 1;case w.DiagnosticTag.Deprecated:return 2}}ce.from=me;function ne(H){switch(H){case 1:return w.DiagnosticTag.Unnecessary;case 2:return w.DiagnosticTag.Deprecated;default:return}}ce.to=ne})(n=e.DiagnosticTag||(e.DiagnosticTag={}));var i;(function(ce){function me(H){let we;return H.code&&((0,C.isString)(H.code)||(0,C.isNumber)(H.code)?we=String(H.code):we={value:String(H.code.value),target:H.code.target}),{...d.from(H.range),message:H.message,source:H.source,code:we,severity:f.from(H.severity),relatedInformation:H.relatedInformation&&H.relatedInformation.map(g.from),tags:Array.isArray(H.tags)?(0,u.coalesce)(H.tags.map(n.from)):void 0}}ce.from=me;function ne(H){const we=new w.Diagnostic(d.to(H),H.message,f.to(H.severity));return we.source=H.source,we.code=(0,C.isString)(H.code)?H.code:H.code?.value,we.relatedInformation=H.relatedInformation&&H.relatedInformation.map(g.to),we.tags=H.tags&&(0,u.coalesce)(H.tags.map(n.to)),we}ce.to=ne})(i=e.Diagnostic||(e.Diagnostic={}));var g;(function(ce){function me(H){return{...d.from(H.location.range),message:H.message,resource:H.location.uri}}ce.from=me;function ne(H){return new w.DiagnosticRelatedInformation(new w.Location(H.resource,d.to(H)),H.message)}ce.to=ne})(g=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var f;(function(ce){function me(H){switch(H){case w.DiagnosticSeverity.Error:return m.MarkerSeverity.Error;case w.DiagnosticSeverity.Warning:return m.MarkerSeverity.Warning;case w.DiagnosticSeverity.Information:return m.MarkerSeverity.Info;case w.DiagnosticSeverity.Hint:return m.MarkerSeverity.Hint}return m.MarkerSeverity.Error}ce.from=me;function ne(H){switch(H){case m.MarkerSeverity.Info:return w.DiagnosticSeverity.Information;case m.MarkerSeverity.Warning:return w.DiagnosticSeverity.Warning;case m.MarkerSeverity.Error:return w.DiagnosticSeverity.Error;case m.MarkerSeverity.Hint:return w.DiagnosticSeverity.Hint;default:return w.DiagnosticSeverity.Error}}ce.to=ne})(f=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var s;(function(ce){function me(H){return typeof H=="number"&&H>=w.ViewColumn.One?H-1:H===w.ViewColumn.Beside?S.SIDE_GROUP:S.ACTIVE_GROUP}ce.from=me;function ne(H){if(typeof H=="number"&&H>=0)return H+1;throw new Error("invalid 'EditorGroupColumn'")}ce.to=ne})(s=e.ViewColumn||(e.ViewColumn={}));function v(ce){return typeof ce.range!="undefined"}function l(ce){return ce.length===0?!0:!!v(ce[0])}e.isDecorationOptionsArr=l;var E;(function(ce){function me(xe){return xe.map(ce.from)}ce.fromMany=me;function ne(xe){return xe&&typeof xe=="object"&&typeof xe.language=="string"&&typeof xe.value=="string"}function H(xe){let ct;if(ne(xe)){const{language:gt,value:dt}=xe;ct={value:"```"+gt+`
`+dt+"\n```\n"}}else w.MarkdownString.isMarkdownString(xe)?ct={value:xe.value,isTrusted:xe.isTrusted,supportThemeIcons:xe.supportThemeIcons,supportHtml:xe.supportHtml}:typeof xe=="string"?ct={value:xe}:ct={value:""};const _t=Object.create(null);ct.uris=_t;const wt=gt=>{try{let dt=k.URI.parse(gt,!0);dt=dt.with({query:we(dt.query,_t)}),_t[gt]=dt}catch(dt){}return""},lt=new P.Renderer;return lt.link=wt,lt.image=gt=>wt(b.parseHrefAndDimensions(gt).href),P(ct.value,{renderer:lt}),ct}ce.from=H;function we(xe,ct){if(!xe)return xe;let _t;try{_t=(0,t.parse)(xe)}catch(lt){}if(!_t)return xe;let wt=!1;return _t=(0,A.cloneAndChange)(_t,lt=>{if(k.URI.isUri(lt)){const gt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ct[gt]=lt,wt=!0,gt}else return}),wt?JSON.stringify(_t):xe}function De(xe){const ct=new w.MarkdownString(xe.value,xe.supportThemeIcons);return ct.isTrusted=xe.isTrusted,ct.supportHtml=xe.supportHtml,ct}ce.to=De;function Ge(xe){if(!!xe)return typeof xe=="string"?xe:ce.from(xe)}ce.fromStrict=Ge})(E=e.MarkdownString||(e.MarkdownString={}));function T(ce){return l(ce)?ce.map(me=>({range:d.from(me.range),hoverMessage:Array.isArray(me.hoverMessage)?E.fromMany(me.hoverMessage):me.hoverMessage?E.from(me.hoverMessage):void 0,renderOptions:me.renderOptions})):ce.map(me=>({range:d.from(me)}))}e.fromRangeOrRangeWithMessage=T;function I(ce){return typeof ce=="undefined"?ce:typeof ce=="string"?k.URI.file(ce):ce}e.pathOrURIToURI=I;var B;(function(ce){function me(ne){return typeof ne=="undefined"?ne:{contentText:ne.contentText,contentIconPath:ne.contentIconPath?I(ne.contentIconPath):void 0,border:ne.border,borderColor:ne.borderColor,fontStyle:ne.fontStyle,fontWeight:ne.fontWeight,textDecoration:ne.textDecoration,color:ne.color,backgroundColor:ne.backgroundColor,margin:ne.margin,width:ne.width,height:ne.height}}ce.from=me})(B=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var O;(function(ce){function me(ne){return typeof ne=="undefined"?ne:{backgroundColor:ne.backgroundColor,outline:ne.outline,outlineColor:ne.outlineColor,outlineStyle:ne.outlineStyle,outlineWidth:ne.outlineWidth,border:ne.border,borderColor:ne.borderColor,borderRadius:ne.borderRadius,borderSpacing:ne.borderSpacing,borderStyle:ne.borderStyle,borderWidth:ne.borderWidth,fontStyle:ne.fontStyle,fontWeight:ne.fontWeight,textDecoration:ne.textDecoration,cursor:ne.cursor,color:ne.color,opacity:ne.opacity,letterSpacing:ne.letterSpacing,gutterIconPath:ne.gutterIconPath?I(ne.gutterIconPath):void 0,gutterIconSize:ne.gutterIconSize,overviewRulerColor:ne.overviewRulerColor,before:ne.before?B.from(ne.before):void 0,after:ne.after?B.from(ne.after):void 0}}ce.from=me})(O=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var D;(function(ce){function me(ne){if(typeof ne=="undefined")return ne;switch(ne){case w.DecorationRangeBehavior.OpenOpen:return 0;case w.DecorationRangeBehavior.ClosedClosed:return 1;case w.DecorationRangeBehavior.OpenClosed:return 2;case w.DecorationRangeBehavior.ClosedOpen:return 3}}ce.from=me})(D=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var x;(function(ce){function me(ne){return{isWholeLine:ne.isWholeLine,rangeBehavior:ne.rangeBehavior?D.from(ne.rangeBehavior):void 0,overviewRulerLane:ne.overviewRulerLane,light:ne.light?O.from(ne.light):void 0,dark:ne.dark?O.from(ne.dark):void 0,backgroundColor:ne.backgroundColor,outline:ne.outline,outlineColor:ne.outlineColor,outlineStyle:ne.outlineStyle,outlineWidth:ne.outlineWidth,border:ne.border,borderColor:ne.borderColor,borderRadius:ne.borderRadius,borderSpacing:ne.borderSpacing,borderStyle:ne.borderStyle,borderWidth:ne.borderWidth,fontStyle:ne.fontStyle,fontWeight:ne.fontWeight,textDecoration:ne.textDecoration,cursor:ne.cursor,color:ne.color,opacity:ne.opacity,letterSpacing:ne.letterSpacing,gutterIconPath:ne.gutterIconPath?I(ne.gutterIconPath):void 0,gutterIconSize:ne.gutterIconSize,overviewRulerColor:ne.overviewRulerColor,before:ne.before?B.from(ne.before):void 0,after:ne.after?B.from(ne.after):void 0}}ce.from=me})(x=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var N;(function(ce){function me(H){return{text:H.newText,eol:H.newEol&&q.from(H.newEol),range:d.from(H.range)}}ce.from=me;function ne(H){const we=new w.TextEdit(d.to(H.range),H.text);return we.newEol=typeof H.eol=="undefined"?void 0:q.to(H.eol),we}ce.to=ne})(N=e.TextEdit||(e.TextEdit={}));var V;(function(ce){function me(H,we,De){const Ge={edits:[]};if(H instanceof w.WorkspaceEdit)for(let xe of H._allEntries())if(xe._type===1)Ge.edits.push({_type:1,oldUri:xe.from,newUri:xe.to,options:xe.options,metadata:xe.metadata});else if(xe._type===2){const ct=we?.getDocument(xe.uri);Ge.edits.push({_type:2,resource:xe.uri,edit:N.from(xe.edit),modelVersionId:ct?.version,metadata:xe.metadata})}else xe._type===3?Ge.edits.push({_type:3,metadata:xe.metadata,resource:xe.uri,edit:xe.edit,notebookMetadata:xe.notebookMetadata,notebookVersionId:De?.getNotebookDocument(xe.uri,!0)?.apiNotebook.version}):xe._type===5&&Ge.edits.push({_type:3,metadata:xe.metadata,resource:xe.uri,notebookVersionId:De?.getNotebookDocument(xe.uri,!0)?.apiNotebook.version,edit:{editType:1,index:xe.index,count:xe.count,cells:xe.cells.map(Ze.from)}});return Ge}ce.from=me;function ne(H){const we=new w.WorkspaceEdit;for(const De of H.edits)De.edit?we.replace(k.URI.revive(De.resource),d.to(De.edit.range),De.edit.text):we.renameFile(k.URI.revive(De.oldUri),k.URI.revive(De.newUri),De.options);return we}ce.to=ne})(V=e.WorkspaceEdit||(e.WorkspaceEdit={}));var $;(function(ce){const me=Object.create(null);me[w.SymbolKind.File]=0,me[w.SymbolKind.Module]=1,me[w.SymbolKind.Namespace]=2,me[w.SymbolKind.Package]=3,me[w.SymbolKind.Class]=4,me[w.SymbolKind.Method]=5,me[w.SymbolKind.Property]=6,me[w.SymbolKind.Field]=7,me[w.SymbolKind.Constructor]=8,me[w.SymbolKind.Enum]=9,me[w.SymbolKind.Interface]=10,me[w.SymbolKind.Function]=11,me[w.SymbolKind.Variable]=12,me[w.SymbolKind.Constant]=13,me[w.SymbolKind.String]=14,me[w.SymbolKind.Number]=15,me[w.SymbolKind.Boolean]=16,me[w.SymbolKind.Array]=17,me[w.SymbolKind.Object]=18,me[w.SymbolKind.Key]=19,me[w.SymbolKind.Null]=20,me[w.SymbolKind.EnumMember]=21,me[w.SymbolKind.Struct]=22,me[w.SymbolKind.Event]=23,me[w.SymbolKind.Operator]=24,me[w.SymbolKind.TypeParameter]=25;function ne(we){return typeof me[we]=="number"?me[we]:6}ce.from=ne;function H(we){for(const De in me)if(me[De]===we)return Number(De);return w.SymbolKind.Property}ce.to=H})($=e.SymbolKind||(e.SymbolKind={}));var z;(function(ce){function me(H){switch(H){case w.SymbolTag.Deprecated:return 1}}ce.from=me;function ne(H){switch(H){case 1:return w.SymbolTag.Deprecated}}ce.to=ne})(z=e.SymbolTag||(e.SymbolTag={}));var ee;(function(ce){function me(H){return{name:H.name,kind:$.from(H.kind),tags:H.tags&&H.tags.map(z.from),containerName:H.containerName,location:ue.from(H.location)}}ce.from=me;function ne(H){const we=new w.SymbolInformation(H.name,$.to(H.kind),H.containerName,ue.to(H.location));return we.tags=H.tags&&H.tags.map(z.to),we}ce.to=ne})(ee=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var j;(function(ce){function me(H){const we={name:H.name||"!!MISSING: name!!",detail:H.detail,range:d.from(H.range),selectionRange:d.from(H.selectionRange),kind:$.from(H.kind),tags:H.tags?.map(z.from)??[]};return H.children&&(we.children=H.children.map(me)),we}ce.from=me;function ne(H){const we=new w.DocumentSymbol(H.name,H.detail,$.to(H.kind),d.to(H.range),d.to(H.selectionRange));return(0,u.isNonEmptyArray)(H.tags)&&(we.tags=H.tags.map(z.to)),H.children&&(we.children=H.children.map(ne)),we}ce.to=ne})(j=e.DocumentSymbol||(e.DocumentSymbol={}));var Q;(function(ce){function me(H){const we=new w.CallHierarchyItem($.to(H.kind),H.name,H.detail||"",k.URI.revive(H.uri),d.to(H.range),d.to(H.selectionRange));return we._sessionId=H._sessionId,we._itemId=H._itemId,we}ce.to=me;function ne(H,we,De){if(we=we??H._sessionId,De=De??H._itemId,we===void 0||De===void 0)throw new Error("invalid item");return{_sessionId:we,_itemId:De,name:H.name,detail:H.detail,kind:$.from(H.kind),uri:H.uri,range:d.from(H.range),selectionRange:d.from(H.selectionRange),tags:H.tags?.map(z.from)}}ce.from=ne})(Q=e.CallHierarchyItem||(e.CallHierarchyItem={}));var le;(function(ce){function me(ne){return new w.CallHierarchyIncomingCall(Q.to(ne.from),ne.fromRanges.map(H=>d.to(H)))}ce.to=me})(le=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var ve;(function(ce){function me(ne){return new w.CallHierarchyOutgoingCall(Q.to(ne.to),ne.fromRanges.map(H=>d.to(H)))}ce.to=me})(ve=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var ue;(function(ce){function me(H){return{range:H.range&&d.from(H.range),uri:H.uri}}ce.from=me;function ne(H){return new w.Location(k.URI.revive(H.uri),d.to(H.range))}ce.to=ne})(ue=e.location||(e.location={}));var Fe;(function(ce){function me(H){const we=H,De=H;return{originSelectionRange:we.originSelectionRange?d.from(we.originSelectionRange):void 0,uri:we.targetUri?we.targetUri:De.uri,range:d.from(we.targetRange?we.targetRange:De.range),targetSelectionRange:we.targetSelectionRange?d.from(we.targetSelectionRange):void 0}}ce.from=me;function ne(H){return{targetUri:k.URI.revive(H.uri),targetRange:d.to(H.range),targetSelectionRange:H.targetSelectionRange?d.to(H.targetSelectionRange):void 0,originSelectionRange:H.originSelectionRange?d.to(H.originSelectionRange):void 0}}ce.to=ne})(Fe=e.DefinitionLink||(e.DefinitionLink={}));var Ke;(function(ce){function me(H){return{range:d.from(H.range),contents:E.fromMany(H.contents)}}ce.from=me;function ne(H){return new w.Hover(H.contents.map(E.to),d.to(H.range))}ce.to=ne})(Ke=e.Hover||(e.Hover={}));var Oe;(function(ce){function me(H){return{range:d.from(H.range),expression:H.expression}}ce.from=me;function ne(H){return new w.EvaluatableExpression(d.to(H.range),H.expression)}ce.to=ne})(Oe=e.EvaluatableExpression||(e.EvaluatableExpression={}));var He;(function(ce){function me(H){if(H instanceof w.InlineValueText)return{type:"text",range:d.from(H.range),text:H.text};if(H instanceof w.InlineValueVariableLookup)return{type:"variable",range:d.from(H.range),variableName:H.variableName,caseSensitiveLookup:H.caseSensitiveLookup};if(H instanceof w.InlineValueEvaluatableExpression)return{type:"expression",range:d.from(H.range),expression:H.expression};throw new Error("Unknown 'InlineValue' type")}ce.from=me;function ne(H){switch(H.type){case"text":return{range:d.to(H.range),text:H.text};case"variable":return{range:d.to(H.range),variableName:H.variableName,caseSensitiveLookup:H.caseSensitiveLookup};case"expression":return{range:d.to(H.range),expression:H.expression}}}ce.to=ne})(He=e.InlineValue||(e.InlineValue={}));var Je;(function(ce){function me(H){return{frameId:H.frameId,stoppedLocation:d.from(H.stoppedLocation)}}ce.from=me;function ne(H){return new w.InlineValueContext(H.frameId,d.to(H.stoppedLocation))}ce.to=ne})(Je=e.InlineValueContext||(e.InlineValueContext={}));var Ye;(function(ce){function me(H){return{range:d.from(H.range),kind:H.kind}}ce.from=me;function ne(H){return new w.DocumentHighlight(d.to(H.range),H.kind)}ce.to=ne})(Ye=e.DocumentHighlight||(e.DocumentHighlight={}));var Qe;(function(ce){function me(ne){switch(ne){case 1:return w.CompletionTriggerKind.TriggerCharacter;case 2:return w.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return w.CompletionTriggerKind.Invoke}}ce.to=me})(Qe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var W;(function(ce){function me(ne){return{triggerKind:Qe.to(ne.triggerKind),triggerCharacter:ne.triggerCharacter}}ce.to=me})(W=e.CompletionContext||(e.CompletionContext={}));var K;(function(ce){function me(H){switch(H){case w.CompletionItemTag.Deprecated:return 1}}ce.from=me;function ne(H){switch(H){case 1:return w.CompletionItemTag.Deprecated}}ce.to=ne})(K=e.CompletionItemTag||(e.CompletionItemTag={}));var X;(function(ce){const me=new Map([[w.CompletionItemKind.Method,0],[w.CompletionItemKind.Function,1],[w.CompletionItemKind.Constructor,2],[w.CompletionItemKind.Field,3],[w.CompletionItemKind.Variable,4],[w.CompletionItemKind.Class,5],[w.CompletionItemKind.Interface,7],[w.CompletionItemKind.Struct,6],[w.CompletionItemKind.Module,8],[w.CompletionItemKind.Property,9],[w.CompletionItemKind.Unit,12],[w.CompletionItemKind.Value,13],[w.CompletionItemKind.Constant,14],[w.CompletionItemKind.Enum,15],[w.CompletionItemKind.EnumMember,16],[w.CompletionItemKind.Keyword,17],[w.CompletionItemKind.Snippet,27],[w.CompletionItemKind.Text,18],[w.CompletionItemKind.Color,19],[w.CompletionItemKind.File,20],[w.CompletionItemKind.Reference,21],[w.CompletionItemKind.Folder,23],[w.CompletionItemKind.Event,10],[w.CompletionItemKind.Operator,11],[w.CompletionItemKind.TypeParameter,24],[w.CompletionItemKind.Issue,26],[w.CompletionItemKind.User,25]]);function ne(De){return me.get(De)??9}ce.from=ne;const H=new Map([[0,w.CompletionItemKind.Method],[1,w.CompletionItemKind.Function],[2,w.CompletionItemKind.Constructor],[3,w.CompletionItemKind.Field],[4,w.CompletionItemKind.Variable],[5,w.CompletionItemKind.Class],[7,w.CompletionItemKind.Interface],[6,w.CompletionItemKind.Struct],[8,w.CompletionItemKind.Module],[9,w.CompletionItemKind.Property],[12,w.CompletionItemKind.Unit],[13,w.CompletionItemKind.Value],[14,w.CompletionItemKind.Constant],[15,w.CompletionItemKind.Enum],[16,w.CompletionItemKind.EnumMember],[17,w.CompletionItemKind.Keyword],[27,w.CompletionItemKind.Snippet],[18,w.CompletionItemKind.Text],[19,w.CompletionItemKind.Color],[20,w.CompletionItemKind.File],[21,w.CompletionItemKind.Reference],[23,w.CompletionItemKind.Folder],[10,w.CompletionItemKind.Event],[11,w.CompletionItemKind.Operator],[24,w.CompletionItemKind.TypeParameter],[25,w.CompletionItemKind.User],[26,w.CompletionItemKind.Issue]]);function we(De){return H.get(De)??w.CompletionItemKind.Property}ce.to=we})(X=e.CompletionItemKind||(e.CompletionItemKind={}));var oe;(function(ce){function me(ne,H){const we=new w.CompletionItem(ne.label);return we.insertText=ne.insertText,we.kind=X.to(ne.kind),we.tags=ne.tags?.map(K.to),we.detail=ne.detail,we.documentation=b.isMarkdownString(ne.documentation)?E.to(ne.documentation):ne.documentation,we.sortText=ne.sortText,we.filterText=ne.filterText,we.preselect=ne.preselect,we.commitCharacters=ne.commitCharacters,F.Range.isIRange(ne.range)?we.range=d.to(ne.range):typeof ne.range=="object"&&(we.range={inserting:d.to(ne.range.insert),replacing:d.to(ne.range.replace)}),we.keepWhitespace=typeof ne.insertTextRules=="undefined"?!1:Boolean(ne.insertTextRules&1),typeof ne.insertTextRules!="undefined"&&ne.insertTextRules&4?we.insertText=new w.SnippetString(ne.insertText):(we.insertText=ne.insertText,we.textEdit=we.range instanceof w.Range?new w.TextEdit(we.range,we.insertText):void 0),ne.additionalTextEdits&&ne.additionalTextEdits.length>0&&(we.additionalTextEdits=ne.additionalTextEdits.map(De=>N.to(De))),we.command=H&&ne.command?H.fromInternal(ne.command):void 0,we}ce.to=me})(oe=e.CompletionItem||(e.CompletionItem={}));var G;(function(ce){function me(H){return{label:H.label,documentation:H.documentation?E.fromStrict(H.documentation):void 0}}ce.from=me;function ne(H){return{label:H.label,documentation:b.isMarkdownString(H.documentation)?E.to(H.documentation):H.documentation}}ce.to=ne})(G=e.ParameterInformation||(e.ParameterInformation={}));var ie;(function(ce){function me(H){return{label:H.label,documentation:H.documentation?E.fromStrict(H.documentation):void 0,parameters:Array.isArray(H.parameters)?H.parameters.map(G.from):[],activeParameter:H.activeParameter}}ce.from=me;function ne(H){return{label:H.label,documentation:b.isMarkdownString(H.documentation)?E.to(H.documentation):H.documentation,parameters:Array.isArray(H.parameters)?H.parameters.map(G.to):[],activeParameter:H.activeParameter}}ce.to=ne})(ie=e.SignatureInformation||(e.SignatureInformation={}));var de;(function(ce){function me(H){return{activeSignature:H.activeSignature,activeParameter:H.activeParameter,signatures:Array.isArray(H.signatures)?H.signatures.map(ie.from):[]}}ce.from=me;function ne(H){return{activeSignature:H.activeSignature,activeParameter:H.activeParameter,signatures:Array.isArray(H.signatures)?H.signatures.map(ie.to):[]}}ce.to=ne})(de=e.SignatureHelp||(e.SignatureHelp={}));var Te;(function(ce){function me(H){return{text:H.text,position:c.from(H.position),kind:Ne.from(H.kind??w.InlayHintKind.Other),whitespaceBefore:H.whitespaceBefore,whitespaceAfter:H.whitespaceAfter}}ce.from=me;function ne(H){const we=new w.InlayHint(H.text,c.to(H.position),Ne.to(H.kind));return we.whitespaceAfter=H.whitespaceAfter,we.whitespaceBefore=H.whitespaceBefore,we}ce.to=ne})(Te=e.InlayHint||(e.InlayHint={}));var Ne;(function(ce){function me(H){return H}ce.from=me;function ne(H){return H}ce.to=ne})(Ne=e.InlayHintKind||(e.InlayHintKind={}));var ze;(function(ce){function me(H){return{range:d.from(H.range),url:H.target,tooltip:H.tooltip}}ce.from=me;function ne(H){let we;if(H.url)try{we=typeof H.url=="string"?k.URI.parse(H.url,!0):k.URI.revive(H.url)}catch(De){}return new w.DocumentLink(d.to(H.range),we)}ce.to=ne})(ze=e.DocumentLink||(e.DocumentLink={}));var je;(function(ce){function me(H){const we=new w.ColorPresentation(H.label);return H.textEdit&&(we.textEdit=N.to(H.textEdit)),H.additionalTextEdits&&(we.additionalTextEdits=H.additionalTextEdits.map(De=>N.to(De))),we}ce.to=me;function ne(H){return{label:H.label,textEdit:H.textEdit?N.from(H.textEdit):void 0,additionalTextEdits:H.additionalTextEdits?H.additionalTextEdits.map(we=>N.from(we)):void 0}}ce.from=ne})(je=e.ColorPresentation||(e.ColorPresentation={}));var et;(function(ce){function me(H){return new w.Color(H[0],H[1],H[2],H[3])}ce.to=me;function ne(H){return[H.red,H.green,H.blue,H.alpha]}ce.from=ne})(et=e.Color||(e.Color={}));var ot;(function(ce){function me(H){return{range:d.from(H.range)}}ce.from=me;function ne(H){return new w.SelectionRange(d.to(H.range))}ce.to=ne})(ot=e.SelectionRange||(e.SelectionRange={}));var ye;(function(ce){function me(ne){switch(ne){case 2:return w.TextDocumentSaveReason.AfterDelay;case 1:return w.TextDocumentSaveReason.Manual;case 3:case 4:return w.TextDocumentSaveReason.FocusOut}}ce.to=me})(ye=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var nt;(function(ce){function me(H){switch(H){case w.TextEditorLineNumbersStyle.Off:return 0;case w.TextEditorLineNumbersStyle.Relative:return 2;case w.TextEditorLineNumbersStyle.On:default:return 1}}ce.from=me;function ne(H){switch(H){case 0:return w.TextEditorLineNumbersStyle.Off;case 2:return w.TextEditorLineNumbersStyle.Relative;case 1:default:return w.TextEditorLineNumbersStyle.On}}ce.to=ne})(nt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var q;(function(ce){function me(H){if(H===w.EndOfLine.CRLF)return 1;if(H===w.EndOfLine.LF)return 0}ce.from=me;function ne(H){if(H===1)return w.EndOfLine.CRLF;if(H===0)return w.EndOfLine.LF}ce.to=ne})(q=e.EndOfLine||(e.EndOfLine={}));var J;(function(ce){function me(ne){if(typeof ne=="object")return ne.viewId;switch(ne){case w.ProgressLocation.SourceControl:return 3;case w.ProgressLocation.Window:return 10;case w.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ce.from=me})(J=e.ProgressLocation||(e.ProgressLocation={}));var pe;(function(ce){function me(ne){const H={start:ne.start+1,end:ne.end+1};return ne.kind&&(H.kind=$e.from(ne.kind)),H}ce.from=me})(pe=e.FoldingRange||(e.FoldingRange={}));var $e;(function(ce){function me(ne){if(ne)switch(ne){case w.FoldingRangeKind.Comment:return y.FoldingRangeKind.Comment;case w.FoldingRangeKind.Imports:return y.FoldingRangeKind.Imports;case w.FoldingRangeKind.Region:return y.FoldingRangeKind.Region}}ce.from=me})($e=e.FoldingRangeKind||(e.FoldingRangeKind={}));var qe;(function(ce){function me(ne){if(ne)return{pinned:typeof ne.preview=="boolean"?!ne.preview:void 0,inactive:ne.background,preserveFocus:ne.preserveFocus,selection:typeof ne.selection=="object"?d.from(ne.selection):void 0,override:typeof ne.override=="boolean"?r.EditorResolution.DISABLED:void 0}}ce.from=me})(qe=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var rt;(function(ce){function me(H){return H instanceof w.RelativePattern||typeof H=="string"?H:ne(H)?new w.RelativePattern(H.base,H.pattern):H}ce.from=me;function ne(H){const we=H;return we&&typeof we.base=="string"&&typeof we.pattern=="string"}})(rt=e.GlobPattern||(e.GlobPattern={}));var ft;(function(ce){function me(ne){if(ne){if(Array.isArray(ne))return ne.map(me);if(typeof ne=="string")return ne;{const H=ne;return{language:H.language,scheme:H.scheme,pattern:typeof H.pattern=="undefined"?void 0:rt.from(H.pattern),exclusive:H.exclusive}}}else return}ce.from=me})(ft=e.LanguageSelector||(e.LanguageSelector={}));var ht;(function(ce){function me(H){return{start:H.start,end:H.end}}ce.from=me;function ne(H){return new w.NotebookRange(H.start,H.end)}ce.to=ne})(ht=e.NotebookRange||(e.NotebookRange={}));var Ct;(function(ce){function me(H){return{timing:typeof H.runStartTime=="number"&&typeof H.runEndTime=="number"?{startTime:H.runStartTime,endTime:H.runEndTime}:void 0,executionOrder:H.executionOrder,success:H.lastRunSuccess}}ce.to=me;function ne(H){return{lastRunSuccess:H.success,runStartTime:H.timing?.startTime,runEndTime:H.timing?.endTime,executionOrder:H.executionOrder}}ce.from=ne})(Ct=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var It;(function(ce){function me(H){switch(H){case w.NotebookCellKind.Markup:return h.CellKind.Markup;case w.NotebookCellKind.Code:default:return h.CellKind.Code}}ce.from=me;function ne(H){switch(H){case h.CellKind.Markup:return w.NotebookCellKind.Markup;case h.CellKind.Code:default:return w.NotebookCellKind.Code}}ce.to=ne})(It=e.NotebookCellKind||(e.NotebookCellKind={}));var Pt;(function(ce){function me(H){const we={metadata:H.metadata??Object.create(null),cells:[]};for(let De of H.cells)w.NotebookCellData.validate(De),we.cells.push(Ze.from(De));return we}ce.from=me;function ne(H){const we=new w.NotebookData(H.cells.map(Ze.to));return(0,C.isEmptyObject)(H.metadata)||(we.metadata=H.metadata),we}ce.to=ne})(Pt=e.NotebookData||(e.NotebookData={}));var Ze;(function(ce){function me(H){return{cellKind:It.from(H.kind),language:H.languageId,mime:H.mime,source:H.value,metadata:H.metadata,internalMetadata:Ct.from(H.executionSummary??{}),outputs:H.outputs?H.outputs.map(Ie.from):[]}}ce.from=me;function ne(H){return new w.NotebookCellData(It.to(H.cellKind),H.source,H.language,H.mime,H.outputs?H.outputs.map(Ie.to):void 0,H.metadata,H.internalMetadata?Ct.to(H.internalMetadata):void 0)}ce.to=ne})(Ze=e.NotebookCellData||(e.NotebookCellData={}));var pt;(function(ce){function me(H){return{mime:H.mime,valueBytes:M.VSBuffer.wrap(H.data)}}ce.from=me;function ne(H){return new w.NotebookCellOutputItem(H.valueBytes.buffer,H.mime)}ce.to=ne})(pt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Ie;(function(ce){function me(H){return{outputId:H.id,items:H.items.map(pt.from),metadata:H.metadata}}ce.from=me;function ne(H){const we=H.items.map(pt.to);return new w.NotebookCellOutput(we,H.outputId,H.metadata)}ce.to=ne})(Ie=e.NotebookCellOutput||(e.NotebookCellOutput={}));var ge;(function(ce){function me(De){if(De!=null){if(De instanceof w.RelativePattern||typeof De=="string")return De;if(we(De))return new w.RelativePattern(De.base,De.pattern);if(H(De))return{include:rt.from(De.include)||void 0,exclude:rt.from(De.exclude)||void 0}}}ce.from=me;function ne(De){return typeof De=="string"?De:we(De)?{base:De.base,pattern:De.pattern}:{include:De.include,exclude:De.exclude}}ce.to=ne;function H(De){const Ge=De,xe=rt.from(Ge.include);if(!(xe&&xe instanceof w.RelativePattern||typeof xe=="string"))return!1;const ct=rt.from(Ge.exclude);return!!(ct&&ct instanceof w.RelativePattern||typeof ct=="string")}function we(De){const Ge=De;return Ge&&typeof Ge.base=="string"&&typeof Ge.pattern=="string"}})(ge=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Ce;(function(ce){function me(ne){return{backgroundColor:ne.backgroundColor,borderColor:ne.borderColor,top:ne.top?B.from(ne.top):void 0}}ce.from=me})(Ce=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Z;(function(ce){function me(ne,H,we){const De=typeof ne.command=="string"?{title:"",command:ne.command}:ne.command;return{alignment:ne.alignment===w.NotebookCellStatusBarAlignment.Left?1:2,command:H.toInternal(De,we),text:ne.text,tooltip:ne.tooltip,accessibilityInformation:ne.accessibilityInformation,priority:ne.priority}}ce.from=me})(Z=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var se;(function(ce){function me(ne){return{transientOutputs:ne?.transientOutputs??!1,transientCellMetadata:ne?.transientCellMetadata??{},transientDocumentMetadata:ne?.transientDocumentMetadata??{}}}ce.from=me})(se=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var fe;(function(ce){function me(H){return{uri:H.uri,provides:H.provides}}ce.from=me;function ne(H){return new w.NotebookRendererScript(k.URI.revive(H.uri),H.provides)}ce.to=ne})(fe=e.NotebookRendererScript||(e.NotebookRendererScript={}));var he;(function(ce){function me(H){return{message:E.fromStrict(H.message)||"",type:0,expected:H.expectedOutput,actual:H.actualOutput,location:H.location?ue.from(H.location):void 0}}ce.from=me;function ne(H){const we=new w.TestMessage(typeof H.message=="string"?H.message:E.to(H.message));return we.actualOutput=H.actual,we.expectedOutput=H.expected,we.location=H.location?ue.to(H.location):void 0,we}ce.to=ne})(he=e.TestMessage||(e.TestMessage={}));var ke;(function(ce){let me;(function(ne){ne.Delimiter="\0"})(me||(me={})),ce.namespace=(ne,H)=>ne+"\0"+H,ce.denamespace=ne=>{const H=ne.indexOf("\0");return{ctrlId:ne.slice(0,H),tagId:ne.slice(H+1)}}})(ke=e.TestTag||(e.TestTag={}));var Le;(function(ce){function me(De){const Ge=(0,a.getPrivateApiFor)(De).controllerId;return{extId:p.TestId.fromExtHostTestItem(De,Ge).toString(),label:De.label,uri:De.uri,tags:De.tags.map(xe=>ke.namespace(Ge,xe.id)),range:d.from(De.range)||null,description:De.description||null,error:De.error&&E.fromStrict(De.error)||null}}ce.from=me;function ne(De){return{parent:void 0,error:void 0,id:p.TestId.fromString(De.extId).localId,label:De.label,uri:k.URI.revive(De.uri),tags:(De.tags||[]).map(Ge=>{const{tagId:xe}=ke.denamespace(Ge);return new w.TestTag(xe)}),range:d.to(De.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:De.description||void 0}}ce.toPlain=ne;function H(De){const Ge=p.TestId.fromString(De.extId),xe=new a.TestItemImpl(Ge.controllerId,Ge.localId,De.label,k.URI.revive(De.uri));return xe.range=d.to(De.range||void 0),xe.description=De.description||void 0,xe}function we(De){let Ge;for(const xe of De.tests){const ct=H(xe.item);(0,a.getPrivateApiFor)(ct).parent=Ge,Ge=ct}return Ge}ce.toItemFromContext=we})(Le=e.TestItem||(e.TestItem={})),function(ce){function me(H){return{id:H.id}}ce.from=me;function ne(H){return new w.TestTag(H.id)}ce.to=ne}(ke=e.TestTag||(e.TestTag={}));var Me;(function(ce){const me=(H,we)=>{const De={...Le.toPlain(H.item),parent:void 0,taskStates:H.tasks.map(Ge=>({state:Ge.state,duration:Ge.duration,messages:Ge.messages.filter(xe=>xe.type===0).map(he.to)})),children:H.children.map(Ge=>we.get(Ge)).filter(C.isDefined).map(Ge=>me(Ge,we))};for(const Ge of De.children)Ge.parent=De;return De};function ne(H){const we=[],De=new Map;for(const Ge of H.items)De.set(Ge.item.extId,Ge),H.request.targets.some(xe=>xe.controllerId===Ge.controllerId&&xe.testIds.includes(Ge.item.extId))&&we.push(Ge);return{completedAt:H.completedAt,results:we.map(Ge=>me(Ge,De))}}ce.to=ne})(Me=e.TestResults||(e.TestResults={}));var We;(function(ce){function me(De){return{covered:De.covered,total:De.covered}}function ne(De){return"line"in De?c.from(De):d.from(De)}function H(De){return"branches"in De?{count:De.executionCount,location:ne(De.location),type:1,branches:De.branches.length?De.branches.map(Ge=>({count:Ge.executionCount,location:Ge.location&&ne(Ge.location)})):void 0}:{type:0,count:De.executionCount,location:ne(De.location)}}ce.fromDetailed=H;function we(De){return{uri:De.uri,statement:me(De.statementCoverage),branch:De.branchCoverage&&me(De.branchCoverage),function:De.functionCoverage&&me(De.functionCoverage),details:De.detailedCoverage?.map(H)}}ce.fromFile=we})(We=e.TestCoverage||(e.TestCoverage={}));var it;(function(ce){function me(ne){switch(ne){case 1:return w.CodeActionTriggerKind.Invoke;case 2:return w.CodeActionTriggerKind.Automatic}}ce.to=me})(it=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Re;(function(ce){function me(H){const we=new w.TypeHierarchyItem($.to(H.kind),H.name,H.detail||"",k.URI.revive(H.uri),d.to(H.range),d.to(H.selectionRange));return we._sessionId=H._sessionId,we._itemId=H._itemId,we}ce.to=me;function ne(H,we,De){if(we=we??H._sessionId,De=De??H._itemId,we===void 0||De===void 0)throw new Error("invalid item");return{_sessionId:we,_itemId:De,kind:$.from(H.kind),name:H.name,detail:H.detail??"",uri:H.uri,range:d.from(H.range),selectionRange:d.from(H.selectionRange),tags:H.tags?.map(z.from)}}ce.from=ne})(Re=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(be[173],Ee([0,1,2,16,7,8,235]),function(re,e,u,M,b,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class A{constructor(k,F,y,r={timeout:1500,errors:3}){this._logService=k,this._documents=F,this._mainThreadBulkEdits=y,this._thresholds=r,this._callbacks=new t.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(k){return(F,y,r)=>{const a={dispose:this._callbacks.push([F,y,k])};return Array.isArray(r)&&r.push(a),a}}async $participateInSave(k,F){const y=u.URI.revive(k);let r=!1;const m=setTimeout(()=>r=!0,this._thresholds.timeout),a=[];try{for(let h of[...this._callbacks]){if(r)break;const p=this._documents.getDocument(y),S=await this._deliverEventAsyncAndBlameBadListeners(h,{document:p,reason:P.TextDocumentSaveReason.to(F)});a.push(S)}}finally{clearTimeout(m)}return a}_deliverEventAsyncAndBlameBadListeners([k,F,y],r){const m=this._badListeners.get(k);return typeof m=="number"&&m>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(y,k,F,r).then(()=>!0,a=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${y.identifier.value}' threw ERROR`),this._logService.error(a),!(a instanceof Error)||a.message!=="concurrent_edits"){const h=this._badListeners.get(k);this._badListeners.set(k,h?h+1:1),typeof h=="number"&&h>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${y.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(k,F,y,r){const m=[],a=Date.now(),{document:h,reason:p}=r,{version:S}=h,w=Object.freeze({document:h,reason:p,waitUntil(o){if(Object.isFrozen(m))throw(0,M.illegalState)("waitUntil can not be called async");m.push(Promise.resolve(o))}});try{F.apply(y,[w])}catch(o){return Promise.reject(o)}return Object.freeze(m),new Promise((o,d)=>{const _=setTimeout(()=>d(new Error("timeout")),this._thresholds.timeout);return Promise.all(m).then(c=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-a}ms`),clearTimeout(_),o(c)}).catch(c=>{clearTimeout(_),d(c)})}).then(o=>{const d={edits:[]};for(const _ of o)if(Array.isArray(_)&&_.every(c=>c instanceof b.TextEdit))for(const{newText:c,newEol:R,range:n}of _)d.edits.push({_type:2,resource:h.uri,edit:{range:n&&P.Range.from(n),text:c,eol:R&&P.EndOfLine.from(R)}});if(d.edits.length!==0)return S===h.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(d):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=A}),define(be[174],Ee([0,1,3,29,2,8,7]),function(re,e,u,M,b,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class A{constructor(F,y,r,m,a){this._onDidCreate=new u.Emitter,this._onDidChange=new u.Emitter,this._onDidDelete=new u.Emitter,this._config=0,r&&(this._config+=1),m&&(this._config+=2),a&&(this._config+=4);const h=(0,M.parse)(y),p=F(S=>{if(!r)for(let w of S.created){const o=b.URI.revive(w);h(o.fsPath)&&this._onDidCreate.fire(o)}if(!m)for(let w of S.changed){const o=b.URI.revive(w);h(o.fsPath)&&this._onDidChange.fire(o)}if(!a)for(let w of S.deleted){const o=b.URI.revive(w);h(o.fsPath)&&this._onDidDelete.fire(o)}});this._disposable=t.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,p)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class C{constructor(F,y,r){this._logService=y,this._extHostDocumentsAndEditors=r,this._onFileSystemEvent=new u.Emitter,this._onDidRenameFile=new u.Emitter,this._onDidCreateFile=new u.Emitter,this._onDidDeleteFile=new u.Emitter,this._onWillRenameFile=new u.AsyncEmitter,this._onWillCreateFile=new u.AsyncEmitter,this._onWillDeleteFile=new u.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(F,y,r,m){return new A(this._onFileSystemEvent.event,F,y,r,m)}$onFileEvent(F){this._onFileSystemEvent.fire(F)}$onDidRunFileOperation(F,y){switch(F){case 2:this._onDidRenameFile.fire(Object.freeze({files:y.map(r=>({oldUri:b.URI.revive(r.source),newUri:b.URI.revive(r.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:y.map(r=>b.URI.revive(r.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:y.map(r=>b.URI.revive(r.target))}));break;default:}}getOnWillRenameFileEvent(F){return this._createWillExecuteEvent(F,this._onWillRenameFile)}getOnWillCreateFileEvent(F){return this._createWillExecuteEvent(F,this._onWillCreateFile)}getOnWillDeleteFileEvent(F){return this._createWillExecuteEvent(F,this._onWillDeleteFile)}_createWillExecuteEvent(F,y){return(r,m,a)=>{const h=function(S){r.call(m,S)};return h.extension=F,y.event(h,void 0,a)}}async $onWillRunFileOperation(F,y,r,m){switch(F){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:y.map(a=>({oldUri:b.URI.revive(a.source),newUri:b.URI.revive(a.target)}))},r,m);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:y.map(a=>b.URI.revive(a.target))},r,m);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:y.map(a=>b.URI.revive(a.target))},r,m)}}async _fireWillEvent(F,y,r,m){const a=new Set,h=[];if(await F.fireAsync(y,m,async(S,w)=>{const o=Date.now(),d=await Promise.resolve(S);d instanceof t.WorkspaceEdit&&(h.push(d),a.add(w.extension.displayName??w.extension.identifier.value)),Date.now()-o>r&&this._logService.warn("SLOW file-participant",w.extension.identifier)}),m.isCancellationRequested||h.length===0)return;const p={edits:[]};for(let S of h){let{edits:w}=P.WorkspaceEdit.from(S,this._extHostDocumentsAndEditors);p.edits=p.edits.concat(w)}return{edit:p,extensionNames:Array.from(a)}}}e.ExtHostFileSystemEventService=C}),define(be[175],Ee([0,1,11,23,2,8,7,89]),function(re,e,u,M,b,P,t,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class C{constructor(r,m,a,h){this.start=r,this.deletedCount=m,this.deletedItems=a,this.items=h}static asApiEvents(r){return r.map(m=>({start:m.start,deletedCount:m.deletedCount,deletedItems:m.deletedItems,items:m.items.map(a=>a.apiCell)}))}}class k{constructor(r,m,a){this.notebook=r,this._extHostDocument=m,this._cellData=a,this.handle=a.handle,this.uri=b.URI.revive(a.uri),this.cellKind=a.cellKind,this._outputs=a.outputs.map(P.NotebookCellOutput.to),this._internalMetadata=a.internalMetadata??{},this._metadata=Object.freeze(a.metadata??{}),this._previousResult=Object.freeze(P.NotebookCellExecutionSummary.to(a.internalMetadata??{}))}static asModelAddData(r,m){return{EOL:m.eol,lines:m.source,languageId:m.language,uri:m.uri,isDirty:!1,versionId:1,notebook:r}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const r=this,m=this._extHostDocument.getDocument(this.uri);if(!m)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return r.notebook.getCellIndex(r)},notebook:r.notebook.apiNotebook,kind:P.NotebookCellKind.to(this._cellData.cellKind),document:m.document,get mime(){return r._mime},set mime(a){r._mime=a},get outputs(){return r._outputs.slice(0)},get metadata(){return r._metadata},get executionSummary(){return r._previousResult}})}return this._apiCell}setOutputs(r){this._outputs=r.map(P.NotebookCellOutput.to)}setOutputItems(r,m,a){const h=a.map(P.NotebookCellOutputItem.to),p=this._outputs.find(S=>S.id===r);p&&(m||(p.items.length=0),p.items.push(...h))}setMetadata(r){this._metadata=Object.freeze(r)}setInternalMetadata(r){this._internalMetadata=r,this._previousResult=Object.freeze(P.NotebookCellExecutionSummary.to(r))}setMime(r){}}e.ExtHostCell=k;class F{constructor(r,m,a,h,p,S){this._proxy=r,this._textDocumentsAndEditors=m,this._textDocuments=a,this._emitter=h,this.uri=p,this.handle=F._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=S.viewType,this._metadata=Object.freeze(S.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,S.cells]],!0),this._versionId=S.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const r=this;this._notebook={get uri(){return r.uri},get version(){return r._versionId},get notebookType(){return r._notebookType},get isDirty(){return r._isDirty},get isUntitled(){return r.uri.scheme===u.Schemas.untitled},get isClosed(){return r._disposed},get metadata(){return r._metadata},get cellCount(){return r._cells.length},cellAt(m){return m=r._validateIndex(m),r._cells[m].apiCell},getCells(m){return(m?r._getCells(m):r._cells).map(h=>h.apiCell)},save(){return r._save()}}}return this._notebook}updateBackup(r){this._backup?.delete(),this._backup=r}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(r){r.metadata&&(this._metadata=Object.freeze({...this._metadata,...r.metadata}))}acceptDirty(r){this._isDirty=r}acceptModelChanged(r,m){this._versionId=r.versionId,this._isDirty=m;for(const a of r.rawEvents)a.kind===A.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(a.changes,!1):a.kind===A.NotebookCellsChangeType.Move?this._moveCell(a.index,a.newIdx):a.kind===A.NotebookCellsChangeType.Output?this._setCellOutputs(a.index,a.outputs):a.kind===A.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(a.index,a.outputId,a.append,a.outputItems):a.kind===A.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(a.index,a.language):a.kind===A.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(a.index,a.mime):a.kind===A.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(a.index,a.metadata):a.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(a.index,a.internalMetadata)}_validateIndex(r){return r=r|0,r<0?0:r>=this._cells.length?this._cells.length-1:r}_validateRange(r){let m=r.start|0,a=r.end|0;return m<0&&(m=0),a>this._cells.length&&(a=this._cells.length),r.with({start:m,end:a})}_getCells(r){r=this._validateRange(r);const m=[];for(let a=r.start;a<r.end;a++)m.push(this._cells[a]);return m}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(r,m){if(this._disposed)return;const a=[],h=[],p=[];r.reverse().forEach(S=>{const o=S[2].map(c=>{const R=new k(this,this._textDocumentsAndEditors,c);return m||h.push(k.asModelAddData(this.apiNotebook,c)),R}),d=new C(S[0],S[1],[],o),_=this._cells.splice(S[0],S[1],...o);for(const c of _)p.push(c.uri),d.deletedItems.push(c.apiCell);a.push(d)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:h,removedDocuments:p}),m||this._emitter.emitModelChange((0,M.deepFreeze)({document:this.apiNotebook,changes:C.asApiEvents(a)}))}_moveCell(r,m){const a=this._cells.splice(r,1);this._cells.splice(m,0,...a);const h=[new C(r,1,a.map(p=>p.apiCell),[]),new C(m,0,[],a)];this._emitter.emitModelChange((0,M.deepFreeze)({document:this.apiNotebook,changes:C.asApiEvents(h)}))}_setCellOutputs(r,m){const a=this._cells[r];a.setOutputs(m),this._emitter.emitCellOutputsChange((0,M.deepFreeze)({document:this.apiNotebook,cells:[a.apiCell]}))}_setCellOutputItems(r,m,a,h){const p=this._cells[r];p.setOutputItems(m,a,h),this._emitter.emitCellOutputsChange((0,M.deepFreeze)({document:this.apiNotebook,cells:[p.apiCell]}))}_changeCellLanguage(r,m){const a=this._cells[r];a.apiCell.document.languageId!==m&&this._textDocuments.$acceptModelModeChanged(a.uri,m)}_changeCellMime(r,m){const a=this._cells[r];a.apiCell.mime=m}_changeCellMetadata(r,m){const a=this._cells[r],h=a.apiCell.metadata;a.setMetadata(m);const p=a.apiCell.metadata;(0,M.equals)(h,p)||this._emitter.emitCellMetadataChange((0,M.deepFreeze)({document:this.apiNotebook,cell:a.apiCell}))}_changeCellInternalMetadata(r,m){const a=this._cells[r],h=a.internalMetadata;if(a.setInternalMetadata(m),h.runState!==m.runState){const p=m.runState??t.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,M.deepFreeze)({document:this.apiNotebook,cell:a.apiCell,state:p}))}}getCellFromApiCell(r){return this._cells.find(m=>m.apiCell===r)}getCellFromIndex(r){return this._cells[r]}getCell(r){return this._cells.find(m=>m.handle===r)}getCellIndex(r){return this._cells.indexOf(r)}}e.ExtHostNotebookDocument=F,F._handlePool=0}),define(be[93],Ee([0,1,7,8,16]),function(re,e,u,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class P{constructor(C){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=C}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(C){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:C})}replaceCellMetadata(C,k){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:C,metadata:k})}replaceCells(C,k,F){this._throwIfFinalized(),!(C===k&&F.length===0)&&this._collectedEdits.push({editType:1,index:C,count:k-C,cells:F.map(M.NotebookCellData.from)})}}class t{constructor(C,k,F,y,r,m){this.id=C,this._proxy=k,this.notebookData=F,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=r,this._visibleRanges=y,this._viewColumn=m}get apiEditor(){if(!this._editor){const C=this;this._editor={get document(){return C.notebookData.apiNotebook},get selections(){return C._selections},set selections(k){if(!Array.isArray(k)||!k.every(u.NotebookRange.isNotebookRange))throw(0,b.illegalArgument)("selections");C._selections=k,C._trySetSelections(k)},get visibleRanges(){return C._visibleRanges},revealRange(k,F){C._proxy.$tryRevealRange(C.id,M.NotebookRange.from(k),F??u.NotebookEditorRevealType.Default)},get viewColumn(){return C._viewColumn},edit(k){const F=new P(this.document.version);return k(F),C._applyEdit(F.finalize())},setDecorations(k,F){return C.setDecorations(k,F)}},t.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(C){this._visible=C}_acceptVisibleRanges(C){this._visibleRanges=C}_acceptSelections(C){this._selections=C}_trySetSelections(C){this._proxy.$trySetSelections(this.id,C.map(M.NotebookRange.from))}_acceptViewColumn(C){this._viewColumn=C}_applyEdit(C){if(C.cellEdits.length===0)return Promise.resolve(!0);const k=[];let F=-1;for(let y=0;y<C.cellEdits.length;y++){if(F<0){k.push(C.cellEdits[y]),F++;continue}const m=k[F],a=C.cellEdits[y];if(m.editType===1&&a.editType===1&&m.index===a.index){m.cells.push(...C.cellEdits[y].cells),m.count+=C.cellEdits[y].count;continue}k.push(C.cellEdits[y]),F++}return this._proxy.$tryApplyEdits(this.id,C.documentVersionId,k)}setDecorations(C,k){if(!(k.isEmpty&&!this._hasDecorationsForKey.has(C.key)))return k.isEmpty?this._hasDecorationsForKey.delete(C.key):this._hasDecorationsForKey.add(C.key),this._proxy.$trySetDecorations(this.id,M.NotebookRange.from(k),C.key)}}e.ExtHostNotebookEditor=t,t.apiEditorsToExtHost=new WeakMap}),define(be[176],Ee([0,1,8,147,127,21,55,16]),function(re,e,u,M,b,P,t,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class C{constructor(r){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=r}async withProgress(r,m,a){const h=this._handles++,{title:p,location:S,cancellable:w}=m,o={label:(0,b.localize)(0,null,r.displayName||r.name),id:r.identifier.value};return this._proxy.$startProgress(h,{location:u.ProgressLocation.from(S),title:p,source:o,cancellable:w},r).catch(A.onUnexpectedExternalError),this._withProgress(h,a,!!w)}_withProgress(r,m,a){let h;a&&(h=new P.CancellationTokenSource,this._mapHandleToCancellationSource.set(r,h));const p=w=>{this._proxy.$progressEnd(w),this._mapHandleToCancellationSource.delete(w),h&&h.dispose()};let S;try{S=m(new F(this._proxy,r),a&&h?h.token:P.CancellationToken.None)}catch(w){throw p(r),w}return S.then(w=>p(r),w=>p(r)),S}$acceptProgressCanceled(r){const m=this._mapHandleToCancellationSource.get(r);m&&(m.cancel(),this._mapHandleToCancellationSource.delete(r))}}e.ExtHostProgress=C;function k(y,r){return y.message=r.message,typeof r.increment=="number"&&(typeof y.increment=="number"?y.increment+=r.increment:y.increment=r.increment),y}class F extends M.Progress{constructor(r,m){super(a=>this.throttledReport(a));this._proxy=r,this._handle=m}throttledReport(r){this._proxy.$progressReport(this._handle,r)}}Ue([(0,t.throttle)(100,(y,r)=>k(y,r),()=>Object.create(null))],F.prototype,"throttledReport",null)}),define(be[94],Ee([0,1,43,16,56,8,7]),function(re,e,u,M,b,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class A{constructor(r,m,a){const h=A._Keys.nextId();r.$registerTextEditorDecorationType(m.identifier,h,P.DecorationRenderOptions.from(a)),this.value=Object.freeze({key:h,dispose(){r.$removeTextEditorDecorationType(h)}})}}e.TextEditorDecorationType=A,A._Keys=new b.IdGenerator("TextEditorDecorationType");class C{constructor(r,m){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=r,this._documentVersionId=r.version,this._undoStopBefore=m.undoStopBefore,this._undoStopAfter=m.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(r,m){this._throwIfFinalized();let a=null;if(r instanceof t.Position)a=new t.Range(r,r);else if(r instanceof t.Range)a=r;else throw new Error("Unrecognized location");this._pushEdit(a,m,!1)}insert(r,m){this._throwIfFinalized(),this._pushEdit(new t.Range(r,r),m,!0)}delete(r){this._throwIfFinalized();let m=null;if(r instanceof t.Range)m=r;else throw new Error("Unrecognized location");this._pushEdit(m,null,!0)}_pushEdit(r,m,a){const h=this._document.validateRange(r);this._collectedEdits.push({range:h,text:m,forceMoveMarkers:a})}setEndOfLine(r){if(this._throwIfFinalized(),r!==t.EndOfLine.LF&&r!==t.EndOfLine.CRLF)throw(0,M.illegalArgument)("endOfLine");this._setEndOfLine=r}}e.TextEditorEdit=C;class k{constructor(r,m,a,h){this._proxy=r,this._id=m,this._accept(a),this._logService=h;const p=this;this.value={get tabSize(){return p._tabSize},set tabSize(S){p._setTabSize(S)},get insertSpaces(){return p._insertSpaces},set insertSpaces(S){p._setInsertSpaces(S)},get cursorStyle(){return p._cursorStyle},set cursorStyle(S){p._setCursorStyle(S)},get lineNumbers(){return p._lineNumbers},set lineNumbers(S){p._setLineNumbers(S)}}}_accept(r){this._tabSize=r.tabSize,this._insertSpaces=r.insertSpaces,this._cursorStyle=r.cursorStyle,this._lineNumbers=P.TextEditorLineNumbersStyle.to(r.lineNumbers)}_validateTabSize(r){if(r==="auto")return"auto";if(typeof r=="number"){const m=Math.floor(r);return m>0?m:null}if(typeof r=="string"){const m=parseInt(r,10);return isNaN(m)?null:m>0?m:null}return null}_setTabSize(r){const m=this._validateTabSize(r);if(m!==null){if(typeof m=="number"){if(this._tabSize===m)return;this._tabSize=m}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:m}))}}_validateInsertSpaces(r){return r==="auto"?"auto":r==="false"?!1:Boolean(r)}_setInsertSpaces(r){const m=this._validateInsertSpaces(r);if(typeof m=="boolean"){if(this._insertSpaces===m)return;this._insertSpaces=m}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:m}))}_setCursorStyle(r){this._cursorStyle!==r&&(this._cursorStyle=r,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:r})))}_setLineNumbers(r){this._lineNumbers!==r&&(this._lineNumbers=r,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:P.TextEditorLineNumbersStyle.from(r)})))}assign(r){const m={};let a=!1;if(typeof r.tabSize!="undefined"){const h=this._validateTabSize(r.tabSize);h==="auto"?(a=!0,m.tabSize=h):typeof h=="number"&&this._tabSize!==h&&(this._tabSize=h,a=!0,m.tabSize=h)}if(typeof r.insertSpaces!="undefined"){const h=this._validateInsertSpaces(r.insertSpaces);h==="auto"?(a=!0,m.insertSpaces=h):this._insertSpaces!==h&&(this._insertSpaces=h,a=!0,m.insertSpaces=h)}typeof r.cursorStyle!="undefined"&&this._cursorStyle!==r.cursorStyle&&(this._cursorStyle=r.cursorStyle,a=!0,m.cursorStyle=r.cursorStyle),typeof r.lineNumbers!="undefined"&&this._lineNumbers!==r.lineNumbers&&(this._lineNumbers=r.lineNumbers,a=!0,m.lineNumbers=P.TextEditorLineNumbersStyle.from(r.lineNumbers)),a&&this._warnOnError(this._proxy.$trySetOptions(this._id,m))}_warnOnError(r){r.catch(m=>this._logService.warn(m))}}e.ExtHostTextEditorOptions=k;class F{constructor(r,m,a,h,p,S,w,o){this.id=r,this._proxy=m,this._logService=a,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=p,this._options=new k(this._proxy,this.id,S,a),this._visibleRanges=w,this._viewColumn=o;const d=this;this.value=Object.freeze({get document(){return h.getValue()},set document(_){throw(0,M.readonly)("document")},get selection(){return d._selections&&d._selections[0]},set selection(_){if(!(_ instanceof t.Selection))throw(0,M.illegalArgument)("selection");d._selections=[_],d._trySetSelection()},get selections(){return d._selections},set selections(_){if(!Array.isArray(_)||_.some(c=>!(c instanceof t.Selection)))throw(0,M.illegalArgument)("selections");d._selections=_,d._trySetSelection()},get visibleRanges(){return d._visibleRanges},set visibleRanges(_){throw(0,M.readonly)("visibleRanges")},get options(){return d._options.value},set options(_){d._disposed||d._options.assign(_)},get viewColumn(){return d._viewColumn},set viewColumn(_){throw(0,M.readonly)("viewColumn")},edit(_,c={undoStopBefore:!0,undoStopAfter:!0}){if(d._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const R=new C(h.getValue(),c);return _(R),d._applyEdit(R)},insertSnippet(_,c,R={undoStopBefore:!0,undoStopAfter:!0}){if(d._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let n;if(!c||Array.isArray(c)&&c.length===0)n=d._selections.map(i=>P.Range.from(i));else if(c instanceof t.Position){const{lineNumber:i,column:g}=P.Position.from(c);n=[{startLineNumber:i,startColumn:g,endLineNumber:i,endColumn:g}]}else if(c instanceof t.Range)n=[P.Range.from(c)];else{n=[];for(const i of c)if(i instanceof t.Range)n.push(P.Range.from(i));else{const{lineNumber:g,column:f}=P.Position.from(i);n.push({startLineNumber:g,startColumn:f,endLineNumber:g,endColumn:f})}}return m.$tryInsertSnippet(r,_.value,n,R)},setDecorations(_,c){const R=c.length===0;R&&!d._hasDecorationsForKey.has(_.key)||(R?d._hasDecorationsForKey.delete(_.key):d._hasDecorationsForKey.add(_.key),d._runOnProxy(()=>{if(P.isDecorationOptionsArr(c))return m.$trySetDecorations(r,_.key,P.fromRangeOrRangeWithMessage(c));{const n=new Array(4*c.length);for(let i=0,g=c.length;i<g;i++){const f=c[i];n[4*i]=f.start.line+1,n[4*i+1]=f.start.character+1,n[4*i+2]=f.end.line+1,n[4*i+3]=f.end.character+1}return m.$trySetDecorationsFast(r,_.key,n)}}))},revealRange(_,c){d._runOnProxy(()=>m.$tryRevealRange(r,P.Range.from(_),c||t.TextEditorRevealType.Default))},show(_){m.$tryShowEditor(r,P.ViewColumn.from(_))},hide(){m.$tryHideEditor(r)}})}dispose(){(0,u.ok)(!this._disposed),this._disposed=!0}_acceptOptions(r){(0,u.ok)(!this._disposed),this._options._accept(r)}_acceptVisibleRanges(r){(0,u.ok)(!this._disposed),this._visibleRanges=r}_acceptViewColumn(r){(0,u.ok)(!this._disposed),this._viewColumn=r}_acceptSelections(r){(0,u.ok)(!this._disposed),this._selections=r}async _trySetSelection(){const r=this._selections.map(P.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,r)),this.value}_applyEdit(r){const m=r.finalize();if(m.edits.length===0&&!m.setEndOfLine)return Promise.resolve(!0);const a=m.edits.map(p=>p.range);a.sort((p,S)=>p.end.line===S.end.line?p.end.character===S.end.character?p.start.line===S.start.line?p.start.character-S.start.character:p.start.line-S.start.line:p.end.character-S.end.character:p.end.line-S.end.line);for(let p=0,S=a.length-1;p<S;p++){const w=a[p].end;if(a[p+1].start.isBefore(w))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const h=m.edits.map(p=>({range:P.Range.from(p.range),text:p.text,forceMoveMarkers:p.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,m.documentVersionId,h,{setEndOfLine:typeof m.setEndOfLine=="number"?P.EndOfLine.from(m.setEndOfLine):void 0,undoStopBefore:m.undoStopBefore,undoStopAfter:m.undoStopAfter})}_runOnProxy(r){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):r().then(()=>this,m=>(m instanceof Error&&m.name==="DISPOSED"||this._logService.warn(m),null))}}e.ExtHostTextEditor=F}),define(be[177],Ee([0,1,130,24,2,3,6,163,13,7,10,15,8,21,160]),function(re,e,u,M,b,P,t,A,C,k,F,y,r,m,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function h(w,o){if((0,F.isString)(w))return{label:w};if(w&&typeof w=="object"&&typeof w.label=="string"){let d;return Array.isArray(w.highlights)&&(d=w.highlights.filter(_=>_.length===2&&typeof _[0]=="number"&&typeof _[1]=="number"),d=d.length?d:void 0),{label:w.label,highlights:d}}}class p{constructor(o,d,_){this._proxy=o,this.commands=d,this.logService=_,this.treeViews=new Map;function c(R){return R&&R.$treeViewId&&R.$treeItemHandle}d.registerArgumentProcessor({processArgument:R=>c(R)?this.convertArgument(R):Array.isArray(R)&&R.length>0?R.map(n=>c(n)?this.convertArgument(n):n):R})}registerTreeDataProvider(o,d,_){const c=this.createTreeView(o,{treeDataProvider:d},_);return{dispose:()=>c.dispose()}}createTreeView(o,d,_){if(!d||!d.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const c=d.dragAndDropController!==void 0,R=this._proxy.$registerTreeViewDataProvider(o,{showCollapseAll:!!d.showCollapseAll,canSelectMany:!!d.canSelectMany,canDragAndDrop:c}),n=this.createExtHostTreeView(o,d,_);return{get onDidCollapseElement(){return n.onDidCollapseElement},get onDidExpandElement(){return n.onDidExpandElement},get selection(){return n.selectedElements},get onDidChangeSelection(){return n.onDidChangeSelection},get visible(){return n.visible},get onDidChangeVisibility(){return n.onDidChangeVisibility},get message(){return n.message},set message(i){n.message=i},get title(){return n.title},set title(i){n.title=i},get description(){return n.description},set description(i){n.description=i},reveal:(i,g)=>n.reveal(i,g),dispose:async()=>{await R,this.treeViews.delete(o),n.dispose()}}}$getChildren(o,d){const _=this.treeViews.get(o);return _?_.getChildren(d):Promise.reject(new Error((0,u.localize)(0,null,o)))}async $onDrop(o,d,_){const c=this.treeViews.get(o);if(!c)return Promise.reject(new Error((0,u.localize)(1,null,o)));const R=a.TreeDataTransferConverter.toITreeDataTransfer(d);if(R.items.has(A.TREE_ITEM_DATA_TRANSFER_TYPE)){const i=JSON.parse(await R.items.get(A.TREE_ITEM_DATA_TRANSFER_TYPE).asString()).map(g=>c.getExtensionElement(g)).filter(g=>!!g);i.length>0?R.items.set(A.TREE_ITEM_DATA_TRANSFER_TYPE,{asString:async()=>JSON.stringify(i)}):R.items.delete(A.TREE_ITEM_DATA_TRANSFER_TYPE)}return c.onDrop(R,_)}async $hasResolve(o){const d=this.treeViews.get(o);if(!d)throw new Error((0,u.localize)(2,null,o));return d.hasResolve}$resolve(o,d,_){const c=this.treeViews.get(o);if(!c)throw new Error((0,u.localize)(3,null,o));return c.resolveTreeItem(d,_)}$setExpanded(o,d,_){const c=this.treeViews.get(o);if(!c)throw new Error((0,u.localize)(4,null,o));c.setExpanded(d,_)}$setSelection(o,d){const _=this.treeViews.get(o);if(!_)throw new Error((0,u.localize)(5,null,o));_.setSelection(d)}$setVisible(o,d){const _=this.treeViews.get(o);if(!_)throw new Error((0,u.localize)(6,null,o));_.setVisible(d)}createExtHostTreeView(o,d,_){const c=new S(o,d,this._proxy,this.commands.converter,this.logService,_);return this.treeViews.set(o,c),c}convertArgument(o){const d=this.treeViews.get(o.$treeViewId);return d?d.getExtensionElement(o.$treeItemHandle):null}}e.ExtHostTreeViews=p;class S extends t.Disposable{constructor(o,d,_,c,R,n){super();if(this.viewId=o,this.proxy=_,this.commands=c,this.logService=R,this.extension=n,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new P.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new P.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new P.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new P.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new P.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new m.CancellationTokenSource,n.contributes&&n.contributes.views)for(const f in n.contributes.views)for(const s of n.contributes.views[f])s.id===o&&(this._title=s.name);this.dataProvider=d.treeDataProvider,this.dndController=d.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(f=>this._onDidChangeData.fire({message:!1,element:f}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(f=>this._onDidChangeData.fire({message:!1,element:f})));let i,g;this._register(P.Event.debounce(this._onDidChangeData.event,(f,s)=>(f||(f={message:!1,elements:[]}),s.element!==!1&&(i||(i=new Promise(v=>g=v),this.refreshPromise=this.refreshPromise.then(()=>i)),Array.isArray(s.element)?f.elements.push(...s.element):f.elements.push(s.element)),s.message&&(f.message=!0),f),200,!0)(({message:f,elements:s})=>{s.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const v=g;return i=null,this.refresh(s).then(()=>v())})),f&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(o=>this.getExtensionElement(o)).filter(o=>!(0,F.isUndefinedOrNull)(o))}async getChildren(o){const d=o?this.getExtensionElement(o):void 0;if(o&&!d)return this.logService.error(`No tree item with id '${o}' found.`),Promise.resolve([]);let _=this.getChildrenNodes(o);return _||(_=await this.fetchChildrenNodes(d)),_?_.map(c=>c.item):void 0}getExtensionElement(o){return this.elements.get(o)}reveal(o,d){d=d||{select:!0,focus:!1};const _=(0,F.isUndefinedOrNull)(d.select)?!0:d.select,c=(0,F.isUndefinedOrNull)(d.focus)?!1:d.focus,R=(0,F.isUndefinedOrNull)(d.expand)?!1:d.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):o?this.refreshPromise.then(()=>this.resolveUnknownParentChain(o)).then(n=>this.resolveTreeNode(o,n[n.length-1]).then(i=>this.proxy.$reveal(this.viewId,{item:i.item,parentChain:n.map(g=>g.item)},{select:_,focus:c,expand:R})),n=>this.logService.error(n)):this.proxy.$reveal(this.viewId,void 0,{select:_,focus:c,expand:R})}get message(){return this._message}set message(o){this._message=o,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(o){this._title=o,this.proxy.$setTitle(this.viewId,o,this._description)}get description(){return this._description}set description(o){this._description=o,this.proxy.$setTitle(this.viewId,this._title,o)}setExpanded(o,d){const _=this.getExtensionElement(o);_&&(d?this._onDidExpandElement.fire(Object.freeze({element:_})):this._onDidCollapseElement.fire(Object.freeze({element:_})))}setSelection(o){(0,y.equals)(this._selectedHandles,o)||(this._selectedHandles=o,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(o){o!==this._visible&&(this._visible=o,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onDrop(o,d){const _=this.getExtensionElement(d);if(!!_)return(0,C.asPromise)(()=>this.dndController?.onDrop(o,_))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(o,d){if(!this.dataProvider.resolveTreeItem)return;const _=this.elements.get(o);if(_){const c=this.nodes.get(_);if(c){const R=await this.dataProvider.resolveTreeItem(c.extensionItem,_,d)??c.extensionItem;return c.item.tooltip=this.getTooltip(R.tooltip),c.item.command=this.getCommand(c.disposableStore,R.command),c.item}}}resolveUnknownParentChain(o){return this.resolveParent(o).then(d=>d?this.resolveUnknownParentChain(d).then(_=>this.resolveTreeNode(d,_[_.length-1]).then(c=>(_.push(c),_))):Promise.resolve([]))}resolveParent(o){const d=this.nodes.get(o);return d?Promise.resolve(d.parent?this.elements.get(d.parent.item.handle):void 0):(0,C.asPromise)(()=>this.dataProvider.getParent(o))}resolveTreeNode(o,d){const _=this.nodes.get(o);return _?Promise.resolve(_):(0,C.asPromise)(()=>this.dataProvider.getTreeItem(o)).then(c=>this.createHandle(o,c,d,!0)).then(c=>this.getChildren(d?d.item.handle:void 0).then(()=>{const R=this.getExtensionElement(c);if(R){const n=this.nodes.get(R);if(n)return Promise.resolve(n)}throw new Error(`Cannot resolve tree item for element ${c}`)}))}getChildrenNodes(o){if(o){let d;if(typeof o=="string"){const _=this.getExtensionElement(o);d=_?this.nodes.get(_):void 0}else d=o;return d&&d.children||void 0}return this.roots}async fetchChildrenNodes(o){this.clearChildren(o);const d=new m.CancellationTokenSource(this._refreshCancellationSource.token);try{const _=o?this.nodes.get(o):void 0,c=await this.dataProvider.getChildren(o);if(d.token.isCancellationRequested)return;const R=await Promise.all((0,y.coalesce)(c||[]).map(async n=>{const i=await this.dataProvider.getTreeItem(n);return i&&!d.token.isCancellationRequested?this.createAndRegisterTreeNode(n,i,_):null}));return d.token.isCancellationRequested?void 0:(0,y.coalesce)(R)}finally{d.dispose()}}refresh(o){if(o.some(_=>!_))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new m.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const _=this.getHandlesToRefresh(o);if(_.length)return this.refreshHandles(_)}return Promise.resolve(void 0)}getHandlesToRefresh(o){const d=new Set,_=o.map(R=>this.nodes.get(R));for(const R of _)if(R&&!d.has(R.item.handle)){let n=R;for(;n&&n.parent&&_.findIndex(i=>n&&n.parent&&i&&i.item.handle===n.parent.item.handle)===-1;){const i=this.elements.get(n.parent.item.handle);n=i?this.nodes.get(i):void 0}n&&!n.parent&&d.add(R.item.handle)}const c=[];return d.forEach(R=>{const n=this.elements.get(R);if(n){const i=this.nodes.get(n);i&&(!i.parent||!d.has(i.parent.item.handle))&&c.push(R)}}),c}refreshHandles(o){const d={};return Promise.all(o.map(_=>this.refreshNode(_).then(c=>{c&&(d[_]=c.item)}))).then(()=>Object.keys(d).length?this.proxy.$refresh(this.viewId,d):void 0)}refreshNode(o){const d=this.getExtensionElement(o);if(d){const _=this.nodes.get(d);if(_)return this.clearChildren(d),(0,C.asPromise)(()=>this.dataProvider.getTreeItem(d)).then(c=>{if(c){const R=this.createTreeNode(d,c,_.parent);return this.updateNodeCache(d,R,_,_.parent),_.dispose(),R}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(o,d,_){const c=this.createTreeNode(o,d,_);if(d.id&&this.elements.has(c.item.handle))throw new Error((0,u.localize)(7,null,d.id));return this.addNodeToCache(o,c),this.addNodeToParentCache(c,_),c}getTooltip(o){return k.MarkdownString.isMarkdownString(o)?r.MarkdownString.from(o):o}getCommand(o,d){return d?this.commands.toInternal(d,o):void 0}createTreeNode(o,d,_){const c=new t.DisposableStore,R=this.createHandle(o,d,_),n=this.getLightIconPath(d);return{item:{handle:R,parentHandle:_?_.item.handle:void 0,label:h(d.label,this.extension),description:d.description,resourceUri:d.resourceUri,tooltip:this.getTooltip(d.tooltip),command:this.getCommand(c,d.command),contextValue:d.contextValue,icon:n,iconDark:this.getDarkIconPath(d)||n,themeIcon:this.getThemeIcon(d),collapsibleState:(0,F.isUndefinedOrNull)(d.collapsibleState)?k.TreeItemCollapsibleState.None:d.collapsibleState,accessibilityInformation:d.accessibilityInformation},extensionItem:d,parent:_,children:void 0,disposableStore:c,dispose(){c.dispose()}}}getThemeIcon(o){return o.iconPath instanceof k.ThemeIcon?o.iconPath:void 0}createHandle(o,{id:d,label:_,resourceUri:c},R,n){if(d)return`${S.ID_HANDLE_PREFIX}/${d}`;const i=h(_,this.extension),g=R?R.item.handle:S.LABEL_HANDLE_PREFIX;let f=i?i.label:c?(0,M.basename)(c):"";f=f.indexOf("/")!==-1?f.replace("/","//"):f;const s=this.nodes.has(o)?this.nodes.get(o).item.handle:void 0,v=this.getChildrenNodes(R)||[];let l,E=0;do{if(l=`${g}/${E}:${f}`,n||!this.elements.has(l)||s===l)break;E++}while(E<=v.length);return l}getLightIconPath(o){if(o.iconPath&&!(o.iconPath instanceof k.ThemeIcon))return typeof o.iconPath=="string"||b.URI.isUri(o.iconPath)?this.getIconPath(o.iconPath):this.getIconPath(o.iconPath.light)}getDarkIconPath(o){if(o.iconPath&&!(o.iconPath instanceof k.ThemeIcon)&&o.iconPath.dark)return this.getIconPath(o.iconPath.dark)}getIconPath(o){return b.URI.isUri(o)?o:b.URI.file(o)}addNodeToCache(o,d){this.elements.set(d.item.handle,o),this.nodes.set(o,d)}updateNodeCache(o,d,_,c){this.elements.delete(d.item.handle),this.nodes.delete(o),d.item.handle!==_.item.handle&&this.elements.delete(_.item.handle),this.addNodeToCache(o,d);const R=this.getChildrenNodes(c)||[],n=R.filter(i=>i.item.handle===_.item.handle)[0];n&&R.splice(R.indexOf(n),1,d)}addNodeToParentCache(o,d){d?(d.children||(d.children=[]),d.children.push(o)):(this.roots||(this.roots=[]),this.roots.push(o))}clearChildren(o){if(o){const d=this.nodes.get(o);if(d){if(d.children)for(const _ of d.children){const c=this.elements.get(_.item.handle);c&&this.clear(c)}d.children=void 0}}else this.clearAll()}clear(o){const d=this.nodes.get(o);if(d){if(d.children)for(const _ of d.children){const c=this.elements.get(_.item.handle);c&&this.clear(c)}this.nodes.delete(o),this.elements.delete(d.item.handle),d.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(o=>o.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}S.LABEL_HANDLE_PREFIX="0",S.ID_HANDLE_PREFIX="1"}),define(be[178],Ee([0,1,13,3,6,10,50,8,90,69]),function(re,e,u,M,b,P,t,A,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class F extends b.Disposable{constructor(r){super();this.controllerId=r,this.debounceSendDiff=this._register(new u.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new M.Emitter),this.root=new t.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(r){this._resolveHandler=r;for(const m of this.tree.values())this.updateExpandability(m)}collectDiff(){const r=this.diff;return this.diff=[],r}pushDiff(r){const m=this.diff[this.diff.length-1];if(m&&r[0]===1){if(m[0]===1&&m[1].extId===r[1].extId){(0,C.applyTestItemUpdate)(m[1],r[1]);return}if(m[0]===0&&m[1].item.extId===r[1].extId){(0,C.applyTestItemUpdate)(m[1],r[1]);return}}this.diff.push(r),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(r,m){const a=this.tree.get(r);if(!!a){if((a.expandLevels===void 0||m>a.expandLevels)&&(a.expandLevels=m),a.expand===1){const h=this.resolveChildren(a);return h.isOpen()?this.expandChildren(a,m-1):h.wait().then(()=>this.expandChildren(a,m-1))}else if(a.expand===3)return a.resolveBarrier?.isOpen()===!1?a.resolveBarrier.wait().then(()=>this.expandChildren(a,m-1)):this.expandChildren(a,m-1)}}dispose(){for(const r of this.tree.values())(0,t.getPrivateApiFor)(r.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(r,m){switch(m.op){case 2:this.pushDiff([4,r.fullId.toString()]);break;case 1:this.removeItem(k.TestId.joinToString(r.fullId,m.id));break;case 0:this.upsertItem(m.item,r);break;case 4:for(const w of m.ops)this.onTestItemEvent(r,w);break;case 3:const{key:a,value:h,previous:p}=m,S=r.fullId.toString();switch(a){case"canResolveChildren":this.updateExpandability(r);break;case"tags":this.diffTagRefs(h,p,S);break;case"range":this.pushDiff([1,{extId:S,item:{range:A.Range.from(h)}}]);break;case"error":this.pushDiff([1,{extId:S,item:{error:A.MarkdownString.fromStrict(h)||null}}]);break;default:this.pushDiff([1,{extId:S,item:{[a]:h??null}}]);break}break;default:(0,P.assertNever)(m)}}upsertItem(r,m){if(!(r instanceof t.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${r.id} did not`);const a=k.TestId.fromExtHostTestItem(r,this.root.id,m?.actual),h=(0,t.getPrivateApiFor)(r);h.parent&&h.parent!==m?.actual&&h.parent.children.delete(r.id);let p=this.tree.get(a.toString());if(!p){p={fullId:a,actual:r,parent:m?a.parentId:null,expandLevels:m?.expandLevels?m.expandLevels-1:void 0,expand:0},r.tags.forEach(this.incrementTagRefs,this),this.tree.set(p.fullId.toString(),p),this.setItemParent(r,m),this.pushDiff([0,{parent:p.parent&&p.parent.toString(),controllerId:this.controllerId,expand:p.expand,item:A.TestItem.from(r)}]),this.connectItemAndChildren(r,p,m);return}if(p.actual===r){this.connectItem(r,p,m);return}const S=p.actual.children,w=p.actual,o=(0,t.diffTestItems)(w,r);(0,t.getPrivateApiFor)(w).listener=void 0,p.actual=r,p.expand=0;for(const[d,_]of o)this.onTestItemEvent(p,{op:3,key:d,value:_,previous:w[d]});this.connectItemAndChildren(r,p,m);for(const d of S)r.children.get(d.id)||this.removeItem(k.TestId.joinToString(a,d.id))}diffTagRefs(r,m,a){const h=new Set(m.map(p=>p.id));for(const p of r)h.delete(p.id)||this.incrementTagRefs(p);this.pushDiff([1,{extId:a,item:{tags:r.map(p=>A.TestTag.namespace(this.controllerId,p.id))}}]),h.forEach(this.decrementTagRefs,this)}incrementTagRefs(r){const m=this.tags.get(r.id);m?m.refCount++:(this.tags.set(r.id,{refCount:1}),this.pushDiff([5,{id:A.TestTag.namespace(this.controllerId,r.id),ctrlLabel:this.root.label}]))}decrementTagRefs(r){const m=this.tags.get(r);m&&!--m.refCount&&(this.tags.delete(r),this.pushDiff([6,A.TestTag.namespace(this.controllerId,r)]))}setItemParent(r,m){(0,t.getPrivateApiFor)(r).parent=m&&m.actual!==this.root?m.actual:void 0}connectItem(r,m,a){this.setItemParent(r,a);const h=(0,t.getPrivateApiFor)(r);h.parent=a?.actual,h.listener=p=>this.onTestItemEvent(m,p),this.updateExpandability(m)}connectItemAndChildren(r,m,a){this.connectItem(r,m,a);for(const h of r.children)this.upsertItem(h,m)}updateExpandability(r){let m;this._resolveHandler?r.resolveBarrier?m=r.resolveBarrier.isOpen()?3:2:m=r.actual.canResolveChildren?1:0:m=0,m!==r.expand&&(r.expand=m,this.pushDiff([1,{extId:r.fullId.toString(),expand:m}]),m===1&&r.expandLevels!==void 0&&this.resolveChildren(r))}expandChildren(r,m){if(m<0)return;const a=[];for(const h of r.actual.children){const p=this.expand(k.TestId.joinToString(r.fullId,h.id),m);(0,u.isThenable)(p)&&a.push(p)}if(a.length)return Promise.all(a).then(()=>{})}resolveChildren(r){if(r.resolveBarrier)return r.resolveBarrier;if(!this._resolveHandler){const p=new u.Barrier;return p.open(),p}r.expand=2,this.pushExpandStateUpdate(r);const m=r.resolveBarrier=new u.Barrier,a=p=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),r.actual!==this.root&&(r.actual.error=p.stack||p.message||String(p))};let h;try{h=this._resolveHandler(r.actual===this.root?void 0:r.actual)}catch(p){a(p)}return(0,u.isThenable)(h)?h.catch(a).then(()=>{m.open(),this.updateExpandability(r)}):(m.open(),this.updateExpandability(r)),r.resolveBarrier}pushExpandStateUpdate(r){this.pushDiff([1,{extId:r.fullId.toString(),expand:r.expand}])}removeItem(r){const m=this.tree.get(r);if(!m)throw new Error("attempting to remove non-existent child");this.pushDiff([2,r]);const a=[m];for(;a.length;){const h=a.pop();if(!!h){(0,t.getPrivateApiFor)(h.actual).listener=void 0;for(const p of h.actual.tags)this.decrementTagRefs(p.id);this.tree.delete(h.fullId.toString());for(const p of h.actual.children)a.push(this.tree.get(k.TestId.joinToString(h.fullId,p.id)))}}}flushDiff(){const r=this.collectDiff();r.length&&this.diffOpEmitter.fire(r)}}e.SingleUseTestCollection=F}),define(be[179],Ee([0,1,4,143]),function(re,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,u.refineServiceDecorator)(M.IEnvironmentService)}),define(be[180],Ee([0,1,26,3,17]),function(re,e,u,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class P{constructor(F){this.removedDueToLooping=F}}e.DeltaExtensionsResult=P;class t{constructor(F){this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=F,this._initialize()}_initialize(){this._extensionDescriptions.sort(C),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const F of this._extensionDescriptions){if(this._extensionsMap.has(u.ExtensionIdentifier.toKey(F.identifier))){console.error("Extension `"+F.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(u.ExtensionIdentifier.toKey(F.identifier),F),this._extensionsArr.push(F),Array.isArray(F.activationEvents))for(let y of F.activationEvents)y==="onUri"&&(y=`onUri:${u.ExtensionIdentifier.toKey(F.identifier)}`),this._activationMap.has(y)||this._activationMap.set(y,[]),this._activationMap.get(y).push(F)}}keepOnly(F){const y=new Set;F.forEach(r=>y.add(u.ExtensionIdentifier.toKey(r))),this._extensionDescriptions=this._extensionDescriptions.filter(r=>y.has(u.ExtensionIdentifier.toKey(r.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(F,y){F.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(F));const r=t._findLoopingExtensions(this._extensionDescriptions);if(y=y.concat(r.map(m=>m.identifier)),y.length>0){const m=new Set;y.forEach(a=>m.add(u.ExtensionIdentifier.toKey(a))),this._extensionDescriptions=this._extensionDescriptions.filter(a=>!m.has(u.ExtensionIdentifier.toKey(a.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new P(r)}static _findLoopingExtensions(F){const y=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(p){this._nodesSet.has(p)||(this._nodesSet.add(p),this._nodesArr.push(p))}addArc(p,S){this.addNode(p),this.addNode(S),this._arcs.has(p)?this._arcs.get(p).push(S):this._arcs.set(p,[S])}getArcs(p){return this._arcs.has(p)?this._arcs.get(p):[]}hasOnlyGoodArcs(p,S){const w=y.getArcs(p);for(let o=0;o<w.length;o++)if(!S.has(w[o]))return!1;return!0}getNodes(){return this._nodesArr}};let r=new Map;for(let p of F){const S=u.ExtensionIdentifier.toKey(p.identifier);if(r.set(S,p),p.extensionDependencies)for(let w of p.extensionDependencies){const o=u.ExtensionIdentifier.toKey(w);y.addArc(S,o)}}let m=new Set;y.getNodes().filter(p=>y.getArcs(p).length===0).forEach(p=>m.add(p));let a=y.getNodes().filter(p=>!m.has(p)),h;do{h=!1;for(let p=0;p<a.length;p++){const S=a[p];y.hasOnlyGoodArcs(S,m)&&(a.splice(p,1),p--,m.add(S),h=!0)}}while(h);return a.map(p=>r.get(p))}containsActivationEvent(F){return this._activationMap.has(F)}containsExtension(F){return this._extensionsMap.has(u.ExtensionIdentifier.toKey(F))}getExtensionDescriptionsForActivationEvent(F){const y=this._activationMap.get(F);return y?y.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(F){const y=this._extensionsMap.get(u.ExtensionIdentifier.toKey(F));return y||void 0}}e.ExtensionDescriptionRegistry=t;var A;(function(k){k[k.Builtin=0]="Builtin",k[k.User=1]="User",k[k.Dev=2]="Dev"})(A||(A={}));function C(k,F){const y=k.isBuiltin?0:k.isUnderDevelopment?2:1,r=F.isBuiltin?0:F.isUnderDevelopment?2:1;if(y!==r)return y-r;const m=b.posix.basename(k.extensionLocation.path),a=b.posix.basename(F.extensionLocation.path);return m<a?-1:m>a?1:0}}),define(be[181],Ee([0,1,22]),function(re,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var M;(function(A){A[A.VersionMismatch=55]="VersionMismatch",A[A.UnexpectedError=81]="UnexpectedError"})(M=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var b;(function(A){A[A.Initialized=0]="Initialized",A[A.Ready=1]="Ready",A[A.Terminate=2]="Terminate"})(b=e.MessageType||(e.MessageType={}));function P(A){const C=u.VSBuffer.alloc(1);switch(A){case 0:C.writeUInt8(1,0);break;case 1:C.writeUInt8(2,0);break;case 2:C.writeUInt8(3,0);break}return C}e.createMessageOfType=P;function t(A,C){if(A.byteLength!==1)return!1;switch(A.readUInt8(0)){case 1:return C===0;case 2:return C===1;case 3:return C===2;default:return!1}}e.isMessageOfType=t}),define(be[27],Ee([0,1,3,2,4,26,149]),function(re,e,u,M,b,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new P.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:M.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,b.createDecorator)("extensionService");var A;(function(d){d[d.None=0]="None",d[d.LocalProcess=1]="LocalProcess",d[d.LocalWebWorker=2]="LocalWebWorker",d[d.Remote=3]="Remote"})(A=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function C(d){switch(d){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=C;class k{constructor(_){this.dependency=_}}e.MissingExtensionDependency=k;var F;(function(d){d[d.LocalProcess=0]="LocalProcess",d[d.LocalWebWorker=1]="LocalWebWorker",d[d.Remote=2]="Remote"})(F=e.ExtensionHostKind||(e.ExtensionHostKind={}));function y(d){switch(d){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=y;function r(d,_){return d.enabledApiProposals?.includes(_)?!0:Boolean(d.enableProposedApi)}e.isProposedApiEnabled=r;function m(d,_){if(!r(d,_))throw new Error(`Extension '${d.identifier.value}' CANNOT use API proposal: ${_}.
According to its package.json#enabledApiProposals-property it wants: ${d.enabledApiProposals?.join(", ")??"<none>"}.
 You MUST start in extension development mode or use the following command line switch: --enable-proposed-api ${d.identifier.value}`)}e.checkProposedApiEnabled=m;class a{constructor(_,c,R,n){this.codeLoadingTime=_,this.activateCallTime=c,this.activateResolvedTime=R,this.activationReason=n}}e.ActivationTimes=a;class h{constructor(_,c){this.description=_,this.value=c}}e.ExtensionPointContribution=h,e.ExtensionHostLogFileName="exthost";var p;(function(d){d[d.Normal=0]="Normal",d[d.Immediate=1]="Immediate"})(p=e.ActivationKind||(e.ActivationKind={}));function S(d){return{type:d.isBuiltin?0:1,isBuiltin:d.isBuiltin||d.isUserBuiltin,identifier:{id:(0,t.getGalleryExtensionId)(d.publisher,d.name),uuid:d.uuid},manifest:d,location:d.extensionLocation}}e.toExtension=S;function w(d,_){return{identifier:new P.ExtensionIdentifier(d.identifier.id),isBuiltin:d.type===0,isUserBuiltin:d.type===1&&d.isBuiltin,isUnderDevelopment:!!_,extensionLocation:d.location,...d.manifest,uuid:d.identifier.uuid}}e.toExtensionDescription=w;class o{constructor(){this.onDidRegisterExtensions=u.Event.None,this.onDidChangeExtensionsStatus=u.Event.None,this.onDidChangeExtensions=u.Event.None,this.onWillActivateByEvent=u.Event.None,this.onDidChangeResponsiveChange=u.Event.None}activateByEvent(_){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(_){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(_){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(_){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(_,c){return Promise.resolve()}_onWillActivateExtension(_){}_onDidActivateExtension(_,c,R,n,i){}_onDidActivateExtensionError(_,c){}_onExtensionRuntimeError(_,c){}_onExtensionHostExit(_){}}e.NullExtensionService=o}),define(be[182],Ee([0,1,26,27,12]),function(re,e,u,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const P=Promise.resolve(void 0);class t{constructor(a,h,p,S){this.startup=a,this.codeLoadingTime=h,this.activateCallTime=p,this.activateResolvedTime=S}}e.ExtensionActivationTimes=t,t.NONE=new t(!1,-1,-1,-1);class A{constructor(a){this._startup=a,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(a,h){return a===-1||h===-1?-1:h-a}build(){return new t(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=A;class C{constructor(a,h,p,S,w,o){this.activationFailed=a,this.activationFailedError=h,this.activationTimes=p,this.module=S,this.exports=w,this.subscriptions=o}}e.ActivatedExtension=C;class k extends C{constructor(a){super(!1,null,a,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=k;class F extends C{constructor(){super(!1,null,t.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=F;class y extends C{constructor(a){super(!0,a,t.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=y;let r=class{constructor(a,h,p,S,w){this._logService=w,this._registry=a,this._resolvedExtensionsSet=new Set,h.forEach(o=>this._resolvedExtensionsSet.add(u.ExtensionIdentifier.toKey(o))),this._hostExtensionsMap=new Map,p.forEach(o=>this._hostExtensionsMap.set(u.ExtensionIdentifier.toKey(o),o)),this._host=S,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(a){const h=u.ExtensionIdentifier.toKey(a);return this._activatedExtensions.has(h)}getActivatedExtension(a){const h=u.ExtensionIdentifier.toKey(a),p=this._activatedExtensions.get(h);if(!p)throw new Error("Extension `"+a.value+"` is not known or not activated");return p}activateByEvent(a,h){if(this._alreadyActivatedEvents[a])return P;const p=this._registry.getExtensionDescriptionsForActivationEvent(a);return this._activateExtensions(p.map(S=>({id:S.identifier,reason:{startup:h,extensionId:S.identifier,activationEvent:a}}))).then(()=>{this._alreadyActivatedEvents[a]=!0})}activateById(a,h){const p=this._registry.getExtensionDescription(a);if(!p)throw new Error("Extension `"+a+"` is not known");return this._activateExtensions([{id:p.identifier,reason:h}])}_handleActivateRequest(a,h,p){if(this._hostExtensionsMap.has(u.ExtensionIdentifier.toKey(a.id))){h[u.ExtensionIdentifier.toKey(a.id)]=a;return}const S=this._registry.getExtensionDescription(a.id);if(!S){const d=new Error(`Cannot activate unknown extension '${a.id.value}'`);this._host.onExtensionActivationError(a.id,d,new M.MissingExtensionDependency(a.id.value)),this._activatedExtensions.set(u.ExtensionIdentifier.toKey(a.id),new y(d));return}const w=typeof S.extensionDependencies=="undefined"?[]:S.extensionDependencies;let o=!0;for(let d=0,_=w.length;d<_;d++){const c=w[d];if(this._resolvedExtensionsSet.has(u.ExtensionIdentifier.toKey(c)))continue;const R=this._activatedExtensions.get(u.ExtensionIdentifier.toKey(c));if(R&&!R.activationFailed)continue;if(R&&R.activationFailed){const f=S.displayName||S.identifier.value,s=this._registry.getExtensionDescription(c),v=s&&s.displayName||c,l=new Error(`Cannot activate the '${f}' extension because its dependency '${v}' failed to activate`);l.detail=R.activationFailedError,this._host.onExtensionActivationError(S.identifier,l,null),this._activatedExtensions.set(u.ExtensionIdentifier.toKey(S.identifier),new y(l));return}if(this._hostExtensionsMap.has(u.ExtensionIdentifier.toKey(c))){o=!1,h[u.ExtensionIdentifier.toKey(c)]={id:this._hostExtensionsMap.get(u.ExtensionIdentifier.toKey(c)),reason:a.reason};continue}const n=this._registry.getExtensionDescription(c);if(n){if(!n.main&&!n.browser)continue;o=!1,h[u.ExtensionIdentifier.toKey(c)]={id:n.identifier,reason:a.reason};continue}const i=S.displayName||S.identifier.value,g=new Error(`Cannot activate the '${i}' extension because it depends on unknown extension '${c}'`);this._host.onExtensionActivationError(S.identifier,g,new M.MissingExtensionDependency(c)),this._activatedExtensions.set(u.ExtensionIdentifier.toKey(S.identifier),new y(g));return}o?h[u.ExtensionIdentifier.toKey(S.identifier)]=a:p.push(a)}_activateExtensions(a){if(a.length===0||(a=a.filter(w=>!this._activatedExtensions.has(u.ExtensionIdentifier.toKey(w.id))),a.length===0))return Promise.resolve(void 0);const h=Object.create(null),p=[];for(let w=0,o=a.length;w<o;w++)this._handleActivateRequest(a[w],h,p);for(let w=0,o=p.length;w<o;w++){const d=u.ExtensionIdentifier.toKey(p[w].id);h[d]&&delete h[d]}const S=Object.keys(h).map(w=>h[w]);return p.length===0?Promise.all(S.map(w=>this._activateExtension(w.id,w.reason))).then(w=>{}):this._activateExtensions(S).then(w=>this._activateExtensions(p))}_activateExtension(a,h){const p=u.ExtensionIdentifier.toKey(a);if(this._activatedExtensions.has(p))return Promise.resolve(void 0);const S=this._activatingExtensions.get(p);if(S)return S;const w=this._host.actualActivateExtension(a,h).then(void 0,o=>{const d=new Error;return o&&o.name&&(d.name=o.name),o&&o.message?d.message=`Activating extension '${a.value}' failed: ${o.message}.`:d.message=`Activating extension '${a.value}' failed: ${o}.`,o&&o.stack&&(d.stack=o.stack),this._host.onExtensionActivationError(a,d,null),this._logService.error(`Activating extension ${a.value} failed due to an error:`),this._logService.error(o),new y(o)}).then(o=>{this._activatedExtensions.set(p,o),this._activatingExtensions.delete(p)});return this._activatingExtensions.set(p,w),w}};r=Ue([Be(4,b.ILogService)],r),e.ExtensionsActivator=r}),define(be[183],Ee([0,1,12,28,27]),function(re,e,u,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let P=class extends u.LogService{constructor(A,C){super(A.createLogger(C.logFile,{name:b.ExtensionHostLogFileName}))}};P=Ue([Be(0,u.ILoggerService),Be(1,M.IExtHostInitDataService)],P),e.ExtHostLogService=P}),define(be[184],Ee([0,1,16]),function(re,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class M{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((P,t)=>{this._actualOk=P,this._actualErr=t,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(P){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=P,this._actual&&this._actualOk(P))}resolveErr(P){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=P,this._actual?this._actualErr(P):(0,u.onUnexpectedError)(P))}then(P,t){return this._ensureActual().then(P,t)}catch(P){return this._ensureActual().then(void 0,P)}finally(P){return this._ensureActual().finally(P)}}e.LazyPromise=M}),define(be[39],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class u{constructor(k,F){this._proxyIdentifierBrand=void 0,this.isMain=k,this.sid=F,this.nid=++u.count}}e.ProxyIdentifier=u,u.count=0;const M=[];function b(C){const k=new u(!0,C);return M[k.nid]=k,k}e.createMainContextProxyIdentifier=b;function P(C){const k=new u(!1,C);return M[k.nid]=k,k}e.createExtHostContextProxyIdentifier=P;function t(C){return M[C].sid}e.getStringIdentifierForProxy=t;class A{constructor(k){this.value=k}}e.SerializableObjectWithBuffers=A}),define(be[5],Ee([0,1,57,2,39]),function(re,e,u,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var P;(function(o){o[o.Desktop=1]="Desktop",o[o.Web=2]="Web"})(P=e.UIKind||(e.UIKind={}));var t;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(t=e.TextEditorRevealType||(e.TextEditorRevealType={}));var A;(function(o){o[o.Editable=0]="Editable",o[o.SupportsHotExit=1]="SupportsHotExit"})(A=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var C;(function(o){o[o.Int8Array=1]="Int8Array",o[o.Uint8Array=2]="Uint8Array",o[o.Uint8ClampedArray=3]="Uint8ClampedArray",o[o.Int16Array=4]="Int16Array",o[o.Uint16Array=5]="Uint16Array",o[o.Int32Array=6]="Int32Array",o[o.Uint32Array=7]="Uint32Array",o[o.Float32Array=8]="Float32Array",o[o.Float64Array=9]="Float64Array",o[o.BigInt64Array=10]="BigInt64Array",o[o.BigUint64Array=11]="BigUint64Array"})(C=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var k;(function(o){o[o.Text=1]="Text",o[o.Error=2]="Error",o[o.Rich=3]="Rich"})(k=e.CellOutputKind||(e.CellOutputKind={}));var F;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(F=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var y;(function(o){o[o.None=0]="None",o[o.Process=1]="Process",o[o.Output=2]="Output"})(y=e.CandidatePortSource||(e.CandidatePortSource={}));var r;(function(o){o.name="$ident";function d(c,R){return Object.defineProperty(c,o.name,{value:R,enumerable:!0}),c}o.mixin=d;function _(c){return c[o.name]}o.of=_})(r=e.ObjectIdentifier||(e.ObjectIdentifier={}));class m{static mixin(d){return d._id=m._n++,d}}e.IdObject=m,m._n=0;var a;(function(o){o.label="a",o.kind="b",o.detail="c",o.documentation="d",o.sortText="e",o.filterText="f",o.preselect="g",o.insertText="h",o.insertTextRules="i",o.range="j",o.commitCharacters="k",o.additionalTextEdits="l",o.command="m",o.kindModifier="n"})(a=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var h;(function(o){o.defaultRanges="a",o.completions="b",o.isIncomplete="c",o.duration="d"})(h=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var p;(function(o){o[o.File=1]="File",o[o.Text=2]="Text",o[o.Cell=3]="Cell"})(p=e.WorkspaceEditType||(e.WorkspaceEditType={}));function S(o){if(o&&o.edits)for(const d of o.edits)typeof d.resource=="object"?d.resource=M.URI.revive(d.resource):(d.newUri=M.URI.revive(d.newUri),d.oldUri=M.URI.revive(d.oldUri)),d.metadata&&d.metadata.iconPath&&(d.metadata=(0,u.revive)(d.metadata));return o}e.reviveWorkspaceEditDto=S;var w;(function(o){o[o.Workspace=0]="Workspace",o[o.TextDocument=1]="TextDocument"})(w=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,b.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,b.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,b.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,b.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,b.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,b.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,b.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,b.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,b.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,b.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,b.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,b.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,b.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,b.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,b.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,b.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,b.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,b.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,b.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,b.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,b.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,b.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,b.createMainContextProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,b.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,b.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,b.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,b.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,b.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,b.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,b.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,b.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,b.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,b.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,b.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,b.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,b.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,b.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,b.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,b.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,b.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,b.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,b.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,b.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,b.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,b.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,b.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,b.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,b.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,b.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,b.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,b.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,b.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,b.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,b.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,b.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,b.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,b.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,b.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,b.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,b.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,b.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,b.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,b.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,b.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,b.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,b.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,b.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,b.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,b.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,b.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,b.createExtHostContextProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,b.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,b.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,b.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,b.createExtHostContextProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,b.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,b.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,b.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,b.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,b.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,b.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,b.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,b.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,b.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,b.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,b.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,b.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,b.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,b.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,b.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,b.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,b.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,b.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,b.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,b.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,b.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,b.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,b.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,b.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,b.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,b.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,b.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,b.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,b.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,b.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,b.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,b.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(be[70],Ee([0,1,5,3,4]),function(re,e,u,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class P{constructor(A){this._onDidChangePassword=new M.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=A.getProxy(u.MainContext.MainThreadSecretState)}async $onDidChangePassword(A){this._onDidChangePassword.fire(A)}get(A,C){return this._proxy.$getPassword(A,C)}store(A,C,k){return this._proxy.$setPassword(A,C,k)}delete(A,C){return this._proxy.$deletePassword(A,C)}}e.ExtHostSecretState=P,e.IExtHostSecretState=(0,b.createDecorator)("IExtHostSecretState")}),define(be[71],Ee([0,1,4,12,5,14]),function(re,e,u,M,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,u.createDecorator)("IExtHostApiDeprecationService");let t=class{constructor(C,k){this._extHostLogService=k,this._reportedUsages=new Set,this._telemetryShape=C.getProxy(b.MainContext.MainThreadTelemetry)}report(C,k,F){const y=this.getUsageKey(C,k);this._reportedUsages.has(y)||(this._reportedUsages.add(y),k.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${C}' is deprecated. ${F}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:C}))}getUsageKey(C,k){return`${C}-${k.identifier.value}`}};t=Ue([Be(0,P.IExtHostRpcService),Be(1,M.ILogService)],t),e.ExtHostApiDeprecationService=t,e.NullApiDeprecationService=Object.freeze(new class{report(A,C,k){}})}),define(be[185],Ee([0,1,3,5,7,26]),function(re,e,u,M,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class t{constructor(C){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new u.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=C.getProxy(M.MainContext.MainThreadAuthentication)}$setProviders(C){return this._providers=C,Promise.resolve()}async getSession(C,k,F,y={}){const r=P.ExtensionIdentifier.toKey(C.identifier),m=this._inFlightRequests.get(r)||[],a=[...F].sort().join(" ");let h=m.find(p=>p.scopes===a);if(h)return h.result;{const p=this._getSession(C,r,k,F,y);h={scopes:a,result:p},m.push(h),this._inFlightRequests.set(r,m);try{await p}finally{const S=m.findIndex(w=>w.scopes===a);S>-1&&(m.splice(S),this._inFlightRequests.set(r,m))}return p}}async _getSession(C,k,F,y,r={}){await this._proxy.$ensureProvider(F);const m=C.displayName||C.name;return this._proxy.$getSession(F,y,k,m,r)}async removeSession(C,k){const F=this._authenticationProviders.get(C);return F?F.provider.removeSession(k):this._proxy.$removeSession(C,k)}registerAuthenticationProvider(C,k,F,y){if(this._authenticationProviders.get(C))throw new Error(`An authentication provider with id '${C}' is already registered.`);this._authenticationProviders.set(C,{label:k,provider:F,options:y??{supportsMultipleAccounts:!1}}),this._providers.find(m=>m.id===C)||this._providers.push({id:C,label:k});const r=F.onDidChangeSessions(m=>{this._proxy.$sendDidChangeSessions(C,{added:m.added??[],changed:m.changed??[],removed:m.removed??[]})});return this._proxy.$registerAuthenticationProvider(C,k,y?.supportsMultipleAccounts??!1),new b.Disposable(()=>{r.dispose(),this._authenticationProviders.delete(C);const m=this._providers.findIndex(a=>a.id===C);m>-1&&this._providers.splice(m),this._proxy.$unregisterAuthenticationProvider(C)})}$createSession(C,k){const F=this._authenticationProviders.get(C);if(F)return Promise.resolve(F.provider.createSession(k));throw new Error(`Unable to find authentication provider with handle: ${C}`)}$removeSession(C,k){const F=this._authenticationProviders.get(C);if(F)return Promise.resolve(F.provider.removeSession(k));throw new Error(`Unable to find authentication provider with handle: ${C}`)}$getSessions(C,k){const F=this._authenticationProviders.get(C);if(F)return Promise.resolve(F.provider.getSessions(k));throw new Error(`Unable to find authentication provider with handle: ${C}`)}$onDidChangeAuthenticationSessions(C,k){return this._onDidChangeSessions.fire({provider:{id:C,label:k}}),Promise.resolve()}}e.ExtHostAuthentication=t}),define(be[186],Ee([0,1,5,14,8]),function(re,e,u,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let P=class{constructor(A,C){this._extHostDocumentsAndEditors=C,this._proxy=A.getProxy(u.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(A){const C=b.WorkspaceEdit.from(A,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(C)}};P=Ue([Be(0,M.IExtHostRpcService)],P),e.ExtHostBulkEdits=P}),define(be[187],Ee([0,1,5]),function(re,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class M{constructor(P){const t=P.getProxy(u.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return t.$readText()},writeText(A){return t.$writeText(A)}})}}e.ExtHostClipboard=M}),define(be[40],Ee([0,1,10,7,8,23,5,15,12,57,45,111,2,6,4,14,50,22,39,46]),function(re,e,u,M,b,P,t,A,C,k,F,y,r,m,a,h,p,S,w,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let d=class{constructor(g,f){this._commands=new Map,this._apiCommands=new Map,this._proxy=g.getProxy(t.MainContext.MainThreadCommands),this._logService=f,this.converter=new _(this,s=>{const v=this._apiCommands.get(s);return v?.result===R.Void?v:void 0},f),this._argumentProcessors=[{processArgument(s){return(0,k.revive)(s)}},{processArgument(s){return(0,P.cloneAndChange)(s,function(v){if(F.Range.isIRange(v))return b.Range.to(v);if(y.Position.isIPosition(v))return b.Position.to(v);if(F.Range.isIRange(v.range)&&r.URI.isUri(v.uri))return b.location.to(v);if(v instanceof S.VSBuffer)return v.buffer.buffer;if(!Array.isArray(v))return v})}}]}registerArgumentProcessor(g){this._argumentProcessors.push(g)}registerApiCommand(g){const f=this.registerCommand(!1,g.id,async(...s)=>{const v=g.args.map((E,T)=>{if(!E.validate(s[T]))throw new Error(`Invalid argument '${E.name}' when running '${g.id}', received: ${s[T]}`);return E.convert(s[T])}),l=await this.executeCommand(g.internalId,...v);return g.result.convert(l,s,this.converter)},void 0,{description:g.description,args:g.args,returns:g.result.description});return this._apiCommands.set(g.id,g),new M.Disposable(()=>{f.dispose(),this._apiCommands.delete(g.id)})}registerCommand(g,f,s,v,l,E){if(this._logService.trace("ExtHostCommands#registerCommand",f),!f.trim().length)throw new Error("invalid id");if(this._commands.has(f))throw new Error(`command '${f}' already exists`);return this._commands.set(f,{callback:s,thisArg:v,description:l,extension:E}),g&&this._proxy.$registerCommand(f),new M.Disposable(()=>{this._commands.delete(f)&&g&&this._proxy.$unregisterCommand(f)})}executeCommand(g,...f){return this._logService.trace("ExtHostCommands#executeCommand",g),this._doExecuteCommand(g,f,!0)}async _doExecuteCommand(g,f,s){if(this._commands.has(g))return this._executeContributedCommand(g,f,!1);{let v=!1;const l=(0,P.cloneAndChange)(f,function(E){if(E instanceof M.Position)return b.Position.from(E);if(E instanceof M.Range)return b.Range.from(E);if(E instanceof M.Location)return b.location.from(E);if(M.NotebookRange.isNotebookRange(E))return b.NotebookRange.from(E);if(E instanceof ArrayBuffer)return v=!0,S.VSBuffer.wrap(new Uint8Array(E));if(E instanceof Uint8Array)return v=!0,S.VSBuffer.wrap(E);if(!Array.isArray(E))return E});try{const E=await this._proxy.$executeCommand(g,v?new w.SerializableObjectWithBuffers(l):l,s);return(0,k.revive)(E)}catch(E){if(E instanceof Error&&E.message==="$executeCommand:retry")return this._doExecuteCommand(g,f,!1);throw E}}}async _executeContributedCommand(g,f,s){const v=this._commands.get(g);if(!v)throw new Error("Unknown command");let{callback:l,thisArg:E,description:T}=v;if(T)for(let I=0;I<T.args.length;I++)try{(0,u.validateConstraint)(f[I],T.args[I].constraint)}catch(B){throw new Error(`Running the contributed command: '${g}' failed. Illegal argument '${T.args[I].name}' - ${T.args[I].description}`)}try{return await l.apply(E,f)}catch(I){if(g===this.converter.delegatingCommandId){const B=this.converter.getActualCommand(...f);B&&(g=B.command)}throw this._logService.error(I,g,v.extension?.identifier),s?new class extends Error{constructor(){super((0,o.toErrorMessage)(I));this.id=g,this.source=v.extension?.displayName??v.extension?.name}}:I}}$executeContributedCommand(g,...f){return this._logService.trace("ExtHostCommands#$executeContributedCommand",g),this._commands.has(g)?(f=f.map(s=>this._argumentProcessors.reduce((v,l)=>l.processArgument(v),s)),this._executeContributedCommand(g,f,!0)):Promise.reject(new Error(`Contributed command '${g}' does not exist.`))}getCommands(g=!1){return this._logService.trace("ExtHostCommands#getCommands",g),this._proxy.$getCommands().then(f=>(g&&(f=f.filter(s=>s[0]!=="_")),f))}$getContributedCommandHandlerDescriptions(){const g=Object.create(null);for(let[f,s]of this._commands){let{description:v}=s;v&&(g[f]=v)}return Promise.resolve(g)}};d=Ue([Be(0,h.IExtHostRpcService),Be(1,C.ILogService)],d),e.ExtHostCommands=d,e.IExtHostCommands=(0,a.createDecorator)("IExtHostCommands");class _{constructor(g,f,s){this._commands=g,this._lookupApiCommand=f,this._logService=s,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(g,f){if(!g)return;const s={$ident:void 0,id:g.command,title:g.title,tooltip:g.tooltip};if(!g.command)return s;const v=this._lookupApiCommand(g.command);if(v)s.id=v.internalId,s.arguments=v.args.map((l,E)=>l.convert(g.arguments&&g.arguments[E]));else if((0,A.isNonEmptyArray)(g.arguments)){const l=++this._cachIdPool;this._cache.set(l,g),f.add((0,m.toDisposable)(()=>{this._cache.delete(l),this._logService.trace("CommandsConverter#DISPOSE",l)})),s.$ident=l,s.id=this.delegatingCommandId,s.arguments=[l],this._logService.trace("CommandsConverter#CREATE",g.command,l)}return s}fromInternal(g){const f=t.ObjectIdentifier.of(g);return typeof f=="number"?this._cache.get(f):{command:g.id,title:g.title,arguments:g.arguments}}getActualCommand(...g){return this._cache.get(g[0])}_executeConvertedCommand(...g){const f=this.getActualCommand(...g);return this._logService.trace("CommandsConverter#EXECUTE",g[0],f?f.command:"MISSING"),f?this._commands.executeCommand(f.command,...f.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=_;class c{constructor(g,f,s,v){this.name=g,this.description=f,this.validate=s,this.convert=v}optional(){return new c(this.name,`(optional) ${this.description}`,g=>g==null||this.validate(g),g=>g===void 0?void 0:g===null?null:this.convert(g))}with(g,f){return new c(g??this.name,f??this.description,this.validate,this.convert)}}e.ApiCommandArgument=c,c.Uri=new c("uri","Uri of a text document",i=>r.URI.isUri(i),i=>i),c.Position=new c("position","A position in a text document",i=>M.Position.isPosition(i),b.Position.from),c.Range=new c("range","A range in a text document",i=>M.Range.isRange(i),b.Range.from),c.Selection=new c("selection","A selection in a text document",i=>M.Selection.isSelection(i),b.Selection.from),c.Number=new c("number","",i=>typeof i=="number",i=>i),c.String=new c("string","",i=>typeof i=="string",i=>i),c.CallHierarchyItem=new c("item","A call hierarchy item",i=>i instanceof M.CallHierarchyItem,b.CallHierarchyItem.from),c.TypeHierarchyItem=new c("item","A type hierarchy item",i=>i instanceof M.TypeHierarchyItem,b.TypeHierarchyItem.from),c.TestItem=new c("testItem","A VS Code TestItem",i=>i instanceof p.TestItemImpl,b.TestItem.from);class R{constructor(g,f){this.description=g,this.convert=f}}e.ApiCommandResult=R,R.Void=new R("no result",i=>i);class n{constructor(g,f,s,v,l){this.id=g,this.internalId=f,this.description=s,this.args=v,this.result=l}}e.ApiCommand=n}),define(be[188],Ee([0,1,8,7,61,40,15,81]),function(re,e,u,M,b,P,t,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const C=[new P.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position],new P.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",F(u.DocumentHighlight.to))),new P.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[P.ApiCommandArgument.Uri],new P.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(r,m)=>{if((0,t.isFalsyOrEmpty)(r))return;class a extends M.SymbolInformation{static to(p){const S=new a(p.name,u.SymbolKind.to(p.kind),p.containerName||"",new M.Location(m[0],u.Range.to(p.range)));return S.detail=p.detail,S.range=S.location.range,S.selectionRange=u.Range.to(p.selectionRange),S.children=p.children?p.children.map(a.to):[],S}}return r.map(a.to)})),new P.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[P.ApiCommandArgument.Uri,new P.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new P.ApiCommandResult("A promise that resolves to an array of TextEdits.",F(u.TextEdit.to))),new P.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Range,new P.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new P.ApiCommandResult("A promise that resolves to an array of TextEdits.",F(u.TextEdit.to))),new P.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position,new P.ApiCommandArgument("ch","Trigger character",r=>typeof r=="string",r=>r),new P.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new P.ApiCommandResult("A promise that resolves to an array of TextEdits.",F(u.TextEdit.to))),new P.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position],new P.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",y)),new P.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position],new P.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",y)),new P.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position],new P.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",y)),new P.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position],new P.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",y)),new P.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position],new P.ApiCommandResult("A promise that resolves to an array of Location-instances.",F(u.location.to))),new P.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position],new P.ApiCommandResult("A promise that resolves to an array of Hover-instances.",F(u.Hover.to))),new P.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[P.ApiCommandArgument.Uri,new P.ApiCommandArgument("position","A position in a text document",r=>Array.isArray(r)&&r.every(m=>M.Position.isPosition(m)),r=>r.map(u.Position.from))],new P.ApiCommandResult("A promise that resolves to an array of ranges.",r=>r.map(m=>{let a;for(const h of m.reverse())a=new M.SelectionRange(u.Range.to(h),a);return a}))),new P.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[P.ApiCommandArgument.String.with("query","Search string")],new P.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",r=>{const m=[];if(Array.isArray(r))for(let a of r)m.push(...a[1].map(u.WorkspaceSymbol.to));return m})),new P.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position],new P.ApiCommandResult("A CallHierarchyItem or undefined",r=>r.map(u.CallHierarchyItem.to))),new P.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[P.ApiCommandArgument.CallHierarchyItem],new P.ApiCommandResult("A CallHierarchyItem or undefined",r=>r.map(u.CallHierarchyIncomingCall.to))),new P.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[P.ApiCommandArgument.CallHierarchyItem],new P.ApiCommandResult("A CallHierarchyItem or undefined",r=>r.map(u.CallHierarchyOutgoingCall.to))),new P.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position],new P.ApiCommandResult("A promise that resolves to a range and placeholder text.",r=>{if(!!r)return{range:u.Range.to(r.range),placeholder:r.text}})),new P.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position,P.ApiCommandArgument.String.with("newName","The new symbol name")],new P.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",r=>{if(!!r){if(r.rejectReason)throw new Error(r.rejectReason);return u.WorkspaceEdit.to(r)}})),new P.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new P.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(u.DocumentLink.to))),new P.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[P.ApiCommandArgument.Uri],new P.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",r=>{if(!!r)return new M.SemanticTokensLegend(r.tokenTypes,r.tokenModifiers)})),new P.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[P.ApiCommandArgument.Uri],new P.ApiCommandResult("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const m=(0,A.decodeSemanticTokensDto)(r);if(m.type==="full")return new M.SemanticTokens(m.data,void 0)})),new P.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Range.optional()],new P.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",r=>{if(!!r)return new M.SemanticTokensLegend(r.tokenTypes,r.tokenModifiers)})),new P.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Range],new P.ApiCommandResult("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const m=(0,A.decodeSemanticTokensDto)(r);if(m.type==="full")return new M.SemanticTokens(m.data,void 0)})),new P.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position,P.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),P.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new P.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(r,m,a)=>{if(!r)return new M.CompletionList([]);const h=r.suggestions.map(p=>u.CompletionItem.to(p,a));return new M.CompletionList(h,r.incomplete)})),new P.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position,P.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new P.ApiCommandResult("A promise that resolves to SignatureHelp.",r=>{if(r)return u.SignatureHelp.to(r)})),new P.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new P.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(r,m,a)=>F(h=>new M.CodeLens(u.Range.to(h.range),h.command&&a.fromInternal(h.command)))(r))),new P.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[P.ApiCommandArgument.Uri,new P.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>M.Range.isRange(r),r=>M.Selection.isSelection(r)?u.Selection.from(r):u.Range.from(r)),P.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),P.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new P.ApiCommandResult("A promise that resolves to an array of Command-instances.",(r,m,a)=>F(h=>{if(h._isSynthetic){if(!h.command)throw new Error("Synthetic code actions must have a command");return a.fromInternal(h.command)}else{const p=new M.CodeAction(h.title,h.kind?new M.CodeActionKind(h.kind):void 0);return h.edit&&(p.edit=u.WorkspaceEdit.to(h.edit)),h.command&&(p.command=a.fromInternal(h.command)),p.isPreferred=h.isPreferred,p}})(r))),new P.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[P.ApiCommandArgument.Uri],new P.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(m=>new M.ColorInformation(u.Range.to(m.range),u.Color.to(m.color))):[])),new P.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new P.ApiCommandArgument("color","The color to show and insert",r=>r instanceof M.Color,u.Color.from),new P.ApiCommandArgument("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:u.Range.from(r.range)}))],new P.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(u.ColorPresentation.to):[])),new P.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Range],new P.ApiCommandResult("A promise that resolves to an array of Inlay objects",r=>r.map(u.InlayHint.to))),new P.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new P.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",F(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientCellMetadata:r.options.transientCellMetadata,transientDocumentMetadata:r.options.transientDocumentMetadata},filenamePattern:r.filenamePattern.map(m=>u.NotebookExclusiveDocumentPattern.to(m))})))),new P.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Range],new P.ApiCommandResult("A promise that resolves to an array of InlineValue objects",r=>r.map(u.InlineValue.to))),new P.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[P.ApiCommandArgument.Uri,new P.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[r,void 0]:[u.ViewColumn.from(r.viewColumn),u.TextEditorOpenOptions.from(r)])).optional(),P.ApiCommandArgument.String.with("label","").optional()],P.ApiCommandResult.Void),new P.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[P.ApiCommandArgument.Uri.with("resource","Resource to open"),P.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new P.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[r,void 0]:[u.ViewColumn.from(r.viewColumn),u.TextEditorOpenOptions.from(r)])).optional()],P.ApiCommandResult.Void),new P.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[P.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),P.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),P.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new P.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[u.ViewColumn.from(r.viewColumn),u.TextEditorOpenOptions.from(r)]).optional()],P.ApiCommandResult.Void),new P.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position],new P.ApiCommandResult("A TypeHierarchyItem or undefined",r=>r.map(u.TypeHierarchyItem.to))),new P.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[P.ApiCommandArgument.TypeHierarchyItem],new P.ApiCommandResult("A TypeHierarchyItem or undefined",r=>r.map(u.TypeHierarchyItem.to))),new P.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[P.ApiCommandArgument.TypeHierarchyItem],new P.ApiCommandResult("A TypeHierarchyItem or undefined",r=>r.map(u.TypeHierarchyItem.to))),new P.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[P.ApiCommandArgument.TestItem],P.ApiCommandResult.Void)];class k{static register(m){C.forEach(m.registerApiCommand,m)}}e.ExtHostApiCommands=k;function F(r){return m=>{if(Array.isArray(m))return m.map(r)}}function y(r){if(!Array.isArray(r))return;const m=[];for(const a of r)b.isLocationLink(a)?m.push(u.DefinitionLink.to(a)):m.push(u.location.to(a));return m}}),define(be[189],Ee([0,1,13,55,3,6,2,61,26,8,7,5]),function(re,e,u,M,b,P,t,A,C,k,F,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function r(m,a,h){const p=m.getProxy(y.MainContext.MainThreadComments);class S{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,a.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===6){const g=this._commentControllers.get(i.handle);return g||i}else if(i&&i.$mid===7){const g=this._commentControllers.get(i.commentControlHandle);if(!g)return i;const f=g.getCommentThread(i.commentThreadHandle);return f||i}else if(i&&i.$mid===8){const g=this._commentControllers.get(i.thread.commentControlHandle);if(!g)return i;const f=g.getCommentThread(i.thread.commentThreadHandle);return f?{thread:f,text:i.text}:i}else if(i&&i.$mid===9){const g=this._commentControllers.get(i.thread.commentControlHandle);if(!g)return i;const f=g.getCommentThread(i.thread.commentThreadHandle);if(!f)return i;let s=i.commentUniqueId,v=f.getCommentByUniqueId(s);return v||i}else if(i&&i.$mid===10){const g=this._commentControllers.get(i.thread.commentControlHandle);if(!g)return i;const f=g.getCommentThread(i.thread.commentThreadHandle);if(!f)return i;let s=i.text,v=i.commentUniqueId,l=f.getCommentByUniqueId(v);return l?(l.body=s,l):i}return i}})}createCommentController(i,g,f){const s=S.handlePool++,v=new o(i,s,g,f);this._commentControllers.set(v.handle,v);const l=this._commentControllersByExtension.get(C.ExtensionIdentifier.toKey(i.identifier))||[];return l.push(v),this._commentControllersByExtension.set(C.ExtensionIdentifier.toKey(i.identifier),l),v.value}$createCommentThreadTemplate(i,g,f){const s=this._commentControllers.get(i);!s||s.$createCommentThreadTemplate(g,f)}async $updateCommentThreadTemplate(i,g,f){const s=this._commentControllers.get(i);!s||s.$updateCommentThreadTemplate(g,f)}$deleteCommentThread(i,g){const f=this._commentControllers.get(i);f&&f.$deleteCommentThread(g)}$provideCommentingRanges(i,g,f){const s=this._commentControllers.get(i);if(!s||!s.commentingRangeProvider)return Promise.resolve(void 0);const v=h.getDocument(t.URI.revive(g));return(0,u.asPromise)(()=>s.commentingRangeProvider.provideCommentingRanges(v,f)).then(l=>l?l.map(E=>k.Range.from(E)):void 0)}$toggleReaction(i,g,f,s,v){const l=this._commentControllers.get(i);return!l||!l.reactionHandler?Promise.resolve(void 0):(0,u.asPromise)(()=>{const E=l.getCommentThread(g);if(E){const T=E.getCommentByUniqueId(s.uniqueIdInThread);if(l!==void 0&&T&&l.reactionHandler)return l.reactionHandler(T,c(v))}return Promise.resolve(void 0)})}dispose(){}}S.handlePool=0;class w{constructor(i,g,f,s,v,l,E){this._commentControllerHandle=g,this._id=f,this._uri=s,this._range=v,this._comments=l,this.handle=w._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new b.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new P.MutableDisposable,this._acceptInputDisposables.value=new P.DisposableStore,this._id===void 0&&(this._id=`${i}.${this.handle}`),p.$createCommentThread(g,this.handle,this._id,this._uri,k.Range.from(this._range),E),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=l,this._localDisposables.push({dispose:()=>{p.$deleteCommentThread(g,this.handle)}});const T=this;this.value={get uri(){return T.uri},get range(){return T.range},set range(I){T.range=I},get comments(){return T.comments},set comments(I){T.comments=I},get collapsibleState(){return T.collapsibleState},set collapsibleState(I){T.collapsibleState=I},get canReply(){return T.canReply},set canReply(I){T.canReply=I},get contextValue(){return T.contextValue},set contextValue(I){T.contextValue=I},get label(){return T.label},set label(I){T.label=I},dispose:()=>{T.dispose()}}}set threadId(i){this._id=i}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(i){i.isEqual(this._range)||(this._range=i,this.modifications.range=i,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(i){this._canReply!==i&&(this._canReply=i,this.modifications.canReply=i,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(i){this._label=i,this.modifications.label=i,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(i){this._contextValue=i,this.modifications.contextValue=i,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(i){this._comments=i,this.modifications.comments=i,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(i){this._collapseState=i,this.modifications.collapsibleState=i,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new P.DisposableStore);const i=f=>Object.prototype.hasOwnProperty.call(this.modifications,f),g={};i("range")&&(g.range=k.Range.from(this._range)),i("label")&&(g.label=this.label),i("contextValue")&&(g.contextValue=this.contextValue??null),i("comments")&&(g.comments=this._comments.map(f=>d(this,f,this._commentsMap))),i("collapsibleState")&&(g.collapseState=R(this._collapseState)),i("canReply")&&(g.canReply=this.canReply),this.modifications={},p.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,g)}getCommentByUniqueId(i){for(let g of this._commentsMap){let f=g[0],s=g[1];if(i===s)return f}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(i=>i.dispose())}}w._handlePool=0,Ue([(0,M.debounce)(100)],w.prototype,"eventuallyUpdateCommentThread",null);class o{constructor(i,g,f,s){this._extension=i,this._handle=g,this._id=f,this._label=s,this._threads=new Map,p.$registerCommentController(this.handle,f,s);const v=this;this.value=Object.freeze({id:v.id,label:v.label,get options(){return v.options},set options(l){v.options=l},get commentingRangeProvider(){return v.commentingRangeProvider},set commentingRangeProvider(l){v.commentingRangeProvider=l},get reactionHandler(){return v.reactionHandler},set reactionHandler(l){v.reactionHandler=l},createCommentThread(l,E,T){return v.createCommentThread(l,E,T).value},dispose:()=>{v.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{p.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(i){this._commentingRangeProvider=i,p.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(i){this._reactionHandler=i,p.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!i})}get options(){return this._options}set options(i){this._options=i,p.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(i,g,f,s){if(typeof i=="string"){const v=new w(this.id,this.handle,i,g,f,s,this._extension.identifier);return this._threads.set(v.handle,v),v}else{const v=new w(this.id,this.handle,void 0,i,g,f,this._extension.identifier);return this._threads.set(v.handle,v),v}}$createCommentThreadTemplate(i,g){const f=new w(this.id,this.handle,void 0,t.URI.revive(i),k.Range.to(g),[],this._extension.identifier);return f.collapsibleState=A.CommentThreadCollapsibleState.Expanded,this._threads.set(f.handle,f),f}$updateCommentThreadTemplate(i,g){let f=this._threads.get(i);f&&(f.range=k.Range.to(g))}$deleteCommentThread(i){let g=this._threads.get(i);g&&g.dispose(),this._threads.delete(i)}getCommentThread(i){return this._threads.get(i)}dispose(){this._threads.forEach(i=>{i.dispose()}),this._localDisposables.forEach(i=>i.dispose())}}function d(n,i,g){let f=g.get(i);f||(f=++n.commentHandle,g.set(i,f));const s=i.author&&i.author.iconPath?i.author.iconPath.toString():void 0;return{mode:i.mode,contextValue:i.contextValue,uniqueIdInThread:f,body:k.MarkdownString.from(i.body),userName:i.author.name,userIconPath:s,label:i.label,commentReactions:i.reactions?i.reactions.map(v=>_(v)):void 0}}function _(n){return{label:n.label,iconPath:n.iconPath?k.pathOrURIToURI(n.iconPath):void 0,count:n.count,hasReacted:n.authorHasReacted}}function c(n){return{label:n.label||"",count:n.count||0,iconPath:n.iconPath?t.URI.revive(n.iconPath):"",authorHasReacted:n.hasReacted||!1}}function R(n){if(n!==void 0)switch(n){case F.CommentThreadCollapsibleState.Expanded:return A.CommentThreadCollapsibleState.Expanded;case F.CommentThreadCollapsibleState.Collapsed:return A.CommentThreadCollapsibleState.Collapsed}return A.CommentThreadCollapsibleState.Collapsed}return new S}e.createExtHostComments=r}),define(be[95],Ee([0,1,2,5,7,4,14,12,15,9,17]),function(re,e,u,M,b,P,t,A,C,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let y=class vi{constructor(m,a){this._logService=a,this._provider=new Map,this._proxy=m.getProxy(M.MainContext.MainThreadDecorations)}registerFileDecorationProvider(m,a){const h=vi._handlePool++;this._provider.set(h,{provider:m,extensionId:a}),this._proxy.$registerDecorationProvider(h,a.value);const p=m.onDidChangeFileDecorations&&m.onDidChangeFileDecorations(S=>{if(!S){this._proxy.$onDidChange(h,null);return}let w=(0,C.asArray)(S);if(w.length<=vi._maxEventSize){this._proxy.$onDidChange(h,w);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",a.value,w.length);const o=w.map(c=>({uri:c,rank:(0,k.count)(c.path,"/")})),d=(0,C.groupBy)(o,(c,R)=>c.rank-R.rank||(0,k.compare)(c.uri.path,R.uri.path));let _=[];e:for(let c of d){let R;for(let n of c){let i=(0,F.dirname)(n.uri.path);if(R!==i&&(R=i,_.push(n.uri)>=vi._maxEventSize))break e}}this._proxy.$onDidChange(h,_)});return new b.Disposable(()=>{p?.dispose(),this._proxy.$unregisterDecorationProvider(h),this._provider.delete(h)})}async $provideDecorations(m,a,h){if(!this._provider.has(m))return Object.create(null);const p=Object.create(null),{provider:S,extensionId:w}=this._provider.get(m);return await Promise.all(a.map(async o=>{try{const{uri:d,id:_}=o,c=await Promise.resolve(S.provideFileDecoration(u.URI.revive(d),h));if(!c)return;try{b.FileDecoration.validate(c),p[_]=[c.propagate,c.tooltip,c.badge,c.color]}catch(R){this._logService.warn(`INVALID decoration from extension '${w.value}': ${R}`)}}catch(d){this._logService.error(d)}})),p}};y._handlePool=0,y._maxEventSize=250,y=Ue([Be(0,t.IExtHostRpcService),Be(1,A.ILogService)],y),e.ExtHostDecorations=y,e.IExtHostDecorations=(0,P.createDecorator)("IExtHostDecorations")});var Xe=this&&this.__classPrivateFieldSet||function(re,e,u,M,b){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!b:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?b.call(re,u):b?b.value=u:e.set(re,u),u},Ae=this&&this.__classPrivateFieldGet||function(re,e,u,M){if(u==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?M:u==="a"?M.call(re):M?M.value:e.get(re)};define(be[190],Ee([0,1,125,83,2,5,7,8,3,12,20,31]),function(re,e,u,M,b,P,t,A,C,k,F,y){"use strict";var r,m,a;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class h{constructor(w,o,d,_,c,R){this._name=w,this._owner=o,this._maxDiagnosticsPerFile=d,r.set(this,void 0),m.set(this,void 0),a.set(this,void 0),this._isDisposed=!1,Xe(this,a,new F.ResourceMap(n=>_.getComparisonKey(n)),"f"),Xe(this,r,c,"f"),Xe(this,m,R,"f")}dispose(){this._isDisposed||(Ae(this,m,"f").fire([...Ae(this,a,"f").keys()]),Ae(this,r,"f")&&Ae(this,r,"f").$clear(this._owner),Ae(this,a,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(w,o){if(!w){this.clear();return}this._checkDisposed();let d=[];if(b.URI.isUri(w)){if(!o){this.delete(w);return}Ae(this,a,"f").set(w,o.slice()),d=[w]}else if(Array.isArray(w)){d=[];let c;w=[...w].sort(h._compareIndexedTuplesByUri);for(const R of w){const[n,i]=R;if((!c||n.toString()!==c.toString())&&(c&&Ae(this,a,"f").get(c).length===0&&Ae(this,a,"f").delete(c),c=n,d.push(n),Ae(this,a,"f").set(n,[])),i){const g=Ae(this,a,"f").get(n);g&&g.push(...i)}else{const g=Ae(this,a,"f").get(n);g&&(g.length=0)}}}if(Ae(this,m,"f").fire(d),!Ae(this,r,"f"))return;const _=[];for(let c of d){let R=[];const n=Ae(this,a,"f").get(c);if(n)if(n.length>this._maxDiagnosticsPerFile){R=[];const i=[t.DiagnosticSeverity.Error,t.DiagnosticSeverity.Warning,t.DiagnosticSeverity.Information,t.DiagnosticSeverity.Hint];e:for(let g=0;g<4;g++)for(let f of n)if(f.severity===i[g]&&R.push(A.Diagnostic.from(f))===this._maxDiagnosticsPerFile)break e;R.push({severity:M.MarkerSeverity.Info,message:(0,u.localize)(0,null,n.length-this._maxDiagnosticsPerFile),startLineNumber:R[R.length-1].startLineNumber,startColumn:R[R.length-1].startColumn,endLineNumber:R[R.length-1].endLineNumber,endColumn:R[R.length-1].endColumn})}else R=n.map(i=>A.Diagnostic.from(i));_.push([c,R])}Ae(this,r,"f").$changeMany(this._owner,_)}delete(w){this._checkDisposed(),Ae(this,m,"f").fire([w]),Ae(this,a,"f").delete(w),Ae(this,r,"f")&&Ae(this,r,"f").$changeMany(this._owner,[[w,void 0]])}clear(){this._checkDisposed(),Ae(this,m,"f").fire([...Ae(this,a,"f").keys()]),Ae(this,a,"f").clear(),Ae(this,r,"f")&&Ae(this,r,"f").$clear(this._owner)}forEach(w,o){this._checkDisposed();for(let d of Ae(this,a,"f").keys())w.apply(o,[d,this.get(d),this])}get(w){this._checkDisposed();const o=Ae(this,a,"f").get(w);return Array.isArray(o)?Object.freeze(o.slice(0)):[]}has(w){return this._checkDisposed(),Array.isArray(Ae(this,a,"f").get(w))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(w,o){return w[0].toString()<o[0].toString()?-1:w[0].toString()>o[0].toString()?1:0}}e.DiagnosticCollection=h,r=new WeakMap,m=new WeakMap,a=new WeakMap;let p=class ei{constructor(w,o,d){this._logService=o,this._fileSystemInfoService=d,this._collections=new Map,this._onDidChangeDiagnostics=new C.DebounceEmitter({merge:_=>_.flat(),delay:50}),this.onDidChangeDiagnostics=C.Event.map(this._onDidChangeDiagnostics.event,ei._mapper),this._proxy=w.getProxy(P.MainContext.MainThreadDiagnostics)}static _mapper(w){const o=new F.ResourceMap;for(const d of w)o.set(d,d);return{uris:Object.freeze(Array.from(o.values()))}}createDiagnosticCollection(w,o){const{_collections:d,_proxy:_,_onDidChangeDiagnostics:c,_logService:R,_fileSystemInfoService:n}=this,i=new class{$changeMany(s,v){_.$changeMany(s,v),R.trace("[DiagnosticCollection] change many (extension, owner, uris)",w.value,s,v.length===0?"CLEARING":v)}$clear(s){_.$clear(s),R.trace("[DiagnosticCollection] remove all (extension, owner)",w.value,s)}dispose(){_.dispose()}};let g;if(!o)o="_generated_diagnostic_collection_name_#"+ei._idPool++,g=o;else if(!d.has(o))g=o;else{this._logService.warn(`DiagnosticCollection with name '${o}' does already exist.`);do g=o+ei._idPool++;while(d.has(g))}return new class extends h{constructor(){super(o,g,ei._maxDiagnosticsPerFile,n.extUri,i,c);d.set(g,this)}dispose(){super.dispose(),d.delete(g)}}}getDiagnostics(w){if(w)return this._getDiagnostics(w);{const o=new Map,d=[];for(const _ of this._collections.values())_.forEach((c,R)=>{let n=o.get(c.toString());typeof n=="undefined"&&(n=d.length,o.set(c.toString(),n),d.push([c,[]])),d[n][1]=d[n][1].concat(...R)});return d}}_getDiagnostics(w){let o=[];for(let d of this._collections.values())d.has(w)&&(o=o.concat(d.get(w)));return o}$acceptMarkersChange(w){if(!this._mirrorCollection){const o="_generated_mirror",d=new h(o,o,ei._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(o,d),this._mirrorCollection=d}for(const[o,d]of w)this._mirrorCollection.set(b.URI.revive(o),d.map(A.Diagnostic.to))}};p._idPool=0,p._maxDiagnosticsPerFile=1e3,p=Ue([Be(1,k.ILogService),Be(2,y.IExtHostFileSystemInfo)],p),e.ExtHostDiagnostics=p}),define(be[191],Ee([0,1,2,5]),function(re,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class b{constructor(t){this._proxy=t.getProxy(M.MainContext.MainThreadDialogs)}showOpenDialog(t){return this._proxy.$showOpenDialog(t).then(A=>A?A.map(C=>u.URI.revive(C)):void 0)}showSaveDialog(t){return this._proxy.$showSaveDialog(t).then(A=>A?u.URI.revive(A):void 0)}}e.ExtHostDialogs=b}),define(be[192],Ee([0,1,16,2,7,5,11,21,9]),function(re,e,u,M,b,P,t,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class k{constructor(y,r,m){this._documentsAndEditors=r,this._logService=m,this._documentContentProviders=new Map,this._proxy=y.getProxy(P.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(y,r){if(Object.keys(t.Schemas).indexOf(y)>=0)throw new Error(`scheme '${y}' already registered`);const m=k._handlePool++;this._documentContentProviders.set(m,r),this._proxy.$registerTextContentProvider(m,y);let a;return typeof r.onDidChange=="function"&&(a=r.onDidChange(h=>{if(h.scheme!==y){this._logService.warn(`Provider for scheme '${y}' is firing event for schema '${h.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(h)&&this.$provideTextDocumentContent(m,h).then(p=>{if(!p&&typeof p!="string")return;const S=this._documentsAndEditors.getDocument(h);if(!S)return;const w=(0,C.splitLines)(p);if(!S.equalLines(w))return this._proxy.$onVirtualDocumentChange(h,p)},u.onUnexpectedError)})),new b.Disposable(()=>{this._documentContentProviders.delete(m)&&this._proxy.$unregisterTextContentProvider(m),a&&(a.dispose(),a=void 0)})}$provideTextDocumentContent(y,r){const m=this._documentContentProviders.get(y);return m?Promise.resolve(m.provideTextDocumentContent(M.URI.revive(r),A.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${r.scheme}`))}}e.ExtHostDocumentContentProvider=k,k._handlePool=0}),define(be[193],Ee([0,1,3,6,2,5,88,8,10,23,7]),function(re,e,u,M,b,P,t,A,C,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class y{constructor(m,a){this._onDidAddDocument=new u.Emitter,this._onDidRemoveDocument=new u.Emitter,this._onDidChangeDocument=new u.Emitter,this._onDidSaveDocument=new u.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new M.DisposableStore,this._documentLoader=new Map,this._proxy=m.getProxy(P.MainContext.MainThreadDocuments),this._documentsAndEditors=a,this._documentsAndEditors.onDidRemoveDocuments(h=>{for(const p of h)this._onDidRemoveDocument.fire(p.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(h=>{for(const p of h)this._onDidAddDocument.fire(p.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(m){if(!m)return;const a=this._documentsAndEditors.getDocument(m);if(a)return a}getDocument(m){const a=this.getDocumentData(m);if(!a?.document)throw new Error(`Unable to retrieve document from URI '${m}'`);return a.document}ensureDocumentData(m){const a=this._documentsAndEditors.getDocument(m);if(a)return Promise.resolve(a);let h=this._documentLoader.get(m.toString());return h||(h=this._proxy.$tryOpenDocument(m).then(p=>{this._documentLoader.delete(m.toString());const S=b.URI.revive(p);return(0,C.assertIsDefined)(this._documentsAndEditors.getDocument(S))},p=>(this._documentLoader.delete(m.toString()),Promise.reject(p))),this._documentLoader.set(m.toString(),h)),h}createDocumentData(m){return this._proxy.$tryCreateDocument(m).then(a=>b.URI.revive(a))}$acceptModelModeChanged(m,a){const h=b.URI.revive(m),p=this._documentsAndEditors.getDocument(h);if(!p)throw new Error("unknown document");this._onDidRemoveDocument.fire(p.document),p._acceptLanguageId(a),this._onDidAddDocument.fire(p.document)}$acceptModelSaved(m){const a=b.URI.revive(m),h=this._documentsAndEditors.getDocument(a);if(!h)throw new Error("unknown document");this.$acceptDirtyStateChanged(m,!1),this._onDidSaveDocument.fire(h.document)}$acceptDirtyStateChanged(m,a){const h=b.URI.revive(m),p=this._documentsAndEditors.getDocument(h);if(!p)throw new Error("unknown document");p._acceptIsDirty(a),this._onDidChangeDocument.fire({document:p.document,contentChanges:[],reason:void 0})}$acceptModelChanged(m,a,h){const p=b.URI.revive(m),S=this._documentsAndEditors.getDocument(p);if(!S)throw new Error("unknown document");S._acceptIsDirty(h),S.onEvents(a);let w;a.isUndoing?w=F.TextDocumentChangeReason.Undo:a.isRedoing&&(w=F.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,k.deepFreeze)({document:S.document,contentChanges:a.changes.map(o=>({range:A.Range.to(o.range),rangeOffset:o.rangeOffset,rangeLength:o.rangeLength,text:o.text})),reason:w}))}setWordDefinitionFor(m,a){(0,t.setWordDefinitionFor)(m,a)}}e.ExtHostDocuments=y}),define(be[51],Ee([0,1,43,3,6,2,4,5,88,14,94,8,12,20,11,166,103]),function(re,e,u,M,b,P,t,A,C,k,F,y,r,m,a,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class S{constructor(d){this.value=d,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let w=class{constructor(d,_){this._extHostRpc=d,this._logService=_,this._activeEditorId=null,this._editors=new Map,this._documents=new m.ResourceMap,this._onDidAddDocuments=new M.Emitter,this._onDidRemoveDocuments=new M.Emitter,this._onDidChangeVisibleTextEditors=new M.Emitter,this._onDidChangeActiveTextEditor=new M.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(d){this.acceptDocumentsAndEditorsDelta(d)}acceptDocumentsAndEditorsDelta(d){const _=[],c=[],R=[];if(d.removedDocuments)for(const n of d.removedDocuments){const i=P.URI.revive(n),g=this._documents.get(i);g?.unref()&&(this._documents.delete(i),_.push(g.value))}if(d.addedDocuments)for(const n of d.addedDocuments){const i=P.URI.revive(n.uri);let g=this._documents.get(i);if(g&&i.scheme!==a.Schemas.vscodeNotebookCell&&i.scheme!==a.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);g||(g=new S(new C.ExtHostDocumentData(this._extHostRpc.getProxy(A.MainContext.MainThreadDocuments),i,n.lines,n.EOL,n.versionId,n.languageId,n.isDirty,n.notebook)),this._documents.set(i,g),c.push(g.value)),g.ref()}if(d.removedEditors)for(const n of d.removedEditors){const i=this._editors.get(n);this._editors.delete(n),i&&R.push(i)}if(d.addedEditors)for(const n of d.addedEditors){const i=P.URI.revive(n.documentUri);u.ok(this._documents.has(i),`document '${i}' does not exist`),u.ok(!this._editors.has(n.id),`editor '${n.id}' already exists!`);const g=this._documents.get(i).value,f=new F.ExtHostTextEditor(n.id,this._extHostRpc.getProxy(A.MainContext.MainThreadTextEditors),this._logService,new p.Lazy(()=>g.document),n.selections.map(y.Selection.to),n.options,n.visibleRanges.map(s=>y.Range.to(s)),typeof n.editorPosition=="number"?y.ViewColumn.to(n.editorPosition):void 0);this._editors.set(n.id,f)}d.newActiveEditor!==void 0&&(u.ok(d.newActiveEditor===null||this._editors.has(d.newActiveEditor),`active editor '${d.newActiveEditor}' does not exist`),this._activeEditorId=d.newActiveEditor),(0,b.dispose)(_),(0,b.dispose)(R),d.removedDocuments&&this._onDidRemoveDocuments.fire(_),d.addedDocuments&&this._onDidAddDocuments.fire(c),(d.removedEditors||d.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(n=>n.value)),d.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(d){return this._documents.get(d)?.value}allDocuments(){return h.Iterable.map(this._documents.values(),d=>d.value)}getEditor(d){return this._editors.get(d)}activeEditor(d){if(!this._activeEditorId)return;const _=this._editors.get(this._activeEditorId);return d?_:_?.value}allEditors(){return[...this._editors.values()]}};w=Ue([Be(0,k.IExtHostRpcService),Be(1,r.ILogService)],w),e.ExtHostDocumentsAndEditors=w,e.IExtHostDocumentsAndEditors=(0,t.createDecorator)("IExtHostDocumentsAndEditors")}),define(be[72],Ee([0,1,8,5,2,3,4,14,13]),function(re,e,u,M,b,P,t,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,t.createDecorator)("IExtHostEditorTabs");let k=class{constructor(y){this._onDidChangeTabs=new P.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new P.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[],this._proxy=y.getProxy(M.MainContext.MainThreadEditorTabs)}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(y){let r=-1;this._tabs=y.map((a,h)=>(a.isActive&&(r=h),Object.freeze({label:a.label,viewColumn:u.ViewColumn.to(a.viewColumn),index:h,resource:b.URI.revive(a.resource),additionalResourcesAndViewIds:a.additionalResourcesAndViewIds.map(({resource:p,viewId:S})=>({resource:b.URI.revive(p),viewId:S})),viewId:a.editorId,isActive:a.isActive,move:async(p,S)=>{this._proxy.$moveTab(a,p,u.ViewColumn.from(S)),await(0,C.raceTimeout)(P.Event.toPromise(this._onDidChangeTabs.event),1e3)},close:async()=>{await this._proxy.$closeTab(a),await(0,C.raceTimeout)(P.Event.toPromise(this._onDidChangeTabs.event),1e3)}}))),this._tabs=this._tabs.sort((a,h)=>a.viewColumn===h.viewColumn?a.index-h.index:a.viewColumn-h.viewColumn);const m=this._activeTab;this._activeTab=r===-1?void 0:this._tabs[r],this._activeTab!==m&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}};k=Ue([Be(0,A.IExtHostRpcService)],k),e.ExtHostEditorTabs=k}),define(be[194],Ee([0,1,2,5,6,7,8,236,9,22,27]),function(re,e,u,M,b,P,t,A,C,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class y{constructor(){this._schemes=[]}add(a){this._stateMachine=void 0,this._schemes.push(a)}delete(a){const h=this._schemes.indexOf(a);h>=0&&(this._schemes.splice(h,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const a=this._schemes.sort(),h=[];let p,S,w=14,o=14;for(const d of a){let _=p?(0,C.commonPrefixLength)(p,d):0;for(_===0?S=1:S=o;_<d.length;_++)_+1===d.length?(w=o,o=9):o+=1,h.push([S,d.toUpperCase().charCodeAt(_),o]),h.push([S,d.toLowerCase().charCodeAt(_),o]),S=o;p=d,o=w}h.push([9,58,10]),h.push([10,47,12]),this._stateMachine=new A.StateMachine(h)}}provideDocumentLinks(a){this._initStateMachine();const h=[],p=A.LinkComputer.computeLinks({getLineContent(S){return a.lineAt(S-1).text},getLineCount(){return a.lineCount}},this._stateMachine);for(const S of p){const w=t.DocumentLink.to(S);w.target&&h.push(w)}return h}}class r{constructor(a,h){this._extHostLanguageFeatures=h,this._linkProvider=new y,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=a.getProxy(M.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(a,h,p,S={}){if(this._registeredSchemes.has(h))throw new Error(`a provider for the scheme '${h}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const w=this._handlePool++;this._linkProvider.add(h),this._registeredSchemes.add(h),this._fsProvider.set(w,p);let o=2;S.isCaseSensitive&&(o+=1024),S.isReadonly&&(o+=2048),typeof p.copy=="function"&&(o+=8),typeof p.open=="function"&&typeof p.close=="function"&&typeof p.read=="function"&&typeof p.write=="function"&&((0,F.checkProposedApiEnabled)(a,"fsChunks"),o+=4),this._proxy.$registerFileSystemProvider(w,h,o).catch(_=>{console.error(`FAILED to register filesystem provider of ${a.identifier.value}-extension for the scheme ${h}`),console.error(_)});const d=p.onDidChangeFile(_=>{const c=[];for(const R of _){let{uri:n,type:i}=R;if(n.scheme!==h)continue;let g;switch(i){case P.FileChangeType.Changed:g=0;break;case P.FileChangeType.Created:g=1;break;case P.FileChangeType.Deleted:g=2;break;default:throw new Error("Unknown FileChangeType")}c.push({resource:n,type:g})}this._proxy.$onFileSystemChange(w,c)});return(0,b.toDisposable)(()=>{d.dispose(),this._linkProvider.delete(h),this._registeredSchemes.delete(h),this._fsProvider.delete(w),this._proxy.$unregisterProvider(w)})}static _asIStat(a){const{type:h,ctime:p,mtime:S,size:w,permissions:o}=a;return{type:h,ctime:p,mtime:S,size:w,permissions:o}}$stat(a,h){return Promise.resolve(this._getFsProvider(a).stat(u.URI.revive(h))).then(p=>r._asIStat(p))}$readdir(a,h){return Promise.resolve(this._getFsProvider(a).readDirectory(u.URI.revive(h)))}$readFile(a,h){return Promise.resolve(this._getFsProvider(a).readFile(u.URI.revive(h))).then(p=>k.VSBuffer.wrap(p))}$writeFile(a,h,p,S){return Promise.resolve(this._getFsProvider(a).writeFile(u.URI.revive(h),p.buffer,S))}$delete(a,h,p){return Promise.resolve(this._getFsProvider(a).delete(u.URI.revive(h),p))}$rename(a,h,p,S){return Promise.resolve(this._getFsProvider(a).rename(u.URI.revive(h),u.URI.revive(p),S))}$copy(a,h,p,S){const w=this._getFsProvider(a);if(!w.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(w.copy(u.URI.revive(h),u.URI.revive(p),S))}$mkdir(a,h){return Promise.resolve(this._getFsProvider(a).createDirectory(u.URI.revive(h)))}$watch(a,h,p,S){const w=this._getFsProvider(a).watch(u.URI.revive(p),S);this._watches.set(h,w)}$unwatch(a,h){const p=this._watches.get(h);p&&(p.dispose(),this._watches.delete(h))}$open(a,h,p){const S=this._getFsProvider(a);if(!S.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(S.open(u.URI.revive(h),p))}$close(a,h){const p=this._getFsProvider(a);if(!p.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(p.close(h))}$read(a,h,p,S){const w=this._getFsProvider(a);if(!w.read)throw new Error('FileSystemProvider does not implement "read"');const o=k.VSBuffer.alloc(S);return Promise.resolve(w.read(h,p,o.buffer,0,S)).then(d=>o.slice(0,d))}$write(a,h,p,S){const w=this._getFsProvider(a);if(!w.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(w.write(h,p,S.buffer,0,S.byteLength))}_getFsProvider(a){const h=this._fsProvider.get(a);if(!h){const p=new Error;throw p.name="ENOPRO",p.message="no provider",p}return h}}e.ExtHostFileSystem=r}),define(be[52],Ee([0,1,5,47,7,22,4,14,31]),function(re,e,u,M,b,P,t,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let k=class Ut{constructor(y,r){const m=y.getProxy(u.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(a){return m.$stat(a).catch(Ut._handleError)},readDirectory(a){return m.$readdir(a).catch(Ut._handleError)},createDirectory(a){return m.$mkdir(a).catch(Ut._handleError)},async readFile(a){return m.$readFile(a).then(h=>h.buffer).catch(Ut._handleError)},writeFile(a,h){return m.$writeFile(a,P.VSBuffer.wrap(h)).catch(Ut._handleError)},delete(a,h){return m.$delete(a,{recursive:!1,useTrash:!1,...h}).catch(Ut._handleError)},rename(a,h,p){return m.$rename(a,h,{overwrite:!1,...p}).catch(Ut._handleError)},copy(a,h,p){return m.$copy(a,h,{overwrite:!1,...p}).catch(Ut._handleError)},isWritableFileSystem(a){const h=r.getCapabilities(a);if(typeof h=="number")return!(h&2048)}})}static _handleError(y){if(!(y instanceof Error))throw new b.FileSystemError(String(y));if(y.name==="ENOPRO")throw b.FileSystemError.Unavailable(y.message);switch(y.name){case M.FileSystemProviderErrorCode.FileExists:throw b.FileSystemError.FileExists(y.message);case M.FileSystemProviderErrorCode.FileNotFound:throw b.FileSystemError.FileNotFound(y.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw b.FileSystemError.FileNotADirectory(y.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw b.FileSystemError.FileIsADirectory(y.message);case M.FileSystemProviderErrorCode.NoPermissions:throw b.FileSystemError.NoPermissions(y.message);case M.FileSystemProviderErrorCode.Unavailable:throw b.FileSystemError.Unavailable(y.message);default:throw new b.FileSystemError(y.message,y.name)}}};k=Ue([Be(0,A.IExtHostRpcService),Be(1,C.IExtHostFileSystemInfo)],k),e.ExtHostConsumerFileSystem=k,e.IExtHostConsumerFileSystem=(0,t.createDecorator)("IExtHostConsumerFileSystem")}),define(be[195],Ee([0,1,2,40]),function(re,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class b{constructor(t,A,C,k){this._extHostNotebooks=A,this._textDocumentsAndEditors=C,this._commands=k;const F=new M.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new M.ApiCommandArgument("showOptions","Show Options",y=>!0,y=>y),new M.ApiCommandArgument("resource","Interactive resource Uri",y=>!0,y=>y),new M.ApiCommandArgument("controllerId","Notebook controller Id",y=>!0,y=>y),new M.ApiCommandArgument("title","Interactive editor title",y=>!0,y=>y)],new M.ApiCommandResult("Notebook and input URI",y=>{if(y.notebookEditorId!==void 0){const r=this._extHostNotebooks.getEditorById(y.notebookEditorId);return{notebookUri:u.URI.revive(y.notebookUri),inputUri:u.URI.revive(y.inputUri),notebookEditor:r.apiEditor}}return{notebookUri:u.URI.revive(y.notebookUri),inputUri:u.URI.revive(y.inputUri)}}));this._commands.registerApiCommand(F)}$willAddInteractiveDocument(t,A,C,k){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:A,lines:[""],languageId:C,uri:t,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(u.URI.revive(k))?.apiNotebook}]})}$willRemoveInteractiveDocument(t,A){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[t]})}}e.ExtHostInteractive=b}),define(be[196],Ee([0,1,6,5]),function(re,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class b{constructor(t){this._handlePool=0,this._proxy=t.getProxy(M.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(t){const A=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(A,t),(0,u.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(A)})}}e.ExtHostLabelService=b}),define(be[197],Ee([0,1,2,23,8,7,5,9,45,15,10,237,6,81,56,65,198,16,3]),function(re,e,u,M,b,P,t,A,C,k,F,y,r,m,a,h,p,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class o{constructor(W,K){this._documents=W,this._provider=K}async provideDocumentSymbols(W,K){const X=this._documents.getDocument(W),oe=await this._provider.provideDocumentSymbols(X,K);if(!(0,k.isFalsyOrEmpty)(oe))return oe[0]instanceof P.DocumentSymbol?oe.map(b.DocumentSymbol.from):o._asDocumentSymbolTree(oe)}static _asDocumentSymbolTree(W){W=W.slice(0).sort((oe,G)=>{let ie=oe.location.range.start.compareTo(G.location.range.start);return ie===0&&(ie=G.location.range.end.compareTo(oe.location.range.end)),ie});const K=[],X=[];for(const oe of W){const G={name:oe.name||"!!MISSING: name!!",kind:b.SymbolKind.from(oe.kind),tags:oe.tags?.map(b.SymbolTag.from)||[],detail:"",containerName:oe.containerName,range:b.Range.from(oe.location.range),selectionRange:b.Range.from(oe.location.range),children:[]};for(;;){if(X.length===0){X.push(G),K.push(G);break}const ie=X[X.length-1];if(C.Range.containsRange(ie.range,G.range)&&!C.Range.equalsRange(ie.range,G.range)){ie.children&&ie.children.push(G),X.push(G);break}X.pop()}}return K}}class d{constructor(W,K,X){this._documents=W,this._commands=K,this._provider=X,this._cache=new h.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(W,K){const X=this._documents.getDocument(W),oe=await this._provider.provideCodeLenses(X,K);if(!oe||K.isCancellationRequested)return;const G=this._cache.add(oe),ie=new r.DisposableStore;this._disposables.set(G,ie);const de={cacheId:G,lenses:[]};for(let Te=0;Te<oe.length;Te++)de.lenses.push({cacheId:[G,Te],range:b.Range.from(oe[Te].range),command:this._commands.toInternal(oe[Te].command,ie)});return de}async resolveCodeLens(W,K){const X=W.cacheId&&this._cache.get(...W.cacheId);if(!X)return;let oe;if(typeof this._provider.resolveCodeLens!="function"||X.isResolved?oe=X:oe=await this._provider.resolveCodeLens(X,K),oe||(oe=X),K.isCancellationRequested)return;const G=W.cacheId&&this._disposables.get(W.cacheId[0]);if(!!G)return W.command=this._commands.toInternal(oe.command??d._badCmd,G),W}releaseCodeLenses(W){this._disposables.get(W)?.dispose(),this._disposables.delete(W),this._cache.delete(W)}}d._badCmd={command:"missing",title:"!!MISSING: command!!"};function _(Qe){return Array.isArray(Qe)?Qe.map(b.DefinitionLink.from):Qe?[b.DefinitionLink.from(Qe)]:[]}class c{constructor(W,K){this._documents=W,this._provider=K}async provideDefinition(W,K,X){const oe=this._documents.getDocument(W),G=b.Position.to(K),ie=await this._provider.provideDefinition(oe,G,X);return _(ie)}}class R{constructor(W,K){this._documents=W,this._provider=K}async provideDeclaration(W,K,X){const oe=this._documents.getDocument(W),G=b.Position.to(K),ie=await this._provider.provideDeclaration(oe,G,X);return _(ie)}}class n{constructor(W,K){this._documents=W,this._provider=K}async provideImplementation(W,K,X){const oe=this._documents.getDocument(W),G=b.Position.to(K),ie=await this._provider.provideImplementation(oe,G,X);return _(ie)}}class i{constructor(W,K){this._documents=W,this._provider=K}async provideTypeDefinition(W,K,X){const oe=this._documents.getDocument(W),G=b.Position.to(K),ie=await this._provider.provideTypeDefinition(oe,G,X);return _(ie)}}class g{constructor(W,K){this._documents=W,this._provider=K}async provideHover(W,K,X){const oe=this._documents.getDocument(W),G=b.Position.to(K),ie=await this._provider.provideHover(oe,G,X);if(!(!ie||(0,k.isFalsyOrEmpty)(ie.contents)))return ie.range||(ie.range=oe.getWordRangeAtPosition(G)),ie.range||(ie.range=new P.Range(G,G)),b.Hover.from(ie)}}class f{constructor(W,K){this._documents=W,this._provider=K}async provideEvaluatableExpression(W,K,X){const oe=this._documents.getDocument(W),G=b.Position.to(K),ie=await this._provider.provideEvaluatableExpression(oe,G,X);if(ie)return b.EvaluatableExpression.from(ie)}}class s{constructor(W,K){this._documents=W,this._provider=K}async provideInlineValues(W,K,X,oe){const G=this._documents.getDocument(W),ie=await this._provider.provideInlineValues(G,b.Range.to(K),b.InlineValueContext.to(X),oe);if(Array.isArray(ie))return ie.map(de=>b.InlineValue.from(de))}}class v{constructor(W,K){this._documents=W,this._provider=K}async provideDocumentHighlights(W,K,X){const oe=this._documents.getDocument(W),G=b.Position.to(K),ie=await this._provider.provideDocumentHighlights(oe,G,X);if(Array.isArray(ie))return ie.map(b.DocumentHighlight.from)}}class l{constructor(W,K){this._documents=W,this._provider=K}async provideLinkedEditingRanges(W,K,X){const oe=this._documents.getDocument(W),G=b.Position.to(K),ie=await this._provider.provideLinkedEditingRanges(oe,G,X);if(ie&&Array.isArray(ie.ranges))return{ranges:(0,k.coalesce)(ie.ranges.map(b.Range.from)),wordPattern:ie.wordPattern}}}class E{constructor(W,K){this._documents=W,this._provider=K}async provideReferences(W,K,X,oe){const G=this._documents.getDocument(W),ie=b.Position.to(K),de=await this._provider.provideReferences(G,ie,X,oe);if(Array.isArray(de))return de.map(b.location.from)}}class T{constructor(W,K,X,oe,G,ie,de){this._documents=W,this._commands=K,this._diagnostics=X,this._provider=oe,this._logService=G,this._extension=ie,this._apiDeprecation=de,this._cache=new h.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(W,K,X,oe){const G=this._documents.getDocument(W),ie=y.Selection.isISelection(K)?b.Selection.to(K):b.Range.to(K),de=[];for(const ot of this._diagnostics.getDiagnostics(W))if(ie.intersection(ot.range)&&de.push(ot)>T._maxCodeActionsPerFile)break;const Te={diagnostics:de,only:X.only?new P.CodeActionKind(X.only):void 0,triggerKind:b.CodeActionTriggerKind.to(X.trigger)},Ne=await this._provider.provideCodeActions(G,ie,Te,oe);if(!(0,k.isNonEmptyArray)(Ne)||oe.isCancellationRequested)return;const ze=this._cache.add(Ne),je=new r.DisposableStore;this._disposables.set(ze,je);const et=[];for(let ot=0;ot<Ne.length;ot++){const ye=Ne[ot];!ye||(T._isCommand(ye)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),et.push({_isSynthetic:!0,title:ye.title,command:this._commands.toInternal(ye,je)})):(Te.only&&(ye.kind?Te.only.contains(ye.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Te.only.value} 'requested but returned code action is of kind '${ye.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Te.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),et.push({cacheId:[ze,ot],title:ye.title,command:ye.command&&this._commands.toInternal(ye.command,je),diagnostics:ye.diagnostics&&ye.diagnostics.map(b.Diagnostic.from),edit:ye.edit&&b.WorkspaceEdit.from(ye.edit),kind:ye.kind&&ye.kind.value,isPreferred:ye.isPreferred,disabled:ye.disabled?.reason})))}return{cacheId:ze,actions:et}}async resolveCodeAction(W,K){const[X,oe]=W,G=this._cache.get(X,oe);if(!G||T._isCommand(G)||!this._provider.resolveCodeAction)return;const ie=await this._provider.resolveCodeAction(G,K)??G;return ie?.edit?b.WorkspaceEdit.from(ie.edit):void 0}releaseCodeActions(W){this._disposables.get(W)?.dispose(),this._disposables.delete(W),this._cache.delete(W)}static _isCommand(W){return typeof W.command=="string"&&typeof W.title=="string"}}T._maxCodeActionsPerFile=1e3;class I{constructor(W,K){this._documents=W,this._provider=K}async provideDocumentFormattingEdits(W,K,X){const oe=this._documents.getDocument(W),G=await this._provider.provideDocumentFormattingEdits(oe,K,X);if(Array.isArray(G))return G.map(b.TextEdit.from)}}class B{constructor(W,K){this._documents=W,this._provider=K}async provideDocumentRangeFormattingEdits(W,K,X,oe){const G=this._documents.getDocument(W),ie=b.Range.to(K),de=await this._provider.provideDocumentRangeFormattingEdits(G,ie,X,oe);if(Array.isArray(de))return de.map(b.TextEdit.from)}}class O{constructor(W,K){this._documents=W,this._provider=K,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(W,K,X,oe,G){const ie=this._documents.getDocument(W),de=b.Position.to(K),Te=await this._provider.provideOnTypeFormattingEdits(ie,de,X,oe,G);if(Array.isArray(Te))return Te.map(b.TextEdit.from)}}class D{constructor(W,K){this._provider=W,this._logService=K,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(W,K){const X=t.IdObject.mixin({symbols:[]}),oe=await this._provider.provideWorkspaceSymbols(W,K);if((0,k.isNonEmptyArray)(oe))for(const G of oe){if(!G)continue;if(!G.name){this._logService.warn("INVALID SymbolInformation, lacks name",G);continue}const ie=t.IdObject.mixin(b.WorkspaceSymbol.from(G));this._symbolCache.set(ie._id,G),X.symbols.push(ie)}return X.symbols.length>0&&this._resultCache.set(X._id,[X.symbols[0]._id,X.symbols[X.symbols.length-1]._id]),X}async resolveWorkspaceSymbol(W,K){if(typeof this._provider.resolveWorkspaceSymbol!="function")return W;const X=this._symbolCache.get(W._id);if(X){const oe=await this._provider.resolveWorkspaceSymbol(X,K);return oe&&(0,M.mixin)(W,b.WorkspaceSymbol.from(oe),!0)}}releaseWorkspaceSymbols(W){const K=this._resultCache.get(W);if(K){for(let[X,oe]=K;X<=oe;X++)this._symbolCache.delete(X);this._resultCache.delete(W)}}}class x{constructor(W,K,X){this._documents=W,this._provider=K,this._logService=X}static supportsResolving(W){return typeof W.prepareRename=="function"}async provideRenameEdits(W,K,X,oe){const G=this._documents.getDocument(W),ie=b.Position.to(K);try{const de=await this._provider.provideRenameEdits(G,ie,X,oe);return de?b.WorkspaceEdit.from(de):void 0}catch(de){const Te=x._asMessage(de);return Te?{rejectReason:Te,edits:void 0}:Promise.reject(de)}}async resolveRenameLocation(W,K,X){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const oe=this._documents.getDocument(W),G=b.Position.to(K);try{const ie=await this._provider.prepareRename(oe,G,X);let de,Te;if(P.Range.isRange(ie)?(de=ie,Te=oe.getText(ie)):(0,F.isObject)(ie)&&(de=ie.range,Te=ie.placeholder),!de||!Te)return;if(de.start.line>G.line||de.end.line<G.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:b.Range.from(de),text:Te}}catch(ie){const de=x._asMessage(ie);return de?{rejectReason:de,range:void 0,text:void 0}:Promise.reject(ie)}}static _asMessage(W){return typeof W=="string"?W:W instanceof Error&&typeof W.message=="string"?W.message:void 0}}class N{constructor(W,K){this.resultId=W,this.tokens=K}}class V{constructor(W,K){this._documents=W,this._provider=K,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(W,K,X){const oe=this._documents.getDocument(W),G=K!==0?this._previousResults.get(K):null;let ie=typeof G?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(oe,G.resultId,X):await this._provider.provideDocumentSemanticTokens(oe,X);return G&&this._previousResults.delete(K),ie?(ie=V._fixProvidedSemanticTokens(ie),this._send(V._convertToEdits(G,ie),ie)):null}async releaseDocumentSemanticColoring(W){this._previousResults.delete(W)}static _fixProvidedSemanticTokens(W){return V._isSemanticTokens(W)?V._isCorrectSemanticTokens(W)?W:new P.SemanticTokens(new Uint32Array(W.data),W.resultId):V._isSemanticTokensEdits(W)?V._isCorrectSemanticTokensEdits(W)?W:new P.SemanticTokensEdits(W.edits.map(K=>new P.SemanticTokensEdit(K.start,K.deleteCount,K.data?new Uint32Array(K.data):K.data)),W.resultId):W}static _isSemanticTokens(W){return W&&!!W.data}static _isCorrectSemanticTokens(W){return W.data instanceof Uint32Array}static _isSemanticTokensEdits(W){return W&&Array.isArray(W.edits)}static _isCorrectSemanticTokensEdits(W){for(const K of W.edits)if(!(K.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(W,K){if(!V._isSemanticTokens(K)||!W||!W.tokens)return K;const X=W.tokens,oe=X.length,G=K.data,ie=G.length;let de=0;const Te=Math.min(oe,ie);for(;de<Te&&X[de]===G[de];)de++;if(de===oe&&de===ie)return new P.SemanticTokensEdits([],K.resultId);let Ne=0;const ze=Te-de;for(;Ne<ze&&X[oe-Ne-1]===G[ie-Ne-1];)Ne++;return new P.SemanticTokensEdits([{start:de,deleteCount:oe-de-Ne,data:G.subarray(de,ie-Ne)}],K.resultId)}_send(W,K){if(V._isSemanticTokens(W)){const X=this._nextResultId++;return this._previousResults.set(X,new N(W.resultId,W.data)),(0,m.encodeSemanticTokensDto)({id:X,type:"full",data:W.data})}if(V._isSemanticTokensEdits(W)){const X=this._nextResultId++;return V._isSemanticTokens(K)?this._previousResults.set(X,new N(K.resultId,K.data)):this._previousResults.set(X,new N(W.resultId)),(0,m.encodeSemanticTokensDto)({id:X,type:"delta",deltas:(W.edits||[]).map(oe=>({start:oe.start,deleteCount:oe.deleteCount,data:oe.data}))})}return null}}e.DocumentSemanticTokensAdapter=V;class ${constructor(W,K){this._documents=W,this._provider=K}async provideDocumentRangeSemanticTokens(W,K,X){const oe=this._documents.getDocument(W),G=await this._provider.provideDocumentRangeSemanticTokens(oe,b.Range.to(K),X);return G?this._send(G):null}_send(W){return(0,m.encodeSemanticTokensDto)({id:0,type:"full",data:W.data})}}e.DocumentRangeSemanticTokensAdapter=$;class z{constructor(W,K,X,oe,G){this._documents=W,this._commands=K,this._provider=X,this._apiDeprecation=oe,this._extension=G,this._cache=new h.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(W){return typeof W.resolveCompletionItem=="function"}async provideCompletionItems(W,K,X,oe){const G=this._documents.getDocument(W),ie=b.Position.to(K),de=G.getWordRangeAtPosition(ie)||new P.Range(ie,ie),Te=de.with({end:ie}),Ne=new p.StopWatch(!0),ze=await this._provider.provideCompletionItems(G,ie,oe,b.CompletionContext.to(X));if(!ze||oe.isCancellationRequested)return;const je=Array.isArray(ze)?new P.CompletionList(ze):ze,et=z.supportsResolving(this._provider)?this._cache.add(je.items):this._cache.add([]),ot=new r.DisposableStore;this._disposables.set(et,ot);const ye=[],nt={x:et,b:ye,a:{replace:b.Range.from(de),insert:b.Range.from(Te)},c:je.isIncomplete||void 0,d:Ne.elapsed()};for(let q=0;q<je.items.length;q++){const J=je.items[q],pe=this._convertCompletionItem(J,[et,q],Te,de);ye.push(pe)}return nt}async resolveCompletionItem(W,K){if(typeof this._provider.resolveCompletionItem!="function")return;const X=this._cache.get(...W);if(!X)return;const oe=await this._provider.resolveCompletionItem(X,K);if(!!oe)return this._convertCompletionItem(oe,W)}releaseCompletionItems(W){this._disposables.get(W)?.dispose(),this._disposables.delete(W),this._cache.delete(W)}_convertCompletionItem(W,K,X,oe){const G=this._disposables.get(K[0]);if(!G)throw Error("DisposableStore is missing...");const ie={x:K,a:W.label,b:W.kind!==void 0?b.CompletionItemKind.from(W.kind):void 0,n:W.tags&&W.tags.map(b.CompletionItemTag.from),c:W.detail,d:typeof W.documentation=="undefined"?void 0:b.MarkdownString.fromStrict(W.documentation),e:W.sortText!==W.label?W.sortText:void 0,f:W.filterText!==W.label?W.filterText:void 0,g:W.preselect||void 0,i:W.keepWhitespace?1:0,k:W.commitCharacters,l:W.additionalTextEdits&&W.additionalTextEdits.map(b.TextEdit.from),m:this._commands.toInternal(W.command,G)};W.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ie.h=W.textEdit.newText):typeof W.insertText=="string"?ie.h=W.insertText:W.insertText instanceof P.SnippetString&&(ie.h=W.insertText.value,ie.i|=4);let de;return W.textEdit?de=W.textEdit.range:W.range&&(de=W.range),P.Range.isRange(de)?ie.j=b.Range.from(de):de&&(!X?.isEqual(de.inserting)||!oe?.isEqual(de.replacing))&&(ie.j={insert:b.Range.from(de.inserting),replace:b.Range.from(de.replacing)}),ie}}class ee{constructor(W,K,X){this._documents=W,this._provider=K,this._commands=X,this._cache=new h.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(W,K,X,oe){const G=this._documents.getDocument(W),ie=b.Position.to(K),de=await this._provider.provideInlineCompletionItems(G,ie,{selectedCompletionInfo:X.selectedSuggestionInfo?{range:b.Range.to(X.selectedSuggestionInfo.range),text:X.selectedSuggestionInfo.text}:void 0,triggerKind:X.triggerKind},oe);if(!de||oe.isCancellationRequested)return;const Te=(0,F.isArray)(de)?{items:de}:de,Ne=this._cache.add(Te.items);let ze;return{pid:Ne,items:Te.items.map((je,et)=>{let ot;return je.command&&(ze||(ze=new r.DisposableStore,this._disposables.set(Ne,ze)),ot=this._commands.toInternal(je.command,ze)),{text:je.text,range:je.range?b.Range.from(je.range):void 0,command:ot,idx:et}})}}disposeCompletions(W){this._cache.delete(W);const K=this._disposables.get(W);K&&K.clear(),this._disposables.delete(W)}handleDidShowCompletionItem(W,K){const X=this._cache.get(W,K);X&&j.get(this._provider).fireOnDidShowCompletionItem({completionItem:X})}}class j{constructor(){this._onDidShowCompletionItemEmitter=new w.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(W){let K=j.map.get(W);return K||(K=new j,j.map.set(W,K)),K}fireOnDidShowCompletionItem(W){this._onDidShowCompletionItemEmitter.fire(W)}}e.InlineCompletionController=j,j.map=new WeakMap;class Q{constructor(W,K){this._documents=W,this._provider=K,this._cache=new h.Cache("SignatureHelp")}async provideSignatureHelp(W,K,X,oe){const G=this._documents.getDocument(W),ie=b.Position.to(K),de=this.reviveContext(X),Te=await this._provider.provideSignatureHelp(G,ie,oe,de);if(Te){const Ne=this._cache.add([Te]);return{...b.SignatureHelp.from(Te),id:Ne}}}reviveContext(W){let K;if(W.activeSignatureHelp){const X=b.SignatureHelp.to(W.activeSignatureHelp),oe=this._cache.get(W.activeSignatureHelp.id,0);oe?(K=oe,K.activeSignature=X.activeSignature,K.activeParameter=X.activeParameter):K=X}return{...W,activeSignatureHelp:K}}releaseSignatureHelp(W){this._cache.delete(W)}}class le{constructor(W,K){this._documents=W,this._provider=K}async provideInlayHints(W,K,X){const oe=this._documents.getDocument(W),G=await this._provider.provideInlayHints(oe,b.Range.to(K),X);return G?{hints:G.map(b.InlayHint.from)}:void 0}}class ve{constructor(W,K){this._documents=W,this._provider=K,this._cache=new h.Cache("DocumentLink")}async provideLinks(W,K){const X=this._documents.getDocument(W),oe=await this._provider.provideDocumentLinks(X,K);if(!(!Array.isArray(oe)||oe.length===0)&&!K.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:oe.filter(ve._validateLink).map(b.DocumentLink.from)};{const G=this._cache.add(oe),ie={links:[],id:G};for(let de=0;de<oe.length;de++){if(!ve._validateLink(oe[de]))continue;const Te=b.DocumentLink.from(oe[de]);Te.cacheId=[G,de],ie.links.push(Te)}return ie}}}static _validateLink(W){return W.target&&W.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(W,K){if(typeof this._provider.resolveDocumentLink!="function")return;const X=this._cache.get(...W);if(!X)return;const oe=await this._provider.resolveDocumentLink(X,K);if(!(!oe||!ve._validateLink(oe)))return b.DocumentLink.from(oe)}releaseLinks(W){this._cache.delete(W)}}class ue{constructor(W,K){this._documents=W,this._provider=K}async provideColors(W,K){const X=this._documents.getDocument(W),oe=await this._provider.provideDocumentColors(X,K);return Array.isArray(oe)?oe.map(ie=>({color:b.Color.from(ie.color),range:b.Range.from(ie.range)})):[]}async provideColorPresentations(W,K,X){const oe=this._documents.getDocument(W),G=b.Range.to(K.range),ie=b.Color.to(K.color),de=await this._provider.provideColorPresentations(ie,{document:oe,range:G},X);if(!!Array.isArray(de))return de.map(b.ColorPresentation.from)}}class Fe{constructor(W,K){this._documents=W,this._provider=K}async provideFoldingRanges(W,K,X){const oe=this._documents.getDocument(W),G=await this._provider.provideFoldingRanges(oe,K,X);if(!!Array.isArray(G))return G.map(b.FoldingRange.from)}}class Ke{constructor(W,K,X){this._documents=W,this._provider=K,this._logService=X}async provideSelectionRanges(W,K,X){const oe=this._documents.getDocument(W),G=K.map(b.Position.to),ie=await this._provider.provideSelectionRanges(oe,G,X);if(!(0,k.isNonEmptyArray)(ie))return[];if(ie.length!==G.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const de=[];for(let Te=0;Te<G.length;Te++){const Ne=[];de.push(Ne);let ze=G[Te],je=ie[Te];for(;;){if(!je.range.contains(ze))throw new Error("INVALID selection range, must contain the previous range");if(Ne.push(b.SelectionRange.from(je)),!je.parent)break;ze=je.range,je=je.parent}}return de}}class Oe{constructor(W,K){this._documents=W,this._provider=K,this._idPool=new a.IdGenerator(""),this._cache=new Map}async prepareSession(W,K,X){const oe=this._documents.getDocument(W),G=b.Position.to(K),ie=await this._provider.prepareCallHierarchy(oe,G,X);if(!ie)return;const de=this._idPool.nextId();return this._cache.set(de,new Map),Array.isArray(ie)?ie.map(Te=>this._cacheAndConvertItem(de,Te)):[this._cacheAndConvertItem(de,ie)]}async provideCallsTo(W,K,X){const oe=this._itemFromCache(W,K);if(!oe)throw new Error("missing call hierarchy item");const G=await this._provider.provideCallHierarchyIncomingCalls(oe,X);if(!!G)return G.map(ie=>({from:this._cacheAndConvertItem(W,ie.from),fromRanges:ie.fromRanges.map(de=>b.Range.from(de))}))}async provideCallsFrom(W,K,X){const oe=this._itemFromCache(W,K);if(!oe)throw new Error("missing call hierarchy item");const G=await this._provider.provideCallHierarchyOutgoingCalls(oe,X);if(!!G)return G.map(ie=>({to:this._cacheAndConvertItem(W,ie.to),fromRanges:ie.fromRanges.map(de=>b.Range.from(de))}))}releaseSession(W){this._cache.delete(W)}_cacheAndConvertItem(W,K){const X=this._cache.get(W),oe=b.CallHierarchyItem.from(K,W,X.size.toString(36));return X.set(oe._itemId,K),oe}_itemFromCache(W,K){return this._cache.get(W)?.get(K)}}class He{constructor(W,K){this._documents=W,this._provider=K,this._idPool=new a.IdGenerator(""),this._cache=new Map}async prepareSession(W,K,X){const oe=this._documents.getDocument(W),G=b.Position.to(K),ie=await this._provider.prepareTypeHierarchy(oe,G,X);if(!ie)return;const de=this._idPool.nextId();return this._cache.set(de,new Map),Array.isArray(ie)?ie.map(Te=>this._cacheAndConvertItem(de,Te)):[this._cacheAndConvertItem(de,ie)]}async provideSupertypes(W,K,X){const oe=this._itemFromCache(W,K);if(!oe)throw new Error("missing type hierarchy item");const G=await this._provider.provideTypeHierarchySupertypes(oe,X);if(!!G)return G.map(ie=>this._cacheAndConvertItem(W,ie))}async provideSubtypes(W,K,X){const oe=this._itemFromCache(W,K);if(!oe)throw new Error("missing type hierarchy item");const G=await this._provider.provideTypeHierarchySubtypes(oe,X);if(!!G)return G.map(ie=>this._cacheAndConvertItem(W,ie))}releaseSession(W){this._cache.delete(W)}_cacheAndConvertItem(W,K){const X=this._cache.get(W),oe=b.TypeHierarchyItem.from(K,W,X.size.toString(36));return X.set(oe._itemId,K),oe}_itemFromCache(W,K){return this._cache.get(W)?.get(K)}}class Je{constructor(W,K){this.adapter=W,this.extension=K}}class Ye{constructor(W,K,X,oe,G,ie,de){this._adapter=new Map,this._uriTransformer=K,this._proxy=W.getProxy(t.MainContext.MainThreadLanguageFeatures),this._documents=X,this._commands=oe,this._diagnostics=G,this._logService=ie,this._apiDeprecation=de}_transformDocumentSelector(W){return b.DocumentSelector.from(W,this._uriTransformer)}_createDisposable(W){return new P.Disposable(()=>{this._adapter.delete(W),this._proxy.$unregister(W)})}_nextHandle(){return Ye._handlePool++}_withAdapter(W,K,X,oe,G=!1){const ie=this._adapter.get(W);if(!ie)return Promise.resolve(oe);if(ie.adapter instanceof K){let de;ie.extension&&(de=Date.now(),this._logService.trace(`[${ie.extension.identifier.value}] INVOKE provider '${K.name}'`));const Te=X(ie.adapter,ie.extension),Ne=ie.extension;return Ne&&Promise.resolve(Te).then(()=>this._logService.trace(`[${Ne.identifier.value}] provider DONE after ${Date.now()-de}ms`),ze=>{G&&ze instanceof S.CancellationError||(this._logService.error(`[${Ne.identifier.value}] provider FAILED`),this._logService.error(ze))}),Te}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(W,K){const X=this._nextHandle();return this._adapter.set(X,new Je(W,K)),X}static _extLabel(W){return W.displayName||W.name}registerDocumentSymbolProvider(W,K,X,oe){const G=this._addNewAdapter(new o(this._documents,X),W),ie=oe&&oe.label||Ye._extLabel(W);return this._proxy.$registerDocumentSymbolProvider(G,this._transformDocumentSelector(K),ie),this._createDisposable(G)}$provideDocumentSymbols(W,K,X){return this._withAdapter(W,o,oe=>oe.provideDocumentSymbols(u.URI.revive(K),X),void 0)}registerCodeLensProvider(W,K,X){const oe=this._nextHandle(),G=typeof X.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(oe,new Je(new d(this._documents,this._commands.converter,X),W)),this._proxy.$registerCodeLensSupport(oe,this._transformDocumentSelector(K),G);let ie=this._createDisposable(oe);if(G!==void 0){const de=X.onDidChangeCodeLenses(Te=>this._proxy.$emitCodeLensEvent(G));ie=P.Disposable.from(ie,de)}return ie}$provideCodeLenses(W,K,X){return this._withAdapter(W,d,oe=>oe.provideCodeLenses(u.URI.revive(K),X),void 0)}$resolveCodeLens(W,K,X){return this._withAdapter(W,d,oe=>oe.resolveCodeLens(K,X),void 0)}$releaseCodeLenses(W,K){this._withAdapter(W,d,X=>Promise.resolve(X.releaseCodeLenses(K)),void 0)}registerDefinitionProvider(W,K,X){const oe=this._addNewAdapter(new c(this._documents,X),W);return this._proxy.$registerDefinitionSupport(oe,this._transformDocumentSelector(K)),this._createDisposable(oe)}$provideDefinition(W,K,X,oe){return this._withAdapter(W,c,G=>G.provideDefinition(u.URI.revive(K),X,oe),[])}registerDeclarationProvider(W,K,X){const oe=this._addNewAdapter(new R(this._documents,X),W);return this._proxy.$registerDeclarationSupport(oe,this._transformDocumentSelector(K)),this._createDisposable(oe)}$provideDeclaration(W,K,X,oe){return this._withAdapter(W,R,G=>G.provideDeclaration(u.URI.revive(K),X,oe),[])}registerImplementationProvider(W,K,X){const oe=this._addNewAdapter(new n(this._documents,X),W);return this._proxy.$registerImplementationSupport(oe,this._transformDocumentSelector(K)),this._createDisposable(oe)}$provideImplementation(W,K,X,oe){return this._withAdapter(W,n,G=>G.provideImplementation(u.URI.revive(K),X,oe),[])}registerTypeDefinitionProvider(W,K,X){const oe=this._addNewAdapter(new i(this._documents,X),W);return this._proxy.$registerTypeDefinitionSupport(oe,this._transformDocumentSelector(K)),this._createDisposable(oe)}$provideTypeDefinition(W,K,X,oe){return this._withAdapter(W,i,G=>G.provideTypeDefinition(u.URI.revive(K),X,oe),[])}registerHoverProvider(W,K,X,oe){const G=this._addNewAdapter(new g(this._documents,X),W);return this._proxy.$registerHoverProvider(G,this._transformDocumentSelector(K)),this._createDisposable(G)}$provideHover(W,K,X,oe){return this._withAdapter(W,g,G=>G.provideHover(u.URI.revive(K),X,oe),void 0)}registerEvaluatableExpressionProvider(W,K,X,oe){const G=this._addNewAdapter(new f(this._documents,X),W);return this._proxy.$registerEvaluatableExpressionProvider(G,this._transformDocumentSelector(K)),this._createDisposable(G)}$provideEvaluatableExpression(W,K,X,oe){return this._withAdapter(W,f,G=>G.provideEvaluatableExpression(u.URI.revive(K),X,oe),void 0)}registerInlineValuesProvider(W,K,X,oe){const G=typeof X.onDidChangeInlineValues=="function"?this._nextHandle():void 0,ie=this._addNewAdapter(new s(this._documents,X),W);this._proxy.$registerInlineValuesProvider(ie,this._transformDocumentSelector(K),G);let de=this._createDisposable(ie);if(G!==void 0){const Te=X.onDidChangeInlineValues(Ne=>this._proxy.$emitInlineValuesEvent(G));de=P.Disposable.from(de,Te)}return de}$provideInlineValues(W,K,X,oe,G){return this._withAdapter(W,s,ie=>ie.provideInlineValues(u.URI.revive(K),X,oe,G),void 0)}registerDocumentHighlightProvider(W,K,X){const oe=this._addNewAdapter(new v(this._documents,X),W);return this._proxy.$registerDocumentHighlightProvider(oe,this._transformDocumentSelector(K)),this._createDisposable(oe)}$provideDocumentHighlights(W,K,X,oe){return this._withAdapter(W,v,G=>G.provideDocumentHighlights(u.URI.revive(K),X,oe),void 0)}registerLinkedEditingRangeProvider(W,K,X){const oe=this._addNewAdapter(new l(this._documents,X),W);return this._proxy.$registerLinkedEditingRangeProvider(oe,this._transformDocumentSelector(K)),this._createDisposable(oe)}$provideLinkedEditingRanges(W,K,X,oe){return this._withAdapter(W,l,async G=>{const ie=await G.provideLinkedEditingRanges(u.URI.revive(K),X,oe);if(ie)return{ranges:ie.ranges,wordPattern:ie.wordPattern?Ye._serializeRegExp(ie.wordPattern):void 0}},void 0)}registerReferenceProvider(W,K,X){const oe=this._addNewAdapter(new E(this._documents,X),W);return this._proxy.$registerReferenceSupport(oe,this._transformDocumentSelector(K)),this._createDisposable(oe)}$provideReferences(W,K,X,oe,G){return this._withAdapter(W,E,ie=>ie.provideReferences(u.URI.revive(K),X,oe,G),void 0)}registerCodeActionProvider(W,K,X,oe){const G=new r.DisposableStore,ie=this._addNewAdapter(new T(this._documents,this._commands.converter,this._diagnostics,X,this._logService,W,this._apiDeprecation),W);return this._proxy.$registerQuickFixSupport(ie,this._transformDocumentSelector(K),{providedKinds:oe?.providedCodeActionKinds?.map(de=>de.value),documentation:oe?.documentation?.map(de=>({kind:de.kind.value,command:this._commands.converter.toInternal(de.command,G)}))},Ye._extLabel(W),Boolean(X.resolveCodeAction)),G.add(this._createDisposable(ie)),G}$provideCodeActions(W,K,X,oe,G){return this._withAdapter(W,T,ie=>ie.provideCodeActions(u.URI.revive(K),X,oe,G),void 0)}$resolveCodeAction(W,K,X){return this._withAdapter(W,T,oe=>oe.resolveCodeAction(K,X),void 0)}$releaseCodeActions(W,K){this._withAdapter(W,T,X=>Promise.resolve(X.releaseCodeActions(K)),void 0)}registerDocumentFormattingEditProvider(W,K,X){const oe=this._addNewAdapter(new I(this._documents,X),W);return this._proxy.$registerDocumentFormattingSupport(oe,this._transformDocumentSelector(K),W.identifier,W.displayName||W.name),this._createDisposable(oe)}$provideDocumentFormattingEdits(W,K,X,oe){return this._withAdapter(W,I,G=>G.provideDocumentFormattingEdits(u.URI.revive(K),X,oe),void 0)}registerDocumentRangeFormattingEditProvider(W,K,X){const oe=this._addNewAdapter(new B(this._documents,X),W);return this._proxy.$registerRangeFormattingSupport(oe,this._transformDocumentSelector(K),W.identifier,W.displayName||W.name),this._createDisposable(oe)}$provideDocumentRangeFormattingEdits(W,K,X,oe,G){return this._withAdapter(W,B,ie=>ie.provideDocumentRangeFormattingEdits(u.URI.revive(K),X,oe,G),void 0)}registerOnTypeFormattingEditProvider(W,K,X,oe){const G=this._addNewAdapter(new O(this._documents,X),W);return this._proxy.$registerOnTypeFormattingSupport(G,this._transformDocumentSelector(K),oe,W.identifier),this._createDisposable(G)}$provideOnTypeFormattingEdits(W,K,X,oe,G,ie){return this._withAdapter(W,O,de=>de.provideOnTypeFormattingEdits(u.URI.revive(K),X,oe,G,ie),void 0)}registerWorkspaceSymbolProvider(W,K){const X=this._addNewAdapter(new D(K,this._logService),W);return this._proxy.$registerNavigateTypeSupport(X),this._createDisposable(X)}$provideWorkspaceSymbols(W,K,X){return this._withAdapter(W,D,oe=>oe.provideWorkspaceSymbols(K,X),{symbols:[]})}$resolveWorkspaceSymbol(W,K,X){return this._withAdapter(W,D,oe=>oe.resolveWorkspaceSymbol(K,X),void 0)}$releaseWorkspaceSymbols(W,K){this._withAdapter(W,D,X=>X.releaseWorkspaceSymbols(K),void 0)}registerRenameProvider(W,K,X){const oe=this._addNewAdapter(new x(this._documents,X,this._logService),W);return this._proxy.$registerRenameSupport(oe,this._transformDocumentSelector(K),x.supportsResolving(X)),this._createDisposable(oe)}$provideRenameEdits(W,K,X,oe,G){return this._withAdapter(W,x,ie=>ie.provideRenameEdits(u.URI.revive(K),X,oe,G),void 0)}$resolveRenameLocation(W,K,X,oe){return this._withAdapter(W,x,G=>G.resolveRenameLocation(u.URI.revive(K),X,oe),void 0)}registerDocumentSemanticTokensProvider(W,K,X,oe){const G=this._nextHandle(),ie=typeof X.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(G,new Je(new V(this._documents,X),W)),this._proxy.$registerDocumentSemanticTokensProvider(G,this._transformDocumentSelector(K),oe,ie);let de=this._createDisposable(G);if(ie){const Te=X.onDidChangeSemanticTokens(Ne=>this._proxy.$emitDocumentSemanticTokensEvent(ie));de=P.Disposable.from(de,Te)}return de}$provideDocumentSemanticTokens(W,K,X,oe){return this._withAdapter(W,V,G=>G.provideDocumentSemanticTokens(u.URI.revive(K),X,oe),null,!0)}$releaseDocumentSemanticTokens(W,K){this._withAdapter(W,V,X=>X.releaseDocumentSemanticColoring(K),void 0)}registerDocumentRangeSemanticTokensProvider(W,K,X,oe){const G=this._addNewAdapter(new $(this._documents,X),W);return this._proxy.$registerDocumentRangeSemanticTokensProvider(G,this._transformDocumentSelector(K),oe),this._createDisposable(G)}$provideDocumentRangeSemanticTokens(W,K,X,oe){return this._withAdapter(W,$,G=>G.provideDocumentRangeSemanticTokens(u.URI.revive(K),X,oe),null,!0)}registerCompletionItemProvider(W,K,X,oe){const G=this._addNewAdapter(new z(this._documents,this._commands.converter,X,this._apiDeprecation,W),W);return this._proxy.$registerSuggestSupport(G,this._transformDocumentSelector(K),oe,z.supportsResolving(X),`${W.identifier.value}(${oe.join("")})`),this._createDisposable(G)}$provideCompletionItems(W,K,X,oe,G){return this._withAdapter(W,z,ie=>ie.provideCompletionItems(u.URI.revive(K),X,oe,G),void 0)}$resolveCompletionItem(W,K,X){return this._withAdapter(W,z,oe=>oe.resolveCompletionItem(K,X),void 0)}$releaseCompletionItems(W,K){this._withAdapter(W,z,X=>X.releaseCompletionItems(K),void 0)}registerInlineCompletionsProvider(W,K,X){const oe=this._addNewAdapter(new ee(this._documents,X,this._commands.converter),W);return this._proxy.$registerInlineCompletionsSupport(oe,this._transformDocumentSelector(K)),this._createDisposable(oe)}$provideInlineCompletions(W,K,X,oe,G){return this._withAdapter(W,ee,ie=>ie.provideInlineCompletions(u.URI.revive(K),X,oe,G),void 0)}$handleInlineCompletionDidShow(W,K,X){this._withAdapter(W,ee,async oe=>{oe.handleDidShowCompletionItem(K,X)},void 0)}$freeInlineCompletionsList(W,K){this._withAdapter(W,ee,async X=>{X.disposeCompletions(K)},void 0)}registerSignatureHelpProvider(W,K,X,oe){const G=Array.isArray(oe)?{triggerCharacters:oe,retriggerCharacters:[]}:oe,ie=this._addNewAdapter(new Q(this._documents,X),W);return this._proxy.$registerSignatureHelpProvider(ie,this._transformDocumentSelector(K),G),this._createDisposable(ie)}$provideSignatureHelp(W,K,X,oe,G){return this._withAdapter(W,Q,ie=>ie.provideSignatureHelp(u.URI.revive(K),X,oe,G),void 0)}$releaseSignatureHelp(W,K){this._withAdapter(W,Q,X=>X.releaseSignatureHelp(K),void 0)}registerInlayHintsProvider(W,K,X){const oe=typeof X.onDidChangeInlayHints=="function"?this._nextHandle():void 0,G=this._addNewAdapter(new le(this._documents,X),W);this._proxy.$registerInlayHintsProvider(G,this._transformDocumentSelector(K),oe);let ie=this._createDisposable(G);if(oe!==void 0){const de=X.onDidChangeInlayHints(Te=>this._proxy.$emitInlayHintsEvent(oe));ie=P.Disposable.from(ie,de)}return ie}$provideInlayHints(W,K,X,oe){return this._withAdapter(W,le,G=>G.provideInlayHints(u.URI.revive(K),X,oe),void 0)}registerDocumentLinkProvider(W,K,X){const oe=this._addNewAdapter(new ve(this._documents,X),W);return this._proxy.$registerDocumentLinkProvider(oe,this._transformDocumentSelector(K),typeof X.resolveDocumentLink=="function"),this._createDisposable(oe)}$provideDocumentLinks(W,K,X){return this._withAdapter(W,ve,oe=>oe.provideLinks(u.URI.revive(K),X),void 0)}$resolveDocumentLink(W,K,X){return this._withAdapter(W,ve,oe=>oe.resolveLink(K,X),void 0)}$releaseDocumentLinks(W,K){this._withAdapter(W,ve,X=>X.releaseLinks(K),void 0)}registerColorProvider(W,K,X){const oe=this._addNewAdapter(new ue(this._documents,X),W);return this._proxy.$registerDocumentColorProvider(oe,this._transformDocumentSelector(K)),this._createDisposable(oe)}$provideDocumentColors(W,K,X){return this._withAdapter(W,ue,oe=>oe.provideColors(u.URI.revive(K),X),[])}$provideColorPresentations(W,K,X,oe){return this._withAdapter(W,ue,G=>G.provideColorPresentations(u.URI.revive(K),X,oe),void 0)}registerFoldingRangeProvider(W,K,X){const oe=this._nextHandle(),G=typeof X.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(oe,new Je(new Fe(this._documents,X),W)),this._proxy.$registerFoldingRangeProvider(oe,this._transformDocumentSelector(K),G);let ie=this._createDisposable(oe);if(G!==void 0){const de=X.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(G));ie=P.Disposable.from(ie,de)}return ie}$provideFoldingRanges(W,K,X,oe){return this._withAdapter(W,Fe,G=>G.provideFoldingRanges(u.URI.revive(K),X,oe),void 0)}registerSelectionRangeProvider(W,K,X){const oe=this._addNewAdapter(new Ke(this._documents,X,this._logService),W);return this._proxy.$registerSelectionRangeProvider(oe,this._transformDocumentSelector(K)),this._createDisposable(oe)}$provideSelectionRanges(W,K,X,oe){return this._withAdapter(W,Ke,G=>G.provideSelectionRanges(u.URI.revive(K),X,oe),[])}registerCallHierarchyProvider(W,K,X){const oe=this._addNewAdapter(new Oe(this._documents,X),W);return this._proxy.$registerCallHierarchyProvider(oe,this._transformDocumentSelector(K)),this._createDisposable(oe)}$prepareCallHierarchy(W,K,X,oe){return this._withAdapter(W,Oe,G=>Promise.resolve(G.prepareSession(u.URI.revive(K),X,oe)),void 0)}$provideCallHierarchyIncomingCalls(W,K,X,oe){return this._withAdapter(W,Oe,G=>G.provideCallsTo(K,X,oe),void 0)}$provideCallHierarchyOutgoingCalls(W,K,X,oe){return this._withAdapter(W,Oe,G=>G.provideCallsFrom(K,X,oe),void 0)}$releaseCallHierarchy(W,K){this._withAdapter(W,Oe,X=>Promise.resolve(X.releaseSession(K)),void 0)}registerTypeHierarchyProvider(W,K,X){const oe=this._addNewAdapter(new He(this._documents,X),W);return this._proxy.$registerTypeHierarchyProvider(oe,this._transformDocumentSelector(K)),this._createDisposable(oe)}$prepareTypeHierarchy(W,K,X,oe){return this._withAdapter(W,He,G=>Promise.resolve(G.prepareSession(u.URI.revive(K),X,oe)),void 0)}$provideTypeHierarchySupertypes(W,K,X,oe){return this._withAdapter(W,He,G=>G.provideSupertypes(K,X,oe),void 0)}$provideTypeHierarchySubtypes(W,K,X,oe){return this._withAdapter(W,He,G=>G.provideSubtypes(K,X,oe),void 0)}$releaseTypeHierarchy(W,K){this._withAdapter(W,He,X=>Promise.resolve(X.releaseSession(K)),void 0)}static _serializeRegExp(W){return{pattern:W.source,flags:(0,A.regExpFlags)(W)}}static _serializeIndentationRule(W){return{decreaseIndentPattern:Ye._serializeRegExp(W.decreaseIndentPattern),increaseIndentPattern:Ye._serializeRegExp(W.increaseIndentPattern),indentNextLinePattern:W.indentNextLinePattern?Ye._serializeRegExp(W.indentNextLinePattern):void 0,unIndentedLinePattern:W.unIndentedLinePattern?Ye._serializeRegExp(W.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(W){return{beforeText:Ye._serializeRegExp(W.beforeText),afterText:W.afterText?Ye._serializeRegExp(W.afterText):void 0,previousLineText:W.previousLineText?Ye._serializeRegExp(W.previousLineText):void 0,action:W.action}}static _serializeOnEnterRules(W){return W.map(Ye._serializeOnEnterRule)}setLanguageConfiguration(W,K,X){let{wordPattern:oe}=X;if(oe&&(0,A.regExpLeadsToEndlessLoop)(oe))throw new Error(`Invalid language configuration: wordPattern '${oe}' is not allowed to match the empty string.`);oe?this._documents.setWordDefinitionFor(K,oe):this._documents.setWordDefinitionFor(K,void 0),X.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",W,"Do not use."),X.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",W,"Do not use.");const G=this._nextHandle(),ie={comments:X.comments,brackets:X.brackets,wordPattern:X.wordPattern?Ye._serializeRegExp(X.wordPattern):void 0,indentationRules:X.indentationRules?Ye._serializeIndentationRule(X.indentationRules):void 0,onEnterRules:X.onEnterRules?Ye._serializeOnEnterRules(X.onEnterRules):void 0,__electricCharacterSupport:X.__electricCharacterSupport,__characterPairSupport:X.__characterPairSupport};return this._proxy.$setLanguageConfiguration(G,K,ie),this._createDisposable(G)}$setWordDefinitions(W){for(const K of W)this._documents.setWordDefinitionFor(K.languageId,new RegExp(K.regexSource,K.regexFlags))}}e.ExtHostLanguageFeatures=Ye,Ye._handlePool=0}),define(be[199],Ee([0,1,5,8,7,36,13,6]),function(re,e,u,M,b,P,t,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class C{constructor(F,y,r,m){this._documents=y,this._commands=r,this._uriTransformer=m,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=F.getProxy(u.MainContext.MainThreadLanguages)}$acceptLanguageIds(F){this._languageIds=F}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(F,y){await this._proxy.$changeLanguage(F,y);const r=this._documents.getDocumentData(F);if(!r)throw new Error(`document '${F.toString}' NOT found`);return r.document}async tokenAtPosition(F,y){const r=F.version,m=M.Position.from(y),a=await this._proxy.$tokensAtPosition(F.uri,m),h={type:b.StandardTokenType.Other,range:F.getWordRangeAtPosition(y)??new b.Range(y.line,y.character,y.line,y.character)};if(!a)return h;const p={range:M.Range.to(a.range),type:M.TokenType.to(a.type)};return!p.range.contains(y)||r!==F.version?h:p}createLanguageStatusItem(F,y,r){const m=this._handlePool++,a=this._proxy,h=this._ids,p=`${F.identifier.value}/${y}`;if(h.has(p))throw new Error(`LanguageStatusItem with id '${y}' ALREADY exists`);h.add(p);const S={selector:r,id:y,name:F.displayName??F.name,severity:b.LanguageStatusSeverity.Information,command:void 0,text:"",detail:""};let w,o=new A.DisposableStore;const d=()=>{w?.dispose(),w=(0,t.disposableTimeout)(()=>{o.clear(),this._proxy.$setLanguageStatus(m,{id:p,name:S.name??F.displayName??F.name,source:F.displayName??F.name,selector:M.DocumentSelector.from(S.selector,this._uriTransformer),label:S.text,detail:S.detail??"",severity:S.severity===b.LanguageStatusSeverity.Error?P.default.Error:S.severity===b.LanguageStatusSeverity.Warning?P.default.Warning:P.default.Info,command:S.command&&this._commands.toInternal(S.command,o),accessibilityInfo:S.accessibilityInformation})},0)},_={dispose(){o.dispose(),w?.dispose(),a.$removeLanguageStatus(m),h.delete(p)},get id(){return S.id},get name(){return S.name},set name(c){S.name=c,d()},get selector(){return S.selector},set selector(c){S.selector=c,d()},get text(){return S.text},set text(c){S.text=c,d()},get detail(){return S.detail},set detail(c){S.detail=c,d()},get severity(){return S.severity},set severity(c){S.severity=c,d()},get accessibilityInformation(){return S.accessibilityInformation},set accessibilityInformation(c){S.accessibilityInformation=c,d()},get command(){return S.command},set command(c){S.command=c,d()}};return d(),_}}e.ExtHostLanguages=C}),define(be[200],Ee([0,1,12,5,28,14,3]),function(re,e,u,M,b,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let A=class extends u.AbstractLoggerService{constructor(F,y){const r=new t.Emitter;super(y.logLevel,r.event);this._proxy=F.getProxy(M.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(r)}$setLevel(F){this._onDidChangeLogLevel.fire(F)}doCreateLogger(F,y,r){return new C(this._proxy,F,y,r)}};A=Ue([Be(0,P.IExtHostRpcService),Be(1,b.IExtHostInitDataService)],A),e.ExtHostLoggerService=A;class C extends u.AbstractMessageLogger{constructor(F,y,r,m){super(m?.always);this.proxy=F,this.file=y,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(r),this.proxy.$createLogger(y,m).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(F,y){const r=[[F,y]];this.isLoggerCreated?this.doLog(r):this.buffer.push(...r)}doLog(F){this.proxy.$log(this.file,F)}}}),define(be[201],Ee([0,1,5,12,27]),function(re,e,u,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function P(A){return A&&A.title}let t=class{constructor(C,k){this._logService=k,this._proxy=C.getProxy(u.MainContext.MainThreadMessageService)}showMessage(C,k,F,y,r){const m={extension:C};let a;typeof y=="string"||P(y)?a=[y,...r]:(m.modal=y?.modal,m.useCustom=y?.useCustom,m.detail=y?.detail,a=r),m.useCustom&&(0,b.checkProposedApiEnabled)(C,"resolvers");const h=[];for(let p=0;p<a.length;p++){const S=a[p];if(typeof S=="string")h.push({title:S,handle:p,isCloseAffordance:!1});else if(typeof S=="object"){let{title:w,isCloseAffordance:o}=S;h.push({title:w,isCloseAffordance:!!o,handle:p})}else this._logService.warn("Invalid message item:",S)}return this._proxy.$showMessage(k,F,m,h).then(p=>{if(typeof p=="number")return a[p]})}};t=Ue([Be(1,M.ILogService)],t),e.ExtHostMessageService=t}),define(be[202],Ee([0,1,22,3,60,6,20,9,10,2,65,5,8,7,39,175,93]),function(re,e,u,M,b,P,t,A,C,k,F,y,r,m,a,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class S{constructor(o,d,_,c,R){this._textDocumentsAndEditors=_,this._textDocuments=c,this._extensionStoragePaths=R,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new t.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new M.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new M.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new M.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new M.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new M.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new M.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new M.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new M.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new F.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=o.getProxy(y.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=o.getProxy(y.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=o.getProxy(y.MainContext.MainThreadNotebookEditors),this._commandsConverter=d.converter,d.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===12){const i=n.notebookEditor?.notebookUri,g=n.cell.handle,s=this._documents.get(i)?.getCell(g);if(s)return s.apiCell}return n}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(o=>o.apiEditor)}getEditorById(o){const d=this._editors.get(o);if(!d)throw new Error(`unknown text editor: ${o}. known editors: ${[...this._editors.keys()]} `);return d}getIdByEditor(o){for(const[d,_]of this._editors)if(_.apiEditor===o)return d}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(o,d){const _=this._documents.get(o);if(!_&&!d)throw new Error(`NO notebook document for '${o}'`);return _}_getProviderData(o){const d=this._notebookContentProviders.get(o);if(!d)throw new Error(`NO provider for '${o}'`);return d}registerNotebookContentProvider(o,d,_,c,R){if((0,A.isFalsyOrWhitespace)(d))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(d))throw new Error(`Notebook provider for '${d}' already registered`);this._notebookContentProviders.set(d,{extension:o,provider:_});let n;return _.onDidChangeNotebookContentOptions&&(n=_.onDidChangeNotebookContentOptions(()=>{const i=r.NotebookDocumentContentOptions.from(_.options);this._notebookProxy.$updateNotebookProviderOptions(d,i)})),this._notebookProxy.$registerNotebookProvider({id:o.identifier,location:o.extensionLocation},d,r.NotebookDocumentContentOptions.from(c),S._convertNotebookRegistrationData(o,R)),new m.Disposable(()=>{n?.dispose(),this._notebookContentProviders.delete(d),this._notebookProxy.$unregisterNotebookProvider(d)})}static _convertNotebookRegistrationData(o,d){if(!d)return;const _=d.filenamePattern.map(c=>r.NotebookExclusiveDocumentPattern.from(c)).filter(c=>c!==void 0);if(d.filenamePattern&&!_){console.warn(`Notebook content provider view options file name pattern is invalid ${d.filenamePattern}`);return}return{extension:o.identifier,providerDisplayName:o.displayName||o.name,displayName:d.displayName,filenamePattern:_,exclusive:d.exclusive||!1}}registerNotebookCellStatusBarItemProvider(o,d,_){const c=S._notebookStatusBarItemProviderHandlePool++,R=typeof _.onDidChangeCellStatusBarItems=="function"?S._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(c,_),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(c,R,d);let n;return R!==void 0&&(n=_.onDidChangeCellStatusBarItems(i=>this._notebookProxy.$emitCellStatusBarEvent(R))),new m.Disposable(()=>{this._notebookStatusBarItemProviders.delete(c),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(c,R),n&&n.dispose()})}async createNotebookDocument(o){const d=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:o.viewType,content:o.content&&r.NotebookData.from(o.content)});return k.URI.revive(d)}async openNotebookDocument(o){const d=this._documents.get(o);if(d)return d.apiNotebook;const _=await this._notebookDocumentsProxy.$tryOpenNotebook(o),c=this._documents.get(k.URI.revive(_));return(0,C.assertIsDefined)(c?.apiNotebook)}async showNotebookDocument(o,d){k.URI.isUri(o)&&(o=await this.openNotebookDocument(o));let _;typeof d=="object"?_={position:r.ViewColumn.from(d.viewColumn),preserveFocus:d.preserveFocus,selections:d.selections&&d.selections.map(r.NotebookRange.from),pinned:typeof d.preview=="boolean"?!d.preview:void 0}:_={preserveFocus:!1};const c=await this._notebookEditorsProxy.$tryShowNotebookDocument(o.uri,o.notebookType,_),R=c&&this._editors.get(c)?.apiEditor;if(R)return R;throw c?new Error(`Could NOT open editor for "${o.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${o.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(o,d,_,c){const R=this._notebookStatusBarItemProviders.get(o),n=k.URI.revive(d),i=this._documents.get(n);if(!i||!R)return;const g=i.getCellFromIndex(_);if(!g)return;const f=await R.provideCellStatusBarItems(g.apiCell,c);if(!f)return;const s=new P.DisposableStore,v=this._statusBarCache.add([s]),E=(Array.isArray(f)?f:[f]).map(T=>r.NotebookStatusBarItem.from(T,this._commandsConverter,s));return{cacheId:v,items:E}}$releaseNotebookCellStatusBarItems(o){this._statusBarCache.delete(o)}registerNotebookSerializer(o,d,_,c,R){if((0,A.isFalsyOrWhitespace)(d))throw new Error("viewType cannot be empty or just whitespace");const n=this._handlePool++;return this._notebookSerializer.set(n,_),this._notebookProxy.$registerNotebookSerializer(n,{id:o.identifier,location:o.extensionLocation},d,r.NotebookDocumentContentOptions.from(c),S._convertNotebookRegistrationData(o,R)),(0,P.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(n)})}async $dataToNotebook(o,d,_){const c=this._notebookSerializer.get(o);if(!c)throw new Error("NO serializer found");const R=await c.deserializeNotebook(d.buffer,_);return new a.SerializableObjectWithBuffers(r.NotebookData.from(R))}async $notebookToData(o,d,_){const c=this._notebookSerializer.get(o);if(!c)throw new Error("NO serializer found");const R=await c.serializeNotebook(r.NotebookData.to(d.value),_);return u.VSBuffer.wrap(R)}async $openNotebook(o,d,_,c,R){const{provider:n}=this._getProviderData(o),i=await n.openNotebook(k.URI.revive(d),{backupId:_,untitledDocumentData:c?.buffer},R);return new a.SerializableObjectWithBuffers({metadata:i.metadata??Object.create(null),cells:i.cells.map(r.NotebookCellData.from)})}async $saveNotebook(o,d,_){const c=this.getNotebookDocument(k.URI.revive(d)),{provider:R}=this._getProviderData(o);return await R.saveNotebook(c.apiNotebook,_),!0}async $saveNotebookAs(o,d,_,c){const R=this.getNotebookDocument(k.URI.revive(d)),{provider:n}=this._getProviderData(o);return await n.saveNotebookAs(k.URI.revive(_),R.apiNotebook,c),!0}async $backupNotebook(o,d,_){const c=this.getNotebookDocument(k.URI.revive(d)),R=this._getProviderData(o),n=this._extensionStoragePaths.workspaceValue(R.extension)??this._extensionStoragePaths.globalValue(R.extension),i=String((0,b.hash)([c.uri.toString(),this._backupIdPool++])),g=k.URI.joinPath(n,i),f=await R.provider.backupNotebook(c.apiNotebook,{destination:g},_);return c.updateBackup(f),f.id}_createExtHostEditor(o,d,_){if(this._editors.has(d))throw new Error(`editor with id ALREADY EXSIST: ${d}`);const c=new p.ExtHostNotebookEditor(d,this._notebookEditorsProxy,o,_.visibleRanges.map(r.NotebookRange.to),_.selections.map(r.NotebookRange.to),typeof _.viewColumn=="number"?r.ViewColumn.to(_.viewColumn):void 0);this._editors.set(d,c)}$acceptDocumentAndEditorsDelta(o){if(o.value.removedDocuments)for(const _ of o.value.removedDocuments){const c=k.URI.revive(_),R=this._documents.get(c);R&&(R.dispose(),this._documents.delete(c),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:R.apiNotebook.getCells().map(n=>n.document.uri)}),this._onDidCloseNotebookDocument.fire(R.apiNotebook));for(const n of this._editors.values())n.notebookData.uri.toString()===c.toString()&&this._editors.delete(n.id)}if(o.value.addedDocuments){const _=[];for(const c of o.value.addedDocuments){const R=k.URI.revive(c.uri);if(this._documents.has(R))throw new Error(`adding EXISTING notebook ${R} `);const n=this,i=new h.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(g){n._onDidChangeNotebookCells.fire(g)},emitCellOutputsChange(g){n._onDidChangeCellOutputs.fire(g)},emitCellMetadataChange(g){n._onDidChangeCellMetadata.fire(g)},emitCellExecutionStateChange(g){n._onDidChangeCellExecutionState.fire(g)}},R,c);_.push(...c.cells.map(g=>h.ExtHostCell.asModelAddData(i.apiNotebook,g))),this._documents.get(R)?.dispose(),this._documents.set(R,i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:_}),this._onDidOpenNotebookDocument.fire(i.apiNotebook)}}if(o.value.addedEditors)for(const _ of o.value.addedEditors){if(this._editors.has(_.id))return;const c=k.URI.revive(_.documentUri),R=this._documents.get(c);R&&this._createExtHostEditor(R,_.id,_)}const d=[];if(o.value.removedEditors)for(const _ of o.value.removedEditors){const c=this._editors.get(_);c&&(this._editors.delete(_),this._activeNotebookEditor?.id===c.id&&(this._activeNotebookEditor=void 0),d.push(c))}if(o.value.visibleEditors){this._visibleNotebookEditors=o.value.visibleEditors.map(c=>this._editors.get(c)).filter(c=>!!c);const _=new Set;this._visibleNotebookEditors.forEach(c=>_.add(c.id));for(const c of this._editors.values()){const R=_.has(c.id);c._acceptVisibility(R)}this._visibleNotebookEditors=[...this._editors.values()].map(c=>c).filter(c=>c.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}o.value.newActiveEditor===null?this._activeNotebookEditor=void 0:o.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(o.value.newActiveEditor)),o.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=S,S._notebookStatusBarItemProviderHandlePool=0}),define(be[203],Ee([0,1,3,56,12,5,14,8]),function(re,e,u,M,b,P,t,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class C{constructor(y,r){const m=C._Keys.nextId();y.$registerNotebookEditorDecorationType(m,A.NotebookDecorationRenderOptions.from(r)),this.value={key:m,dispose(){y.$removeNotebookEditorDecorationType(m)}}}}C._Keys=new M.IdGenerator("NotebookEditorDecorationType");let k=class{constructor(y,r,m){this._logService=y,this._extHostRpc=r,this._notebooksAndEditors=m,this._onDidChangeNotebookEditorSelection=new u.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new u.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(y){return new C(this._extHostRpc.getProxy(P.MainContext.MainThreadNotebookEditors),y).value}$acceptEditorPropertiesChanged(y,r){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",y,r);const m=this._notebooksAndEditors.getEditorById(y);r.visibleRanges&&m._acceptVisibleRanges(r.visibleRanges.ranges.map(A.NotebookRange.to)),r.selections&&m._acceptSelections(r.selections.selections.map(A.NotebookRange.to)),r.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:m.apiEditor,visibleRanges:m.apiEditor.visibleRanges}),r.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:m.apiEditor,selections:m.apiEditor.selections}))}$acceptEditorViewColumns(y){for(const r in y)this._notebooksAndEditors.getEditorById(r)._acceptViewColumn(A.ViewColumn.to(y[r]))}};k=Ue([Be(0,b.ILogService),Be(1,t.IExtHostRpcService)],k),e.ExtHostNotebookEditors=k}),define(be[204],Ee([0,1,15,13,21,3,6,20,2,26,12,5,40,8,7,68,167,27,39]),function(re,e,u,M,b,P,t,A,C,k,F,y,r,m,a,h,p,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let o=class{constructor(n,i,g,f,s){this._initData=i,this._extHostNotebook=g,this._commands=f,this._logService=s,this._activeExecutions=new A.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=n.getProxy(y.MainContext.MainThreadNotebookKernels);const v=new r.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new r.ApiCommandArgument("options","Select kernel options",l=>!0,l=>{if(l&&"notebookEditor"in l&&"id"in l){const E=this._extHostNotebook.getIdByEditor(l.notebookEditor);return{id:l.id,extension:l.extension,notebookEditorId:E}}else if(l&&"notebookEditor"in l){const E=this._extHostNotebook.getIdByEditor(l.notebookEditor);if(E===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${l.notebookEditor.document.uri.toString()}`);return{notebookEditorId:E}}return l})],r.ApiCommandResult.Void);this._commands.registerApiCommand(v)}createNotebookController(n,i,g,f,s,v){for(let Q of this._kernelData.values())if(Q.controller.id===i&&k.ExtensionIdentifier.equals(n.identifier,Q.extensionId))throw new Error(`notebook controller with id '${i}' ALREADY exist`);const l=this._handlePool++,E=this;this._logService.trace(`NotebookController[${l}], CREATED by ${n.identifier.value}, ${i}`);const T=()=>console.warn(`NO execute handler from notebook controller '${x.id}' of extension: '${n.identifier}'`);let I=!1;const B=new t.DisposableStore,O=new P.Emitter,D=new P.Emitter,x={id:`${n.identifier.value}/${i}`,notebookType:g,extensionId:n.identifier,extensionLocation:n.extensionLocation,label:f||n.identifier.value,preloads:v?v.map(m.NotebookRendererScript.from):[]};let N=s??T,V;this._proxy.$addKernel(l,x).catch(Q=>{console.log(Q),I=!0});let $=0;const z=()=>{if(I)return;const Q=++$;Promise.resolve().then(()=>{Q===$&&this._proxy.$updateKernel(l,x)})},ee=new A.ResourceMap,j={get id(){return i},get notebookType(){return x.notebookType},onDidChangeSelectedNotebooks:O.event,get label(){return x.label},set label(Q){x.label=Q??n.displayName??n.name,z()},get detail(){return x.detail??""},set detail(Q){x.detail=Q,z()},get description(){return x.description??""},set description(Q){x.description=Q,z()},get kind(){return(0,S.checkProposedApiEnabled)(n,"notebookControllerKind"),x.kind??""},set kind(Q){(0,S.checkProposedApiEnabled)(n,"notebookControllerKind"),x.kind=Q,z()},get supportedLanguages(){return x.supportedLanguages},set supportedLanguages(Q){x.supportedLanguages=Q,z()},get supportsExecutionOrder(){return x.supportsExecutionOrder??!1},set supportsExecutionOrder(Q){x.supportsExecutionOrder=Q,z()},get rendererScripts(){return x.preloads?x.preloads.map(m.NotebookRendererScript.to):[]},get executeHandler(){return N},set executeHandler(Q){N=Q??T},get interruptHandler(){return V},set interruptHandler(Q){V=Q,x.supportsInterrupt=Boolean(Q),z()},createNotebookCellExecution(Q){if(I)throw new Error("notebook controller is DISPOSED");if(!ee.has(Q.notebook.uri))throw E._logService.trace(`NotebookController[${l}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ee.keys()).map(le=>le.toString())),new Error(`notebook controller is NOT associated to notebook: ${Q.notebook.uri.toString()}`);return E._createNotebookCellExecution(Q)},dispose:()=>{I||(this._logService.trace(`NotebookController[${l}], DISPOSED`),I=!0,this._kernelData.delete(l),B.dispose(),O.dispose(),D.dispose(),this._proxy.$removeKernel(l))},updateNotebookAffinity(Q,le){E._proxy.$updateNotebookPriority(l,Q.uri,le)},onDidReceiveMessage:D.event,postMessage(Q,le){return(0,S.checkProposedApiEnabled)(n,"notebookMessaging"),E._proxy.$postMessage(l,le&&E._extHostNotebook.getIdByEditor(le),Q)},asWebviewUri(Q){return(0,S.checkProposedApiEnabled)(n,"notebookMessaging"),(0,h.asWebviewUri)(Q,E._initData.remote)}};return this._kernelData.set(l,{extensionId:n.identifier,controller:j,onDidReceiveMessage:D,onDidChangeSelection:O,associatedNotebooks:ee}),j}$acceptNotebookAssociation(n,i,g){const f=this._kernelData.get(n);if(f){const s=this._extHostNotebook.getNotebookDocument(C.URI.revive(i));g?f.associatedNotebooks.set(s.uri,!0):f.associatedNotebooks.delete(s.uri),this._logService.trace(`NotebookController[${n}] ASSOCIATE notebook`,s.uri.toString(),g),f.onDidChangeSelection.fire({selected:g,notebook:s.apiNotebook})}}async $executeCells(n,i,g){const f=this._kernelData.get(n);if(!f)return;const s=this._extHostNotebook.getNotebookDocument(C.URI.revive(i)),v=[];for(let l of g){const E=s.getCell(l);E&&v.push(E.apiCell)}try{this._logService.trace(`NotebookController[${n}] EXECUTE cells`,s.uri.toString(),v.length),await f.controller.executeHandler.call(f.controller,v,s.apiNotebook,f.controller)}catch(l){this._logService.error(`NotebookController[${n}] execute cells FAILED`,l),console.error(l)}}async $cancelCells(n,i,g){const f=this._kernelData.get(n);if(!f)return;const s=this._extHostNotebook.getNotebookDocument(C.URI.revive(i));if(f.controller.interruptHandler)await f.controller.interruptHandler.call(f.controller,s.apiNotebook);else for(let v of g){const l=s.getCell(v);l&&this._activeExecutions.get(l.uri)?.cancel()}}$acceptKernelMessageFromRenderer(n,i,g){const f=this._kernelData.get(n);if(!f)return;const s=this._extHostNotebook.getEditorById(i);f.onDidReceiveMessage.fire(Object.freeze({editor:s.apiEditor,message:g}))}_createNotebookCellExecution(n){if(n.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const g=this._extHostNotebook.getNotebookDocument(n.notebook.uri).getCellFromApiCell(n);if(!g)throw new Error("invalid cell");if(this._activeExecutions.has(g.uri))throw new Error(`duplicate execution for ${g.uri}`);const f=new _(g.notebook,g,this._proxy);this._activeExecutions.set(g.uri,f);const s=f.onDidChangeState(()=>{f.state===d.Resolved&&(f.dispose(),s.dispose(),this._activeExecutions.delete(g.uri))});return f.asApiObject()}};o=Ue([Be(4,F.ILogService)],o),e.ExtHostNotebookKernels=o;var d;(function(R){R[R.Init=0]="Init",R[R.Started=1]="Started",R[R.Resolved=2]="Resolved"})(d||(d={}));class _ extends t.Disposable{constructor(n,i,g){super();this._document=n,this._cell=i,this._proxy=g,this._handle=_.HANDLE++,this._onDidChangeState=new P.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=d.Init,this._tokenSource=this._register(new b.CancellationTokenSource),this._collector=new c(10,f=>this.update(f)),this._executionOrder=i.internalMetadata.executionOrder,this._proxy.$addExecution(this._handle,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(n){await this._collector.addItem(n)}async update(n){const i=Array.isArray(n)?n:[n];return this._proxy.$updateExecutions(new w.SerializableObjectWithBuffers(i))}verifyStateForOutput(){if(this._state===d.Init)throw new Error("Must call start before modifying cell output");if(this._state===d.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(n){let i=this._cell;if(n&&(i=this._document.getCellFromApiCell(n)),!i)throw new Error("INVALID cell");return i.handle}validateAndConvertOutputs(n){return n.map(i=>{const g=a.NotebookCellOutput.ensureUniqueMimeTypes(i.items,!0);return g===i.items?m.NotebookCellOutput.from(i):m.NotebookCellOutput.from({items:g,id:i.id,metadata:i.metadata})})}async updateOutputs(n,i,g){const f=this.cellIndexToHandle(i),s=this.validateAndConvertOutputs((0,u.asArray)(n));return this.updateSoon({editType:p.CellExecutionUpdateType.Output,executionHandle:this._handle,cellHandle:f,append:g,outputs:s})}async updateOutputItems(n,i,g){return n=a.NotebookCellOutput.ensureUniqueMimeTypes((0,u.asArray)(n),!0),this.updateSoon({editType:p.CellExecutionUpdateType.OutputItems,executionHandle:this._handle,items:n.map(m.NotebookCellOutputItem.from),outputId:i.id,append:g})}asApiObject(){const n=this;return Object.freeze({get token(){return n._tokenSource.token},get cell(){return n._cell.apiCell},get executionOrder(){return n._executionOrder},set executionOrder(g){n._executionOrder=g,n.update([{editType:p.CellExecutionUpdateType.ExecutionState,executionHandle:n._handle,executionOrder:n._executionOrder}])},start(g){if(n._state===d.Resolved||n._state===d.Started)throw new Error("Cannot call start again");n._state=d.Started,n._onDidChangeState.fire(),n.update({editType:p.CellExecutionUpdateType.ExecutionState,executionHandle:n._handle,runStartTime:g})},end(g,f){if(n._state===d.Resolved)throw new Error("Cannot call resolve twice");n._state=d.Resolved,n._onDidChangeState.fire(),n.updateSoon({editType:p.CellExecutionUpdateType.Complete,executionHandle:n._handle,runEndTime:f,lastRunSuccess:g}),n._collector.flush(),n._proxy.$removeExecution(n._handle)},clearOutput(g){return n.verifyStateForOutput(),n.updateOutputs([],g,!1)},appendOutput(g,f){return n.verifyStateForOutput(),n.updateOutputs(g,f,!0)},replaceOutput(g,f){return n.verifyStateForOutput(),n.updateOutputs(g,f,!1)},appendOutputItems(g,f){return n.verifyStateForOutput(),n.updateOutputItems(g,f,!0)},replaceOutputItems(g,f){return n.verifyStateForOutput(),n.updateOutputItems(g,f,!1)}})}}_.HANDLE=0;class c{constructor(n,i){this.delay=n,this.callback=i,this.batch=[],this.startedTimer=Date.now()}addItem(n){return this.batch.push(n),this.currentDeferred||(this.currentDeferred=new M.DeferredPromise,this.startedTimer=Date.now(),(0,M.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const n=this.currentDeferred;this.currentDeferred=void 0;const i=this.batch;return this.batch=[],this.callback(i).finally(()=>n.complete())}}}),define(be[205],Ee([0,1,3,5,93,27]),function(re,e,u,M,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class t{constructor(C,k){this._extHostNotebook=k,this._rendererMessageEmitters=new Map,this.proxy=C.getProxy(M.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(C,k,F){const y=this._extHostNotebook.getEditorById(C);this._rendererMessageEmitters.get(k)?.fire({editor:y.apiEditor,message:F})}createRendererMessaging(C,k){if(!C.contributes?.notebookRenderer?.some(m=>m.id===k))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${k})`);const F=(0,P.isProposedApiEnabled)(C,"notebookEditor"),y=new WeakMap;return{onDidReceiveMessage:(m,a,h)=>{const p=F?m:S=>{const w={};y.set(w,S.editor),m({editor:w,message:S.message})};return this.getOrCreateEmitterFor(k).event(p,a,h)},postMessage:(m,a)=>{b.ExtHostNotebookEditor.apiEditorsToExtHost.has(m)&&([m,a]=[a,m]);const h=F?a:y.get(a),p=h&&b.ExtHostNotebookEditor.apiEditorsToExtHost.get(h);return this.proxy.$postMessage(p?.id,k,m)}}}getOrCreateEmitterFor(C){let k=this._rendererMessageEmitters.get(C);return k||(k=new u.Emitter({onLastListenerRemove:()=>{k?.dispose(),this._rendererMessageEmitters.delete(C)}}),this._rendererMessageEmitters.set(C,k),k)}}e.ExtHostNotebookRenderers=t}),define(be[96],Ee([0,1,5,6,4,14,12,168,52,28,31,115,22]),function(re,e,u,M,b,P,t,A,C,k,F,y,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class m extends M.Disposable{constructor(p,S,w,o){super();this.id=p,this.name=S,this.logger=w,this.proxy=o,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(p){this.append(p+`
`)}append(p){this.write(p),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,A.OutputChannelUpdateMode.Append))}clear(){const p=this.offset;this.logger.flush(),this.proxy.$update(this.id,A.OutputChannelUpdateMode.Clear,p)}replace(p){const S=this.offset;this.write(p),this.proxy.$update(this.id,A.OutputChannelUpdateMode.Replace,S),this.visible&&this.logger.flush()}show(p,S){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof p=="boolean"?p:S))}hide(){this.proxy.$close(this.id)}write(p){this.offset+=r.VSBuffer.fromString(p).byteLength,this.logger.info(p)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=m;let a=class{constructor(p,S,w,o,d){this.extHostFileSystem=w,this.extHostFileSystemInfo=o,this.loggerService=d,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=p.getProxy(u.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(S.logsLocation,`output_logging_${(0,y.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(p){this.visibleChannelId=p;for(const[S,w]of this.channels)w.visible=S===this.visibleChannelId}createOutputChannel(p,S){if(p=p.trim(),!p)throw new Error("illegal argument `name`. must not be falsy");const w=this.doCreateOutputChannel(p,S);return w.then(o=>{this.channels.set(o.id,o),o.visible=o.id===this.visibleChannelId}),this.createExtHostOutputChannel(p,w)}async doCreateOutputChannel(p,S){const w=await this.createOutputDirectory(),o=this.extHostFileSystemInfo.extUri.joinPath(w,`${this.namePool++}-${p.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),d=this.loggerService.createLogger(o,{always:!0,donotRotate:!0,donotUseFormatters:!0}),_=await this.proxy.$register(p,!1,o,S.identifier.value);return new m(_,p,d,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(p,S){let w=!1;const o=()=>{if(w)throw new Error("Channel has been closed")};return{get name(){return p},append(d){o(),S.then(_=>_.append(d))},appendLine(d){o(),S.then(_=>_.appendLine(d))},clear(){o(),S.then(d=>d.clear())},replace(d){o(),S.then(_=>_.replace(d))},show(d,_){o(),S.then(c=>c.show(d,_))},hide(){o(),S.then(d=>d.hide())},dispose(){w=!0,S.then(d=>d.dispose())}}}};a=Ue([Be(0,P.IExtHostRpcService),Be(1,k.IExtHostInitDataService),Be(2,C.IExtHostConsumerFileSystem),Be(3,F.IExtHostFileSystemInfo),Be(4,t.ILoggerService)],a),e.ExtHostOutputService=a,e.IExtHostOutputService=(0,b.createDecorator)("IExtHostOutputService")}),define(be[206],Ee([0,1,13,21,3,6,5,2,7,16,15,36,48,27]),function(re,e,u,M,b,P,t,A,C,k,F,y,r,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function a(h,p,S){const w=h.getProxy(t.MainContext.MainThreadQuickOpen);class o{constructor(s,v){this._sessions=new Map,this._instances=0,this._workspace=s,this._commands=v}showQuickPick(s,v,l=M.CancellationToken.None){this._onDidSelectItem=void 0;const E=Promise.resolve(s),T=++this._instances,I=w.$show(T,{title:v?.title,placeHolder:v?.placeHolder,matchOnDescription:v?.matchOnDescription,matchOnDetail:v?.matchOnDetail,ignoreFocusLost:v?.ignoreFocusOut,canPickMany:v?.canPickMany},l),B={},O=I.then(()=>B);return Promise.race([O,E]).then(D=>{if(D!==B)return E.then(x=>{const N=[];for(let V=0;V<x.length;V++){const $=x[V];typeof $=="string"?N.push({label:$,handle:V}):$.kind===C.QuickPickItemKind.Separator?N.push({type:"separator",label:$.label}):N.push({label:$.label,description:$.description,detail:$.detail,picked:$.picked,alwaysShow:$.alwaysShow,handle:V})}return v&&typeof v.onDidSelectItem=="function"&&(this._onDidSelectItem=V=>{v.onDidSelectItem(x[V])}),w.$setItems(T,N),I.then(V=>{if(typeof V=="number")return x[V];if(Array.isArray(V))return V.map($=>x[$])})})}).then(void 0,D=>{if(!(0,k.isPromiseCanceledError)(D))return w.$setError(T,D),Promise.reject(D)})}$onItemSelected(s){this._onDidSelectItem&&this._onDidSelectItem(s)}showInput(s,v=M.CancellationToken.None){return this._validateInput=s?s.validateInput:void 0,w.$input(s,typeof this._validateInput=="function",v).then(void 0,l=>{if(!(0,k.isPromiseCanceledError)(l))return Promise.reject(l)})}$validateInput(s){return this._validateInput?(0,u.asPromise)(()=>this._validateInput(s)):Promise.resolve(void 0)}async showWorkspaceFolderPick(s,v=M.CancellationToken.None){const l=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[s]);if(!l)return;const E=await this._workspace.getWorkspaceFolders2();if(!!E)return E.find(T=>T.uri.toString()===l.uri.toString())}createQuickPick(s){const v=new i(s,()=>this._sessions.delete(v._id));return this._sessions.set(v._id,v),v}createInputBox(s){const v=new g(s,()=>this._sessions.delete(v._id));return this._sessions.set(v._id,v),v}$onDidChangeValue(s,v){const l=this._sessions.get(s);l&&l._fireDidChangeValue(v)}$onDidAccept(s){const v=this._sessions.get(s);v&&v._fireDidAccept()}$onDidChangeActive(s,v){const l=this._sessions.get(s);l instanceof i&&l._fireDidChangeActive(v)}$onDidChangeSelection(s,v){const l=this._sessions.get(s);l instanceof i&&l._fireDidChangeSelection(v)}$onDidTriggerButton(s,v){const l=this._sessions.get(s);l&&l._fireDidTriggerButton(v)}$onDidTriggerItemButton(s,v,l){const E=this._sessions.get(s);E instanceof i&&E._fireDidTriggerItemButton(v,l)}$onDidHide(s){const v=this._sessions.get(s);v&&v._fireDidHide()}}class d{constructor(s,v){this._extensionId=s,this._onDidDispose=v,this._id=i._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new b.Emitter,this._onDidChangeValueEmitter=new b.Emitter,this._onDidTriggerButtonEmitter=new b.Emitter,this._onDidHideEmitter=new b.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(s){this._title=s,this.update({title:s})}get step(){return this._steps}set step(s){this._steps=s,this.update({step:s})}get totalSteps(){return this._totalSteps}set totalSteps(s){this._totalSteps=s,this.update({totalSteps:s})}get enabled(){return this._enabled}set enabled(s){this._enabled=s,this.update({enabled:s})}get busy(){return this._busy}set busy(s){this._busy=s,this.update({busy:s})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(s){this._ignoreFocusOut=s,this.update({ignoreFocusOut:s})}get value(){return this._value}set value(s){this._value=s,this.update({value:s})}get placeholder(){return this._placeholder}set placeholder(s){this._placeholder=s,this.update({placeholder:s})}get buttons(){return this._buttons}set buttons(s){this._buttons=s.slice(),this._handlesToButtons.clear(),s.forEach((v,l)=>{const E=v===C.QuickInputButtons.Back?-1:l;this._handlesToButtons.set(E,v)}),this.update({buttons:s.map((v,l)=>({...n(v),tooltip:v.tooltip,handle:v===C.QuickInputButtons.Back?-1:l}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(s){this._value=s,this._onDidChangeValueEmitter.fire(s)}_fireDidTriggerButton(s){const v=this._handlesToButtons.get(s);v&&this._onDidTriggerButtonEmitter.fire(v)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,P.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),w.$dispose(this._id))}update(s){if(!this._disposed){for(const v of Object.keys(s)){const l=s[v];this._pendingUpdate[v]=l===void 0?null:l}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){w.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}d._nextId=1;function _(f){if(f instanceof C.ThemeIcon)return{id:f.id};const s=R(f),v=c(f);return{dark:typeof s=="string"?A.URI.file(s):s,light:typeof v=="string"?A.URI.file(v):v}}function c(f){return typeof f=="object"&&"light"in f?f.light:f}function R(f){return typeof f=="object"&&"dark"in f?f.dark:f}function n(f){const s=_(f.iconPath);let v,l;return"id"in s?l=r.ThemeIcon.asClassName(s):v=s,{iconPath:v,iconClass:l}}class i extends d{constructor(s,v){super(s.identifier,v);this.extension=s,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new b.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new b.Emitter,this._onDidTriggerItemButtonEmitter=new b.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(s){s.some(l=>l.kind!==void 0)&&(0,m.checkProposedApiEnabled)(this.extension,"quickPickSeparators"),this._items=s.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),s.forEach((l,E)=>{this._handlesToItems.set(E,l),this._itemsToHandles.set(l,E)});const v=[];for(let l=0;l<s.length;l++){const E=s[l];E.kind===C.QuickPickItemKind.Separator?v.push({type:"separator",label:E.label}):v.push({handle:l,label:E.label,description:E.description,detail:E.detail,picked:E.picked,alwaysShow:E.alwaysShow,buttons:E.buttons?.map((T,I)=>({...n(T),tooltip:T.tooltip,handle:I}))})}this.update({items:v})}get canSelectMany(){return this._canSelectMany}set canSelectMany(s){this._canSelectMany=s,this.update({canSelectMany:s})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(s){this._matchOnDescription=s,this.update({matchOnDescription:s})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(s){this._matchOnDetail=s,this.update({matchOnDetail:s})}get sortByLabel(){return this._sortByLabel}set sortByLabel(s){this._sortByLabel=s,this.update({sortByLabel:s})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(s){this._keepScrollPosition=s,this.update({keepScrollPosition:s})}get activeItems(){return this._activeItems}set activeItems(s){this._activeItems=s.filter(v=>this._itemsToHandles.has(v)),this.update({activeItems:this._activeItems.map(v=>this._itemsToHandles.get(v))})}get selectedItems(){return this._selectedItems}set selectedItems(s){this._selectedItems=s.filter(v=>this._itemsToHandles.has(v)),this.update({selectedItems:this._selectedItems.map(v=>this._itemsToHandles.get(v))})}_fireDidChangeActive(s){const v=(0,F.coalesce)(s.map(l=>this._handlesToItems.get(l)));this._activeItems=v,this._onDidChangeActiveEmitter.fire(v)}_fireDidChangeSelection(s){const v=(0,F.coalesce)(s.map(l=>this._handlesToItems.get(l)));this._selectedItems=v,this._onDidChangeSelectionEmitter.fire(v)}_fireDidTriggerItemButton(s,v){const l=this._handlesToItems.get(s);if(!l||!l.buttons||!l.buttons.length)return;const E=l.buttons[v];E&&this._onDidTriggerItemButtonEmitter.fire({button:E,item:l})}}class g extends d{constructor(s,v){super(s,v);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(s){this._password=s,this.update({password:s})}get prompt(){return this._prompt}set prompt(s){this._prompt=s,this.update({prompt:s})}get validationMessage(){return this._validationMessage}set validationMessage(s){this._validationMessage=s,this.update({validationMessage:s,severity:s?y.default.Error:y.default.Ignore})}}return new o(p,S)}e.createExtHostQuickOpen=a}),define(be[207],Ee([0,1,2,3,55,6,13,5,15,107,12,26,48,8,27]),function(re,e,u,M,b,P,t,A,C,k,F,y,r,m,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function h(f){if(f)return typeof f.iconPath=="string"?u.URI.file(f.iconPath):u.URI.isUri(f.iconPath)||r.ThemeIcon.isThemeIcon(f.iconPath)?f.iconPath:void 0}function p(f,s){if(!f.iconPath&&!s.iconPath)return 0;if(f.iconPath){if(!s.iconPath)return 1}else return-1;const v=typeof f.iconPath=="string"?f.iconPath:u.URI.isUri(f.iconPath)?f.iconPath.fsPath:f.iconPath.id,l=typeof s.iconPath=="string"?s.iconPath:u.URI.isUri(s.iconPath)?s.iconPath.fsPath:s.iconPath.id;return(0,k.comparePaths)(v,l)}function S(f,s){let v=0;if(f.strikeThrough!==s.strikeThrough)return f.strikeThrough?1:-1;if(f.faded!==s.faded)return f.faded?1:-1;if(f.tooltip!==s.tooltip)return(f.tooltip||"").localeCompare(s.tooltip||"");if(v=p(f,s),v!==0)return v;if(f.light&&s.light)v=p(f.light,s.light);else{if(f.light)return 1;if(s.light)return-1}if(v!==0)return v;if(f.dark&&s.dark)v=p(f.dark,s.dark);else{if(f.dark)return 1;if(s.dark)return-1}return v}function w(f,s){if(f.command!==s.command)return f.command<s.command?-1:1;if(f.title!==s.title)return f.title<s.title?-1:1;if(f.tooltip!==s.tooltip){if(f.tooltip!==void 0&&s.tooltip!==void 0)return f.tooltip<s.tooltip?-1:1;if(f.tooltip!==void 0)return 1;if(s.tooltip!==void 0)return-1}if(f.arguments===s.arguments)return 0;if(f.arguments)if(s.arguments){if(f.arguments.length!==s.arguments.length)return f.arguments.length-s.arguments.length}else return 1;else return-1;for(let v=0;v<f.arguments.length;v++){const l=f.arguments[v],E=s.arguments[v];if(l!==E)return l<E?-1:1}return 0}function o(f,s){let v=(0,k.comparePaths)(f.resourceUri.fsPath,s.resourceUri.fsPath,!0);if(v!==0)return v;if(f.command&&s.command)v=w(f.command,s.command);else{if(f.command)return 1;if(s.command)return-1}if(v!==0)return v;if(f.decorations&&s.decorations)v=S(f.decorations,s.decorations);else{if(f.decorations)return 1;if(s.decorations)return-1}return v}function d(f,s){for(let v=0;v<f.length;v++)if(f[v]!==s[v])return!1;return!0}function _(f,s){return f.command===s.command&&f.title===s.title&&f.tooltip===s.tooltip&&(f.arguments&&s.arguments?d(f.arguments,s.arguments):f.arguments===s.arguments)}function c(f,s){return(0,C.equals)(f,s,_)}class R{constructor(s,v,l){this._extension=s,this._proxy=v,this._sourceControlHandle=l,this._value="",this._onDidChange=new M.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(s){this._proxy.$setInputBoxValue(this._sourceControlHandle,s),this.updateValue(s)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(s){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,s),this._placeholder=s}get validateInput(){return(0,a.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(s){if((0,a.checkProposedApiEnabled)(this._extension,"scmValidation"),s&&typeof s!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=s,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!s)}get visible(){return this._visible}set visible(s){s=!!s,this._visible!==s&&(this._visible=s,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,s))}showValidationMessage(s,v){(0,a.checkProposedApiEnabled)(this._extension,"scmValidation"),this._proxy.$showValidationMessage(this._sourceControlHandle,s,v)}$onInputBoxValueChange(s){this.updateValue(s)}updateValue(s){this._value=s,this._onDidChange.fire(s)}}e.ExtHostSCMInputBox=R;class n{constructor(s,v,l,E,T){this._proxy=s,this._commands=v,this._sourceControlHandle=l,this._id=E,this._label=T,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new M.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new M.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=n._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(s){this._label=s,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,s)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(s){this._hideWhenEmpty=s,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(s){this._resourceStates=[...s],this._onDidUpdateResourceStates.fire()}getResourceState(s){return this._resourceStatesMap.get(s)}$executeResourceCommand(s,v){const l=this._resourceStatesCommandsMap.get(s);return l?(0,t.asPromise)(()=>this._commands.executeCommand(l.command,...l.arguments||[],v)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const s=[...this._resourceStates].sort(o),l=(0,C.sortedDiff)(this._resourceSnapshot,s,o).map(I=>{const B=I.toInsert.map(O=>{const D=this._resourceHandlePool++;this._resourceStatesMap.set(D,O);const x=O.resourceUri;let N;if(O.command)if(O.command.command==="vscode.open"||O.command.command==="vscode.diff"){const Fe=new P.DisposableStore;N=this._commands.converter.toInternal(O.command,Fe),this._resourceStatesDisposablesMap.set(D,Fe)}else this._resourceStatesCommandsMap.set(D,O.command);const V=h(O.decorations),$=O.decorations&&h(O.decorations.light)||V,z=O.decorations&&h(O.decorations.dark)||V,ee=[$,z],j=O.decorations&&O.decorations.tooltip||"",Q=O.decorations&&!!O.decorations.strikeThrough,le=O.decorations&&!!O.decorations.faded,ve=O.contextValue||"";return{rawResource:[D,x,ee,j,Q,le,ve,N],handle:D}});return{start:I.start,deleteCount:I.deleteCount,toInsert:B}}),E=l.map(({start:I,deleteCount:B,toInsert:O})=>[I,B,O.map(D=>D.rawResource)]),T=l.reverse();for(const{start:I,deleteCount:B,toInsert:O}of T){const D=O.map(N=>N.handle),x=this._handlesSnapshot.splice(I,B,...D);for(const N of x)this._resourceStatesMap.delete(N),this._resourceStatesCommandsMap.delete(N),this._resourceStatesDisposablesMap.get(N)?.dispose(),this._resourceStatesDisposablesMap.delete(N)}return this._resourceSnapshot=s,E}dispose(){this._disposed=!0,this._onDidDispose.fire()}}n._handlePool=0;class i{constructor(s,v,l,E,T,I){this._extension=s,this._proxy=v,this._commands=l,this._id=E,this._label=T,this._rootUri=I,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new P.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new P.MutableDisposable,this._statusBarDisposables=new P.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new M.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=i._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new R(s,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,E,T,I)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(s){this._count!==s&&(this._count=s,this._proxy.$updateSourceControl(this.handle,{count:s}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(s){this._quickDiffProvider=s,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!s})}get commitTemplate(){return this._commitTemplate}set commitTemplate(s){s!==this._commitTemplate&&(this._commitTemplate=s,this._proxy.$updateSourceControl(this.handle,{commitTemplate:s}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(s){this._acceptInputDisposables.value=new P.DisposableStore,this._acceptInputCommand=s;const v=this._commands.converter.toInternal(s,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:v})}get actionButton(){return(0,a.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(s){(0,a.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new P.DisposableStore,this._actionButton=s;const v=s!==void 0?this._commands.converter.toInternal(this._actionButton,this._actionButtonDisposables.value):void 0;this._proxy.$updateSourceControl(this.handle,{actionButton:v??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(s){if(this._statusBarCommands&&s&&c(this._statusBarCommands,s))return;this._statusBarDisposables.value=new P.DisposableStore,this._statusBarCommands=s;const v=(s||[]).map(l=>this._commands.converter.toInternal(l,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:v})}get selected(){return this._selected}createResourceGroup(s,v){const l=new n(this._proxy,this._commands,this.handle,s,v),E=M.Event.once(l.onDidDispose)(()=>this.createdResourceGroups.delete(l));return this.createdResourceGroups.set(l,E),this.eventuallyAddResourceGroups(),l}eventuallyAddResourceGroups(){const s=[],v=[];for(const[l,E]of this.createdResourceGroups){E.dispose();const T=l.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(l),this.eventuallyUpdateResourceStates()});M.Event.once(l.onDidDispose)(()=>{this.updatedResourceGroups.delete(l),T.dispose(),this._groups.delete(l.handle),this._proxy.$unregisterGroup(this.handle,l.handle)}),s.push([l.handle,l.id,l.label,l.features]);const I=l._takeResourceStateSnapshot();I.length>0&&v.push([l.handle,I]),this._groups.set(l.handle,l)}this._proxy.$registerGroups(this.handle,s,v),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const s=[];this.updatedResourceGroups.forEach(v=>{const l=v._takeResourceStateSnapshot();l.length!==0&&s.push([v.handle,l])}),s.length>0&&this._proxy.$spliceResourceStates(this.handle,s),this.updatedResourceGroups.clear()}getResourceGroup(s){return this._groups.get(s)}setSelectionState(s){this._selected=s,this._onDidChangeSelection.fire(s)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(s=>s.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}i._handlePool=0,Ue([(0,b.debounce)(100)],i.prototype,"eventuallyAddResourceGroups",null),Ue([(0,b.debounce)(100)],i.prototype,"eventuallyUpdateResourceStates",null);let g=class $i{constructor(s,v,l){this._commands=v,this.logService=l,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new M.Emitter,this._proxy=s.getProxy(A.MainContext.MainThreadSCM),this._telemetry=s.getProxy(A.MainContext.MainThreadTelemetry),v.registerArgumentProcessor({processArgument:E=>{if(E&&E.$mid===3){const T=this._sourceControls.get(E.sourceControlHandle);if(!T)return E;const I=T.getResourceGroup(E.groupHandle);return I?I.getResourceState(E.handle):E}else if(E&&E.$mid===4){const T=this._sourceControls.get(E.sourceControlHandle);return T?T.getResourceGroup(E.groupHandle):E}else if(E&&E.$mid===5){const T=this._sourceControls.get(E.handle);return T||E}return E}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(s,v,l,E){this.logService.trace("ExtHostSCM#createSourceControl",s.identifier.value,v,l,E),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:s.identifier.value});const T=$i._handlePool++,I=new i(s,this._proxy,this._commands,v,l,E);this._sourceControls.set(T,I);const B=this._sourceControlsByExtension.get(y.ExtensionIdentifier.toKey(s.identifier))||[];return B.push(I),this._sourceControlsByExtension.set(y.ExtensionIdentifier.toKey(s.identifier),B),I}getLastInputBox(s){this.logService.trace("ExtHostSCM#getLastInputBox",s.identifier.value);const v=this._sourceControlsByExtension.get(y.ExtensionIdentifier.toKey(s.identifier)),l=v&&v[v.length-1];return l&&l.inputBox}$provideOriginalResource(s,v,l){const E=u.URI.revive(v);this.logService.trace("ExtHostSCM#$provideOriginalResource",s,E.toString());const T=this._sourceControls.get(s);return!T||!T.quickDiffProvider||!T.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,t.asPromise)(()=>T.quickDiffProvider.provideOriginalResource(E,l)).then(I=>I||null)}$onInputBoxValueChange(s,v){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",s);const l=this._sourceControls.get(s);return l&&l.inputBox.$onInputBoxValueChange(v),Promise.resolve(void 0)}$executeResourceCommand(s,v,l,E){this.logService.trace("ExtHostSCM#$executeResourceCommand",s,v,l);const T=this._sourceControls.get(s);if(!T)return Promise.resolve(void 0);const I=T.getResourceGroup(v);return I?I.$executeResourceCommand(l,E):Promise.resolve(void 0)}$validateInput(s,v,l){this.logService.trace("ExtHostSCM#$validateInput",s);const E=this._sourceControls.get(s);return!E||!E.inputBox.validateInput?Promise.resolve(void 0):(0,t.asPromise)(()=>E.inputBox.validateInput(v,l)).then(T=>{if(!T)return Promise.resolve(void 0);const I=m.MarkdownString.fromStrict(T.message);return I?Promise.resolve([I,T.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(s){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",s),s!==void 0&&this._sourceControls.get(s)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=s,Promise.resolve(void 0)}};g._handlePool=0,g=Ue([Be(2,F.ILogService)],g),e.ExtHostSCM=g});var Xe=this&&this.__classPrivateFieldSet||function(re,e,u,M,b){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!b:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?b.call(re,u):b?b.value=u:e.set(re,u),u},Ae=this&&this.__classPrivateFieldGet||function(re,e,u,M){if(u==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?M:u==="a"?M.call(re):M?M.value:e.get(re)};define(be[208],Ee([0,1,7,5,128,6,8,10]),function(re,e,u,M,b,P,t,A){"use strict";var C,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class F{constructor(a,h,p,S,w=u.StatusBarAlignment.Left,o){C.set(this,void 0),k.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new P.DisposableStore,Xe(this,C,a,"f"),Xe(this,k,h,"f"),this._entryId=F.ID_GEN++,this._extension=p,this._id=S,this._alignment=w,this._priority=this.validatePriority(o)}validatePriority(a){if(!!(0,A.isNumber)(a))return a===Number.POSITIVE_INFINITY?Number.MAX_VALUE:a===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:a}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(a){this._text=a,this.update()}set name(a){this._name=a,this.update()}set tooltip(a){this._tooltip=a,this.update()}set color(a){this._color=a,this.update()}set backgroundColor(a){a&&!F.ALLOWED_BACKGROUND_COLORS.has(a.id)&&(a=void 0),this._backgroundColor=a,this.update()}set command(a){this._command?.fromApi!==a&&(this._internalCommandRegistration.clear(),typeof a=="string"?this._command={fromApi:a,internal:Ae(this,k,"f").toInternal({title:"",command:a},this._internalCommandRegistration)}:a?this._command={fromApi:a,internal:Ae(this,k,"f").toInternal(a,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(a){this._accessibilityInformation=a,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Ae(this,C,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let a;this._extension?this._id?a=`${this._extension.identifier.value}.${this._id}`:a=this._extension.identifier.value:a=this._id;let h;this._name?h=this._name:h=(0,b.localize)(0,null,this._extension.displayName||this._extension.name);let p=this._color;this._backgroundColor&&(p=F.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const S=this._tooltip?t.MarkdownString.fromStrict(this._tooltip):void 0;Ae(this,C,"f").$setEntry(this._entryId,a,h,this._text,S,this._command?.internal,p,this._backgroundColor,this._alignment===u.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=F,C=new WeakMap,k=new WeakMap,F.ID_GEN=0,F.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new u.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new u.ThemeColor("statusBarItem.warningForeground")]]);class y{constructor(a){this._messages=[],this._item=a.createStatusBarEntry(void 0,"status.extensionMessage",u.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,b.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(a){const h={message:a};return this._messages.unshift(h),this._update(),new u.Disposable(()=>{const p=this._messages.indexOf(h);p>=0&&(this._messages.splice(p,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class r{constructor(a,h){this._proxy=a.getProxy(M.MainContext.MainThreadStatusBar),this._commands=h,this._statusMessage=new y(this)}createStatusBarEntry(a,h,p,S){return new F(this._proxy,this._commands,a,h,p,S)}setStatusBarMessage(a,h){const p=this._statusMessage.setMessage(a);let S;return typeof h=="number"?S=setTimeout(()=>p.dispose(),h):typeof h!="undefined"&&h.then(()=>p.dispose(),()=>p.dispose()),new u.Disposable(()=>{p.dispose(),clearTimeout(S)})}}e.ExtHostStatusBar=r}),define(be[73],Ee([0,1,5,3,4]),function(re,e,u,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class P{constructor(A){this._onDidChangeStorage=new M.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=A.getProxy(u.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(A,C){this._proxy.$registerExtensionStorageKeysToSync(A,C)}getValue(A,C,k){return this._proxy.$getValue(A,C).then(F=>F||k)}setValue(A,C,k){return this._proxy.$setValue(A,C,k)}$acceptValue(A,C,k){this._onDidChangeStorage.fire({shared:A,key:C,value:k})}}e.ExtHostStorage=P,e.IExtHostStorage=(0,b.createDecorator)("IExtHostStorage")}),define(be[74],Ee([0,1,4,28,12,52,2]),function(re,e,u,M,b,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,u.createDecorator)("IExtensionStoragePaths");let A=class{constructor(k,F,y){this._logService=F,this._extHostFileSystem=y,this._workspace=k.workspace??void 0,this._environment=k.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(r=>this._value=r)}async _getWorkspaceStorageURI(k){return t.URI.joinPath(this._environment.workspaceStorageHome,k)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const k=this._workspace.id,F=await this._getWorkspaceStorageURI(k);try{return await this._extHostFileSystem.value.stat(F),this._logService.trace("[ExtHostStorage] storage dir already exists",F),F}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",F),await this._extHostFileSystem.value.createDirectory(F),await this._extHostFileSystem.value.writeFile(t.URI.joinPath(F,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:t.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),F}catch(y){this._logService.error("[ExtHostStorage]",y);return}}workspaceValue(k){if(this._value)return t.URI.joinPath(this._value,k.identifier.value)}globalValue(k){return t.URI.joinPath(this._environment.globalStorageHome,k.identifier.value.toLowerCase())}onWillDeactivateAll(){}};A=Ue([Be(0,M.IExtHostInitDataService),Be(1,b.ILogService),Be(2,P.IExtHostConsumerFileSystem)],A),e.ExtensionStoragePaths=A}),define(be[41],Ee([0,1,3,5,4,2,14,6,7,129,16,170,21,37,151,48,10,13]),function(re,e,u,M,b,P,t,A,C,k,F,y,r,m,a,h,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,b.createDecorator)("IExtHostTerminalService");class w{constructor(f,s,v,l){this._proxy=f,this._id=s,this._creationOptions=v,this._name=l,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(T=>this._pidPromiseComplete=T);const E=this;this.value={get name(){return E._name||""},get processId(){return E._pidPromise},get creationOptions(){return E._creationOptions},get exitStatus(){return E._exitStatus},get state(){return E._state},sendText(T,I=!0){E._checkDisposed(),E._proxy.$sendText(E._id,T,I)},show(T){E._checkDisposed(),E._proxy.$show(E._id,T)},hide(){E._checkDisposed(),E._proxy.$hide(E._id)},dispose(){E._disposed||(E._disposed=!0,E._proxy.$dispose(E._id))},get dimensions(){if(!(E._cols===void 0||E._rows===void 0))return{columns:E._cols,rows:E._rows}}}}async create(f,s){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:f.name,shellPath:(0,p.withNullAsUndefined)(f.shellPath),shellArgs:(0,p.withNullAsUndefined)(f.shellArgs),cwd:(0,p.withNullAsUndefined)(f.cwd),env:(0,p.withNullAsUndefined)(f.env),icon:(0,p.withNullAsUndefined)(n(f.iconPath)),color:h.ThemeColor.isThemeColor(f.color)?f.color.id:void 0,initialText:(0,p.withNullAsUndefined)(f.message),strictEnv:(0,p.withNullAsUndefined)(f.strictEnv),hideFromUser:(0,p.withNullAsUndefined)(f.hideFromUser),isFeatureTerminal:(0,p.withNullAsUndefined)(s?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,p.withNullAsUndefined)(s?.useShellEnvironment),location:s?.location||this._serializeParentTerminal(f.location,s?.resolvedExtHostIdentifier)})}async createExtensionTerminal(f,s,v,l){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:v,color:h.ThemeColor.isThemeColor(l)?l.id:void 0,location:this._serializeParentTerminal(f,s)}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(f,s){return typeof f=="object"?"parentTerminal"in f&&f.parentTerminal&&s?{parentTerminal:s}:"viewColumn"in f?{viewColumn:f.viewColumn,preserveFocus:f.preserveFocus}:void 0:f}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(f){this._name=f}setExitCode(f){this._exitStatus=Object.freeze({code:f})}setDimensions(f,s){return f===this._cols&&s===this._rows||f===0||s===0?!1:(this._cols=f,this._rows=s,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(f){this._pidPromiseComplete?(this._pidPromiseComplete(f),this._pidPromiseComplete=void 0):this._pidPromise.then(s=>{s!==f&&(this._pidPromise=Promise.resolve(f))})}}e.ExtHostTerminal=w;class o{constructor(f){this._pty=f,this.id=0,this.shouldPersist=!1,this._capabilities=[],this._onProcessData=new u.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new u.Emitter,this._onDidChangeProperty=new u.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new u.Emitter,this.onProcessExit=this._onProcessExit.event}get capabilities(){return this._capabilities}get onProcessReady(){return this._onProcessReady.event}refreshProperty(f){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${f}`)}updateProperty(f,s){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${f}, value: ${s}`)}async start(){}shutdown(){this._pty.close()}input(f){this._pty.handleInput?.(f)}resize(f,s){this._pty.setDimensions?.({columns:f,rows:s})}async processBinary(f){}acknowledgeDataEvent(f){}async setUnicodeVersion(f){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(f){this._pty.onDidWrite(s=>this._onProcessData.fire(s)),this._pty.onDidClose?.((s=void 0)=>{this._onProcessExit.fire(s===void 0?void 0:s)}),this._pty.onDidOverrideDimensions?.(s=>{s&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:s.columns,rows:s.rows}})}),this._pty.onDidChangeName?.(s=>{this._onDidChangeProperty.fire({type:"title",value:s})}),this._pty.open(f||void 0),f&&this._pty.setDimensions?.(f),this._onProcessReady.fire({pid:-1,cwd:"",capabilities:this._capabilities})}}e.ExtHostPseudoterminal=o;let d=1,_=class extends A.Disposable{constructor(f,s){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new u.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new u.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new u.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new u.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new u.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=s.getProxy(M.MainContext.MainThreadTerminalService),this._bufferer=new a.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new u.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(f),this._register({dispose:()=>{for(const[v,l]of this._terminalProcesses)l.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(f=>f.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(f){return(f?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(f){return(f?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(f,s){const v=new w(this._proxy,(0,m.generateUuid)(),f,f.name),l=new o(f.pty);return v.createExtensionTerminal(f.location,this._serializeParentTerminal(f,s).resolvedExtHostIdentifier,n(f.iconPath),i(f.color)).then(E=>{const T=this._setupExtHostProcessListeners(E,l);this._terminalProcessDisposables[E]=T}),this._terminals.push(v),v.value}_serializeParentTerminal(f,s){if(s=s||{},f.location&&typeof f.location=="object"&&"parentTerminal"in f.location){const v=f.location.parentTerminal;if(v){const l=this._terminals.find(E=>E.value===v);l&&(s.resolvedExtHostIdentifier=l._id)}}else f.location&&typeof f.location!="object"?s.location=f.location:s.location&&typeof s.location=="object"&&"splitActiveTerminal"in s.location&&(s.location={splitActiveTerminal:!0});return s}attachPtyToTerminal(f,s){if(!this._getTerminalById(f))throw new Error(`Cannot resolve terminal with id ${f} for virtual process`);const l=new o(s),E=this._setupExtHostProcessListeners(f,l);this._terminalProcessDisposables[f]=E}async $acceptActiveTerminalChanged(f){const s=this._activeTerminal;if(f===null){this._activeTerminal=void 0,s!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const v=this._getTerminalById(f);v&&(this._activeTerminal=v,s!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(f,s){const v=this._getTerminalById(f);v&&this._onDidWriteTerminalData.fire({terminal:v.value,data:s})}async $acceptTerminalDimensions(f,s,v){const l=this._getTerminalById(f);l&&l.setDimensions(s,v)&&this._onDidChangeTerminalDimensions.fire({terminal:l.value,dimensions:l.value.dimensions})}async $acceptTerminalMaximumDimensions(f,s,v){this._terminalProcesses.get(f)?.resize(s,v)}async $acceptTerminalTitleChange(f,s){const v=this._getTerminalById(f);v&&(v.name=s)}async $acceptTerminalClosed(f,s){const v=this._getTerminalObjectIndexById(this._terminals,f);if(v!==null){const l=this._terminals.splice(v,1)[0];l.setExitCode(s),this._onDidCloseTerminal.fire(l.value)}}$acceptTerminalOpened(f,s,v,l){if(s){const I=this._getTerminalObjectIndexById(this._terminals,s);if(I!==null){this._terminals[I]._id=f,this._onDidOpenTerminal.fire(this.terminals[I]),this._terminals[I].isOpen=!0;return}}const E={name:l.name,shellPath:l.executable,shellArgs:l.args,cwd:typeof l.cwd=="string"?l.cwd:P.URI.revive(l.cwd),env:l.env,hideFromUser:l.hideFromUser},T=new w(this._proxy,f,E,v);this._terminals.push(T),this._onDidOpenTerminal.fire(T.value),T.isOpen=!0}async $acceptTerminalProcessId(f,s){const v=this._getTerminalById(f);v&&v._setProcessId(s)}async $startExtensionTerminal(f,s){const v=this._getTerminalById(f);if(!v)return{message:(0,k.localize)(0,null,f)};v.isOpen||await new Promise(E=>{const T=this.onDidOpenTerminal(async I=>{I===v.value&&(T.dispose(),E())})});const l=this._terminalProcesses.get(f);l?l.startSendingEvents(s):this._extensionTerminalAwaitingStart[f]={initialDimensions:s}}_setupExtHostProcessListeners(f,s){const v=new A.DisposableStore;v.add(s.onProcessReady(E=>this._proxy.$sendProcessReady(f,E.pid,E.cwd))),v.add(s.onDidChangeProperty(E=>this._proxy.$sendProcessProperty(f,E))),this._bufferer.startBuffering(f,s.onProcessData),v.add(s.onProcessExit(E=>this._onProcessExit(f,E))),this._terminalProcesses.set(f,s);const l=this._extensionTerminalAwaitingStart[f];return l&&s instanceof o&&(s.startSendingEvents(l.initialDimensions),delete this._extensionTerminalAwaitingStart[f]),v}$acceptProcessAckDataEvent(f,s){this._terminalProcesses.get(f)?.acknowledgeDataEvent(s)}$acceptProcessInput(f,s){this._terminalProcesses.get(f)?.input(s)}$acceptTerminalInteraction(f){const s=this._getTerminalById(f);s?.setInteractedWith()&&this._onDidChangeTerminalState.fire(s.value)}$acceptProcessResize(f,s,v){try{this._terminalProcesses.get(f)?.resize(s,v)}catch(l){if(l.code!=="EPIPE"&&l.code!=="ERR_IPC_CHANNEL_CLOSED")throw l}}$acceptProcessShutdown(f,s){this._terminalProcesses.get(f)?.shutdown(s)}$acceptProcessRequestInitialCwd(f){this._terminalProcesses.get(f)?.getInitialCwd().then(s=>this._proxy.$sendProcessProperty(f,{type:"initialCwd",value:s}))}$acceptProcessRequestCwd(f){this._terminalProcesses.get(f)?.getCwd().then(s=>this._proxy.$sendProcessProperty(f,{type:"cwd",value:s}))}$acceptProcessRequestLatency(f){return f}registerLinkProvider(f){return this._linkProviders.add(f),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new C.Disposable(()=>{this._linkProviders.delete(f),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(f,s,v){if(this._profileProviders.has(s))throw new Error(`Terminal profile provider "${s}" already registered`);return this._profileProviders.set(s,v),this._proxy.$registerProfileProvider(s,f.identifier.value),new C.Disposable(()=>{this._profileProviders.delete(s),this._proxy.$unregisterProfileProvider(s)})}async $createContributedProfileTerminal(f,s){const v=new r.CancellationTokenSource().token;let l=await this._profileProviders.get(f)?.provideTerminalProfile(v);if(!v.isCancellationRequested){if(l&&!("options"in l)&&(l={options:l}),!l||!("options"in l))throw new Error(`No terminal profile options provided for id "${f}"`);if("pty"in l.options){this.createExtensionTerminal(l.options,s);return}this.createTerminalFromOptions(l.options,s)}}async $provideLinks(f,s){const v=this._getTerminalById(f);if(!v)return[];this._terminalLinkCache.delete(f);const l=this._terminalLinkCancellationSource.get(f);l&&l.dispose(!0);const E=new r.CancellationTokenSource;this._terminalLinkCancellationSource.set(f,E);const T=[],I={terminal:v.value,line:s},B=[];for(const x of this._linkProviders)B.push(S.Promises.withAsyncBody(async N=>{E.token.onCancellationRequested(()=>N({provider:x,links:[]}));const V=await x.provideTerminalLinks(I,E.token)||[];E.token.isCancellationRequested||N({provider:x,links:V})}));const O=await Promise.all(B);if(E.token.isCancellationRequested)return[];const D=new Map;for(const x of O)x&&x.links.length>0&&T.push(...x.links.map(N=>{const V={id:d++,startIndex:N.startIndex,length:N.length,label:N.tooltip};return D.set(V.id,{provider:x.provider,link:N}),V}));return this._terminalLinkCache.set(f,D),T}$activateLink(f,s){const v=this._terminalLinkCache.get(f)?.get(s);!v||v.provider.handleTerminalLink(v.link)}_onProcessExit(f,s){this._bufferer.stopBuffering(f),this._terminalProcesses.delete(f),delete this._extensionTerminalAwaitingStart[f];const v=this._terminalProcessDisposables[f];v&&(v.dispose(),delete this._terminalProcessDisposables[f]),this._proxy.$sendProcessExit(f,s)}_getTerminalById(f){return this._getTerminalObjectById(this._terminals,f)}_getTerminalObjectById(f,s){const v=this._getTerminalObjectIndexById(f,s);return v!==null?f[v]:null}_getTerminalObjectIndexById(f,s){let v=null;return f.some((l,E)=>l._id===s?(v=E,!0):!1),v}getEnvironmentVariableCollection(f){let s=this._environmentVariableCollections.get(f.identifier.value);return s||(s=new c,this._setEnvironmentVariableCollection(f.identifier.value,s)),s}_syncEnvironmentVariableCollection(f,s){const v=(0,y.serializeEnvironmentVariableCollection)(s.map);this._proxy.$setEnvironmentVariableCollection(f,s.persistent,v.length===0?void 0:v)}$initEnvironmentVariableCollections(f){f.forEach(s=>{const v=s[0],l=new c(s[1]);this._setEnvironmentVariableCollection(v,l)})}$acceptDefaultProfile(f,s){this._defaultProfile=f,this._defaultAutomationProfile=s}_setEnvironmentVariableCollection(f,s){this._environmentVariableCollections.set(f,s),s.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(f,s)})}};_=Ue([Be(1,t.IExtHostRpcService)],_),e.BaseExtHostTerminalService=_;class c{constructor(f){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new u.Emitter,this.map=new Map(f)}get persistent(){return this._persistent}set persistent(f){this._persistent=f,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(f,s){this._setIfDiffers(f,{value:s,type:C.EnvironmentVariableMutatorType.Replace})}append(f,s){this._setIfDiffers(f,{value:s,type:C.EnvironmentVariableMutatorType.Append})}prepend(f,s){this._setIfDiffers(f,{value:s,type:C.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(f,s){const v=this.map.get(f);(!v||v.value!==s.value||v.type!==s.type)&&(this.map.set(f,s),this._onDidChangeCollection.fire())}get(f){return this.map.get(f)}forEach(f,s){this.map.forEach((v,l)=>f.call(s,l,v,this))}delete(f){this.map.delete(f),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=c;let R=class extends _{constructor(f){super(!1,f)}createTerminal(f,s,v){throw new F.NotSupportedError}createTerminalFromOptions(f,s){throw new F.NotSupportedError}};R=Ue([Be(0,t.IExtHostRpcService)],R),e.WorkerExtHostTerminalService=R;function n(g){if(!(!g||typeof g=="string"))return"id"in g?{id:g.id,color:g.color}:g}function i(g){return h.ThemeColor.isThemeColor(g)?g:void 0}});var Xe=this&&this.__classPrivateFieldSet||function(re,e,u,M,b){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!b:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?b.call(re,u):b?b.value=u:e.set(re,u),u},Ae=this&&this.__classPrivateFieldGet||function(re,e,u,M){if(u==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?M:u==="a"?M.call(re):M?M.value:e.get(re)};define(be[209],Ee([0,1,15,22,21,3,238,60,6,23,10,37,5,14,50,8,7,178,90,69]),function(re,e,u,M,b,P,t,A,C,k,F,y,r,m,a,h,p,S,w,o){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let _=class{constructor(I,B){this.resultsChangedEmitter=new P.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=I.getProxy(r.MainContext.MainThreadTesting),this.observer=new v(this.proxy),this.runTracker=new R(this.proxy),B.registerArgumentProcessor({processArgument:O=>O?.$mid===13?h.TestItem.toItemFromContext(O):O})}createTestController(I,B){if(this.controllers.has(I))throw new Error(`Attempt to insert a duplicate controller with ID "${I}"`);const O=new C.DisposableStore,D=O.add(new S.SingleUseTestCollection(I));D.root.label=B;const x=new Map,N=this.proxy,V={items:D.root.children,get label(){return B},set label(z){B=z,D.root.label=z,N.$updateControllerLabel(I,B)},get id(){return I},createRunProfile:(z,ee,j,Q,le)=>{let ve=(0,A.hash)(z);for(;x.has(ve);)ve++;const ue=new l(this.proxy,I,ve,z,ee,j,Q,le);return x.set(ve,ue),ue},createTestItem(z,ee,j){return new a.TestItemImpl(I,z,ee,j)},createTestRun:(z,ee,j=!0)=>this.runTracker.createTestRun(I,D,z,ee,j),set resolveHandler(z){D.resolveHandler=z},get resolveHandler(){return D.resolveHandler},dispose:()=>{O.dispose()}};V.createRunConfiguration=V.createRunProfile,N.$registerTestController(I,B),O.add((0,C.toDisposable)(()=>N.$unregisterTestController(I)));const $={controller:V,collection:D,profiles:x};return this.controllers.set(I,$),O.add((0,C.toDisposable)(()=>this.controllers.delete(I))),O.add(D.onDidGenerateDiff(z=>N.$publishDiff(I,z))),V}createTestObserver(){return this.observer.checkout()}async runTests(I,B=b.CancellationToken.None){const O=n(I);if(!O)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const D=this.controllers.get(O.controllerId);if(!D)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:I.include?.map(x=>x.id)??[D.collection.root.id],profileGroup:E[O.kind],profileId:O.profileId,controllerId:O.controllerId}],exclude:I.exclude?.map(x=>x.id)},B)}$provideFileCoverage(I,B,O){return(0,u.mapFind)(this.runTracker.trackers,x=>x.id===I?x.getCoverage(B):void 0)?.provideFileCoverage(O)??Promise.resolve([])}$resolveFileCoverage(I,B,O,D){return(0,u.mapFind)(this.runTracker.trackers,N=>N.id===I?N.getCoverage(B):void 0)?.resolveFileCoverage(O,D)??Promise.resolve([])}$configureRunProfile(I,B){this.controllers.get(I)?.profiles.get(B)?.configureHandler?.()}$publishTestResults(I){this.results=Object.freeze(I.map(B=>(0,k.deepFreeze)(h.TestResults.to(B))).concat(this.results).sort((B,O)=>O.completedAt-B.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(I,B){const O=this.controllers.get(o.TestId.fromString(I).controllerId)?.collection;O&&(await O.expand(I,B<0?Infinity:B),O.flushDiff())}$acceptDiff(I){this.observer.applyDiff(I)}async $runControllerTests(I,B){const O=this.controllers.get(I.controllerId);if(!O)return;const{collection:D,profiles:x}=O,N=x.get(I.profileId);if(!N)return;const V=I.testIds.map(j=>D.tree.get(j)).filter(F.isDefined),$=I.excludeExtIds.map(j=>O.collection.tree.get(j)).filter(F.isDefined).filter(j=>V.some(Q=>Q.fullId.compare(j.fullId)===2));if(!V.length)return;const z=new p.TestRunRequest(V.some(j=>j.actual instanceof a.TestItemRootImpl)?void 0:V.map(j=>j.actual),$.map(j=>j.actual),N),ee=this.runTracker.prepareForMainThreadTestRun(z,i.fromInternal(I,O.collection),B);try{await N.runHandler(z,B)}finally{ee.isRunning&&!B.isCancellationRequested&&await P.Event.toPromise(ee.onEnd),ee.dispose()}}$cancelExtensionTestRun(I){I===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(I)}};_=Ue([Be(0,m.IExtHostRpcService)],_),e.ExtHostTesting=_;class c extends C.Disposable{constructor(I,B,O){super();this.dto=I,this.proxy=B,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new P.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new b.CancellationTokenSource(O)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:D}of this.tasks.values())D.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(I){return this.tasks.get(I)?.coverage}createRun(I){const B=this.dto.id,O=this.dto.controllerId,D=(0,y.generateUuid)(),x=new g(this.proxy,B,D),N=ee=>(j,...Q)=>{if($){console.warn(`Setting the state of test "${j.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(j)||(this.ensureTestIsKnown(j),ee(j,...Q))},V=(ee,j)=>{const Q=j instanceof Array?j.map(h.TestMessage.from):[h.TestMessage.from(j)];if(ee.uri&&ee.range){const le={range:h.Range.from(ee.range),uri:ee.uri};for(const ve of Q)ve.location=ve.location||le}this.proxy.$appendTestMessagesInRun(B,D,o.TestId.fromExtHostTestItem(ee,O).toString(),Q)};let $=!1;const z={isPersisted:this.dto.isPersisted,token:this.cts.token,name:I,get coverageProvider(){return x.coverageProvider},set coverageProvider(ee){x.coverageProvider=ee},enqueued:N(ee=>{this.proxy.$updateTestStateInRun(B,D,o.TestId.fromExtHostTestItem(ee,O).toString(),1)}),skipped:N(ee=>{this.proxy.$updateTestStateInRun(B,D,o.TestId.fromExtHostTestItem(ee,O).toString(),5)}),started:N(ee=>{this.proxy.$updateTestStateInRun(B,D,o.TestId.fromExtHostTestItem(ee,O).toString(),2)}),errored:N((ee,j,Q)=>{V(ee,j),this.proxy.$updateTestStateInRun(B,D,o.TestId.fromExtHostTestItem(ee,O).toString(),6,Q)}),failed:N((ee,j,Q)=>{V(ee,j),this.proxy.$updateTestStateInRun(B,D,o.TestId.fromExtHostTestItem(ee,O).toString(),4,Q)}),passed:N((ee,j)=>{this.proxy.$updateTestStateInRun(B,D,o.TestId.fromExtHostTestItem(ee,this.dto.controllerId).toString(),3,j)}),appendOutput:(ee,j,Q)=>{$||(Q&&(this.dto.isIncluded(Q)?this.ensureTestIsKnown(Q):Q=void 0),this.proxy.$appendOutputToRun(B,D,M.VSBuffer.fromString(ee),j&&h.location.from(j),Q&&o.TestId.fromExtHostTestItem(Q,O).toString()))},end:()=>{$||($=!0,this.proxy.$finishedTestRunTask(B,D),this.tasks.delete(D),this.isRunning||this.dispose())}};return this.tasks.set(D,{run:z,coverage:x}),this.proxy.$startedTestRunTask(B,{id:D,name:I,running:!0}),z}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(I){if(!(I instanceof a.TestItemImpl))throw new a.InvalidTestItemError(I.id);if(this.sharedTestIds.has(o.TestId.fromExtHostTestItem(I,this.dto.controllerId).toString()))return;const B=[],O=this.dto.colllection.root;for(;;){const D=h.TestItem.from(I);if(B.unshift(D),this.sharedTestIds.has(D.extId)||(this.sharedTestIds.add(D.extId),I===O))break;I=I.parent||O}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,B)}}class R{constructor(I){this.proxy=I,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(I,B,O){return this.getTracker(I,B,O)}cancelRunById(I){for(const B of this.tracked.values())if(B.id===I){B.dispose();return}}cancelAllRuns(){for(const I of this.tracked.values())I.dispose()}createTestRun(I,B,O,D,x){const N=this.tracked.get(O);if(N)return N.createRun(D);const V=i.fromPublic(I,B,O,x),$=n(O);this.proxy.$startedExtensionTestRun({controllerId:I,profile:$&&{group:E[$.kind],id:$.profileId},exclude:O.exclude?.map(ee=>ee.id)??[],id:V.id,include:O.include?.map(ee=>ee.id)??[B.root.id],persist:x});const z=this.getTracker(O,V);return z.onEnd(()=>this.proxy.$finishedExtensionTestRun(V.id)),z.createRun(D)}getTracker(I,B,O){const D=new c(B,this.proxy,O);return this.tracked.set(I,D),D.onEnd(()=>this.tracked.delete(I)),D}}e.TestRunCoordinator=R;const n=T=>{if(!!T.profile){if(!(T.profile instanceof l))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return T.profile}};class i{constructor(I,B,O,D,x,N){this.controllerId=I,this.id=B,this.isPersisted=x,this.colllection=N,this.includePrefix=O.map(V=>V+"\0"),this.excludePrefix=D.map(V=>V+"\0")}static fromPublic(I,B,O,D){return new i(I,(0,y.generateUuid)(),O.include?.map(x=>o.TestId.fromExtHostTestItem(x,I).toString())??[I],O.exclude?.map(x=>o.TestId.fromExtHostTestItem(x,I).toString())??[],D,B)}static fromInternal(I,B){return new i(I.controllerId,I.runId,I.testIds,I.excludeExtIds,!0,B)}isIncluded(I){const B=o.TestId.fromExtHostTestItem(I,this.controllerId).toString()+"\0";for(const O of this.excludePrefix)if(B===O||B.startsWith(O))return!1;for(const O of this.includePrefix)if(B===O||B.startsWith(O))return!0;return!1}}e.TestRunDto=i;class g{constructor(I,B,O){this.proxy=I,this.runId=B,this.taskId=O}set coverageProvider(I){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!I||(this._coverageProvider=I,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(I){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(I))());try{return(await this.fileCoverage)?.map(h.TestCoverage.fromFile)??[]}catch(B){throw this.fileCoverage=void 0,B}}async resolveFileCoverage(I,B){const O=await this.fileCoverage;let D=O?.[I];return!this._coverageProvider||!O||!D?[]:(D.detailedCoverage||(D=O[I]=await this._coverageProvider.resolveFileCoverage?.(D,B)??D),D.detailedCoverage?.map(h.TestCoverage.fromDetailed)??[])}}class f extends w.IncrementalChangeCollector{constructor(I){super();this.emitter=I,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(I){this.added.add(I)}update(I){Object.assign(I.revived,h.TestItem.toPlain(I.item)),this.added.has(I)||this.updated.add(I)}remove(I){if(this.added.has(I)){this.added.delete(I);return}if(this.updated.delete(I),I.parent&&this.alreadyRemoved.has(I.parent)){this.alreadyRemoved.add(I.item.extId);return}this.removed.add(I)}getChangeEvent(){const{added:I,updated:B,removed:O}=this;return{get added(){return[...I].map(D=>D.revived)},get updated(){return[...B].map(D=>D.revived)},get removed(){return[...O].map(D=>D.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class s extends w.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new P.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(I){return this.items.get(I)}getMirroredTestDataByReference(I){return this.items.get(I.id)}createItem(I,B){return{...I,revived:h.TestItem.toPlain(I.item),depth:B?B.depth+1:0,children:new Set}}createChangeCollector(){return new f(this.changeEmitter)}}e.MirroredTestCollection=s;class v{constructor(I){this.proxy=I}checkout(){this.current||(this.current=this.createObserverData());const I=this.current;return I.observers++,{onDidChangeTest:I.tests.onDidChangeTests,get tests(){return[...I.tests.rootTests].map(B=>B.revived)},dispose:(0,t.once)(()=>{--I.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(I){return this.current?.tests.getMirroredTestDataByReference(I)}applyDiff(I){this.current?.tests.apply(I)}createObserverData(){const I=new s;return this.proxy.$subscribeToDiffs(),{observers:0,tests:I}}}class l{constructor(I,B,O,D,x,N,V=!1,$=void 0){this.controllerId=B,this.profileId=O,this._label=D,this.kind=x,this.runHandler=N,this._isDefault=V,this._tag=$,d.set(this,void 0),Xe(this,d,I,"f");const z=E[x];if(typeof z!="number")throw new Error(`Unknown TestRunProfile.group ${x}`);Ae(this,d,"f").$publishTestRunProfile({profileId:O,controllerId:B,tag:$?h.TestTag.namespace(this.controllerId,$.id):null,label:D,group:z,isDefault:V,hasConfigurationHandler:!1})}get label(){return this._label}set label(I){I!==this._label&&(this._label=I,Ae(this,d,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:I}))}get isDefault(){return this._isDefault}set isDefault(I){I!==this._isDefault&&(this._isDefault=I,Ae(this,d,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:I}))}get tag(){return this._tag}set tag(I){I?.id!==this._tag?.id&&(this._tag=I,Ae(this,d,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:I?h.TestTag.namespace(this.controllerId,I.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(I){I!==this._configureHandler&&(this._configureHandler=I,Ae(this,d,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!I}))}dispose(){Ae(this,d,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=l,d=new WeakMap;const E={[p.TestRunProfileKind.Coverage]:8,[p.TestRunProfileKind.Debug]:4,[p.TestRunProfileKind.Run]:2}}),define(be[210],Ee([0,1,3,15,5,94,8,7]),function(re,e,u,M,b,P,t,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class C{constructor(F,y){this._extHostDocumentsAndEditors=y,this._onDidChangeTextEditorSelection=new u.Emitter,this._onDidChangeTextEditorOptions=new u.Emitter,this._onDidChangeTextEditorVisibleRanges=new u.Emitter,this._onDidChangeTextEditorViewColumn=new u.Emitter,this._onDidChangeActiveTextEditor=new u.Emitter,this._onDidChangeVisibleTextEditors=new u.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=F.getProxy(b.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(r=>this._onDidChangeVisibleTextEditors.fire(r)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(r=>this._onDidChangeActiveTextEditor.fire(r))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(F){const y=this._extHostDocumentsAndEditors.allEditors();return F?y:y.map(r=>r.value)}async showTextDocument(F,y,r){let m;typeof y=="number"?m={position:t.ViewColumn.from(y),preserveFocus:r}:typeof y=="object"?m={position:t.ViewColumn.from(y.viewColumn),preserveFocus:y.preserveFocus,selection:typeof y.selection=="object"?t.Range.from(y.selection):void 0,pinned:typeof y.preview=="boolean"?!y.preview:void 0}:m={preserveFocus:!1};const a=await this._proxy.$tryShowTextDocument(F.uri,m),h=a&&this._extHostDocumentsAndEditors.getEditor(a);if(h)return h.value;throw a?new Error(`Could NOT open editor for "${F.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${F.uri.toString()}".`)}createTextEditorDecorationType(F,y){return new P.TextEditorDecorationType(this._proxy,F,y).value}$acceptEditorPropertiesChanged(F,y){const r=this._extHostDocumentsAndEditors.getEditor(F);if(!r)throw new Error("unknown text editor");if(y.options&&r._acceptOptions(y.options),y.selections){const m=y.selections.selections.map(t.Selection.to);r._acceptSelections(m)}if(y.visibleRanges){const m=M.coalesce(y.visibleRanges.map(t.Range.to));r._acceptVisibleRanges(m)}if(y.options&&this._onDidChangeTextEditorOptions.fire({textEditor:r.value,options:{...y.options,lineNumbers:t.TextEditorLineNumbersStyle.to(y.options.lineNumbers)}}),y.selections){const m=A.TextEditorSelectionChangeKind.fromValue(y.selections.source),a=y.selections.selections.map(t.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:r.value,selections:a,kind:m})}if(y.visibleRanges){const m=M.coalesce(y.visibleRanges.map(t.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:r.value,visibleRanges:m})}}$acceptEditorPositionData(F){for(const y in F){const r=this._extHostDocumentsAndEditors.getEditor(y);if(!r)throw new Error("Unknown text editor");const m=t.ViewColumn.to(F[y]);r.value.viewColumn!==m&&(r._acceptViewColumn(m),this._onDidChangeTextEditorViewColumn.fire({textEditor:r.value,viewColumn:m}))}}getDiffInformation(F){return Promise.resolve(this._proxy.$getDiffInformation(F))}}e.ExtHostEditors=C}),define(be[211],Ee([0,1,2,4,5,6,7]),function(re,e,u,M,b,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,M.createDecorator)("IExtHostTimeline");class A{constructor(F,y){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=F.getProxy(b.MainContext.MainThreadTimeline),y.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===11){const m=r.uri===void 0?void 0:u.URI.revive(r.uri);return this._itemsBySourceAndUriMap.get(r.source)?.get(C(m))?.get(r.handle)}return r}})}async $getTimeline(F,y,r,m,a){return this._providers.get(F)?.provideTimeline(u.URI.revive(y),r,m,a)}registerTimelineProvider(F,y,r,m){const a=new P.DisposableStore,h=this.convertTimelineItem(y.id,m,a).bind(this);let p;y.onDidChange&&(p=y.onDidChange(w=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...w,id:y.id}),this));const S=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...y,scheme:F,onDidChange:void 0,async provideTimeline(w,o,d,_){_?.resetCache&&(a.clear(),S.get(y.id)?.clear());const c=await y.provideTimeline(w,o,d);if(c==null)return;const R=h(w,_);return{...c,source:y.id,items:c.items.map(R)}},dispose(){for(const w of S.values())w.get(y.id)?.clear();p?.dispose(),a.dispose()}})}convertTimelineItem(F,y,r){return(m,a)=>{let h;if(a?.cacheResults){let p=this._itemsBySourceAndUriMap.get(F);p===void 0&&(p=new Map,this._itemsBySourceAndUriMap.set(F,p));const S=C(m);h=p.get(S),h===void 0&&(h=new Map,p.set(S,h))}return p=>{const{iconPath:S,...w}=p,o=`${F}|${p.id??p.timestamp}`;h?.set(o,p);let d,_,c;return p.iconPath&&(S instanceof t.ThemeIcon?c={id:S.id,color:S.color}:u.URI.isUri(S)?(d=S,_=S):{light:d,dark:_}=S),{...w,id:w.id??void 0,handle:o,source:F,command:p.command?y.toInternal(p.command,r):void 0,icon:d,iconDark:_,themeIcon:c,accessibilityInformation:p.accessibilityInformation}}}}registerTimelineProviderCore(F){if(this._providers.get(F.id))throw new Error(`Timeline Provider ${F.id} already exists.`);return this._proxy.$registerTimelineProvider({id:F.id,label:F.label,scheme:F.scheme}),this._providers.set(F.id,F),(0,P.toDisposable)(()=>{for(const r of this._itemsBySourceAndUriMap.values())r.get(F.id)?.clear();this._providers.delete(F.id),this._proxy.$unregisterTimelineProvider(F.id),F.dispose()})}}e.ExtHostTimeline=A;function C(k){return k?.toString()}}),define(be[212],Ee([0,1,6,11,2,5]),function(re,e,u,M,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class t{constructor(C){this._openers=new Map,this._proxy=C.getProxy(P.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(C,k,F,y){if(this._openers.has(k))throw new Error(`Opener with id '${k}' already registered`);const r=y.schemes.find(m=>!t.supportedSchemes.has(m));if(r)throw new Error(`Scheme '${r}' is not supported. Only http and https are currently supported.`);return this._openers.set(k,F),this._proxy.$registerUriOpener(k,y.schemes,C,y.label),(0,u.toDisposable)(()=>{this._openers.delete(k),this._proxy.$unregisterUriOpener(k)})}async $canOpenUri(C,k,F){const y=this._openers.get(C);if(!y)throw new Error(`Unknown opener with id: ${C}`);const r=b.URI.revive(k);return y.canOpenExternalUri(r,F)}async $openUri(C,k,F){const y=this._openers.get(C);if(!y)throw new Error(`Unknown opener id: '${C}'`);return y.openExternalUri(b.URI.revive(k.resolvedUri),{sourceUri:b.URI.revive(k.sourceUri)},F)}}e.ExtHostUriOpeners=t,t.supportedSchemes=new Set([M.Schemas.http,M.Schemas.https])}),define(be[213],Ee([0,1,5,2,6,16,26]),function(re,e,u,M,b,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class A{constructor(k){this.handles=new Set,this.handlers=new Map,this._proxy=k.getProxy(u.MainContext.MainThreadUrls)}registerUriHandler(k,F){if(this.handles.has(t.ExtensionIdentifier.toKey(k)))throw new Error(`Protocol handler already registered for extension ${k}`);const y=A.HandlePool++;return this.handles.add(t.ExtensionIdentifier.toKey(k)),this.handlers.set(y,F),this._proxy.$registerUriHandler(y,k),(0,b.toDisposable)(()=>{this.handles.delete(t.ExtensionIdentifier.toKey(k)),this.handlers.delete(y),this._proxy.$unregisterUriHandler(y)})}$handleExternalUri(k,F){const y=this.handlers.get(k);if(!y)return Promise.resolve(void 0);try{y.handleUri(M.URI.revive(F))}catch(r){(0,P.onUnexpectedError)(r)}return Promise.resolve(void 0)}async createAppUri(k){return M.URI.revive(await this._proxy.$createAppUri(k))}}e.ExtHostUrls=A,A.HandlePool=0});var Xe=this&&this.__classPrivateFieldSet||function(re,e,u,M,b){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!b:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?b.call(re,u):b?b.value=u:e.set(re,u),u},Ae=this&&this.__classPrivateFieldGet||function(re,e,u,M){if(u==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?M:u==="a"?M.call(re):M?M.value:e.get(re)};define(be[53],Ee([0,1,3,11,2,139,159,68,5]),function(re,e,u,M,b,P,t,A,C){"use strict";var k,F,y,r,m,a,h,p,S,w,o,d;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class _{constructor(v,l,E,T,I,B,O){k.set(this,void 0),F.set(this,void 0),y.set(this,void 0),r.set(this,void 0),m.set(this,void 0),a.set(this,void 0),h.set(this,""),p.set(this,void 0),S.set(this,!1),w.set(this,!1),o.set(this,!1),this._onMessageEmitter=new u.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,d.set(this,new u.Emitter),this._onDidDispose=Ae(this,d,"f").event,Xe(this,k,v,"f"),Xe(this,F,l,"f"),Xe(this,p,E,"f"),Xe(this,r,T,"f"),Xe(this,m,I,"f"),Xe(this,a,B,"f"),Xe(this,o,c(B),"f"),Xe(this,y,O,"f")}dispose(){Xe(this,S,!0,"f"),Ae(this,d,"f").fire(),Ae(this,d,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(v){return Xe(this,w,!0,"f"),(0,A.asWebviewUri)(v,Ae(this,r,"f").remote)}get cspSource(){const v=Ae(this,a,"f").extensionLocation;if(v.scheme===M.Schemas.https||v.scheme===M.Schemas.http){let l=v.toString();return l.endsWith("/")||(l+="/"),l+" "+A.webviewGenericCspSource}return A.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Ae(this,h,"f")}set html(v){this.assertNotDisposed(),Ae(this,h,"f")!==v&&(Xe(this,h,v,"f"),!Ae(this,w,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(v)&&(Xe(this,w,!0,"f"),Ae(this,y,"f").report("Webview vscode-resource: uris",Ae(this,a,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ae(this,F,"f").$setHtml(Ae(this,k,"f"),v))}get options(){return this.assertNotDisposed(),Ae(this,p,"f")}set options(v){this.assertNotDisposed(),Ae(this,F,"f").$setOptions(Ae(this,k,"f"),i(Ae(this,a,"f"),Ae(this,m,"f"),v)),Xe(this,p,v,"f")}async postMessage(v){if(Ae(this,S,"f"))return!1;const l=(0,t.serializeWebviewMessage)(v,{serializeBuffersForPostMessage:Ae(this,o,"f")});return Ae(this,F,"f").$postMessage(Ae(this,k,"f"),l.message,...l.buffers)}assertNotDisposed(){if(Ae(this,S,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=_,k=new WeakMap,F=new WeakMap,y=new WeakMap,r=new WeakMap,m=new WeakMap,a=new WeakMap,h=new WeakMap,p=new WeakMap,S=new WeakMap,w=new WeakMap,o=new WeakMap,d=new WeakMap;function c(s){try{const v=(0,P.normalizeVersion)((0,P.parseVersion)(s.engines.vscode));return!!v&&v.majorBase>=1&&v.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=c;class R{constructor(v,l,E,T,I){this.initData=l,this.workspace=E,this._logService=T,this._deprecationService=I,this._webviews=new Map,this._webviewProxy=v.getProxy(C.MainContext.MainThreadWebviews)}$onMessage(v,l,...E){const T=this.getWebview(v);if(T){const{message:I}=(0,t.deserializeWebviewMessage)(l,E);T._onMessageEmitter.fire(I)}}$onMissingCsp(v,l){this._logService.warn(`${l} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(v,l,E){const T=new _(v,this._webviewProxy,g(l),this.initData,this.workspace,E,this._deprecationService);return this._webviews.set(v,T),T._onDidDispose(()=>{this._webviews.delete(v)}),T}deleteWebview(v){this._webviews.delete(v)}getWebview(v){return this._webviews.get(v)}}e.ExtHostWebviews=R;function n(s){return{id:s.identifier,location:s.extensionLocation}}e.toExtensionData=n;function i(s,v,l){return{enableCommandUris:l.enableCommandUris,enableScripts:l.enableScripts,enableForms:l.enableForms,portMapping:l.portMapping,localResourceRoots:l.localResourceRoots||f(s,v)}}e.serializeWebviewOptions=i;function g(s){return{enableCommandUris:s.enableCommandUris,enableScripts:s.enableScripts,enableForms:s.enableForms,portMapping:s.portMapping,localResourceRoots:s.localResourceRoots?.map(v=>b.URI.from(v))}}e.reviveOptions=g;function f(s,v){return[...(v?.getWorkspaceFolders()||[]).map(l=>l.uri),s.extensionLocation]}}),define(be[214],Ee([0,1,21,60,6,11,24,2,8,53,65,5,7]),function(re,e,u,M,b,P,t,A,C,k,F,y,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class m{constructor(c,R){this.document=c,this._storagePath=R,this._backupCounter=1,this._edits=new F.Cache("custom documents")}addEdit(c){return this._edits.add([c])}async undo(c,R){await this.getEdit(c).undo(),R||this.disposeBackup()}async redo(c,R){await this.getEdit(c).redo(),R||this.disposeBackup()}disposeEdits(c){for(const R of c)this._edits.delete(R)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const c=d(this.document.uri)+this._backupCounter++;return(0,t.joinPath)(this._storagePath,c)}updateBackup(c){this._backup?.delete(),this._backup=c}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(c){const R=this._edits.get(c,0);if(!R)throw new Error("No edit found");return R}}class a{constructor(){this._documents=new Map}get(c,R){return this._documents.get(this.key(c,R))}add(c,R,n){const i=this.key(c,R.uri);if(this._documents.has(i))throw new Error(`Document already exists for viewType:${c} resource:${R.uri}`);const g=new m(R,n);return this._documents.set(i,g),g}delete(c,R){const n=this.key(c,R.uri);this._documents.delete(n)}key(c,R){return`${c}@@@${R}`}}var h;(function(_){_[_.Text=0]="Text",_[_.Custom=1]="Custom"})(h||(h={}));class p{constructor(){this._providers=new Map}addTextProvider(c,R,n){return this.add(0,c,R,n)}addCustomProvider(c,R,n){return this.add(1,c,R,n)}get(c){return this._providers.get(c)}add(c,R,n,i){if(this._providers.has(R))throw new Error(`Provider for viewType:${R} already registered`);return this._providers.set(R,{type:c,extension:n,provider:i}),new r.Disposable(()=>this._providers.delete(R))}}class S{constructor(c,R,n,i,g){this._extHostDocuments=R,this._extensionStoragePaths=n,this._extHostWebview=i,this._extHostWebviewPanels=g,this._editorProviders=new p,this._documents=new a,this._proxy=c.getProxy(y.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(c,R,n,i){const g=new b.DisposableStore;return w(n)?(g.add(this._editorProviders.addTextProvider(R,c,n)),this._proxy.$registerTextEditorProvider((0,k.toExtensionData)(c),R,i.webviewOptions||{},{supportsMove:!!n.moveCustomTextEditor},(0,k.shouldSerializeBuffersForPostMessage)(c))):(g.add(this._editorProviders.addCustomProvider(R,c,n)),this.supportEditing(n)&&g.add(n.onDidChangeCustomDocument(f=>{const s=this.getCustomDocumentEntry(R,f.document.uri);if(o(f)){const v=s.addEdit(f);this._proxy.$onDidEdit(f.document.uri,R,v,f.label)}else this._proxy.$onContentChange(f.document.uri,R)})),this._proxy.$registerCustomEditorProvider((0,k.toExtensionData)(c),R,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,(0,k.shouldSerializeBuffersForPostMessage)(c))),r.Disposable.from(g,new r.Disposable(()=>{this._proxy.$unregisterEditorProvider(R)}))}async $createCustomDocument(c,R,n,i,g){const f=this._editorProviders.get(R);if(!f)throw new Error(`No provider found for '${R}'`);if(f.type!==1)throw new Error(`Invalid provide type for '${R}'`);const s=A.URI.revive(c),v=await f.provider.openCustomDocument(s,{backupId:n,untitledDocumentData:i?.buffer},g);let l;return this.supportEditing(f.provider)&&this._extensionStoragePaths&&(l=this._extensionStoragePaths.workspaceValue(f.extension)??this._extensionStoragePaths.globalValue(f.extension)),this._documents.add(R,v,l),{editable:this.supportEditing(f.provider)}}async $disposeCustomDocument(c,R){const n=this._editorProviders.get(R);if(!n)throw new Error(`No provider found for '${R}'`);if(n.type!==1)throw new Error(`Invalid provider type for '${R}'`);const i=A.URI.revive(c),{document:g}=this.getCustomDocumentEntry(R,i);this._documents.delete(R,g),g.dispose()}async $resolveWebviewEditor(c,R,n,i,g,f){const s=this._editorProviders.get(n);if(!s)throw new Error(`No provider found for '${n}'`);const v=C.ViewColumn.to(g),l=this._extHostWebview.createNewWebview(R,i.webviewOptions,s.extension),E=this._extHostWebviewPanels.createNewWebviewPanel(R,n,i.title,v,i.panelOptions,l),T=A.URI.revive(c);switch(s.type){case 1:{const{document:I}=this.getCustomDocumentEntry(n,T);return s.provider.resolveCustomEditor(I,E,f)}case 0:{const I=this._extHostDocuments.getDocument(T);return s.provider.resolveCustomTextEditor(I,E,f)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(c,R,n){this.getCustomDocumentEntry(R,c).disposeEdits(n)}async $onMoveCustomEditor(c,R,n){const i=this._editorProviders.get(n);if(!i)throw new Error(`No provider found for '${n}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${n}'`);const g=this._extHostWebviewPanels.getWebviewPanel(c);if(!g)throw new Error("No webview found");const f=A.URI.revive(R),s=this._extHostDocuments.getDocument(f);await i.provider.moveCustomTextEditor(s,g,u.CancellationToken.None)}async $undo(c,R,n,i){return this.getCustomDocumentEntry(R,c).undo(n,i)}async $redo(c,R,n,i){return this.getCustomDocumentEntry(R,c).redo(n,i)}async $revert(c,R,n){const i=this.getCustomDocumentEntry(R,c);await this.getCustomEditorProvider(R).revertCustomDocument(i.document,n),i.disposeBackup()}async $onSave(c,R,n){const i=this.getCustomDocumentEntry(R,c);await this.getCustomEditorProvider(R).saveCustomDocument(i.document,n),i.disposeBackup()}async $onSaveAs(c,R,n,i){const g=this.getCustomDocumentEntry(R,c);return this.getCustomEditorProvider(R).saveCustomDocumentAs(g.document,A.URI.revive(n),i)}async $backup(c,R,n){const i=this.getCustomDocumentEntry(R,c),f=await this.getCustomEditorProvider(R).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},n);return i.updateBackup(f),f.id}getCustomDocumentEntry(c,R){const n=this._documents.get(c,A.URI.revive(R));if(!n)throw new Error("No custom document found");return n}getCustomEditorProvider(c){const n=this._editorProviders.get(c)?.provider;if(!n||!this.supportEditing(n))throw new Error("Custom document is not editable");return n}supportEditing(c){return!!c.onDidChangeCustomDocument}}e.ExtHostCustomEditors=S;function w(_){return typeof _.resolveCustomTextEditor=="function"}function o(_){return typeof _.undo=="function"&&typeof _.redo=="function"}function d(_){const c=_.scheme===P.Schemas.file||_.scheme===P.Schemas.untitled?_.fsPath:_.toString();return(0,M.hash)(c)+""}});var Xe=this&&this.__classPrivateFieldSet||function(re,e,u,M,b){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!b:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?b.call(re,u):b?b.value=u:e.set(re,u),u},Ae=this&&this.__classPrivateFieldGet||function(re,e,u,M){if(u==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?M:u==="a"?M.call(re):M?M.value:e.get(re)};define(be[215],Ee([0,1,3,6,2,37,8,53,5,7]),function(re,e,u,M,b,P,t,A,C,k){"use strict";var F,y,r,m,a,h,p,S,w,o,d,_,c;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class R extends M.Disposable{constructor(f,s,v,l,E,T,I){super();F.set(this,void 0),y.set(this,void 0),r.set(this,void 0),m.set(this,void 0),a.set(this,void 0),h.set(this,void 0),p.set(this,void 0),S.set(this,void 0),w.set(this,!0),o.set(this,!0),d.set(this,!1),_.set(this,this._register(new u.Emitter)),this.onDidDispose=Ae(this,_,"f").event,c.set(this,this._register(new u.Emitter)),this.onDidChangeViewState=Ae(this,c,"f").event,Xe(this,F,f,"f"),Xe(this,y,s,"f"),Xe(this,r,v,"f"),Xe(this,a,T,"f"),Xe(this,S,E,"f"),Xe(this,h,l,"f"),Xe(this,m,I,"f")}dispose(){Ae(this,d,"f")||(Xe(this,d,!0,"f"),Ae(this,_,"f").fire(),Ae(this,y,"f").$disposeWebview(Ae(this,F,"f")),Ae(this,m,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Ae(this,m,"f")}get viewType(){return this.assertNotDisposed(),Ae(this,r,"f")}get title(){return this.assertNotDisposed(),Ae(this,h,"f")}set title(f){this.assertNotDisposed(),Ae(this,h,"f")!==f&&(Xe(this,h,f,"f"),Ae(this,y,"f").$setTitle(Ae(this,F,"f"),f))}get iconPath(){return this.assertNotDisposed(),Ae(this,p,"f")}set iconPath(f){this.assertNotDisposed(),Ae(this,p,"f")!==f&&(Xe(this,p,f,"f"),Ae(this,y,"f").$setIconPath(Ae(this,F,"f"),b.URI.isUri(f)?{light:f,dark:f}:f))}get options(){return Ae(this,a,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Ae(this,S,"f")=="number"&&Ae(this,S,"f")<0))return Ae(this,S,"f")}get active(){return this.assertNotDisposed(),Ae(this,o,"f")}get visible(){return this.assertNotDisposed(),Ae(this,w,"f")}_updateViewState(f){Ae(this,d,"f")||(this.active!==f.active||this.visible!==f.visible||this.viewColumn!==f.viewColumn)&&(Xe(this,o,f.active,"f"),Xe(this,w,f.visible,"f"),Xe(this,S,f.viewColumn,"f"),Ae(this,c,"f").fire({webviewPanel:this}))}reveal(f,s){this.assertNotDisposed(),Ae(this,y,"f").$reveal(Ae(this,F,"f"),{viewColumn:f?t.ViewColumn.from(f):void 0,preserveFocus:!!s})}assertNotDisposed(){if(Ae(this,d,"f"))throw new Error("Webview is disposed")}}F=new WeakMap,y=new WeakMap,r=new WeakMap,m=new WeakMap,a=new WeakMap,h=new WeakMap,p=new WeakMap,S=new WeakMap,w=new WeakMap,o=new WeakMap,d=new WeakMap,_=new WeakMap,c=new WeakMap;class n{constructor(f,s,v){this.webviews=s,this.workspace=v,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=f.getProxy(C.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,P.generateUuid)()}createWebviewPanel(f,s,v,l,E={}){const T=typeof l=="object"?l.viewColumn:l,I={viewColumn:t.ViewColumn.from(T),preserveFocus:typeof l=="object"&&!!l.preserveFocus},B=(0,A.shouldSerializeBuffersForPostMessage)(f),O=n.newHandle();this._proxy.$createWebviewPanel((0,A.toExtensionData)(f),O,s,{title:v,panelOptions:i(E),webviewOptions:(0,A.serializeWebviewOptions)(f,this.workspace,E),serializeBuffersForPostMessage:B},I);const D=this.webviews.createNewWebview(O,E,f);return this.createNewWebviewPanel(O,s,v,T,E,D)}$onDidChangeWebviewPanelViewStates(f){const s=Object.keys(f);s.sort((v,l)=>{const E=f[v],T=f[l];return E.active?1:T.active?-1:+E.visible-+T.visible});for(const v of s){const l=this.getWebviewPanel(v);if(!l)continue;const E=f[v];l._updateViewState({active:E.active,visible:E.visible,viewColumn:t.ViewColumn.to(E.position)})}}async $onDidDisposeWebviewPanel(f){this.getWebviewPanel(f)?.dispose(),this._webviewPanels.delete(f),this.webviews.deleteWebview(f)}registerWebviewPanelSerializer(f,s,v){if(this._serializers.has(s))throw new Error(`Serializer for '${s}' already registered`);return this._serializers.set(s,{serializer:v,extension:f}),this._proxy.$registerSerializer(s,{serializeBuffersForPostMessage:(0,A.shouldSerializeBuffersForPostMessage)(f)}),new k.Disposable(()=>{this._serializers.delete(s),this._proxy.$unregisterSerializer(s)})}async $deserializeWebviewPanel(f,s,v,l){const E=this._serializers.get(s);if(!E)throw new Error(`No serializer found for '${s}'`);const{serializer:T,extension:I}=E,B=this.webviews.createNewWebview(f,v.webviewOptions,I),O=this.createNewWebviewPanel(f,s,v.title,l,v.panelOptions,B);await T.deserializeWebviewPanel(O,v.state)}createNewWebviewPanel(f,s,v,l,E,T){const I=new R(f,this._proxy,s,v,l,E,T);return this._webviewPanels.set(f,I),I}getWebviewPanel(f){return this._webviewPanels.get(f)}}e.ExtHostWebviewPanels=n;function i(g){return{enableFindWidget:g.enableFindWidget,retainContextWhenHidden:g.retainContextWhenHidden}}});var Xe=this&&this.__classPrivateFieldSet||function(re,e,u,M,b){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!b:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?b.call(re,u):b?b.value=u:e.set(re,u),u},Ae=this&&this.__classPrivateFieldGet||function(re,e,u,M){if(u==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?M:u==="a"?M.call(re):M?M.value:e.get(re)};define(be[216],Ee([0,1,3,6,53,5,7]),function(re,e,u,M,b,P,t){"use strict";var A,C,k,F,y,r,m,a,h,p;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class S extends M.Disposable{constructor(d,_,c,R,n,i){super();A.set(this,void 0),C.set(this,void 0),k.set(this,void 0),F.set(this,void 0),y.set(this,!1),r.set(this,void 0),m.set(this,void 0),a.set(this,void 0),h.set(this,this._register(new u.Emitter)),this.onDidChangeVisibility=Ae(this,h,"f").event,p.set(this,this._register(new u.Emitter)),this.onDidDispose=Ae(this,p,"f").event,Xe(this,k,c,"f"),Xe(this,m,R,"f"),Xe(this,A,d,"f"),Xe(this,C,_,"f"),Xe(this,F,n,"f"),Xe(this,r,i,"f")}dispose(){Ae(this,y,"f")||(Xe(this,y,!0,"f"),Ae(this,p,"f").fire(),Ae(this,F,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Ae(this,m,"f")}set title(d){this.assertNotDisposed(),Ae(this,m,"f")!==d&&(Xe(this,m,d,"f"),Ae(this,C,"f").$setWebviewViewTitle(Ae(this,A,"f"),d))}get description(){return this.assertNotDisposed(),Ae(this,a,"f")}set description(d){this.assertNotDisposed(),Ae(this,a,"f")!==d&&(Xe(this,a,d,"f"),Ae(this,C,"f").$setWebviewViewDescription(Ae(this,A,"f"),d))}get visible(){return Ae(this,r,"f")}get webview(){return Ae(this,F,"f")}get viewType(){return Ae(this,k,"f")}_setVisible(d){d===Ae(this,r,"f")||Ae(this,y,"f")||(Xe(this,r,d,"f"),Ae(this,h,"f").fire())}show(d){this.assertNotDisposed(),Ae(this,C,"f").$show(Ae(this,A,"f"),!!d)}assertNotDisposed(){if(Ae(this,y,"f"))throw new Error("Webview is disposed")}}A=new WeakMap,C=new WeakMap,k=new WeakMap,F=new WeakMap,y=new WeakMap,r=new WeakMap,m=new WeakMap,a=new WeakMap,h=new WeakMap,p=new WeakMap;class w{constructor(d,_){this._extHostWebview=_,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=d.getProxy(P.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(d,_,c,R){if(this._viewProviders.has(_))throw new Error(`View provider for '${_}' already registered`);return this._viewProviders.set(_,{provider:c,extension:d}),this._proxy.$registerWebviewViewProvider((0,b.toExtensionData)(d),_,{retainContextWhenHidden:R?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new t.Disposable(()=>{this._viewProviders.delete(_),this._proxy.$unregisterWebviewViewProvider(_)})}async $resolveWebviewView(d,_,c,R,n){const i=this._viewProviders.get(_);if(!i)throw new Error(`No view provider found for '${_}'`);const{provider:g,extension:f}=i,s=this._extHostWebview.createNewWebview(d,{},f),v=new S(d,this._proxy,_,c,s,!0);this._webviewViews.set(d,v),await g.resolveWebviewView(v,{state:R},n)}async $onDidChangeWebviewViewVisibility(d,_){this.getWebviewView(d)._setVisible(_)}async $disposeWebviewView(d){const _=this.getWebviewView(d);this._webviewViews.delete(d),_.dispose(),this._extHostWebview.deleteWebview(d)}getWebviewView(d){const _=this._webviewViews.get(d);if(!_)throw new Error("No webview found");return _}}e.ExtHostWebviewViews=w}),define(be[97],Ee([0,1,3,5,2,11,9,4,14]),function(re,e,u,M,b,P,t,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let k=class zi{constructor(y){this._onDidChangeWindowState=new u.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=zi.InitialState,this._proxy=y.getProxy(M.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(r=>this.$onDidChangeWindowFocus(r))}get state(){return this._state}$onDidChangeWindowFocus(y){y!==this._state.focused&&(this._state={...this._state,focused:y},this._onDidChangeWindowState.fire(this._state))}openUri(y,r){let m;if(typeof y=="string"){m=y;try{y=b.URI.parse(y)}catch(a){return Promise.reject(`Invalid uri - '${y}'`)}}return(0,t.isFalsyOrWhitespace)(y.scheme)?Promise.reject("Invalid scheme - cannot be empty"):y.scheme===P.Schemas.command?Promise.reject(`Invalid scheme '${y.scheme}'`):this._proxy.$openUri(y,m,r)}async asExternalUri(y,r){if((0,t.isFalsyOrWhitespace)(y.scheme))return Promise.reject("Invalid scheme - cannot be empty");const m=await this._proxy.$asExternalUri(y,r);return b.URI.from(m)}};k.InitialState={focused:!0},k=Ue([Be(0,C.IExtHostRpcService)],k),e.ExtHostWindow=k,e.IExtHostWindow=(0,A.createDecorator)("IExtHostWindow")}),define(be[217],Ee([0,1,13,22,21,16,3,6,108,184,39]),function(re,e,u,M,b,P,t,A,C,k,F){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function r(E,T){try{return JSON.stringify(E,T)}catch(I){return"null"}}const m="$$ref$$",a={[m]:-1};class h{constructor(T,I){this.jsonString=T,this.referencedBuffers=I}}function p(E,T=null,I=!1){const B=[];return{jsonString:(I?r:JSON.stringify)(E,(D,x)=>{if(typeof x=="undefined")return a;if(typeof x=="object"){if(x instanceof M.VSBuffer){const N=B.push(x)-1;return{[m]:N}}if(T)return T(D,x)}return x}),referencedBuffers:B}}e.stringifyJsonWithBufferRefs=p;function S(E,T,I){return JSON.parse(E,(B,O)=>{if(O){const D=O[m];if(typeof D=="number")return T[D];if(I&&O.$mid===1)return I.transformIncoming(O)}return O})}e.parseJsonAndRestoreBufferRefs=S;function w(E,T){return JSON.stringify(E,T)}function o(E){return E?(T,I)=>I&&I.$mid===1?E.transformOutgoing(I):I:null}var d;(function(E){E[E.LocalSide=0]="LocalSide",E[E.OtherSide=1]="OtherSide"})(d=e.RequestInitiator||(e.RequestInitiator={}));var _;(function(E){E[E.Responsive=0]="Responsive",E[E.Unresponsive=1]="Unresponsive"})(_=e.ResponsiveState||(e.ResponsiveState={}));const c=()=>{},R=Symbol.for("rpcProtocol"),n=Symbol.for("rpcProxy");class i extends A.Disposable{constructor(T,I=null,B=null){super();this[y]=!0,this._onDidChangeResponsiveState=this._register(new t.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=T,this._logger=I,this._uriTransformer=B,this._uriReplacer=o(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let O=0,D=F.ProxyIdentifier.count;O<D;O++)this._locals[O]=null,this._proxies[O]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new u.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(O=>this._receiveOneMessage(O))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(T=>{this._pendingRPCReplies[T].resolveErr(P.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(T){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(T){this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(T){this._responsiveState!==T&&(this._responsiveState=T,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(T){return this._uriTransformer?(0,C.transformIncomingURIs)(T,this._uriTransformer):T}getProxy(T){const{nid:I,sid:B}=T;return this._proxies[I]||(this._proxies[I]=this._createProxy(I,B)),this._proxies[I]}_createProxy(T,I){let B={get:(O,D)=>(typeof D=="string"&&!O[D]&&D.charCodeAt(0)===36&&(O[D]=(...x)=>this._remoteCall(T,D,x)),D===n?I:O[D])};return new Proxy(Object.create(null),B)}set(T,I){return this._locals[T.nid]=I,I}assertRegistered(T){for(let I=0,B=T.length;I<B;I++){const O=T[I];if(!this._locals[O.nid])throw new Error(`Missing actor ${O.sid} (isMain: ${O.isMain})`)}}_receiveOneMessage(T){if(this._isDisposed)return;const I=T.byteLength,B=g.read(T,0),O=B.readUInt8(),D=B.readUInt32();switch(O){case 1:case 2:{let{rpcId:x,method:N,args:V}=s.deserializeRequestJSONArgs(B);this._uriTransformer&&(V=(0,C.transformIncomingURIs)(V,this._uriTransformer)),this._receiveRequest(I,D,x,N,V,O===2);break}case 3:case 4:{let{rpcId:x,method:N,args:V}=s.deserializeRequestMixedArgs(B);this._uriTransformer&&(V=(0,C.transformIncomingURIs)(V,this._uriTransformer)),this._receiveRequest(I,D,x,N,V,O===4);break}case 5:{this._logger&&this._logger.logIncoming(I,D,0,"ack"),this._onDidReceiveAcknowledge(D);break}case 6:{this._receiveCancel(I,D);break}case 7:{this._receiveReply(I,D,void 0);break}case 9:{let x=s.deserializeReplyOKJSON(B);this._uriTransformer&&(x=(0,C.transformIncomingURIs)(x,this._uriTransformer)),this._receiveReply(I,D,x);break}case 10:{const x=s.deserializeReplyOKJSONWithBuffers(B,this._uriTransformer);this._receiveReply(I,D,x);break}case 8:{let x=s.deserializeReplyOKVSBuffer(B);this._receiveReply(I,D,x);break}case 11:{let x=s.deserializeReplyErrError(B);this._uriTransformer&&(x=(0,C.transformIncomingURIs)(x,this._uriTransformer)),this._receiveReplyErr(I,D,x);break}case 12:{this._receiveReplyErr(I,D,void 0);break}default:console.error("received unexpected message"),console.error(T)}}_receiveRequest(T,I,B,O,D,x){this._logger&&this._logger.logIncoming(T,I,1,`receiveRequest ${(0,F.getStringIdentifierForProxy)(B)}.${O}(`,D);const N=String(I);let V,$;if(x){const ee=new b.CancellationTokenSource;D.push(ee.token),V=this._invokeHandler(B,O,D),$=()=>ee.cancel()}else V=this._invokeHandler(B,O,D),$=c;this._cancelInvokedHandlers[N]=$;const z=s.serializeAcknowledged(I);this._logger&&this._logger.logOutgoing(z.byteLength,I,1,"ack"),this._protocol.send(z),V.then(ee=>{delete this._cancelInvokedHandlers[N];const j=s.serializeReplyOK(I,ee,this._uriReplacer);this._logger&&this._logger.logOutgoing(j.byteLength,I,1,"reply:",ee),this._protocol.send(j)},ee=>{delete this._cancelInvokedHandlers[N];const j=s.serializeReplyErr(I,ee);this._logger&&this._logger.logOutgoing(j.byteLength,I,1,"replyErr:",ee),this._protocol.send(j)})}_receiveCancel(T,I){this._logger&&this._logger.logIncoming(T,I,1,"receiveCancel");const B=String(I);this._cancelInvokedHandlers[B]&&this._cancelInvokedHandlers[B]()}_receiveReply(T,I,B){this._logger&&this._logger.logIncoming(T,I,0,"receiveReply:",B);const O=String(I);if(!this._pendingRPCReplies.hasOwnProperty(O))return;const D=this._pendingRPCReplies[O];delete this._pendingRPCReplies[O],D.resolveOk(B)}_receiveReplyErr(T,I,B){this._logger&&this._logger.logIncoming(T,I,0,"receiveReplyErr:",B);const O=String(I);if(!this._pendingRPCReplies.hasOwnProperty(O))return;const D=this._pendingRPCReplies[O];delete this._pendingRPCReplies[O];let x;B&&(B.$isError?(x=new Error,x.name=B.name,x.message=B.message,x.stack=B.stack):x=B),D.resolveErr(x)}_invokeHandler(T,I,B){try{return Promise.resolve(this._doInvokeHandler(T,I,B))}catch(O){return Promise.reject(O)}}_doInvokeHandler(T,I,B){const O=this._locals[T];if(!O)throw new Error("Unknown actor "+(0,F.getStringIdentifierForProxy)(T));let D=O[I];if(typeof D!="function")throw new Error("Unknown method "+I+" on actor "+(0,F.getStringIdentifierForProxy)(T));return D.apply(O,B)}_remoteCall(T,I,B){if(this._isDisposed)return Promise.reject(P.canceled());let O=null;if(B.length>0&&b.CancellationToken.isCancellationToken(B[B.length-1])&&(O=B.pop()),O&&O.isCancellationRequested)return Promise.reject(P.canceled());const D=s.serializeRequestArguments(B,this._uriReplacer),x=++this._lastMessageId,N=String(x),V=new k.LazyPromise;O&&O.onCancellationRequested(()=>{const z=s.serializeCancel(x);this._logger&&this._logger.logOutgoing(z.byteLength,x,0,"cancel"),this._protocol.send(s.serializeCancel(x))}),this._pendingRPCReplies[N]=V,this._onWillSendRequest(x);const $=s.serializeRequest(x,T,I,D,!!O);return this._logger&&this._logger.logOutgoing($.byteLength,x,0,`request: ${(0,F.getStringIdentifierForProxy)(T)}.${I}(`,B),this._protocol.send($),V}}e.RPCProtocol=i,y=R,i.UNRESPONSIVE_TIME=3*1e3;class g{constructor(T,I){this._buff=T,this._offset=I}static alloc(T,I,B){let O=new g(M.VSBuffer.alloc(B+1+4),0);return O.writeUInt8(T),O.writeUInt32(I),O}static read(T,I){return new g(T,I)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(T){this._buff.writeUInt8(T,this._offset),this._offset+=1}readUInt8(){const T=this._buff.readUInt8(this._offset);return this._offset+=1,T}writeUInt32(T){this._buff.writeUInt32BE(T,this._offset),this._offset+=4}readUInt32(){const T=this._buff.readUInt32BE(this._offset);return this._offset+=4,T}static sizeShortString(T){return 1+T.byteLength}writeShortString(T){this._buff.writeUInt8(T.byteLength,this._offset),this._offset+=1,this._buff.set(T,this._offset),this._offset+=T.byteLength}readShortString(){const T=this._buff.readUInt8(this._offset);this._offset+=1;const B=this._buff.slice(this._offset,this._offset+T).toString();return this._offset+=T,B}static sizeLongString(T){return 4+T.byteLength}writeLongString(T){this._buff.writeUInt32BE(T.byteLength,this._offset),this._offset+=4,this._buff.set(T,this._offset),this._offset+=T.byteLength}readLongString(){const T=this._buff.readUInt32BE(this._offset);this._offset+=4;const B=this._buff.slice(this._offset,this._offset+T).toString();return this._offset+=T,B}writeBuffer(T){this._buff.writeUInt32BE(T.byteLength,this._offset),this._offset+=4,this._buff.set(T,this._offset),this._offset+=T.byteLength}static sizeVSBuffer(T){return 4+T.byteLength}writeVSBuffer(T){this._buff.writeUInt32BE(T.byteLength,this._offset),this._offset+=4,this._buff.set(T,this._offset),this._offset+=T.byteLength}readVSBuffer(){const T=this._buff.readUInt32BE(this._offset);this._offset+=4;const I=this._buff.slice(this._offset,this._offset+T);return this._offset+=T,I}static sizeMixedArray(T){let I=0;I+=1;for(let B=0,O=T.length;B<O;B++){const D=T[B];switch(I+=1,D.type){case 1:I+=this.sizeLongString(D.value);break;case 2:I+=this.sizeVSBuffer(D.value);break;case 3:I+=this.sizeUInt32,I+=this.sizeLongString(D.value);for(let x=0;x<D.buffers.length;++x)I+=this.sizeVSBuffer(D.buffers[x]);break;case 4:break}}return I}writeMixedArray(T){this._buff.writeUInt8(T.length,this._offset),this._offset+=1;for(let I=0,B=T.length;I<B;I++){const O=T[I];switch(O.type){case 1:this.writeUInt8(1),this.writeLongString(O.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(O.value);break;case 3:this.writeUInt8(3),this.writeUInt32(O.buffers.length),this.writeLongString(O.value);for(let D=0;D<O.buffers.length;++D)this.writeBuffer(O.buffers[D]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const T=this._buff.readUInt8(this._offset);this._offset+=1;let I=new Array(T);for(let B=0;B<T;B++)switch(this.readUInt8()){case 1:I[B]=this.readLongString();break;case 2:I[B]=this.readVSBuffer();break;case 3:const D=this.readUInt32(),x=this.readLongString(),N=[];for(let V=0;V<D;++V)N.push(this.readVSBuffer());I[B]=new F.SerializableObjectWithBuffers(S(x,N,null));break;case 4:I[B]=void 0;break}return I}}g.sizeUInt32=4;var f;(function(E){E[E.Simple=0]="Simple",E[E.Mixed=1]="Mixed"})(f||(f={}));class s{static _useMixedArgSerialization(T){for(let I=0,B=T.length;I<B;I++)if(T[I]instanceof M.VSBuffer||T[I]instanceof F.SerializableObjectWithBuffers||typeof T[I]=="undefined")return!0;return!1}static serializeRequestArguments(T,I){if(this._useMixedArgSerialization(T)){const B=[];for(let O=0,D=T.length;O<D;O++){const x=T[O];if(x instanceof M.VSBuffer)B[O]={type:2,value:x};else if(typeof x=="undefined")B[O]={type:4};else if(x instanceof F.SerializableObjectWithBuffers){const{jsonString:N,referencedBuffers:V}=p(x.value,I);B[O]={type:3,value:M.VSBuffer.fromString(N),buffers:V}}else B[O]={type:1,value:M.VSBuffer.fromString(w(x,I))}}return{type:1,args:B}}return{type:0,args:w(T,I)}}static serializeRequest(T,I,B,O,D){switch(O.type){case 0:return this._requestJSONArgs(T,I,B,O.args,D);case 1:return this._requestMixedArgs(T,I,B,O.args,D)}}static _requestJSONArgs(T,I,B,O,D){const x=M.VSBuffer.fromString(B),N=M.VSBuffer.fromString(O);let V=0;V+=g.sizeUInt8(),V+=g.sizeShortString(x),V+=g.sizeLongString(N);let $=g.alloc(D?2:1,T,V);return $.writeUInt8(I),$.writeShortString(x),$.writeLongString(N),$.buffer}static deserializeRequestJSONArgs(T){const I=T.readUInt8(),B=T.readShortString(),O=T.readLongString();return{rpcId:I,method:B,args:JSON.parse(O)}}static _requestMixedArgs(T,I,B,O,D){const x=M.VSBuffer.fromString(B);let N=0;N+=g.sizeUInt8(),N+=g.sizeShortString(x),N+=g.sizeMixedArray(O);let V=g.alloc(D?4:3,T,N);return V.writeUInt8(I),V.writeShortString(x),V.writeMixedArray(O),V.buffer}static deserializeRequestMixedArgs(T){const I=T.readUInt8(),B=T.readShortString(),O=T.readMixedArray(),D=new Array(O.length);for(let x=0,N=O.length;x<N;x++){const V=O[x];typeof V=="string"?D[x]=JSON.parse(V):D[x]=V}return{rpcId:I,method:B,args:D}}static serializeAcknowledged(T){return g.alloc(5,T,0).buffer}static serializeCancel(T){return g.alloc(6,T,0).buffer}static serializeReplyOK(T,I,B){if(typeof I=="undefined")return this._serializeReplyOKEmpty(T);if(I instanceof M.VSBuffer)return this._serializeReplyOKVSBuffer(T,I);if(I instanceof F.SerializableObjectWithBuffers){const{jsonString:O,referencedBuffers:D}=p(I.value,B,!0);return this._serializeReplyOKJSONWithBuffers(T,O,D)}else return this._serializeReplyOKJSON(T,r(I,B))}static _serializeReplyOKEmpty(T){return g.alloc(7,T,0).buffer}static _serializeReplyOKVSBuffer(T,I){let B=0;B+=g.sizeVSBuffer(I);let O=g.alloc(8,T,B);return O.writeVSBuffer(I),O.buffer}static deserializeReplyOKVSBuffer(T){return T.readVSBuffer()}static _serializeReplyOKJSON(T,I){const B=M.VSBuffer.fromString(I);let O=0;O+=g.sizeLongString(B);let D=g.alloc(9,T,O);return D.writeLongString(B),D.buffer}static _serializeReplyOKJSONWithBuffers(T,I,B){const O=M.VSBuffer.fromString(I);let D=0;D+=g.sizeUInt32,D+=g.sizeLongString(O);for(const N of B)D+=g.sizeVSBuffer(N);let x=g.alloc(10,T,D);x.writeUInt32(B.length),x.writeLongString(O);for(const N of B)x.writeBuffer(N);return x.buffer}static deserializeReplyOKJSON(T){const I=T.readLongString();return JSON.parse(I)}static deserializeReplyOKJSONWithBuffers(T,I){const B=T.readUInt32(),O=T.readLongString(),D=[];for(let x=0;x<B;++x)D.push(T.readVSBuffer());return new F.SerializableObjectWithBuffers(S(O,D,I))}static serializeReplyErr(T,I){return I?this._serializeReplyErrEror(T,I):this._serializeReplyErrEmpty(T)}static _serializeReplyErrEror(T,I){const B=M.VSBuffer.fromString(r(P.transformErrorForSerialization(I),null));let O=0;O+=g.sizeLongString(B);let D=g.alloc(11,T,O);return D.writeLongString(B),D.buffer}static deserializeReplyErrError(T){const I=T.readLongString();return JSON.parse(I)}static _serializeReplyErrEmpty(T){return g.alloc(12,T,0).buffer}}var v;(function(E){E[E.RequestJSONArgs=1]="RequestJSONArgs",E[E.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",E[E.RequestMixedArgs=3]="RequestMixedArgs",E[E.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",E[E.Acknowledged=5]="Acknowledged",E[E.Cancel=6]="Cancel",E[E.ReplyOKEmpty=7]="ReplyOKEmpty",E[E.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",E[E.ReplyOKJSON=9]="ReplyOKJSON",E[E.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",E[E.ReplyErrError=11]="ReplyErrError",E[E.ReplyErrEmpty=12]="ReplyErrEmpty"})(v||(v={}));var l;(function(E){E[E.String=1]="String",E[E.VSBuffer=2]="VSBuffer",E[E.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",E[E.Undefined=4]="Undefined"})(l||(l={}))}),define(be[218],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const u=function(P){const t=A=>{self.removeEventListener("message",t);const C=A.data;Object.defineProperties(self,{postMessage:{value(k,F){C.postMessage(k,F)}},onmessage:{get(){return C.onmessage},set(k){C.onmessage=k}}}),C.addEventListener("message",k=>{self.dispatchEvent(new MessageEvent("message",{data:k.data}))}),C.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(P)};self.addEventListener("message",t)}.toString();class M extends EventTarget{constructor(P,t,A){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const C=`((${u})('${t}'))`,k=new Blob([C],{type:"application/javascript"}),F=URL.createObjectURL(k),y=new MessageChannel,r=F,m={type:"_newWorker",id:r,port:y.port2,url:F,options:A};P(m,[y.port2]),this.postMessage=y.port1.postMessage.bind(y.port1),this.terminate=()=>{const a={type:"_terminateWorker",id:r};y.port1.postMessage(a),URL.revokeObjectURL(F),y.port1.close(),y.port2.close()},Object.defineProperties(this,{onmessage:{get(){return y.port1.onmessage},set(a){y.port1.onmessage=a}},onmessageerror:{get(){return y.port1.onmessageerror},set(a){y.port1.onmessageerror=a}}}),y.port1.addEventListener("messageerror",a=>{const h=new MessageEvent("messageerror",{data:a.data});this.dispatchEvent(h)}),y.port1.addEventListener("message",a=>{const h=new MessageEvent("message",{data:a.data});this.dispatchEvent(h)}),y.port1.start()}}e.NestedWorker=M}),define(be[219],Ee([0,1,4]),function(re,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,u.createDecorator)("remoteAgentService")}),define(be[220],Ee([0,1,11,17,25,2,4,64,49,179,219]),function(re,e,u,M,b,P,t,A,C,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,t.createDecorator)("pathService");let y=class Wi{constructor(m,a,h,p){this.localUserHome=m,this.remoteAgentService=a,this.environmentService=h,this.contextService=p,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||b.OS)(),this.resolveUserHome=(async()=>{const S=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=S?.userHome||m})()}get defaultUriScheme(){return Wi.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(m,a){if(m.remoteAuthority)return u.Schemas.vscodeRemote;const h=(0,A.getVirtualWorkspaceScheme)(a.getWorkspace());if(h)return h;const p=a.getWorkspace().folders[0];if(p)return p.uri.scheme;const S=a.getWorkspace().configuration;return S?S.scheme:u.Schemas.file}async userHome(m){return m?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(m=>m===1?M.win32:M.posix)}async fileURI(m){let a="";if(await this.resolveOS===1&&(m=m.replace(/\\/g,"/")),m[0]==="/"&&m[1]==="/"){const p=m.indexOf("/",2);p===-1?(a=m.substring(2),m="/"):(a=m.substring(2,p),m=m.substring(p)||"/")}return P.URI.from({scheme:u.Schemas.file,authority:a,path:m,query:"",fragment:""})}};y=Ue([Be(1,F.IRemoteAgentService),Be(2,k.IWorkbenchEnvironmentService),Be(3,C.IWorkspaceContextService)],y),e.AbstractPathService=y}),define(be[98],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class u{constructor(t,A){this.line=t,this.character=A}isBefore(t){return!1}isBeforeOrEqual(t){return!1}isAfter(t){return!1}isAfterOrEqual(t){return!1}isEqual(t){return!1}compareTo(t){return 0}translate(t,A){return new u(0,0)}with(t){return new u(0,0)}}e.Position=u;class M{constructor(t,A,C,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new u(t,A),this.end=new u(C,k)}contains(t){return!1}isEqual(t){return!1}intersection(t){}union(t){return new M(0,0,0,0)}with(t){return new M(0,0,0,0)}}e.Range=M;var b;(function(P){P[P.Information=1]="Information",P[P.Warning=2]="Warning"})(b=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(be[42],Ee([0,1,15,29,23,44,9,4,17,16,98,10]),function(re,e,u,M,b,P,t,A,C,k,F,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return F.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const r="\u27EA ",m=" characters skipped \u27EB",a=(r.length+m.length+5)*2;e.ISearchService=(0,A.createDecorator)("searchService");var h;(function(z){z[z.file=0]="file",z[z.text=1]="text"})(h=e.SearchProviderType||(e.SearchProviderType={}));var p;(function(z){z[z.File=1]="File",z[z.Text=2]="Text"})(p=e.QueryType||(e.QueryType={}));function S(z){return!!z.preview}e.resultIsMatch=S;function w(z){return!!z.resource}e.isFileMatch=w;function o(z){return!!z.message}e.isProgressMessage=o;var d;(function(z){z[z.Normal=0]="Normal",z[z.NewSearchStarted=1]="NewSearchStarted"})(d=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class _{constructor(ee){this.resource=ee,this.results=[]}}e.FileMatch=_;class c{constructor(ee,j,Q){this.ranges=j;const le=Array.isArray(j)?j:[j];if(Q&&Q.matchLines===1&&R(le)){ee=(0,t.getNLines)(ee,Q.matchLines);let ve="",ue=0,Fe=0;const Ke=Math.floor(Q.charsPerLine/5),Oe=[];for(const He of le){const Je=Math.max(He.startColumn-Ke,0),Ye=He.startColumn+Q.charsPerLine;if(Je>Fe+Ke+a){const Qe=r+(Je-Fe)+m;ve+=Qe+ee.slice(Je,Ye),ue+=Je-(Fe+Qe.length)}else ve+=ee.slice(Fe,Ye);Oe.push(new i(0,He.startColumn-ue,He.endColumn-ue)),Fe=Ye}this.preview={text:ve,matches:Array.isArray(this.ranges)?Oe:Oe[0]}}else{const ve=Array.isArray(j)?j[0].startLineNumber:j.startLineNumber;this.preview={text:ee,matches:(0,u.mapArrayOrNot)(j,ue=>new n(ue.startLineNumber-ve,ue.startColumn,ue.endLineNumber-ve,ue.endColumn))}}}}e.TextSearchMatch=c;function R(z){const ee=z[0].startLineNumber;for(const j of z)if(j.startLineNumber!==ee||j.endLineNumber!==ee)return!1;return!0}class n{constructor(ee,j,Q,le){this.startLineNumber=ee,this.startColumn=j,this.endLineNumber=Q,this.endColumn=le}}e.SearchRange=n;class i extends n{constructor(ee,j,Q){super(ee,j,ee,Q)}}e.OneLineRange=i;var g;(function(z){z.Default="default",z.FileNames="fileNames",z.Type="type",z.Modified="modified",z.CountDescending="countDescending",z.CountAscending="countAscending"})(g=e.SearchSortOrder||(e.SearchSortOrder={}));function f(z,ee=!0){const j=z&&z.files&&z.files.exclude,Q=ee&&z&&z.search&&z.search.exclude;if(!j&&!Q)return;if(!j||!Q)return j||Q;let le=Object.create(null);return le=b.mixin(le,b.deepClone(j)),le=b.mixin(le,b.deepClone(Q),!0),le}e.getExcludes=f;function s(z,ee){return z.excludePattern&&M.match(z.excludePattern,ee)?!1:z.includePattern||z.usingSearchPaths?z.includePattern&&M.match(z.includePattern,ee)?!0:z.usingSearchPaths?!!z.folderQueries&&z.folderQueries.some(j=>{const Q=j.folder.fsPath;if(P.isEqualOrParent(ee,Q)){const le=C.relative(Q,ee);return!j.includePattern||!!M.match(j.includePattern,le)}else return!1}):!1:!0}e.pathIncludedInQuery=s;var v;(function(z){z[z.unknownEncoding=1]="unknownEncoding",z[z.regexParseError=2]="regexParseError",z[z.globParseError=3]="globParseError",z[z.invalidLiteral=4]="invalidLiteral",z[z.rgProcessError=5]="rgProcessError",z[z.other=6]="other",z[z.canceled=7]="canceled"})(v=e.SearchErrorCode||(e.SearchErrorCode={}));class l extends Error{constructor(ee,j){super(ee);this.code=j}}e.SearchError=l;function E(z){const ee=z.message;if((0,k.isPromiseCanceledError)(z))return new l(ee,v.canceled);try{const j=JSON.parse(ee);return new l(j.message,j.code)}catch(j){return new l(ee,v.other)}}e.deserializeSearchError=E;function T(z){const ee={message:z.message,code:z.code};return new Error(JSON.stringify(ee))}e.serializeSearchError=T;function I(z){return z.type==="error"?!0:z.type==="success"}e.isSerializedSearchComplete=I;function B(z){return z.type==="success"}e.isSerializedSearchSuccess=B;function O(z){return!!z.path}e.isSerializedFileMatch=O;function D(z,ee){const j=z.searchPath?z.searchPath:z.relativePath;return(0,t.fuzzyContains)(j,ee)}e.isFilePatternMatch=D;class x{constructor(ee){this.path=ee,this.results=[]}addMatch(ee){this.results.push(ee)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=x;function N(z,ee){const j={...z||{},...ee||{}};return Object.keys(j).filter(Q=>{const le=j[Q];return typeof le=="boolean"&&le})}e.resolvePatternsForProvider=N;class V{constructor(ee,j){this._parsedIncludeExpression=null,this._excludeExpression={...ee.excludePattern||{},...j.excludePattern||{}},this._parsedExcludeExpression=M.parse(this._excludeExpression);let Q=ee.includePattern;j.includePattern&&(Q?Q={...Q,...j.includePattern}:Q=j.includePattern),Q&&(this._parsedIncludeExpression=M.parse(Q))}matchesExcludesSync(ee,j,Q){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ee,j,Q))}includedInQuerySync(ee,j,Q){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ee,j,Q)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(ee,j,Q))}includedInQuery(ee,j,Q){const le=this._parsedExcludeExpression(ee,j,Q),ve=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(ee,j,Q):!0;return(0,y.isPromise)(le)?le.then(ue=>ue?!1:ve()):ve()}hasSiblingExcludeClauses(){return $(this._excludeExpression)}}e.QueryGlobTester=V;function $(z){for(const ee in z)if(typeof z[ee]!="boolean")return!0;return!1}}),define(be[32],Ee([0,1,15,13,21,3,20,11,76,24,9,10,2,131,4,12,145,49,31,28,14,7,42,5]),function(re,e,u,M,b,P,t,A,C,k,F,y,r,m,a,h,p,S,w,o,d,_,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function n(T,I,B){return new k.ExtUri(O=>s(O,B)).isEqual(T,I)}function i(T,I,B){return n(T.uri,I.uri,B)?0:(0,F.compare)(T.uri.toString(),I.uri.toString())}function g(T,I,B){return T.index!==I.index?T.index<I.index?-1:1:n(T.uri,I.uri,B)?(0,F.compare)(T.name,I.name):(0,F.compare)(T.uri.toString(),I.uri.toString())}function f(T,I,B,O){const D=T.slice(0).sort((N,V)=>B(N,V,O)),x=I.slice(0).sort((N,V)=>B(N,V,O));return(0,u.delta)(D,x,(N,V)=>B(N,V,O))}function s(T,I){const B=I.getCapabilities(T.scheme);return!(B&&B&1024)}class v extends S.Workspace{constructor(I,B,O,D,x,N,V){super(I,O.map($=>new S.WorkspaceFolder($)),D,x,V);this._name=B,this._isUntitled=N,this._workspaceFolders=[],this._structure=t.TernarySearchTree.forUris(V),O.forEach($=>{this._workspaceFolders.push($),this._structure.set($.uri,$)})}static toExtHostWorkspace(I,B,O,D){if(!I)return{workspace:null,added:[],removed:[]};const{id:x,name:N,folders:V,configuration:$,transient:z,isUntitled:ee}=I,j=[],Q=B;B?V.forEach((Fe,Ke)=>{const Oe=r.URI.revive(Fe.uri),He=v._findFolder(O||B,Oe,D);He?(He.name=Fe.name,He.index=Fe.index,j.push(He)):j.push({uri:Oe,name:Fe.name,index:Ke})}):j.push(...V.map(({uri:Fe,name:Ke,index:Oe})=>({uri:r.URI.revive(Fe),name:Ke,index:Oe}))),j.sort((Fe,Ke)=>Fe.index<Ke.index?-1:1);const le=new v(x,N,j,!!z,$?r.URI.revive($):null,!!ee,Fe=>s(Fe,D)),{added:ve,removed:ue}=f(Q?Q.workspaceFolders:[],le.workspaceFolders,i,D);return{workspace:le,added:ve,removed:ue}}static _findFolder(I,B,O){for(let D=0;D<I.folders.length;D++){const x=I.workspaceFolders[D];if(n(x.uri,B,O))return x}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(I,B){return B&&this._structure.get(I)&&(I=(0,k.dirname)(I)),this._structure.findSubstr(I)}resolveWorkspaceFolder(I){return this._structure.get(I)}}let l=class{constructor(I,B,O,D){this._onDidChangeWorkspace=new P.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new P.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=D,this._extHostFileSystemInfo=O,this._requestIdProvider=new C.Counter,this._barrier=new M.Barrier,this._proxy=I.getProxy(R.MainContext.MainThreadWorkspace),this._messageService=I.getProxy(R.MainContext.MainThreadMessageService);const x=B.workspace;this._confirmedWorkspace=x?new v(x.id,x.name,[],!!x.transient,x.configuration?r.URI.revive(x.configuration):null,!!x.isUntitled,N=>s(N,O)):void 0}$initializeWorkspace(I,B){this._trusted=B,this.$acceptWorkspaceData(I),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?r.URI.from({scheme:A.Schemas.untitled,path:(0,k.basename)((0,k.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(I,B,O,...D){const x=[];if(Array.isArray(D)&&D.forEach(ee=>{r.URI.isUri(ee.uri)&&!x.some(j=>n(j.uri,ee.uri,this._extHostFileSystemInfo))&&x.push({uri:ee.uri,name:ee.name||(0,k.basenameOrAuthority)(ee.uri)})}),this._unconfirmedWorkspace||[B,O].some(ee=>typeof ee!="number"||ee<0)||O===0&&x.length===0)return!1;const N=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(B+O>N.length)return!1;const V=N.slice(0);V.splice(B,O,...x.map(ee=>({uri:ee.uri,name:ee.name||(0,k.basenameOrAuthority)(ee.uri),index:void 0})));for(let ee=0;ee<V.length;ee++){const j=V[ee];if(V.some((Q,le)=>le!==ee&&n(j.uri,Q.uri,this._extHostFileSystemInfo)))return!1}V.forEach((ee,j)=>ee.index=j);const{added:$,removed:z}=f(N,V,g,this._extHostFileSystemInfo);if($.length===0&&z.length===0)return!1;if(this._proxy){const ee=I.displayName||I.name;this._proxy.$updateWorkspaceFolders(ee,B,O,x).then(void 0,j=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(p.Severity.Error,(0,m.localize)(0,null,ee,j.toString()),{extension:I},[])})}return this.trySetWorkspaceFolders(V),!0}getWorkspaceFolder(I,B){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(I,B)}async getWorkspaceFolder2(I,B){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(I,B)}async resolveWorkspaceFolder(I){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(I)}getPath(){if(!this._actualWorkspace)return;const{folders:I}=this._actualWorkspace;if(I.length!==0)return I[0].uri.fsPath}getRelativePath(I,B){let O,D="";if(typeof I=="string"?(O=r.URI.file(I),D=I):typeof I!="undefined"&&(O=I,D=I.fsPath),!O)return D;const x=this.getWorkspaceFolder(O,!0);if(!x)return D;typeof B=="undefined"&&this._actualWorkspace&&(B=this._actualWorkspace.folders.length>1);let N=(0,k.relativePath)(x.uri,O);return B&&x.name&&(N=`${x.name}/${N}`),N}trySetWorkspaceFolders(I){this._actualWorkspace&&(this._unconfirmedWorkspace=v.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:I,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(I){const{workspace:B,added:O,removed:D}=v.toExtHostWorkspace(I,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=B||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:O,removed:D}))}findFiles(I,B,O,D,x=b.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${D.value}, entryPoint: findFiles`);let N;if(B===null?N=!1:B&&(typeof B=="string"?N=B:N=B.pattern),x&&x.isCancellationRequested)return Promise.resolve([]);const{includePattern:V,folder:$}=E(I);return this._proxy.$startFileSearch((0,y.withUndefinedAsNull)(V),(0,y.withUndefinedAsNull)($),(0,y.withUndefinedAsNull)(N),(0,y.withUndefinedAsNull)(O),x).then(z=>Array.isArray(z)?z.map(ee=>r.URI.revive(ee)):[])}async findTextInFiles(I,B,O,D,x=b.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${D.value}, entryPoint: findTextInFiles`);const N=this._requestIdProvider.getNext(),V=typeof B.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:B.previewOptions,{includePattern:$,folder:z}=E(B.include),ee=typeof B.exclude=="string"?B.exclude:B.exclude?B.exclude.pattern:void 0,j={ignoreSymlinks:typeof B.followSymlinks=="boolean"?!B.followSymlinks:void 0,disregardIgnoreFiles:typeof B.useIgnoreFiles=="boolean"?!B.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof B.useGlobalIgnoreFiles=="boolean"?!B.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof B.useDefaultExcludes=="boolean"?!B.useDefaultExcludes:!0,fileEncoding:B.encoding,maxResults:B.maxResults,previewOptions:V,afterContext:B.afterContext,beforeContext:B.beforeContext,includePattern:$,excludePattern:ee},Q=!1;if(this._activeSearchCallbacks[N]=le=>{if(Q)return;const ve=r.URI.revive(le.resource);le.results.forEach(ue=>{(0,c.resultIsMatch)(ue)?O({uri:ve,preview:{text:ue.preview.text,matches:(0,u.mapArrayOrNot)(ue.preview.matches,Fe=>new _.Range(Fe.startLineNumber,Fe.startColumn,Fe.endLineNumber,Fe.endColumn))},ranges:(0,u.mapArrayOrNot)(ue.ranges,Fe=>new _.Range(Fe.startLineNumber,Fe.startColumn,Fe.endLineNumber,Fe.endColumn))}):O({uri:ve,text:ue.text,lineNumber:ue.lineNumber})})},x.isCancellationRequested)return{};try{const le=await this._proxy.$startTextSearch(I,(0,y.withUndefinedAsNull)(z),j,N,x);return delete this._activeSearchCallbacks[N],le||{}}catch(le){throw delete this._activeSearchCallbacks[N],le}}$handleTextSearchResult(I,B){this._activeSearchCallbacks[B]&&this._activeSearchCallbacks[B](I)}saveAll(I){return this._proxy.$saveAll(I)}resolveProxy(I){return this._proxy.$resolveProxy(I)}get trusted(){return this._trusted}requestWorkspaceTrust(I){return this._proxy.$requestWorkspaceTrust(I)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};l=Ue([Be(0,d.IExtHostRpcService),Be(1,o.IExtHostInitDataService),Be(2,w.IExtHostFileSystemInfo),Be(3,h.ILogService)],l),e.ExtHostWorkspace=l,e.IExtHostWorkspace=(0,a.createDecorator)("IExtHostWorkspace");function E(T){let I,B;return T&&(typeof T=="string"?I=T:(I=T.pattern,B=T.baseFolder||r.URI.file(T.base))),{includePattern:I,folder:B}}}),define(be[33],Ee([0,1,23,3,32,5,7,148,63,10,13,4,14,12,2]),function(re,e,u,M,b,P,t,A,C,k,F,y,r,m,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function h(R,n){if(n){const i=n.split(".");let g=R;for(let f=0;g&&f<i.length;f++)g=g[i[f]];return g}}function p(R){return R instanceof a.URI}function S(R){return R&&R.uri instanceof a.URI&&R.languageId&&typeof R.languageId=="string"}function w(R){return R&&!R.uri&&R.languageId&&typeof R.languageId=="string"}function o(R){return R&&R.uri instanceof a.URI&&(!R.name||typeof R.name=="string")&&(!R.index||typeof R.index=="number")}function d(R){if(p(R))return{resource:R};if(S(R))return{resource:R.uri,overrideIdentifier:R.languageId};if(w(R))return{overrideIdentifier:R.languageId};if(o(R))return{resource:R.uri};if(R===null)return{resource:null}}let _=class{constructor(n,i,g){this._proxy=n.getProxy(P.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=g,this._barrier=new F.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(n=>this._actual)}$initializeConfiguration(n){this._actual=new c(this._proxy,this._extHostWorkspace,n,this._logService),this._barrier.open()}$acceptConfigurationChanged(n,i){this.getConfigProvider().then(g=>g.$acceptConfigurationChanged(n,i))}};_=Ue([Be(0,r.IExtHostRpcService),Be(1,b.IExtHostWorkspace),Be(2,m.ILogService)],_),e.ExtHostConfiguration=_;class c{constructor(n,i,g,f){this._onDidChangeConfiguration=new M.Emitter,this._proxy=n,this._logService=f,this._extHostWorkspace=i,this._configuration=A.Configuration.parse(g),this._configurationScopes=this._toMap(g.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(n,i){const g={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=A.Configuration.parse(n),this._configurationScopes=this._toMap(n.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,g))}getConfiguration(n,i,g){const f=d(i)||{},s=this._toReadonlyValue(n?h(this._configuration.getValue(void 0,f,this._extHostWorkspace.workspace),n):this._configuration.getValue(void 0,f,this._extHostWorkspace.workspace));n&&this._validateConfigurationAccess(n,f,g?.identifier);function v(E){if(E==null)return null;if(typeof E=="boolean")return E?1:4;switch(E){case t.ConfigurationTarget.Global:return 1;case t.ConfigurationTarget.Workspace:return 4;case t.ConfigurationTarget.WorkspaceFolder:return 5}}const l={has(E){return typeof h(s,E)!="undefined"},get:(E,T)=>{this._validateConfigurationAccess(n?`${n}.${E}`:E,f,g?.identifier);let I=h(s,E);if(typeof I=="undefined")I=T;else{let B;const O=(D,x)=>{let N;const V=()=>{B=B||(0,u.deepClone)(s),N=N||h(B,x)};return(0,k.isObject)(D)?new Proxy(D,{get:($,z)=>{if(typeof z=="string"&&z.toLowerCase()==="tojson")return V(),()=>N;if(B)return N=N||h(B,x),N[z];const ee=$[z];return typeof z=="string"?O(ee,`${x}.${z}`):ee},set:($,z,ee)=>(V(),N&&(N[z]=ee),!0),deleteProperty:($,z)=>(V(),N&&delete N[z],!0),defineProperty:($,z,ee)=>(V(),N&&Object.defineProperty(N,z,ee),!0)}):D};I=O(I,E)}return I},update:(E,T,I,B)=>{E=n?`${n}.${E}`:E;const O=v(I);return T!==void 0?this._proxy.$updateConfigurationOption(O,E,T,f,B):this._proxy.$removeConfigurationOption(O,E,f,B)},inspect:E=>{E=n?`${n}.${E}`:E;const T=(0,u.deepClone)(this._configuration.inspect(E,f,this._extHostWorkspace.workspace));if(T)return{key:E,defaultValue:T.default?.value,globalValue:T.user?.value,workspaceValue:T.workspace?.value,workspaceFolderValue:T.workspaceFolder?.value,defaultLanguageValue:T.default?.override,globalLanguageValue:T.user?.override,workspaceLanguageValue:T.workspace?.override,workspaceFolderLanguageValue:T.workspaceFolder?.override,languageIds:T.overrideIdentifiers}}};return typeof s=="object"&&(0,u.mixin)(l,s,!1),Object.freeze(l)}_toReadonlyValue(n){const i=g=>(0,k.isObject)(g)?new Proxy(g,{get:(f,s)=>i(f[s]),set:(f,s,v)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(s)}' of object`)},deleteProperty:(f,s)=>{throw new Error(`TypeError: Cannot delete read only property '${String(s)}' of object`)},defineProperty:(f,s)=>{throw new Error(`TypeError: Cannot define property '${String(s)}' for a readonly object`)},setPrototypeOf:f=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):g;return i(n)}_validateConfigurationAccess(n,i,g){const f=C.OVERRIDE_PROPERTY_PATTERN.test(n)?4:this._configurationScopes.get(n),s=g?`[${g.value}] `:"";if(f===4){typeof i?.resource=="undefined"&&this._logService.warn(`${s}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${n}', provide the URI of a resource or 'null' for any resource.`);return}if(f===3){i?.resource&&this._logService.warn(`${s}Accessing a window scoped configuration for a resource is not expected. To associate '${n}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(n,i){const g=new A.ConfigurationChangeEvent(n,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(f,s)=>g.affectsConfiguration(f,d(s))})}_toMap(n){return n.reduce((i,g)=>(i.set(g[0],g[1]),i),new Map)}}e.ExtHostConfigProvider=c,e.IExtHostConfiguration=(0,y.createDecorator)("IExtHostConfiguration")});var Xe=this&&this.__classPrivateFieldSet||function(re,e,u,M,b){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!b:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?b.call(re,u):b?b.value=u:e.set(re,u),u},Ae=this&&this.__classPrivateFieldGet||function(re,e,u,M){if(u==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?M:u==="a"?M.call(re):M?M.value:e.get(re)};define(be[99],Ee([0,1,2,13,3,5,7,32,51,33,21,41,14,28,4,11,25,12,71,169,16]),function(re,e,u,M,b,P,t,A,C,k,F,y,r,m,a,h,p,S,w,o,d){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var c;(function(x){function N($){if($!=null)return $}x.from=N;function V($){if($!=null)return $}x.to=V})(c=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var R;(function(x){function N($){if($!=null)return $}x.from=N;function V($){if($!=null)return $}x.to=V})(R=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var n;(function(x){function N($){if($!=null)return $}x.from=N;function V($){if($!=null)return $}x.to=V})(n=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var i;(function(x){function N(z){if(z){const ee=z;return ee&&!!ee.process}else return!1}x.is=N;function V(z){if(z==null)return;const ee={process:z.process,args:z.args};return z.options&&(ee.options=n.from(z.options)),ee}x.from=V;function $(z){if(z!=null)return new t.ProcessExecution(z.process,z.args,z.options)}x.to=$})(i=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var g;(function(x){function N($){if($!=null)return $}x.from=N;function V($){if($!=null)return $}x.to=V})(g=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var f;(function(x){function N(z){if(z){const ee=z;return ee&&(!!ee.commandLine||!!ee.command)}else return!1}x.is=N;function V(z){if(z==null)return;const ee={};return z.commandLine!==void 0?ee.commandLine=z.commandLine:(ee.command=z.command,ee.args=z.args),z.options&&(ee.options=g.from(z.options)),ee}x.from=V;function $(z){if(!(z==null||z.command===void 0&&z.commandLine===void 0))return z.commandLine?new t.ShellExecution(z.commandLine,z.options):new t.ShellExecution(z.command,z.args?z.args:[],z.options)}x.to=$})(f=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var s;(function(x){function N(z){if(z){let ee=z;return ee&&ee.customExecution==="customExecution"}else return!1}x.is=N;function V(z){return{customExecution:"customExecution"}}x.from=V;function $(z,ee){return ee.get(z)}x.to=$})(s=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var v;(function(x){function N(V,$){let z;return V.scope!==void 0&&typeof V.scope!="number"?z=V.scope.uri:V.scope!==void 0&&typeof V.scope=="number"&&(V.scope===t.TaskScope.Workspace&&$&&$.workspaceFile?z=$.workspaceFile:z=o.USER_TASKS_GROUP_KEY),{id:V._id,workspaceFolder:z}}x.from=N})(v=e.TaskHandleDTO||(e.TaskHandleDTO={}));var l;(function(x){function N(V){if(V!=null)return{_id:V.id,isDefault:V.isDefault}}x.from=N})(l=e.TaskGroupDTO||(e.TaskGroupDTO={}));var E;(function(x){function N(z,ee){if(z==null)return[];const j=[];for(let Q of z){const le=V(Q,ee);le&&j.push(le)}return j}x.fromMany=N;function V(z,ee){if(z==null)return;let j;z.execution instanceof t.ProcessExecution?j=i.from(z.execution):z.execution instanceof t.ShellExecution?j=f.from(z.execution):z.execution&&z.execution instanceof t.CustomExecution&&(j=s.from(z.execution));const Q=c.from(z.definition);let le;return z.scope?typeof z.scope=="number"?le=z.scope:le=z.scope.uri:le=t.TaskScope.Workspace,!Q||!le?void 0:{_id:z._id,definition:Q,name:z.name,source:{extensionId:ee.identifier.value,label:z.source,scope:le},execution:j,isBackground:z.isBackground,group:l.from(z.group),presentationOptions:R.from(z.presentationOptions),problemMatchers:z.problemMatchers,hasDefinedMatchers:z.hasDefinedMatchers,runOptions:z.runOptions?z.runOptions:{reevaluateOnRerun:!0},detail:z.detail}}x.from=V;async function $(z,ee,j){if(z==null)return;let Q;i.is(z.execution)?Q=i.to(z.execution):f.is(z.execution)?Q=f.to(z.execution):s.is(z.execution)&&(Q=s.to(z._id,j));const le=c.to(z.definition);let ve;if(z.source&&(z.source.scope!==void 0?typeof z.source.scope=="number"?ve=z.source.scope:ve=await ee.resolveWorkspaceFolder(u.URI.revive(z.source.scope)):ve=t.TaskScope.Workspace),!le||!ve)return;const ue=new t.Task(le,ve,z.name,z.source.label,Q,z.problemMatchers);return z.isBackground!==void 0&&(ue.isBackground=z.isBackground),z.group!==void 0&&(ue.group=t.TaskGroup.from(z.group._id),ue.group&&z.group.isDefault&&(ue.group=new t.TaskGroup(ue.group.id,ue.group.label),z.group.isDefault&&(ue.group.isDefault=z.group.isDefault))),z.presentationOptions&&(ue.presentationOptions=R.to(z.presentationOptions)),z._id&&(ue._id=z._id),z.detail&&(ue.detail=z.detail),ue}x.to=$})(E=e.TaskDTO||(e.TaskDTO={}));var T;(function(x){function N($){return $}x.from=N;function V($){if(!!$)return Object.assign(Object.create(null),$)}x.to=V})(T=e.TaskFilterDTO||(e.TaskFilterDTO={}));class I{constructor(N,V,$){this._id=V,this._task=$,_.set(this,void 0),Xe(this,_,N,"f")}get task(){return this._task}terminate(){Ae(this,_,"f").terminateTask(this)}fireDidStartProcess(N){}fireDidEndProcess(N){}}_=new WeakMap;var B;(function(x){function N(V){return{id:V._id,task:void 0}}x.from=N})(B=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let O=class{constructor(N,V,$,z,ee,j,Q,le){this._onDidExecuteTask=new b.Emitter,this._onDidTerminateTask=new b.Emitter,this._onDidTaskProcessStarted=new b.Emitter,this._onDidTaskProcessEnded=new b.Emitter,this._proxy=N.getProxy(P.MainContext.MainThreadTask),this._workspaceProvider=$,this._editorService=z,this._configurationService=ee,this._terminalService=j,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=Q,this._deprecationService=le,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(N,V,$){if(!$)return new t.Disposable(()=>{});const z=this.nextHandle();return this._handlers.set(z,{type:V,provider:$,extension:N}),this._proxy.$registerTaskProvider(z,V),new t.Disposable(()=>{this._handlers.delete(z),this._proxy.$unregisterTaskProvider(z)})}registerTaskSystem(N,V){this._proxy.$registerTaskSystem(N,V)}fetchTasks(N){return this._proxy.$fetchTasks(T.from(N)).then(async V=>{const $=[];for(let z of V){const ee=await E.to(z,this._workspaceProvider,this._providedCustomExecutions2);ee&&$.push(ee)}return $})}get taskExecutions(){const N=[];return this._taskExecutions.forEach(V=>N.push(V)),N}terminateTask(N){if(!(N instanceof I))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(N._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(N,V,$){const z=this._providedCustomExecutions2.get(N.id);z&&(this._activeCustomExecutions2.set(N.id,z),this._terminalService.attachPtyToTerminal(V,await z.callback($))),this._lastStartedTask=N.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(N)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(N){const V=await this.getTaskExecution(N);this._taskExecutionPromises.delete(N.id),this._taskExecutions.delete(N.id),this.customExecutionComplete(N),this._onDidTerminateTask.fire({execution:V})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(N){const V=await this.getTaskExecution(N.id);this._onDidTaskProcessStarted.fire({execution:V,processId:N.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(N){const V=await this.getTaskExecution(N.id);this._onDidTaskProcessEnded.fire({execution:V,exitCode:N.exitCode})}$provideTasks(N,V){const $=this._handlers.get(N);if(!$)return Promise.reject(new Error("no handler found"));const z=[],ee=(0,M.asPromise)(()=>$.provider.provideTasks(F.CancellationToken.None)).then(j=>this.provideTasksInternal(V,z,$,j));return new Promise(j=>{ee.then(Q=>{Promise.all(z).then(()=>{j(Q)})})})}async $resolveTask(N,V){const $=this._handlers.get(N);if(!$)return Promise.reject(new Error("no handler found"));if(V.definition.type!==$.type)throw new Error(`Unexpected: Task of type [${V.definition.type}] cannot be resolved by provider of type [${$.type}].`);const z=await E.to(V,this._workspaceProvider,this._providedCustomExecutions2);if(!z)throw new Error("Unexpected: Task cannot be resolved.");const ee=await $.provider.resolveTask(z,F.CancellationToken.None);if(!ee)return;this.checkDeprecation(ee,$);const j=E.from(ee,$.extension);if(!j)throw new Error("Unexpected: Task cannot be resolved.");if(ee.definition!==z.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return s.is(j.execution)&&await this.addCustomExecution(j,ee,!0),await this.resolveTaskInternal(j)}nextHandle(){return this._handleCounter++}async addCustomExecution(N,V,$){const z=await this._proxy.$createTaskId(N);!$&&!this._providedCustomExecutions2.has(z)&&(this._notProvidedCustomExecutions.add(z),this._activeCustomExecutions2.set(z,V.execution)),this._providedCustomExecutions2.set(z,V.execution)}async getTaskExecution(N,V){if(typeof N=="string"){const ee=this._taskExecutionPromises.get(N);if(!ee)throw new Error("Unexpected: The specified task is missing an execution");return ee}let $=this._taskExecutionPromises.get(N.id);if($)return $;const z=new Promise((ee,j)=>{function Q(le,ve,ue){ue?ee(new I(le,ve.id,ue)):j("Unexpected: Task does not exist.")}V?Q(this,N,V):E.to(N.task,this._workspaceProvider,this._providedCustomExecutions2).then(le=>Q(this,N,le))});return this._taskExecutionPromises.set(N.id,z),z.then(ee=>(this._taskExecutions.set(N.id,ee),ee),ee=>Promise.reject(ee))}checkDeprecation(N,V){N._deprecated&&this._deprecationService.report("Task.constructor",V.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(N){this._activeCustomExecutions2.get(N.id)&&this._activeCustomExecutions2.delete(N.id),this._notProvidedCustomExecutions.has(N.id)&&this._lastStartedTask!==N.id&&(this._providedCustomExecutions2.delete(N.id),this._notProvidedCustomExecutions.delete(N.id));let $=this._notProvidedCustomExecutions.values(),z=$.next();for(;!z.done;)!this._activeCustomExecutions2.has(z.value)&&this._lastStartedTask!==z.value&&(this._providedCustomExecutions2.delete(z.value),this._notProvidedCustomExecutions.delete(z.value)),z=$.next()}};O=Ue([Be(0,r.IExtHostRpcService),Be(1,m.IExtHostInitDataService),Be(2,A.IExtHostWorkspace),Be(3,C.IExtHostDocumentsAndEditors),Be(4,k.IExtHostConfiguration),Be(5,y.IExtHostTerminalService),Be(6,S.ILogService),Be(7,w.IExtHostApiDeprecationService)],O),e.ExtHostTaskBase=O;let D=class extends O{constructor(N,V,$,z,ee,j,Q,le){super(N,V,$,z,ee,j,Q,le);this.registerTaskSystem(h.Schemas.vscodeRemote,{scheme:h.Schemas.vscodeRemote,authority:"",platform:p.PlatformToString(0)})}async executeTask(N,V){if(!V.execution)throw new Error("Tasks to execute must include an execution");const $=E.from(V,N);if($===void 0)throw new Error("Task is not valid");if(s.is($.execution))await this.addCustomExecution($,V,!1);else throw new d.NotSupportedError;const z=await this.getTaskExecution(await this._proxy.$getTaskExecution($),V);return this._proxy.$executeTask($).catch(ee=>{throw new Error(ee)}),z}provideTasksInternal(N,V,$,z){const ee=[];if(z)for(let j of z){this.checkDeprecation(j,$),(!j.definition||!N[j.definition.type])&&this._logService.warn(`The task [${j.source}, ${j.name}] uses an undefined task type. The task will be ignored in the future.`);const Q=E.from(j,$.extension);Q&&s.is(Q.execution)?(ee.push(Q),V.push(this.addCustomExecution(Q,j,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:ee,extension:$.extension}}async resolveTaskInternal(N){if(s.is(N.execution))return N;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(N,V){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(N,V,$){}};D=Ue([Be(0,r.IExtHostRpcService),Be(1,m.IExtHostInitDataService),Be(2,A.IExtHostWorkspace),Be(3,C.IExtHostDocumentsAndEditors),Be(4,k.IExtHostConfiguration),Be(5,y.IExtHostTerminalService),Be(6,S.ILogService),Be(7,w.IExtHostApiDeprecationService)],D),e.WorkerExtHostTask=D,e.IExtHostTask=(0,a.createDecorator)("IExtHostTask")}),define(be[221],Ee([0,1,15,54,29,78,20,11,17,24,9,10,2,110,135,85,49,92,220,42]),function(re,e,u,M,b,P,t,A,C,k,F,y,r,m,a,h,p,S,w,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let d=class{constructor(v,l,E,T){this.configurationService=v,this.workspaceContextService=l,this.editorGroupsService=E,this.pathService=T}text(v,l,E={}){v=this.getContentPattern(v,E);const T=this.configurationService.getValue(),I=l&&l.some(O=>!this.configurationService.getValue({resource:O}).search.useRipgrep);return{...this.commonQuery(l?.map(p.toWorkspaceFolder),E),type:2,contentPattern:v,previewOptions:E.previewOptions,maxFileSize:E.maxFileSize,usePCRE2:T.search.usePCRE2||I||!1,beforeContext:E.beforeContext,afterContext:E.afterContext,userDisabledExcludesAndIgnoreFiles:E.disregardExcludeSettings&&E.disregardIgnoreFiles}}getContentPattern(v,l){const E=this.configurationService.getValue();v.isRegExp&&(v.pattern=v.pattern.replace(/\r?\n/g,"\\n"));const T={...v,wordSeparators:E.editor.wordSeparators};return this.isCaseSensitive(v,l)&&(T.isCaseSensitive=!0),this.isMultiline(v)&&(T.isMultiline=!0),T}file(v,l={}){return{...this.commonQuery(v,l),type:1,filePattern:l.filePattern?l.filePattern.trim():l.filePattern,exists:l.exists,sortByScore:l.sortByScore,cacheKey:l.cacheKey}}handleIncludeExclude(v,l){return v?(v=Array.isArray(v)?v.map(i):i(v),l?this.parseSearchPaths(v):{pattern:c(...Array.isArray(v)?v:[v])}):{}}commonQuery(v=[],l={}){const E=this.handleIncludeExclude(l.includePattern,l.expandPatterns),T=this.handleIncludeExclude(l.excludePattern,l.expandPatterns),I=v.length>1,B=(E.searchPaths&&E.searchPaths.length?E.searchPaths.map(x=>this.getFolderQueryForSearchPath(x,l,T)):v.map(x=>this.getFolderQueryForRoot(x,l,T,I))).filter(x=>!!x),O={_reason:l._reason,folderQueries:B,usingSearchPaths:!!(E.searchPaths&&E.searchPaths.length),extraFileResources:l.extraFileResources,excludePattern:T.pattern,includePattern:E.pattern,onlyOpenEditors:l.onlyOpenEditors,maxResults:l.maxResults};if(l.onlyOpenEditors){const N=u.coalesce(u.flatten(this.editorGroupsService.groups.map($=>$.editors.map(z=>z.resource)))).filter($=>(0,o.pathIncludedInQuery)(O,$.fsPath)),V=this.commonQueryFromFileList(N);return{...O,...V}}const D=l.extraFileResources&&l.extraFileResources.filter(x=>(0,o.pathIncludedInQuery)(O,x.fsPath));return O.extraFileResources=D&&D.length?D:void 0,O}commonQueryFromFileList(v){const l=[],E=new t.ResourceMap,T={};let I=!1;return v.forEach(B=>{if(B.scheme===A.Schemas.walkThrough)return;if((0,k.isAbsolutePath)(B)){const D=this.workspaceContextService.getWorkspaceFolder(B)?.uri??B.with({path:C.dirname(B.fsPath)});let x=E.get(D);x||(I=!0,x={folder:D,includePattern:{}},l.push(x),E.set(D,x));const N=C.relative(D.fsPath,B.fsPath);(0,y.assertIsDefined)(x.includePattern)[N.replace(/\\/g,"/")]=!0}else B.fsPath&&(I=!0,T[B.fsPath]=!0)}),{folderQueries:l,includePattern:T,usingSearchPaths:!0,excludePattern:I?void 0:{"**/*":!0}}}isCaseSensitive(v,l){if(l.isSmartCase){if(v.isRegExp){if(F.containsUppercaseCharacter(v.pattern,!0))return!0}else if(F.containsUppercaseCharacter(v.pattern))return!0}return!!v.isCaseSensitive}isMultiline(v){return v.isMultiline||v.isRegExp&&(0,m.isMultilineRegexSource)(v.pattern)||v.pattern.indexOf(`
`)>=0?!0:!!v.isMultiline}parseSearchPaths(v){const l=V=>C.isAbsolute(V)||/^\.\.?([\/\\]|$)/.test(V),T=(Array.isArray(v)?v:R(v)).map(V=>{const $=this.pathService.resolvedUserHome;return $?(0,P.untildify)(V,$.scheme===A.Schemas.file?$.fsPath:$.path):V}),I=M.groupBy(T,V=>l(V)?"searchPaths":"exprSegments"),B=(I.exprSegments||[]).map(V=>F.rtrim(V,"/")).map(V=>F.rtrim(V,"\\")).map(V=>(V[0]==="."&&(V="*"+V),n(V))),O={},D=this.expandSearchPathPatterns(I.searchPaths||[]);D&&D.length&&(O.searchPaths=D);const x=u.flatten(B),N=c(...x);return N&&(O.pattern=N),O}getExcludesForFolder(v,l){return l.disregardExcludeSettings?void 0:(0,o.getExcludes)(v,!l.disregardSearchExcludeSettings)}expandSearchPathPatterns(v){if(!v||!v.length)return[];const l=u.flatten(v.map(T=>{let{pathPortion:I,globPortion:B}=_(T);B&&(B=g(B));const O=this.expandOneSearchPath(I);return u.flatten(O.map(D=>this.resolveOneSearchPathPattern(D,B)))})),E=new Map;return l.forEach(T=>{const I=T.searchPath.toString(),B=E.get(I);B?T.pattern&&(B.pattern=B.pattern||{},B.pattern[T.pattern]=!0):E.set(I,{searchPath:T.searchPath,pattern:T.pattern?c(T.pattern):void 0})}),Array.from(E.values())}expandOneSearchPath(v){if(C.isAbsolute(v)){const l=this.workspaceContextService.getWorkspace().folders;return l[0]&&l[0].uri.scheme!==A.Schemas.file?[{searchPath:l[0].uri.with({path:v})}]:[{searchPath:r.URI.file(C.normalize(v))}]}if(this.workspaceContextService.getWorkbenchState()===2){const l=this.workspaceContextService.getWorkspace().folders[0].uri;if(v=i(v),v.startsWith("../")||v===".."){const T=C.posix.resolve(l.path,v);return[{searchPath:l.with({path:T})}]}const E=g(v);return[{searchPath:l,pattern:E}]}else{if(v==="./"||v===".\\")return[];{const l=v.replace(/^\.[\/\\]/,""),T=this.workspaceContextService.getWorkspace().folders.map(I=>{const B=l.match(new RegExp(`^${F.escapeRegExpCharacters(I.name)}(?:/(.*)|$)`));return B?{match:B,folder:I}:null}).filter(y.isDefined);if(T.length)return T.map(I=>{const B=I.match[1];return{searchPath:I.folder.uri,pattern:B&&g(B)}});{const I=v.match(/\.[\/\\](.+)[\/\\]?/),B=I?I[1]:v,O=a.localize(0,null,B);throw new Error(O)}}}}resolveOneSearchPathPattern(v,l){const E=v.pattern&&l?`${v.pattern}/${l}`:v.pattern||l,T=[{searchPath:v.searchPath,pattern:E}];return E&&!E.endsWith("**")&&T.push({searchPath:v.searchPath,pattern:E+"/**"}),T}getFolderQueryForSearchPath(v,l,E){const T=this.getFolderQueryForRoot((0,p.toWorkspaceFolder)(v.searchPath),l,E,!1);return T?{...T,includePattern:v.pattern}:null}getFolderQueryForRoot(v,l,E,T){let I;const B=r.URI.isUri(v)?v:v.uri;if(E.searchPaths){const V=E.searchPaths.filter($=>(0,k.isEqual)($.searchPath,B))[0];if(V&&!V.pattern)return null;V&&(I=V.pattern)}const O=this.configurationService.getValue({resource:B}),x={...this.getExcludesForFolder(O,l)||{},...I||{}},N=r.URI.isUri(v)?(0,k.basename)(v):v.name;return{folder:B,folderName:T?N:void 0,excludePattern:Object.keys(x).length>0?x:void 0,fileEncoding:O.files&&O.files.encoding,disregardIgnoreFiles:typeof l.disregardIgnoreFiles=="boolean"?l.disregardIgnoreFiles:!O.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof l.disregardGlobalIgnoreFiles=="boolean"?l.disregardGlobalIgnoreFiles:!O.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof l.ignoreSymlinks=="boolean"?l.ignoreSymlinks:!O.search.followSymlinks}}};d=Ue([Be(0,h.IConfigurationService),Be(1,p.IWorkspaceContextService),Be(2,S.IEditorGroupsService),Be(3,w.IPathService)],d),e.QueryBuilder=d;function _(s){const v=s.match(/[\*\{\}\(\)\[\]\?]/);if(v){const l=v.index,E=s.substr(0,l).match(/[/|\\][^/\\]*$/);if(E){let T=s.substr(0,E.index);return T.match(/[/\\]/)||(T+="/"),{pathPortion:T,globPortion:s.substr((E.index||0)+1)}}}return{pathPortion:s}}function c(...s){return s.length?s.reduce((v,l)=>(v[l]=!0,v),Object.create(null)):void 0}function R(s){return b.splitGlobAware(s,",").map(v=>v.trim()).filter(v=>!!v.length)}function n(s){return[`**/${s}/**`,`**/${s}`].map(l=>l.replace(/\*\*\/\*\*/g,"**"))}function i(s){return s.replace(/\\/g,"/")}function g(s){return i(s).replace(/^\.\//,"").replace(/\/+$/g,"")}function f(s,v){s=u.distinct(s,T=>T.toString());const l=[],E=v.getWorkspace();return s&&s.forEach(T=>{let I;if(v.getWorkbenchState()===2)I=(0,k.relativePath)(E.folders[0].uri,T),I&&I!=="."&&(I="./"+I);else{const B=v.getWorkspaceFolder(T);if(B){const O=B.name;if(E.folders.filter(x=>x.name===O).length===1){const x=(0,k.relativePath)(B.uri,T);x===""?I=`./${B.name}`:I=`./${B.name}/${x}`}else I=T.fsPath}}I&&l.push(I)}),l}e.resolveResourcesForSearchIncludes=f}),define(be[222],Ee([0,1,24,2,21,16,4,221,42,49]),function(re,e,u,M,b,P,t,A,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const F=7e3;function y(h,p){const S=p.activationEvents;if(!S)return Promise.resolve(void 0);const w=[],o=[];for(const i of S)if(/^workspaceContains:/.test(i)){const g=i.substr("workspaceContains:".length);g.indexOf("*")>=0||g.indexOf("?")>=0||h.forceUsingSearch?o.push(g):w.push(g)}if(w.length===0&&o.length===0)return Promise.resolve(void 0);let d;const _=new Promise((i,g)=>{d=i}),c=i=>d({activationEvent:i}),R=Promise.all(w.map(i=>r(h,i,c))).then(()=>{}),n=m(h,p.identifier,o,c);return Promise.all([R,n]).then(()=>{d(void 0)}),_}e.checkActivateWorkspaceContainsExtension=y;async function r(h,p,S){for(const w of h.folders)if(await h.exists(u.joinPath(M.URI.revive(w),p))){S(`workspaceContains:${p}`);return}}async function m(h,p,S,w){if(S.length===0)return Promise.resolve(void 0);const o=new b.CancellationTokenSource,d=h.checkExists(h.folders,S,o.token),_=setTimeout(async()=>{o.cancel(),w(`workspaceContainsTimeout:${S.join(",")}`)},F);let c=!1;try{c=await d}catch(R){P.isPromiseCanceledError(R)||P.onUnexpectedError(R)}o.dispose(),clearTimeout(_),c&&w(`workspaceContains:${S.join(",")}`)}function a(h,p,S,w){const o=h.get(t.IInstantiationService),d=h.get(C.ISearchService),c=o.createInstance(A.QueryBuilder).file(p.map(R=>(0,k.toWorkspaceFolder)(M.URI.revive(R))),{_reason:"checkExists",includePattern:S,exists:!0});return d.fileSearch(c,w).then(R=>!!R.limitHit,R=>P.isPromiseCanceledError(R)?!1:Promise.reject(R))}e.checkGlobFileExists=a});var Xe=this&&this.__classPrivateFieldSet||function(re,e,u,M,b){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!b:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?b.call(re,u):b?b.value=u:e.set(re,u),u},Ae=this&&this.__classPrivateFieldGet||function(re,e,u,M){if(u==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?M:u==="a"?M.call(re):M?M.value:e.get(re)};define(be[34],Ee([0,1,126,17,75,24,13,6,20,2,12,5,33,182,73,32,27,180,16,26,22,154,7,86,4,28,74,14,62,66,41,3,222,70,156,11]),function(re,e,u,M,b,P,t,A,C,k,F,y,r,m,a,h,p,S,w,o,d,_,c,R,n,i,g,f,s,v,l,E,T,I,B,O){"use strict";var D,x,N;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,n.createDecorator)("IHostUtils");let V=class Hi extends A.Disposable{constructor(j,Q,le,ve,ue,Fe,Ke,Oe,He,Je){super();this._onDidChangeRemoteConnectionData=this._register(new E.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=Q,this._extHostContext=le,this._initData=Ke,this._extHostWorkspace=ve,this._extHostConfiguration=ue,this._logService=Fe,this._extHostTunnelService=He,this._extHostTerminalService=Je,this._disposables=new A.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(y.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(y.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(y.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new t.Barrier,this._readyToStartExtensionHost=new t.Barrier,this._readyToRunExtensions=new t.Barrier,this._eagerExtensionsActivated=new t.Barrier,this._registry=new S.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new a.ExtHostStorage(this._extHostContext),this._secretState=new I.ExtHostSecretState(this._extHostContext),this._storagePath=Oe,this._instaService=j.createChild(new s.ServiceCollection([a.IExtHostStorage,this._storage],[I.IExtHostSecretState,this._secretState]));const Ye=new Set;this._initData.hostExtensions.forEach(Qe=>Ye.add(o.ExtensionIdentifier.toKey(Qe))),this._activator=new m.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(Qe,W,K)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Qe,w.transformErrorForSerialization(W),K)},actualActivateExtension:async(Qe,W)=>{if(Ye.has(o.ExtensionIdentifier.toKey(Qe)))return await this._mainThreadExtensionsProxy.$activateExtension(Qe,W),new m.HostExtension;const K=this._registry.getExtensionDescription(Qe);return this._activateExtension(K,W)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),b.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(j){w.onUnexpectedError(j)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let j=[];try{j=this._registry.getAllExtensionDescriptions().map(ue=>ue.identifier).filter(ue=>this.isActivated(ue)).map(ue=>this._deactivate(ue))}catch(Q){}await Promise.all(j)}isActivated(j){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(j):!1}_activateByEvent(j,Q){return this._activator.activateByEvent(j,Q)}_activateById(j,Q){return this._activator.activateById(j,Q)}activateByIdWithErrors(j,Q){return this._activateById(j,Q).then(()=>{const le=this._activator.getActivatedExtension(j);if(le.activationFailed)return Promise.reject(le.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(j=>this._registry)}getExtensionExports(j){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(j).exports:null}async _realPathExtensionUri(j){if(j.scheme!==O.Schemas.file)return j;const Q=await this._hostUtils.realpath(j.fsPath);return k.URI.file(Q)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const j=C.TernarySearchTree.forUris(Q=>P.extUriBiasedIgnorePathCase.ignorePathCasing(Q));for(const Q of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint(Q)){const le=await this._realPathExtensionUri(Q.extensionLocation);j.set(le,Q)}return j})()),this._extensionPathIndex}_deactivate(j){let Q=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(j))return Q;const le=this._activator.getActivatedExtension(j);if(!le)return Q;try{typeof le.module.deactivate=="function"&&(Q=Promise.resolve(le.module.deactivate()).then(void 0,ve=>(this._logService.error(ve),Promise.resolve(void 0))))}catch(ve){this._logService.error(ve)}try{(0,A.dispose)(le.subscriptions)}catch(ve){this._logService.error(ve)}return Q}async _activateExtension(j,Q){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(j.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(j.identifier),this._doActivateExtension(j,Q).then(le=>{const ve=le.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(j.identifier,ve.codeLoadingTime,ve.activateCallTime,ve.activateResolvedTime,Q),this._logExtensionActivationTimes(j,Q,"success",ve),le},le=>{throw this._logExtensionActivationTimes(j,Q,"failure"),le})}_logExtensionActivationTimes(j,Q,le,ve){const ue=$(j,Q);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...ue,...ve||{},outcome:le})}_doActivateExtension(j,Q){const le=$(j,Q);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",le);const ve=this._getEntryPoint(j);if(!ve)return Promise.resolve(new m.EmptyExtension(m.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${j.identifier.value}, startup: ${Q.startup}, activationEvent: '${Q.activationEvent}'${j.identifier.value!==Q.extensionId.value?`, root cause: ${Q.extensionId.value}`:""}`),this._logService.flush();const ue=new m.ExtensionActivationTimesBuilder(Q.startup);return Promise.all([this._loadCommonJSModule(j.identifier,(0,P.joinPath)(j.extensionLocation,ve),ue),this._loadExtensionContext(j)]).then(Fe=>(b.mark(`code/extHost/willActivateExtension/${j.identifier.value}`),Hi._callActivate(this._logService,j.identifier,Fe[0],Fe[1],ue))).then(Fe=>(b.mark(`code/extHost/didActivateExtension/${j.identifier.value}`),Fe))}_loadExtensionContext(j){const Q=new _.ExtensionGlobalMemento(j,this._storage),le=new _.ExtensionMemento(j.identifier.value,!1,this._storage),ve=new B.ExtensionSecrets(j,this._secretState),ue=j.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?c.ExtensionMode.Test:c.ExtensionMode.Development:c.ExtensionMode.Production,Fe=this._initData.remote.isRemote?c.ExtensionKind.Workspace:c.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${j.identifier.value}`),Promise.all([Q.whenReady,le.whenReady,this._storagePath.whenReady]).then(()=>{const Ke=this;let Oe;return Object.freeze({globalState:Q,workspaceState:le,secrets:ve,subscriptions:[],get extensionUri(){return j.extensionLocation},get extensionPath(){return j.extensionLocation.fsPath},asAbsolutePath(He){return M.join(j.extensionLocation.fsPath,He)},get storagePath(){return Ke._storagePath.workspaceValue(j)?.fsPath},get globalStoragePath(){return Ke._storagePath.globalValue(j).fsPath},get logPath(){return M.join(Ke._initData.logsLocation.fsPath,j.identifier.value)},get logUri(){return k.URI.joinPath(Ke._initData.logsLocation,j.identifier.value)},get storageUri(){return Ke._storagePath.workspaceValue(j)},get globalStorageUri(){return Ke._storagePath.globalValue(j)},get extensionMode(){return ue},get extension(){return Oe===void 0&&(Oe=new z(Ke,j.identifier,j,Fe)),Oe},get extensionRuntime(){return(0,p.checkProposedApiEnabled)(j,"extensionRuntime"),Ke.extensionRuntime},get environmentVariableCollection(){return Ke._extHostTerminalService.getEnvironmentVariableCollection(j)}})})}static _callActivate(j,Q,le,ve,ue){return le=le||{activate:void 0,deactivate:void 0},this._callActivateOptional(j,Q,le,ve,ue).then(Fe=>new m.ActivatedExtension(!1,null,ue.build(),le,Fe,ve.subscriptions))}static _callActivateOptional(j,Q,le,ve,ue){if(typeof le.activate=="function")try{ue.activateCallStart(),j.trace(`ExtensionService#_callActivateOptional ${Q.value}`);const Fe=typeof global=="object"?global:self,Ke=le.activate.apply(Fe,[ve]);return ue.activateCallStop(),ue.activateResolveStart(),Promise.resolve(Ke).then(Oe=>(ue.activateResolveStop(),Oe))}catch(Fe){return Promise.reject(Fe)}else return Promise.resolve(le)}_activateOneStartupFinished(j,Q){this._activateById(j.identifier,{startup:!1,extensionId:j.identifier,activationEvent:Q}).then(void 0,le=>{this._logService.error(le)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(b.getMarks());for(const j of this._registry.getAllExtensionDescriptions())if(j.activationEvents)for(const Q of j.activationEvents)Q==="onStartupFinished"&&this._activateOneStartupFinished(j,Q)}_handleEagerExtensions(){const j=this._activateByEvent("*",!0).then(void 0,ue=>{this._logService.error(ue)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(ue=>this._handleWorkspaceContainsEagerExtensions(ue.added)));const Q=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],le=this._handleWorkspaceContainsEagerExtensions(Q),ve=Promise.all([j,le]).then(()=>{});return Promise.race([ve,(0,t.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),ve}_handleWorkspaceContainsEagerExtensions(j){return j.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(Q=>this._handleWorkspaceContainsEagerExtension(j,Q))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(j,Q){if(this.isActivated(Q.identifier))return;const le=!this._initData.remote.isRemote&&!!this._initData.remote.authority,ve={folders:j.map(Fe=>Fe.uri),forceUsingSearch:le,exists:Fe=>this._hostUtils.exists(Fe.fsPath),checkExists:(Fe,Ke,Oe)=>this._mainThreadWorkspaceProxy.$checkExists(Fe,Ke,Oe)},ue=await(0,T.checkActivateWorkspaceContainsExtension)(ve,Q);if(!!ue)return this._activateById(Q.identifier,{startup:!0,extensionId:Q.identifier,activationEvent:ue.activationEvent}).then(void 0,Fe=>this._logService.error(Fe))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(j){throw console.error(j),j}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:j,extensionTestsLocationURI:Q}=this._initData.environment;if(!j||!Q)throw new Error(u.localize(0,null));const le=await this._loadCommonJSModule(null,Q,new m.ExtensionActivationTimesBuilder(!1));if(!le||typeof le.run!="function")throw new Error(u.localize(1,null,Q.toString()));return new Promise((ve,ue)=>{const Fe=(He,Je)=>{He?ue(He):ve(typeof Je=="number"&&Je>0?1:0)},Ke=(0,P.originalFSPath)(Q),Oe=le.run(Ke,Fe);Oe&&Oe.then&&Oe.then(()=>{ve(0)}).catch(He=>{ue(He.toString())})})}async $extensionTestsExit(j){this._logService.info(`Extension host terminating: test runner requested exit with code ${j}`),this._hostUtils.pid&&this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${j}`),this._logService.flush(),this._hostUtils.exit(j)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(j,Q){return this._resolvers[j]=Q,(0,A.toDisposable)(()=>{delete this._resolvers[j]})}async _activateAndGetResolver(j){const Q=j.indexOf("+");if(Q===-1)throw new Error("Not an authority that can be resolved!");const le=j.substr(0,Q);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${le}`,!1),{authorityPrefix:le,resolver:this._resolvers[le]}}async $resolveAuthority(j,Q){const{authorityPrefix:le,resolver:ve}=await this._activateAndGetResolver(j);if(!ve)return{type:"error",error:{code:R.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${le}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(ve)),b.mark(`code/extHost/willResolveAuthority/${le}`);const ue=await ve.resolve(j,{resolveAttempt:Q});b.mark(`code/extHost/didResolveAuthorityOK/${le}`);const Fe={authority:j,host:ue.host,port:ue.port,connectionToken:ue.connectionToken},Ke={extensionHostEnv:ue.extensionHostEnv,isTrusted:ue.isTrusted,authenticationSession:ue.authenticationSession?{id:ue.authenticationSession.id,providerId:ue.authenticationSession.providerId}:void 0};return{type:"ok",value:{authority:Fe,options:Ke,tunnelInformation:{environmentTunnels:ue.environmentTunnels}}}}catch(ue){if(b.mark(`code/extHost/didResolveAuthorityError/${le}`),ue instanceof c.RemoteAuthorityResolverError)return{type:"error",error:{code:ue._code,message:ue._message,detail:ue._detail}};throw ue}}async $getCanonicalURI(j,Q){const{authorityPrefix:le,resolver:ve}=await this._activateAndGetResolver(j);if(!ve)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${le}`);const ue=k.URI.revive(Q);if(typeof ve.getCanonicalURI=="undefined")return ue;const Fe=await(0,t.asPromise)(()=>ve.getCanonicalURI(ue));return Fe||ue}$startExtensionHost(j){return this._registry.keepOnly(j),this._startExtensionHost()}$activateByEvent(j,Q){return Q===1?this._activateByEvent(j,!1):this._readyToRunExtensions.wait().then(le=>this._activateByEvent(j,!1))}async $activate(j,Q){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(j)?(await this._activateById(j,Q),!0):!1}async $deltaExtensions(j,Q){j.forEach(ve=>ve.extensionLocation=k.URI.revive(ve.extensionLocation));const le=await this.getExtensionPathIndex();return await Promise.all(Q.map(async ve=>{const ue=this._registry.getExtensionDescription(ve);ue&&le.delete(await this._realPathExtensionUri(ue.extensionLocation))})),await Promise.all(j.map(async ve=>{const ue=await this._realPathExtensionUri(ve.extensionLocation);le.set(ue,ve)})),this._registry.deltaExtensions(j,Q),Promise.resolve(void 0)}async $test_latency(j){return j}async $test_up(j){return j.byteLength}async $test_down(j){let Q=d.VSBuffer.alloc(j),le=Math.random()%256;for(let ve=0;ve<j;ve++)Q.writeUInt8(le,ve);return Q}async $updateRemoteConnectionData(j){this._remoteConnectionData=j,this._onDidChangeRemoteConnectionData.fire()}};V=Ue([Be(0,n.IInstantiationService),Be(1,e.IHostUtils),Be(2,f.IExtHostRpcService),Be(3,h.IExtHostWorkspace),Be(4,r.IExtHostConfiguration),Be(5,F.ILogService),Be(6,i.IExtHostInitDataService),Be(7,g.IExtensionStoragePaths),Be(8,v.IExtHostTunnelService),Be(9,l.IExtHostTerminalService)],V),e.AbstractExtHostExtensionService=V;function $(ee,j){return{id:ee.identifier.value,name:ee.name,extensionVersion:ee.version,publisherDisplayName:ee.publisher,activationEvents:ee.activationEvents?ee.activationEvents.join(","):null,isBuiltin:ee.isBuiltin,reason:j.activationEvent,reasonId:j.extensionId.value}}e.IExtHostExtensionService=(0,n.createDecorator)("IExtHostExtensionService");class z{constructor(j,Q,le,ve){D.set(this,void 0),x.set(this,void 0),N.set(this,void 0),Xe(this,D,j,"f"),Xe(this,x,Q,"f"),Xe(this,N,le.identifier,"f"),this.id=le.identifier.value,this.extensionUri=le.extensionLocation,this.extensionPath=M.normalize((0,P.originalFSPath)(le.extensionLocation)),this.packageJSON=le,this.extensionKind=ve}get isActive(){return Ae(this,D,"f").isActivated(Ae(this,N,"f"))}get exports(){if(this.packageJSON.api!=="none")return Ae(this,D,"f").getExtensionExports(Ae(this,N,"f"))}activate(){return Ae(this,D,"f").activateByIdWithErrors(Ae(this,N,"f"),{startup:!1,extensionId:Ae(this,x,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=z,D=new WeakMap,x=new WeakMap,N=new WeakMap}),define(be[100],Ee([0,1,17,2,3,13,5,7,164,32,34,51,171,33,165,14,4,10,91,72]),function(re,e,u,M,b,P,t,A,C,k,F,y,r,m,a,h,p,S,w,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,p.createDecorator)("IExtHostDebugService");let d=class{constructor(s,v,l,E,T,I){this._workspaceService=v,this._extensionService=l,this._editorsService=E,this._configurationService=T,this._editorTabs=I,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new b.Emitter,this._onDidTerminateDebugSession=new b.Emitter,this._onDidChangeActiveDebugSession=new b.Emitter,this._onDidReceiveDebugSessionCustomEvent=new b.Emitter,this._debugServiceProxy=s.getProxy(t.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new b.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new c(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(B=>{B.onDidChange(O=>{this.registerAllDebugTypes(B)}),this.registerAllDebugTypes(B)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(s,v){const l=s;if(typeof l.sourceReference=="number"&&l.sourceReference>0){let E=`debug:${encodeURIComponent(l.path||"")}`,T="?";return v&&(E+=`${T}session=${encodeURIComponent(v.id)}`,T="&"),E+=`${T}ref=${l.sourceReference}`,M.URI.parse(E)}else{if(l.path)return M.URI.file(l.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(s){const v=[];for(const l of s.getAllExtensionDescriptions())if(l.contributes){const E=l.contributes.debuggers;if(E&&E.length>0)for(const T of E)(0,a.isDebuggerMainContribution)(T)&&v.push(T.type)}this._debugServiceProxy.$registerDebugTypes(v)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const s=[];return this._breakpoints.forEach(v=>s.push(v)),s}addBreakpoints(s){this.startBreakpoints();const v=s.filter(T=>{const I=T.id;return this._breakpoints.has(I)?!1:(this._breakpoints.set(I,T),!0)});this.fireBreakpointChanges(v,[],[]);const l=[],E=new Map;for(const T of v)if(T instanceof A.SourceBreakpoint){let I=E.get(T.location.uri.toString());I||(I={type:"sourceMulti",uri:T.location.uri,lines:[]},E.set(T.location.uri.toString(),I),l.push(I)),I.lines.push({id:T.id,enabled:T.enabled,condition:T.condition,hitCondition:T.hitCondition,logMessage:T.logMessage,line:T.location.range.start.line,character:T.location.range.start.character})}else T instanceof A.FunctionBreakpoint&&l.push({type:"function",id:T.id,enabled:T.enabled,hitCondition:T.hitCondition,logMessage:T.logMessage,condition:T.condition,functionName:T.functionName});return this._debugServiceProxy.$registerBreakpoints(l)}removeBreakpoints(s){this.startBreakpoints();const v=s.filter(I=>this._breakpoints.delete(I.id));this.fireBreakpointChanges([],v,[]);const l=v.filter(I=>I instanceof A.SourceBreakpoint).map(I=>I.id),E=v.filter(I=>I instanceof A.FunctionBreakpoint).map(I=>I.id),T=v.filter(I=>I instanceof A.DataBreakpoint).map(I=>I.id);return this._debugServiceProxy.$unregisterBreakpoints(l,E,T)}startDebugging(s,v,l){return this._debugServiceProxy.$startDebugging(s?s.uri:void 0,v,{parentSessionID:l.parentSession?l.parentSession.id:void 0,lifecycleManagedByParent:l.lifecycleManagedByParent,repl:l.consoleMode===A.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:l.noDebug,compact:l.compact,debugUI:l.debugUI,suppressSaveBeforeStart:l.suppressSaveBeforeStart})}stopDebugging(s){return this._debugServiceProxy.$stopDebugging(s?s.id:void 0)}registerDebugConfigurationProvider(s,v,l){if(!v)return new A.Disposable(()=>{});const E=this._configProviderHandleCounter++;return this._configProviders.push({type:s,handle:E,provider:v}),this._debugServiceProxy.$registerDebugConfigurationProvider(s,l,!!v.provideDebugConfigurations,!!v.resolveDebugConfiguration,!!v.resolveDebugConfigurationWithSubstitutedVariables,E),new A.Disposable(()=>{this._configProviders=this._configProviders.filter(T=>T.provider!==v),this._debugServiceProxy.$unregisterDebugConfigurationProvider(E)})}registerDebugAdapterDescriptorFactory(s,v,l){if(!l)return new A.Disposable(()=>{});if(!this.definesDebugType(s,v))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${v}' debugger.`);if(this.getAdapterDescriptorFactoryByType(v))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const E=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:v,handle:E,factory:l}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(v,E),new A.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(T=>T.factory!==l),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(E)})}registerDebugAdapterTrackerFactory(s,v){if(!v)return new A.Disposable(()=>{});const l=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:s,handle:l,factory:v}),new A.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(E=>E.factory!==v)})}async $runInTerminal(s,v){return Promise.resolve(void 0)}async $substituteVariables(s,v){if(!this._variableResolver){const[T,I]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(T||[],this._editorsService,I)}let l;const E=await this.getFolder(s);return E&&(l={uri:E.uri,name:E.name,index:E.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(l,v)}createDebugAdapter(s,v){if(s.type==="implementation")return new i(s.implementation)}createSignService(){}async $startDASession(s,v){const l=this,E=await this.getSession(v);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(E.type),E).then(T=>{if(!T)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${E.type}' (extension might have failed to activate)`);const I=this.convertToDto(T),B=this.createDebugAdapter(I,E);if(!B)throw new Error(`Couldn't create a debug adapter for type '${E.type}'.`);const O=B;return this._debugAdapters.set(s,O),this.getDebugAdapterTrackers(E).then(D=>(D&&this._debugAdaptersTrackers.set(s,D),O.onMessage(async x=>{if(x.type==="request"&&x.command==="handshake"){const N=x,V={type:"response",seq:0,command:N.command,request_seq:N.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const $=await this._signService.sign(N.arguments.value);V.body={signature:$},O.sendResponse(V)}else throw new Error("no signer")}catch($){V.success=!1,V.message=$.message,O.sendResponse(V)}}else D&&D.onDidSendMessage&&D.onDidSendMessage(x),x=(0,a.convertToVSCPaths)(x,!0),l._debugServiceProxy.$acceptDAMessage(s,x)}),O.onError(x=>{D&&D.onError&&D.onError(x),this._debugServiceProxy.$acceptDAError(s,x.name,x.message,x.stack)}),O.onExit(x=>{D&&D.onExit&&D.onExit((0,S.withNullAsUndefined)(x),void 0),this._debugServiceProxy.$acceptDAExit(s,(0,S.withNullAsUndefined)(x),void 0)}),D&&D.onWillStartSession&&D.onWillStartSession(),O.startSession()))})}$sendDAMessage(s,v){v=(0,a.convertToDAPaths)(v,!1);const l=this._debugAdaptersTrackers.get(s);l&&l.onWillReceiveMessage&&l.onWillReceiveMessage(v);const E=this._debugAdapters.get(s);E&&E.sendMessage(v)}$stopDASession(s){const v=this._debugAdaptersTrackers.get(s);this._debugAdaptersTrackers.delete(s),v&&v.onWillStopSession&&v.onWillStopSession();const l=this._debugAdapters.get(s);return this._debugAdapters.delete(s),l?l.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(s){const v=[],l=[],E=[];if(s.added)for(const T of s.added){const I=T.id;if(I&&!this._breakpoints.has(I)){let B;if(T.type==="function")B=new A.FunctionBreakpoint(T.functionName,T.enabled,T.condition,T.hitCondition,T.logMessage);else if(T.type==="data")B=new A.DataBreakpoint(T.label,T.dataId,T.canPersist,T.enabled,T.hitCondition,T.condition,T.logMessage);else{const O=M.URI.revive(T.uri);B=new A.SourceBreakpoint(new A.Location(O,new A.Position(T.line,T.character)),T.enabled,T.condition,T.hitCondition,T.logMessage)}B._id=I,this._breakpoints.set(I,B),v.push(B)}}if(s.removed)for(const T of s.removed){const I=this._breakpoints.get(T);I&&(this._breakpoints.delete(T),l.push(I))}if(s.changed){for(const T of s.changed)if(T.id){const I=this._breakpoints.get(T.id);if(I){if(I instanceof A.FunctionBreakpoint&&T.type==="function"){const B=I;B.enabled=T.enabled,B.condition=T.condition,B.hitCondition=T.hitCondition,B.logMessage=T.logMessage,B.functionName=T.functionName}else if(I instanceof A.SourceBreakpoint&&T.type==="source"){const B=I;B.enabled=T.enabled,B.condition=T.condition,B.hitCondition=T.hitCondition,B.logMessage=T.logMessage,B.location=new A.Location(M.URI.revive(T.uri),new A.Position(T.line,T.character))}E.push(I)}}}this.fireBreakpointChanges(v,l,E)}$provideDebugConfigurations(s,v,l){return(0,P.asPromise)(async()=>{const E=this.getConfigProviderByHandle(s);if(!E)throw new Error("no DebugConfigurationProvider found");if(!E.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const T=await this.getFolder(v);return E.provideDebugConfigurations(T,l)}).then(E=>{if(!E)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return E})}$resolveDebugConfiguration(s,v,l,E){return(0,P.asPromise)(async()=>{const T=this.getConfigProviderByHandle(s);if(!T)throw new Error("no DebugConfigurationProvider found");if(!T.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const I=await this.getFolder(v);return T.resolveDebugConfiguration(I,l,E)})}$resolveDebugConfigurationWithSubstitutedVariables(s,v,l,E){return(0,P.asPromise)(async()=>{const T=this.getConfigProviderByHandle(s);if(!T)throw new Error("no DebugConfigurationProvider found");if(!T.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const I=await this.getFolder(v);return T.resolveDebugConfigurationWithSubstitutedVariables(I,l,E)})}async $provideDebugAdapter(s,v){const l=this.getAdapterDescriptorFactoryByHandle(s);if(!l)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const E=await this.getSession(v);return this.getAdapterDescriptor(l,E).then(T=>{if(!T)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${E.type}'`);return this.convertToDto(T)})}async $acceptDebugSessionStarted(s){const v=await this.getSession(s);this._onDidStartDebugSession.fire(v)}async $acceptDebugSessionTerminated(s){const v=await this.getSession(s);v&&(this._onDidTerminateDebugSession.fire(v),this._debugSessions.delete(v.id))}async $acceptDebugSessionActiveChanged(s){this._activeDebugSession=s?await this.getSession(s):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(s,v){const l=await this.getSession(s);l&&l._acceptNameChanged(v)}async $acceptDebugSessionCustomEvent(s,v){const E={session:await this.getSession(s),event:v.event,body:v.body};this._onDidReceiveDebugSessionCustomEvent.fire(E)}convertToDto(s){if(s instanceof A.DebugAdapterExecutable)return{type:"executable",command:s.command,args:s.args,options:s.options};if(s instanceof A.DebugAdapterServer)return{type:"server",port:s.port,host:s.host};if(s instanceof A.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:s.path};if(s instanceof A.DebugAdapterInlineImplementation)return{type:"implementation",implementation:s.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(s){const v=this._adapterFactories.filter(l=>l.type===s);if(v.length>0)return v[0].factory}getAdapterDescriptorFactoryByHandle(s){const v=this._adapterFactories.filter(l=>l.handle===s);if(v.length>0)return v[0].factory}getConfigProviderByHandle(s){const v=this._configProviders.filter(l=>l.handle===s);if(v.length>0)return v[0].provider}definesDebugType(s,v){if(s.contributes){const l=s.contributes.debuggers;if(l&&l.length>0){for(const E of l)if(E.label&&E.type&&E.type===v)return!0}}return!1}getDebugAdapterTrackers(s){const l=s.configuration.type,E=this._trackerFactories.filter(T=>T.type===l||T.type==="*").map(T=>(0,P.asPromise)(()=>T.factory.createDebugAdapterTracker(s)).then(I=>I,I=>null));return Promise.race([Promise.all(E).then(T=>{const I=T.filter(B=>!!B);if(I.length>0)return new n(I)}),new Promise((T,I)=>{const B=setTimeout(()=>{clearTimeout(B),I(new Error("timeout"))},1e3)})]).catch(T=>{})}async getAdapterDescriptor(s,v){const l=v.configuration.debugServer;if(typeof l=="number")return Promise.resolve(new A.DebugAdapterServer(l));if(s){const T=await this._extensionService.getExtensionRegistry();return(0,P.asPromise)(()=>s.createDebugAdapterDescriptor(v,this.daExecutableFromPackage(v,T))).then(I=>{if(I)return I})}const E=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(v,E))}daExecutableFromPackage(s,v){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(s,v,l){(s.length>0||v.length>0||l.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:s,removed:v,changed:l}))}async getSession(s){if(s)if(typeof s=="string"){const v=this._debugSessions.get(s);if(v)return v}else{let v=this._debugSessions.get(s.id);if(!v){const l=await this.getFolder(s.folderUri),E=s.parent?this._debugSessions.get(s.parent):void 0;v=new _(this._debugServiceProxy,s.id,s.type,s.name,l,s.configuration,E),this._debugSessions.set(v.id,v),this._debugServiceProxy.$sessionCached(v.id)}return v}throw new Error("cannot find session")}getFolder(s){if(s){const v=M.URI.revive(s);return this._workspaceService.resolveWorkspaceFolder(v)}return Promise.resolve(void 0)}};d=Ue([Be(0,h.IExtHostRpcService),Be(1,k.IExtHostWorkspace),Be(2,F.IExtHostExtensionService),Be(3,y.IExtHostDocumentsAndEditors),Be(4,m.IExtHostConfiguration),Be(5,o.IExtHostEditorTabs)],d),e.ExtHostDebugServiceBase=d;class _{constructor(s,v,l,E,T,I,B){this._debugServiceProxy=s,this._id=v,this._type=l,this._name=E,this._workspaceFolder=T,this._configuration=I,this._parentSession=B}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(s){this._name=s,this._debugServiceProxy.$setDebugSessionName(this._id,s)}get parentSession(){return this._parentSession}_acceptNameChanged(s){this._name=s}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(s,v){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,s,v)}getDebugProtocolBreakpoint(s){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,s.id)}}e.ExtHostDebugSession=_;class c{constructor(s){this.value=Object.freeze({append(v){s.$appendDebugConsole(v)},appendLine(v){this.append(v+`
`)}})}}e.ExtHostDebugConsole=c;class R extends r.AbstractVariableResolverService{constructor(s,v,l,E,T){function I(){if(v){const B=v.activeEditor();if(B)return B.document.uri;const O=E.tabs.filter(D=>D.isActive);if(O.length>0){const D=O[0].resource;return D&&(D.primary||D.secondary)?D.primary??D.secondary:O[0].resource}}}super({getFolderUri:B=>{const O=s.filter(D=>D.name===B);if(O&&O.length>0)return O[0].uri},getWorkspaceFolderCount:()=>s.length,getConfigurationValue:(B,O)=>l.getConfiguration(void 0,B).get(O),getAppRoot:()=>w.cwd(),getExecPath:()=>w.env.VSCODE_EXEC_PATH,getFilePath:()=>{const B=I();if(B)return u.normalize(B.fsPath)},getWorkspaceFolderPathForFile:()=>{if(T){const B=I();if(B){const O=T.getWorkspaceFolder(B);if(O)return u.normalize(O.uri.fsPath)}}},getSelectedText:()=>{if(v){const B=v.activeEditor();if(B&&!B.selection.isEmpty)return B.document.getText(B.selection)}},getLineNumber:()=>{if(v){const B=v.activeEditor();if(B)return String(B.selection.end.line+1)}}},void 0,Promise.resolve(w.env))}}e.ExtHostVariableResolverService=R;class n{constructor(s){this.trackers=s}onWillStartSession(){this.trackers.forEach(s=>s.onWillStartSession?s.onWillStartSession():void 0)}onWillReceiveMessage(s){this.trackers.forEach(v=>v.onWillReceiveMessage?v.onWillReceiveMessage(s):void 0)}onDidSendMessage(s){this.trackers.forEach(v=>v.onDidSendMessage?v.onDidSendMessage(s):void 0)}onWillStopSession(){this.trackers.forEach(s=>s.onWillStopSession?s.onWillStopSession():void 0)}onError(s){this.trackers.forEach(v=>v.onError?v.onError(s):void 0)}onExit(s,v){this.trackers.forEach(l=>l.onExit?l.onExit(s,v):void 0)}}class i extends C.AbstractDebugAdapter{constructor(s){super();this.implementation=s,s.onDidSendMessage(v=>{this.acceptMessage(v)})}startSession(){return Promise.resolve(void 0)}sendMessage(s){this.implementation.handleMessage(s)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let g=class extends d{constructor(s,v,l,E,T,I){super(s,v,l,E,T,I)}createVariableResolver(s,v,l){return new R(s,v,l,this._editorTabs)}};g=Ue([Be(0,h.IExtHostRpcService),Be(1,k.IExtHostWorkspace),Be(2,F.IExtHostExtensionService),Be(3,y.IExtHostDocumentsAndEditors),Be(4,m.IExtHostConfiguration),Be(5,o.IExtHostEditorTabs)],g),e.WorkerExtHostDebugService=g}),define(be[223],Ee([0,1,75,2,5,33,27,26,14,28,4,34,91,12]),function(re,e,u,M,b,P,t,A,C,k,F,y,r,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let a=class{constructor(o,d,_,c,R,n,i){this._apiFactory=o,this._extensionRegistry=d,this._instaService=_,this._extHostConfiguration=c,this._extHostExtensionService=R,this._initData=n,this._logService=i,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),u.mark("code/extHost/willWaitForConfig");const o=await this._extHostConfiguration.getConfigProvider();u.mark("code/extHost/didWaitForConfig");const d=await this._extHostExtensionService.getExtensionPathIndex();this.register(new h(this._apiFactory,d,this._extensionRegistry,o,this._logService)),this.register(this._instaService.createInstance(p,d)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(S,d,this._initData.environment.appUriScheme))}register(o){if(Array.isArray(o.nodeModuleName))for(let d of o.nodeModuleName)this._factories.set(d,o);else this._factories.set(o.nodeModuleName,o);typeof o.alternativeModuleName=="function"&&this._alternatives.push(d=>o.alternativeModuleName(d))}};a=Ue([Be(2,F.IInstantiationService),Be(3,P.IExtHostConfiguration),Be(4,y.IExtHostExtensionService),Be(5,k.IExtHostInitDataService),Be(6,m.ILogService)],a),e.RequireInterceptor=a;class h{constructor(o,d,_,c,R){this._apiFactory=o,this._extensionPaths=d,this._extensionRegistry=_,this._configProvider=c,this._logService=R,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(o,d){const _=this._extensionPaths.findSubstr(d);if(_){let c=this._extApiImpl.get(A.ExtensionIdentifier.toKey(_.identifier));return c||(c=this._apiFactory(_,this._extensionRegistry,this._configProvider),this._extApiImpl.set(A.ExtensionIdentifier.toKey(_.identifier),c)),c}if(!this._defaultApiImpl){let c="";this._extensionPaths.forEach((R,n)=>c+=`	${n} -> ${R.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${d}. These are the extension path mappings: 
${c}`),this._defaultApiImpl=this._apiFactory(t.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let p=class{constructor(o,d,_){this._extensionPaths=o,this.nodeModuleName="keytar",this._mainThreadTelemetry=d.getProxy(b.MainContext.MainThreadTelemetry);const{environment:c}=_,R=d.getProxy(b.MainContext.MainThreadKeytar);if(c.appRoot){let n=c.appRoot.fsPath;r.platform==="win32"&&(n=n.replace(/\\/g,"/")),n[n.length-1]==="/"&&(n=n.substr(0,n.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${n}/node_modules.asar/keytar`),this.alternativeNames.add(`${n}/node_modules/keytar`)}this._impl={getPassword:(n,i)=>R.$getPassword(n,i),setPassword:(n,i,g)=>R.$setPassword(n,i,g),deletePassword:(n,i)=>R.$deletePassword(n,i),findPassword:n=>R.$findPassword(n),findCredentials(n){return R.$findCredentials(n)}}}load(o,d){const _=this._extensionPaths.findSubstr(d);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:_?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(o){const d=o.length;if(d<=7||!this.alternativeNames)return;const _=d-7;if((o.charAt(_)==="/"||o.charAt(_)==="\\")&&o.endsWith("keytar")&&(o=o.replace(/\\/g,"/"),this.alternativeNames.has(o)))return"keytar"}};p=Ue([Be(1,C.IExtHostRpcService),Be(2,k.IExtHostInitDataService)],p);let S=class{constructor(o,d,_){this._extensionPaths=o,this._appUriScheme=d,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=_.getProxy(b.MainContext.MainThreadTelemetry);const c=_.getProxy(b.MainContext.MainThreadWindow);this._impl=(R,n)=>{const i=M.URI.parse(R);return n?this.callOriginal(R,n):i.scheme==="http"||i.scheme==="https"?c.$openUri(i,R,{allowTunneling:!0}):i.scheme==="mailto"||i.scheme===this._appUriScheme?c.$openUri(i,R,{}):this.callOriginal(R,n)}}load(o,d,_){const c=this._extensionPaths.findSubstr(d);return c&&(this._extensionId=c.identifier.value,this.sendShimmingTelemetry()),this._original=_(o),this._impl}callOriginal(o,d){return this.sendNoForwardTelemetry(),this._original(o,d)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};S=Ue([Be(2,C.IExtHostRpcService)],S)}),define(be[224],Ee([0,1,13,16,75,6,2,5,217,12,59,62,28,144,14,67,34,41]),function(re,e,u,M,b,P,t,A,C,k,F,y,r,m,a,h,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class w{constructor(d,_,c,R){this._disposables=new P.DisposableStore,this._isTerminating=!1,this._hostUtils=c,this._rpcProtocol=new C.RPCProtocol(d,null,R),_=w._transform(_,this._rpcProtocol);const n=new y.ServiceCollection(...(0,F.getSingletonServiceDescriptors)());n.set(r.IExtHostInitDataService,{_serviceBrand:void 0,..._}),n.set(a.IExtHostRpcService,new a.ExtHostRpcService(this._rpcProtocol)),n.set(h.IURITransformerService,new h.URITransformerService(R)),n.set(p.IHostUtils,c);const i=new m.InstantiationService(n,!0),g=i.invokeFunction(l=>l.get(S.IExtHostTerminalService));this._disposables.add(g),this._logService=i.invokeFunction(l=>l.get(k.ILogService)),b.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",_),this._extensionService=i.invokeFunction(l=>l.get(p.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const f=new WeakMap;this._extensionService.getExtensionPathIndex().then(l=>{Error.prepareStackTrace=(E,T)=>{let I="",B,O;for(const D of T)I+=`
	at ${D.toString()}`,O=D.getFileName(),!B&&O&&(B=l.findSubstr(t.URI.file(O)));return f.set(E,B),`${E.name||"Error"}: ${E.message||""}${I}`}});const s=this._rpcProtocol.getProxy(A.MainContext.MainThreadExtensionService),v=this._rpcProtocol.getProxy(A.MainContext.MainThreadErrors);M.setUnexpectedErrorHandler(l=>{const E=M.transformErrorForSerialization(l),T=f.get(l);T?s.$onExtensionRuntimeError(T.identifier,E):v.$onUnexpectedError(E)})}terminate(d){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${d}`),this._logService.flush(),this._disposables.dispose(),M.setUnexpectedErrorHandler(c=>{this._logService.error(c)}),this._rpcProtocol.dispose();const _=this._extensionService.deactivateAll();Promise.race([(0,u.timeout)(5e3),_]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code 0`):this._logService.info("Extension host exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})}static _transform(d,_){d.extensions.forEach(R=>R.extensionLocation=t.URI.revive(_.transformIncomingURIs(R.extensionLocation))),d.environment.appRoot=t.URI.revive(_.transformIncomingURIs(d.environment.appRoot));const c=d.environment.extensionDevelopmentLocationURI;return c&&(d.environment.extensionDevelopmentLocationURI=c.map(R=>t.URI.revive(_.transformIncomingURIs(R)))),d.environment.extensionTestsLocationURI=t.URI.revive(_.transformIncomingURIs(d.environment.extensionTestsLocationURI)),d.environment.globalStorageHome=t.URI.revive(_.transformIncomingURIs(d.environment.globalStorageHome)),d.environment.workspaceStorageHome=t.URI.revive(_.transformIncomingURIs(d.environment.workspaceStorageHome)),d.logsLocation=t.URI.revive(_.transformIncomingURIs(d.logsLocation)),d.logFile=t.URI.revive(_.transformIncomingURIs(d.logFile)),d.workspace=_.transformIncomingURIs(d.workspace),d}}e.ExtensionHostMain=w}),define(be[225],Ee([0,1,17,21,46,29,24,198,42]),function(re,e,u,M,b,P,t,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class k{constructor(r,m,a){this.config=r,this.provider=m,this.sessionToken=a,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=r.filePattern,this.includePattern=r.includePattern&&P.parse(r.includePattern),this.maxResults=r.maxResults||void 0,this.exists=r.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=r.excludePattern&&P.parse(r.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(r=>r.cancel()),this.activeCancellationTokens=new Set}search(r){const m=this.config.folderQueries||[];return new Promise((a,h)=>{const p=S=>{this.resultCount++,r(S)};if(this.isCanceled)return a({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(S=>{const w=S.toString(),o=u.basename(w);this.globalExcludePattern&&this.globalExcludePattern(w,o)||this.matchFile(p,{base:S,basename:o})}),Promise.all(m.map(S=>this.searchInFolder(S,p))).then(S=>{a({limitHit:this.isLimitHit,stats:S[0]||void 0})},S=>{h(new Error((0,b.toErrorMessage)(S)))})})}async searchInFolder(r,m){const a=new M.CancellationTokenSource,h=this.getSearchOptionsForFolder(r),p=this.initDirectoryTree(),S=new C.QueryGlobTester(this.config,r),w=!S.hasSiblingExcludeClauses();let o;try{this.activeCancellationTokens.add(a),o=A.StopWatch.create();const d=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},h,a.token),_=o.elapsed(),c=A.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(d&&d.forEach(R=>{const n=u.posix.relative(r.folder.path,R.path);if(w){const i=u.basename(R.path);this.matchFile(m,{base:r.folder,relativePath:n,basename:i});return}this.addDirectoryEntries(p,r.folder,n,m)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(p,S,m),{providerTime:_,postProcessTime:c.elapsed()})}finally{a.dispose(),this.activeCancellationTokens.delete(a)}}getSearchOptionsForFolder(r){const m=(0,C.resolvePatternsForProvider)(this.config.includePattern,r.includePattern),a=(0,C.resolvePatternsForProvider)(this.config.excludePattern,r.excludePattern);return{folder:r.folder,excludes:a,includes:m,useIgnoreFiles:!r.disregardIgnoreFiles,useGlobalIgnoreFiles:!r.disregardGlobalIgnoreFiles,followSymlinks:!r.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const r={rootEntries:[],pathToEntries:Object.create(null)};return r.pathToEntries["."]=r.rootEntries,r}addDirectoryEntries({pathToEntries:r},m,a,h){if(a===this.filePattern){const S=u.basename(this.filePattern);this.matchFile(h,{base:m,relativePath:this.filePattern,basename:S})}function p(S){const w=u.basename(S),o=u.dirname(S);let d=r[o];d||(d=r[o]=[],p(o)),d.push({base:m,relativePath:S,basename:w})}p(a)}matchDirectoryTree({rootEntries:r,pathToEntries:m},a,h){const p=this,S=this.filePattern;function w(o){const d=P.hasSiblingFn(()=>o.map(_=>_.basename));for(let _=0,c=o.length;_<c;_++){const R=o[_],{relativePath:n,basename:i}=R;if(a.matchesExcludesSync(n,i,S!==i?d:void 0))continue;const g=m[n];if(g)w(g);else{if(n===S)continue;p.matchFile(h,R)}if(p.isLimitHit)break}}w(r)}matchFile(r,m){(!this.includePattern||m.relativePath&&this.includePattern(m.relativePath,m.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||r(m))}}class F{constructor(){this.sessions=new Map}fileSearch(r,m,a,h){const p=this.getSessionTokenSource(r.cacheKey),S=new k(r,m,p&&p.token);let w=0;const o=d=>{w+=d.length,a(d.map(_=>this.rawMatchToSearchItem(_)))};return this.doSearch(S,F.BATCH_SIZE,o,h).then(d=>({limitHit:d.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:w,detailStats:d.stats}}))}clearCache(r){const m=this.getSessionTokenSource(r);m&&m.cancel()}getSessionTokenSource(r){if(!!r)return this.sessions.has(r)||this.sessions.set(r,new M.CancellationTokenSource),this.sessions.get(r)}rawMatchToSearchItem(r){return r.relativePath?{resource:t.joinPath(r.base,r.relativePath)}:{resource:r.base}}doSearch(r,m,a,h){h.onCancellationRequested(()=>{r.cancel()});const p=w=>{w&&(S.push(w),m>0&&S.length>=m&&(a(S),S=[]))};let S=[];return r.search(p).then(w=>(S.length&&a(S),w),w=>(S.length&&a(S),Promise.reject(w)))}}e.FileSearchManager=F,F.BATCH_SIZE=512}),define(be[226],Ee([0,1,15,21,46,29,11,17,24,10,2,42]),function(re,e,u,M,b,P,t,A,C,k,F,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class r{constructor(o,d,_,c){this.query=o,this.provider=d,this.fileUtils=_,this.processType=c,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(o,d){const _=this.query.folderQueries||[],c=new M.CancellationTokenSource;return d.onCancellationRequested(()=>c.cancel()),new Promise((R,n)=>{this.collector=new a(o);let i=!1;const g=(f,s)=>{if(!i&&!this.isLimitHit){const v=this.resultSize(f);p(f)&&typeof this.query.maxResults=="number"&&this.resultCount+v>this.query.maxResults&&(this.isLimitHit=!0,i=!0,c.cancel(),f=this.trimResultToSize(f,this.query.maxResults-this.resultCount));const l=this.resultSize(f);this.resultCount+=l,(l>0||!p(f))&&this.collector.add(f,s)}};Promise.all(_.map((f,s)=>this.searchInFolder(f,v=>g(v,s),c.token))).then(f=>{c.dispose(),this.collector.flush();const s=f.some(v=>!!v&&!!v.limitHit);R({limitHit:this.isLimitHit||s,messages:(0,u.flatten)(f.map(v=>v?.message?(0,k.isArray)(v.message)?v.message:[v.message]:[])),stats:{type:this.processType}})},f=>{c.dispose();const s=(0,b.toErrorMessage)(f);n(new Error(s))})})}resultSize(o){return p(o)?Array.isArray(o.ranges)?o.ranges.length:1:0}trimResultToSize(o,d){const _=Array.isArray(o.ranges)?o.ranges:[o.ranges],c=Array.isArray(o.preview.matches)?o.preview.matches:[o.preview.matches];return{ranges:_.slice(0,d),preview:{matches:c.slice(0,d),text:o.preview.text},uri:o.uri}}async searchInFolder(o,d,_){const c=new y.QueryGlobTester(this.query,o),R=[],n={report:f=>{if(!this.validateProviderResult(f))return;const s=o.folder.scheme===t.Schemas.file?P.hasSiblingPromiseFn(()=>this.fileUtils.readdir(C.dirname(f.uri))):void 0,v=C.relativePath(o.folder,f.uri);if(v){const l=c.includedInQuery(v,A.basename(v),s);(0,k.isPromise)(l)?R.push(l.then(E=>{E&&d(f)})):l&&d(f)}}},i=this.getSearchOptionsForFolder(o),g=await this.provider.provideTextSearchResults(m(this.query.contentPattern),i,n,_);return R.length&&await Promise.all(R),g}validateProviderResult(o){if(p(o)){if(Array.isArray(o.ranges)){if(!Array.isArray(o.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(o.preview.matches.length!==o.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(o.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(o){const d=(0,y.resolvePatternsForProvider)(this.query.includePattern,o.includePattern),_=(0,y.resolvePatternsForProvider)(this.query.excludePattern,o.excludePattern),c={folder:F.URI.from(o.folder),excludes:_,includes:d,useIgnoreFiles:!o.disregardIgnoreFiles,useGlobalIgnoreFiles:!o.disregardGlobalIgnoreFiles,followSymlinks:!o.ignoreSymlinks,encoding:o.fileEncoding&&this.fileUtils.toCanonicalName(o.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return c.usePCRE2=this.query.usePCRE2,c}}e.TextSearchManager=r;function m(w){return{isCaseSensitive:w.isCaseSensitive||!1,isRegExp:w.isRegExp||!1,isWordMatch:w.isWordMatch||!1,isMultiline:w.isMultiline||!1,pattern:w.pattern}}class a{constructor(o){this._onResult=o,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new S(512,d=>this.sendItems(d))}add(o,d){this._currentFileMatch&&(this._currentFolderIdx!==d||!C.isEqual(this._currentUri,o.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=d,this._currentFileMatch={resource:o.uri,results:[]}),this._currentFileMatch.results.push(h(o))}pushToCollector(){const o=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,o)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(o){this._onResult(o)}}e.TextSearchResultsCollector=a;function h(w){return p(w)?{preview:{matches:(0,u.mapArrayOrNot)(w.preview.matches,o=>({startLineNumber:o.start.line,startColumn:o.start.character,endLineNumber:o.end.line,endColumn:o.end.character})),text:w.preview.text},ranges:(0,u.mapArrayOrNot)(w.ranges,o=>({startLineNumber:o.start.line,startColumn:o.start.character,endLineNumber:o.end.line,endColumn:o.end.character}))}:{text:w.text,lineNumber:w.lineNumber}}function p(w){return!!w.preview}e.extensionResultIsMatch=p;class S{constructor(o,d){this.maxBatchSize=o,this.cb=d,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(o,d){!o||this.addItemToBatch(o,d)}addItems(o,d){!o||this.addItemsToBatch(o,d)}addItemToBatch(o,d){this.batch.push(o),this.batchSize+=d,this.onUpdate()}addItemsToBatch(o,d){this.batch=this.batch.concat(o),this.batchSize+=d,this.onUpdate()}onUpdate(){this.totalNumberCompleted<S.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},S.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=S,S.TIMEOUT=4e3,S.START_BATCH_AFTER_COUNT=50}),define(be[101],Ee([0,1,6,5,4,225,14,67,12,2,226]),function(re,e,u,M,b,P,t,A,C,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,b.createDecorator)("IExtHostSearch");let y=class{constructor(h,p,S){this.extHostRpc=h,this._uriTransformer=p,this._logService=S,this._proxy=this.extHostRpc.getProxy(M.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new P.FileSearchManager}_transformScheme(h){return this._uriTransformer.transformOutgoingScheme(h)}registerTextSearchProvider(h,p){if(this._textSearchUsedSchemes.has(h))throw new Error(`a text search provider for the scheme '${h}' is already registered`);this._textSearchUsedSchemes.add(h);const S=this._handlePool++;return this._textSearchProvider.set(S,p),this._proxy.$registerTextSearchProvider(S,this._transformScheme(h)),(0,u.toDisposable)(()=>{this._textSearchUsedSchemes.delete(h),this._textSearchProvider.delete(S),this._proxy.$unregisterProvider(S)})}registerFileSearchProvider(h,p){if(this._fileSearchUsedSchemes.has(h))throw new Error(`a file search provider for the scheme '${h}' is already registered`);this._fileSearchUsedSchemes.add(h);const S=this._handlePool++;return this._fileSearchProvider.set(S,p),this._proxy.$registerFileSearchProvider(S,this._transformScheme(h)),(0,u.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(h),this._fileSearchProvider.delete(S),this._proxy.$unregisterProvider(S)})}$provideFileSearchResults(h,p,S,w){const o=r(S),d=this._fileSearchProvider.get(h);if(d)return this._fileSearchManager.fileSearch(o,d,_=>{this._proxy.$handleFileMatch(h,p,_.map(c=>c.resource))},w);throw new Error("unknown provider: "+h)}$clearCache(h){return this._fileSearchManager.clearCache(h),Promise.resolve(void 0)}$provideTextSearchResults(h,p,S,w){const o=this._textSearchProvider.get(h);if(!o||!o.provideTextSearchResults)throw new Error(`Unknown provider ${h}`);const d=r(S);return this.createTextSearchManager(d,o).search(c=>this._proxy.$handleTextMatch(h,p,c),w)}$enableExtensionHostSearch(){}createTextSearchManager(h,p){return new F.TextSearchManager(h,p,{readdir:S=>Promise.resolve([]),toCanonicalName:S=>S},"textSearchProvider")}};y=Ue([Be(0,t.IExtHostRpcService),Be(1,A.IURITransformerService),Be(2,C.ILogService)],y),e.ExtHostSearch=y;function r(a){return{...a,folderQueries:a.folderQueries&&a.folderQueries.map(m),extraFileResources:a.extraFileResources&&a.extraFileResources.map(h=>k.URI.revive(h))}}e.reviveQuery=r;function m(a){return{...a,folder:k.URI.revive(a.folder)}}}),define(be[227],Ee([0,1,21,16,3,36,2,118,80,112,58,47,5,188,187,40,189,33,190,191,192,173,193,51,34,194,174,197,199,201,96,176,206,207,208,73,41,210,177,8,7,213,53,97,32,54,161,196,64,95,99,100,101,12,67,14,28,202,158,66,71,185,211,157,74,52,216,214,215,186,31,209,212,70,72,87,204,98,205,11,146,203,155,195,27]),function(re,e,u,M,b,P,t,A,C,k,F,y,r,m,a,h,p,S,w,o,d,_,c,R,n,i,g,f,s,v,l,E,T,I,B,O,D,x,N,V,$,z,ee,j,Q,le,ve,ue,Fe,Ke,Oe,He,Je,Ye,Qe,W,K,X,oe,G,ie,de,Te,Ne,ze,je,et,ot,ye,nt,q,J,pe,$e,qe,rt,ft,ht,Ct,It,Pt,Ze,pt,Ie,ge){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Ce(Z){const se=Z.get(K.IExtHostInitDataService),fe=Z.get(q.IExtHostFileSystemInfo),he=Z.get(je.IExtHostConsumerFileSystem),ke=Z.get(n.IExtHostExtensionService),Le=Z.get(Q.IExtHostWorkspace),Me=Z.get(rt.IExtHostTelemetry),We=Z.get(S.IExtHostConfiguration),it=Z.get(Qe.IURITransformerService),Re=Z.get(W.IExtHostRpcService),ce=Z.get(O.IExtHostStorage),me=Z.get(ze.IExtensionStoragePaths),ne=Z.get(Ye.ILoggerService),H=Z.get(Ye.ILogService),we=Z.get(G.IExtHostTunnelService),De=Z.get(ie.IExtHostApiDeprecationService),Ge=Z.get(j.IExtHostWindow),xe=Z.get($e.IExtHostSecretState),ct=Z.get(qe.IExtHostEditorTabs);Re.set(r.ExtHostContext.ExtHostFileSystemInfo,fe),Re.set(r.ExtHostContext.ExtHostLogLevelServiceShape,ne),Re.set(r.ExtHostContext.ExtHostWorkspace,Le),Re.set(r.ExtHostContext.ExtHostConfiguration,We),Re.set(r.ExtHostContext.ExtHostExtensionService,ke),Re.set(r.ExtHostContext.ExtHostStorage,ce),Re.set(r.ExtHostContext.ExtHostTunnelService,we),Re.set(r.ExtHostContext.ExtHostWindow,Ge),Re.set(r.ExtHostContext.ExtHostSecretState,xe),Re.set(r.ExtHostContext.ExtHostTelemetry,Me),Re.set(r.ExtHostContext.ExtHostEditorTabs,ct);const _t=Re.set(r.ExtHostContext.ExtHostDecorations,Z.get(Ke.IExtHostDecorations)),wt=Re.set(r.ExtHostContext.ExtHostDocumentsAndEditors,Z.get(R.IExtHostDocumentsAndEditors)),lt=Re.set(r.ExtHostContext.ExtHostCommands,Z.get(h.IExtHostCommands)),gt=Re.set(r.ExtHostContext.ExtHostTerminalService,Z.get(D.IExtHostTerminalService)),dt=Re.set(r.ExtHostContext.ExtHostDebugService,Z.get(He.IExtHostDebugService)),Tt=Re.set(r.ExtHostContext.ExtHostSearch,Z.get(Je.IExtHostSearch)),yt=Re.set(r.ExtHostContext.ExtHostTask,Z.get(Oe.IExtHostTask)),Bt=Re.set(r.ExtHostContext.ExtHostOutputService,Z.get(l.IExtHostOutputService)),Vt=Re.set(r.ExtHostContext.ExtHostUrls,new z.ExtHostUrls(Re)),St=Re.set(r.ExtHostContext.ExtHostDocuments,new c.ExtHostDocuments(Re,wt)),$t=Re.set(r.ExtHostContext.ExtHostDocumentContentProviders,new d.ExtHostDocumentContentProvider(Re,wt,H)),ti=Re.set(r.ExtHostContext.ExtHostDocumentSaveParticipant,new _.ExtHostDocumentSaveParticipant(H,St,Re.getProxy(r.MainContext.MainThreadBulkEdits))),bt=Re.set(r.ExtHostContext.ExtHostNotebook,new X.ExtHostNotebookController(Re,lt,wt,St,me)),Qt=Re.set(r.ExtHostContext.ExtHostNotebookDocuments,new pt.ExtHostNotebookDocuments(H,bt)),jt=Re.set(r.ExtHostContext.ExtHostNotebookEditors,new Ze.ExtHostNotebookEditors(H,Re,bt)),ii=Re.set(r.ExtHostContext.ExtHostNotebookKernels,new ft.ExtHostNotebookKernels(Re,se,bt,lt,H)),ni=Re.set(r.ExtHostContext.ExtHostNotebookRenderers,new Ct.ExtHostNotebookRenderers(Re,bt)),At=Re.set(r.ExtHostContext.ExtHostEditors,new x.ExtHostEditors(Re,wt)),Yt=Re.set(r.ExtHostContext.ExtHostTreeViews,new N.ExtHostTreeViews(Re.getProxy(r.MainContext.MainThreadTreeViews),lt,H)),wi=Re.set(r.ExtHostContext.ExtHostEditorInsets,new ve.ExtHostEditorInsets(Re.getProxy(r.MainContext.MainThreadEditorInsets),At,se)),zt=Re.set(r.ExtHostContext.ExtHostDiagnostics,new w.ExtHostDiagnostics(Re,H,fe)),Wt=Re.set(r.ExtHostContext.ExtHostLanguages,new s.ExtHostLanguages(Re,St,lt.converter,it)),mt=Re.set(r.ExtHostContext.ExtHostLanguageFeatures,new f.ExtHostLanguageFeatures(Re,it,St,lt,zt,H,De)),ri=Re.set(r.ExtHostContext.ExtHostFileSystem,new i.ExtHostFileSystem(Re,mt)),Ot=Re.set(r.ExtHostContext.ExtHostFileSystemEventService,new g.ExtHostFileSystemEventService(Re,H,wt)),Nt=Re.set(r.ExtHostContext.ExtHostQuickOpen,(0,T.createExtHostQuickOpen)(Re,Le,lt)),Jt=Re.set(r.ExtHostContext.ExtHostSCM,new I.ExtHostSCM(Re,lt,H)),bi=Re.set(r.ExtHostContext.ExtHostComments,(0,p.createExtHostComments)(Re,lt,St)),di=Re.set(r.ExtHostContext.ExtHostProgress,new E.ExtHostProgress(Re.getProxy(r.MainContext.MainThreadProgress))),Ei=Re.set(r.ExtHostContext.ExtHosLabelService,new ue.ExtHostLabelService(Re)),hi=Re.set(r.ExtHostContext.ExtHostTheming,new oe.ExtHostTheming(Re)),Xt=Re.set(r.ExtHostContext.ExtHostAuthentication,new de.ExtHostAuthentication(Re)),oi=Re.set(r.ExtHostContext.ExtHostTimeline,new Te.ExtHostTimeline(Re,lt)),qt=Re.set(r.ExtHostContext.ExtHostWebviews,new ee.ExtHostWebviews(Re,{remote:se.remote},Le,H,De)),si=Re.set(r.ExtHostContext.ExtHostWebviewPanels,new ye.ExtHostWebviewPanels(Re,qt,Le)),_i=Re.set(r.ExtHostContext.ExtHostCustomEditors,new ot.ExtHostCustomEditors(Re,St,me,qt,si)),yi=Re.set(r.ExtHostContext.ExtHostWebviewViews,new et.ExtHostWebviewViews(Re,qt)),Gt=Re.set(r.ExtHostContext.ExtHostTesting,new J.ExtHostTesting(Re,lt)),Zt=Re.set(r.ExtHostContext.ExtHostUriOpeners,new pe.ExtHostUriOpeners(Re));Re.set(r.ExtHostContext.ExtHostInteractive,new Ie.ExtHostInteractive(Re,bt,wt,lt));const Si=(0,le.values)(r.ExtHostContext);Re.assertRegistered(Si);const Ci=new nt.ExtHostBulkEdits(Re,wt),Di=new a.ExtHostClipboard(Re),Kt=new v.ExtHostMessageService(Re,H),fi=new o.ExtHostDialogs(Re),Ht=new B.ExtHostStatusBar(Re,lt.converter);return m.ExtHostApiCommands.register(lt),function(Pe,ai,Ft){const vt=function(){let Y=!Pe.isUnderDevelopment;function ae(){Y||(H.info(`Extension '${Pe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),Y=!0)}return function Se(at){if(Array.isArray(at))at.forEach(Se);else if(typeof at=="string")ae();else{const Et=at;typeof Et.scheme=="undefined"&&ae(),typeof Et.exclusive=="boolean"&&(0,ge.checkProposedApiEnabled)(Pe,"documentFiltersExclusive")}return at}}(),ki={getSession(Y,ae,Se){return Se?.forceNewSession&&(0,ge.checkProposedApiEnabled)(Pe,"authSession"),Xt.getSession(Pe,Y,ae,Se)},async hasSession(Y,ae){return(0,ge.checkProposedApiEnabled)(Pe,"authSession"),!!await Xt.getSession(Pe,Y,ae,{silent:!0})},get onDidChangeSessions(){return Xt.onDidChangeSessions},registerAuthenticationProvider(Y,ae,Se,at){return Xt.registerAuthenticationProvider(Y,ae,Se,at)}},Ii={registerCommand(Y,ae,Se){return lt.registerCommand(!0,Y,ae,Se,void 0,Pe)},registerTextEditorCommand(Y,ae,Se){return lt.registerCommand(!0,Y,(...at)=>{const Et=At.getActiveTextEditor();if(!Et){H.warn("Cannot execute "+Y+" because there is no active text editor.");return}return Et.edit(kt=>{ae.apply(Se,[Et,kt,...at])}).then(kt=>{kt||H.warn("Edits from command "+Y+" were not applied.")},kt=>{H.warn("An error occurred while running command "+Y,kt)})},void 0,void 0,Pe)},registerDiffInformationCommand:(Y,ae,Se)=>((0,ge.checkProposedApiEnabled)(Pe,"diffCommand"),lt.registerCommand(!0,Y,async(...at)=>{const Et=wt.activeEditor(!0);if(!Et){H.warn("Cannot execute "+Y+" because there is no active text editor.");return}const kt=await At.getDiffInformation(Et.id);ae.apply(Se,[kt,...at])},void 0,void 0,Pe)),executeCommand(Y,...ae){return lt.executeCommand(Y,...ae)},getCommands(Y=!1){return lt.getCommands(Y)}},mi={get machineId(){return se.telemetryInfo.machineId},get sessionId(){return se.telemetryInfo.sessionId},get language(){return se.environment.appLanguage},get appName(){return se.environment.appName},get appRoot(){return se.environment.appRoot?.fsPath??""},get appHost(){return se.environment.appHost},get uriScheme(){return se.environment.appUriScheme},get clipboard(){return Di.value},get shell(){return gt.getDefaultShell(!1)},get isTelemetryEnabled(){return Me.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return Me.onDidChangeTelemetryEnabled},get isNewAppInstall(){const Y=Date.now()-new Date(se.telemetryInfo.firstSessionDate).getTime();return isNaN(Y)?!1:Y<1e3*60*60*24},openExternal(Y,ae){return Ge.openUri(Y,{allowTunneling:!!se.remote.authority,allowContributedOpeners:ae?.allowContributedOpeners})},async asExternalUri(Y){if(Y.scheme===se.environment.appUriScheme)return Vt.createAppUri(Y);try{return await Ge.asExternalUri(Y,{allowTunneling:!!se.remote.authority})}catch(ae){if((0,Pt.matchesScheme)(Y,It.Schemas.http)||(0,Pt.matchesScheme)(Y,It.Schemas.https))return Y;throw ae}},get remoteName(){return(0,Fe.getRemoteName)(se.remote.authority)},get remoteAuthority(){return(0,ge.checkProposedApiEnabled)(Pe,"resolvers"),se.remote.authority},get uiKind(){return se.uiKind}};se.environment.extensionTestsLocationURI||Object.freeze(mi);const gi=se.remote.isRemote?$.ExtensionKind.Workspace:$.ExtensionKind.UI,Pi={createTestController(Y,ae){return Gt.createTestController(Y,ae)},createTestObserver(){return(0,ge.checkProposedApiEnabled)(Pe,"testObserver"),Gt.createTestObserver()},runTests(Y){return(0,ge.checkProposedApiEnabled)(Pe,"testObserver"),Gt.runTests(Y)},get onDidChangeTestResults(){return(0,ge.checkProposedApiEnabled)(Pe,"testObserver"),Gt.onResultsChanged},get testResults(){return(0,ge.checkProposedApiEnabled)(Pe,"testObserver"),Gt.results}},Ti={getExtension(Y){const ae=ai.getExtensionDescription(Y);if(ae)return new n.Extension(ke,Pe.identifier,ae,gi)},get all(){return ai.getAllExtensionDescriptions().map(Y=>new n.Extension(ke,Pe.identifier,Y,gi))},get onDidChange(){return ai.onDidChange}},Ai={createDiagnosticCollection(Y){return zt.createDiagnosticCollection(Pe.identifier,Y)},get onDidChangeDiagnostics(){return zt.onDidChangeDiagnostics},getDiagnostics:Y=>zt.getDiagnostics(Y),getLanguages(){return Wt.getLanguages()},setTextDocumentLanguage(Y,ae){return Wt.changeLanguage(Y.uri,ae)},match(Y,ae){return(0,F.score)(V.LanguageSelector.from(Y),ae.uri,ae.languageId,!0)},registerCodeActionsProvider(Y,ae,Se){return mt.registerCodeActionProvider(Pe,vt(Y),ae,Se)},registerCodeLensProvider(Y,ae){return mt.registerCodeLensProvider(Pe,vt(Y),ae)},registerDefinitionProvider(Y,ae){return mt.registerDefinitionProvider(Pe,vt(Y),ae)},registerDeclarationProvider(Y,ae){return mt.registerDeclarationProvider(Pe,vt(Y),ae)},registerImplementationProvider(Y,ae){return mt.registerImplementationProvider(Pe,vt(Y),ae)},registerTypeDefinitionProvider(Y,ae){return mt.registerTypeDefinitionProvider(Pe,vt(Y),ae)},registerHoverProvider(Y,ae){return mt.registerHoverProvider(Pe,vt(Y),ae,Pe.identifier)},registerEvaluatableExpressionProvider(Y,ae){return mt.registerEvaluatableExpressionProvider(Pe,vt(Y),ae,Pe.identifier)},registerInlineValuesProvider(Y,ae){return mt.registerInlineValuesProvider(Pe,vt(Y),ae,Pe.identifier)},registerDocumentHighlightProvider(Y,ae){return mt.registerDocumentHighlightProvider(Pe,vt(Y),ae)},registerLinkedEditingRangeProvider(Y,ae){return mt.registerLinkedEditingRangeProvider(Pe,vt(Y),ae)},registerReferenceProvider(Y,ae){return mt.registerReferenceProvider(Pe,vt(Y),ae)},registerRenameProvider(Y,ae){return mt.registerRenameProvider(Pe,vt(Y),ae)},registerDocumentSymbolProvider(Y,ae,Se){return mt.registerDocumentSymbolProvider(Pe,vt(Y),ae,Se)},registerWorkspaceSymbolProvider(Y){return mt.registerWorkspaceSymbolProvider(Pe,Y)},registerDocumentFormattingEditProvider(Y,ae){return mt.registerDocumentFormattingEditProvider(Pe,vt(Y),ae)},registerDocumentRangeFormattingEditProvider(Y,ae){return mt.registerDocumentRangeFormattingEditProvider(Pe,vt(Y),ae)},registerOnTypeFormattingEditProvider(Y,ae,Se,...at){return mt.registerOnTypeFormattingEditProvider(Pe,vt(Y),ae,[Se].concat(at))},registerDocumentSemanticTokensProvider(Y,ae,Se){return mt.registerDocumentSemanticTokensProvider(Pe,vt(Y),ae,Se)},registerDocumentRangeSemanticTokensProvider(Y,ae,Se){return mt.registerDocumentRangeSemanticTokensProvider(Pe,vt(Y),ae,Se)},registerSignatureHelpProvider(Y,ae,Se,...at){return typeof Se=="object"?mt.registerSignatureHelpProvider(Pe,vt(Y),ae,Se):mt.registerSignatureHelpProvider(Pe,vt(Y),ae,typeof Se=="undefined"?[]:[Se,...at])},registerCompletionItemProvider(Y,ae,...Se){return mt.registerCompletionItemProvider(Pe,vt(Y),ae,Se)},registerInlineCompletionItemProvider(Y,ae){return(0,ge.checkProposedApiEnabled)(Pe,"inlineCompletions"),mt.registerInlineCompletionsProvider(Pe,vt(Y),ae)},registerDocumentLinkProvider(Y,ae){return mt.registerDocumentLinkProvider(Pe,vt(Y),ae)},registerColorProvider(Y,ae){return mt.registerColorProvider(Pe,vt(Y),ae)},registerFoldingRangeProvider(Y,ae){return mt.registerFoldingRangeProvider(Pe,vt(Y),ae)},registerSelectionRangeProvider(Y,ae){return mt.registerSelectionRangeProvider(Pe,Y,ae)},registerCallHierarchyProvider(Y,ae){return mt.registerCallHierarchyProvider(Pe,Y,ae)},registerTypeHierarchyProvider(Y,ae){return mt.registerTypeHierarchyProvider(Pe,Y,ae)},setLanguageConfiguration:(Y,ae)=>mt.setLanguageConfiguration(Pe,Y,ae),getTokenInformationAtPosition(Y,ae){return(0,ge.checkProposedApiEnabled)(Pe,"tokenInformation"),Wt.tokenAtPosition(Y,ae)},registerInlayHintsProvider(Y,ae){return(0,ge.checkProposedApiEnabled)(Pe,"inlayHints"),mt.registerInlayHintsProvider(Pe,Y,ae)},createLanguageStatusItem(Y,ae){return(0,ge.checkProposedApiEnabled)(Pe,"languageStatus"),Wt.createLanguageStatusItem(Pe,Y,ae)}},ci={get activeTextEditor(){return At.getActiveTextEditor()},get visibleTextEditors(){return At.getVisibleTextEditors()},get activeTerminal(){return gt.activeTerminal},get terminals(){return gt.terminals},async showTextDocument(Y,ae,Se){const at=await(t.URI.isUri(Y)?Promise.resolve(pi.openTextDocument(Y)):Promise.resolve(Y));return At.showTextDocument(at,ae,Se)},createTextEditorDecorationType(Y){return At.createTextEditorDecorationType(Pe,Y)},onDidChangeActiveTextEditor(Y,ae,Se){return At.onDidChangeActiveTextEditor(Y,ae,Se)},onDidChangeVisibleTextEditors(Y,ae,Se){return At.onDidChangeVisibleTextEditors(Y,ae,Se)},onDidChangeTextEditorSelection(Y,ae,Se){return At.onDidChangeTextEditorSelection(Y,ae,Se)},onDidChangeTextEditorOptions(Y,ae,Se){return At.onDidChangeTextEditorOptions(Y,ae,Se)},onDidChangeTextEditorVisibleRanges(Y,ae,Se){return At.onDidChangeTextEditorVisibleRanges(Y,ae,Se)},onDidChangeTextEditorViewColumn(Y,ae,Se){return At.onDidChangeTextEditorViewColumn(Y,ae,Se)},onDidCloseTerminal(Y,ae,Se){return gt.onDidCloseTerminal(Y,ae,Se)},onDidOpenTerminal(Y,ae,Se){return gt.onDidOpenTerminal(Y,ae,Se)},onDidChangeActiveTerminal(Y,ae,Se){return gt.onDidChangeActiveTerminal(Y,ae,Se)},onDidChangeTerminalDimensions(Y,ae,Se){return(0,ge.checkProposedApiEnabled)(Pe,"terminalDimensions"),gt.onDidChangeTerminalDimensions(Y,ae,Se)},onDidChangeTerminalState(Y,ae,Se){return gt.onDidChangeTerminalState(Y,ae,Se)},onDidWriteTerminalData(Y,ae,Se){return(0,ge.checkProposedApiEnabled)(Pe,"terminalDataWriteEvent"),gt.onDidWriteTerminalData(Y,ae,Se)},get state(){return Ge.state},onDidChangeWindowState(Y,ae,Se){return Ge.onDidChangeWindowState(Y,ae,Se)},showInformationMessage(Y,...ae){return Kt.showMessage(Pe,P.default.Info,Y,ae[0],ae.slice(1))},showWarningMessage(Y,...ae){return Kt.showMessage(Pe,P.default.Warning,Y,ae[0],ae.slice(1))},showErrorMessage(Y,...ae){return Kt.showMessage(Pe,P.default.Error,Y,ae[0],ae.slice(1))},showQuickPick(Y,ae,Se){return Array.isArray(Y)&&Y.some(at=>at.kind!==void 0)&&(0,ge.checkProposedApiEnabled)(Pe,"quickPickSeparators"),Nt.showQuickPick(Y,ae,Se)},showWorkspaceFolderPick(Y){return Nt.showWorkspaceFolderPick(Y)},showInputBox(Y,ae){return Nt.showInput(Y,ae)},showOpenDialog(Y){return fi.showOpenDialog(Y)},showSaveDialog(Y){return fi.showSaveDialog(Y)},createStatusBarItem(Y,ae,Se){let at,Et,kt;return typeof Y=="string"?(at=Y,Et=ae,kt=Se):(Et=Y,kt=ae),Ht.createStatusBarEntry(Pe,at,Et,kt)},setStatusBarMessage(Y,ae){return Ht.setStatusBarMessage(Y,ae)},withScmProgress(Y){return De.report("window.withScmProgress",Pe,"Use 'withProgress' instead."),di.withProgress(Pe,{location:$.ProgressLocation.SourceControl},(ae,Se)=>Y({report(at){}}))},withProgress(Y,ae){return di.withProgress(Pe,Y,ae)},createOutputChannel(Y){return Bt.createOutputChannel(Y,Pe)},createWebviewPanel(Y,ae,Se,at){return si.createWebviewPanel(Pe,Y,ae,Se,at)},createWebviewTextEditorInset(Y,ae,Se,at){return(0,ge.checkProposedApiEnabled)(Pe,"editorInsets"),wi.createWebviewEditorInset(Y,ae,Se,at,Pe)},createTerminal(Y,ae,Se){return typeof Y=="object"?("location"in Y&&(0,ge.checkProposedApiEnabled)(Pe,"terminalLocation"),"pty"in Y?gt.createExtensionTerminal(Y):gt.createTerminalFromOptions(Y)):gt.createTerminal(Y,ae,Se)},registerTerminalLinkProvider(Y){return gt.registerLinkProvider(Y)},registerTerminalProfileProvider(Y,ae){return gt.registerProfileProvider(Pe,Y,ae)},registerTreeDataProvider(Y,ae){return Yt.registerTreeDataProvider(Y,ae,Pe)},createTreeView(Y,ae){return Yt.createTreeView(Y,ae,Pe)},registerWebviewPanelSerializer:(Y,ae)=>si.registerWebviewPanelSerializer(Pe,Y,ae),registerCustomEditorProvider:(Y,ae,Se={})=>_i.registerCustomEditorProvider(Pe,Y,ae,Se),registerFileDecorationProvider(Y){return _t.registerFileDecorationProvider(Y,Pe.identifier)},registerUriHandler(Y){return Vt.registerUriHandler(Pe.identifier,Y)},createQuickPick(){return Nt.createQuickPick(Pe)},createInputBox(){return Nt.createInputBox(Pe.identifier)},get activeColorTheme(){return hi.activeColorTheme},onDidChangeActiveColorTheme(Y,ae,Se){return hi.onDidChangeActiveColorTheme(Y,ae,Se)},registerWebviewViewProvider(Y,ae,Se){return yi.registerWebviewViewProvider(Pe,Y,ae,Se?.webviewOptions)},get activeNotebookEditor(){return(0,ge.checkProposedApiEnabled)(Pe,"notebookEditor"),bt.activeNotebookEditor},onDidChangeActiveNotebookEditor(Y,ae,Se){return(0,ge.checkProposedApiEnabled)(Pe,"notebookEditor"),bt.onDidChangeActiveNotebookEditor(Y,ae,Se)},get visibleNotebookEditors(){return(0,ge.checkProposedApiEnabled)(Pe,"notebookEditor"),bt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,ge.checkProposedApiEnabled)(Pe,"notebookEditor"),bt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(Y,ae,Se){return(0,ge.checkProposedApiEnabled)(Pe,"notebookEditor"),jt.onDidChangeNotebookEditorSelection(Y,ae,Se)},onDidChangeNotebookEditorVisibleRanges(Y,ae,Se){return(0,ge.checkProposedApiEnabled)(Pe,"notebookEditor"),jt.onDidChangeNotebookEditorVisibleRanges(Y,ae,Se)},showNotebookDocument(Y,ae){return(0,ge.checkProposedApiEnabled)(Pe,"notebookEditor"),bt.showNotebookDocument(Y,ae)},registerExternalUriOpener(Y,ae,Se){return(0,ge.checkProposedApiEnabled)(Pe,"externalUriOpener"),Zt.registerExternalUriOpener(Pe.identifier,Y,ae,Se)},get tabs(){return(0,ge.checkProposedApiEnabled)(Pe,"tabs"),ct.tabs},get activeTab(){return(0,ge.checkProposedApiEnabled)(Pe,"tabs"),ct.activeTab},get onDidChangeTabs(){return(0,ge.checkProposedApiEnabled)(Pe,"tabs"),ct.onDidChangeTabs},get onDidChangeActiveTab(){return(0,ge.checkProposedApiEnabled)(Pe,"tabs"),ct.onDidChangeActiveTab},getInlineCompletionItemController(Y){return(0,ge.checkProposedApiEnabled)(Pe,"inlineCompletions"),f.InlineCompletionController.get(Y)}},pi={get rootPath(){return De.report("workspace.rootPath",Pe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Le.getPath()},set rootPath(Y){throw M.readonly()},getWorkspaceFolder(Y){return Le.getWorkspaceFolder(Y)},get workspaceFolders(){return Le.getWorkspaceFolders()},get name(){return Le.name},set name(Y){throw M.readonly()},get workspaceFile(){return Le.workspaceFile},set workspaceFile(Y){throw M.readonly()},updateWorkspaceFolders:(Y,ae,...Se)=>Le.updateWorkspaceFolders(Pe,Y,ae||0,...Se),onDidChangeWorkspaceFolders:function(Y,ae,Se){return Le.onDidChangeWorkspace(Y,ae,Se)},asRelativePath:(Y,ae)=>Le.getRelativePath(Y,ae),findFiles:(Y,ae,Se,at)=>Le.findFiles(V.GlobPattern.from(Y),V.GlobPattern.from(ae),Se,Pe.identifier,at),findTextInFiles:(Y,ae,Se,at)=>{(0,ge.checkProposedApiEnabled)(Pe,"findTextInFiles");let Et,kt;return typeof ae=="object"?(Et=ae,kt=Se):(Et={},kt=ae,at=Se),Le.findTextInFiles(Y,Et||{},kt,Pe.identifier,at)},saveAll:Y=>Le.saveAll(Y),applyEdit(Y){return Ci.applyWorkspaceEdit(Y)},createFileSystemWatcher:(Y,ae,Se,at)=>Ot.createFileSystemWatcher(V.GlobPattern.from(Y),ae,Se,at),get textDocuments(){return St.getAllDocumentData().map(Y=>Y.document)},set textDocuments(Y){throw M.readonly()},openTextDocument(Y){let ae;const Se=Y;if(typeof Y=="string")ae=Promise.resolve(t.URI.file(Y));else if(t.URI.isUri(Y))ae=Promise.resolve(Y);else if(!Se||typeof Se=="object")ae=St.createDocumentData(Se);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ae.then(at=>St.ensureDocumentData(at).then(Et=>Et.document))},onDidOpenTextDocument:(Y,ae,Se)=>St.onDidAddDocument(Y,ae,Se),onDidCloseTextDocument:(Y,ae,Se)=>St.onDidRemoveDocument(Y,ae,Se),onDidChangeTextDocument:(Y,ae,Se)=>St.onDidChangeDocument(Y,ae,Se),onDidSaveTextDocument:(Y,ae,Se)=>St.onDidSaveDocument(Y,ae,Se),onWillSaveTextDocument:(Y,ae,Se)=>ti.getOnWillSaveTextDocumentEvent(Pe)(Y,ae,Se),get notebookDocuments(){return bt.notebookDocuments.map(Y=>Y.apiNotebook)},async openNotebookDocument(Y,ae){let Se;if(t.URI.isUri(Y))Se=Y,await bt.openNotebookDocument(Y);else if(typeof Y=="string")Se=t.URI.revive(await bt.createNotebookDocument({viewType:Y,content:ae}));else throw new Error("Invalid arguments");return bt.getNotebookDocument(Se).apiNotebook},get onDidOpenNotebookDocument(){return bt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return bt.onDidCloseNotebookDocument},registerNotebookSerializer(Y,ae,Se,at){return bt.registerNotebookSerializer(Pe,Y,ae,Se,(0,ge.isProposedApiEnabled)(Pe,"notebookLiveShare")?at:void 0)},registerNotebookContentProvider:(Y,ae,Se,at)=>((0,ge.checkProposedApiEnabled)(Pe,"notebookContentProvider"),bt.registerNotebookContentProvider(Pe,Y,ae,Se,(0,ge.isProposedApiEnabled)(Pe,"notebookLiveShare")?at:void 0)),onDidChangeConfiguration:(Y,ae,Se)=>Ft.onDidChangeConfiguration(Y,ae,Se),getConfiguration(Y,ae){return ae=arguments.length===1?void 0:ae,Ft.getConfiguration(Y,ae,Pe)},registerTextDocumentContentProvider(Y,ae){return $t.registerTextDocumentContentProvider(Y,ae)},registerTaskProvider:(Y,ae)=>(De.report("window.registerTaskProvider",Pe,"Use the corresponding function on the 'tasks' namespace instead"),yt.registerTaskProvider(Pe,Y,ae)),registerFileSystemProvider(Y,ae,Se){return ri.registerFileSystemProvider(Pe,Y,ae,Se)},get fs(){return he.value},registerFileSearchProvider:(Y,ae)=>((0,ge.checkProposedApiEnabled)(Pe,"fileSearchProvider"),Tt.registerFileSearchProvider(Y,ae)),registerTextSearchProvider:(Y,ae)=>((0,ge.checkProposedApiEnabled)(Pe,"textSearchProvider"),Tt.registerTextSearchProvider(Y,ae)),registerRemoteAuthorityResolver:(Y,ae)=>((0,ge.checkProposedApiEnabled)(Pe,"resolvers"),ke.registerRemoteAuthorityResolver(Y,ae)),registerResourceLabelFormatter:Y=>((0,ge.checkProposedApiEnabled)(Pe,"resolvers"),Ei.$registerResourceLabelFormatter(Y)),onDidCreateFiles:(Y,ae,Se)=>Ot.onDidCreateFile(Y,ae,Se),onDidDeleteFiles:(Y,ae,Se)=>Ot.onDidDeleteFile(Y,ae,Se),onDidRenameFiles:(Y,ae,Se)=>Ot.onDidRenameFile(Y,ae,Se),onWillCreateFiles:(Y,ae,Se)=>Ot.getOnWillCreateFileEvent(Pe)(Y,ae,Se),onWillDeleteFiles:(Y,ae,Se)=>Ot.getOnWillDeleteFileEvent(Pe)(Y,ae,Se),onWillRenameFiles:(Y,ae,Se)=>Ot.getOnWillRenameFileEvent(Pe)(Y,ae,Se),openTunnel:Y=>((0,ge.checkProposedApiEnabled)(Pe,"resolvers"),we.openTunnel(Pe,Y).then(ae=>{if(!ae)throw new Error("cannot open tunnel");return ae})),get tunnels(){return(0,ge.checkProposedApiEnabled)(Pe,"resolvers"),we.getTunnels()},onDidChangeTunnels:(Y,ae,Se)=>((0,ge.checkProposedApiEnabled)(Pe,"resolvers"),we.onDidChangeTunnels(Y,ae,Se)),registerPortAttributesProvider:(Y,ae)=>((0,ge.checkProposedApiEnabled)(Pe,"portsAttributes"),we.registerPortsAttributesProvider(Y,ae)),registerTimelineProvider:(Y,ae)=>((0,ge.checkProposedApiEnabled)(Pe,"timeline"),oi.registerTimelineProvider(Y,ae,Pe.identifier,lt.converter)),get isTrusted(){return Le.trusted},requestWorkspaceTrust:Y=>((0,ge.checkProposedApiEnabled)(Pe,"workspaceTrust"),Le.requestWorkspaceTrust(Y)),onDidGrantWorkspaceTrust:(Y,ae,Se)=>Le.onDidGrantWorkspaceTrust(Y,ae,Se)},Ri={get inputBox(){return De.report("scm.inputBox",Pe,"Use 'SourceControl.inputBox' instead"),Jt.getLastInputBox(Pe)},createSourceControl(Y,ae,Se){return Jt.createSourceControl(Pe,Y,ae,Se)}},Fi={createCommentController(Y,ae){return bi.createCommentController(Pe,Y,ae)}},Mi={get activeDebugSession(){return dt.activeDebugSession},get activeDebugConsole(){return dt.activeDebugConsole},get breakpoints(){return dt.breakpoints},onDidStartDebugSession(Y,ae,Se){return dt.onDidStartDebugSession(Y,ae,Se)},onDidTerminateDebugSession(Y,ae,Se){return dt.onDidTerminateDebugSession(Y,ae,Se)},onDidChangeActiveDebugSession(Y,ae,Se){return dt.onDidChangeActiveDebugSession(Y,ae,Se)},onDidReceiveDebugSessionCustomEvent(Y,ae,Se){return dt.onDidReceiveDebugSessionCustomEvent(Y,ae,Se)},onDidChangeBreakpoints(Y,ae,Se){return dt.onDidChangeBreakpoints(Y,ae,Se)},registerDebugConfigurationProvider(Y,ae,Se){return dt.registerDebugConfigurationProvider(Y,ae,Se||$.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(Y,ae){return dt.registerDebugAdapterDescriptorFactory(Pe,Y,ae)},registerDebugAdapterTrackerFactory(Y,ae){return dt.registerDebugAdapterTrackerFactory(Y,ae)},startDebugging(Y,ae,Se){return!Se||typeof Se=="object"&&"configuration"in Se?dt.startDebugging(Y,ae,{parentSession:Se}):dt.startDebugging(Y,ae,Se||{})},stopDebugging(Y){return dt.stopDebugging(Y)},addBreakpoints(Y){return dt.addBreakpoints(Y)},removeBreakpoints(Y){return dt.removeBreakpoints(Y)},asDebugSourceUri(Y,ae){return dt.asDebugSourceUri(Y,ae)}},Li={registerTaskProvider:(Y,ae)=>yt.registerTaskProvider(Pe,Y,ae),fetchTasks:Y=>yt.fetchTasks(Y),executeTask:Y=>yt.executeTask(Pe,Y),get taskExecutions(){return yt.taskExecutions},onDidStartTask:(Y,ae,Se)=>yt.onDidStartTask(Y,ae,Se),onDidEndTask:(Y,ae,Se)=>yt.onDidEndTask(Y,ae,Se),onDidStartTaskProcess:(Y,ae,Se)=>yt.onDidStartTaskProcess(Y,ae,Se),onDidEndTaskProcess:(Y,ae,Se)=>yt.onDidEndTaskProcess(Y,ae,Se)},Oi={createNotebookController(Y,ae,Se,at,Et){return ii.createNotebookController(Pe,Y,ae,Se,at,(0,ge.isProposedApiEnabled)(Pe,"notebookMessaging")?Et:void 0)},registerNotebookCellStatusBarItemProvider:(Y,ae)=>bt.registerNotebookCellStatusBarItemProvider(Pe,Y,ae),get onDidSaveNotebookDocument(){return(0,ge.checkProposedApiEnabled)(Pe,"notebookEditor"),Qt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(Y){return(0,ge.checkProposedApiEnabled)(Pe,"notebookEditorDecorationType"),jt.createNotebookEditorDecorationType(Y)},createRendererMessaging(Y){return ni.createRendererMessaging(Pe,Y)},onDidChangeNotebookDocumentMetadata(Y,ae,Se){return(0,ge.checkProposedApiEnabled)(Pe,"notebookEditor"),Qt.onDidChangeNotebookDocumentMetadata(Y,ae,Se)},onDidChangeNotebookCells(Y,ae,Se){return(0,ge.checkProposedApiEnabled)(Pe,"notebookEditor"),bt.onDidChangeNotebookCells(Y,ae,Se)},onDidChangeNotebookCellExecutionState(Y,ae,Se){return(0,ge.checkProposedApiEnabled)(Pe,"notebookCellExecutionState"),bt.onDidChangeNotebookCellExecutionState(Y,ae,Se)},onDidChangeCellOutputs(Y,ae,Se){return(0,ge.checkProposedApiEnabled)(Pe,"notebookEditor"),bt.onDidChangeCellOutputs(Y,ae,Se)},onDidChangeCellMetadata(Y,ae,Se){return(0,ge.checkProposedApiEnabled)(Pe,"notebookEditor"),bt.onDidChangeCellMetadata(Y,ae,Se)},createConcatTextDocument(Y,ae){return(0,ge.checkProposedApiEnabled)(Pe,"notebookConcatTextDocument"),new Ne.ExtHostNotebookConcatDocument(bt,St,Y,ae)}};return{version:se.version,authentication:ki,commands:Ii,comments:Fi,debug:Mi,env:mi,extensions:Ti,languages:Ai,notebooks:Oi,scm:Ri,tasks:Li,tests:Pi,window:ci,workspace:pi,Breakpoint:$.Breakpoint,CallHierarchyIncomingCall:$.CallHierarchyIncomingCall,CallHierarchyItem:$.CallHierarchyItem,CallHierarchyOutgoingCall:$.CallHierarchyOutgoingCall,CancellationError:M.CancellationError,CancellationTokenSource:u.CancellationTokenSource,CandidatePortSource:r.CandidatePortSource,CodeAction:$.CodeAction,CodeActionKind:$.CodeActionKind,CodeActionTriggerKind:$.CodeActionTriggerKind,CodeLens:$.CodeLens,Color:$.Color,ColorInformation:$.ColorInformation,ColorPresentation:$.ColorPresentation,ColorThemeKind:$.ColorThemeKind,CommentMode:$.CommentMode,CommentThreadCollapsibleState:$.CommentThreadCollapsibleState,CompletionItem:$.CompletionItem,CompletionItemKind:$.CompletionItemKind,CompletionItemTag:$.CompletionItemTag,CompletionList:$.CompletionList,CompletionTriggerKind:$.CompletionTriggerKind,ConfigurationTarget:$.ConfigurationTarget,CustomExecution:$.CustomExecution,DebugAdapterExecutable:$.DebugAdapterExecutable,DebugAdapterInlineImplementation:$.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:$.DebugAdapterNamedPipeServer,DebugAdapterServer:$.DebugAdapterServer,DebugConfigurationProviderTriggerKind:$.DebugConfigurationProviderTriggerKind,DebugConsoleMode:$.DebugConsoleMode,DecorationRangeBehavior:$.DecorationRangeBehavior,Diagnostic:$.Diagnostic,DiagnosticRelatedInformation:$.DiagnosticRelatedInformation,DiagnosticSeverity:$.DiagnosticSeverity,DiagnosticTag:$.DiagnosticTag,Disposable:$.Disposable,DocumentHighlight:$.DocumentHighlight,DocumentHighlightKind:$.DocumentHighlightKind,DocumentLink:$.DocumentLink,DocumentSymbol:$.DocumentSymbol,EndOfLine:$.EndOfLine,EnvironmentVariableMutatorType:$.EnvironmentVariableMutatorType,EvaluatableExpression:$.EvaluatableExpression,InlineValueText:$.InlineValueText,InlineValueVariableLookup:$.InlineValueVariableLookup,InlineValueEvaluatableExpression:$.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:$.InlineCompletionTriggerKind,EventEmitter:b.Emitter,ExtensionKind:$.ExtensionKind,ExtensionMode:$.ExtensionMode,ExternalUriOpenerPriority:$.ExternalUriOpenerPriority,FileChangeType:$.FileChangeType,FileDecoration:$.FileDecoration,FileSystemError:$.FileSystemError,FileType:y.FileType,FilePermission:y.FilePermission,FoldingRange:$.FoldingRange,FoldingRangeKind:$.FoldingRangeKind,FunctionBreakpoint:$.FunctionBreakpoint,InlineCompletionItem:$.InlineSuggestion,InlineCompletionList:$.InlineSuggestions,Hover:$.Hover,IndentAction:k.IndentAction,Location:$.Location,MarkdownString:$.MarkdownString,OverviewRulerLane:C.OverviewRulerLane,ParameterInformation:$.ParameterInformation,PortAutoForwardAction:$.PortAutoForwardAction,Position:$.Position,ProcessExecution:$.ProcessExecution,ProgressLocation:$.ProgressLocation,QuickInputButtons:$.QuickInputButtons,Range:$.Range,RelativePattern:$.RelativePattern,Selection:$.Selection,SelectionRange:$.SelectionRange,SemanticTokens:$.SemanticTokens,SemanticTokensBuilder:$.SemanticTokensBuilder,SemanticTokensEdit:$.SemanticTokensEdit,SemanticTokensEdits:$.SemanticTokensEdits,SemanticTokensLegend:$.SemanticTokensLegend,ShellExecution:$.ShellExecution,ShellQuoting:$.ShellQuoting,SignatureHelp:$.SignatureHelp,SignatureHelpTriggerKind:$.SignatureHelpTriggerKind,SignatureInformation:$.SignatureInformation,SnippetString:$.SnippetString,SourceBreakpoint:$.SourceBreakpoint,StandardTokenType:$.StandardTokenType,StatusBarAlignment:$.StatusBarAlignment,SymbolInformation:$.SymbolInformation,SymbolKind:$.SymbolKind,SymbolTag:$.SymbolTag,Task:$.Task,TaskGroup:$.TaskGroup,TaskPanelKind:$.TaskPanelKind,TaskRevealKind:$.TaskRevealKind,TaskScope:$.TaskScope,TerminalLink:$.TerminalLink,TerminalLocation:$.TerminalLocation,TerminalProfile:$.TerminalProfile,TextDocumentSaveReason:$.TextDocumentSaveReason,TextEdit:$.TextEdit,TextEditorCursorStyle:A.TextEditorCursorStyle,TextEditorLineNumbersStyle:$.TextEditorLineNumbersStyle,TextEditorRevealType:$.TextEditorRevealType,TextEditorSelectionChangeKind:$.TextEditorSelectionChangeKind,TextDocumentChangeReason:$.TextDocumentChangeReason,ThemeColor:$.ThemeColor,ThemeIcon:$.ThemeIcon,TreeItem:$.TreeItem,TreeItemCollapsibleState:$.TreeItemCollapsibleState,TypeHierarchyItem:$.TypeHierarchyItem,UIKind:r.UIKind,Uri:t.URI,ViewColumn:$.ViewColumn,WorkspaceEdit:$.WorkspaceEdit,InlayHint:$.InlayHint,InlayHintKind:$.InlayHintKind,RemoteAuthorityResolverError:$.RemoteAuthorityResolverError,ResolvedAuthority:$.ResolvedAuthority,SourceControlInputBoxValidationType:$.SourceControlInputBoxValidationType,ExtensionRuntime:$.ExtensionRuntime,TimelineItem:$.TimelineItem,NotebookRange:$.NotebookRange,NotebookCellKind:$.NotebookCellKind,NotebookCellExecutionState:$.NotebookCellExecutionState,NotebookCellData:$.NotebookCellData,NotebookData:$.NotebookData,NotebookRendererScript:$.NotebookRendererScript,NotebookCellStatusBarAlignment:$.NotebookCellStatusBarAlignment,NotebookEditorRevealType:$.NotebookEditorRevealType,NotebookCellOutput:$.NotebookCellOutput,NotebookCellOutputItem:$.NotebookCellOutputItem,NotebookCellStatusBarItem:$.NotebookCellStatusBarItem,NotebookControllerAffinity:$.NotebookControllerAffinity,PortAttributes:$.PortAttributes,LinkedEditingRanges:$.LinkedEditingRanges,TestResultState:$.TestResultState,TestRunRequest:$.TestRunRequest,TestMessage:$.TestMessage,TestTag:$.TestTag,TestRunProfileKind:$.TestRunProfileKind,TextSearchCompleteMessageType:ht.TextSearchCompleteMessageType,CoveredCount:$.CoveredCount,FileCoverage:$.FileCoverage,StatementCoverage:$.StatementCoverage,BranchCoverage:$.BranchCoverage,FunctionCoverage:$.FunctionCoverage,WorkspaceTrustState:$.WorkspaceTrustState,LanguageStatusSeverity:$.LanguageStatusSeverity,QuickPickItemKind:$.QuickPickItemKind}}}e.createApiFactoryAndRegisterActors=Ce}),define(be[228],Ee([0,1,59,96,32,95,33,40,51,41,99,100,101,73,66,71,97,52,31,70,87,72,200,12,183]),function(re,e,u,M,b,P,t,A,C,k,F,y,r,m,a,h,p,S,w,o,d,_,c,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,u.registerSingleton)(R.ILoggerService,c.ExtHostLoggerService),(0,u.registerSingleton)(R.ILogService,n.ExtHostLogService),(0,u.registerSingleton)(h.IExtHostApiDeprecationService,h.ExtHostApiDeprecationService),(0,u.registerSingleton)(A.IExtHostCommands,A.ExtHostCommands),(0,u.registerSingleton)(t.IExtHostConfiguration,t.ExtHostConfiguration),(0,u.registerSingleton)(S.IExtHostConsumerFileSystem,S.ExtHostConsumerFileSystem),(0,u.registerSingleton)(y.IExtHostDebugService,y.WorkerExtHostDebugService),(0,u.registerSingleton)(P.IExtHostDecorations,P.ExtHostDecorations),(0,u.registerSingleton)(C.IExtHostDocumentsAndEditors,C.ExtHostDocumentsAndEditors),(0,u.registerSingleton)(w.IExtHostFileSystemInfo,w.ExtHostFileSystemInfo),(0,u.registerSingleton)(M.IExtHostOutputService,M.ExtHostOutputService),(0,u.registerSingleton)(r.IExtHostSearch,r.ExtHostSearch),(0,u.registerSingleton)(m.IExtHostStorage,m.ExtHostStorage),(0,u.registerSingleton)(F.IExtHostTask,F.WorkerExtHostTask),(0,u.registerSingleton)(k.IExtHostTerminalService,k.WorkerExtHostTerminalService),(0,u.registerSingleton)(a.IExtHostTunnelService,a.ExtHostTunnelService),(0,u.registerSingleton)(p.IExtHostWindow,p.ExtHostWindow),(0,u.registerSingleton)(b.IExtHostWorkspace,b.ExtHostWorkspace),(0,u.registerSingleton)(o.IExtHostSecretState,o.ExtHostSecretState),(0,u.registerSingleton)(d.IExtHostTelemetry,d.ExtHostTelemetry),(0,u.registerSingleton)(_.IExtHostEditorTabs,_.ExtHostEditorTabs)}),define(be[229],Ee([0,1,227,34,223,7,13,5,11]),function(re,e,u,M,b,P,t,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var k;(function(a){const h=self.trustedTypes?.createPolicy("TrustedFunctionWorkaround",{createScript:(S,...w)=>{w.forEach(c=>{if(!self.trustedTypes?.isScript(c))throw new Error("TrustedScripts only, please")});const o=w.slice(0,-1).join(","),d=w.pop().toString();return`(function anonymous(${o}) {${d}
})`}});function p(...S){return h?self.eval(h.createScript("",...S)):new Function(...S)}a.create=p})(k||(k={}));class F extends b.RequireInterceptor{_installInterceptor(){}getModule(h,p){for(let S of this._alternatives){let w=S(h);if(w){h=w;break}}if(this._factories.has(h))return this._factories.get(h).load(h,p,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class y extends M.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=P.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const h=this._extHostContext.getProxy(A.MainContext.MainThreadConsole);m(h,this._initData.environment.isExtensionDevelopmentDebug);const p=this._instaService.invokeFunction(u.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(F,p,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(h){return h.browser}async _loadCommonJSModule(h,p,S){p=p.with({path:r(p.path,".js")}),h&&performance.mark(`code/extHost/willFetchExtensionCode/${h.value}`);const w=await fetch(C.FileAccess.asBrowserUri(p).toString(!0));if(h&&performance.mark(`code/extHost/didFetchExtensionCode/${h.value}`),w.status!==200)throw new Error(w.statusText);const o=await w.text(),d=`${p.toString(!0)}#vscode-extension`,_=`${o}
//# sourceURL=${d}`;let c;try{c=k.create(y._ttpExtensionScripts?.createScript("module")??"module",y._ttpExtensionScripts?.createScript("exports")??"exports",y._ttpExtensionScripts?.createScript("require")??"require",y._ttpExtensionScripts?.createScript(_)??_)}catch(g){throw console.error(h?`Loading code for extension ${h.value} failed: ${g.message}`:`Loading code failed: ${g.message}`),console.error(`${p.toString(!0)}${typeof g.line=="number"?` line ${g.line}`:""}${typeof g.column=="number"?` column ${g.column}`:""}`),console.error(g),g}const R={},n={exports:R},i=g=>{const f=this._fakeModules.getModule(g,p);if(f===void 0)throw new Error(`Cannot load module '${g}'`);return f};try{return S.codeLoadingStart(),h&&performance.mark(`code/extHost/willLoadExtensionCode/${h.value}`),c(n,R,i),n.exports!==R?n.exports:R}finally{h&&performance.mark(`code/extHost/didLoadExtensionCode/${h.value}`),S.codeLoadingStop()}}async $setRemoteEnvironment(h){}async _waitForDebuggerAttachment(h=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const p=Date.now()+h;for(;Date.now()<p&&!("__jsDebugIsReady"in globalThis);)await(0,t.timeout)(10)}}e.ExtHostExtensionService=y,y._ttpExtensionScripts=self.trustedTypes?.createPolicy("ExtensionScripts",{createScript:a=>a});function r(a,h){return a.endsWith(h)?a:a+h}function m(a,h){p("info","log"),p("log","log"),p("warn","warn"),p("error","error");function p(o,d){const _=console[o];console[o]=function(){a.$logExtensionHostMessage({type:"__$console",severity:d,arguments:w(arguments)}),h&&_.apply(console,arguments)}}const S=1e5;function w(o){const d=[],_=[];if(o.length)for(let c=0;c<o.length;c++){if(typeof o[c]=="undefined")o[c]="undefined";else if(o[c]instanceof Error){const R=o[c];R.stack?o[c]=R.stack:o[c]=R.toString()}_.push(o[c])}try{const c=JSON.stringify(_,function(R,n){if(n&&typeof n=="object"){if(d.indexOf(n)!==-1)return"[Circular]";d.push(n)}return n});return c.length>S?"Output omitted for a large object that exceeds the limits":c}catch(c){return`Output omitted for an object that cannot be inspected ('${c.toString()}')`}}}}),define(be[230],Ee([0,1,59,34,74,229]),function(re,e,u,M,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,u.registerSingleton)(M.IExtHostExtensionService,P.ExtHostExtensionService),(0,u.registerSingleton)(b.IExtensionStoragePaths,b.ExtensionStoragePaths)}),define(be[239],Ee([0,1,22,3,181,224,218,17,75,11,2,228,230]),function(re,e,u,M,b,P,t,A,C,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const y=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const r=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");const m=fetch.bind(self);if(self.fetch=function(o,d){return o instanceof Request||/^file:/i.test(String(o))&&(o=k.FileAccess.asBrowserUri(F.URI.parse(String(o))).toString(!0)),m(o,d)},self.XMLHttpRequest=class extends XMLHttpRequest{open(o,d,_,c,R){return/^file:/i.test(d.toString())&&(d=k.FileAccess.asBrowserUri(F.URI.parse(d.toString())).toString(!0)),super.open(o,d,_??!0,c,R)}},self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const o=self.trustedTypes?.createPolicy("extensionHostWorker",{createScriptURL:_=>_}),d=self.Worker;Worker=function(_,c){/^file:/i.test(_.toString())&&(_=k.FileAccess.asBrowserUri(F.URI.parse(_.toString())).toString(!0));const n=`(${function(s){function v(I){return typeof I=="string"||I instanceof URL?String(I).replace(/^file:\/\//i,"vscode-file://vscode-app"):I}const l=fetch.bind(self);self.fetch=function(I,B){return I instanceof Request?l(I,B):l(v(I),B)},self.XMLHttpRequest=class extends XMLHttpRequest{open(I,B,O,D,x){return super.open(I,v(B),O??!0,D,x)}};const E=importScripts.bind(self);self.importScripts=(...I)=>{E(...I.map(v))};const T=self.trustedTypes?self.trustedTypes.createPolicy("extensionHostWorker",{createScriptURL:I=>I}):void 0;E(T?T.createScriptURL(s):s)}.toString()}('${_}'))`;c=c||{},c.name=c.name||A.basename(_.toString());const i=new Blob([n],{type:"application/javascript"}),g=URL.createObjectURL(i);return new d(o?o.createScriptURL(g):g,c)}}else self.Worker=class extends t.NestedWorker{constructor(o,d){super(r,o,{name:A.basename(o.toString()),...d})}};const a=new class{constructor(){this.pid=void 0}exit(o){y()}async exists(o){return!0}async realpath(o){return o}};class h{constructor(){const d=new MessageChannel,_=new M.Emitter;let c=!1;r(d.port2,[d.port2]),d.port1.onmessage=R=>{const{data:n}=R;if(!(n instanceof ArrayBuffer)){console.warn("UNKNOWN data received",n);return}const i=u.VSBuffer.wrap(new Uint8Array(n,0,n.byteLength));if((0,b.isMessageOfType)(i,2)){c=!0,S("received terminate message from renderer");return}_.fire(i)},this.protocol={onMessage:_.event,send:R=>{if(!c){const n=R.buffer.buffer.slice(R.buffer.byteOffset,R.buffer.byteOffset+R.buffer.byteLength);d.port1.postMessage(n,[n])}}}}}function p(o){return new Promise(d=>{const _=o.onMessage(c=>{_.dispose();const R=JSON.parse(c.toString());o.send((0,b.createMessageOfType)(0)),d({protocol:o,initData:R})});o.send((0,b.createMessageOfType)(1))})}let S=o=>y();function w(){const o=new h;C.mark("code/extHost/willConnectToRenderer"),p(o.protocol).then(d=>{C.mark("code/extHost/didWaitForInitData");const _=new P.ExtensionHostMain(d.protocol,d.initData,a,null);S=c=>_.terminate(c)})}e.create=w})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/6a25ae3a24929f35aabf8a051531c0716032e0a0/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
